#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 381
#define LARGE_STATE_COUNT 189
#define SYMBOL_COUNT 176
#define ALIAS_COUNT 3
#define TOKEN_COUNT 101
#define EXTERNAL_TOKEN_COUNT 6
#define FIELD_COUNT 8
#define MAX_ALIAS_SEQUENCE_LENGTH 6
#define PRODUCTION_ID_COUNT 16

enum {
  sym_identifier = 1,
  anon_sym_LF = 2,
  anon_sym_COMMA = 3,
  anon_sym_package = 4,
  anon_sym_import = 5,
  anon_sym_LPAREN = 6,
  anon_sym_RPAREN = 7,
  sym_dot = 8,
  anon_sym__ = 9,
  anon_sym_AT = 10,
  sym_attr_token = 11,
  sym_escape_char = 12,
  sym_escape_byte = 13,
  sym_escape_unicode = 14,
  anon_sym_DQUOTE = 15,
  aux_sym_simple_string_lit_token1 = 16,
  anon_sym_POUND_DQUOTE = 17,
  anon_sym_DQUOTE_POUND = 18,
  anon_sym_SQUOTE = 19,
  aux_sym_simple_bytes_lit_token1 = 20,
  anon_sym_POUND_SQUOTE = 21,
  anon_sym_SQUOTE_POUND = 22,
  anon_sym_DQUOTE_DQUOTE_DQUOTE = 23,
  anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE = 24,
  anon_sym_DQUOTE_DQUOTE_DQUOTE_POUND = 25,
  anon_sym_SQUOTE_SQUOTE_SQUOTE = 26,
  anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE = 27,
  anon_sym_SQUOTE_SQUOTE_SQUOTE_POUND = 28,
  anon_sym_BSLASH_LPAREN = 29,
  anon_sym_BSLASH_POUND_LPAREN = 30,
  anon_sym_len = 31,
  anon_sym_close = 32,
  anon_sym_and = 33,
  anon_sym_or = 34,
  anon_sym_div = 35,
  anon_sym_mod = 36,
  anon_sym_quo = 37,
  anon_sym_rem = 38,
  sym_number_type = 39,
  anon_sym_float = 40,
  anon_sym_float32 = 41,
  anon_sym_float64 = 42,
  anon_sym_uint = 43,
  anon_sym_uint8 = 44,
  anon_sym_uint16 = 45,
  anon_sym_uint32 = 46,
  anon_sym_uint64 = 47,
  anon_sym_uint128 = 48,
  anon_sym_int = 49,
  anon_sym_int8 = 50,
  anon_sym_int16 = 51,
  anon_sym_int32 = 52,
  anon_sym_int64 = 53,
  anon_sym_int128 = 54,
  sym_string_type = 55,
  sym_bytes_type = 56,
  sym_bool_type = 57,
  sym_bottom_lit = 58,
  sym_null = 59,
  sym_true = 60,
  sym_false = 61,
  sym_int_lit = 62,
  sym_float_lit = 63,
  anon_sym_LBRACK = 64,
  anon_sym_RBRACK = 65,
  anon_sym_LBRACE = 66,
  anon_sym_RBRACE = 67,
  anon_sym_DOT_DOT_DOT = 68,
  anon_sym_QMARK = 69,
  anon_sym_EQ = 70,
  anon_sym_COLON = 71,
  anon_sym_for = 72,
  anon_sym_in = 73,
  anon_sym_if = 74,
  anon_sym_let = 75,
  anon_sym_PIPE = 76,
  anon_sym_AMP = 77,
  anon_sym_PIPE_PIPE = 78,
  anon_sym_AMP_AMP = 79,
  anon_sym_EQ_EQ = 80,
  anon_sym_BANG_EQ = 81,
  anon_sym_LT = 82,
  anon_sym_LT_EQ = 83,
  anon_sym_GT = 84,
  anon_sym_GT_EQ = 85,
  anon_sym_EQ_TILDE = 86,
  anon_sym_BANG_TILDE = 87,
  anon_sym_PLUS = 88,
  anon_sym_DASH = 89,
  anon_sym_STAR = 90,
  anon_sym_SLASH = 91,
  anon_sym_BANG = 92,
  anon_sym_LBRACK2 = 93,
  sym_comment = 94,
  sym__multi_str_content = 95,
  sym__multi_bytes_content = 96,
  sym__raw_str_content = 97,
  sym__raw_bytes_content = 98,
  sym__multi_raw_str_content = 99,
  sym__multi_raw_bytes_content = 100,
  sym_source_file = 101,
  sym__package_identifier = 102,
  sym_package_clause = 103,
  sym_import_declaration = 104,
  sym_import_spec = 105,
  sym_import_spec_list = 106,
  sym_blank_identifier = 107,
  sym_attribute = 108,
  sym_qualified_identifier = 109,
  sym__string_lit = 110,
  sym_simple_string_lit = 111,
  sym_simple_raw_string_lit = 112,
  sym_simple_bytes_lit = 113,
  sym_simple_raw_bytes_lit = 114,
  sym_multiline_string_lit = 115,
  sym_multiline_raw_string_lit = 116,
  sym_multiline_bytes_lit = 117,
  sym_multiline_raw_bytes_lit = 118,
  sym_interpolation = 119,
  sym_raw_interpolation = 120,
  sym_builtin = 121,
  sym_float_type = 122,
  sym_uint_type = 123,
  sym_int_type = 124,
  sym_top_lit = 125,
  sym__declaration = 126,
  sym__list_elem = 127,
  sym_list_lit = 128,
  sym_struct_lit = 129,
  sym_ellipsis = 130,
  sym__embedding = 131,
  sym__label_name = 132,
  sym__label_alias_expr = 133,
  sym__label_expr = 134,
  sym_label = 135,
  sym_field = 136,
  sym__value = 137,
  sym_for_clause = 138,
  sym_guard_clause = 139,
  sym_let_clause = 140,
  sym__clause = 141,
  sym_comprehension = 142,
  sym__alias_expr = 143,
  sym__expression = 144,
  sym_binary_expression = 145,
  sym_unary_expression = 146,
  sym__primary_expression = 147,
  sym__operand = 148,
  sym__call_operand = 149,
  sym_index_expression = 150,
  sym_selector_expression = 151,
  sym_call_expression = 152,
  sym_selector = 153,
  sym_index = 154,
  sym_arguments = 155,
  sym_argument = 156,
  sym__literal = 157,
  aux_sym_source_file_repeat1 = 158,
  aux_sym_source_file_repeat2 = 159,
  aux_sym_import_spec_list_repeat1 = 160,
  aux_sym_attribute_repeat1 = 161,
  aux_sym_simple_string_lit_repeat1 = 162,
  aux_sym_simple_raw_string_lit_repeat1 = 163,
  aux_sym_simple_bytes_lit_repeat1 = 164,
  aux_sym_simple_raw_bytes_lit_repeat1 = 165,
  aux_sym_multiline_string_lit_repeat1 = 166,
  aux_sym_multiline_raw_string_lit_repeat1 = 167,
  aux_sym_multiline_bytes_lit_repeat1 = 168,
  aux_sym_multiline_raw_bytes_lit_repeat1 = 169,
  aux_sym__list_elem_repeat1 = 170,
  aux_sym_list_lit_repeat1 = 171,
  aux_sym_struct_lit_repeat1 = 172,
  aux_sym_field_repeat1 = 173,
  aux_sym_comprehension_repeat1 = 174,
  aux_sym_arguments_repeat1 = 175,
  alias_sym_optional = 176,
  alias_sym_package_identifier = 177,
  alias_sym_value = 178,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_LF] = "\n",
  [anon_sym_COMMA] = ",",
  [anon_sym_package] = "package",
  [anon_sym_import] = "import",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [sym_dot] = "dot",
  [anon_sym__] = "_",
  [anon_sym_AT] = "@",
  [sym_attr_token] = "attr_token",
  [sym_escape_char] = "escape_char",
  [sym_escape_byte] = "escape_byte",
  [sym_escape_unicode] = "escape_unicode",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_simple_string_lit_token1] = "simple_string_lit_token1",
  [anon_sym_POUND_DQUOTE] = "#\"",
  [anon_sym_DQUOTE_POUND] = "\"#",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_simple_bytes_lit_token1] = "simple_bytes_lit_token1",
  [anon_sym_POUND_SQUOTE] = "#'",
  [anon_sym_SQUOTE_POUND] = "'#",
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = "\"\"\"",
  [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = "#\"\"\"",
  [anon_sym_DQUOTE_DQUOTE_DQUOTE_POUND] = "\"\"\"#",
  [anon_sym_SQUOTE_SQUOTE_SQUOTE] = "'''",
  [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = "#'''",
  [anon_sym_SQUOTE_SQUOTE_SQUOTE_POUND] = "'''#",
  [anon_sym_BSLASH_LPAREN] = "\\(",
  [anon_sym_BSLASH_POUND_LPAREN] = "\\#(",
  [anon_sym_len] = "len",
  [anon_sym_close] = "close",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_div] = "div",
  [anon_sym_mod] = "mod",
  [anon_sym_quo] = "quo",
  [anon_sym_rem] = "rem",
  [sym_number_type] = "number_type",
  [anon_sym_float] = "float",
  [anon_sym_float32] = "float32",
  [anon_sym_float64] = "float64",
  [anon_sym_uint] = "uint",
  [anon_sym_uint8] = "uint8",
  [anon_sym_uint16] = "uint16",
  [anon_sym_uint32] = "uint32",
  [anon_sym_uint64] = "uint64",
  [anon_sym_uint128] = "uint128",
  [anon_sym_int] = "int",
  [anon_sym_int8] = "int8",
  [anon_sym_int16] = "int16",
  [anon_sym_int32] = "int32",
  [anon_sym_int64] = "int64",
  [anon_sym_int128] = "int128",
  [sym_string_type] = "string_type",
  [sym_bytes_type] = "bytes_type",
  [sym_bool_type] = "bool_type",
  [sym_bottom_lit] = "bottom_lit",
  [sym_null] = "null",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_int_lit] = "int_lit",
  [sym_float_lit] = "float_lit",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "\?",
  [anon_sym_EQ] = "=",
  [anon_sym_COLON] = ":",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_if] = "if",
  [anon_sym_let] = "let",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_BANG_TILDE] = "!~",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_BANG] = "!",
  [anon_sym_LBRACK2] = "[",
  [sym_comment] = "comment",
  [sym__multi_str_content] = "_multi_str_content",
  [sym__multi_bytes_content] = "_multi_bytes_content",
  [sym__raw_str_content] = "_raw_str_content",
  [sym__raw_bytes_content] = "_raw_bytes_content",
  [sym__multi_raw_str_content] = "_multi_raw_str_content",
  [sym__multi_raw_bytes_content] = "_multi_raw_bytes_content",
  [sym_source_file] = "source_file",
  [sym__package_identifier] = "_package_identifier",
  [sym_package_clause] = "package_clause",
  [sym_import_declaration] = "import_declaration",
  [sym_import_spec] = "import_spec",
  [sym_import_spec_list] = "import_spec_list",
  [sym_blank_identifier] = "blank_identifier",
  [sym_attribute] = "attribute",
  [sym_qualified_identifier] = "qualified_identifier",
  [sym__string_lit] = "_string_lit",
  [sym_simple_string_lit] = "simple_string_lit",
  [sym_simple_raw_string_lit] = "simple_raw_string_lit",
  [sym_simple_bytes_lit] = "simple_bytes_lit",
  [sym_simple_raw_bytes_lit] = "simple_raw_bytes_lit",
  [sym_multiline_string_lit] = "multiline_string_lit",
  [sym_multiline_raw_string_lit] = "multiline_raw_string_lit",
  [sym_multiline_bytes_lit] = "multiline_bytes_lit",
  [sym_multiline_raw_bytes_lit] = "multiline_raw_bytes_lit",
  [sym_interpolation] = "interpolation",
  [sym_raw_interpolation] = "raw_interpolation",
  [sym_builtin] = "builtin",
  [sym_float_type] = "float_type",
  [sym_uint_type] = "uint_type",
  [sym_int_type] = "int_type",
  [sym_top_lit] = "top_lit",
  [sym__declaration] = "_declaration",
  [sym__list_elem] = "_list_elem",
  [sym_list_lit] = "list_lit",
  [sym_struct_lit] = "struct_lit",
  [sym_ellipsis] = "ellipsis",
  [sym__embedding] = "_embedding",
  [sym__label_name] = "_label_name",
  [sym__label_alias_expr] = "_label_alias_expr",
  [sym__label_expr] = "_label_expr",
  [sym_label] = "label",
  [sym_field] = "field",
  [sym__value] = "_value",
  [sym_for_clause] = "for_clause",
  [sym_guard_clause] = "guard_clause",
  [sym_let_clause] = "let_clause",
  [sym__clause] = "_clause",
  [sym_comprehension] = "comprehension",
  [sym__alias_expr] = "_alias_expr",
  [sym__expression] = "_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym__primary_expression] = "_primary_expression",
  [sym__operand] = "_operand",
  [sym__call_operand] = "_call_operand",
  [sym_index_expression] = "index_expression",
  [sym_selector_expression] = "selector_expression",
  [sym_call_expression] = "call_expression",
  [sym_selector] = "selector",
  [sym_index] = "index",
  [sym_arguments] = "arguments",
  [sym_argument] = "argument",
  [sym__literal] = "_literal",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_source_file_repeat2] = "source_file_repeat2",
  [aux_sym_import_spec_list_repeat1] = "import_spec_list_repeat1",
  [aux_sym_attribute_repeat1] = "attribute_repeat1",
  [aux_sym_simple_string_lit_repeat1] = "simple_string_lit_repeat1",
  [aux_sym_simple_raw_string_lit_repeat1] = "simple_raw_string_lit_repeat1",
  [aux_sym_simple_bytes_lit_repeat1] = "simple_bytes_lit_repeat1",
  [aux_sym_simple_raw_bytes_lit_repeat1] = "simple_raw_bytes_lit_repeat1",
  [aux_sym_multiline_string_lit_repeat1] = "multiline_string_lit_repeat1",
  [aux_sym_multiline_raw_string_lit_repeat1] = "multiline_raw_string_lit_repeat1",
  [aux_sym_multiline_bytes_lit_repeat1] = "multiline_bytes_lit_repeat1",
  [aux_sym_multiline_raw_bytes_lit_repeat1] = "multiline_raw_bytes_lit_repeat1",
  [aux_sym__list_elem_repeat1] = "_list_elem_repeat1",
  [aux_sym_list_lit_repeat1] = "list_lit_repeat1",
  [aux_sym_struct_lit_repeat1] = "struct_lit_repeat1",
  [aux_sym_field_repeat1] = "field_repeat1",
  [aux_sym_comprehension_repeat1] = "comprehension_repeat1",
  [aux_sym_arguments_repeat1] = "arguments_repeat1",
  [alias_sym_optional] = "optional",
  [alias_sym_package_identifier] = "package_identifier",
  [alias_sym_value] = "value",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_LF] = anon_sym_LF,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_package] = anon_sym_package,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [sym_dot] = sym_dot,
  [anon_sym__] = anon_sym__,
  [anon_sym_AT] = anon_sym_AT,
  [sym_attr_token] = sym_attr_token,
  [sym_escape_char] = sym_escape_char,
  [sym_escape_byte] = sym_escape_byte,
  [sym_escape_unicode] = sym_escape_unicode,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_simple_string_lit_token1] = aux_sym_simple_string_lit_token1,
  [anon_sym_POUND_DQUOTE] = anon_sym_POUND_DQUOTE,
  [anon_sym_DQUOTE_POUND] = anon_sym_DQUOTE_POUND,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_simple_bytes_lit_token1] = aux_sym_simple_bytes_lit_token1,
  [anon_sym_POUND_SQUOTE] = anon_sym_POUND_SQUOTE,
  [anon_sym_SQUOTE_POUND] = anon_sym_SQUOTE_POUND,
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
  [anon_sym_DQUOTE_DQUOTE_DQUOTE_POUND] = anon_sym_DQUOTE_DQUOTE_DQUOTE_POUND,
  [anon_sym_SQUOTE_SQUOTE_SQUOTE] = anon_sym_SQUOTE_SQUOTE_SQUOTE,
  [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
  [anon_sym_SQUOTE_SQUOTE_SQUOTE_POUND] = anon_sym_SQUOTE_SQUOTE_SQUOTE_POUND,
  [anon_sym_BSLASH_LPAREN] = anon_sym_BSLASH_LPAREN,
  [anon_sym_BSLASH_POUND_LPAREN] = anon_sym_BSLASH_POUND_LPAREN,
  [anon_sym_len] = anon_sym_len,
  [anon_sym_close] = anon_sym_close,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_div] = anon_sym_div,
  [anon_sym_mod] = anon_sym_mod,
  [anon_sym_quo] = anon_sym_quo,
  [anon_sym_rem] = anon_sym_rem,
  [sym_number_type] = sym_number_type,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_float32] = anon_sym_float32,
  [anon_sym_float64] = anon_sym_float64,
  [anon_sym_uint] = anon_sym_uint,
  [anon_sym_uint8] = anon_sym_uint8,
  [anon_sym_uint16] = anon_sym_uint16,
  [anon_sym_uint32] = anon_sym_uint32,
  [anon_sym_uint64] = anon_sym_uint64,
  [anon_sym_uint128] = anon_sym_uint128,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_int8] = anon_sym_int8,
  [anon_sym_int16] = anon_sym_int16,
  [anon_sym_int32] = anon_sym_int32,
  [anon_sym_int64] = anon_sym_int64,
  [anon_sym_int128] = anon_sym_int128,
  [sym_string_type] = sym_string_type,
  [sym_bytes_type] = sym_bytes_type,
  [sym_bool_type] = sym_bool_type,
  [sym_bottom_lit] = sym_bottom_lit,
  [sym_null] = sym_null,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_int_lit] = sym_int_lit,
  [sym_float_lit] = sym_float_lit,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_EQ_TILDE] = anon_sym_EQ_TILDE,
  [anon_sym_BANG_TILDE] = anon_sym_BANG_TILDE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_LBRACK2] = anon_sym_LBRACK,
  [sym_comment] = sym_comment,
  [sym__multi_str_content] = sym__multi_str_content,
  [sym__multi_bytes_content] = sym__multi_bytes_content,
  [sym__raw_str_content] = sym__raw_str_content,
  [sym__raw_bytes_content] = sym__raw_bytes_content,
  [sym__multi_raw_str_content] = sym__multi_raw_str_content,
  [sym__multi_raw_bytes_content] = sym__multi_raw_bytes_content,
  [sym_source_file] = sym_source_file,
  [sym__package_identifier] = sym__package_identifier,
  [sym_package_clause] = sym_package_clause,
  [sym_import_declaration] = sym_import_declaration,
  [sym_import_spec] = sym_import_spec,
  [sym_import_spec_list] = sym_import_spec_list,
  [sym_blank_identifier] = sym_blank_identifier,
  [sym_attribute] = sym_attribute,
  [sym_qualified_identifier] = sym_qualified_identifier,
  [sym__string_lit] = sym__string_lit,
  [sym_simple_string_lit] = sym_simple_string_lit,
  [sym_simple_raw_string_lit] = sym_simple_raw_string_lit,
  [sym_simple_bytes_lit] = sym_simple_bytes_lit,
  [sym_simple_raw_bytes_lit] = sym_simple_raw_bytes_lit,
  [sym_multiline_string_lit] = sym_multiline_string_lit,
  [sym_multiline_raw_string_lit] = sym_multiline_raw_string_lit,
  [sym_multiline_bytes_lit] = sym_multiline_bytes_lit,
  [sym_multiline_raw_bytes_lit] = sym_multiline_raw_bytes_lit,
  [sym_interpolation] = sym_interpolation,
  [sym_raw_interpolation] = sym_raw_interpolation,
  [sym_builtin] = sym_builtin,
  [sym_float_type] = sym_float_type,
  [sym_uint_type] = sym_uint_type,
  [sym_int_type] = sym_int_type,
  [sym_top_lit] = sym_top_lit,
  [sym__declaration] = sym__declaration,
  [sym__list_elem] = sym__list_elem,
  [sym_list_lit] = sym_list_lit,
  [sym_struct_lit] = sym_struct_lit,
  [sym_ellipsis] = sym_ellipsis,
  [sym__embedding] = sym__embedding,
  [sym__label_name] = sym__label_name,
  [sym__label_alias_expr] = sym__label_alias_expr,
  [sym__label_expr] = sym__label_expr,
  [sym_label] = sym_label,
  [sym_field] = sym_field,
  [sym__value] = sym__value,
  [sym_for_clause] = sym_for_clause,
  [sym_guard_clause] = sym_guard_clause,
  [sym_let_clause] = sym_let_clause,
  [sym__clause] = sym__clause,
  [sym_comprehension] = sym_comprehension,
  [sym__alias_expr] = sym__alias_expr,
  [sym__expression] = sym__expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym__primary_expression] = sym__primary_expression,
  [sym__operand] = sym__operand,
  [sym__call_operand] = sym__call_operand,
  [sym_index_expression] = sym_index_expression,
  [sym_selector_expression] = sym_selector_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_selector] = sym_selector,
  [sym_index] = sym_index,
  [sym_arguments] = sym_arguments,
  [sym_argument] = sym_argument,
  [sym__literal] = sym__literal,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_source_file_repeat2] = aux_sym_source_file_repeat2,
  [aux_sym_import_spec_list_repeat1] = aux_sym_import_spec_list_repeat1,
  [aux_sym_attribute_repeat1] = aux_sym_attribute_repeat1,
  [aux_sym_simple_string_lit_repeat1] = aux_sym_simple_string_lit_repeat1,
  [aux_sym_simple_raw_string_lit_repeat1] = aux_sym_simple_raw_string_lit_repeat1,
  [aux_sym_simple_bytes_lit_repeat1] = aux_sym_simple_bytes_lit_repeat1,
  [aux_sym_simple_raw_bytes_lit_repeat1] = aux_sym_simple_raw_bytes_lit_repeat1,
  [aux_sym_multiline_string_lit_repeat1] = aux_sym_multiline_string_lit_repeat1,
  [aux_sym_multiline_raw_string_lit_repeat1] = aux_sym_multiline_raw_string_lit_repeat1,
  [aux_sym_multiline_bytes_lit_repeat1] = aux_sym_multiline_bytes_lit_repeat1,
  [aux_sym_multiline_raw_bytes_lit_repeat1] = aux_sym_multiline_raw_bytes_lit_repeat1,
  [aux_sym__list_elem_repeat1] = aux_sym__list_elem_repeat1,
  [aux_sym_list_lit_repeat1] = aux_sym_list_lit_repeat1,
  [aux_sym_struct_lit_repeat1] = aux_sym_struct_lit_repeat1,
  [aux_sym_field_repeat1] = aux_sym_field_repeat1,
  [aux_sym_comprehension_repeat1] = aux_sym_comprehension_repeat1,
  [aux_sym_arguments_repeat1] = aux_sym_arguments_repeat1,
  [alias_sym_optional] = alias_sym_optional,
  [alias_sym_package_identifier] = alias_sym_package_identifier,
  [alias_sym_value] = alias_sym_value,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_package] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_dot] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [sym_attr_token] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_char] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_byte] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_unicode] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_simple_string_lit_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_POUND_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_simple_bytes_lit_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_POUND_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE_DQUOTE_DQUOTE_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE_SQUOTE_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE_SQUOTE_SQUOTE_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH_POUND_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_len] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_close] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_div] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_quo] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rem] = {
    .visible = true,
    .named = false,
  },
  [sym_number_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float64] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint64] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint128] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int64] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int128] = {
    .visible = true,
    .named = false,
  },
  [sym_string_type] = {
    .visible = true,
    .named = true,
  },
  [sym_bytes_type] = {
    .visible = true,
    .named = true,
  },
  [sym_bool_type] = {
    .visible = true,
    .named = true,
  },
  [sym_bottom_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_int_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_float_lit] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK2] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__multi_str_content] = {
    .visible = false,
    .named = true,
  },
  [sym__multi_bytes_content] = {
    .visible = false,
    .named = true,
  },
  [sym__raw_str_content] = {
    .visible = false,
    .named = true,
  },
  [sym__raw_bytes_content] = {
    .visible = false,
    .named = true,
  },
  [sym__multi_raw_str_content] = {
    .visible = false,
    .named = true,
  },
  [sym__multi_raw_bytes_content] = {
    .visible = false,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__package_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_package_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_import_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_import_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_import_spec_list] = {
    .visible = true,
    .named = true,
  },
  [sym_blank_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__string_lit] = {
    .visible = false,
    .named = true,
  },
  [sym_simple_string_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_raw_string_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_bytes_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_raw_bytes_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_multiline_string_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_multiline_raw_string_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_multiline_bytes_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_multiline_raw_bytes_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_builtin] = {
    .visible = true,
    .named = true,
  },
  [sym_float_type] = {
    .visible = true,
    .named = true,
  },
  [sym_uint_type] = {
    .visible = true,
    .named = true,
  },
  [sym_int_type] = {
    .visible = true,
    .named = true,
  },
  [sym_top_lit] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym__list_elem] = {
    .visible = false,
    .named = true,
  },
  [sym_list_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_lit] = {
    .visible = true,
    .named = true,
  },
  [sym_ellipsis] = {
    .visible = true,
    .named = true,
  },
  [sym__embedding] = {
    .visible = false,
    .named = true,
  },
  [sym__label_name] = {
    .visible = false,
    .named = true,
  },
  [sym__label_alias_expr] = {
    .visible = false,
    .named = true,
  },
  [sym__label_expr] = {
    .visible = false,
    .named = true,
  },
  [sym_label] = {
    .visible = true,
    .named = true,
  },
  [sym_field] = {
    .visible = true,
    .named = true,
  },
  [sym__value] = {
    .visible = false,
    .named = true,
  },
  [sym_for_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_guard_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_let_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__clause] = {
    .visible = false,
    .named = true,
  },
  [sym_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym__alias_expr] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__operand] = {
    .visible = false,
    .named = true,
  },
  [sym__call_operand] = {
    .visible = false,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_selector_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_selector] = {
    .visible = true,
    .named = true,
  },
  [sym_index] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_argument] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_source_file_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_spec_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_simple_string_lit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_simple_raw_string_lit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_simple_bytes_lit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_simple_raw_bytes_lit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_multiline_string_lit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_multiline_raw_string_lit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_multiline_bytes_lit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_multiline_raw_bytes_lit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_elem_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_list_lit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_lit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_comprehension_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_optional] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_package_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_value] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_condition = 2,
  field_left = 3,
  field_name = 4,
  field_operand = 5,
  field_operator = 6,
  field_path = 7,
  field_right = 8,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_condition] = "condition",
  [field_left] = "left",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_path] = "path",
  [field_right] = "right",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 0, .length = 1},
  [5] = {.index = 2, .length = 1},
  [6] = {.index = 3, .length = 2},
  [7] = {.index = 5, .length = 1},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 0, .length = 1},
  [10] = {.index = 8, .length = 2},
  [11] = {.index = 10, .length = 1},
  [12] = {.index = 11, .length = 1},
  [13] = {.index = 12, .length = 3},
  [14] = {.index = 15, .length = 2},
  [15] = {.index = 17, .length = 1},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_alias, 0, .inherited = true},
  [1] =
    {field_path, 0},
  [2] =
    {field_condition, 1},
  [3] =
    {field_operand, 1},
    {field_operator, 0},
  [5] =
    {field_alias, 1, .inherited = true},
  [6] =
    {field_alias, 0, .inherited = true},
    {field_alias, 1, .inherited = true},
  [8] =
    {field_name, 0},
    {field_path, 1},
  [10] =
    {field_alias, 0},
  [11] =
    {field_alias, 2, .inherited = true},
  [12] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [15] =
    {field_left, 1},
    {field_right, 3},
  [17] =
    {field_alias, 3, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_package_identifier,
  },
  [4] = {
    [0] = alias_sym_optional,
  },
  [9] = {
    [0] = alias_sym_value,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__alias_expr, 3,
    sym__alias_expr,
    alias_sym_optional,
    alias_sym_value,
  0,
};

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 6688
    ? (c < 2984
      ? (c < 2365
        ? (c < 1376
          ? (c < 880
            ? (c < 192
              ? (c < 170
                ? (c < 'A'
                  ? c == '$'
                  : (c <= 'Z' || (c >= 'a' && c <= 'z')))
                : (c <= 170 || (c < 186
                  ? c == 181
                  : c <= 186)))
              : (c <= 214 || (c < 736
                ? (c < 248
                  ? (c >= 216 && c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))
                : (c <= 740 || (c < 750
                  ? c == 748
                  : c <= 750)))))
            : (c <= 884 || (c < 910
              ? (c < 902
                ? (c < 890
                  ? (c >= 886 && c <= 887)
                  : (c <= 893 || c == 895))
                : (c <= 902 || (c < 908
                  ? (c >= 904 && c <= 906)
                  : c <= 908)))
              : (c <= 929 || (c < 1162
                ? (c < 1015
                  ? (c >= 931 && c <= 1013)
                  : c <= 1153)
                : (c <= 1327 || (c < 1369
                  ? (c >= 1329 && c <= 1366)
                  : c <= 1369)))))))
          : (c <= 1416 || (c < 1969
            ? (c < 1765
              ? (c < 1646
                ? (c < 1519
                  ? (c >= 1488 && c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))
                : (c <= 1647 || (c < 1749
                  ? (c >= 1649 && c <= 1747)
                  : c <= 1749)))
              : (c <= 1766 || (c < 1808
                ? (c < 1786
                  ? (c >= 1774 && c <= 1775)
                  : (c <= 1788 || c == 1791))
                : (c <= 1808 || (c < 1869
                  ? (c >= 1810 && c <= 1839)
                  : c <= 1957)))))
            : (c <= 1969 || (c < 2088
              ? (c < 2048
                ? (c < 2036
                  ? (c >= 1994 && c <= 2026)
                  : (c <= 2037 || c == 2042))
                : (c <= 2069 || (c < 2084
                  ? c == 2074
                  : c <= 2084)))
              : (c <= 2088 || (c < 2208
                ? (c < 2144
                  ? (c >= 2112 && c <= 2136)
                  : c <= 2154)
                : (c <= 2228 || (c < 2308
                  ? (c >= 2230 && c <= 2247)
                  : c <= 2361)))))))))
        : (c <= 2365 || (c < 2703
          ? (c < 2544
            ? (c < 2474
              ? (c < 2437
                ? (c < 2392
                  ? c == 2384
                  : (c <= 2401 || (c >= 2417 && c <= 2432)))
                : (c <= 2444 || (c < 2451
                  ? (c >= 2447 && c <= 2448)
                  : c <= 2472)))
              : (c <= 2480 || (c < 2510
                ? (c < 2486
                  ? c == 2482
                  : (c <= 2489 || c == 2493))
                : (c <= 2510 || (c < 2527
                  ? (c >= 2524 && c <= 2525)
                  : c <= 2529)))))
            : (c <= 2545 || (c < 2613
              ? (c < 2579
                ? (c < 2565
                  ? c == 2556
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))
                : (c <= 2600 || (c < 2610
                  ? (c >= 2602 && c <= 2608)
                  : c <= 2611)))
              : (c <= 2614 || (c < 2654
                ? (c < 2649
                  ? (c >= 2616 && c <= 2617)
                  : c <= 2652)
                : (c <= 2654 || (c < 2693
                  ? (c >= 2674 && c <= 2676)
                  : c <= 2701)))))))
          : (c <= 2705 || (c < 2869
            ? (c < 2784
              ? (c < 2741
                ? (c < 2730
                  ? (c >= 2707 && c <= 2728)
                  : (c <= 2736 || (c >= 2738 && c <= 2739)))
                : (c <= 2745 || (c < 2768
                  ? c == 2749
                  : c <= 2768)))
              : (c <= 2785 || (c < 2835
                ? (c < 2821
                  ? c == 2809
                  : (c <= 2828 || (c >= 2831 && c <= 2832)))
                : (c <= 2856 || (c < 2866
                  ? (c >= 2858 && c <= 2864)
                  : c <= 2867)))))
            : (c <= 2873 || (c < 2958
              ? (c < 2929
                ? (c < 2908
                  ? c == 2877
                  : (c <= 2909 || (c >= 2911 && c <= 2913)))
                : (c <= 2929 || (c < 2949
                  ? c == 2947
                  : c <= 2954)))
              : (c <= 2960 || (c < 2972
                ? (c < 2969
                  ? (c >= 2962 && c <= 2965)
                  : c <= 2970)
                : (c <= 2972 || (c < 2979
                  ? (c >= 2974 && c <= 2975)
                  : c <= 2980)))))))))))
      : (c <= 2986 || (c < 4186
        ? (c < 3450
          ? (c < 3242
            ? (c < 3133
              ? (c < 3086
                ? (c < 3024
                  ? (c >= 2990 && c <= 3001)
                  : (c <= 3024 || (c >= 3077 && c <= 3084)))
                : (c <= 3088 || (c < 3114
                  ? (c >= 3090 && c <= 3112)
                  : c <= 3129)))
              : (c <= 3133 || (c < 3205
                ? (c < 3168
                  ? (c >= 3160 && c <= 3162)
                  : (c <= 3169 || c == 3200))
                : (c <= 3212 || (c < 3218
                  ? (c >= 3214 && c <= 3216)
                  : c <= 3240)))))
            : (c <= 3251 || (c < 3342
              ? (c < 3296
                ? (c < 3261
                  ? (c >= 3253 && c <= 3257)
                  : (c <= 3261 || c == 3294))
                : (c <= 3297 || (c < 3332
                  ? (c >= 3313 && c <= 3314)
                  : c <= 3340)))
              : (c <= 3344 || (c < 3406
                ? (c < 3389
                  ? (c >= 3346 && c <= 3386)
                  : c <= 3389)
                : (c <= 3406 || (c < 3423
                  ? (c >= 3412 && c <= 3414)
                  : c <= 3425)))))))
          : (c <= 3455 || (c < 3751
            ? (c < 3634
              ? (c < 3517
                ? (c < 3482
                  ? (c >= 3461 && c <= 3478)
                  : (c <= 3505 || (c >= 3507 && c <= 3515)))
                : (c <= 3517 || (c < 3585
                  ? (c >= 3520 && c <= 3526)
                  : c <= 3632)))
              : (c <= 3635 || (c < 3718
                ? (c < 3713
                  ? (c >= 3648 && c <= 3654)
                  : (c <= 3714 || c == 3716))
                : (c <= 3722 || (c < 3749
                  ? (c >= 3724 && c <= 3747)
                  : c <= 3749)))))
            : (c <= 3760 || (c < 3904
              ? (c < 3782
                ? (c < 3773
                  ? (c >= 3762 && c <= 3763)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))
                : (c <= 3782 || (c < 3840
                  ? (c >= 3804 && c <= 3807)
                  : c <= 3840)))
              : (c <= 3911 || (c < 4096
                ? (c < 3976
                  ? (c >= 3913 && c <= 3948)
                  : c <= 3980)
                : (c <= 4138 || (c < 4176
                  ? c == 4159
                  : c <= 4181)))))))))
        : (c <= 4189 || (c < 5024
          ? (c < 4698
            ? (c < 4295
              ? (c < 4213
                ? (c < 4197
                  ? c == 4193
                  : (c <= 4198 || (c >= 4206 && c <= 4208)))
                : (c <= 4225 || (c < 4256
                  ? c == 4238
                  : c <= 4293)))
              : (c <= 4295 || (c < 4682
                ? (c < 4304
                  ? c == 4301
                  : (c <= 4346 || (c >= 4348 && c <= 4680)))
                : (c <= 4685 || (c < 4696
                  ? (c >= 4688 && c <= 4694)
                  : c <= 4696)))))
            : (c <= 4701 || (c < 4802
              ? (c < 4786
                ? (c < 4746
                  ? (c >= 4704 && c <= 4744)
                  : (c <= 4749 || (c >= 4752 && c <= 4784)))
                : (c <= 4789 || (c < 4800
                  ? (c >= 4792 && c <= 4798)
                  : c <= 4800)))
              : (c <= 4805 || (c < 4882
                ? (c < 4824
                  ? (c >= 4808 && c <= 4822)
                  : c <= 4880)
                : (c <= 4885 || (c < 4992
                  ? (c >= 4888 && c <= 4954)
                  : c <= 5007)))))))
          : (c <= 5109 || (c < 6103
            ? (c < 5888
              ? (c < 5761
                ? (c < 5121
                  ? (c >= 5112 && c <= 5117)
                  : (c <= 5740 || (c >= 5743 && c <= 5759)))
                : (c <= 5786 || (c < 5873
                  ? (c >= 5792 && c <= 5866)
                  : c <= 5880)))
              : (c <= 5900 || (c < 5984
                ? (c < 5920
                  ? (c >= 5902 && c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6016
                  ? (c >= 5998 && c <= 6000)
                  : c <= 6067)))))
            : (c <= 6103 || (c < 6400
              ? (c < 6279
                ? (c < 6176
                  ? c == 6108
                  : (c <= 6264 || (c >= 6272 && c <= 6276)))
                : (c <= 6312 || (c < 6320
                  ? c == 6314
                  : c <= 6389)))
              : (c <= 6430 || (c < 6528
                ? (c < 6512
                  ? (c >= 6480 && c <= 6509)
                  : c <= 6516)
                : (c <= 6571 || (c < 6656
                  ? (c >= 6576 && c <= 6601)
                  : c <= 6678)))))))))))))
    : (c <= 6740 || (c < 43259
      ? (c < 11264
        ? (c < 8064
          ? (c < 7406
            ? (c < 7168
              ? (c < 7043
                ? (c < 6917
                  ? c == 6823
                  : (c <= 6963 || (c >= 6981 && c <= 6987)))
                : (c <= 7072 || (c < 7098
                  ? (c >= 7086 && c <= 7087)
                  : c <= 7141)))
              : (c <= 7203 || (c < 7312
                ? (c < 7258
                  ? (c >= 7245 && c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))
                : (c <= 7354 || (c < 7401
                  ? (c >= 7357 && c <= 7359)
                  : c <= 7404)))))
            : (c <= 7411 || (c < 8008
              ? (c < 7680
                ? (c < 7418
                  ? (c >= 7413 && c <= 7414)
                  : (c <= 7418 || (c >= 7424 && c <= 7615)))
                : (c <= 7957 || (c < 7968
                  ? (c >= 7960 && c <= 7965)
                  : c <= 8005)))
              : (c <= 8013 || (c < 8027
                ? (c < 8025
                  ? (c >= 8016 && c <= 8023)
                  : c <= 8025)
                : (c <= 8027 || (c < 8031
                  ? c == 8029
                  : c <= 8061)))))))
          : (c <= 8116 || (c < 8455
            ? (c < 8160
              ? (c < 8134
                ? (c < 8126
                  ? (c >= 8118 && c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))
                : (c <= 8140 || (c < 8150
                  ? (c >= 8144 && c <= 8147)
                  : c <= 8155)))
              : (c <= 8172 || (c < 8319
                ? (c < 8182
                  ? (c >= 8178 && c <= 8180)
                  : (c <= 8188 || c == 8305))
                : (c <= 8319 || (c < 8450
                  ? (c >= 8336 && c <= 8348)
                  : c <= 8450)))))
            : (c <= 8455 || (c < 8490
              ? (c < 8484
                ? (c < 8469
                  ? (c >= 8458 && c <= 8467)
                  : (c <= 8469 || (c >= 8473 && c <= 8477)))
                : (c <= 8484 || (c < 8488
                  ? c == 8486
                  : c <= 8488)))
              : (c <= 8493 || (c < 8517
                ? (c < 8508
                  ? (c >= 8495 && c <= 8505)
                  : c <= 8511)
                : (c <= 8521 || (c < 8579
                  ? c == 8526
                  : c <= 8580)))))))))
        : (c <= 11310 || (c < 12549
          ? (c < 11704
            ? (c < 11565
              ? (c < 11506
                ? (c < 11360
                  ? (c >= 11312 && c <= 11358)
                  : (c <= 11492 || (c >= 11499 && c <= 11502)))
                : (c <= 11507 || (c < 11559
                  ? (c >= 11520 && c <= 11557)
                  : c <= 11559)))
              : (c <= 11565 || (c < 11680
                ? (c < 11631
                  ? (c >= 11568 && c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))
                : (c <= 11686 || (c < 11696
                  ? (c >= 11688 && c <= 11694)
                  : c <= 11702)))))
            : (c <= 11710 || (c < 12337
              ? (c < 11736
                ? (c < 11720
                  ? (c >= 11712 && c <= 11718)
                  : (c <= 11726 || (c >= 11728 && c <= 11734)))
                : (c <= 11742 || (c < 12293
                  ? c == 11823
                  : c <= 12294)))
              : (c <= 12341 || (c < 12445
                ? (c < 12353
                  ? (c >= 12347 && c <= 12348)
                  : c <= 12438)
                : (c <= 12447 || (c < 12540
                  ? (c >= 12449 && c <= 12538)
                  : c <= 12543)))))))
          : (c <= 12591 || (c < 42623
            ? (c < 40956
              ? (c < 13312
                ? (c < 12704
                  ? (c >= 12593 && c <= 12686)
                  : (c <= 12735 || (c >= 12784 && c <= 12799)))
                : (c <= 13312 || (c < 19968
                  ? c == 19903
                  : c <= 19968)))
              : (c <= 40956 || (c < 42512
                ? (c < 42192
                  ? (c >= 40960 && c <= 42124)
                  : (c <= 42237 || (c >= 42240 && c <= 42508)))
                : (c <= 42527 || (c < 42560
                  ? (c >= 42538 && c <= 42539)
                  : c <= 42606)))))
            : (c <= 42653 || (c < 43011
              ? (c < 42891
                ? (c < 42775
                  ? (c >= 42656 && c <= 42725)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))
                : (c <= 42943 || (c < 42997
                  ? (c >= 42946 && c <= 42954)
                  : c <= 43009)))
              : (c <= 43013 || (c < 43072
                ? (c < 43020
                  ? (c >= 43015 && c <= 43018)
                  : c <= 43042)
                : (c <= 43123 || (c < 43250
                  ? (c >= 43138 && c <= 43187)
                  : c <= 43255)))))))))))
      : (c <= 43259 || (c < 65313
        ? (c < 43808
          ? (c < 43642
            ? (c < 43488
              ? (c < 43360
                ? (c < 43274
                  ? (c >= 43261 && c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43471
                  ? (c >= 43396 && c <= 43442)
                  : c <= 43471)))
              : (c <= 43492 || (c < 43584
                ? (c < 43514
                  ? (c >= 43494 && c <= 43503)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43616
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43638)))))
            : (c <= 43642 || (c < 43739
              ? (c < 43705
                ? (c < 43697
                  ? (c >= 43646 && c <= 43695)
                  : (c <= 43697 || (c >= 43701 && c <= 43702)))
                : (c <= 43709 || (c < 43714
                  ? c == 43712
                  : c <= 43714)))
              : (c <= 43741 || (c < 43777
                ? (c < 43762
                  ? (c >= 43744 && c <= 43754)
                  : c <= 43764)
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64287
            ? (c < 55216
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 55203
                  ? c == 44032
                  : c <= 55203)))
              : (c <= 55238 || (c < 64256
                ? (c < 63744
                  ? (c >= 55243 && c <= 55291)
                  : (c <= 64109 || (c >= 64112 && c <= 64217)))
                : (c <= 64262 || (c < 64285
                  ? (c >= 64275 && c <= 64279)
                  : c <= 64285)))))
            : (c <= 64296 || (c < 64467
              ? (c < 64320
                ? (c < 64312
                  ? (c >= 64298 && c <= 64310)
                  : (c <= 64316 || c == 64318))
                : (c <= 64321 || (c < 64326
                  ? (c >= 64323 && c <= 64324)
                  : c <= 64433)))
              : (c <= 64829 || (c < 65008
                ? (c < 64914
                  ? (c >= 64848 && c <= 64911)
                  : c <= 64967)
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65338 || (c < 66864
          ? (c < 66176
            ? (c < 65536
              ? (c < 65482
                ? (c < 65382
                  ? (c >= 65345 && c <= 65370)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65498
                  ? (c >= 65490 && c <= 65495)
                  : c <= 65500)))
              : (c <= 65547 || (c < 65599
                ? (c < 65576
                  ? (c >= 65549 && c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))
                : (c <= 65613 || (c < 65664
                  ? (c >= 65616 && c <= 65629)
                  : c <= 65786)))))
            : (c <= 66204 || (c < 66464
              ? (c < 66370
                ? (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66368)))
                : (c <= 66377 || (c < 66432
                  ? (c >= 66384 && c <= 66421)
                  : c <= 66461)))
              : (c <= 66499 || (c < 66736
                ? (c < 66560
                  ? (c >= 66504 && c <= 66511)
                  : c <= 66717)
                : (c <= 66771 || (c < 66816
                  ? (c >= 66776 && c <= 66811)
                  : c <= 66855)))))))
          : (c <= 66915 || (c < 67828
            ? (c < 67639
              ? (c < 67584
                ? (c < 67392
                  ? (c >= 67072 && c <= 67382)
                  : (c <= 67413 || (c >= 67424 && c <= 67431)))
                : (c <= 67589 || (c < 67594
                  ? c == 67592
                  : c <= 67637)))
              : (c <= 67640 || (c < 67680
                ? (c < 67647
                  ? c == 67644
                  : c <= 67669)
                : (c <= 67702 || (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)))))
            : (c <= 67829 || (c < 68117
              ? (c < 68030
                ? (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : (c <= 67897 || (c >= 67968 && c <= 68023)))
                : (c <= 68031 || (c < 68112
                  ? c == 68096
                  : c <= 68115)))
              : (c <= 68119 || (c < 68224
                ? (c < 68192
                  ? (c >= 68121 && c <= 68149)
                  : c <= 68220)
                : (c <= 68252 || (c < 68297
                  ? (c >= 68288 && c <= 68295)
                  : c <= 68309)))))))))))))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 6656
    ? (c < 2979
      ? (c < 2308
        ? (c < 1369
          ? (c < 750
            ? (c < 186
              ? (c < 'a'
                ? (c < 'A'
                  ? c == '$'
                  : (c <= 'Z' || c == '_'))
                : (c <= 'z' || (c < 181
                  ? c == 170
                  : c <= 181)))
              : (c <= 186 || (c < 710
                ? (c < 216
                  ? (c >= 192 && c <= 214)
                  : (c <= 246 || (c >= 248 && c <= 705)))
                : (c <= 721 || (c < 748
                  ? (c >= 736 && c <= 740)
                  : c <= 748)))))
            : (c <= 750 || (c < 908
              ? (c < 895
                ? (c < 886
                  ? (c >= 880 && c <= 884)
                  : (c <= 887 || (c >= 890 && c <= 893)))
                : (c <= 895 || (c < 904
                  ? c == 902
                  : c <= 906)))
              : (c <= 908 || (c < 1015
                ? (c < 931
                  ? (c >= 910 && c <= 929)
                  : c <= 1013)
                : (c <= 1153 || (c < 1329
                  ? (c >= 1162 && c <= 1327)
                  : c <= 1366)))))))
          : (c <= 1369 || (c < 1869
            ? (c < 1749
              ? (c < 1568
                ? (c < 1488
                  ? (c >= 1376 && c <= 1416)
                  : (c <= 1514 || (c >= 1519 && c <= 1522)))
                : (c <= 1610 || (c < 1649
                  ? (c >= 1646 && c <= 1647)
                  : c <= 1747)))
              : (c <= 1749 || (c < 1791
                ? (c < 1774
                  ? (c >= 1765 && c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1810
                  ? c == 1808
                  : c <= 1839)))))
            : (c <= 1957 || (c < 2084
              ? (c < 2042
                ? (c < 1994
                  ? c == 1969
                  : (c <= 2026 || (c >= 2036 && c <= 2037)))
                : (c <= 2042 || (c < 2074
                  ? (c >= 2048 && c <= 2069)
                  : c <= 2074)))
              : (c <= 2084 || (c < 2144
                ? (c < 2112
                  ? c == 2088
                  : c <= 2136)
                : (c <= 2154 || (c < 2230
                  ? (c >= 2208 && c <= 2228)
                  : c <= 2247)))))))))
        : (c <= 2361 || (c < 2693
          ? (c < 2527
            ? (c < 2451
              ? (c < 2417
                ? (c < 2384
                  ? c == 2365
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2447
                  ? (c >= 2437 && c <= 2444)
                  : c <= 2448)))
              : (c <= 2472 || (c < 2493
                ? (c < 2482
                  ? (c >= 2474 && c <= 2480)
                  : (c <= 2482 || (c >= 2486 && c <= 2489)))
                : (c <= 2493 || (c < 2524
                  ? c == 2510
                  : c <= 2525)))))
            : (c <= 2529 || (c < 2610
              ? (c < 2575
                ? (c < 2556
                  ? (c >= 2544 && c <= 2545)
                  : (c <= 2556 || (c >= 2565 && c <= 2570)))
                : (c <= 2576 || (c < 2602
                  ? (c >= 2579 && c <= 2600)
                  : c <= 2608)))
              : (c <= 2611 || (c < 2649
                ? (c < 2616
                  ? (c >= 2613 && c <= 2614)
                  : c <= 2617)
                : (c <= 2652 || (c < 2674
                  ? c == 2654
                  : c <= 2676)))))))
          : (c <= 2701 || (c < 2866
            ? (c < 2768
              ? (c < 2738
                ? (c < 2707
                  ? (c >= 2703 && c <= 2705)
                  : (c <= 2728 || (c >= 2730 && c <= 2736)))
                : (c <= 2739 || (c < 2749
                  ? (c >= 2741 && c <= 2745)
                  : c <= 2749)))
              : (c <= 2768 || (c < 2831
                ? (c < 2809
                  ? (c >= 2784 && c <= 2785)
                  : (c <= 2809 || (c >= 2821 && c <= 2828)))
                : (c <= 2832 || (c < 2858
                  ? (c >= 2835 && c <= 2856)
                  : c <= 2864)))))
            : (c <= 2867 || (c < 2949
              ? (c < 2911
                ? (c < 2877
                  ? (c >= 2869 && c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2947
                  ? c == 2929
                  : c <= 2947)))
              : (c <= 2954 || (c < 2969
                ? (c < 2962
                  ? (c >= 2958 && c <= 2960)
                  : c <= 2965)
                : (c <= 2970 || (c < 2974
                  ? c == 2972
                  : c <= 2975)))))))))))
      : (c <= 2980 || (c < 4176
        ? (c < 3423
          ? (c < 3218
            ? (c < 3114
              ? (c < 3077
                ? (c < 2990
                  ? (c >= 2984 && c <= 2986)
                  : (c <= 3001 || c == 3024))
                : (c <= 3084 || (c < 3090
                  ? (c >= 3086 && c <= 3088)
                  : c <= 3112)))
              : (c <= 3129 || (c < 3200
                ? (c < 3160
                  ? c == 3133
                  : (c <= 3162 || (c >= 3168 && c <= 3169)))
                : (c <= 3200 || (c < 3214
                  ? (c >= 3205 && c <= 3212)
                  : c <= 3216)))))
            : (c <= 3240 || (c < 3332
              ? (c < 3294
                ? (c < 3253
                  ? (c >= 3242 && c <= 3251)
                  : (c <= 3257 || c == 3261))
                : (c <= 3294 || (c < 3313
                  ? (c >= 3296 && c <= 3297)
                  : c <= 3314)))
              : (c <= 3340 || (c < 3389
                ? (c < 3346
                  ? (c >= 3342 && c <= 3344)
                  : c <= 3386)
                : (c <= 3389 || (c < 3412
                  ? c == 3406
                  : c <= 3414)))))))
          : (c <= 3425 || (c < 3749
            ? (c < 3585
              ? (c < 3507
                ? (c < 3461
                  ? (c >= 3450 && c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3520
                  ? c == 3517
                  : c <= 3526)))
              : (c <= 3632 || (c < 3716
                ? (c < 3648
                  ? (c >= 3634 && c <= 3635)
                  : (c <= 3654 || (c >= 3713 && c <= 3714)))
                : (c <= 3716 || (c < 3724
                  ? (c >= 3718 && c <= 3722)
                  : c <= 3747)))))
            : (c <= 3749 || (c < 3840
              ? (c < 3776
                ? (c < 3762
                  ? (c >= 3751 && c <= 3760)
                  : (c <= 3763 || c == 3773))
                : (c <= 3780 || (c < 3804
                  ? c == 3782
                  : c <= 3807)))
              : (c <= 3840 || (c < 3976
                ? (c < 3913
                  ? (c >= 3904 && c <= 3911)
                  : c <= 3948)
                : (c <= 3980 || (c < 4159
                  ? (c >= 4096 && c <= 4138)
                  : c <= 4159)))))))))
        : (c <= 4181 || (c < 4992
          ? (c < 4696
            ? (c < 4256
              ? (c < 4206
                ? (c < 4193
                  ? (c >= 4186 && c <= 4189)
                  : (c <= 4193 || (c >= 4197 && c <= 4198)))
                : (c <= 4208 || (c < 4238
                  ? (c >= 4213 && c <= 4225)
                  : c <= 4238)))
              : (c <= 4293 || (c < 4348
                ? (c < 4301
                  ? c == 4295
                  : (c <= 4301 || (c >= 4304 && c <= 4346)))
                : (c <= 4680 || (c < 4688
                  ? (c >= 4682 && c <= 4685)
                  : c <= 4694)))))
            : (c <= 4696 || (c < 4800
              ? (c < 4752
                ? (c < 4704
                  ? (c >= 4698 && c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4792
                  ? (c >= 4786 && c <= 4789)
                  : c <= 4798)))
              : (c <= 4800 || (c < 4824
                ? (c < 4808
                  ? (c >= 4802 && c <= 4805)
                  : c <= 4822)
                : (c <= 4880 || (c < 4888
                  ? (c >= 4882 && c <= 4885)
                  : c <= 4954)))))))
          : (c <= 5007 || (c < 6016
            ? (c < 5873
              ? (c < 5743
                ? (c < 5112
                  ? (c >= 5024 && c <= 5109)
                  : (c <= 5117 || (c >= 5121 && c <= 5740)))
                : (c <= 5759 || (c < 5792
                  ? (c >= 5761 && c <= 5786)
                  : c <= 5866)))
              : (c <= 5880 || (c < 5952
                ? (c < 5902
                  ? (c >= 5888 && c <= 5900)
                  : (c <= 5905 || (c >= 5920 && c <= 5937)))
                : (c <= 5969 || (c < 5998
                  ? (c >= 5984 && c <= 5996)
                  : c <= 6000)))))
            : (c <= 6067 || (c < 6320
              ? (c < 6272
                ? (c < 6108
                  ? c == 6103
                  : (c <= 6108 || (c >= 6176 && c <= 6264)))
                : (c <= 6276 || (c < 6314
                  ? (c >= 6279 && c <= 6312)
                  : c <= 6314)))
              : (c <= 6389 || (c < 6512
                ? (c < 6480
                  ? (c >= 6400 && c <= 6430)
                  : c <= 6509)
                : (c <= 6516 || (c < 6576
                  ? (c >= 6528 && c <= 6571)
                  : c <= 6601)))))))))))))
    : (c <= 6678 || (c < 43250
      ? (c < 8579
        ? (c < 8031
          ? (c < 7401
            ? (c < 7098
              ? (c < 6981
                ? (c < 6823
                  ? (c >= 6688 && c <= 6740)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))
                : (c <= 6987 || (c < 7086
                  ? (c >= 7043 && c <= 7072)
                  : c <= 7087)))
              : (c <= 7141 || (c < 7296
                ? (c < 7245
                  ? (c >= 7168 && c <= 7203)
                  : (c <= 7247 || (c >= 7258 && c <= 7293)))
                : (c <= 7304 || (c < 7357
                  ? (c >= 7312 && c <= 7354)
                  : c <= 7359)))))
            : (c <= 7404 || (c < 7968
              ? (c < 7424
                ? (c < 7413
                  ? (c >= 7406 && c <= 7411)
                  : (c <= 7414 || c == 7418))
                : (c <= 7615 || (c < 7960
                  ? (c >= 7680 && c <= 7957)
                  : c <= 7965)))
              : (c <= 8005 || (c < 8025
                ? (c < 8016
                  ? (c >= 8008 && c <= 8013)
                  : c <= 8023)
                : (c <= 8025 || (c < 8029
                  ? c == 8027
                  : c <= 8029)))))))
          : (c <= 8061 || (c < 8450
            ? (c < 8150
              ? (c < 8130
                ? (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : (c <= 8124 || c == 8126))
                : (c <= 8132 || (c < 8144
                  ? (c >= 8134 && c <= 8140)
                  : c <= 8147)))
              : (c <= 8155 || (c < 8305
                ? (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : (c <= 8180 || (c >= 8182 && c <= 8188)))
                : (c <= 8305 || (c < 8336
                  ? c == 8319
                  : c <= 8348)))))
            : (c <= 8450 || (c < 8488
              ? (c < 8473
                ? (c < 8458
                  ? c == 8455
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8486
                  ? c == 8484
                  : c <= 8486)))
              : (c <= 8488 || (c < 8508
                ? (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : c <= 8505)
                : (c <= 8511 || (c < 8526
                  ? (c >= 8517 && c <= 8521)
                  : c <= 8526)))))))))
        : (c <= 8580 || (c < 12540
          ? (c < 11696
            ? (c < 11559
              ? (c < 11499
                ? (c < 11312
                  ? (c >= 11264 && c <= 11310)
                  : (c <= 11358 || (c >= 11360 && c <= 11492)))
                : (c <= 11502 || (c < 11520
                  ? (c >= 11506 && c <= 11507)
                  : c <= 11557)))
              : (c <= 11559 || (c < 11648
                ? (c < 11568
                  ? c == 11565
                  : (c <= 11623 || c == 11631))
                : (c <= 11670 || (c < 11688
                  ? (c >= 11680 && c <= 11686)
                  : c <= 11694)))))
            : (c <= 11702 || (c < 12293
              ? (c < 11728
                ? (c < 11712
                  ? (c >= 11704 && c <= 11710)
                  : (c <= 11718 || (c >= 11720 && c <= 11726)))
                : (c <= 11734 || (c < 11823
                  ? (c >= 11736 && c <= 11742)
                  : c <= 11823)))
              : (c <= 12294 || (c < 12353
                ? (c < 12347
                  ? (c >= 12337 && c <= 12341)
                  : c <= 12348)
                : (c <= 12438 || (c < 12449
                  ? (c >= 12445 && c <= 12447)
                  : c <= 12538)))))))
          : (c <= 12543 || (c < 42560
            ? (c < 19968
              ? (c < 12784
                ? (c < 12593
                  ? (c >= 12549 && c <= 12591)
                  : (c <= 12686 || (c >= 12704 && c <= 12735)))
                : (c <= 12799 || (c < 19903
                  ? c == 13312
                  : c <= 19903)))
              : (c <= 19968 || (c < 42240
                ? (c < 40960
                  ? c == 40956
                  : (c <= 42124 || (c >= 42192 && c <= 42237)))
                : (c <= 42508 || (c < 42538
                  ? (c >= 42512 && c <= 42527)
                  : c <= 42539)))))
            : (c <= 42606 || (c < 42997
              ? (c < 42786
                ? (c < 42656
                  ? (c >= 42623 && c <= 42653)
                  : (c <= 42725 || (c >= 42775 && c <= 42783)))
                : (c <= 42888 || (c < 42946
                  ? (c >= 42891 && c <= 42943)
                  : c <= 42954)))
              : (c <= 43009 || (c < 43020
                ? (c < 43015
                  ? (c >= 43011 && c <= 43013)
                  : c <= 43018)
                : (c <= 43042 || (c < 43138
                  ? (c >= 43072 && c <= 43123)
                  : c <= 43187)))))))))))
      : (c <= 43255 || (c < 65142
        ? (c < 43793
          ? (c < 43616
            ? (c < 43471
              ? (c < 43312
                ? (c < 43261
                  ? c == 43259
                  : (c <= 43262 || (c >= 43274 && c <= 43301)))
                : (c <= 43334 || (c < 43396
                  ? (c >= 43360 && c <= 43388)
                  : c <= 43442)))
              : (c <= 43471 || (c < 43520
                ? (c < 43494
                  ? (c >= 43488 && c <= 43492)
                  : (c <= 43503 || (c >= 43514 && c <= 43518)))
                : (c <= 43560 || (c < 43588
                  ? (c >= 43584 && c <= 43586)
                  : c <= 43595)))))
            : (c <= 43638 || (c < 43714
              ? (c < 43701
                ? (c < 43646
                  ? c == 43642
                  : (c <= 43695 || c == 43697))
                : (c <= 43702 || (c < 43712
                  ? (c >= 43705 && c <= 43709)
                  : c <= 43712)))
              : (c <= 43714 || (c < 43762
                ? (c < 43744
                  ? (c >= 43739 && c <= 43741)
                  : c <= 43754)
                : (c <= 43764 || (c < 43785
                  ? (c >= 43777 && c <= 43782)
                  : c <= 43790)))))))
          : (c <= 43798 || (c < 64285
            ? (c < 55203
              ? (c < 43868
                ? (c < 43816
                  ? (c >= 43808 && c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))
                : (c <= 43881 || (c < 44032
                  ? (c >= 43888 && c <= 44002)
                  : c <= 44032)))
              : (c <= 55203 || (c < 64112
                ? (c < 55243
                  ? (c >= 55216 && c <= 55238)
                  : (c <= 55291 || (c >= 63744 && c <= 64109)))
                : (c <= 64217 || (c < 64275
                  ? (c >= 64256 && c <= 64262)
                  : c <= 64279)))))
            : (c <= 64285 || (c < 64326
              ? (c < 64318
                ? (c < 64298
                  ? (c >= 64287 && c <= 64296)
                  : (c <= 64310 || (c >= 64312 && c <= 64316)))
                : (c <= 64318 || (c < 64323
                  ? (c >= 64320 && c <= 64321)
                  : c <= 64324)))
              : (c <= 64433 || (c < 64914
                ? (c < 64848
                  ? (c >= 64467 && c <= 64829)
                  : c <= 64911)
                : (c <= 64967 || (c < 65136
                  ? (c >= 65008 && c <= 65019)
                  : c <= 65140)))))))))
        : (c <= 65276 || (c < 66816
          ? (c < 65664
            ? (c < 65498
              ? (c < 65474
                ? (c < 65345
                  ? (c >= 65313 && c <= 65338)
                  : (c <= 65370 || (c >= 65382 && c <= 65470)))
                : (c <= 65479 || (c < 65490
                  ? (c >= 65482 && c <= 65487)
                  : c <= 65495)))
              : (c <= 65500 || (c < 65596
                ? (c < 65549
                  ? (c >= 65536 && c <= 65547)
                  : (c <= 65574 || (c >= 65576 && c <= 65594)))
                : (c <= 65597 || (c < 65616
                  ? (c >= 65599 && c <= 65613)
                  : c <= 65629)))))
            : (c <= 65786 || (c < 66432
              ? (c < 66349
                ? (c < 66208
                  ? (c >= 66176 && c <= 66204)
                  : (c <= 66256 || (c >= 66304 && c <= 66335)))
                : (c <= 66368 || (c < 66384
                  ? (c >= 66370 && c <= 66377)
                  : c <= 66421)))
              : (c <= 66461 || (c < 66560
                ? (c < 66504
                  ? (c >= 66464 && c <= 66499)
                  : c <= 66511)
                : (c <= 66717 || (c < 66776
                  ? (c >= 66736 && c <= 66771)
                  : c <= 66811)))))))
          : (c <= 66855 || (c < 67828
            ? (c < 67594
              ? (c < 67424
                ? (c < 67072
                  ? (c >= 66864 && c <= 66915)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : c <= 67592)))
              : (c <= 67637 || (c < 67680
                ? (c < 67644
                  ? (c >= 67639 && c <= 67640)
                  : (c <= 67644 || (c >= 67647 && c <= 67669)))
                : (c <= 67702 || (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)))))
            : (c <= 67829 || (c < 68117
              ? (c < 68030
                ? (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : (c <= 67897 || (c >= 67968 && c <= 68023)))
                : (c <= 68031 || (c < 68112
                  ? c == 68096
                  : c <= 68115)))
              : (c <= 68119 || (c < 68224
                ? (c < 68192
                  ? (c >= 68121 && c <= 68149)
                  : c <= 68220)
                : (c <= 68252 || (c < 68297
                  ? (c >= 68288 && c <= 68295)
                  : c <= 68309)))))))))))))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 6656
    ? (c < 2979
      ? (c < 2308
        ? (c < 1369
          ? (c < 748
            ? (c < 181
              ? (c < '_'
                ? (c < '0'
                  ? c == '$'
                  : (c <= '9' || (c >= 'A' && c <= 'Z')))
                : (c <= '_' || (c < 170
                  ? (c >= 'a' && c <= 'z')
                  : c <= 170)))
              : (c <= 181 || (c < 248
                ? (c < 192
                  ? c == 186
                  : (c <= 214 || (c >= 216 && c <= 246)))
                : (c <= 705 || (c < 736
                  ? (c >= 710 && c <= 721)
                  : c <= 740)))))
            : (c <= 748 || (c < 904
              ? (c < 890
                ? (c < 880
                  ? c == 750
                  : (c <= 884 || (c >= 886 && c <= 887)))
                : (c <= 893 || (c < 902
                  ? c == 895
                  : c <= 902)))
              : (c <= 906 || (c < 1015
                ? (c < 910
                  ? c == 908
                  : (c <= 929 || (c >= 931 && c <= 1013)))
                : (c <= 1153 || (c < 1329
                  ? (c >= 1162 && c <= 1327)
                  : c <= 1366)))))))
          : (c <= 1369 || (c < 1869
            ? (c < 1749
              ? (c < 1568
                ? (c < 1488
                  ? (c >= 1376 && c <= 1416)
                  : (c <= 1514 || (c >= 1519 && c <= 1522)))
                : (c <= 1610 || (c < 1649
                  ? (c >= 1646 && c <= 1647)
                  : c <= 1747)))
              : (c <= 1749 || (c < 1791
                ? (c < 1774
                  ? (c >= 1765 && c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1810
                  ? c == 1808
                  : c <= 1839)))))
            : (c <= 1957 || (c < 2084
              ? (c < 2042
                ? (c < 1994
                  ? c == 1969
                  : (c <= 2026 || (c >= 2036 && c <= 2037)))
                : (c <= 2042 || (c < 2074
                  ? (c >= 2048 && c <= 2069)
                  : c <= 2074)))
              : (c <= 2084 || (c < 2144
                ? (c < 2112
                  ? c == 2088
                  : c <= 2136)
                : (c <= 2154 || (c < 2230
                  ? (c >= 2208 && c <= 2228)
                  : c <= 2247)))))))))
        : (c <= 2361 || (c < 2693
          ? (c < 2527
            ? (c < 2451
              ? (c < 2417
                ? (c < 2384
                  ? c == 2365
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2447
                  ? (c >= 2437 && c <= 2444)
                  : c <= 2448)))
              : (c <= 2472 || (c < 2493
                ? (c < 2482
                  ? (c >= 2474 && c <= 2480)
                  : (c <= 2482 || (c >= 2486 && c <= 2489)))
                : (c <= 2493 || (c < 2524
                  ? c == 2510
                  : c <= 2525)))))
            : (c <= 2529 || (c < 2610
              ? (c < 2575
                ? (c < 2556
                  ? (c >= 2544 && c <= 2545)
                  : (c <= 2556 || (c >= 2565 && c <= 2570)))
                : (c <= 2576 || (c < 2602
                  ? (c >= 2579 && c <= 2600)
                  : c <= 2608)))
              : (c <= 2611 || (c < 2649
                ? (c < 2616
                  ? (c >= 2613 && c <= 2614)
                  : c <= 2617)
                : (c <= 2652 || (c < 2674
                  ? c == 2654
                  : c <= 2676)))))))
          : (c <= 2701 || (c < 2866
            ? (c < 2768
              ? (c < 2738
                ? (c < 2707
                  ? (c >= 2703 && c <= 2705)
                  : (c <= 2728 || (c >= 2730 && c <= 2736)))
                : (c <= 2739 || (c < 2749
                  ? (c >= 2741 && c <= 2745)
                  : c <= 2749)))
              : (c <= 2768 || (c < 2831
                ? (c < 2809
                  ? (c >= 2784 && c <= 2785)
                  : (c <= 2809 || (c >= 2821 && c <= 2828)))
                : (c <= 2832 || (c < 2858
                  ? (c >= 2835 && c <= 2856)
                  : c <= 2864)))))
            : (c <= 2867 || (c < 2949
              ? (c < 2911
                ? (c < 2877
                  ? (c >= 2869 && c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2947
                  ? c == 2929
                  : c <= 2947)))
              : (c <= 2954 || (c < 2969
                ? (c < 2962
                  ? (c >= 2958 && c <= 2960)
                  : c <= 2965)
                : (c <= 2970 || (c < 2974
                  ? c == 2972
                  : c <= 2975)))))))))))
      : (c <= 2980 || (c < 4176
        ? (c < 3423
          ? (c < 3218
            ? (c < 3114
              ? (c < 3077
                ? (c < 2990
                  ? (c >= 2984 && c <= 2986)
                  : (c <= 3001 || c == 3024))
                : (c <= 3084 || (c < 3090
                  ? (c >= 3086 && c <= 3088)
                  : c <= 3112)))
              : (c <= 3129 || (c < 3200
                ? (c < 3160
                  ? c == 3133
                  : (c <= 3162 || (c >= 3168 && c <= 3169)))
                : (c <= 3200 || (c < 3214
                  ? (c >= 3205 && c <= 3212)
                  : c <= 3216)))))
            : (c <= 3240 || (c < 3332
              ? (c < 3294
                ? (c < 3253
                  ? (c >= 3242 && c <= 3251)
                  : (c <= 3257 || c == 3261))
                : (c <= 3294 || (c < 3313
                  ? (c >= 3296 && c <= 3297)
                  : c <= 3314)))
              : (c <= 3340 || (c < 3389
                ? (c < 3346
                  ? (c >= 3342 && c <= 3344)
                  : c <= 3386)
                : (c <= 3389 || (c < 3412
                  ? c == 3406
                  : c <= 3414)))))))
          : (c <= 3425 || (c < 3749
            ? (c < 3585
              ? (c < 3507
                ? (c < 3461
                  ? (c >= 3450 && c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3520
                  ? c == 3517
                  : c <= 3526)))
              : (c <= 3632 || (c < 3716
                ? (c < 3648
                  ? (c >= 3634 && c <= 3635)
                  : (c <= 3654 || (c >= 3713 && c <= 3714)))
                : (c <= 3716 || (c < 3724
                  ? (c >= 3718 && c <= 3722)
                  : c <= 3747)))))
            : (c <= 3749 || (c < 3840
              ? (c < 3776
                ? (c < 3762
                  ? (c >= 3751 && c <= 3760)
                  : (c <= 3763 || c == 3773))
                : (c <= 3780 || (c < 3804
                  ? c == 3782
                  : c <= 3807)))
              : (c <= 3840 || (c < 3976
                ? (c < 3913
                  ? (c >= 3904 && c <= 3911)
                  : c <= 3948)
                : (c <= 3980 || (c < 4159
                  ? (c >= 4096 && c <= 4138)
                  : c <= 4159)))))))))
        : (c <= 4181 || (c < 4992
          ? (c < 4696
            ? (c < 4256
              ? (c < 4206
                ? (c < 4193
                  ? (c >= 4186 && c <= 4189)
                  : (c <= 4193 || (c >= 4197 && c <= 4198)))
                : (c <= 4208 || (c < 4238
                  ? (c >= 4213 && c <= 4225)
                  : c <= 4238)))
              : (c <= 4293 || (c < 4348
                ? (c < 4301
                  ? c == 4295
                  : (c <= 4301 || (c >= 4304 && c <= 4346)))
                : (c <= 4680 || (c < 4688
                  ? (c >= 4682 && c <= 4685)
                  : c <= 4694)))))
            : (c <= 4696 || (c < 4800
              ? (c < 4752
                ? (c < 4704
                  ? (c >= 4698 && c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4792
                  ? (c >= 4786 && c <= 4789)
                  : c <= 4798)))
              : (c <= 4800 || (c < 4824
                ? (c < 4808
                  ? (c >= 4802 && c <= 4805)
                  : c <= 4822)
                : (c <= 4880 || (c < 4888
                  ? (c >= 4882 && c <= 4885)
                  : c <= 4954)))))))
          : (c <= 5007 || (c < 6016
            ? (c < 5873
              ? (c < 5743
                ? (c < 5112
                  ? (c >= 5024 && c <= 5109)
                  : (c <= 5117 || (c >= 5121 && c <= 5740)))
                : (c <= 5759 || (c < 5792
                  ? (c >= 5761 && c <= 5786)
                  : c <= 5866)))
              : (c <= 5880 || (c < 5952
                ? (c < 5902
                  ? (c >= 5888 && c <= 5900)
                  : (c <= 5905 || (c >= 5920 && c <= 5937)))
                : (c <= 5969 || (c < 5998
                  ? (c >= 5984 && c <= 5996)
                  : c <= 6000)))))
            : (c <= 6067 || (c < 6320
              ? (c < 6272
                ? (c < 6108
                  ? c == 6103
                  : (c <= 6108 || (c >= 6176 && c <= 6264)))
                : (c <= 6276 || (c < 6314
                  ? (c >= 6279 && c <= 6312)
                  : c <= 6314)))
              : (c <= 6389 || (c < 6512
                ? (c < 6480
                  ? (c >= 6400 && c <= 6430)
                  : c <= 6509)
                : (c <= 6516 || (c < 6576
                  ? (c >= 6528 && c <= 6571)
                  : c <= 6601)))))))))))))
    : (c <= 6678 || (c < 43250
      ? (c < 8579
        ? (c < 8031
          ? (c < 7401
            ? (c < 7098
              ? (c < 6981
                ? (c < 6823
                  ? (c >= 6688 && c <= 6740)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))
                : (c <= 6987 || (c < 7086
                  ? (c >= 7043 && c <= 7072)
                  : c <= 7087)))
              : (c <= 7141 || (c < 7296
                ? (c < 7245
                  ? (c >= 7168 && c <= 7203)
                  : (c <= 7247 || (c >= 7258 && c <= 7293)))
                : (c <= 7304 || (c < 7357
                  ? (c >= 7312 && c <= 7354)
                  : c <= 7359)))))
            : (c <= 7404 || (c < 7968
              ? (c < 7424
                ? (c < 7413
                  ? (c >= 7406 && c <= 7411)
                  : (c <= 7414 || c == 7418))
                : (c <= 7615 || (c < 7960
                  ? (c >= 7680 && c <= 7957)
                  : c <= 7965)))
              : (c <= 8005 || (c < 8025
                ? (c < 8016
                  ? (c >= 8008 && c <= 8013)
                  : c <= 8023)
                : (c <= 8025 || (c < 8029
                  ? c == 8027
                  : c <= 8029)))))))
          : (c <= 8061 || (c < 8450
            ? (c < 8150
              ? (c < 8130
                ? (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : (c <= 8124 || c == 8126))
                : (c <= 8132 || (c < 8144
                  ? (c >= 8134 && c <= 8140)
                  : c <= 8147)))
              : (c <= 8155 || (c < 8305
                ? (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : (c <= 8180 || (c >= 8182 && c <= 8188)))
                : (c <= 8305 || (c < 8336
                  ? c == 8319
                  : c <= 8348)))))
            : (c <= 8450 || (c < 8488
              ? (c < 8473
                ? (c < 8458
                  ? c == 8455
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8486
                  ? c == 8484
                  : c <= 8486)))
              : (c <= 8488 || (c < 8508
                ? (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : c <= 8505)
                : (c <= 8511 || (c < 8526
                  ? (c >= 8517 && c <= 8521)
                  : c <= 8526)))))))))
        : (c <= 8580 || (c < 12540
          ? (c < 11696
            ? (c < 11559
              ? (c < 11499
                ? (c < 11312
                  ? (c >= 11264 && c <= 11310)
                  : (c <= 11358 || (c >= 11360 && c <= 11492)))
                : (c <= 11502 || (c < 11520
                  ? (c >= 11506 && c <= 11507)
                  : c <= 11557)))
              : (c <= 11559 || (c < 11648
                ? (c < 11568
                  ? c == 11565
                  : (c <= 11623 || c == 11631))
                : (c <= 11670 || (c < 11688
                  ? (c >= 11680 && c <= 11686)
                  : c <= 11694)))))
            : (c <= 11702 || (c < 12293
              ? (c < 11728
                ? (c < 11712
                  ? (c >= 11704 && c <= 11710)
                  : (c <= 11718 || (c >= 11720 && c <= 11726)))
                : (c <= 11734 || (c < 11823
                  ? (c >= 11736 && c <= 11742)
                  : c <= 11823)))
              : (c <= 12294 || (c < 12353
                ? (c < 12347
                  ? (c >= 12337 && c <= 12341)
                  : c <= 12348)
                : (c <= 12438 || (c < 12449
                  ? (c >= 12445 && c <= 12447)
                  : c <= 12538)))))))
          : (c <= 12543 || (c < 42560
            ? (c < 19968
              ? (c < 12784
                ? (c < 12593
                  ? (c >= 12549 && c <= 12591)
                  : (c <= 12686 || (c >= 12704 && c <= 12735)))
                : (c <= 12799 || (c < 19903
                  ? c == 13312
                  : c <= 19903)))
              : (c <= 19968 || (c < 42240
                ? (c < 40960
                  ? c == 40956
                  : (c <= 42124 || (c >= 42192 && c <= 42237)))
                : (c <= 42508 || (c < 42538
                  ? (c >= 42512 && c <= 42527)
                  : c <= 42539)))))
            : (c <= 42606 || (c < 42997
              ? (c < 42786
                ? (c < 42656
                  ? (c >= 42623 && c <= 42653)
                  : (c <= 42725 || (c >= 42775 && c <= 42783)))
                : (c <= 42888 || (c < 42946
                  ? (c >= 42891 && c <= 42943)
                  : c <= 42954)))
              : (c <= 43009 || (c < 43020
                ? (c < 43015
                  ? (c >= 43011 && c <= 43013)
                  : c <= 43018)
                : (c <= 43042 || (c < 43138
                  ? (c >= 43072 && c <= 43123)
                  : c <= 43187)))))))))))
      : (c <= 43255 || (c < 65142
        ? (c < 43793
          ? (c < 43616
            ? (c < 43471
              ? (c < 43312
                ? (c < 43261
                  ? c == 43259
                  : (c <= 43262 || (c >= 43274 && c <= 43301)))
                : (c <= 43334 || (c < 43396
                  ? (c >= 43360 && c <= 43388)
                  : c <= 43442)))
              : (c <= 43471 || (c < 43520
                ? (c < 43494
                  ? (c >= 43488 && c <= 43492)
                  : (c <= 43503 || (c >= 43514 && c <= 43518)))
                : (c <= 43560 || (c < 43588
                  ? (c >= 43584 && c <= 43586)
                  : c <= 43595)))))
            : (c <= 43638 || (c < 43714
              ? (c < 43701
                ? (c < 43646
                  ? c == 43642
                  : (c <= 43695 || c == 43697))
                : (c <= 43702 || (c < 43712
                  ? (c >= 43705 && c <= 43709)
                  : c <= 43712)))
              : (c <= 43714 || (c < 43762
                ? (c < 43744
                  ? (c >= 43739 && c <= 43741)
                  : c <= 43754)
                : (c <= 43764 || (c < 43785
                  ? (c >= 43777 && c <= 43782)
                  : c <= 43790)))))))
          : (c <= 43798 || (c < 64285
            ? (c < 55203
              ? (c < 43868
                ? (c < 43816
                  ? (c >= 43808 && c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))
                : (c <= 43881 || (c < 44032
                  ? (c >= 43888 && c <= 44002)
                  : c <= 44032)))
              : (c <= 55203 || (c < 64112
                ? (c < 55243
                  ? (c >= 55216 && c <= 55238)
                  : (c <= 55291 || (c >= 63744 && c <= 64109)))
                : (c <= 64217 || (c < 64275
                  ? (c >= 64256 && c <= 64262)
                  : c <= 64279)))))
            : (c <= 64285 || (c < 64326
              ? (c < 64318
                ? (c < 64298
                  ? (c >= 64287 && c <= 64296)
                  : (c <= 64310 || (c >= 64312 && c <= 64316)))
                : (c <= 64318 || (c < 64323
                  ? (c >= 64320 && c <= 64321)
                  : c <= 64324)))
              : (c <= 64433 || (c < 64914
                ? (c < 64848
                  ? (c >= 64467 && c <= 64829)
                  : c <= 64911)
                : (c <= 64967 || (c < 65136
                  ? (c >= 65008 && c <= 65019)
                  : c <= 65140)))))))))
        : (c <= 65276 || (c < 66816
          ? (c < 65664
            ? (c < 65498
              ? (c < 65474
                ? (c < 65345
                  ? (c >= 65313 && c <= 65338)
                  : (c <= 65370 || (c >= 65382 && c <= 65470)))
                : (c <= 65479 || (c < 65490
                  ? (c >= 65482 && c <= 65487)
                  : c <= 65495)))
              : (c <= 65500 || (c < 65596
                ? (c < 65549
                  ? (c >= 65536 && c <= 65547)
                  : (c <= 65574 || (c >= 65576 && c <= 65594)))
                : (c <= 65597 || (c < 65616
                  ? (c >= 65599 && c <= 65613)
                  : c <= 65629)))))
            : (c <= 65786 || (c < 66432
              ? (c < 66349
                ? (c < 66208
                  ? (c >= 66176 && c <= 66204)
                  : (c <= 66256 || (c >= 66304 && c <= 66335)))
                : (c <= 66368 || (c < 66384
                  ? (c >= 66370 && c <= 66377)
                  : c <= 66421)))
              : (c <= 66461 || (c < 66560
                ? (c < 66504
                  ? (c >= 66464 && c <= 66499)
                  : c <= 66511)
                : (c <= 66717 || (c < 66776
                  ? (c >= 66736 && c <= 66771)
                  : c <= 66811)))))))
          : (c <= 66855 || (c < 67828
            ? (c < 67594
              ? (c < 67424
                ? (c < 67072
                  ? (c >= 66864 && c <= 66915)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : c <= 67592)))
              : (c <= 67637 || (c < 67680
                ? (c < 67644
                  ? (c >= 67639 && c <= 67640)
                  : (c <= 67644 || (c >= 67647 && c <= 67669)))
                : (c <= 67702 || (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)))))
            : (c <= 67829 || (c < 68117
              ? (c < 68030
                ? (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : (c <= 67897 || (c >= 67968 && c <= 68023)))
                : (c <= 68031 || (c < 68112
                  ? c == 68096
                  : c <= 68115)))
              : (c <= 68119 || (c < 68224
                ? (c < 68192
                  ? (c >= 68121 && c <= 68149)
                  : c <= 68220)
                : (c <= 68252 || (c < 68297
                  ? (c >= 68288 && c <= 68295)
                  : c <= 68309)))))))))))))));
}

static inline bool sym_escape_char_character_set_1(int32_t c) {
  return (c < 'f'
    ? (c < '\\'
      ? (c < '\''
        ? c == '"'
        : c <= '\'')
      : (c <= '\\' || (c >= 'a' && c <= 'b')))
    : (c <= 'f' || (c < 't'
      ? (c < 'r'
        ? c == 'n'
        : c <= 'r')
      : (c <= 't' || c == 'v'))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(75);
      if (lookahead == '!') ADVANCE(158);
      if (lookahead == '"') ADVANCE(95);
      if (lookahead == '#') ADVANCE(7);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(84);
      if (lookahead == '&') ADVANCE(143);
      if (lookahead == '\'') ADVANCE(102);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(156);
      if (lookahead == '+') ADVANCE(154);
      if (lookahead == ',') ADVANCE(77);
      if (lookahead == '-') ADVANCE(155);
      if (lookahead == '.') ADVANCE(81);
      if (lookahead == '/') ADVANCE(157);
      if (lookahead == '0') ADVANCE(118);
      if (lookahead == ':') ADVANCE(141);
      if (lookahead == '<') ADVANCE(148);
      if (lookahead == '=') ADVANCE(140);
      if (lookahead == '>') ADVANCE(150);
      if (lookahead == '?') ADVANCE(138);
      if (lookahead == '@') ADVANCE(85);
      if (lookahead == '[') ADVANCE(159);
      if (lookahead == '\\') ADVANCE(49);
      if (lookahead == ']') ADVANCE(134);
      if (lookahead == '_') ADVANCE(82);
      if (lookahead == '{') ADVANCE(135);
      if (lookahead == '|') ADVANCE(142);
      if (lookahead == '}') ADVANCE(136);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(73)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(119);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(76);
      if (lookahead == '!') ADVANCE(158);
      if (lookahead == '"') ADVANCE(95);
      if (lookahead == '#') ADVANCE(7);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(84);
      if (lookahead == '&') ADVANCE(143);
      if (lookahead == '\'') ADVANCE(102);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == '*') ADVANCE(156);
      if (lookahead == '+') ADVANCE(154);
      if (lookahead == ',') ADVANCE(77);
      if (lookahead == '-') ADVANCE(155);
      if (lookahead == '.') ADVANCE(81);
      if (lookahead == '/') ADVANCE(157);
      if (lookahead == '0') ADVANCE(118);
      if (lookahead == ':') ADVANCE(141);
      if (lookahead == '<') ADVANCE(148);
      if (lookahead == '=') ADVANCE(140);
      if (lookahead == '>') ADVANCE(150);
      if (lookahead == '?') ADVANCE(138);
      if (lookahead == '@') ADVANCE(85);
      if (lookahead == '[') ADVANCE(159);
      if (lookahead == '_') ADVANCE(82);
      if (lookahead == '{') ADVANCE(135);
      if (lookahead == '|') ADVANCE(142);
      if (lookahead == '}') ADVANCE(136);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(2)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(119);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(76);
      if (lookahead == '!') ADVANCE(158);
      if (lookahead == '"') ADVANCE(95);
      if (lookahead == '#') ADVANCE(7);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(84);
      if (lookahead == '&') ADVANCE(143);
      if (lookahead == '\'') ADVANCE(102);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == '*') ADVANCE(156);
      if (lookahead == '+') ADVANCE(154);
      if (lookahead == ',') ADVANCE(77);
      if (lookahead == '-') ADVANCE(155);
      if (lookahead == '.') ADVANCE(81);
      if (lookahead == '/') ADVANCE(157);
      if (lookahead == '0') ADVANCE(118);
      if (lookahead == ':') ADVANCE(141);
      if (lookahead == '<') ADVANCE(148);
      if (lookahead == '=') ADVANCE(140);
      if (lookahead == '>') ADVANCE(150);
      if (lookahead == '?') ADVANCE(138);
      if (lookahead == '@') ADVANCE(85);
      if (lookahead == '[') ADVANCE(133);
      if (lookahead == '_') ADVANCE(82);
      if (lookahead == '{') ADVANCE(135);
      if (lookahead == '|') ADVANCE(142);
      if (lookahead == '}') ADVANCE(136);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(2)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(119);
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(76);
      if (lookahead == '!') ADVANCE(158);
      if (lookahead == '"') ADVANCE(95);
      if (lookahead == '#') ADVANCE(7);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(84);
      if (lookahead == '&') ADVANCE(143);
      if (lookahead == '\'') ADVANCE(102);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == '*') ADVANCE(156);
      if (lookahead == '+') ADVANCE(154);
      if (lookahead == ',') ADVANCE(77);
      if (lookahead == '-') ADVANCE(155);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '/') ADVANCE(157);
      if (lookahead == '0') ADVANCE(118);
      if (lookahead == '<') ADVANCE(148);
      if (lookahead == '=') ADVANCE(37);
      if (lookahead == '>') ADVANCE(150);
      if (lookahead == '@') ADVANCE(85);
      if (lookahead == '[') ADVANCE(133);
      if (lookahead == '_') ADVANCE(82);
      if (lookahead == '{') ADVANCE(135);
      if (lookahead == '|') ADVANCE(142);
      if (lookahead == '}') ADVANCE(136);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(119);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(22)
      if (lookahead == '\'') ADVANCE(101);
      if (lookahead == '/') ADVANCE(104);
      if (lookahead == '\\') ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(103);
      if (lookahead != 0) ADVANCE(105);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(11)
      if (lookahead == '"') ADVANCE(94);
      if (lookahead == '/') ADVANCE(97);
      if (lookahead == '\\') ADVANCE(51);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(96);
      if (lookahead != 0) ADVANCE(98);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(36);
      if (lookahead == '"') ADVANCE(95);
      if (lookahead == '#') ADVANCE(7);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(84);
      if (lookahead == '&') ADVANCE(143);
      if (lookahead == '\'') ADVANCE(102);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(156);
      if (lookahead == '+') ADVANCE(154);
      if (lookahead == ',') ADVANCE(77);
      if (lookahead == '-') ADVANCE(155);
      if (lookahead == '.') ADVANCE(80);
      if (lookahead == '/') ADVANCE(157);
      if (lookahead == '<') ADVANCE(148);
      if (lookahead == '=') ADVANCE(37);
      if (lookahead == '>') ADVANCE(150);
      if (lookahead == '_') ADVANCE(83);
      if (lookahead == '{') ADVANCE(135);
      if (lookahead == '|') ADVANCE(142);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(6)
      END_STATE();
    case 7:
      if (lookahead == '"') ADVANCE(99);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(84);
      if (lookahead == '\'') ADVANCE(106);
      END_STATE();
    case 8:
      if (lookahead == '"') ADVANCE(108);
      END_STATE();
    case 9:
      if (lookahead == '"') ADVANCE(109);
      END_STATE();
    case 10:
      if (lookahead == '"') ADVANCE(94);
      if (lookahead == '#') ADVANCE(72);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(84);
      if (lookahead == '\'') ADVANCE(17);
      if (lookahead == '/') ADVANCE(34);
      if (lookahead == ':') ADVANCE(141);
      if (lookahead == '=') ADVANCE(139);
      if (lookahead == '?') ADVANCE(138);
      if (lookahead == '[') ADVANCE(133);
      if (lookahead == '\\') ADVANCE(15);
      if (lookahead == '_') ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(10)
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(94);
      if (lookahead == '/') ADVANCE(34);
      if (lookahead == '\\') ADVANCE(24);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(11)
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == '/') ADVANCE(34);
      if (lookahead == '\\') ADVANCE(15);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(12)
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(14);
      if (lookahead == '#') ADVANCE(100);
      END_STATE();
    case 14:
      if (lookahead == '"') ADVANCE(19);
      END_STATE();
    case 15:
      if (lookahead == '#') ADVANCE(25);
      END_STATE();
    case 16:
      if (lookahead == '#') ADVANCE(25);
      if (lookahead == '(') ADVANCE(114);
      END_STATE();
    case 17:
      if (lookahead == '#') ADVANCE(107);
      if (lookahead == '\'') ADVANCE(23);
      END_STATE();
    case 18:
      if (lookahead == '#') ADVANCE(113);
      END_STATE();
    case 19:
      if (lookahead == '#') ADVANCE(110);
      END_STATE();
    case 20:
      if (lookahead == '\'') ADVANCE(111);
      END_STATE();
    case 21:
      if (lookahead == '\'') ADVANCE(112);
      END_STATE();
    case 22:
      if (lookahead == '\'') ADVANCE(101);
      if (lookahead == '/') ADVANCE(34);
      if (lookahead == '\\') ADVANCE(24);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(22)
      END_STATE();
    case 23:
      if (lookahead == '\'') ADVANCE(18);
      END_STATE();
    case 24:
      if (lookahead == '(') ADVANCE(114);
      END_STATE();
    case 25:
      if (lookahead == '(') ADVANCE(115);
      END_STATE();
    case 26:
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == 'U') ADVANCE(71);
      if (lookahead == 'u') ADVANCE(67);
      if (lookahead == 'x') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(56);
      END_STATE();
    case 27:
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '/') ADVANCE(88);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(89);
      END_STATE();
    case 28:
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '0') ADVANCE(130);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(131);
      END_STATE();
    case 29:
      if (lookahead == '.') ADVANCE(137);
      END_STATE();
    case 30:
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(43);
      if (lookahead == '_') ADVANCE(53);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(30);
      END_STATE();
    case 31:
      if (lookahead == '.') ADVANCE(35);
      if (lookahead == 'G' ||
          lookahead == 'K' ||
          lookahead == 'M' ||
          lookahead == 'P' ||
          lookahead == 'T') ADVANCE(124);
      END_STATE();
    case 32:
      if (lookahead == '.') ADVANCE(35);
      if (lookahead == 'G' ||
          lookahead == 'K' ||
          lookahead == 'M' ||
          lookahead == 'P' ||
          lookahead == 'T') ADVANCE(124);
      if (lookahead == '_') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(32);
      END_STATE();
    case 33:
      if (lookahead == '.') ADVANCE(61);
      if (lookahead == '_') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(121);
      END_STATE();
    case 34:
      if (lookahead == '/') ADVANCE(160);
      END_STATE();
    case 35:
      if (lookahead == '0') ADVANCE(31);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(32);
      END_STATE();
    case 36:
      if (lookahead == '=') ADVANCE(147);
      if (lookahead == '~') ADVANCE(153);
      END_STATE();
    case 37:
      if (lookahead == '=') ADVANCE(146);
      if (lookahead == '~') ADVANCE(152);
      END_STATE();
    case 38:
      if (lookahead == 'U') ADVANCE(71);
      if (lookahead == 'u') ADVANCE(67);
      END_STATE();
    case 39:
      if (lookahead == 'U') ADVANCE(71);
      if (lookahead == 'u') ADVANCE(67);
      if (lookahead == 'x') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(56);
      END_STATE();
    case 40:
      if (lookahead == '_') ADVANCE(46);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(122);
      END_STATE();
    case 41:
      if (lookahead == '_') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(123);
      END_STATE();
    case 42:
      if (lookahead == '_') ADVANCE(116);
      END_STATE();
    case 43:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(128);
      END_STATE();
    case 44:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(43);
      if (lookahead == '_') ADVANCE(61);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 45:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 46:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(122);
      END_STATE();
    case 47:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(30);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(120);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(123);
      END_STATE();
    case 49:
      if (sym_escape_char_character_set_1(lookahead)) ADVANCE(90);
      if (lookahead == '#') ADVANCE(26);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == 'U') ADVANCE(71);
      if (lookahead == 'u') ADVANCE(67);
      if (lookahead == 'x') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(56);
      END_STATE();
    case 50:
      if (sym_escape_char_character_set_1(lookahead)) ADVANCE(90);
      if (lookahead == '#') ADVANCE(39);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == 'U') ADVANCE(71);
      if (lookahead == 'u') ADVANCE(67);
      if (lookahead == 'x') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(56);
      END_STATE();
    case 51:
      if (sym_escape_char_character_set_1(lookahead)) ADVANCE(90);
      if (lookahead == '#') ADVANCE(38);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == 'U') ADVANCE(71);
      if (lookahead == 'u') ADVANCE(67);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(119);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(30);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(129);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(128);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(92);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(32);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(131);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(126);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(121);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 62:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(91);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(93);
      END_STATE();
    case 64:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 65:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 66:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 67:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(66);
      END_STATE();
    case 68:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      END_STATE();
    case 69:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(68);
      END_STATE();
    case 70:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(69);
      END_STATE();
    case 71:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(70);
      END_STATE();
    case 72:
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(84);
      END_STATE();
    case 73:
      if (eof) ADVANCE(75);
      if (lookahead == '!') ADVANCE(158);
      if (lookahead == '"') ADVANCE(95);
      if (lookahead == '#') ADVANCE(7);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(84);
      if (lookahead == '&') ADVANCE(143);
      if (lookahead == '\'') ADVANCE(102);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(156);
      if (lookahead == '+') ADVANCE(154);
      if (lookahead == ',') ADVANCE(77);
      if (lookahead == '-') ADVANCE(155);
      if (lookahead == '.') ADVANCE(81);
      if (lookahead == '/') ADVANCE(157);
      if (lookahead == '0') ADVANCE(118);
      if (lookahead == ':') ADVANCE(141);
      if (lookahead == '<') ADVANCE(148);
      if (lookahead == '=') ADVANCE(140);
      if (lookahead == '>') ADVANCE(150);
      if (lookahead == '?') ADVANCE(138);
      if (lookahead == '@') ADVANCE(85);
      if (lookahead == '[') ADVANCE(133);
      if (lookahead == '\\') ADVANCE(16);
      if (lookahead == ']') ADVANCE(134);
      if (lookahead == '_') ADVANCE(82);
      if (lookahead == '{') ADVANCE(135);
      if (lookahead == '|') ADVANCE(142);
      if (lookahead == '}') ADVANCE(136);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(73)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(119);
      END_STATE();
    case 74:
      if (eof) ADVANCE(75);
      if (lookahead == '!') ADVANCE(158);
      if (lookahead == '"') ADVANCE(95);
      if (lookahead == '#') ADVANCE(7);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(84);
      if (lookahead == '&') ADVANCE(143);
      if (lookahead == '\'') ADVANCE(102);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(156);
      if (lookahead == '+') ADVANCE(154);
      if (lookahead == ',') ADVANCE(77);
      if (lookahead == '-') ADVANCE(155);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '/') ADVANCE(157);
      if (lookahead == '0') ADVANCE(118);
      if (lookahead == '<') ADVANCE(148);
      if (lookahead == '=') ADVANCE(37);
      if (lookahead == '>') ADVANCE(150);
      if (lookahead == '@') ADVANCE(85);
      if (lookahead == '[') ADVANCE(133);
      if (lookahead == ']') ADVANCE(134);
      if (lookahead == '_') ADVANCE(82);
      if (lookahead == '{') ADVANCE(135);
      if (lookahead == '|') ADVANCE(142);
      if (lookahead == '}') ADVANCE(136);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(74)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(119);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(76);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_dot);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_dot);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '0') ADVANCE(130);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(131);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '#') ADVANCE(72);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(84);
      if (lookahead == '|') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(84);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '#') ADVANCE(72);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(84);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(84);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(84);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_attr_token);
      if (lookahead == '\n') ADVANCE(89);
      if (lookahead == '(' ||
          lookahead == ')' ||
          lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(160);
      if (lookahead != 0) ADVANCE(86);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_attr_token);
      if (lookahead == '/') ADVANCE(88);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(89);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_attr_token);
      if (lookahead == '/') ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(89);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_attr_token);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(89);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_escape_char);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_escape_byte);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_escape_byte);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(91);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_escape_unicode);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead == '"') ADVANCE(8);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(aux_sym_simple_string_lit_token1);
      if (lookahead == '/') ADVANCE(97);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(96);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(98);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(aux_sym_simple_string_lit_token1);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(98);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(aux_sym_simple_string_lit_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(98);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_POUND_DQUOTE);
      if (lookahead == '"') ADVANCE(9);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_DQUOTE_POUND);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if (lookahead == '\'') ADVANCE(20);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(aux_sym_simple_bytes_lit_token1);
      if (lookahead == '/') ADVANCE(104);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(103);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(105);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(aux_sym_simple_bytes_lit_token1);
      if (lookahead == '/') ADVANCE(105);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(105);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(aux_sym_simple_bytes_lit_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(105);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_POUND_SQUOTE);
      if (lookahead == '\'') ADVANCE(21);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_SQUOTE_POUND);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE_DQUOTE);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE_DQUOTE_POUND);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_SQUOTE_SQUOTE_SQUOTE);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_SQUOTE_SQUOTE_SQUOTE_POUND);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_BSLASH_LPAREN);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_BSLASH_POUND_LPAREN);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_bottom_lit);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_int_lit);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_int_lit);
      if (lookahead == '.') ADVANCE(127);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(40);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(43);
      if (lookahead == 'G' ||
          lookahead == 'K' ||
          lookahead == 'M' ||
          lookahead == 'P' ||
          lookahead == 'T') ADVANCE(124);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(41);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(33);
      if (lookahead == '_') ADVANCE(47);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(30);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(120);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_int_lit);
      if (lookahead == '.') ADVANCE(127);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(43);
      if (lookahead == 'G' ||
          lookahead == 'K' ||
          lookahead == 'M' ||
          lookahead == 'P' ||
          lookahead == 'T') ADVANCE(124);
      if (lookahead == '_') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(119);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_int_lit);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(43);
      if (lookahead == '_') ADVANCE(47);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(30);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(120);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_int_lit);
      if (lookahead == '.') ADVANCE(45);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(43);
      if (lookahead == '_') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(121);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_int_lit);
      if (lookahead == '_') ADVANCE(46);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(122);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_int_lit);
      if (lookahead == '_') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(123);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_int_lit);
      if (lookahead == 'i') ADVANCE(117);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_float_lit);
      if (lookahead == '.') ADVANCE(35);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(43);
      if (lookahead == 'G' ||
          lookahead == 'K' ||
          lookahead == 'M' ||
          lookahead == 'P' ||
          lookahead == 'T') ADVANCE(124);
      if (lookahead == '_') ADVANCE(54);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(129);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_float_lit);
      if (lookahead == '.') ADVANCE(35);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(43);
      if (lookahead == 'G' ||
          lookahead == 'K' ||
          lookahead == 'M' ||
          lookahead == 'P' ||
          lookahead == 'T') ADVANCE(124);
      if (lookahead == '_') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(126);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_float_lit);
      if (lookahead == '0') ADVANCE(125);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(43);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(126);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_float_lit);
      if (lookahead == '_') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(128);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_float_lit);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(43);
      if (lookahead == '_') ADVANCE(54);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(129);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_float_lit);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(43);
      if (lookahead == 'G' ||
          lookahead == 'K' ||
          lookahead == 'M' ||
          lookahead == 'P' ||
          lookahead == 'T') ADVANCE(124);
      if (lookahead == '_') ADVANCE(54);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(129);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_float_lit);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(43);
      if (lookahead == 'G' ||
          lookahead == 'K' ||
          lookahead == 'M' ||
          lookahead == 'P' ||
          lookahead == 'T') ADVANCE(124);
      if (lookahead == '_') ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(131);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_float_lit);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(129);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(146);
      if (lookahead == '~') ADVANCE(152);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(144);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(145);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(149);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(151);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_BANG_TILDE);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(160);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(147);
      if (lookahead == '~') ADVANCE(153);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_LBRACK2);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(160);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == '_') ADVANCE(1);
      if (lookahead == 'a') ADVANCE(2);
      if (lookahead == 'b') ADVANCE(3);
      if (lookahead == 'c') ADVANCE(4);
      if (lookahead == 'd') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'i') ADVANCE(7);
      if (lookahead == 'l') ADVANCE(8);
      if (lookahead == 'm') ADVANCE(9);
      if (lookahead == 'n') ADVANCE(10);
      if (lookahead == 'o') ADVANCE(11);
      if (lookahead == 'p') ADVANCE(12);
      if (lookahead == 'q') ADVANCE(13);
      if (lookahead == 'r') ADVANCE(14);
      if (lookahead == 's') ADVANCE(15);
      if (lookahead == 't') ADVANCE(16);
      if (lookahead == 'u') ADVANCE(17);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 2:
      if (lookahead == 'n') ADVANCE(18);
      END_STATE();
    case 3:
      if (lookahead == 'o') ADVANCE(19);
      if (lookahead == 'y') ADVANCE(20);
      END_STATE();
    case 4:
      if (lookahead == 'l') ADVANCE(21);
      END_STATE();
    case 5:
      if (lookahead == 'i') ADVANCE(22);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(23);
      if (lookahead == 'l') ADVANCE(24);
      if (lookahead == 'o') ADVANCE(25);
      END_STATE();
    case 7:
      if (lookahead == 'f') ADVANCE(26);
      if (lookahead == 'm') ADVANCE(27);
      if (lookahead == 'n') ADVANCE(28);
      END_STATE();
    case 8:
      if (lookahead == 'e') ADVANCE(29);
      END_STATE();
    case 9:
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 10:
      if (lookahead == 'u') ADVANCE(31);
      END_STATE();
    case 11:
      if (lookahead == 'r') ADVANCE(32);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(33);
      END_STATE();
    case 13:
      if (lookahead == 'u') ADVANCE(34);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(35);
      END_STATE();
    case 15:
      if (lookahead == 't') ADVANCE(36);
      END_STATE();
    case 16:
      if (lookahead == 'r') ADVANCE(37);
      END_STATE();
    case 17:
      if (lookahead == 'i') ADVANCE(38);
      END_STATE();
    case 18:
      if (lookahead == 'd') ADVANCE(39);
      END_STATE();
    case 19:
      if (lookahead == 'o') ADVANCE(40);
      END_STATE();
    case 20:
      if (lookahead == 't') ADVANCE(41);
      END_STATE();
    case 21:
      if (lookahead == 'o') ADVANCE(42);
      END_STATE();
    case 22:
      if (lookahead == 'v') ADVANCE(43);
      END_STATE();
    case 23:
      if (lookahead == 'l') ADVANCE(44);
      END_STATE();
    case 24:
      if (lookahead == 'o') ADVANCE(45);
      END_STATE();
    case 25:
      if (lookahead == 'r') ADVANCE(46);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 27:
      if (lookahead == 'p') ADVANCE(47);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 't') ADVANCE(48);
      END_STATE();
    case 29:
      if (lookahead == 'n') ADVANCE(49);
      if (lookahead == 't') ADVANCE(50);
      END_STATE();
    case 30:
      if (lookahead == 'd') ADVANCE(51);
      END_STATE();
    case 31:
      if (lookahead == 'l') ADVANCE(52);
      if (lookahead == 'm') ADVANCE(53);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 33:
      if (lookahead == 'c') ADVANCE(54);
      END_STATE();
    case 34:
      if (lookahead == 'o') ADVANCE(55);
      END_STATE();
    case 35:
      if (lookahead == 'm') ADVANCE(56);
      END_STATE();
    case 36:
      if (lookahead == 'r') ADVANCE(57);
      END_STATE();
    case 37:
      if (lookahead == 'u') ADVANCE(58);
      END_STATE();
    case 38:
      if (lookahead == 'n') ADVANCE(59);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 40:
      if (lookahead == 'l') ADVANCE(60);
      END_STATE();
    case 41:
      if (lookahead == 'e') ADVANCE(61);
      END_STATE();
    case 42:
      if (lookahead == 's') ADVANCE(62);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_div);
      END_STATE();
    case 44:
      if (lookahead == 's') ADVANCE(63);
      END_STATE();
    case 45:
      if (lookahead == 'a') ADVANCE(64);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 47:
      if (lookahead == 'o') ADVANCE(65);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_int);
      if (lookahead == '1') ADVANCE(66);
      if (lookahead == '3') ADVANCE(67);
      if (lookahead == '6') ADVANCE(68);
      if (lookahead == '8') ADVANCE(69);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_len);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_mod);
      END_STATE();
    case 52:
      if (lookahead == 'l') ADVANCE(70);
      END_STATE();
    case 53:
      if (lookahead == 'b') ADVANCE(71);
      END_STATE();
    case 54:
      if (lookahead == 'k') ADVANCE(72);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_quo);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_rem);
      END_STATE();
    case 57:
      if (lookahead == 'i') ADVANCE(73);
      END_STATE();
    case 58:
      if (lookahead == 'e') ADVANCE(74);
      END_STATE();
    case 59:
      if (lookahead == 't') ADVANCE(75);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_bool_type);
      END_STATE();
    case 61:
      if (lookahead == 's') ADVANCE(76);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(77);
      END_STATE();
    case 63:
      if (lookahead == 'e') ADVANCE(78);
      END_STATE();
    case 64:
      if (lookahead == 't') ADVANCE(79);
      END_STATE();
    case 65:
      if (lookahead == 'r') ADVANCE(80);
      END_STATE();
    case 66:
      if (lookahead == '2') ADVANCE(81);
      if (lookahead == '6') ADVANCE(82);
      END_STATE();
    case 67:
      if (lookahead == '2') ADVANCE(83);
      END_STATE();
    case 68:
      if (lookahead == '4') ADVANCE(84);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_int8);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(85);
      END_STATE();
    case 72:
      if (lookahead == 'a') ADVANCE(86);
      END_STATE();
    case 73:
      if (lookahead == 'n') ADVANCE(87);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_uint);
      if (lookahead == '1') ADVANCE(88);
      if (lookahead == '3') ADVANCE(89);
      if (lookahead == '6') ADVANCE(90);
      if (lookahead == '8') ADVANCE(91);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_bytes_type);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_close);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_float);
      if (lookahead == '3') ADVANCE(92);
      if (lookahead == '6') ADVANCE(93);
      END_STATE();
    case 80:
      if (lookahead == 't') ADVANCE(94);
      END_STATE();
    case 81:
      if (lookahead == '8') ADVANCE(95);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_int16);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_int32);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_int64);
      END_STATE();
    case 85:
      if (lookahead == 'r') ADVANCE(96);
      END_STATE();
    case 86:
      if (lookahead == 'g') ADVANCE(97);
      END_STATE();
    case 87:
      if (lookahead == 'g') ADVANCE(98);
      END_STATE();
    case 88:
      if (lookahead == '2') ADVANCE(99);
      if (lookahead == '6') ADVANCE(100);
      END_STATE();
    case 89:
      if (lookahead == '2') ADVANCE(101);
      END_STATE();
    case 90:
      if (lookahead == '4') ADVANCE(102);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_uint8);
      END_STATE();
    case 92:
      if (lookahead == '2') ADVANCE(103);
      END_STATE();
    case 93:
      if (lookahead == '4') ADVANCE(104);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_int128);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_number_type);
      END_STATE();
    case 97:
      if (lookahead == 'e') ADVANCE(105);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_string_type);
      END_STATE();
    case 99:
      if (lookahead == '8') ADVANCE(106);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_uint16);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_uint32);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_uint64);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_float32);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_float64);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_package);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_uint128);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 74},
  [2] = {.lex_state = 74},
  [3] = {.lex_state = 74},
  [4] = {.lex_state = 74},
  [5] = {.lex_state = 74},
  [6] = {.lex_state = 74},
  [7] = {.lex_state = 74},
  [8] = {.lex_state = 74},
  [9] = {.lex_state = 74},
  [10] = {.lex_state = 74},
  [11] = {.lex_state = 74},
  [12] = {.lex_state = 74},
  [13] = {.lex_state = 74},
  [14] = {.lex_state = 74},
  [15] = {.lex_state = 74},
  [16] = {.lex_state = 74},
  [17] = {.lex_state = 74},
  [18] = {.lex_state = 74},
  [19] = {.lex_state = 74},
  [20] = {.lex_state = 74},
  [21] = {.lex_state = 74},
  [22] = {.lex_state = 74},
  [23] = {.lex_state = 74},
  [24] = {.lex_state = 74},
  [25] = {.lex_state = 74},
  [26] = {.lex_state = 74},
  [27] = {.lex_state = 74},
  [28] = {.lex_state = 74},
  [29] = {.lex_state = 74},
  [30] = {.lex_state = 74},
  [31] = {.lex_state = 74},
  [32] = {.lex_state = 74},
  [33] = {.lex_state = 3},
  [34] = {.lex_state = 74},
  [35] = {.lex_state = 74},
  [36] = {.lex_state = 74},
  [37] = {.lex_state = 74},
  [38] = {.lex_state = 3},
  [39] = {.lex_state = 74},
  [40] = {.lex_state = 74},
  [41] = {.lex_state = 74},
  [42] = {.lex_state = 74},
  [43] = {.lex_state = 74},
  [44] = {.lex_state = 74},
  [45] = {.lex_state = 74},
  [46] = {.lex_state = 74},
  [47] = {.lex_state = 74},
  [48] = {.lex_state = 74},
  [49] = {.lex_state = 74},
  [50] = {.lex_state = 74},
  [51] = {.lex_state = 74},
  [52] = {.lex_state = 74},
  [53] = {.lex_state = 74},
  [54] = {.lex_state = 74},
  [55] = {.lex_state = 74},
  [56] = {.lex_state = 74},
  [57] = {.lex_state = 74},
  [58] = {.lex_state = 74},
  [59] = {.lex_state = 74},
  [60] = {.lex_state = 74},
  [61] = {.lex_state = 74},
  [62] = {.lex_state = 74},
  [63] = {.lex_state = 74},
  [64] = {.lex_state = 74},
  [65] = {.lex_state = 74},
  [66] = {.lex_state = 74},
  [67] = {.lex_state = 74},
  [68] = {.lex_state = 74},
  [69] = {.lex_state = 74},
  [70] = {.lex_state = 74},
  [71] = {.lex_state = 74},
  [72] = {.lex_state = 74},
  [73] = {.lex_state = 74},
  [74] = {.lex_state = 74},
  [75] = {.lex_state = 74},
  [76] = {.lex_state = 74},
  [77] = {.lex_state = 74},
  [78] = {.lex_state = 1},
  [79] = {.lex_state = 1},
  [80] = {.lex_state = 1},
  [81] = {.lex_state = 1},
  [82] = {.lex_state = 1},
  [83] = {.lex_state = 1},
  [84] = {.lex_state = 0},
  [85] = {.lex_state = 0},
  [86] = {.lex_state = 0},
  [87] = {.lex_state = 1},
  [88] = {.lex_state = 1},
  [89] = {.lex_state = 1},
  [90] = {.lex_state = 1},
  [91] = {.lex_state = 1},
  [92] = {.lex_state = 1},
  [93] = {.lex_state = 1},
  [94] = {.lex_state = 1},
  [95] = {.lex_state = 1},
  [96] = {.lex_state = 1},
  [97] = {.lex_state = 1},
  [98] = {.lex_state = 1},
  [99] = {.lex_state = 1},
  [100] = {.lex_state = 1},
  [101] = {.lex_state = 1},
  [102] = {.lex_state = 1},
  [103] = {.lex_state = 1},
  [104] = {.lex_state = 1},
  [105] = {.lex_state = 1},
  [106] = {.lex_state = 1},
  [107] = {.lex_state = 1},
  [108] = {.lex_state = 1},
  [109] = {.lex_state = 1},
  [110] = {.lex_state = 1},
  [111] = {.lex_state = 1},
  [112] = {.lex_state = 1},
  [113] = {.lex_state = 1},
  [114] = {.lex_state = 1},
  [115] = {.lex_state = 1},
  [116] = {.lex_state = 1},
  [117] = {.lex_state = 1},
  [118] = {.lex_state = 0},
  [119] = {.lex_state = 0},
  [120] = {.lex_state = 0},
  [121] = {.lex_state = 0},
  [122] = {.lex_state = 0},
  [123] = {.lex_state = 0},
  [124] = {.lex_state = 0},
  [125] = {.lex_state = 0},
  [126] = {.lex_state = 0},
  [127] = {.lex_state = 0},
  [128] = {.lex_state = 0},
  [129] = {.lex_state = 0},
  [130] = {.lex_state = 0},
  [131] = {.lex_state = 0},
  [132] = {.lex_state = 0},
  [133] = {.lex_state = 0},
  [134] = {.lex_state = 0},
  [135] = {.lex_state = 0},
  [136] = {.lex_state = 0},
  [137] = {.lex_state = 0},
  [138] = {.lex_state = 0},
  [139] = {.lex_state = 0},
  [140] = {.lex_state = 0},
  [141] = {.lex_state = 0},
  [142] = {.lex_state = 0},
  [143] = {.lex_state = 0},
  [144] = {.lex_state = 0},
  [145] = {.lex_state = 0},
  [146] = {.lex_state = 0},
  [147] = {.lex_state = 0},
  [148] = {.lex_state = 0},
  [149] = {.lex_state = 3},
  [150] = {.lex_state = 3},
  [151] = {.lex_state = 3},
  [152] = {.lex_state = 0},
  [153] = {.lex_state = 3},
  [154] = {.lex_state = 3},
  [155] = {.lex_state = 3},
  [156] = {.lex_state = 3},
  [157] = {.lex_state = 3},
  [158] = {.lex_state = 3},
  [159] = {.lex_state = 3},
  [160] = {.lex_state = 3},
  [161] = {.lex_state = 3},
  [162] = {.lex_state = 74},
  [163] = {.lex_state = 74},
  [164] = {.lex_state = 74},
  [165] = {.lex_state = 74},
  [166] = {.lex_state = 74},
  [167] = {.lex_state = 74},
  [168] = {.lex_state = 74},
  [169] = {.lex_state = 74},
  [170] = {.lex_state = 74},
  [171] = {.lex_state = 74},
  [172] = {.lex_state = 74},
  [173] = {.lex_state = 3},
  [174] = {.lex_state = 3},
  [175] = {.lex_state = 3},
  [176] = {.lex_state = 74},
  [177] = {.lex_state = 3},
  [178] = {.lex_state = 3},
  [179] = {.lex_state = 3},
  [180] = {.lex_state = 3},
  [181] = {.lex_state = 3},
  [182] = {.lex_state = 3},
  [183] = {.lex_state = 3},
  [184] = {.lex_state = 3},
  [185] = {.lex_state = 3},
  [186] = {.lex_state = 3},
  [187] = {.lex_state = 74},
  [188] = {.lex_state = 74},
  [189] = {.lex_state = 74},
  [190] = {.lex_state = 74},
  [191] = {.lex_state = 74},
  [192] = {.lex_state = 74},
  [193] = {.lex_state = 74},
  [194] = {.lex_state = 74},
  [195] = {.lex_state = 74},
  [196] = {.lex_state = 74},
  [197] = {.lex_state = 74},
  [198] = {.lex_state = 74},
  [199] = {.lex_state = 74},
  [200] = {.lex_state = 74},
  [201] = {.lex_state = 74},
  [202] = {.lex_state = 74},
  [203] = {.lex_state = 74},
  [204] = {.lex_state = 74},
  [205] = {.lex_state = 74},
  [206] = {.lex_state = 74},
  [207] = {.lex_state = 74},
  [208] = {.lex_state = 74},
  [209] = {.lex_state = 74},
  [210] = {.lex_state = 74},
  [211] = {.lex_state = 74},
  [212] = {.lex_state = 74},
  [213] = {.lex_state = 74},
  [214] = {.lex_state = 74},
  [215] = {.lex_state = 74},
  [216] = {.lex_state = 74},
  [217] = {.lex_state = 74},
  [218] = {.lex_state = 74},
  [219] = {.lex_state = 74},
  [220] = {.lex_state = 74},
  [221] = {.lex_state = 74},
  [222] = {.lex_state = 74},
  [223] = {.lex_state = 74},
  [224] = {.lex_state = 74},
  [225] = {.lex_state = 74},
  [226] = {.lex_state = 74},
  [227] = {.lex_state = 74},
  [228] = {.lex_state = 74},
  [229] = {.lex_state = 74},
  [230] = {.lex_state = 74},
  [231] = {.lex_state = 74},
  [232] = {.lex_state = 74},
  [233] = {.lex_state = 74},
  [234] = {.lex_state = 6},
  [235] = {.lex_state = 6},
  [236] = {.lex_state = 6},
  [237] = {.lex_state = 6},
  [238] = {.lex_state = 6},
  [239] = {.lex_state = 6},
  [240] = {.lex_state = 6},
  [241] = {.lex_state = 6},
  [242] = {.lex_state = 0},
  [243] = {.lex_state = 0},
  [244] = {.lex_state = 0},
  [245] = {.lex_state = 0},
  [246] = {.lex_state = 0},
  [247] = {.lex_state = 0},
  [248] = {.lex_state = 0},
  [249] = {.lex_state = 0},
  [250] = {.lex_state = 0},
  [251] = {.lex_state = 0},
  [252] = {.lex_state = 0},
  [253] = {.lex_state = 0},
  [254] = {.lex_state = 0},
  [255] = {.lex_state = 0},
  [256] = {.lex_state = 0},
  [257] = {.lex_state = 6},
  [258] = {.lex_state = 6},
  [259] = {.lex_state = 6},
  [260] = {.lex_state = 6},
  [261] = {.lex_state = 6},
  [262] = {.lex_state = 6},
  [263] = {.lex_state = 6},
  [264] = {.lex_state = 6},
  [265] = {.lex_state = 6},
  [266] = {.lex_state = 4},
  [267] = {.lex_state = 4},
  [268] = {.lex_state = 4},
  [269] = {.lex_state = 4},
  [270] = {.lex_state = 4},
  [271] = {.lex_state = 4},
  [272] = {.lex_state = 0},
  [273] = {.lex_state = 4},
  [274] = {.lex_state = 5},
  [275] = {.lex_state = 5},
  [276] = {.lex_state = 5},
  [277] = {.lex_state = 5},
  [278] = {.lex_state = 5},
  [279] = {.lex_state = 5},
  [280] = {.lex_state = 6},
  [281] = {.lex_state = 5},
  [282] = {.lex_state = 4},
  [283] = {.lex_state = 10},
  [284] = {.lex_state = 0, .external_lex_state = 2},
  [285] = {.lex_state = 10, .external_lex_state = 3},
  [286] = {.lex_state = 5},
  [287] = {.lex_state = 10, .external_lex_state = 3},
  [288] = {.lex_state = 12, .external_lex_state = 4},
  [289] = {.lex_state = 10, .external_lex_state = 3},
  [290] = {.lex_state = 12, .external_lex_state = 4},
  [291] = {.lex_state = 12, .external_lex_state = 5},
  [292] = {.lex_state = 0, .external_lex_state = 6},
  [293] = {.lex_state = 0, .external_lex_state = 2},
  [294] = {.lex_state = 12, .external_lex_state = 5},
  [295] = {.lex_state = 10, .external_lex_state = 7},
  [296] = {.lex_state = 0, .external_lex_state = 6},
  [297] = {.lex_state = 10, .external_lex_state = 7},
  [298] = {.lex_state = 10, .external_lex_state = 7},
  [299] = {.lex_state = 0, .external_lex_state = 6},
  [300] = {.lex_state = 12, .external_lex_state = 5},
  [301] = {.lex_state = 0, .external_lex_state = 2},
  [302] = {.lex_state = 10, .external_lex_state = 7},
  [303] = {.lex_state = 0, .external_lex_state = 6},
  [304] = {.lex_state = 12, .external_lex_state = 5},
  [305] = {.lex_state = 0, .external_lex_state = 2},
  [306] = {.lex_state = 10, .external_lex_state = 3},
  [307] = {.lex_state = 0, .external_lex_state = 6},
  [308] = {.lex_state = 12, .external_lex_state = 4},
  [309] = {.lex_state = 12, .external_lex_state = 4},
  [310] = {.lex_state = 10, .external_lex_state = 7},
  [311] = {.lex_state = 10, .external_lex_state = 3},
  [312] = {.lex_state = 0, .external_lex_state = 2},
  [313] = {.lex_state = 12, .external_lex_state = 5},
  [314] = {.lex_state = 0, .external_lex_state = 6},
  [315] = {.lex_state = 10, .external_lex_state = 7},
  [316] = {.lex_state = 0, .external_lex_state = 6},
  [317] = {.lex_state = 12, .external_lex_state = 5},
  [318] = {.lex_state = 0, .external_lex_state = 2},
  [319] = {.lex_state = 10, .external_lex_state = 3},
  [320] = {.lex_state = 6},
  [321] = {.lex_state = 12, .external_lex_state = 4},
  [322] = {.lex_state = 12, .external_lex_state = 4},
  [323] = {.lex_state = 12, .external_lex_state = 5},
  [324] = {.lex_state = 12, .external_lex_state = 4},
  [325] = {.lex_state = 10, .external_lex_state = 7},
  [326] = {.lex_state = 10, .external_lex_state = 3},
  [327] = {.lex_state = 0, .external_lex_state = 2},
  [328] = {.lex_state = 3},
  [329] = {.lex_state = 6},
  [330] = {.lex_state = 0},
  [331] = {.lex_state = 27},
  [332] = {.lex_state = 10},
  [333] = {.lex_state = 12, .external_lex_state = 4},
  [334] = {.lex_state = 10},
  [335] = {.lex_state = 10},
  [336] = {.lex_state = 27},
  [337] = {.lex_state = 10, .external_lex_state = 3},
  [338] = {.lex_state = 0},
  [339] = {.lex_state = 12, .external_lex_state = 5},
  [340] = {.lex_state = 0},
  [341] = {.lex_state = 27},
  [342] = {.lex_state = 0},
  [343] = {.lex_state = 0, .external_lex_state = 6},
  [344] = {.lex_state = 6},
  [345] = {.lex_state = 27},
  [346] = {.lex_state = 10, .external_lex_state = 7},
  [347] = {.lex_state = 27},
  [348] = {.lex_state = 0},
  [349] = {.lex_state = 0, .external_lex_state = 2},
  [350] = {.lex_state = 0},
  [351] = {.lex_state = 6},
  [352] = {.lex_state = 3},
  [353] = {.lex_state = 0},
  [354] = {.lex_state = 0},
  [355] = {.lex_state = 0},
  [356] = {.lex_state = 3},
  [357] = {.lex_state = 6},
  [358] = {.lex_state = 3},
  [359] = {.lex_state = 3},
  [360] = {.lex_state = 0},
  [361] = {.lex_state = 0},
  [362] = {.lex_state = 0},
  [363] = {.lex_state = 0},
  [364] = {.lex_state = 10},
  [365] = {.lex_state = 0},
  [366] = {.lex_state = 0},
  [367] = {.lex_state = 6},
  [368] = {.lex_state = 0},
  [369] = {.lex_state = 6},
  [370] = {.lex_state = 6},
  [371] = {.lex_state = 0},
  [372] = {.lex_state = 6},
  [373] = {.lex_state = 0},
  [374] = {.lex_state = 0},
  [375] = {.lex_state = 0},
  [376] = {.lex_state = 0},
  [377] = {.lex_state = 10},
  [378] = {.lex_state = 6},
  [379] = {.lex_state = 0},
  [380] = {.lex_state = 6},
};

enum {
  ts_external_token__multi_str_content = 0,
  ts_external_token__multi_bytes_content = 1,
  ts_external_token__raw_str_content = 2,
  ts_external_token__raw_bytes_content = 3,
  ts_external_token__multi_raw_str_content = 4,
  ts_external_token__multi_raw_bytes_content = 5,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__multi_str_content] = sym__multi_str_content,
  [ts_external_token__multi_bytes_content] = sym__multi_bytes_content,
  [ts_external_token__raw_str_content] = sym__raw_str_content,
  [ts_external_token__raw_bytes_content] = sym__raw_bytes_content,
  [ts_external_token__multi_raw_str_content] = sym__multi_raw_str_content,
  [ts_external_token__multi_raw_bytes_content] = sym__multi_raw_bytes_content,
};

static const bool ts_external_scanner_states[8][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__multi_str_content] = true,
    [ts_external_token__multi_bytes_content] = true,
    [ts_external_token__raw_str_content] = true,
    [ts_external_token__raw_bytes_content] = true,
    [ts_external_token__multi_raw_str_content] = true,
    [ts_external_token__multi_raw_bytes_content] = true,
  },
  [2] = {
    [ts_external_token__multi_str_content] = true,
  },
  [3] = {
    [ts_external_token__raw_bytes_content] = true,
  },
  [4] = {
    [ts_external_token__raw_str_content] = true,
  },
  [5] = {
    [ts_external_token__multi_raw_str_content] = true,
  },
  [6] = {
    [ts_external_token__multi_bytes_content] = true,
  },
  [7] = {
    [ts_external_token__multi_raw_bytes_content] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_package] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [sym_dot] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [sym_escape_char] = ACTIONS(1),
    [sym_escape_byte] = ACTIONS(1),
    [sym_escape_unicode] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_POUND_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_POUND_SQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1),
    [anon_sym_BSLASH_POUND_LPAREN] = ACTIONS(1),
    [anon_sym_len] = ACTIONS(1),
    [anon_sym_close] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_div] = ACTIONS(1),
    [anon_sym_mod] = ACTIONS(1),
    [anon_sym_quo] = ACTIONS(1),
    [anon_sym_rem] = ACTIONS(1),
    [sym_number_type] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_float32] = ACTIONS(1),
    [anon_sym_float64] = ACTIONS(1),
    [anon_sym_uint] = ACTIONS(1),
    [anon_sym_uint8] = ACTIONS(1),
    [anon_sym_uint16] = ACTIONS(1),
    [anon_sym_uint32] = ACTIONS(1),
    [anon_sym_uint64] = ACTIONS(1),
    [anon_sym_uint128] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_int8] = ACTIONS(1),
    [anon_sym_int16] = ACTIONS(1),
    [anon_sym_int32] = ACTIONS(1),
    [anon_sym_int64] = ACTIONS(1),
    [anon_sym_int128] = ACTIONS(1),
    [sym_string_type] = ACTIONS(1),
    [sym_bytes_type] = ACTIONS(1),
    [sym_bool_type] = ACTIONS(1),
    [sym_bottom_lit] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_int_lit] = ACTIONS(1),
    [sym_float_lit] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_BANG_TILDE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_LBRACK2] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym__multi_str_content] = ACTIONS(1),
    [sym__multi_bytes_content] = ACTIONS(1),
    [sym__raw_str_content] = ACTIONS(1),
    [sym__raw_bytes_content] = ACTIONS(1),
    [sym__multi_raw_str_content] = ACTIONS(1),
    [sym__multi_raw_bytes_content] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(379),
    [sym__package_identifier] = STATE(362),
    [sym_package_clause] = STATE(6),
    [sym_import_declaration] = STATE(4),
    [sym_attribute] = STATE(2),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(356),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(356),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(356),
    [sym_for_clause] = STATE(263),
    [sym_guard_clause] = STATE(263),
    [sym_let_clause] = STATE(356),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(4),
    [aux_sym_source_file_repeat2] = STATE(24),
    [aux_sym_field_repeat1] = STATE(35),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_package] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(17),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [2] = {
    [sym__package_identifier] = STATE(362),
    [sym_package_clause] = STATE(5),
    [sym_import_declaration] = STATE(7),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(356),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(356),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(356),
    [sym_for_clause] = STATE(263),
    [sym_guard_clause] = STATE(263),
    [sym_let_clause] = STATE(356),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(7),
    [aux_sym_source_file_repeat2] = STATE(17),
    [aux_sym_field_repeat1] = STATE(35),
    [ts_builtin_sym_end] = ACTIONS(63),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_package] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [3] = {
    [sym__package_identifier] = STATE(362),
    [sym_import_declaration] = STATE(176),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(356),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(356),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(356),
    [sym_for_clause] = STATE(263),
    [sym_guard_clause] = STATE(263),
    [sym_let_clause] = STATE(356),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(176),
    [aux_sym_source_file_repeat2] = STATE(23),
    [aux_sym_field_repeat1] = STATE(35),
    [ts_builtin_sym_end] = ACTIONS(65),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym__package_identifier] = STATE(362),
    [sym_import_declaration] = STATE(176),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(356),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(356),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(356),
    [sym_for_clause] = STATE(263),
    [sym_guard_clause] = STATE(263),
    [sym_let_clause] = STATE(356),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(176),
    [aux_sym_source_file_repeat2] = STATE(20),
    [aux_sym_field_repeat1] = STATE(35),
    [ts_builtin_sym_end] = ACTIONS(63),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [5] = {
    [sym__package_identifier] = STATE(362),
    [sym_import_declaration] = STATE(3),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(356),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(356),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(356),
    [sym_for_clause] = STATE(263),
    [sym_guard_clause] = STATE(263),
    [sym_let_clause] = STATE(356),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(3),
    [aux_sym_source_file_repeat2] = STATE(19),
    [aux_sym_field_repeat1] = STATE(35),
    [ts_builtin_sym_end] = ACTIONS(67),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [6] = {
    [sym__package_identifier] = STATE(362),
    [sym_import_declaration] = STATE(7),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(356),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(356),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(356),
    [sym_for_clause] = STATE(263),
    [sym_guard_clause] = STATE(263),
    [sym_let_clause] = STATE(356),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(7),
    [aux_sym_source_file_repeat2] = STATE(22),
    [aux_sym_field_repeat1] = STATE(35),
    [ts_builtin_sym_end] = ACTIONS(63),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [7] = {
    [sym__package_identifier] = STATE(362),
    [sym_import_declaration] = STATE(176),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(356),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(356),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(356),
    [sym_for_clause] = STATE(263),
    [sym_guard_clause] = STATE(263),
    [sym_let_clause] = STATE(356),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(176),
    [aux_sym_source_file_repeat2] = STATE(18),
    [aux_sym_field_repeat1] = STATE(35),
    [ts_builtin_sym_end] = ACTIONS(67),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [8] = {
    [sym__package_identifier] = STATE(362),
    [sym_attribute] = STATE(180),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(174),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(174),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(174),
    [sym_for_clause] = STATE(261),
    [sym_guard_clause] = STATE(261),
    [sym_let_clause] = STATE(174),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_struct_lit_repeat1] = STATE(9),
    [aux_sym_field_repeat1] = STATE(36),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(71),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [9] = {
    [sym__package_identifier] = STATE(362),
    [sym_attribute] = STATE(180),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(174),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(174),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(174),
    [sym_for_clause] = STATE(261),
    [sym_guard_clause] = STATE(261),
    [sym_let_clause] = STATE(174),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_struct_lit_repeat1] = STATE(13),
    [aux_sym_field_repeat1] = STATE(36),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym__package_identifier] = STATE(362),
    [sym_attribute] = STATE(180),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(174),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(174),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(174),
    [sym_for_clause] = STATE(261),
    [sym_guard_clause] = STATE(261),
    [sym_let_clause] = STATE(174),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_struct_lit_repeat1] = STATE(14),
    [aux_sym_field_repeat1] = STATE(36),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [11] = {
    [sym__package_identifier] = STATE(362),
    [sym_attribute] = STATE(180),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(174),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(174),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(174),
    [sym_for_clause] = STATE(261),
    [sym_guard_clause] = STATE(261),
    [sym_let_clause] = STATE(174),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_struct_lit_repeat1] = STATE(12),
    [aux_sym_field_repeat1] = STATE(36),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(79),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [12] = {
    [sym__package_identifier] = STATE(362),
    [sym_attribute] = STATE(180),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(174),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(174),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(174),
    [sym_for_clause] = STATE(261),
    [sym_guard_clause] = STATE(261),
    [sym_let_clause] = STATE(174),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_struct_lit_repeat1] = STATE(13),
    [aux_sym_field_repeat1] = STATE(36),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(81),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [13] = {
    [sym__package_identifier] = STATE(362),
    [sym_attribute] = STATE(180),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(174),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(174),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(174),
    [sym_for_clause] = STATE(261),
    [sym_guard_clause] = STATE(261),
    [sym_let_clause] = STATE(174),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_struct_lit_repeat1] = STATE(13),
    [aux_sym_field_repeat1] = STATE(36),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_LPAREN] = ACTIONS(86),
    [anon_sym__] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(92),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_POUND_DQUOTE] = ACTIONS(98),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_POUND_SQUOTE] = ACTIONS(104),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(107),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(110),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(116),
    [anon_sym_len] = ACTIONS(119),
    [anon_sym_close] = ACTIONS(119),
    [anon_sym_and] = ACTIONS(119),
    [anon_sym_or] = ACTIONS(119),
    [anon_sym_div] = ACTIONS(119),
    [anon_sym_mod] = ACTIONS(119),
    [anon_sym_quo] = ACTIONS(119),
    [anon_sym_rem] = ACTIONS(119),
    [sym_number_type] = ACTIONS(122),
    [anon_sym_float] = ACTIONS(125),
    [anon_sym_float32] = ACTIONS(125),
    [anon_sym_float64] = ACTIONS(125),
    [anon_sym_uint] = ACTIONS(128),
    [anon_sym_uint8] = ACTIONS(128),
    [anon_sym_uint16] = ACTIONS(128),
    [anon_sym_uint32] = ACTIONS(128),
    [anon_sym_uint64] = ACTIONS(128),
    [anon_sym_uint128] = ACTIONS(128),
    [anon_sym_int] = ACTIONS(131),
    [anon_sym_int8] = ACTIONS(131),
    [anon_sym_int16] = ACTIONS(131),
    [anon_sym_int32] = ACTIONS(131),
    [anon_sym_int64] = ACTIONS(131),
    [anon_sym_int128] = ACTIONS(131),
    [sym_string_type] = ACTIONS(122),
    [sym_bytes_type] = ACTIONS(122),
    [sym_bool_type] = ACTIONS(122),
    [sym_bottom_lit] = ACTIONS(134),
    [sym_null] = ACTIONS(122),
    [sym_true] = ACTIONS(122),
    [sym_false] = ACTIONS(122),
    [sym_int_lit] = ACTIONS(122),
    [sym_float_lit] = ACTIONS(122),
    [anon_sym_LBRACK] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(140),
    [anon_sym_RBRACE] = ACTIONS(143),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(148),
    [anon_sym_if] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(154),
    [anon_sym_BANG_EQ] = ACTIONS(157),
    [anon_sym_LT] = ACTIONS(160),
    [anon_sym_LT_EQ] = ACTIONS(157),
    [anon_sym_GT] = ACTIONS(160),
    [anon_sym_GT_EQ] = ACTIONS(157),
    [anon_sym_EQ_TILDE] = ACTIONS(157),
    [anon_sym_BANG_TILDE] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(160),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym__package_identifier] = STATE(362),
    [sym_attribute] = STATE(180),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(174),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(174),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(174),
    [sym_for_clause] = STATE(261),
    [sym_guard_clause] = STATE(261),
    [sym_let_clause] = STATE(174),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_struct_lit_repeat1] = STATE(13),
    [aux_sym_field_repeat1] = STATE(36),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(163),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym__package_identifier] = STATE(362),
    [sym_attribute] = STATE(180),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(174),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(174),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(174),
    [sym_for_clause] = STATE(261),
    [sym_guard_clause] = STATE(261),
    [sym_let_clause] = STATE(174),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_struct_lit_repeat1] = STATE(13),
    [aux_sym_field_repeat1] = STATE(36),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [16] = {
    [sym__package_identifier] = STATE(362),
    [sym_attribute] = STATE(180),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(174),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(174),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(174),
    [sym_for_clause] = STATE(261),
    [sym_guard_clause] = STATE(261),
    [sym_let_clause] = STATE(174),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_struct_lit_repeat1] = STATE(15),
    [aux_sym_field_repeat1] = STATE(36),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(167),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [17] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(356),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(356),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(356),
    [sym_for_clause] = STATE(263),
    [sym_guard_clause] = STATE(263),
    [sym_let_clause] = STATE(356),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_source_file_repeat2] = STATE(21),
    [aux_sym_field_repeat1] = STATE(35),
    [ts_builtin_sym_end] = ACTIONS(169),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [18] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(356),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(356),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(356),
    [sym_for_clause] = STATE(263),
    [sym_guard_clause] = STATE(263),
    [sym_let_clause] = STATE(356),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_source_file_repeat2] = STATE(21),
    [aux_sym_field_repeat1] = STATE(35),
    [ts_builtin_sym_end] = ACTIONS(171),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [19] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(356),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(356),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(356),
    [sym_for_clause] = STATE(263),
    [sym_guard_clause] = STATE(263),
    [sym_let_clause] = STATE(356),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_source_file_repeat2] = STATE(21),
    [aux_sym_field_repeat1] = STATE(35),
    [ts_builtin_sym_end] = ACTIONS(171),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [20] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(356),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(356),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(356),
    [sym_for_clause] = STATE(263),
    [sym_guard_clause] = STATE(263),
    [sym_let_clause] = STATE(356),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_source_file_repeat2] = STATE(21),
    [aux_sym_field_repeat1] = STATE(35),
    [ts_builtin_sym_end] = ACTIONS(169),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [21] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(356),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(356),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(356),
    [sym_for_clause] = STATE(263),
    [sym_guard_clause] = STATE(263),
    [sym_let_clause] = STATE(356),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_source_file_repeat2] = STATE(21),
    [aux_sym_field_repeat1] = STATE(35),
    [ts_builtin_sym_end] = ACTIONS(173),
    [sym_identifier] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(178),
    [anon_sym__] = ACTIONS(181),
    [anon_sym_DQUOTE] = ACTIONS(184),
    [anon_sym_POUND_DQUOTE] = ACTIONS(187),
    [anon_sym_SQUOTE] = ACTIONS(190),
    [anon_sym_POUND_SQUOTE] = ACTIONS(193),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(196),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(199),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(202),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(205),
    [anon_sym_len] = ACTIONS(208),
    [anon_sym_close] = ACTIONS(208),
    [anon_sym_and] = ACTIONS(208),
    [anon_sym_or] = ACTIONS(208),
    [anon_sym_div] = ACTIONS(208),
    [anon_sym_mod] = ACTIONS(208),
    [anon_sym_quo] = ACTIONS(208),
    [anon_sym_rem] = ACTIONS(208),
    [sym_number_type] = ACTIONS(211),
    [anon_sym_float] = ACTIONS(214),
    [anon_sym_float32] = ACTIONS(214),
    [anon_sym_float64] = ACTIONS(214),
    [anon_sym_uint] = ACTIONS(217),
    [anon_sym_uint8] = ACTIONS(217),
    [anon_sym_uint16] = ACTIONS(217),
    [anon_sym_uint32] = ACTIONS(217),
    [anon_sym_uint64] = ACTIONS(217),
    [anon_sym_uint128] = ACTIONS(217),
    [anon_sym_int] = ACTIONS(220),
    [anon_sym_int8] = ACTIONS(220),
    [anon_sym_int16] = ACTIONS(220),
    [anon_sym_int32] = ACTIONS(220),
    [anon_sym_int64] = ACTIONS(220),
    [anon_sym_int128] = ACTIONS(220),
    [sym_string_type] = ACTIONS(211),
    [sym_bytes_type] = ACTIONS(211),
    [sym_bool_type] = ACTIONS(211),
    [sym_bottom_lit] = ACTIONS(223),
    [sym_null] = ACTIONS(211),
    [sym_true] = ACTIONS(211),
    [sym_false] = ACTIONS(211),
    [sym_int_lit] = ACTIONS(211),
    [sym_float_lit] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(226),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_let] = ACTIONS(241),
    [anon_sym_BANG_EQ] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(247),
    [anon_sym_LT_EQ] = ACTIONS(244),
    [anon_sym_GT] = ACTIONS(247),
    [anon_sym_GT_EQ] = ACTIONS(244),
    [anon_sym_EQ_TILDE] = ACTIONS(244),
    [anon_sym_BANG_TILDE] = ACTIONS(244),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(244),
    [anon_sym_BANG] = ACTIONS(247),
    [sym_comment] = ACTIONS(3),
  },
  [22] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(356),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(356),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(356),
    [sym_for_clause] = STATE(263),
    [sym_guard_clause] = STATE(263),
    [sym_let_clause] = STATE(356),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_source_file_repeat2] = STATE(21),
    [aux_sym_field_repeat1] = STATE(35),
    [ts_builtin_sym_end] = ACTIONS(169),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [23] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(356),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(356),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(356),
    [sym_for_clause] = STATE(263),
    [sym_guard_clause] = STATE(263),
    [sym_let_clause] = STATE(356),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_source_file_repeat2] = STATE(21),
    [aux_sym_field_repeat1] = STATE(35),
    [ts_builtin_sym_end] = ACTIONS(250),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [24] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym__declaration] = STATE(356),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym_ellipsis] = STATE(356),
    [sym__embedding] = STATE(186),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym_field] = STATE(356),
    [sym_for_clause] = STATE(263),
    [sym_guard_clause] = STATE(263),
    [sym_let_clause] = STATE(356),
    [sym_comprehension] = STATE(186),
    [sym__alias_expr] = STATE(178),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_source_file_repeat2] = STATE(21),
    [aux_sym_field_repeat1] = STATE(35),
    [ts_builtin_sym_end] = ACTIONS(252),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [25] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym__list_elem] = STATE(231),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym_ellipsis] = STATE(231),
    [sym__embedding] = STATE(207),
    [sym__label_alias_expr] = STATE(373),
    [sym_for_clause] = STATE(258),
    [sym_guard_clause] = STATE(258),
    [sym_comprehension] = STATE(207),
    [sym__alias_expr] = STATE(223),
    [sym__expression] = STATE(170),
    [sym_binary_expression] = STATE(170),
    [sym_unary_expression] = STATE(170),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [aux_sym_list_lit_repeat1] = STATE(30),
    [sym_identifier] = ACTIONS(254),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_RBRACK] = ACTIONS(288),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(292),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [26] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym__list_elem] = STATE(231),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym_ellipsis] = STATE(231),
    [sym__embedding] = STATE(207),
    [sym_for_clause] = STATE(258),
    [sym_guard_clause] = STATE(258),
    [sym_comprehension] = STATE(207),
    [sym__alias_expr] = STATE(221),
    [sym__expression] = STATE(170),
    [sym_binary_expression] = STATE(170),
    [sym_unary_expression] = STATE(170),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [aux_sym_list_lit_repeat1] = STATE(26),
    [sym_identifier] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(301),
    [anon_sym__] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(307),
    [anon_sym_POUND_DQUOTE] = ACTIONS(310),
    [anon_sym_SQUOTE] = ACTIONS(313),
    [anon_sym_POUND_SQUOTE] = ACTIONS(316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(319),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(322),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(325),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(328),
    [anon_sym_len] = ACTIONS(331),
    [anon_sym_close] = ACTIONS(331),
    [anon_sym_and] = ACTIONS(331),
    [anon_sym_or] = ACTIONS(331),
    [anon_sym_div] = ACTIONS(331),
    [anon_sym_mod] = ACTIONS(331),
    [anon_sym_quo] = ACTIONS(331),
    [anon_sym_rem] = ACTIONS(331),
    [sym_number_type] = ACTIONS(334),
    [anon_sym_float] = ACTIONS(337),
    [anon_sym_float32] = ACTIONS(337),
    [anon_sym_float64] = ACTIONS(337),
    [anon_sym_uint] = ACTIONS(340),
    [anon_sym_uint8] = ACTIONS(340),
    [anon_sym_uint16] = ACTIONS(340),
    [anon_sym_uint32] = ACTIONS(340),
    [anon_sym_uint64] = ACTIONS(340),
    [anon_sym_uint128] = ACTIONS(340),
    [anon_sym_int] = ACTIONS(343),
    [anon_sym_int8] = ACTIONS(343),
    [anon_sym_int16] = ACTIONS(343),
    [anon_sym_int32] = ACTIONS(343),
    [anon_sym_int64] = ACTIONS(343),
    [anon_sym_int128] = ACTIONS(343),
    [sym_string_type] = ACTIONS(334),
    [sym_bytes_type] = ACTIONS(334),
    [sym_bool_type] = ACTIONS(334),
    [sym_bottom_lit] = ACTIONS(346),
    [sym_null] = ACTIONS(334),
    [sym_true] = ACTIONS(334),
    [sym_false] = ACTIONS(334),
    [sym_int_lit] = ACTIONS(334),
    [sym_float_lit] = ACTIONS(334),
    [anon_sym_LBRACK] = ACTIONS(349),
    [anon_sym_RBRACK] = ACTIONS(352),
    [anon_sym_LBRACE] = ACTIONS(354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(357),
    [anon_sym_for] = ACTIONS(360),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_BANG_EQ] = ACTIONS(366),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_LT_EQ] = ACTIONS(366),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_EQ] = ACTIONS(366),
    [anon_sym_EQ_TILDE] = ACTIONS(366),
    [anon_sym_BANG_TILDE] = ACTIONS(366),
    [anon_sym_PLUS] = ACTIONS(366),
    [anon_sym_DASH] = ACTIONS(366),
    [anon_sym_STAR] = ACTIONS(366),
    [anon_sym_BANG] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
  },
  [27] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym__list_elem] = STATE(231),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym_ellipsis] = STATE(231),
    [sym__embedding] = STATE(207),
    [sym_for_clause] = STATE(258),
    [sym_guard_clause] = STATE(258),
    [sym_comprehension] = STATE(207),
    [sym__alias_expr] = STATE(221),
    [sym__expression] = STATE(170),
    [sym_binary_expression] = STATE(170),
    [sym_unary_expression] = STATE(170),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [aux_sym_list_lit_repeat1] = STATE(26),
    [sym_identifier] = ACTIONS(254),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_RBRACK] = ACTIONS(372),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(292),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [28] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym__list_elem] = STATE(231),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym_ellipsis] = STATE(231),
    [sym__embedding] = STATE(207),
    [sym_for_clause] = STATE(258),
    [sym_guard_clause] = STATE(258),
    [sym_comprehension] = STATE(207),
    [sym__alias_expr] = STATE(221),
    [sym__expression] = STATE(170),
    [sym_binary_expression] = STATE(170),
    [sym_unary_expression] = STATE(170),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [aux_sym_list_lit_repeat1] = STATE(30),
    [sym_identifier] = ACTIONS(254),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_RBRACK] = ACTIONS(288),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(292),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [29] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym__list_elem] = STATE(231),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym_ellipsis] = STATE(231),
    [sym__embedding] = STATE(207),
    [sym_for_clause] = STATE(258),
    [sym_guard_clause] = STATE(258),
    [sym_comprehension] = STATE(207),
    [sym__alias_expr] = STATE(221),
    [sym__expression] = STATE(170),
    [sym_binary_expression] = STATE(170),
    [sym_unary_expression] = STATE(170),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [aux_sym_list_lit_repeat1] = STATE(27),
    [sym_identifier] = ACTIONS(254),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_RBRACK] = ACTIONS(374),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(292),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [30] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym__list_elem] = STATE(231),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym_ellipsis] = STATE(231),
    [sym__embedding] = STATE(207),
    [sym_for_clause] = STATE(258),
    [sym_guard_clause] = STATE(258),
    [sym_comprehension] = STATE(207),
    [sym__alias_expr] = STATE(221),
    [sym__expression] = STATE(170),
    [sym_binary_expression] = STATE(170),
    [sym_unary_expression] = STATE(170),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [aux_sym_list_lit_repeat1] = STATE(26),
    [sym_identifier] = ACTIONS(254),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_RBRACK] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(292),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [31] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym_ellipsis] = STATE(227),
    [sym__embedding] = STATE(219),
    [sym_for_clause] = STATE(258),
    [sym_guard_clause] = STATE(258),
    [sym_comprehension] = STATE(219),
    [sym__alias_expr] = STATE(221),
    [sym__expression] = STATE(170),
    [sym_binary_expression] = STATE(170),
    [sym_unary_expression] = STATE(170),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(378),
    [anon_sym_LPAREN] = ACTIONS(381),
    [anon_sym__] = ACTIONS(384),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_POUND_DQUOTE] = ACTIONS(390),
    [anon_sym_SQUOTE] = ACTIONS(393),
    [anon_sym_POUND_SQUOTE] = ACTIONS(396),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(399),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(402),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(405),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(408),
    [anon_sym_len] = ACTIONS(411),
    [anon_sym_close] = ACTIONS(411),
    [anon_sym_and] = ACTIONS(411),
    [anon_sym_or] = ACTIONS(411),
    [anon_sym_div] = ACTIONS(411),
    [anon_sym_mod] = ACTIONS(411),
    [anon_sym_quo] = ACTIONS(411),
    [anon_sym_rem] = ACTIONS(411),
    [sym_number_type] = ACTIONS(414),
    [anon_sym_float] = ACTIONS(417),
    [anon_sym_float32] = ACTIONS(417),
    [anon_sym_float64] = ACTIONS(417),
    [anon_sym_uint] = ACTIONS(420),
    [anon_sym_uint8] = ACTIONS(420),
    [anon_sym_uint16] = ACTIONS(420),
    [anon_sym_uint32] = ACTIONS(420),
    [anon_sym_uint64] = ACTIONS(420),
    [anon_sym_uint128] = ACTIONS(420),
    [anon_sym_int] = ACTIONS(423),
    [anon_sym_int8] = ACTIONS(423),
    [anon_sym_int16] = ACTIONS(423),
    [anon_sym_int32] = ACTIONS(423),
    [anon_sym_int64] = ACTIONS(423),
    [anon_sym_int128] = ACTIONS(423),
    [sym_string_type] = ACTIONS(414),
    [sym_bytes_type] = ACTIONS(414),
    [sym_bool_type] = ACTIONS(414),
    [sym_bottom_lit] = ACTIONS(426),
    [sym_null] = ACTIONS(414),
    [sym_true] = ACTIONS(414),
    [sym_false] = ACTIONS(414),
    [sym_int_lit] = ACTIONS(414),
    [sym_float_lit] = ACTIONS(414),
    [anon_sym_LBRACK] = ACTIONS(429),
    [anon_sym_RBRACK] = ACTIONS(432),
    [anon_sym_LBRACE] = ACTIONS(434),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(437),
    [anon_sym_for] = ACTIONS(440),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_BANG_EQ] = ACTIONS(446),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(446),
    [anon_sym_EQ_TILDE] = ACTIONS(446),
    [anon_sym_BANG_TILDE] = ACTIONS(446),
    [anon_sym_PLUS] = ACTIONS(446),
    [anon_sym_DASH] = ACTIONS(446),
    [anon_sym_STAR] = ACTIONS(446),
    [anon_sym_BANG] = ACTIONS(449),
    [sym_comment] = ACTIONS(3),
  },
  [32] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym_ellipsis] = STATE(220),
    [sym__embedding] = STATE(219),
    [sym_for_clause] = STATE(258),
    [sym_guard_clause] = STATE(258),
    [sym_comprehension] = STATE(219),
    [sym__alias_expr] = STATE(221),
    [sym__expression] = STATE(170),
    [sym_binary_expression] = STATE(170),
    [sym_unary_expression] = STATE(170),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym__] = ACTIONS(458),
    [anon_sym_DQUOTE] = ACTIONS(461),
    [anon_sym_POUND_DQUOTE] = ACTIONS(464),
    [anon_sym_SQUOTE] = ACTIONS(467),
    [anon_sym_POUND_SQUOTE] = ACTIONS(470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(473),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(476),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(479),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(482),
    [anon_sym_len] = ACTIONS(485),
    [anon_sym_close] = ACTIONS(485),
    [anon_sym_and] = ACTIONS(485),
    [anon_sym_or] = ACTIONS(485),
    [anon_sym_div] = ACTIONS(485),
    [anon_sym_mod] = ACTIONS(485),
    [anon_sym_quo] = ACTIONS(485),
    [anon_sym_rem] = ACTIONS(485),
    [sym_number_type] = ACTIONS(488),
    [anon_sym_float] = ACTIONS(491),
    [anon_sym_float32] = ACTIONS(491),
    [anon_sym_float64] = ACTIONS(491),
    [anon_sym_uint] = ACTIONS(494),
    [anon_sym_uint8] = ACTIONS(494),
    [anon_sym_uint16] = ACTIONS(494),
    [anon_sym_uint32] = ACTIONS(494),
    [anon_sym_uint64] = ACTIONS(494),
    [anon_sym_uint128] = ACTIONS(494),
    [anon_sym_int] = ACTIONS(497),
    [anon_sym_int8] = ACTIONS(497),
    [anon_sym_int16] = ACTIONS(497),
    [anon_sym_int32] = ACTIONS(497),
    [anon_sym_int64] = ACTIONS(497),
    [anon_sym_int128] = ACTIONS(497),
    [sym_string_type] = ACTIONS(488),
    [sym_bytes_type] = ACTIONS(488),
    [sym_bool_type] = ACTIONS(488),
    [sym_bottom_lit] = ACTIONS(500),
    [sym_null] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_int_lit] = ACTIONS(488),
    [sym_float_lit] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_RBRACK] = ACTIONS(506),
    [anon_sym_LBRACE] = ACTIONS(508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(511),
    [anon_sym_for] = ACTIONS(514),
    [anon_sym_if] = ACTIONS(517),
    [anon_sym_BANG_EQ] = ACTIONS(520),
    [anon_sym_LT] = ACTIONS(523),
    [anon_sym_LT_EQ] = ACTIONS(520),
    [anon_sym_GT] = ACTIONS(523),
    [anon_sym_GT_EQ] = ACTIONS(520),
    [anon_sym_EQ_TILDE] = ACTIONS(520),
    [anon_sym_BANG_TILDE] = ACTIONS(520),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_STAR] = ACTIONS(520),
    [anon_sym_BANG] = ACTIONS(523),
    [sym_comment] = ACTIONS(3),
  },
  [33] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(81),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym__expression] = STATE(159),
    [sym_binary_expression] = STATE(159),
    [sym_unary_expression] = STATE(159),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [sym_identifier] = ACTIONS(526),
    [anon_sym_LF] = ACTIONS(528),
    [anon_sym_COMMA] = ACTIONS(526),
    [anon_sym_LPAREN] = ACTIONS(526),
    [anon_sym__] = ACTIONS(526),
    [anon_sym_AT] = ACTIONS(526),
    [anon_sym_DQUOTE] = ACTIONS(526),
    [anon_sym_POUND_DQUOTE] = ACTIONS(526),
    [anon_sym_SQUOTE] = ACTIONS(526),
    [anon_sym_POUND_SQUOTE] = ACTIONS(526),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(526),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(526),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(526),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(526),
    [anon_sym_len] = ACTIONS(526),
    [anon_sym_close] = ACTIONS(526),
    [anon_sym_and] = ACTIONS(526),
    [anon_sym_or] = ACTIONS(526),
    [anon_sym_div] = ACTIONS(526),
    [anon_sym_mod] = ACTIONS(526),
    [anon_sym_quo] = ACTIONS(526),
    [anon_sym_rem] = ACTIONS(526),
    [sym_number_type] = ACTIONS(526),
    [anon_sym_float] = ACTIONS(526),
    [anon_sym_float32] = ACTIONS(526),
    [anon_sym_float64] = ACTIONS(526),
    [anon_sym_uint] = ACTIONS(526),
    [anon_sym_uint8] = ACTIONS(526),
    [anon_sym_uint16] = ACTIONS(526),
    [anon_sym_uint32] = ACTIONS(526),
    [anon_sym_uint64] = ACTIONS(526),
    [anon_sym_uint128] = ACTIONS(526),
    [anon_sym_int] = ACTIONS(526),
    [anon_sym_int8] = ACTIONS(526),
    [anon_sym_int16] = ACTIONS(526),
    [anon_sym_int32] = ACTIONS(526),
    [anon_sym_int64] = ACTIONS(526),
    [anon_sym_int128] = ACTIONS(526),
    [sym_string_type] = ACTIONS(526),
    [sym_bytes_type] = ACTIONS(526),
    [sym_bool_type] = ACTIONS(526),
    [sym_bottom_lit] = ACTIONS(526),
    [sym_null] = ACTIONS(526),
    [sym_true] = ACTIONS(526),
    [sym_false] = ACTIONS(526),
    [sym_int_lit] = ACTIONS(526),
    [sym_float_lit] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(526),
    [anon_sym_LBRACE] = ACTIONS(526),
    [anon_sym_RBRACE] = ACTIONS(526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(526),
    [anon_sym_for] = ACTIONS(526),
    [anon_sym_if] = ACTIONS(526),
    [anon_sym_let] = ACTIONS(526),
    [anon_sym_BANG_EQ] = ACTIONS(526),
    [anon_sym_LT] = ACTIONS(526),
    [anon_sym_LT_EQ] = ACTIONS(526),
    [anon_sym_GT] = ACTIONS(526),
    [anon_sym_GT_EQ] = ACTIONS(526),
    [anon_sym_EQ_TILDE] = ACTIONS(526),
    [anon_sym_BANG_TILDE] = ACTIONS(526),
    [anon_sym_PLUS] = ACTIONS(526),
    [anon_sym_DASH] = ACTIONS(526),
    [anon_sym_STAR] = ACTIONS(526),
    [anon_sym_BANG] = ACTIONS(526),
    [sym_comment] = ACTIONS(530),
  },
  [34] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__embedding] = STATE(219),
    [sym_for_clause] = STATE(258),
    [sym_guard_clause] = STATE(258),
    [sym_comprehension] = STATE(219),
    [sym__alias_expr] = STATE(221),
    [sym__expression] = STATE(170),
    [sym_binary_expression] = STATE(170),
    [sym_unary_expression] = STATE(170),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(254),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [35] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym__value] = STATE(328),
    [sym__alias_expr] = STATE(185),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_field_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [36] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(374),
    [sym_label] = STATE(361),
    [sym__value] = STATE(173),
    [sym__alias_expr] = STATE(185),
    [sym__expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [aux_sym_field_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [37] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(172),
    [sym_binary_expression] = STATE(172),
    [sym_unary_expression] = STATE(172),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(526),
    [anon_sym_COMMA] = ACTIONS(528),
    [anon_sym_LPAREN] = ACTIONS(528),
    [anon_sym__] = ACTIONS(526),
    [anon_sym_DQUOTE] = ACTIONS(526),
    [anon_sym_POUND_DQUOTE] = ACTIONS(526),
    [anon_sym_SQUOTE] = ACTIONS(526),
    [anon_sym_POUND_SQUOTE] = ACTIONS(526),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(528),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(528),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(528),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(528),
    [anon_sym_len] = ACTIONS(526),
    [anon_sym_close] = ACTIONS(526),
    [anon_sym_and] = ACTIONS(526),
    [anon_sym_or] = ACTIONS(526),
    [anon_sym_div] = ACTIONS(526),
    [anon_sym_mod] = ACTIONS(526),
    [anon_sym_quo] = ACTIONS(526),
    [anon_sym_rem] = ACTIONS(526),
    [sym_number_type] = ACTIONS(526),
    [anon_sym_float] = ACTIONS(526),
    [anon_sym_float32] = ACTIONS(526),
    [anon_sym_float64] = ACTIONS(526),
    [anon_sym_uint] = ACTIONS(526),
    [anon_sym_uint8] = ACTIONS(526),
    [anon_sym_uint16] = ACTIONS(526),
    [anon_sym_uint32] = ACTIONS(526),
    [anon_sym_uint64] = ACTIONS(526),
    [anon_sym_uint128] = ACTIONS(526),
    [anon_sym_int] = ACTIONS(526),
    [anon_sym_int8] = ACTIONS(526),
    [anon_sym_int16] = ACTIONS(526),
    [anon_sym_int32] = ACTIONS(526),
    [anon_sym_int64] = ACTIONS(526),
    [anon_sym_int128] = ACTIONS(526),
    [sym_string_type] = ACTIONS(526),
    [sym_bytes_type] = ACTIONS(526),
    [sym_bool_type] = ACTIONS(526),
    [sym_bottom_lit] = ACTIONS(528),
    [sym_null] = ACTIONS(526),
    [sym_true] = ACTIONS(526),
    [sym_false] = ACTIONS(526),
    [sym_int_lit] = ACTIONS(526),
    [sym_float_lit] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(528),
    [anon_sym_RBRACK] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(528),
    [anon_sym_for] = ACTIONS(526),
    [anon_sym_if] = ACTIONS(526),
    [anon_sym_BANG_EQ] = ACTIONS(528),
    [anon_sym_LT] = ACTIONS(526),
    [anon_sym_LT_EQ] = ACTIONS(528),
    [anon_sym_GT] = ACTIONS(526),
    [anon_sym_GT_EQ] = ACTIONS(528),
    [anon_sym_EQ_TILDE] = ACTIONS(528),
    [anon_sym_BANG_TILDE] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(528),
    [anon_sym_DASH] = ACTIONS(528),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_BANG] = ACTIONS(526),
    [sym_comment] = ACTIONS(3),
  },
  [38] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(81),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym__expression] = STATE(159),
    [sym_binary_expression] = STATE(159),
    [sym_unary_expression] = STATE(159),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [sym_identifier] = ACTIONS(532),
    [anon_sym_LF] = ACTIONS(528),
    [anon_sym_COMMA] = ACTIONS(526),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(536),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(538),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(540),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(542),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(37),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(544),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_BANG_EQ] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(61),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(61),
    [anon_sym_EQ_TILDE] = ACTIONS(61),
    [anon_sym_BANG_TILDE] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(61),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(530),
  },
  [39] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(80),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym__label_name] = STATE(353),
    [sym__label_expr] = STATE(368),
    [sym__expression] = STATE(153),
    [sym_binary_expression] = STATE(153),
    [sym_unary_expression] = STATE(153),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [sym_identifier] = ACTIONS(548),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [40] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__label_alias_expr] = STATE(373),
    [sym__alias_expr] = STATE(363),
    [sym__expression] = STATE(170),
    [sym_binary_expression] = STATE(170),
    [sym_unary_expression] = STATE(170),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(254),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [41] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(242),
    [sym_binary_expression] = STATE(242),
    [sym_unary_expression] = STATE(242),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym_argument] = STATE(354),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [42] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(242),
    [sym_binary_expression] = STATE(242),
    [sym_unary_expression] = STATE(242),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym_argument] = STATE(348),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [43] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(242),
    [sym_binary_expression] = STATE(242),
    [sym_unary_expression] = STATE(242),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym_argument] = STATE(340),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [44] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(239),
    [sym_binary_expression] = STATE(239),
    [sym_unary_expression] = STATE(239),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [45] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(246),
    [sym_binary_expression] = STATE(246),
    [sym_unary_expression] = STATE(246),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [46] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(162),
    [sym_binary_expression] = STATE(162),
    [sym_unary_expression] = STATE(162),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [47] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(255),
    [sym_binary_expression] = STATE(255),
    [sym_unary_expression] = STATE(255),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [48] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(169),
    [sym_binary_expression] = STATE(169),
    [sym_unary_expression] = STATE(169),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [49] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(163),
    [sym_binary_expression] = STATE(163),
    [sym_unary_expression] = STATE(163),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [50] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(164),
    [sym_binary_expression] = STATE(164),
    [sym_unary_expression] = STATE(164),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [51] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(165),
    [sym_binary_expression] = STATE(165),
    [sym_unary_expression] = STATE(165),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [52] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(166),
    [sym_binary_expression] = STATE(166),
    [sym_unary_expression] = STATE(166),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [53] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(168),
    [sym_binary_expression] = STATE(168),
    [sym_unary_expression] = STATE(168),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [54] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(249),
    [sym_binary_expression] = STATE(249),
    [sym_unary_expression] = STATE(249),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [55] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(243),
    [sym_binary_expression] = STATE(243),
    [sym_unary_expression] = STATE(243),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [56] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(167),
    [sym_binary_expression] = STATE(167),
    [sym_unary_expression] = STATE(167),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [57] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(256),
    [sym_binary_expression] = STATE(256),
    [sym_unary_expression] = STATE(256),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [58] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(250),
    [sym_binary_expression] = STATE(250),
    [sym_unary_expression] = STATE(250),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [59] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(251),
    [sym_binary_expression] = STATE(251),
    [sym_unary_expression] = STATE(251),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [60] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(244),
    [sym_binary_expression] = STATE(244),
    [sym_unary_expression] = STATE(244),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [61] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(238),
    [sym_binary_expression] = STATE(238),
    [sym_unary_expression] = STATE(238),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [62] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(253),
    [sym_binary_expression] = STATE(253),
    [sym_unary_expression] = STATE(253),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [63] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(241),
    [sym_binary_expression] = STATE(241),
    [sym_unary_expression] = STATE(241),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [64] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(81),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym__expression] = STATE(155),
    [sym_binary_expression] = STATE(155),
    [sym_unary_expression] = STATE(155),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [sym_identifier] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(552),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [65] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(81),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym__expression] = STATE(156),
    [sym_binary_expression] = STATE(156),
    [sym_unary_expression] = STATE(156),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [sym_identifier] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(552),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [66] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(171),
    [sym_binary_expression] = STATE(171),
    [sym_unary_expression] = STATE(171),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [67] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(81),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym__expression] = STATE(157),
    [sym_binary_expression] = STATE(157),
    [sym_unary_expression] = STATE(157),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [sym_identifier] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(552),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [68] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(81),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym__expression] = STATE(158),
    [sym_binary_expression] = STATE(158),
    [sym_unary_expression] = STATE(158),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [sym_identifier] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(552),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [69] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(81),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym__expression] = STATE(160),
    [sym_binary_expression] = STATE(160),
    [sym_unary_expression] = STATE(160),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [sym_identifier] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(552),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [70] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(81),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym__expression] = STATE(149),
    [sym_binary_expression] = STATE(149),
    [sym_unary_expression] = STATE(149),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [sym_identifier] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(552),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [71] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(81),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym__expression] = STATE(161),
    [sym_binary_expression] = STATE(161),
    [sym_unary_expression] = STATE(161),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [sym_identifier] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(552),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [72] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(81),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym__expression] = STATE(154),
    [sym_binary_expression] = STATE(154),
    [sym_unary_expression] = STATE(154),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [sym_identifier] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(552),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [73] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(254),
    [sym_binary_expression] = STATE(254),
    [sym_unary_expression] = STATE(254),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [74] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(350),
    [sym__string_lit] = STATE(81),
    [sym_simple_string_lit] = STATE(81),
    [sym_simple_raw_string_lit] = STATE(81),
    [sym_simple_bytes_lit] = STATE(81),
    [sym_simple_raw_bytes_lit] = STATE(81),
    [sym_multiline_string_lit] = STATE(81),
    [sym_multiline_raw_string_lit] = STATE(81),
    [sym_multiline_bytes_lit] = STATE(81),
    [sym_multiline_raw_bytes_lit] = STATE(81),
    [sym_builtin] = STATE(350),
    [sym_float_type] = STATE(81),
    [sym_uint_type] = STATE(81),
    [sym_int_type] = STATE(81),
    [sym_top_lit] = STATE(81),
    [sym_list_lit] = STATE(81),
    [sym_struct_lit] = STATE(81),
    [sym__expression] = STATE(151),
    [sym_binary_expression] = STATE(151),
    [sym_unary_expression] = STATE(151),
    [sym__primary_expression] = STATE(81),
    [sym__operand] = STATE(81),
    [sym__call_operand] = STATE(350),
    [sym_index_expression] = STATE(81),
    [sym_selector_expression] = STATE(81),
    [sym_call_expression] = STATE(81),
    [sym__literal] = STATE(81),
    [sym_identifier] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(19),
    [anon_sym_POUND_DQUOTE] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_POUND_SQUOTE] = ACTIONS(25),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(27),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(29),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(31),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(33),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(37),
    [anon_sym_float] = ACTIONS(39),
    [anon_sym_float32] = ACTIONS(39),
    [anon_sym_float64] = ACTIONS(39),
    [anon_sym_uint] = ACTIONS(41),
    [anon_sym_uint8] = ACTIONS(41),
    [anon_sym_uint16] = ACTIONS(41),
    [anon_sym_uint32] = ACTIONS(41),
    [anon_sym_uint64] = ACTIONS(41),
    [anon_sym_uint128] = ACTIONS(41),
    [anon_sym_int] = ACTIONS(43),
    [anon_sym_int8] = ACTIONS(43),
    [anon_sym_int16] = ACTIONS(43),
    [anon_sym_int32] = ACTIONS(43),
    [anon_sym_int64] = ACTIONS(43),
    [anon_sym_int128] = ACTIONS(43),
    [sym_string_type] = ACTIONS(37),
    [sym_bytes_type] = ACTIONS(37),
    [sym_bool_type] = ACTIONS(37),
    [sym_bottom_lit] = ACTIONS(45),
    [sym_null] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_int_lit] = ACTIONS(37),
    [sym_float_lit] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(552),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_EQ_TILDE] = ACTIONS(59),
    [anon_sym_BANG_TILDE] = ACTIONS(59),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [75] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(240),
    [sym_binary_expression] = STATE(240),
    [sym_unary_expression] = STATE(240),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [76] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(245),
    [sym_binary_expression] = STATE(245),
    [sym_unary_expression] = STATE(245),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [77] = {
    [sym__package_identifier] = STATE(362),
    [sym_qualified_identifier] = STATE(355),
    [sym__string_lit] = STATE(86),
    [sym_simple_string_lit] = STATE(86),
    [sym_simple_raw_string_lit] = STATE(86),
    [sym_simple_bytes_lit] = STATE(86),
    [sym_simple_raw_bytes_lit] = STATE(86),
    [sym_multiline_string_lit] = STATE(86),
    [sym_multiline_raw_string_lit] = STATE(86),
    [sym_multiline_bytes_lit] = STATE(86),
    [sym_multiline_raw_bytes_lit] = STATE(86),
    [sym_builtin] = STATE(355),
    [sym_float_type] = STATE(86),
    [sym_uint_type] = STATE(86),
    [sym_int_type] = STATE(86),
    [sym_top_lit] = STATE(86),
    [sym_list_lit] = STATE(86),
    [sym_struct_lit] = STATE(86),
    [sym__expression] = STATE(248),
    [sym_binary_expression] = STATE(248),
    [sym_unary_expression] = STATE(248),
    [sym__primary_expression] = STATE(86),
    [sym__operand] = STATE(86),
    [sym__call_operand] = STATE(355),
    [sym_index_expression] = STATE(86),
    [sym_selector_expression] = STATE(86),
    [sym_call_expression] = STATE(86),
    [sym__literal] = STATE(86),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym__] = ACTIONS(258),
    [anon_sym_DQUOTE] = ACTIONS(260),
    [anon_sym_POUND_DQUOTE] = ACTIONS(262),
    [anon_sym_SQUOTE] = ACTIONS(264),
    [anon_sym_POUND_SQUOTE] = ACTIONS(266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(268),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(270),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(272),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(274),
    [anon_sym_len] = ACTIONS(35),
    [anon_sym_close] = ACTIONS(35),
    [anon_sym_and] = ACTIONS(35),
    [anon_sym_or] = ACTIONS(35),
    [anon_sym_div] = ACTIONS(35),
    [anon_sym_mod] = ACTIONS(35),
    [anon_sym_quo] = ACTIONS(35),
    [anon_sym_rem] = ACTIONS(35),
    [sym_number_type] = ACTIONS(276),
    [anon_sym_float] = ACTIONS(278),
    [anon_sym_float32] = ACTIONS(278),
    [anon_sym_float64] = ACTIONS(278),
    [anon_sym_uint] = ACTIONS(280),
    [anon_sym_uint8] = ACTIONS(280),
    [anon_sym_uint16] = ACTIONS(280),
    [anon_sym_uint32] = ACTIONS(280),
    [anon_sym_uint64] = ACTIONS(280),
    [anon_sym_uint128] = ACTIONS(280),
    [anon_sym_int] = ACTIONS(282),
    [anon_sym_int8] = ACTIONS(282),
    [anon_sym_int16] = ACTIONS(282),
    [anon_sym_int32] = ACTIONS(282),
    [anon_sym_int64] = ACTIONS(282),
    [anon_sym_int128] = ACTIONS(282),
    [sym_string_type] = ACTIONS(276),
    [sym_bytes_type] = ACTIONS(276),
    [sym_bool_type] = ACTIONS(276),
    [sym_bottom_lit] = ACTIONS(284),
    [sym_null] = ACTIONS(276),
    [sym_true] = ACTIONS(276),
    [sym_false] = ACTIONS(276),
    [sym_int_lit] = ACTIONS(276),
    [sym_float_lit] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_BANG_EQ] = ACTIONS(294),
    [anon_sym_LT] = ACTIONS(296),
    [anon_sym_LT_EQ] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_EQ] = ACTIONS(294),
    [anon_sym_EQ_TILDE] = ACTIONS(294),
    [anon_sym_BANG_TILDE] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_comment] = ACTIONS(3),
  },
  [78] = {
    [sym_identifier] = ACTIONS(554),
    [anon_sym_LF] = ACTIONS(556),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(554),
    [sym_dot] = ACTIONS(558),
    [anon_sym__] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym_DQUOTE] = ACTIONS(554),
    [anon_sym_POUND_DQUOTE] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(554),
    [anon_sym_POUND_SQUOTE] = ACTIONS(554),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(554),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(554),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(554),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(554),
    [anon_sym_len] = ACTIONS(554),
    [anon_sym_close] = ACTIONS(554),
    [anon_sym_and] = ACTIONS(554),
    [anon_sym_or] = ACTIONS(554),
    [anon_sym_div] = ACTIONS(554),
    [anon_sym_mod] = ACTIONS(554),
    [anon_sym_quo] = ACTIONS(554),
    [anon_sym_rem] = ACTIONS(554),
    [sym_number_type] = ACTIONS(554),
    [anon_sym_float] = ACTIONS(554),
    [anon_sym_float32] = ACTIONS(554),
    [anon_sym_float64] = ACTIONS(554),
    [anon_sym_uint] = ACTIONS(554),
    [anon_sym_uint8] = ACTIONS(554),
    [anon_sym_uint16] = ACTIONS(554),
    [anon_sym_uint32] = ACTIONS(554),
    [anon_sym_uint64] = ACTIONS(554),
    [anon_sym_uint128] = ACTIONS(554),
    [anon_sym_int] = ACTIONS(554),
    [anon_sym_int8] = ACTIONS(554),
    [anon_sym_int16] = ACTIONS(554),
    [anon_sym_int32] = ACTIONS(554),
    [anon_sym_int64] = ACTIONS(554),
    [anon_sym_int128] = ACTIONS(554),
    [sym_string_type] = ACTIONS(554),
    [sym_bytes_type] = ACTIONS(554),
    [sym_bool_type] = ACTIONS(554),
    [sym_bottom_lit] = ACTIONS(554),
    [sym_null] = ACTIONS(554),
    [sym_true] = ACTIONS(554),
    [sym_false] = ACTIONS(554),
    [sym_int_lit] = ACTIONS(554),
    [sym_float_lit] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(554),
    [anon_sym_RBRACE] = ACTIONS(554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_QMARK] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(563),
    [anon_sym_COLON] = ACTIONS(561),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_if] = ACTIONS(554),
    [anon_sym_let] = ACTIONS(554),
    [anon_sym_PIPE] = ACTIONS(554),
    [anon_sym_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(554),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ_TILDE] = ACTIONS(554),
    [anon_sym_BANG_TILDE] = ACTIONS(554),
    [anon_sym_PLUS] = ACTIONS(554),
    [anon_sym_DASH] = ACTIONS(554),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_SLASH] = ACTIONS(554),
    [anon_sym_BANG] = ACTIONS(554),
    [anon_sym_LBRACK2] = ACTIONS(556),
    [sym_comment] = ACTIONS(530),
  },
  [79] = {
    [sym_identifier] = ACTIONS(565),
    [anon_sym_LF] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_LPAREN] = ACTIONS(565),
    [sym_dot] = ACTIONS(565),
    [anon_sym__] = ACTIONS(565),
    [anon_sym_AT] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(565),
    [anon_sym_POUND_DQUOTE] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_POUND_SQUOTE] = ACTIONS(565),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(565),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(565),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(565),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(565),
    [anon_sym_len] = ACTIONS(565),
    [anon_sym_close] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_div] = ACTIONS(565),
    [anon_sym_mod] = ACTIONS(565),
    [anon_sym_quo] = ACTIONS(565),
    [anon_sym_rem] = ACTIONS(565),
    [sym_number_type] = ACTIONS(565),
    [anon_sym_float] = ACTIONS(565),
    [anon_sym_float32] = ACTIONS(565),
    [anon_sym_float64] = ACTIONS(565),
    [anon_sym_uint] = ACTIONS(565),
    [anon_sym_uint8] = ACTIONS(565),
    [anon_sym_uint16] = ACTIONS(565),
    [anon_sym_uint32] = ACTIONS(565),
    [anon_sym_uint64] = ACTIONS(565),
    [anon_sym_uint128] = ACTIONS(565),
    [anon_sym_int] = ACTIONS(565),
    [anon_sym_int8] = ACTIONS(565),
    [anon_sym_int16] = ACTIONS(565),
    [anon_sym_int32] = ACTIONS(565),
    [anon_sym_int64] = ACTIONS(565),
    [anon_sym_int128] = ACTIONS(565),
    [sym_string_type] = ACTIONS(565),
    [sym_bytes_type] = ACTIONS(565),
    [sym_bool_type] = ACTIONS(565),
    [sym_bottom_lit] = ACTIONS(565),
    [sym_null] = ACTIONS(565),
    [sym_true] = ACTIONS(565),
    [sym_false] = ACTIONS(565),
    [sym_int_lit] = ACTIONS(565),
    [sym_float_lit] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(565),
    [anon_sym_COLON] = ACTIONS(565),
    [anon_sym_for] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_let] = ACTIONS(565),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_AMP] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(565),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_EQ_EQ] = ACTIONS(565),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(565),
    [anon_sym_GT] = ACTIONS(565),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_BANG_TILDE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(565),
    [anon_sym_STAR] = ACTIONS(565),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(565),
    [anon_sym_LBRACK2] = ACTIONS(567),
    [sym_comment] = ACTIONS(530),
  },
  [80] = {
    [sym_identifier] = ACTIONS(569),
    [anon_sym_LF] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(569),
    [sym_dot] = ACTIONS(569),
    [anon_sym__] = ACTIONS(569),
    [anon_sym_AT] = ACTIONS(569),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [anon_sym_POUND_DQUOTE] = ACTIONS(569),
    [anon_sym_SQUOTE] = ACTIONS(569),
    [anon_sym_POUND_SQUOTE] = ACTIONS(569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(569),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(569),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(569),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(569),
    [anon_sym_len] = ACTIONS(569),
    [anon_sym_close] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_div] = ACTIONS(569),
    [anon_sym_mod] = ACTIONS(569),
    [anon_sym_quo] = ACTIONS(569),
    [anon_sym_rem] = ACTIONS(569),
    [sym_number_type] = ACTIONS(569),
    [anon_sym_float] = ACTIONS(569),
    [anon_sym_float32] = ACTIONS(569),
    [anon_sym_float64] = ACTIONS(569),
    [anon_sym_uint] = ACTIONS(569),
    [anon_sym_uint8] = ACTIONS(569),
    [anon_sym_uint16] = ACTIONS(569),
    [anon_sym_uint32] = ACTIONS(569),
    [anon_sym_uint64] = ACTIONS(569),
    [anon_sym_uint128] = ACTIONS(569),
    [anon_sym_int] = ACTIONS(569),
    [anon_sym_int8] = ACTIONS(569),
    [anon_sym_int16] = ACTIONS(569),
    [anon_sym_int32] = ACTIONS(569),
    [anon_sym_int64] = ACTIONS(569),
    [anon_sym_int128] = ACTIONS(569),
    [sym_string_type] = ACTIONS(569),
    [sym_bytes_type] = ACTIONS(569),
    [sym_bool_type] = ACTIONS(569),
    [sym_bottom_lit] = ACTIONS(569),
    [sym_null] = ACTIONS(569),
    [sym_true] = ACTIONS(569),
    [sym_false] = ACTIONS(569),
    [sym_int_lit] = ACTIONS(569),
    [sym_float_lit] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(561),
    [anon_sym_for] = ACTIONS(569),
    [anon_sym_if] = ACTIONS(569),
    [anon_sym_let] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(569),
    [anon_sym_AMP_AMP] = ACTIONS(569),
    [anon_sym_EQ_EQ] = ACTIONS(569),
    [anon_sym_BANG_EQ] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(569),
    [anon_sym_GT] = ACTIONS(569),
    [anon_sym_GT_EQ] = ACTIONS(569),
    [anon_sym_EQ_TILDE] = ACTIONS(569),
    [anon_sym_BANG_TILDE] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(569),
    [anon_sym_DASH] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(569),
    [anon_sym_SLASH] = ACTIONS(569),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LBRACK2] = ACTIONS(571),
    [sym_comment] = ACTIONS(530),
  },
  [81] = {
    [sym_selector] = STATE(112),
    [sym_index] = STATE(113),
    [sym_identifier] = ACTIONS(573),
    [anon_sym_LF] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(573),
    [sym_dot] = ACTIONS(577),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_POUND_DQUOTE] = ACTIONS(573),
    [anon_sym_SQUOTE] = ACTIONS(573),
    [anon_sym_POUND_SQUOTE] = ACTIONS(573),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(573),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(573),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(573),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(573),
    [anon_sym_len] = ACTIONS(573),
    [anon_sym_close] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_div] = ACTIONS(573),
    [anon_sym_mod] = ACTIONS(573),
    [anon_sym_quo] = ACTIONS(573),
    [anon_sym_rem] = ACTIONS(573),
    [sym_number_type] = ACTIONS(573),
    [anon_sym_float] = ACTIONS(573),
    [anon_sym_float32] = ACTIONS(573),
    [anon_sym_float64] = ACTIONS(573),
    [anon_sym_uint] = ACTIONS(573),
    [anon_sym_uint8] = ACTIONS(573),
    [anon_sym_uint16] = ACTIONS(573),
    [anon_sym_uint32] = ACTIONS(573),
    [anon_sym_uint64] = ACTIONS(573),
    [anon_sym_uint128] = ACTIONS(573),
    [anon_sym_int] = ACTIONS(573),
    [anon_sym_int8] = ACTIONS(573),
    [anon_sym_int16] = ACTIONS(573),
    [anon_sym_int32] = ACTIONS(573),
    [anon_sym_int64] = ACTIONS(573),
    [anon_sym_int128] = ACTIONS(573),
    [sym_string_type] = ACTIONS(573),
    [sym_bytes_type] = ACTIONS(573),
    [sym_bool_type] = ACTIONS(573),
    [sym_bottom_lit] = ACTIONS(573),
    [sym_null] = ACTIONS(573),
    [sym_true] = ACTIONS(573),
    [sym_false] = ACTIONS(573),
    [sym_int_lit] = ACTIONS(573),
    [sym_float_lit] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(573),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(573),
    [anon_sym_for] = ACTIONS(573),
    [anon_sym_if] = ACTIONS(573),
    [anon_sym_let] = ACTIONS(573),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_AMP] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_EQ_EQ] = ACTIONS(573),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [anon_sym_LT] = ACTIONS(573),
    [anon_sym_LT_EQ] = ACTIONS(573),
    [anon_sym_GT] = ACTIONS(573),
    [anon_sym_GT_EQ] = ACTIONS(573),
    [anon_sym_EQ_TILDE] = ACTIONS(573),
    [anon_sym_BANG_TILDE] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_SLASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(573),
    [anon_sym_LBRACK2] = ACTIONS(579),
    [sym_comment] = ACTIONS(530),
  },
  [82] = {
    [sym_identifier] = ACTIONS(554),
    [anon_sym_LF] = ACTIONS(556),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(554),
    [sym_dot] = ACTIONS(558),
    [anon_sym__] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym_DQUOTE] = ACTIONS(554),
    [anon_sym_POUND_DQUOTE] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(554),
    [anon_sym_POUND_SQUOTE] = ACTIONS(554),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(554),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(554),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(554),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(554),
    [anon_sym_len] = ACTIONS(554),
    [anon_sym_close] = ACTIONS(554),
    [anon_sym_and] = ACTIONS(554),
    [anon_sym_or] = ACTIONS(554),
    [anon_sym_div] = ACTIONS(554),
    [anon_sym_mod] = ACTIONS(554),
    [anon_sym_quo] = ACTIONS(554),
    [anon_sym_rem] = ACTIONS(554),
    [sym_number_type] = ACTIONS(554),
    [anon_sym_float] = ACTIONS(554),
    [anon_sym_float32] = ACTIONS(554),
    [anon_sym_float64] = ACTIONS(554),
    [anon_sym_uint] = ACTIONS(554),
    [anon_sym_uint8] = ACTIONS(554),
    [anon_sym_uint16] = ACTIONS(554),
    [anon_sym_uint32] = ACTIONS(554),
    [anon_sym_uint64] = ACTIONS(554),
    [anon_sym_uint128] = ACTIONS(554),
    [anon_sym_int] = ACTIONS(554),
    [anon_sym_int8] = ACTIONS(554),
    [anon_sym_int16] = ACTIONS(554),
    [anon_sym_int32] = ACTIONS(554),
    [anon_sym_int64] = ACTIONS(554),
    [anon_sym_int128] = ACTIONS(554),
    [sym_string_type] = ACTIONS(554),
    [sym_bytes_type] = ACTIONS(554),
    [sym_bool_type] = ACTIONS(554),
    [sym_bottom_lit] = ACTIONS(554),
    [sym_null] = ACTIONS(554),
    [sym_true] = ACTIONS(554),
    [sym_false] = ACTIONS(554),
    [sym_int_lit] = ACTIONS(554),
    [sym_float_lit] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(554),
    [anon_sym_RBRACE] = ACTIONS(554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_QMARK] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(561),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_if] = ACTIONS(554),
    [anon_sym_let] = ACTIONS(554),
    [anon_sym_PIPE] = ACTIONS(554),
    [anon_sym_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(554),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ_TILDE] = ACTIONS(554),
    [anon_sym_BANG_TILDE] = ACTIONS(554),
    [anon_sym_PLUS] = ACTIONS(554),
    [anon_sym_DASH] = ACTIONS(554),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_SLASH] = ACTIONS(554),
    [anon_sym_BANG] = ACTIONS(554),
    [anon_sym_LBRACK2] = ACTIONS(556),
    [sym_comment] = ACTIONS(530),
  },
  [83] = {
    [sym_identifier] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(583),
    [anon_sym_COMMA] = ACTIONS(581),
    [anon_sym_LPAREN] = ACTIONS(581),
    [sym_dot] = ACTIONS(581),
    [anon_sym__] = ACTIONS(581),
    [anon_sym_AT] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(581),
    [anon_sym_POUND_DQUOTE] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(581),
    [anon_sym_POUND_SQUOTE] = ACTIONS(581),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(581),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(581),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(581),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(581),
    [anon_sym_len] = ACTIONS(581),
    [anon_sym_close] = ACTIONS(581),
    [anon_sym_and] = ACTIONS(581),
    [anon_sym_or] = ACTIONS(581),
    [anon_sym_div] = ACTIONS(581),
    [anon_sym_mod] = ACTIONS(581),
    [anon_sym_quo] = ACTIONS(581),
    [anon_sym_rem] = ACTIONS(581),
    [sym_number_type] = ACTIONS(581),
    [anon_sym_float] = ACTIONS(581),
    [anon_sym_float32] = ACTIONS(581),
    [anon_sym_float64] = ACTIONS(581),
    [anon_sym_uint] = ACTIONS(581),
    [anon_sym_uint8] = ACTIONS(581),
    [anon_sym_uint16] = ACTIONS(581),
    [anon_sym_uint32] = ACTIONS(581),
    [anon_sym_uint64] = ACTIONS(581),
    [anon_sym_uint128] = ACTIONS(581),
    [anon_sym_int] = ACTIONS(581),
    [anon_sym_int8] = ACTIONS(581),
    [anon_sym_int16] = ACTIONS(581),
    [anon_sym_int32] = ACTIONS(581),
    [anon_sym_int64] = ACTIONS(581),
    [anon_sym_int128] = ACTIONS(581),
    [sym_string_type] = ACTIONS(581),
    [sym_bytes_type] = ACTIONS(581),
    [sym_bool_type] = ACTIONS(581),
    [sym_bottom_lit] = ACTIONS(581),
    [sym_null] = ACTIONS(581),
    [sym_true] = ACTIONS(581),
    [sym_false] = ACTIONS(581),
    [sym_int_lit] = ACTIONS(581),
    [sym_float_lit] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(581),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_RBRACE] = ACTIONS(581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(581),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_COLON] = ACTIONS(581),
    [anon_sym_for] = ACTIONS(581),
    [anon_sym_if] = ACTIONS(581),
    [anon_sym_let] = ACTIONS(581),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(581),
    [anon_sym_BANG_EQ] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_EQ] = ACTIONS(581),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_GT_EQ] = ACTIONS(581),
    [anon_sym_EQ_TILDE] = ACTIONS(581),
    [anon_sym_BANG_TILDE] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_STAR] = ACTIONS(581),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_BANG] = ACTIONS(581),
    [anon_sym_LBRACK2] = ACTIONS(583),
    [sym_comment] = ACTIONS(530),
  },
  [84] = {
    [sym_identifier] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_LPAREN] = ACTIONS(567),
    [anon_sym_RPAREN] = ACTIONS(567),
    [sym_dot] = ACTIONS(565),
    [anon_sym__] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(565),
    [anon_sym_POUND_DQUOTE] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_POUND_SQUOTE] = ACTIONS(565),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(567),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(567),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(567),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(567),
    [anon_sym_len] = ACTIONS(565),
    [anon_sym_close] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_div] = ACTIONS(565),
    [anon_sym_mod] = ACTIONS(565),
    [anon_sym_quo] = ACTIONS(565),
    [anon_sym_rem] = ACTIONS(565),
    [sym_number_type] = ACTIONS(565),
    [anon_sym_float] = ACTIONS(565),
    [anon_sym_float32] = ACTIONS(565),
    [anon_sym_float64] = ACTIONS(565),
    [anon_sym_uint] = ACTIONS(565),
    [anon_sym_uint8] = ACTIONS(565),
    [anon_sym_uint16] = ACTIONS(565),
    [anon_sym_uint32] = ACTIONS(565),
    [anon_sym_uint64] = ACTIONS(565),
    [anon_sym_uint128] = ACTIONS(565),
    [anon_sym_int] = ACTIONS(565),
    [anon_sym_int8] = ACTIONS(565),
    [anon_sym_int16] = ACTIONS(565),
    [anon_sym_int32] = ACTIONS(565),
    [anon_sym_int64] = ACTIONS(565),
    [anon_sym_int128] = ACTIONS(565),
    [sym_string_type] = ACTIONS(565),
    [sym_bytes_type] = ACTIONS(565),
    [sym_bool_type] = ACTIONS(565),
    [sym_bottom_lit] = ACTIONS(567),
    [sym_null] = ACTIONS(565),
    [sym_true] = ACTIONS(565),
    [sym_false] = ACTIONS(565),
    [sym_int_lit] = ACTIONS(565),
    [sym_float_lit] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_RBRACK] = ACTIONS(567),
    [anon_sym_LBRACE] = ACTIONS(567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(567),
    [anon_sym_QMARK] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(567),
    [anon_sym_for] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_let] = ACTIONS(565),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_AMP] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(567),
    [anon_sym_AMP_AMP] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(565),
    [anon_sym_GT_EQ] = ACTIONS(567),
    [anon_sym_EQ_TILDE] = ACTIONS(567),
    [anon_sym_BANG_TILDE] = ACTIONS(567),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(565),
    [anon_sym_LBRACK2] = ACTIONS(567),
    [sym_comment] = ACTIONS(3),
  },
  [85] = {
    [sym_identifier] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(583),
    [anon_sym_RPAREN] = ACTIONS(583),
    [sym_dot] = ACTIONS(581),
    [anon_sym__] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(581),
    [anon_sym_POUND_DQUOTE] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(581),
    [anon_sym_POUND_SQUOTE] = ACTIONS(581),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(583),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(583),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(583),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(583),
    [anon_sym_len] = ACTIONS(581),
    [anon_sym_close] = ACTIONS(581),
    [anon_sym_and] = ACTIONS(581),
    [anon_sym_or] = ACTIONS(581),
    [anon_sym_div] = ACTIONS(581),
    [anon_sym_mod] = ACTIONS(581),
    [anon_sym_quo] = ACTIONS(581),
    [anon_sym_rem] = ACTIONS(581),
    [sym_number_type] = ACTIONS(581),
    [anon_sym_float] = ACTIONS(581),
    [anon_sym_float32] = ACTIONS(581),
    [anon_sym_float64] = ACTIONS(581),
    [anon_sym_uint] = ACTIONS(581),
    [anon_sym_uint8] = ACTIONS(581),
    [anon_sym_uint16] = ACTIONS(581),
    [anon_sym_uint32] = ACTIONS(581),
    [anon_sym_uint64] = ACTIONS(581),
    [anon_sym_uint128] = ACTIONS(581),
    [anon_sym_int] = ACTIONS(581),
    [anon_sym_int8] = ACTIONS(581),
    [anon_sym_int16] = ACTIONS(581),
    [anon_sym_int32] = ACTIONS(581),
    [anon_sym_int64] = ACTIONS(581),
    [anon_sym_int128] = ACTIONS(581),
    [sym_string_type] = ACTIONS(581),
    [sym_bytes_type] = ACTIONS(581),
    [sym_bool_type] = ACTIONS(581),
    [sym_bottom_lit] = ACTIONS(583),
    [sym_null] = ACTIONS(581),
    [sym_true] = ACTIONS(581),
    [sym_false] = ACTIONS(581),
    [sym_int_lit] = ACTIONS(581),
    [sym_float_lit] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(581),
    [anon_sym_RBRACK] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(583),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(583),
    [anon_sym_QMARK] = ACTIONS(583),
    [anon_sym_COLON] = ACTIONS(583),
    [anon_sym_for] = ACTIONS(581),
    [anon_sym_if] = ACTIONS(581),
    [anon_sym_let] = ACTIONS(581),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(583),
    [anon_sym_AMP_AMP] = ACTIONS(583),
    [anon_sym_EQ_EQ] = ACTIONS(583),
    [anon_sym_BANG_EQ] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_EQ] = ACTIONS(583),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_GT_EQ] = ACTIONS(583),
    [anon_sym_EQ_TILDE] = ACTIONS(583),
    [anon_sym_BANG_TILDE] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(583),
    [anon_sym_DASH] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(583),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_BANG] = ACTIONS(581),
    [anon_sym_LBRACK2] = ACTIONS(583),
    [sym_comment] = ACTIONS(3),
  },
  [86] = {
    [sym_selector] = STATE(137),
    [sym_index] = STATE(141),
    [sym_identifier] = ACTIONS(573),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_LPAREN] = ACTIONS(575),
    [anon_sym_RPAREN] = ACTIONS(575),
    [sym_dot] = ACTIONS(585),
    [anon_sym__] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_POUND_DQUOTE] = ACTIONS(573),
    [anon_sym_SQUOTE] = ACTIONS(573),
    [anon_sym_POUND_SQUOTE] = ACTIONS(573),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(575),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(575),
    [anon_sym_len] = ACTIONS(573),
    [anon_sym_close] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_div] = ACTIONS(573),
    [anon_sym_mod] = ACTIONS(573),
    [anon_sym_quo] = ACTIONS(573),
    [anon_sym_rem] = ACTIONS(573),
    [sym_number_type] = ACTIONS(573),
    [anon_sym_float] = ACTIONS(573),
    [anon_sym_float32] = ACTIONS(573),
    [anon_sym_float64] = ACTIONS(573),
    [anon_sym_uint] = ACTIONS(573),
    [anon_sym_uint8] = ACTIONS(573),
    [anon_sym_uint16] = ACTIONS(573),
    [anon_sym_uint32] = ACTIONS(573),
    [anon_sym_uint64] = ACTIONS(573),
    [anon_sym_uint128] = ACTIONS(573),
    [anon_sym_int] = ACTIONS(573),
    [anon_sym_int8] = ACTIONS(573),
    [anon_sym_int16] = ACTIONS(573),
    [anon_sym_int32] = ACTIONS(573),
    [anon_sym_int64] = ACTIONS(573),
    [anon_sym_int128] = ACTIONS(573),
    [sym_string_type] = ACTIONS(573),
    [sym_bytes_type] = ACTIONS(573),
    [sym_bool_type] = ACTIONS(573),
    [sym_bottom_lit] = ACTIONS(575),
    [sym_null] = ACTIONS(573),
    [sym_true] = ACTIONS(573),
    [sym_false] = ACTIONS(573),
    [sym_int_lit] = ACTIONS(573),
    [sym_float_lit] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_RBRACK] = ACTIONS(575),
    [anon_sym_LBRACE] = ACTIONS(575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(575),
    [anon_sym_for] = ACTIONS(573),
    [anon_sym_if] = ACTIONS(573),
    [anon_sym_let] = ACTIONS(573),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_AMP] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(575),
    [anon_sym_AMP_AMP] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_BANG_EQ] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(573),
    [anon_sym_LT_EQ] = ACTIONS(575),
    [anon_sym_GT] = ACTIONS(573),
    [anon_sym_GT_EQ] = ACTIONS(575),
    [anon_sym_EQ_TILDE] = ACTIONS(575),
    [anon_sym_BANG_TILDE] = ACTIONS(575),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_STAR] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(573),
    [anon_sym_LBRACK2] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
  },
  [87] = {
    [sym_identifier] = ACTIONS(589),
    [anon_sym_LF] = ACTIONS(591),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_LPAREN] = ACTIONS(589),
    [sym_dot] = ACTIONS(589),
    [anon_sym__] = ACTIONS(589),
    [anon_sym_AT] = ACTIONS(589),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [anon_sym_POUND_DQUOTE] = ACTIONS(589),
    [anon_sym_SQUOTE] = ACTIONS(589),
    [anon_sym_POUND_SQUOTE] = ACTIONS(589),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(589),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(589),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(589),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(589),
    [anon_sym_len] = ACTIONS(589),
    [anon_sym_close] = ACTIONS(589),
    [anon_sym_and] = ACTIONS(589),
    [anon_sym_or] = ACTIONS(589),
    [anon_sym_div] = ACTIONS(589),
    [anon_sym_mod] = ACTIONS(589),
    [anon_sym_quo] = ACTIONS(589),
    [anon_sym_rem] = ACTIONS(589),
    [sym_number_type] = ACTIONS(589),
    [anon_sym_float] = ACTIONS(589),
    [anon_sym_float32] = ACTIONS(589),
    [anon_sym_float64] = ACTIONS(589),
    [anon_sym_uint] = ACTIONS(589),
    [anon_sym_uint8] = ACTIONS(589),
    [anon_sym_uint16] = ACTIONS(589),
    [anon_sym_uint32] = ACTIONS(589),
    [anon_sym_uint64] = ACTIONS(589),
    [anon_sym_uint128] = ACTIONS(589),
    [anon_sym_int] = ACTIONS(589),
    [anon_sym_int8] = ACTIONS(589),
    [anon_sym_int16] = ACTIONS(589),
    [anon_sym_int32] = ACTIONS(589),
    [anon_sym_int64] = ACTIONS(589),
    [anon_sym_int128] = ACTIONS(589),
    [sym_string_type] = ACTIONS(589),
    [sym_bytes_type] = ACTIONS(589),
    [sym_bool_type] = ACTIONS(589),
    [sym_bottom_lit] = ACTIONS(589),
    [sym_null] = ACTIONS(589),
    [sym_true] = ACTIONS(589),
    [sym_false] = ACTIONS(589),
    [sym_int_lit] = ACTIONS(589),
    [sym_float_lit] = ACTIONS(589),
    [anon_sym_LBRACK] = ACTIONS(589),
    [anon_sym_LBRACE] = ACTIONS(589),
    [anon_sym_RBRACE] = ACTIONS(589),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_for] = ACTIONS(589),
    [anon_sym_if] = ACTIONS(589),
    [anon_sym_let] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(589),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE_PIPE] = ACTIONS(589),
    [anon_sym_AMP_AMP] = ACTIONS(589),
    [anon_sym_EQ_EQ] = ACTIONS(589),
    [anon_sym_BANG_EQ] = ACTIONS(589),
    [anon_sym_LT] = ACTIONS(589),
    [anon_sym_LT_EQ] = ACTIONS(589),
    [anon_sym_GT] = ACTIONS(589),
    [anon_sym_GT_EQ] = ACTIONS(589),
    [anon_sym_EQ_TILDE] = ACTIONS(589),
    [anon_sym_BANG_TILDE] = ACTIONS(589),
    [anon_sym_PLUS] = ACTIONS(589),
    [anon_sym_DASH] = ACTIONS(589),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_SLASH] = ACTIONS(589),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_LBRACK2] = ACTIONS(591),
    [sym_comment] = ACTIONS(530),
  },
  [88] = {
    [sym_identifier] = ACTIONS(593),
    [anon_sym_LF] = ACTIONS(595),
    [anon_sym_COMMA] = ACTIONS(593),
    [anon_sym_LPAREN] = ACTIONS(593),
    [sym_dot] = ACTIONS(593),
    [anon_sym__] = ACTIONS(593),
    [anon_sym_AT] = ACTIONS(593),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [anon_sym_POUND_DQUOTE] = ACTIONS(593),
    [anon_sym_SQUOTE] = ACTIONS(593),
    [anon_sym_POUND_SQUOTE] = ACTIONS(593),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(593),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(593),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(593),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(593),
    [anon_sym_len] = ACTIONS(593),
    [anon_sym_close] = ACTIONS(593),
    [anon_sym_and] = ACTIONS(593),
    [anon_sym_or] = ACTIONS(593),
    [anon_sym_div] = ACTIONS(593),
    [anon_sym_mod] = ACTIONS(593),
    [anon_sym_quo] = ACTIONS(593),
    [anon_sym_rem] = ACTIONS(593),
    [sym_number_type] = ACTIONS(593),
    [anon_sym_float] = ACTIONS(593),
    [anon_sym_float32] = ACTIONS(593),
    [anon_sym_float64] = ACTIONS(593),
    [anon_sym_uint] = ACTIONS(593),
    [anon_sym_uint8] = ACTIONS(593),
    [anon_sym_uint16] = ACTIONS(593),
    [anon_sym_uint32] = ACTIONS(593),
    [anon_sym_uint64] = ACTIONS(593),
    [anon_sym_uint128] = ACTIONS(593),
    [anon_sym_int] = ACTIONS(593),
    [anon_sym_int8] = ACTIONS(593),
    [anon_sym_int16] = ACTIONS(593),
    [anon_sym_int32] = ACTIONS(593),
    [anon_sym_int64] = ACTIONS(593),
    [anon_sym_int128] = ACTIONS(593),
    [sym_string_type] = ACTIONS(593),
    [sym_bytes_type] = ACTIONS(593),
    [sym_bool_type] = ACTIONS(593),
    [sym_bottom_lit] = ACTIONS(593),
    [sym_null] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_int_lit] = ACTIONS(593),
    [sym_float_lit] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(593),
    [anon_sym_LBRACE] = ACTIONS(593),
    [anon_sym_RBRACE] = ACTIONS(593),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(593),
    [anon_sym_for] = ACTIONS(593),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_let] = ACTIONS(593),
    [anon_sym_PIPE] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(593),
    [anon_sym_PIPE_PIPE] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(593),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(593),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_GT_EQ] = ACTIONS(593),
    [anon_sym_EQ_TILDE] = ACTIONS(593),
    [anon_sym_BANG_TILDE] = ACTIONS(593),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_STAR] = ACTIONS(593),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_BANG] = ACTIONS(593),
    [anon_sym_LBRACK2] = ACTIONS(595),
    [sym_comment] = ACTIONS(530),
  },
  [89] = {
    [sym_identifier] = ACTIONS(597),
    [anon_sym_LF] = ACTIONS(599),
    [anon_sym_COMMA] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(597),
    [sym_dot] = ACTIONS(597),
    [anon_sym__] = ACTIONS(597),
    [anon_sym_AT] = ACTIONS(597),
    [anon_sym_DQUOTE] = ACTIONS(597),
    [anon_sym_POUND_DQUOTE] = ACTIONS(597),
    [anon_sym_SQUOTE] = ACTIONS(597),
    [anon_sym_POUND_SQUOTE] = ACTIONS(597),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(597),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(597),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(597),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(597),
    [anon_sym_len] = ACTIONS(597),
    [anon_sym_close] = ACTIONS(597),
    [anon_sym_and] = ACTIONS(597),
    [anon_sym_or] = ACTIONS(597),
    [anon_sym_div] = ACTIONS(597),
    [anon_sym_mod] = ACTIONS(597),
    [anon_sym_quo] = ACTIONS(597),
    [anon_sym_rem] = ACTIONS(597),
    [sym_number_type] = ACTIONS(597),
    [anon_sym_float] = ACTIONS(597),
    [anon_sym_float32] = ACTIONS(597),
    [anon_sym_float64] = ACTIONS(597),
    [anon_sym_uint] = ACTIONS(597),
    [anon_sym_uint8] = ACTIONS(597),
    [anon_sym_uint16] = ACTIONS(597),
    [anon_sym_uint32] = ACTIONS(597),
    [anon_sym_uint64] = ACTIONS(597),
    [anon_sym_uint128] = ACTIONS(597),
    [anon_sym_int] = ACTIONS(597),
    [anon_sym_int8] = ACTIONS(597),
    [anon_sym_int16] = ACTIONS(597),
    [anon_sym_int32] = ACTIONS(597),
    [anon_sym_int64] = ACTIONS(597),
    [anon_sym_int128] = ACTIONS(597),
    [sym_string_type] = ACTIONS(597),
    [sym_bytes_type] = ACTIONS(597),
    [sym_bool_type] = ACTIONS(597),
    [sym_bottom_lit] = ACTIONS(597),
    [sym_null] = ACTIONS(597),
    [sym_true] = ACTIONS(597),
    [sym_false] = ACTIONS(597),
    [sym_int_lit] = ACTIONS(597),
    [sym_float_lit] = ACTIONS(597),
    [anon_sym_LBRACK] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(597),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_let] = ACTIONS(597),
    [anon_sym_PIPE] = ACTIONS(597),
    [anon_sym_AMP] = ACTIONS(597),
    [anon_sym_PIPE_PIPE] = ACTIONS(597),
    [anon_sym_AMP_AMP] = ACTIONS(597),
    [anon_sym_EQ_EQ] = ACTIONS(597),
    [anon_sym_BANG_EQ] = ACTIONS(597),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_LT_EQ] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_EQ] = ACTIONS(597),
    [anon_sym_EQ_TILDE] = ACTIONS(597),
    [anon_sym_BANG_TILDE] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(597),
    [anon_sym_SLASH] = ACTIONS(597),
    [anon_sym_BANG] = ACTIONS(597),
    [anon_sym_LBRACK2] = ACTIONS(599),
    [sym_comment] = ACTIONS(530),
  },
  [90] = {
    [sym_identifier] = ACTIONS(554),
    [anon_sym_LF] = ACTIONS(556),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(554),
    [sym_dot] = ACTIONS(558),
    [anon_sym__] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym_DQUOTE] = ACTIONS(554),
    [anon_sym_POUND_DQUOTE] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(554),
    [anon_sym_POUND_SQUOTE] = ACTIONS(554),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(554),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(554),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(554),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(554),
    [anon_sym_len] = ACTIONS(554),
    [anon_sym_close] = ACTIONS(554),
    [anon_sym_and] = ACTIONS(554),
    [anon_sym_or] = ACTIONS(554),
    [anon_sym_div] = ACTIONS(554),
    [anon_sym_mod] = ACTIONS(554),
    [anon_sym_quo] = ACTIONS(554),
    [anon_sym_rem] = ACTIONS(554),
    [sym_number_type] = ACTIONS(554),
    [anon_sym_float] = ACTIONS(554),
    [anon_sym_float32] = ACTIONS(554),
    [anon_sym_float64] = ACTIONS(554),
    [anon_sym_uint] = ACTIONS(554),
    [anon_sym_uint8] = ACTIONS(554),
    [anon_sym_uint16] = ACTIONS(554),
    [anon_sym_uint32] = ACTIONS(554),
    [anon_sym_uint64] = ACTIONS(554),
    [anon_sym_uint128] = ACTIONS(554),
    [anon_sym_int] = ACTIONS(554),
    [anon_sym_int8] = ACTIONS(554),
    [anon_sym_int16] = ACTIONS(554),
    [anon_sym_int32] = ACTIONS(554),
    [anon_sym_int64] = ACTIONS(554),
    [anon_sym_int128] = ACTIONS(554),
    [sym_string_type] = ACTIONS(554),
    [sym_bytes_type] = ACTIONS(554),
    [sym_bool_type] = ACTIONS(554),
    [sym_bottom_lit] = ACTIONS(554),
    [sym_null] = ACTIONS(554),
    [sym_true] = ACTIONS(554),
    [sym_false] = ACTIONS(554),
    [sym_int_lit] = ACTIONS(554),
    [sym_float_lit] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(554),
    [anon_sym_RBRACE] = ACTIONS(554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_if] = ACTIONS(554),
    [anon_sym_let] = ACTIONS(554),
    [anon_sym_PIPE] = ACTIONS(554),
    [anon_sym_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(554),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ_TILDE] = ACTIONS(554),
    [anon_sym_BANG_TILDE] = ACTIONS(554),
    [anon_sym_PLUS] = ACTIONS(554),
    [anon_sym_DASH] = ACTIONS(554),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_SLASH] = ACTIONS(554),
    [anon_sym_BANG] = ACTIONS(554),
    [anon_sym_LBRACK2] = ACTIONS(556),
    [sym_comment] = ACTIONS(530),
  },
  [91] = {
    [sym_identifier] = ACTIONS(601),
    [anon_sym_LF] = ACTIONS(603),
    [anon_sym_COMMA] = ACTIONS(601),
    [anon_sym_LPAREN] = ACTIONS(601),
    [sym_dot] = ACTIONS(601),
    [anon_sym__] = ACTIONS(601),
    [anon_sym_AT] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [anon_sym_POUND_DQUOTE] = ACTIONS(601),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [anon_sym_POUND_SQUOTE] = ACTIONS(601),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(601),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(601),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(601),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(601),
    [anon_sym_len] = ACTIONS(601),
    [anon_sym_close] = ACTIONS(601),
    [anon_sym_and] = ACTIONS(601),
    [anon_sym_or] = ACTIONS(601),
    [anon_sym_div] = ACTIONS(601),
    [anon_sym_mod] = ACTIONS(601),
    [anon_sym_quo] = ACTIONS(601),
    [anon_sym_rem] = ACTIONS(601),
    [sym_number_type] = ACTIONS(601),
    [anon_sym_float] = ACTIONS(601),
    [anon_sym_float32] = ACTIONS(601),
    [anon_sym_float64] = ACTIONS(601),
    [anon_sym_uint] = ACTIONS(601),
    [anon_sym_uint8] = ACTIONS(601),
    [anon_sym_uint16] = ACTIONS(601),
    [anon_sym_uint32] = ACTIONS(601),
    [anon_sym_uint64] = ACTIONS(601),
    [anon_sym_uint128] = ACTIONS(601),
    [anon_sym_int] = ACTIONS(601),
    [anon_sym_int8] = ACTIONS(601),
    [anon_sym_int16] = ACTIONS(601),
    [anon_sym_int32] = ACTIONS(601),
    [anon_sym_int64] = ACTIONS(601),
    [anon_sym_int128] = ACTIONS(601),
    [sym_string_type] = ACTIONS(601),
    [sym_bytes_type] = ACTIONS(601),
    [sym_bool_type] = ACTIONS(601),
    [sym_bottom_lit] = ACTIONS(601),
    [sym_null] = ACTIONS(601),
    [sym_true] = ACTIONS(601),
    [sym_false] = ACTIONS(601),
    [sym_int_lit] = ACTIONS(601),
    [sym_float_lit] = ACTIONS(601),
    [anon_sym_LBRACK] = ACTIONS(601),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(601),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(601),
    [anon_sym_for] = ACTIONS(601),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_let] = ACTIONS(601),
    [anon_sym_PIPE] = ACTIONS(601),
    [anon_sym_AMP] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(601),
    [anon_sym_AMP_AMP] = ACTIONS(601),
    [anon_sym_EQ_EQ] = ACTIONS(601),
    [anon_sym_BANG_EQ] = ACTIONS(601),
    [anon_sym_LT] = ACTIONS(601),
    [anon_sym_LT_EQ] = ACTIONS(601),
    [anon_sym_GT] = ACTIONS(601),
    [anon_sym_GT_EQ] = ACTIONS(601),
    [anon_sym_EQ_TILDE] = ACTIONS(601),
    [anon_sym_BANG_TILDE] = ACTIONS(601),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_STAR] = ACTIONS(601),
    [anon_sym_SLASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(601),
    [anon_sym_LBRACK2] = ACTIONS(603),
    [sym_comment] = ACTIONS(530),
  },
  [92] = {
    [sym_identifier] = ACTIONS(605),
    [anon_sym_LF] = ACTIONS(607),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(605),
    [sym_dot] = ACTIONS(605),
    [anon_sym__] = ACTIONS(605),
    [anon_sym_AT] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [anon_sym_POUND_DQUOTE] = ACTIONS(605),
    [anon_sym_SQUOTE] = ACTIONS(605),
    [anon_sym_POUND_SQUOTE] = ACTIONS(605),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(605),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(605),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(605),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(605),
    [anon_sym_len] = ACTIONS(605),
    [anon_sym_close] = ACTIONS(605),
    [anon_sym_and] = ACTIONS(605),
    [anon_sym_or] = ACTIONS(605),
    [anon_sym_div] = ACTIONS(605),
    [anon_sym_mod] = ACTIONS(605),
    [anon_sym_quo] = ACTIONS(605),
    [anon_sym_rem] = ACTIONS(605),
    [sym_number_type] = ACTIONS(605),
    [anon_sym_float] = ACTIONS(605),
    [anon_sym_float32] = ACTIONS(605),
    [anon_sym_float64] = ACTIONS(605),
    [anon_sym_uint] = ACTIONS(605),
    [anon_sym_uint8] = ACTIONS(605),
    [anon_sym_uint16] = ACTIONS(605),
    [anon_sym_uint32] = ACTIONS(605),
    [anon_sym_uint64] = ACTIONS(605),
    [anon_sym_uint128] = ACTIONS(605),
    [anon_sym_int] = ACTIONS(605),
    [anon_sym_int8] = ACTIONS(605),
    [anon_sym_int16] = ACTIONS(605),
    [anon_sym_int32] = ACTIONS(605),
    [anon_sym_int64] = ACTIONS(605),
    [anon_sym_int128] = ACTIONS(605),
    [sym_string_type] = ACTIONS(605),
    [sym_bytes_type] = ACTIONS(605),
    [sym_bool_type] = ACTIONS(605),
    [sym_bottom_lit] = ACTIONS(605),
    [sym_null] = ACTIONS(605),
    [sym_true] = ACTIONS(605),
    [sym_false] = ACTIONS(605),
    [sym_int_lit] = ACTIONS(605),
    [sym_float_lit] = ACTIONS(605),
    [anon_sym_LBRACK] = ACTIONS(605),
    [anon_sym_LBRACE] = ACTIONS(605),
    [anon_sym_RBRACE] = ACTIONS(605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(605),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_if] = ACTIONS(605),
    [anon_sym_let] = ACTIONS(605),
    [anon_sym_PIPE] = ACTIONS(605),
    [anon_sym_AMP] = ACTIONS(605),
    [anon_sym_PIPE_PIPE] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(605),
    [anon_sym_EQ_EQ] = ACTIONS(605),
    [anon_sym_BANG_EQ] = ACTIONS(605),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_LT_EQ] = ACTIONS(605),
    [anon_sym_GT] = ACTIONS(605),
    [anon_sym_GT_EQ] = ACTIONS(605),
    [anon_sym_EQ_TILDE] = ACTIONS(605),
    [anon_sym_BANG_TILDE] = ACTIONS(605),
    [anon_sym_PLUS] = ACTIONS(605),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(605),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_LBRACK2] = ACTIONS(607),
    [sym_comment] = ACTIONS(530),
  },
  [93] = {
    [sym_identifier] = ACTIONS(609),
    [anon_sym_LF] = ACTIONS(611),
    [anon_sym_COMMA] = ACTIONS(609),
    [anon_sym_LPAREN] = ACTIONS(609),
    [sym_dot] = ACTIONS(609),
    [anon_sym__] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(609),
    [anon_sym_POUND_DQUOTE] = ACTIONS(609),
    [anon_sym_SQUOTE] = ACTIONS(609),
    [anon_sym_POUND_SQUOTE] = ACTIONS(609),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(609),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(609),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(609),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(609),
    [anon_sym_len] = ACTIONS(609),
    [anon_sym_close] = ACTIONS(609),
    [anon_sym_and] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(609),
    [anon_sym_div] = ACTIONS(609),
    [anon_sym_mod] = ACTIONS(609),
    [anon_sym_quo] = ACTIONS(609),
    [anon_sym_rem] = ACTIONS(609),
    [sym_number_type] = ACTIONS(609),
    [anon_sym_float] = ACTIONS(609),
    [anon_sym_float32] = ACTIONS(609),
    [anon_sym_float64] = ACTIONS(609),
    [anon_sym_uint] = ACTIONS(609),
    [anon_sym_uint8] = ACTIONS(609),
    [anon_sym_uint16] = ACTIONS(609),
    [anon_sym_uint32] = ACTIONS(609),
    [anon_sym_uint64] = ACTIONS(609),
    [anon_sym_uint128] = ACTIONS(609),
    [anon_sym_int] = ACTIONS(609),
    [anon_sym_int8] = ACTIONS(609),
    [anon_sym_int16] = ACTIONS(609),
    [anon_sym_int32] = ACTIONS(609),
    [anon_sym_int64] = ACTIONS(609),
    [anon_sym_int128] = ACTIONS(609),
    [sym_string_type] = ACTIONS(609),
    [sym_bytes_type] = ACTIONS(609),
    [sym_bool_type] = ACTIONS(609),
    [sym_bottom_lit] = ACTIONS(609),
    [sym_null] = ACTIONS(609),
    [sym_true] = ACTIONS(609),
    [sym_false] = ACTIONS(609),
    [sym_int_lit] = ACTIONS(609),
    [sym_float_lit] = ACTIONS(609),
    [anon_sym_LBRACK] = ACTIONS(609),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_RBRACE] = ACTIONS(609),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(609),
    [anon_sym_for] = ACTIONS(609),
    [anon_sym_if] = ACTIONS(609),
    [anon_sym_let] = ACTIONS(609),
    [anon_sym_PIPE] = ACTIONS(609),
    [anon_sym_AMP] = ACTIONS(609),
    [anon_sym_PIPE_PIPE] = ACTIONS(609),
    [anon_sym_AMP_AMP] = ACTIONS(609),
    [anon_sym_EQ_EQ] = ACTIONS(609),
    [anon_sym_BANG_EQ] = ACTIONS(609),
    [anon_sym_LT] = ACTIONS(609),
    [anon_sym_LT_EQ] = ACTIONS(609),
    [anon_sym_GT] = ACTIONS(609),
    [anon_sym_GT_EQ] = ACTIONS(609),
    [anon_sym_EQ_TILDE] = ACTIONS(609),
    [anon_sym_BANG_TILDE] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(609),
    [anon_sym_DASH] = ACTIONS(609),
    [anon_sym_STAR] = ACTIONS(609),
    [anon_sym_SLASH] = ACTIONS(609),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_LBRACK2] = ACTIONS(611),
    [sym_comment] = ACTIONS(530),
  },
  [94] = {
    [sym_identifier] = ACTIONS(613),
    [anon_sym_LF] = ACTIONS(615),
    [anon_sym_COMMA] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(613),
    [sym_dot] = ACTIONS(613),
    [anon_sym__] = ACTIONS(613),
    [anon_sym_AT] = ACTIONS(613),
    [anon_sym_DQUOTE] = ACTIONS(613),
    [anon_sym_POUND_DQUOTE] = ACTIONS(613),
    [anon_sym_SQUOTE] = ACTIONS(613),
    [anon_sym_POUND_SQUOTE] = ACTIONS(613),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(613),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(613),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(613),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(613),
    [anon_sym_len] = ACTIONS(613),
    [anon_sym_close] = ACTIONS(613),
    [anon_sym_and] = ACTIONS(613),
    [anon_sym_or] = ACTIONS(613),
    [anon_sym_div] = ACTIONS(613),
    [anon_sym_mod] = ACTIONS(613),
    [anon_sym_quo] = ACTIONS(613),
    [anon_sym_rem] = ACTIONS(613),
    [sym_number_type] = ACTIONS(613),
    [anon_sym_float] = ACTIONS(613),
    [anon_sym_float32] = ACTIONS(613),
    [anon_sym_float64] = ACTIONS(613),
    [anon_sym_uint] = ACTIONS(613),
    [anon_sym_uint8] = ACTIONS(613),
    [anon_sym_uint16] = ACTIONS(613),
    [anon_sym_uint32] = ACTIONS(613),
    [anon_sym_uint64] = ACTIONS(613),
    [anon_sym_uint128] = ACTIONS(613),
    [anon_sym_int] = ACTIONS(613),
    [anon_sym_int8] = ACTIONS(613),
    [anon_sym_int16] = ACTIONS(613),
    [anon_sym_int32] = ACTIONS(613),
    [anon_sym_int64] = ACTIONS(613),
    [anon_sym_int128] = ACTIONS(613),
    [sym_string_type] = ACTIONS(613),
    [sym_bytes_type] = ACTIONS(613),
    [sym_bool_type] = ACTIONS(613),
    [sym_bottom_lit] = ACTIONS(613),
    [sym_null] = ACTIONS(613),
    [sym_true] = ACTIONS(613),
    [sym_false] = ACTIONS(613),
    [sym_int_lit] = ACTIONS(613),
    [sym_float_lit] = ACTIONS(613),
    [anon_sym_LBRACK] = ACTIONS(613),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_RBRACE] = ACTIONS(613),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(613),
    [anon_sym_for] = ACTIONS(613),
    [anon_sym_if] = ACTIONS(613),
    [anon_sym_let] = ACTIONS(613),
    [anon_sym_PIPE] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(613),
    [anon_sym_PIPE_PIPE] = ACTIONS(613),
    [anon_sym_AMP_AMP] = ACTIONS(613),
    [anon_sym_EQ_EQ] = ACTIONS(613),
    [anon_sym_BANG_EQ] = ACTIONS(613),
    [anon_sym_LT] = ACTIONS(613),
    [anon_sym_LT_EQ] = ACTIONS(613),
    [anon_sym_GT] = ACTIONS(613),
    [anon_sym_GT_EQ] = ACTIONS(613),
    [anon_sym_EQ_TILDE] = ACTIONS(613),
    [anon_sym_BANG_TILDE] = ACTIONS(613),
    [anon_sym_PLUS] = ACTIONS(613),
    [anon_sym_DASH] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(613),
    [anon_sym_SLASH] = ACTIONS(613),
    [anon_sym_BANG] = ACTIONS(613),
    [anon_sym_LBRACK2] = ACTIONS(615),
    [sym_comment] = ACTIONS(530),
  },
  [95] = {
    [sym_identifier] = ACTIONS(617),
    [anon_sym_LF] = ACTIONS(619),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_LPAREN] = ACTIONS(617),
    [sym_dot] = ACTIONS(617),
    [anon_sym__] = ACTIONS(617),
    [anon_sym_AT] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(617),
    [anon_sym_POUND_DQUOTE] = ACTIONS(617),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_POUND_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(617),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(617),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(617),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(617),
    [anon_sym_len] = ACTIONS(617),
    [anon_sym_close] = ACTIONS(617),
    [anon_sym_and] = ACTIONS(617),
    [anon_sym_or] = ACTIONS(617),
    [anon_sym_div] = ACTIONS(617),
    [anon_sym_mod] = ACTIONS(617),
    [anon_sym_quo] = ACTIONS(617),
    [anon_sym_rem] = ACTIONS(617),
    [sym_number_type] = ACTIONS(617),
    [anon_sym_float] = ACTIONS(617),
    [anon_sym_float32] = ACTIONS(617),
    [anon_sym_float64] = ACTIONS(617),
    [anon_sym_uint] = ACTIONS(617),
    [anon_sym_uint8] = ACTIONS(617),
    [anon_sym_uint16] = ACTIONS(617),
    [anon_sym_uint32] = ACTIONS(617),
    [anon_sym_uint64] = ACTIONS(617),
    [anon_sym_uint128] = ACTIONS(617),
    [anon_sym_int] = ACTIONS(617),
    [anon_sym_int8] = ACTIONS(617),
    [anon_sym_int16] = ACTIONS(617),
    [anon_sym_int32] = ACTIONS(617),
    [anon_sym_int64] = ACTIONS(617),
    [anon_sym_int128] = ACTIONS(617),
    [sym_string_type] = ACTIONS(617),
    [sym_bytes_type] = ACTIONS(617),
    [sym_bool_type] = ACTIONS(617),
    [sym_bottom_lit] = ACTIONS(617),
    [sym_null] = ACTIONS(617),
    [sym_true] = ACTIONS(617),
    [sym_false] = ACTIONS(617),
    [sym_int_lit] = ACTIONS(617),
    [sym_float_lit] = ACTIONS(617),
    [anon_sym_LBRACK] = ACTIONS(617),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(617),
    [anon_sym_for] = ACTIONS(617),
    [anon_sym_if] = ACTIONS(617),
    [anon_sym_let] = ACTIONS(617),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_AMP] = ACTIONS(617),
    [anon_sym_PIPE_PIPE] = ACTIONS(617),
    [anon_sym_AMP_AMP] = ACTIONS(617),
    [anon_sym_EQ_EQ] = ACTIONS(617),
    [anon_sym_BANG_EQ] = ACTIONS(617),
    [anon_sym_LT] = ACTIONS(617),
    [anon_sym_LT_EQ] = ACTIONS(617),
    [anon_sym_GT] = ACTIONS(617),
    [anon_sym_GT_EQ] = ACTIONS(617),
    [anon_sym_EQ_TILDE] = ACTIONS(617),
    [anon_sym_BANG_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(617),
    [anon_sym_SLASH] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(617),
    [anon_sym_LBRACK2] = ACTIONS(619),
    [sym_comment] = ACTIONS(530),
  },
  [96] = {
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LF] = ACTIONS(623),
    [anon_sym_COMMA] = ACTIONS(621),
    [anon_sym_LPAREN] = ACTIONS(621),
    [sym_dot] = ACTIONS(621),
    [anon_sym__] = ACTIONS(621),
    [anon_sym_AT] = ACTIONS(621),
    [anon_sym_DQUOTE] = ACTIONS(621),
    [anon_sym_POUND_DQUOTE] = ACTIONS(621),
    [anon_sym_SQUOTE] = ACTIONS(621),
    [anon_sym_POUND_SQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(621),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(621),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(621),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(621),
    [anon_sym_len] = ACTIONS(621),
    [anon_sym_close] = ACTIONS(621),
    [anon_sym_and] = ACTIONS(621),
    [anon_sym_or] = ACTIONS(621),
    [anon_sym_div] = ACTIONS(621),
    [anon_sym_mod] = ACTIONS(621),
    [anon_sym_quo] = ACTIONS(621),
    [anon_sym_rem] = ACTIONS(621),
    [sym_number_type] = ACTIONS(621),
    [anon_sym_float] = ACTIONS(621),
    [anon_sym_float32] = ACTIONS(621),
    [anon_sym_float64] = ACTIONS(621),
    [anon_sym_uint] = ACTIONS(621),
    [anon_sym_uint8] = ACTIONS(621),
    [anon_sym_uint16] = ACTIONS(621),
    [anon_sym_uint32] = ACTIONS(621),
    [anon_sym_uint64] = ACTIONS(621),
    [anon_sym_uint128] = ACTIONS(621),
    [anon_sym_int] = ACTIONS(621),
    [anon_sym_int8] = ACTIONS(621),
    [anon_sym_int16] = ACTIONS(621),
    [anon_sym_int32] = ACTIONS(621),
    [anon_sym_int64] = ACTIONS(621),
    [anon_sym_int128] = ACTIONS(621),
    [sym_string_type] = ACTIONS(621),
    [sym_bytes_type] = ACTIONS(621),
    [sym_bool_type] = ACTIONS(621),
    [sym_bottom_lit] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_int_lit] = ACTIONS(621),
    [sym_float_lit] = ACTIONS(621),
    [anon_sym_LBRACK] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(621),
    [anon_sym_RBRACE] = ACTIONS(621),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(621),
    [anon_sym_for] = ACTIONS(621),
    [anon_sym_if] = ACTIONS(621),
    [anon_sym_let] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(621),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_PIPE_PIPE] = ACTIONS(621),
    [anon_sym_AMP_AMP] = ACTIONS(621),
    [anon_sym_EQ_EQ] = ACTIONS(621),
    [anon_sym_BANG_EQ] = ACTIONS(621),
    [anon_sym_LT] = ACTIONS(621),
    [anon_sym_LT_EQ] = ACTIONS(621),
    [anon_sym_GT] = ACTIONS(621),
    [anon_sym_GT_EQ] = ACTIONS(621),
    [anon_sym_EQ_TILDE] = ACTIONS(621),
    [anon_sym_BANG_TILDE] = ACTIONS(621),
    [anon_sym_PLUS] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(621),
    [anon_sym_STAR] = ACTIONS(621),
    [anon_sym_SLASH] = ACTIONS(621),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_LBRACK2] = ACTIONS(623),
    [sym_comment] = ACTIONS(530),
  },
  [97] = {
    [sym_identifier] = ACTIONS(625),
    [anon_sym_LF] = ACTIONS(627),
    [anon_sym_COMMA] = ACTIONS(625),
    [anon_sym_LPAREN] = ACTIONS(625),
    [sym_dot] = ACTIONS(625),
    [anon_sym__] = ACTIONS(625),
    [anon_sym_AT] = ACTIONS(625),
    [anon_sym_DQUOTE] = ACTIONS(625),
    [anon_sym_POUND_DQUOTE] = ACTIONS(625),
    [anon_sym_SQUOTE] = ACTIONS(625),
    [anon_sym_POUND_SQUOTE] = ACTIONS(625),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(625),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(625),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(625),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(625),
    [anon_sym_len] = ACTIONS(625),
    [anon_sym_close] = ACTIONS(625),
    [anon_sym_and] = ACTIONS(625),
    [anon_sym_or] = ACTIONS(625),
    [anon_sym_div] = ACTIONS(625),
    [anon_sym_mod] = ACTIONS(625),
    [anon_sym_quo] = ACTIONS(625),
    [anon_sym_rem] = ACTIONS(625),
    [sym_number_type] = ACTIONS(625),
    [anon_sym_float] = ACTIONS(625),
    [anon_sym_float32] = ACTIONS(625),
    [anon_sym_float64] = ACTIONS(625),
    [anon_sym_uint] = ACTIONS(625),
    [anon_sym_uint8] = ACTIONS(625),
    [anon_sym_uint16] = ACTIONS(625),
    [anon_sym_uint32] = ACTIONS(625),
    [anon_sym_uint64] = ACTIONS(625),
    [anon_sym_uint128] = ACTIONS(625),
    [anon_sym_int] = ACTIONS(625),
    [anon_sym_int8] = ACTIONS(625),
    [anon_sym_int16] = ACTIONS(625),
    [anon_sym_int32] = ACTIONS(625),
    [anon_sym_int64] = ACTIONS(625),
    [anon_sym_int128] = ACTIONS(625),
    [sym_string_type] = ACTIONS(625),
    [sym_bytes_type] = ACTIONS(625),
    [sym_bool_type] = ACTIONS(625),
    [sym_bottom_lit] = ACTIONS(625),
    [sym_null] = ACTIONS(625),
    [sym_true] = ACTIONS(625),
    [sym_false] = ACTIONS(625),
    [sym_int_lit] = ACTIONS(625),
    [sym_float_lit] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(625),
    [anon_sym_RBRACE] = ACTIONS(625),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [anon_sym_for] = ACTIONS(625),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_let] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(625),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE_PIPE] = ACTIONS(625),
    [anon_sym_AMP_AMP] = ACTIONS(625),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_LT] = ACTIONS(625),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(625),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_EQ_TILDE] = ACTIONS(625),
    [anon_sym_BANG_TILDE] = ACTIONS(625),
    [anon_sym_PLUS] = ACTIONS(625),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_STAR] = ACTIONS(625),
    [anon_sym_SLASH] = ACTIONS(625),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_LBRACK2] = ACTIONS(627),
    [sym_comment] = ACTIONS(530),
  },
  [98] = {
    [sym_identifier] = ACTIONS(629),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_COMMA] = ACTIONS(629),
    [anon_sym_LPAREN] = ACTIONS(629),
    [sym_dot] = ACTIONS(629),
    [anon_sym__] = ACTIONS(629),
    [anon_sym_AT] = ACTIONS(629),
    [anon_sym_DQUOTE] = ACTIONS(629),
    [anon_sym_POUND_DQUOTE] = ACTIONS(629),
    [anon_sym_SQUOTE] = ACTIONS(629),
    [anon_sym_POUND_SQUOTE] = ACTIONS(629),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(629),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(629),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(629),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(629),
    [anon_sym_len] = ACTIONS(629),
    [anon_sym_close] = ACTIONS(629),
    [anon_sym_and] = ACTIONS(629),
    [anon_sym_or] = ACTIONS(629),
    [anon_sym_div] = ACTIONS(629),
    [anon_sym_mod] = ACTIONS(629),
    [anon_sym_quo] = ACTIONS(629),
    [anon_sym_rem] = ACTIONS(629),
    [sym_number_type] = ACTIONS(629),
    [anon_sym_float] = ACTIONS(629),
    [anon_sym_float32] = ACTIONS(629),
    [anon_sym_float64] = ACTIONS(629),
    [anon_sym_uint] = ACTIONS(629),
    [anon_sym_uint8] = ACTIONS(629),
    [anon_sym_uint16] = ACTIONS(629),
    [anon_sym_uint32] = ACTIONS(629),
    [anon_sym_uint64] = ACTIONS(629),
    [anon_sym_uint128] = ACTIONS(629),
    [anon_sym_int] = ACTIONS(629),
    [anon_sym_int8] = ACTIONS(629),
    [anon_sym_int16] = ACTIONS(629),
    [anon_sym_int32] = ACTIONS(629),
    [anon_sym_int64] = ACTIONS(629),
    [anon_sym_int128] = ACTIONS(629),
    [sym_string_type] = ACTIONS(629),
    [sym_bytes_type] = ACTIONS(629),
    [sym_bool_type] = ACTIONS(629),
    [sym_bottom_lit] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_int_lit] = ACTIONS(629),
    [sym_float_lit] = ACTIONS(629),
    [anon_sym_LBRACK] = ACTIONS(629),
    [anon_sym_LBRACE] = ACTIONS(629),
    [anon_sym_RBRACE] = ACTIONS(629),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(629),
    [anon_sym_if] = ACTIONS(629),
    [anon_sym_let] = ACTIONS(629),
    [anon_sym_PIPE] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_PIPE_PIPE] = ACTIONS(629),
    [anon_sym_AMP_AMP] = ACTIONS(629),
    [anon_sym_EQ_EQ] = ACTIONS(629),
    [anon_sym_BANG_EQ] = ACTIONS(629),
    [anon_sym_LT] = ACTIONS(629),
    [anon_sym_LT_EQ] = ACTIONS(629),
    [anon_sym_GT] = ACTIONS(629),
    [anon_sym_GT_EQ] = ACTIONS(629),
    [anon_sym_EQ_TILDE] = ACTIONS(629),
    [anon_sym_BANG_TILDE] = ACTIONS(629),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_STAR] = ACTIONS(629),
    [anon_sym_SLASH] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_LBRACK2] = ACTIONS(631),
    [sym_comment] = ACTIONS(530),
  },
  [99] = {
    [sym_identifier] = ACTIONS(633),
    [anon_sym_LF] = ACTIONS(635),
    [anon_sym_COMMA] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(633),
    [sym_dot] = ACTIONS(633),
    [anon_sym__] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(633),
    [anon_sym_DQUOTE] = ACTIONS(633),
    [anon_sym_POUND_DQUOTE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(633),
    [anon_sym_POUND_SQUOTE] = ACTIONS(633),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(633),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(633),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(633),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(633),
    [anon_sym_len] = ACTIONS(633),
    [anon_sym_close] = ACTIONS(633),
    [anon_sym_and] = ACTIONS(633),
    [anon_sym_or] = ACTIONS(633),
    [anon_sym_div] = ACTIONS(633),
    [anon_sym_mod] = ACTIONS(633),
    [anon_sym_quo] = ACTIONS(633),
    [anon_sym_rem] = ACTIONS(633),
    [sym_number_type] = ACTIONS(633),
    [anon_sym_float] = ACTIONS(633),
    [anon_sym_float32] = ACTIONS(633),
    [anon_sym_float64] = ACTIONS(633),
    [anon_sym_uint] = ACTIONS(633),
    [anon_sym_uint8] = ACTIONS(633),
    [anon_sym_uint16] = ACTIONS(633),
    [anon_sym_uint32] = ACTIONS(633),
    [anon_sym_uint64] = ACTIONS(633),
    [anon_sym_uint128] = ACTIONS(633),
    [anon_sym_int] = ACTIONS(633),
    [anon_sym_int8] = ACTIONS(633),
    [anon_sym_int16] = ACTIONS(633),
    [anon_sym_int32] = ACTIONS(633),
    [anon_sym_int64] = ACTIONS(633),
    [anon_sym_int128] = ACTIONS(633),
    [sym_string_type] = ACTIONS(633),
    [sym_bytes_type] = ACTIONS(633),
    [sym_bool_type] = ACTIONS(633),
    [sym_bottom_lit] = ACTIONS(633),
    [sym_null] = ACTIONS(633),
    [sym_true] = ACTIONS(633),
    [sym_false] = ACTIONS(633),
    [sym_int_lit] = ACTIONS(633),
    [sym_float_lit] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(633),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_RBRACE] = ACTIONS(633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_if] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(633),
    [anon_sym_PIPE] = ACTIONS(633),
    [anon_sym_AMP] = ACTIONS(633),
    [anon_sym_PIPE_PIPE] = ACTIONS(633),
    [anon_sym_AMP_AMP] = ACTIONS(633),
    [anon_sym_EQ_EQ] = ACTIONS(633),
    [anon_sym_BANG_EQ] = ACTIONS(633),
    [anon_sym_LT] = ACTIONS(633),
    [anon_sym_LT_EQ] = ACTIONS(633),
    [anon_sym_GT] = ACTIONS(633),
    [anon_sym_GT_EQ] = ACTIONS(633),
    [anon_sym_EQ_TILDE] = ACTIONS(633),
    [anon_sym_BANG_TILDE] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(633),
    [anon_sym_SLASH] = ACTIONS(633),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LBRACK2] = ACTIONS(635),
    [sym_comment] = ACTIONS(530),
  },
  [100] = {
    [sym_identifier] = ACTIONS(637),
    [anon_sym_LF] = ACTIONS(639),
    [anon_sym_COMMA] = ACTIONS(637),
    [anon_sym_LPAREN] = ACTIONS(637),
    [sym_dot] = ACTIONS(637),
    [anon_sym__] = ACTIONS(637),
    [anon_sym_AT] = ACTIONS(637),
    [anon_sym_DQUOTE] = ACTIONS(637),
    [anon_sym_POUND_DQUOTE] = ACTIONS(637),
    [anon_sym_SQUOTE] = ACTIONS(637),
    [anon_sym_POUND_SQUOTE] = ACTIONS(637),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(637),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(637),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(637),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(637),
    [anon_sym_len] = ACTIONS(637),
    [anon_sym_close] = ACTIONS(637),
    [anon_sym_and] = ACTIONS(637),
    [anon_sym_or] = ACTIONS(637),
    [anon_sym_div] = ACTIONS(637),
    [anon_sym_mod] = ACTIONS(637),
    [anon_sym_quo] = ACTIONS(637),
    [anon_sym_rem] = ACTIONS(637),
    [sym_number_type] = ACTIONS(637),
    [anon_sym_float] = ACTIONS(637),
    [anon_sym_float32] = ACTIONS(637),
    [anon_sym_float64] = ACTIONS(637),
    [anon_sym_uint] = ACTIONS(637),
    [anon_sym_uint8] = ACTIONS(637),
    [anon_sym_uint16] = ACTIONS(637),
    [anon_sym_uint32] = ACTIONS(637),
    [anon_sym_uint64] = ACTIONS(637),
    [anon_sym_uint128] = ACTIONS(637),
    [anon_sym_int] = ACTIONS(637),
    [anon_sym_int8] = ACTIONS(637),
    [anon_sym_int16] = ACTIONS(637),
    [anon_sym_int32] = ACTIONS(637),
    [anon_sym_int64] = ACTIONS(637),
    [anon_sym_int128] = ACTIONS(637),
    [sym_string_type] = ACTIONS(637),
    [sym_bytes_type] = ACTIONS(637),
    [sym_bool_type] = ACTIONS(637),
    [sym_bottom_lit] = ACTIONS(637),
    [sym_null] = ACTIONS(637),
    [sym_true] = ACTIONS(637),
    [sym_false] = ACTIONS(637),
    [sym_int_lit] = ACTIONS(637),
    [sym_float_lit] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_LBRACE] = ACTIONS(637),
    [anon_sym_RBRACE] = ACTIONS(637),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(637),
    [anon_sym_for] = ACTIONS(637),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_let] = ACTIONS(637),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(637),
    [anon_sym_PIPE_PIPE] = ACTIONS(637),
    [anon_sym_AMP_AMP] = ACTIONS(637),
    [anon_sym_EQ_EQ] = ACTIONS(637),
    [anon_sym_BANG_EQ] = ACTIONS(637),
    [anon_sym_LT] = ACTIONS(637),
    [anon_sym_LT_EQ] = ACTIONS(637),
    [anon_sym_GT] = ACTIONS(637),
    [anon_sym_GT_EQ] = ACTIONS(637),
    [anon_sym_EQ_TILDE] = ACTIONS(637),
    [anon_sym_BANG_TILDE] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_STAR] = ACTIONS(637),
    [anon_sym_SLASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(637),
    [anon_sym_LBRACK2] = ACTIONS(639),
    [sym_comment] = ACTIONS(530),
  },
  [101] = {
    [sym_identifier] = ACTIONS(641),
    [anon_sym_LF] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(641),
    [anon_sym_LPAREN] = ACTIONS(641),
    [sym_dot] = ACTIONS(641),
    [anon_sym__] = ACTIONS(641),
    [anon_sym_AT] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [anon_sym_POUND_DQUOTE] = ACTIONS(641),
    [anon_sym_SQUOTE] = ACTIONS(641),
    [anon_sym_POUND_SQUOTE] = ACTIONS(641),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(641),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(641),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(641),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(641),
    [anon_sym_len] = ACTIONS(641),
    [anon_sym_close] = ACTIONS(641),
    [anon_sym_and] = ACTIONS(641),
    [anon_sym_or] = ACTIONS(641),
    [anon_sym_div] = ACTIONS(641),
    [anon_sym_mod] = ACTIONS(641),
    [anon_sym_quo] = ACTIONS(641),
    [anon_sym_rem] = ACTIONS(641),
    [sym_number_type] = ACTIONS(641),
    [anon_sym_float] = ACTIONS(641),
    [anon_sym_float32] = ACTIONS(641),
    [anon_sym_float64] = ACTIONS(641),
    [anon_sym_uint] = ACTIONS(641),
    [anon_sym_uint8] = ACTIONS(641),
    [anon_sym_uint16] = ACTIONS(641),
    [anon_sym_uint32] = ACTIONS(641),
    [anon_sym_uint64] = ACTIONS(641),
    [anon_sym_uint128] = ACTIONS(641),
    [anon_sym_int] = ACTIONS(641),
    [anon_sym_int8] = ACTIONS(641),
    [anon_sym_int16] = ACTIONS(641),
    [anon_sym_int32] = ACTIONS(641),
    [anon_sym_int64] = ACTIONS(641),
    [anon_sym_int128] = ACTIONS(641),
    [sym_string_type] = ACTIONS(641),
    [sym_bytes_type] = ACTIONS(641),
    [sym_bool_type] = ACTIONS(641),
    [sym_bottom_lit] = ACTIONS(641),
    [sym_null] = ACTIONS(641),
    [sym_true] = ACTIONS(641),
    [sym_false] = ACTIONS(641),
    [sym_int_lit] = ACTIONS(641),
    [sym_float_lit] = ACTIONS(641),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(641),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(641),
    [anon_sym_let] = ACTIONS(641),
    [anon_sym_PIPE] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(641),
    [anon_sym_PIPE_PIPE] = ACTIONS(641),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [anon_sym_EQ_EQ] = ACTIONS(641),
    [anon_sym_BANG_EQ] = ACTIONS(641),
    [anon_sym_LT] = ACTIONS(641),
    [anon_sym_LT_EQ] = ACTIONS(641),
    [anon_sym_GT] = ACTIONS(641),
    [anon_sym_GT_EQ] = ACTIONS(641),
    [anon_sym_EQ_TILDE] = ACTIONS(641),
    [anon_sym_BANG_TILDE] = ACTIONS(641),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_DASH] = ACTIONS(641),
    [anon_sym_STAR] = ACTIONS(641),
    [anon_sym_SLASH] = ACTIONS(641),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_LBRACK2] = ACTIONS(643),
    [sym_comment] = ACTIONS(530),
  },
  [102] = {
    [sym_identifier] = ACTIONS(645),
    [anon_sym_LF] = ACTIONS(647),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(645),
    [sym_dot] = ACTIONS(645),
    [anon_sym__] = ACTIONS(645),
    [anon_sym_AT] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(645),
    [anon_sym_POUND_DQUOTE] = ACTIONS(645),
    [anon_sym_SQUOTE] = ACTIONS(645),
    [anon_sym_POUND_SQUOTE] = ACTIONS(645),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(645),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(645),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(645),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(645),
    [anon_sym_len] = ACTIONS(645),
    [anon_sym_close] = ACTIONS(645),
    [anon_sym_and] = ACTIONS(645),
    [anon_sym_or] = ACTIONS(645),
    [anon_sym_div] = ACTIONS(645),
    [anon_sym_mod] = ACTIONS(645),
    [anon_sym_quo] = ACTIONS(645),
    [anon_sym_rem] = ACTIONS(645),
    [sym_number_type] = ACTIONS(645),
    [anon_sym_float] = ACTIONS(645),
    [anon_sym_float32] = ACTIONS(645),
    [anon_sym_float64] = ACTIONS(645),
    [anon_sym_uint] = ACTIONS(645),
    [anon_sym_uint8] = ACTIONS(645),
    [anon_sym_uint16] = ACTIONS(645),
    [anon_sym_uint32] = ACTIONS(645),
    [anon_sym_uint64] = ACTIONS(645),
    [anon_sym_uint128] = ACTIONS(645),
    [anon_sym_int] = ACTIONS(645),
    [anon_sym_int8] = ACTIONS(645),
    [anon_sym_int16] = ACTIONS(645),
    [anon_sym_int32] = ACTIONS(645),
    [anon_sym_int64] = ACTIONS(645),
    [anon_sym_int128] = ACTIONS(645),
    [sym_string_type] = ACTIONS(645),
    [sym_bytes_type] = ACTIONS(645),
    [sym_bool_type] = ACTIONS(645),
    [sym_bottom_lit] = ACTIONS(645),
    [sym_null] = ACTIONS(645),
    [sym_true] = ACTIONS(645),
    [sym_false] = ACTIONS(645),
    [sym_int_lit] = ACTIONS(645),
    [sym_float_lit] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_RBRACE] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_for] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(645),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_PIPE] = ACTIONS(645),
    [anon_sym_AMP] = ACTIONS(645),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(645),
    [anon_sym_LT_EQ] = ACTIONS(645),
    [anon_sym_GT] = ACTIONS(645),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(645),
    [anon_sym_STAR] = ACTIONS(645),
    [anon_sym_SLASH] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(647),
    [sym_comment] = ACTIONS(530),
  },
  [103] = {
    [sym_identifier] = ACTIONS(649),
    [anon_sym_LF] = ACTIONS(651),
    [anon_sym_COMMA] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(649),
    [sym_dot] = ACTIONS(649),
    [anon_sym__] = ACTIONS(649),
    [anon_sym_AT] = ACTIONS(649),
    [anon_sym_DQUOTE] = ACTIONS(649),
    [anon_sym_POUND_DQUOTE] = ACTIONS(649),
    [anon_sym_SQUOTE] = ACTIONS(649),
    [anon_sym_POUND_SQUOTE] = ACTIONS(649),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(649),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(649),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(649),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(649),
    [anon_sym_len] = ACTIONS(649),
    [anon_sym_close] = ACTIONS(649),
    [anon_sym_and] = ACTIONS(649),
    [anon_sym_or] = ACTIONS(649),
    [anon_sym_div] = ACTIONS(649),
    [anon_sym_mod] = ACTIONS(649),
    [anon_sym_quo] = ACTIONS(649),
    [anon_sym_rem] = ACTIONS(649),
    [sym_number_type] = ACTIONS(649),
    [anon_sym_float] = ACTIONS(649),
    [anon_sym_float32] = ACTIONS(649),
    [anon_sym_float64] = ACTIONS(649),
    [anon_sym_uint] = ACTIONS(649),
    [anon_sym_uint8] = ACTIONS(649),
    [anon_sym_uint16] = ACTIONS(649),
    [anon_sym_uint32] = ACTIONS(649),
    [anon_sym_uint64] = ACTIONS(649),
    [anon_sym_uint128] = ACTIONS(649),
    [anon_sym_int] = ACTIONS(649),
    [anon_sym_int8] = ACTIONS(649),
    [anon_sym_int16] = ACTIONS(649),
    [anon_sym_int32] = ACTIONS(649),
    [anon_sym_int64] = ACTIONS(649),
    [anon_sym_int128] = ACTIONS(649),
    [sym_string_type] = ACTIONS(649),
    [sym_bytes_type] = ACTIONS(649),
    [sym_bool_type] = ACTIONS(649),
    [sym_bottom_lit] = ACTIONS(649),
    [sym_null] = ACTIONS(649),
    [sym_true] = ACTIONS(649),
    [sym_false] = ACTIONS(649),
    [sym_int_lit] = ACTIONS(649),
    [sym_float_lit] = ACTIONS(649),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LBRACE] = ACTIONS(649),
    [anon_sym_RBRACE] = ACTIONS(649),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(649),
    [anon_sym_if] = ACTIONS(649),
    [anon_sym_let] = ACTIONS(649),
    [anon_sym_PIPE] = ACTIONS(649),
    [anon_sym_AMP] = ACTIONS(649),
    [anon_sym_PIPE_PIPE] = ACTIONS(649),
    [anon_sym_AMP_AMP] = ACTIONS(649),
    [anon_sym_EQ_EQ] = ACTIONS(649),
    [anon_sym_BANG_EQ] = ACTIONS(649),
    [anon_sym_LT] = ACTIONS(649),
    [anon_sym_LT_EQ] = ACTIONS(649),
    [anon_sym_GT] = ACTIONS(649),
    [anon_sym_GT_EQ] = ACTIONS(649),
    [anon_sym_EQ_TILDE] = ACTIONS(649),
    [anon_sym_BANG_TILDE] = ACTIONS(649),
    [anon_sym_PLUS] = ACTIONS(649),
    [anon_sym_DASH] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(649),
    [anon_sym_SLASH] = ACTIONS(649),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_LBRACK2] = ACTIONS(651),
    [sym_comment] = ACTIONS(530),
  },
  [104] = {
    [sym_identifier] = ACTIONS(653),
    [anon_sym_LF] = ACTIONS(655),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_dot] = ACTIONS(653),
    [anon_sym__] = ACTIONS(653),
    [anon_sym_AT] = ACTIONS(653),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_POUND_DQUOTE] = ACTIONS(653),
    [anon_sym_SQUOTE] = ACTIONS(653),
    [anon_sym_POUND_SQUOTE] = ACTIONS(653),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(653),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(653),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(653),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(653),
    [anon_sym_len] = ACTIONS(653),
    [anon_sym_close] = ACTIONS(653),
    [anon_sym_and] = ACTIONS(653),
    [anon_sym_or] = ACTIONS(653),
    [anon_sym_div] = ACTIONS(653),
    [anon_sym_mod] = ACTIONS(653),
    [anon_sym_quo] = ACTIONS(653),
    [anon_sym_rem] = ACTIONS(653),
    [sym_number_type] = ACTIONS(653),
    [anon_sym_float] = ACTIONS(653),
    [anon_sym_float32] = ACTIONS(653),
    [anon_sym_float64] = ACTIONS(653),
    [anon_sym_uint] = ACTIONS(653),
    [anon_sym_uint8] = ACTIONS(653),
    [anon_sym_uint16] = ACTIONS(653),
    [anon_sym_uint32] = ACTIONS(653),
    [anon_sym_uint64] = ACTIONS(653),
    [anon_sym_uint128] = ACTIONS(653),
    [anon_sym_int] = ACTIONS(653),
    [anon_sym_int8] = ACTIONS(653),
    [anon_sym_int16] = ACTIONS(653),
    [anon_sym_int32] = ACTIONS(653),
    [anon_sym_int64] = ACTIONS(653),
    [anon_sym_int128] = ACTIONS(653),
    [sym_string_type] = ACTIONS(653),
    [sym_bytes_type] = ACTIONS(653),
    [sym_bool_type] = ACTIONS(653),
    [sym_bottom_lit] = ACTIONS(653),
    [sym_null] = ACTIONS(653),
    [sym_true] = ACTIONS(653),
    [sym_false] = ACTIONS(653),
    [sym_int_lit] = ACTIONS(653),
    [sym_float_lit] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_LBRACE] = ACTIONS(653),
    [anon_sym_RBRACE] = ACTIONS(653),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(653),
    [anon_sym_for] = ACTIONS(653),
    [anon_sym_if] = ACTIONS(653),
    [anon_sym_let] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(653),
    [anon_sym_PIPE_PIPE] = ACTIONS(653),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_EQ_EQ] = ACTIONS(653),
    [anon_sym_BANG_EQ] = ACTIONS(653),
    [anon_sym_LT] = ACTIONS(653),
    [anon_sym_LT_EQ] = ACTIONS(653),
    [anon_sym_GT] = ACTIONS(653),
    [anon_sym_GT_EQ] = ACTIONS(653),
    [anon_sym_EQ_TILDE] = ACTIONS(653),
    [anon_sym_BANG_TILDE] = ACTIONS(653),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_SLASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(653),
    [anon_sym_LBRACK2] = ACTIONS(655),
    [sym_comment] = ACTIONS(530),
  },
  [105] = {
    [sym_identifier] = ACTIONS(657),
    [anon_sym_LF] = ACTIONS(659),
    [anon_sym_COMMA] = ACTIONS(657),
    [anon_sym_LPAREN] = ACTIONS(657),
    [sym_dot] = ACTIONS(657),
    [anon_sym__] = ACTIONS(657),
    [anon_sym_AT] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(657),
    [anon_sym_POUND_DQUOTE] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_POUND_SQUOTE] = ACTIONS(657),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(657),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(657),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(657),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(657),
    [anon_sym_len] = ACTIONS(657),
    [anon_sym_close] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(657),
    [anon_sym_or] = ACTIONS(657),
    [anon_sym_div] = ACTIONS(657),
    [anon_sym_mod] = ACTIONS(657),
    [anon_sym_quo] = ACTIONS(657),
    [anon_sym_rem] = ACTIONS(657),
    [sym_number_type] = ACTIONS(657),
    [anon_sym_float] = ACTIONS(657),
    [anon_sym_float32] = ACTIONS(657),
    [anon_sym_float64] = ACTIONS(657),
    [anon_sym_uint] = ACTIONS(657),
    [anon_sym_uint8] = ACTIONS(657),
    [anon_sym_uint16] = ACTIONS(657),
    [anon_sym_uint32] = ACTIONS(657),
    [anon_sym_uint64] = ACTIONS(657),
    [anon_sym_uint128] = ACTIONS(657),
    [anon_sym_int] = ACTIONS(657),
    [anon_sym_int8] = ACTIONS(657),
    [anon_sym_int16] = ACTIONS(657),
    [anon_sym_int32] = ACTIONS(657),
    [anon_sym_int64] = ACTIONS(657),
    [anon_sym_int128] = ACTIONS(657),
    [sym_string_type] = ACTIONS(657),
    [sym_bytes_type] = ACTIONS(657),
    [sym_bool_type] = ACTIONS(657),
    [sym_bottom_lit] = ACTIONS(657),
    [sym_null] = ACTIONS(657),
    [sym_true] = ACTIONS(657),
    [sym_false] = ACTIONS(657),
    [sym_int_lit] = ACTIONS(657),
    [sym_float_lit] = ACTIONS(657),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(657),
    [anon_sym_RBRACE] = ACTIONS(657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(657),
    [anon_sym_for] = ACTIONS(657),
    [anon_sym_if] = ACTIONS(657),
    [anon_sym_let] = ACTIONS(657),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(657),
    [anon_sym_AMP_AMP] = ACTIONS(657),
    [anon_sym_EQ_EQ] = ACTIONS(657),
    [anon_sym_BANG_EQ] = ACTIONS(657),
    [anon_sym_LT] = ACTIONS(657),
    [anon_sym_LT_EQ] = ACTIONS(657),
    [anon_sym_GT] = ACTIONS(657),
    [anon_sym_GT_EQ] = ACTIONS(657),
    [anon_sym_EQ_TILDE] = ACTIONS(657),
    [anon_sym_BANG_TILDE] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(657),
    [anon_sym_DASH] = ACTIONS(657),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_SLASH] = ACTIONS(657),
    [anon_sym_BANG] = ACTIONS(657),
    [anon_sym_LBRACK2] = ACTIONS(659),
    [sym_comment] = ACTIONS(530),
  },
  [106] = {
    [sym_identifier] = ACTIONS(661),
    [anon_sym_LF] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(661),
    [sym_dot] = ACTIONS(661),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_AT] = ACTIONS(661),
    [anon_sym_DQUOTE] = ACTIONS(661),
    [anon_sym_POUND_DQUOTE] = ACTIONS(661),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_POUND_SQUOTE] = ACTIONS(661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(661),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_len] = ACTIONS(661),
    [anon_sym_close] = ACTIONS(661),
    [anon_sym_and] = ACTIONS(661),
    [anon_sym_or] = ACTIONS(661),
    [anon_sym_div] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_quo] = ACTIONS(661),
    [anon_sym_rem] = ACTIONS(661),
    [sym_number_type] = ACTIONS(661),
    [anon_sym_float] = ACTIONS(661),
    [anon_sym_float32] = ACTIONS(661),
    [anon_sym_float64] = ACTIONS(661),
    [anon_sym_uint] = ACTIONS(661),
    [anon_sym_uint8] = ACTIONS(661),
    [anon_sym_uint16] = ACTIONS(661),
    [anon_sym_uint32] = ACTIONS(661),
    [anon_sym_uint64] = ACTIONS(661),
    [anon_sym_uint128] = ACTIONS(661),
    [anon_sym_int] = ACTIONS(661),
    [anon_sym_int8] = ACTIONS(661),
    [anon_sym_int16] = ACTIONS(661),
    [anon_sym_int32] = ACTIONS(661),
    [anon_sym_int64] = ACTIONS(661),
    [anon_sym_int128] = ACTIONS(661),
    [sym_string_type] = ACTIONS(661),
    [sym_bytes_type] = ACTIONS(661),
    [sym_bool_type] = ACTIONS(661),
    [sym_bottom_lit] = ACTIONS(661),
    [sym_null] = ACTIONS(661),
    [sym_true] = ACTIONS(661),
    [sym_false] = ACTIONS(661),
    [sym_int_lit] = ACTIONS(661),
    [sym_float_lit] = ACTIONS(661),
    [anon_sym_LBRACK] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(661),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_PIPE] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_EQ_EQ] = ACTIONS(661),
    [anon_sym_BANG_EQ] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(661),
    [anon_sym_LT_EQ] = ACTIONS(661),
    [anon_sym_GT] = ACTIONS(661),
    [anon_sym_GT_EQ] = ACTIONS(661),
    [anon_sym_EQ_TILDE] = ACTIONS(661),
    [anon_sym_BANG_TILDE] = ACTIONS(661),
    [anon_sym_PLUS] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(661),
    [anon_sym_STAR] = ACTIONS(661),
    [anon_sym_SLASH] = ACTIONS(661),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [sym_comment] = ACTIONS(530),
  },
  [107] = {
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(667),
    [anon_sym_COMMA] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(665),
    [sym_dot] = ACTIONS(665),
    [anon_sym__] = ACTIONS(665),
    [anon_sym_AT] = ACTIONS(665),
    [anon_sym_DQUOTE] = ACTIONS(665),
    [anon_sym_POUND_DQUOTE] = ACTIONS(665),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [anon_sym_POUND_SQUOTE] = ACTIONS(665),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(665),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(665),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(665),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(665),
    [anon_sym_len] = ACTIONS(665),
    [anon_sym_close] = ACTIONS(665),
    [anon_sym_and] = ACTIONS(665),
    [anon_sym_or] = ACTIONS(665),
    [anon_sym_div] = ACTIONS(665),
    [anon_sym_mod] = ACTIONS(665),
    [anon_sym_quo] = ACTIONS(665),
    [anon_sym_rem] = ACTIONS(665),
    [sym_number_type] = ACTIONS(665),
    [anon_sym_float] = ACTIONS(665),
    [anon_sym_float32] = ACTIONS(665),
    [anon_sym_float64] = ACTIONS(665),
    [anon_sym_uint] = ACTIONS(665),
    [anon_sym_uint8] = ACTIONS(665),
    [anon_sym_uint16] = ACTIONS(665),
    [anon_sym_uint32] = ACTIONS(665),
    [anon_sym_uint64] = ACTIONS(665),
    [anon_sym_uint128] = ACTIONS(665),
    [anon_sym_int] = ACTIONS(665),
    [anon_sym_int8] = ACTIONS(665),
    [anon_sym_int16] = ACTIONS(665),
    [anon_sym_int32] = ACTIONS(665),
    [anon_sym_int64] = ACTIONS(665),
    [anon_sym_int128] = ACTIONS(665),
    [sym_string_type] = ACTIONS(665),
    [sym_bytes_type] = ACTIONS(665),
    [sym_bool_type] = ACTIONS(665),
    [sym_bottom_lit] = ACTIONS(665),
    [sym_null] = ACTIONS(665),
    [sym_true] = ACTIONS(665),
    [sym_false] = ACTIONS(665),
    [sym_int_lit] = ACTIONS(665),
    [sym_float_lit] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(665),
    [anon_sym_RBRACE] = ACTIONS(665),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(665),
    [anon_sym_for] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_let] = ACTIONS(665),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_AMP] = ACTIONS(665),
    [anon_sym_PIPE_PIPE] = ACTIONS(665),
    [anon_sym_AMP_AMP] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_TILDE] = ACTIONS(665),
    [anon_sym_BANG_TILDE] = ACTIONS(665),
    [anon_sym_PLUS] = ACTIONS(665),
    [anon_sym_DASH] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(665),
    [anon_sym_SLASH] = ACTIONS(665),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LBRACK2] = ACTIONS(667),
    [sym_comment] = ACTIONS(530),
  },
  [108] = {
    [sym_identifier] = ACTIONS(669),
    [anon_sym_LF] = ACTIONS(671),
    [anon_sym_COMMA] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(669),
    [sym_dot] = ACTIONS(669),
    [anon_sym__] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_DQUOTE] = ACTIONS(669),
    [anon_sym_POUND_DQUOTE] = ACTIONS(669),
    [anon_sym_SQUOTE] = ACTIONS(669),
    [anon_sym_POUND_SQUOTE] = ACTIONS(669),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(669),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(669),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(669),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(669),
    [anon_sym_len] = ACTIONS(669),
    [anon_sym_close] = ACTIONS(669),
    [anon_sym_and] = ACTIONS(669),
    [anon_sym_or] = ACTIONS(669),
    [anon_sym_div] = ACTIONS(669),
    [anon_sym_mod] = ACTIONS(669),
    [anon_sym_quo] = ACTIONS(669),
    [anon_sym_rem] = ACTIONS(669),
    [sym_number_type] = ACTIONS(669),
    [anon_sym_float] = ACTIONS(669),
    [anon_sym_float32] = ACTIONS(669),
    [anon_sym_float64] = ACTIONS(669),
    [anon_sym_uint] = ACTIONS(669),
    [anon_sym_uint8] = ACTIONS(669),
    [anon_sym_uint16] = ACTIONS(669),
    [anon_sym_uint32] = ACTIONS(669),
    [anon_sym_uint64] = ACTIONS(669),
    [anon_sym_uint128] = ACTIONS(669),
    [anon_sym_int] = ACTIONS(669),
    [anon_sym_int8] = ACTIONS(669),
    [anon_sym_int16] = ACTIONS(669),
    [anon_sym_int32] = ACTIONS(669),
    [anon_sym_int64] = ACTIONS(669),
    [anon_sym_int128] = ACTIONS(669),
    [sym_string_type] = ACTIONS(669),
    [sym_bytes_type] = ACTIONS(669),
    [sym_bool_type] = ACTIONS(669),
    [sym_bottom_lit] = ACTIONS(669),
    [sym_null] = ACTIONS(669),
    [sym_true] = ACTIONS(669),
    [sym_false] = ACTIONS(669),
    [sym_int_lit] = ACTIONS(669),
    [sym_float_lit] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_RBRACE] = ACTIONS(669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(669),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_if] = ACTIONS(669),
    [anon_sym_let] = ACTIONS(669),
    [anon_sym_PIPE] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_PIPE_PIPE] = ACTIONS(669),
    [anon_sym_AMP_AMP] = ACTIONS(669),
    [anon_sym_EQ_EQ] = ACTIONS(669),
    [anon_sym_BANG_EQ] = ACTIONS(669),
    [anon_sym_LT] = ACTIONS(669),
    [anon_sym_LT_EQ] = ACTIONS(669),
    [anon_sym_GT] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(669),
    [anon_sym_EQ_TILDE] = ACTIONS(669),
    [anon_sym_BANG_TILDE] = ACTIONS(669),
    [anon_sym_PLUS] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_LBRACK2] = ACTIONS(671),
    [sym_comment] = ACTIONS(530),
  },
  [109] = {
    [sym_identifier] = ACTIONS(673),
    [anon_sym_LF] = ACTIONS(675),
    [anon_sym_COMMA] = ACTIONS(673),
    [anon_sym_LPAREN] = ACTIONS(673),
    [sym_dot] = ACTIONS(673),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_POUND_DQUOTE] = ACTIONS(673),
    [anon_sym_SQUOTE] = ACTIONS(673),
    [anon_sym_POUND_SQUOTE] = ACTIONS(673),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(673),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(673),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(673),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(673),
    [anon_sym_len] = ACTIONS(673),
    [anon_sym_close] = ACTIONS(673),
    [anon_sym_and] = ACTIONS(673),
    [anon_sym_or] = ACTIONS(673),
    [anon_sym_div] = ACTIONS(673),
    [anon_sym_mod] = ACTIONS(673),
    [anon_sym_quo] = ACTIONS(673),
    [anon_sym_rem] = ACTIONS(673),
    [sym_number_type] = ACTIONS(673),
    [anon_sym_float] = ACTIONS(673),
    [anon_sym_float32] = ACTIONS(673),
    [anon_sym_float64] = ACTIONS(673),
    [anon_sym_uint] = ACTIONS(673),
    [anon_sym_uint8] = ACTIONS(673),
    [anon_sym_uint16] = ACTIONS(673),
    [anon_sym_uint32] = ACTIONS(673),
    [anon_sym_uint64] = ACTIONS(673),
    [anon_sym_uint128] = ACTIONS(673),
    [anon_sym_int] = ACTIONS(673),
    [anon_sym_int8] = ACTIONS(673),
    [anon_sym_int16] = ACTIONS(673),
    [anon_sym_int32] = ACTIONS(673),
    [anon_sym_int64] = ACTIONS(673),
    [anon_sym_int128] = ACTIONS(673),
    [sym_string_type] = ACTIONS(673),
    [sym_bytes_type] = ACTIONS(673),
    [sym_bool_type] = ACTIONS(673),
    [sym_bottom_lit] = ACTIONS(673),
    [sym_null] = ACTIONS(673),
    [sym_true] = ACTIONS(673),
    [sym_false] = ACTIONS(673),
    [sym_int_lit] = ACTIONS(673),
    [sym_float_lit] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(673),
    [anon_sym_LBRACE] = ACTIONS(673),
    [anon_sym_RBRACE] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(673),
    [anon_sym_if] = ACTIONS(673),
    [anon_sym_let] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(673),
    [anon_sym_BANG_EQ] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_LT_EQ] = ACTIONS(673),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(673),
    [anon_sym_EQ_TILDE] = ACTIONS(673),
    [anon_sym_BANG_TILDE] = ACTIONS(673),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_LBRACK2] = ACTIONS(675),
    [sym_comment] = ACTIONS(530),
  },
  [110] = {
    [sym_identifier] = ACTIONS(677),
    [anon_sym_LF] = ACTIONS(679),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(677),
    [sym_dot] = ACTIONS(677),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(677),
    [anon_sym_POUND_DQUOTE] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(677),
    [anon_sym_POUND_SQUOTE] = ACTIONS(677),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(677),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(677),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(677),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(677),
    [anon_sym_len] = ACTIONS(677),
    [anon_sym_close] = ACTIONS(677),
    [anon_sym_and] = ACTIONS(677),
    [anon_sym_or] = ACTIONS(677),
    [anon_sym_div] = ACTIONS(677),
    [anon_sym_mod] = ACTIONS(677),
    [anon_sym_quo] = ACTIONS(677),
    [anon_sym_rem] = ACTIONS(677),
    [sym_number_type] = ACTIONS(677),
    [anon_sym_float] = ACTIONS(677),
    [anon_sym_float32] = ACTIONS(677),
    [anon_sym_float64] = ACTIONS(677),
    [anon_sym_uint] = ACTIONS(677),
    [anon_sym_uint8] = ACTIONS(677),
    [anon_sym_uint16] = ACTIONS(677),
    [anon_sym_uint32] = ACTIONS(677),
    [anon_sym_uint64] = ACTIONS(677),
    [anon_sym_uint128] = ACTIONS(677),
    [anon_sym_int] = ACTIONS(677),
    [anon_sym_int8] = ACTIONS(677),
    [anon_sym_int16] = ACTIONS(677),
    [anon_sym_int32] = ACTIONS(677),
    [anon_sym_int64] = ACTIONS(677),
    [anon_sym_int128] = ACTIONS(677),
    [sym_string_type] = ACTIONS(677),
    [sym_bytes_type] = ACTIONS(677),
    [sym_bool_type] = ACTIONS(677),
    [sym_bottom_lit] = ACTIONS(677),
    [sym_null] = ACTIONS(677),
    [sym_true] = ACTIONS(677),
    [sym_false] = ACTIONS(677),
    [sym_int_lit] = ACTIONS(677),
    [sym_float_lit] = ACTIONS(677),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(677),
    [anon_sym_RBRACE] = ACTIONS(677),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(677),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_if] = ACTIONS(677),
    [anon_sym_let] = ACTIONS(677),
    [anon_sym_PIPE] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_EQ_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(677),
    [anon_sym_GT_EQ] = ACTIONS(677),
    [anon_sym_EQ_TILDE] = ACTIONS(677),
    [anon_sym_BANG_TILDE] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(677),
    [anon_sym_DASH] = ACTIONS(677),
    [anon_sym_STAR] = ACTIONS(677),
    [anon_sym_SLASH] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_LBRACK2] = ACTIONS(679),
    [sym_comment] = ACTIONS(530),
  },
  [111] = {
    [sym_identifier] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_dot] = ACTIONS(681),
    [anon_sym__] = ACTIONS(681),
    [anon_sym_AT] = ACTIONS(681),
    [anon_sym_DQUOTE] = ACTIONS(681),
    [anon_sym_POUND_DQUOTE] = ACTIONS(681),
    [anon_sym_SQUOTE] = ACTIONS(681),
    [anon_sym_POUND_SQUOTE] = ACTIONS(681),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(681),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(681),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(681),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(681),
    [anon_sym_len] = ACTIONS(681),
    [anon_sym_close] = ACTIONS(681),
    [anon_sym_and] = ACTIONS(681),
    [anon_sym_or] = ACTIONS(681),
    [anon_sym_div] = ACTIONS(681),
    [anon_sym_mod] = ACTIONS(681),
    [anon_sym_quo] = ACTIONS(681),
    [anon_sym_rem] = ACTIONS(681),
    [sym_number_type] = ACTIONS(681),
    [anon_sym_float] = ACTIONS(681),
    [anon_sym_float32] = ACTIONS(681),
    [anon_sym_float64] = ACTIONS(681),
    [anon_sym_uint] = ACTIONS(681),
    [anon_sym_uint8] = ACTIONS(681),
    [anon_sym_uint16] = ACTIONS(681),
    [anon_sym_uint32] = ACTIONS(681),
    [anon_sym_uint64] = ACTIONS(681),
    [anon_sym_uint128] = ACTIONS(681),
    [anon_sym_int] = ACTIONS(681),
    [anon_sym_int8] = ACTIONS(681),
    [anon_sym_int16] = ACTIONS(681),
    [anon_sym_int32] = ACTIONS(681),
    [anon_sym_int64] = ACTIONS(681),
    [anon_sym_int128] = ACTIONS(681),
    [sym_string_type] = ACTIONS(681),
    [sym_bytes_type] = ACTIONS(681),
    [sym_bool_type] = ACTIONS(681),
    [sym_bottom_lit] = ACTIONS(681),
    [sym_null] = ACTIONS(681),
    [sym_true] = ACTIONS(681),
    [sym_false] = ACTIONS(681),
    [sym_int_lit] = ACTIONS(681),
    [sym_float_lit] = ACTIONS(681),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_LBRACE] = ACTIONS(681),
    [anon_sym_RBRACE] = ACTIONS(681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(681),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_if] = ACTIONS(681),
    [anon_sym_let] = ACTIONS(681),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_AMP] = ACTIONS(681),
    [anon_sym_PIPE_PIPE] = ACTIONS(681),
    [anon_sym_AMP_AMP] = ACTIONS(681),
    [anon_sym_EQ_EQ] = ACTIONS(681),
    [anon_sym_BANG_EQ] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_LT_EQ] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(681),
    [anon_sym_GT_EQ] = ACTIONS(681),
    [anon_sym_EQ_TILDE] = ACTIONS(681),
    [anon_sym_BANG_TILDE] = ACTIONS(681),
    [anon_sym_PLUS] = ACTIONS(681),
    [anon_sym_DASH] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(681),
    [anon_sym_SLASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(681),
    [anon_sym_LBRACK2] = ACTIONS(683),
    [sym_comment] = ACTIONS(530),
  },
  [112] = {
    [sym_identifier] = ACTIONS(685),
    [anon_sym_LF] = ACTIONS(687),
    [anon_sym_COMMA] = ACTIONS(685),
    [anon_sym_LPAREN] = ACTIONS(685),
    [sym_dot] = ACTIONS(685),
    [anon_sym__] = ACTIONS(685),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_POUND_DQUOTE] = ACTIONS(685),
    [anon_sym_SQUOTE] = ACTIONS(685),
    [anon_sym_POUND_SQUOTE] = ACTIONS(685),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(685),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(685),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(685),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(685),
    [anon_sym_len] = ACTIONS(685),
    [anon_sym_close] = ACTIONS(685),
    [anon_sym_and] = ACTIONS(685),
    [anon_sym_or] = ACTIONS(685),
    [anon_sym_div] = ACTIONS(685),
    [anon_sym_mod] = ACTIONS(685),
    [anon_sym_quo] = ACTIONS(685),
    [anon_sym_rem] = ACTIONS(685),
    [sym_number_type] = ACTIONS(685),
    [anon_sym_float] = ACTIONS(685),
    [anon_sym_float32] = ACTIONS(685),
    [anon_sym_float64] = ACTIONS(685),
    [anon_sym_uint] = ACTIONS(685),
    [anon_sym_uint8] = ACTIONS(685),
    [anon_sym_uint16] = ACTIONS(685),
    [anon_sym_uint32] = ACTIONS(685),
    [anon_sym_uint64] = ACTIONS(685),
    [anon_sym_uint128] = ACTIONS(685),
    [anon_sym_int] = ACTIONS(685),
    [anon_sym_int8] = ACTIONS(685),
    [anon_sym_int16] = ACTIONS(685),
    [anon_sym_int32] = ACTIONS(685),
    [anon_sym_int64] = ACTIONS(685),
    [anon_sym_int128] = ACTIONS(685),
    [sym_string_type] = ACTIONS(685),
    [sym_bytes_type] = ACTIONS(685),
    [sym_bool_type] = ACTIONS(685),
    [sym_bottom_lit] = ACTIONS(685),
    [sym_null] = ACTIONS(685),
    [sym_true] = ACTIONS(685),
    [sym_false] = ACTIONS(685),
    [sym_int_lit] = ACTIONS(685),
    [sym_float_lit] = ACTIONS(685),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(685),
    [anon_sym_RBRACE] = ACTIONS(685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(685),
    [anon_sym_for] = ACTIONS(685),
    [anon_sym_if] = ACTIONS(685),
    [anon_sym_let] = ACTIONS(685),
    [anon_sym_PIPE] = ACTIONS(685),
    [anon_sym_AMP] = ACTIONS(685),
    [anon_sym_PIPE_PIPE] = ACTIONS(685),
    [anon_sym_AMP_AMP] = ACTIONS(685),
    [anon_sym_EQ_EQ] = ACTIONS(685),
    [anon_sym_BANG_EQ] = ACTIONS(685),
    [anon_sym_LT] = ACTIONS(685),
    [anon_sym_LT_EQ] = ACTIONS(685),
    [anon_sym_GT] = ACTIONS(685),
    [anon_sym_GT_EQ] = ACTIONS(685),
    [anon_sym_EQ_TILDE] = ACTIONS(685),
    [anon_sym_BANG_TILDE] = ACTIONS(685),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_DASH] = ACTIONS(685),
    [anon_sym_STAR] = ACTIONS(685),
    [anon_sym_SLASH] = ACTIONS(685),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_LBRACK2] = ACTIONS(687),
    [sym_comment] = ACTIONS(530),
  },
  [113] = {
    [sym_identifier] = ACTIONS(689),
    [anon_sym_LF] = ACTIONS(691),
    [anon_sym_COMMA] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(689),
    [sym_dot] = ACTIONS(689),
    [anon_sym__] = ACTIONS(689),
    [anon_sym_AT] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [anon_sym_POUND_DQUOTE] = ACTIONS(689),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_POUND_SQUOTE] = ACTIONS(689),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(689),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(689),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(689),
    [anon_sym_len] = ACTIONS(689),
    [anon_sym_close] = ACTIONS(689),
    [anon_sym_and] = ACTIONS(689),
    [anon_sym_or] = ACTIONS(689),
    [anon_sym_div] = ACTIONS(689),
    [anon_sym_mod] = ACTIONS(689),
    [anon_sym_quo] = ACTIONS(689),
    [anon_sym_rem] = ACTIONS(689),
    [sym_number_type] = ACTIONS(689),
    [anon_sym_float] = ACTIONS(689),
    [anon_sym_float32] = ACTIONS(689),
    [anon_sym_float64] = ACTIONS(689),
    [anon_sym_uint] = ACTIONS(689),
    [anon_sym_uint8] = ACTIONS(689),
    [anon_sym_uint16] = ACTIONS(689),
    [anon_sym_uint32] = ACTIONS(689),
    [anon_sym_uint64] = ACTIONS(689),
    [anon_sym_uint128] = ACTIONS(689),
    [anon_sym_int] = ACTIONS(689),
    [anon_sym_int8] = ACTIONS(689),
    [anon_sym_int16] = ACTIONS(689),
    [anon_sym_int32] = ACTIONS(689),
    [anon_sym_int64] = ACTIONS(689),
    [anon_sym_int128] = ACTIONS(689),
    [sym_string_type] = ACTIONS(689),
    [sym_bytes_type] = ACTIONS(689),
    [sym_bool_type] = ACTIONS(689),
    [sym_bottom_lit] = ACTIONS(689),
    [sym_null] = ACTIONS(689),
    [sym_true] = ACTIONS(689),
    [sym_false] = ACTIONS(689),
    [sym_int_lit] = ACTIONS(689),
    [sym_float_lit] = ACTIONS(689),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_RBRACE] = ACTIONS(689),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(689),
    [anon_sym_for] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(689),
    [anon_sym_let] = ACTIONS(689),
    [anon_sym_PIPE] = ACTIONS(689),
    [anon_sym_AMP] = ACTIONS(689),
    [anon_sym_PIPE_PIPE] = ACTIONS(689),
    [anon_sym_AMP_AMP] = ACTIONS(689),
    [anon_sym_EQ_EQ] = ACTIONS(689),
    [anon_sym_BANG_EQ] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(689),
    [anon_sym_LT_EQ] = ACTIONS(689),
    [anon_sym_GT] = ACTIONS(689),
    [anon_sym_GT_EQ] = ACTIONS(689),
    [anon_sym_EQ_TILDE] = ACTIONS(689),
    [anon_sym_BANG_TILDE] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(689),
    [anon_sym_DASH] = ACTIONS(689),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_SLASH] = ACTIONS(689),
    [anon_sym_BANG] = ACTIONS(689),
    [anon_sym_LBRACK2] = ACTIONS(691),
    [sym_comment] = ACTIONS(530),
  },
  [114] = {
    [sym_identifier] = ACTIONS(693),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_COMMA] = ACTIONS(693),
    [anon_sym_LPAREN] = ACTIONS(693),
    [sym_dot] = ACTIONS(693),
    [anon_sym__] = ACTIONS(693),
    [anon_sym_AT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_POUND_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_POUND_SQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(693),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(693),
    [anon_sym_len] = ACTIONS(693),
    [anon_sym_close] = ACTIONS(693),
    [anon_sym_and] = ACTIONS(693),
    [anon_sym_or] = ACTIONS(693),
    [anon_sym_div] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_quo] = ACTIONS(693),
    [anon_sym_rem] = ACTIONS(693),
    [sym_number_type] = ACTIONS(693),
    [anon_sym_float] = ACTIONS(693),
    [anon_sym_float32] = ACTIONS(693),
    [anon_sym_float64] = ACTIONS(693),
    [anon_sym_uint] = ACTIONS(693),
    [anon_sym_uint8] = ACTIONS(693),
    [anon_sym_uint16] = ACTIONS(693),
    [anon_sym_uint32] = ACTIONS(693),
    [anon_sym_uint64] = ACTIONS(693),
    [anon_sym_uint128] = ACTIONS(693),
    [anon_sym_int] = ACTIONS(693),
    [anon_sym_int8] = ACTIONS(693),
    [anon_sym_int16] = ACTIONS(693),
    [anon_sym_int32] = ACTIONS(693),
    [anon_sym_int64] = ACTIONS(693),
    [anon_sym_int128] = ACTIONS(693),
    [sym_string_type] = ACTIONS(693),
    [sym_bytes_type] = ACTIONS(693),
    [sym_bool_type] = ACTIONS(693),
    [sym_bottom_lit] = ACTIONS(693),
    [sym_null] = ACTIONS(693),
    [sym_true] = ACTIONS(693),
    [sym_false] = ACTIONS(693),
    [sym_int_lit] = ACTIONS(693),
    [sym_float_lit] = ACTIONS(693),
    [anon_sym_LBRACK] = ACTIONS(693),
    [anon_sym_LBRACE] = ACTIONS(693),
    [anon_sym_RBRACE] = ACTIONS(693),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_EQ_EQ] = ACTIONS(693),
    [anon_sym_BANG_EQ] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(693),
    [anon_sym_LT_EQ] = ACTIONS(693),
    [anon_sym_GT] = ACTIONS(693),
    [anon_sym_GT_EQ] = ACTIONS(693),
    [anon_sym_EQ_TILDE] = ACTIONS(693),
    [anon_sym_BANG_TILDE] = ACTIONS(693),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(693),
    [anon_sym_STAR] = ACTIONS(693),
    [anon_sym_SLASH] = ACTIONS(693),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_LBRACK2] = ACTIONS(695),
    [sym_comment] = ACTIONS(530),
  },
  [115] = {
    [sym_identifier] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(699),
    [anon_sym_COMMA] = ACTIONS(697),
    [anon_sym_LPAREN] = ACTIONS(697),
    [sym_dot] = ACTIONS(697),
    [anon_sym__] = ACTIONS(697),
    [anon_sym_AT] = ACTIONS(697),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_POUND_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(697),
    [anon_sym_POUND_SQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(697),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(697),
    [anon_sym_len] = ACTIONS(697),
    [anon_sym_close] = ACTIONS(697),
    [anon_sym_and] = ACTIONS(697),
    [anon_sym_or] = ACTIONS(697),
    [anon_sym_div] = ACTIONS(697),
    [anon_sym_mod] = ACTIONS(697),
    [anon_sym_quo] = ACTIONS(697),
    [anon_sym_rem] = ACTIONS(697),
    [sym_number_type] = ACTIONS(697),
    [anon_sym_float] = ACTIONS(697),
    [anon_sym_float32] = ACTIONS(697),
    [anon_sym_float64] = ACTIONS(697),
    [anon_sym_uint] = ACTIONS(697),
    [anon_sym_uint8] = ACTIONS(697),
    [anon_sym_uint16] = ACTIONS(697),
    [anon_sym_uint32] = ACTIONS(697),
    [anon_sym_uint64] = ACTIONS(697),
    [anon_sym_uint128] = ACTIONS(697),
    [anon_sym_int] = ACTIONS(697),
    [anon_sym_int8] = ACTIONS(697),
    [anon_sym_int16] = ACTIONS(697),
    [anon_sym_int32] = ACTIONS(697),
    [anon_sym_int64] = ACTIONS(697),
    [anon_sym_int128] = ACTIONS(697),
    [sym_string_type] = ACTIONS(697),
    [sym_bytes_type] = ACTIONS(697),
    [sym_bool_type] = ACTIONS(697),
    [sym_bottom_lit] = ACTIONS(697),
    [sym_null] = ACTIONS(697),
    [sym_true] = ACTIONS(697),
    [sym_false] = ACTIONS(697),
    [sym_int_lit] = ACTIONS(697),
    [sym_float_lit] = ACTIONS(697),
    [anon_sym_LBRACK] = ACTIONS(697),
    [anon_sym_LBRACE] = ACTIONS(697),
    [anon_sym_RBRACE] = ACTIONS(697),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(697),
    [anon_sym_for] = ACTIONS(697),
    [anon_sym_if] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(697),
    [anon_sym_PIPE_PIPE] = ACTIONS(697),
    [anon_sym_AMP_AMP] = ACTIONS(697),
    [anon_sym_EQ_EQ] = ACTIONS(697),
    [anon_sym_BANG_EQ] = ACTIONS(697),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_LT_EQ] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_GT_EQ] = ACTIONS(697),
    [anon_sym_EQ_TILDE] = ACTIONS(697),
    [anon_sym_BANG_TILDE] = ACTIONS(697),
    [anon_sym_PLUS] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(697),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_SLASH] = ACTIONS(697),
    [anon_sym_BANG] = ACTIONS(697),
    [anon_sym_LBRACK2] = ACTIONS(699),
    [sym_comment] = ACTIONS(530),
  },
  [116] = {
    [sym_identifier] = ACTIONS(701),
    [anon_sym_LF] = ACTIONS(703),
    [anon_sym_COMMA] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(701),
    [sym_dot] = ACTIONS(701),
    [anon_sym__] = ACTIONS(701),
    [anon_sym_AT] = ACTIONS(701),
    [anon_sym_DQUOTE] = ACTIONS(701),
    [anon_sym_POUND_DQUOTE] = ACTIONS(701),
    [anon_sym_SQUOTE] = ACTIONS(701),
    [anon_sym_POUND_SQUOTE] = ACTIONS(701),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(701),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(701),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(701),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(701),
    [anon_sym_len] = ACTIONS(701),
    [anon_sym_close] = ACTIONS(701),
    [anon_sym_and] = ACTIONS(701),
    [anon_sym_or] = ACTIONS(701),
    [anon_sym_div] = ACTIONS(701),
    [anon_sym_mod] = ACTIONS(701),
    [anon_sym_quo] = ACTIONS(701),
    [anon_sym_rem] = ACTIONS(701),
    [sym_number_type] = ACTIONS(701),
    [anon_sym_float] = ACTIONS(701),
    [anon_sym_float32] = ACTIONS(701),
    [anon_sym_float64] = ACTIONS(701),
    [anon_sym_uint] = ACTIONS(701),
    [anon_sym_uint8] = ACTIONS(701),
    [anon_sym_uint16] = ACTIONS(701),
    [anon_sym_uint32] = ACTIONS(701),
    [anon_sym_uint64] = ACTIONS(701),
    [anon_sym_uint128] = ACTIONS(701),
    [anon_sym_int] = ACTIONS(701),
    [anon_sym_int8] = ACTIONS(701),
    [anon_sym_int16] = ACTIONS(701),
    [anon_sym_int32] = ACTIONS(701),
    [anon_sym_int64] = ACTIONS(701),
    [anon_sym_int128] = ACTIONS(701),
    [sym_string_type] = ACTIONS(701),
    [sym_bytes_type] = ACTIONS(701),
    [sym_bool_type] = ACTIONS(701),
    [sym_bottom_lit] = ACTIONS(701),
    [sym_null] = ACTIONS(701),
    [sym_true] = ACTIONS(701),
    [sym_false] = ACTIONS(701),
    [sym_int_lit] = ACTIONS(701),
    [sym_float_lit] = ACTIONS(701),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_RBRACE] = ACTIONS(701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(701),
    [anon_sym_for] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_let] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_PIPE_PIPE] = ACTIONS(701),
    [anon_sym_AMP_AMP] = ACTIONS(701),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_LT] = ACTIONS(701),
    [anon_sym_LT_EQ] = ACTIONS(701),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_GT_EQ] = ACTIONS(701),
    [anon_sym_EQ_TILDE] = ACTIONS(701),
    [anon_sym_BANG_TILDE] = ACTIONS(701),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_DASH] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(701),
    [anon_sym_SLASH] = ACTIONS(701),
    [anon_sym_BANG] = ACTIONS(701),
    [anon_sym_LBRACK2] = ACTIONS(703),
    [sym_comment] = ACTIONS(530),
  },
  [117] = {
    [sym_identifier] = ACTIONS(705),
    [anon_sym_LF] = ACTIONS(707),
    [anon_sym_COMMA] = ACTIONS(705),
    [anon_sym_LPAREN] = ACTIONS(705),
    [sym_dot] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
    [anon_sym_AT] = ACTIONS(705),
    [anon_sym_DQUOTE] = ACTIONS(705),
    [anon_sym_POUND_DQUOTE] = ACTIONS(705),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [anon_sym_POUND_SQUOTE] = ACTIONS(705),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(705),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(705),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_len] = ACTIONS(705),
    [anon_sym_close] = ACTIONS(705),
    [anon_sym_and] = ACTIONS(705),
    [anon_sym_or] = ACTIONS(705),
    [anon_sym_div] = ACTIONS(705),
    [anon_sym_mod] = ACTIONS(705),
    [anon_sym_quo] = ACTIONS(705),
    [anon_sym_rem] = ACTIONS(705),
    [sym_number_type] = ACTIONS(705),
    [anon_sym_float] = ACTIONS(705),
    [anon_sym_float32] = ACTIONS(705),
    [anon_sym_float64] = ACTIONS(705),
    [anon_sym_uint] = ACTIONS(705),
    [anon_sym_uint8] = ACTIONS(705),
    [anon_sym_uint16] = ACTIONS(705),
    [anon_sym_uint32] = ACTIONS(705),
    [anon_sym_uint64] = ACTIONS(705),
    [anon_sym_uint128] = ACTIONS(705),
    [anon_sym_int] = ACTIONS(705),
    [anon_sym_int8] = ACTIONS(705),
    [anon_sym_int16] = ACTIONS(705),
    [anon_sym_int32] = ACTIONS(705),
    [anon_sym_int64] = ACTIONS(705),
    [anon_sym_int128] = ACTIONS(705),
    [sym_string_type] = ACTIONS(705),
    [sym_bytes_type] = ACTIONS(705),
    [sym_bool_type] = ACTIONS(705),
    [sym_bottom_lit] = ACTIONS(705),
    [sym_null] = ACTIONS(705),
    [sym_true] = ACTIONS(705),
    [sym_false] = ACTIONS(705),
    [sym_int_lit] = ACTIONS(705),
    [sym_float_lit] = ACTIONS(705),
    [anon_sym_LBRACK] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(705),
    [anon_sym_RBRACE] = ACTIONS(705),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(705),
    [anon_sym_let] = ACTIONS(705),
    [anon_sym_PIPE] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(705),
    [anon_sym_AMP_AMP] = ACTIONS(705),
    [anon_sym_EQ_EQ] = ACTIONS(705),
    [anon_sym_BANG_EQ] = ACTIONS(705),
    [anon_sym_LT] = ACTIONS(705),
    [anon_sym_LT_EQ] = ACTIONS(705),
    [anon_sym_GT] = ACTIONS(705),
    [anon_sym_GT_EQ] = ACTIONS(705),
    [anon_sym_EQ_TILDE] = ACTIONS(705),
    [anon_sym_BANG_TILDE] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_STAR] = ACTIONS(705),
    [anon_sym_SLASH] = ACTIONS(705),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_LBRACK2] = ACTIONS(707),
    [sym_comment] = ACTIONS(530),
  },
  [118] = {
    [sym_identifier] = ACTIONS(693),
    [anon_sym_COMMA] = ACTIONS(695),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(695),
    [sym_dot] = ACTIONS(693),
    [anon_sym__] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_POUND_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_POUND_SQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(695),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(695),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(695),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(695),
    [anon_sym_len] = ACTIONS(693),
    [anon_sym_close] = ACTIONS(693),
    [anon_sym_and] = ACTIONS(693),
    [anon_sym_or] = ACTIONS(693),
    [anon_sym_div] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_quo] = ACTIONS(693),
    [anon_sym_rem] = ACTIONS(693),
    [sym_number_type] = ACTIONS(693),
    [anon_sym_float] = ACTIONS(693),
    [anon_sym_float32] = ACTIONS(693),
    [anon_sym_float64] = ACTIONS(693),
    [anon_sym_uint] = ACTIONS(693),
    [anon_sym_uint8] = ACTIONS(693),
    [anon_sym_uint16] = ACTIONS(693),
    [anon_sym_uint32] = ACTIONS(693),
    [anon_sym_uint64] = ACTIONS(693),
    [anon_sym_uint128] = ACTIONS(693),
    [anon_sym_int] = ACTIONS(693),
    [anon_sym_int8] = ACTIONS(693),
    [anon_sym_int16] = ACTIONS(693),
    [anon_sym_int32] = ACTIONS(693),
    [anon_sym_int64] = ACTIONS(693),
    [anon_sym_int128] = ACTIONS(693),
    [sym_string_type] = ACTIONS(693),
    [sym_bytes_type] = ACTIONS(693),
    [sym_bool_type] = ACTIONS(693),
    [sym_bottom_lit] = ACTIONS(695),
    [sym_null] = ACTIONS(693),
    [sym_true] = ACTIONS(693),
    [sym_false] = ACTIONS(693),
    [sym_int_lit] = ACTIONS(693),
    [sym_float_lit] = ACTIONS(693),
    [anon_sym_LBRACK] = ACTIONS(693),
    [anon_sym_RBRACK] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(695),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(695),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_EQ_EQ] = ACTIONS(695),
    [anon_sym_BANG_EQ] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(693),
    [anon_sym_LT_EQ] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(693),
    [anon_sym_GT_EQ] = ACTIONS(695),
    [anon_sym_EQ_TILDE] = ACTIONS(695),
    [anon_sym_BANG_TILDE] = ACTIONS(695),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(695),
    [anon_sym_SLASH] = ACTIONS(693),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_LBRACK2] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
  },
  [119] = {
    [sym_identifier] = ACTIONS(597),
    [anon_sym_COMMA] = ACTIONS(599),
    [anon_sym_LPAREN] = ACTIONS(599),
    [anon_sym_RPAREN] = ACTIONS(599),
    [sym_dot] = ACTIONS(597),
    [anon_sym__] = ACTIONS(597),
    [anon_sym_DQUOTE] = ACTIONS(597),
    [anon_sym_POUND_DQUOTE] = ACTIONS(597),
    [anon_sym_SQUOTE] = ACTIONS(597),
    [anon_sym_POUND_SQUOTE] = ACTIONS(597),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(599),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(599),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(599),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(599),
    [anon_sym_len] = ACTIONS(597),
    [anon_sym_close] = ACTIONS(597),
    [anon_sym_and] = ACTIONS(597),
    [anon_sym_or] = ACTIONS(597),
    [anon_sym_div] = ACTIONS(597),
    [anon_sym_mod] = ACTIONS(597),
    [anon_sym_quo] = ACTIONS(597),
    [anon_sym_rem] = ACTIONS(597),
    [sym_number_type] = ACTIONS(597),
    [anon_sym_float] = ACTIONS(597),
    [anon_sym_float32] = ACTIONS(597),
    [anon_sym_float64] = ACTIONS(597),
    [anon_sym_uint] = ACTIONS(597),
    [anon_sym_uint8] = ACTIONS(597),
    [anon_sym_uint16] = ACTIONS(597),
    [anon_sym_uint32] = ACTIONS(597),
    [anon_sym_uint64] = ACTIONS(597),
    [anon_sym_uint128] = ACTIONS(597),
    [anon_sym_int] = ACTIONS(597),
    [anon_sym_int8] = ACTIONS(597),
    [anon_sym_int16] = ACTIONS(597),
    [anon_sym_int32] = ACTIONS(597),
    [anon_sym_int64] = ACTIONS(597),
    [anon_sym_int128] = ACTIONS(597),
    [sym_string_type] = ACTIONS(597),
    [sym_bytes_type] = ACTIONS(597),
    [sym_bool_type] = ACTIONS(597),
    [sym_bottom_lit] = ACTIONS(599),
    [sym_null] = ACTIONS(597),
    [sym_true] = ACTIONS(597),
    [sym_false] = ACTIONS(597),
    [sym_int_lit] = ACTIONS(597),
    [sym_float_lit] = ACTIONS(597),
    [anon_sym_LBRACK] = ACTIONS(597),
    [anon_sym_RBRACK] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(599),
    [anon_sym_for] = ACTIONS(597),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_let] = ACTIONS(597),
    [anon_sym_PIPE] = ACTIONS(597),
    [anon_sym_AMP] = ACTIONS(597),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_AMP_AMP] = ACTIONS(599),
    [anon_sym_EQ_EQ] = ACTIONS(599),
    [anon_sym_BANG_EQ] = ACTIONS(599),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_LT_EQ] = ACTIONS(599),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_EQ] = ACTIONS(599),
    [anon_sym_EQ_TILDE] = ACTIONS(599),
    [anon_sym_BANG_TILDE] = ACTIONS(599),
    [anon_sym_PLUS] = ACTIONS(599),
    [anon_sym_DASH] = ACTIONS(599),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_SLASH] = ACTIONS(597),
    [anon_sym_BANG] = ACTIONS(597),
    [anon_sym_LBRACK2] = ACTIONS(599),
    [sym_comment] = ACTIONS(3),
  },
  [120] = {
    [sym_identifier] = ACTIONS(589),
    [anon_sym_COMMA] = ACTIONS(591),
    [anon_sym_LPAREN] = ACTIONS(591),
    [anon_sym_RPAREN] = ACTIONS(591),
    [sym_dot] = ACTIONS(589),
    [anon_sym__] = ACTIONS(589),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [anon_sym_POUND_DQUOTE] = ACTIONS(589),
    [anon_sym_SQUOTE] = ACTIONS(589),
    [anon_sym_POUND_SQUOTE] = ACTIONS(589),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(591),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(591),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(591),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(591),
    [anon_sym_len] = ACTIONS(589),
    [anon_sym_close] = ACTIONS(589),
    [anon_sym_and] = ACTIONS(589),
    [anon_sym_or] = ACTIONS(589),
    [anon_sym_div] = ACTIONS(589),
    [anon_sym_mod] = ACTIONS(589),
    [anon_sym_quo] = ACTIONS(589),
    [anon_sym_rem] = ACTIONS(589),
    [sym_number_type] = ACTIONS(589),
    [anon_sym_float] = ACTIONS(589),
    [anon_sym_float32] = ACTIONS(589),
    [anon_sym_float64] = ACTIONS(589),
    [anon_sym_uint] = ACTIONS(589),
    [anon_sym_uint8] = ACTIONS(589),
    [anon_sym_uint16] = ACTIONS(589),
    [anon_sym_uint32] = ACTIONS(589),
    [anon_sym_uint64] = ACTIONS(589),
    [anon_sym_uint128] = ACTIONS(589),
    [anon_sym_int] = ACTIONS(589),
    [anon_sym_int8] = ACTIONS(589),
    [anon_sym_int16] = ACTIONS(589),
    [anon_sym_int32] = ACTIONS(589),
    [anon_sym_int64] = ACTIONS(589),
    [anon_sym_int128] = ACTIONS(589),
    [sym_string_type] = ACTIONS(589),
    [sym_bytes_type] = ACTIONS(589),
    [sym_bool_type] = ACTIONS(589),
    [sym_bottom_lit] = ACTIONS(591),
    [sym_null] = ACTIONS(589),
    [sym_true] = ACTIONS(589),
    [sym_false] = ACTIONS(589),
    [sym_int_lit] = ACTIONS(589),
    [sym_float_lit] = ACTIONS(589),
    [anon_sym_LBRACK] = ACTIONS(589),
    [anon_sym_RBRACK] = ACTIONS(591),
    [anon_sym_LBRACE] = ACTIONS(591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(591),
    [anon_sym_for] = ACTIONS(589),
    [anon_sym_if] = ACTIONS(589),
    [anon_sym_let] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(589),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE_PIPE] = ACTIONS(591),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_EQ_EQ] = ACTIONS(591),
    [anon_sym_BANG_EQ] = ACTIONS(591),
    [anon_sym_LT] = ACTIONS(589),
    [anon_sym_LT_EQ] = ACTIONS(591),
    [anon_sym_GT] = ACTIONS(589),
    [anon_sym_GT_EQ] = ACTIONS(591),
    [anon_sym_EQ_TILDE] = ACTIONS(591),
    [anon_sym_BANG_TILDE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(591),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_SLASH] = ACTIONS(589),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_LBRACK2] = ACTIONS(591),
    [sym_comment] = ACTIONS(3),
  },
  [121] = {
    [sym_identifier] = ACTIONS(617),
    [anon_sym_COMMA] = ACTIONS(619),
    [anon_sym_LPAREN] = ACTIONS(619),
    [anon_sym_RPAREN] = ACTIONS(619),
    [sym_dot] = ACTIONS(617),
    [anon_sym__] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(617),
    [anon_sym_POUND_DQUOTE] = ACTIONS(617),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_POUND_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(619),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(619),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(619),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(619),
    [anon_sym_len] = ACTIONS(617),
    [anon_sym_close] = ACTIONS(617),
    [anon_sym_and] = ACTIONS(617),
    [anon_sym_or] = ACTIONS(617),
    [anon_sym_div] = ACTIONS(617),
    [anon_sym_mod] = ACTIONS(617),
    [anon_sym_quo] = ACTIONS(617),
    [anon_sym_rem] = ACTIONS(617),
    [sym_number_type] = ACTIONS(617),
    [anon_sym_float] = ACTIONS(617),
    [anon_sym_float32] = ACTIONS(617),
    [anon_sym_float64] = ACTIONS(617),
    [anon_sym_uint] = ACTIONS(617),
    [anon_sym_uint8] = ACTIONS(617),
    [anon_sym_uint16] = ACTIONS(617),
    [anon_sym_uint32] = ACTIONS(617),
    [anon_sym_uint64] = ACTIONS(617),
    [anon_sym_uint128] = ACTIONS(617),
    [anon_sym_int] = ACTIONS(617),
    [anon_sym_int8] = ACTIONS(617),
    [anon_sym_int16] = ACTIONS(617),
    [anon_sym_int32] = ACTIONS(617),
    [anon_sym_int64] = ACTIONS(617),
    [anon_sym_int128] = ACTIONS(617),
    [sym_string_type] = ACTIONS(617),
    [sym_bytes_type] = ACTIONS(617),
    [sym_bool_type] = ACTIONS(617),
    [sym_bottom_lit] = ACTIONS(619),
    [sym_null] = ACTIONS(617),
    [sym_true] = ACTIONS(617),
    [sym_false] = ACTIONS(617),
    [sym_int_lit] = ACTIONS(617),
    [sym_float_lit] = ACTIONS(617),
    [anon_sym_LBRACK] = ACTIONS(617),
    [anon_sym_RBRACK] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(619),
    [anon_sym_for] = ACTIONS(617),
    [anon_sym_if] = ACTIONS(617),
    [anon_sym_let] = ACTIONS(617),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_AMP] = ACTIONS(617),
    [anon_sym_PIPE_PIPE] = ACTIONS(619),
    [anon_sym_AMP_AMP] = ACTIONS(619),
    [anon_sym_EQ_EQ] = ACTIONS(619),
    [anon_sym_BANG_EQ] = ACTIONS(619),
    [anon_sym_LT] = ACTIONS(617),
    [anon_sym_LT_EQ] = ACTIONS(619),
    [anon_sym_GT] = ACTIONS(617),
    [anon_sym_GT_EQ] = ACTIONS(619),
    [anon_sym_EQ_TILDE] = ACTIONS(619),
    [anon_sym_BANG_TILDE] = ACTIONS(619),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_SLASH] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(617),
    [anon_sym_LBRACK2] = ACTIONS(619),
    [sym_comment] = ACTIONS(3),
  },
  [122] = {
    [sym_identifier] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(615),
    [anon_sym_LPAREN] = ACTIONS(615),
    [anon_sym_RPAREN] = ACTIONS(615),
    [sym_dot] = ACTIONS(613),
    [anon_sym__] = ACTIONS(613),
    [anon_sym_DQUOTE] = ACTIONS(613),
    [anon_sym_POUND_DQUOTE] = ACTIONS(613),
    [anon_sym_SQUOTE] = ACTIONS(613),
    [anon_sym_POUND_SQUOTE] = ACTIONS(613),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(615),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(615),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(615),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(615),
    [anon_sym_len] = ACTIONS(613),
    [anon_sym_close] = ACTIONS(613),
    [anon_sym_and] = ACTIONS(613),
    [anon_sym_or] = ACTIONS(613),
    [anon_sym_div] = ACTIONS(613),
    [anon_sym_mod] = ACTIONS(613),
    [anon_sym_quo] = ACTIONS(613),
    [anon_sym_rem] = ACTIONS(613),
    [sym_number_type] = ACTIONS(613),
    [anon_sym_float] = ACTIONS(613),
    [anon_sym_float32] = ACTIONS(613),
    [anon_sym_float64] = ACTIONS(613),
    [anon_sym_uint] = ACTIONS(613),
    [anon_sym_uint8] = ACTIONS(613),
    [anon_sym_uint16] = ACTIONS(613),
    [anon_sym_uint32] = ACTIONS(613),
    [anon_sym_uint64] = ACTIONS(613),
    [anon_sym_uint128] = ACTIONS(613),
    [anon_sym_int] = ACTIONS(613),
    [anon_sym_int8] = ACTIONS(613),
    [anon_sym_int16] = ACTIONS(613),
    [anon_sym_int32] = ACTIONS(613),
    [anon_sym_int64] = ACTIONS(613),
    [anon_sym_int128] = ACTIONS(613),
    [sym_string_type] = ACTIONS(613),
    [sym_bytes_type] = ACTIONS(613),
    [sym_bool_type] = ACTIONS(613),
    [sym_bottom_lit] = ACTIONS(615),
    [sym_null] = ACTIONS(613),
    [sym_true] = ACTIONS(613),
    [sym_false] = ACTIONS(613),
    [sym_int_lit] = ACTIONS(613),
    [sym_float_lit] = ACTIONS(613),
    [anon_sym_LBRACK] = ACTIONS(613),
    [anon_sym_RBRACK] = ACTIONS(615),
    [anon_sym_LBRACE] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(615),
    [anon_sym_for] = ACTIONS(613),
    [anon_sym_if] = ACTIONS(613),
    [anon_sym_let] = ACTIONS(613),
    [anon_sym_PIPE] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(613),
    [anon_sym_PIPE_PIPE] = ACTIONS(615),
    [anon_sym_AMP_AMP] = ACTIONS(615),
    [anon_sym_EQ_EQ] = ACTIONS(615),
    [anon_sym_BANG_EQ] = ACTIONS(615),
    [anon_sym_LT] = ACTIONS(613),
    [anon_sym_LT_EQ] = ACTIONS(615),
    [anon_sym_GT] = ACTIONS(613),
    [anon_sym_GT_EQ] = ACTIONS(615),
    [anon_sym_EQ_TILDE] = ACTIONS(615),
    [anon_sym_BANG_TILDE] = ACTIONS(615),
    [anon_sym_PLUS] = ACTIONS(615),
    [anon_sym_DASH] = ACTIONS(615),
    [anon_sym_STAR] = ACTIONS(615),
    [anon_sym_SLASH] = ACTIONS(613),
    [anon_sym_BANG] = ACTIONS(613),
    [anon_sym_LBRACK2] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
  },
  [123] = {
    [sym_identifier] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(556),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_RPAREN] = ACTIONS(556),
    [sym_dot] = ACTIONS(558),
    [anon_sym__] = ACTIONS(554),
    [anon_sym_DQUOTE] = ACTIONS(554),
    [anon_sym_POUND_DQUOTE] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(554),
    [anon_sym_POUND_SQUOTE] = ACTIONS(554),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(556),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(556),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(556),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(556),
    [anon_sym_len] = ACTIONS(554),
    [anon_sym_close] = ACTIONS(554),
    [anon_sym_and] = ACTIONS(554),
    [anon_sym_or] = ACTIONS(554),
    [anon_sym_div] = ACTIONS(554),
    [anon_sym_mod] = ACTIONS(554),
    [anon_sym_quo] = ACTIONS(554),
    [anon_sym_rem] = ACTIONS(554),
    [sym_number_type] = ACTIONS(554),
    [anon_sym_float] = ACTIONS(554),
    [anon_sym_float32] = ACTIONS(554),
    [anon_sym_float64] = ACTIONS(554),
    [anon_sym_uint] = ACTIONS(554),
    [anon_sym_uint8] = ACTIONS(554),
    [anon_sym_uint16] = ACTIONS(554),
    [anon_sym_uint32] = ACTIONS(554),
    [anon_sym_uint64] = ACTIONS(554),
    [anon_sym_uint128] = ACTIONS(554),
    [anon_sym_int] = ACTIONS(554),
    [anon_sym_int8] = ACTIONS(554),
    [anon_sym_int16] = ACTIONS(554),
    [anon_sym_int32] = ACTIONS(554),
    [anon_sym_int64] = ACTIONS(554),
    [anon_sym_int128] = ACTIONS(554),
    [sym_string_type] = ACTIONS(554),
    [sym_bytes_type] = ACTIONS(554),
    [sym_bool_type] = ACTIONS(554),
    [sym_bottom_lit] = ACTIONS(556),
    [sym_null] = ACTIONS(554),
    [sym_true] = ACTIONS(554),
    [sym_false] = ACTIONS(554),
    [sym_int_lit] = ACTIONS(554),
    [sym_float_lit] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(554),
    [anon_sym_RBRACK] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(556),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_if] = ACTIONS(554),
    [anon_sym_let] = ACTIONS(554),
    [anon_sym_PIPE] = ACTIONS(554),
    [anon_sym_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(556),
    [anon_sym_AMP_AMP] = ACTIONS(556),
    [anon_sym_EQ_EQ] = ACTIONS(556),
    [anon_sym_BANG_EQ] = ACTIONS(556),
    [anon_sym_LT] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(556),
    [anon_sym_GT] = ACTIONS(554),
    [anon_sym_GT_EQ] = ACTIONS(556),
    [anon_sym_EQ_TILDE] = ACTIONS(556),
    [anon_sym_BANG_TILDE] = ACTIONS(556),
    [anon_sym_PLUS] = ACTIONS(556),
    [anon_sym_DASH] = ACTIONS(556),
    [anon_sym_STAR] = ACTIONS(556),
    [anon_sym_SLASH] = ACTIONS(554),
    [anon_sym_BANG] = ACTIONS(554),
    [anon_sym_LBRACK2] = ACTIONS(556),
    [sym_comment] = ACTIONS(3),
  },
  [124] = {
    [sym_identifier] = ACTIONS(645),
    [anon_sym_COMMA] = ACTIONS(647),
    [anon_sym_LPAREN] = ACTIONS(647),
    [anon_sym_RPAREN] = ACTIONS(647),
    [sym_dot] = ACTIONS(645),
    [anon_sym__] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(645),
    [anon_sym_POUND_DQUOTE] = ACTIONS(645),
    [anon_sym_SQUOTE] = ACTIONS(645),
    [anon_sym_POUND_SQUOTE] = ACTIONS(645),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(647),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(647),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(647),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(647),
    [anon_sym_len] = ACTIONS(645),
    [anon_sym_close] = ACTIONS(645),
    [anon_sym_and] = ACTIONS(645),
    [anon_sym_or] = ACTIONS(645),
    [anon_sym_div] = ACTIONS(645),
    [anon_sym_mod] = ACTIONS(645),
    [anon_sym_quo] = ACTIONS(645),
    [anon_sym_rem] = ACTIONS(645),
    [sym_number_type] = ACTIONS(645),
    [anon_sym_float] = ACTIONS(645),
    [anon_sym_float32] = ACTIONS(645),
    [anon_sym_float64] = ACTIONS(645),
    [anon_sym_uint] = ACTIONS(645),
    [anon_sym_uint8] = ACTIONS(645),
    [anon_sym_uint16] = ACTIONS(645),
    [anon_sym_uint32] = ACTIONS(645),
    [anon_sym_uint64] = ACTIONS(645),
    [anon_sym_uint128] = ACTIONS(645),
    [anon_sym_int] = ACTIONS(645),
    [anon_sym_int8] = ACTIONS(645),
    [anon_sym_int16] = ACTIONS(645),
    [anon_sym_int32] = ACTIONS(645),
    [anon_sym_int64] = ACTIONS(645),
    [anon_sym_int128] = ACTIONS(645),
    [sym_string_type] = ACTIONS(645),
    [sym_bytes_type] = ACTIONS(645),
    [sym_bool_type] = ACTIONS(645),
    [sym_bottom_lit] = ACTIONS(647),
    [sym_null] = ACTIONS(645),
    [sym_true] = ACTIONS(645),
    [sym_false] = ACTIONS(645),
    [sym_int_lit] = ACTIONS(645),
    [sym_float_lit] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_RBRACK] = ACTIONS(647),
    [anon_sym_LBRACE] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(647),
    [anon_sym_for] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(645),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_PIPE] = ACTIONS(645),
    [anon_sym_AMP] = ACTIONS(645),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [anon_sym_LT] = ACTIONS(645),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(645),
    [anon_sym_GT_EQ] = ACTIONS(647),
    [anon_sym_EQ_TILDE] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(647),
    [anon_sym_SLASH] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(647),
    [sym_comment] = ACTIONS(3),
  },
  [125] = {
    [sym_identifier] = ACTIONS(601),
    [anon_sym_COMMA] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(603),
    [anon_sym_RPAREN] = ACTIONS(603),
    [sym_dot] = ACTIONS(601),
    [anon_sym__] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [anon_sym_POUND_DQUOTE] = ACTIONS(601),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [anon_sym_POUND_SQUOTE] = ACTIONS(601),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(603),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(603),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(603),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(603),
    [anon_sym_len] = ACTIONS(601),
    [anon_sym_close] = ACTIONS(601),
    [anon_sym_and] = ACTIONS(601),
    [anon_sym_or] = ACTIONS(601),
    [anon_sym_div] = ACTIONS(601),
    [anon_sym_mod] = ACTIONS(601),
    [anon_sym_quo] = ACTIONS(601),
    [anon_sym_rem] = ACTIONS(601),
    [sym_number_type] = ACTIONS(601),
    [anon_sym_float] = ACTIONS(601),
    [anon_sym_float32] = ACTIONS(601),
    [anon_sym_float64] = ACTIONS(601),
    [anon_sym_uint] = ACTIONS(601),
    [anon_sym_uint8] = ACTIONS(601),
    [anon_sym_uint16] = ACTIONS(601),
    [anon_sym_uint32] = ACTIONS(601),
    [anon_sym_uint64] = ACTIONS(601),
    [anon_sym_uint128] = ACTIONS(601),
    [anon_sym_int] = ACTIONS(601),
    [anon_sym_int8] = ACTIONS(601),
    [anon_sym_int16] = ACTIONS(601),
    [anon_sym_int32] = ACTIONS(601),
    [anon_sym_int64] = ACTIONS(601),
    [anon_sym_int128] = ACTIONS(601),
    [sym_string_type] = ACTIONS(601),
    [sym_bytes_type] = ACTIONS(601),
    [sym_bool_type] = ACTIONS(601),
    [sym_bottom_lit] = ACTIONS(603),
    [sym_null] = ACTIONS(601),
    [sym_true] = ACTIONS(601),
    [sym_false] = ACTIONS(601),
    [sym_int_lit] = ACTIONS(601),
    [sym_float_lit] = ACTIONS(601),
    [anon_sym_LBRACK] = ACTIONS(601),
    [anon_sym_RBRACK] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(601),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_let] = ACTIONS(601),
    [anon_sym_PIPE] = ACTIONS(601),
    [anon_sym_AMP] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(603),
    [anon_sym_AMP_AMP] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(603),
    [anon_sym_BANG_EQ] = ACTIONS(603),
    [anon_sym_LT] = ACTIONS(601),
    [anon_sym_LT_EQ] = ACTIONS(603),
    [anon_sym_GT] = ACTIONS(601),
    [anon_sym_GT_EQ] = ACTIONS(603),
    [anon_sym_EQ_TILDE] = ACTIONS(603),
    [anon_sym_BANG_TILDE] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(603),
    [anon_sym_DASH] = ACTIONS(603),
    [anon_sym_STAR] = ACTIONS(603),
    [anon_sym_SLASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(601),
    [anon_sym_LBRACK2] = ACTIONS(603),
    [sym_comment] = ACTIONS(3),
  },
  [126] = {
    [sym_identifier] = ACTIONS(621),
    [anon_sym_COMMA] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_RPAREN] = ACTIONS(623),
    [sym_dot] = ACTIONS(621),
    [anon_sym__] = ACTIONS(621),
    [anon_sym_DQUOTE] = ACTIONS(621),
    [anon_sym_POUND_DQUOTE] = ACTIONS(621),
    [anon_sym_SQUOTE] = ACTIONS(621),
    [anon_sym_POUND_SQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(623),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(623),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(623),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(623),
    [anon_sym_len] = ACTIONS(621),
    [anon_sym_close] = ACTIONS(621),
    [anon_sym_and] = ACTIONS(621),
    [anon_sym_or] = ACTIONS(621),
    [anon_sym_div] = ACTIONS(621),
    [anon_sym_mod] = ACTIONS(621),
    [anon_sym_quo] = ACTIONS(621),
    [anon_sym_rem] = ACTIONS(621),
    [sym_number_type] = ACTIONS(621),
    [anon_sym_float] = ACTIONS(621),
    [anon_sym_float32] = ACTIONS(621),
    [anon_sym_float64] = ACTIONS(621),
    [anon_sym_uint] = ACTIONS(621),
    [anon_sym_uint8] = ACTIONS(621),
    [anon_sym_uint16] = ACTIONS(621),
    [anon_sym_uint32] = ACTIONS(621),
    [anon_sym_uint64] = ACTIONS(621),
    [anon_sym_uint128] = ACTIONS(621),
    [anon_sym_int] = ACTIONS(621),
    [anon_sym_int8] = ACTIONS(621),
    [anon_sym_int16] = ACTIONS(621),
    [anon_sym_int32] = ACTIONS(621),
    [anon_sym_int64] = ACTIONS(621),
    [anon_sym_int128] = ACTIONS(621),
    [sym_string_type] = ACTIONS(621),
    [sym_bytes_type] = ACTIONS(621),
    [sym_bool_type] = ACTIONS(621),
    [sym_bottom_lit] = ACTIONS(623),
    [sym_null] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_int_lit] = ACTIONS(621),
    [sym_float_lit] = ACTIONS(621),
    [anon_sym_LBRACK] = ACTIONS(621),
    [anon_sym_RBRACK] = ACTIONS(623),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(623),
    [anon_sym_for] = ACTIONS(621),
    [anon_sym_if] = ACTIONS(621),
    [anon_sym_let] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(621),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_PIPE_PIPE] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(623),
    [anon_sym_EQ_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(621),
    [anon_sym_LT_EQ] = ACTIONS(623),
    [anon_sym_GT] = ACTIONS(621),
    [anon_sym_GT_EQ] = ACTIONS(623),
    [anon_sym_EQ_TILDE] = ACTIONS(623),
    [anon_sym_BANG_TILDE] = ACTIONS(623),
    [anon_sym_PLUS] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(623),
    [anon_sym_STAR] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(621),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_LBRACK2] = ACTIONS(623),
    [sym_comment] = ACTIONS(3),
  },
  [127] = {
    [sym_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(627),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_RPAREN] = ACTIONS(627),
    [sym_dot] = ACTIONS(625),
    [anon_sym__] = ACTIONS(625),
    [anon_sym_DQUOTE] = ACTIONS(625),
    [anon_sym_POUND_DQUOTE] = ACTIONS(625),
    [anon_sym_SQUOTE] = ACTIONS(625),
    [anon_sym_POUND_SQUOTE] = ACTIONS(625),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(627),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(627),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(627),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(627),
    [anon_sym_len] = ACTIONS(625),
    [anon_sym_close] = ACTIONS(625),
    [anon_sym_and] = ACTIONS(625),
    [anon_sym_or] = ACTIONS(625),
    [anon_sym_div] = ACTIONS(625),
    [anon_sym_mod] = ACTIONS(625),
    [anon_sym_quo] = ACTIONS(625),
    [anon_sym_rem] = ACTIONS(625),
    [sym_number_type] = ACTIONS(625),
    [anon_sym_float] = ACTIONS(625),
    [anon_sym_float32] = ACTIONS(625),
    [anon_sym_float64] = ACTIONS(625),
    [anon_sym_uint] = ACTIONS(625),
    [anon_sym_uint8] = ACTIONS(625),
    [anon_sym_uint16] = ACTIONS(625),
    [anon_sym_uint32] = ACTIONS(625),
    [anon_sym_uint64] = ACTIONS(625),
    [anon_sym_uint128] = ACTIONS(625),
    [anon_sym_int] = ACTIONS(625),
    [anon_sym_int8] = ACTIONS(625),
    [anon_sym_int16] = ACTIONS(625),
    [anon_sym_int32] = ACTIONS(625),
    [anon_sym_int64] = ACTIONS(625),
    [anon_sym_int128] = ACTIONS(625),
    [sym_string_type] = ACTIONS(625),
    [sym_bytes_type] = ACTIONS(625),
    [sym_bool_type] = ACTIONS(625),
    [sym_bottom_lit] = ACTIONS(627),
    [sym_null] = ACTIONS(625),
    [sym_true] = ACTIONS(625),
    [sym_false] = ACTIONS(625),
    [sym_int_lit] = ACTIONS(625),
    [sym_float_lit] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(625),
    [anon_sym_RBRACK] = ACTIONS(627),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(627),
    [anon_sym_for] = ACTIONS(625),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_let] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(625),
    [anon_sym_AMP] = ACTIONS(625),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_EQ_EQ] = ACTIONS(627),
    [anon_sym_BANG_EQ] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(625),
    [anon_sym_LT_EQ] = ACTIONS(627),
    [anon_sym_GT] = ACTIONS(625),
    [anon_sym_GT_EQ] = ACTIONS(627),
    [anon_sym_EQ_TILDE] = ACTIONS(627),
    [anon_sym_BANG_TILDE] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(627),
    [anon_sym_DASH] = ACTIONS(627),
    [anon_sym_STAR] = ACTIONS(627),
    [anon_sym_SLASH] = ACTIONS(625),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_LBRACK2] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
  },
  [128] = {
    [sym_identifier] = ACTIONS(629),
    [anon_sym_COMMA] = ACTIONS(631),
    [anon_sym_LPAREN] = ACTIONS(631),
    [anon_sym_RPAREN] = ACTIONS(631),
    [sym_dot] = ACTIONS(629),
    [anon_sym__] = ACTIONS(629),
    [anon_sym_DQUOTE] = ACTIONS(629),
    [anon_sym_POUND_DQUOTE] = ACTIONS(629),
    [anon_sym_SQUOTE] = ACTIONS(629),
    [anon_sym_POUND_SQUOTE] = ACTIONS(629),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(631),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(631),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(631),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(631),
    [anon_sym_len] = ACTIONS(629),
    [anon_sym_close] = ACTIONS(629),
    [anon_sym_and] = ACTIONS(629),
    [anon_sym_or] = ACTIONS(629),
    [anon_sym_div] = ACTIONS(629),
    [anon_sym_mod] = ACTIONS(629),
    [anon_sym_quo] = ACTIONS(629),
    [anon_sym_rem] = ACTIONS(629),
    [sym_number_type] = ACTIONS(629),
    [anon_sym_float] = ACTIONS(629),
    [anon_sym_float32] = ACTIONS(629),
    [anon_sym_float64] = ACTIONS(629),
    [anon_sym_uint] = ACTIONS(629),
    [anon_sym_uint8] = ACTIONS(629),
    [anon_sym_uint16] = ACTIONS(629),
    [anon_sym_uint32] = ACTIONS(629),
    [anon_sym_uint64] = ACTIONS(629),
    [anon_sym_uint128] = ACTIONS(629),
    [anon_sym_int] = ACTIONS(629),
    [anon_sym_int8] = ACTIONS(629),
    [anon_sym_int16] = ACTIONS(629),
    [anon_sym_int32] = ACTIONS(629),
    [anon_sym_int64] = ACTIONS(629),
    [anon_sym_int128] = ACTIONS(629),
    [sym_string_type] = ACTIONS(629),
    [sym_bytes_type] = ACTIONS(629),
    [sym_bool_type] = ACTIONS(629),
    [sym_bottom_lit] = ACTIONS(631),
    [sym_null] = ACTIONS(629),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_int_lit] = ACTIONS(629),
    [sym_float_lit] = ACTIONS(629),
    [anon_sym_LBRACK] = ACTIONS(629),
    [anon_sym_RBRACK] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(631),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(629),
    [anon_sym_if] = ACTIONS(629),
    [anon_sym_let] = ACTIONS(629),
    [anon_sym_PIPE] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_PIPE_PIPE] = ACTIONS(631),
    [anon_sym_AMP_AMP] = ACTIONS(631),
    [anon_sym_EQ_EQ] = ACTIONS(631),
    [anon_sym_BANG_EQ] = ACTIONS(631),
    [anon_sym_LT] = ACTIONS(629),
    [anon_sym_LT_EQ] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(629),
    [anon_sym_GT_EQ] = ACTIONS(631),
    [anon_sym_EQ_TILDE] = ACTIONS(631),
    [anon_sym_BANG_TILDE] = ACTIONS(631),
    [anon_sym_PLUS] = ACTIONS(631),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_STAR] = ACTIONS(631),
    [anon_sym_SLASH] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_LBRACK2] = ACTIONS(631),
    [sym_comment] = ACTIONS(3),
  },
  [129] = {
    [sym_identifier] = ACTIONS(605),
    [anon_sym_COMMA] = ACTIONS(607),
    [anon_sym_LPAREN] = ACTIONS(607),
    [anon_sym_RPAREN] = ACTIONS(607),
    [sym_dot] = ACTIONS(605),
    [anon_sym__] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [anon_sym_POUND_DQUOTE] = ACTIONS(605),
    [anon_sym_SQUOTE] = ACTIONS(605),
    [anon_sym_POUND_SQUOTE] = ACTIONS(605),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(607),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(607),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(607),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(607),
    [anon_sym_len] = ACTIONS(605),
    [anon_sym_close] = ACTIONS(605),
    [anon_sym_and] = ACTIONS(605),
    [anon_sym_or] = ACTIONS(605),
    [anon_sym_div] = ACTIONS(605),
    [anon_sym_mod] = ACTIONS(605),
    [anon_sym_quo] = ACTIONS(605),
    [anon_sym_rem] = ACTIONS(605),
    [sym_number_type] = ACTIONS(605),
    [anon_sym_float] = ACTIONS(605),
    [anon_sym_float32] = ACTIONS(605),
    [anon_sym_float64] = ACTIONS(605),
    [anon_sym_uint] = ACTIONS(605),
    [anon_sym_uint8] = ACTIONS(605),
    [anon_sym_uint16] = ACTIONS(605),
    [anon_sym_uint32] = ACTIONS(605),
    [anon_sym_uint64] = ACTIONS(605),
    [anon_sym_uint128] = ACTIONS(605),
    [anon_sym_int] = ACTIONS(605),
    [anon_sym_int8] = ACTIONS(605),
    [anon_sym_int16] = ACTIONS(605),
    [anon_sym_int32] = ACTIONS(605),
    [anon_sym_int64] = ACTIONS(605),
    [anon_sym_int128] = ACTIONS(605),
    [sym_string_type] = ACTIONS(605),
    [sym_bytes_type] = ACTIONS(605),
    [sym_bool_type] = ACTIONS(605),
    [sym_bottom_lit] = ACTIONS(607),
    [sym_null] = ACTIONS(605),
    [sym_true] = ACTIONS(605),
    [sym_false] = ACTIONS(605),
    [sym_int_lit] = ACTIONS(605),
    [sym_float_lit] = ACTIONS(605),
    [anon_sym_LBRACK] = ACTIONS(605),
    [anon_sym_RBRACK] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(607),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_if] = ACTIONS(605),
    [anon_sym_let] = ACTIONS(605),
    [anon_sym_PIPE] = ACTIONS(605),
    [anon_sym_AMP] = ACTIONS(605),
    [anon_sym_PIPE_PIPE] = ACTIONS(607),
    [anon_sym_AMP_AMP] = ACTIONS(607),
    [anon_sym_EQ_EQ] = ACTIONS(607),
    [anon_sym_BANG_EQ] = ACTIONS(607),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_LT_EQ] = ACTIONS(607),
    [anon_sym_GT] = ACTIONS(605),
    [anon_sym_GT_EQ] = ACTIONS(607),
    [anon_sym_EQ_TILDE] = ACTIONS(607),
    [anon_sym_BANG_TILDE] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(607),
    [anon_sym_DASH] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_SLASH] = ACTIONS(605),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_LBRACK2] = ACTIONS(607),
    [sym_comment] = ACTIONS(3),
  },
  [130] = {
    [sym_identifier] = ACTIONS(633),
    [anon_sym_COMMA] = ACTIONS(635),
    [anon_sym_LPAREN] = ACTIONS(635),
    [anon_sym_RPAREN] = ACTIONS(635),
    [sym_dot] = ACTIONS(633),
    [anon_sym__] = ACTIONS(633),
    [anon_sym_DQUOTE] = ACTIONS(633),
    [anon_sym_POUND_DQUOTE] = ACTIONS(633),
    [anon_sym_SQUOTE] = ACTIONS(633),
    [anon_sym_POUND_SQUOTE] = ACTIONS(633),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(635),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(635),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(635),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(635),
    [anon_sym_len] = ACTIONS(633),
    [anon_sym_close] = ACTIONS(633),
    [anon_sym_and] = ACTIONS(633),
    [anon_sym_or] = ACTIONS(633),
    [anon_sym_div] = ACTIONS(633),
    [anon_sym_mod] = ACTIONS(633),
    [anon_sym_quo] = ACTIONS(633),
    [anon_sym_rem] = ACTIONS(633),
    [sym_number_type] = ACTIONS(633),
    [anon_sym_float] = ACTIONS(633),
    [anon_sym_float32] = ACTIONS(633),
    [anon_sym_float64] = ACTIONS(633),
    [anon_sym_uint] = ACTIONS(633),
    [anon_sym_uint8] = ACTIONS(633),
    [anon_sym_uint16] = ACTIONS(633),
    [anon_sym_uint32] = ACTIONS(633),
    [anon_sym_uint64] = ACTIONS(633),
    [anon_sym_uint128] = ACTIONS(633),
    [anon_sym_int] = ACTIONS(633),
    [anon_sym_int8] = ACTIONS(633),
    [anon_sym_int16] = ACTIONS(633),
    [anon_sym_int32] = ACTIONS(633),
    [anon_sym_int64] = ACTIONS(633),
    [anon_sym_int128] = ACTIONS(633),
    [sym_string_type] = ACTIONS(633),
    [sym_bytes_type] = ACTIONS(633),
    [sym_bool_type] = ACTIONS(633),
    [sym_bottom_lit] = ACTIONS(635),
    [sym_null] = ACTIONS(633),
    [sym_true] = ACTIONS(633),
    [sym_false] = ACTIONS(633),
    [sym_int_lit] = ACTIONS(633),
    [sym_float_lit] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(633),
    [anon_sym_RBRACK] = ACTIONS(635),
    [anon_sym_LBRACE] = ACTIONS(635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(635),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_if] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(633),
    [anon_sym_PIPE] = ACTIONS(633),
    [anon_sym_AMP] = ACTIONS(633),
    [anon_sym_PIPE_PIPE] = ACTIONS(635),
    [anon_sym_AMP_AMP] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(635),
    [anon_sym_BANG_EQ] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(633),
    [anon_sym_LT_EQ] = ACTIONS(635),
    [anon_sym_GT] = ACTIONS(633),
    [anon_sym_GT_EQ] = ACTIONS(635),
    [anon_sym_EQ_TILDE] = ACTIONS(635),
    [anon_sym_BANG_TILDE] = ACTIONS(635),
    [anon_sym_PLUS] = ACTIONS(635),
    [anon_sym_DASH] = ACTIONS(635),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_SLASH] = ACTIONS(633),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LBRACK2] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
  },
  [131] = {
    [sym_identifier] = ACTIONS(637),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_RPAREN] = ACTIONS(639),
    [sym_dot] = ACTIONS(637),
    [anon_sym__] = ACTIONS(637),
    [anon_sym_DQUOTE] = ACTIONS(637),
    [anon_sym_POUND_DQUOTE] = ACTIONS(637),
    [anon_sym_SQUOTE] = ACTIONS(637),
    [anon_sym_POUND_SQUOTE] = ACTIONS(637),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(639),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(639),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(639),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(639),
    [anon_sym_len] = ACTIONS(637),
    [anon_sym_close] = ACTIONS(637),
    [anon_sym_and] = ACTIONS(637),
    [anon_sym_or] = ACTIONS(637),
    [anon_sym_div] = ACTIONS(637),
    [anon_sym_mod] = ACTIONS(637),
    [anon_sym_quo] = ACTIONS(637),
    [anon_sym_rem] = ACTIONS(637),
    [sym_number_type] = ACTIONS(637),
    [anon_sym_float] = ACTIONS(637),
    [anon_sym_float32] = ACTIONS(637),
    [anon_sym_float64] = ACTIONS(637),
    [anon_sym_uint] = ACTIONS(637),
    [anon_sym_uint8] = ACTIONS(637),
    [anon_sym_uint16] = ACTIONS(637),
    [anon_sym_uint32] = ACTIONS(637),
    [anon_sym_uint64] = ACTIONS(637),
    [anon_sym_uint128] = ACTIONS(637),
    [anon_sym_int] = ACTIONS(637),
    [anon_sym_int8] = ACTIONS(637),
    [anon_sym_int16] = ACTIONS(637),
    [anon_sym_int32] = ACTIONS(637),
    [anon_sym_int64] = ACTIONS(637),
    [anon_sym_int128] = ACTIONS(637),
    [sym_string_type] = ACTIONS(637),
    [sym_bytes_type] = ACTIONS(637),
    [sym_bool_type] = ACTIONS(637),
    [sym_bottom_lit] = ACTIONS(639),
    [sym_null] = ACTIONS(637),
    [sym_true] = ACTIONS(637),
    [sym_false] = ACTIONS(637),
    [sym_int_lit] = ACTIONS(637),
    [sym_float_lit] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(639),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(637),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_let] = ACTIONS(637),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(637),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_AMP_AMP] = ACTIONS(639),
    [anon_sym_EQ_EQ] = ACTIONS(639),
    [anon_sym_BANG_EQ] = ACTIONS(639),
    [anon_sym_LT] = ACTIONS(637),
    [anon_sym_LT_EQ] = ACTIONS(639),
    [anon_sym_GT] = ACTIONS(637),
    [anon_sym_GT_EQ] = ACTIONS(639),
    [anon_sym_EQ_TILDE] = ACTIONS(639),
    [anon_sym_BANG_TILDE] = ACTIONS(639),
    [anon_sym_PLUS] = ACTIONS(639),
    [anon_sym_DASH] = ACTIONS(639),
    [anon_sym_STAR] = ACTIONS(639),
    [anon_sym_SLASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(637),
    [anon_sym_LBRACK2] = ACTIONS(639),
    [sym_comment] = ACTIONS(3),
  },
  [132] = {
    [sym_identifier] = ACTIONS(609),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_LPAREN] = ACTIONS(611),
    [anon_sym_RPAREN] = ACTIONS(611),
    [sym_dot] = ACTIONS(609),
    [anon_sym__] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(609),
    [anon_sym_POUND_DQUOTE] = ACTIONS(609),
    [anon_sym_SQUOTE] = ACTIONS(609),
    [anon_sym_POUND_SQUOTE] = ACTIONS(609),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(611),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(611),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(611),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(611),
    [anon_sym_len] = ACTIONS(609),
    [anon_sym_close] = ACTIONS(609),
    [anon_sym_and] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(609),
    [anon_sym_div] = ACTIONS(609),
    [anon_sym_mod] = ACTIONS(609),
    [anon_sym_quo] = ACTIONS(609),
    [anon_sym_rem] = ACTIONS(609),
    [sym_number_type] = ACTIONS(609),
    [anon_sym_float] = ACTIONS(609),
    [anon_sym_float32] = ACTIONS(609),
    [anon_sym_float64] = ACTIONS(609),
    [anon_sym_uint] = ACTIONS(609),
    [anon_sym_uint8] = ACTIONS(609),
    [anon_sym_uint16] = ACTIONS(609),
    [anon_sym_uint32] = ACTIONS(609),
    [anon_sym_uint64] = ACTIONS(609),
    [anon_sym_uint128] = ACTIONS(609),
    [anon_sym_int] = ACTIONS(609),
    [anon_sym_int8] = ACTIONS(609),
    [anon_sym_int16] = ACTIONS(609),
    [anon_sym_int32] = ACTIONS(609),
    [anon_sym_int64] = ACTIONS(609),
    [anon_sym_int128] = ACTIONS(609),
    [sym_string_type] = ACTIONS(609),
    [sym_bytes_type] = ACTIONS(609),
    [sym_bool_type] = ACTIONS(609),
    [sym_bottom_lit] = ACTIONS(611),
    [sym_null] = ACTIONS(609),
    [sym_true] = ACTIONS(609),
    [sym_false] = ACTIONS(609),
    [sym_int_lit] = ACTIONS(609),
    [sym_float_lit] = ACTIONS(609),
    [anon_sym_LBRACK] = ACTIONS(609),
    [anon_sym_RBRACK] = ACTIONS(611),
    [anon_sym_LBRACE] = ACTIONS(611),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(611),
    [anon_sym_for] = ACTIONS(609),
    [anon_sym_if] = ACTIONS(609),
    [anon_sym_let] = ACTIONS(609),
    [anon_sym_PIPE] = ACTIONS(609),
    [anon_sym_AMP] = ACTIONS(609),
    [anon_sym_PIPE_PIPE] = ACTIONS(611),
    [anon_sym_AMP_AMP] = ACTIONS(611),
    [anon_sym_EQ_EQ] = ACTIONS(611),
    [anon_sym_BANG_EQ] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(609),
    [anon_sym_LT_EQ] = ACTIONS(611),
    [anon_sym_GT] = ACTIONS(609),
    [anon_sym_GT_EQ] = ACTIONS(611),
    [anon_sym_EQ_TILDE] = ACTIONS(611),
    [anon_sym_BANG_TILDE] = ACTIONS(611),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_STAR] = ACTIONS(611),
    [anon_sym_SLASH] = ACTIONS(609),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_LBRACK2] = ACTIONS(611),
    [sym_comment] = ACTIONS(3),
  },
  [133] = {
    [sym_identifier] = ACTIONS(641),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(643),
    [anon_sym_RPAREN] = ACTIONS(643),
    [sym_dot] = ACTIONS(641),
    [anon_sym__] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [anon_sym_POUND_DQUOTE] = ACTIONS(641),
    [anon_sym_SQUOTE] = ACTIONS(641),
    [anon_sym_POUND_SQUOTE] = ACTIONS(641),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(643),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(643),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(643),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(643),
    [anon_sym_len] = ACTIONS(641),
    [anon_sym_close] = ACTIONS(641),
    [anon_sym_and] = ACTIONS(641),
    [anon_sym_or] = ACTIONS(641),
    [anon_sym_div] = ACTIONS(641),
    [anon_sym_mod] = ACTIONS(641),
    [anon_sym_quo] = ACTIONS(641),
    [anon_sym_rem] = ACTIONS(641),
    [sym_number_type] = ACTIONS(641),
    [anon_sym_float] = ACTIONS(641),
    [anon_sym_float32] = ACTIONS(641),
    [anon_sym_float64] = ACTIONS(641),
    [anon_sym_uint] = ACTIONS(641),
    [anon_sym_uint8] = ACTIONS(641),
    [anon_sym_uint16] = ACTIONS(641),
    [anon_sym_uint32] = ACTIONS(641),
    [anon_sym_uint64] = ACTIONS(641),
    [anon_sym_uint128] = ACTIONS(641),
    [anon_sym_int] = ACTIONS(641),
    [anon_sym_int8] = ACTIONS(641),
    [anon_sym_int16] = ACTIONS(641),
    [anon_sym_int32] = ACTIONS(641),
    [anon_sym_int64] = ACTIONS(641),
    [anon_sym_int128] = ACTIONS(641),
    [sym_string_type] = ACTIONS(641),
    [sym_bytes_type] = ACTIONS(641),
    [sym_bool_type] = ACTIONS(641),
    [sym_bottom_lit] = ACTIONS(643),
    [sym_null] = ACTIONS(641),
    [sym_true] = ACTIONS(641),
    [sym_false] = ACTIONS(641),
    [sym_int_lit] = ACTIONS(641),
    [sym_float_lit] = ACTIONS(641),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_RBRACK] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(641),
    [anon_sym_let] = ACTIONS(641),
    [anon_sym_PIPE] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(641),
    [anon_sym_PIPE_PIPE] = ACTIONS(643),
    [anon_sym_AMP_AMP] = ACTIONS(643),
    [anon_sym_EQ_EQ] = ACTIONS(643),
    [anon_sym_BANG_EQ] = ACTIONS(643),
    [anon_sym_LT] = ACTIONS(641),
    [anon_sym_LT_EQ] = ACTIONS(643),
    [anon_sym_GT] = ACTIONS(641),
    [anon_sym_GT_EQ] = ACTIONS(643),
    [anon_sym_EQ_TILDE] = ACTIONS(643),
    [anon_sym_BANG_TILDE] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(643),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_STAR] = ACTIONS(643),
    [anon_sym_SLASH] = ACTIONS(641),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_LBRACK2] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
  },
  [134] = {
    [sym_identifier] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_RPAREN] = ACTIONS(655),
    [sym_dot] = ACTIONS(653),
    [anon_sym__] = ACTIONS(653),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_POUND_DQUOTE] = ACTIONS(653),
    [anon_sym_SQUOTE] = ACTIONS(653),
    [anon_sym_POUND_SQUOTE] = ACTIONS(653),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(655),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(655),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(655),
    [anon_sym_len] = ACTIONS(653),
    [anon_sym_close] = ACTIONS(653),
    [anon_sym_and] = ACTIONS(653),
    [anon_sym_or] = ACTIONS(653),
    [anon_sym_div] = ACTIONS(653),
    [anon_sym_mod] = ACTIONS(653),
    [anon_sym_quo] = ACTIONS(653),
    [anon_sym_rem] = ACTIONS(653),
    [sym_number_type] = ACTIONS(653),
    [anon_sym_float] = ACTIONS(653),
    [anon_sym_float32] = ACTIONS(653),
    [anon_sym_float64] = ACTIONS(653),
    [anon_sym_uint] = ACTIONS(653),
    [anon_sym_uint8] = ACTIONS(653),
    [anon_sym_uint16] = ACTIONS(653),
    [anon_sym_uint32] = ACTIONS(653),
    [anon_sym_uint64] = ACTIONS(653),
    [anon_sym_uint128] = ACTIONS(653),
    [anon_sym_int] = ACTIONS(653),
    [anon_sym_int8] = ACTIONS(653),
    [anon_sym_int16] = ACTIONS(653),
    [anon_sym_int32] = ACTIONS(653),
    [anon_sym_int64] = ACTIONS(653),
    [anon_sym_int128] = ACTIONS(653),
    [sym_string_type] = ACTIONS(653),
    [sym_bytes_type] = ACTIONS(653),
    [sym_bool_type] = ACTIONS(653),
    [sym_bottom_lit] = ACTIONS(655),
    [sym_null] = ACTIONS(653),
    [sym_true] = ACTIONS(653),
    [sym_false] = ACTIONS(653),
    [sym_int_lit] = ACTIONS(653),
    [sym_float_lit] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(653),
    [anon_sym_RBRACK] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(655),
    [anon_sym_for] = ACTIONS(653),
    [anon_sym_if] = ACTIONS(653),
    [anon_sym_let] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(653),
    [anon_sym_PIPE_PIPE] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(655),
    [anon_sym_EQ_EQ] = ACTIONS(655),
    [anon_sym_BANG_EQ] = ACTIONS(655),
    [anon_sym_LT] = ACTIONS(653),
    [anon_sym_LT_EQ] = ACTIONS(655),
    [anon_sym_GT] = ACTIONS(653),
    [anon_sym_GT_EQ] = ACTIONS(655),
    [anon_sym_EQ_TILDE] = ACTIONS(655),
    [anon_sym_BANG_TILDE] = ACTIONS(655),
    [anon_sym_PLUS] = ACTIONS(655),
    [anon_sym_DASH] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(655),
    [anon_sym_SLASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(653),
    [anon_sym_LBRACK2] = ACTIONS(655),
    [sym_comment] = ACTIONS(3),
  },
  [135] = {
    [sym_identifier] = ACTIONS(657),
    [anon_sym_COMMA] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(659),
    [anon_sym_RPAREN] = ACTIONS(659),
    [sym_dot] = ACTIONS(657),
    [anon_sym__] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(657),
    [anon_sym_POUND_DQUOTE] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_POUND_SQUOTE] = ACTIONS(657),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(659),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(659),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(659),
    [anon_sym_len] = ACTIONS(657),
    [anon_sym_close] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(657),
    [anon_sym_or] = ACTIONS(657),
    [anon_sym_div] = ACTIONS(657),
    [anon_sym_mod] = ACTIONS(657),
    [anon_sym_quo] = ACTIONS(657),
    [anon_sym_rem] = ACTIONS(657),
    [sym_number_type] = ACTIONS(657),
    [anon_sym_float] = ACTIONS(657),
    [anon_sym_float32] = ACTIONS(657),
    [anon_sym_float64] = ACTIONS(657),
    [anon_sym_uint] = ACTIONS(657),
    [anon_sym_uint8] = ACTIONS(657),
    [anon_sym_uint16] = ACTIONS(657),
    [anon_sym_uint32] = ACTIONS(657),
    [anon_sym_uint64] = ACTIONS(657),
    [anon_sym_uint128] = ACTIONS(657),
    [anon_sym_int] = ACTIONS(657),
    [anon_sym_int8] = ACTIONS(657),
    [anon_sym_int16] = ACTIONS(657),
    [anon_sym_int32] = ACTIONS(657),
    [anon_sym_int64] = ACTIONS(657),
    [anon_sym_int128] = ACTIONS(657),
    [sym_string_type] = ACTIONS(657),
    [sym_bytes_type] = ACTIONS(657),
    [sym_bool_type] = ACTIONS(657),
    [sym_bottom_lit] = ACTIONS(659),
    [sym_null] = ACTIONS(657),
    [sym_true] = ACTIONS(657),
    [sym_false] = ACTIONS(657),
    [sym_int_lit] = ACTIONS(657),
    [sym_float_lit] = ACTIONS(657),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_RBRACK] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(659),
    [anon_sym_for] = ACTIONS(657),
    [anon_sym_if] = ACTIONS(657),
    [anon_sym_let] = ACTIONS(657),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(659),
    [anon_sym_EQ_EQ] = ACTIONS(659),
    [anon_sym_BANG_EQ] = ACTIONS(659),
    [anon_sym_LT] = ACTIONS(657),
    [anon_sym_LT_EQ] = ACTIONS(659),
    [anon_sym_GT] = ACTIONS(657),
    [anon_sym_GT_EQ] = ACTIONS(659),
    [anon_sym_EQ_TILDE] = ACTIONS(659),
    [anon_sym_BANG_TILDE] = ACTIONS(659),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_STAR] = ACTIONS(659),
    [anon_sym_SLASH] = ACTIONS(657),
    [anon_sym_BANG] = ACTIONS(657),
    [anon_sym_LBRACK2] = ACTIONS(659),
    [sym_comment] = ACTIONS(3),
  },
  [136] = {
    [sym_identifier] = ACTIONS(661),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RPAREN] = ACTIONS(663),
    [sym_dot] = ACTIONS(661),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_DQUOTE] = ACTIONS(661),
    [anon_sym_POUND_DQUOTE] = ACTIONS(661),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_POUND_SQUOTE] = ACTIONS(661),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(663),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(663),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(663),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(663),
    [anon_sym_len] = ACTIONS(661),
    [anon_sym_close] = ACTIONS(661),
    [anon_sym_and] = ACTIONS(661),
    [anon_sym_or] = ACTIONS(661),
    [anon_sym_div] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_quo] = ACTIONS(661),
    [anon_sym_rem] = ACTIONS(661),
    [sym_number_type] = ACTIONS(661),
    [anon_sym_float] = ACTIONS(661),
    [anon_sym_float32] = ACTIONS(661),
    [anon_sym_float64] = ACTIONS(661),
    [anon_sym_uint] = ACTIONS(661),
    [anon_sym_uint8] = ACTIONS(661),
    [anon_sym_uint16] = ACTIONS(661),
    [anon_sym_uint32] = ACTIONS(661),
    [anon_sym_uint64] = ACTIONS(661),
    [anon_sym_uint128] = ACTIONS(661),
    [anon_sym_int] = ACTIONS(661),
    [anon_sym_int8] = ACTIONS(661),
    [anon_sym_int16] = ACTIONS(661),
    [anon_sym_int32] = ACTIONS(661),
    [anon_sym_int64] = ACTIONS(661),
    [anon_sym_int128] = ACTIONS(661),
    [sym_string_type] = ACTIONS(661),
    [sym_bytes_type] = ACTIONS(661),
    [sym_bool_type] = ACTIONS(661),
    [sym_bottom_lit] = ACTIONS(663),
    [sym_null] = ACTIONS(661),
    [sym_true] = ACTIONS(661),
    [sym_false] = ACTIONS(661),
    [sym_int_lit] = ACTIONS(661),
    [sym_float_lit] = ACTIONS(661),
    [anon_sym_LBRACK] = ACTIONS(661),
    [anon_sym_RBRACK] = ACTIONS(663),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_PIPE] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_LT] = ACTIONS(661),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(661),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ_TILDE] = ACTIONS(663),
    [anon_sym_BANG_TILDE] = ACTIONS(663),
    [anon_sym_PLUS] = ACTIONS(663),
    [anon_sym_DASH] = ACTIONS(663),
    [anon_sym_STAR] = ACTIONS(663),
    [anon_sym_SLASH] = ACTIONS(661),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
  },
  [137] = {
    [sym_identifier] = ACTIONS(685),
    [anon_sym_COMMA] = ACTIONS(687),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RPAREN] = ACTIONS(687),
    [sym_dot] = ACTIONS(685),
    [anon_sym__] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_POUND_DQUOTE] = ACTIONS(685),
    [anon_sym_SQUOTE] = ACTIONS(685),
    [anon_sym_POUND_SQUOTE] = ACTIONS(685),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(687),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(687),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(687),
    [anon_sym_len] = ACTIONS(685),
    [anon_sym_close] = ACTIONS(685),
    [anon_sym_and] = ACTIONS(685),
    [anon_sym_or] = ACTIONS(685),
    [anon_sym_div] = ACTIONS(685),
    [anon_sym_mod] = ACTIONS(685),
    [anon_sym_quo] = ACTIONS(685),
    [anon_sym_rem] = ACTIONS(685),
    [sym_number_type] = ACTIONS(685),
    [anon_sym_float] = ACTIONS(685),
    [anon_sym_float32] = ACTIONS(685),
    [anon_sym_float64] = ACTIONS(685),
    [anon_sym_uint] = ACTIONS(685),
    [anon_sym_uint8] = ACTIONS(685),
    [anon_sym_uint16] = ACTIONS(685),
    [anon_sym_uint32] = ACTIONS(685),
    [anon_sym_uint64] = ACTIONS(685),
    [anon_sym_uint128] = ACTIONS(685),
    [anon_sym_int] = ACTIONS(685),
    [anon_sym_int8] = ACTIONS(685),
    [anon_sym_int16] = ACTIONS(685),
    [anon_sym_int32] = ACTIONS(685),
    [anon_sym_int64] = ACTIONS(685),
    [anon_sym_int128] = ACTIONS(685),
    [sym_string_type] = ACTIONS(685),
    [sym_bytes_type] = ACTIONS(685),
    [sym_bool_type] = ACTIONS(685),
    [sym_bottom_lit] = ACTIONS(687),
    [sym_null] = ACTIONS(685),
    [sym_true] = ACTIONS(685),
    [sym_false] = ACTIONS(685),
    [sym_int_lit] = ACTIONS(685),
    [sym_float_lit] = ACTIONS(685),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_RBRACK] = ACTIONS(687),
    [anon_sym_LBRACE] = ACTIONS(687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(687),
    [anon_sym_for] = ACTIONS(685),
    [anon_sym_if] = ACTIONS(685),
    [anon_sym_let] = ACTIONS(685),
    [anon_sym_PIPE] = ACTIONS(685),
    [anon_sym_AMP] = ACTIONS(685),
    [anon_sym_PIPE_PIPE] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(687),
    [anon_sym_BANG_EQ] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(685),
    [anon_sym_LT_EQ] = ACTIONS(687),
    [anon_sym_GT] = ACTIONS(685),
    [anon_sym_GT_EQ] = ACTIONS(687),
    [anon_sym_EQ_TILDE] = ACTIONS(687),
    [anon_sym_BANG_TILDE] = ACTIONS(687),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(685),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_LBRACK2] = ACTIONS(687),
    [sym_comment] = ACTIONS(3),
  },
  [138] = {
    [sym_identifier] = ACTIONS(669),
    [anon_sym_COMMA] = ACTIONS(671),
    [anon_sym_LPAREN] = ACTIONS(671),
    [anon_sym_RPAREN] = ACTIONS(671),
    [sym_dot] = ACTIONS(669),
    [anon_sym__] = ACTIONS(669),
    [anon_sym_DQUOTE] = ACTIONS(669),
    [anon_sym_POUND_DQUOTE] = ACTIONS(669),
    [anon_sym_SQUOTE] = ACTIONS(669),
    [anon_sym_POUND_SQUOTE] = ACTIONS(669),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(671),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(671),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(671),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(671),
    [anon_sym_len] = ACTIONS(669),
    [anon_sym_close] = ACTIONS(669),
    [anon_sym_and] = ACTIONS(669),
    [anon_sym_or] = ACTIONS(669),
    [anon_sym_div] = ACTIONS(669),
    [anon_sym_mod] = ACTIONS(669),
    [anon_sym_quo] = ACTIONS(669),
    [anon_sym_rem] = ACTIONS(669),
    [sym_number_type] = ACTIONS(669),
    [anon_sym_float] = ACTIONS(669),
    [anon_sym_float32] = ACTIONS(669),
    [anon_sym_float64] = ACTIONS(669),
    [anon_sym_uint] = ACTIONS(669),
    [anon_sym_uint8] = ACTIONS(669),
    [anon_sym_uint16] = ACTIONS(669),
    [anon_sym_uint32] = ACTIONS(669),
    [anon_sym_uint64] = ACTIONS(669),
    [anon_sym_uint128] = ACTIONS(669),
    [anon_sym_int] = ACTIONS(669),
    [anon_sym_int8] = ACTIONS(669),
    [anon_sym_int16] = ACTIONS(669),
    [anon_sym_int32] = ACTIONS(669),
    [anon_sym_int64] = ACTIONS(669),
    [anon_sym_int128] = ACTIONS(669),
    [sym_string_type] = ACTIONS(669),
    [sym_bytes_type] = ACTIONS(669),
    [sym_bool_type] = ACTIONS(669),
    [sym_bottom_lit] = ACTIONS(671),
    [sym_null] = ACTIONS(669),
    [sym_true] = ACTIONS(669),
    [sym_false] = ACTIONS(669),
    [sym_int_lit] = ACTIONS(669),
    [sym_float_lit] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_RBRACK] = ACTIONS(671),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_if] = ACTIONS(669),
    [anon_sym_let] = ACTIONS(669),
    [anon_sym_PIPE] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_PIPE_PIPE] = ACTIONS(671),
    [anon_sym_AMP_AMP] = ACTIONS(671),
    [anon_sym_EQ_EQ] = ACTIONS(671),
    [anon_sym_BANG_EQ] = ACTIONS(671),
    [anon_sym_LT] = ACTIONS(669),
    [anon_sym_LT_EQ] = ACTIONS(671),
    [anon_sym_GT] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(671),
    [anon_sym_EQ_TILDE] = ACTIONS(671),
    [anon_sym_BANG_TILDE] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_LBRACK2] = ACTIONS(671),
    [sym_comment] = ACTIONS(3),
  },
  [139] = {
    [sym_identifier] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(675),
    [anon_sym_LPAREN] = ACTIONS(675),
    [anon_sym_RPAREN] = ACTIONS(675),
    [sym_dot] = ACTIONS(673),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_POUND_DQUOTE] = ACTIONS(673),
    [anon_sym_SQUOTE] = ACTIONS(673),
    [anon_sym_POUND_SQUOTE] = ACTIONS(673),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(675),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(675),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(675),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(675),
    [anon_sym_len] = ACTIONS(673),
    [anon_sym_close] = ACTIONS(673),
    [anon_sym_and] = ACTIONS(673),
    [anon_sym_or] = ACTIONS(673),
    [anon_sym_div] = ACTIONS(673),
    [anon_sym_mod] = ACTIONS(673),
    [anon_sym_quo] = ACTIONS(673),
    [anon_sym_rem] = ACTIONS(673),
    [sym_number_type] = ACTIONS(673),
    [anon_sym_float] = ACTIONS(673),
    [anon_sym_float32] = ACTIONS(673),
    [anon_sym_float64] = ACTIONS(673),
    [anon_sym_uint] = ACTIONS(673),
    [anon_sym_uint8] = ACTIONS(673),
    [anon_sym_uint16] = ACTIONS(673),
    [anon_sym_uint32] = ACTIONS(673),
    [anon_sym_uint64] = ACTIONS(673),
    [anon_sym_uint128] = ACTIONS(673),
    [anon_sym_int] = ACTIONS(673),
    [anon_sym_int8] = ACTIONS(673),
    [anon_sym_int16] = ACTIONS(673),
    [anon_sym_int32] = ACTIONS(673),
    [anon_sym_int64] = ACTIONS(673),
    [anon_sym_int128] = ACTIONS(673),
    [sym_string_type] = ACTIONS(673),
    [sym_bytes_type] = ACTIONS(673),
    [sym_bool_type] = ACTIONS(673),
    [sym_bottom_lit] = ACTIONS(675),
    [sym_null] = ACTIONS(673),
    [sym_true] = ACTIONS(673),
    [sym_false] = ACTIONS(673),
    [sym_int_lit] = ACTIONS(673),
    [sym_float_lit] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(673),
    [anon_sym_RBRACK] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(675),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(673),
    [anon_sym_if] = ACTIONS(673),
    [anon_sym_let] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE_PIPE] = ACTIONS(675),
    [anon_sym_AMP_AMP] = ACTIONS(675),
    [anon_sym_EQ_EQ] = ACTIONS(675),
    [anon_sym_BANG_EQ] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_EQ_TILDE] = ACTIONS(675),
    [anon_sym_BANG_TILDE] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_STAR] = ACTIONS(675),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_LBRACK2] = ACTIONS(675),
    [sym_comment] = ACTIONS(3),
  },
  [140] = {
    [sym_identifier] = ACTIONS(681),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym_dot] = ACTIONS(681),
    [anon_sym__] = ACTIONS(681),
    [anon_sym_DQUOTE] = ACTIONS(681),
    [anon_sym_POUND_DQUOTE] = ACTIONS(681),
    [anon_sym_SQUOTE] = ACTIONS(681),
    [anon_sym_POUND_SQUOTE] = ACTIONS(681),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(683),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(683),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(683),
    [anon_sym_len] = ACTIONS(681),
    [anon_sym_close] = ACTIONS(681),
    [anon_sym_and] = ACTIONS(681),
    [anon_sym_or] = ACTIONS(681),
    [anon_sym_div] = ACTIONS(681),
    [anon_sym_mod] = ACTIONS(681),
    [anon_sym_quo] = ACTIONS(681),
    [anon_sym_rem] = ACTIONS(681),
    [sym_number_type] = ACTIONS(681),
    [anon_sym_float] = ACTIONS(681),
    [anon_sym_float32] = ACTIONS(681),
    [anon_sym_float64] = ACTIONS(681),
    [anon_sym_uint] = ACTIONS(681),
    [anon_sym_uint8] = ACTIONS(681),
    [anon_sym_uint16] = ACTIONS(681),
    [anon_sym_uint32] = ACTIONS(681),
    [anon_sym_uint64] = ACTIONS(681),
    [anon_sym_uint128] = ACTIONS(681),
    [anon_sym_int] = ACTIONS(681),
    [anon_sym_int8] = ACTIONS(681),
    [anon_sym_int16] = ACTIONS(681),
    [anon_sym_int32] = ACTIONS(681),
    [anon_sym_int64] = ACTIONS(681),
    [anon_sym_int128] = ACTIONS(681),
    [sym_string_type] = ACTIONS(681),
    [sym_bytes_type] = ACTIONS(681),
    [sym_bool_type] = ACTIONS(681),
    [sym_bottom_lit] = ACTIONS(683),
    [sym_null] = ACTIONS(681),
    [sym_true] = ACTIONS(681),
    [sym_false] = ACTIONS(681),
    [sym_int_lit] = ACTIONS(681),
    [sym_float_lit] = ACTIONS(681),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_RBRACK] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(683),
    [anon_sym_for] = ACTIONS(681),
    [anon_sym_if] = ACTIONS(681),
    [anon_sym_let] = ACTIONS(681),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_AMP] = ACTIONS(681),
    [anon_sym_PIPE_PIPE] = ACTIONS(683),
    [anon_sym_AMP_AMP] = ACTIONS(683),
    [anon_sym_EQ_EQ] = ACTIONS(683),
    [anon_sym_BANG_EQ] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_LT_EQ] = ACTIONS(683),
    [anon_sym_GT] = ACTIONS(681),
    [anon_sym_GT_EQ] = ACTIONS(683),
    [anon_sym_EQ_TILDE] = ACTIONS(683),
    [anon_sym_BANG_TILDE] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(681),
    [anon_sym_LBRACK2] = ACTIONS(683),
    [sym_comment] = ACTIONS(3),
  },
  [141] = {
    [sym_identifier] = ACTIONS(689),
    [anon_sym_COMMA] = ACTIONS(691),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_RPAREN] = ACTIONS(691),
    [sym_dot] = ACTIONS(689),
    [anon_sym__] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [anon_sym_POUND_DQUOTE] = ACTIONS(689),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_POUND_SQUOTE] = ACTIONS(689),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(691),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(691),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(691),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(691),
    [anon_sym_len] = ACTIONS(689),
    [anon_sym_close] = ACTIONS(689),
    [anon_sym_and] = ACTIONS(689),
    [anon_sym_or] = ACTIONS(689),
    [anon_sym_div] = ACTIONS(689),
    [anon_sym_mod] = ACTIONS(689),
    [anon_sym_quo] = ACTIONS(689),
    [anon_sym_rem] = ACTIONS(689),
    [sym_number_type] = ACTIONS(689),
    [anon_sym_float] = ACTIONS(689),
    [anon_sym_float32] = ACTIONS(689),
    [anon_sym_float64] = ACTIONS(689),
    [anon_sym_uint] = ACTIONS(689),
    [anon_sym_uint8] = ACTIONS(689),
    [anon_sym_uint16] = ACTIONS(689),
    [anon_sym_uint32] = ACTIONS(689),
    [anon_sym_uint64] = ACTIONS(689),
    [anon_sym_uint128] = ACTIONS(689),
    [anon_sym_int] = ACTIONS(689),
    [anon_sym_int8] = ACTIONS(689),
    [anon_sym_int16] = ACTIONS(689),
    [anon_sym_int32] = ACTIONS(689),
    [anon_sym_int64] = ACTIONS(689),
    [anon_sym_int128] = ACTIONS(689),
    [sym_string_type] = ACTIONS(689),
    [sym_bytes_type] = ACTIONS(689),
    [sym_bool_type] = ACTIONS(689),
    [sym_bottom_lit] = ACTIONS(691),
    [sym_null] = ACTIONS(689),
    [sym_true] = ACTIONS(689),
    [sym_false] = ACTIONS(689),
    [sym_int_lit] = ACTIONS(689),
    [sym_float_lit] = ACTIONS(689),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_RBRACK] = ACTIONS(691),
    [anon_sym_LBRACE] = ACTIONS(691),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(691),
    [anon_sym_for] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(689),
    [anon_sym_let] = ACTIONS(689),
    [anon_sym_PIPE] = ACTIONS(689),
    [anon_sym_AMP] = ACTIONS(689),
    [anon_sym_PIPE_PIPE] = ACTIONS(691),
    [anon_sym_AMP_AMP] = ACTIONS(691),
    [anon_sym_EQ_EQ] = ACTIONS(691),
    [anon_sym_BANG_EQ] = ACTIONS(691),
    [anon_sym_LT] = ACTIONS(689),
    [anon_sym_LT_EQ] = ACTIONS(691),
    [anon_sym_GT] = ACTIONS(689),
    [anon_sym_GT_EQ] = ACTIONS(691),
    [anon_sym_EQ_TILDE] = ACTIONS(691),
    [anon_sym_BANG_TILDE] = ACTIONS(691),
    [anon_sym_PLUS] = ACTIONS(691),
    [anon_sym_DASH] = ACTIONS(691),
    [anon_sym_STAR] = ACTIONS(691),
    [anon_sym_SLASH] = ACTIONS(689),
    [anon_sym_BANG] = ACTIONS(689),
    [anon_sym_LBRACK2] = ACTIONS(691),
    [sym_comment] = ACTIONS(3),
  },
  [142] = {
    [sym_identifier] = ACTIONS(705),
    [anon_sym_COMMA] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(707),
    [anon_sym_RPAREN] = ACTIONS(707),
    [sym_dot] = ACTIONS(705),
    [anon_sym__] = ACTIONS(705),
    [anon_sym_DQUOTE] = ACTIONS(705),
    [anon_sym_POUND_DQUOTE] = ACTIONS(705),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [anon_sym_POUND_SQUOTE] = ACTIONS(705),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(707),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(707),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(707),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(707),
    [anon_sym_len] = ACTIONS(705),
    [anon_sym_close] = ACTIONS(705),
    [anon_sym_and] = ACTIONS(705),
    [anon_sym_or] = ACTIONS(705),
    [anon_sym_div] = ACTIONS(705),
    [anon_sym_mod] = ACTIONS(705),
    [anon_sym_quo] = ACTIONS(705),
    [anon_sym_rem] = ACTIONS(705),
    [sym_number_type] = ACTIONS(705),
    [anon_sym_float] = ACTIONS(705),
    [anon_sym_float32] = ACTIONS(705),
    [anon_sym_float64] = ACTIONS(705),
    [anon_sym_uint] = ACTIONS(705),
    [anon_sym_uint8] = ACTIONS(705),
    [anon_sym_uint16] = ACTIONS(705),
    [anon_sym_uint32] = ACTIONS(705),
    [anon_sym_uint64] = ACTIONS(705),
    [anon_sym_uint128] = ACTIONS(705),
    [anon_sym_int] = ACTIONS(705),
    [anon_sym_int8] = ACTIONS(705),
    [anon_sym_int16] = ACTIONS(705),
    [anon_sym_int32] = ACTIONS(705),
    [anon_sym_int64] = ACTIONS(705),
    [anon_sym_int128] = ACTIONS(705),
    [sym_string_type] = ACTIONS(705),
    [sym_bytes_type] = ACTIONS(705),
    [sym_bool_type] = ACTIONS(705),
    [sym_bottom_lit] = ACTIONS(707),
    [sym_null] = ACTIONS(705),
    [sym_true] = ACTIONS(705),
    [sym_false] = ACTIONS(705),
    [sym_int_lit] = ACTIONS(705),
    [sym_float_lit] = ACTIONS(705),
    [anon_sym_LBRACK] = ACTIONS(705),
    [anon_sym_RBRACK] = ACTIONS(707),
    [anon_sym_LBRACE] = ACTIONS(707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(707),
    [anon_sym_for] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(705),
    [anon_sym_let] = ACTIONS(705),
    [anon_sym_PIPE] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(707),
    [anon_sym_EQ_EQ] = ACTIONS(707),
    [anon_sym_BANG_EQ] = ACTIONS(707),
    [anon_sym_LT] = ACTIONS(705),
    [anon_sym_LT_EQ] = ACTIONS(707),
    [anon_sym_GT] = ACTIONS(705),
    [anon_sym_GT_EQ] = ACTIONS(707),
    [anon_sym_EQ_TILDE] = ACTIONS(707),
    [anon_sym_BANG_TILDE] = ACTIONS(707),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(707),
    [anon_sym_STAR] = ACTIONS(707),
    [anon_sym_SLASH] = ACTIONS(705),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_LBRACK2] = ACTIONS(707),
    [sym_comment] = ACTIONS(3),
  },
  [143] = {
    [sym_identifier] = ACTIONS(697),
    [anon_sym_COMMA] = ACTIONS(699),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(699),
    [sym_dot] = ACTIONS(697),
    [anon_sym__] = ACTIONS(697),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_POUND_DQUOTE] = ACTIONS(697),
    [anon_sym_SQUOTE] = ACTIONS(697),
    [anon_sym_POUND_SQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(699),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(699),
    [anon_sym_len] = ACTIONS(697),
    [anon_sym_close] = ACTIONS(697),
    [anon_sym_and] = ACTIONS(697),
    [anon_sym_or] = ACTIONS(697),
    [anon_sym_div] = ACTIONS(697),
    [anon_sym_mod] = ACTIONS(697),
    [anon_sym_quo] = ACTIONS(697),
    [anon_sym_rem] = ACTIONS(697),
    [sym_number_type] = ACTIONS(697),
    [anon_sym_float] = ACTIONS(697),
    [anon_sym_float32] = ACTIONS(697),
    [anon_sym_float64] = ACTIONS(697),
    [anon_sym_uint] = ACTIONS(697),
    [anon_sym_uint8] = ACTIONS(697),
    [anon_sym_uint16] = ACTIONS(697),
    [anon_sym_uint32] = ACTIONS(697),
    [anon_sym_uint64] = ACTIONS(697),
    [anon_sym_uint128] = ACTIONS(697),
    [anon_sym_int] = ACTIONS(697),
    [anon_sym_int8] = ACTIONS(697),
    [anon_sym_int16] = ACTIONS(697),
    [anon_sym_int32] = ACTIONS(697),
    [anon_sym_int64] = ACTIONS(697),
    [anon_sym_int128] = ACTIONS(697),
    [sym_string_type] = ACTIONS(697),
    [sym_bytes_type] = ACTIONS(697),
    [sym_bool_type] = ACTIONS(697),
    [sym_bottom_lit] = ACTIONS(699),
    [sym_null] = ACTIONS(697),
    [sym_true] = ACTIONS(697),
    [sym_false] = ACTIONS(697),
    [sym_int_lit] = ACTIONS(697),
    [sym_float_lit] = ACTIONS(697),
    [anon_sym_LBRACK] = ACTIONS(697),
    [anon_sym_RBRACK] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(699),
    [anon_sym_for] = ACTIONS(697),
    [anon_sym_if] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(697),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_EQ_EQ] = ACTIONS(699),
    [anon_sym_BANG_EQ] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_LT_EQ] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_GT_EQ] = ACTIONS(699),
    [anon_sym_EQ_TILDE] = ACTIONS(699),
    [anon_sym_BANG_TILDE] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(699),
    [anon_sym_STAR] = ACTIONS(699),
    [anon_sym_SLASH] = ACTIONS(697),
    [anon_sym_BANG] = ACTIONS(697),
    [anon_sym_LBRACK2] = ACTIONS(699),
    [sym_comment] = ACTIONS(3),
  },
  [144] = {
    [sym_identifier] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(679),
    [sym_dot] = ACTIONS(677),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(677),
    [anon_sym_POUND_DQUOTE] = ACTIONS(677),
    [anon_sym_SQUOTE] = ACTIONS(677),
    [anon_sym_POUND_SQUOTE] = ACTIONS(677),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(679),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(679),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(679),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(679),
    [anon_sym_len] = ACTIONS(677),
    [anon_sym_close] = ACTIONS(677),
    [anon_sym_and] = ACTIONS(677),
    [anon_sym_or] = ACTIONS(677),
    [anon_sym_div] = ACTIONS(677),
    [anon_sym_mod] = ACTIONS(677),
    [anon_sym_quo] = ACTIONS(677),
    [anon_sym_rem] = ACTIONS(677),
    [sym_number_type] = ACTIONS(677),
    [anon_sym_float] = ACTIONS(677),
    [anon_sym_float32] = ACTIONS(677),
    [anon_sym_float64] = ACTIONS(677),
    [anon_sym_uint] = ACTIONS(677),
    [anon_sym_uint8] = ACTIONS(677),
    [anon_sym_uint16] = ACTIONS(677),
    [anon_sym_uint32] = ACTIONS(677),
    [anon_sym_uint64] = ACTIONS(677),
    [anon_sym_uint128] = ACTIONS(677),
    [anon_sym_int] = ACTIONS(677),
    [anon_sym_int8] = ACTIONS(677),
    [anon_sym_int16] = ACTIONS(677),
    [anon_sym_int32] = ACTIONS(677),
    [anon_sym_int64] = ACTIONS(677),
    [anon_sym_int128] = ACTIONS(677),
    [sym_string_type] = ACTIONS(677),
    [sym_bytes_type] = ACTIONS(677),
    [sym_bool_type] = ACTIONS(677),
    [sym_bottom_lit] = ACTIONS(679),
    [sym_null] = ACTIONS(677),
    [sym_true] = ACTIONS(677),
    [sym_false] = ACTIONS(677),
    [sym_int_lit] = ACTIONS(677),
    [sym_float_lit] = ACTIONS(677),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_if] = ACTIONS(677),
    [anon_sym_let] = ACTIONS(677),
    [anon_sym_PIPE] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_EQ_EQ] = ACTIONS(679),
    [anon_sym_BANG_EQ] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_LT_EQ] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(677),
    [anon_sym_GT_EQ] = ACTIONS(679),
    [anon_sym_EQ_TILDE] = ACTIONS(679),
    [anon_sym_BANG_TILDE] = ACTIONS(679),
    [anon_sym_PLUS] = ACTIONS(679),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_STAR] = ACTIONS(679),
    [anon_sym_SLASH] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_LBRACK2] = ACTIONS(679),
    [sym_comment] = ACTIONS(3),
  },
  [145] = {
    [sym_identifier] = ACTIONS(665),
    [anon_sym_COMMA] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(667),
    [anon_sym_RPAREN] = ACTIONS(667),
    [sym_dot] = ACTIONS(665),
    [anon_sym__] = ACTIONS(665),
    [anon_sym_DQUOTE] = ACTIONS(665),
    [anon_sym_POUND_DQUOTE] = ACTIONS(665),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [anon_sym_POUND_SQUOTE] = ACTIONS(665),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(667),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(667),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(667),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(667),
    [anon_sym_len] = ACTIONS(665),
    [anon_sym_close] = ACTIONS(665),
    [anon_sym_and] = ACTIONS(665),
    [anon_sym_or] = ACTIONS(665),
    [anon_sym_div] = ACTIONS(665),
    [anon_sym_mod] = ACTIONS(665),
    [anon_sym_quo] = ACTIONS(665),
    [anon_sym_rem] = ACTIONS(665),
    [sym_number_type] = ACTIONS(665),
    [anon_sym_float] = ACTIONS(665),
    [anon_sym_float32] = ACTIONS(665),
    [anon_sym_float64] = ACTIONS(665),
    [anon_sym_uint] = ACTIONS(665),
    [anon_sym_uint8] = ACTIONS(665),
    [anon_sym_uint16] = ACTIONS(665),
    [anon_sym_uint32] = ACTIONS(665),
    [anon_sym_uint64] = ACTIONS(665),
    [anon_sym_uint128] = ACTIONS(665),
    [anon_sym_int] = ACTIONS(665),
    [anon_sym_int8] = ACTIONS(665),
    [anon_sym_int16] = ACTIONS(665),
    [anon_sym_int32] = ACTIONS(665),
    [anon_sym_int64] = ACTIONS(665),
    [anon_sym_int128] = ACTIONS(665),
    [sym_string_type] = ACTIONS(665),
    [sym_bytes_type] = ACTIONS(665),
    [sym_bool_type] = ACTIONS(665),
    [sym_bottom_lit] = ACTIONS(667),
    [sym_null] = ACTIONS(665),
    [sym_true] = ACTIONS(665),
    [sym_false] = ACTIONS(665),
    [sym_int_lit] = ACTIONS(665),
    [sym_float_lit] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(665),
    [anon_sym_RBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(665),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_let] = ACTIONS(665),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_AMP] = ACTIONS(665),
    [anon_sym_PIPE_PIPE] = ACTIONS(667),
    [anon_sym_AMP_AMP] = ACTIONS(667),
    [anon_sym_EQ_EQ] = ACTIONS(667),
    [anon_sym_BANG_EQ] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_LT_EQ] = ACTIONS(667),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_EQ] = ACTIONS(667),
    [anon_sym_EQ_TILDE] = ACTIONS(667),
    [anon_sym_BANG_TILDE] = ACTIONS(667),
    [anon_sym_PLUS] = ACTIONS(667),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(665),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LBRACK2] = ACTIONS(667),
    [sym_comment] = ACTIONS(3),
  },
  [146] = {
    [sym_identifier] = ACTIONS(701),
    [anon_sym_COMMA] = ACTIONS(703),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_RPAREN] = ACTIONS(703),
    [sym_dot] = ACTIONS(701),
    [anon_sym__] = ACTIONS(701),
    [anon_sym_DQUOTE] = ACTIONS(701),
    [anon_sym_POUND_DQUOTE] = ACTIONS(701),
    [anon_sym_SQUOTE] = ACTIONS(701),
    [anon_sym_POUND_SQUOTE] = ACTIONS(701),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(703),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(703),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(703),
    [anon_sym_len] = ACTIONS(701),
    [anon_sym_close] = ACTIONS(701),
    [anon_sym_and] = ACTIONS(701),
    [anon_sym_or] = ACTIONS(701),
    [anon_sym_div] = ACTIONS(701),
    [anon_sym_mod] = ACTIONS(701),
    [anon_sym_quo] = ACTIONS(701),
    [anon_sym_rem] = ACTIONS(701),
    [sym_number_type] = ACTIONS(701),
    [anon_sym_float] = ACTIONS(701),
    [anon_sym_float32] = ACTIONS(701),
    [anon_sym_float64] = ACTIONS(701),
    [anon_sym_uint] = ACTIONS(701),
    [anon_sym_uint8] = ACTIONS(701),
    [anon_sym_uint16] = ACTIONS(701),
    [anon_sym_uint32] = ACTIONS(701),
    [anon_sym_uint64] = ACTIONS(701),
    [anon_sym_uint128] = ACTIONS(701),
    [anon_sym_int] = ACTIONS(701),
    [anon_sym_int8] = ACTIONS(701),
    [anon_sym_int16] = ACTIONS(701),
    [anon_sym_int32] = ACTIONS(701),
    [anon_sym_int64] = ACTIONS(701),
    [anon_sym_int128] = ACTIONS(701),
    [sym_string_type] = ACTIONS(701),
    [sym_bytes_type] = ACTIONS(701),
    [sym_bool_type] = ACTIONS(701),
    [sym_bottom_lit] = ACTIONS(703),
    [sym_null] = ACTIONS(701),
    [sym_true] = ACTIONS(701),
    [sym_false] = ACTIONS(701),
    [sym_int_lit] = ACTIONS(701),
    [sym_float_lit] = ACTIONS(701),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_RBRACK] = ACTIONS(703),
    [anon_sym_LBRACE] = ACTIONS(703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(703),
    [anon_sym_for] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(701),
    [anon_sym_let] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_PIPE_PIPE] = ACTIONS(703),
    [anon_sym_AMP_AMP] = ACTIONS(703),
    [anon_sym_EQ_EQ] = ACTIONS(703),
    [anon_sym_BANG_EQ] = ACTIONS(703),
    [anon_sym_LT] = ACTIONS(701),
    [anon_sym_LT_EQ] = ACTIONS(703),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_GT_EQ] = ACTIONS(703),
    [anon_sym_EQ_TILDE] = ACTIONS(703),
    [anon_sym_BANG_TILDE] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_STAR] = ACTIONS(703),
    [anon_sym_SLASH] = ACTIONS(701),
    [anon_sym_BANG] = ACTIONS(701),
    [anon_sym_LBRACK2] = ACTIONS(703),
    [sym_comment] = ACTIONS(3),
  },
  [147] = {
    [sym_identifier] = ACTIONS(649),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_RPAREN] = ACTIONS(651),
    [sym_dot] = ACTIONS(649),
    [anon_sym__] = ACTIONS(649),
    [anon_sym_DQUOTE] = ACTIONS(649),
    [anon_sym_POUND_DQUOTE] = ACTIONS(649),
    [anon_sym_SQUOTE] = ACTIONS(649),
    [anon_sym_POUND_SQUOTE] = ACTIONS(649),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(651),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(651),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(651),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(651),
    [anon_sym_len] = ACTIONS(649),
    [anon_sym_close] = ACTIONS(649),
    [anon_sym_and] = ACTIONS(649),
    [anon_sym_or] = ACTIONS(649),
    [anon_sym_div] = ACTIONS(649),
    [anon_sym_mod] = ACTIONS(649),
    [anon_sym_quo] = ACTIONS(649),
    [anon_sym_rem] = ACTIONS(649),
    [sym_number_type] = ACTIONS(649),
    [anon_sym_float] = ACTIONS(649),
    [anon_sym_float32] = ACTIONS(649),
    [anon_sym_float64] = ACTIONS(649),
    [anon_sym_uint] = ACTIONS(649),
    [anon_sym_uint8] = ACTIONS(649),
    [anon_sym_uint16] = ACTIONS(649),
    [anon_sym_uint32] = ACTIONS(649),
    [anon_sym_uint64] = ACTIONS(649),
    [anon_sym_uint128] = ACTIONS(649),
    [anon_sym_int] = ACTIONS(649),
    [anon_sym_int8] = ACTIONS(649),
    [anon_sym_int16] = ACTIONS(649),
    [anon_sym_int32] = ACTIONS(649),
    [anon_sym_int64] = ACTIONS(649),
    [anon_sym_int128] = ACTIONS(649),
    [sym_string_type] = ACTIONS(649),
    [sym_bytes_type] = ACTIONS(649),
    [sym_bool_type] = ACTIONS(649),
    [sym_bottom_lit] = ACTIONS(651),
    [sym_null] = ACTIONS(649),
    [sym_true] = ACTIONS(649),
    [sym_false] = ACTIONS(649),
    [sym_int_lit] = ACTIONS(649),
    [sym_float_lit] = ACTIONS(649),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_RBRACK] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(651),
    [anon_sym_for] = ACTIONS(649),
    [anon_sym_if] = ACTIONS(649),
    [anon_sym_let] = ACTIONS(649),
    [anon_sym_PIPE] = ACTIONS(649),
    [anon_sym_AMP] = ACTIONS(649),
    [anon_sym_PIPE_PIPE] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(651),
    [anon_sym_EQ_EQ] = ACTIONS(651),
    [anon_sym_BANG_EQ] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(649),
    [anon_sym_LT_EQ] = ACTIONS(651),
    [anon_sym_GT] = ACTIONS(649),
    [anon_sym_GT_EQ] = ACTIONS(651),
    [anon_sym_EQ_TILDE] = ACTIONS(651),
    [anon_sym_BANG_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(651),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_STAR] = ACTIONS(651),
    [anon_sym_SLASH] = ACTIONS(649),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_LBRACK2] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [148] = {
    [sym_identifier] = ACTIONS(593),
    [anon_sym_COMMA] = ACTIONS(595),
    [anon_sym_LPAREN] = ACTIONS(595),
    [anon_sym_RPAREN] = ACTIONS(595),
    [sym_dot] = ACTIONS(593),
    [anon_sym__] = ACTIONS(593),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [anon_sym_POUND_DQUOTE] = ACTIONS(593),
    [anon_sym_SQUOTE] = ACTIONS(593),
    [anon_sym_POUND_SQUOTE] = ACTIONS(593),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(595),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(595),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(595),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(595),
    [anon_sym_len] = ACTIONS(593),
    [anon_sym_close] = ACTIONS(593),
    [anon_sym_and] = ACTIONS(593),
    [anon_sym_or] = ACTIONS(593),
    [anon_sym_div] = ACTIONS(593),
    [anon_sym_mod] = ACTIONS(593),
    [anon_sym_quo] = ACTIONS(593),
    [anon_sym_rem] = ACTIONS(593),
    [sym_number_type] = ACTIONS(593),
    [anon_sym_float] = ACTIONS(593),
    [anon_sym_float32] = ACTIONS(593),
    [anon_sym_float64] = ACTIONS(593),
    [anon_sym_uint] = ACTIONS(593),
    [anon_sym_uint8] = ACTIONS(593),
    [anon_sym_uint16] = ACTIONS(593),
    [anon_sym_uint32] = ACTIONS(593),
    [anon_sym_uint64] = ACTIONS(593),
    [anon_sym_uint128] = ACTIONS(593),
    [anon_sym_int] = ACTIONS(593),
    [anon_sym_int8] = ACTIONS(593),
    [anon_sym_int16] = ACTIONS(593),
    [anon_sym_int32] = ACTIONS(593),
    [anon_sym_int64] = ACTIONS(593),
    [anon_sym_int128] = ACTIONS(593),
    [sym_string_type] = ACTIONS(593),
    [sym_bytes_type] = ACTIONS(593),
    [sym_bool_type] = ACTIONS(593),
    [sym_bottom_lit] = ACTIONS(595),
    [sym_null] = ACTIONS(593),
    [sym_true] = ACTIONS(593),
    [sym_false] = ACTIONS(593),
    [sym_int_lit] = ACTIONS(593),
    [sym_float_lit] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(593),
    [anon_sym_RBRACK] = ACTIONS(595),
    [anon_sym_LBRACE] = ACTIONS(595),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(595),
    [anon_sym_for] = ACTIONS(593),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_let] = ACTIONS(593),
    [anon_sym_PIPE] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(593),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_EQ_EQ] = ACTIONS(595),
    [anon_sym_BANG_EQ] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(595),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_GT_EQ] = ACTIONS(595),
    [anon_sym_EQ_TILDE] = ACTIONS(595),
    [anon_sym_BANG_TILDE] = ACTIONS(595),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_STAR] = ACTIONS(595),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_BANG] = ACTIONS(593),
    [anon_sym_LBRACK2] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
  },
  [149] = {
    [sym_identifier] = ACTIONS(709),
    [anon_sym_LF] = ACTIONS(711),
    [anon_sym_COMMA] = ACTIONS(709),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym__] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(709),
    [anon_sym_POUND_DQUOTE] = ACTIONS(709),
    [anon_sym_SQUOTE] = ACTIONS(709),
    [anon_sym_POUND_SQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(709),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(709),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(709),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(709),
    [anon_sym_len] = ACTIONS(709),
    [anon_sym_close] = ACTIONS(709),
    [anon_sym_and] = ACTIONS(709),
    [anon_sym_or] = ACTIONS(709),
    [anon_sym_div] = ACTIONS(709),
    [anon_sym_mod] = ACTIONS(709),
    [anon_sym_quo] = ACTIONS(709),
    [anon_sym_rem] = ACTIONS(709),
    [sym_number_type] = ACTIONS(709),
    [anon_sym_float] = ACTIONS(709),
    [anon_sym_float32] = ACTIONS(709),
    [anon_sym_float64] = ACTIONS(709),
    [anon_sym_uint] = ACTIONS(709),
    [anon_sym_uint8] = ACTIONS(709),
    [anon_sym_uint16] = ACTIONS(709),
    [anon_sym_uint32] = ACTIONS(709),
    [anon_sym_uint64] = ACTIONS(709),
    [anon_sym_uint128] = ACTIONS(709),
    [anon_sym_int] = ACTIONS(709),
    [anon_sym_int8] = ACTIONS(709),
    [anon_sym_int16] = ACTIONS(709),
    [anon_sym_int32] = ACTIONS(709),
    [anon_sym_int64] = ACTIONS(709),
    [anon_sym_int128] = ACTIONS(709),
    [sym_string_type] = ACTIONS(709),
    [sym_bytes_type] = ACTIONS(709),
    [sym_bool_type] = ACTIONS(709),
    [sym_bottom_lit] = ACTIONS(709),
    [sym_null] = ACTIONS(709),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_int_lit] = ACTIONS(709),
    [sym_float_lit] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(709),
    [anon_sym_LBRACE] = ACTIONS(709),
    [anon_sym_RBRACE] = ACTIONS(709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(709),
    [anon_sym_for] = ACTIONS(709),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(709),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_PIPE_PIPE] = ACTIONS(713),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_EQ_EQ] = ACTIONS(717),
    [anon_sym_BANG_EQ] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(717),
    [anon_sym_LT_EQ] = ACTIONS(717),
    [anon_sym_GT] = ACTIONS(717),
    [anon_sym_GT_EQ] = ACTIONS(717),
    [anon_sym_EQ_TILDE] = ACTIONS(717),
    [anon_sym_BANG_TILDE] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(721),
    [anon_sym_BANG] = ACTIONS(709),
    [sym_comment] = ACTIONS(530),
  },
  [150] = {
    [sym_identifier] = ACTIONS(723),
    [anon_sym_LF] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(723),
    [anon_sym__] = ACTIONS(723),
    [anon_sym_AT] = ACTIONS(723),
    [anon_sym_DQUOTE] = ACTIONS(723),
    [anon_sym_POUND_DQUOTE] = ACTIONS(723),
    [anon_sym_SQUOTE] = ACTIONS(723),
    [anon_sym_POUND_SQUOTE] = ACTIONS(723),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(723),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(723),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(723),
    [anon_sym_len] = ACTIONS(723),
    [anon_sym_close] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(723),
    [anon_sym_or] = ACTIONS(723),
    [anon_sym_div] = ACTIONS(723),
    [anon_sym_mod] = ACTIONS(723),
    [anon_sym_quo] = ACTIONS(723),
    [anon_sym_rem] = ACTIONS(723),
    [sym_number_type] = ACTIONS(723),
    [anon_sym_float] = ACTIONS(723),
    [anon_sym_float32] = ACTIONS(723),
    [anon_sym_float64] = ACTIONS(723),
    [anon_sym_uint] = ACTIONS(723),
    [anon_sym_uint8] = ACTIONS(723),
    [anon_sym_uint16] = ACTIONS(723),
    [anon_sym_uint32] = ACTIONS(723),
    [anon_sym_uint64] = ACTIONS(723),
    [anon_sym_uint128] = ACTIONS(723),
    [anon_sym_int] = ACTIONS(723),
    [anon_sym_int8] = ACTIONS(723),
    [anon_sym_int16] = ACTIONS(723),
    [anon_sym_int32] = ACTIONS(723),
    [anon_sym_int64] = ACTIONS(723),
    [anon_sym_int128] = ACTIONS(723),
    [sym_string_type] = ACTIONS(723),
    [sym_bytes_type] = ACTIONS(723),
    [sym_bool_type] = ACTIONS(723),
    [sym_bottom_lit] = ACTIONS(723),
    [sym_null] = ACTIONS(723),
    [sym_true] = ACTIONS(723),
    [sym_false] = ACTIONS(723),
    [sym_int_lit] = ACTIONS(723),
    [sym_float_lit] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(723),
    [anon_sym_LBRACE] = ACTIONS(723),
    [anon_sym_RBRACE] = ACTIONS(723),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(723),
    [anon_sym_for] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_PIPE] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(713),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_EQ_EQ] = ACTIONS(717),
    [anon_sym_BANG_EQ] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(717),
    [anon_sym_LT_EQ] = ACTIONS(717),
    [anon_sym_GT] = ACTIONS(717),
    [anon_sym_GT_EQ] = ACTIONS(717),
    [anon_sym_EQ_TILDE] = ACTIONS(717),
    [anon_sym_BANG_TILDE] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(721),
    [anon_sym_BANG] = ACTIONS(723),
    [sym_comment] = ACTIONS(530),
  },
  [151] = {
    [sym_identifier] = ACTIONS(731),
    [anon_sym_LF] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym__] = ACTIONS(731),
    [anon_sym_AT] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_POUND_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(731),
    [anon_sym_POUND_SQUOTE] = ACTIONS(731),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(731),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(731),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(731),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(731),
    [anon_sym_len] = ACTIONS(731),
    [anon_sym_close] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_div] = ACTIONS(731),
    [anon_sym_mod] = ACTIONS(731),
    [anon_sym_quo] = ACTIONS(731),
    [anon_sym_rem] = ACTIONS(731),
    [sym_number_type] = ACTIONS(731),
    [anon_sym_float] = ACTIONS(731),
    [anon_sym_float32] = ACTIONS(731),
    [anon_sym_float64] = ACTIONS(731),
    [anon_sym_uint] = ACTIONS(731),
    [anon_sym_uint8] = ACTIONS(731),
    [anon_sym_uint16] = ACTIONS(731),
    [anon_sym_uint32] = ACTIONS(731),
    [anon_sym_uint64] = ACTIONS(731),
    [anon_sym_uint128] = ACTIONS(731),
    [anon_sym_int] = ACTIONS(731),
    [anon_sym_int8] = ACTIONS(731),
    [anon_sym_int16] = ACTIONS(731),
    [anon_sym_int32] = ACTIONS(731),
    [anon_sym_int64] = ACTIONS(731),
    [anon_sym_int128] = ACTIONS(731),
    [sym_string_type] = ACTIONS(731),
    [sym_bytes_type] = ACTIONS(731),
    [sym_bool_type] = ACTIONS(731),
    [sym_bottom_lit] = ACTIONS(731),
    [sym_null] = ACTIONS(731),
    [sym_true] = ACTIONS(731),
    [sym_false] = ACTIONS(731),
    [sym_int_lit] = ACTIONS(731),
    [sym_float_lit] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_RBRACE] = ACTIONS(731),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(731),
    [anon_sym_for] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(713),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_EQ_EQ] = ACTIONS(717),
    [anon_sym_BANG_EQ] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(717),
    [anon_sym_LT_EQ] = ACTIONS(717),
    [anon_sym_GT] = ACTIONS(717),
    [anon_sym_GT_EQ] = ACTIONS(717),
    [anon_sym_EQ_TILDE] = ACTIONS(717),
    [anon_sym_BANG_TILDE] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(721),
    [anon_sym_BANG] = ACTIONS(731),
    [sym_comment] = ACTIONS(530),
  },
  [152] = {
    [sym_identifier] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(556),
    [anon_sym_LPAREN] = ACTIONS(556),
    [sym_dot] = ACTIONS(558),
    [anon_sym__] = ACTIONS(554),
    [anon_sym_DQUOTE] = ACTIONS(554),
    [anon_sym_POUND_DQUOTE] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(554),
    [anon_sym_POUND_SQUOTE] = ACTIONS(554),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(556),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(556),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(556),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(556),
    [anon_sym_len] = ACTIONS(554),
    [anon_sym_close] = ACTIONS(554),
    [anon_sym_and] = ACTIONS(554),
    [anon_sym_or] = ACTIONS(554),
    [anon_sym_div] = ACTIONS(554),
    [anon_sym_mod] = ACTIONS(554),
    [anon_sym_quo] = ACTIONS(554),
    [anon_sym_rem] = ACTIONS(554),
    [sym_number_type] = ACTIONS(554),
    [anon_sym_float] = ACTIONS(554),
    [anon_sym_float32] = ACTIONS(554),
    [anon_sym_float64] = ACTIONS(554),
    [anon_sym_uint] = ACTIONS(554),
    [anon_sym_uint8] = ACTIONS(554),
    [anon_sym_uint16] = ACTIONS(554),
    [anon_sym_uint32] = ACTIONS(554),
    [anon_sym_uint64] = ACTIONS(554),
    [anon_sym_uint128] = ACTIONS(554),
    [anon_sym_int] = ACTIONS(554),
    [anon_sym_int8] = ACTIONS(554),
    [anon_sym_int16] = ACTIONS(554),
    [anon_sym_int32] = ACTIONS(554),
    [anon_sym_int64] = ACTIONS(554),
    [anon_sym_int128] = ACTIONS(554),
    [sym_string_type] = ACTIONS(554),
    [sym_bytes_type] = ACTIONS(554),
    [sym_bool_type] = ACTIONS(554),
    [sym_bottom_lit] = ACTIONS(556),
    [sym_null] = ACTIONS(554),
    [sym_true] = ACTIONS(554),
    [sym_false] = ACTIONS(554),
    [sym_int_lit] = ACTIONS(554),
    [sym_float_lit] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(554),
    [anon_sym_RBRACK] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(556),
    [anon_sym_EQ] = ACTIONS(735),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_if] = ACTIONS(554),
    [anon_sym_PIPE] = ACTIONS(554),
    [anon_sym_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(556),
    [anon_sym_AMP_AMP] = ACTIONS(556),
    [anon_sym_EQ_EQ] = ACTIONS(556),
    [anon_sym_BANG_EQ] = ACTIONS(556),
    [anon_sym_LT] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(556),
    [anon_sym_GT] = ACTIONS(554),
    [anon_sym_GT_EQ] = ACTIONS(556),
    [anon_sym_EQ_TILDE] = ACTIONS(556),
    [anon_sym_BANG_TILDE] = ACTIONS(556),
    [anon_sym_PLUS] = ACTIONS(556),
    [anon_sym_DASH] = ACTIONS(556),
    [anon_sym_STAR] = ACTIONS(556),
    [anon_sym_SLASH] = ACTIONS(554),
    [anon_sym_BANG] = ACTIONS(554),
    [anon_sym_LBRACK2] = ACTIONS(556),
    [sym_comment] = ACTIONS(3),
  },
  [153] = {
    [sym_identifier] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(739),
    [anon_sym_COMMA] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(737),
    [anon_sym__] = ACTIONS(737),
    [anon_sym_AT] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [anon_sym_POUND_DQUOTE] = ACTIONS(737),
    [anon_sym_SQUOTE] = ACTIONS(737),
    [anon_sym_POUND_SQUOTE] = ACTIONS(737),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(737),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(737),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(737),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(737),
    [anon_sym_len] = ACTIONS(737),
    [anon_sym_close] = ACTIONS(737),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_or] = ACTIONS(737),
    [anon_sym_div] = ACTIONS(737),
    [anon_sym_mod] = ACTIONS(737),
    [anon_sym_quo] = ACTIONS(737),
    [anon_sym_rem] = ACTIONS(737),
    [sym_number_type] = ACTIONS(737),
    [anon_sym_float] = ACTIONS(737),
    [anon_sym_float32] = ACTIONS(737),
    [anon_sym_float64] = ACTIONS(737),
    [anon_sym_uint] = ACTIONS(737),
    [anon_sym_uint8] = ACTIONS(737),
    [anon_sym_uint16] = ACTIONS(737),
    [anon_sym_uint32] = ACTIONS(737),
    [anon_sym_uint64] = ACTIONS(737),
    [anon_sym_uint128] = ACTIONS(737),
    [anon_sym_int] = ACTIONS(737),
    [anon_sym_int8] = ACTIONS(737),
    [anon_sym_int16] = ACTIONS(737),
    [anon_sym_int32] = ACTIONS(737),
    [anon_sym_int64] = ACTIONS(737),
    [anon_sym_int128] = ACTIONS(737),
    [sym_string_type] = ACTIONS(737),
    [sym_bytes_type] = ACTIONS(737),
    [sym_bool_type] = ACTIONS(737),
    [sym_bottom_lit] = ACTIONS(737),
    [sym_null] = ACTIONS(737),
    [sym_true] = ACTIONS(737),
    [sym_false] = ACTIONS(737),
    [sym_int_lit] = ACTIONS(737),
    [sym_float_lit] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LBRACE] = ACTIONS(737),
    [anon_sym_RBRACE] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_let] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(713),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_EQ_EQ] = ACTIONS(717),
    [anon_sym_BANG_EQ] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(717),
    [anon_sym_LT_EQ] = ACTIONS(717),
    [anon_sym_GT] = ACTIONS(717),
    [anon_sym_GT_EQ] = ACTIONS(717),
    [anon_sym_EQ_TILDE] = ACTIONS(717),
    [anon_sym_BANG_TILDE] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(721),
    [anon_sym_BANG] = ACTIONS(737),
    [sym_comment] = ACTIONS(530),
  },
  [154] = {
    [sym_identifier] = ACTIONS(741),
    [anon_sym_LF] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(741),
    [anon_sym_LPAREN] = ACTIONS(741),
    [anon_sym__] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(741),
    [anon_sym_DQUOTE] = ACTIONS(741),
    [anon_sym_POUND_DQUOTE] = ACTIONS(741),
    [anon_sym_SQUOTE] = ACTIONS(741),
    [anon_sym_POUND_SQUOTE] = ACTIONS(741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(741),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(741),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(741),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(741),
    [anon_sym_len] = ACTIONS(741),
    [anon_sym_close] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(741),
    [anon_sym_div] = ACTIONS(741),
    [anon_sym_mod] = ACTIONS(741),
    [anon_sym_quo] = ACTIONS(741),
    [anon_sym_rem] = ACTIONS(741),
    [sym_number_type] = ACTIONS(741),
    [anon_sym_float] = ACTIONS(741),
    [anon_sym_float32] = ACTIONS(741),
    [anon_sym_float64] = ACTIONS(741),
    [anon_sym_uint] = ACTIONS(741),
    [anon_sym_uint8] = ACTIONS(741),
    [anon_sym_uint16] = ACTIONS(741),
    [anon_sym_uint32] = ACTIONS(741),
    [anon_sym_uint64] = ACTIONS(741),
    [anon_sym_uint128] = ACTIONS(741),
    [anon_sym_int] = ACTIONS(741),
    [anon_sym_int8] = ACTIONS(741),
    [anon_sym_int16] = ACTIONS(741),
    [anon_sym_int32] = ACTIONS(741),
    [anon_sym_int64] = ACTIONS(741),
    [anon_sym_int128] = ACTIONS(741),
    [sym_string_type] = ACTIONS(741),
    [sym_bytes_type] = ACTIONS(741),
    [sym_bool_type] = ACTIONS(741),
    [sym_bottom_lit] = ACTIONS(741),
    [sym_null] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_int_lit] = ACTIONS(741),
    [sym_float_lit] = ACTIONS(741),
    [anon_sym_LBRACK] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_for] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_BANG_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(741),
    [anon_sym_EQ_TILDE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_DASH] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_BANG] = ACTIONS(741),
    [sym_comment] = ACTIONS(530),
  },
  [155] = {
    [sym_identifier] = ACTIONS(709),
    [anon_sym_LF] = ACTIONS(711),
    [anon_sym_COMMA] = ACTIONS(709),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym__] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(709),
    [anon_sym_POUND_DQUOTE] = ACTIONS(709),
    [anon_sym_SQUOTE] = ACTIONS(709),
    [anon_sym_POUND_SQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(709),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(709),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(709),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(709),
    [anon_sym_len] = ACTIONS(709),
    [anon_sym_close] = ACTIONS(709),
    [anon_sym_and] = ACTIONS(709),
    [anon_sym_or] = ACTIONS(709),
    [anon_sym_div] = ACTIONS(709),
    [anon_sym_mod] = ACTIONS(709),
    [anon_sym_quo] = ACTIONS(709),
    [anon_sym_rem] = ACTIONS(709),
    [sym_number_type] = ACTIONS(709),
    [anon_sym_float] = ACTIONS(709),
    [anon_sym_float32] = ACTIONS(709),
    [anon_sym_float64] = ACTIONS(709),
    [anon_sym_uint] = ACTIONS(709),
    [anon_sym_uint8] = ACTIONS(709),
    [anon_sym_uint16] = ACTIONS(709),
    [anon_sym_uint32] = ACTIONS(709),
    [anon_sym_uint64] = ACTIONS(709),
    [anon_sym_uint128] = ACTIONS(709),
    [anon_sym_int] = ACTIONS(709),
    [anon_sym_int8] = ACTIONS(709),
    [anon_sym_int16] = ACTIONS(709),
    [anon_sym_int32] = ACTIONS(709),
    [anon_sym_int64] = ACTIONS(709),
    [anon_sym_int128] = ACTIONS(709),
    [sym_string_type] = ACTIONS(709),
    [sym_bytes_type] = ACTIONS(709),
    [sym_bool_type] = ACTIONS(709),
    [sym_bottom_lit] = ACTIONS(709),
    [sym_null] = ACTIONS(709),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_int_lit] = ACTIONS(709),
    [sym_float_lit] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(709),
    [anon_sym_LBRACE] = ACTIONS(709),
    [anon_sym_RBRACE] = ACTIONS(709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(709),
    [anon_sym_for] = ACTIONS(709),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(709),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_PIPE_PIPE] = ACTIONS(709),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_EQ_EQ] = ACTIONS(709),
    [anon_sym_BANG_EQ] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(709),
    [anon_sym_LT_EQ] = ACTIONS(709),
    [anon_sym_GT] = ACTIONS(709),
    [anon_sym_GT_EQ] = ACTIONS(709),
    [anon_sym_EQ_TILDE] = ACTIONS(709),
    [anon_sym_BANG_TILDE] = ACTIONS(709),
    [anon_sym_PLUS] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_SLASH] = ACTIONS(709),
    [anon_sym_BANG] = ACTIONS(709),
    [sym_comment] = ACTIONS(530),
  },
  [156] = {
    [sym_identifier] = ACTIONS(709),
    [anon_sym_LF] = ACTIONS(711),
    [anon_sym_COMMA] = ACTIONS(709),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym__] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(709),
    [anon_sym_POUND_DQUOTE] = ACTIONS(709),
    [anon_sym_SQUOTE] = ACTIONS(709),
    [anon_sym_POUND_SQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(709),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(709),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(709),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(709),
    [anon_sym_len] = ACTIONS(709),
    [anon_sym_close] = ACTIONS(709),
    [anon_sym_and] = ACTIONS(709),
    [anon_sym_or] = ACTIONS(709),
    [anon_sym_div] = ACTIONS(709),
    [anon_sym_mod] = ACTIONS(709),
    [anon_sym_quo] = ACTIONS(709),
    [anon_sym_rem] = ACTIONS(709),
    [sym_number_type] = ACTIONS(709),
    [anon_sym_float] = ACTIONS(709),
    [anon_sym_float32] = ACTIONS(709),
    [anon_sym_float64] = ACTIONS(709),
    [anon_sym_uint] = ACTIONS(709),
    [anon_sym_uint8] = ACTIONS(709),
    [anon_sym_uint16] = ACTIONS(709),
    [anon_sym_uint32] = ACTIONS(709),
    [anon_sym_uint64] = ACTIONS(709),
    [anon_sym_uint128] = ACTIONS(709),
    [anon_sym_int] = ACTIONS(709),
    [anon_sym_int8] = ACTIONS(709),
    [anon_sym_int16] = ACTIONS(709),
    [anon_sym_int32] = ACTIONS(709),
    [anon_sym_int64] = ACTIONS(709),
    [anon_sym_int128] = ACTIONS(709),
    [sym_string_type] = ACTIONS(709),
    [sym_bytes_type] = ACTIONS(709),
    [sym_bool_type] = ACTIONS(709),
    [sym_bottom_lit] = ACTIONS(709),
    [sym_null] = ACTIONS(709),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_int_lit] = ACTIONS(709),
    [sym_float_lit] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(709),
    [anon_sym_LBRACE] = ACTIONS(709),
    [anon_sym_RBRACE] = ACTIONS(709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(709),
    [anon_sym_for] = ACTIONS(709),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(709),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_PIPE_PIPE] = ACTIONS(709),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_EQ_EQ] = ACTIONS(709),
    [anon_sym_BANG_EQ] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(709),
    [anon_sym_LT_EQ] = ACTIONS(709),
    [anon_sym_GT] = ACTIONS(709),
    [anon_sym_GT_EQ] = ACTIONS(709),
    [anon_sym_EQ_TILDE] = ACTIONS(709),
    [anon_sym_BANG_TILDE] = ACTIONS(709),
    [anon_sym_PLUS] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(721),
    [anon_sym_BANG] = ACTIONS(709),
    [sym_comment] = ACTIONS(530),
  },
  [157] = {
    [sym_identifier] = ACTIONS(709),
    [anon_sym_LF] = ACTIONS(711),
    [anon_sym_COMMA] = ACTIONS(709),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym__] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(709),
    [anon_sym_POUND_DQUOTE] = ACTIONS(709),
    [anon_sym_SQUOTE] = ACTIONS(709),
    [anon_sym_POUND_SQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(709),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(709),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(709),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(709),
    [anon_sym_len] = ACTIONS(709),
    [anon_sym_close] = ACTIONS(709),
    [anon_sym_and] = ACTIONS(709),
    [anon_sym_or] = ACTIONS(709),
    [anon_sym_div] = ACTIONS(709),
    [anon_sym_mod] = ACTIONS(709),
    [anon_sym_quo] = ACTIONS(709),
    [anon_sym_rem] = ACTIONS(709),
    [sym_number_type] = ACTIONS(709),
    [anon_sym_float] = ACTIONS(709),
    [anon_sym_float32] = ACTIONS(709),
    [anon_sym_float64] = ACTIONS(709),
    [anon_sym_uint] = ACTIONS(709),
    [anon_sym_uint8] = ACTIONS(709),
    [anon_sym_uint16] = ACTIONS(709),
    [anon_sym_uint32] = ACTIONS(709),
    [anon_sym_uint64] = ACTIONS(709),
    [anon_sym_uint128] = ACTIONS(709),
    [anon_sym_int] = ACTIONS(709),
    [anon_sym_int8] = ACTIONS(709),
    [anon_sym_int16] = ACTIONS(709),
    [anon_sym_int32] = ACTIONS(709),
    [anon_sym_int64] = ACTIONS(709),
    [anon_sym_int128] = ACTIONS(709),
    [sym_string_type] = ACTIONS(709),
    [sym_bytes_type] = ACTIONS(709),
    [sym_bool_type] = ACTIONS(709),
    [sym_bottom_lit] = ACTIONS(709),
    [sym_null] = ACTIONS(709),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_int_lit] = ACTIONS(709),
    [sym_float_lit] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(709),
    [anon_sym_LBRACE] = ACTIONS(709),
    [anon_sym_RBRACE] = ACTIONS(709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(709),
    [anon_sym_for] = ACTIONS(709),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(709),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_PIPE_PIPE] = ACTIONS(709),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_EQ_EQ] = ACTIONS(709),
    [anon_sym_BANG_EQ] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(709),
    [anon_sym_LT_EQ] = ACTIONS(709),
    [anon_sym_GT] = ACTIONS(709),
    [anon_sym_GT_EQ] = ACTIONS(709),
    [anon_sym_EQ_TILDE] = ACTIONS(709),
    [anon_sym_BANG_TILDE] = ACTIONS(709),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(721),
    [anon_sym_BANG] = ACTIONS(709),
    [sym_comment] = ACTIONS(530),
  },
  [158] = {
    [sym_identifier] = ACTIONS(709),
    [anon_sym_LF] = ACTIONS(711),
    [anon_sym_COMMA] = ACTIONS(709),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym__] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(709),
    [anon_sym_POUND_DQUOTE] = ACTIONS(709),
    [anon_sym_SQUOTE] = ACTIONS(709),
    [anon_sym_POUND_SQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(709),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(709),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(709),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(709),
    [anon_sym_len] = ACTIONS(709),
    [anon_sym_close] = ACTIONS(709),
    [anon_sym_and] = ACTIONS(709),
    [anon_sym_or] = ACTIONS(709),
    [anon_sym_div] = ACTIONS(709),
    [anon_sym_mod] = ACTIONS(709),
    [anon_sym_quo] = ACTIONS(709),
    [anon_sym_rem] = ACTIONS(709),
    [sym_number_type] = ACTIONS(709),
    [anon_sym_float] = ACTIONS(709),
    [anon_sym_float32] = ACTIONS(709),
    [anon_sym_float64] = ACTIONS(709),
    [anon_sym_uint] = ACTIONS(709),
    [anon_sym_uint8] = ACTIONS(709),
    [anon_sym_uint16] = ACTIONS(709),
    [anon_sym_uint32] = ACTIONS(709),
    [anon_sym_uint64] = ACTIONS(709),
    [anon_sym_uint128] = ACTIONS(709),
    [anon_sym_int] = ACTIONS(709),
    [anon_sym_int8] = ACTIONS(709),
    [anon_sym_int16] = ACTIONS(709),
    [anon_sym_int32] = ACTIONS(709),
    [anon_sym_int64] = ACTIONS(709),
    [anon_sym_int128] = ACTIONS(709),
    [sym_string_type] = ACTIONS(709),
    [sym_bytes_type] = ACTIONS(709),
    [sym_bool_type] = ACTIONS(709),
    [sym_bottom_lit] = ACTIONS(709),
    [sym_null] = ACTIONS(709),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_int_lit] = ACTIONS(709),
    [sym_float_lit] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(709),
    [anon_sym_LBRACE] = ACTIONS(709),
    [anon_sym_RBRACE] = ACTIONS(709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(709),
    [anon_sym_for] = ACTIONS(709),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(709),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_PIPE_PIPE] = ACTIONS(709),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_EQ_EQ] = ACTIONS(717),
    [anon_sym_BANG_EQ] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(717),
    [anon_sym_LT_EQ] = ACTIONS(717),
    [anon_sym_GT] = ACTIONS(717),
    [anon_sym_GT_EQ] = ACTIONS(717),
    [anon_sym_EQ_TILDE] = ACTIONS(717),
    [anon_sym_BANG_TILDE] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(721),
    [anon_sym_BANG] = ACTIONS(709),
    [sym_comment] = ACTIONS(530),
  },
  [159] = {
    [sym_identifier] = ACTIONS(745),
    [anon_sym_LF] = ACTIONS(747),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_LPAREN] = ACTIONS(745),
    [anon_sym__] = ACTIONS(745),
    [anon_sym_AT] = ACTIONS(745),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_POUND_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(745),
    [anon_sym_POUND_SQUOTE] = ACTIONS(745),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(745),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(745),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(745),
    [anon_sym_len] = ACTIONS(745),
    [anon_sym_close] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(745),
    [anon_sym_or] = ACTIONS(745),
    [anon_sym_div] = ACTIONS(745),
    [anon_sym_mod] = ACTIONS(745),
    [anon_sym_quo] = ACTIONS(745),
    [anon_sym_rem] = ACTIONS(745),
    [sym_number_type] = ACTIONS(745),
    [anon_sym_float] = ACTIONS(745),
    [anon_sym_float32] = ACTIONS(745),
    [anon_sym_float64] = ACTIONS(745),
    [anon_sym_uint] = ACTIONS(745),
    [anon_sym_uint8] = ACTIONS(745),
    [anon_sym_uint16] = ACTIONS(745),
    [anon_sym_uint32] = ACTIONS(745),
    [anon_sym_uint64] = ACTIONS(745),
    [anon_sym_uint128] = ACTIONS(745),
    [anon_sym_int] = ACTIONS(745),
    [anon_sym_int8] = ACTIONS(745),
    [anon_sym_int16] = ACTIONS(745),
    [anon_sym_int32] = ACTIONS(745),
    [anon_sym_int64] = ACTIONS(745),
    [anon_sym_int128] = ACTIONS(745),
    [sym_string_type] = ACTIONS(745),
    [sym_bytes_type] = ACTIONS(745),
    [sym_bool_type] = ACTIONS(745),
    [sym_bottom_lit] = ACTIONS(745),
    [sym_null] = ACTIONS(745),
    [sym_true] = ACTIONS(745),
    [sym_false] = ACTIONS(745),
    [sym_int_lit] = ACTIONS(745),
    [sym_float_lit] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_let] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(713),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_EQ_EQ] = ACTIONS(717),
    [anon_sym_BANG_EQ] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(717),
    [anon_sym_LT_EQ] = ACTIONS(717),
    [anon_sym_GT] = ACTIONS(717),
    [anon_sym_GT_EQ] = ACTIONS(717),
    [anon_sym_EQ_TILDE] = ACTIONS(717),
    [anon_sym_BANG_TILDE] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(721),
    [anon_sym_BANG] = ACTIONS(745),
    [sym_comment] = ACTIONS(530),
  },
  [160] = {
    [sym_identifier] = ACTIONS(709),
    [anon_sym_LF] = ACTIONS(711),
    [anon_sym_COMMA] = ACTIONS(709),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym__] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(709),
    [anon_sym_POUND_DQUOTE] = ACTIONS(709),
    [anon_sym_SQUOTE] = ACTIONS(709),
    [anon_sym_POUND_SQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(709),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(709),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(709),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(709),
    [anon_sym_len] = ACTIONS(709),
    [anon_sym_close] = ACTIONS(709),
    [anon_sym_and] = ACTIONS(709),
    [anon_sym_or] = ACTIONS(709),
    [anon_sym_div] = ACTIONS(709),
    [anon_sym_mod] = ACTIONS(709),
    [anon_sym_quo] = ACTIONS(709),
    [anon_sym_rem] = ACTIONS(709),
    [sym_number_type] = ACTIONS(709),
    [anon_sym_float] = ACTIONS(709),
    [anon_sym_float32] = ACTIONS(709),
    [anon_sym_float64] = ACTIONS(709),
    [anon_sym_uint] = ACTIONS(709),
    [anon_sym_uint8] = ACTIONS(709),
    [anon_sym_uint16] = ACTIONS(709),
    [anon_sym_uint32] = ACTIONS(709),
    [anon_sym_uint64] = ACTIONS(709),
    [anon_sym_uint128] = ACTIONS(709),
    [anon_sym_int] = ACTIONS(709),
    [anon_sym_int8] = ACTIONS(709),
    [anon_sym_int16] = ACTIONS(709),
    [anon_sym_int32] = ACTIONS(709),
    [anon_sym_int64] = ACTIONS(709),
    [anon_sym_int128] = ACTIONS(709),
    [sym_string_type] = ACTIONS(709),
    [sym_bytes_type] = ACTIONS(709),
    [sym_bool_type] = ACTIONS(709),
    [sym_bottom_lit] = ACTIONS(709),
    [sym_null] = ACTIONS(709),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_int_lit] = ACTIONS(709),
    [sym_float_lit] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(709),
    [anon_sym_LBRACE] = ACTIONS(709),
    [anon_sym_RBRACE] = ACTIONS(709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(709),
    [anon_sym_for] = ACTIONS(709),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(709),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_PIPE_PIPE] = ACTIONS(709),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_EQ_EQ] = ACTIONS(717),
    [anon_sym_BANG_EQ] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(717),
    [anon_sym_LT_EQ] = ACTIONS(717),
    [anon_sym_GT] = ACTIONS(717),
    [anon_sym_GT_EQ] = ACTIONS(717),
    [anon_sym_EQ_TILDE] = ACTIONS(717),
    [anon_sym_BANG_TILDE] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(721),
    [anon_sym_BANG] = ACTIONS(709),
    [sym_comment] = ACTIONS(530),
  },
  [161] = {
    [sym_identifier] = ACTIONS(709),
    [anon_sym_LF] = ACTIONS(711),
    [anon_sym_COMMA] = ACTIONS(709),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym__] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(709),
    [anon_sym_POUND_DQUOTE] = ACTIONS(709),
    [anon_sym_SQUOTE] = ACTIONS(709),
    [anon_sym_POUND_SQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(709),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(709),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(709),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(709),
    [anon_sym_len] = ACTIONS(709),
    [anon_sym_close] = ACTIONS(709),
    [anon_sym_and] = ACTIONS(709),
    [anon_sym_or] = ACTIONS(709),
    [anon_sym_div] = ACTIONS(709),
    [anon_sym_mod] = ACTIONS(709),
    [anon_sym_quo] = ACTIONS(709),
    [anon_sym_rem] = ACTIONS(709),
    [sym_number_type] = ACTIONS(709),
    [anon_sym_float] = ACTIONS(709),
    [anon_sym_float32] = ACTIONS(709),
    [anon_sym_float64] = ACTIONS(709),
    [anon_sym_uint] = ACTIONS(709),
    [anon_sym_uint8] = ACTIONS(709),
    [anon_sym_uint16] = ACTIONS(709),
    [anon_sym_uint32] = ACTIONS(709),
    [anon_sym_uint64] = ACTIONS(709),
    [anon_sym_uint128] = ACTIONS(709),
    [anon_sym_int] = ACTIONS(709),
    [anon_sym_int8] = ACTIONS(709),
    [anon_sym_int16] = ACTIONS(709),
    [anon_sym_int32] = ACTIONS(709),
    [anon_sym_int64] = ACTIONS(709),
    [anon_sym_int128] = ACTIONS(709),
    [sym_string_type] = ACTIONS(709),
    [sym_bytes_type] = ACTIONS(709),
    [sym_bool_type] = ACTIONS(709),
    [sym_bottom_lit] = ACTIONS(709),
    [sym_null] = ACTIONS(709),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_int_lit] = ACTIONS(709),
    [sym_float_lit] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(709),
    [anon_sym_LBRACE] = ACTIONS(709),
    [anon_sym_RBRACE] = ACTIONS(709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(709),
    [anon_sym_for] = ACTIONS(709),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(709),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(713),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_EQ_EQ] = ACTIONS(717),
    [anon_sym_BANG_EQ] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(717),
    [anon_sym_LT_EQ] = ACTIONS(717),
    [anon_sym_GT] = ACTIONS(717),
    [anon_sym_GT_EQ] = ACTIONS(717),
    [anon_sym_EQ_TILDE] = ACTIONS(717),
    [anon_sym_BANG_TILDE] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(721),
    [anon_sym_BANG] = ACTIONS(709),
    [sym_comment] = ACTIONS(530),
  },
  [162] = {
    [sym_identifier] = ACTIONS(709),
    [anon_sym_COMMA] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(711),
    [anon_sym__] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(709),
    [anon_sym_POUND_DQUOTE] = ACTIONS(709),
    [anon_sym_SQUOTE] = ACTIONS(709),
    [anon_sym_POUND_SQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(711),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(711),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(711),
    [anon_sym_len] = ACTIONS(709),
    [anon_sym_close] = ACTIONS(709),
    [anon_sym_and] = ACTIONS(709),
    [anon_sym_or] = ACTIONS(709),
    [anon_sym_div] = ACTIONS(709),
    [anon_sym_mod] = ACTIONS(709),
    [anon_sym_quo] = ACTIONS(709),
    [anon_sym_rem] = ACTIONS(709),
    [sym_number_type] = ACTIONS(709),
    [anon_sym_float] = ACTIONS(709),
    [anon_sym_float32] = ACTIONS(709),
    [anon_sym_float64] = ACTIONS(709),
    [anon_sym_uint] = ACTIONS(709),
    [anon_sym_uint8] = ACTIONS(709),
    [anon_sym_uint16] = ACTIONS(709),
    [anon_sym_uint32] = ACTIONS(709),
    [anon_sym_uint64] = ACTIONS(709),
    [anon_sym_uint128] = ACTIONS(709),
    [anon_sym_int] = ACTIONS(709),
    [anon_sym_int8] = ACTIONS(709),
    [anon_sym_int16] = ACTIONS(709),
    [anon_sym_int32] = ACTIONS(709),
    [anon_sym_int64] = ACTIONS(709),
    [anon_sym_int128] = ACTIONS(709),
    [sym_string_type] = ACTIONS(709),
    [sym_bytes_type] = ACTIONS(709),
    [sym_bool_type] = ACTIONS(709),
    [sym_bottom_lit] = ACTIONS(711),
    [sym_null] = ACTIONS(709),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_int_lit] = ACTIONS(709),
    [sym_float_lit] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_RBRACK] = ACTIONS(711),
    [anon_sym_LBRACE] = ACTIONS(711),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(709),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(709),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_PIPE_PIPE] = ACTIONS(711),
    [anon_sym_AMP_AMP] = ACTIONS(711),
    [anon_sym_EQ_EQ] = ACTIONS(711),
    [anon_sym_BANG_EQ] = ACTIONS(711),
    [anon_sym_LT] = ACTIONS(709),
    [anon_sym_LT_EQ] = ACTIONS(711),
    [anon_sym_GT] = ACTIONS(709),
    [anon_sym_GT_EQ] = ACTIONS(711),
    [anon_sym_EQ_TILDE] = ACTIONS(711),
    [anon_sym_BANG_TILDE] = ACTIONS(711),
    [anon_sym_PLUS] = ACTIONS(711),
    [anon_sym_DASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(711),
    [anon_sym_SLASH] = ACTIONS(709),
    [anon_sym_BANG] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
  },
  [163] = {
    [sym_identifier] = ACTIONS(709),
    [anon_sym_COMMA] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(711),
    [anon_sym__] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(709),
    [anon_sym_POUND_DQUOTE] = ACTIONS(709),
    [anon_sym_SQUOTE] = ACTIONS(709),
    [anon_sym_POUND_SQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(711),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(711),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(711),
    [anon_sym_len] = ACTIONS(709),
    [anon_sym_close] = ACTIONS(709),
    [anon_sym_and] = ACTIONS(709),
    [anon_sym_or] = ACTIONS(709),
    [anon_sym_div] = ACTIONS(709),
    [anon_sym_mod] = ACTIONS(709),
    [anon_sym_quo] = ACTIONS(709),
    [anon_sym_rem] = ACTIONS(709),
    [sym_number_type] = ACTIONS(709),
    [anon_sym_float] = ACTIONS(709),
    [anon_sym_float32] = ACTIONS(709),
    [anon_sym_float64] = ACTIONS(709),
    [anon_sym_uint] = ACTIONS(709),
    [anon_sym_uint8] = ACTIONS(709),
    [anon_sym_uint16] = ACTIONS(709),
    [anon_sym_uint32] = ACTIONS(709),
    [anon_sym_uint64] = ACTIONS(709),
    [anon_sym_uint128] = ACTIONS(709),
    [anon_sym_int] = ACTIONS(709),
    [anon_sym_int8] = ACTIONS(709),
    [anon_sym_int16] = ACTIONS(709),
    [anon_sym_int32] = ACTIONS(709),
    [anon_sym_int64] = ACTIONS(709),
    [anon_sym_int128] = ACTIONS(709),
    [sym_string_type] = ACTIONS(709),
    [sym_bytes_type] = ACTIONS(709),
    [sym_bool_type] = ACTIONS(709),
    [sym_bottom_lit] = ACTIONS(711),
    [sym_null] = ACTIONS(709),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_int_lit] = ACTIONS(709),
    [sym_float_lit] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_RBRACK] = ACTIONS(711),
    [anon_sym_LBRACE] = ACTIONS(711),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(709),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(709),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_PIPE_PIPE] = ACTIONS(711),
    [anon_sym_AMP_AMP] = ACTIONS(711),
    [anon_sym_EQ_EQ] = ACTIONS(711),
    [anon_sym_BANG_EQ] = ACTIONS(711),
    [anon_sym_LT] = ACTIONS(709),
    [anon_sym_LT_EQ] = ACTIONS(711),
    [anon_sym_GT] = ACTIONS(709),
    [anon_sym_GT_EQ] = ACTIONS(711),
    [anon_sym_EQ_TILDE] = ACTIONS(711),
    [anon_sym_BANG_TILDE] = ACTIONS(711),
    [anon_sym_PLUS] = ACTIONS(749),
    [anon_sym_DASH] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(751),
    [anon_sym_SLASH] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
  },
  [164] = {
    [sym_identifier] = ACTIONS(709),
    [anon_sym_COMMA] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(711),
    [anon_sym__] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(709),
    [anon_sym_POUND_DQUOTE] = ACTIONS(709),
    [anon_sym_SQUOTE] = ACTIONS(709),
    [anon_sym_POUND_SQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(711),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(711),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(711),
    [anon_sym_len] = ACTIONS(709),
    [anon_sym_close] = ACTIONS(709),
    [anon_sym_and] = ACTIONS(709),
    [anon_sym_or] = ACTIONS(709),
    [anon_sym_div] = ACTIONS(709),
    [anon_sym_mod] = ACTIONS(709),
    [anon_sym_quo] = ACTIONS(709),
    [anon_sym_rem] = ACTIONS(709),
    [sym_number_type] = ACTIONS(709),
    [anon_sym_float] = ACTIONS(709),
    [anon_sym_float32] = ACTIONS(709),
    [anon_sym_float64] = ACTIONS(709),
    [anon_sym_uint] = ACTIONS(709),
    [anon_sym_uint8] = ACTIONS(709),
    [anon_sym_uint16] = ACTIONS(709),
    [anon_sym_uint32] = ACTIONS(709),
    [anon_sym_uint64] = ACTIONS(709),
    [anon_sym_uint128] = ACTIONS(709),
    [anon_sym_int] = ACTIONS(709),
    [anon_sym_int8] = ACTIONS(709),
    [anon_sym_int16] = ACTIONS(709),
    [anon_sym_int32] = ACTIONS(709),
    [anon_sym_int64] = ACTIONS(709),
    [anon_sym_int128] = ACTIONS(709),
    [sym_string_type] = ACTIONS(709),
    [sym_bytes_type] = ACTIONS(709),
    [sym_bool_type] = ACTIONS(709),
    [sym_bottom_lit] = ACTIONS(711),
    [sym_null] = ACTIONS(709),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_int_lit] = ACTIONS(709),
    [sym_float_lit] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_RBRACK] = ACTIONS(711),
    [anon_sym_LBRACE] = ACTIONS(711),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(709),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(709),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_PIPE_PIPE] = ACTIONS(711),
    [anon_sym_AMP_AMP] = ACTIONS(711),
    [anon_sym_EQ_EQ] = ACTIONS(755),
    [anon_sym_BANG_EQ] = ACTIONS(755),
    [anon_sym_LT] = ACTIONS(757),
    [anon_sym_LT_EQ] = ACTIONS(755),
    [anon_sym_GT] = ACTIONS(757),
    [anon_sym_GT_EQ] = ACTIONS(755),
    [anon_sym_EQ_TILDE] = ACTIONS(755),
    [anon_sym_BANG_TILDE] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(749),
    [anon_sym_DASH] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(751),
    [anon_sym_SLASH] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
  },
  [165] = {
    [sym_identifier] = ACTIONS(709),
    [anon_sym_COMMA] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(711),
    [anon_sym__] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(709),
    [anon_sym_POUND_DQUOTE] = ACTIONS(709),
    [anon_sym_SQUOTE] = ACTIONS(709),
    [anon_sym_POUND_SQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(711),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(711),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(711),
    [anon_sym_len] = ACTIONS(709),
    [anon_sym_close] = ACTIONS(709),
    [anon_sym_and] = ACTIONS(709),
    [anon_sym_or] = ACTIONS(709),
    [anon_sym_div] = ACTIONS(709),
    [anon_sym_mod] = ACTIONS(709),
    [anon_sym_quo] = ACTIONS(709),
    [anon_sym_rem] = ACTIONS(709),
    [sym_number_type] = ACTIONS(709),
    [anon_sym_float] = ACTIONS(709),
    [anon_sym_float32] = ACTIONS(709),
    [anon_sym_float64] = ACTIONS(709),
    [anon_sym_uint] = ACTIONS(709),
    [anon_sym_uint8] = ACTIONS(709),
    [anon_sym_uint16] = ACTIONS(709),
    [anon_sym_uint32] = ACTIONS(709),
    [anon_sym_uint64] = ACTIONS(709),
    [anon_sym_uint128] = ACTIONS(709),
    [anon_sym_int] = ACTIONS(709),
    [anon_sym_int8] = ACTIONS(709),
    [anon_sym_int16] = ACTIONS(709),
    [anon_sym_int32] = ACTIONS(709),
    [anon_sym_int64] = ACTIONS(709),
    [anon_sym_int128] = ACTIONS(709),
    [sym_string_type] = ACTIONS(709),
    [sym_bytes_type] = ACTIONS(709),
    [sym_bool_type] = ACTIONS(709),
    [sym_bottom_lit] = ACTIONS(711),
    [sym_null] = ACTIONS(709),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_int_lit] = ACTIONS(709),
    [sym_float_lit] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_RBRACK] = ACTIONS(711),
    [anon_sym_LBRACE] = ACTIONS(711),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(709),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(709),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_PIPE_PIPE] = ACTIONS(711),
    [anon_sym_AMP_AMP] = ACTIONS(759),
    [anon_sym_EQ_EQ] = ACTIONS(755),
    [anon_sym_BANG_EQ] = ACTIONS(755),
    [anon_sym_LT] = ACTIONS(757),
    [anon_sym_LT_EQ] = ACTIONS(755),
    [anon_sym_GT] = ACTIONS(757),
    [anon_sym_GT_EQ] = ACTIONS(755),
    [anon_sym_EQ_TILDE] = ACTIONS(755),
    [anon_sym_BANG_TILDE] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(749),
    [anon_sym_DASH] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(751),
    [anon_sym_SLASH] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
  },
  [166] = {
    [sym_identifier] = ACTIONS(709),
    [anon_sym_COMMA] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(711),
    [anon_sym__] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(709),
    [anon_sym_POUND_DQUOTE] = ACTIONS(709),
    [anon_sym_SQUOTE] = ACTIONS(709),
    [anon_sym_POUND_SQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(711),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(711),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(711),
    [anon_sym_len] = ACTIONS(709),
    [anon_sym_close] = ACTIONS(709),
    [anon_sym_and] = ACTIONS(709),
    [anon_sym_or] = ACTIONS(709),
    [anon_sym_div] = ACTIONS(709),
    [anon_sym_mod] = ACTIONS(709),
    [anon_sym_quo] = ACTIONS(709),
    [anon_sym_rem] = ACTIONS(709),
    [sym_number_type] = ACTIONS(709),
    [anon_sym_float] = ACTIONS(709),
    [anon_sym_float32] = ACTIONS(709),
    [anon_sym_float64] = ACTIONS(709),
    [anon_sym_uint] = ACTIONS(709),
    [anon_sym_uint8] = ACTIONS(709),
    [anon_sym_uint16] = ACTIONS(709),
    [anon_sym_uint32] = ACTIONS(709),
    [anon_sym_uint64] = ACTIONS(709),
    [anon_sym_uint128] = ACTIONS(709),
    [anon_sym_int] = ACTIONS(709),
    [anon_sym_int8] = ACTIONS(709),
    [anon_sym_int16] = ACTIONS(709),
    [anon_sym_int32] = ACTIONS(709),
    [anon_sym_int64] = ACTIONS(709),
    [anon_sym_int128] = ACTIONS(709),
    [sym_string_type] = ACTIONS(709),
    [sym_bytes_type] = ACTIONS(709),
    [sym_bool_type] = ACTIONS(709),
    [sym_bottom_lit] = ACTIONS(711),
    [sym_null] = ACTIONS(709),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_int_lit] = ACTIONS(709),
    [sym_float_lit] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_RBRACK] = ACTIONS(711),
    [anon_sym_LBRACE] = ACTIONS(711),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(709),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(709),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_PIPE_PIPE] = ACTIONS(761),
    [anon_sym_AMP_AMP] = ACTIONS(759),
    [anon_sym_EQ_EQ] = ACTIONS(755),
    [anon_sym_BANG_EQ] = ACTIONS(755),
    [anon_sym_LT] = ACTIONS(757),
    [anon_sym_LT_EQ] = ACTIONS(755),
    [anon_sym_GT] = ACTIONS(757),
    [anon_sym_GT_EQ] = ACTIONS(755),
    [anon_sym_EQ_TILDE] = ACTIONS(755),
    [anon_sym_BANG_TILDE] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(749),
    [anon_sym_DASH] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(751),
    [anon_sym_SLASH] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
  },
  [167] = {
    [sym_identifier] = ACTIONS(741),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym__] = ACTIONS(741),
    [anon_sym_DQUOTE] = ACTIONS(741),
    [anon_sym_POUND_DQUOTE] = ACTIONS(741),
    [anon_sym_SQUOTE] = ACTIONS(741),
    [anon_sym_POUND_SQUOTE] = ACTIONS(741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(743),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(743),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(743),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(743),
    [anon_sym_len] = ACTIONS(741),
    [anon_sym_close] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(741),
    [anon_sym_div] = ACTIONS(741),
    [anon_sym_mod] = ACTIONS(741),
    [anon_sym_quo] = ACTIONS(741),
    [anon_sym_rem] = ACTIONS(741),
    [sym_number_type] = ACTIONS(741),
    [anon_sym_float] = ACTIONS(741),
    [anon_sym_float32] = ACTIONS(741),
    [anon_sym_float64] = ACTIONS(741),
    [anon_sym_uint] = ACTIONS(741),
    [anon_sym_uint8] = ACTIONS(741),
    [anon_sym_uint16] = ACTIONS(741),
    [anon_sym_uint32] = ACTIONS(741),
    [anon_sym_uint64] = ACTIONS(741),
    [anon_sym_uint128] = ACTIONS(741),
    [anon_sym_int] = ACTIONS(741),
    [anon_sym_int8] = ACTIONS(741),
    [anon_sym_int16] = ACTIONS(741),
    [anon_sym_int32] = ACTIONS(741),
    [anon_sym_int64] = ACTIONS(741),
    [anon_sym_int128] = ACTIONS(741),
    [sym_string_type] = ACTIONS(741),
    [sym_bytes_type] = ACTIONS(741),
    [sym_bool_type] = ACTIONS(741),
    [sym_bottom_lit] = ACTIONS(743),
    [sym_null] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_int_lit] = ACTIONS(741),
    [sym_float_lit] = ACTIONS(741),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_LT_EQ] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_STAR] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_BANG] = ACTIONS(741),
    [sym_comment] = ACTIONS(3),
  },
  [168] = {
    [sym_identifier] = ACTIONS(709),
    [anon_sym_COMMA] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(711),
    [anon_sym__] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(709),
    [anon_sym_POUND_DQUOTE] = ACTIONS(709),
    [anon_sym_SQUOTE] = ACTIONS(709),
    [anon_sym_POUND_SQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(711),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(711),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(711),
    [anon_sym_len] = ACTIONS(709),
    [anon_sym_close] = ACTIONS(709),
    [anon_sym_and] = ACTIONS(709),
    [anon_sym_or] = ACTIONS(709),
    [anon_sym_div] = ACTIONS(709),
    [anon_sym_mod] = ACTIONS(709),
    [anon_sym_quo] = ACTIONS(709),
    [anon_sym_rem] = ACTIONS(709),
    [sym_number_type] = ACTIONS(709),
    [anon_sym_float] = ACTIONS(709),
    [anon_sym_float32] = ACTIONS(709),
    [anon_sym_float64] = ACTIONS(709),
    [anon_sym_uint] = ACTIONS(709),
    [anon_sym_uint8] = ACTIONS(709),
    [anon_sym_uint16] = ACTIONS(709),
    [anon_sym_uint32] = ACTIONS(709),
    [anon_sym_uint64] = ACTIONS(709),
    [anon_sym_uint128] = ACTIONS(709),
    [anon_sym_int] = ACTIONS(709),
    [anon_sym_int8] = ACTIONS(709),
    [anon_sym_int16] = ACTIONS(709),
    [anon_sym_int32] = ACTIONS(709),
    [anon_sym_int64] = ACTIONS(709),
    [anon_sym_int128] = ACTIONS(709),
    [sym_string_type] = ACTIONS(709),
    [sym_bytes_type] = ACTIONS(709),
    [sym_bool_type] = ACTIONS(709),
    [sym_bottom_lit] = ACTIONS(711),
    [sym_null] = ACTIONS(709),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_int_lit] = ACTIONS(709),
    [sym_float_lit] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_RBRACK] = ACTIONS(711),
    [anon_sym_LBRACE] = ACTIONS(711),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(709),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(709),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_AMP] = ACTIONS(763),
    [anon_sym_PIPE_PIPE] = ACTIONS(761),
    [anon_sym_AMP_AMP] = ACTIONS(759),
    [anon_sym_EQ_EQ] = ACTIONS(755),
    [anon_sym_BANG_EQ] = ACTIONS(755),
    [anon_sym_LT] = ACTIONS(757),
    [anon_sym_LT_EQ] = ACTIONS(755),
    [anon_sym_GT] = ACTIONS(757),
    [anon_sym_GT_EQ] = ACTIONS(755),
    [anon_sym_EQ_TILDE] = ACTIONS(755),
    [anon_sym_BANG_TILDE] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(749),
    [anon_sym_DASH] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(751),
    [anon_sym_SLASH] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
  },
  [169] = {
    [sym_identifier] = ACTIONS(709),
    [anon_sym_COMMA] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(711),
    [anon_sym__] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(709),
    [anon_sym_POUND_DQUOTE] = ACTIONS(709),
    [anon_sym_SQUOTE] = ACTIONS(709),
    [anon_sym_POUND_SQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(711),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(711),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(711),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(711),
    [anon_sym_len] = ACTIONS(709),
    [anon_sym_close] = ACTIONS(709),
    [anon_sym_and] = ACTIONS(709),
    [anon_sym_or] = ACTIONS(709),
    [anon_sym_div] = ACTIONS(709),
    [anon_sym_mod] = ACTIONS(709),
    [anon_sym_quo] = ACTIONS(709),
    [anon_sym_rem] = ACTIONS(709),
    [sym_number_type] = ACTIONS(709),
    [anon_sym_float] = ACTIONS(709),
    [anon_sym_float32] = ACTIONS(709),
    [anon_sym_float64] = ACTIONS(709),
    [anon_sym_uint] = ACTIONS(709),
    [anon_sym_uint8] = ACTIONS(709),
    [anon_sym_uint16] = ACTIONS(709),
    [anon_sym_uint32] = ACTIONS(709),
    [anon_sym_uint64] = ACTIONS(709),
    [anon_sym_uint128] = ACTIONS(709),
    [anon_sym_int] = ACTIONS(709),
    [anon_sym_int8] = ACTIONS(709),
    [anon_sym_int16] = ACTIONS(709),
    [anon_sym_int32] = ACTIONS(709),
    [anon_sym_int64] = ACTIONS(709),
    [anon_sym_int128] = ACTIONS(709),
    [sym_string_type] = ACTIONS(709),
    [sym_bytes_type] = ACTIONS(709),
    [sym_bool_type] = ACTIONS(709),
    [sym_bottom_lit] = ACTIONS(711),
    [sym_null] = ACTIONS(709),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_int_lit] = ACTIONS(709),
    [sym_float_lit] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_RBRACK] = ACTIONS(711),
    [anon_sym_LBRACE] = ACTIONS(711),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(709),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(709),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_AMP] = ACTIONS(709),
    [anon_sym_PIPE_PIPE] = ACTIONS(711),
    [anon_sym_AMP_AMP] = ACTIONS(711),
    [anon_sym_EQ_EQ] = ACTIONS(711),
    [anon_sym_BANG_EQ] = ACTIONS(711),
    [anon_sym_LT] = ACTIONS(709),
    [anon_sym_LT_EQ] = ACTIONS(711),
    [anon_sym_GT] = ACTIONS(709),
    [anon_sym_GT_EQ] = ACTIONS(711),
    [anon_sym_EQ_TILDE] = ACTIONS(711),
    [anon_sym_BANG_TILDE] = ACTIONS(711),
    [anon_sym_PLUS] = ACTIONS(711),
    [anon_sym_DASH] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(751),
    [anon_sym_SLASH] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
  },
  [170] = {
    [sym_identifier] = ACTIONS(723),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym__] = ACTIONS(723),
    [anon_sym_DQUOTE] = ACTIONS(723),
    [anon_sym_POUND_DQUOTE] = ACTIONS(723),
    [anon_sym_SQUOTE] = ACTIONS(723),
    [anon_sym_POUND_SQUOTE] = ACTIONS(723),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(725),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(725),
    [anon_sym_len] = ACTIONS(723),
    [anon_sym_close] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(723),
    [anon_sym_or] = ACTIONS(723),
    [anon_sym_div] = ACTIONS(723),
    [anon_sym_mod] = ACTIONS(723),
    [anon_sym_quo] = ACTIONS(723),
    [anon_sym_rem] = ACTIONS(723),
    [sym_number_type] = ACTIONS(723),
    [anon_sym_float] = ACTIONS(723),
    [anon_sym_float32] = ACTIONS(723),
    [anon_sym_float64] = ACTIONS(723),
    [anon_sym_uint] = ACTIONS(723),
    [anon_sym_uint8] = ACTIONS(723),
    [anon_sym_uint16] = ACTIONS(723),
    [anon_sym_uint32] = ACTIONS(723),
    [anon_sym_uint64] = ACTIONS(723),
    [anon_sym_uint128] = ACTIONS(723),
    [anon_sym_int] = ACTIONS(723),
    [anon_sym_int8] = ACTIONS(723),
    [anon_sym_int16] = ACTIONS(723),
    [anon_sym_int32] = ACTIONS(723),
    [anon_sym_int64] = ACTIONS(723),
    [anon_sym_int128] = ACTIONS(723),
    [sym_string_type] = ACTIONS(723),
    [sym_bytes_type] = ACTIONS(723),
    [sym_bool_type] = ACTIONS(723),
    [sym_bottom_lit] = ACTIONS(725),
    [sym_null] = ACTIONS(723),
    [sym_true] = ACTIONS(723),
    [sym_false] = ACTIONS(723),
    [sym_int_lit] = ACTIONS(723),
    [sym_float_lit] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(725),
    [anon_sym_RBRACK] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(725),
    [anon_sym_for] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_PIPE] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(763),
    [anon_sym_PIPE_PIPE] = ACTIONS(761),
    [anon_sym_AMP_AMP] = ACTIONS(759),
    [anon_sym_EQ_EQ] = ACTIONS(755),
    [anon_sym_BANG_EQ] = ACTIONS(755),
    [anon_sym_LT] = ACTIONS(757),
    [anon_sym_LT_EQ] = ACTIONS(755),
    [anon_sym_GT] = ACTIONS(757),
    [anon_sym_GT_EQ] = ACTIONS(755),
    [anon_sym_EQ_TILDE] = ACTIONS(755),
    [anon_sym_BANG_TILDE] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(749),
    [anon_sym_DASH] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(751),
    [anon_sym_SLASH] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
  },
  [171] = {
    [sym_identifier] = ACTIONS(737),
    [anon_sym_COMMA] = ACTIONS(739),
    [anon_sym_LPAREN] = ACTIONS(739),
    [anon_sym__] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [anon_sym_POUND_DQUOTE] = ACTIONS(737),
    [anon_sym_SQUOTE] = ACTIONS(737),
    [anon_sym_POUND_SQUOTE] = ACTIONS(737),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(739),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(739),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(739),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(739),
    [anon_sym_len] = ACTIONS(737),
    [anon_sym_close] = ACTIONS(737),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_or] = ACTIONS(737),
    [anon_sym_div] = ACTIONS(737),
    [anon_sym_mod] = ACTIONS(737),
    [anon_sym_quo] = ACTIONS(737),
    [anon_sym_rem] = ACTIONS(737),
    [sym_number_type] = ACTIONS(737),
    [anon_sym_float] = ACTIONS(737),
    [anon_sym_float32] = ACTIONS(737),
    [anon_sym_float64] = ACTIONS(737),
    [anon_sym_uint] = ACTIONS(737),
    [anon_sym_uint8] = ACTIONS(737),
    [anon_sym_uint16] = ACTIONS(737),
    [anon_sym_uint32] = ACTIONS(737),
    [anon_sym_uint64] = ACTIONS(737),
    [anon_sym_uint128] = ACTIONS(737),
    [anon_sym_int] = ACTIONS(737),
    [anon_sym_int8] = ACTIONS(737),
    [anon_sym_int16] = ACTIONS(737),
    [anon_sym_int32] = ACTIONS(737),
    [anon_sym_int64] = ACTIONS(737),
    [anon_sym_int128] = ACTIONS(737),
    [sym_string_type] = ACTIONS(737),
    [sym_bytes_type] = ACTIONS(737),
    [sym_bool_type] = ACTIONS(737),
    [sym_bottom_lit] = ACTIONS(739),
    [sym_null] = ACTIONS(737),
    [sym_true] = ACTIONS(737),
    [sym_false] = ACTIONS(737),
    [sym_int_lit] = ACTIONS(737),
    [sym_float_lit] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_RBRACK] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(739),
    [anon_sym_for] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(763),
    [anon_sym_PIPE_PIPE] = ACTIONS(761),
    [anon_sym_AMP_AMP] = ACTIONS(759),
    [anon_sym_EQ_EQ] = ACTIONS(755),
    [anon_sym_BANG_EQ] = ACTIONS(755),
    [anon_sym_LT] = ACTIONS(757),
    [anon_sym_LT_EQ] = ACTIONS(755),
    [anon_sym_GT] = ACTIONS(757),
    [anon_sym_GT_EQ] = ACTIONS(755),
    [anon_sym_EQ_TILDE] = ACTIONS(755),
    [anon_sym_BANG_TILDE] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(749),
    [anon_sym_DASH] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(751),
    [anon_sym_SLASH] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(737),
    [sym_comment] = ACTIONS(3),
  },
  [172] = {
    [sym_identifier] = ACTIONS(745),
    [anon_sym_COMMA] = ACTIONS(747),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym__] = ACTIONS(745),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_POUND_DQUOTE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(745),
    [anon_sym_POUND_SQUOTE] = ACTIONS(745),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(747),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(747),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(747),
    [anon_sym_len] = ACTIONS(745),
    [anon_sym_close] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(745),
    [anon_sym_or] = ACTIONS(745),
    [anon_sym_div] = ACTIONS(745),
    [anon_sym_mod] = ACTIONS(745),
    [anon_sym_quo] = ACTIONS(745),
    [anon_sym_rem] = ACTIONS(745),
    [sym_number_type] = ACTIONS(745),
    [anon_sym_float] = ACTIONS(745),
    [anon_sym_float32] = ACTIONS(745),
    [anon_sym_float64] = ACTIONS(745),
    [anon_sym_uint] = ACTIONS(745),
    [anon_sym_uint8] = ACTIONS(745),
    [anon_sym_uint16] = ACTIONS(745),
    [anon_sym_uint32] = ACTIONS(745),
    [anon_sym_uint64] = ACTIONS(745),
    [anon_sym_uint128] = ACTIONS(745),
    [anon_sym_int] = ACTIONS(745),
    [anon_sym_int8] = ACTIONS(745),
    [anon_sym_int16] = ACTIONS(745),
    [anon_sym_int32] = ACTIONS(745),
    [anon_sym_int64] = ACTIONS(745),
    [anon_sym_int128] = ACTIONS(745),
    [sym_string_type] = ACTIONS(745),
    [sym_bytes_type] = ACTIONS(745),
    [sym_bool_type] = ACTIONS(745),
    [sym_bottom_lit] = ACTIONS(747),
    [sym_null] = ACTIONS(745),
    [sym_true] = ACTIONS(745),
    [sym_false] = ACTIONS(745),
    [sym_int_lit] = ACTIONS(745),
    [sym_float_lit] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(747),
    [anon_sym_RBRACK] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(747),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(763),
    [anon_sym_PIPE_PIPE] = ACTIONS(761),
    [anon_sym_AMP_AMP] = ACTIONS(759),
    [anon_sym_EQ_EQ] = ACTIONS(755),
    [anon_sym_BANG_EQ] = ACTIONS(755),
    [anon_sym_LT] = ACTIONS(757),
    [anon_sym_LT_EQ] = ACTIONS(755),
    [anon_sym_GT] = ACTIONS(757),
    [anon_sym_GT_EQ] = ACTIONS(755),
    [anon_sym_EQ_TILDE] = ACTIONS(755),
    [anon_sym_BANG_TILDE] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(749),
    [anon_sym_DASH] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(751),
    [anon_sym_SLASH] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
  },
  [173] = {
    [sym_attribute] = STATE(181),
    [sym_identifier] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND_DQUOTE] = ACTIONS(767),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_POUND_SQUOTE] = ACTIONS(767),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(767),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(767),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(767),
    [anon_sym_len] = ACTIONS(767),
    [anon_sym_close] = ACTIONS(767),
    [anon_sym_and] = ACTIONS(767),
    [anon_sym_or] = ACTIONS(767),
    [anon_sym_div] = ACTIONS(767),
    [anon_sym_mod] = ACTIONS(767),
    [anon_sym_quo] = ACTIONS(767),
    [anon_sym_rem] = ACTIONS(767),
    [sym_number_type] = ACTIONS(767),
    [anon_sym_float] = ACTIONS(767),
    [anon_sym_float32] = ACTIONS(767),
    [anon_sym_float64] = ACTIONS(767),
    [anon_sym_uint] = ACTIONS(767),
    [anon_sym_uint8] = ACTIONS(767),
    [anon_sym_uint16] = ACTIONS(767),
    [anon_sym_uint32] = ACTIONS(767),
    [anon_sym_uint64] = ACTIONS(767),
    [anon_sym_uint128] = ACTIONS(767),
    [anon_sym_int] = ACTIONS(767),
    [anon_sym_int8] = ACTIONS(767),
    [anon_sym_int16] = ACTIONS(767),
    [anon_sym_int32] = ACTIONS(767),
    [anon_sym_int64] = ACTIONS(767),
    [anon_sym_int128] = ACTIONS(767),
    [sym_string_type] = ACTIONS(767),
    [sym_bytes_type] = ACTIONS(767),
    [sym_bool_type] = ACTIONS(767),
    [sym_bottom_lit] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_int_lit] = ACTIONS(767),
    [sym_float_lit] = ACTIONS(767),
    [anon_sym_LBRACK] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(767),
    [anon_sym_for] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_let] = ACTIONS(767),
    [anon_sym_BANG_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(767),
    [anon_sym_EQ_TILDE] = ACTIONS(767),
    [anon_sym_BANG_TILDE] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(767),
    [sym_comment] = ACTIONS(530),
  },
  [174] = {
    [sym_identifier] = ACTIONS(771),
    [anon_sym_LF] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(771),
    [anon_sym__] = ACTIONS(771),
    [anon_sym_AT] = ACTIONS(771),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_POUND_DQUOTE] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(771),
    [anon_sym_POUND_SQUOTE] = ACTIONS(771),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(771),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(771),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(771),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(771),
    [anon_sym_len] = ACTIONS(771),
    [anon_sym_close] = ACTIONS(771),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_div] = ACTIONS(771),
    [anon_sym_mod] = ACTIONS(771),
    [anon_sym_quo] = ACTIONS(771),
    [anon_sym_rem] = ACTIONS(771),
    [sym_number_type] = ACTIONS(771),
    [anon_sym_float] = ACTIONS(771),
    [anon_sym_float32] = ACTIONS(771),
    [anon_sym_float64] = ACTIONS(771),
    [anon_sym_uint] = ACTIONS(771),
    [anon_sym_uint8] = ACTIONS(771),
    [anon_sym_uint16] = ACTIONS(771),
    [anon_sym_uint32] = ACTIONS(771),
    [anon_sym_uint64] = ACTIONS(771),
    [anon_sym_uint128] = ACTIONS(771),
    [anon_sym_int] = ACTIONS(771),
    [anon_sym_int8] = ACTIONS(771),
    [anon_sym_int16] = ACTIONS(771),
    [anon_sym_int32] = ACTIONS(771),
    [anon_sym_int64] = ACTIONS(771),
    [anon_sym_int128] = ACTIONS(771),
    [sym_string_type] = ACTIONS(771),
    [sym_bytes_type] = ACTIONS(771),
    [sym_bool_type] = ACTIONS(771),
    [sym_bottom_lit] = ACTIONS(771),
    [sym_null] = ACTIONS(771),
    [sym_true] = ACTIONS(771),
    [sym_false] = ACTIONS(771),
    [sym_int_lit] = ACTIONS(771),
    [sym_float_lit] = ACTIONS(771),
    [anon_sym_LBRACK] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_RBRACE] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(771),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_let] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(771),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(771),
    [anon_sym_EQ_TILDE] = ACTIONS(771),
    [anon_sym_BANG_TILDE] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_DASH] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_BANG] = ACTIONS(771),
    [sym_comment] = ACTIONS(530),
  },
  [175] = {
    [sym_identifier] = ACTIONS(777),
    [anon_sym_LF] = ACTIONS(779),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym__] = ACTIONS(777),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(777),
    [anon_sym_POUND_DQUOTE] = ACTIONS(777),
    [anon_sym_SQUOTE] = ACTIONS(777),
    [anon_sym_POUND_SQUOTE] = ACTIONS(777),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(777),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(777),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(777),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(777),
    [anon_sym_len] = ACTIONS(777),
    [anon_sym_close] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_div] = ACTIONS(777),
    [anon_sym_mod] = ACTIONS(777),
    [anon_sym_quo] = ACTIONS(777),
    [anon_sym_rem] = ACTIONS(777),
    [sym_number_type] = ACTIONS(777),
    [anon_sym_float] = ACTIONS(777),
    [anon_sym_float32] = ACTIONS(777),
    [anon_sym_float64] = ACTIONS(777),
    [anon_sym_uint] = ACTIONS(777),
    [anon_sym_uint8] = ACTIONS(777),
    [anon_sym_uint16] = ACTIONS(777),
    [anon_sym_uint32] = ACTIONS(777),
    [anon_sym_uint64] = ACTIONS(777),
    [anon_sym_uint128] = ACTIONS(777),
    [anon_sym_int] = ACTIONS(777),
    [anon_sym_int8] = ACTIONS(777),
    [anon_sym_int16] = ACTIONS(777),
    [anon_sym_int32] = ACTIONS(777),
    [anon_sym_int64] = ACTIONS(777),
    [anon_sym_int128] = ACTIONS(777),
    [sym_string_type] = ACTIONS(777),
    [sym_bytes_type] = ACTIONS(777),
    [sym_bool_type] = ACTIONS(777),
    [sym_bottom_lit] = ACTIONS(777),
    [sym_null] = ACTIONS(777),
    [sym_true] = ACTIONS(777),
    [sym_false] = ACTIONS(777),
    [sym_int_lit] = ACTIONS(777),
    [sym_float_lit] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_for] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_let] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(777),
    [sym_comment] = ACTIONS(530),
  },
  [176] = {
    [sym_import_declaration] = STATE(176),
    [aux_sym_source_file_repeat1] = STATE(176),
    [ts_builtin_sym_end] = ACTIONS(781),
    [sym_identifier] = ACTIONS(783),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym__] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(783),
    [anon_sym_POUND_DQUOTE] = ACTIONS(783),
    [anon_sym_SQUOTE] = ACTIONS(783),
    [anon_sym_POUND_SQUOTE] = ACTIONS(783),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(781),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(781),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(781),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(781),
    [anon_sym_len] = ACTIONS(783),
    [anon_sym_close] = ACTIONS(783),
    [anon_sym_and] = ACTIONS(783),
    [anon_sym_or] = ACTIONS(783),
    [anon_sym_div] = ACTIONS(783),
    [anon_sym_mod] = ACTIONS(783),
    [anon_sym_quo] = ACTIONS(783),
    [anon_sym_rem] = ACTIONS(783),
    [sym_number_type] = ACTIONS(783),
    [anon_sym_float] = ACTIONS(783),
    [anon_sym_float32] = ACTIONS(783),
    [anon_sym_float64] = ACTIONS(783),
    [anon_sym_uint] = ACTIONS(783),
    [anon_sym_uint8] = ACTIONS(783),
    [anon_sym_uint16] = ACTIONS(783),
    [anon_sym_uint32] = ACTIONS(783),
    [anon_sym_uint64] = ACTIONS(783),
    [anon_sym_uint128] = ACTIONS(783),
    [anon_sym_int] = ACTIONS(783),
    [anon_sym_int8] = ACTIONS(783),
    [anon_sym_int16] = ACTIONS(783),
    [anon_sym_int32] = ACTIONS(783),
    [anon_sym_int64] = ACTIONS(783),
    [anon_sym_int128] = ACTIONS(783),
    [sym_string_type] = ACTIONS(783),
    [sym_bytes_type] = ACTIONS(783),
    [sym_bool_type] = ACTIONS(783),
    [sym_bottom_lit] = ACTIONS(781),
    [sym_null] = ACTIONS(783),
    [sym_true] = ACTIONS(783),
    [sym_false] = ACTIONS(783),
    [sym_int_lit] = ACTIONS(783),
    [sym_float_lit] = ACTIONS(783),
    [anon_sym_LBRACK] = ACTIONS(781),
    [anon_sym_LBRACE] = ACTIONS(781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(781),
    [anon_sym_for] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(783),
    [anon_sym_let] = ACTIONS(783),
    [anon_sym_BANG_EQ] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(783),
    [anon_sym_GT_EQ] = ACTIONS(781),
    [anon_sym_EQ_TILDE] = ACTIONS(781),
    [anon_sym_BANG_TILDE] = ACTIONS(781),
    [anon_sym_PLUS] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [177] = {
    [sym_identifier] = ACTIONS(788),
    [anon_sym_LF] = ACTIONS(790),
    [anon_sym_COMMA] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(788),
    [anon_sym__] = ACTIONS(788),
    [anon_sym_AT] = ACTIONS(788),
    [anon_sym_DQUOTE] = ACTIONS(788),
    [anon_sym_POUND_DQUOTE] = ACTIONS(788),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_POUND_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(788),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(788),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(788),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(788),
    [anon_sym_len] = ACTIONS(788),
    [anon_sym_close] = ACTIONS(788),
    [anon_sym_and] = ACTIONS(788),
    [anon_sym_or] = ACTIONS(788),
    [anon_sym_div] = ACTIONS(788),
    [anon_sym_mod] = ACTIONS(788),
    [anon_sym_quo] = ACTIONS(788),
    [anon_sym_rem] = ACTIONS(788),
    [sym_number_type] = ACTIONS(788),
    [anon_sym_float] = ACTIONS(788),
    [anon_sym_float32] = ACTIONS(788),
    [anon_sym_float64] = ACTIONS(788),
    [anon_sym_uint] = ACTIONS(788),
    [anon_sym_uint8] = ACTIONS(788),
    [anon_sym_uint16] = ACTIONS(788),
    [anon_sym_uint32] = ACTIONS(788),
    [anon_sym_uint64] = ACTIONS(788),
    [anon_sym_uint128] = ACTIONS(788),
    [anon_sym_int] = ACTIONS(788),
    [anon_sym_int8] = ACTIONS(788),
    [anon_sym_int16] = ACTIONS(788),
    [anon_sym_int32] = ACTIONS(788),
    [anon_sym_int64] = ACTIONS(788),
    [anon_sym_int128] = ACTIONS(788),
    [sym_string_type] = ACTIONS(788),
    [sym_bytes_type] = ACTIONS(788),
    [sym_bool_type] = ACTIONS(788),
    [sym_bottom_lit] = ACTIONS(788),
    [sym_null] = ACTIONS(788),
    [sym_true] = ACTIONS(788),
    [sym_false] = ACTIONS(788),
    [sym_int_lit] = ACTIONS(788),
    [sym_float_lit] = ACTIONS(788),
    [anon_sym_LBRACK] = ACTIONS(788),
    [anon_sym_LBRACE] = ACTIONS(788),
    [anon_sym_RBRACE] = ACTIONS(788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(788),
    [anon_sym_for] = ACTIONS(788),
    [anon_sym_if] = ACTIONS(788),
    [anon_sym_let] = ACTIONS(788),
    [anon_sym_BANG_EQ] = ACTIONS(788),
    [anon_sym_LT] = ACTIONS(788),
    [anon_sym_LT_EQ] = ACTIONS(788),
    [anon_sym_GT] = ACTIONS(788),
    [anon_sym_GT_EQ] = ACTIONS(788),
    [anon_sym_EQ_TILDE] = ACTIONS(788),
    [anon_sym_BANG_TILDE] = ACTIONS(788),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_STAR] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(788),
    [sym_comment] = ACTIONS(530),
  },
  [178] = {
    [sym_identifier] = ACTIONS(792),
    [anon_sym_LF] = ACTIONS(794),
    [anon_sym_COMMA] = ACTIONS(792),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym__] = ACTIONS(792),
    [anon_sym_AT] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(792),
    [anon_sym_POUND_DQUOTE] = ACTIONS(792),
    [anon_sym_SQUOTE] = ACTIONS(792),
    [anon_sym_POUND_SQUOTE] = ACTIONS(792),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(792),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(792),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_len] = ACTIONS(792),
    [anon_sym_close] = ACTIONS(792),
    [anon_sym_and] = ACTIONS(792),
    [anon_sym_or] = ACTIONS(792),
    [anon_sym_div] = ACTIONS(792),
    [anon_sym_mod] = ACTIONS(792),
    [anon_sym_quo] = ACTIONS(792),
    [anon_sym_rem] = ACTIONS(792),
    [sym_number_type] = ACTIONS(792),
    [anon_sym_float] = ACTIONS(792),
    [anon_sym_float32] = ACTIONS(792),
    [anon_sym_float64] = ACTIONS(792),
    [anon_sym_uint] = ACTIONS(792),
    [anon_sym_uint8] = ACTIONS(792),
    [anon_sym_uint16] = ACTIONS(792),
    [anon_sym_uint32] = ACTIONS(792),
    [anon_sym_uint64] = ACTIONS(792),
    [anon_sym_uint128] = ACTIONS(792),
    [anon_sym_int] = ACTIONS(792),
    [anon_sym_int8] = ACTIONS(792),
    [anon_sym_int16] = ACTIONS(792),
    [anon_sym_int32] = ACTIONS(792),
    [anon_sym_int64] = ACTIONS(792),
    [anon_sym_int128] = ACTIONS(792),
    [sym_string_type] = ACTIONS(792),
    [sym_bytes_type] = ACTIONS(792),
    [sym_bool_type] = ACTIONS(792),
    [sym_bottom_lit] = ACTIONS(792),
    [sym_null] = ACTIONS(792),
    [sym_true] = ACTIONS(792),
    [sym_false] = ACTIONS(792),
    [sym_int_lit] = ACTIONS(792),
    [sym_float_lit] = ACTIONS(792),
    [anon_sym_LBRACK] = ACTIONS(792),
    [anon_sym_LBRACE] = ACTIONS(792),
    [anon_sym_RBRACE] = ACTIONS(792),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(792),
    [anon_sym_for] = ACTIONS(792),
    [anon_sym_if] = ACTIONS(792),
    [anon_sym_let] = ACTIONS(792),
    [anon_sym_BANG_EQ] = ACTIONS(792),
    [anon_sym_LT] = ACTIONS(792),
    [anon_sym_LT_EQ] = ACTIONS(792),
    [anon_sym_GT] = ACTIONS(792),
    [anon_sym_GT_EQ] = ACTIONS(792),
    [anon_sym_EQ_TILDE] = ACTIONS(792),
    [anon_sym_BANG_TILDE] = ACTIONS(792),
    [anon_sym_PLUS] = ACTIONS(792),
    [anon_sym_DASH] = ACTIONS(792),
    [anon_sym_STAR] = ACTIONS(792),
    [anon_sym_BANG] = ACTIONS(792),
    [sym_comment] = ACTIONS(530),
  },
  [179] = {
    [sym_identifier] = ACTIONS(605),
    [anon_sym_LF] = ACTIONS(607),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym__] = ACTIONS(605),
    [anon_sym_AT] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [anon_sym_POUND_DQUOTE] = ACTIONS(605),
    [anon_sym_SQUOTE] = ACTIONS(605),
    [anon_sym_POUND_SQUOTE] = ACTIONS(605),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(605),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(605),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(605),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(605),
    [anon_sym_len] = ACTIONS(605),
    [anon_sym_close] = ACTIONS(605),
    [anon_sym_and] = ACTIONS(605),
    [anon_sym_or] = ACTIONS(605),
    [anon_sym_div] = ACTIONS(605),
    [anon_sym_mod] = ACTIONS(605),
    [anon_sym_quo] = ACTIONS(605),
    [anon_sym_rem] = ACTIONS(605),
    [sym_number_type] = ACTIONS(605),
    [anon_sym_float] = ACTIONS(605),
    [anon_sym_float32] = ACTIONS(605),
    [anon_sym_float64] = ACTIONS(605),
    [anon_sym_uint] = ACTIONS(605),
    [anon_sym_uint8] = ACTIONS(605),
    [anon_sym_uint16] = ACTIONS(605),
    [anon_sym_uint32] = ACTIONS(605),
    [anon_sym_uint64] = ACTIONS(605),
    [anon_sym_uint128] = ACTIONS(605),
    [anon_sym_int] = ACTIONS(605),
    [anon_sym_int8] = ACTIONS(605),
    [anon_sym_int16] = ACTIONS(605),
    [anon_sym_int32] = ACTIONS(605),
    [anon_sym_int64] = ACTIONS(605),
    [anon_sym_int128] = ACTIONS(605),
    [sym_string_type] = ACTIONS(605),
    [sym_bytes_type] = ACTIONS(605),
    [sym_bool_type] = ACTIONS(605),
    [sym_bottom_lit] = ACTIONS(605),
    [sym_null] = ACTIONS(605),
    [sym_true] = ACTIONS(605),
    [sym_false] = ACTIONS(605),
    [sym_int_lit] = ACTIONS(605),
    [sym_float_lit] = ACTIONS(605),
    [anon_sym_LBRACK] = ACTIONS(605),
    [anon_sym_LBRACE] = ACTIONS(605),
    [anon_sym_RBRACE] = ACTIONS(605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(605),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_if] = ACTIONS(605),
    [anon_sym_let] = ACTIONS(605),
    [anon_sym_BANG_EQ] = ACTIONS(605),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_LT_EQ] = ACTIONS(605),
    [anon_sym_GT] = ACTIONS(605),
    [anon_sym_GT_EQ] = ACTIONS(605),
    [anon_sym_EQ_TILDE] = ACTIONS(605),
    [anon_sym_BANG_TILDE] = ACTIONS(605),
    [anon_sym_PLUS] = ACTIONS(605),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(605),
    [anon_sym_BANG] = ACTIONS(605),
    [sym_comment] = ACTIONS(530),
  },
  [180] = {
    [sym_identifier] = ACTIONS(796),
    [anon_sym_LF] = ACTIONS(798),
    [anon_sym_COMMA] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym__] = ACTIONS(796),
    [anon_sym_AT] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(796),
    [anon_sym_POUND_DQUOTE] = ACTIONS(796),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [anon_sym_POUND_SQUOTE] = ACTIONS(796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(796),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(796),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(796),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(796),
    [anon_sym_len] = ACTIONS(796),
    [anon_sym_close] = ACTIONS(796),
    [anon_sym_and] = ACTIONS(796),
    [anon_sym_or] = ACTIONS(796),
    [anon_sym_div] = ACTIONS(796),
    [anon_sym_mod] = ACTIONS(796),
    [anon_sym_quo] = ACTIONS(796),
    [anon_sym_rem] = ACTIONS(796),
    [sym_number_type] = ACTIONS(796),
    [anon_sym_float] = ACTIONS(796),
    [anon_sym_float32] = ACTIONS(796),
    [anon_sym_float64] = ACTIONS(796),
    [anon_sym_uint] = ACTIONS(796),
    [anon_sym_uint8] = ACTIONS(796),
    [anon_sym_uint16] = ACTIONS(796),
    [anon_sym_uint32] = ACTIONS(796),
    [anon_sym_uint64] = ACTIONS(796),
    [anon_sym_uint128] = ACTIONS(796),
    [anon_sym_int] = ACTIONS(796),
    [anon_sym_int8] = ACTIONS(796),
    [anon_sym_int16] = ACTIONS(796),
    [anon_sym_int32] = ACTIONS(796),
    [anon_sym_int64] = ACTIONS(796),
    [anon_sym_int128] = ACTIONS(796),
    [sym_string_type] = ACTIONS(796),
    [sym_bytes_type] = ACTIONS(796),
    [sym_bool_type] = ACTIONS(796),
    [sym_bottom_lit] = ACTIONS(796),
    [sym_null] = ACTIONS(796),
    [sym_true] = ACTIONS(796),
    [sym_false] = ACTIONS(796),
    [sym_int_lit] = ACTIONS(796),
    [sym_float_lit] = ACTIONS(796),
    [anon_sym_LBRACK] = ACTIONS(796),
    [anon_sym_LBRACE] = ACTIONS(796),
    [anon_sym_RBRACE] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(796),
    [anon_sym_for] = ACTIONS(796),
    [anon_sym_if] = ACTIONS(796),
    [anon_sym_let] = ACTIONS(796),
    [anon_sym_BANG_EQ] = ACTIONS(796),
    [anon_sym_LT] = ACTIONS(796),
    [anon_sym_LT_EQ] = ACTIONS(796),
    [anon_sym_GT] = ACTIONS(796),
    [anon_sym_GT_EQ] = ACTIONS(796),
    [anon_sym_EQ_TILDE] = ACTIONS(796),
    [anon_sym_BANG_TILDE] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(796),
    [anon_sym_DASH] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(796),
    [anon_sym_BANG] = ACTIONS(796),
    [sym_comment] = ACTIONS(530),
  },
  [181] = {
    [sym_identifier] = ACTIONS(802),
    [anon_sym_LF] = ACTIONS(804),
    [anon_sym_COMMA] = ACTIONS(802),
    [anon_sym_LPAREN] = ACTIONS(802),
    [anon_sym__] = ACTIONS(802),
    [anon_sym_AT] = ACTIONS(802),
    [anon_sym_DQUOTE] = ACTIONS(802),
    [anon_sym_POUND_DQUOTE] = ACTIONS(802),
    [anon_sym_SQUOTE] = ACTIONS(802),
    [anon_sym_POUND_SQUOTE] = ACTIONS(802),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(802),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(802),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(802),
    [anon_sym_len] = ACTIONS(802),
    [anon_sym_close] = ACTIONS(802),
    [anon_sym_and] = ACTIONS(802),
    [anon_sym_or] = ACTIONS(802),
    [anon_sym_div] = ACTIONS(802),
    [anon_sym_mod] = ACTIONS(802),
    [anon_sym_quo] = ACTIONS(802),
    [anon_sym_rem] = ACTIONS(802),
    [sym_number_type] = ACTIONS(802),
    [anon_sym_float] = ACTIONS(802),
    [anon_sym_float32] = ACTIONS(802),
    [anon_sym_float64] = ACTIONS(802),
    [anon_sym_uint] = ACTIONS(802),
    [anon_sym_uint8] = ACTIONS(802),
    [anon_sym_uint16] = ACTIONS(802),
    [anon_sym_uint32] = ACTIONS(802),
    [anon_sym_uint64] = ACTIONS(802),
    [anon_sym_uint128] = ACTIONS(802),
    [anon_sym_int] = ACTIONS(802),
    [anon_sym_int8] = ACTIONS(802),
    [anon_sym_int16] = ACTIONS(802),
    [anon_sym_int32] = ACTIONS(802),
    [anon_sym_int64] = ACTIONS(802),
    [anon_sym_int128] = ACTIONS(802),
    [sym_string_type] = ACTIONS(802),
    [sym_bytes_type] = ACTIONS(802),
    [sym_bool_type] = ACTIONS(802),
    [sym_bottom_lit] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_int_lit] = ACTIONS(802),
    [sym_float_lit] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(802),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_RBRACE] = ACTIONS(802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(802),
    [anon_sym_for] = ACTIONS(802),
    [anon_sym_if] = ACTIONS(802),
    [anon_sym_let] = ACTIONS(802),
    [anon_sym_BANG_EQ] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(802),
    [anon_sym_LT_EQ] = ACTIONS(802),
    [anon_sym_GT] = ACTIONS(802),
    [anon_sym_GT_EQ] = ACTIONS(802),
    [anon_sym_EQ_TILDE] = ACTIONS(802),
    [anon_sym_BANG_TILDE] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(802),
    [anon_sym_DASH] = ACTIONS(802),
    [anon_sym_STAR] = ACTIONS(802),
    [anon_sym_BANG] = ACTIONS(802),
    [sym_comment] = ACTIONS(530),
  },
  [182] = {
    [sym_identifier] = ACTIONS(597),
    [anon_sym_LF] = ACTIONS(599),
    [anon_sym_COMMA] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym__] = ACTIONS(597),
    [anon_sym_AT] = ACTIONS(597),
    [anon_sym_DQUOTE] = ACTIONS(597),
    [anon_sym_POUND_DQUOTE] = ACTIONS(597),
    [anon_sym_SQUOTE] = ACTIONS(597),
    [anon_sym_POUND_SQUOTE] = ACTIONS(597),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(597),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(597),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(597),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(597),
    [anon_sym_len] = ACTIONS(597),
    [anon_sym_close] = ACTIONS(597),
    [anon_sym_and] = ACTIONS(597),
    [anon_sym_or] = ACTIONS(597),
    [anon_sym_div] = ACTIONS(597),
    [anon_sym_mod] = ACTIONS(597),
    [anon_sym_quo] = ACTIONS(597),
    [anon_sym_rem] = ACTIONS(597),
    [sym_number_type] = ACTIONS(597),
    [anon_sym_float] = ACTIONS(597),
    [anon_sym_float32] = ACTIONS(597),
    [anon_sym_float64] = ACTIONS(597),
    [anon_sym_uint] = ACTIONS(597),
    [anon_sym_uint8] = ACTIONS(597),
    [anon_sym_uint16] = ACTIONS(597),
    [anon_sym_uint32] = ACTIONS(597),
    [anon_sym_uint64] = ACTIONS(597),
    [anon_sym_uint128] = ACTIONS(597),
    [anon_sym_int] = ACTIONS(597),
    [anon_sym_int8] = ACTIONS(597),
    [anon_sym_int16] = ACTIONS(597),
    [anon_sym_int32] = ACTIONS(597),
    [anon_sym_int64] = ACTIONS(597),
    [anon_sym_int128] = ACTIONS(597),
    [sym_string_type] = ACTIONS(597),
    [sym_bytes_type] = ACTIONS(597),
    [sym_bool_type] = ACTIONS(597),
    [sym_bottom_lit] = ACTIONS(597),
    [sym_null] = ACTIONS(597),
    [sym_true] = ACTIONS(597),
    [sym_false] = ACTIONS(597),
    [sym_int_lit] = ACTIONS(597),
    [sym_float_lit] = ACTIONS(597),
    [anon_sym_LBRACK] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(597),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_let] = ACTIONS(597),
    [anon_sym_BANG_EQ] = ACTIONS(597),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_LT_EQ] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_EQ] = ACTIONS(597),
    [anon_sym_EQ_TILDE] = ACTIONS(597),
    [anon_sym_BANG_TILDE] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(597),
    [anon_sym_BANG] = ACTIONS(597),
    [sym_comment] = ACTIONS(530),
  },
  [183] = {
    [sym_identifier] = ACTIONS(806),
    [anon_sym_LF] = ACTIONS(808),
    [anon_sym_COMMA] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(806),
    [anon_sym__] = ACTIONS(806),
    [anon_sym_AT] = ACTIONS(806),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_POUND_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(806),
    [anon_sym_POUND_SQUOTE] = ACTIONS(806),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(806),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(806),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(806),
    [anon_sym_len] = ACTIONS(806),
    [anon_sym_close] = ACTIONS(806),
    [anon_sym_and] = ACTIONS(806),
    [anon_sym_or] = ACTIONS(806),
    [anon_sym_div] = ACTIONS(806),
    [anon_sym_mod] = ACTIONS(806),
    [anon_sym_quo] = ACTIONS(806),
    [anon_sym_rem] = ACTIONS(806),
    [sym_number_type] = ACTIONS(806),
    [anon_sym_float] = ACTIONS(806),
    [anon_sym_float32] = ACTIONS(806),
    [anon_sym_float64] = ACTIONS(806),
    [anon_sym_uint] = ACTIONS(806),
    [anon_sym_uint8] = ACTIONS(806),
    [anon_sym_uint16] = ACTIONS(806),
    [anon_sym_uint32] = ACTIONS(806),
    [anon_sym_uint64] = ACTIONS(806),
    [anon_sym_uint128] = ACTIONS(806),
    [anon_sym_int] = ACTIONS(806),
    [anon_sym_int8] = ACTIONS(806),
    [anon_sym_int16] = ACTIONS(806),
    [anon_sym_int32] = ACTIONS(806),
    [anon_sym_int64] = ACTIONS(806),
    [anon_sym_int128] = ACTIONS(806),
    [sym_string_type] = ACTIONS(806),
    [sym_bytes_type] = ACTIONS(806),
    [sym_bool_type] = ACTIONS(806),
    [sym_bottom_lit] = ACTIONS(806),
    [sym_null] = ACTIONS(806),
    [sym_true] = ACTIONS(806),
    [sym_false] = ACTIONS(806),
    [sym_int_lit] = ACTIONS(806),
    [sym_float_lit] = ACTIONS(806),
    [anon_sym_LBRACK] = ACTIONS(806),
    [anon_sym_LBRACE] = ACTIONS(806),
    [anon_sym_RBRACE] = ACTIONS(806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(806),
    [anon_sym_for] = ACTIONS(806),
    [anon_sym_if] = ACTIONS(806),
    [anon_sym_let] = ACTIONS(806),
    [anon_sym_BANG_EQ] = ACTIONS(806),
    [anon_sym_LT] = ACTIONS(806),
    [anon_sym_LT_EQ] = ACTIONS(806),
    [anon_sym_GT] = ACTIONS(806),
    [anon_sym_GT_EQ] = ACTIONS(806),
    [anon_sym_EQ_TILDE] = ACTIONS(806),
    [anon_sym_BANG_TILDE] = ACTIONS(806),
    [anon_sym_PLUS] = ACTIONS(806),
    [anon_sym_DASH] = ACTIONS(806),
    [anon_sym_STAR] = ACTIONS(806),
    [anon_sym_BANG] = ACTIONS(806),
    [sym_comment] = ACTIONS(530),
  },
  [184] = {
    [sym_identifier] = ACTIONS(810),
    [anon_sym_LF] = ACTIONS(812),
    [anon_sym_COMMA] = ACTIONS(810),
    [anon_sym_LPAREN] = ACTIONS(810),
    [anon_sym__] = ACTIONS(810),
    [anon_sym_AT] = ACTIONS(810),
    [anon_sym_DQUOTE] = ACTIONS(810),
    [anon_sym_POUND_DQUOTE] = ACTIONS(810),
    [anon_sym_SQUOTE] = ACTIONS(810),
    [anon_sym_POUND_SQUOTE] = ACTIONS(810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(810),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(810),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(810),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(810),
    [anon_sym_len] = ACTIONS(810),
    [anon_sym_close] = ACTIONS(810),
    [anon_sym_and] = ACTIONS(810),
    [anon_sym_or] = ACTIONS(810),
    [anon_sym_div] = ACTIONS(810),
    [anon_sym_mod] = ACTIONS(810),
    [anon_sym_quo] = ACTIONS(810),
    [anon_sym_rem] = ACTIONS(810),
    [sym_number_type] = ACTIONS(810),
    [anon_sym_float] = ACTIONS(810),
    [anon_sym_float32] = ACTIONS(810),
    [anon_sym_float64] = ACTIONS(810),
    [anon_sym_uint] = ACTIONS(810),
    [anon_sym_uint8] = ACTIONS(810),
    [anon_sym_uint16] = ACTIONS(810),
    [anon_sym_uint32] = ACTIONS(810),
    [anon_sym_uint64] = ACTIONS(810),
    [anon_sym_uint128] = ACTIONS(810),
    [anon_sym_int] = ACTIONS(810),
    [anon_sym_int8] = ACTIONS(810),
    [anon_sym_int16] = ACTIONS(810),
    [anon_sym_int32] = ACTIONS(810),
    [anon_sym_int64] = ACTIONS(810),
    [anon_sym_int128] = ACTIONS(810),
    [sym_string_type] = ACTIONS(810),
    [sym_bytes_type] = ACTIONS(810),
    [sym_bool_type] = ACTIONS(810),
    [sym_bottom_lit] = ACTIONS(810),
    [sym_null] = ACTIONS(810),
    [sym_true] = ACTIONS(810),
    [sym_false] = ACTIONS(810),
    [sym_int_lit] = ACTIONS(810),
    [sym_float_lit] = ACTIONS(810),
    [anon_sym_LBRACK] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(810),
    [anon_sym_RBRACE] = ACTIONS(810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(810),
    [anon_sym_for] = ACTIONS(810),
    [anon_sym_if] = ACTIONS(810),
    [anon_sym_let] = ACTIONS(810),
    [anon_sym_BANG_EQ] = ACTIONS(810),
    [anon_sym_LT] = ACTIONS(810),
    [anon_sym_LT_EQ] = ACTIONS(810),
    [anon_sym_GT] = ACTIONS(810),
    [anon_sym_GT_EQ] = ACTIONS(810),
    [anon_sym_EQ_TILDE] = ACTIONS(810),
    [anon_sym_BANG_TILDE] = ACTIONS(810),
    [anon_sym_PLUS] = ACTIONS(810),
    [anon_sym_DASH] = ACTIONS(810),
    [anon_sym_STAR] = ACTIONS(810),
    [anon_sym_BANG] = ACTIONS(810),
    [sym_comment] = ACTIONS(530),
  },
  [185] = {
    [sym_identifier] = ACTIONS(814),
    [anon_sym_LF] = ACTIONS(816),
    [anon_sym_COMMA] = ACTIONS(814),
    [anon_sym_LPAREN] = ACTIONS(814),
    [anon_sym__] = ACTIONS(814),
    [anon_sym_AT] = ACTIONS(814),
    [anon_sym_DQUOTE] = ACTIONS(814),
    [anon_sym_POUND_DQUOTE] = ACTIONS(814),
    [anon_sym_SQUOTE] = ACTIONS(814),
    [anon_sym_POUND_SQUOTE] = ACTIONS(814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(814),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(814),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(814),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(814),
    [anon_sym_len] = ACTIONS(814),
    [anon_sym_close] = ACTIONS(814),
    [anon_sym_and] = ACTIONS(814),
    [anon_sym_or] = ACTIONS(814),
    [anon_sym_div] = ACTIONS(814),
    [anon_sym_mod] = ACTIONS(814),
    [anon_sym_quo] = ACTIONS(814),
    [anon_sym_rem] = ACTIONS(814),
    [sym_number_type] = ACTIONS(814),
    [anon_sym_float] = ACTIONS(814),
    [anon_sym_float32] = ACTIONS(814),
    [anon_sym_float64] = ACTIONS(814),
    [anon_sym_uint] = ACTIONS(814),
    [anon_sym_uint8] = ACTIONS(814),
    [anon_sym_uint16] = ACTIONS(814),
    [anon_sym_uint32] = ACTIONS(814),
    [anon_sym_uint64] = ACTIONS(814),
    [anon_sym_uint128] = ACTIONS(814),
    [anon_sym_int] = ACTIONS(814),
    [anon_sym_int8] = ACTIONS(814),
    [anon_sym_int16] = ACTIONS(814),
    [anon_sym_int32] = ACTIONS(814),
    [anon_sym_int64] = ACTIONS(814),
    [anon_sym_int128] = ACTIONS(814),
    [sym_string_type] = ACTIONS(814),
    [sym_bytes_type] = ACTIONS(814),
    [sym_bool_type] = ACTIONS(814),
    [sym_bottom_lit] = ACTIONS(814),
    [sym_null] = ACTIONS(814),
    [sym_true] = ACTIONS(814),
    [sym_false] = ACTIONS(814),
    [sym_int_lit] = ACTIONS(814),
    [sym_float_lit] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(814),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_RBRACE] = ACTIONS(814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(814),
    [anon_sym_for] = ACTIONS(814),
    [anon_sym_if] = ACTIONS(814),
    [anon_sym_let] = ACTIONS(814),
    [anon_sym_BANG_EQ] = ACTIONS(814),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_LT_EQ] = ACTIONS(814),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_GT_EQ] = ACTIONS(814),
    [anon_sym_EQ_TILDE] = ACTIONS(814),
    [anon_sym_BANG_TILDE] = ACTIONS(814),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(814),
    [sym_comment] = ACTIONS(530),
  },
  [186] = {
    [sym_identifier] = ACTIONS(818),
    [anon_sym_LF] = ACTIONS(820),
    [anon_sym_COMMA] = ACTIONS(818),
    [anon_sym_LPAREN] = ACTIONS(818),
    [anon_sym__] = ACTIONS(818),
    [anon_sym_AT] = ACTIONS(818),
    [anon_sym_DQUOTE] = ACTIONS(818),
    [anon_sym_POUND_DQUOTE] = ACTIONS(818),
    [anon_sym_SQUOTE] = ACTIONS(818),
    [anon_sym_POUND_SQUOTE] = ACTIONS(818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(818),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(818),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(818),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(818),
    [anon_sym_len] = ACTIONS(818),
    [anon_sym_close] = ACTIONS(818),
    [anon_sym_and] = ACTIONS(818),
    [anon_sym_or] = ACTIONS(818),
    [anon_sym_div] = ACTIONS(818),
    [anon_sym_mod] = ACTIONS(818),
    [anon_sym_quo] = ACTIONS(818),
    [anon_sym_rem] = ACTIONS(818),
    [sym_number_type] = ACTIONS(818),
    [anon_sym_float] = ACTIONS(818),
    [anon_sym_float32] = ACTIONS(818),
    [anon_sym_float64] = ACTIONS(818),
    [anon_sym_uint] = ACTIONS(818),
    [anon_sym_uint8] = ACTIONS(818),
    [anon_sym_uint16] = ACTIONS(818),
    [anon_sym_uint32] = ACTIONS(818),
    [anon_sym_uint64] = ACTIONS(818),
    [anon_sym_uint128] = ACTIONS(818),
    [anon_sym_int] = ACTIONS(818),
    [anon_sym_int8] = ACTIONS(818),
    [anon_sym_int16] = ACTIONS(818),
    [anon_sym_int32] = ACTIONS(818),
    [anon_sym_int64] = ACTIONS(818),
    [anon_sym_int128] = ACTIONS(818),
    [sym_string_type] = ACTIONS(818),
    [sym_bytes_type] = ACTIONS(818),
    [sym_bool_type] = ACTIONS(818),
    [sym_bottom_lit] = ACTIONS(818),
    [sym_null] = ACTIONS(818),
    [sym_true] = ACTIONS(818),
    [sym_false] = ACTIONS(818),
    [sym_int_lit] = ACTIONS(818),
    [sym_float_lit] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(818),
    [anon_sym_LBRACE] = ACTIONS(818),
    [anon_sym_RBRACE] = ACTIONS(818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(818),
    [anon_sym_for] = ACTIONS(818),
    [anon_sym_if] = ACTIONS(818),
    [anon_sym_let] = ACTIONS(818),
    [anon_sym_BANG_EQ] = ACTIONS(818),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_LT_EQ] = ACTIONS(818),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_EQ] = ACTIONS(818),
    [anon_sym_EQ_TILDE] = ACTIONS(818),
    [anon_sym_BANG_TILDE] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(818),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_STAR] = ACTIONS(818),
    [anon_sym_BANG] = ACTIONS(818),
    [sym_comment] = ACTIONS(530),
  },
  [187] = {
    [ts_builtin_sym_end] = ACTIONS(812),
    [sym_identifier] = ACTIONS(810),
    [anon_sym_package] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(810),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym__] = ACTIONS(810),
    [anon_sym_DQUOTE] = ACTIONS(810),
    [anon_sym_POUND_DQUOTE] = ACTIONS(810),
    [anon_sym_SQUOTE] = ACTIONS(810),
    [anon_sym_POUND_SQUOTE] = ACTIONS(810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(812),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(812),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(812),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(812),
    [anon_sym_len] = ACTIONS(810),
    [anon_sym_close] = ACTIONS(810),
    [anon_sym_and] = ACTIONS(810),
    [anon_sym_or] = ACTIONS(810),
    [anon_sym_div] = ACTIONS(810),
    [anon_sym_mod] = ACTIONS(810),
    [anon_sym_quo] = ACTIONS(810),
    [anon_sym_rem] = ACTIONS(810),
    [sym_number_type] = ACTIONS(810),
    [anon_sym_float] = ACTIONS(810),
    [anon_sym_float32] = ACTIONS(810),
    [anon_sym_float64] = ACTIONS(810),
    [anon_sym_uint] = ACTIONS(810),
    [anon_sym_uint8] = ACTIONS(810),
    [anon_sym_uint16] = ACTIONS(810),
    [anon_sym_uint32] = ACTIONS(810),
    [anon_sym_uint64] = ACTIONS(810),
    [anon_sym_uint128] = ACTIONS(810),
    [anon_sym_int] = ACTIONS(810),
    [anon_sym_int8] = ACTIONS(810),
    [anon_sym_int16] = ACTIONS(810),
    [anon_sym_int32] = ACTIONS(810),
    [anon_sym_int64] = ACTIONS(810),
    [anon_sym_int128] = ACTIONS(810),
    [sym_string_type] = ACTIONS(810),
    [sym_bytes_type] = ACTIONS(810),
    [sym_bool_type] = ACTIONS(810),
    [sym_bottom_lit] = ACTIONS(812),
    [sym_null] = ACTIONS(810),
    [sym_true] = ACTIONS(810),
    [sym_false] = ACTIONS(810),
    [sym_int_lit] = ACTIONS(810),
    [sym_float_lit] = ACTIONS(810),
    [anon_sym_LBRACK] = ACTIONS(812),
    [anon_sym_LBRACE] = ACTIONS(812),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(812),
    [anon_sym_for] = ACTIONS(810),
    [anon_sym_if] = ACTIONS(810),
    [anon_sym_let] = ACTIONS(810),
    [anon_sym_BANG_EQ] = ACTIONS(812),
    [anon_sym_LT] = ACTIONS(810),
    [anon_sym_LT_EQ] = ACTIONS(812),
    [anon_sym_GT] = ACTIONS(810),
    [anon_sym_GT_EQ] = ACTIONS(812),
    [anon_sym_EQ_TILDE] = ACTIONS(812),
    [anon_sym_BANG_TILDE] = ACTIONS(812),
    [anon_sym_PLUS] = ACTIONS(812),
    [anon_sym_DASH] = ACTIONS(812),
    [anon_sym_STAR] = ACTIONS(812),
    [anon_sym_BANG] = ACTIONS(810),
    [sym_comment] = ACTIONS(3),
  },
  [188] = {
    [ts_builtin_sym_end] = ACTIONS(808),
    [sym_identifier] = ACTIONS(806),
    [anon_sym_package] = ACTIONS(806),
    [anon_sym_import] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym__] = ACTIONS(806),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_POUND_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(806),
    [anon_sym_POUND_SQUOTE] = ACTIONS(806),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(808),
    [anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(808),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(808),
    [anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(808),
    [anon_sym_len] = ACTIONS(806),
    [anon_sym_close] = ACTIONS(806),
    [anon_sym_and] = ACTIONS(806),
    [anon_sym_or] = ACTIONS(806),
    [anon_sym_div] = ACTIONS(806),
    [anon_sym_mod] = ACTIONS(806),
    [anon_sym_quo] = ACTIONS(806),
    [anon_sym_rem] = ACTIONS(806),
    [sym_number_type] = ACTIONS(806),
    [anon_sym_float] = ACTIONS(806),
    [anon_sym_float32] = ACTIONS(806),
    [anon_sym_float64] = ACTIONS(806),
    [anon_sym_uint] = ACTIONS(806),
    [anon_sym_uint8] = ACTIONS(806),
    [anon_sym_uint16] = ACTIONS(806),
    [anon_sym_uint32] = ACTIONS(806),
    [anon_sym_uint64] = ACTIONS(806),
    [anon_sym_uint128] = ACTIONS(806),
    [anon_sym_int] = ACTIONS(806),
    [anon_sym_int8] = ACTIONS(806),
    [anon_sym_int16] = ACTIONS(806),
    [anon_sym_int32] = ACTIONS(806),
    [anon_sym_int64] = ACTIONS(806),
    [anon_sym_int128] = ACTIONS(806),
    [sym_string_type] = ACTIONS(806),
    [sym_bytes_type] = ACTIONS(806),
    [sym_bool_type] = ACTIONS(806),
    [sym_bottom_lit] = ACTIONS(808),
    [sym_null] = ACTIONS(806),
    [sym_true] = ACTIONS(806),
    [sym_false] = ACTIONS(806),
    [sym_int_lit] = ACTIONS(806),
    [sym_float_lit] = ACTIONS(806),
    [anon_sym_LBRACK] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(808),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(808),
    [anon_sym_for] = ACTIONS(806),
    [anon_sym_if] = ACTIONS(806),
    [anon_sym_let] = ACTIONS(806),
    [anon_sym_BANG_EQ] = ACTIONS(808),
    [anon_sym_LT] = ACTIONS(806),
    [anon_sym_LT_EQ] = ACTIONS(808),
    [anon_sym_GT] = ACTIONS(806),
    [anon_sym_GT_EQ] = ACTIONS(808),
    [anon_sym_EQ_TILDE] = ACTIONS(808),
    [anon_sym_BANG_TILDE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(808),
    [anon_sym_DASH] = ACTIONS(808),
    [anon_sym_STAR] = ACTIONS(808),
    [anon_sym_BANG] = ACTIONS(806),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(822), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(824), 45,
      anon_sym_import,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [71] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(695), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(693), 45,
      anon_sym_import,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(828), 45,
      anon_sym_import,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(830), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(832), 45,
      anon_sym_import,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(653), 45,
      anon_sym_import,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(657), 45,
      anon_sym_import,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(663), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(661), 45,
      anon_sym_import,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(669), 45,
      anon_sym_import,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(673), 45,
      anon_sym_import,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(683), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(681), 45,
      anon_sym_import,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(834), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(836), 45,
      anon_sym_import,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [781] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(840), 1,
      anon_sym_COMMA,
    STATE(200), 1,
      aux_sym__list_elem_repeat1,
    ACTIONS(843), 18,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(838), 43,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [856] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(847), 1,
      anon_sym_COMMA,
    STATE(200), 1,
      aux_sym__list_elem_repeat1,
    ACTIONS(849), 18,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(845), 43,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(581), 45,
      anon_sym_import,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [1002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(851), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(853), 45,
      anon_sym_import,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [1073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(855), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(857), 45,
      anon_sym_import,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [1144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(861), 19,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(859), 44,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [1215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(865), 19,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(863), 44,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [1286] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_COMMA,
    STATE(201), 1,
      aux_sym__list_elem_repeat1,
    ACTIONS(871), 18,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(867), 43,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [1361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(873), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(875), 45,
      anon_sym_import,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [1432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(865), 19,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(863), 44,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [1503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(567), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(565), 45,
      anon_sym_import,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [1574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(641), 45,
      anon_sym_import,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [1645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(637), 45,
      anon_sym_import,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [1716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(603), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(601), 45,
      anon_sym_import,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [1787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(623), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(621), 45,
      anon_sym_import,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [1858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(625), 45,
      anon_sym_import,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [1929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(631), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(629), 45,
      anon_sym_import,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [2000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(635), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(633), 45,
      anon_sym_import,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [2071] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(877), 1,
      sym_identifier,
    ACTIONS(884), 1,
      anon_sym_DQUOTE,
    ACTIONS(887), 1,
      anon_sym_LBRACK,
    STATE(218), 1,
      aux_sym_field_repeat1,
    STATE(361), 1,
      sym_label,
    STATE(374), 1,
      sym__label_expr,
    STATE(353), 2,
      sym_simple_string_lit,
      sym__label_name,
    ACTIONS(880), 15,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACE,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(882), 39,
      anon_sym__,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [2155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(892), 19,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(890), 43,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [2225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(896), 1,
      anon_sym_COMMA,
    ACTIONS(898), 18,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(894), 43,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [2297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(794), 19,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(792), 43,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [2367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(599), 19,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(597), 43,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [2437] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(900), 1,
      anon_sym_RBRACK,
    ACTIONS(794), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(792), 43,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [2509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(790), 19,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(788), 43,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [2579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(903), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(905), 44,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [2649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(779), 19,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(777), 43,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [2719] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(909), 1,
      anon_sym_COMMA,
    ACTIONS(911), 18,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(907), 43,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [2791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(607), 19,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(605), 43,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [2861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(903), 18,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(905), 44,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [2931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(915), 18,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(913), 43,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [3000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(919), 18,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(917), 43,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [3069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 18,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(921), 43,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_for,
      anon_sym_if,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [3138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(880), 16,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      sym_bottom_lit,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
    ACTIONS(882), 41,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
      anon_sym_len,
      anon_sym_close,
      anon_sym_and,
      anon_sym_or,
      anon_sym_div,
      anon_sym_mod,
      anon_sym_quo,
      anon_sym_rem,
      sym_number_type,
      anon_sym_float,
      anon_sym_float32,
      anon_sym_float64,
      anon_sym_uint,
      anon_sym_uint8,
      anon_sym_uint16,
      anon_sym_uint32,
      anon_sym_uint64,
      anon_sym_uint128,
      anon_sym_int,
      anon_sym_int8,
      anon_sym_int16,
      anon_sym_int32,
      anon_sym_int64,
      anon_sym_int128,
      sym_string_type,
      sym_bytes_type,
      sym_bool_type,
      sym_null,
      sym_true,
      sym_false,
      sym_int_lit,
      sym_float_lit,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
  [3203] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym_POUND_DQUOTE,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(27), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(31), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(33), 1,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(925), 1,
      sym_identifier,
    ACTIONS(927), 1,
      anon_sym_RPAREN,
    ACTIONS(929), 1,
      sym_dot,
    ACTIONS(931), 1,
      anon_sym__,
    STATE(235), 1,
      aux_sym_import_spec_list_repeat1,
    STATE(358), 1,
      sym_import_spec,
    STATE(247), 2,
      sym__package_identifier,
      sym_blank_identifier,
    STATE(359), 9,
      sym__string_lit,
      sym_simple_string_lit,
      sym_simple_raw_string_lit,
      sym_simple_bytes_lit,
      sym_simple_raw_bytes_lit,
      sym_multiline_string_lit,
      sym_multiline_raw_string_lit,
      sym_multiline_bytes_lit,
      sym_multiline_raw_bytes_lit,
  [3264] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(933), 1,
      sym_identifier,
    ACTIONS(936), 1,
      anon_sym_RPAREN,
    ACTIONS(938), 1,
      sym_dot,
    ACTIONS(941), 1,
      anon_sym__,
    ACTIONS(944), 1,
      anon_sym_DQUOTE,
    ACTIONS(947), 1,
      anon_sym_POUND_DQUOTE,
    ACTIONS(950), 1,
      anon_sym_SQUOTE,
    ACTIONS(953), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(956), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(959), 1,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(962), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(965), 1,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
    STATE(235), 1,
      aux_sym_import_spec_list_repeat1,
    STATE(358), 1,
      sym_import_spec,
    STATE(247), 2,
      sym__package_identifier,
      sym_blank_identifier,
    STATE(359), 9,
      sym__string_lit,
      sym_simple_string_lit,
      sym_simple_raw_string_lit,
      sym_simple_bytes_lit,
      sym_simple_raw_bytes_lit,
      sym_multiline_string_lit,
      sym_multiline_raw_string_lit,
      sym_multiline_bytes_lit,
      sym_multiline_raw_bytes_lit,
  [3325] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym_POUND_DQUOTE,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(27), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(31), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(33), 1,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(925), 1,
      sym_identifier,
    ACTIONS(929), 1,
      sym_dot,
    ACTIONS(931), 1,
      anon_sym__,
    ACTIONS(968), 1,
      anon_sym_RPAREN,
    STATE(234), 1,
      aux_sym_import_spec_list_repeat1,
    STATE(358), 1,
      sym_import_spec,
    STATE(247), 2,
      sym__package_identifier,
      sym_blank_identifier,
    STATE(359), 9,
      sym__string_lit,
      sym_simple_string_lit,
      sym_simple_raw_string_lit,
      sym_simple_bytes_lit,
      sym_simple_raw_bytes_lit,
      sym_multiline_string_lit,
      sym_multiline_raw_string_lit,
      sym_multiline_bytes_lit,
      sym_multiline_raw_bytes_lit,
  [3386] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(925), 1,
      sym_identifier,
    ACTIONS(931), 1,
      anon_sym__,
    ACTIONS(970), 1,
      anon_sym_LPAREN,
    ACTIONS(972), 1,
      sym_dot,
    ACTIONS(974), 1,
      anon_sym_DQUOTE,
    ACTIONS(976), 1,
      anon_sym_POUND_DQUOTE,
    ACTIONS(978), 1,
      anon_sym_SQUOTE,
    ACTIONS(980), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(982), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(984), 1,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(986), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(988), 1,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
    STATE(192), 2,
      sym_import_spec,
      sym_import_spec_list,
    STATE(252), 2,
      sym__package_identifier,
      sym_blank_identifier,
    STATE(204), 9,
      sym__string_lit,
      sym_simple_string_lit,
      sym_simple_raw_string_lit,
      sym_simple_bytes_lit,
      sym_simple_raw_bytes_lit,
      sym_multiline_string_lit,
      sym_multiline_raw_string_lit,
      sym_multiline_bytes_lit,
      sym_multiline_raw_bytes_lit,
  [3445] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_STAR,
    ACTIONS(753), 1,
      anon_sym_SLASH,
    ACTIONS(759), 1,
      anon_sym_AMP_AMP,
    ACTIONS(761), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(763), 1,
      anon_sym_AMP,
    ACTIONS(765), 1,
      anon_sym_PIPE,
    ACTIONS(749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(757), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(733), 5,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
    ACTIONS(755), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3490] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_STAR,
    ACTIONS(753), 1,
      anon_sym_SLASH,
    ACTIONS(759), 1,
      anon_sym_AMP_AMP,
    ACTIONS(761), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(763), 1,
      anon_sym_AMP,
    ACTIONS(765), 1,
      anon_sym_PIPE,
    ACTIONS(749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(757), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(990), 5,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
    ACTIONS(755), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3535] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_STAR,
    ACTIONS(753), 1,
      anon_sym_SLASH,
    ACTIONS(759), 1,
      anon_sym_AMP_AMP,
    ACTIONS(761), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(763), 1,
      anon_sym_AMP,
    ACTIONS(765), 1,
      anon_sym_PIPE,
    ACTIONS(749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(757), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(992), 5,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
    ACTIONS(755), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3580] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_STAR,
    ACTIONS(753), 1,
      anon_sym_SLASH,
    ACTIONS(759), 1,
      anon_sym_AMP_AMP,
    ACTIONS(761), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(763), 1,
      anon_sym_AMP,
    ACTIONS(765), 1,
      anon_sym_PIPE,
    ACTIONS(749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(757), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(994), 5,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
    ACTIONS(755), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3625] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_STAR,
    ACTIONS(753), 1,
      anon_sym_SLASH,
    ACTIONS(759), 1,
      anon_sym_AMP_AMP,
    ACTIONS(761), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(763), 1,
      anon_sym_AMP,
    ACTIONS(765), 1,
      anon_sym_PIPE,
    ACTIONS(749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(757), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(996), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(755), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3667] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_STAR,
    ACTIONS(753), 1,
      anon_sym_SLASH,
    ACTIONS(759), 1,
      anon_sym_AMP_AMP,
    ACTIONS(761), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(763), 1,
      anon_sym_AMP,
    ACTIONS(765), 1,
      anon_sym_PIPE,
    ACTIONS(998), 1,
      anon_sym_RPAREN,
    ACTIONS(749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(757), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(755), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3708] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_STAR,
    ACTIONS(753), 1,
      anon_sym_SLASH,
    ACTIONS(759), 1,
      anon_sym_AMP_AMP,
    ACTIONS(761), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(763), 1,
      anon_sym_AMP,
    ACTIONS(765), 1,
      anon_sym_PIPE,
    ACTIONS(1000), 1,
      anon_sym_RBRACK,
    ACTIONS(749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(757), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(755), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3749] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_STAR,
    ACTIONS(753), 1,
      anon_sym_SLASH,
    ACTIONS(759), 1,
      anon_sym_AMP_AMP,
    ACTIONS(761), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(763), 1,
      anon_sym_AMP,
    ACTIONS(765), 1,
      anon_sym_PIPE,
    ACTIONS(1002), 1,
      anon_sym_RPAREN,
    ACTIONS(749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(757), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(755), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3790] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_STAR,
    ACTIONS(753), 1,
      anon_sym_SLASH,
    ACTIONS(759), 1,
      anon_sym_AMP_AMP,
    ACTIONS(761), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(763), 1,
      anon_sym_AMP,
    ACTIONS(765), 1,
      anon_sym_PIPE,
    ACTIONS(1004), 1,
      anon_sym_RPAREN,
    ACTIONS(749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(757), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(755), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3831] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym_POUND_DQUOTE,
    ACTIONS(23), 1,
      anon_sym_SQUOTE,
    ACTIONS(25), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(27), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(29), 1,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(31), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(33), 1,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
    STATE(352), 9,
      sym__string_lit,
      sym_simple_string_lit,
      sym_simple_raw_string_lit,
      sym_simple_bytes_lit,
      sym_simple_raw_bytes_lit,
      sym_multiline_string_lit,
      sym_multiline_raw_string_lit,
      sym_multiline_bytes_lit,
      sym_multiline_raw_bytes_lit,
  [3870] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_STAR,
    ACTIONS(753), 1,
      anon_sym_SLASH,
    ACTIONS(759), 1,
      anon_sym_AMP_AMP,
    ACTIONS(761), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(763), 1,
      anon_sym_AMP,
    ACTIONS(765), 1,
      anon_sym_PIPE,
    ACTIONS(1006), 1,
      anon_sym_RPAREN,
    ACTIONS(749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(757), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(755), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3911] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_STAR,
    ACTIONS(753), 1,
      anon_sym_SLASH,
    ACTIONS(759), 1,
      anon_sym_AMP_AMP,
    ACTIONS(761), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(763), 1,
      anon_sym_AMP,
    ACTIONS(765), 1,
      anon_sym_PIPE,
    ACTIONS(1008), 1,
      anon_sym_RPAREN,
    ACTIONS(749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(757), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(755), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3952] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_STAR,
    ACTIONS(753), 1,
      anon_sym_SLASH,
    ACTIONS(759), 1,
      anon_sym_AMP_AMP,
    ACTIONS(761), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(763), 1,
      anon_sym_AMP,
    ACTIONS(765), 1,
      anon_sym_PIPE,
    ACTIONS(1010), 1,
      anon_sym_RPAREN,
    ACTIONS(749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(757), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(755), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3993] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_STAR,
    ACTIONS(753), 1,
      anon_sym_SLASH,
    ACTIONS(759), 1,
      anon_sym_AMP_AMP,
    ACTIONS(761), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(763), 1,
      anon_sym_AMP,
    ACTIONS(765), 1,
      anon_sym_PIPE,
    ACTIONS(1012), 1,
      anon_sym_RPAREN,
    ACTIONS(749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(757), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(755), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4034] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(974), 1,
      anon_sym_DQUOTE,
    ACTIONS(976), 1,
      anon_sym_POUND_DQUOTE,
    ACTIONS(978), 1,
      anon_sym_SQUOTE,
    ACTIONS(980), 1,
      anon_sym_POUND_SQUOTE,
    ACTIONS(982), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(984), 1,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(986), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(988), 1,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
    STATE(203), 9,
      sym__string_lit,
      sym_simple_string_lit,
      sym_simple_raw_string_lit,
      sym_simple_bytes_lit,
      sym_simple_raw_bytes_lit,
      sym_multiline_string_lit,
      sym_multiline_raw_string_lit,
      sym_multiline_bytes_lit,
      sym_multiline_raw_bytes_lit,
  [4073] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_STAR,
    ACTIONS(753), 1,
      anon_sym_SLASH,
    ACTIONS(759), 1,
      anon_sym_AMP_AMP,
    ACTIONS(761), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(763), 1,
      anon_sym_AMP,
    ACTIONS(765), 1,
      anon_sym_PIPE,
    ACTIONS(1014), 1,
      anon_sym_RPAREN,
    ACTIONS(749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(757), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(755), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4114] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_STAR,
    ACTIONS(753), 1,
      anon_sym_SLASH,
    ACTIONS(759), 1,
      anon_sym_AMP_AMP,
    ACTIONS(761), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(763), 1,
      anon_sym_AMP,
    ACTIONS(765), 1,
      anon_sym_PIPE,
    ACTIONS(1016), 1,
      anon_sym_RBRACK,
    ACTIONS(749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(757), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(755), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4155] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_STAR,
    ACTIONS(753), 1,
      anon_sym_SLASH,
    ACTIONS(759), 1,
      anon_sym_AMP_AMP,
    ACTIONS(761), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(763), 1,
      anon_sym_AMP,
    ACTIONS(765), 1,
      anon_sym_PIPE,
    ACTIONS(1018), 1,
      anon_sym_RPAREN,
    ACTIONS(749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(757), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(755), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4196] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_STAR,
    ACTIONS(753), 1,
      anon_sym_SLASH,
    ACTIONS(759), 1,
      anon_sym_AMP_AMP,
    ACTIONS(761), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(763), 1,
      anon_sym_AMP,
    ACTIONS(765), 1,
      anon_sym_PIPE,
    ACTIONS(1020), 1,
      anon_sym_RPAREN,
    ACTIONS(749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(757), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(755), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(936), 6,
      anon_sym_RPAREN,
      sym_dot,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1022), 6,
      anon_sym__,
      sym_identifier,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
  [4257] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1024), 1,
      anon_sym_COMMA,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_for,
    ACTIONS(1030), 1,
      anon_sym_if,
    ACTIONS(1032), 1,
      anon_sym_let,
    STATE(226), 1,
      sym_struct_lit,
    STATE(259), 5,
      sym_for_clause,
      sym_guard_clause,
      sym_let_clause,
      sym__clause,
      aux_sym_comprehension_repeat1,
  [4286] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1024), 1,
      anon_sym_COMMA,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_for,
    ACTIONS(1030), 1,
      anon_sym_if,
    ACTIONS(1032), 1,
      anon_sym_let,
    STATE(224), 1,
      sym_struct_lit,
    STATE(264), 5,
      sym_for_clause,
      sym_guard_clause,
      sym_let_clause,
      sym__clause,
      aux_sym_comprehension_repeat1,
  [4315] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACE,
    ACTIONS(1024), 1,
      anon_sym_COMMA,
    ACTIONS(1028), 1,
      anon_sym_for,
    ACTIONS(1030), 1,
      anon_sym_if,
    ACTIONS(1032), 1,
      anon_sym_let,
    STATE(177), 1,
      sym_struct_lit,
    STATE(264), 5,
      sym_for_clause,
      sym_guard_clause,
      sym_let_clause,
      sym__clause,
      aux_sym_comprehension_repeat1,
  [4344] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1024), 1,
      anon_sym_COMMA,
    ACTIONS(1028), 1,
      anon_sym_for,
    ACTIONS(1030), 1,
      anon_sym_if,
    ACTIONS(1032), 1,
      anon_sym_let,
    ACTIONS(1034), 1,
      anon_sym_LBRACE,
    STATE(175), 1,
      sym_struct_lit,
    STATE(262), 5,
      sym_for_clause,
      sym_guard_clause,
      sym_let_clause,
      sym__clause,
      aux_sym_comprehension_repeat1,
  [4373] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1024), 1,
      anon_sym_COMMA,
    ACTIONS(1028), 1,
      anon_sym_for,
    ACTIONS(1030), 1,
      anon_sym_if,
    ACTIONS(1032), 1,
      anon_sym_let,
    ACTIONS(1034), 1,
      anon_sym_LBRACE,
    STATE(177), 1,
      sym_struct_lit,
    STATE(264), 5,
      sym_for_clause,
      sym_guard_clause,
      sym_let_clause,
      sym__clause,
      aux_sym_comprehension_repeat1,
  [4402] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACE,
    ACTIONS(1024), 1,
      anon_sym_COMMA,
    ACTIONS(1028), 1,
      anon_sym_for,
    ACTIONS(1030), 1,
      anon_sym_if,
    ACTIONS(1032), 1,
      anon_sym_let,
    STATE(175), 1,
      sym_struct_lit,
    STATE(260), 5,
      sym_for_clause,
      sym_guard_clause,
      sym_let_clause,
      sym__clause,
      aux_sym_comprehension_repeat1,
  [4431] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1036), 1,
      anon_sym_COMMA,
    ACTIONS(1039), 1,
      anon_sym_LBRACE,
    ACTIONS(1041), 1,
      anon_sym_for,
    ACTIONS(1044), 1,
      anon_sym_if,
    ACTIONS(1047), 1,
      anon_sym_let,
    STATE(264), 5,
      sym_for_clause,
      sym_guard_clause,
      sym_let_clause,
      sym__clause,
      aux_sym_comprehension_repeat1,
  [4457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1052), 4,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
    ACTIONS(1050), 6,
      anon_sym_COMMA,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_in,
  [4475] = 5,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(1056), 1,
      anon_sym_SQUOTE,
    ACTIONS(1058), 1,
      anon_sym_BSLASH_LPAREN,
    STATE(268), 2,
      sym_interpolation,
      aux_sym_simple_bytes_lit_repeat1,
    ACTIONS(1054), 4,
      sym_escape_char,
      sym_escape_byte,
      sym_escape_unicode,
      aux_sym_simple_bytes_lit_token1,
  [4495] = 5,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(1058), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1062), 1,
      anon_sym_SQUOTE,
    STATE(270), 2,
      sym_interpolation,
      aux_sym_simple_bytes_lit_repeat1,
    ACTIONS(1060), 4,
      sym_escape_char,
      sym_escape_byte,
      sym_escape_unicode,
      aux_sym_simple_bytes_lit_token1,
  [4515] = 5,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(1058), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1064), 1,
      anon_sym_SQUOTE,
    STATE(270), 2,
      sym_interpolation,
      aux_sym_simple_bytes_lit_repeat1,
    ACTIONS(1060), 4,
      sym_escape_char,
      sym_escape_byte,
      sym_escape_unicode,
      aux_sym_simple_bytes_lit_token1,
  [4535] = 5,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(1058), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_SQUOTE,
    STATE(271), 2,
      sym_interpolation,
      aux_sym_simple_bytes_lit_repeat1,
    ACTIONS(1066), 4,
      sym_escape_char,
      sym_escape_byte,
      sym_escape_unicode,
      aux_sym_simple_bytes_lit_token1,
  [4555] = 5,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(1073), 1,
      anon_sym_SQUOTE,
    ACTIONS(1075), 1,
      anon_sym_BSLASH_LPAREN,
    STATE(270), 2,
      sym_interpolation,
      aux_sym_simple_bytes_lit_repeat1,
    ACTIONS(1070), 4,
      sym_escape_char,
      sym_escape_byte,
      sym_escape_unicode,
      aux_sym_simple_bytes_lit_token1,
  [4575] = 5,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(1058), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1078), 1,
      anon_sym_SQUOTE,
    STATE(270), 2,
      sym_interpolation,
      aux_sym_simple_bytes_lit_repeat1,
    ACTIONS(1060), 4,
      sym_escape_char,
      sym_escape_byte,
      sym_escape_unicode,
      aux_sym_simple_bytes_lit_token1,
  [4595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(834), 4,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_POUND_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_POUND_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(836), 4,
      anon_sym_DQUOTE,
      anon_sym_POUND_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_POUND_SQUOTE,
  [4611] = 5,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(1058), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1082), 1,
      anon_sym_SQUOTE,
    STATE(267), 2,
      sym_interpolation,
      aux_sym_simple_bytes_lit_repeat1,
    ACTIONS(1080), 4,
      sym_escape_char,
      sym_escape_byte,
      sym_escape_unicode,
      aux_sym_simple_bytes_lit_token1,
  [4631] = 5,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_BSLASH_LPAREN,
    STATE(277), 2,
      sym_interpolation,
      aux_sym_simple_string_lit_repeat1,
    ACTIONS(1084), 3,
      sym_escape_char,
      sym_escape_unicode,
      aux_sym_simple_string_lit_token1,
  [4650] = 5,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(1093), 1,
      anon_sym_DQUOTE,
    ACTIONS(1095), 1,
      anon_sym_BSLASH_LPAREN,
    STATE(275), 2,
      sym_interpolation,
      aux_sym_simple_string_lit_repeat1,
    ACTIONS(1090), 3,
      sym_escape_char,
      sym_escape_unicode,
      aux_sym_simple_string_lit_token1,
  [4669] = 5,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(1088), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1100), 1,
      anon_sym_DQUOTE,
    STATE(275), 2,
      sym_interpolation,
      aux_sym_simple_string_lit_repeat1,
    ACTIONS(1098), 3,
      sym_escape_char,
      sym_escape_unicode,
      aux_sym_simple_string_lit_token1,
  [4688] = 5,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(1088), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1102), 1,
      anon_sym_DQUOTE,
    STATE(275), 2,
      sym_interpolation,
      aux_sym_simple_string_lit_repeat1,
    ACTIONS(1098), 3,
      sym_escape_char,
      sym_escape_unicode,
      aux_sym_simple_string_lit_token1,
  [4707] = 5,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(1088), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1106), 1,
      anon_sym_DQUOTE,
    STATE(276), 2,
      sym_interpolation,
      aux_sym_simple_string_lit_repeat1,
    ACTIONS(1104), 3,
      sym_escape_char,
      sym_escape_unicode,
      aux_sym_simple_string_lit_token1,
  [4726] = 5,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(1088), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1108), 1,
      anon_sym_DQUOTE,
    STATE(275), 2,
      sym_interpolation,
      aux_sym_simple_string_lit_repeat1,
    ACTIONS(1098), 3,
      sym_escape_char,
      sym_escape_unicode,
      aux_sym_simple_string_lit_token1,
  [4745] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1028), 1,
      anon_sym_for,
    ACTIONS(1030), 1,
      anon_sym_if,
    ACTIONS(1032), 1,
      anon_sym_let,
    STATE(320), 4,
      sym_for_clause,
      sym_guard_clause,
      sym_let_clause,
      sym__clause,
  [4764] = 5,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(1088), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1112), 1,
      anon_sym_DQUOTE,
    STATE(279), 2,
      sym_interpolation,
      aux_sym_simple_string_lit_repeat1,
    ACTIONS(1110), 3,
      sym_escape_char,
      sym_escape_unicode,
      aux_sym_simple_string_lit_token1,
  [4783] = 3,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(1116), 2,
      anon_sym_SQUOTE,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1114), 4,
      sym_escape_char,
      sym_escape_byte,
      sym_escape_unicode,
      aux_sym_simple_bytes_lit_token1,
  [4797] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1118), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_DQUOTE,
    ACTIONS(1122), 1,
      anon_sym_LBRACK,
    STATE(368), 1,
      sym__label_expr,
    STATE(353), 2,
      sym_simple_string_lit,
      sym__label_name,
  [4817] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1124), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1126), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1129), 1,
      sym__multi_str_content,
    STATE(284), 2,
      sym_interpolation,
      aux_sym_multiline_string_lit_repeat1,
  [4834] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1132), 1,
      anon_sym_SQUOTE_POUND,
    ACTIONS(1134), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1136), 1,
      sym__raw_bytes_content,
    STATE(287), 2,
      sym_raw_interpolation,
      aux_sym_simple_raw_bytes_lit_repeat1,
  [4851] = 3,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(1116), 2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1114), 3,
      sym_escape_char,
      sym_escape_unicode,
      aux_sym_simple_string_lit_token1,
  [4864] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1138), 1,
      anon_sym_SQUOTE_POUND,
    ACTIONS(1140), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1143), 1,
      sym__raw_bytes_content,
    STATE(287), 2,
      sym_raw_interpolation,
      aux_sym_simple_raw_bytes_lit_repeat1,
  [4881] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_DQUOTE_POUND,
    ACTIONS(1148), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1150), 1,
      sym__raw_str_content,
    STATE(322), 2,
      sym_raw_interpolation,
      aux_sym_simple_raw_string_lit_repeat1,
  [4898] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1134), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1152), 1,
      anon_sym_SQUOTE_POUND,
    ACTIONS(1154), 1,
      sym__raw_bytes_content,
    STATE(285), 2,
      sym_raw_interpolation,
      aux_sym_simple_raw_bytes_lit_repeat1,
  [4915] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym_DQUOTE_POUND,
    ACTIONS(1158), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1161), 1,
      sym__raw_str_content,
    STATE(290), 2,
      sym_raw_interpolation,
      aux_sym_simple_raw_string_lit_repeat1,
  [4932] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1164), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE_POUND,
    ACTIONS(1166), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1169), 1,
      sym__multi_raw_str_content,
    STATE(291), 2,
      sym_raw_interpolation,
      aux_sym_multiline_raw_string_lit_repeat1,
  [4949] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1172), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1174), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1177), 1,
      sym__multi_bytes_content,
    STATE(292), 2,
      sym_interpolation,
      aux_sym_multiline_bytes_lit_repeat1,
  [4966] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1180), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1182), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1184), 1,
      sym__multi_str_content,
    STATE(301), 2,
      sym_interpolation,
      aux_sym_multiline_string_lit_repeat1,
  [4983] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1186), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE_POUND,
    ACTIONS(1188), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1190), 1,
      sym__multi_raw_str_content,
    STATE(300), 2,
      sym_raw_interpolation,
      aux_sym_multiline_raw_string_lit_repeat1,
  [5000] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1192), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE_POUND,
    ACTIONS(1194), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1197), 1,
      sym__multi_raw_bytes_content,
    STATE(295), 2,
      sym_raw_interpolation,
      aux_sym_multiline_raw_bytes_lit_repeat1,
  [5017] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1200), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1202), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1204), 1,
      sym__multi_bytes_content,
    STATE(299), 2,
      sym_interpolation,
      aux_sym_multiline_bytes_lit_repeat1,
  [5034] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1206), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE_POUND,
    ACTIONS(1208), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1210), 1,
      sym__multi_raw_bytes_content,
    STATE(295), 2,
      sym_raw_interpolation,
      aux_sym_multiline_raw_bytes_lit_repeat1,
  [5051] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1208), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1212), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE_POUND,
    ACTIONS(1214), 1,
      sym__multi_raw_bytes_content,
    STATE(297), 2,
      sym_raw_interpolation,
      aux_sym_multiline_raw_bytes_lit_repeat1,
  [5068] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1202), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1216), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1218), 1,
      sym__multi_bytes_content,
    STATE(292), 2,
      sym_interpolation,
      aux_sym_multiline_bytes_lit_repeat1,
  [5085] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1188), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE_POUND,
    ACTIONS(1222), 1,
      sym__multi_raw_str_content,
    STATE(291), 2,
      sym_raw_interpolation,
      aux_sym_multiline_raw_string_lit_repeat1,
  [5102] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1182), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1224), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1226), 1,
      sym__multi_str_content,
    STATE(284), 2,
      sym_interpolation,
      aux_sym_multiline_string_lit_repeat1,
  [5119] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1208), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1210), 1,
      sym__multi_raw_bytes_content,
    ACTIONS(1228), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE_POUND,
    STATE(295), 2,
      sym_raw_interpolation,
      aux_sym_multiline_raw_bytes_lit_repeat1,
  [5136] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1202), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1218), 1,
      sym__multi_bytes_content,
    ACTIONS(1230), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(292), 2,
      sym_interpolation,
      aux_sym_multiline_bytes_lit_repeat1,
  [5153] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1188), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1222), 1,
      sym__multi_raw_str_content,
    ACTIONS(1232), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE_POUND,
    STATE(291), 2,
      sym_raw_interpolation,
      aux_sym_multiline_raw_string_lit_repeat1,
  [5170] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1182), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1226), 1,
      sym__multi_str_content,
    ACTIONS(1234), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(284), 2,
      sym_interpolation,
      aux_sym_multiline_string_lit_repeat1,
  [5187] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1134), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1136), 1,
      sym__raw_bytes_content,
    ACTIONS(1236), 1,
      anon_sym_SQUOTE_POUND,
    STATE(287), 2,
      sym_raw_interpolation,
      aux_sym_simple_raw_bytes_lit_repeat1,
  [5204] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1202), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1218), 1,
      sym__multi_bytes_content,
    ACTIONS(1238), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(292), 2,
      sym_interpolation,
      aux_sym_multiline_bytes_lit_repeat1,
  [5221] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1148), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE_POUND,
    ACTIONS(1242), 1,
      sym__raw_str_content,
    STATE(290), 2,
      sym_raw_interpolation,
      aux_sym_simple_raw_string_lit_repeat1,
  [5238] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1148), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1244), 1,
      anon_sym_DQUOTE_POUND,
    ACTIONS(1246), 1,
      sym__raw_str_content,
    STATE(324), 2,
      sym_raw_interpolation,
      aux_sym_simple_raw_string_lit_repeat1,
  [5255] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1208), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE_POUND,
    ACTIONS(1250), 1,
      sym__multi_raw_bytes_content,
    STATE(302), 2,
      sym_raw_interpolation,
      aux_sym_multiline_raw_bytes_lit_repeat1,
  [5272] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1134), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1252), 1,
      anon_sym_SQUOTE_POUND,
    ACTIONS(1254), 1,
      sym__raw_bytes_content,
    STATE(326), 2,
      sym_raw_interpolation,
      aux_sym_simple_raw_bytes_lit_repeat1,
  [5289] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1182), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1256), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1258), 1,
      sym__multi_str_content,
    STATE(327), 2,
      sym_interpolation,
      aux_sym_multiline_string_lit_repeat1,
  [5306] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1188), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1260), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE_POUND,
    ACTIONS(1262), 1,
      sym__multi_raw_str_content,
    STATE(323), 2,
      sym_raw_interpolation,
      aux_sym_multiline_raw_string_lit_repeat1,
  [5323] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1202), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1264), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1266), 1,
      sym__multi_bytes_content,
    STATE(307), 2,
      sym_interpolation,
      aux_sym_multiline_bytes_lit_repeat1,
  [5340] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1208), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1268), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE_POUND,
    ACTIONS(1270), 1,
      sym__multi_raw_bytes_content,
    STATE(325), 2,
      sym_raw_interpolation,
      aux_sym_multiline_raw_bytes_lit_repeat1,
  [5357] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1202), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1272), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1274), 1,
      sym__multi_bytes_content,
    STATE(303), 2,
      sym_interpolation,
      aux_sym_multiline_bytes_lit_repeat1,
  [5374] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1188), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE_POUND,
    ACTIONS(1278), 1,
      sym__multi_raw_str_content,
    STATE(304), 2,
      sym_raw_interpolation,
      aux_sym_multiline_raw_string_lit_repeat1,
  [5391] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1182), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1280), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1282), 1,
      sym__multi_str_content,
    STATE(305), 2,
      sym_interpolation,
      aux_sym_multiline_string_lit_repeat1,
  [5408] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1134), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1284), 1,
      anon_sym_SQUOTE_POUND,
    ACTIONS(1286), 1,
      sym__raw_bytes_content,
    STATE(306), 2,
      sym_raw_interpolation,
      aux_sym_simple_raw_bytes_lit_repeat1,
  [5425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1039), 5,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_for,
      anon_sym_if,
      anon_sym_let,
  [5436] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1148), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1288), 1,
      anon_sym_DQUOTE_POUND,
    ACTIONS(1290), 1,
      sym__raw_str_content,
    STATE(308), 2,
      sym_raw_interpolation,
      aux_sym_simple_raw_string_lit_repeat1,
  [5453] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1148), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1242), 1,
      sym__raw_str_content,
    ACTIONS(1292), 1,
      anon_sym_DQUOTE_POUND,
    STATE(290), 2,
      sym_raw_interpolation,
      aux_sym_simple_raw_string_lit_repeat1,
  [5470] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1188), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1222), 1,
      sym__multi_raw_str_content,
    ACTIONS(1294), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE_POUND,
    STATE(291), 2,
      sym_raw_interpolation,
      aux_sym_multiline_raw_string_lit_repeat1,
  [5487] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1148), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1242), 1,
      sym__raw_str_content,
    ACTIONS(1296), 1,
      anon_sym_DQUOTE_POUND,
    STATE(290), 2,
      sym_raw_interpolation,
      aux_sym_simple_raw_string_lit_repeat1,
  [5504] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1208), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1210), 1,
      sym__multi_raw_bytes_content,
    ACTIONS(1298), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE_POUND,
    STATE(295), 2,
      sym_raw_interpolation,
      aux_sym_multiline_raw_bytes_lit_repeat1,
  [5521] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1134), 1,
      anon_sym_BSLASH_POUND_LPAREN,
    ACTIONS(1136), 1,
      sym__raw_bytes_content,
    ACTIONS(1300), 1,
      anon_sym_SQUOTE_POUND,
    STATE(287), 2,
      sym_raw_interpolation,
      aux_sym_simple_raw_bytes_lit_repeat1,
  [5538] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1182), 1,
      anon_sym_BSLASH_LPAREN,
    ACTIONS(1226), 1,
      sym__multi_str_content,
    ACTIONS(1302), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(284), 2,
      sym_interpolation,
      aux_sym_multiline_string_lit_repeat1,
  [5555] = 5,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(767), 1,
      anon_sym_COMMA,
    ACTIONS(769), 1,
      anon_sym_LF,
    ACTIONS(1304), 1,
      anon_sym_AT,
    STATE(181), 1,
      sym_attribute,
  [5571] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(931), 1,
      anon_sym__,
    ACTIONS(1306), 1,
      sym_identifier,
    STATE(367), 1,
      sym_blank_identifier,
  [5584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1308), 1,
      anon_sym_COMMA,
    ACTIONS(1310), 1,
      anon_sym_RPAREN,
    STATE(338), 1,
      aux_sym_arguments_repeat1,
  [5597] = 4,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(1312), 1,
      anon_sym_RPAREN,
    ACTIONS(1314), 1,
      sym_attr_token,
    STATE(345), 1,
      aux_sym_attribute_repeat1,
  [5610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1318), 1,
      anon_sym_EQ,
    ACTIONS(1316), 2,
      anon_sym_QMARK,
      anon_sym_COLON,
  [5621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1320), 3,
      sym__raw_str_content,
      anon_sym_DQUOTE_POUND,
      anon_sym_BSLASH_POUND_LPAREN,
  [5630] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1322), 1,
      sym_identifier,
    ACTIONS(1324), 1,
      anon_sym_DQUOTE,
    STATE(103), 1,
      sym_simple_string_lit,
  [5643] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1120), 1,
      anon_sym_DQUOTE,
    ACTIONS(1326), 1,
      sym_identifier,
    STATE(147), 1,
      sym_simple_string_lit,
  [5656] = 4,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(1328), 1,
      anon_sym_RPAREN,
    ACTIONS(1330), 1,
      sym_attr_token,
    STATE(341), 1,
      aux_sym_attribute_repeat1,
  [5669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1320), 3,
      sym__raw_bytes_content,
      anon_sym_SQUOTE_POUND,
      anon_sym_BSLASH_POUND_LPAREN,
  [5678] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1332), 1,
      anon_sym_COMMA,
    ACTIONS(1335), 1,
      anon_sym_RPAREN,
    STATE(338), 1,
      aux_sym_arguments_repeat1,
  [5691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1320), 3,
      sym__multi_raw_str_content,
      anon_sym_DQUOTE_DQUOTE_DQUOTE_POUND,
      anon_sym_BSLASH_POUND_LPAREN,
  [5700] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1308), 1,
      anon_sym_COMMA,
    ACTIONS(1337), 1,
      anon_sym_RPAREN,
    STATE(342), 1,
      aux_sym_arguments_repeat1,
  [5713] = 4,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(1314), 1,
      sym_attr_token,
    ACTIONS(1339), 1,
      anon_sym_RPAREN,
    STATE(345), 1,
      aux_sym_attribute_repeat1,
  [5726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1308), 1,
      anon_sym_COMMA,
    ACTIONS(1341), 1,
      anon_sym_RPAREN,
    STATE(338), 1,
      aux_sym_arguments_repeat1,
  [5739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1114), 3,
      sym__multi_bytes_content,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_BSLASH_LPAREN,
  [5748] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(931), 1,
      anon_sym__,
    ACTIONS(1343), 1,
      sym_identifier,
    STATE(357), 1,
      sym_blank_identifier,
  [5761] = 4,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(1345), 1,
      anon_sym_RPAREN,
    ACTIONS(1347), 1,
      sym_attr_token,
    STATE(345), 1,
      aux_sym_attribute_repeat1,
  [5774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1320), 3,
      sym__multi_raw_bytes_content,
      anon_sym_SQUOTE_SQUOTE_SQUOTE_POUND,
      anon_sym_BSLASH_POUND_LPAREN,
  [5783] = 4,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(1350), 1,
      anon_sym_RPAREN,
    ACTIONS(1352), 1,
      sym_attr_token,
    STATE(331), 1,
      aux_sym_attribute_repeat1,
  [5796] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1308), 1,
      anon_sym_COMMA,
    ACTIONS(1354), 1,
      anon_sym_RPAREN,
    STATE(330), 1,
      aux_sym_arguments_repeat1,
  [5809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1114), 3,
      sym__multi_str_content,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BSLASH_LPAREN,
  [5818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1356), 1,
      anon_sym_LPAREN,
    STATE(115), 1,
      sym_arguments,
  [5828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1358), 1,
      sym_identifier,
    STATE(191), 1,
      sym__package_identifier,
  [5838] = 3,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(851), 1,
      anon_sym_LF,
    ACTIONS(853), 1,
      anon_sym_COMMA,
  [5848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1360), 1,
      anon_sym_QMARK,
    ACTIONS(1362), 1,
      anon_sym_COLON,
  [5858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1335), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [5866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1364), 1,
      anon_sym_LPAREN,
    STATE(143), 1,
      sym_arguments,
  [5876] = 3,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(1366), 1,
      anon_sym_LF,
    ACTIONS(1368), 1,
      anon_sym_COMMA,
  [5886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1370), 1,
      anon_sym_COMMA,
    ACTIONS(1372), 1,
      anon_sym_in,
  [5896] = 3,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(1374), 1,
      anon_sym_LF,
    ACTIONS(1376), 1,
      anon_sym_COMMA,
  [5906] = 3,
    ACTIONS(530), 1,
      sym_comment,
    ACTIONS(855), 1,
      anon_sym_LF,
    ACTIONS(857), 1,
      anon_sym_COMMA,
  [5916] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1378), 1,
      anon_sym_LPAREN,
  [5923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1380), 1,
      anon_sym_COLON,
  [5930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1382), 1,
      sym_dot,
  [5937] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1384), 1,
      anon_sym_RBRACK,
  [5944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1386), 1,
      anon_sym_EQ,
  [5951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1388), 1,
      anon_sym_LPAREN,
  [5958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1390), 1,
      anon_sym_COLON,
  [5965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1392), 1,
      anon_sym_in,
  [5972] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1394), 1,
      anon_sym_COLON,
  [5979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1396), 1,
      sym_identifier,
  [5986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1398), 1,
      sym_identifier,
  [5993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1400), 1,
      anon_sym_LPAREN,
  [6000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1402), 1,
      sym_identifier,
  [6007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1404), 1,
      anon_sym_RBRACK,
  [6014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1406), 1,
      anon_sym_COLON,
  [6021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1408), 1,
      anon_sym_LPAREN,
  [6028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1410), 1,
      anon_sym_COLON,
  [6035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1412), 1,
      anon_sym_EQ,
  [6042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1414), 1,
      sym_identifier,
  [6049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1416), 1,
      ts_builtin_sym_end,
  [6056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      sym_identifier,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(189)] = 0,
  [SMALL_STATE(190)] = 71,
  [SMALL_STATE(191)] = 142,
  [SMALL_STATE(192)] = 213,
  [SMALL_STATE(193)] = 284,
  [SMALL_STATE(194)] = 355,
  [SMALL_STATE(195)] = 426,
  [SMALL_STATE(196)] = 497,
  [SMALL_STATE(197)] = 568,
  [SMALL_STATE(198)] = 639,
  [SMALL_STATE(199)] = 710,
  [SMALL_STATE(200)] = 781,
  [SMALL_STATE(201)] = 856,
  [SMALL_STATE(202)] = 931,
  [SMALL_STATE(203)] = 1002,
  [SMALL_STATE(204)] = 1073,
  [SMALL_STATE(205)] = 1144,
  [SMALL_STATE(206)] = 1215,
  [SMALL_STATE(207)] = 1286,
  [SMALL_STATE(208)] = 1361,
  [SMALL_STATE(209)] = 1432,
  [SMALL_STATE(210)] = 1503,
  [SMALL_STATE(211)] = 1574,
  [SMALL_STATE(212)] = 1645,
  [SMALL_STATE(213)] = 1716,
  [SMALL_STATE(214)] = 1787,
  [SMALL_STATE(215)] = 1858,
  [SMALL_STATE(216)] = 1929,
  [SMALL_STATE(217)] = 2000,
  [SMALL_STATE(218)] = 2071,
  [SMALL_STATE(219)] = 2155,
  [SMALL_STATE(220)] = 2225,
  [SMALL_STATE(221)] = 2297,
  [SMALL_STATE(222)] = 2367,
  [SMALL_STATE(223)] = 2437,
  [SMALL_STATE(224)] = 2509,
  [SMALL_STATE(225)] = 2579,
  [SMALL_STATE(226)] = 2649,
  [SMALL_STATE(227)] = 2719,
  [SMALL_STATE(228)] = 2791,
  [SMALL_STATE(229)] = 2861,
  [SMALL_STATE(230)] = 2931,
  [SMALL_STATE(231)] = 3000,
  [SMALL_STATE(232)] = 3069,
  [SMALL_STATE(233)] = 3138,
  [SMALL_STATE(234)] = 3203,
  [SMALL_STATE(235)] = 3264,
  [SMALL_STATE(236)] = 3325,
  [SMALL_STATE(237)] = 3386,
  [SMALL_STATE(238)] = 3445,
  [SMALL_STATE(239)] = 3490,
  [SMALL_STATE(240)] = 3535,
  [SMALL_STATE(241)] = 3580,
  [SMALL_STATE(242)] = 3625,
  [SMALL_STATE(243)] = 3667,
  [SMALL_STATE(244)] = 3708,
  [SMALL_STATE(245)] = 3749,
  [SMALL_STATE(246)] = 3790,
  [SMALL_STATE(247)] = 3831,
  [SMALL_STATE(248)] = 3870,
  [SMALL_STATE(249)] = 3911,
  [SMALL_STATE(250)] = 3952,
  [SMALL_STATE(251)] = 3993,
  [SMALL_STATE(252)] = 4034,
  [SMALL_STATE(253)] = 4073,
  [SMALL_STATE(254)] = 4114,
  [SMALL_STATE(255)] = 4155,
  [SMALL_STATE(256)] = 4196,
  [SMALL_STATE(257)] = 4237,
  [SMALL_STATE(258)] = 4257,
  [SMALL_STATE(259)] = 4286,
  [SMALL_STATE(260)] = 4315,
  [SMALL_STATE(261)] = 4344,
  [SMALL_STATE(262)] = 4373,
  [SMALL_STATE(263)] = 4402,
  [SMALL_STATE(264)] = 4431,
  [SMALL_STATE(265)] = 4457,
  [SMALL_STATE(266)] = 4475,
  [SMALL_STATE(267)] = 4495,
  [SMALL_STATE(268)] = 4515,
  [SMALL_STATE(269)] = 4535,
  [SMALL_STATE(270)] = 4555,
  [SMALL_STATE(271)] = 4575,
  [SMALL_STATE(272)] = 4595,
  [SMALL_STATE(273)] = 4611,
  [SMALL_STATE(274)] = 4631,
  [SMALL_STATE(275)] = 4650,
  [SMALL_STATE(276)] = 4669,
  [SMALL_STATE(277)] = 4688,
  [SMALL_STATE(278)] = 4707,
  [SMALL_STATE(279)] = 4726,
  [SMALL_STATE(280)] = 4745,
  [SMALL_STATE(281)] = 4764,
  [SMALL_STATE(282)] = 4783,
  [SMALL_STATE(283)] = 4797,
  [SMALL_STATE(284)] = 4817,
  [SMALL_STATE(285)] = 4834,
  [SMALL_STATE(286)] = 4851,
  [SMALL_STATE(287)] = 4864,
  [SMALL_STATE(288)] = 4881,
  [SMALL_STATE(289)] = 4898,
  [SMALL_STATE(290)] = 4915,
  [SMALL_STATE(291)] = 4932,
  [SMALL_STATE(292)] = 4949,
  [SMALL_STATE(293)] = 4966,
  [SMALL_STATE(294)] = 4983,
  [SMALL_STATE(295)] = 5000,
  [SMALL_STATE(296)] = 5017,
  [SMALL_STATE(297)] = 5034,
  [SMALL_STATE(298)] = 5051,
  [SMALL_STATE(299)] = 5068,
  [SMALL_STATE(300)] = 5085,
  [SMALL_STATE(301)] = 5102,
  [SMALL_STATE(302)] = 5119,
  [SMALL_STATE(303)] = 5136,
  [SMALL_STATE(304)] = 5153,
  [SMALL_STATE(305)] = 5170,
  [SMALL_STATE(306)] = 5187,
  [SMALL_STATE(307)] = 5204,
  [SMALL_STATE(308)] = 5221,
  [SMALL_STATE(309)] = 5238,
  [SMALL_STATE(310)] = 5255,
  [SMALL_STATE(311)] = 5272,
  [SMALL_STATE(312)] = 5289,
  [SMALL_STATE(313)] = 5306,
  [SMALL_STATE(314)] = 5323,
  [SMALL_STATE(315)] = 5340,
  [SMALL_STATE(316)] = 5357,
  [SMALL_STATE(317)] = 5374,
  [SMALL_STATE(318)] = 5391,
  [SMALL_STATE(319)] = 5408,
  [SMALL_STATE(320)] = 5425,
  [SMALL_STATE(321)] = 5436,
  [SMALL_STATE(322)] = 5453,
  [SMALL_STATE(323)] = 5470,
  [SMALL_STATE(324)] = 5487,
  [SMALL_STATE(325)] = 5504,
  [SMALL_STATE(326)] = 5521,
  [SMALL_STATE(327)] = 5538,
  [SMALL_STATE(328)] = 5555,
  [SMALL_STATE(329)] = 5571,
  [SMALL_STATE(330)] = 5584,
  [SMALL_STATE(331)] = 5597,
  [SMALL_STATE(332)] = 5610,
  [SMALL_STATE(333)] = 5621,
  [SMALL_STATE(334)] = 5630,
  [SMALL_STATE(335)] = 5643,
  [SMALL_STATE(336)] = 5656,
  [SMALL_STATE(337)] = 5669,
  [SMALL_STATE(338)] = 5678,
  [SMALL_STATE(339)] = 5691,
  [SMALL_STATE(340)] = 5700,
  [SMALL_STATE(341)] = 5713,
  [SMALL_STATE(342)] = 5726,
  [SMALL_STATE(343)] = 5739,
  [SMALL_STATE(344)] = 5748,
  [SMALL_STATE(345)] = 5761,
  [SMALL_STATE(346)] = 5774,
  [SMALL_STATE(347)] = 5783,
  [SMALL_STATE(348)] = 5796,
  [SMALL_STATE(349)] = 5809,
  [SMALL_STATE(350)] = 5818,
  [SMALL_STATE(351)] = 5828,
  [SMALL_STATE(352)] = 5838,
  [SMALL_STATE(353)] = 5848,
  [SMALL_STATE(354)] = 5858,
  [SMALL_STATE(355)] = 5866,
  [SMALL_STATE(356)] = 5876,
  [SMALL_STATE(357)] = 5886,
  [SMALL_STATE(358)] = 5896,
  [SMALL_STATE(359)] = 5906,
  [SMALL_STATE(360)] = 5916,
  [SMALL_STATE(361)] = 5923,
  [SMALL_STATE(362)] = 5930,
  [SMALL_STATE(363)] = 5937,
  [SMALL_STATE(364)] = 5944,
  [SMALL_STATE(365)] = 5951,
  [SMALL_STATE(366)] = 5958,
  [SMALL_STATE(367)] = 5965,
  [SMALL_STATE(368)] = 5972,
  [SMALL_STATE(369)] = 5979,
  [SMALL_STATE(370)] = 5986,
  [SMALL_STATE(371)] = 5993,
  [SMALL_STATE(372)] = 6000,
  [SMALL_STATE(373)] = 6007,
  [SMALL_STATE(374)] = 6014,
  [SMALL_STATE(375)] = 6021,
  [SMALL_STATE(376)] = 6028,
  [SMALL_STATE(377)] = 6035,
  [SMALL_STATE(378)] = 6042,
  [SMALL_STATE(379)] = 6049,
  [SMALL_STATE(380)] = 6056,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [63] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [65] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 3),
  [67] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 2),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [83] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(78),
  [86] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(57),
  [89] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(95),
  [92] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(380),
  [95] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(281),
  [98] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(288),
  [101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(266),
  [104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(289),
  [107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(293),
  [110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(294),
  [113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(296),
  [116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(298),
  [119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(365),
  [122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(81),
  [125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(87),
  [128] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(93),
  [131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(94),
  [134] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(81),
  [137] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(25),
  [140] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(11),
  [143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8),
  [145] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(33),
  [148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(344),
  [151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(75),
  [154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(369),
  [157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(72),
  [160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(72),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 2, .production_id = 7),
  [171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 3, .production_id = 12),
  [173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8),
  [175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(78),
  [178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(57),
  [181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(95),
  [184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(281),
  [187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(288),
  [190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(266),
  [193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(289),
  [196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(293),
  [199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(294),
  [202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(296),
  [205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(298),
  [208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(365),
  [211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(81),
  [214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(87),
  [217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(93),
  [220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(94),
  [223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(81),
  [226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(25),
  [229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(11),
  [232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(38),
  [235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(344),
  [238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(75),
  [241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(369),
  [244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(72),
  [247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 8), SHIFT_REPEAT(72),
  [250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 4, .production_id = 15),
  [252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1, .production_id = 2),
  [254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(152),
  [301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(58),
  [304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(121),
  [307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(278),
  [310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(321),
  [313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(269),
  [316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(319),
  [319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(318),
  [322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(317),
  [325] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(316),
  [328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(310),
  [331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(365),
  [334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(86),
  [337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(120),
  [340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(132),
  [343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(122),
  [346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(86),
  [349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(29),
  [352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8),
  [354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(8),
  [357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(37),
  [360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(344),
  [363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(75),
  [366] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(56),
  [369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_list_lit_repeat1, 2, .production_id = 8), SHIFT_REPEAT(56),
  [372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(152),
  [381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(58),
  [384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(121),
  [387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(278),
  [390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(321),
  [393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(269),
  [396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(319),
  [399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(318),
  [402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(317),
  [405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(316),
  [408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(310),
  [411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(365),
  [414] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(86),
  [417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(120),
  [420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(132),
  [423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(122),
  [426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(86),
  [429] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(29),
  [432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_elem, 2, .production_id = 2),
  [434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(8),
  [437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(37),
  [440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(344),
  [443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(75),
  [446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(56),
  [449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 2, .production_id = 2), SHIFT(56),
  [452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(152),
  [455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(58),
  [458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(121),
  [461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(278),
  [464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(321),
  [467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(269),
  [470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(319),
  [473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(318),
  [476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(317),
  [479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(316),
  [482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(310),
  [485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(365),
  [488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(86),
  [491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(120),
  [494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(132),
  [497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(122),
  [500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(86),
  [503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(29),
  [506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_elem, 3, .production_id = 8),
  [508] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(8),
  [511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(37),
  [514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(344),
  [517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(75),
  [520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(56),
  [523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__list_elem, 3, .production_id = 8), SHIFT(56),
  [526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ellipsis, 1),
  [528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ellipsis, 1),
  [530] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__operand, 1),
  [556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__operand, 1),
  [558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__package_identifier, 1, .production_id = 1), REDUCE(sym__operand, 1),
  [561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__label_name, 1),
  [563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_simple_string_lit, 3),
  [567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_string_lit, 3),
  [569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_lit, 1),
  [571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_lit, 1),
  [573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_simple_string_lit, 2),
  [583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_string_lit, 2),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float_type, 1),
  [591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float_type, 1),
  [593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_lit, 3, .production_id = 7),
  [595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_lit, 3, .production_id = 7),
  [597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_lit, 3, .production_id = 7),
  [599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_lit, 3, .production_id = 7),
  [601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multiline_raw_bytes_lit, 3),
  [603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multiline_raw_bytes_lit, 3),
  [605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_lit, 2),
  [607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_lit, 2),
  [609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_uint_type, 1),
  [611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uint_type, 1),
  [613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_int_type, 1),
  [615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_int_type, 1),
  [617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_top_lit, 1),
  [619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_top_lit, 1),
  [621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multiline_bytes_lit, 3),
  [623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multiline_bytes_lit, 3),
  [625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multiline_raw_string_lit, 3),
  [627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multiline_raw_string_lit, 3),
  [629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multiline_string_lit, 3),
  [631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multiline_string_lit, 3),
  [633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_simple_raw_bytes_lit, 3),
  [635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_raw_bytes_lit, 3),
  [637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_simple_bytes_lit, 3),
  [639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_bytes_lit, 3),
  [641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_simple_raw_string_lit, 3),
  [643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_raw_string_lit, 3),
  [645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_lit, 2),
  [647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_lit, 2),
  [649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selector, 2),
  [651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_selector, 2),
  [653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multiline_raw_bytes_lit, 2),
  [655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multiline_raw_bytes_lit, 2),
  [657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multiline_bytes_lit, 2),
  [659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multiline_bytes_lit, 2),
  [661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multiline_raw_string_lit, 2),
  [663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multiline_raw_string_lit, 2),
  [665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index, 3),
  [667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index, 3),
  [669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multiline_string_lit, 2),
  [671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multiline_string_lit, 2),
  [673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_simple_raw_bytes_lit, 2),
  [675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_raw_bytes_lit, 2),
  [677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_simple_bytes_lit, 2),
  [683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_bytes_lit, 2),
  [685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selector_expression, 2),
  [687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_selector_expression, 2),
  [689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 2),
  [691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 2),
  [693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_simple_raw_string_lit, 2),
  [695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_raw_string_lit, 2),
  [697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2),
  [699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2),
  [701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__operand, 3),
  [703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__operand, 3),
  [705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 13),
  [711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 13),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__alias_expr, 1),
  [725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__alias_expr, 1),
  [727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_clause, 4, .production_id = 14),
  [733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_clause, 4, .production_id = 14),
  [735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__alias_expr, 3, .production_id = 11),
  [739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__alias_expr, 3, .production_id = 11),
  [741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 6),
  [743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 6),
  [745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ellipsis, 2),
  [747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ellipsis, 2),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field, 2),
  [769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 2),
  [771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_struct_lit_repeat1, 1, .production_id = 2),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comprehension, 2),
  [779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comprehension, 2),
  [781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [785] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(237),
  [788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comprehension, 3),
  [790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comprehension, 3),
  [792] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__embedding, 1, .production_id = 2),
  [794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__embedding, 1, .production_id = 2),
  [796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_struct_lit_repeat1, 1),
  [798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field, 3),
  [804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 3),
  [806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 5),
  [808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 5),
  [810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 4),
  [812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 4),
  [814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__value, 1, .production_id = 9),
  [816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__value, 1, .production_id = 9),
  [818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration, 1, .production_id = 2),
  [820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration, 1, .production_id = 2),
  [822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec_list, 3),
  [824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec_list, 3),
  [826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_clause, 2),
  [828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_clause, 2),
  [830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 2),
  [832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 2),
  [834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__package_identifier, 1, .production_id = 1),
  [836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__package_identifier, 1, .production_id = 1),
  [838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__list_elem_repeat1, 2, .production_id = 8),
  [840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_elem_repeat1, 2, .production_id = 8), SHIFT_REPEAT(34),
  [843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_elem_repeat1, 2, .production_id = 8),
  [845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_elem, 2, .production_id = 8),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_elem, 2, .production_id = 8),
  [851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec, 2, .production_id = 10),
  [853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec, 2, .production_id = 10),
  [855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec, 1, .production_id = 3),
  [857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec, 1, .production_id = 3),
  [859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_struct_lit_repeat1, 2),
  [861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_lit_repeat1, 2),
  [863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 2),
  [865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_lit_repeat1, 2, .production_id = 2),
  [867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_elem, 1, .production_id = 2),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_elem, 1, .production_id = 2),
  [873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec_list, 2),
  [875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec_list, 2),
  [877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_repeat1, 2), SHIFT_REPEAT(332),
  [880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_repeat1, 2),
  [882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_repeat1, 2),
  [884] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_repeat1, 2), SHIFT_REPEAT(278),
  [887] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_repeat1, 2), SHIFT_REPEAT(40),
  [890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__list_elem_repeat1, 2, .production_id = 7),
  [892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_elem_repeat1, 2, .production_id = 7),
  [894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_elem, 4, .production_id = 8),
  [896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_elem, 4, .production_id = 8),
  [900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__embedding, 1, .production_id = 2), REDUCE(sym__label_alias_expr, 1, .production_id = 4),
  [903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 2),
  [905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, .production_id = 2),
  [907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_elem, 3, .production_id = 2),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_elem, 3, .production_id = 2),
  [913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_elem, 4, .production_id = 2),
  [915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_elem, 4, .production_id = 2),
  [917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_list_lit_repeat1, 1, .production_id = 2),
  [919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_lit_repeat1, 1, .production_id = 2),
  [921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_elem, 5, .production_id = 8),
  [923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_elem, 5, .production_id = 8),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [933] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(272),
  [936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_spec_list_repeat1, 2),
  [938] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(247),
  [941] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(265),
  [944] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(281),
  [947] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(288),
  [950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(266),
  [953] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(289),
  [956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(293),
  [959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(294),
  [962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(296),
  [965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(298),
  [968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 6),
  [992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guard_clause, 2, .production_id = 5),
  [994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 4),
  [996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 1),
  [998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [1000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [1002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [1004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [1006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [1008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [1010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [1012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [1014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [1016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [1018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [1020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_import_spec_list_repeat1, 2),
  [1024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [1026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [1028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [1034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1036] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comprehension_repeat1, 2), SHIFT_REPEAT(280),
  [1039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comprehension_repeat1, 2),
  [1041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comprehension_repeat1, 2), SHIFT_REPEAT(344),
  [1044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comprehension_repeat1, 2), SHIFT_REPEAT(75),
  [1047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comprehension_repeat1, 2), SHIFT_REPEAT(370),
  [1050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_blank_identifier, 1),
  [1052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_blank_identifier, 1),
  [1054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [1056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [1058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [1060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [1062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [1064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [1066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [1068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [1070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_simple_bytes_lit_repeat1, 2), SHIFT_REPEAT(270),
  [1073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_simple_bytes_lit_repeat1, 2),
  [1075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_simple_bytes_lit_repeat1, 2), SHIFT_REPEAT(55),
  [1078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [1080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [1082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [1084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [1086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [1088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [1090] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_simple_string_lit_repeat1, 2), SHIFT_REPEAT(275),
  [1093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_simple_string_lit_repeat1, 2),
  [1095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_simple_string_lit_repeat1, 2), SHIFT_REPEAT(59),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [1100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [1102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [1104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [1106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [1108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [1110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [1112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [1114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 3),
  [1116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 3),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [1120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [1122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [1124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_multiline_string_lit_repeat1, 2),
  [1126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multiline_string_lit_repeat1, 2), SHIFT_REPEAT(77),
  [1129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multiline_string_lit_repeat1, 2), SHIFT_REPEAT(284),
  [1132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [1136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [1138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_simple_raw_bytes_lit_repeat1, 2),
  [1140] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_simple_raw_bytes_lit_repeat1, 2), SHIFT_REPEAT(47),
  [1143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_simple_raw_bytes_lit_repeat1, 2), SHIFT_REPEAT(287),
  [1146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [1148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [1150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [1152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [1154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_simple_raw_string_lit_repeat1, 2),
  [1158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_simple_raw_string_lit_repeat1, 2), SHIFT_REPEAT(45),
  [1161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_simple_raw_string_lit_repeat1, 2), SHIFT_REPEAT(290),
  [1164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_multiline_raw_string_lit_repeat1, 2),
  [1166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multiline_raw_string_lit_repeat1, 2), SHIFT_REPEAT(76),
  [1169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multiline_raw_string_lit_repeat1, 2), SHIFT_REPEAT(291),
  [1172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_multiline_bytes_lit_repeat1, 2),
  [1174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multiline_bytes_lit_repeat1, 2), SHIFT_REPEAT(54),
  [1177] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multiline_bytes_lit_repeat1, 2), SHIFT_REPEAT(292),
  [1180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [1182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [1184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [1186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [1188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [1190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [1192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_multiline_raw_bytes_lit_repeat1, 2),
  [1194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multiline_raw_bytes_lit_repeat1, 2), SHIFT_REPEAT(62),
  [1197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multiline_raw_bytes_lit_repeat1, 2), SHIFT_REPEAT(295),
  [1200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [1204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [1206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [1208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [1212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [1214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [1216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [1218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [1220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [1222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [1224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [1226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [1228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [1230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [1232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [1234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [1236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [1240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [1242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [1244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [1248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [1250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [1252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [1254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [1256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [1258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [1260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [1262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [1264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [1266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [1268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [1270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [1272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [1274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [1276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [1278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [1280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [1282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [1284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [1290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [1292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [1294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [1296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [1298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [1300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [1302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [1304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [1306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [1308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [1310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [1312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [1314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [1316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__label_name, 1),
  [1318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [1320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_interpolation, 3),
  [1322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [1324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [1326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [1328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [1330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [1332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(41),
  [1335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [1339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [1345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attribute_repeat1, 2),
  [1347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attribute_repeat1, 2), SHIFT_REPEAT(345),
  [1350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [1352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [1354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [1360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [1362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__label_expr, 1),
  [1364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [1366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [1370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [1372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [1376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [1378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_identifier, 3),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [1384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__label_alias_expr, 1, .production_id = 4),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [1388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_builtin, 1),
  [1390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__label_expr, 3),
  [1392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [1394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label, 3, .production_id = 11),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [1402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [1404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [1406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label, 1),
  [1408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [1410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__label_expr, 2),
  [1412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [1414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [1416] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_cue_external_scanner_create(void);
void tree_sitter_cue_external_scanner_destroy(void *);
bool tree_sitter_cue_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_cue_external_scanner_serialize(void *, char *);
void tree_sitter_cue_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_cue(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_cue_external_scanner_create,
      tree_sitter_cue_external_scanner_destroy,
      tree_sitter_cue_external_scanner_scan,
      tree_sitter_cue_external_scanner_serialize,
      tree_sitter_cue_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
