#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 1396
#define LARGE_STATE_COUNT 120
#define SYMBOL_COUNT 208
#define ALIAS_COUNT 2
#define TOKEN_COUNT 104
#define EXTERNAL_TOKEN_COUNT 12
#define FIELD_COUNT 18
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 72

enum {
  sym__identifier = 1,
  sym_comment = 2,
  sym_true = 3,
  sym_false = 4,
  sym_null = 5,
  sym_underscore = 6,
  sym_static_keyword = 7,
  anon_sym_remote = 8,
  anon_sym_master = 9,
  anon_sym_puppet = 10,
  anon_sym_remotesync = 11,
  anon_sym_mastersync = 12,
  anon_sym_puppetsync = 13,
  sym_escape_sequence = 14,
  sym_float = 15,
  sym_integer = 16,
  anon_sym_AMP = 17,
  sym_node_path = 18,
  sym_get_node = 19,
  anon_sym_SEMI = 20,
  anon_sym_AT = 21,
  anon_sym_COLON_EQ = 22,
  anon_sym_COLON = 23,
  anon_sym_EQ = 24,
  anon_sym_set = 25,
  anon_sym_get = 26,
  anon_sym_COMMA = 27,
  anon_sym_setget = 28,
  anon_sym_var = 29,
  anon_sym_export = 30,
  anon_sym_onready = 31,
  anon_sym_const = 32,
  anon_sym_return = 33,
  anon_sym_pass = 34,
  anon_sym_break = 35,
  sym_breakpoint_statement = 36,
  anon_sym_continue = 37,
  sym_tool_statement = 38,
  anon_sym_signal = 39,
  anon_sym_class_name = 40,
  anon_sym_DOT = 41,
  anon_sym_extends = 42,
  anon_sym_if = 43,
  anon_sym_elif = 44,
  anon_sym_else = 45,
  anon_sym_for = 46,
  anon_sym_in = 47,
  anon_sym_while = 48,
  anon_sym_class = 49,
  anon_sym_enum = 50,
  anon_sym_LBRACE = 51,
  anon_sym_RBRACE = 52,
  anon_sym_match = 53,
  sym_pattern_open_ending = 54,
  anon_sym_LBRACK = 55,
  anon_sym_RBRACK = 56,
  anon_sym_and = 57,
  anon_sym_AMP_AMP = 58,
  anon_sym_or = 59,
  anon_sym_PIPE_PIPE = 60,
  anon_sym_PLUS = 61,
  anon_sym_DASH = 62,
  anon_sym_STAR = 63,
  anon_sym_SLASH = 64,
  anon_sym_PERCENT = 65,
  anon_sym_PIPE = 66,
  anon_sym_CARET = 67,
  anon_sym_LT_LT = 68,
  anon_sym_GT_GT = 69,
  anon_sym_is = 70,
  anon_sym_as = 71,
  anon_sym_not = 72,
  anon_sym_BANG = 73,
  anon_sym_TILDE = 74,
  anon_sym_LT = 75,
  anon_sym_LT_EQ = 76,
  anon_sym_EQ_EQ = 77,
  anon_sym_BANG_EQ = 78,
  anon_sym_GT_EQ = 79,
  anon_sym_GT = 80,
  anon_sym_LPAREN = 81,
  anon_sym_RPAREN = 82,
  anon_sym_await = 83,
  anon_sym_PLUS_EQ = 84,
  anon_sym_DASH_EQ = 85,
  anon_sym_STAR_EQ = 86,
  anon_sym_SLASH_EQ = 87,
  anon_sym_PERCENT_EQ = 88,
  anon_sym_GT_GT_EQ = 89,
  anon_sym_LT_LT_EQ = 90,
  anon_sym_AMP_EQ = 91,
  anon_sym_CARET_EQ = 92,
  anon_sym_PIPE_EQ = 93,
  anon_sym_DASH_GT = 94,
  anon_sym_func = 95,
  anon_sym__init = 96,
  sym__newline = 97,
  sym__indent = 98,
  sym__dedent = 99,
  sym__string_start = 100,
  sym__string_content = 101,
  sym__string_end = 102,
  sym__body_end = 103,
  sym_source = 104,
  sym_identifier = 105,
  sym_name = 106,
  sym_type = 107,
  sym_remote_keyword = 108,
  sym_string = 109,
  sym_string_name = 110,
  sym__statement = 111,
  sym_body = 112,
  sym__simple_statements = 113,
  sym_expression_statement = 114,
  sym_annotation = 115,
  aux_sym__annotations = 116,
  sym_annotations = 117,
  sym_inferred_type = 118,
  sym__variable_assignment = 119,
  sym__variable_inferred_type_assignment = 120,
  sym__variable_typed_assignment = 121,
  sym__variable_typed_definition = 122,
  sym_set_body = 123,
  sym_get_body = 124,
  sym__set_assign = 125,
  sym__get_assign = 126,
  sym__setget_body = 127,
  sym_setter = 128,
  sym_getter = 129,
  sym_setget = 130,
  sym__variable_statement = 131,
  sym_variable_statement = 132,
  sym_export_variable_statement = 133,
  sym_onready_variable_statement = 134,
  sym_const_statement = 135,
  sym_return_statement = 136,
  sym_pass_statement = 137,
  sym_break_statement = 138,
  sym_continue_statement = 139,
  sym_signal_statement = 140,
  sym_class_name_statement = 141,
  sym_dotted_type = 142,
  sym_extends_statement = 143,
  sym_if_statement = 144,
  sym_elif_clause = 145,
  sym_else_clause = 146,
  sym_for_statement = 147,
  sym_while_statement = 148,
  sym_class_definition = 149,
  sym_enum_definition = 150,
  sym_enumerator_list = 151,
  sym__enumerator_expression = 152,
  sym_enumerator = 153,
  sym_match_statement = 154,
  sym_match_body = 155,
  sym_pattern_section = 156,
  sym__pattern = 157,
  sym_pattern_binding = 158,
  sym_pattern_array = 159,
  sym_pattern_dictionary = 160,
  sym_pattern_pair = 161,
  sym__expression = 162,
  sym__primary_expression = 163,
  sym__rhs_expression = 164,
  sym__attribute_expression = 165,
  sym_binary_operator = 166,
  sym_unary_operator = 167,
  sym_comparison_operator = 168,
  sym_subscript = 169,
  sym_attribute_call = 170,
  sym_attribute_subscript = 171,
  sym_attribute = 172,
  sym_conditional_expression = 173,
  sym_parenthesized_expression = 174,
  sym_await_expression = 175,
  sym_assignment = 176,
  sym_augmented_assignment = 177,
  sym_pair = 178,
  sym_dictionary = 179,
  sym_array = 180,
  sym_typed_parameter = 181,
  sym_default_parameter = 182,
  sym_typed_default_parameter = 183,
  sym__parameters = 184,
  sym_parameters = 185,
  sym__return_type = 186,
  sym_function_definition = 187,
  sym_lambda = 188,
  sym_constructor_definition = 189,
  sym_arguments = 190,
  sym_base_call = 191,
  sym_call = 192,
  aux_sym_source_repeat1 = 193,
  aux_sym_string_repeat1 = 194,
  aux_sym__simple_statements_repeat1 = 195,
  aux_sym_dotted_type_repeat1 = 196,
  aux_sym_if_statement_repeat1 = 197,
  aux_sym_enumerator_list_repeat1 = 198,
  aux_sym_match_body_repeat1 = 199,
  aux_sym_pattern_section_repeat1 = 200,
  aux_sym_pattern_array_repeat1 = 201,
  aux_sym_pattern_dictionary_repeat1 = 202,
  aux_sym_comparison_operator_repeat1 = 203,
  aux_sym_attribute_repeat1 = 204,
  aux_sym_dictionary_repeat1 = 205,
  aux_sym_array_repeat1 = 206,
  aux_sym_parameters_repeat1 = 207,
  anon_alias_sym_body = 208,
  anon_alias_sym_value = 209,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym__identifier] = "_identifier",
  [sym_comment] = "comment",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_underscore] = "underscore",
  [sym_static_keyword] = "static_keyword",
  [anon_sym_remote] = "remote",
  [anon_sym_master] = "master",
  [anon_sym_puppet] = "puppet",
  [anon_sym_remotesync] = "remotesync",
  [anon_sym_mastersync] = "mastersync",
  [anon_sym_puppetsync] = "puppetsync",
  [sym_escape_sequence] = "escape_sequence",
  [sym_float] = "float",
  [sym_integer] = "integer",
  [anon_sym_AMP] = "&",
  [sym_node_path] = "node_path",
  [sym_get_node] = "get_node",
  [anon_sym_SEMI] = ";",
  [anon_sym_AT] = "@",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_COLON] = ":",
  [anon_sym_EQ] = "=",
  [anon_sym_set] = "set",
  [anon_sym_get] = "get",
  [anon_sym_COMMA] = ",",
  [anon_sym_setget] = "setget",
  [anon_sym_var] = "var",
  [anon_sym_export] = "export",
  [anon_sym_onready] = "onready",
  [anon_sym_const] = "const",
  [anon_sym_return] = "return",
  [anon_sym_pass] = "pass",
  [anon_sym_break] = "break",
  [sym_breakpoint_statement] = "breakpoint_statement",
  [anon_sym_continue] = "continue",
  [sym_tool_statement] = "tool_statement",
  [anon_sym_signal] = "signal",
  [anon_sym_class_name] = "class_name",
  [anon_sym_DOT] = ".",
  [anon_sym_extends] = "extends",
  [anon_sym_if] = "if",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_class] = "class",
  [anon_sym_enum] = "enum",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_match] = "match",
  [sym_pattern_open_ending] = "pattern_open_ending",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_and] = "and",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_or] = "or",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_is] = "is",
  [anon_sym_as] = "as",
  [anon_sym_not] = "not",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_GT] = ">",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_func] = "func",
  [anon_sym__init] = "_init",
  [sym__newline] = "_newline",
  [sym__indent] = "_indent",
  [sym__dedent] = "_dedent",
  [sym__string_start] = "\"",
  [sym__string_content] = "_string_content",
  [sym__string_end] = "\"",
  [sym__body_end] = "_body_end",
  [sym_source] = "source",
  [sym_identifier] = "identifier",
  [sym_name] = "name",
  [sym_type] = "type",
  [sym_remote_keyword] = "remote_keyword",
  [sym_string] = "string",
  [sym_string_name] = "string_name",
  [sym__statement] = "_statement",
  [sym_body] = "body",
  [sym__simple_statements] = "_simple_statements",
  [sym_expression_statement] = "expression_statement",
  [sym_annotation] = "annotation",
  [aux_sym__annotations] = "_annotations",
  [sym_annotations] = "annotations",
  [sym_inferred_type] = "inferred_type",
  [sym__variable_assignment] = "_variable_assignment",
  [sym__variable_inferred_type_assignment] = "_variable_inferred_type_assignment",
  [sym__variable_typed_assignment] = "_variable_typed_assignment",
  [sym__variable_typed_definition] = "_variable_typed_definition",
  [sym_set_body] = "set_body",
  [sym_get_body] = "get_body",
  [sym__set_assign] = "_set_assign",
  [sym__get_assign] = "_get_assign",
  [sym__setget_body] = "_setget_body",
  [sym_setter] = "setter",
  [sym_getter] = "getter",
  [sym_setget] = "setget",
  [sym__variable_statement] = "_variable_statement",
  [sym_variable_statement] = "variable_statement",
  [sym_export_variable_statement] = "export_variable_statement",
  [sym_onready_variable_statement] = "onready_variable_statement",
  [sym_const_statement] = "const_statement",
  [sym_return_statement] = "return_statement",
  [sym_pass_statement] = "pass_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_signal_statement] = "signal_statement",
  [sym_class_name_statement] = "class_name_statement",
  [sym_dotted_type] = "dotted_type",
  [sym_extends_statement] = "extends_statement",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_class_definition] = "class_definition",
  [sym_enum_definition] = "enum_definition",
  [sym_enumerator_list] = "enumerator_list",
  [sym__enumerator_expression] = "_enumerator_expression",
  [sym_enumerator] = "enumerator",
  [sym_match_statement] = "match_statement",
  [sym_match_body] = "match_body",
  [sym_pattern_section] = "pattern_section",
  [sym__pattern] = "_pattern",
  [sym_pattern_binding] = "pattern_binding",
  [sym_pattern_array] = "pattern_array",
  [sym_pattern_dictionary] = "pattern_dictionary",
  [sym_pattern_pair] = "pattern_pair",
  [sym__expression] = "_expression",
  [sym__primary_expression] = "_primary_expression",
  [sym__rhs_expression] = "_rhs_expression",
  [sym__attribute_expression] = "_attribute_expression",
  [sym_binary_operator] = "binary_operator",
  [sym_unary_operator] = "unary_operator",
  [sym_comparison_operator] = "comparison_operator",
  [sym_subscript] = "subscript",
  [sym_attribute_call] = "attribute_call",
  [sym_attribute_subscript] = "attribute_subscript",
  [sym_attribute] = "attribute",
  [sym_conditional_expression] = "conditional_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_await_expression] = "await_expression",
  [sym_assignment] = "assignment",
  [sym_augmented_assignment] = "augmented_assignment",
  [sym_pair] = "pair",
  [sym_dictionary] = "dictionary",
  [sym_array] = "array",
  [sym_typed_parameter] = "typed_parameter",
  [sym_default_parameter] = "default_parameter",
  [sym_typed_default_parameter] = "typed_default_parameter",
  [sym__parameters] = "_parameters",
  [sym_parameters] = "parameters",
  [sym__return_type] = "_return_type",
  [sym_function_definition] = "function_definition",
  [sym_lambda] = "lambda",
  [sym_constructor_definition] = "constructor_definition",
  [sym_arguments] = "arguments",
  [sym_base_call] = "base_call",
  [sym_call] = "call",
  [aux_sym_source_repeat1] = "source_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym__simple_statements_repeat1] = "_simple_statements_repeat1",
  [aux_sym_dotted_type_repeat1] = "dotted_type_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_enumerator_list_repeat1] = "enumerator_list_repeat1",
  [aux_sym_match_body_repeat1] = "match_body_repeat1",
  [aux_sym_pattern_section_repeat1] = "pattern_section_repeat1",
  [aux_sym_pattern_array_repeat1] = "pattern_array_repeat1",
  [aux_sym_pattern_dictionary_repeat1] = "pattern_dictionary_repeat1",
  [aux_sym_comparison_operator_repeat1] = "comparison_operator_repeat1",
  [aux_sym_attribute_repeat1] = "attribute_repeat1",
  [aux_sym_dictionary_repeat1] = "dictionary_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [anon_alias_sym_body] = "body",
  [anon_alias_sym_value] = "value",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym__identifier] = sym__identifier,
  [sym_comment] = sym_comment,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_underscore] = sym_underscore,
  [sym_static_keyword] = sym_static_keyword,
  [anon_sym_remote] = anon_sym_remote,
  [anon_sym_master] = anon_sym_master,
  [anon_sym_puppet] = anon_sym_puppet,
  [anon_sym_remotesync] = anon_sym_remotesync,
  [anon_sym_mastersync] = anon_sym_mastersync,
  [anon_sym_puppetsync] = anon_sym_puppetsync,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_float] = sym_float,
  [sym_integer] = sym_integer,
  [anon_sym_AMP] = anon_sym_AMP,
  [sym_node_path] = sym_node_path,
  [sym_get_node] = sym_get_node,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_setget] = anon_sym_setget,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_onready] = anon_sym_onready,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_pass] = anon_sym_pass,
  [anon_sym_break] = anon_sym_break,
  [sym_breakpoint_statement] = sym_breakpoint_statement,
  [anon_sym_continue] = anon_sym_continue,
  [sym_tool_statement] = sym_tool_statement,
  [anon_sym_signal] = anon_sym_signal,
  [anon_sym_class_name] = anon_sym_class_name,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_elif] = anon_sym_elif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_match] = anon_sym_match,
  [sym_pattern_open_ending] = sym_pattern_open_ending,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_func] = anon_sym_func,
  [anon_sym__init] = anon_sym__init,
  [sym__newline] = sym__newline,
  [sym__indent] = sym__indent,
  [sym__dedent] = sym__dedent,
  [sym__string_start] = sym__string_start,
  [sym__string_content] = sym__string_content,
  [sym__string_end] = sym__string_start,
  [sym__body_end] = sym__body_end,
  [sym_source] = sym_source,
  [sym_identifier] = sym_identifier,
  [sym_name] = sym_name,
  [sym_type] = sym_type,
  [sym_remote_keyword] = sym_remote_keyword,
  [sym_string] = sym_string,
  [sym_string_name] = sym_string_name,
  [sym__statement] = sym__statement,
  [sym_body] = sym_body,
  [sym__simple_statements] = sym__simple_statements,
  [sym_expression_statement] = sym_expression_statement,
  [sym_annotation] = sym_annotation,
  [aux_sym__annotations] = aux_sym__annotations,
  [sym_annotations] = sym_annotations,
  [sym_inferred_type] = sym_inferred_type,
  [sym__variable_assignment] = sym__variable_assignment,
  [sym__variable_inferred_type_assignment] = sym__variable_inferred_type_assignment,
  [sym__variable_typed_assignment] = sym__variable_typed_assignment,
  [sym__variable_typed_definition] = sym__variable_typed_definition,
  [sym_set_body] = sym_set_body,
  [sym_get_body] = sym_get_body,
  [sym__set_assign] = sym__set_assign,
  [sym__get_assign] = sym__get_assign,
  [sym__setget_body] = sym__setget_body,
  [sym_setter] = sym_setter,
  [sym_getter] = sym_getter,
  [sym_setget] = sym_setget,
  [sym__variable_statement] = sym__variable_statement,
  [sym_variable_statement] = sym_variable_statement,
  [sym_export_variable_statement] = sym_export_variable_statement,
  [sym_onready_variable_statement] = sym_onready_variable_statement,
  [sym_const_statement] = sym_const_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_pass_statement] = sym_pass_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_signal_statement] = sym_signal_statement,
  [sym_class_name_statement] = sym_class_name_statement,
  [sym_dotted_type] = sym_dotted_type,
  [sym_extends_statement] = sym_extends_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_elif_clause] = sym_elif_clause,
  [sym_else_clause] = sym_else_clause,
  [sym_for_statement] = sym_for_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_class_definition] = sym_class_definition,
  [sym_enum_definition] = sym_enum_definition,
  [sym_enumerator_list] = sym_enumerator_list,
  [sym__enumerator_expression] = sym__enumerator_expression,
  [sym_enumerator] = sym_enumerator,
  [sym_match_statement] = sym_match_statement,
  [sym_match_body] = sym_match_body,
  [sym_pattern_section] = sym_pattern_section,
  [sym__pattern] = sym__pattern,
  [sym_pattern_binding] = sym_pattern_binding,
  [sym_pattern_array] = sym_pattern_array,
  [sym_pattern_dictionary] = sym_pattern_dictionary,
  [sym_pattern_pair] = sym_pattern_pair,
  [sym__expression] = sym__expression,
  [sym__primary_expression] = sym__primary_expression,
  [sym__rhs_expression] = sym__rhs_expression,
  [sym__attribute_expression] = sym__attribute_expression,
  [sym_binary_operator] = sym_binary_operator,
  [sym_unary_operator] = sym_unary_operator,
  [sym_comparison_operator] = sym_comparison_operator,
  [sym_subscript] = sym_subscript,
  [sym_attribute_call] = sym_attribute_call,
  [sym_attribute_subscript] = sym_attribute_subscript,
  [sym_attribute] = sym_attribute,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_assignment] = sym_assignment,
  [sym_augmented_assignment] = sym_augmented_assignment,
  [sym_pair] = sym_pair,
  [sym_dictionary] = sym_dictionary,
  [sym_array] = sym_array,
  [sym_typed_parameter] = sym_typed_parameter,
  [sym_default_parameter] = sym_default_parameter,
  [sym_typed_default_parameter] = sym_typed_default_parameter,
  [sym__parameters] = sym__parameters,
  [sym_parameters] = sym_parameters,
  [sym__return_type] = sym__return_type,
  [sym_function_definition] = sym_function_definition,
  [sym_lambda] = sym_lambda,
  [sym_constructor_definition] = sym_constructor_definition,
  [sym_arguments] = sym_arguments,
  [sym_base_call] = sym_base_call,
  [sym_call] = sym_call,
  [aux_sym_source_repeat1] = aux_sym_source_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym__simple_statements_repeat1] = aux_sym__simple_statements_repeat1,
  [aux_sym_dotted_type_repeat1] = aux_sym_dotted_type_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym_enumerator_list_repeat1] = aux_sym_enumerator_list_repeat1,
  [aux_sym_match_body_repeat1] = aux_sym_match_body_repeat1,
  [aux_sym_pattern_section_repeat1] = aux_sym_pattern_section_repeat1,
  [aux_sym_pattern_array_repeat1] = aux_sym_pattern_array_repeat1,
  [aux_sym_pattern_dictionary_repeat1] = aux_sym_pattern_dictionary_repeat1,
  [aux_sym_comparison_operator_repeat1] = aux_sym_comparison_operator_repeat1,
  [aux_sym_attribute_repeat1] = aux_sym_attribute_repeat1,
  [aux_sym_dictionary_repeat1] = aux_sym_dictionary_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [anon_alias_sym_body] = anon_alias_sym_body,
  [anon_alias_sym_value] = anon_alias_sym_value,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym__identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_underscore] = {
    .visible = true,
    .named = true,
  },
  [sym_static_keyword] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_remote] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_master] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_puppet] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_remotesync] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mastersync] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_puppetsync] = {
    .visible = true,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [sym_node_path] = {
    .visible = true,
    .named = true,
  },
  [sym_get_node] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_setget] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_onready] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pass] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [sym_breakpoint_statement] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [sym_tool_statement] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_signal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class_name] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = false,
  },
  [sym_pattern_open_ending] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_func] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__init] = {
    .visible = true,
    .named = false,
  },
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__indent] = {
    .visible = false,
    .named = true,
  },
  [sym__dedent] = {
    .visible = false,
    .named = true,
  },
  [sym__string_start] = {
    .visible = true,
    .named = false,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym__string_end] = {
    .visible = true,
    .named = false,
  },
  [sym__body_end] = {
    .visible = false,
    .named = true,
  },
  [sym_source] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_name] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_remote_keyword] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_name] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_body] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_statements] = {
    .visible = false,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__annotations] = {
    .visible = false,
    .named = false,
  },
  [sym_annotations] = {
    .visible = true,
    .named = true,
  },
  [sym_inferred_type] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_assignment] = {
    .visible = false,
    .named = true,
  },
  [sym__variable_inferred_type_assignment] = {
    .visible = false,
    .named = true,
  },
  [sym__variable_typed_assignment] = {
    .visible = false,
    .named = true,
  },
  [sym__variable_typed_definition] = {
    .visible = false,
    .named = true,
  },
  [sym_set_body] = {
    .visible = true,
    .named = true,
  },
  [sym_get_body] = {
    .visible = true,
    .named = true,
  },
  [sym__set_assign] = {
    .visible = false,
    .named = true,
  },
  [sym__get_assign] = {
    .visible = false,
    .named = true,
  },
  [sym__setget_body] = {
    .visible = false,
    .named = true,
  },
  [sym_setter] = {
    .visible = true,
    .named = true,
  },
  [sym_getter] = {
    .visible = true,
    .named = true,
  },
  [sym_setget] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_variable_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_onready_variable_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_const_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_pass_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_signal_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_class_name_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_dotted_type] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_class_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym__enumerator_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_enumerator] = {
    .visible = true,
    .named = true,
  },
  [sym_match_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_match_body] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_section] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_pattern_binding] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_array] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_dictionary] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__rhs_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__attribute_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_binary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_comparison_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_call] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameters] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__return_type] = {
    .visible = false,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_base_call] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__simple_statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dotted_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pattern_section_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pattern_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pattern_dictionary_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_comparison_operator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dictionary_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [anon_alias_sym_body] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_value] = {
    .visible = true,
    .named = false,
  },
};

enum {
  field_alternative = 1,
  field_body = 2,
  field_condition = 3,
  field_constructor_arguments = 4,
  field_export_arguments = 5,
  field_extends = 6,
  field_get = 7,
  field_icon_path = 8,
  field_key = 9,
  field_left = 10,
  field_name = 11,
  field_parameters = 12,
  field_return_type = 13,
  field_right = 14,
  field_set = 15,
  field_setget = 16,
  field_type = 17,
  field_value = 18,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_constructor_arguments] = "constructor_arguments",
  [field_export_arguments] = "export_arguments",
  [field_extends] = "extends",
  [field_get] = "get",
  [field_icon_path] = "icon_path",
  [field_key] = "key",
  [field_left] = "left",
  [field_name] = "name",
  [field_parameters] = "parameters",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_set] = "set",
  [field_setget] = "setget",
  [field_type] = "type",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 4},
  [3] = {.index = 4, .length = 1},
  [4] = {.index = 5, .length = 4},
  [5] = {.index = 9, .length = 1},
  [6] = {.index = 10, .length = 2},
  [7] = {.index = 12, .length = 3},
  [8] = {.index = 15, .length = 2},
  [9] = {.index = 17, .length = 2},
  [10] = {.index = 19, .length = 2},
  [11] = {.index = 21, .length = 4},
  [12] = {.index = 25, .length = 5},
  [13] = {.index = 30, .length = 1},
  [14] = {.index = 31, .length = 2},
  [15] = {.index = 33, .length = 1},
  [16] = {.index = 34, .length = 2},
  [17] = {.index = 36, .length = 1},
  [18] = {.index = 37, .length = 1},
  [19] = {.index = 38, .length = 2},
  [20] = {.index = 40, .length = 3},
  [21] = {.index = 43, .length = 4},
  [22] = {.index = 47, .length = 5},
  [23] = {.index = 52, .length = 1},
  [24] = {.index = 53, .length = 2},
  [25] = {.index = 55, .length = 2},
  [26] = {.index = 57, .length = 2},
  [27] = {.index = 59, .length = 2},
  [28] = {.index = 61, .length = 2},
  [29] = {.index = 63, .length = 1},
  [30] = {.index = 64, .length = 2},
  [31] = {.index = 66, .length = 3},
  [32] = {.index = 69, .length = 2},
  [33] = {.index = 71, .length = 2},
  [34] = {.index = 73, .length = 1},
  [35] = {.index = 74, .length = 3},
  [36] = {.index = 77, .length = 3},
  [37] = {.index = 80, .length = 3},
  [38] = {.index = 83, .length = 1},
  [39] = {.index = 84, .length = 1},
  [40] = {.index = 85, .length = 3},
  [41] = {.index = 88, .length = 3},
  [42] = {.index = 91, .length = 3},
  [43] = {.index = 94, .length = 4},
  [44] = {.index = 98, .length = 3},
  [45] = {.index = 101, .length = 3},
  [46] = {.index = 104, .length = 2},
  [47] = {.index = 106, .length = 1},
  [48] = {.index = 107, .length = 1},
  [49] = {.index = 108, .length = 2},
  [50] = {.index = 110, .length = 1},
  [51] = {.index = 111, .length = 4},
  [52] = {.index = 115, .length = 2},
  [53] = {.index = 117, .length = 3},
  [54] = {.index = 120, .length = 4},
  [55] = {.index = 124, .length = 4},
  [56] = {.index = 128, .length = 3},
  [57] = {.index = 131, .length = 3},
  [59] = {.index = 134, .length = 2},
  [60] = {.index = 136, .length = 2},
  [61] = {.index = 138, .length = 1},
  [62] = {.index = 139, .length = 1},
  [63] = {.index = 140, .length = 2},
  [64] = {.index = 142, .length = 3},
  [65] = {.index = 145, .length = 3},
  [66] = {.index = 148, .length = 4},
  [68] = {.index = 152, .length = 2},
  [69] = {.index = 154, .length = 2},
  [70] = {.index = 156, .length = 1},
  [71] = {.index = 157, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 0, .inherited = true},
    {field_setget, 0, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_value, 0, .inherited = true},
  [4] =
    {field_name, 1},
  [5] =
    {field_name, 1, .inherited = true},
    {field_setget, 1, .inherited = true},
    {field_type, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [9] =
    {field_body, 1},
  [10] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [12] =
    {field_name, 1},
    {field_type, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [15] =
    {field_type, 0, .inherited = true},
    {field_value, 0, .inherited = true},
  [17] =
    {field_get, 0, .inherited = true},
    {field_set, 0, .inherited = true},
  [19] =
    {field_name, 1},
    {field_setget, 2},
  [21] =
    {field_name, 2, .inherited = true},
    {field_setget, 2, .inherited = true},
    {field_type, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [25] =
    {field_export_arguments, 1},
    {field_name, 2, .inherited = true},
    {field_setget, 2, .inherited = true},
    {field_type, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [30] =
    {field_left, 0},
  [31] =
    {field_body, 2},
    {field_name, 1},
  [33] =
    {field_name, 2},
  [34] =
    {field_left, 0},
    {field_right, 2},
  [36] =
    {field_type, 1},
  [37] =
    {field_value, 1},
  [38] =
    {field_type, 0},
    {field_value, 1},
  [40] =
    {field_name, 1},
    {field_setget, 3},
    {field_value, 2, .inherited = true},
  [43] =
    {field_name, 1},
    {field_setget, 3},
    {field_type, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [47] =
    {field_export_arguments, 1},
    {field_name, 3, .inherited = true},
    {field_setget, 3, .inherited = true},
    {field_type, 3, .inherited = true},
    {field_value, 3, .inherited = true},
  [52] =
    {field_icon_path, 3},
  [53] =
    {field_body, 3},
    {field_condition, 1},
  [55] =
    {field_body, 3},
    {field_name, 1},
  [57] =
    {field_key, 0},
    {field_value, 2},
  [59] =
    {field_body, 3},
    {field_value, 1},
  [61] =
    {field_body, 3},
    {field_parameters, 1},
  [63] =
    {field_return_type, 1},
  [64] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [66] =
    {field_name, 2},
    {field_type, 3, .inherited = true},
    {field_value, 3, .inherited = true},
  [69] =
    {field_name, 2},
    {field_setget, 3},
  [71] =
    {field_body, 4},
    {field_parameters, 2},
  [73] =
    {field_alternative, 0},
  [74] =
    {field_alternative, 4},
    {field_body, 3},
    {field_condition, 1},
  [77] =
    {field_alternative, 4, .inherited = true},
    {field_body, 3},
    {field_condition, 1},
  [80] =
    {field_body, 4},
    {field_extends, 2},
    {field_name, 1},
  [83] =
    {field_type, 2},
  [84] =
    {field_value, 2},
  [85] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
  [88] =
    {field_body, 4},
    {field_parameters, 1},
    {field_return_type, 2, .inherited = true},
  [91] =
    {field_name, 2},
    {field_setget, 4},
    {field_value, 3, .inherited = true},
  [94] =
    {field_name, 2},
    {field_setget, 4},
    {field_type, 3, .inherited = true},
    {field_value, 3, .inherited = true},
  [98] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
  [101] =
    {field_body, 5},
    {field_parameters, 2},
    {field_return_type, 3, .inherited = true},
  [104] =
    {field_body, 5},
    {field_parameters, 3},
  [106] =
    {field_set, 2},
  [107] =
    {field_get, 2},
  [108] =
    {field_type, 1},
    {field_value, 3},
  [110] =
    {field_return_type, 2, .inherited = true},
  [111] =
    {field_alternative, 4, .inherited = true},
    {field_alternative, 5},
    {field_body, 3},
    {field_condition, 1},
  [115] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [117] =
    {field_body, 5},
    {field_left, 1},
    {field_right, 3},
  [120] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 3, .inherited = true},
  [124] =
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 4, .inherited = true},
  [128] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 4},
  [131] =
    {field_body, 6},
    {field_parameters, 3},
    {field_return_type, 4, .inherited = true},
  [134] =
    {field_get, 3},
    {field_set, 2},
  [136] =
    {field_get, 2},
    {field_set, 3},
  [138] =
    {field_return_type, 3, .inherited = true},
  [139] =
    {field_body, 2},
  [140] =
    {field_type, 2},
    {field_value, 4},
  [142] =
    {field_body, 6},
    {field_constructor_arguments, 4},
    {field_parameters, 2},
  [145] =
    {field_body, 6},
    {field_parameters, 2},
    {field_return_type, 4},
  [148] =
    {field_body, 7},
    {field_name, 3},
    {field_parameters, 4},
    {field_return_type, 5, .inherited = true},
  [152] =
    {field_get, 4, .inherited = true},
    {field_set, 2, .inherited = true},
  [154] =
    {field_get, 2, .inherited = true},
    {field_set, 4, .inherited = true},
  [156] =
    {field_body, 3},
  [157] =
    {field_body, 8},
    {field_constructor_arguments, 4},
    {field_parameters, 2},
    {field_return_type, 6},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [2] = {
    [1] = anon_alias_sym_value,
  },
  [58] = {
    [2] = anon_alias_sym_body,
  },
  [67] = {
    [3] = anon_alias_sym_body,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_string, 2,
    sym_string,
    anon_alias_sym_value,
  sym_body, 2,
    sym_body,
    anon_alias_sym_body,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 2,
  [5] = 5,
  [6] = 2,
  [7] = 5,
  [8] = 2,
  [9] = 5,
  [10] = 5,
  [11] = 5,
  [12] = 5,
  [13] = 2,
  [14] = 2,
  [15] = 5,
  [16] = 16,
  [17] = 5,
  [18] = 2,
  [19] = 2,
  [20] = 5,
  [21] = 5,
  [22] = 2,
  [23] = 23,
  [24] = 16,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 32,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 29,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 42,
  [44] = 44,
  [45] = 39,
  [46] = 46,
  [47] = 47,
  [48] = 26,
  [49] = 25,
  [50] = 36,
  [51] = 46,
  [52] = 52,
  [53] = 34,
  [54] = 54,
  [55] = 30,
  [56] = 30,
  [57] = 57,
  [58] = 36,
  [59] = 35,
  [60] = 60,
  [61] = 60,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 25,
  [67] = 64,
  [68] = 36,
  [69] = 69,
  [70] = 69,
  [71] = 71,
  [72] = 71,
  [73] = 36,
  [74] = 25,
  [75] = 26,
  [76] = 76,
  [77] = 76,
  [78] = 65,
  [79] = 30,
  [80] = 47,
  [81] = 54,
  [82] = 28,
  [83] = 62,
  [84] = 30,
  [85] = 85,
  [86] = 38,
  [87] = 63,
  [88] = 26,
  [89] = 52,
  [90] = 26,
  [91] = 36,
  [92] = 27,
  [93] = 25,
  [94] = 26,
  [95] = 85,
  [96] = 40,
  [97] = 30,
  [98] = 25,
  [99] = 99,
  [100] = 99,
  [101] = 101,
  [102] = 99,
  [103] = 101,
  [104] = 99,
  [105] = 99,
  [106] = 101,
  [107] = 101,
  [108] = 99,
  [109] = 101,
  [110] = 99,
  [111] = 101,
  [112] = 101,
  [113] = 101,
  [114] = 101,
  [115] = 99,
  [116] = 99,
  [117] = 99,
  [118] = 101,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 120,
  [124] = 121,
  [125] = 122,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 132,
  [135] = 130,
  [136] = 133,
  [137] = 127,
  [138] = 131,
  [139] = 126,
  [140] = 129,
  [141] = 128,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 165,
  [173] = 162,
  [174] = 158,
  [175] = 163,
  [176] = 159,
  [177] = 164,
  [178] = 155,
  [179] = 166,
  [180] = 157,
  [181] = 170,
  [182] = 154,
  [183] = 142,
  [184] = 160,
  [185] = 143,
  [186] = 156,
  [187] = 168,
  [188] = 146,
  [189] = 161,
  [190] = 169,
  [191] = 145,
  [192] = 144,
  [193] = 153,
  [194] = 148,
  [195] = 171,
  [196] = 149,
  [197] = 167,
  [198] = 150,
  [199] = 151,
  [200] = 152,
  [201] = 147,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 216,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 227,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 227,
  [236] = 225,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 226,
  [242] = 225,
  [243] = 226,
  [244] = 225,
  [245] = 245,
  [246] = 227,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 225,
  [253] = 225,
  [254] = 254,
  [255] = 226,
  [256] = 256,
  [257] = 226,
  [258] = 258,
  [259] = 227,
  [260] = 227,
  [261] = 226,
  [262] = 262,
  [263] = 225,
  [264] = 264,
  [265] = 226,
  [266] = 227,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 269,
  [271] = 271,
  [272] = 267,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 268,
  [277] = 274,
  [278] = 273,
  [279] = 269,
  [280] = 273,
  [281] = 273,
  [282] = 268,
  [283] = 273,
  [284] = 267,
  [285] = 267,
  [286] = 271,
  [287] = 267,
  [288] = 269,
  [289] = 274,
  [290] = 271,
  [291] = 274,
  [292] = 271,
  [293] = 269,
  [294] = 268,
  [295] = 268,
  [296] = 271,
  [297] = 271,
  [298] = 267,
  [299] = 273,
  [300] = 274,
  [301] = 274,
  [302] = 268,
  [303] = 267,
  [304] = 271,
  [305] = 269,
  [306] = 273,
  [307] = 274,
  [308] = 269,
  [309] = 268,
  [310] = 310,
  [311] = 310,
  [312] = 312,
  [313] = 313,
  [314] = 313,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 313,
  [319] = 319,
  [320] = 320,
  [321] = 313,
  [322] = 313,
  [323] = 313,
  [324] = 324,
  [325] = 316,
  [326] = 310,
  [327] = 327,
  [328] = 313,
  [329] = 329,
  [330] = 204,
  [331] = 202,
  [332] = 332,
  [333] = 206,
  [334] = 203,
  [335] = 335,
  [336] = 335,
  [337] = 337,
  [338] = 338,
  [339] = 337,
  [340] = 338,
  [341] = 341,
  [342] = 338,
  [343] = 337,
  [344] = 344,
  [345] = 338,
  [346] = 337,
  [347] = 347,
  [348] = 338,
  [349] = 349,
  [350] = 341,
  [351] = 351,
  [352] = 338,
  [353] = 353,
  [354] = 338,
  [355] = 344,
  [356] = 349,
  [357] = 335,
  [358] = 344,
  [359] = 337,
  [360] = 337,
  [361] = 335,
  [362] = 344,
  [363] = 347,
  [364] = 344,
  [365] = 335,
  [366] = 344,
  [367] = 335,
  [368] = 335,
  [369] = 344,
  [370] = 337,
  [371] = 353,
  [372] = 351,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 376,
  [378] = 376,
  [379] = 376,
  [380] = 376,
  [381] = 376,
  [382] = 374,
  [383] = 375,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 376,
  [395] = 374,
  [396] = 375,
  [397] = 384,
  [398] = 385,
  [399] = 386,
  [400] = 387,
  [401] = 388,
  [402] = 389,
  [403] = 390,
  [404] = 391,
  [405] = 392,
  [406] = 393,
  [407] = 393,
  [408] = 375,
  [409] = 384,
  [410] = 393,
  [411] = 385,
  [412] = 392,
  [413] = 391,
  [414] = 390,
  [415] = 389,
  [416] = 388,
  [417] = 387,
  [418] = 386,
  [419] = 385,
  [420] = 384,
  [421] = 393,
  [422] = 386,
  [423] = 387,
  [424] = 374,
  [425] = 393,
  [426] = 388,
  [427] = 392,
  [428] = 391,
  [429] = 390,
  [430] = 389,
  [431] = 388,
  [432] = 387,
  [433] = 386,
  [434] = 385,
  [435] = 384,
  [436] = 375,
  [437] = 374,
  [438] = 389,
  [439] = 390,
  [440] = 391,
  [441] = 392,
  [442] = 391,
  [443] = 390,
  [444] = 389,
  [445] = 388,
  [446] = 387,
  [447] = 386,
  [448] = 205,
  [449] = 385,
  [450] = 384,
  [451] = 374,
  [452] = 375,
  [453] = 393,
  [454] = 392,
  [455] = 392,
  [456] = 391,
  [457] = 390,
  [458] = 389,
  [459] = 388,
  [460] = 387,
  [461] = 386,
  [462] = 385,
  [463] = 384,
  [464] = 375,
  [465] = 374,
  [466] = 205,
  [467] = 217,
  [468] = 215,
  [469] = 223,
  [470] = 223,
  [471] = 216,
  [472] = 215,
  [473] = 222,
  [474] = 214,
  [475] = 213,
  [476] = 207,
  [477] = 210,
  [478] = 209,
  [479] = 208,
  [480] = 220,
  [481] = 212,
  [482] = 221,
  [483] = 218,
  [484] = 222,
  [485] = 205,
  [486] = 216,
  [487] = 216,
  [488] = 215,
  [489] = 223,
  [490] = 216,
  [491] = 217,
  [492] = 222,
  [493] = 218,
  [494] = 221,
  [495] = 212,
  [496] = 220,
  [497] = 208,
  [498] = 209,
  [499] = 214,
  [500] = 210,
  [501] = 207,
  [502] = 217,
  [503] = 213,
  [504] = 214,
  [505] = 213,
  [506] = 207,
  [507] = 210,
  [508] = 209,
  [509] = 208,
  [510] = 220,
  [511] = 212,
  [512] = 214,
  [513] = 217,
  [514] = 221,
  [515] = 213,
  [516] = 218,
  [517] = 216,
  [518] = 207,
  [519] = 210,
  [520] = 209,
  [521] = 208,
  [522] = 220,
  [523] = 212,
  [524] = 221,
  [525] = 218,
  [526] = 222,
  [527] = 216,
  [528] = 223,
  [529] = 215,
  [530] = 216,
  [531] = 216,
  [532] = 213,
  [533] = 230,
  [534] = 237,
  [535] = 240,
  [536] = 228,
  [537] = 233,
  [538] = 224,
  [539] = 258,
  [540] = 239,
  [541] = 238,
  [542] = 228,
  [543] = 239,
  [544] = 238,
  [545] = 248,
  [546] = 546,
  [547] = 216,
  [548] = 251,
  [549] = 256,
  [550] = 222,
  [551] = 204,
  [552] = 264,
  [553] = 218,
  [554] = 221,
  [555] = 212,
  [556] = 220,
  [557] = 262,
  [558] = 208,
  [559] = 209,
  [560] = 245,
  [561] = 210,
  [562] = 207,
  [563] = 213,
  [564] = 214,
  [565] = 216,
  [566] = 217,
  [567] = 254,
  [568] = 249,
  [569] = 216,
  [570] = 247,
  [571] = 237,
  [572] = 230,
  [573] = 233,
  [574] = 216,
  [575] = 234,
  [576] = 206,
  [577] = 245,
  [578] = 262,
  [579] = 202,
  [580] = 258,
  [581] = 224,
  [582] = 256,
  [583] = 250,
  [584] = 203,
  [585] = 232,
  [586] = 248,
  [587] = 231,
  [588] = 231,
  [589] = 234,
  [590] = 230,
  [591] = 247,
  [592] = 249,
  [593] = 254,
  [594] = 264,
  [595] = 204,
  [596] = 251,
  [597] = 251,
  [598] = 248,
  [599] = 232,
  [600] = 264,
  [601] = 203,
  [602] = 223,
  [603] = 228,
  [604] = 240,
  [605] = 239,
  [606] = 238,
  [607] = 237,
  [608] = 250,
  [609] = 205,
  [610] = 233,
  [611] = 231,
  [612] = 233,
  [613] = 237,
  [614] = 256,
  [615] = 224,
  [616] = 238,
  [617] = 239,
  [618] = 258,
  [619] = 215,
  [620] = 202,
  [621] = 262,
  [622] = 240,
  [623] = 228,
  [624] = 250,
  [625] = 245,
  [626] = 206,
  [627] = 234,
  [628] = 222,
  [629] = 234,
  [630] = 215,
  [631] = 206,
  [632] = 218,
  [633] = 223,
  [634] = 221,
  [635] = 245,
  [636] = 262,
  [637] = 248,
  [638] = 202,
  [639] = 212,
  [640] = 258,
  [641] = 251,
  [642] = 204,
  [643] = 220,
  [644] = 264,
  [645] = 254,
  [646] = 249,
  [647] = 208,
  [648] = 247,
  [649] = 232,
  [650] = 230,
  [651] = 224,
  [652] = 209,
  [653] = 240,
  [654] = 210,
  [655] = 247,
  [656] = 249,
  [657] = 254,
  [658] = 207,
  [659] = 231,
  [660] = 256,
  [661] = 214,
  [662] = 232,
  [663] = 250,
  [664] = 217,
  [665] = 203,
  [666] = 224,
  [667] = 205,
  [668] = 230,
  [669] = 234,
  [670] = 254,
  [671] = 264,
  [672] = 206,
  [673] = 245,
  [674] = 204,
  [675] = 262,
  [676] = 251,
  [677] = 202,
  [678] = 231,
  [679] = 248,
  [680] = 258,
  [681] = 232,
  [682] = 203,
  [683] = 228,
  [684] = 240,
  [685] = 239,
  [686] = 238,
  [687] = 250,
  [688] = 237,
  [689] = 256,
  [690] = 224,
  [691] = 233,
  [692] = 249,
  [693] = 249,
  [694] = 203,
  [695] = 205,
  [696] = 233,
  [697] = 262,
  [698] = 245,
  [699] = 237,
  [700] = 206,
  [701] = 234,
  [702] = 238,
  [703] = 239,
  [704] = 258,
  [705] = 256,
  [706] = 250,
  [707] = 240,
  [708] = 228,
  [709] = 202,
  [710] = 247,
  [711] = 232,
  [712] = 231,
  [713] = 230,
  [714] = 247,
  [715] = 251,
  [716] = 254,
  [717] = 264,
  [718] = 204,
  [719] = 248,
  [720] = 720,
  [721] = 721,
  [722] = 722,
  [723] = 723,
  [724] = 724,
  [725] = 725,
  [726] = 726,
  [727] = 727,
  [728] = 726,
  [729] = 726,
  [730] = 726,
  [731] = 726,
  [732] = 725,
  [733] = 726,
  [734] = 726,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 737,
  [740] = 738,
  [741] = 738,
  [742] = 742,
  [743] = 743,
  [744] = 744,
  [745] = 745,
  [746] = 746,
  [747] = 747,
  [748] = 748,
  [749] = 749,
  [750] = 750,
  [751] = 751,
  [752] = 752,
  [753] = 720,
  [754] = 720,
  [755] = 131,
  [756] = 132,
  [757] = 130,
  [758] = 721,
  [759] = 128,
  [760] = 720,
  [761] = 761,
  [762] = 720,
  [763] = 721,
  [764] = 129,
  [765] = 133,
  [766] = 721,
  [767] = 767,
  [768] = 721,
  [769] = 720,
  [770] = 721,
  [771] = 721,
  [772] = 720,
  [773] = 773,
  [774] = 773,
  [775] = 773,
  [776] = 776,
  [777] = 777,
  [778] = 778,
  [779] = 773,
  [780] = 773,
  [781] = 773,
  [782] = 773,
  [783] = 773,
  [784] = 773,
  [785] = 773,
  [786] = 786,
  [787] = 787,
  [788] = 788,
  [789] = 789,
  [790] = 790,
  [791] = 789,
  [792] = 792,
  [793] = 793,
  [794] = 794,
  [795] = 795,
  [796] = 792,
  [797] = 787,
  [798] = 798,
  [799] = 799,
  [800] = 800,
  [801] = 790,
  [802] = 802,
  [803] = 803,
  [804] = 804,
  [805] = 805,
  [806] = 806,
  [807] = 807,
  [808] = 808,
  [809] = 809,
  [810] = 810,
  [811] = 811,
  [812] = 812,
  [813] = 776,
  [814] = 814,
  [815] = 815,
  [816] = 816,
  [817] = 812,
  [818] = 818,
  [819] = 819,
  [820] = 820,
  [821] = 821,
  [822] = 822,
  [823] = 128,
  [824] = 778,
  [825] = 825,
  [826] = 133,
  [827] = 132,
  [828] = 777,
  [829] = 129,
  [830] = 830,
  [831] = 821,
  [832] = 815,
  [833] = 833,
  [834] = 834,
  [835] = 131,
  [836] = 836,
  [837] = 837,
  [838] = 838,
  [839] = 130,
  [840] = 840,
  [841] = 841,
  [842] = 842,
  [843] = 843,
  [844] = 844,
  [845] = 845,
  [846] = 840,
  [847] = 847,
  [848] = 843,
  [849] = 849,
  [850] = 843,
  [851] = 851,
  [852] = 852,
  [853] = 853,
  [854] = 854,
  [855] = 855,
  [856] = 843,
  [857] = 842,
  [858] = 844,
  [859] = 847,
  [860] = 849,
  [861] = 842,
  [862] = 840,
  [863] = 843,
  [864] = 840,
  [865] = 842,
  [866] = 844,
  [867] = 840,
  [868] = 868,
  [869] = 847,
  [870] = 868,
  [871] = 841,
  [872] = 842,
  [873] = 844,
  [874] = 844,
  [875] = 842,
  [876] = 840,
  [877] = 877,
  [878] = 847,
  [879] = 841,
  [880] = 841,
  [881] = 855,
  [882] = 882,
  [883] = 841,
  [884] = 847,
  [885] = 840,
  [886] = 844,
  [887] = 842,
  [888] = 841,
  [889] = 843,
  [890] = 890,
  [891] = 842,
  [892] = 840,
  [893] = 847,
  [894] = 894,
  [895] = 844,
  [896] = 841,
  [897] = 853,
  [898] = 776,
  [899] = 840,
  [900] = 842,
  [901] = 847,
  [902] = 844,
  [903] = 842,
  [904] = 904,
  [905] = 851,
  [906] = 906,
  [907] = 840,
  [908] = 847,
  [909] = 909,
  [910] = 830,
  [911] = 911,
  [912] = 912,
  [913] = 913,
  [914] = 743,
  [915] = 915,
  [916] = 916,
  [917] = 917,
  [918] = 918,
  [919] = 816,
  [920] = 920,
  [921] = 921,
  [922] = 743,
  [923] = 793,
  [924] = 924,
  [925] = 925,
  [926] = 810,
  [927] = 927,
  [928] = 744,
  [929] = 929,
  [930] = 930,
  [931] = 931,
  [932] = 744,
  [933] = 933,
  [934] = 934,
  [935] = 935,
  [936] = 936,
  [937] = 937,
  [938] = 938,
  [939] = 743,
  [940] = 915,
  [941] = 941,
  [942] = 942,
  [943] = 917,
  [944] = 944,
  [945] = 918,
  [946] = 918,
  [947] = 947,
  [948] = 948,
  [949] = 917,
  [950] = 950,
  [951] = 951,
  [952] = 952,
  [953] = 953,
  [954] = 937,
  [955] = 955,
  [956] = 956,
  [957] = 957,
  [958] = 933,
  [959] = 935,
  [960] = 960,
  [961] = 938,
  [962] = 962,
  [963] = 915,
  [964] = 917,
  [965] = 918,
  [966] = 966,
  [967] = 967,
  [968] = 968,
  [969] = 807,
  [970] = 970,
  [971] = 971,
  [972] = 130,
  [973] = 973,
  [974] = 974,
  [975] = 938,
  [976] = 976,
  [977] = 977,
  [978] = 978,
  [979] = 933,
  [980] = 129,
  [981] = 935,
  [982] = 982,
  [983] = 746,
  [984] = 984,
  [985] = 131,
  [986] = 986,
  [987] = 987,
  [988] = 933,
  [989] = 132,
  [990] = 933,
  [991] = 935,
  [992] = 128,
  [993] = 133,
  [994] = 994,
  [995] = 938,
  [996] = 996,
  [997] = 997,
  [998] = 951,
  [999] = 915,
  [1000] = 917,
  [1001] = 918,
  [1002] = 1002,
  [1003] = 1003,
  [1004] = 1004,
  [1005] = 1005,
  [1006] = 744,
  [1007] = 937,
  [1008] = 1008,
  [1009] = 1009,
  [1010] = 925,
  [1011] = 1011,
  [1012] = 1012,
  [1013] = 1013,
  [1014] = 1014,
  [1015] = 1015,
  [1016] = 1016,
  [1017] = 1017,
  [1018] = 810,
  [1019] = 1019,
  [1020] = 1020,
  [1021] = 1021,
  [1022] = 746,
  [1023] = 931,
  [1024] = 934,
  [1025] = 942,
  [1026] = 1026,
  [1027] = 936,
  [1028] = 962,
  [1029] = 960,
  [1030] = 918,
  [1031] = 917,
  [1032] = 952,
  [1033] = 793,
  [1034] = 915,
  [1035] = 746,
  [1036] = 1036,
  [1037] = 1037,
  [1038] = 1038,
  [1039] = 938,
  [1040] = 1040,
  [1041] = 935,
  [1042] = 1040,
  [1043] = 1038,
  [1044] = 1036,
  [1045] = 1009,
  [1046] = 987,
  [1047] = 929,
  [1048] = 913,
  [1049] = 933,
  [1050] = 970,
  [1051] = 935,
  [1052] = 951,
  [1053] = 956,
  [1054] = 938,
  [1055] = 819,
  [1056] = 1002,
  [1057] = 1057,
  [1058] = 1037,
  [1059] = 1059,
  [1060] = 911,
  [1061] = 746,
  [1062] = 937,
  [1063] = 1063,
  [1064] = 984,
  [1065] = 1057,
  [1066] = 960,
  [1067] = 962,
  [1068] = 942,
  [1069] = 931,
  [1070] = 951,
  [1071] = 1071,
  [1072] = 1072,
  [1073] = 937,
  [1074] = 982,
  [1075] = 1075,
  [1076] = 743,
  [1077] = 951,
  [1078] = 937,
  [1079] = 918,
  [1080] = 917,
  [1081] = 915,
  [1082] = 1082,
  [1083] = 951,
  [1084] = 938,
  [1085] = 935,
  [1086] = 1086,
  [1087] = 933,
  [1088] = 810,
  [1089] = 1089,
  [1090] = 1090,
  [1091] = 1091,
  [1092] = 744,
  [1093] = 915,
  [1094] = 1094,
  [1095] = 1095,
  [1096] = 1096,
  [1097] = 1097,
  [1098] = 129,
  [1099] = 1099,
  [1100] = 1100,
  [1101] = 132,
  [1102] = 1102,
  [1103] = 1103,
  [1104] = 1104,
  [1105] = 1105,
  [1106] = 1106,
  [1107] = 1107,
  [1108] = 1097,
  [1109] = 1109,
  [1110] = 1110,
  [1111] = 1110,
  [1112] = 894,
  [1113] = 1113,
  [1114] = 1114,
  [1115] = 1115,
  [1116] = 1110,
  [1117] = 1110,
  [1118] = 1104,
  [1119] = 1109,
  [1120] = 810,
  [1121] = 1110,
  [1122] = 1122,
  [1123] = 1123,
  [1124] = 1124,
  [1125] = 1125,
  [1126] = 1110,
  [1127] = 1114,
  [1128] = 1128,
  [1129] = 1129,
  [1130] = 1107,
  [1131] = 746,
  [1132] = 1132,
  [1133] = 129,
  [1134] = 1103,
  [1135] = 1135,
  [1136] = 1136,
  [1137] = 1097,
  [1138] = 1104,
  [1139] = 1139,
  [1140] = 1140,
  [1141] = 1109,
  [1142] = 1140,
  [1143] = 1143,
  [1144] = 1144,
  [1145] = 1103,
  [1146] = 1140,
  [1147] = 128,
  [1148] = 1148,
  [1149] = 1149,
  [1150] = 1097,
  [1151] = 1151,
  [1152] = 1152,
  [1153] = 130,
  [1154] = 133,
  [1155] = 128,
  [1156] = 132,
  [1157] = 131,
  [1158] = 129,
  [1159] = 130,
  [1160] = 1104,
  [1161] = 1109,
  [1162] = 251,
  [1163] = 1163,
  [1164] = 238,
  [1165] = 1165,
  [1166] = 205,
  [1167] = 1167,
  [1168] = 1168,
  [1169] = 1129,
  [1170] = 1170,
  [1171] = 1171,
  [1172] = 1172,
  [1173] = 1173,
  [1174] = 1170,
  [1175] = 1140,
  [1176] = 1176,
  [1177] = 1177,
  [1178] = 1151,
  [1179] = 1179,
  [1180] = 1103,
  [1181] = 1181,
  [1182] = 133,
  [1183] = 1179,
  [1184] = 1184,
  [1185] = 1097,
  [1186] = 1186,
  [1187] = 1187,
  [1188] = 1129,
  [1189] = 1123,
  [1190] = 1163,
  [1191] = 1191,
  [1192] = 1122,
  [1193] = 1193,
  [1194] = 1129,
  [1195] = 1104,
  [1196] = 1109,
  [1197] = 1197,
  [1198] = 1198,
  [1199] = 1199,
  [1200] = 1200,
  [1201] = 1128,
  [1202] = 1106,
  [1203] = 1203,
  [1204] = 1204,
  [1205] = 1205,
  [1206] = 133,
  [1207] = 1163,
  [1208] = 1125,
  [1209] = 743,
  [1210] = 1140,
  [1211] = 128,
  [1212] = 1212,
  [1213] = 1213,
  [1214] = 1214,
  [1215] = 1103,
  [1216] = 1216,
  [1217] = 1129,
  [1218] = 1163,
  [1219] = 1163,
  [1220] = 1097,
  [1221] = 810,
  [1222] = 1222,
  [1223] = 776,
  [1224] = 1216,
  [1225] = 744,
  [1226] = 1136,
  [1227] = 1102,
  [1228] = 1222,
  [1229] = 1229,
  [1230] = 1104,
  [1231] = 1109,
  [1232] = 132,
  [1233] = 1199,
  [1234] = 1234,
  [1235] = 1135,
  [1236] = 1236,
  [1237] = 1163,
  [1238] = 818,
  [1239] = 131,
  [1240] = 825,
  [1241] = 131,
  [1242] = 1181,
  [1243] = 822,
  [1244] = 746,
  [1245] = 1140,
  [1246] = 1140,
  [1247] = 834,
  [1248] = 1113,
  [1249] = 1144,
  [1250] = 1103,
  [1251] = 1167,
  [1252] = 1107,
  [1253] = 130,
  [1254] = 834,
  [1255] = 1097,
  [1256] = 1172,
  [1257] = 906,
  [1258] = 1148,
  [1259] = 1129,
  [1260] = 1149,
  [1261] = 1261,
  [1262] = 1199,
  [1263] = 1176,
  [1264] = 1264,
  [1265] = 1104,
  [1266] = 1109,
  [1267] = 822,
  [1268] = 825,
  [1269] = 1229,
  [1270] = 1165,
  [1271] = 818,
  [1272] = 1272,
  [1273] = 834,
  [1274] = 1229,
  [1275] = 1203,
  [1276] = 1167,
  [1277] = 1129,
  [1278] = 1103,
  [1279] = 1279,
  [1280] = 1204,
  [1281] = 1213,
  [1282] = 1222,
  [1283] = 1115,
  [1284] = 1284,
  [1285] = 743,
  [1286] = 822,
  [1287] = 1103,
  [1288] = 825,
  [1289] = 1289,
  [1290] = 1234,
  [1291] = 1172,
  [1292] = 1103,
  [1293] = 1170,
  [1294] = 744,
  [1295] = 1103,
  [1296] = 1236,
  [1297] = 1179,
  [1298] = 818,
  [1299] = 1099,
  [1300] = 1300,
  [1301] = 1103,
  [1302] = 1103,
  [1303] = 1103,
  [1304] = 1103,
  [1305] = 1163,
  [1306] = 1216,
  [1307] = 1307,
  [1308] = 132,
  [1309] = 131,
  [1310] = 1310,
  [1311] = 1311,
  [1312] = 1312,
  [1313] = 129,
  [1314] = 1314,
  [1315] = 1315,
  [1316] = 128,
  [1317] = 1317,
  [1318] = 1016,
  [1319] = 131,
  [1320] = 1320,
  [1321] = 818,
  [1322] = 130,
  [1323] = 904,
  [1324] = 1324,
  [1325] = 129,
  [1326] = 904,
  [1327] = 1327,
  [1328] = 950,
  [1329] = 1314,
  [1330] = 133,
  [1331] = 1331,
  [1332] = 1332,
  [1333] = 1333,
  [1334] = 1324,
  [1335] = 1016,
  [1336] = 1327,
  [1337] = 1337,
  [1338] = 1324,
  [1339] = 132,
  [1340] = 1314,
  [1341] = 1341,
  [1342] = 1342,
  [1343] = 1343,
  [1344] = 818,
  [1345] = 1345,
  [1346] = 130,
  [1347] = 1324,
  [1348] = 1327,
  [1349] = 1314,
  [1350] = 1350,
  [1351] = 834,
  [1352] = 1352,
  [1353] = 1353,
  [1354] = 1345,
  [1355] = 1355,
  [1356] = 1324,
  [1357] = 1352,
  [1358] = 1314,
  [1359] = 1359,
  [1360] = 1327,
  [1361] = 1361,
  [1362] = 1362,
  [1363] = 1363,
  [1364] = 128,
  [1365] = 1324,
  [1366] = 133,
  [1367] = 1314,
  [1368] = 1368,
  [1369] = 1327,
  [1370] = 825,
  [1371] = 822,
  [1372] = 1372,
  [1373] = 1373,
  [1374] = 834,
  [1375] = 1327,
  [1376] = 1376,
  [1377] = 1312,
  [1378] = 822,
  [1379] = 1310,
  [1380] = 1380,
  [1381] = 1333,
  [1382] = 1372,
  [1383] = 1331,
  [1384] = 825,
  [1385] = 1355,
  [1386] = 1386,
  [1387] = 1311,
  [1388] = 1380,
  [1389] = 1327,
  [1390] = 927,
  [1391] = 1391,
  [1392] = 1307,
  [1393] = 1386,
  [1394] = 1391,
  [1395] = 1376,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(52);
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '#') ADVANCE(54);
      if (lookahead == '%') ADVANCE(103);
      if (lookahead == '&') ADVANCE(70);
      if (lookahead == '(') ADVANCE(124);
      if (lookahead == ')') ADVANCE(125);
      if (lookahead == '*') ADVANCE(99);
      if (lookahead == '+') ADVANCE(94);
      if (lookahead == ',') ADVANCE(83);
      if (lookahead == '-') ADVANCE(96);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '/') ADVANCE(101);
      if (lookahead == '0') ADVANCE(64);
      if (lookahead == ':') ADVANCE(80);
      if (lookahead == ';') ADVANCE(75);
      if (lookahead == '<') ADVANCE(116);
      if (lookahead == '=') ADVANCE(82);
      if (lookahead == '>') ADVANCE(122);
      if (lookahead == '@') ADVANCE(77);
      if (lookahead == '[') ADVANCE(89);
      if (lookahead == '\\') SKIP(48)
      if (lookahead == ']') ADVANCE(90);
      if (lookahead == '^') ADVANCE(107);
      if (lookahead == '{') ADVANCE(86);
      if (lookahead == '|') ADVANCE(104);
      if (lookahead == '}') ADVANCE(87);
      if (lookahead == '~') ADVANCE(115);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(63);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(53);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(8)
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(8)
      if (lookahead == '\r') SKIP(1)
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(9)
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(9)
      if (lookahead == '\r') SKIP(3)
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(57);
      if (lookahead == '\r') ADVANCE(56);
      if (lookahead == 'U') ADVANCE(58);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'u') ADVANCE(44);
      if (lookahead == 'x') ADVANCE(42);
      if (lookahead != 0) ADVANCE(55);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(15)
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(15)
      if (lookahead == '\r') SKIP(6)
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(20);
      if (lookahead == '#') ADVANCE(54);
      if (lookahead == '%') ADVANCE(103);
      if (lookahead == '&') ADVANCE(70);
      if (lookahead == '(') ADVANCE(124);
      if (lookahead == ')') ADVANCE(125);
      if (lookahead == '*') ADVANCE(99);
      if (lookahead == '+') ADVANCE(94);
      if (lookahead == ',') ADVANCE(83);
      if (lookahead == '-') ADVANCE(95);
      if (lookahead == '.') ADVANCE(84);
      if (lookahead == '/') ADVANCE(101);
      if (lookahead == ':') ADVANCE(79);
      if (lookahead == ';') ADVANCE(75);
      if (lookahead == '<') ADVANCE(116);
      if (lookahead == '=') ADVANCE(82);
      if (lookahead == '>') ADVANCE(122);
      if (lookahead == '@') ADVANCE(76);
      if (lookahead == '[') ADVANCE(89);
      if (lookahead == '\\') SKIP(2)
      if (lookahead == ']') ADVANCE(90);
      if (lookahead == '^') ADVANCE(108);
      if (lookahead == '|') ADVANCE(104);
      if (lookahead == '}') ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(8)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(53);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(20);
      if (lookahead == '#') ADVANCE(54);
      if (lookahead == '%') ADVANCE(102);
      if (lookahead == '&') ADVANCE(69);
      if (lookahead == '(') ADVANCE(124);
      if (lookahead == '*') ADVANCE(98);
      if (lookahead == '+') ADVANCE(93);
      if (lookahead == '-') ADVANCE(97);
      if (lookahead == '.') ADVANCE(84);
      if (lookahead == '/') ADVANCE(100);
      if (lookahead == ':') ADVANCE(79);
      if (lookahead == '<') ADVANCE(117);
      if (lookahead == '=') ADVANCE(23);
      if (lookahead == '>') ADVANCE(123);
      if (lookahead == '@') ADVANCE(76);
      if (lookahead == '[') ADVANCE(89);
      if (lookahead == '\\') SKIP(4)
      if (lookahead == '^') ADVANCE(106);
      if (lookahead == '|') ADVANCE(105);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(9)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(53);
      END_STATE();
    case 10:
      if (lookahead == '"') ADVANCE(11);
      if (lookahead == '\'') ADVANCE(17);
      if (lookahead == '=') ADVANCE(134);
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(72);
      if (lookahead == ' ' ||
          ('-' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(11);
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(73);
      if (lookahead == ' ' ||
          ('-' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(12);
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(12);
      if (lookahead == '\'') ADVANCE(18);
      if (lookahead == '=') ADVANCE(130);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(74);
      END_STATE();
    case 14:
      if (lookahead == '"') ADVANCE(12);
      if (lookahead == '\'') ADVANCE(18);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(74);
      END_STATE();
    case 15:
      if (lookahead == '#') ADVANCE(54);
      if (lookahead == '-') ADVANCE(27);
      if (lookahead == '.') ADVANCE(84);
      if (lookahead == ':') ADVANCE(79);
      if (lookahead == '\\') SKIP(7)
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(15)
      END_STATE();
    case 16:
      if (lookahead == '#') ADVANCE(54);
      if (lookahead == '\\') ADVANCE(5);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      END_STATE();
    case 17:
      if (lookahead == '\'') ADVANCE(72);
      if (lookahead == ' ' ||
          ('-' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(17);
      END_STATE();
    case 18:
      if (lookahead == '\'') ADVANCE(73);
      if (lookahead == ' ' ||
          ('-' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(18);
      END_STATE();
    case 19:
      if (lookahead == '<') ADVANCE(25);
      END_STATE();
    case 20:
      if (lookahead == '=') ADVANCE(120);
      END_STATE();
    case 21:
      if (lookahead == '=') ADVANCE(128);
      END_STATE();
    case 22:
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 23:
      if (lookahead == '=') ADVANCE(119);
      END_STATE();
    case 24:
      if (lookahead == '=') ADVANCE(135);
      END_STATE();
    case 25:
      if (lookahead == '=') ADVANCE(132);
      END_STATE();
    case 26:
      if (lookahead == '=') ADVANCE(131);
      END_STATE();
    case 27:
      if (lookahead == '>') ADVANCE(136);
      END_STATE();
    case 28:
      if (lookahead == '>') ADVANCE(26);
      END_STATE();
    case 29:
      if (lookahead == '_') ADVANCE(33);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(66);
      END_STATE();
    case 30:
      if (lookahead == '_') ADVANCE(34);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(67);
      END_STATE();
    case 31:
      if (lookahead == '_') ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(68);
      END_STATE();
    case 32:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(60);
      END_STATE();
    case 33:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(66);
      END_STATE();
    case 34:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(67);
      END_STATE();
    case 35:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(60);
      END_STATE();
    case 36:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(55);
      END_STATE();
    case 37:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(36);
      END_STATE();
    case 38:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(37);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(68);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(55);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(42);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(41);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(45);
      END_STATE();
    case 47:
      if (eof) ADVANCE(52);
      if (lookahead == '\n') SKIP(0)
      END_STATE();
    case 48:
      if (eof) ADVANCE(52);
      if (lookahead == '\n') SKIP(0)
      if (lookahead == '\r') SKIP(47)
      END_STATE();
    case 49:
      if (eof) ADVANCE(52);
      if (lookahead == '\n') SKIP(51)
      END_STATE();
    case 50:
      if (eof) ADVANCE(52);
      if (lookahead == '\n') SKIP(51)
      if (lookahead == '\r') SKIP(49)
      END_STATE();
    case 51:
      if (eof) ADVANCE(52);
      if (lookahead == '!') ADVANCE(113);
      if (lookahead == '#') ADVANCE(54);
      if (lookahead == '$') ADVANCE(14);
      if (lookahead == '%') ADVANCE(13);
      if (lookahead == '&') ADVANCE(71);
      if (lookahead == '(') ADVANCE(124);
      if (lookahead == ')') ADVANCE(125);
      if (lookahead == '*') ADVANCE(21);
      if (lookahead == '+') ADVANCE(94);
      if (lookahead == ',') ADVANCE(83);
      if (lookahead == '-') ADVANCE(95);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '0') ADVANCE(64);
      if (lookahead == ':') ADVANCE(79);
      if (lookahead == ';') ADVANCE(75);
      if (lookahead == '<') ADVANCE(19);
      if (lookahead == '=') ADVANCE(81);
      if (lookahead == '>') ADVANCE(28);
      if (lookahead == '@') ADVANCE(77);
      if (lookahead == '[') ADVANCE(89);
      if (lookahead == '\\') SKIP(50)
      if (lookahead == ']') ADVANCE(90);
      if (lookahead == '^') ADVANCE(10);
      if (lookahead == '{') ADVANCE(86);
      if (lookahead == '|') ADVANCE(24);
      if (lookahead == '}') ADVANCE(87);
      if (lookahead == '~') ADVANCE(115);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(51)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(63);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(53);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym__identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(53);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(54);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(57);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(5);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(61);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(32);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(59);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(60);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(32);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(59);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(60);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(61);
      if (lookahead == '_') ADVANCE(65);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(32);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(63);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(61);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(29);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(30);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(31);
      if (lookahead == '_') ADVANCE(65);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(32);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(63);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(61);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(32);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(63);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(33);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(66);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(34);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(67);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(68);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(91);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(91);
      if (lookahead == '=') ADVANCE(133);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '=') ADVANCE(133);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_node_path);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_get_node);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_get_node);
      if (('/' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(74);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '"') ADVANCE(11);
      if (lookahead == '\'') ADVANCE(17);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(78);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(119);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(88);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(59);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_pattern_open_ending);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(126);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(127);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(127);
      if (lookahead == '>') ADVANCE(136);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(136);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(128);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(130);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(135);
      if (lookahead == '|') ADVANCE(92);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(92);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '"') ADVANCE(11);
      if (lookahead == '\'') ADVANCE(17);
      if (lookahead == '=') ADVANCE(134);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(134);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(132);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(131);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(120);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(110);
      if (lookahead == '=') ADVANCE(118);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(109);
      if (lookahead == '=') ADVANCE(118);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(112);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(111);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == '\\') SKIP(1)
      if (lookahead == '_') ADVANCE(2);
      if (lookahead == 'a') ADVANCE(3);
      if (lookahead == 'b') ADVANCE(4);
      if (lookahead == 'c') ADVANCE(5);
      if (lookahead == 'e') ADVANCE(6);
      if (lookahead == 'f') ADVANCE(7);
      if (lookahead == 'g') ADVANCE(8);
      if (lookahead == 'i') ADVANCE(9);
      if (lookahead == 'm') ADVANCE(10);
      if (lookahead == 'n') ADVANCE(11);
      if (lookahead == 'o') ADVANCE(12);
      if (lookahead == 'p') ADVANCE(13);
      if (lookahead == 'r') ADVANCE(14);
      if (lookahead == 's') ADVANCE(15);
      if (lookahead == 't') ADVANCE(16);
      if (lookahead == 'v') ADVANCE(17);
      if (lookahead == 'w') ADVANCE(18);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(0)
      if (lookahead == '\r') SKIP(19)
      END_STATE();
    case 2:
      ACCEPT_TOKEN(sym_underscore);
      if (lookahead == 'i') ADVANCE(20);
      END_STATE();
    case 3:
      if (lookahead == 'n') ADVANCE(21);
      if (lookahead == 's') ADVANCE(22);
      if (lookahead == 'w') ADVANCE(23);
      END_STATE();
    case 4:
      if (lookahead == 'r') ADVANCE(24);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(25);
      if (lookahead == 'o') ADVANCE(26);
      END_STATE();
    case 6:
      if (lookahead == 'l') ADVANCE(27);
      if (lookahead == 'n') ADVANCE(28);
      if (lookahead == 'x') ADVANCE(29);
      END_STATE();
    case 7:
      if (lookahead == 'a') ADVANCE(30);
      if (lookahead == 'o') ADVANCE(31);
      if (lookahead == 'u') ADVANCE(32);
      END_STATE();
    case 8:
      if (lookahead == 'e') ADVANCE(33);
      END_STATE();
    case 9:
      if (lookahead == 'f') ADVANCE(34);
      if (lookahead == 'n') ADVANCE(35);
      if (lookahead == 's') ADVANCE(36);
      END_STATE();
    case 10:
      if (lookahead == 'a') ADVANCE(37);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'u') ADVANCE(39);
      END_STATE();
    case 12:
      if (lookahead == 'n') ADVANCE(40);
      if (lookahead == 'r') ADVANCE(41);
      END_STATE();
    case 13:
      if (lookahead == 'a') ADVANCE(42);
      if (lookahead == 'u') ADVANCE(43);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(44);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(45);
      if (lookahead == 'i') ADVANCE(46);
      if (lookahead == 't') ADVANCE(47);
      END_STATE();
    case 16:
      if (lookahead == 'o') ADVANCE(48);
      if (lookahead == 'r') ADVANCE(49);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(50);
      END_STATE();
    case 18:
      if (lookahead == 'h') ADVANCE(51);
      END_STATE();
    case 19:
      if (lookahead == '\n') SKIP(0)
      END_STATE();
    case 20:
      if (lookahead == 'n') ADVANCE(52);
      END_STATE();
    case 21:
      if (lookahead == 'd') ADVANCE(53);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 23:
      if (lookahead == 'a') ADVANCE(54);
      END_STATE();
    case 24:
      if (lookahead == 'e') ADVANCE(55);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(56);
      END_STATE();
    case 26:
      if (lookahead == 'n') ADVANCE(57);
      END_STATE();
    case 27:
      if (lookahead == 'i') ADVANCE(58);
      if (lookahead == 's') ADVANCE(59);
      END_STATE();
    case 28:
      if (lookahead == 'u') ADVANCE(60);
      END_STATE();
    case 29:
      if (lookahead == 'p') ADVANCE(61);
      if (lookahead == 't') ADVANCE(62);
      END_STATE();
    case 30:
      if (lookahead == 'l') ADVANCE(63);
      END_STATE();
    case 31:
      if (lookahead == 'r') ADVANCE(64);
      END_STATE();
    case 32:
      if (lookahead == 'n') ADVANCE(65);
      END_STATE();
    case 33:
      if (lookahead == 't') ADVANCE(66);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 37:
      if (lookahead == 's') ADVANCE(67);
      if (lookahead == 't') ADVANCE(68);
      END_STATE();
    case 38:
      if (lookahead == 't') ADVANCE(69);
      END_STATE();
    case 39:
      if (lookahead == 'l') ADVANCE(70);
      END_STATE();
    case 40:
      if (lookahead == 'r') ADVANCE(71);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 42:
      if (lookahead == 's') ADVANCE(72);
      END_STATE();
    case 43:
      if (lookahead == 'p') ADVANCE(73);
      END_STATE();
    case 44:
      if (lookahead == 'm') ADVANCE(74);
      if (lookahead == 't') ADVANCE(75);
      END_STATE();
    case 45:
      if (lookahead == 't') ADVANCE(76);
      END_STATE();
    case 46:
      if (lookahead == 'g') ADVANCE(77);
      END_STATE();
    case 47:
      if (lookahead == 'a') ADVANCE(78);
      END_STATE();
    case 48:
      if (lookahead == 'o') ADVANCE(79);
      END_STATE();
    case 49:
      if (lookahead == 'u') ADVANCE(80);
      END_STATE();
    case 50:
      if (lookahead == 'r') ADVANCE(81);
      END_STATE();
    case 51:
      if (lookahead == 'i') ADVANCE(82);
      END_STATE();
    case 52:
      if (lookahead == 'i') ADVANCE(83);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 54:
      if (lookahead == 'i') ADVANCE(84);
      END_STATE();
    case 55:
      if (lookahead == 'a') ADVANCE(85);
      END_STATE();
    case 56:
      if (lookahead == 's') ADVANCE(86);
      END_STATE();
    case 57:
      if (lookahead == 's') ADVANCE(87);
      if (lookahead == 't') ADVANCE(88);
      END_STATE();
    case 58:
      if (lookahead == 'f') ADVANCE(89);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 60:
      if (lookahead == 'm') ADVANCE(91);
      END_STATE();
    case 61:
      if (lookahead == 'o') ADVANCE(92);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(93);
      END_STATE();
    case 63:
      if (lookahead == 's') ADVANCE(94);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 65:
      if (lookahead == 'c') ADVANCE(95);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 67:
      if (lookahead == 't') ADVANCE(96);
      END_STATE();
    case 68:
      if (lookahead == 'c') ADVANCE(97);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 70:
      if (lookahead == 'l') ADVANCE(98);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(99);
      END_STATE();
    case 72:
      if (lookahead == 's') ADVANCE(100);
      END_STATE();
    case 73:
      if (lookahead == 'p') ADVANCE(101);
      END_STATE();
    case 74:
      if (lookahead == 'o') ADVANCE(102);
      END_STATE();
    case 75:
      if (lookahead == 'u') ADVANCE(103);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_set);
      if (lookahead == 'g') ADVANCE(104);
      END_STATE();
    case 77:
      if (lookahead == 'n') ADVANCE(105);
      END_STATE();
    case 78:
      if (lookahead == 't') ADVANCE(106);
      END_STATE();
    case 79:
      if (lookahead == 'l') ADVANCE(107);
      END_STATE();
    case 80:
      if (lookahead == 'e') ADVANCE(108);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 82:
      if (lookahead == 'l') ADVANCE(109);
      END_STATE();
    case 83:
      if (lookahead == 't') ADVANCE(110);
      END_STATE();
    case 84:
      if (lookahead == 't') ADVANCE(111);
      END_STATE();
    case 85:
      if (lookahead == 'k') ADVANCE(112);
      END_STATE();
    case 86:
      if (lookahead == 's') ADVANCE(113);
      END_STATE();
    case 87:
      if (lookahead == 't') ADVANCE(114);
      END_STATE();
    case 88:
      if (lookahead == 'i') ADVANCE(115);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 92:
      if (lookahead == 'r') ADVANCE(116);
      END_STATE();
    case 93:
      if (lookahead == 'n') ADVANCE(117);
      END_STATE();
    case 94:
      if (lookahead == 'e') ADVANCE(118);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_func);
      END_STATE();
    case 96:
      if (lookahead == 'e') ADVANCE(119);
      END_STATE();
    case 97:
      if (lookahead == 'h') ADVANCE(120);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 99:
      if (lookahead == 'a') ADVANCE(121);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_pass);
      END_STATE();
    case 101:
      if (lookahead == 'e') ADVANCE(122);
      END_STATE();
    case 102:
      if (lookahead == 't') ADVANCE(123);
      END_STATE();
    case 103:
      if (lookahead == 'r') ADVANCE(124);
      END_STATE();
    case 104:
      if (lookahead == 'e') ADVANCE(125);
      END_STATE();
    case 105:
      if (lookahead == 'a') ADVANCE(126);
      END_STATE();
    case 106:
      if (lookahead == 'i') ADVANCE(127);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_tool_statement);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 109:
      if (lookahead == 'e') ADVANCE(128);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym__init);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_break);
      if (lookahead == 'p') ADVANCE(129);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_class);
      if (lookahead == '_') ADVANCE(130);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 115:
      if (lookahead == 'n') ADVANCE(131);
      END_STATE();
    case 116:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 117:
      if (lookahead == 'd') ADVANCE(133);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 119:
      if (lookahead == 'r') ADVANCE(134);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 121:
      if (lookahead == 'd') ADVANCE(135);
      END_STATE();
    case 122:
      if (lookahead == 't') ADVANCE(136);
      END_STATE();
    case 123:
      if (lookahead == 'e') ADVANCE(137);
      END_STATE();
    case 124:
      if (lookahead == 'n') ADVANCE(138);
      END_STATE();
    case 125:
      if (lookahead == 't') ADVANCE(139);
      END_STATE();
    case 126:
      if (lookahead == 'l') ADVANCE(140);
      END_STATE();
    case 127:
      if (lookahead == 'c') ADVANCE(141);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 129:
      if (lookahead == 'o') ADVANCE(142);
      END_STATE();
    case 130:
      if (lookahead == 'n') ADVANCE(143);
      END_STATE();
    case 131:
      if (lookahead == 'u') ADVANCE(144);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 133:
      if (lookahead == 's') ADVANCE(145);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_master);
      if (lookahead == 's') ADVANCE(146);
      END_STATE();
    case 135:
      if (lookahead == 'y') ADVANCE(147);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_puppet);
      if (lookahead == 's') ADVANCE(148);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_remote);
      if (lookahead == 's') ADVANCE(149);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_setget);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_signal);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_static_keyword);
      END_STATE();
    case 142:
      if (lookahead == 'i') ADVANCE(150);
      END_STATE();
    case 143:
      if (lookahead == 'a') ADVANCE(151);
      END_STATE();
    case 144:
      if (lookahead == 'e') ADVANCE(152);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 146:
      if (lookahead == 'y') ADVANCE(153);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_onready);
      END_STATE();
    case 148:
      if (lookahead == 'y') ADVANCE(154);
      END_STATE();
    case 149:
      if (lookahead == 'y') ADVANCE(155);
      END_STATE();
    case 150:
      if (lookahead == 'n') ADVANCE(156);
      END_STATE();
    case 151:
      if (lookahead == 'm') ADVANCE(157);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 153:
      if (lookahead == 'n') ADVANCE(158);
      END_STATE();
    case 154:
      if (lookahead == 'n') ADVANCE(159);
      END_STATE();
    case 155:
      if (lookahead == 'n') ADVANCE(160);
      END_STATE();
    case 156:
      if (lookahead == 't') ADVANCE(161);
      END_STATE();
    case 157:
      if (lookahead == 'e') ADVANCE(162);
      END_STATE();
    case 158:
      if (lookahead == 'c') ADVANCE(163);
      END_STATE();
    case 159:
      if (lookahead == 'c') ADVANCE(164);
      END_STATE();
    case 160:
      if (lookahead == 'c') ADVANCE(165);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_breakpoint_statement);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_class_name);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_mastersync);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_puppetsync);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_remotesync);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 51, .external_lex_state = 2},
  [2] = {.lex_state = 51, .external_lex_state = 3},
  [3] = {.lex_state = 51, .external_lex_state = 3},
  [4] = {.lex_state = 51, .external_lex_state = 3},
  [5] = {.lex_state = 51, .external_lex_state = 3},
  [6] = {.lex_state = 51, .external_lex_state = 3},
  [7] = {.lex_state = 51, .external_lex_state = 3},
  [8] = {.lex_state = 51, .external_lex_state = 3},
  [9] = {.lex_state = 51, .external_lex_state = 3},
  [10] = {.lex_state = 51, .external_lex_state = 3},
  [11] = {.lex_state = 51, .external_lex_state = 3},
  [12] = {.lex_state = 51, .external_lex_state = 3},
  [13] = {.lex_state = 51, .external_lex_state = 3},
  [14] = {.lex_state = 51, .external_lex_state = 3},
  [15] = {.lex_state = 51, .external_lex_state = 3},
  [16] = {.lex_state = 51, .external_lex_state = 3},
  [17] = {.lex_state = 51, .external_lex_state = 3},
  [18] = {.lex_state = 51, .external_lex_state = 3},
  [19] = {.lex_state = 51, .external_lex_state = 3},
  [20] = {.lex_state = 51, .external_lex_state = 3},
  [21] = {.lex_state = 51, .external_lex_state = 3},
  [22] = {.lex_state = 51, .external_lex_state = 3},
  [23] = {.lex_state = 51, .external_lex_state = 2},
  [24] = {.lex_state = 51, .external_lex_state = 2},
  [25] = {.lex_state = 51, .external_lex_state = 4},
  [26] = {.lex_state = 51, .external_lex_state = 4},
  [27] = {.lex_state = 51, .external_lex_state = 4},
  [28] = {.lex_state = 51, .external_lex_state = 4},
  [29] = {.lex_state = 51, .external_lex_state = 4},
  [30] = {.lex_state = 51, .external_lex_state = 4},
  [31] = {.lex_state = 51, .external_lex_state = 4},
  [32] = {.lex_state = 51, .external_lex_state = 4},
  [33] = {.lex_state = 51, .external_lex_state = 4},
  [34] = {.lex_state = 51, .external_lex_state = 4},
  [35] = {.lex_state = 51, .external_lex_state = 4},
  [36] = {.lex_state = 51, .external_lex_state = 4},
  [37] = {.lex_state = 51, .external_lex_state = 4},
  [38] = {.lex_state = 51, .external_lex_state = 4},
  [39] = {.lex_state = 51, .external_lex_state = 4},
  [40] = {.lex_state = 51, .external_lex_state = 4},
  [41] = {.lex_state = 51, .external_lex_state = 4},
  [42] = {.lex_state = 51, .external_lex_state = 4},
  [43] = {.lex_state = 51, .external_lex_state = 4},
  [44] = {.lex_state = 51, .external_lex_state = 4},
  [45] = {.lex_state = 51, .external_lex_state = 4},
  [46] = {.lex_state = 51, .external_lex_state = 4},
  [47] = {.lex_state = 51, .external_lex_state = 4},
  [48] = {.lex_state = 51, .external_lex_state = 4},
  [49] = {.lex_state = 51, .external_lex_state = 4},
  [50] = {.lex_state = 51, .external_lex_state = 4},
  [51] = {.lex_state = 51, .external_lex_state = 4},
  [52] = {.lex_state = 51, .external_lex_state = 4},
  [53] = {.lex_state = 51, .external_lex_state = 4},
  [54] = {.lex_state = 51, .external_lex_state = 4},
  [55] = {.lex_state = 51, .external_lex_state = 4},
  [56] = {.lex_state = 51, .external_lex_state = 4},
  [57] = {.lex_state = 51, .external_lex_state = 4},
  [58] = {.lex_state = 51, .external_lex_state = 4},
  [59] = {.lex_state = 51, .external_lex_state = 4},
  [60] = {.lex_state = 51, .external_lex_state = 4},
  [61] = {.lex_state = 51, .external_lex_state = 4},
  [62] = {.lex_state = 51, .external_lex_state = 4},
  [63] = {.lex_state = 51, .external_lex_state = 4},
  [64] = {.lex_state = 51, .external_lex_state = 4},
  [65] = {.lex_state = 51, .external_lex_state = 4},
  [66] = {.lex_state = 51, .external_lex_state = 4},
  [67] = {.lex_state = 51, .external_lex_state = 4},
  [68] = {.lex_state = 51, .external_lex_state = 4},
  [69] = {.lex_state = 51, .external_lex_state = 4},
  [70] = {.lex_state = 51, .external_lex_state = 4},
  [71] = {.lex_state = 51, .external_lex_state = 4},
  [72] = {.lex_state = 51, .external_lex_state = 4},
  [73] = {.lex_state = 51, .external_lex_state = 4},
  [74] = {.lex_state = 51, .external_lex_state = 4},
  [75] = {.lex_state = 51, .external_lex_state = 4},
  [76] = {.lex_state = 51, .external_lex_state = 4},
  [77] = {.lex_state = 51, .external_lex_state = 4},
  [78] = {.lex_state = 51, .external_lex_state = 4},
  [79] = {.lex_state = 51, .external_lex_state = 4},
  [80] = {.lex_state = 51, .external_lex_state = 4},
  [81] = {.lex_state = 51, .external_lex_state = 4},
  [82] = {.lex_state = 51, .external_lex_state = 4},
  [83] = {.lex_state = 51, .external_lex_state = 4},
  [84] = {.lex_state = 51, .external_lex_state = 4},
  [85] = {.lex_state = 51, .external_lex_state = 4},
  [86] = {.lex_state = 51, .external_lex_state = 4},
  [87] = {.lex_state = 51, .external_lex_state = 4},
  [88] = {.lex_state = 51, .external_lex_state = 4},
  [89] = {.lex_state = 51, .external_lex_state = 4},
  [90] = {.lex_state = 51, .external_lex_state = 4},
  [91] = {.lex_state = 51, .external_lex_state = 4},
  [92] = {.lex_state = 51, .external_lex_state = 4},
  [93] = {.lex_state = 51, .external_lex_state = 4},
  [94] = {.lex_state = 51, .external_lex_state = 4},
  [95] = {.lex_state = 51, .external_lex_state = 4},
  [96] = {.lex_state = 51, .external_lex_state = 4},
  [97] = {.lex_state = 51, .external_lex_state = 4},
  [98] = {.lex_state = 51, .external_lex_state = 4},
  [99] = {.lex_state = 51, .external_lex_state = 5},
  [100] = {.lex_state = 51, .external_lex_state = 5},
  [101] = {.lex_state = 51, .external_lex_state = 5},
  [102] = {.lex_state = 51, .external_lex_state = 5},
  [103] = {.lex_state = 51, .external_lex_state = 5},
  [104] = {.lex_state = 51, .external_lex_state = 5},
  [105] = {.lex_state = 51, .external_lex_state = 5},
  [106] = {.lex_state = 51, .external_lex_state = 5},
  [107] = {.lex_state = 51, .external_lex_state = 5},
  [108] = {.lex_state = 51, .external_lex_state = 5},
  [109] = {.lex_state = 51, .external_lex_state = 5},
  [110] = {.lex_state = 51, .external_lex_state = 5},
  [111] = {.lex_state = 51, .external_lex_state = 5},
  [112] = {.lex_state = 51, .external_lex_state = 5},
  [113] = {.lex_state = 51, .external_lex_state = 5},
  [114] = {.lex_state = 51, .external_lex_state = 5},
  [115] = {.lex_state = 51, .external_lex_state = 5},
  [116] = {.lex_state = 51, .external_lex_state = 5},
  [117] = {.lex_state = 51, .external_lex_state = 5},
  [118] = {.lex_state = 51, .external_lex_state = 5},
  [119] = {.lex_state = 51, .external_lex_state = 2},
  [120] = {.lex_state = 51, .external_lex_state = 3},
  [121] = {.lex_state = 51, .external_lex_state = 3},
  [122] = {.lex_state = 51, .external_lex_state = 3},
  [123] = {.lex_state = 51, .external_lex_state = 2},
  [124] = {.lex_state = 51, .external_lex_state = 2},
  [125] = {.lex_state = 51, .external_lex_state = 2},
  [126] = {.lex_state = 51, .external_lex_state = 3},
  [127] = {.lex_state = 51, .external_lex_state = 3},
  [128] = {.lex_state = 51, .external_lex_state = 3},
  [129] = {.lex_state = 51, .external_lex_state = 3},
  [130] = {.lex_state = 51, .external_lex_state = 3},
  [131] = {.lex_state = 51, .external_lex_state = 3},
  [132] = {.lex_state = 51, .external_lex_state = 3},
  [133] = {.lex_state = 51, .external_lex_state = 3},
  [134] = {.lex_state = 51, .external_lex_state = 2},
  [135] = {.lex_state = 51, .external_lex_state = 2},
  [136] = {.lex_state = 51, .external_lex_state = 2},
  [137] = {.lex_state = 51, .external_lex_state = 2},
  [138] = {.lex_state = 51, .external_lex_state = 2},
  [139] = {.lex_state = 51, .external_lex_state = 2},
  [140] = {.lex_state = 51, .external_lex_state = 2},
  [141] = {.lex_state = 51, .external_lex_state = 2},
  [142] = {.lex_state = 51, .external_lex_state = 3},
  [143] = {.lex_state = 51, .external_lex_state = 3},
  [144] = {.lex_state = 51, .external_lex_state = 3},
  [145] = {.lex_state = 51, .external_lex_state = 3},
  [146] = {.lex_state = 51, .external_lex_state = 3},
  [147] = {.lex_state = 51, .external_lex_state = 3},
  [148] = {.lex_state = 51, .external_lex_state = 3},
  [149] = {.lex_state = 51, .external_lex_state = 3},
  [150] = {.lex_state = 51, .external_lex_state = 3},
  [151] = {.lex_state = 51, .external_lex_state = 3},
  [152] = {.lex_state = 51, .external_lex_state = 3},
  [153] = {.lex_state = 51, .external_lex_state = 3},
  [154] = {.lex_state = 51, .external_lex_state = 3},
  [155] = {.lex_state = 51, .external_lex_state = 3},
  [156] = {.lex_state = 51, .external_lex_state = 3},
  [157] = {.lex_state = 51, .external_lex_state = 3},
  [158] = {.lex_state = 51, .external_lex_state = 3},
  [159] = {.lex_state = 51, .external_lex_state = 3},
  [160] = {.lex_state = 51, .external_lex_state = 3},
  [161] = {.lex_state = 51, .external_lex_state = 3},
  [162] = {.lex_state = 51, .external_lex_state = 3},
  [163] = {.lex_state = 51, .external_lex_state = 3},
  [164] = {.lex_state = 51, .external_lex_state = 3},
  [165] = {.lex_state = 51, .external_lex_state = 3},
  [166] = {.lex_state = 51, .external_lex_state = 3},
  [167] = {.lex_state = 51, .external_lex_state = 3},
  [168] = {.lex_state = 51, .external_lex_state = 3},
  [169] = {.lex_state = 51, .external_lex_state = 3},
  [170] = {.lex_state = 51, .external_lex_state = 3},
  [171] = {.lex_state = 51, .external_lex_state = 3},
  [172] = {.lex_state = 51, .external_lex_state = 2},
  [173] = {.lex_state = 51, .external_lex_state = 2},
  [174] = {.lex_state = 51, .external_lex_state = 2},
  [175] = {.lex_state = 51, .external_lex_state = 2},
  [176] = {.lex_state = 51, .external_lex_state = 2},
  [177] = {.lex_state = 51, .external_lex_state = 2},
  [178] = {.lex_state = 51, .external_lex_state = 2},
  [179] = {.lex_state = 51, .external_lex_state = 2},
  [180] = {.lex_state = 51, .external_lex_state = 2},
  [181] = {.lex_state = 51, .external_lex_state = 2},
  [182] = {.lex_state = 51, .external_lex_state = 2},
  [183] = {.lex_state = 51, .external_lex_state = 2},
  [184] = {.lex_state = 51, .external_lex_state = 2},
  [185] = {.lex_state = 51, .external_lex_state = 2},
  [186] = {.lex_state = 51, .external_lex_state = 2},
  [187] = {.lex_state = 51, .external_lex_state = 2},
  [188] = {.lex_state = 51, .external_lex_state = 2},
  [189] = {.lex_state = 51, .external_lex_state = 2},
  [190] = {.lex_state = 51, .external_lex_state = 2},
  [191] = {.lex_state = 51, .external_lex_state = 2},
  [192] = {.lex_state = 51, .external_lex_state = 2},
  [193] = {.lex_state = 51, .external_lex_state = 2},
  [194] = {.lex_state = 51, .external_lex_state = 2},
  [195] = {.lex_state = 51, .external_lex_state = 2},
  [196] = {.lex_state = 51, .external_lex_state = 2},
  [197] = {.lex_state = 51, .external_lex_state = 2},
  [198] = {.lex_state = 51, .external_lex_state = 2},
  [199] = {.lex_state = 51, .external_lex_state = 2},
  [200] = {.lex_state = 51, .external_lex_state = 2},
  [201] = {.lex_state = 51, .external_lex_state = 2},
  [202] = {.lex_state = 8, .external_lex_state = 6},
  [203] = {.lex_state = 8, .external_lex_state = 6},
  [204] = {.lex_state = 8, .external_lex_state = 6},
  [205] = {.lex_state = 8, .external_lex_state = 6},
  [206] = {.lex_state = 8, .external_lex_state = 6},
  [207] = {.lex_state = 8, .external_lex_state = 6},
  [208] = {.lex_state = 8, .external_lex_state = 6},
  [209] = {.lex_state = 8, .external_lex_state = 6},
  [210] = {.lex_state = 8, .external_lex_state = 6},
  [211] = {.lex_state = 51, .external_lex_state = 5},
  [212] = {.lex_state = 8, .external_lex_state = 6},
  [213] = {.lex_state = 8, .external_lex_state = 6},
  [214] = {.lex_state = 8, .external_lex_state = 6},
  [215] = {.lex_state = 8, .external_lex_state = 6},
  [216] = {.lex_state = 8, .external_lex_state = 6},
  [217] = {.lex_state = 8, .external_lex_state = 6},
  [218] = {.lex_state = 8, .external_lex_state = 6},
  [219] = {.lex_state = 8, .external_lex_state = 6},
  [220] = {.lex_state = 8, .external_lex_state = 6},
  [221] = {.lex_state = 8, .external_lex_state = 6},
  [222] = {.lex_state = 8, .external_lex_state = 6},
  [223] = {.lex_state = 8, .external_lex_state = 6},
  [224] = {.lex_state = 8, .external_lex_state = 6},
  [225] = {.lex_state = 51, .external_lex_state = 7},
  [226] = {.lex_state = 51, .external_lex_state = 7},
  [227] = {.lex_state = 51, .external_lex_state = 7},
  [228] = {.lex_state = 8, .external_lex_state = 6},
  [229] = {.lex_state = 51, .external_lex_state = 7},
  [230] = {.lex_state = 8, .external_lex_state = 6},
  [231] = {.lex_state = 8, .external_lex_state = 6},
  [232] = {.lex_state = 8, .external_lex_state = 6},
  [233] = {.lex_state = 8, .external_lex_state = 6},
  [234] = {.lex_state = 8, .external_lex_state = 6},
  [235] = {.lex_state = 51, .external_lex_state = 7},
  [236] = {.lex_state = 51, .external_lex_state = 7},
  [237] = {.lex_state = 8, .external_lex_state = 6},
  [238] = {.lex_state = 8, .external_lex_state = 6},
  [239] = {.lex_state = 8, .external_lex_state = 6},
  [240] = {.lex_state = 8, .external_lex_state = 6},
  [241] = {.lex_state = 51, .external_lex_state = 7},
  [242] = {.lex_state = 51, .external_lex_state = 7},
  [243] = {.lex_state = 51, .external_lex_state = 7},
  [244] = {.lex_state = 51, .external_lex_state = 7},
  [245] = {.lex_state = 8, .external_lex_state = 6},
  [246] = {.lex_state = 51, .external_lex_state = 7},
  [247] = {.lex_state = 8, .external_lex_state = 6},
  [248] = {.lex_state = 8, .external_lex_state = 6},
  [249] = {.lex_state = 8, .external_lex_state = 6},
  [250] = {.lex_state = 8, .external_lex_state = 6},
  [251] = {.lex_state = 8, .external_lex_state = 6},
  [252] = {.lex_state = 51, .external_lex_state = 7},
  [253] = {.lex_state = 51, .external_lex_state = 7},
  [254] = {.lex_state = 8, .external_lex_state = 6},
  [255] = {.lex_state = 51, .external_lex_state = 7},
  [256] = {.lex_state = 8, .external_lex_state = 6},
  [257] = {.lex_state = 51, .external_lex_state = 7},
  [258] = {.lex_state = 8, .external_lex_state = 6},
  [259] = {.lex_state = 51, .external_lex_state = 7},
  [260] = {.lex_state = 51, .external_lex_state = 7},
  [261] = {.lex_state = 51, .external_lex_state = 7},
  [262] = {.lex_state = 8, .external_lex_state = 6},
  [263] = {.lex_state = 51, .external_lex_state = 7},
  [264] = {.lex_state = 8, .external_lex_state = 6},
  [265] = {.lex_state = 51, .external_lex_state = 7},
  [266] = {.lex_state = 51, .external_lex_state = 7},
  [267] = {.lex_state = 51, .external_lex_state = 8},
  [268] = {.lex_state = 51, .external_lex_state = 9},
  [269] = {.lex_state = 51, .external_lex_state = 8},
  [270] = {.lex_state = 51, .external_lex_state = 8},
  [271] = {.lex_state = 51, .external_lex_state = 9},
  [272] = {.lex_state = 51, .external_lex_state = 8},
  [273] = {.lex_state = 51, .external_lex_state = 8},
  [274] = {.lex_state = 51, .external_lex_state = 9},
  [275] = {.lex_state = 51, .external_lex_state = 2},
  [276] = {.lex_state = 51, .external_lex_state = 9},
  [277] = {.lex_state = 51, .external_lex_state = 9},
  [278] = {.lex_state = 51, .external_lex_state = 8},
  [279] = {.lex_state = 51, .external_lex_state = 8},
  [280] = {.lex_state = 51, .external_lex_state = 8},
  [281] = {.lex_state = 51, .external_lex_state = 8},
  [282] = {.lex_state = 51, .external_lex_state = 9},
  [283] = {.lex_state = 51, .external_lex_state = 8},
  [284] = {.lex_state = 51, .external_lex_state = 8},
  [285] = {.lex_state = 51, .external_lex_state = 8},
  [286] = {.lex_state = 51, .external_lex_state = 9},
  [287] = {.lex_state = 51, .external_lex_state = 8},
  [288] = {.lex_state = 51, .external_lex_state = 8},
  [289] = {.lex_state = 51, .external_lex_state = 9},
  [290] = {.lex_state = 51, .external_lex_state = 9},
  [291] = {.lex_state = 51, .external_lex_state = 9},
  [292] = {.lex_state = 51, .external_lex_state = 9},
  [293] = {.lex_state = 51, .external_lex_state = 8},
  [294] = {.lex_state = 51, .external_lex_state = 9},
  [295] = {.lex_state = 51, .external_lex_state = 9},
  [296] = {.lex_state = 51, .external_lex_state = 9},
  [297] = {.lex_state = 51, .external_lex_state = 9},
  [298] = {.lex_state = 51, .external_lex_state = 8},
  [299] = {.lex_state = 51, .external_lex_state = 8},
  [300] = {.lex_state = 51, .external_lex_state = 9},
  [301] = {.lex_state = 51, .external_lex_state = 9},
  [302] = {.lex_state = 51, .external_lex_state = 9},
  [303] = {.lex_state = 51, .external_lex_state = 8},
  [304] = {.lex_state = 51, .external_lex_state = 9},
  [305] = {.lex_state = 51, .external_lex_state = 8},
  [306] = {.lex_state = 51, .external_lex_state = 8},
  [307] = {.lex_state = 51, .external_lex_state = 9},
  [308] = {.lex_state = 51, .external_lex_state = 8},
  [309] = {.lex_state = 51, .external_lex_state = 9},
  [310] = {.lex_state = 51, .external_lex_state = 7},
  [311] = {.lex_state = 51, .external_lex_state = 7},
  [312] = {.lex_state = 51, .external_lex_state = 2},
  [313] = {.lex_state = 51, .external_lex_state = 2},
  [314] = {.lex_state = 51, .external_lex_state = 2},
  [315] = {.lex_state = 51, .external_lex_state = 2},
  [316] = {.lex_state = 51, .external_lex_state = 2},
  [317] = {.lex_state = 51, .external_lex_state = 2},
  [318] = {.lex_state = 51, .external_lex_state = 2},
  [319] = {.lex_state = 51, .external_lex_state = 2},
  [320] = {.lex_state = 51, .external_lex_state = 2},
  [321] = {.lex_state = 51, .external_lex_state = 2},
  [322] = {.lex_state = 51, .external_lex_state = 2},
  [323] = {.lex_state = 51, .external_lex_state = 2},
  [324] = {.lex_state = 51, .external_lex_state = 2},
  [325] = {.lex_state = 51, .external_lex_state = 2},
  [326] = {.lex_state = 51, .external_lex_state = 7},
  [327] = {.lex_state = 51, .external_lex_state = 2},
  [328] = {.lex_state = 51, .external_lex_state = 2},
  [329] = {.lex_state = 51, .external_lex_state = 2},
  [330] = {.lex_state = 9, .external_lex_state = 10},
  [331] = {.lex_state = 9, .external_lex_state = 10},
  [332] = {.lex_state = 51, .external_lex_state = 2},
  [333] = {.lex_state = 9, .external_lex_state = 10},
  [334] = {.lex_state = 9, .external_lex_state = 10},
  [335] = {.lex_state = 51, .external_lex_state = 2},
  [336] = {.lex_state = 51, .external_lex_state = 2},
  [337] = {.lex_state = 51, .external_lex_state = 2},
  [338] = {.lex_state = 51, .external_lex_state = 2},
  [339] = {.lex_state = 51, .external_lex_state = 2},
  [340] = {.lex_state = 51, .external_lex_state = 2},
  [341] = {.lex_state = 51, .external_lex_state = 2},
  [342] = {.lex_state = 51, .external_lex_state = 2},
  [343] = {.lex_state = 51, .external_lex_state = 2},
  [344] = {.lex_state = 51, .external_lex_state = 2},
  [345] = {.lex_state = 51, .external_lex_state = 2},
  [346] = {.lex_state = 51, .external_lex_state = 2},
  [347] = {.lex_state = 51, .external_lex_state = 2},
  [348] = {.lex_state = 51, .external_lex_state = 2},
  [349] = {.lex_state = 51, .external_lex_state = 2},
  [350] = {.lex_state = 51, .external_lex_state = 2},
  [351] = {.lex_state = 51, .external_lex_state = 2},
  [352] = {.lex_state = 51, .external_lex_state = 2},
  [353] = {.lex_state = 51, .external_lex_state = 2},
  [354] = {.lex_state = 51, .external_lex_state = 2},
  [355] = {.lex_state = 51, .external_lex_state = 2},
  [356] = {.lex_state = 51, .external_lex_state = 2},
  [357] = {.lex_state = 51, .external_lex_state = 2},
  [358] = {.lex_state = 51, .external_lex_state = 2},
  [359] = {.lex_state = 51, .external_lex_state = 2},
  [360] = {.lex_state = 51, .external_lex_state = 2},
  [361] = {.lex_state = 51, .external_lex_state = 2},
  [362] = {.lex_state = 51, .external_lex_state = 2},
  [363] = {.lex_state = 51, .external_lex_state = 2},
  [364] = {.lex_state = 51, .external_lex_state = 2},
  [365] = {.lex_state = 51, .external_lex_state = 2},
  [366] = {.lex_state = 51, .external_lex_state = 2},
  [367] = {.lex_state = 51, .external_lex_state = 2},
  [368] = {.lex_state = 51, .external_lex_state = 2},
  [369] = {.lex_state = 51, .external_lex_state = 2},
  [370] = {.lex_state = 51, .external_lex_state = 2},
  [371] = {.lex_state = 51, .external_lex_state = 2},
  [372] = {.lex_state = 51, .external_lex_state = 2},
  [373] = {.lex_state = 51, .external_lex_state = 2},
  [374] = {.lex_state = 51, .external_lex_state = 2},
  [375] = {.lex_state = 51, .external_lex_state = 2},
  [376] = {.lex_state = 51, .external_lex_state = 2},
  [377] = {.lex_state = 51, .external_lex_state = 2},
  [378] = {.lex_state = 51, .external_lex_state = 2},
  [379] = {.lex_state = 51, .external_lex_state = 2},
  [380] = {.lex_state = 51, .external_lex_state = 2},
  [381] = {.lex_state = 51, .external_lex_state = 2},
  [382] = {.lex_state = 51, .external_lex_state = 2},
  [383] = {.lex_state = 51, .external_lex_state = 2},
  [384] = {.lex_state = 51, .external_lex_state = 2},
  [385] = {.lex_state = 51, .external_lex_state = 2},
  [386] = {.lex_state = 51, .external_lex_state = 2},
  [387] = {.lex_state = 51, .external_lex_state = 2},
  [388] = {.lex_state = 51, .external_lex_state = 2},
  [389] = {.lex_state = 51, .external_lex_state = 2},
  [390] = {.lex_state = 51, .external_lex_state = 2},
  [391] = {.lex_state = 51, .external_lex_state = 2},
  [392] = {.lex_state = 51, .external_lex_state = 2},
  [393] = {.lex_state = 51, .external_lex_state = 2},
  [394] = {.lex_state = 51, .external_lex_state = 2},
  [395] = {.lex_state = 51, .external_lex_state = 2},
  [396] = {.lex_state = 51, .external_lex_state = 2},
  [397] = {.lex_state = 51, .external_lex_state = 2},
  [398] = {.lex_state = 51, .external_lex_state = 2},
  [399] = {.lex_state = 51, .external_lex_state = 2},
  [400] = {.lex_state = 51, .external_lex_state = 2},
  [401] = {.lex_state = 51, .external_lex_state = 2},
  [402] = {.lex_state = 51, .external_lex_state = 2},
  [403] = {.lex_state = 51, .external_lex_state = 2},
  [404] = {.lex_state = 51, .external_lex_state = 2},
  [405] = {.lex_state = 51, .external_lex_state = 2},
  [406] = {.lex_state = 51, .external_lex_state = 2},
  [407] = {.lex_state = 51, .external_lex_state = 2},
  [408] = {.lex_state = 51, .external_lex_state = 2},
  [409] = {.lex_state = 51, .external_lex_state = 2},
  [410] = {.lex_state = 51, .external_lex_state = 2},
  [411] = {.lex_state = 51, .external_lex_state = 2},
  [412] = {.lex_state = 51, .external_lex_state = 2},
  [413] = {.lex_state = 51, .external_lex_state = 2},
  [414] = {.lex_state = 51, .external_lex_state = 2},
  [415] = {.lex_state = 51, .external_lex_state = 2},
  [416] = {.lex_state = 51, .external_lex_state = 2},
  [417] = {.lex_state = 51, .external_lex_state = 2},
  [418] = {.lex_state = 51, .external_lex_state = 2},
  [419] = {.lex_state = 51, .external_lex_state = 2},
  [420] = {.lex_state = 51, .external_lex_state = 2},
  [421] = {.lex_state = 51, .external_lex_state = 2},
  [422] = {.lex_state = 51, .external_lex_state = 2},
  [423] = {.lex_state = 51, .external_lex_state = 2},
  [424] = {.lex_state = 51, .external_lex_state = 2},
  [425] = {.lex_state = 51, .external_lex_state = 2},
  [426] = {.lex_state = 51, .external_lex_state = 2},
  [427] = {.lex_state = 51, .external_lex_state = 2},
  [428] = {.lex_state = 51, .external_lex_state = 2},
  [429] = {.lex_state = 51, .external_lex_state = 2},
  [430] = {.lex_state = 51, .external_lex_state = 2},
  [431] = {.lex_state = 51, .external_lex_state = 2},
  [432] = {.lex_state = 51, .external_lex_state = 2},
  [433] = {.lex_state = 51, .external_lex_state = 2},
  [434] = {.lex_state = 51, .external_lex_state = 2},
  [435] = {.lex_state = 51, .external_lex_state = 2},
  [436] = {.lex_state = 51, .external_lex_state = 2},
  [437] = {.lex_state = 51, .external_lex_state = 2},
  [438] = {.lex_state = 51, .external_lex_state = 2},
  [439] = {.lex_state = 51, .external_lex_state = 2},
  [440] = {.lex_state = 51, .external_lex_state = 2},
  [441] = {.lex_state = 51, .external_lex_state = 2},
  [442] = {.lex_state = 51, .external_lex_state = 2},
  [443] = {.lex_state = 51, .external_lex_state = 2},
  [444] = {.lex_state = 51, .external_lex_state = 2},
  [445] = {.lex_state = 51, .external_lex_state = 2},
  [446] = {.lex_state = 51, .external_lex_state = 2},
  [447] = {.lex_state = 51, .external_lex_state = 2},
  [448] = {.lex_state = 8, .external_lex_state = 10},
  [449] = {.lex_state = 51, .external_lex_state = 2},
  [450] = {.lex_state = 51, .external_lex_state = 2},
  [451] = {.lex_state = 51, .external_lex_state = 2},
  [452] = {.lex_state = 51, .external_lex_state = 2},
  [453] = {.lex_state = 51, .external_lex_state = 2},
  [454] = {.lex_state = 51, .external_lex_state = 2},
  [455] = {.lex_state = 51, .external_lex_state = 2},
  [456] = {.lex_state = 51, .external_lex_state = 2},
  [457] = {.lex_state = 51, .external_lex_state = 2},
  [458] = {.lex_state = 51, .external_lex_state = 2},
  [459] = {.lex_state = 51, .external_lex_state = 2},
  [460] = {.lex_state = 51, .external_lex_state = 2},
  [461] = {.lex_state = 51, .external_lex_state = 2},
  [462] = {.lex_state = 51, .external_lex_state = 2},
  [463] = {.lex_state = 51, .external_lex_state = 2},
  [464] = {.lex_state = 51, .external_lex_state = 2},
  [465] = {.lex_state = 51, .external_lex_state = 2},
  [466] = {.lex_state = 8, .external_lex_state = 11},
  [467] = {.lex_state = 8, .external_lex_state = 11},
  [468] = {.lex_state = 8, .external_lex_state = 11},
  [469] = {.lex_state = 8, .external_lex_state = 10},
  [470] = {.lex_state = 8, .external_lex_state = 11},
  [471] = {.lex_state = 8, .external_lex_state = 12},
  [472] = {.lex_state = 8, .external_lex_state = 10},
  [473] = {.lex_state = 8, .external_lex_state = 10},
  [474] = {.lex_state = 8, .external_lex_state = 11},
  [475] = {.lex_state = 8, .external_lex_state = 11},
  [476] = {.lex_state = 8, .external_lex_state = 11},
  [477] = {.lex_state = 8, .external_lex_state = 11},
  [478] = {.lex_state = 8, .external_lex_state = 11},
  [479] = {.lex_state = 8, .external_lex_state = 11},
  [480] = {.lex_state = 8, .external_lex_state = 11},
  [481] = {.lex_state = 8, .external_lex_state = 11},
  [482] = {.lex_state = 8, .external_lex_state = 11},
  [483] = {.lex_state = 8, .external_lex_state = 11},
  [484] = {.lex_state = 8, .external_lex_state = 11},
  [485] = {.lex_state = 8, .external_lex_state = 12},
  [486] = {.lex_state = 8, .external_lex_state = 10},
  [487] = {.lex_state = 8, .external_lex_state = 11},
  [488] = {.lex_state = 8, .external_lex_state = 12},
  [489] = {.lex_state = 8, .external_lex_state = 12},
  [490] = {.lex_state = 8, .external_lex_state = 10},
  [491] = {.lex_state = 8, .external_lex_state = 12},
  [492] = {.lex_state = 8, .external_lex_state = 13},
  [493] = {.lex_state = 8, .external_lex_state = 13},
  [494] = {.lex_state = 8, .external_lex_state = 13},
  [495] = {.lex_state = 8, .external_lex_state = 13},
  [496] = {.lex_state = 8, .external_lex_state = 13},
  [497] = {.lex_state = 8, .external_lex_state = 13},
  [498] = {.lex_state = 8, .external_lex_state = 13},
  [499] = {.lex_state = 8, .external_lex_state = 12},
  [500] = {.lex_state = 8, .external_lex_state = 13},
  [501] = {.lex_state = 8, .external_lex_state = 13},
  [502] = {.lex_state = 8, .external_lex_state = 10},
  [503] = {.lex_state = 8, .external_lex_state = 13},
  [504] = {.lex_state = 8, .external_lex_state = 10},
  [505] = {.lex_state = 8, .external_lex_state = 10},
  [506] = {.lex_state = 8, .external_lex_state = 10},
  [507] = {.lex_state = 8, .external_lex_state = 10},
  [508] = {.lex_state = 8, .external_lex_state = 10},
  [509] = {.lex_state = 8, .external_lex_state = 10},
  [510] = {.lex_state = 8, .external_lex_state = 10},
  [511] = {.lex_state = 8, .external_lex_state = 10},
  [512] = {.lex_state = 8, .external_lex_state = 13},
  [513] = {.lex_state = 8, .external_lex_state = 13},
  [514] = {.lex_state = 8, .external_lex_state = 10},
  [515] = {.lex_state = 8, .external_lex_state = 12},
  [516] = {.lex_state = 8, .external_lex_state = 10},
  [517] = {.lex_state = 8, .external_lex_state = 13},
  [518] = {.lex_state = 8, .external_lex_state = 12},
  [519] = {.lex_state = 8, .external_lex_state = 12},
  [520] = {.lex_state = 8, .external_lex_state = 12},
  [521] = {.lex_state = 8, .external_lex_state = 12},
  [522] = {.lex_state = 8, .external_lex_state = 12},
  [523] = {.lex_state = 8, .external_lex_state = 12},
  [524] = {.lex_state = 8, .external_lex_state = 12},
  [525] = {.lex_state = 8, .external_lex_state = 12},
  [526] = {.lex_state = 8, .external_lex_state = 12},
  [527] = {.lex_state = 8, .external_lex_state = 13},
  [528] = {.lex_state = 8, .external_lex_state = 13},
  [529] = {.lex_state = 8, .external_lex_state = 13},
  [530] = {.lex_state = 8, .external_lex_state = 11},
  [531] = {.lex_state = 8, .external_lex_state = 12},
  [532] = {.lex_state = 8, .external_lex_state = 14},
  [533] = {.lex_state = 8, .external_lex_state = 10},
  [534] = {.lex_state = 8, .external_lex_state = 11},
  [535] = {.lex_state = 8, .external_lex_state = 11},
  [536] = {.lex_state = 8, .external_lex_state = 10},
  [537] = {.lex_state = 8, .external_lex_state = 11},
  [538] = {.lex_state = 8, .external_lex_state = 10},
  [539] = {.lex_state = 8, .external_lex_state = 10},
  [540] = {.lex_state = 8, .external_lex_state = 11},
  [541] = {.lex_state = 8, .external_lex_state = 11},
  [542] = {.lex_state = 8, .external_lex_state = 11},
  [543] = {.lex_state = 8, .external_lex_state = 10},
  [544] = {.lex_state = 8, .external_lex_state = 10},
  [545] = {.lex_state = 8, .external_lex_state = 11},
  [546] = {.lex_state = 8, .external_lex_state = 10},
  [547] = {.lex_state = 8, .external_lex_state = 15},
  [548] = {.lex_state = 8, .external_lex_state = 11},
  [549] = {.lex_state = 8, .external_lex_state = 10},
  [550] = {.lex_state = 8, .external_lex_state = 15},
  [551] = {.lex_state = 8, .external_lex_state = 11},
  [552] = {.lex_state = 8, .external_lex_state = 11},
  [553] = {.lex_state = 8, .external_lex_state = 15},
  [554] = {.lex_state = 8, .external_lex_state = 15},
  [555] = {.lex_state = 8, .external_lex_state = 15},
  [556] = {.lex_state = 8, .external_lex_state = 15},
  [557] = {.lex_state = 8, .external_lex_state = 10},
  [558] = {.lex_state = 8, .external_lex_state = 15},
  [559] = {.lex_state = 8, .external_lex_state = 15},
  [560] = {.lex_state = 8, .external_lex_state = 10},
  [561] = {.lex_state = 8, .external_lex_state = 15},
  [562] = {.lex_state = 8, .external_lex_state = 15},
  [563] = {.lex_state = 8, .external_lex_state = 15},
  [564] = {.lex_state = 8, .external_lex_state = 15},
  [565] = {.lex_state = 8, .external_lex_state = 14},
  [566] = {.lex_state = 8, .external_lex_state = 15},
  [567] = {.lex_state = 8, .external_lex_state = 11},
  [568] = {.lex_state = 8, .external_lex_state = 11},
  [569] = {.lex_state = 8, .external_lex_state = 14},
  [570] = {.lex_state = 8, .external_lex_state = 11},
  [571] = {.lex_state = 8, .external_lex_state = 10},
  [572] = {.lex_state = 8, .external_lex_state = 11},
  [573] = {.lex_state = 8, .external_lex_state = 10},
  [574] = {.lex_state = 8, .external_lex_state = 15},
  [575] = {.lex_state = 8, .external_lex_state = 12},
  [576] = {.lex_state = 8, .external_lex_state = 12},
  [577] = {.lex_state = 8, .external_lex_state = 12},
  [578] = {.lex_state = 8, .external_lex_state = 12},
  [579] = {.lex_state = 8, .external_lex_state = 12},
  [580] = {.lex_state = 8, .external_lex_state = 12},
  [581] = {.lex_state = 8, .external_lex_state = 12},
  [582] = {.lex_state = 8, .external_lex_state = 12},
  [583] = {.lex_state = 8, .external_lex_state = 12},
  [584] = {.lex_state = 8, .external_lex_state = 12},
  [585] = {.lex_state = 8, .external_lex_state = 12},
  [586] = {.lex_state = 8, .external_lex_state = 10},
  [587] = {.lex_state = 8, .external_lex_state = 11},
  [588] = {.lex_state = 8, .external_lex_state = 12},
  [589] = {.lex_state = 8, .external_lex_state = 10},
  [590] = {.lex_state = 8, .external_lex_state = 12},
  [591] = {.lex_state = 8, .external_lex_state = 12},
  [592] = {.lex_state = 8, .external_lex_state = 12},
  [593] = {.lex_state = 8, .external_lex_state = 12},
  [594] = {.lex_state = 8, .external_lex_state = 12},
  [595] = {.lex_state = 8, .external_lex_state = 12},
  [596] = {.lex_state = 8, .external_lex_state = 12},
  [597] = {.lex_state = 8, .external_lex_state = 10},
  [598] = {.lex_state = 8, .external_lex_state = 12},
  [599] = {.lex_state = 8, .external_lex_state = 11},
  [600] = {.lex_state = 8, .external_lex_state = 10},
  [601] = {.lex_state = 8, .external_lex_state = 11},
  [602] = {.lex_state = 8, .external_lex_state = 15},
  [603] = {.lex_state = 8, .external_lex_state = 12},
  [604] = {.lex_state = 8, .external_lex_state = 12},
  [605] = {.lex_state = 8, .external_lex_state = 12},
  [606] = {.lex_state = 8, .external_lex_state = 12},
  [607] = {.lex_state = 8, .external_lex_state = 12},
  [608] = {.lex_state = 8, .external_lex_state = 11},
  [609] = {.lex_state = 8, .external_lex_state = 13},
  [610] = {.lex_state = 8, .external_lex_state = 13},
  [611] = {.lex_state = 8, .external_lex_state = 10},
  [612] = {.lex_state = 8, .external_lex_state = 12},
  [613] = {.lex_state = 8, .external_lex_state = 13},
  [614] = {.lex_state = 8, .external_lex_state = 11},
  [615] = {.lex_state = 8, .external_lex_state = 11},
  [616] = {.lex_state = 8, .external_lex_state = 13},
  [617] = {.lex_state = 8, .external_lex_state = 13},
  [618] = {.lex_state = 8, .external_lex_state = 11},
  [619] = {.lex_state = 8, .external_lex_state = 15},
  [620] = {.lex_state = 8, .external_lex_state = 11},
  [621] = {.lex_state = 8, .external_lex_state = 11},
  [622] = {.lex_state = 8, .external_lex_state = 13},
  [623] = {.lex_state = 8, .external_lex_state = 13},
  [624] = {.lex_state = 8, .external_lex_state = 10},
  [625] = {.lex_state = 8, .external_lex_state = 11},
  [626] = {.lex_state = 8, .external_lex_state = 11},
  [627] = {.lex_state = 8, .external_lex_state = 11},
  [628] = {.lex_state = 8, .external_lex_state = 14},
  [629] = {.lex_state = 8, .external_lex_state = 13},
  [630] = {.lex_state = 8, .external_lex_state = 14},
  [631] = {.lex_state = 8, .external_lex_state = 13},
  [632] = {.lex_state = 8, .external_lex_state = 14},
  [633] = {.lex_state = 8, .external_lex_state = 14},
  [634] = {.lex_state = 8, .external_lex_state = 14},
  [635] = {.lex_state = 8, .external_lex_state = 13},
  [636] = {.lex_state = 8, .external_lex_state = 13},
  [637] = {.lex_state = 8, .external_lex_state = 13},
  [638] = {.lex_state = 8, .external_lex_state = 13},
  [639] = {.lex_state = 8, .external_lex_state = 14},
  [640] = {.lex_state = 8, .external_lex_state = 13},
  [641] = {.lex_state = 8, .external_lex_state = 13},
  [642] = {.lex_state = 8, .external_lex_state = 13},
  [643] = {.lex_state = 8, .external_lex_state = 14},
  [644] = {.lex_state = 8, .external_lex_state = 13},
  [645] = {.lex_state = 8, .external_lex_state = 13},
  [646] = {.lex_state = 8, .external_lex_state = 13},
  [647] = {.lex_state = 8, .external_lex_state = 14},
  [648] = {.lex_state = 8, .external_lex_state = 13},
  [649] = {.lex_state = 8, .external_lex_state = 10},
  [650] = {.lex_state = 8, .external_lex_state = 13},
  [651] = {.lex_state = 8, .external_lex_state = 13},
  [652] = {.lex_state = 8, .external_lex_state = 14},
  [653] = {.lex_state = 8, .external_lex_state = 10},
  [654] = {.lex_state = 8, .external_lex_state = 14},
  [655] = {.lex_state = 8, .external_lex_state = 10},
  [656] = {.lex_state = 8, .external_lex_state = 10},
  [657] = {.lex_state = 8, .external_lex_state = 10},
  [658] = {.lex_state = 8, .external_lex_state = 14},
  [659] = {.lex_state = 8, .external_lex_state = 13},
  [660] = {.lex_state = 8, .external_lex_state = 13},
  [661] = {.lex_state = 8, .external_lex_state = 14},
  [662] = {.lex_state = 8, .external_lex_state = 13},
  [663] = {.lex_state = 8, .external_lex_state = 13},
  [664] = {.lex_state = 8, .external_lex_state = 14},
  [665] = {.lex_state = 8, .external_lex_state = 13},
  [666] = {.lex_state = 8, .external_lex_state = 14},
  [667] = {.lex_state = 8, .external_lex_state = 14},
  [668] = {.lex_state = 8, .external_lex_state = 14},
  [669] = {.lex_state = 8, .external_lex_state = 15},
  [670] = {.lex_state = 8, .external_lex_state = 14},
  [671] = {.lex_state = 8, .external_lex_state = 14},
  [672] = {.lex_state = 8, .external_lex_state = 15},
  [673] = {.lex_state = 8, .external_lex_state = 15},
  [674] = {.lex_state = 8, .external_lex_state = 14},
  [675] = {.lex_state = 8, .external_lex_state = 15},
  [676] = {.lex_state = 8, .external_lex_state = 14},
  [677] = {.lex_state = 8, .external_lex_state = 15},
  [678] = {.lex_state = 8, .external_lex_state = 14},
  [679] = {.lex_state = 8, .external_lex_state = 14},
  [680] = {.lex_state = 8, .external_lex_state = 15},
  [681] = {.lex_state = 8, .external_lex_state = 14},
  [682] = {.lex_state = 8, .external_lex_state = 14},
  [683] = {.lex_state = 8, .external_lex_state = 14},
  [684] = {.lex_state = 8, .external_lex_state = 14},
  [685] = {.lex_state = 8, .external_lex_state = 14},
  [686] = {.lex_state = 8, .external_lex_state = 14},
  [687] = {.lex_state = 8, .external_lex_state = 14},
  [688] = {.lex_state = 8, .external_lex_state = 14},
  [689] = {.lex_state = 8, .external_lex_state = 14},
  [690] = {.lex_state = 8, .external_lex_state = 15},
  [691] = {.lex_state = 8, .external_lex_state = 14},
  [692] = {.lex_state = 8, .external_lex_state = 15},
  [693] = {.lex_state = 8, .external_lex_state = 14},
  [694] = {.lex_state = 8, .external_lex_state = 15},
  [695] = {.lex_state = 8, .external_lex_state = 15},
  [696] = {.lex_state = 8, .external_lex_state = 15},
  [697] = {.lex_state = 8, .external_lex_state = 14},
  [698] = {.lex_state = 8, .external_lex_state = 14},
  [699] = {.lex_state = 8, .external_lex_state = 15},
  [700] = {.lex_state = 8, .external_lex_state = 14},
  [701] = {.lex_state = 8, .external_lex_state = 14},
  [702] = {.lex_state = 8, .external_lex_state = 15},
  [703] = {.lex_state = 8, .external_lex_state = 15},
  [704] = {.lex_state = 8, .external_lex_state = 14},
  [705] = {.lex_state = 8, .external_lex_state = 15},
  [706] = {.lex_state = 8, .external_lex_state = 15},
  [707] = {.lex_state = 8, .external_lex_state = 15},
  [708] = {.lex_state = 8, .external_lex_state = 15},
  [709] = {.lex_state = 8, .external_lex_state = 14},
  [710] = {.lex_state = 8, .external_lex_state = 14},
  [711] = {.lex_state = 8, .external_lex_state = 15},
  [712] = {.lex_state = 8, .external_lex_state = 15},
  [713] = {.lex_state = 8, .external_lex_state = 15},
  [714] = {.lex_state = 8, .external_lex_state = 15},
  [715] = {.lex_state = 8, .external_lex_state = 15},
  [716] = {.lex_state = 8, .external_lex_state = 15},
  [717] = {.lex_state = 8, .external_lex_state = 15},
  [718] = {.lex_state = 8, .external_lex_state = 15},
  [719] = {.lex_state = 8, .external_lex_state = 15},
  [720] = {.lex_state = 8, .external_lex_state = 6},
  [721] = {.lex_state = 8, .external_lex_state = 6},
  [722] = {.lex_state = 51, .external_lex_state = 2},
  [723] = {.lex_state = 51, .external_lex_state = 2},
  [724] = {.lex_state = 8, .external_lex_state = 12},
  [725] = {.lex_state = 0, .external_lex_state = 16},
  [726] = {.lex_state = 8, .external_lex_state = 14},
  [727] = {.lex_state = 0, .external_lex_state = 16},
  [728] = {.lex_state = 8, .external_lex_state = 14},
  [729] = {.lex_state = 8, .external_lex_state = 14},
  [730] = {.lex_state = 8, .external_lex_state = 14},
  [731] = {.lex_state = 8, .external_lex_state = 14},
  [732] = {.lex_state = 0, .external_lex_state = 16},
  [733] = {.lex_state = 8, .external_lex_state = 14},
  [734] = {.lex_state = 8, .external_lex_state = 14},
  [735] = {.lex_state = 8, .external_lex_state = 12},
  [736] = {.lex_state = 8, .external_lex_state = 10},
  [737] = {.lex_state = 0, .external_lex_state = 2},
  [738] = {.lex_state = 0, .external_lex_state = 8},
  [739] = {.lex_state = 0, .external_lex_state = 2},
  [740] = {.lex_state = 0, .external_lex_state = 8},
  [741] = {.lex_state = 0, .external_lex_state = 8},
  [742] = {.lex_state = 0, .external_lex_state = 2},
  [743] = {.lex_state = 51, .external_lex_state = 6},
  [744] = {.lex_state = 51, .external_lex_state = 6},
  [745] = {.lex_state = 0, .external_lex_state = 2},
  [746] = {.lex_state = 51, .external_lex_state = 6},
  [747] = {.lex_state = 0, .external_lex_state = 2},
  [748] = {.lex_state = 0, .external_lex_state = 10},
  [749] = {.lex_state = 0, .external_lex_state = 6},
  [750] = {.lex_state = 0, .external_lex_state = 6},
  [751] = {.lex_state = 0, .external_lex_state = 10},
  [752] = {.lex_state = 0, .external_lex_state = 6},
  [753] = {.lex_state = 8, .external_lex_state = 12},
  [754] = {.lex_state = 8, .external_lex_state = 10},
  [755] = {.lex_state = 0, .external_lex_state = 16},
  [756] = {.lex_state = 0, .external_lex_state = 16},
  [757] = {.lex_state = 0, .external_lex_state = 16},
  [758] = {.lex_state = 8, .external_lex_state = 13},
  [759] = {.lex_state = 0, .external_lex_state = 16},
  [760] = {.lex_state = 8, .external_lex_state = 11},
  [761] = {.lex_state = 0, .external_lex_state = 16},
  [762] = {.lex_state = 8, .external_lex_state = 13},
  [763] = {.lex_state = 8, .external_lex_state = 11},
  [764] = {.lex_state = 0, .external_lex_state = 16},
  [765] = {.lex_state = 0, .external_lex_state = 16},
  [766] = {.lex_state = 8, .external_lex_state = 12},
  [767] = {.lex_state = 0, .external_lex_state = 16},
  [768] = {.lex_state = 8, .external_lex_state = 10},
  [769] = {.lex_state = 8, .external_lex_state = 14},
  [770] = {.lex_state = 8, .external_lex_state = 14},
  [771] = {.lex_state = 8, .external_lex_state = 15},
  [772] = {.lex_state = 8, .external_lex_state = 15},
  [773] = {.lex_state = 0, .external_lex_state = 6},
  [774] = {.lex_state = 0, .external_lex_state = 6},
  [775] = {.lex_state = 0, .external_lex_state = 6},
  [776] = {.lex_state = 0, .external_lex_state = 6},
  [777] = {.lex_state = 0, .external_lex_state = 6},
  [778] = {.lex_state = 0, .external_lex_state = 6},
  [779] = {.lex_state = 0, .external_lex_state = 6},
  [780] = {.lex_state = 0, .external_lex_state = 6},
  [781] = {.lex_state = 0, .external_lex_state = 6},
  [782] = {.lex_state = 0, .external_lex_state = 6},
  [783] = {.lex_state = 0, .external_lex_state = 6},
  [784] = {.lex_state = 0, .external_lex_state = 6},
  [785] = {.lex_state = 0, .external_lex_state = 6},
  [786] = {.lex_state = 0, .external_lex_state = 10},
  [787] = {.lex_state = 0, .external_lex_state = 15},
  [788] = {.lex_state = 51, .external_lex_state = 6},
  [789] = {.lex_state = 0, .external_lex_state = 10},
  [790] = {.lex_state = 0, .external_lex_state = 15},
  [791] = {.lex_state = 0, .external_lex_state = 10},
  [792] = {.lex_state = 0, .external_lex_state = 15},
  [793] = {.lex_state = 51, .external_lex_state = 6},
  [794] = {.lex_state = 0, .external_lex_state = 6},
  [795] = {.lex_state = 51, .external_lex_state = 6},
  [796] = {.lex_state = 0, .external_lex_state = 15},
  [797] = {.lex_state = 0, .external_lex_state = 15},
  [798] = {.lex_state = 51, .external_lex_state = 6},
  [799] = {.lex_state = 51, .external_lex_state = 6},
  [800] = {.lex_state = 51, .external_lex_state = 6},
  [801] = {.lex_state = 0, .external_lex_state = 15},
  [802] = {.lex_state = 51, .external_lex_state = 6},
  [803] = {.lex_state = 0, .external_lex_state = 10},
  [804] = {.lex_state = 0, .external_lex_state = 10},
  [805] = {.lex_state = 0, .external_lex_state = 10},
  [806] = {.lex_state = 51, .external_lex_state = 6},
  [807] = {.lex_state = 0, .external_lex_state = 6},
  [808] = {.lex_state = 0, .external_lex_state = 10},
  [809] = {.lex_state = 0, .external_lex_state = 10},
  [810] = {.lex_state = 51, .external_lex_state = 6},
  [811] = {.lex_state = 0, .external_lex_state = 10},
  [812] = {.lex_state = 0, .external_lex_state = 10},
  [813] = {.lex_state = 0, .external_lex_state = 10},
  [814] = {.lex_state = 51, .external_lex_state = 6},
  [815] = {.lex_state = 0, .external_lex_state = 10},
  [816] = {.lex_state = 0, .external_lex_state = 6},
  [817] = {.lex_state = 0, .external_lex_state = 10},
  [818] = {.lex_state = 51, .external_lex_state = 6},
  [819] = {.lex_state = 0, .external_lex_state = 6},
  [820] = {.lex_state = 0, .external_lex_state = 6},
  [821] = {.lex_state = 0, .external_lex_state = 2},
  [822] = {.lex_state = 51, .external_lex_state = 6},
  [823] = {.lex_state = 51, .external_lex_state = 6},
  [824] = {.lex_state = 0, .external_lex_state = 10},
  [825] = {.lex_state = 51, .external_lex_state = 6},
  [826] = {.lex_state = 51, .external_lex_state = 6},
  [827] = {.lex_state = 51, .external_lex_state = 6},
  [828] = {.lex_state = 0, .external_lex_state = 10},
  [829] = {.lex_state = 51, .external_lex_state = 6},
  [830] = {.lex_state = 0, .external_lex_state = 6},
  [831] = {.lex_state = 0, .external_lex_state = 2},
  [832] = {.lex_state = 0, .external_lex_state = 10},
  [833] = {.lex_state = 0, .external_lex_state = 10},
  [834] = {.lex_state = 51, .external_lex_state = 6},
  [835] = {.lex_state = 51, .external_lex_state = 6},
  [836] = {.lex_state = 51, .external_lex_state = 6},
  [837] = {.lex_state = 51, .external_lex_state = 6},
  [838] = {.lex_state = 51, .external_lex_state = 6},
  [839] = {.lex_state = 51, .external_lex_state = 6},
  [840] = {.lex_state = 0, .external_lex_state = 6},
  [841] = {.lex_state = 0, .external_lex_state = 10},
  [842] = {.lex_state = 0, .external_lex_state = 6},
  [843] = {.lex_state = 0, .external_lex_state = 10},
  [844] = {.lex_state = 16, .external_lex_state = 17},
  [845] = {.lex_state = 0, .external_lex_state = 6},
  [846] = {.lex_state = 0, .external_lex_state = 6},
  [847] = {.lex_state = 16, .external_lex_state = 17},
  [848] = {.lex_state = 0, .external_lex_state = 10},
  [849] = {.lex_state = 0, .external_lex_state = 10},
  [850] = {.lex_state = 0, .external_lex_state = 10},
  [851] = {.lex_state = 0, .external_lex_state = 18},
  [852] = {.lex_state = 0, .external_lex_state = 19},
  [853] = {.lex_state = 0, .external_lex_state = 18},
  [854] = {.lex_state = 51, .external_lex_state = 11},
  [855] = {.lex_state = 0, .external_lex_state = 10},
  [856] = {.lex_state = 0, .external_lex_state = 10},
  [857] = {.lex_state = 0, .external_lex_state = 6},
  [858] = {.lex_state = 16, .external_lex_state = 17},
  [859] = {.lex_state = 16, .external_lex_state = 17},
  [860] = {.lex_state = 0, .external_lex_state = 10},
  [861] = {.lex_state = 0, .external_lex_state = 6},
  [862] = {.lex_state = 0, .external_lex_state = 6},
  [863] = {.lex_state = 0, .external_lex_state = 10},
  [864] = {.lex_state = 0, .external_lex_state = 6},
  [865] = {.lex_state = 0, .external_lex_state = 6},
  [866] = {.lex_state = 16, .external_lex_state = 17},
  [867] = {.lex_state = 0, .external_lex_state = 6},
  [868] = {.lex_state = 0, .external_lex_state = 10},
  [869] = {.lex_state = 16, .external_lex_state = 17},
  [870] = {.lex_state = 0, .external_lex_state = 10},
  [871] = {.lex_state = 0, .external_lex_state = 10},
  [872] = {.lex_state = 0, .external_lex_state = 6},
  [873] = {.lex_state = 16, .external_lex_state = 17},
  [874] = {.lex_state = 16, .external_lex_state = 17},
  [875] = {.lex_state = 0, .external_lex_state = 6},
  [876] = {.lex_state = 0, .external_lex_state = 6},
  [877] = {.lex_state = 0, .external_lex_state = 20},
  [878] = {.lex_state = 16, .external_lex_state = 17},
  [879] = {.lex_state = 0, .external_lex_state = 10},
  [880] = {.lex_state = 0, .external_lex_state = 10},
  [881] = {.lex_state = 0, .external_lex_state = 10},
  [882] = {.lex_state = 16, .external_lex_state = 17},
  [883] = {.lex_state = 0, .external_lex_state = 10},
  [884] = {.lex_state = 16, .external_lex_state = 17},
  [885] = {.lex_state = 0, .external_lex_state = 6},
  [886] = {.lex_state = 16, .external_lex_state = 17},
  [887] = {.lex_state = 0, .external_lex_state = 6},
  [888] = {.lex_state = 0, .external_lex_state = 10},
  [889] = {.lex_state = 0, .external_lex_state = 10},
  [890] = {.lex_state = 0, .external_lex_state = 19},
  [891] = {.lex_state = 0, .external_lex_state = 6},
  [892] = {.lex_state = 0, .external_lex_state = 6},
  [893] = {.lex_state = 16, .external_lex_state = 17},
  [894] = {.lex_state = 0, .external_lex_state = 6},
  [895] = {.lex_state = 16, .external_lex_state = 17},
  [896] = {.lex_state = 0, .external_lex_state = 10},
  [897] = {.lex_state = 0, .external_lex_state = 18},
  [898] = {.lex_state = 0, .external_lex_state = 19},
  [899] = {.lex_state = 0, .external_lex_state = 6},
  [900] = {.lex_state = 0, .external_lex_state = 6},
  [901] = {.lex_state = 16, .external_lex_state = 17},
  [902] = {.lex_state = 16, .external_lex_state = 17},
  [903] = {.lex_state = 0, .external_lex_state = 6},
  [904] = {.lex_state = 0, .external_lex_state = 19},
  [905] = {.lex_state = 0, .external_lex_state = 18},
  [906] = {.lex_state = 0, .external_lex_state = 6},
  [907] = {.lex_state = 0, .external_lex_state = 6},
  [908] = {.lex_state = 16, .external_lex_state = 17},
  [909] = {.lex_state = 0, .external_lex_state = 11},
  [910] = {.lex_state = 51, .external_lex_state = 10},
  [911] = {.lex_state = 0, .external_lex_state = 10},
  [912] = {.lex_state = 51, .external_lex_state = 21},
  [913] = {.lex_state = 0, .external_lex_state = 6},
  [914] = {.lex_state = 51, .external_lex_state = 10},
  [915] = {.lex_state = 0, .external_lex_state = 11},
  [916] = {.lex_state = 0, .external_lex_state = 6},
  [917] = {.lex_state = 0, .external_lex_state = 13},
  [918] = {.lex_state = 0, .external_lex_state = 12},
  [919] = {.lex_state = 51, .external_lex_state = 10},
  [920] = {.lex_state = 0, .external_lex_state = 12},
  [921] = {.lex_state = 0, .external_lex_state = 6},
  [922] = {.lex_state = 0, .external_lex_state = 13},
  [923] = {.lex_state = 0, .external_lex_state = 11},
  [924] = {.lex_state = 0, .external_lex_state = 6},
  [925] = {.lex_state = 0, .external_lex_state = 13},
  [926] = {.lex_state = 0, .external_lex_state = 13},
  [927] = {.lex_state = 0, .external_lex_state = 6},
  [928] = {.lex_state = 0, .external_lex_state = 13},
  [929] = {.lex_state = 15, .external_lex_state = 10},
  [930] = {.lex_state = 0, .external_lex_state = 6},
  [931] = {.lex_state = 0, .external_lex_state = 13},
  [932] = {.lex_state = 0, .external_lex_state = 12},
  [933] = {.lex_state = 0, .external_lex_state = 11},
  [934] = {.lex_state = 51, .external_lex_state = 10},
  [935] = {.lex_state = 0, .external_lex_state = 13},
  [936] = {.lex_state = 0, .external_lex_state = 10},
  [937] = {.lex_state = 15, .external_lex_state = 10},
  [938] = {.lex_state = 0, .external_lex_state = 12},
  [939] = {.lex_state = 0, .external_lex_state = 12},
  [940] = {.lex_state = 0, .external_lex_state = 11},
  [941] = {.lex_state = 0, .external_lex_state = 6},
  [942] = {.lex_state = 0, .external_lex_state = 12},
  [943] = {.lex_state = 0, .external_lex_state = 13},
  [944] = {.lex_state = 0, .external_lex_state = 6},
  [945] = {.lex_state = 0, .external_lex_state = 12},
  [946] = {.lex_state = 0, .external_lex_state = 12},
  [947] = {.lex_state = 0, .external_lex_state = 6},
  [948] = {.lex_state = 0, .external_lex_state = 13},
  [949] = {.lex_state = 0, .external_lex_state = 13},
  [950] = {.lex_state = 0, .external_lex_state = 6},
  [951] = {.lex_state = 15, .external_lex_state = 10},
  [952] = {.lex_state = 15, .external_lex_state = 10},
  [953] = {.lex_state = 0, .external_lex_state = 6},
  [954] = {.lex_state = 15, .external_lex_state = 10},
  [955] = {.lex_state = 0, .external_lex_state = 6},
  [956] = {.lex_state = 0, .external_lex_state = 12},
  [957] = {.lex_state = 0, .external_lex_state = 6},
  [958] = {.lex_state = 0, .external_lex_state = 11},
  [959] = {.lex_state = 0, .external_lex_state = 13},
  [960] = {.lex_state = 0, .external_lex_state = 12},
  [961] = {.lex_state = 0, .external_lex_state = 12},
  [962] = {.lex_state = 0, .external_lex_state = 13},
  [963] = {.lex_state = 0, .external_lex_state = 11},
  [964] = {.lex_state = 0, .external_lex_state = 13},
  [965] = {.lex_state = 0, .external_lex_state = 12},
  [966] = {.lex_state = 0, .external_lex_state = 6},
  [967] = {.lex_state = 0, .external_lex_state = 6},
  [968] = {.lex_state = 0, .external_lex_state = 12},
  [969] = {.lex_state = 0, .external_lex_state = 10},
  [970] = {.lex_state = 0, .external_lex_state = 6},
  [971] = {.lex_state = 0, .external_lex_state = 6},
  [972] = {.lex_state = 0, .external_lex_state = 22},
  [973] = {.lex_state = 0, .external_lex_state = 6},
  [974] = {.lex_state = 51, .external_lex_state = 21},
  [975] = {.lex_state = 0, .external_lex_state = 12},
  [976] = {.lex_state = 0, .external_lex_state = 6},
  [977] = {.lex_state = 0, .external_lex_state = 22},
  [978] = {.lex_state = 0, .external_lex_state = 22},
  [979] = {.lex_state = 0, .external_lex_state = 11},
  [980] = {.lex_state = 0, .external_lex_state = 22},
  [981] = {.lex_state = 0, .external_lex_state = 13},
  [982] = {.lex_state = 15, .external_lex_state = 10},
  [983] = {.lex_state = 0, .external_lex_state = 12},
  [984] = {.lex_state = 15, .external_lex_state = 10},
  [985] = {.lex_state = 0, .external_lex_state = 22},
  [986] = {.lex_state = 0, .external_lex_state = 6},
  [987] = {.lex_state = 15, .external_lex_state = 10},
  [988] = {.lex_state = 0, .external_lex_state = 11},
  [989] = {.lex_state = 0, .external_lex_state = 22},
  [990] = {.lex_state = 0, .external_lex_state = 11},
  [991] = {.lex_state = 0, .external_lex_state = 13},
  [992] = {.lex_state = 0, .external_lex_state = 22},
  [993] = {.lex_state = 0, .external_lex_state = 22},
  [994] = {.lex_state = 0, .external_lex_state = 6},
  [995] = {.lex_state = 0, .external_lex_state = 12},
  [996] = {.lex_state = 0, .external_lex_state = 10},
  [997] = {.lex_state = 0, .external_lex_state = 6},
  [998] = {.lex_state = 15, .external_lex_state = 10},
  [999] = {.lex_state = 0, .external_lex_state = 11},
  [1000] = {.lex_state = 0, .external_lex_state = 13},
  [1001] = {.lex_state = 0, .external_lex_state = 12},
  [1002] = {.lex_state = 0, .external_lex_state = 11},
  [1003] = {.lex_state = 0, .external_lex_state = 21},
  [1004] = {.lex_state = 0, .external_lex_state = 6},
  [1005] = {.lex_state = 51, .external_lex_state = 21},
  [1006] = {.lex_state = 51, .external_lex_state = 10},
  [1007] = {.lex_state = 15, .external_lex_state = 10},
  [1008] = {.lex_state = 0, .external_lex_state = 6},
  [1009] = {.lex_state = 15, .external_lex_state = 10},
  [1010] = {.lex_state = 0, .external_lex_state = 11},
  [1011] = {.lex_state = 0, .external_lex_state = 6},
  [1012] = {.lex_state = 0, .external_lex_state = 10},
  [1013] = {.lex_state = 0, .external_lex_state = 6},
  [1014] = {.lex_state = 0, .external_lex_state = 6},
  [1015] = {.lex_state = 0, .external_lex_state = 6},
  [1016] = {.lex_state = 0, .external_lex_state = 6},
  [1017] = {.lex_state = 0, .external_lex_state = 11},
  [1018] = {.lex_state = 0, .external_lex_state = 12},
  [1019] = {.lex_state = 0, .external_lex_state = 6},
  [1020] = {.lex_state = 0, .external_lex_state = 6},
  [1021] = {.lex_state = 0, .external_lex_state = 6},
  [1022] = {.lex_state = 0, .external_lex_state = 13},
  [1023] = {.lex_state = 0, .external_lex_state = 13},
  [1024] = {.lex_state = 51, .external_lex_state = 10},
  [1025] = {.lex_state = 0, .external_lex_state = 12},
  [1026] = {.lex_state = 0, .external_lex_state = 6},
  [1027] = {.lex_state = 0, .external_lex_state = 10},
  [1028] = {.lex_state = 0, .external_lex_state = 13},
  [1029] = {.lex_state = 0, .external_lex_state = 12},
  [1030] = {.lex_state = 0, .external_lex_state = 12},
  [1031] = {.lex_state = 0, .external_lex_state = 13},
  [1032] = {.lex_state = 15, .external_lex_state = 10},
  [1033] = {.lex_state = 51, .external_lex_state = 10},
  [1034] = {.lex_state = 0, .external_lex_state = 11},
  [1035] = {.lex_state = 51, .external_lex_state = 10},
  [1036] = {.lex_state = 15, .external_lex_state = 10},
  [1037] = {.lex_state = 0, .external_lex_state = 12},
  [1038] = {.lex_state = 15, .external_lex_state = 10},
  [1039] = {.lex_state = 0, .external_lex_state = 12},
  [1040] = {.lex_state = 0, .external_lex_state = 11},
  [1041] = {.lex_state = 0, .external_lex_state = 13},
  [1042] = {.lex_state = 0, .external_lex_state = 11},
  [1043] = {.lex_state = 15, .external_lex_state = 10},
  [1044] = {.lex_state = 15, .external_lex_state = 10},
  [1045] = {.lex_state = 15, .external_lex_state = 10},
  [1046] = {.lex_state = 15, .external_lex_state = 10},
  [1047] = {.lex_state = 15, .external_lex_state = 10},
  [1048] = {.lex_state = 15, .external_lex_state = 10},
  [1049] = {.lex_state = 0, .external_lex_state = 11},
  [1050] = {.lex_state = 15, .external_lex_state = 10},
  [1051] = {.lex_state = 0, .external_lex_state = 13},
  [1052] = {.lex_state = 15, .external_lex_state = 10},
  [1053] = {.lex_state = 0, .external_lex_state = 12},
  [1054] = {.lex_state = 0, .external_lex_state = 12},
  [1055] = {.lex_state = 51, .external_lex_state = 10},
  [1056] = {.lex_state = 0, .external_lex_state = 11},
  [1057] = {.lex_state = 15, .external_lex_state = 10},
  [1058] = {.lex_state = 0, .external_lex_state = 12},
  [1059] = {.lex_state = 0, .external_lex_state = 12},
  [1060] = {.lex_state = 0, .external_lex_state = 10},
  [1061] = {.lex_state = 0, .external_lex_state = 11},
  [1062] = {.lex_state = 15, .external_lex_state = 10},
  [1063] = {.lex_state = 0, .external_lex_state = 6},
  [1064] = {.lex_state = 0, .external_lex_state = 6},
  [1065] = {.lex_state = 15, .external_lex_state = 10},
  [1066] = {.lex_state = 0, .external_lex_state = 12},
  [1067] = {.lex_state = 0, .external_lex_state = 13},
  [1068] = {.lex_state = 0, .external_lex_state = 12},
  [1069] = {.lex_state = 0, .external_lex_state = 13},
  [1070] = {.lex_state = 15, .external_lex_state = 10},
  [1071] = {.lex_state = 0, .external_lex_state = 12},
  [1072] = {.lex_state = 0, .external_lex_state = 6},
  [1073] = {.lex_state = 15, .external_lex_state = 10},
  [1074] = {.lex_state = 0, .external_lex_state = 6},
  [1075] = {.lex_state = 0, .external_lex_state = 10},
  [1076] = {.lex_state = 0, .external_lex_state = 11},
  [1077] = {.lex_state = 15, .external_lex_state = 10},
  [1078] = {.lex_state = 15, .external_lex_state = 10},
  [1079] = {.lex_state = 0, .external_lex_state = 12},
  [1080] = {.lex_state = 0, .external_lex_state = 13},
  [1081] = {.lex_state = 0, .external_lex_state = 11},
  [1082] = {.lex_state = 0, .external_lex_state = 6},
  [1083] = {.lex_state = 15, .external_lex_state = 10},
  [1084] = {.lex_state = 0, .external_lex_state = 12},
  [1085] = {.lex_state = 0, .external_lex_state = 13},
  [1086] = {.lex_state = 0, .external_lex_state = 6},
  [1087] = {.lex_state = 0, .external_lex_state = 11},
  [1088] = {.lex_state = 0, .external_lex_state = 11},
  [1089] = {.lex_state = 0, .external_lex_state = 6},
  [1090] = {.lex_state = 0, .external_lex_state = 10},
  [1091] = {.lex_state = 0, .external_lex_state = 6},
  [1092] = {.lex_state = 0, .external_lex_state = 11},
  [1093] = {.lex_state = 0, .external_lex_state = 11},
  [1094] = {.lex_state = 0, .external_lex_state = 6},
  [1095] = {.lex_state = 0, .external_lex_state = 6},
  [1096] = {.lex_state = 0, .external_lex_state = 6},
  [1097] = {.lex_state = 0, .external_lex_state = 10},
  [1098] = {.lex_state = 0, .external_lex_state = 11},
  [1099] = {.lex_state = 0, .external_lex_state = 10},
  [1100] = {.lex_state = 0, .external_lex_state = 11},
  [1101] = {.lex_state = 0, .external_lex_state = 13},
  [1102] = {.lex_state = 0, .external_lex_state = 10},
  [1103] = {.lex_state = 0, .external_lex_state = 10},
  [1104] = {.lex_state = 0, .external_lex_state = 10},
  [1105] = {.lex_state = 0, .external_lex_state = 11},
  [1106] = {.lex_state = 51, .external_lex_state = 10},
  [1107] = {.lex_state = 0, .external_lex_state = 10},
  [1108] = {.lex_state = 0, .external_lex_state = 10},
  [1109] = {.lex_state = 0, .external_lex_state = 14},
  [1110] = {.lex_state = 0, .external_lex_state = 10},
  [1111] = {.lex_state = 0, .external_lex_state = 10},
  [1112] = {.lex_state = 51, .external_lex_state = 10},
  [1113] = {.lex_state = 0, .external_lex_state = 10},
  [1114] = {.lex_state = 0, .external_lex_state = 20},
  [1115] = {.lex_state = 15, .external_lex_state = 10},
  [1116] = {.lex_state = 0, .external_lex_state = 10},
  [1117] = {.lex_state = 0, .external_lex_state = 10},
  [1118] = {.lex_state = 0, .external_lex_state = 10},
  [1119] = {.lex_state = 0, .external_lex_state = 14},
  [1120] = {.lex_state = 51, .external_lex_state = 10},
  [1121] = {.lex_state = 0, .external_lex_state = 10},
  [1122] = {.lex_state = 0, .external_lex_state = 10},
  [1123] = {.lex_state = 0, .external_lex_state = 10},
  [1124] = {.lex_state = 0, .external_lex_state = 2},
  [1125] = {.lex_state = 51, .external_lex_state = 10},
  [1126] = {.lex_state = 0, .external_lex_state = 10},
  [1127] = {.lex_state = 0, .external_lex_state = 20},
  [1128] = {.lex_state = 0, .external_lex_state = 10},
  [1129] = {.lex_state = 0, .external_lex_state = 10},
  [1130] = {.lex_state = 0, .external_lex_state = 10},
  [1131] = {.lex_state = 0, .external_lex_state = 15},
  [1132] = {.lex_state = 0, .external_lex_state = 10},
  [1133] = {.lex_state = 0, .external_lex_state = 13},
  [1134] = {.lex_state = 0, .external_lex_state = 10},
  [1135] = {.lex_state = 0, .external_lex_state = 10},
  [1136] = {.lex_state = 0, .external_lex_state = 10},
  [1137] = {.lex_state = 0, .external_lex_state = 10},
  [1138] = {.lex_state = 0, .external_lex_state = 10},
  [1139] = {.lex_state = 0, .external_lex_state = 12},
  [1140] = {.lex_state = 0, .external_lex_state = 2},
  [1141] = {.lex_state = 0, .external_lex_state = 14},
  [1142] = {.lex_state = 0, .external_lex_state = 2},
  [1143] = {.lex_state = 0, .external_lex_state = 10},
  [1144] = {.lex_state = 0, .external_lex_state = 10},
  [1145] = {.lex_state = 0, .external_lex_state = 10},
  [1146] = {.lex_state = 0, .external_lex_state = 2},
  [1147] = {.lex_state = 0, .external_lex_state = 13},
  [1148] = {.lex_state = 0, .external_lex_state = 10},
  [1149] = {.lex_state = 0, .external_lex_state = 10},
  [1150] = {.lex_state = 0, .external_lex_state = 10},
  [1151] = {.lex_state = 0, .external_lex_state = 10},
  [1152] = {.lex_state = 0, .external_lex_state = 10},
  [1153] = {.lex_state = 0, .external_lex_state = 13},
  [1154] = {.lex_state = 0, .external_lex_state = 12},
  [1155] = {.lex_state = 0, .external_lex_state = 12},
  [1156] = {.lex_state = 0, .external_lex_state = 12},
  [1157] = {.lex_state = 0, .external_lex_state = 12},
  [1158] = {.lex_state = 0, .external_lex_state = 12},
  [1159] = {.lex_state = 0, .external_lex_state = 12},
  [1160] = {.lex_state = 0, .external_lex_state = 10},
  [1161] = {.lex_state = 0, .external_lex_state = 14},
  [1162] = {.lex_state = 51, .external_lex_state = 21},
  [1163] = {.lex_state = 0, .external_lex_state = 10},
  [1164] = {.lex_state = 51, .external_lex_state = 21},
  [1165] = {.lex_state = 0, .external_lex_state = 10},
  [1166] = {.lex_state = 51, .external_lex_state = 21},
  [1167] = {.lex_state = 0, .external_lex_state = 13},
  [1168] = {.lex_state = 51, .external_lex_state = 10},
  [1169] = {.lex_state = 0, .external_lex_state = 10},
  [1170] = {.lex_state = 51, .external_lex_state = 21},
  [1171] = {.lex_state = 0, .external_lex_state = 10},
  [1172] = {.lex_state = 0, .external_lex_state = 13},
  [1173] = {.lex_state = 0, .external_lex_state = 10},
  [1174] = {.lex_state = 0, .external_lex_state = 13},
  [1175] = {.lex_state = 0, .external_lex_state = 2},
  [1176] = {.lex_state = 0, .external_lex_state = 10},
  [1177] = {.lex_state = 0, .external_lex_state = 10},
  [1178] = {.lex_state = 0, .external_lex_state = 10},
  [1179] = {.lex_state = 0, .external_lex_state = 13},
  [1180] = {.lex_state = 0, .external_lex_state = 10},
  [1181] = {.lex_state = 0, .external_lex_state = 13},
  [1182] = {.lex_state = 0, .external_lex_state = 11},
  [1183] = {.lex_state = 51, .external_lex_state = 21},
  [1184] = {.lex_state = 0, .external_lex_state = 10},
  [1185] = {.lex_state = 0, .external_lex_state = 10},
  [1186] = {.lex_state = 0, .external_lex_state = 12},
  [1187] = {.lex_state = 0, .external_lex_state = 12},
  [1188] = {.lex_state = 0, .external_lex_state = 10},
  [1189] = {.lex_state = 0, .external_lex_state = 10},
  [1190] = {.lex_state = 0, .external_lex_state = 10},
  [1191] = {.lex_state = 51, .external_lex_state = 10},
  [1192] = {.lex_state = 0, .external_lex_state = 10},
  [1193] = {.lex_state = 0, .external_lex_state = 11},
  [1194] = {.lex_state = 0, .external_lex_state = 10},
  [1195] = {.lex_state = 0, .external_lex_state = 10},
  [1196] = {.lex_state = 0, .external_lex_state = 14},
  [1197] = {.lex_state = 0, .external_lex_state = 10},
  [1198] = {.lex_state = 0, .external_lex_state = 22},
  [1199] = {.lex_state = 51, .external_lex_state = 21},
  [1200] = {.lex_state = 0, .external_lex_state = 13},
  [1201] = {.lex_state = 0, .external_lex_state = 10},
  [1202] = {.lex_state = 51, .external_lex_state = 10},
  [1203] = {.lex_state = 0, .external_lex_state = 10},
  [1204] = {.lex_state = 0, .external_lex_state = 10},
  [1205] = {.lex_state = 0, .external_lex_state = 12},
  [1206] = {.lex_state = 0, .external_lex_state = 13},
  [1207] = {.lex_state = 0, .external_lex_state = 10},
  [1208] = {.lex_state = 51, .external_lex_state = 10},
  [1209] = {.lex_state = 0, .external_lex_state = 15},
  [1210] = {.lex_state = 0, .external_lex_state = 2},
  [1211] = {.lex_state = 0, .external_lex_state = 11},
  [1212] = {.lex_state = 0, .external_lex_state = 10},
  [1213] = {.lex_state = 51, .external_lex_state = 10},
  [1214] = {.lex_state = 0, .external_lex_state = 10},
  [1215] = {.lex_state = 0, .external_lex_state = 10},
  [1216] = {.lex_state = 0, .external_lex_state = 13},
  [1217] = {.lex_state = 0, .external_lex_state = 10},
  [1218] = {.lex_state = 0, .external_lex_state = 10},
  [1219] = {.lex_state = 0, .external_lex_state = 10},
  [1220] = {.lex_state = 0, .external_lex_state = 10},
  [1221] = {.lex_state = 0, .external_lex_state = 15},
  [1222] = {.lex_state = 0, .external_lex_state = 13},
  [1223] = {.lex_state = 51, .external_lex_state = 10},
  [1224] = {.lex_state = 51, .external_lex_state = 21},
  [1225] = {.lex_state = 0, .external_lex_state = 15},
  [1226] = {.lex_state = 0, .external_lex_state = 10},
  [1227] = {.lex_state = 0, .external_lex_state = 10},
  [1228] = {.lex_state = 51, .external_lex_state = 21},
  [1229] = {.lex_state = 0, .external_lex_state = 13},
  [1230] = {.lex_state = 0, .external_lex_state = 10},
  [1231] = {.lex_state = 0, .external_lex_state = 14},
  [1232] = {.lex_state = 0, .external_lex_state = 11},
  [1233] = {.lex_state = 0, .external_lex_state = 13},
  [1234] = {.lex_state = 51, .external_lex_state = 10},
  [1235] = {.lex_state = 0, .external_lex_state = 10},
  [1236] = {.lex_state = 51, .external_lex_state = 10},
  [1237] = {.lex_state = 0, .external_lex_state = 10},
  [1238] = {.lex_state = 0, .external_lex_state = 12},
  [1239] = {.lex_state = 0, .external_lex_state = 11},
  [1240] = {.lex_state = 0, .external_lex_state = 12},
  [1241] = {.lex_state = 0, .external_lex_state = 13},
  [1242] = {.lex_state = 0, .external_lex_state = 11},
  [1243] = {.lex_state = 0, .external_lex_state = 12},
  [1244] = {.lex_state = 0, .external_lex_state = 14},
  [1245] = {.lex_state = 0, .external_lex_state = 2},
  [1246] = {.lex_state = 0, .external_lex_state = 2},
  [1247] = {.lex_state = 0, .external_lex_state = 12},
  [1248] = {.lex_state = 0, .external_lex_state = 10},
  [1249] = {.lex_state = 0, .external_lex_state = 10},
  [1250] = {.lex_state = 0, .external_lex_state = 10},
  [1251] = {.lex_state = 51, .external_lex_state = 21},
  [1252] = {.lex_state = 0, .external_lex_state = 10},
  [1253] = {.lex_state = 0, .external_lex_state = 11},
  [1254] = {.lex_state = 0, .external_lex_state = 11},
  [1255] = {.lex_state = 0, .external_lex_state = 10},
  [1256] = {.lex_state = 51, .external_lex_state = 21},
  [1257] = {.lex_state = 51, .external_lex_state = 10},
  [1258] = {.lex_state = 0, .external_lex_state = 10},
  [1259] = {.lex_state = 0, .external_lex_state = 10},
  [1260] = {.lex_state = 0, .external_lex_state = 10},
  [1261] = {.lex_state = 0, .external_lex_state = 10},
  [1262] = {.lex_state = 0, .external_lex_state = 12},
  [1263] = {.lex_state = 0, .external_lex_state = 10},
  [1264] = {.lex_state = 51, .external_lex_state = 21},
  [1265] = {.lex_state = 0, .external_lex_state = 10},
  [1266] = {.lex_state = 0, .external_lex_state = 14},
  [1267] = {.lex_state = 0, .external_lex_state = 11},
  [1268] = {.lex_state = 0, .external_lex_state = 11},
  [1269] = {.lex_state = 0, .external_lex_state = 12},
  [1270] = {.lex_state = 0, .external_lex_state = 10},
  [1271] = {.lex_state = 0, .external_lex_state = 11},
  [1272] = {.lex_state = 0, .external_lex_state = 10},
  [1273] = {.lex_state = 0, .external_lex_state = 13},
  [1274] = {.lex_state = 51, .external_lex_state = 21},
  [1275] = {.lex_state = 0, .external_lex_state = 10},
  [1276] = {.lex_state = 0, .external_lex_state = 12},
  [1277] = {.lex_state = 0, .external_lex_state = 10},
  [1278] = {.lex_state = 0, .external_lex_state = 10},
  [1279] = {.lex_state = 0, .external_lex_state = 11},
  [1280] = {.lex_state = 0, .external_lex_state = 10},
  [1281] = {.lex_state = 51, .external_lex_state = 10},
  [1282] = {.lex_state = 0, .external_lex_state = 12},
  [1283] = {.lex_state = 15, .external_lex_state = 10},
  [1284] = {.lex_state = 0, .external_lex_state = 22},
  [1285] = {.lex_state = 0, .external_lex_state = 14},
  [1286] = {.lex_state = 0, .external_lex_state = 13},
  [1287] = {.lex_state = 0, .external_lex_state = 10},
  [1288] = {.lex_state = 0, .external_lex_state = 13},
  [1289] = {.lex_state = 0, .external_lex_state = 12},
  [1290] = {.lex_state = 51, .external_lex_state = 10},
  [1291] = {.lex_state = 0, .external_lex_state = 12},
  [1292] = {.lex_state = 0, .external_lex_state = 10},
  [1293] = {.lex_state = 0, .external_lex_state = 12},
  [1294] = {.lex_state = 0, .external_lex_state = 14},
  [1295] = {.lex_state = 0, .external_lex_state = 10},
  [1296] = {.lex_state = 51, .external_lex_state = 10},
  [1297] = {.lex_state = 0, .external_lex_state = 12},
  [1298] = {.lex_state = 0, .external_lex_state = 13},
  [1299] = {.lex_state = 0, .external_lex_state = 10},
  [1300] = {.lex_state = 0, .external_lex_state = 12},
  [1301] = {.lex_state = 0, .external_lex_state = 10},
  [1302] = {.lex_state = 0, .external_lex_state = 10},
  [1303] = {.lex_state = 0, .external_lex_state = 10},
  [1304] = {.lex_state = 0, .external_lex_state = 10},
  [1305] = {.lex_state = 0, .external_lex_state = 10},
  [1306] = {.lex_state = 0, .external_lex_state = 12},
  [1307] = {.lex_state = 51, .external_lex_state = 10},
  [1308] = {.lex_state = 0, .external_lex_state = 15},
  [1309] = {.lex_state = 51, .external_lex_state = 10},
  [1310] = {.lex_state = 0, .external_lex_state = 10},
  [1311] = {.lex_state = 51, .external_lex_state = 10},
  [1312] = {.lex_state = 51, .external_lex_state = 10},
  [1313] = {.lex_state = 51, .external_lex_state = 10},
  [1314] = {.lex_state = 51, .external_lex_state = 10},
  [1315] = {.lex_state = 0, .external_lex_state = 10},
  [1316] = {.lex_state = 0, .external_lex_state = 15},
  [1317] = {.lex_state = 0, .external_lex_state = 10},
  [1318] = {.lex_state = 0, .external_lex_state = 22},
  [1319] = {.lex_state = 0, .external_lex_state = 15},
  [1320] = {.lex_state = 0, .external_lex_state = 20},
  [1321] = {.lex_state = 0, .external_lex_state = 15},
  [1322] = {.lex_state = 51, .external_lex_state = 10},
  [1323] = {.lex_state = 0, .external_lex_state = 22},
  [1324] = {.lex_state = 51, .external_lex_state = 10},
  [1325] = {.lex_state = 0, .external_lex_state = 15},
  [1326] = {.lex_state = 0, .external_lex_state = 21},
  [1327] = {.lex_state = 0, .external_lex_state = 15},
  [1328] = {.lex_state = 51, .external_lex_state = 10},
  [1329] = {.lex_state = 51, .external_lex_state = 10},
  [1330] = {.lex_state = 0, .external_lex_state = 15},
  [1331] = {.lex_state = 51, .external_lex_state = 10},
  [1332] = {.lex_state = 0, .external_lex_state = 10},
  [1333] = {.lex_state = 0, .external_lex_state = 10},
  [1334] = {.lex_state = 51, .external_lex_state = 10},
  [1335] = {.lex_state = 0, .external_lex_state = 21},
  [1336] = {.lex_state = 0, .external_lex_state = 15},
  [1337] = {.lex_state = 0, .external_lex_state = 22},
  [1338] = {.lex_state = 51, .external_lex_state = 10},
  [1339] = {.lex_state = 51, .external_lex_state = 10},
  [1340] = {.lex_state = 51, .external_lex_state = 10},
  [1341] = {.lex_state = 0, .external_lex_state = 10},
  [1342] = {.lex_state = 51, .external_lex_state = 10},
  [1343] = {.lex_state = 0, .external_lex_state = 22},
  [1344] = {.lex_state = 51, .external_lex_state = 10},
  [1345] = {.lex_state = 0, .external_lex_state = 22},
  [1346] = {.lex_state = 0, .external_lex_state = 15},
  [1347] = {.lex_state = 51, .external_lex_state = 10},
  [1348] = {.lex_state = 0, .external_lex_state = 15},
  [1349] = {.lex_state = 51, .external_lex_state = 10},
  [1350] = {.lex_state = 0, .external_lex_state = 21},
  [1351] = {.lex_state = 51, .external_lex_state = 10},
  [1352] = {.lex_state = 0, .external_lex_state = 22},
  [1353] = {.lex_state = 0, .external_lex_state = 10},
  [1354] = {.lex_state = 0, .external_lex_state = 21},
  [1355] = {.lex_state = 51, .external_lex_state = 10},
  [1356] = {.lex_state = 51, .external_lex_state = 10},
  [1357] = {.lex_state = 0, .external_lex_state = 21},
  [1358] = {.lex_state = 51, .external_lex_state = 10},
  [1359] = {.lex_state = 51, .external_lex_state = 10},
  [1360] = {.lex_state = 0, .external_lex_state = 15},
  [1361] = {.lex_state = 51, .external_lex_state = 10},
  [1362] = {.lex_state = 0, .external_lex_state = 21},
  [1363] = {.lex_state = 0, .external_lex_state = 22},
  [1364] = {.lex_state = 51, .external_lex_state = 10},
  [1365] = {.lex_state = 51, .external_lex_state = 10},
  [1366] = {.lex_state = 51, .external_lex_state = 10},
  [1367] = {.lex_state = 51, .external_lex_state = 10},
  [1368] = {.lex_state = 0, .external_lex_state = 22},
  [1369] = {.lex_state = 0, .external_lex_state = 15},
  [1370] = {.lex_state = 51, .external_lex_state = 10},
  [1371] = {.lex_state = 51, .external_lex_state = 10},
  [1372] = {.lex_state = 51, .external_lex_state = 10},
  [1373] = {.lex_state = 51, .external_lex_state = 10},
  [1374] = {.lex_state = 0, .external_lex_state = 15},
  [1375] = {.lex_state = 0, .external_lex_state = 15},
  [1376] = {.lex_state = 51, .external_lex_state = 10},
  [1377] = {.lex_state = 51, .external_lex_state = 10},
  [1378] = {.lex_state = 0, .external_lex_state = 15},
  [1379] = {.lex_state = 0, .external_lex_state = 10},
  [1380] = {.lex_state = 51, .external_lex_state = 10},
  [1381] = {.lex_state = 0, .external_lex_state = 10},
  [1382] = {.lex_state = 51, .external_lex_state = 10},
  [1383] = {.lex_state = 51, .external_lex_state = 10},
  [1384] = {.lex_state = 0, .external_lex_state = 15},
  [1385] = {.lex_state = 51, .external_lex_state = 10},
  [1386] = {.lex_state = 51, .external_lex_state = 10},
  [1387] = {.lex_state = 51, .external_lex_state = 10},
  [1388] = {.lex_state = 51, .external_lex_state = 10},
  [1389] = {.lex_state = 0, .external_lex_state = 15},
  [1390] = {.lex_state = 51, .external_lex_state = 10},
  [1391] = {.lex_state = 51, .external_lex_state = 10},
  [1392] = {.lex_state = 51, .external_lex_state = 10},
  [1393] = {.lex_state = 51, .external_lex_state = 10},
  [1394] = {.lex_state = 51, .external_lex_state = 10},
  [1395] = {.lex_state = 51, .external_lex_state = 10},
};

enum {
  ts_external_token__newline = 0,
  ts_external_token__indent = 1,
  ts_external_token__dedent = 2,
  ts_external_token__string_start = 3,
  ts_external_token__string_content = 4,
  ts_external_token__string_end = 5,
  ts_external_token_comment = 6,
  ts_external_token_RBRACK = 7,
  ts_external_token_RPAREN = 8,
  ts_external_token_RBRACE = 9,
  ts_external_token_COMMA = 10,
  ts_external_token__body_end = 11,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__indent] = sym__indent,
  [ts_external_token__dedent] = sym__dedent,
  [ts_external_token__string_start] = sym__string_start,
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token__string_end] = sym__string_end,
  [ts_external_token_comment] = sym_comment,
  [ts_external_token_RBRACK] = anon_sym_RBRACK,
  [ts_external_token_RPAREN] = anon_sym_RPAREN,
  [ts_external_token_RBRACE] = anon_sym_RBRACE,
  [ts_external_token_COMMA] = anon_sym_COMMA,
  [ts_external_token__body_end] = sym__body_end,
};

static const bool ts_external_scanner_states[23][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACK] = true,
    [ts_external_token_RPAREN] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__body_end] = true,
  },
  [2] = {
    [ts_external_token__string_start] = true,
    [ts_external_token_comment] = true,
  },
  [3] = {
    [ts_external_token__dedent] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token__body_end] = true,
  },
  [4] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token__body_end] = true,
  },
  [5] = {
    [ts_external_token__newline] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token__body_end] = true,
  },
  [6] = {
    [ts_external_token__newline] = true,
    [ts_external_token_comment] = true,
    [ts_external_token__body_end] = true,
  },
  [7] = {
    [ts_external_token__string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACE] = true,
  },
  [8] = {
    [ts_external_token__string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACK] = true,
  },
  [9] = {
    [ts_external_token__string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RPAREN] = true,
  },
  [10] = {
    [ts_external_token_comment] = true,
  },
  [11] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RPAREN] = true,
    [ts_external_token_COMMA] = true,
  },
  [12] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_COMMA] = true,
  },
  [13] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACK] = true,
    [ts_external_token_COMMA] = true,
  },
  [14] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACK] = true,
  },
  [15] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RPAREN] = true,
  },
  [16] = {
    [ts_external_token__dedent] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token_comment] = true,
  },
  [17] = {
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
    [ts_external_token_comment] = true,
  },
  [18] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACE] = true,
  },
  [19] = {
    [ts_external_token__newline] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_COMMA] = true,
    [ts_external_token__body_end] = true,
  },
  [20] = {
    [ts_external_token__indent] = true,
    [ts_external_token_comment] = true,
  },
  [21] = {
    [ts_external_token_comment] = true,
    [ts_external_token_COMMA] = true,
  },
  [22] = {
    [ts_external_token__dedent] = true,
    [ts_external_token_comment] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym__identifier] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_underscore] = ACTIONS(1),
    [sym_static_keyword] = ACTIONS(1),
    [anon_sym_remote] = ACTIONS(1),
    [anon_sym_master] = ACTIONS(1),
    [anon_sym_puppet] = ACTIONS(1),
    [anon_sym_remotesync] = ACTIONS(1),
    [anon_sym_mastersync] = ACTIONS(1),
    [anon_sym_puppetsync] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [sym_node_path] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_setget] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_onready] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_pass] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [sym_breakpoint_statement] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [sym_tool_statement] = ACTIONS(1),
    [anon_sym_signal] = ACTIONS(1),
    [anon_sym_class_name] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [sym_pattern_open_ending] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_func] = ACTIONS(1),
    [anon_sym__init] = ACTIONS(1),
    [sym__newline] = ACTIONS(1),
    [sym__indent] = ACTIONS(1),
    [sym__dedent] = ACTIONS(1),
    [sym__string_start] = ACTIONS(1),
    [sym__string_content] = ACTIONS(1),
    [sym__string_end] = ACTIONS(1),
    [sym__body_end] = ACTIONS(1),
  },
  [1] = {
    [sym_source] = STATE(1315),
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(791),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(23),
    [sym__simple_statements] = STATE(23),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1299),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym_if_statement] = STATE(23),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_class_definition] = STATE(23),
    [sym_enum_definition] = STATE(23),
    [sym_match_statement] = STATE(23),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(23),
    [sym_constructor_definition] = STATE(23),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(23),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_static_keyword] = ACTIONS(11),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_for] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_class] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_func] = ACTIONS(71),
    [sym__string_start] = ACTIONS(73),
  },
  [2] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(789),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(9),
    [sym__simple_statements] = STATE(9),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1099),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym_if_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_class_definition] = STATE(9),
    [sym_enum_definition] = STATE(9),
    [sym_match_statement] = STATE(9),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(9),
    [sym_constructor_definition] = STATE(9),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(9),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_static_keyword] = ACTIONS(75),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_class] = ACTIONS(85),
    [anon_sym_enum] = ACTIONS(87),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(89),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_func] = ACTIONS(91),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(93),
  },
  [3] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(789),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(12),
    [sym__simple_statements] = STATE(12),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1099),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym_if_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_class_definition] = STATE(12),
    [sym_enum_definition] = STATE(12),
    [sym_match_statement] = STATE(12),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(12),
    [sym_constructor_definition] = STATE(12),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(12),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_static_keyword] = ACTIONS(75),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_class] = ACTIONS(85),
    [anon_sym_enum] = ACTIONS(87),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(89),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_func] = ACTIONS(91),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(95),
  },
  [4] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(789),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(5),
    [sym__simple_statements] = STATE(5),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1099),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym_if_statement] = STATE(5),
    [sym_for_statement] = STATE(5),
    [sym_while_statement] = STATE(5),
    [sym_class_definition] = STATE(5),
    [sym_enum_definition] = STATE(5),
    [sym_match_statement] = STATE(5),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(5),
    [sym_constructor_definition] = STATE(5),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(5),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_static_keyword] = ACTIONS(75),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_class] = ACTIONS(85),
    [anon_sym_enum] = ACTIONS(87),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(89),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_func] = ACTIONS(91),
    [sym__dedent] = ACTIONS(97),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(97),
  },
  [5] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(789),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(16),
    [sym__simple_statements] = STATE(16),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1099),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym_if_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_class_definition] = STATE(16),
    [sym_enum_definition] = STATE(16),
    [sym_match_statement] = STATE(16),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(16),
    [sym_constructor_definition] = STATE(16),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(16),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_static_keyword] = ACTIONS(75),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_class] = ACTIONS(85),
    [anon_sym_enum] = ACTIONS(87),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(89),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_func] = ACTIONS(91),
    [sym__dedent] = ACTIONS(99),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(99),
  },
  [6] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(789),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(7),
    [sym__simple_statements] = STATE(7),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1099),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym_if_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_class_definition] = STATE(7),
    [sym_enum_definition] = STATE(7),
    [sym_match_statement] = STATE(7),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(7),
    [sym_constructor_definition] = STATE(7),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(7),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_static_keyword] = ACTIONS(75),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_class] = ACTIONS(85),
    [anon_sym_enum] = ACTIONS(87),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(89),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_func] = ACTIONS(91),
    [sym__dedent] = ACTIONS(101),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(101),
  },
  [7] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(789),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(16),
    [sym__simple_statements] = STATE(16),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1099),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym_if_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_class_definition] = STATE(16),
    [sym_enum_definition] = STATE(16),
    [sym_match_statement] = STATE(16),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(16),
    [sym_constructor_definition] = STATE(16),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(16),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_static_keyword] = ACTIONS(75),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_class] = ACTIONS(85),
    [anon_sym_enum] = ACTIONS(87),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(89),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_func] = ACTIONS(91),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(103),
  },
  [8] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(789),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(10),
    [sym__simple_statements] = STATE(10),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1099),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym_if_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_class_definition] = STATE(10),
    [sym_enum_definition] = STATE(10),
    [sym_match_statement] = STATE(10),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(10),
    [sym_constructor_definition] = STATE(10),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(10),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_static_keyword] = ACTIONS(75),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_class] = ACTIONS(85),
    [anon_sym_enum] = ACTIONS(87),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(89),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_func] = ACTIONS(91),
    [sym__dedent] = ACTIONS(105),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(105),
  },
  [9] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(789),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(16),
    [sym__simple_statements] = STATE(16),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1099),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym_if_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_class_definition] = STATE(16),
    [sym_enum_definition] = STATE(16),
    [sym_match_statement] = STATE(16),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(16),
    [sym_constructor_definition] = STATE(16),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(16),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_static_keyword] = ACTIONS(75),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_class] = ACTIONS(85),
    [anon_sym_enum] = ACTIONS(87),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(89),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_func] = ACTIONS(91),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(107),
  },
  [10] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(789),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(16),
    [sym__simple_statements] = STATE(16),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1099),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym_if_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_class_definition] = STATE(16),
    [sym_enum_definition] = STATE(16),
    [sym_match_statement] = STATE(16),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(16),
    [sym_constructor_definition] = STATE(16),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(16),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_static_keyword] = ACTIONS(75),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_class] = ACTIONS(85),
    [anon_sym_enum] = ACTIONS(87),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(89),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_func] = ACTIONS(91),
    [sym__dedent] = ACTIONS(109),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(109),
  },
  [11] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(789),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(16),
    [sym__simple_statements] = STATE(16),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1099),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym_if_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_class_definition] = STATE(16),
    [sym_enum_definition] = STATE(16),
    [sym_match_statement] = STATE(16),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(16),
    [sym_constructor_definition] = STATE(16),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(16),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_static_keyword] = ACTIONS(75),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_class] = ACTIONS(85),
    [anon_sym_enum] = ACTIONS(87),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(89),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_func] = ACTIONS(91),
    [sym__dedent] = ACTIONS(111),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(111),
  },
  [12] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(789),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(16),
    [sym__simple_statements] = STATE(16),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1099),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym_if_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_class_definition] = STATE(16),
    [sym_enum_definition] = STATE(16),
    [sym_match_statement] = STATE(16),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(16),
    [sym_constructor_definition] = STATE(16),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(16),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_static_keyword] = ACTIONS(75),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_class] = ACTIONS(85),
    [anon_sym_enum] = ACTIONS(87),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(89),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_func] = ACTIONS(91),
    [sym__dedent] = ACTIONS(113),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(113),
  },
  [13] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(789),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(11),
    [sym__simple_statements] = STATE(11),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1099),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym_if_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_class_definition] = STATE(11),
    [sym_enum_definition] = STATE(11),
    [sym_match_statement] = STATE(11),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(11),
    [sym_constructor_definition] = STATE(11),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(11),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_static_keyword] = ACTIONS(75),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_class] = ACTIONS(85),
    [anon_sym_enum] = ACTIONS(87),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(89),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_func] = ACTIONS(91),
    [sym__dedent] = ACTIONS(115),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(115),
  },
  [14] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(789),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(21),
    [sym__simple_statements] = STATE(21),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1099),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym_if_statement] = STATE(21),
    [sym_for_statement] = STATE(21),
    [sym_while_statement] = STATE(21),
    [sym_class_definition] = STATE(21),
    [sym_enum_definition] = STATE(21),
    [sym_match_statement] = STATE(21),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(21),
    [sym_constructor_definition] = STATE(21),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(21),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_static_keyword] = ACTIONS(75),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_class] = ACTIONS(85),
    [anon_sym_enum] = ACTIONS(87),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(89),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_func] = ACTIONS(91),
    [sym__dedent] = ACTIONS(117),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(117),
  },
  [15] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(789),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(16),
    [sym__simple_statements] = STATE(16),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1099),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym_if_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_class_definition] = STATE(16),
    [sym_enum_definition] = STATE(16),
    [sym_match_statement] = STATE(16),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(16),
    [sym_constructor_definition] = STATE(16),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(16),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_static_keyword] = ACTIONS(75),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_class] = ACTIONS(85),
    [anon_sym_enum] = ACTIONS(87),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(89),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_func] = ACTIONS(91),
    [sym__dedent] = ACTIONS(119),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(119),
  },
  [16] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(789),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(16),
    [sym__simple_statements] = STATE(16),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1099),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym_if_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_class_definition] = STATE(16),
    [sym_enum_definition] = STATE(16),
    [sym_match_statement] = STATE(16),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(16),
    [sym_constructor_definition] = STATE(16),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(16),
    [sym__identifier] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(124),
    [sym_false] = ACTIONS(124),
    [sym_null] = ACTIONS(124),
    [sym_static_keyword] = ACTIONS(127),
    [anon_sym_remote] = ACTIONS(130),
    [anon_sym_master] = ACTIONS(130),
    [anon_sym_puppet] = ACTIONS(130),
    [anon_sym_remotesync] = ACTIONS(130),
    [anon_sym_mastersync] = ACTIONS(130),
    [anon_sym_puppetsync] = ACTIONS(130),
    [sym_float] = ACTIONS(133),
    [sym_integer] = ACTIONS(124),
    [anon_sym_AMP] = ACTIONS(136),
    [sym_node_path] = ACTIONS(133),
    [sym_get_node] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(139),
    [anon_sym_var] = ACTIONS(142),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_onready] = ACTIONS(148),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(154),
    [anon_sym_pass] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(160),
    [sym_breakpoint_statement] = ACTIONS(163),
    [anon_sym_continue] = ACTIONS(166),
    [sym_tool_statement] = ACTIONS(163),
    [anon_sym_signal] = ACTIONS(169),
    [anon_sym_class_name] = ACTIONS(172),
    [anon_sym_DOT] = ACTIONS(175),
    [anon_sym_extends] = ACTIONS(178),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_for] = ACTIONS(184),
    [anon_sym_while] = ACTIONS(187),
    [anon_sym_class] = ACTIONS(190),
    [anon_sym_enum] = ACTIONS(193),
    [anon_sym_LBRACE] = ACTIONS(196),
    [anon_sym_match] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(202),
    [anon_sym_PLUS] = ACTIONS(205),
    [anon_sym_DASH] = ACTIONS(205),
    [anon_sym_not] = ACTIONS(208),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_LPAREN] = ACTIONS(211),
    [anon_sym_await] = ACTIONS(214),
    [anon_sym_func] = ACTIONS(217),
    [sym__dedent] = ACTIONS(220),
    [sym__string_start] = ACTIONS(222),
    [sym__body_end] = ACTIONS(220),
  },
  [17] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(789),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(16),
    [sym__simple_statements] = STATE(16),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1099),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym_if_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_class_definition] = STATE(16),
    [sym_enum_definition] = STATE(16),
    [sym_match_statement] = STATE(16),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(16),
    [sym_constructor_definition] = STATE(16),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(16),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_static_keyword] = ACTIONS(75),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_class] = ACTIONS(85),
    [anon_sym_enum] = ACTIONS(87),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(89),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_func] = ACTIONS(91),
    [sym__dedent] = ACTIONS(225),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(225),
  },
  [18] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(789),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(17),
    [sym__simple_statements] = STATE(17),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1099),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym_if_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_class_definition] = STATE(17),
    [sym_enum_definition] = STATE(17),
    [sym_match_statement] = STATE(17),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(17),
    [sym_constructor_definition] = STATE(17),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(17),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_static_keyword] = ACTIONS(75),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_class] = ACTIONS(85),
    [anon_sym_enum] = ACTIONS(87),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(89),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_func] = ACTIONS(91),
    [sym__dedent] = ACTIONS(227),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(227),
  },
  [19] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(789),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(15),
    [sym__simple_statements] = STATE(15),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1099),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym_if_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_while_statement] = STATE(15),
    [sym_class_definition] = STATE(15),
    [sym_enum_definition] = STATE(15),
    [sym_match_statement] = STATE(15),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(15),
    [sym_constructor_definition] = STATE(15),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(15),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_static_keyword] = ACTIONS(75),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_class] = ACTIONS(85),
    [anon_sym_enum] = ACTIONS(87),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(89),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_func] = ACTIONS(91),
    [sym__dedent] = ACTIONS(229),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(229),
  },
  [20] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(789),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(16),
    [sym__simple_statements] = STATE(16),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1099),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym_if_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_class_definition] = STATE(16),
    [sym_enum_definition] = STATE(16),
    [sym_match_statement] = STATE(16),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(16),
    [sym_constructor_definition] = STATE(16),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(16),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_static_keyword] = ACTIONS(75),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_class] = ACTIONS(85),
    [anon_sym_enum] = ACTIONS(87),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(89),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_func] = ACTIONS(91),
    [sym__dedent] = ACTIONS(231),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(231),
  },
  [21] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(789),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(16),
    [sym__simple_statements] = STATE(16),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1099),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym_if_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_class_definition] = STATE(16),
    [sym_enum_definition] = STATE(16),
    [sym_match_statement] = STATE(16),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(16),
    [sym_constructor_definition] = STATE(16),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(16),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_static_keyword] = ACTIONS(75),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_class] = ACTIONS(85),
    [anon_sym_enum] = ACTIONS(87),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(89),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_func] = ACTIONS(91),
    [sym__dedent] = ACTIONS(233),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(233),
  },
  [22] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(789),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(20),
    [sym__simple_statements] = STATE(20),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1099),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym_if_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_class_definition] = STATE(20),
    [sym_enum_definition] = STATE(20),
    [sym_match_statement] = STATE(20),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(20),
    [sym_constructor_definition] = STATE(20),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(20),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_static_keyword] = ACTIONS(75),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_class] = ACTIONS(85),
    [anon_sym_enum] = ACTIONS(87),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(89),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_func] = ACTIONS(91),
    [sym__dedent] = ACTIONS(235),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(235),
  },
  [23] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(791),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(24),
    [sym__simple_statements] = STATE(24),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1299),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym_if_statement] = STATE(24),
    [sym_for_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_class_definition] = STATE(24),
    [sym_enum_definition] = STATE(24),
    [sym_match_statement] = STATE(24),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(24),
    [sym_constructor_definition] = STATE(24),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(24),
    [ts_builtin_sym_end] = ACTIONS(237),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [sym_static_keyword] = ACTIONS(11),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_for] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_class] = ACTIONS(53),
    [anon_sym_enum] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_func] = ACTIONS(71),
    [sym__string_start] = ACTIONS(73),
  },
  [24] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(791),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym__statement] = STATE(24),
    [sym__simple_statements] = STATE(24),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1299),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym_if_statement] = STATE(24),
    [sym_for_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_class_definition] = STATE(24),
    [sym_enum_definition] = STATE(24),
    [sym_match_statement] = STATE(24),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_function_definition] = STATE(24),
    [sym_constructor_definition] = STATE(24),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [aux_sym_source_repeat1] = STATE(24),
    [ts_builtin_sym_end] = ACTIONS(220),
    [sym__identifier] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(124),
    [sym_false] = ACTIONS(124),
    [sym_null] = ACTIONS(124),
    [sym_static_keyword] = ACTIONS(239),
    [anon_sym_remote] = ACTIONS(130),
    [anon_sym_master] = ACTIONS(130),
    [anon_sym_puppet] = ACTIONS(130),
    [anon_sym_remotesync] = ACTIONS(130),
    [anon_sym_mastersync] = ACTIONS(130),
    [anon_sym_puppetsync] = ACTIONS(130),
    [sym_float] = ACTIONS(133),
    [sym_integer] = ACTIONS(124),
    [anon_sym_AMP] = ACTIONS(136),
    [sym_node_path] = ACTIONS(133),
    [sym_get_node] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(139),
    [anon_sym_var] = ACTIONS(142),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_onready] = ACTIONS(148),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(154),
    [anon_sym_pass] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(160),
    [sym_breakpoint_statement] = ACTIONS(242),
    [anon_sym_continue] = ACTIONS(166),
    [sym_tool_statement] = ACTIONS(242),
    [anon_sym_signal] = ACTIONS(169),
    [anon_sym_class_name] = ACTIONS(172),
    [anon_sym_DOT] = ACTIONS(175),
    [anon_sym_extends] = ACTIONS(178),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(248),
    [anon_sym_while] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(254),
    [anon_sym_enum] = ACTIONS(257),
    [anon_sym_LBRACE] = ACTIONS(196),
    [anon_sym_match] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(202),
    [anon_sym_PLUS] = ACTIONS(205),
    [anon_sym_DASH] = ACTIONS(205),
    [anon_sym_not] = ACTIONS(208),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_LPAREN] = ACTIONS(211),
    [anon_sym_await] = ACTIONS(214),
    [anon_sym_func] = ACTIONS(263),
    [sym__string_start] = ACTIONS(222),
  },
  [25] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(1384),
    [sym__simple_statements] = STATE(1346),
    [sym_expression_statement] = STATE(899),
    [sym_annotation] = STATE(780),
    [aux_sym__annotations] = STATE(780),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(899),
    [sym_export_variable_statement] = STATE(899),
    [sym_onready_variable_statement] = STATE(899),
    [sym_const_statement] = STATE(899),
    [sym_return_statement] = STATE(899),
    [sym_pass_statement] = STATE(899),
    [sym_break_statement] = STATE(899),
    [sym_continue_statement] = STATE(899),
    [sym_signal_statement] = STATE(899),
    [sym_class_name_statement] = STATE(899),
    [sym_extends_statement] = STATE(899),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(266),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(266),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(268),
    [sym__indent] = ACTIONS(270),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(268),
  },
  [26] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(1378),
    [sym__simple_statements] = STATE(1346),
    [sym_expression_statement] = STATE(899),
    [sym_annotation] = STATE(780),
    [aux_sym__annotations] = STATE(780),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(899),
    [sym_export_variable_statement] = STATE(899),
    [sym_onready_variable_statement] = STATE(899),
    [sym_const_statement] = STATE(899),
    [sym_return_statement] = STATE(899),
    [sym_pass_statement] = STATE(899),
    [sym_break_statement] = STATE(899),
    [sym_continue_statement] = STATE(899),
    [sym_signal_statement] = STATE(899),
    [sym_class_name_statement] = STATE(899),
    [sym_extends_statement] = STATE(899),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(266),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(266),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(268),
    [sym__indent] = ACTIONS(270),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(268),
  },
  [27] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(199),
    [sym__simple_statements] = STATE(135),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(272),
    [sym__indent] = ACTIONS(274),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(272),
  },
  [28] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(173),
    [sym__simple_statements] = STATE(135),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(272),
    [sym__indent] = ACTIONS(274),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(272),
  },
  [29] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(168),
    [sym__simple_statements] = STATE(130),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(276),
    [sym__indent] = ACTIONS(278),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(276),
  },
  [30] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(1273),
    [sym__simple_statements] = STATE(1153),
    [sym_expression_statement] = STATE(885),
    [sym_annotation] = STATE(775),
    [aux_sym__annotations] = STATE(775),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(885),
    [sym_export_variable_statement] = STATE(885),
    [sym_onready_variable_statement] = STATE(885),
    [sym_const_statement] = STATE(885),
    [sym_return_statement] = STATE(885),
    [sym_pass_statement] = STATE(885),
    [sym_break_statement] = STATE(885),
    [sym_continue_statement] = STATE(885),
    [sym_signal_statement] = STATE(885),
    [sym_class_name_statement] = STATE(885),
    [sym_extends_statement] = STATE(885),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(280),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(280),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(282),
    [sym__indent] = ACTIONS(284),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(282),
  },
  [31] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(1198),
    [sym__simple_statements] = STATE(972),
    [sym_expression_statement] = STATE(876),
    [sym_annotation] = STATE(784),
    [aux_sym__annotations] = STATE(784),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(876),
    [sym_export_variable_statement] = STATE(876),
    [sym_onready_variable_statement] = STATE(876),
    [sym_const_statement] = STATE(876),
    [sym_return_statement] = STATE(876),
    [sym_pass_statement] = STATE(876),
    [sym_break_statement] = STATE(876),
    [sym_continue_statement] = STATE(876),
    [sym_signal_statement] = STATE(876),
    [sym_class_name_statement] = STATE(876),
    [sym_extends_statement] = STATE(876),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(286),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(286),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(288),
    [sym__indent] = ACTIONS(290),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(288),
  },
  [32] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(153),
    [sym__simple_statements] = STATE(130),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(276),
    [sym__indent] = ACTIONS(278),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(276),
  },
  [33] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(193),
    [sym__simple_statements] = STATE(135),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(272),
    [sym__indent] = ACTIONS(274),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(272),
  },
  [34] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(191),
    [sym__simple_statements] = STATE(135),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(272),
    [sym__indent] = ACTIONS(274),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(272),
  },
  [35] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(194),
    [sym__simple_statements] = STATE(135),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(272),
    [sym__indent] = ACTIONS(274),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(272),
  },
  [36] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(818),
    [sym__simple_statements] = STATE(839),
    [sym_expression_statement] = STATE(864),
    [sym_annotation] = STATE(785),
    [aux_sym__annotations] = STATE(785),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(864),
    [sym_export_variable_statement] = STATE(864),
    [sym_onready_variable_statement] = STATE(864),
    [sym_const_statement] = STATE(864),
    [sym_return_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_signal_statement] = STATE(864),
    [sym_class_name_statement] = STATE(864),
    [sym_extends_statement] = STATE(864),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(292),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(292),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(294),
    [sym__indent] = ACTIONS(296),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(294),
  },
  [37] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(187),
    [sym__simple_statements] = STATE(135),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(272),
    [sym__indent] = ACTIONS(274),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(272),
  },
  [38] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(201),
    [sym__simple_statements] = STATE(135),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(272),
    [sym__indent] = ACTIONS(274),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(272),
  },
  [39] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(185),
    [sym__simple_statements] = STATE(135),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(272),
    [sym__indent] = ACTIONS(274),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(272),
  },
  [40] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(196),
    [sym__simple_statements] = STATE(135),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(272),
    [sym__indent] = ACTIONS(274),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(272),
  },
  [41] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(1284),
    [sym__simple_statements] = STATE(972),
    [sym_expression_statement] = STATE(876),
    [sym_annotation] = STATE(784),
    [aux_sym__annotations] = STATE(784),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(876),
    [sym_export_variable_statement] = STATE(876),
    [sym_onready_variable_statement] = STATE(876),
    [sym_const_statement] = STATE(876),
    [sym_return_statement] = STATE(876),
    [sym_pass_statement] = STATE(876),
    [sym_break_statement] = STATE(876),
    [sym_continue_statement] = STATE(876),
    [sym_signal_statement] = STATE(876),
    [sym_class_name_statement] = STATE(876),
    [sym_extends_statement] = STATE(876),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(286),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(286),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(288),
    [sym__indent] = ACTIONS(290),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(288),
  },
  [42] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(137),
    [sym__simple_statements] = STATE(135),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(272),
    [sym__indent] = ACTIONS(274),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(272),
  },
  [43] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(127),
    [sym__simple_statements] = STATE(130),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(276),
    [sym__indent] = ACTIONS(278),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(276),
  },
  [44] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(767),
    [sym__simple_statements] = STATE(757),
    [sym_expression_statement] = STATE(862),
    [sym_annotation] = STATE(781),
    [aux_sym__annotations] = STATE(781),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(862),
    [sym_export_variable_statement] = STATE(862),
    [sym_onready_variable_statement] = STATE(862),
    [sym_const_statement] = STATE(862),
    [sym_return_statement] = STATE(862),
    [sym_pass_statement] = STATE(862),
    [sym_break_statement] = STATE(862),
    [sym_continue_statement] = STATE(862),
    [sym_signal_statement] = STATE(862),
    [sym_class_name_statement] = STATE(862),
    [sym_extends_statement] = STATE(862),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(298),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(298),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(300),
    [sym__indent] = ACTIONS(302),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(300),
  },
  [45] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(143),
    [sym__simple_statements] = STATE(130),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(276),
    [sym__indent] = ACTIONS(278),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(276),
  },
  [46] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(183),
    [sym__simple_statements] = STATE(135),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(272),
    [sym__indent] = ACTIONS(274),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(272),
  },
  [47] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(181),
    [sym__simple_statements] = STATE(135),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(272),
    [sym__indent] = ACTIONS(274),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(272),
  },
  [48] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(1286),
    [sym__simple_statements] = STATE(1153),
    [sym_expression_statement] = STATE(885),
    [sym_annotation] = STATE(775),
    [aux_sym__annotations] = STATE(775),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(885),
    [sym_export_variable_statement] = STATE(885),
    [sym_onready_variable_statement] = STATE(885),
    [sym_const_statement] = STATE(885),
    [sym_return_statement] = STATE(885),
    [sym_pass_statement] = STATE(885),
    [sym_break_statement] = STATE(885),
    [sym_continue_statement] = STATE(885),
    [sym_signal_statement] = STATE(885),
    [sym_class_name_statement] = STATE(885),
    [sym_extends_statement] = STATE(885),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(280),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(280),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(282),
    [sym__indent] = ACTIONS(284),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(282),
  },
  [49] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(1288),
    [sym__simple_statements] = STATE(1153),
    [sym_expression_statement] = STATE(885),
    [sym_annotation] = STATE(775),
    [aux_sym__annotations] = STATE(775),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(885),
    [sym_export_variable_statement] = STATE(885),
    [sym_onready_variable_statement] = STATE(885),
    [sym_const_statement] = STATE(885),
    [sym_return_statement] = STATE(885),
    [sym_pass_statement] = STATE(885),
    [sym_break_statement] = STATE(885),
    [sym_continue_statement] = STATE(885),
    [sym_signal_statement] = STATE(885),
    [sym_class_name_statement] = STATE(885),
    [sym_extends_statement] = STATE(885),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(280),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(280),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(282),
    [sym__indent] = ACTIONS(284),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(282),
  },
  [50] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(1298),
    [sym__simple_statements] = STATE(1153),
    [sym_expression_statement] = STATE(885),
    [sym_annotation] = STATE(775),
    [aux_sym__annotations] = STATE(775),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(885),
    [sym_export_variable_statement] = STATE(885),
    [sym_onready_variable_statement] = STATE(885),
    [sym_const_statement] = STATE(885),
    [sym_return_statement] = STATE(885),
    [sym_pass_statement] = STATE(885),
    [sym_break_statement] = STATE(885),
    [sym_continue_statement] = STATE(885),
    [sym_signal_statement] = STATE(885),
    [sym_class_name_statement] = STATE(885),
    [sym_extends_statement] = STATE(885),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(280),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(280),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(282),
    [sym__indent] = ACTIONS(284),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(282),
  },
  [51] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(142),
    [sym__simple_statements] = STATE(130),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(276),
    [sym__indent] = ACTIONS(278),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(276),
  },
  [52] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(192),
    [sym__simple_statements] = STATE(135),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(272),
    [sym__indent] = ACTIONS(274),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(272),
  },
  [53] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(145),
    [sym__simple_statements] = STATE(130),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(276),
    [sym__indent] = ACTIONS(278),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(276),
  },
  [54] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(200),
    [sym__simple_statements] = STATE(135),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(272),
    [sym__indent] = ACTIONS(274),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(272),
  },
  [55] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(1374),
    [sym__simple_statements] = STATE(1346),
    [sym_expression_statement] = STATE(899),
    [sym_annotation] = STATE(780),
    [aux_sym__annotations] = STATE(780),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(899),
    [sym_export_variable_statement] = STATE(899),
    [sym_onready_variable_statement] = STATE(899),
    [sym_const_statement] = STATE(899),
    [sym_return_statement] = STATE(899),
    [sym_pass_statement] = STATE(899),
    [sym_break_statement] = STATE(899),
    [sym_continue_statement] = STATE(899),
    [sym_signal_statement] = STATE(899),
    [sym_class_name_statement] = STATE(899),
    [sym_extends_statement] = STATE(899),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(266),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(266),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(268),
    [sym__indent] = ACTIONS(270),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(268),
  },
  [56] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(834),
    [sym__simple_statements] = STATE(839),
    [sym_expression_statement] = STATE(864),
    [sym_annotation] = STATE(785),
    [aux_sym__annotations] = STATE(785),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(864),
    [sym_export_variable_statement] = STATE(864),
    [sym_onready_variable_statement] = STATE(864),
    [sym_const_statement] = STATE(864),
    [sym_return_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_signal_statement] = STATE(864),
    [sym_class_name_statement] = STATE(864),
    [sym_extends_statement] = STATE(864),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(292),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(292),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(294),
    [sym__indent] = ACTIONS(296),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(294),
  },
  [57] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(761),
    [sym__simple_statements] = STATE(757),
    [sym_expression_statement] = STATE(862),
    [sym_annotation] = STATE(781),
    [aux_sym__annotations] = STATE(781),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(862),
    [sym_export_variable_statement] = STATE(862),
    [sym_onready_variable_statement] = STATE(862),
    [sym_const_statement] = STATE(862),
    [sym_return_statement] = STATE(862),
    [sym_pass_statement] = STATE(862),
    [sym_break_statement] = STATE(862),
    [sym_continue_statement] = STATE(862),
    [sym_signal_statement] = STATE(862),
    [sym_class_name_statement] = STATE(862),
    [sym_extends_statement] = STATE(862),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(298),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(298),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(300),
    [sym__indent] = ACTIONS(302),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(300),
  },
  [58] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(1344),
    [sym__simple_statements] = STATE(1322),
    [sym_expression_statement] = STATE(840),
    [sym_annotation] = STATE(782),
    [aux_sym__annotations] = STATE(782),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(840),
    [sym_export_variable_statement] = STATE(840),
    [sym_onready_variable_statement] = STATE(840),
    [sym_const_statement] = STATE(840),
    [sym_return_statement] = STATE(840),
    [sym_pass_statement] = STATE(840),
    [sym_break_statement] = STATE(840),
    [sym_continue_statement] = STATE(840),
    [sym_signal_statement] = STATE(840),
    [sym_class_name_statement] = STATE(840),
    [sym_extends_statement] = STATE(840),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(304),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(304),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(306),
    [sym__indent] = ACTIONS(308),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(306),
  },
  [59] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(148),
    [sym__simple_statements] = STATE(130),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(276),
    [sym__indent] = ACTIONS(278),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(276),
  },
  [60] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(189),
    [sym__simple_statements] = STATE(135),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(272),
    [sym__indent] = ACTIONS(274),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(272),
  },
  [61] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(161),
    [sym__simple_statements] = STATE(130),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(276),
    [sym__indent] = ACTIONS(278),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(276),
  },
  [62] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(188),
    [sym__simple_statements] = STATE(135),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(272),
    [sym__indent] = ACTIONS(274),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(272),
  },
  [63] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(165),
    [sym__simple_statements] = STATE(130),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(276),
    [sym__indent] = ACTIONS(278),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(276),
  },
  [64] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(121),
    [sym__simple_statements] = STATE(130),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(276),
    [sym__indent] = ACTIONS(278),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(276),
  },
  [65] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(195),
    [sym__simple_statements] = STATE(135),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(272),
    [sym__indent] = ACTIONS(274),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(272),
  },
  [66] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(1370),
    [sym__simple_statements] = STATE(1322),
    [sym_expression_statement] = STATE(840),
    [sym_annotation] = STATE(782),
    [aux_sym__annotations] = STATE(782),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(840),
    [sym_export_variable_statement] = STATE(840),
    [sym_onready_variable_statement] = STATE(840),
    [sym_const_statement] = STATE(840),
    [sym_return_statement] = STATE(840),
    [sym_pass_statement] = STATE(840),
    [sym_break_statement] = STATE(840),
    [sym_continue_statement] = STATE(840),
    [sym_signal_statement] = STATE(840),
    [sym_class_name_statement] = STATE(840),
    [sym_extends_statement] = STATE(840),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(304),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(304),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(306),
    [sym__indent] = ACTIONS(308),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(306),
  },
  [67] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(124),
    [sym__simple_statements] = STATE(135),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(272),
    [sym__indent] = ACTIONS(274),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(272),
  },
  [68] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(1321),
    [sym__simple_statements] = STATE(1346),
    [sym_expression_statement] = STATE(899),
    [sym_annotation] = STATE(780),
    [aux_sym__annotations] = STATE(780),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(899),
    [sym_export_variable_statement] = STATE(899),
    [sym_onready_variable_statement] = STATE(899),
    [sym_const_statement] = STATE(899),
    [sym_return_statement] = STATE(899),
    [sym_pass_statement] = STATE(899),
    [sym_break_statement] = STATE(899),
    [sym_continue_statement] = STATE(899),
    [sym_signal_statement] = STATE(899),
    [sym_class_name_statement] = STATE(899),
    [sym_extends_statement] = STATE(899),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(266),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(266),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(268),
    [sym__indent] = ACTIONS(270),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(268),
  },
  [69] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(158),
    [sym__simple_statements] = STATE(130),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(276),
    [sym__indent] = ACTIONS(278),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(276),
  },
  [70] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(174),
    [sym__simple_statements] = STATE(135),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(272),
    [sym__indent] = ACTIONS(274),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(272),
  },
  [71] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(184),
    [sym__simple_statements] = STATE(135),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(272),
    [sym__indent] = ACTIONS(274),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(272),
  },
  [72] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(160),
    [sym__simple_statements] = STATE(130),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(276),
    [sym__indent] = ACTIONS(278),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(276),
  },
  [73] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(1238),
    [sym__simple_statements] = STATE(1159),
    [sym_expression_statement] = STATE(867),
    [sym_annotation] = STATE(783),
    [aux_sym__annotations] = STATE(783),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(867),
    [sym_export_variable_statement] = STATE(867),
    [sym_onready_variable_statement] = STATE(867),
    [sym_const_statement] = STATE(867),
    [sym_return_statement] = STATE(867),
    [sym_pass_statement] = STATE(867),
    [sym_break_statement] = STATE(867),
    [sym_continue_statement] = STATE(867),
    [sym_signal_statement] = STATE(867),
    [sym_class_name_statement] = STATE(867),
    [sym_extends_statement] = STATE(867),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(310),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(310),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(312),
    [sym__indent] = ACTIONS(314),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(312),
  },
  [74] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(1240),
    [sym__simple_statements] = STATE(1159),
    [sym_expression_statement] = STATE(867),
    [sym_annotation] = STATE(783),
    [aux_sym__annotations] = STATE(783),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(867),
    [sym_export_variable_statement] = STATE(867),
    [sym_onready_variable_statement] = STATE(867),
    [sym_const_statement] = STATE(867),
    [sym_return_statement] = STATE(867),
    [sym_pass_statement] = STATE(867),
    [sym_break_statement] = STATE(867),
    [sym_continue_statement] = STATE(867),
    [sym_signal_statement] = STATE(867),
    [sym_class_name_statement] = STATE(867),
    [sym_extends_statement] = STATE(867),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(310),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(310),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(312),
    [sym__indent] = ACTIONS(314),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(312),
  },
  [75] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(1243),
    [sym__simple_statements] = STATE(1159),
    [sym_expression_statement] = STATE(867),
    [sym_annotation] = STATE(783),
    [aux_sym__annotations] = STATE(783),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(867),
    [sym_export_variable_statement] = STATE(867),
    [sym_onready_variable_statement] = STATE(867),
    [sym_const_statement] = STATE(867),
    [sym_return_statement] = STATE(867),
    [sym_pass_statement] = STATE(867),
    [sym_break_statement] = STATE(867),
    [sym_continue_statement] = STATE(867),
    [sym_signal_statement] = STATE(867),
    [sym_class_name_statement] = STATE(867),
    [sym_extends_statement] = STATE(867),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(310),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(310),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(312),
    [sym__indent] = ACTIONS(314),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(312),
  },
  [76] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(159),
    [sym__simple_statements] = STATE(130),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(276),
    [sym__indent] = ACTIONS(278),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(276),
  },
  [77] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(176),
    [sym__simple_statements] = STATE(135),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(272),
    [sym__indent] = ACTIONS(274),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(272),
  },
  [78] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(171),
    [sym__simple_statements] = STATE(130),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(276),
    [sym__indent] = ACTIONS(278),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(276),
  },
  [79] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(1247),
    [sym__simple_statements] = STATE(1159),
    [sym_expression_statement] = STATE(867),
    [sym_annotation] = STATE(783),
    [aux_sym__annotations] = STATE(783),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(867),
    [sym_export_variable_statement] = STATE(867),
    [sym_onready_variable_statement] = STATE(867),
    [sym_const_statement] = STATE(867),
    [sym_return_statement] = STATE(867),
    [sym_pass_statement] = STATE(867),
    [sym_break_statement] = STATE(867),
    [sym_continue_statement] = STATE(867),
    [sym_signal_statement] = STATE(867),
    [sym_class_name_statement] = STATE(867),
    [sym_extends_statement] = STATE(867),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(310),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(310),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(312),
    [sym__indent] = ACTIONS(314),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(312),
  },
  [80] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(170),
    [sym__simple_statements] = STATE(130),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(276),
    [sym__indent] = ACTIONS(278),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(276),
  },
  [81] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(152),
    [sym__simple_statements] = STATE(130),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(276),
    [sym__indent] = ACTIONS(278),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(276),
  },
  [82] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(162),
    [sym__simple_statements] = STATE(130),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(276),
    [sym__indent] = ACTIONS(278),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(276),
  },
  [83] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(146),
    [sym__simple_statements] = STATE(130),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(276),
    [sym__indent] = ACTIONS(278),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(276),
  },
  [84] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(1351),
    [sym__simple_statements] = STATE(1322),
    [sym_expression_statement] = STATE(840),
    [sym_annotation] = STATE(782),
    [aux_sym__annotations] = STATE(782),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(840),
    [sym_export_variable_statement] = STATE(840),
    [sym_onready_variable_statement] = STATE(840),
    [sym_const_statement] = STATE(840),
    [sym_return_statement] = STATE(840),
    [sym_pass_statement] = STATE(840),
    [sym_break_statement] = STATE(840),
    [sym_continue_statement] = STATE(840),
    [sym_signal_statement] = STATE(840),
    [sym_class_name_statement] = STATE(840),
    [sym_extends_statement] = STATE(840),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(304),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(304),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(306),
    [sym__indent] = ACTIONS(308),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(306),
  },
  [85] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(198),
    [sym__simple_statements] = STATE(135),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(272),
    [sym__indent] = ACTIONS(274),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(272),
  },
  [86] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(147),
    [sym__simple_statements] = STATE(130),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(276),
    [sym__indent] = ACTIONS(278),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(276),
  },
  [87] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(172),
    [sym__simple_statements] = STATE(135),
    [sym_expression_statement] = STATE(892),
    [sym_annotation] = STATE(774),
    [aux_sym__annotations] = STATE(774),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(892),
    [sym_export_variable_statement] = STATE(892),
    [sym_onready_variable_statement] = STATE(892),
    [sym_const_statement] = STATE(892),
    [sym_return_statement] = STATE(892),
    [sym_pass_statement] = STATE(892),
    [sym_break_statement] = STATE(892),
    [sym_continue_statement] = STATE(892),
    [sym_signal_statement] = STATE(892),
    [sym_class_name_statement] = STATE(892),
    [sym_extends_statement] = STATE(892),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(35),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(35),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(272),
    [sym__indent] = ACTIONS(274),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(272),
  },
  [88] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(1371),
    [sym__simple_statements] = STATE(1322),
    [sym_expression_statement] = STATE(840),
    [sym_annotation] = STATE(782),
    [aux_sym__annotations] = STATE(782),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(840),
    [sym_export_variable_statement] = STATE(840),
    [sym_onready_variable_statement] = STATE(840),
    [sym_const_statement] = STATE(840),
    [sym_return_statement] = STATE(840),
    [sym_pass_statement] = STATE(840),
    [sym_break_statement] = STATE(840),
    [sym_continue_statement] = STATE(840),
    [sym_signal_statement] = STATE(840),
    [sym_class_name_statement] = STATE(840),
    [sym_extends_statement] = STATE(840),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(304),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(304),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(306),
    [sym__indent] = ACTIONS(308),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(306),
  },
  [89] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(144),
    [sym__simple_statements] = STATE(130),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(276),
    [sym__indent] = ACTIONS(278),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(276),
  },
  [90] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(822),
    [sym__simple_statements] = STATE(839),
    [sym_expression_statement] = STATE(864),
    [sym_annotation] = STATE(785),
    [aux_sym__annotations] = STATE(785),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(864),
    [sym_export_variable_statement] = STATE(864),
    [sym_onready_variable_statement] = STATE(864),
    [sym_const_statement] = STATE(864),
    [sym_return_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_signal_statement] = STATE(864),
    [sym_class_name_statement] = STATE(864),
    [sym_extends_statement] = STATE(864),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(292),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(292),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(294),
    [sym__indent] = ACTIONS(296),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(294),
  },
  [91] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(1271),
    [sym__simple_statements] = STATE(1253),
    [sym_expression_statement] = STATE(907),
    [sym_annotation] = STATE(779),
    [aux_sym__annotations] = STATE(779),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(907),
    [sym_export_variable_statement] = STATE(907),
    [sym_onready_variable_statement] = STATE(907),
    [sym_const_statement] = STATE(907),
    [sym_return_statement] = STATE(907),
    [sym_pass_statement] = STATE(907),
    [sym_break_statement] = STATE(907),
    [sym_continue_statement] = STATE(907),
    [sym_signal_statement] = STATE(907),
    [sym_class_name_statement] = STATE(907),
    [sym_extends_statement] = STATE(907),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(316),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(316),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(318),
    [sym__indent] = ACTIONS(320),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(318),
  },
  [92] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(151),
    [sym__simple_statements] = STATE(130),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(276),
    [sym__indent] = ACTIONS(278),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(276),
  },
  [93] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(1268),
    [sym__simple_statements] = STATE(1253),
    [sym_expression_statement] = STATE(907),
    [sym_annotation] = STATE(779),
    [aux_sym__annotations] = STATE(779),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(907),
    [sym_export_variable_statement] = STATE(907),
    [sym_onready_variable_statement] = STATE(907),
    [sym_const_statement] = STATE(907),
    [sym_return_statement] = STATE(907),
    [sym_pass_statement] = STATE(907),
    [sym_break_statement] = STATE(907),
    [sym_continue_statement] = STATE(907),
    [sym_signal_statement] = STATE(907),
    [sym_class_name_statement] = STATE(907),
    [sym_extends_statement] = STATE(907),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(316),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(316),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(318),
    [sym__indent] = ACTIONS(320),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(318),
  },
  [94] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(1267),
    [sym__simple_statements] = STATE(1253),
    [sym_expression_statement] = STATE(907),
    [sym_annotation] = STATE(779),
    [aux_sym__annotations] = STATE(779),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(907),
    [sym_export_variable_statement] = STATE(907),
    [sym_onready_variable_statement] = STATE(907),
    [sym_const_statement] = STATE(907),
    [sym_return_statement] = STATE(907),
    [sym_pass_statement] = STATE(907),
    [sym_break_statement] = STATE(907),
    [sym_continue_statement] = STATE(907),
    [sym_signal_statement] = STATE(907),
    [sym_class_name_statement] = STATE(907),
    [sym_extends_statement] = STATE(907),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(316),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(316),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(318),
    [sym__indent] = ACTIONS(320),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(318),
  },
  [95] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(150),
    [sym__simple_statements] = STATE(130),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(276),
    [sym__indent] = ACTIONS(278),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(276),
  },
  [96] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(149),
    [sym__simple_statements] = STATE(130),
    [sym_expression_statement] = STATE(846),
    [sym_annotation] = STATE(773),
    [aux_sym__annotations] = STATE(773),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(846),
    [sym_export_variable_statement] = STATE(846),
    [sym_onready_variable_statement] = STATE(846),
    [sym_const_statement] = STATE(846),
    [sym_return_statement] = STATE(846),
    [sym_pass_statement] = STATE(846),
    [sym_break_statement] = STATE(846),
    [sym_continue_statement] = STATE(846),
    [sym_signal_statement] = STATE(846),
    [sym_class_name_statement] = STATE(846),
    [sym_extends_statement] = STATE(846),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(77),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(77),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(276),
    [sym__indent] = ACTIONS(278),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(276),
  },
  [97] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(1254),
    [sym__simple_statements] = STATE(1253),
    [sym_expression_statement] = STATE(907),
    [sym_annotation] = STATE(779),
    [aux_sym__annotations] = STATE(779),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(907),
    [sym_export_variable_statement] = STATE(907),
    [sym_onready_variable_statement] = STATE(907),
    [sym_const_statement] = STATE(907),
    [sym_return_statement] = STATE(907),
    [sym_pass_statement] = STATE(907),
    [sym_break_statement] = STATE(907),
    [sym_continue_statement] = STATE(907),
    [sym_signal_statement] = STATE(907),
    [sym_class_name_statement] = STATE(907),
    [sym_extends_statement] = STATE(907),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(316),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(316),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(318),
    [sym__indent] = ACTIONS(320),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(318),
  },
  [98] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_body] = STATE(825),
    [sym__simple_statements] = STATE(839),
    [sym_expression_statement] = STATE(864),
    [sym_annotation] = STATE(785),
    [aux_sym__annotations] = STATE(785),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(864),
    [sym_export_variable_statement] = STATE(864),
    [sym_onready_variable_statement] = STATE(864),
    [sym_const_statement] = STATE(864),
    [sym_return_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_signal_statement] = STATE(864),
    [sym_class_name_statement] = STATE(864),
    [sym_extends_statement] = STATE(864),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(292),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(292),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(294),
    [sym__indent] = ACTIONS(296),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(294),
  },
  [99] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_expression_statement] = STATE(1082),
    [sym_annotation] = STATE(794),
    [aux_sym__annotations] = STATE(794),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(1082),
    [sym_export_variable_statement] = STATE(1082),
    [sym_onready_variable_statement] = STATE(1082),
    [sym_const_statement] = STATE(1082),
    [sym_return_statement] = STATE(1082),
    [sym_pass_statement] = STATE(1082),
    [sym_break_statement] = STATE(1082),
    [sym_continue_statement] = STATE(1082),
    [sym_signal_statement] = STATE(1082),
    [sym_class_name_statement] = STATE(1082),
    [sym_extends_statement] = STATE(1082),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(322),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(324),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(324),
  },
  [100] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_expression_statement] = STATE(1082),
    [sym_annotation] = STATE(794),
    [aux_sym__annotations] = STATE(794),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(1082),
    [sym_export_variable_statement] = STATE(1082),
    [sym_onready_variable_statement] = STATE(1082),
    [sym_const_statement] = STATE(1082),
    [sym_return_statement] = STATE(1082),
    [sym_pass_statement] = STATE(1082),
    [sym_break_statement] = STATE(1082),
    [sym_continue_statement] = STATE(1082),
    [sym_signal_statement] = STATE(1082),
    [sym_class_name_statement] = STATE(1082),
    [sym_extends_statement] = STATE(1082),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(322),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(326),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(326),
  },
  [101] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_expression_statement] = STATE(1082),
    [sym_annotation] = STATE(794),
    [aux_sym__annotations] = STATE(794),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(1082),
    [sym_export_variable_statement] = STATE(1082),
    [sym_onready_variable_statement] = STATE(1082),
    [sym_const_statement] = STATE(1082),
    [sym_return_statement] = STATE(1082),
    [sym_pass_statement] = STATE(1082),
    [sym_break_statement] = STATE(1082),
    [sym_continue_statement] = STATE(1082),
    [sym_signal_statement] = STATE(1082),
    [sym_class_name_statement] = STATE(1082),
    [sym_extends_statement] = STATE(1082),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(322),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(328),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(328),
  },
  [102] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_expression_statement] = STATE(1082),
    [sym_annotation] = STATE(794),
    [aux_sym__annotations] = STATE(794),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(1082),
    [sym_export_variable_statement] = STATE(1082),
    [sym_onready_variable_statement] = STATE(1082),
    [sym_const_statement] = STATE(1082),
    [sym_return_statement] = STATE(1082),
    [sym_pass_statement] = STATE(1082),
    [sym_break_statement] = STATE(1082),
    [sym_continue_statement] = STATE(1082),
    [sym_signal_statement] = STATE(1082),
    [sym_class_name_statement] = STATE(1082),
    [sym_extends_statement] = STATE(1082),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(322),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(330),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(330),
  },
  [103] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_expression_statement] = STATE(1082),
    [sym_annotation] = STATE(794),
    [aux_sym__annotations] = STATE(794),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(1082),
    [sym_export_variable_statement] = STATE(1082),
    [sym_onready_variable_statement] = STATE(1082),
    [sym_const_statement] = STATE(1082),
    [sym_return_statement] = STATE(1082),
    [sym_pass_statement] = STATE(1082),
    [sym_break_statement] = STATE(1082),
    [sym_continue_statement] = STATE(1082),
    [sym_signal_statement] = STATE(1082),
    [sym_class_name_statement] = STATE(1082),
    [sym_extends_statement] = STATE(1082),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(322),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(332),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(332),
  },
  [104] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_expression_statement] = STATE(1082),
    [sym_annotation] = STATE(794),
    [aux_sym__annotations] = STATE(794),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(1082),
    [sym_export_variable_statement] = STATE(1082),
    [sym_onready_variable_statement] = STATE(1082),
    [sym_const_statement] = STATE(1082),
    [sym_return_statement] = STATE(1082),
    [sym_pass_statement] = STATE(1082),
    [sym_break_statement] = STATE(1082),
    [sym_continue_statement] = STATE(1082),
    [sym_signal_statement] = STATE(1082),
    [sym_class_name_statement] = STATE(1082),
    [sym_extends_statement] = STATE(1082),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(322),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(334),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(334),
  },
  [105] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_expression_statement] = STATE(1082),
    [sym_annotation] = STATE(794),
    [aux_sym__annotations] = STATE(794),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(1082),
    [sym_export_variable_statement] = STATE(1082),
    [sym_onready_variable_statement] = STATE(1082),
    [sym_const_statement] = STATE(1082),
    [sym_return_statement] = STATE(1082),
    [sym_pass_statement] = STATE(1082),
    [sym_break_statement] = STATE(1082),
    [sym_continue_statement] = STATE(1082),
    [sym_signal_statement] = STATE(1082),
    [sym_class_name_statement] = STATE(1082),
    [sym_extends_statement] = STATE(1082),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(322),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(336),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(336),
  },
  [106] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_expression_statement] = STATE(1082),
    [sym_annotation] = STATE(794),
    [aux_sym__annotations] = STATE(794),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(1082),
    [sym_export_variable_statement] = STATE(1082),
    [sym_onready_variable_statement] = STATE(1082),
    [sym_const_statement] = STATE(1082),
    [sym_return_statement] = STATE(1082),
    [sym_pass_statement] = STATE(1082),
    [sym_break_statement] = STATE(1082),
    [sym_continue_statement] = STATE(1082),
    [sym_signal_statement] = STATE(1082),
    [sym_class_name_statement] = STATE(1082),
    [sym_extends_statement] = STATE(1082),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(322),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(338),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(338),
  },
  [107] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_expression_statement] = STATE(1082),
    [sym_annotation] = STATE(794),
    [aux_sym__annotations] = STATE(794),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(1082),
    [sym_export_variable_statement] = STATE(1082),
    [sym_onready_variable_statement] = STATE(1082),
    [sym_const_statement] = STATE(1082),
    [sym_return_statement] = STATE(1082),
    [sym_pass_statement] = STATE(1082),
    [sym_break_statement] = STATE(1082),
    [sym_continue_statement] = STATE(1082),
    [sym_signal_statement] = STATE(1082),
    [sym_class_name_statement] = STATE(1082),
    [sym_extends_statement] = STATE(1082),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(322),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(340),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(340),
  },
  [108] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_expression_statement] = STATE(1082),
    [sym_annotation] = STATE(794),
    [aux_sym__annotations] = STATE(794),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(1082),
    [sym_export_variable_statement] = STATE(1082),
    [sym_onready_variable_statement] = STATE(1082),
    [sym_const_statement] = STATE(1082),
    [sym_return_statement] = STATE(1082),
    [sym_pass_statement] = STATE(1082),
    [sym_break_statement] = STATE(1082),
    [sym_continue_statement] = STATE(1082),
    [sym_signal_statement] = STATE(1082),
    [sym_class_name_statement] = STATE(1082),
    [sym_extends_statement] = STATE(1082),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(322),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(342),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(342),
  },
  [109] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_expression_statement] = STATE(1082),
    [sym_annotation] = STATE(794),
    [aux_sym__annotations] = STATE(794),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(1082),
    [sym_export_variable_statement] = STATE(1082),
    [sym_onready_variable_statement] = STATE(1082),
    [sym_const_statement] = STATE(1082),
    [sym_return_statement] = STATE(1082),
    [sym_pass_statement] = STATE(1082),
    [sym_break_statement] = STATE(1082),
    [sym_continue_statement] = STATE(1082),
    [sym_signal_statement] = STATE(1082),
    [sym_class_name_statement] = STATE(1082),
    [sym_extends_statement] = STATE(1082),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(322),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(344),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(344),
  },
  [110] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_expression_statement] = STATE(1082),
    [sym_annotation] = STATE(794),
    [aux_sym__annotations] = STATE(794),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(1082),
    [sym_export_variable_statement] = STATE(1082),
    [sym_onready_variable_statement] = STATE(1082),
    [sym_const_statement] = STATE(1082),
    [sym_return_statement] = STATE(1082),
    [sym_pass_statement] = STATE(1082),
    [sym_break_statement] = STATE(1082),
    [sym_continue_statement] = STATE(1082),
    [sym_signal_statement] = STATE(1082),
    [sym_class_name_statement] = STATE(1082),
    [sym_extends_statement] = STATE(1082),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(322),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(346),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(346),
  },
  [111] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_expression_statement] = STATE(1082),
    [sym_annotation] = STATE(794),
    [aux_sym__annotations] = STATE(794),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(1082),
    [sym_export_variable_statement] = STATE(1082),
    [sym_onready_variable_statement] = STATE(1082),
    [sym_const_statement] = STATE(1082),
    [sym_return_statement] = STATE(1082),
    [sym_pass_statement] = STATE(1082),
    [sym_break_statement] = STATE(1082),
    [sym_continue_statement] = STATE(1082),
    [sym_signal_statement] = STATE(1082),
    [sym_class_name_statement] = STATE(1082),
    [sym_extends_statement] = STATE(1082),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(322),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(348),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(348),
  },
  [112] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_expression_statement] = STATE(1082),
    [sym_annotation] = STATE(794),
    [aux_sym__annotations] = STATE(794),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(1082),
    [sym_export_variable_statement] = STATE(1082),
    [sym_onready_variable_statement] = STATE(1082),
    [sym_const_statement] = STATE(1082),
    [sym_return_statement] = STATE(1082),
    [sym_pass_statement] = STATE(1082),
    [sym_break_statement] = STATE(1082),
    [sym_continue_statement] = STATE(1082),
    [sym_signal_statement] = STATE(1082),
    [sym_class_name_statement] = STATE(1082),
    [sym_extends_statement] = STATE(1082),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(322),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(350),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(350),
  },
  [113] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_expression_statement] = STATE(1082),
    [sym_annotation] = STATE(794),
    [aux_sym__annotations] = STATE(794),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(1082),
    [sym_export_variable_statement] = STATE(1082),
    [sym_onready_variable_statement] = STATE(1082),
    [sym_const_statement] = STATE(1082),
    [sym_return_statement] = STATE(1082),
    [sym_pass_statement] = STATE(1082),
    [sym_break_statement] = STATE(1082),
    [sym_continue_statement] = STATE(1082),
    [sym_signal_statement] = STATE(1082),
    [sym_class_name_statement] = STATE(1082),
    [sym_extends_statement] = STATE(1082),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(322),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(352),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(352),
  },
  [114] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_expression_statement] = STATE(1082),
    [sym_annotation] = STATE(794),
    [aux_sym__annotations] = STATE(794),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(1082),
    [sym_export_variable_statement] = STATE(1082),
    [sym_onready_variable_statement] = STATE(1082),
    [sym_const_statement] = STATE(1082),
    [sym_return_statement] = STATE(1082),
    [sym_pass_statement] = STATE(1082),
    [sym_break_statement] = STATE(1082),
    [sym_continue_statement] = STATE(1082),
    [sym_signal_statement] = STATE(1082),
    [sym_class_name_statement] = STATE(1082),
    [sym_extends_statement] = STATE(1082),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(322),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(354),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(354),
  },
  [115] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_expression_statement] = STATE(1082),
    [sym_annotation] = STATE(794),
    [aux_sym__annotations] = STATE(794),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(1082),
    [sym_export_variable_statement] = STATE(1082),
    [sym_onready_variable_statement] = STATE(1082),
    [sym_const_statement] = STATE(1082),
    [sym_return_statement] = STATE(1082),
    [sym_pass_statement] = STATE(1082),
    [sym_break_statement] = STATE(1082),
    [sym_continue_statement] = STATE(1082),
    [sym_signal_statement] = STATE(1082),
    [sym_class_name_statement] = STATE(1082),
    [sym_extends_statement] = STATE(1082),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(322),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(356),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(356),
  },
  [116] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_expression_statement] = STATE(1082),
    [sym_annotation] = STATE(794),
    [aux_sym__annotations] = STATE(794),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(1082),
    [sym_export_variable_statement] = STATE(1082),
    [sym_onready_variable_statement] = STATE(1082),
    [sym_const_statement] = STATE(1082),
    [sym_return_statement] = STATE(1082),
    [sym_pass_statement] = STATE(1082),
    [sym_break_statement] = STATE(1082),
    [sym_continue_statement] = STATE(1082),
    [sym_signal_statement] = STATE(1082),
    [sym_class_name_statement] = STATE(1082),
    [sym_extends_statement] = STATE(1082),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(322),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(358),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(358),
  },
  [117] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_expression_statement] = STATE(1082),
    [sym_annotation] = STATE(794),
    [aux_sym__annotations] = STATE(794),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(1082),
    [sym_export_variable_statement] = STATE(1082),
    [sym_onready_variable_statement] = STATE(1082),
    [sym_const_statement] = STATE(1082),
    [sym_return_statement] = STATE(1082),
    [sym_pass_statement] = STATE(1082),
    [sym_break_statement] = STATE(1082),
    [sym_continue_statement] = STATE(1082),
    [sym_signal_statement] = STATE(1082),
    [sym_class_name_statement] = STATE(1082),
    [sym_extends_statement] = STATE(1082),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(322),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(360),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(360),
  },
  [118] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_expression_statement] = STATE(1082),
    [sym_annotation] = STATE(794),
    [aux_sym__annotations] = STATE(794),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(1082),
    [sym_export_variable_statement] = STATE(1082),
    [sym_onready_variable_statement] = STATE(1082),
    [sym_const_statement] = STATE(1082),
    [sym_return_statement] = STATE(1082),
    [sym_pass_statement] = STATE(1082),
    [sym_break_statement] = STATE(1082),
    [sym_continue_statement] = STATE(1082),
    [sym_signal_statement] = STATE(1082),
    [sym_class_name_statement] = STATE(1082),
    [sym_extends_statement] = STATE(1082),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(322),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__newline] = ACTIONS(362),
    [sym__string_start] = ACTIONS(73),
    [sym__body_end] = ACTIONS(362),
  },
  [119] = {
    [sym_identifier] = STATE(233),
    [sym_remote_keyword] = STATE(805),
    [sym_string] = STATE(233),
    [sym_string_name] = STATE(237),
    [sym_expression_statement] = STATE(1082),
    [sym_annotation] = STATE(794),
    [aux_sym__annotations] = STATE(794),
    [sym_annotations] = STATE(1317),
    [sym__variable_statement] = STATE(1020),
    [sym_variable_statement] = STATE(1082),
    [sym_export_variable_statement] = STATE(1082),
    [sym_onready_variable_statement] = STATE(1082),
    [sym_const_statement] = STATE(1082),
    [sym_return_statement] = STATE(1082),
    [sym_pass_statement] = STATE(1082),
    [sym_break_statement] = STATE(1082),
    [sym_continue_statement] = STATE(1082),
    [sym_signal_statement] = STATE(1082),
    [sym_class_name_statement] = STATE(1082),
    [sym_extends_statement] = STATE(1082),
    [sym__expression] = STATE(749),
    [sym__primary_expression] = STATE(215),
    [sym__attribute_expression] = STATE(1292),
    [sym_binary_operator] = STATE(233),
    [sym_unary_operator] = STATE(233),
    [sym_comparison_operator] = STATE(744),
    [sym_subscript] = STATE(233),
    [sym_attribute] = STATE(237),
    [sym_conditional_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(233),
    [sym_await_expression] = STATE(744),
    [sym_assignment] = STATE(1019),
    [sym_augmented_assignment] = STATE(1019),
    [sym_dictionary] = STATE(233),
    [sym_array] = STATE(233),
    [sym_base_call] = STATE(233),
    [sym_call] = STATE(233),
    [sym__identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_null] = ACTIONS(9),
    [anon_sym_remote] = ACTIONS(13),
    [anon_sym_master] = ACTIONS(13),
    [anon_sym_puppet] = ACTIONS(13),
    [anon_sym_remotesync] = ACTIONS(13),
    [anon_sym_mastersync] = ACTIONS(13),
    [anon_sym_puppetsync] = ACTIONS(13),
    [sym_float] = ACTIONS(15),
    [sym_integer] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(17),
    [sym_node_path] = ACTIONS(15),
    [sym_get_node] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_onready] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_pass] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(33),
    [sym_breakpoint_statement] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(37),
    [sym_tool_statement] = ACTIONS(322),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_class_name] = ACTIONS(41),
    [anon_sym_DOT] = ACTIONS(43),
    [anon_sym_extends] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [sym__string_start] = ACTIONS(73),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(368), 1,
      anon_sym_elif,
    ACTIONS(370), 1,
      anon_sym_else,
    STATE(122), 1,
      aux_sym_if_statement_repeat1,
    STATE(126), 1,
      sym_elif_clause,
    STATE(156), 1,
      sym_else_clause,
    ACTIONS(366), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(364), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [73] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(368), 1,
      anon_sym_elif,
    ACTIONS(370), 1,
      anon_sym_else,
    STATE(120), 1,
      aux_sym_if_statement_repeat1,
    STATE(126), 1,
      sym_elif_clause,
    STATE(163), 1,
      sym_else_clause,
    ACTIONS(374), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(372), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [146] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(380), 1,
      anon_sym_elif,
    STATE(122), 1,
      aux_sym_if_statement_repeat1,
    STATE(126), 1,
      sym_elif_clause,
    ACTIONS(378), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(376), 37,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [214] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(383), 1,
      anon_sym_elif,
    ACTIONS(385), 1,
      anon_sym_else,
    STATE(125), 1,
      aux_sym_if_statement_repeat1,
    STATE(139), 1,
      sym_elif_clause,
    STATE(186), 1,
      sym_else_clause,
    ACTIONS(366), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(364), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [286] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(383), 1,
      anon_sym_elif,
    ACTIONS(385), 1,
      anon_sym_else,
    STATE(123), 1,
      aux_sym_if_statement_repeat1,
    STATE(139), 1,
      sym_elif_clause,
    STATE(175), 1,
      sym_else_clause,
    ACTIONS(374), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(372), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [358] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(387), 1,
      anon_sym_elif,
    STATE(125), 1,
      aux_sym_if_statement_repeat1,
    STATE(139), 1,
      sym_elif_clause,
    ACTIONS(378), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(376), 37,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(392), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(390), 38,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(396), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(394), 38,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(400), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(398), 38,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(404), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(402), 38,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(408), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(406), 38,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(412), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(410), 38,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(416), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(414), 38,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(420), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(418), 38,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(416), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(414), 38,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(408), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(406), 38,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [1023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(420), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(418), 38,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [1082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(396), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(394), 38,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [1141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(412), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(410), 38,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [1200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(392), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(390), 38,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [1259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(404), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(402), 38,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [1318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(400), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(398), 38,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [1377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(422), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [1435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(426), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [1493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(430), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [1551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(434), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [1609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(440), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(438), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [1667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(442), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [1725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(448), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(446), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [1783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(452), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(450), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [1841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(456), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(454), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [1899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(460), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(458), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [1957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(464), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(462), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [2015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(468), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(466), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [2073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(470), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [2131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(476), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(474), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [2189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(478), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [2247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(482), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [2305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(488), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(486), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [2363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(490), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [2421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(496), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(494), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [2479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(500), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(498), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [2537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(504), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(502), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [2595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(508), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(506), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [2653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(510), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [2711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(516), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(514), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [2769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(520), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(518), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [2827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(524), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(522), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [2885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(528), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(526), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [2943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(532), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(530), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [3001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(536), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(534), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [3059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(540), 14,
      sym__dedent,
      sym__string_start,
      sym__body_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(538), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [3117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(516), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(514), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [3174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(504), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(502), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [3231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(488), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(486), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [3288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(508), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(506), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [3345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(490), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [3402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(510), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [3459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(476), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(474), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [3516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(520), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(518), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [3573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(482), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [3630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(536), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(534), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [3687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(470), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [3744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(422), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [3801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(496), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(494), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [3858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(426), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [3915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(478), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [3972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(528), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(526), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [4029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(440), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(438), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [4086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(500), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(498), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [4143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(532), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(530), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [4200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(434), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [4257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(430), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [4314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(468), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(466), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [4371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(448), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(446), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [4428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(540), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(538), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [4485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(452), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(450), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [4542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(524), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(522), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [4599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(456), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(454), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [4656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(460), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(458), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [4713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(464), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(462), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [4770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 13,
      sym__string_start,
      ts_builtin_sym_end,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
    ACTIONS(442), 36,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_static_keyword,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      sym_integer,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_export,
      anon_sym_onready,
      anon_sym_const,
      anon_sym_return,
      anon_sym_pass,
      anon_sym_break,
      sym_breakpoint_statement,
      anon_sym_continue,
      sym_tool_statement,
      anon_sym_signal,
      anon_sym_class_name,
      anon_sym_DOT,
      anon_sym_extends,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_match,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
  [4827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(542), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(544), 33,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_var,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_func,
  [4881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(546), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(548), 33,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_var,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_func,
  [4935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(550), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(552), 33,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_var,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_func,
  [4989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(554), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(556), 33,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_var,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_func,
  [5043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(558), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 33,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_var,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_func,
  [5097] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(568), 1,
      anon_sym_is,
    ACTIONS(570), 1,
      anon_sym_as,
    ACTIONS(572), 1,
      anon_sym_LPAREN,
    STATE(248), 1,
      sym_arguments,
    ACTIONS(566), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 10,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 27,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [5159] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(568), 1,
      anon_sym_is,
    ACTIONS(570), 1,
      anon_sym_as,
    ACTIONS(572), 1,
      anon_sym_LPAREN,
    STATE(248), 1,
      sym_arguments,
    ACTIONS(574), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(566), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 6,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 27,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [5225] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(568), 1,
      anon_sym_is,
    ACTIONS(570), 1,
      anon_sym_as,
    ACTIONS(572), 1,
      anon_sym_LPAREN,
    ACTIONS(578), 1,
      anon_sym_AMP,
    ACTIONS(580), 1,
      anon_sym_CARET,
    STATE(248), 1,
      sym_arguments,
    ACTIONS(574), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(566), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 27,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [5295] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(568), 1,
      anon_sym_is,
    ACTIONS(570), 1,
      anon_sym_as,
    ACTIONS(572), 1,
      anon_sym_LPAREN,
    STATE(248), 1,
      sym_arguments,
    ACTIONS(562), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 27,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [5355] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym__identifier,
    ACTIONS(17), 1,
      anon_sym_AMP,
    ACTIONS(43), 1,
      anon_sym_DOT,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(65), 1,
      anon_sym_not,
    ACTIONS(67), 1,
      anon_sym_LPAREN,
    ACTIONS(69), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    ACTIONS(584), 1,
      anon_sym_func,
    STATE(215), 1,
      sym__primary_expression,
    STATE(810), 1,
      sym__expression,
    STATE(1292), 1,
      sym__attribute_expression,
    STATE(237), 2,
      sym_string_name,
      sym_attribute,
    STATE(1004), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(15), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(582), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
    STATE(744), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(9), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(63), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(233), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [5445] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(570), 1,
      anon_sym_as,
    ACTIONS(572), 1,
      anon_sym_LPAREN,
    STATE(248), 1,
      sym_arguments,
    ACTIONS(562), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 28,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [5503] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(568), 1,
      anon_sym_is,
    ACTIONS(570), 1,
      anon_sym_as,
    ACTIONS(572), 1,
      anon_sym_LPAREN,
    ACTIONS(578), 1,
      anon_sym_AMP,
    ACTIONS(580), 1,
      anon_sym_CARET,
    ACTIONS(588), 1,
      anon_sym_PIPE,
    STATE(248), 1,
      sym_arguments,
    ACTIONS(574), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(586), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(562), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(566), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(564), 25,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [5577] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(568), 1,
      anon_sym_is,
    ACTIONS(570), 1,
      anon_sym_as,
    ACTIONS(572), 1,
      anon_sym_LPAREN,
    ACTIONS(578), 1,
      anon_sym_AMP,
    ACTIONS(580), 1,
      anon_sym_CARET,
    ACTIONS(588), 1,
      anon_sym_PIPE,
    STATE(248), 1,
      sym_arguments,
    ACTIONS(574), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(562), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(566), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(564), 27,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [5649] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(570), 1,
      anon_sym_as,
    ACTIONS(572), 1,
      anon_sym_LPAREN,
    ACTIONS(578), 1,
      anon_sym_AMP,
    ACTIONS(580), 1,
      anon_sym_CARET,
    ACTIONS(588), 1,
      anon_sym_PIPE,
    ACTIONS(592), 1,
      anon_sym_EQ,
    ACTIONS(596), 1,
      anon_sym_LBRACK,
    ACTIONS(600), 1,
      anon_sym_is,
    STATE(248), 1,
      sym_arguments,
    STATE(720), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(574), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(586), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(598), 2,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
    ACTIONS(602), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(566), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(594), 5,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(590), 16,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_if,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [5733] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(218), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(604), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(606), 30,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [5787] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(568), 1,
      anon_sym_is,
    ACTIONS(570), 1,
      anon_sym_as,
    ACTIONS(572), 1,
      anon_sym_LPAREN,
    ACTIONS(580), 1,
      anon_sym_CARET,
    STATE(248), 1,
      sym_arguments,
    ACTIONS(574), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(566), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 5,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 27,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [5855] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(612), 1,
      anon_sym_DOT,
    STATE(218), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(608), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(610), 29,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [5911] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(615), 1,
      anon_sym_DOT,
    STATE(218), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(604), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(606), 29,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [5967] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(568), 1,
      anon_sym_is,
    ACTIONS(570), 1,
      anon_sym_as,
    ACTIONS(572), 1,
      anon_sym_LPAREN,
    STATE(248), 1,
      sym_arguments,
    ACTIONS(574), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(566), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 8,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 27,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [6031] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(572), 1,
      anon_sym_LPAREN,
    ACTIONS(617), 1,
      anon_sym_LBRACK,
    STATE(258), 1,
      sym_arguments,
    ACTIONS(608), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(610), 28,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [6089] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(570), 1,
      anon_sym_as,
    ACTIONS(572), 1,
      anon_sym_LPAREN,
    STATE(248), 1,
      sym_arguments,
    ACTIONS(562), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 28,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [6147] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(568), 1,
      anon_sym_is,
    ACTIONS(570), 1,
      anon_sym_as,
    ACTIONS(572), 1,
      anon_sym_LPAREN,
    STATE(248), 1,
      sym_arguments,
    ACTIONS(619), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(621), 27,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [6207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(623), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(625), 30,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [6258] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(639), 1,
      anon_sym_RBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(651), 1,
      anon_sym_func,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(472), 1,
      sym__primary_expression,
    STATE(546), 1,
      sym_identifier,
    STATE(1120), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1186), 1,
      sym_pair,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    STATE(1342), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 9,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [6351] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(651), 1,
      anon_sym_func,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(655), 1,
      anon_sym_RBRACE,
    STATE(472), 1,
      sym__primary_expression,
    STATE(546), 1,
      sym_identifier,
    STATE(1120), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1186), 1,
      sym_pair,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    STATE(1342), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 9,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [6444] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(651), 1,
      anon_sym_func,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(657), 1,
      anon_sym_RBRACE,
    STATE(472), 1,
      sym__primary_expression,
    STATE(546), 1,
      sym_identifier,
    STATE(945), 1,
      sym_pair,
    STATE(1120), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    STATE(1342), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 9,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [6537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(661), 30,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [6588] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(651), 1,
      anon_sym_func,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(663), 1,
      anon_sym_RBRACE,
    STATE(472), 1,
      sym__primary_expression,
    STATE(546), 1,
      sym_identifier,
    STATE(1030), 1,
      sym_pair,
    STATE(1120), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    STATE(1342), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 9,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [6681] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(568), 1,
      anon_sym_is,
    ACTIONS(570), 1,
      anon_sym_as,
    ACTIONS(572), 1,
      anon_sym_LPAREN,
    ACTIONS(578), 1,
      anon_sym_AMP,
    ACTIONS(580), 1,
      anon_sym_CARET,
    ACTIONS(588), 1,
      anon_sym_PIPE,
    ACTIONS(596), 1,
      anon_sym_LBRACK,
    STATE(248), 1,
      sym_arguments,
    ACTIONS(574), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(586), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(598), 2,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
    ACTIONS(566), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(667), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(665), 21,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [6758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(562), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 30,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [6809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(608), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(610), 30,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [6860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(673), 1,
      anon_sym_DOT,
    ACTIONS(669), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(671), 29,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [6913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(677), 30,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [6964] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(651), 1,
      anon_sym_func,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(679), 1,
      anon_sym_RBRACE,
    STATE(472), 1,
      sym__primary_expression,
    STATE(546), 1,
      sym_identifier,
    STATE(946), 1,
      sym_pair,
    STATE(1120), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    STATE(1342), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 9,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [7057] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(651), 1,
      anon_sym_func,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(681), 1,
      anon_sym_RBRACE,
    STATE(472), 1,
      sym__primary_expression,
    STATE(546), 1,
      sym_identifier,
    STATE(1120), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1186), 1,
      sym_pair,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    STATE(1342), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 9,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [7150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(669), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(671), 30,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [7201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(683), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(685), 30,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [7252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(689), 30,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [7303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(691), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(693), 30,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [7354] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(651), 1,
      anon_sym_func,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(695), 1,
      anon_sym_RBRACE,
    STATE(472), 1,
      sym__primary_expression,
    STATE(546), 1,
      sym_identifier,
    STATE(1120), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1186), 1,
      sym_pair,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    STATE(1342), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 9,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [7447] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(651), 1,
      anon_sym_func,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(697), 1,
      anon_sym_RBRACE,
    STATE(472), 1,
      sym__primary_expression,
    STATE(546), 1,
      sym_identifier,
    STATE(1120), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1186), 1,
      sym_pair,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    STATE(1342), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 9,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [7540] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(651), 1,
      anon_sym_func,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(699), 1,
      anon_sym_RBRACE,
    STATE(472), 1,
      sym__primary_expression,
    STATE(546), 1,
      sym_identifier,
    STATE(1120), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1186), 1,
      sym_pair,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    STATE(1342), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 9,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [7633] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(651), 1,
      anon_sym_func,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(701), 1,
      anon_sym_RBRACE,
    STATE(472), 1,
      sym__primary_expression,
    STATE(546), 1,
      sym_identifier,
    STATE(1120), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1186), 1,
      sym_pair,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    STATE(1342), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 9,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [7726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(703), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(705), 30,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [7777] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(651), 1,
      anon_sym_func,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(707), 1,
      anon_sym_RBRACE,
    STATE(472), 1,
      sym__primary_expression,
    STATE(546), 1,
      sym_identifier,
    STATE(965), 1,
      sym_pair,
    STATE(1120), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    STATE(1342), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 9,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [7870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(709), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(711), 30,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [7921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(715), 30,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [7972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(719), 30,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [8023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(721), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(723), 30,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [8074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(725), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(727), 30,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [8125] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(651), 1,
      anon_sym_func,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(729), 1,
      anon_sym_RBRACE,
    STATE(472), 1,
      sym__primary_expression,
    STATE(546), 1,
      sym_identifier,
    STATE(1120), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1186), 1,
      sym_pair,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    STATE(1342), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 9,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [8218] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(651), 1,
      anon_sym_func,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(731), 1,
      anon_sym_RBRACE,
    STATE(472), 1,
      sym__primary_expression,
    STATE(546), 1,
      sym_identifier,
    STATE(1120), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1186), 1,
      sym_pair,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    STATE(1342), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 9,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [8311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(733), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(735), 30,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [8362] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(651), 1,
      anon_sym_func,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(737), 1,
      anon_sym_RBRACE,
    STATE(472), 1,
      sym__primary_expression,
    STATE(546), 1,
      sym_identifier,
    STATE(1120), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1186), 1,
      sym_pair,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    STATE(1342), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 9,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [8455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(741), 30,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [8506] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(651), 1,
      anon_sym_func,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(743), 1,
      anon_sym_RBRACE,
    STATE(472), 1,
      sym__primary_expression,
    STATE(546), 1,
      sym_identifier,
    STATE(1120), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1186), 1,
      sym_pair,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    STATE(1342), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 9,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [8599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(747), 30,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [8650] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(651), 1,
      anon_sym_func,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(749), 1,
      anon_sym_RBRACE,
    STATE(472), 1,
      sym__primary_expression,
    STATE(546), 1,
      sym_identifier,
    STATE(918), 1,
      sym_pair,
    STATE(1120), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    STATE(1342), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 9,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [8743] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(651), 1,
      anon_sym_func,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(751), 1,
      anon_sym_RBRACE,
    STATE(472), 1,
      sym__primary_expression,
    STATE(546), 1,
      sym_identifier,
    STATE(1001), 1,
      sym_pair,
    STATE(1120), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    STATE(1342), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 9,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [8836] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(651), 1,
      anon_sym_func,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(753), 1,
      anon_sym_RBRACE,
    STATE(472), 1,
      sym__primary_expression,
    STATE(546), 1,
      sym_identifier,
    STATE(1120), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1186), 1,
      sym_pair,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    STATE(1342), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 9,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [8929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(755), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(757), 30,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [8980] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(651), 1,
      anon_sym_func,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(759), 1,
      anon_sym_RBRACE,
    STATE(472), 1,
      sym__primary_expression,
    STATE(546), 1,
      sym_identifier,
    STATE(1120), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1186), 1,
      sym_pair,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    STATE(1342), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 9,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [9073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(761), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(763), 30,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [9124] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(651), 1,
      anon_sym_func,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(765), 1,
      anon_sym_RBRACE,
    STATE(472), 1,
      sym__primary_expression,
    STATE(546), 1,
      sym_identifier,
    STATE(1120), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1186), 1,
      sym_pair,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    STATE(1342), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 9,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [9217] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(651), 1,
      anon_sym_func,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(767), 1,
      anon_sym_RBRACE,
    STATE(472), 1,
      sym__primary_expression,
    STATE(546), 1,
      sym_identifier,
    STATE(1079), 1,
      sym_pair,
    STATE(1120), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    STATE(1342), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 9,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [9310] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(783), 1,
      anon_sym_RBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(793), 1,
      anon_sym_func,
    ACTIONS(795), 1,
      sym__string_start,
    STATE(529), 1,
      sym__primary_expression,
    STATE(926), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    STATE(1181), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [9398] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(817), 1,
      anon_sym_RPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(1081), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [9486] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(793), 1,
      anon_sym_func,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(825), 1,
      anon_sym_RBRACK,
    STATE(529), 1,
      sym__primary_expression,
    STATE(926), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    STATE(917), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [9574] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(793), 1,
      anon_sym_func,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(827), 1,
      anon_sym_RBRACK,
    STATE(529), 1,
      sym__primary_expression,
    STATE(926), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    STATE(1080), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [9662] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    ACTIONS(829), 1,
      anon_sym_RPAREN,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(1242), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [9750] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(793), 1,
      anon_sym_func,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(831), 1,
      anon_sym_RBRACK,
    STATE(529), 1,
      sym__primary_expression,
    STATE(926), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    STATE(1181), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [9838] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(793), 1,
      anon_sym_func,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(833), 1,
      anon_sym_RBRACK,
    STATE(529), 1,
      sym__primary_expression,
    STATE(926), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    STATE(1181), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [9926] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    ACTIONS(835), 1,
      anon_sym_RPAREN,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(1242), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [10014] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(651), 1,
      anon_sym_func,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(472), 1,
      sym__primary_expression,
    STATE(546), 1,
      sym_identifier,
    STATE(1120), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1186), 1,
      sym_pair,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    STATE(1342), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 9,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [10104] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    ACTIONS(837), 1,
      anon_sym_RPAREN,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(915), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [10192] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    ACTIONS(839), 1,
      anon_sym_RPAREN,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(1242), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [10280] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(793), 1,
      anon_sym_func,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(841), 1,
      anon_sym_RBRACK,
    STATE(529), 1,
      sym__primary_expression,
    STATE(926), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    STATE(1181), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [10368] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(793), 1,
      anon_sym_func,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(843), 1,
      anon_sym_RBRACK,
    STATE(529), 1,
      sym__primary_expression,
    STATE(926), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    STATE(1000), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [10456] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(793), 1,
      anon_sym_func,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(845), 1,
      anon_sym_RBRACK,
    STATE(529), 1,
      sym__primary_expression,
    STATE(926), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    STATE(1181), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [10544] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(793), 1,
      anon_sym_func,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(847), 1,
      anon_sym_RBRACK,
    STATE(529), 1,
      sym__primary_expression,
    STATE(926), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    STATE(1181), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [10632] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    ACTIONS(849), 1,
      anon_sym_RPAREN,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(999), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [10720] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(793), 1,
      anon_sym_func,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(851), 1,
      anon_sym_RBRACK,
    STATE(529), 1,
      sym__primary_expression,
    STATE(926), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    STATE(1181), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [10808] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(793), 1,
      anon_sym_func,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(853), 1,
      anon_sym_RBRACK,
    STATE(529), 1,
      sym__primary_expression,
    STATE(926), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    STATE(1181), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [10896] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(793), 1,
      anon_sym_func,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(855), 1,
      anon_sym_RBRACK,
    STATE(529), 1,
      sym__primary_expression,
    STATE(926), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    STATE(1181), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [10984] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    ACTIONS(857), 1,
      anon_sym_RPAREN,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(1242), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [11072] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(793), 1,
      anon_sym_func,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(859), 1,
      anon_sym_RBRACK,
    STATE(529), 1,
      sym__primary_expression,
    STATE(926), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    STATE(1181), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [11160] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(793), 1,
      anon_sym_func,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(861), 1,
      anon_sym_RBRACK,
    STATE(529), 1,
      sym__primary_expression,
    STATE(926), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    STATE(943), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [11248] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    ACTIONS(863), 1,
      anon_sym_RPAREN,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(1242), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [11336] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    ACTIONS(865), 1,
      anon_sym_RPAREN,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(1242), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [11424] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    ACTIONS(867), 1,
      anon_sym_RPAREN,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(1242), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [11512] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    ACTIONS(869), 1,
      anon_sym_RPAREN,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(1242), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [11600] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(793), 1,
      anon_sym_func,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(871), 1,
      anon_sym_RBRACK,
    STATE(529), 1,
      sym__primary_expression,
    STATE(926), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    STATE(964), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [11688] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    ACTIONS(873), 1,
      anon_sym_RPAREN,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(963), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [11776] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    ACTIONS(875), 1,
      anon_sym_RPAREN,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(1093), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [11864] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    ACTIONS(877), 1,
      anon_sym_RPAREN,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(1242), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [11952] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    ACTIONS(879), 1,
      anon_sym_RPAREN,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(1242), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [12040] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(793), 1,
      anon_sym_func,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(881), 1,
      anon_sym_RBRACK,
    STATE(529), 1,
      sym__primary_expression,
    STATE(926), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    STATE(1181), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [12128] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(793), 1,
      anon_sym_func,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(883), 1,
      anon_sym_RBRACK,
    STATE(529), 1,
      sym__primary_expression,
    STATE(926), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    STATE(1181), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [12216] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    ACTIONS(885), 1,
      anon_sym_RPAREN,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(1242), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [12304] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    ACTIONS(887), 1,
      anon_sym_RPAREN,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(1242), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [12392] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    ACTIONS(889), 1,
      anon_sym_RPAREN,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(940), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [12480] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(793), 1,
      anon_sym_func,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(891), 1,
      anon_sym_RBRACK,
    STATE(529), 1,
      sym__primary_expression,
    STATE(926), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    STATE(1181), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [12568] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    ACTIONS(893), 1,
      anon_sym_RPAREN,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(1242), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [12656] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(793), 1,
      anon_sym_func,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(895), 1,
      anon_sym_RBRACK,
    STATE(529), 1,
      sym__primary_expression,
    STATE(926), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    STATE(949), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [12744] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(793), 1,
      anon_sym_func,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(897), 1,
      anon_sym_RBRACK,
    STATE(529), 1,
      sym__primary_expression,
    STATE(926), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    STATE(1181), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [12832] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    ACTIONS(899), 1,
      anon_sym_RPAREN,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(1242), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [12920] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(793), 1,
      anon_sym_func,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(901), 1,
      anon_sym_RBRACK,
    STATE(529), 1,
      sym__primary_expression,
    STATE(926), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    STATE(1031), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [13008] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    ACTIONS(903), 1,
      anon_sym_RPAREN,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(1034), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [13096] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(905), 1,
      anon_sym_RBRACE,
    ACTIONS(907), 1,
      sym_pattern_open_ending,
    STATE(472), 1,
      sym__primary_expression,
    STATE(1066), 1,
      sym_pattern_pair,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1191), 1,
      sym__expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [13183] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(909), 1,
      anon_sym_RBRACE,
    ACTIONS(911), 1,
      sym_pattern_open_ending,
    STATE(472), 1,
      sym__primary_expression,
    STATE(1029), 1,
      sym_pattern_pair,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1191), 1,
      sym__expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [13270] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym__identifier,
    ACTIONS(17), 1,
      anon_sym_AMP,
    ACTIONS(43), 1,
      anon_sym_DOT,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(65), 1,
      anon_sym_not,
    ACTIONS(67), 1,
      anon_sym_LPAREN,
    ACTIONS(69), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    ACTIONS(584), 1,
      anon_sym_func,
    STATE(215), 1,
      sym__primary_expression,
    STATE(810), 1,
      sym__expression,
    STATE(1292), 1,
      sym__attribute_expression,
    STATE(237), 2,
      sym_string_name,
      sym_attribute,
    STATE(1026), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(15), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(744), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(9), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(63), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(233), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [13355] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(913), 1,
      sym__identifier,
    ACTIONS(919), 1,
      anon_sym_AMP,
    ACTIONS(921), 1,
      anon_sym_DOT,
    ACTIONS(923), 1,
      anon_sym_LBRACE,
    ACTIONS(925), 1,
      anon_sym_LBRACK,
    ACTIONS(929), 1,
      anon_sym_not,
    ACTIONS(931), 1,
      anon_sym_LPAREN,
    ACTIONS(933), 1,
      anon_sym_await,
    ACTIONS(935), 1,
      anon_sym_func,
    ACTIONS(937), 1,
      sym__string_start,
    STATE(619), 1,
      sym__primary_expression,
    STATE(1180), 1,
      sym__attribute_expression,
    STATE(1221), 1,
      sym__expression,
    STATE(699), 2,
      sym_string_name,
      sym_attribute,
    STATE(1348), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(917), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1225), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(915), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(927), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(696), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [13440] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(913), 1,
      sym__identifier,
    ACTIONS(919), 1,
      anon_sym_AMP,
    ACTIONS(921), 1,
      anon_sym_DOT,
    ACTIONS(923), 1,
      anon_sym_LBRACE,
    ACTIONS(925), 1,
      anon_sym_LBRACK,
    ACTIONS(929), 1,
      anon_sym_not,
    ACTIONS(931), 1,
      anon_sym_LPAREN,
    ACTIONS(933), 1,
      anon_sym_await,
    ACTIONS(935), 1,
      anon_sym_func,
    ACTIONS(937), 1,
      sym__string_start,
    STATE(619), 1,
      sym__primary_expression,
    STATE(1180), 1,
      sym__attribute_expression,
    STATE(1221), 1,
      sym__expression,
    STATE(699), 2,
      sym_string_name,
      sym_attribute,
    STATE(1327), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(917), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1225), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(915), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(927), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(696), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [13525] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(1279), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [13610] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(793), 1,
      anon_sym_func,
    ACTIONS(795), 1,
      sym__string_start,
    STATE(529), 1,
      sym__primary_expression,
    STATE(926), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    STATE(1181), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [13695] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym__identifier,
    ACTIONS(17), 1,
      anon_sym_AMP,
    ACTIONS(43), 1,
      anon_sym_DOT,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(65), 1,
      anon_sym_not,
    ACTIONS(67), 1,
      anon_sym_LPAREN,
    ACTIONS(69), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    ACTIONS(584), 1,
      anon_sym_func,
    STATE(215), 1,
      sym__primary_expression,
    STATE(810), 1,
      sym__expression,
    STATE(1292), 1,
      sym__attribute_expression,
    STATE(237), 2,
      sym_string_name,
      sym_attribute,
    STATE(1021), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(15), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(744), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(9), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(63), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(233), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [13780] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(913), 1,
      sym__identifier,
    ACTIONS(919), 1,
      anon_sym_AMP,
    ACTIONS(921), 1,
      anon_sym_DOT,
    ACTIONS(923), 1,
      anon_sym_LBRACE,
    ACTIONS(925), 1,
      anon_sym_LBRACK,
    ACTIONS(929), 1,
      anon_sym_not,
    ACTIONS(931), 1,
      anon_sym_LPAREN,
    ACTIONS(933), 1,
      anon_sym_await,
    ACTIONS(935), 1,
      anon_sym_func,
    ACTIONS(937), 1,
      sym__string_start,
    STATE(619), 1,
      sym__primary_expression,
    STATE(1180), 1,
      sym__attribute_expression,
    STATE(1221), 1,
      sym__expression,
    STATE(699), 2,
      sym_string_name,
      sym_attribute,
    STATE(1336), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(917), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1225), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(915), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(927), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(696), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [13865] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym__identifier,
    ACTIONS(17), 1,
      anon_sym_AMP,
    ACTIONS(43), 1,
      anon_sym_DOT,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(65), 1,
      anon_sym_not,
    ACTIONS(67), 1,
      anon_sym_LPAREN,
    ACTIONS(69), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    ACTIONS(584), 1,
      anon_sym_func,
    STATE(215), 1,
      sym__primary_expression,
    STATE(810), 1,
      sym__expression,
    STATE(1292), 1,
      sym__attribute_expression,
    STATE(237), 2,
      sym_string_name,
      sym_attribute,
    STATE(838), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(15), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(744), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(9), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(63), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(233), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [13950] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym__identifier,
    ACTIONS(17), 1,
      anon_sym_AMP,
    ACTIONS(43), 1,
      anon_sym_DOT,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(65), 1,
      anon_sym_not,
    ACTIONS(67), 1,
      anon_sym_LPAREN,
    ACTIONS(69), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    ACTIONS(584), 1,
      anon_sym_func,
    STATE(215), 1,
      sym__primary_expression,
    STATE(810), 1,
      sym__expression,
    STATE(1292), 1,
      sym__attribute_expression,
    STATE(237), 2,
      sym_string_name,
      sym_attribute,
    STATE(837), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(15), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(744), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(9), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(63), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(233), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [14035] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(913), 1,
      sym__identifier,
    ACTIONS(919), 1,
      anon_sym_AMP,
    ACTIONS(921), 1,
      anon_sym_DOT,
    ACTIONS(923), 1,
      anon_sym_LBRACE,
    ACTIONS(925), 1,
      anon_sym_LBRACK,
    ACTIONS(929), 1,
      anon_sym_not,
    ACTIONS(931), 1,
      anon_sym_LPAREN,
    ACTIONS(933), 1,
      anon_sym_await,
    ACTIONS(935), 1,
      anon_sym_func,
    ACTIONS(937), 1,
      sym__string_start,
    STATE(619), 1,
      sym__primary_expression,
    STATE(1180), 1,
      sym__attribute_expression,
    STATE(1221), 1,
      sym__expression,
    STATE(699), 2,
      sym_string_name,
      sym_attribute,
    STATE(1360), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(917), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1225), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(915), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(927), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(696), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [14120] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(913), 1,
      sym__identifier,
    ACTIONS(919), 1,
      anon_sym_AMP,
    ACTIONS(921), 1,
      anon_sym_DOT,
    ACTIONS(923), 1,
      anon_sym_LBRACE,
    ACTIONS(925), 1,
      anon_sym_LBRACK,
    ACTIONS(929), 1,
      anon_sym_not,
    ACTIONS(931), 1,
      anon_sym_LPAREN,
    ACTIONS(933), 1,
      anon_sym_await,
    ACTIONS(935), 1,
      anon_sym_func,
    ACTIONS(937), 1,
      sym__string_start,
    STATE(619), 1,
      sym__primary_expression,
    STATE(1180), 1,
      sym__attribute_expression,
    STATE(1221), 1,
      sym__expression,
    STATE(699), 2,
      sym_string_name,
      sym_attribute,
    STATE(1369), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(917), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1225), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(915), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(927), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(696), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [14205] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(913), 1,
      sym__identifier,
    ACTIONS(919), 1,
      anon_sym_AMP,
    ACTIONS(921), 1,
      anon_sym_DOT,
    ACTIONS(923), 1,
      anon_sym_LBRACE,
    ACTIONS(925), 1,
      anon_sym_LBRACK,
    ACTIONS(929), 1,
      anon_sym_not,
    ACTIONS(931), 1,
      anon_sym_LPAREN,
    ACTIONS(933), 1,
      anon_sym_await,
    ACTIONS(935), 1,
      anon_sym_func,
    ACTIONS(937), 1,
      sym__string_start,
    STATE(619), 1,
      sym__primary_expression,
    STATE(1180), 1,
      sym__attribute_expression,
    STATE(1221), 1,
      sym__expression,
    STATE(699), 2,
      sym_string_name,
      sym_attribute,
    STATE(1375), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(917), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1225), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(915), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(927), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(696), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [14290] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym__identifier,
    ACTIONS(17), 1,
      anon_sym_AMP,
    ACTIONS(43), 1,
      anon_sym_DOT,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(65), 1,
      anon_sym_not,
    ACTIONS(67), 1,
      anon_sym_LPAREN,
    ACTIONS(69), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    ACTIONS(584), 1,
      anon_sym_func,
    STATE(215), 1,
      sym__primary_expression,
    STATE(810), 1,
      sym__expression,
    STATE(1292), 1,
      sym__attribute_expression,
    STATE(237), 2,
      sym_string_name,
      sym_attribute,
    STATE(836), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(15), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(744), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(9), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(63), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(233), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [14375] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(1242), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [14460] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(939), 1,
      anon_sym_RBRACE,
    ACTIONS(941), 1,
      sym_pattern_open_ending,
    STATE(472), 1,
      sym__primary_expression,
    STATE(960), 1,
      sym_pattern_pair,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1191), 1,
      sym__expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [14547] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(821), 1,
      anon_sym_func,
    ACTIONS(823), 1,
      sym__string_start,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1088), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    STATE(1105), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [14632] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(913), 1,
      sym__identifier,
    ACTIONS(919), 1,
      anon_sym_AMP,
    ACTIONS(921), 1,
      anon_sym_DOT,
    ACTIONS(923), 1,
      anon_sym_LBRACE,
    ACTIONS(925), 1,
      anon_sym_LBRACK,
    ACTIONS(929), 1,
      anon_sym_not,
    ACTIONS(931), 1,
      anon_sym_LPAREN,
    ACTIONS(933), 1,
      anon_sym_await,
    ACTIONS(935), 1,
      anon_sym_func,
    ACTIONS(937), 1,
      sym__string_start,
    STATE(619), 1,
      sym__primary_expression,
    STATE(1180), 1,
      sym__attribute_expression,
    STATE(1221), 1,
      sym__expression,
    STATE(699), 2,
      sym_string_name,
      sym_attribute,
    STATE(1389), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(917), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1225), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(915), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(927), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(696), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [14717] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(943), 1,
      sym__identifier,
    ACTIONS(949), 1,
      anon_sym_AMP,
    ACTIONS(951), 1,
      anon_sym_DOT,
    ACTIONS(953), 1,
      anon_sym_LBRACE,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(959), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_LPAREN,
    ACTIONS(963), 1,
      anon_sym_await,
    ACTIONS(965), 1,
      anon_sym_func,
    ACTIONS(967), 1,
      sym__string_start,
    STATE(488), 1,
      sym__primary_expression,
    STATE(1018), 1,
      sym__expression,
    STATE(1302), 1,
      sym__attribute_expression,
    STATE(607), 2,
      sym_string_name,
      sym_attribute,
    STATE(1187), 2,
      sym__rhs_expression,
      sym_lambda,
    ACTIONS(947), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(932), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(945), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(957), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(612), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [14802] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(550), 8,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(552), 32,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      anon_sym_AT,
      anon_sym_COLON,
      anon_sym_var,
      anon_sym_onready,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_func,
  [14850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(542), 8,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(544), 32,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      anon_sym_AT,
      anon_sym_COLON,
      anon_sym_var,
      anon_sym_onready,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_func,
  [14898] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(969), 1,
      sym_pattern_open_ending,
    STATE(472), 1,
      sym__primary_expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1191), 1,
      sym__expression,
    STATE(1289), 1,
      sym_pattern_pair,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [14982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(558), 8,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 32,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      anon_sym_AT,
      anon_sym_COLON,
      anon_sym_var,
      anon_sym_onready,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_func,
  [15030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(546), 8,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(548), 32,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
      anon_sym_AT,
      anon_sym_COLON,
      anon_sym_var,
      anon_sym_onready,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_func,
  [15078] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(472), 1,
      sym__primary_expression,
    STATE(1104), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [15156] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(472), 1,
      sym__primary_expression,
    STATE(1118), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [15234] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(795), 1,
      sym__string_start,
    STATE(529), 1,
      sym__primary_expression,
    STATE(1022), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [15312] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(913), 1,
      sym__identifier,
    ACTIONS(919), 1,
      anon_sym_AMP,
    ACTIONS(921), 1,
      anon_sym_DOT,
    ACTIONS(923), 1,
      anon_sym_LBRACE,
    ACTIONS(925), 1,
      anon_sym_LBRACK,
    ACTIONS(929), 1,
      anon_sym_not,
    ACTIONS(931), 1,
      anon_sym_LPAREN,
    ACTIONS(933), 1,
      anon_sym_await,
    ACTIONS(937), 1,
      sym__string_start,
    STATE(619), 1,
      sym__primary_expression,
    STATE(1180), 1,
      sym__attribute_expression,
    STATE(1209), 1,
      sym__expression,
    STATE(699), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(917), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1225), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(915), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(927), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(696), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [15390] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(913), 1,
      sym__identifier,
    ACTIONS(919), 1,
      anon_sym_AMP,
    ACTIONS(921), 1,
      anon_sym_DOT,
    ACTIONS(923), 1,
      anon_sym_LBRACE,
    ACTIONS(925), 1,
      anon_sym_LBRACK,
    ACTIONS(929), 1,
      anon_sym_not,
    ACTIONS(931), 1,
      anon_sym_LPAREN,
    ACTIONS(933), 1,
      anon_sym_await,
    ACTIONS(937), 1,
      sym__string_start,
    STATE(619), 1,
      sym__primary_expression,
    STATE(1131), 1,
      sym__expression,
    STATE(1180), 1,
      sym__attribute_expression,
    STATE(699), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(917), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1225), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(915), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(927), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(696), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [15468] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(823), 1,
      sym__string_start,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1076), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [15546] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(472), 1,
      sym__primary_expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1208), 1,
      sym__expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [15624] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym__identifier,
    ACTIONS(17), 1,
      anon_sym_AMP,
    ACTIONS(43), 1,
      anon_sym_DOT,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(65), 1,
      anon_sym_not,
    ACTIONS(67), 1,
      anon_sym_LPAREN,
    ACTIONS(69), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(215), 1,
      sym__primary_expression,
    STATE(743), 1,
      sym__expression,
    STATE(1292), 1,
      sym__attribute_expression,
    STATE(237), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(15), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(744), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(9), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(63), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(233), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [15702] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(943), 1,
      sym__identifier,
    ACTIONS(949), 1,
      anon_sym_AMP,
    ACTIONS(951), 1,
      anon_sym_DOT,
    ACTIONS(953), 1,
      anon_sym_LBRACE,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(959), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_LPAREN,
    ACTIONS(963), 1,
      anon_sym_await,
    ACTIONS(967), 1,
      sym__string_start,
    STATE(488), 1,
      sym__primary_expression,
    STATE(983), 1,
      sym__expression,
    STATE(1302), 1,
      sym__attribute_expression,
    STATE(607), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(947), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(932), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(945), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(957), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(612), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [15780] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(630), 1,
      sym__primary_expression,
    STATE(1109), 1,
      sym__expression,
    STATE(1295), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1294), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [15858] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(472), 1,
      sym__primary_expression,
    STATE(914), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [15936] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(819), 1,
      anon_sym_await,
    ACTIONS(823), 1,
      sym__string_start,
    STATE(468), 1,
      sym__primary_expression,
    STATE(1061), 1,
      sym__expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1092), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [16014] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(472), 1,
      sym__primary_expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1213), 1,
      sym__expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [16092] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(630), 1,
      sym__primary_expression,
    STATE(1285), 1,
      sym__expression,
    STATE(1295), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1294), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [16170] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(472), 1,
      sym__primary_expression,
    STATE(1106), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [16248] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(472), 1,
      sym__primary_expression,
    STATE(1125), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [16326] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(472), 1,
      sym__primary_expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1234), 1,
      sym__expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [16404] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(943), 1,
      sym__identifier,
    ACTIONS(949), 1,
      anon_sym_AMP,
    ACTIONS(951), 1,
      anon_sym_DOT,
    ACTIONS(953), 1,
      anon_sym_LBRACE,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(959), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_LPAREN,
    ACTIONS(963), 1,
      anon_sym_await,
    ACTIONS(967), 1,
      sym__string_start,
    STATE(488), 1,
      sym__primary_expression,
    STATE(939), 1,
      sym__expression,
    STATE(1302), 1,
      sym__attribute_expression,
    STATE(607), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(947), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(932), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(945), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(957), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(612), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [16482] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(472), 1,
      sym__primary_expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1236), 1,
      sym__expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [16560] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(791), 1,
      anon_sym_await,
    ACTIONS(795), 1,
      sym__string_start,
    STATE(529), 1,
      sym__primary_expression,
    STATE(922), 1,
      sym__expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(928), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [16638] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(630), 1,
      sym__primary_expression,
    STATE(1119), 1,
      sym__expression,
    STATE(1295), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1294), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [16716] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(472), 1,
      sym__primary_expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1202), 1,
      sym__expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [16794] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(472), 1,
      sym__primary_expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1160), 1,
      sym__expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [16872] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(630), 1,
      sym__primary_expression,
    STATE(1161), 1,
      sym__expression,
    STATE(1295), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1294), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [16950] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym__identifier,
    ACTIONS(17), 1,
      anon_sym_AMP,
    ACTIONS(43), 1,
      anon_sym_DOT,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(65), 1,
      anon_sym_not,
    ACTIONS(67), 1,
      anon_sym_LPAREN,
    ACTIONS(69), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(215), 1,
      sym__primary_expression,
    STATE(746), 1,
      sym__expression,
    STATE(1292), 1,
      sym__attribute_expression,
    STATE(237), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(15), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(744), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(9), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(63), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(233), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [17028] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(630), 1,
      sym__primary_expression,
    STATE(1244), 1,
      sym__expression,
    STATE(1295), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1294), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [17106] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(472), 1,
      sym__primary_expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1195), 1,
      sym__expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [17184] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(630), 1,
      sym__primary_expression,
    STATE(1196), 1,
      sym__expression,
    STATE(1295), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1294), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [17262] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(472), 1,
      sym__primary_expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1281), 1,
      sym__expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [17340] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(630), 1,
      sym__primary_expression,
    STATE(1141), 1,
      sym__expression,
    STATE(1295), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1294), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [17418] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(472), 1,
      sym__primary_expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1230), 1,
      sym__expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [17496] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(630), 1,
      sym__primary_expression,
    STATE(1231), 1,
      sym__expression,
    STATE(1295), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1294), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [17574] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(472), 1,
      sym__primary_expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1138), 1,
      sym__expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [17652] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(472), 1,
      sym__primary_expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1265), 1,
      sym__expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [17730] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(630), 1,
      sym__primary_expression,
    STATE(1266), 1,
      sym__expression,
    STATE(1295), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1294), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [17808] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(472), 1,
      sym__primary_expression,
    STATE(1035), 1,
      sym__expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [17886] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(472), 1,
      sym__primary_expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1296), 1,
      sym__expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [17964] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(649), 1,
      anon_sym_await,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(472), 1,
      sym__primary_expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(1290), 1,
      sym__expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    STATE(1006), 3,
      sym_comparison_operator,
      sym_conditional_expression,
      sym_await_expression,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [18042] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(943), 1,
      sym__identifier,
    ACTIONS(959), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_LPAREN,
    ACTIONS(995), 1,
      sym_integer,
    STATE(571), 1,
      sym_string_name,
    STATE(735), 1,
      sym_attribute,
    STATE(736), 1,
      sym__primary_expression,
    STATE(1300), 1,
      sym__enumerator_expression,
    STATE(1302), 1,
      sym__attribute_expression,
    ACTIONS(629), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(957), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 4,
      sym_string,
      sym_dictionary,
      sym_array,
      sym_base_call,
    STATE(724), 6,
      sym_identifier,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_call,
  [18118] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(913), 1,
      sym__identifier,
    ACTIONS(919), 1,
      anon_sym_AMP,
    ACTIONS(921), 1,
      anon_sym_DOT,
    ACTIONS(923), 1,
      anon_sym_LBRACE,
    ACTIONS(925), 1,
      anon_sym_LBRACK,
    ACTIONS(929), 1,
      anon_sym_not,
    ACTIONS(931), 1,
      anon_sym_LPAREN,
    ACTIONS(937), 1,
      sym__string_start,
    STATE(602), 1,
      sym__primary_expression,
    STATE(1287), 1,
      sym__attribute_expression,
    STATE(699), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(917), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(915), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(927), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(696), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [18185] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(943), 1,
      sym__identifier,
    ACTIONS(949), 1,
      anon_sym_AMP,
    ACTIONS(951), 1,
      anon_sym_DOT,
    ACTIONS(953), 1,
      anon_sym_LBRACE,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(959), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_LPAREN,
    ACTIONS(967), 1,
      sym__string_start,
    STATE(491), 1,
      sym__primary_expression,
    STATE(1304), 1,
      sym__attribute_expression,
    STATE(607), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(947), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(945), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(957), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(612), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [18252] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(734), 1,
      sym__primary_expression,
    STATE(1295), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [18319] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(729), 1,
      sym__primary_expression,
    STATE(1295), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [18386] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(730), 1,
      sym__primary_expression,
    STATE(1295), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [18453] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(726), 1,
      sym__primary_expression,
    STATE(1295), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [18520] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(731), 1,
      sym__primary_expression,
    STATE(1295), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [18587] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(733), 1,
      sym__primary_expression,
    STATE(1295), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [18654] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym__identifier,
    ACTIONS(17), 1,
      anon_sym_AMP,
    ACTIONS(43), 1,
      anon_sym_DOT,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(65), 1,
      anon_sym_not,
    ACTIONS(67), 1,
      anon_sym_LPAREN,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(223), 1,
      sym__primary_expression,
    STATE(1145), 1,
      sym__attribute_expression,
    STATE(237), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(15), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(9), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(63), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(233), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [18721] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym__identifier,
    ACTIONS(17), 1,
      anon_sym_AMP,
    ACTIONS(43), 1,
      anon_sym_DOT,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(65), 1,
      anon_sym_not,
    ACTIONS(67), 1,
      anon_sym_LPAREN,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(217), 1,
      sym__primary_expression,
    STATE(1145), 1,
      sym__attribute_expression,
    STATE(237), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(15), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(9), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(63), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(233), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [18788] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym__identifier,
    ACTIONS(17), 1,
      anon_sym_AMP,
    ACTIONS(43), 1,
      anon_sym_DOT,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(65), 1,
      anon_sym_not,
    ACTIONS(67), 1,
      anon_sym_LPAREN,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(230), 1,
      sym__primary_expression,
    STATE(1292), 1,
      sym__attribute_expression,
    STATE(237), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(15), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(9), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(63), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(233), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [18855] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym__identifier,
    ACTIONS(17), 1,
      anon_sym_AMP,
    ACTIONS(43), 1,
      anon_sym_DOT,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(65), 1,
      anon_sym_not,
    ACTIONS(67), 1,
      anon_sym_LPAREN,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(214), 1,
      sym__primary_expression,
    STATE(1145), 1,
      sym__attribute_expression,
    STATE(237), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(15), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(9), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(63), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(233), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [18922] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym__identifier,
    ACTIONS(17), 1,
      anon_sym_AMP,
    ACTIONS(43), 1,
      anon_sym_DOT,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(65), 1,
      anon_sym_not,
    ACTIONS(67), 1,
      anon_sym_LPAREN,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(213), 1,
      sym__primary_expression,
    STATE(1145), 1,
      sym__attribute_expression,
    STATE(237), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(15), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(9), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(63), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(233), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [18989] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym__identifier,
    ACTIONS(17), 1,
      anon_sym_AMP,
    ACTIONS(43), 1,
      anon_sym_DOT,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(65), 1,
      anon_sym_not,
    ACTIONS(67), 1,
      anon_sym_LPAREN,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(207), 1,
      sym__primary_expression,
    STATE(1145), 1,
      sym__attribute_expression,
    STATE(237), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(15), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(9), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(63), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(233), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [19056] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym__identifier,
    ACTIONS(17), 1,
      anon_sym_AMP,
    ACTIONS(43), 1,
      anon_sym_DOT,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(65), 1,
      anon_sym_not,
    ACTIONS(67), 1,
      anon_sym_LPAREN,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(210), 1,
      sym__primary_expression,
    STATE(1145), 1,
      sym__attribute_expression,
    STATE(237), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(15), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(9), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(63), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(233), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [19123] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym__identifier,
    ACTIONS(17), 1,
      anon_sym_AMP,
    ACTIONS(43), 1,
      anon_sym_DOT,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(65), 1,
      anon_sym_not,
    ACTIONS(67), 1,
      anon_sym_LPAREN,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(209), 1,
      sym__primary_expression,
    STATE(1145), 1,
      sym__attribute_expression,
    STATE(237), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(15), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(9), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(63), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(233), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [19190] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym__identifier,
    ACTIONS(17), 1,
      anon_sym_AMP,
    ACTIONS(43), 1,
      anon_sym_DOT,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(65), 1,
      anon_sym_not,
    ACTIONS(67), 1,
      anon_sym_LPAREN,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(208), 1,
      sym__primary_expression,
    STATE(1145), 1,
      sym__attribute_expression,
    STATE(237), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(15), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(9), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(63), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(233), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [19257] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym__identifier,
    ACTIONS(17), 1,
      anon_sym_AMP,
    ACTIONS(43), 1,
      anon_sym_DOT,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(65), 1,
      anon_sym_not,
    ACTIONS(67), 1,
      anon_sym_LPAREN,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(220), 1,
      sym__primary_expression,
    STATE(1145), 1,
      sym__attribute_expression,
    STATE(237), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(15), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(9), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(63), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(233), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [19324] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym__identifier,
    ACTIONS(17), 1,
      anon_sym_AMP,
    ACTIONS(43), 1,
      anon_sym_DOT,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(65), 1,
      anon_sym_not,
    ACTIONS(67), 1,
      anon_sym_LPAREN,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(212), 1,
      sym__primary_expression,
    STATE(1145), 1,
      sym__attribute_expression,
    STATE(237), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(15), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(9), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(63), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(233), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [19391] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym__identifier,
    ACTIONS(17), 1,
      anon_sym_AMP,
    ACTIONS(43), 1,
      anon_sym_DOT,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(65), 1,
      anon_sym_not,
    ACTIONS(67), 1,
      anon_sym_LPAREN,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(222), 1,
      sym__primary_expression,
    STATE(1145), 1,
      sym__attribute_expression,
    STATE(237), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(15), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(9), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(63), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(233), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [19458] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(728), 1,
      sym__primary_expression,
    STATE(1295), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [19525] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(795), 1,
      sym__string_start,
    STATE(528), 1,
      sym__primary_expression,
    STATE(1278), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [19592] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(795), 1,
      sym__string_start,
    STATE(513), 1,
      sym__primary_expression,
    STATE(1278), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [19659] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(795), 1,
      sym__string_start,
    STATE(650), 1,
      sym__primary_expression,
    STATE(1103), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [19726] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(795), 1,
      sym__string_start,
    STATE(512), 1,
      sym__primary_expression,
    STATE(1278), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [19793] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(795), 1,
      sym__string_start,
    STATE(503), 1,
      sym__primary_expression,
    STATE(1278), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [19860] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(795), 1,
      sym__string_start,
    STATE(501), 1,
      sym__primary_expression,
    STATE(1278), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [19927] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(795), 1,
      sym__string_start,
    STATE(500), 1,
      sym__primary_expression,
    STATE(1278), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [19994] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(795), 1,
      sym__string_start,
    STATE(498), 1,
      sym__primary_expression,
    STATE(1278), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [20061] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(795), 1,
      sym__string_start,
    STATE(497), 1,
      sym__primary_expression,
    STATE(1278), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [20128] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(795), 1,
      sym__string_start,
    STATE(496), 1,
      sym__primary_expression,
    STATE(1278), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [20195] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(795), 1,
      sym__string_start,
    STATE(495), 1,
      sym__primary_expression,
    STATE(1278), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [20262] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(775), 1,
      anon_sym_AMP,
    ACTIONS(777), 1,
      anon_sym_DOT,
    ACTIONS(779), 1,
      anon_sym_LBRACE,
    ACTIONS(781), 1,
      anon_sym_LBRACK,
    ACTIONS(787), 1,
      anon_sym_not,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(795), 1,
      sym__string_start,
    STATE(492), 1,
      sym__primary_expression,
    STATE(1278), 1,
      sym__attribute_expression,
    STATE(613), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(773), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(771), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(785), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(610), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [20329] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(473), 1,
      sym__primary_expression,
    STATE(1250), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [20396] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(913), 1,
      sym__identifier,
    ACTIONS(919), 1,
      anon_sym_AMP,
    ACTIONS(921), 1,
      anon_sym_DOT,
    ACTIONS(923), 1,
      anon_sym_LBRACE,
    ACTIONS(925), 1,
      anon_sym_LBRACK,
    ACTIONS(929), 1,
      anon_sym_not,
    ACTIONS(931), 1,
      anon_sym_LPAREN,
    ACTIONS(937), 1,
      sym__string_start,
    STATE(566), 1,
      sym__primary_expression,
    STATE(1287), 1,
      sym__attribute_expression,
    STATE(699), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(917), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(915), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(927), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(696), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [20463] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(913), 1,
      sym__identifier,
    ACTIONS(919), 1,
      anon_sym_AMP,
    ACTIONS(921), 1,
      anon_sym_DOT,
    ACTIONS(923), 1,
      anon_sym_LBRACE,
    ACTIONS(925), 1,
      anon_sym_LBRACK,
    ACTIONS(929), 1,
      anon_sym_not,
    ACTIONS(931), 1,
      anon_sym_LPAREN,
    ACTIONS(937), 1,
      sym__string_start,
    STATE(713), 1,
      sym__primary_expression,
    STATE(1180), 1,
      sym__attribute_expression,
    STATE(699), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(917), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(915), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(927), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(696), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [20530] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(943), 1,
      sym__identifier,
    ACTIONS(949), 1,
      anon_sym_AMP,
    ACTIONS(951), 1,
      anon_sym_DOT,
    ACTIONS(953), 1,
      anon_sym_LBRACE,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(959), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_LPAREN,
    ACTIONS(967), 1,
      sym__string_start,
    STATE(526), 1,
      sym__primary_expression,
    STATE(1304), 1,
      sym__attribute_expression,
    STATE(607), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(947), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(945), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(957), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(612), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [20597] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(913), 1,
      sym__identifier,
    ACTIONS(919), 1,
      anon_sym_AMP,
    ACTIONS(921), 1,
      anon_sym_DOT,
    ACTIONS(923), 1,
      anon_sym_LBRACE,
    ACTIONS(925), 1,
      anon_sym_LBRACK,
    ACTIONS(929), 1,
      anon_sym_not,
    ACTIONS(931), 1,
      anon_sym_LPAREN,
    ACTIONS(937), 1,
      sym__string_start,
    STATE(564), 1,
      sym__primary_expression,
    STATE(1287), 1,
      sym__attribute_expression,
    STATE(699), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(917), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(915), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(927), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(696), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [20664] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(943), 1,
      sym__identifier,
    ACTIONS(949), 1,
      anon_sym_AMP,
    ACTIONS(951), 1,
      anon_sym_DOT,
    ACTIONS(953), 1,
      anon_sym_LBRACE,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(959), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_LPAREN,
    ACTIONS(967), 1,
      sym__string_start,
    STATE(523), 1,
      sym__primary_expression,
    STATE(1304), 1,
      sym__attribute_expression,
    STATE(607), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(947), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(945), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(957), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(612), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [20731] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(943), 1,
      sym__identifier,
    ACTIONS(949), 1,
      anon_sym_AMP,
    ACTIONS(951), 1,
      anon_sym_DOT,
    ACTIONS(953), 1,
      anon_sym_LBRACE,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(959), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_LPAREN,
    ACTIONS(967), 1,
      sym__string_start,
    STATE(522), 1,
      sym__primary_expression,
    STATE(1304), 1,
      sym__attribute_expression,
    STATE(607), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(947), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(945), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(957), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(612), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [20798] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(943), 1,
      sym__identifier,
    ACTIONS(949), 1,
      anon_sym_AMP,
    ACTIONS(951), 1,
      anon_sym_DOT,
    ACTIONS(953), 1,
      anon_sym_LBRACE,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(959), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_LPAREN,
    ACTIONS(967), 1,
      sym__string_start,
    STATE(521), 1,
      sym__primary_expression,
    STATE(1304), 1,
      sym__attribute_expression,
    STATE(607), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(947), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(945), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(957), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(612), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [20865] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(943), 1,
      sym__identifier,
    ACTIONS(949), 1,
      anon_sym_AMP,
    ACTIONS(951), 1,
      anon_sym_DOT,
    ACTIONS(953), 1,
      anon_sym_LBRACE,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(959), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_LPAREN,
    ACTIONS(967), 1,
      sym__string_start,
    STATE(520), 1,
      sym__primary_expression,
    STATE(1304), 1,
      sym__attribute_expression,
    STATE(607), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(947), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(945), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(957), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(612), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [20932] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(943), 1,
      sym__identifier,
    ACTIONS(949), 1,
      anon_sym_AMP,
    ACTIONS(951), 1,
      anon_sym_DOT,
    ACTIONS(953), 1,
      anon_sym_LBRACE,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(959), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_LPAREN,
    ACTIONS(967), 1,
      sym__string_start,
    STATE(519), 1,
      sym__primary_expression,
    STATE(1304), 1,
      sym__attribute_expression,
    STATE(607), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(947), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(945), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(957), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(612), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [20999] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(943), 1,
      sym__identifier,
    ACTIONS(949), 1,
      anon_sym_AMP,
    ACTIONS(951), 1,
      anon_sym_DOT,
    ACTIONS(953), 1,
      anon_sym_LBRACE,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(959), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_LPAREN,
    ACTIONS(967), 1,
      sym__string_start,
    STATE(518), 1,
      sym__primary_expression,
    STATE(1304), 1,
      sym__attribute_expression,
    STATE(607), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(947), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(945), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(957), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(612), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [21066] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(943), 1,
      sym__identifier,
    ACTIONS(949), 1,
      anon_sym_AMP,
    ACTIONS(951), 1,
      anon_sym_DOT,
    ACTIONS(953), 1,
      anon_sym_LBRACE,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(959), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_LPAREN,
    ACTIONS(967), 1,
      sym__string_start,
    STATE(515), 1,
      sym__primary_expression,
    STATE(1304), 1,
      sym__attribute_expression,
    STATE(607), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(947), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(945), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(957), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(612), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [21133] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(943), 1,
      sym__identifier,
    ACTIONS(949), 1,
      anon_sym_AMP,
    ACTIONS(951), 1,
      anon_sym_DOT,
    ACTIONS(953), 1,
      anon_sym_LBRACE,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(959), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_LPAREN,
    ACTIONS(967), 1,
      sym__string_start,
    STATE(499), 1,
      sym__primary_expression,
    STATE(1304), 1,
      sym__attribute_expression,
    STATE(607), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(947), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(945), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(957), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(612), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [21200] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(943), 1,
      sym__identifier,
    ACTIONS(949), 1,
      anon_sym_AMP,
    ACTIONS(951), 1,
      anon_sym_DOT,
    ACTIONS(953), 1,
      anon_sym_LBRACE,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(959), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_LPAREN,
    ACTIONS(967), 1,
      sym__string_start,
    STATE(590), 1,
      sym__primary_expression,
    STATE(1302), 1,
      sym__attribute_expression,
    STATE(607), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(947), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(945), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(957), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(612), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [21267] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(913), 1,
      sym__identifier,
    ACTIONS(919), 1,
      anon_sym_AMP,
    ACTIONS(921), 1,
      anon_sym_DOT,
    ACTIONS(923), 1,
      anon_sym_LBRACE,
    ACTIONS(925), 1,
      anon_sym_LBRACK,
    ACTIONS(929), 1,
      anon_sym_not,
    ACTIONS(931), 1,
      anon_sym_LPAREN,
    ACTIONS(937), 1,
      sym__string_start,
    STATE(550), 1,
      sym__primary_expression,
    STATE(1287), 1,
      sym__attribute_expression,
    STATE(699), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(917), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(915), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(927), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(696), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [21334] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(913), 1,
      sym__identifier,
    ACTIONS(919), 1,
      anon_sym_AMP,
    ACTIONS(921), 1,
      anon_sym_DOT,
    ACTIONS(923), 1,
      anon_sym_LBRACE,
    ACTIONS(925), 1,
      anon_sym_LBRACK,
    ACTIONS(929), 1,
      anon_sym_not,
    ACTIONS(931), 1,
      anon_sym_LPAREN,
    ACTIONS(937), 1,
      sym__string_start,
    STATE(563), 1,
      sym__primary_expression,
    STATE(1287), 1,
      sym__attribute_expression,
    STATE(699), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(917), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(915), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(927), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(696), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [21401] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(913), 1,
      sym__identifier,
    ACTIONS(919), 1,
      anon_sym_AMP,
    ACTIONS(921), 1,
      anon_sym_DOT,
    ACTIONS(923), 1,
      anon_sym_LBRACE,
    ACTIONS(925), 1,
      anon_sym_LBRACK,
    ACTIONS(929), 1,
      anon_sym_not,
    ACTIONS(931), 1,
      anon_sym_LPAREN,
    ACTIONS(937), 1,
      sym__string_start,
    STATE(562), 1,
      sym__primary_expression,
    STATE(1287), 1,
      sym__attribute_expression,
    STATE(699), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(917), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(915), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(927), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(696), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [21468] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(943), 1,
      sym__identifier,
    ACTIONS(949), 1,
      anon_sym_AMP,
    ACTIONS(951), 1,
      anon_sym_DOT,
    ACTIONS(953), 1,
      anon_sym_LBRACE,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(959), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_LPAREN,
    ACTIONS(967), 1,
      sym__string_start,
    STATE(489), 1,
      sym__primary_expression,
    STATE(1304), 1,
      sym__attribute_expression,
    STATE(607), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(947), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(945), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(957), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(612), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [21535] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(628), 1,
      sym__primary_expression,
    STATE(1303), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [21602] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(913), 1,
      sym__identifier,
    ACTIONS(919), 1,
      anon_sym_AMP,
    ACTIONS(921), 1,
      anon_sym_DOT,
    ACTIONS(923), 1,
      anon_sym_LBRACE,
    ACTIONS(925), 1,
      anon_sym_LBRACK,
    ACTIONS(929), 1,
      anon_sym_not,
    ACTIONS(931), 1,
      anon_sym_LPAREN,
    ACTIONS(937), 1,
      sym__string_start,
    STATE(561), 1,
      sym__primary_expression,
    STATE(1287), 1,
      sym__attribute_expression,
    STATE(699), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(917), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(915), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(927), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(696), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [21669] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(639), 1,
      sym__primary_expression,
    STATE(1303), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [21736] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(643), 1,
      sym__primary_expression,
    STATE(1303), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [21803] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(647), 1,
      sym__primary_expression,
    STATE(1303), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [21870] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(652), 1,
      sym__primary_expression,
    STATE(1303), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [21937] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(654), 1,
      sym__primary_expression,
    STATE(1303), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [22004] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(658), 1,
      sym__primary_expression,
    STATE(1303), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [22071] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(532), 1,
      sym__primary_expression,
    STATE(1303), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [22138] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(661), 1,
      sym__primary_expression,
    STATE(1303), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [22205] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(668), 1,
      sym__primary_expression,
    STATE(1295), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [22272] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(664), 1,
      sym__primary_expression,
    STATE(1303), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [22339] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__identifier,
    ACTIONS(977), 1,
      anon_sym_AMP,
    ACTIONS(979), 1,
      anon_sym_DOT,
    ACTIONS(981), 1,
      anon_sym_LBRACE,
    ACTIONS(983), 1,
      anon_sym_LBRACK,
    ACTIONS(987), 1,
      anon_sym_not,
    ACTIONS(989), 1,
      anon_sym_LPAREN,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(633), 1,
      sym__primary_expression,
    STATE(1303), 1,
      sym__attribute_expression,
    STATE(688), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(975), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(973), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(985), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(691), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [22406] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(913), 1,
      sym__identifier,
    ACTIONS(919), 1,
      anon_sym_AMP,
    ACTIONS(921), 1,
      anon_sym_DOT,
    ACTIONS(923), 1,
      anon_sym_LBRACE,
    ACTIONS(925), 1,
      anon_sym_LBRACK,
    ACTIONS(929), 1,
      anon_sym_not,
    ACTIONS(931), 1,
      anon_sym_LPAREN,
    ACTIONS(937), 1,
      sym__string_start,
    STATE(559), 1,
      sym__primary_expression,
    STATE(1287), 1,
      sym__attribute_expression,
    STATE(699), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(917), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(915), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(927), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(696), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [22473] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(913), 1,
      sym__identifier,
    ACTIONS(919), 1,
      anon_sym_AMP,
    ACTIONS(921), 1,
      anon_sym_DOT,
    ACTIONS(923), 1,
      anon_sym_LBRACE,
    ACTIONS(925), 1,
      anon_sym_LBRACK,
    ACTIONS(929), 1,
      anon_sym_not,
    ACTIONS(931), 1,
      anon_sym_LPAREN,
    ACTIONS(937), 1,
      sym__string_start,
    STATE(558), 1,
      sym__primary_expression,
    STATE(1287), 1,
      sym__attribute_expression,
    STATE(699), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(917), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(915), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(927), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(696), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [22540] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(913), 1,
      sym__identifier,
    ACTIONS(919), 1,
      anon_sym_AMP,
    ACTIONS(921), 1,
      anon_sym_DOT,
    ACTIONS(923), 1,
      anon_sym_LBRACE,
    ACTIONS(925), 1,
      anon_sym_LBRACK,
    ACTIONS(929), 1,
      anon_sym_not,
    ACTIONS(931), 1,
      anon_sym_LPAREN,
    ACTIONS(937), 1,
      sym__string_start,
    STATE(556), 1,
      sym__primary_expression,
    STATE(1287), 1,
      sym__attribute_expression,
    STATE(699), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(917), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(915), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(927), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(696), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [22607] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(511), 1,
      sym__primary_expression,
    STATE(1250), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [22674] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(510), 1,
      sym__primary_expression,
    STATE(1250), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [22741] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(509), 1,
      sym__primary_expression,
    STATE(1250), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [22808] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(508), 1,
      sym__primary_expression,
    STATE(1250), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [22875] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(507), 1,
      sym__primary_expression,
    STATE(1250), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [22942] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(506), 1,
      sym__primary_expression,
    STATE(1250), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [23009] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(505), 1,
      sym__primary_expression,
    STATE(1250), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [23076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(554), 5,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(556), 28,
      anon_sym_AT,
      anon_sym_COLON,
      anon_sym_var,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_func,
  [23117] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(504), 1,
      sym__primary_expression,
    STATE(1250), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [23184] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(533), 1,
      sym__primary_expression,
    STATE(1134), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [23251] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(469), 1,
      sym__primary_expression,
    STATE(1250), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [23318] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      sym__identifier,
    ACTIONS(633), 1,
      anon_sym_AMP,
    ACTIONS(635), 1,
      anon_sym_DOT,
    ACTIONS(637), 1,
      anon_sym_LBRACE,
    ACTIONS(641), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_not,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(502), 1,
      sym__primary_expression,
    STATE(1250), 1,
      sym__attribute_expression,
    STATE(571), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(631), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(629), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(643), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(573), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [23385] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(823), 1,
      sym__string_start,
    STATE(484), 1,
      sym__primary_expression,
    STATE(1301), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [23452] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(913), 1,
      sym__identifier,
    ACTIONS(919), 1,
      anon_sym_AMP,
    ACTIONS(921), 1,
      anon_sym_DOT,
    ACTIONS(923), 1,
      anon_sym_LBRACE,
    ACTIONS(925), 1,
      anon_sym_LBRACK,
    ACTIONS(929), 1,
      anon_sym_not,
    ACTIONS(931), 1,
      anon_sym_LPAREN,
    ACTIONS(937), 1,
      sym__string_start,
    STATE(555), 1,
      sym__primary_expression,
    STATE(1287), 1,
      sym__attribute_expression,
    STATE(699), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(917), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(915), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(927), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(696), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [23519] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(823), 1,
      sym__string_start,
    STATE(481), 1,
      sym__primary_expression,
    STATE(1301), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [23586] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(823), 1,
      sym__string_start,
    STATE(480), 1,
      sym__primary_expression,
    STATE(1301), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [23653] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(823), 1,
      sym__string_start,
    STATE(479), 1,
      sym__primary_expression,
    STATE(1301), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [23720] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(823), 1,
      sym__string_start,
    STATE(478), 1,
      sym__primary_expression,
    STATE(1301), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [23787] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(823), 1,
      sym__string_start,
    STATE(477), 1,
      sym__primary_expression,
    STATE(1301), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [23854] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(823), 1,
      sym__string_start,
    STATE(476), 1,
      sym__primary_expression,
    STATE(1301), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [23921] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(823), 1,
      sym__string_start,
    STATE(475), 1,
      sym__primary_expression,
    STATE(1301), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [23988] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(823), 1,
      sym__string_start,
    STATE(474), 1,
      sym__primary_expression,
    STATE(1301), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [24055] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(823), 1,
      sym__string_start,
    STATE(572), 1,
      sym__primary_expression,
    STATE(1215), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [24122] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(823), 1,
      sym__string_start,
    STATE(467), 1,
      sym__primary_expression,
    STATE(1301), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [24189] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      sym__identifier,
    ACTIONS(803), 1,
      anon_sym_AMP,
    ACTIONS(805), 1,
      anon_sym_DOT,
    ACTIONS(807), 1,
      anon_sym_LBRACE,
    ACTIONS(809), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_not,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(823), 1,
      sym__string_start,
    STATE(470), 1,
      sym__primary_expression,
    STATE(1301), 1,
      sym__attribute_expression,
    STATE(534), 2,
      sym_string_name,
      sym_attribute,
    ACTIONS(801), 3,
      sym_float,
      sym_node_path,
      sym_get_node,
    ACTIONS(799), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
    ACTIONS(811), 4,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(537), 10,
      sym_identifier,
      sym_string,
      sym_binary_operator,
      sym_unary_operator,
      sym_subscript,
      sym_parenthesized_expression,
      sym_dictionary,
      sym_array,
      sym_base_call,
      sym_call,
  [24256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(554), 5,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(556), 26,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [24295] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1001), 1,
      anon_sym_CARET,
    ACTIONS(1005), 1,
      anon_sym_is,
    ACTIONS(1007), 1,
      anon_sym_as,
    ACTIONS(1009), 1,
      anon_sym_LPAREN,
    STATE(545), 1,
      sym_arguments,
    ACTIONS(997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(999), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 14,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [24349] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1001), 1,
      anon_sym_CARET,
    ACTIONS(1007), 1,
      anon_sym_as,
    ACTIONS(1009), 1,
      anon_sym_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_AMP,
    ACTIONS(1015), 1,
      anon_sym_LBRACK,
    ACTIONS(1021), 1,
      anon_sym_PIPE,
    ACTIONS(1023), 1,
      anon_sym_is,
    STATE(545), 1,
      sym_arguments,
    STATE(760), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1017), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1019), 2,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
    ACTIONS(1025), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(590), 3,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_RPAREN,
    ACTIONS(999), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1013), 5,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [24417] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_is,
    ACTIONS(1029), 1,
      anon_sym_as,
    ACTIONS(1031), 1,
      anon_sym_LPAREN,
    STATE(586), 1,
      sym_arguments,
    ACTIONS(619), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(621), 22,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [24463] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 1,
      anon_sym_is,
    ACTIONS(1007), 1,
      anon_sym_as,
    ACTIONS(1009), 1,
      anon_sym_LPAREN,
    STATE(545), 1,
      sym_arguments,
    ACTIONS(619), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(621), 22,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [24509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(525), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(604), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(606), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [24549] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_as,
    ACTIONS(1031), 1,
      anon_sym_LPAREN,
    ACTIONS(1033), 1,
      anon_sym_AMP,
    ACTIONS(1037), 1,
      anon_sym_LBRACK,
    ACTIONS(1047), 1,
      anon_sym_PIPE,
    ACTIONS(1049), 1,
      anon_sym_CARET,
    ACTIONS(1053), 1,
      anon_sym_is,
    STATE(586), 1,
      sym_arguments,
    STATE(754), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1039), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1041), 2,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
    ACTIONS(1043), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1051), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1055), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(590), 3,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_else,
    ACTIONS(1045), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1035), 5,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [24617] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_as,
    ACTIONS(1031), 1,
      anon_sym_LPAREN,
    STATE(586), 1,
      sym_arguments,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 23,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [24661] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1001), 1,
      anon_sym_CARET,
    ACTIONS(1005), 1,
      anon_sym_is,
    ACTIONS(1007), 1,
      anon_sym_as,
    ACTIONS(1009), 1,
      anon_sym_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_AMP,
    ACTIONS(1021), 1,
      anon_sym_PIPE,
    STATE(545), 1,
      sym_arguments,
    ACTIONS(562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(999), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(564), 14,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [24719] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1001), 1,
      anon_sym_CARET,
    ACTIONS(1005), 1,
      anon_sym_is,
    ACTIONS(1007), 1,
      anon_sym_as,
    ACTIONS(1009), 1,
      anon_sym_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_AMP,
    ACTIONS(1021), 1,
      anon_sym_PIPE,
    STATE(545), 1,
      sym_arguments,
    ACTIONS(562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1017), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(999), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(564), 12,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [24779] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 1,
      anon_sym_is,
    ACTIONS(1007), 1,
      anon_sym_as,
    ACTIONS(1009), 1,
      anon_sym_LPAREN,
    STATE(545), 1,
      sym_arguments,
    ACTIONS(999), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 19,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [24827] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 1,
      anon_sym_is,
    ACTIONS(1007), 1,
      anon_sym_as,
    ACTIONS(1009), 1,
      anon_sym_LPAREN,
    STATE(545), 1,
      sym_arguments,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 22,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [24873] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1001), 1,
      anon_sym_CARET,
    ACTIONS(1005), 1,
      anon_sym_is,
    ACTIONS(1007), 1,
      anon_sym_as,
    ACTIONS(1009), 1,
      anon_sym_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_AMP,
    STATE(545), 1,
      sym_arguments,
    ACTIONS(997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(562), 3,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(999), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(564), 14,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [24929] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 1,
      anon_sym_is,
    ACTIONS(1007), 1,
      anon_sym_as,
    ACTIONS(1009), 1,
      anon_sym_LPAREN,
    STATE(545), 1,
      sym_arguments,
    ACTIONS(997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(999), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 15,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [24981] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 1,
      anon_sym_is,
    ACTIONS(1007), 1,
      anon_sym_as,
    ACTIONS(1009), 1,
      anon_sym_LPAREN,
    STATE(545), 1,
      sym_arguments,
    ACTIONS(997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(999), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 17,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [25031] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1007), 1,
      anon_sym_as,
    ACTIONS(1009), 1,
      anon_sym_LPAREN,
    STATE(545), 1,
      sym_arguments,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 23,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [25075] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1009), 1,
      anon_sym_LPAREN,
    ACTIONS(1057), 1,
      anon_sym_LBRACK,
    STATE(618), 1,
      sym_arguments,
    ACTIONS(608), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(610), 23,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [25119] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 1,
      anon_sym_DOT,
    STATE(483), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(608), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(610), 24,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [25161] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1007), 1,
      anon_sym_as,
    ACTIONS(1009), 1,
      anon_sym_LPAREN,
    STATE(545), 1,
      sym_arguments,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 23,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [25205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(554), 5,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(556), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [25243] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1062), 1,
      anon_sym_DOT,
    STATE(516), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(604), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(606), 24,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [25285] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1064), 1,
      anon_sym_DOT,
    STATE(483), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(604), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(606), 24,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [25327] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1066), 1,
      anon_sym_AMP,
    ACTIONS(1070), 1,
      anon_sym_LBRACK,
    ACTIONS(1080), 1,
      anon_sym_PIPE,
    ACTIONS(1082), 1,
      anon_sym_CARET,
    ACTIONS(1086), 1,
      anon_sym_is,
    ACTIONS(1088), 1,
      anon_sym_as,
    ACTIONS(1092), 1,
      anon_sym_LPAREN,
    STATE(598), 1,
      sym_arguments,
    STATE(753), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1072), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1074), 2,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
    ACTIONS(1076), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1090), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(590), 3,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_RBRACE,
    ACTIONS(1078), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1068), 5,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [25395] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1088), 1,
      anon_sym_as,
    ACTIONS(1092), 1,
      anon_sym_LPAREN,
    ACTIONS(1094), 1,
      anon_sym_is,
    STATE(598), 1,
      sym_arguments,
    ACTIONS(619), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(621), 22,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [25441] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(516), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(604), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(606), 25,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [25481] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1082), 1,
      anon_sym_CARET,
    ACTIONS(1088), 1,
      anon_sym_as,
    ACTIONS(1092), 1,
      anon_sym_LPAREN,
    ACTIONS(1094), 1,
      anon_sym_is,
    STATE(598), 1,
      sym_arguments,
    ACTIONS(1076), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1078), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 14,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [25535] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1096), 1,
      anon_sym_as,
    ACTIONS(1098), 1,
      anon_sym_LPAREN,
    STATE(637), 1,
      sym_arguments,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 23,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [25579] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1100), 1,
      anon_sym_DOT,
    STATE(493), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(608), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(610), 24,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [25621] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1098), 1,
      anon_sym_LPAREN,
    ACTIONS(1103), 1,
      anon_sym_LBRACK,
    STATE(640), 1,
      sym_arguments,
    ACTIONS(608), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(610), 23,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [25665] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1096), 1,
      anon_sym_as,
    ACTIONS(1098), 1,
      anon_sym_LPAREN,
    STATE(637), 1,
      sym_arguments,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 23,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [25709] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1096), 1,
      anon_sym_as,
    ACTIONS(1098), 1,
      anon_sym_LPAREN,
    ACTIONS(1109), 1,
      anon_sym_is,
    STATE(637), 1,
      sym_arguments,
    ACTIONS(1105), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1107), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 17,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [25759] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1096), 1,
      anon_sym_as,
    ACTIONS(1098), 1,
      anon_sym_LPAREN,
    ACTIONS(1109), 1,
      anon_sym_is,
    STATE(637), 1,
      sym_arguments,
    ACTIONS(1105), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1111), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1107), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 15,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [25811] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1096), 1,
      anon_sym_as,
    ACTIONS(1098), 1,
      anon_sym_LPAREN,
    ACTIONS(1109), 1,
      anon_sym_is,
    ACTIONS(1113), 1,
      anon_sym_AMP,
    ACTIONS(1115), 1,
      anon_sym_CARET,
    STATE(637), 1,
      sym_arguments,
    ACTIONS(1105), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1111), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(562), 3,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1107), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(564), 14,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [25867] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1066), 1,
      anon_sym_AMP,
    ACTIONS(1080), 1,
      anon_sym_PIPE,
    ACTIONS(1082), 1,
      anon_sym_CARET,
    ACTIONS(1088), 1,
      anon_sym_as,
    ACTIONS(1092), 1,
      anon_sym_LPAREN,
    ACTIONS(1094), 1,
      anon_sym_is,
    STATE(598), 1,
      sym_arguments,
    ACTIONS(562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1076), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1078), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(564), 14,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [25925] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1096), 1,
      anon_sym_as,
    ACTIONS(1098), 1,
      anon_sym_LPAREN,
    ACTIONS(1109), 1,
      anon_sym_is,
    STATE(637), 1,
      sym_arguments,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 22,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [25971] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1096), 1,
      anon_sym_as,
    ACTIONS(1098), 1,
      anon_sym_LPAREN,
    ACTIONS(1109), 1,
      anon_sym_is,
    STATE(637), 1,
      sym_arguments,
    ACTIONS(1107), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 19,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [26019] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_is,
    ACTIONS(1029), 1,
      anon_sym_as,
    ACTIONS(1031), 1,
      anon_sym_LPAREN,
    ACTIONS(1049), 1,
      anon_sym_CARET,
    STATE(586), 1,
      sym_arguments,
    ACTIONS(1043), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1051), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1045), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 14,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [26073] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1096), 1,
      anon_sym_as,
    ACTIONS(1098), 1,
      anon_sym_LPAREN,
    ACTIONS(1109), 1,
      anon_sym_is,
    ACTIONS(1113), 1,
      anon_sym_AMP,
    ACTIONS(1115), 1,
      anon_sym_CARET,
    ACTIONS(1119), 1,
      anon_sym_PIPE,
    STATE(637), 1,
      sym_arguments,
    ACTIONS(562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1105), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1111), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1117), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1107), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(564), 12,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [26133] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_is,
    ACTIONS(1029), 1,
      anon_sym_as,
    ACTIONS(1031), 1,
      anon_sym_LPAREN,
    ACTIONS(1033), 1,
      anon_sym_AMP,
    ACTIONS(1047), 1,
      anon_sym_PIPE,
    ACTIONS(1049), 1,
      anon_sym_CARET,
    STATE(586), 1,
      sym_arguments,
    ACTIONS(562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1043), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1051), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1045), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(564), 14,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [26191] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_is,
    ACTIONS(1029), 1,
      anon_sym_as,
    ACTIONS(1031), 1,
      anon_sym_LPAREN,
    ACTIONS(1033), 1,
      anon_sym_AMP,
    ACTIONS(1047), 1,
      anon_sym_PIPE,
    ACTIONS(1049), 1,
      anon_sym_CARET,
    STATE(586), 1,
      sym_arguments,
    ACTIONS(562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1039), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1043), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1051), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1045), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(564), 12,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [26251] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_is,
    ACTIONS(1029), 1,
      anon_sym_as,
    ACTIONS(1031), 1,
      anon_sym_LPAREN,
    STATE(586), 1,
      sym_arguments,
    ACTIONS(1045), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 19,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [26299] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_is,
    ACTIONS(1029), 1,
      anon_sym_as,
    ACTIONS(1031), 1,
      anon_sym_LPAREN,
    STATE(586), 1,
      sym_arguments,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 22,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [26345] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_is,
    ACTIONS(1029), 1,
      anon_sym_as,
    ACTIONS(1031), 1,
      anon_sym_LPAREN,
    ACTIONS(1033), 1,
      anon_sym_AMP,
    ACTIONS(1049), 1,
      anon_sym_CARET,
    STATE(586), 1,
      sym_arguments,
    ACTIONS(1043), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1051), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(562), 3,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1045), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(564), 14,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [26401] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_is,
    ACTIONS(1029), 1,
      anon_sym_as,
    ACTIONS(1031), 1,
      anon_sym_LPAREN,
    STATE(586), 1,
      sym_arguments,
    ACTIONS(1043), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1051), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1045), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 15,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [26453] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_is,
    ACTIONS(1029), 1,
      anon_sym_as,
    ACTIONS(1031), 1,
      anon_sym_LPAREN,
    STATE(586), 1,
      sym_arguments,
    ACTIONS(1043), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1045), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 17,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [26503] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      anon_sym_as,
    ACTIONS(1031), 1,
      anon_sym_LPAREN,
    STATE(586), 1,
      sym_arguments,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 23,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [26547] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1096), 1,
      anon_sym_as,
    ACTIONS(1098), 1,
      anon_sym_LPAREN,
    ACTIONS(1109), 1,
      anon_sym_is,
    ACTIONS(1113), 1,
      anon_sym_AMP,
    ACTIONS(1115), 1,
      anon_sym_CARET,
    ACTIONS(1119), 1,
      anon_sym_PIPE,
    STATE(637), 1,
      sym_arguments,
    ACTIONS(562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1105), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1111), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1107), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(564), 14,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [26605] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1096), 1,
      anon_sym_as,
    ACTIONS(1098), 1,
      anon_sym_LPAREN,
    ACTIONS(1109), 1,
      anon_sym_is,
    ACTIONS(1115), 1,
      anon_sym_CARET,
    STATE(637), 1,
      sym_arguments,
    ACTIONS(1105), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1111), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1107), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 14,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [26659] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1031), 1,
      anon_sym_LPAREN,
    ACTIONS(1121), 1,
      anon_sym_LBRACK,
    STATE(539), 1,
      sym_arguments,
    ACTIONS(608), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(610), 23,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [26703] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1066), 1,
      anon_sym_AMP,
    ACTIONS(1080), 1,
      anon_sym_PIPE,
    ACTIONS(1082), 1,
      anon_sym_CARET,
    ACTIONS(1088), 1,
      anon_sym_as,
    ACTIONS(1092), 1,
      anon_sym_LPAREN,
    ACTIONS(1094), 1,
      anon_sym_is,
    STATE(598), 1,
      sym_arguments,
    ACTIONS(562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1072), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1076), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1078), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(564), 12,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [26763] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1123), 1,
      anon_sym_DOT,
    STATE(516), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(608), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(610), 24,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [26805] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1126), 1,
      anon_sym_DOT,
    STATE(493), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(604), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(606), 24,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [26847] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1088), 1,
      anon_sym_as,
    ACTIONS(1092), 1,
      anon_sym_LPAREN,
    ACTIONS(1094), 1,
      anon_sym_is,
    STATE(598), 1,
      sym_arguments,
    ACTIONS(1078), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 19,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [26895] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1088), 1,
      anon_sym_as,
    ACTIONS(1092), 1,
      anon_sym_LPAREN,
    ACTIONS(1094), 1,
      anon_sym_is,
    STATE(598), 1,
      sym_arguments,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 22,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [26941] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1066), 1,
      anon_sym_AMP,
    ACTIONS(1082), 1,
      anon_sym_CARET,
    ACTIONS(1088), 1,
      anon_sym_as,
    ACTIONS(1092), 1,
      anon_sym_LPAREN,
    ACTIONS(1094), 1,
      anon_sym_is,
    STATE(598), 1,
      sym_arguments,
    ACTIONS(1076), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(562), 3,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1078), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(564), 14,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [26997] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1088), 1,
      anon_sym_as,
    ACTIONS(1092), 1,
      anon_sym_LPAREN,
    ACTIONS(1094), 1,
      anon_sym_is,
    STATE(598), 1,
      sym_arguments,
    ACTIONS(1076), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1078), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 15,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27049] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1088), 1,
      anon_sym_as,
    ACTIONS(1092), 1,
      anon_sym_LPAREN,
    ACTIONS(1094), 1,
      anon_sym_is,
    STATE(598), 1,
      sym_arguments,
    ACTIONS(1076), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1078), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 17,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27099] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1088), 1,
      anon_sym_as,
    ACTIONS(1092), 1,
      anon_sym_LPAREN,
    STATE(598), 1,
      sym_arguments,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 23,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27143] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1092), 1,
      anon_sym_LPAREN,
    ACTIONS(1128), 1,
      anon_sym_LBRACK,
    STATE(580), 1,
      sym_arguments,
    ACTIONS(608), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(610), 23,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27187] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1130), 1,
      anon_sym_DOT,
    STATE(525), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(608), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(610), 24,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [27229] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1088), 1,
      anon_sym_as,
    ACTIONS(1092), 1,
      anon_sym_LPAREN,
    STATE(598), 1,
      sym_arguments,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 23,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27273] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(493), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(604), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(606), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [27313] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1096), 1,
      anon_sym_as,
    ACTIONS(1098), 1,
      anon_sym_LPAREN,
    ACTIONS(1109), 1,
      anon_sym_is,
    STATE(637), 1,
      sym_arguments,
    ACTIONS(619), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(621), 22,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27359] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1096), 1,
      anon_sym_as,
    ACTIONS(1098), 1,
      anon_sym_LPAREN,
    ACTIONS(1113), 1,
      anon_sym_AMP,
    ACTIONS(1115), 1,
      anon_sym_CARET,
    ACTIONS(1119), 1,
      anon_sym_PIPE,
    ACTIONS(1135), 1,
      anon_sym_LBRACK,
    ACTIONS(1139), 1,
      anon_sym_is,
    STATE(637), 1,
      sym_arguments,
    STATE(762), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1105), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1111), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1117), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1137), 2,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
    ACTIONS(1141), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(590), 3,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_RBRACK,
    ACTIONS(1107), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1133), 5,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27427] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(483), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(604), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(606), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [27467] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    STATE(525), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(604), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(606), 24,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [27509] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1145), 1,
      anon_sym_AMP,
    ACTIONS(1153), 1,
      anon_sym_PIPE,
    ACTIONS(1155), 1,
      anon_sym_CARET,
    ACTIONS(1159), 1,
      anon_sym_is,
    ACTIONS(1161), 1,
      anon_sym_as,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    STATE(679), 1,
      sym_arguments,
    ACTIONS(562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1147), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1149), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1157), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1151), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(564), 11,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27568] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_is,
    ACTIONS(1029), 1,
      anon_sym_as,
    ACTIONS(1031), 1,
      anon_sym_LPAREN,
    ACTIONS(1033), 1,
      anon_sym_AMP,
    ACTIONS(1037), 1,
      anon_sym_LBRACK,
    ACTIONS(1047), 1,
      anon_sym_PIPE,
    ACTIONS(1049), 1,
      anon_sym_CARET,
    STATE(586), 1,
      sym_arguments,
    ACTIONS(667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1039), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1041), 2,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
    ACTIONS(1043), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1051), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1045), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(665), 8,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [27631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(669), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(671), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [27668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(691), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(693), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [27705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(661), 25,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [27742] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(673), 1,
      anon_sym_DOT,
    ACTIONS(669), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(671), 24,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [27781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(623), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(625), 25,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [27818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(747), 25,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [27855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(689), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [27892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(683), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(685), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [27929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(661), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [27966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(689), 25,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [28003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(683), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(685), 25,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [28040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(715), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [28077] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(673), 1,
      anon_sym_DOT,
    ACTIONS(1165), 1,
      anon_sym_EQ,
    ACTIONS(669), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(671), 23,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [28118] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 1,
      anon_sym_DOT,
    STATE(553), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(604), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(606), 23,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [28159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(725), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(727), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [28196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(741), 25,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [28233] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1169), 1,
      anon_sym_as,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    STATE(719), 1,
      sym_arguments,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 22,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [28276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(550), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(552), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [28313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(761), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(763), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [28350] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DOT,
    STATE(553), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(608), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(610), 23,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [28391] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1176), 1,
      anon_sym_LBRACK,
    STATE(680), 1,
      sym_arguments,
    ACTIONS(608), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(610), 22,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [28434] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1169), 1,
      anon_sym_as,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    STATE(719), 1,
      sym_arguments,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 22,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [28477] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1169), 1,
      anon_sym_as,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_is,
    STATE(719), 1,
      sym_arguments,
    ACTIONS(1178), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1180), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 16,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [28526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(755), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(757), 25,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [28563] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1169), 1,
      anon_sym_as,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_is,
    STATE(719), 1,
      sym_arguments,
    ACTIONS(1178), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1184), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1180), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 14,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [28614] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1169), 1,
      anon_sym_as,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_is,
    ACTIONS(1186), 1,
      anon_sym_AMP,
    ACTIONS(1188), 1,
      anon_sym_CARET,
    STATE(719), 1,
      sym_arguments,
    ACTIONS(1178), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1184), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(562), 3,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1180), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(564), 13,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [28669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(703), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(705), 25,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [28706] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1169), 1,
      anon_sym_as,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_is,
    STATE(719), 1,
      sym_arguments,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 21,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [28751] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1169), 1,
      anon_sym_as,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_is,
    STATE(719), 1,
      sym_arguments,
    ACTIONS(1180), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 18,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [28798] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1169), 1,
      anon_sym_as,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_is,
    ACTIONS(1186), 1,
      anon_sym_AMP,
    ACTIONS(1188), 1,
      anon_sym_CARET,
    ACTIONS(1192), 1,
      anon_sym_PIPE,
    STATE(719), 1,
      sym_arguments,
    ACTIONS(562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1178), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1184), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1190), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1180), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(564), 11,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [28857] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1169), 1,
      anon_sym_as,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_is,
    ACTIONS(1186), 1,
      anon_sym_AMP,
    ACTIONS(1188), 1,
      anon_sym_CARET,
    ACTIONS(1192), 1,
      anon_sym_PIPE,
    STATE(719), 1,
      sym_arguments,
    ACTIONS(562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1178), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1184), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1180), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(564), 13,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [28914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(632), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(604), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(606), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [28953] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1169), 1,
      anon_sym_as,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_is,
    ACTIONS(1188), 1,
      anon_sym_CARET,
    STATE(719), 1,
      sym_arguments,
    ACTIONS(1178), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1184), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1180), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 13,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [29006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(733), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(735), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [29043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(719), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [29080] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1194), 1,
      anon_sym_DOT,
    STATE(632), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(604), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(606), 23,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [29121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(709), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(711), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [29158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(669), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(671), 25,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [29195] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1001), 1,
      anon_sym_CARET,
    ACTIONS(1005), 1,
      anon_sym_is,
    ACTIONS(1007), 1,
      anon_sym_as,
    ACTIONS(1009), 1,
      anon_sym_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_AMP,
    ACTIONS(1015), 1,
      anon_sym_LBRACK,
    ACTIONS(1021), 1,
      anon_sym_PIPE,
    STATE(545), 1,
      sym_arguments,
    ACTIONS(667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1017), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1019), 2,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
    ACTIONS(999), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(665), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [29258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(673), 1,
      anon_sym_DOT,
    ACTIONS(669), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(671), 24,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [29297] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(553), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(604), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(606), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [29336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(677), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [29373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(558), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [29410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(703), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(705), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [29447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(755), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(757), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [29484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(542), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(544), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [29521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(747), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [29558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(623), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(625), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [29595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(741), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [29632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(721), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(723), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [29669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(546), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(548), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [29706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(608), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(610), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [29743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(715), 25,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [29780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [29817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [29854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(677), 25,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [29891] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1066), 1,
      anon_sym_AMP,
    ACTIONS(1070), 1,
      anon_sym_LBRACK,
    ACTIONS(1080), 1,
      anon_sym_PIPE,
    ACTIONS(1082), 1,
      anon_sym_CARET,
    ACTIONS(1088), 1,
      anon_sym_as,
    ACTIONS(1092), 1,
      anon_sym_LPAREN,
    ACTIONS(1094), 1,
      anon_sym_is,
    STATE(598), 1,
      sym_arguments,
    ACTIONS(667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1072), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1074), 2,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
    ACTIONS(1076), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1078), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(665), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [29954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(709), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(711), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [29991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(719), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [30028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(733), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(735), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [30065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(761), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(763), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [30102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(550), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(552), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [30139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(725), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(727), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [30176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(725), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(727), 25,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [30213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(715), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [30250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(608), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(610), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [30287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(761), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(763), 25,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [30324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(546), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(548), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [30361] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1169), 1,
      anon_sym_as,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_is,
    STATE(719), 1,
      sym_arguments,
    ACTIONS(619), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(621), 21,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [30406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(661), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [30443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(691), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(693), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [30480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(689), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [30517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(683), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(685), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [30554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(669), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(671), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [30591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(721), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(723), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [30628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(554), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(556), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [30665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(673), 1,
      anon_sym_DOT,
    ACTIONS(669), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(671), 24,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [30704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 25,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [30741] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(673), 1,
      anon_sym_DOT,
    ACTIONS(669), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(671), 24,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [30780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(669), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(671), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [30817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(741), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [30854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(623), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(625), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [30891] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(683), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(685), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [30928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(689), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [30965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(747), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [31002] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1169), 1,
      anon_sym_as,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1186), 1,
      anon_sym_AMP,
    ACTIONS(1188), 1,
      anon_sym_CARET,
    ACTIONS(1192), 1,
      anon_sym_PIPE,
    ACTIONS(1198), 1,
      anon_sym_LBRACK,
    ACTIONS(1202), 1,
      anon_sym_is,
    STATE(719), 1,
      sym_arguments,
    STATE(772), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(590), 2,
      anon_sym_if,
      anon_sym_RPAREN,
    ACTIONS(1178), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1184), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1190), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1200), 2,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
    ACTIONS(1204), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1180), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1196), 5,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(542), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(544), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [31106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(755), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(757), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [31143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(691), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(693), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [31180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(661), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [31217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(721), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(723), 25,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [31254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(703), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(705), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [31291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(558), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [31328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(677), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [31365] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1161), 1,
      anon_sym_as,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    STATE(679), 1,
      sym_arguments,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 22,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(677), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [31445] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1145), 1,
      anon_sym_AMP,
    ACTIONS(1153), 1,
      anon_sym_PIPE,
    ACTIONS(1155), 1,
      anon_sym_CARET,
    ACTIONS(1161), 1,
      anon_sym_as,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1208), 1,
      anon_sym_LBRACK,
    ACTIONS(1212), 1,
      anon_sym_is,
    STATE(679), 1,
      sym_arguments,
    STATE(769), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(590), 2,
      anon_sym_if,
      anon_sym_RBRACK,
    ACTIONS(1147), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1149), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1157), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1210), 2,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
    ACTIONS(1214), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1151), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1206), 5,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(558), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [31549] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1216), 1,
      anon_sym_DOT,
    STATE(632), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(608), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(610), 23,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [31590] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1159), 1,
      anon_sym_is,
    ACTIONS(1161), 1,
      anon_sym_as,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    STATE(679), 1,
      sym_arguments,
    ACTIONS(619), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(621), 21,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31635] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1219), 1,
      anon_sym_LBRACK,
    STATE(704), 1,
      sym_arguments,
    ACTIONS(608), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(610), 22,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(703), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(705), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [31715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(755), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(757), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [31752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(715), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [31789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(542), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(544), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [31826] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1161), 1,
      anon_sym_as,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    STATE(679), 1,
      sym_arguments,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 22,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [31869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(747), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [31906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(725), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(727), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [31943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(550), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(552), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [31980] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1159), 1,
      anon_sym_is,
    ACTIONS(1161), 1,
      anon_sym_as,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    STATE(679), 1,
      sym_arguments,
    ACTIONS(1149), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1151), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 16,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [32029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(761), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(763), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [32066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(733), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(735), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [32103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(719), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [32140] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1159), 1,
      anon_sym_is,
    ACTIONS(1161), 1,
      anon_sym_as,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    STATE(679), 1,
      sym_arguments,
    ACTIONS(1149), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1157), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1151), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 14,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [32191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(709), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(711), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [32228] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(608), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(610), 25,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [32265] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1096), 1,
      anon_sym_as,
    ACTIONS(1098), 1,
      anon_sym_LPAREN,
    ACTIONS(1109), 1,
      anon_sym_is,
    ACTIONS(1113), 1,
      anon_sym_AMP,
    ACTIONS(1115), 1,
      anon_sym_CARET,
    ACTIONS(1119), 1,
      anon_sym_PIPE,
    ACTIONS(1135), 1,
      anon_sym_LBRACK,
    STATE(637), 1,
      sym_arguments,
    ACTIONS(667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1105), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1111), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1117), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1137), 2,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
    ACTIONS(1107), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(665), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [32328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(623), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(625), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [32365] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1145), 1,
      anon_sym_AMP,
    ACTIONS(1155), 1,
      anon_sym_CARET,
    ACTIONS(1159), 1,
      anon_sym_is,
    ACTIONS(1161), 1,
      anon_sym_as,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    STATE(679), 1,
      sym_arguments,
    ACTIONS(1149), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1157), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(562), 3,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1151), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(564), 13,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [32420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(691), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(693), 25,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [32457] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1159), 1,
      anon_sym_is,
    ACTIONS(1161), 1,
      anon_sym_as,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    STATE(679), 1,
      sym_arguments,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 21,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [32502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(709), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(711), 25,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [32539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(719), 25,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [32576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(733), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(735), 25,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [32613] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1159), 1,
      anon_sym_is,
    ACTIONS(1161), 1,
      anon_sym_as,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    STATE(679), 1,
      sym_arguments,
    ACTIONS(1151), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 18,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [32660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [32697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(741), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [32734] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1145), 1,
      anon_sym_AMP,
    ACTIONS(1153), 1,
      anon_sym_PIPE,
    ACTIONS(1155), 1,
      anon_sym_CARET,
    ACTIONS(1159), 1,
      anon_sym_is,
    ACTIONS(1161), 1,
      anon_sym_as,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    STATE(679), 1,
      sym_arguments,
    ACTIONS(562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1149), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1157), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1151), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(564), 13,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [32791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(608), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(610), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [32828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(721), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(723), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [32865] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1155), 1,
      anon_sym_CARET,
    ACTIONS(1159), 1,
      anon_sym_is,
    ACTIONS(1161), 1,
      anon_sym_as,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    STATE(679), 1,
      sym_arguments,
    ACTIONS(1149), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1157), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1151), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 13,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [32918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(546), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(548), 25,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [32955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(623), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(625), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [32991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(554), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(556), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [33027] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1145), 1,
      anon_sym_AMP,
    ACTIONS(1153), 1,
      anon_sym_PIPE,
    ACTIONS(1155), 1,
      anon_sym_CARET,
    ACTIONS(1159), 1,
      anon_sym_is,
    ACTIONS(1161), 1,
      anon_sym_as,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1208), 1,
      anon_sym_LBRACK,
    STATE(679), 1,
      sym_arguments,
    ACTIONS(667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1147), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1149), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1157), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1210), 2,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
    ACTIONS(1151), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(665), 7,
      anon_sym_if,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [33089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(677), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(733), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(735), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [33161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(761), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(763), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [33197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(558), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(703), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(705), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(550), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(552), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [33305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(755), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(757), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(725), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(727), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [33377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(542), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(544), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [33449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(715), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [33485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(747), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(608), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(610), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [33557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(546), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(548), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [33593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(661), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [33629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(691), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(693), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [33665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(689), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [33701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(683), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(685), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [33737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(721), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(723), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [33773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(669), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(671), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [33809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(741), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [33845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(623), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(625), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33881] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(673), 1,
      anon_sym_DOT,
    ACTIONS(669), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(671), 23,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [33919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(719), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(719), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [33991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(546), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(548), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(554), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(556), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34063] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(673), 1,
      anon_sym_DOT,
    ACTIONS(669), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(671), 23,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(755), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(757), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [34137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(703), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(705), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [34173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(669), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(671), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(558), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(560), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [34245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(677), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [34281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(683), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(685), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(689), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(747), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [34389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(741), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(721), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(723), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(691), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(693), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(661), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(542), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(544), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [34569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(709), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(711), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
  [34605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(608), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(610), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(562), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(564), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34677] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1169), 1,
      anon_sym_as,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_is,
    ACTIONS(1186), 1,
      anon_sym_AMP,
    ACTIONS(1188), 1,
      anon_sym_CARET,
    ACTIONS(1192), 1,
      anon_sym_PIPE,
    ACTIONS(1198), 1,
      anon_sym_LBRACK,
    STATE(719), 1,
      sym_arguments,
    ACTIONS(667), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1178), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1184), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1190), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1200), 2,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
    ACTIONS(1180), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(665), 7,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN,
  [34739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(709), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(711), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(725), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(727), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(733), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(735), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(761), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(763), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(550), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(552), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(715), 24,
      anon_sym_DOT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34955] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1223), 1,
      anon_sym_EQ,
    STATE(721), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(602), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(594), 6,
      anon_sym_in,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1221), 16,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_if,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [34995] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(667), 1,
      anon_sym_EQ,
    STATE(721), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1228), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1225), 6,
      anon_sym_in,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
    ACTIONS(665), 16,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
      anon_sym_if,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1231), 9,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
      anon_sym_DOT,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
    ACTIONS(1233), 12,
      sym__string_start,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
  [35064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 9,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_integer,
      anon_sym_DOT,
      anon_sym_not,
      anon_sym_await,
      anon_sym_func,
    ACTIONS(1237), 12,
      sym__string_start,
      sym_float,
      anon_sym_AMP,
      sym_node_path,
      sym_get_node,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_LPAREN,
  [35093] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(673), 1,
      anon_sym_DOT,
    ACTIONS(669), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1239), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(671), 16,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LPAREN,
  [35126] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym__identifier,
    ACTIONS(1245), 1,
      sym_float,
    ACTIONS(1247), 1,
      anon_sym_var,
    ACTIONS(1249), 1,
      anon_sym_LBRACE,
    ACTIONS(1251), 1,
      anon_sym_LBRACK,
    ACTIONS(1253), 1,
      sym__dedent,
    ACTIONS(1255), 1,
      sym__string_start,
    STATE(912), 1,
      sym__pattern,
    STATE(727), 2,
      sym_pattern_section,
      aux_sym_match_body_repeat1,
    ACTIONS(1243), 5,
      sym_true,
      sym_false,
      sym_null,
      sym_underscore,
      sym_integer,
    STATE(1251), 5,
      sym_identifier,
      sym_string,
      sym_pattern_binding,
      sym_pattern_array,
      sym_pattern_dictionary,
  [35172] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1145), 1,
      anon_sym_AMP,
    ACTIONS(1153), 1,
      anon_sym_PIPE,
    ACTIONS(1155), 1,
      anon_sym_CARET,
    ACTIONS(1159), 1,
      anon_sym_is,
    ACTIONS(1161), 1,
      anon_sym_as,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1208), 1,
      anon_sym_LBRACK,
    ACTIONS(1257), 1,
      anon_sym_RBRACK,
    STATE(679), 1,
      sym_arguments,
    ACTIONS(1147), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1149), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1157), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1210), 2,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
    ACTIONS(1151), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [35224] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1259), 1,
      sym__identifier,
    ACTIONS(1265), 1,
      sym_float,
    ACTIONS(1268), 1,
      anon_sym_var,
    ACTIONS(1271), 1,
      anon_sym_LBRACE,
    ACTIONS(1274), 1,
      anon_sym_LBRACK,
    ACTIONS(1277), 1,
      sym__dedent,
    ACTIONS(1279), 1,
      sym__string_start,
    STATE(912), 1,
      sym__pattern,
    STATE(727), 2,
      sym_pattern_section,
      aux_sym_match_body_repeat1,
    ACTIONS(1262), 5,
      sym_true,
      sym_false,
      sym_null,
      sym_underscore,
      sym_integer,
    STATE(1251), 5,
      sym_identifier,
      sym_string,
      sym_pattern_binding,
      sym_pattern_array,
      sym_pattern_dictionary,
  [35270] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1145), 1,
      anon_sym_AMP,
    ACTIONS(1153), 1,
      anon_sym_PIPE,
    ACTIONS(1155), 1,
      anon_sym_CARET,
    ACTIONS(1159), 1,
      anon_sym_is,
    ACTIONS(1161), 1,
      anon_sym_as,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1208), 1,
      anon_sym_LBRACK,
    ACTIONS(1282), 1,
      anon_sym_RBRACK,
    STATE(679), 1,
      sym_arguments,
    ACTIONS(1147), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1149), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1157), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1210), 2,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
    ACTIONS(1151), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [35322] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1145), 1,
      anon_sym_AMP,
    ACTIONS(1153), 1,
      anon_sym_PIPE,
    ACTIONS(1155), 1,
      anon_sym_CARET,
    ACTIONS(1159), 1,
      anon_sym_is,
    ACTIONS(1161), 1,
      anon_sym_as,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1208), 1,
      anon_sym_LBRACK,
    ACTIONS(1284), 1,
      anon_sym_RBRACK,
    STATE(679), 1,
      sym_arguments,
    ACTIONS(1147), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1149), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1157), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1210), 2,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
    ACTIONS(1151), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [35374] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1145), 1,
      anon_sym_AMP,
    ACTIONS(1153), 1,
      anon_sym_PIPE,
    ACTIONS(1155), 1,
      anon_sym_CARET,
    ACTIONS(1159), 1,
      anon_sym_is,
    ACTIONS(1161), 1,
      anon_sym_as,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1208), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_RBRACK,
    STATE(679), 1,
      sym_arguments,
    ACTIONS(1147), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1149), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1157), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1210), 2,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
    ACTIONS(1151), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [35426] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1145), 1,
      anon_sym_AMP,
    ACTIONS(1153), 1,
      anon_sym_PIPE,
    ACTIONS(1155), 1,
      anon_sym_CARET,
    ACTIONS(1159), 1,
      anon_sym_is,
    ACTIONS(1161), 1,
      anon_sym_as,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1208), 1,
      anon_sym_LBRACK,
    ACTIONS(1288), 1,
      anon_sym_RBRACK,
    STATE(679), 1,
      sym_arguments,
    ACTIONS(1147), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1149), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1157), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1210), 2,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
    ACTIONS(1151), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [35478] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym__identifier,
    ACTIONS(1245), 1,
      sym_float,
    ACTIONS(1247), 1,
      anon_sym_var,
    ACTIONS(1249), 1,
      anon_sym_LBRACE,
    ACTIONS(1251), 1,
      anon_sym_LBRACK,
    ACTIONS(1255), 1,
      sym__string_start,
    ACTIONS(1290), 1,
      sym__dedent,
    STATE(912), 1,
      sym__pattern,
    STATE(727), 2,
      sym_pattern_section,
      aux_sym_match_body_repeat1,
    ACTIONS(1243), 5,
      sym_true,
      sym_false,
      sym_null,
      sym_underscore,
      sym_integer,
    STATE(1251), 5,
      sym_identifier,
      sym_string,
      sym_pattern_binding,
      sym_pattern_array,
      sym_pattern_dictionary,
  [35524] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1145), 1,
      anon_sym_AMP,
    ACTIONS(1153), 1,
      anon_sym_PIPE,
    ACTIONS(1155), 1,
      anon_sym_CARET,
    ACTIONS(1159), 1,
      anon_sym_is,
    ACTIONS(1161), 1,
      anon_sym_as,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1208), 1,
      anon_sym_LBRACK,
    ACTIONS(1292), 1,
      anon_sym_RBRACK,
    STATE(679), 1,
      sym_arguments,
    ACTIONS(1147), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1149), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1157), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1210), 2,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
    ACTIONS(1151), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [35576] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1145), 1,
      anon_sym_AMP,
    ACTIONS(1153), 1,
      anon_sym_PIPE,
    ACTIONS(1155), 1,
      anon_sym_CARET,
    ACTIONS(1159), 1,
      anon_sym_is,
    ACTIONS(1161), 1,
      anon_sym_as,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1208), 1,
      anon_sym_LBRACK,
    ACTIONS(1294), 1,
      anon_sym_RBRACK,
    STATE(679), 1,
      sym_arguments,
    ACTIONS(1147), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1149), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1157), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1210), 2,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
    ACTIONS(1151), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [35628] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(669), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1239), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(671), 16,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_LPAREN,
  [35658] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1066), 1,
      anon_sym_AMP,
    ACTIONS(1070), 1,
      anon_sym_LBRACK,
    ACTIONS(1080), 1,
      anon_sym_PIPE,
    ACTIONS(1082), 1,
      anon_sym_CARET,
    ACTIONS(1088), 1,
      anon_sym_as,
    ACTIONS(1092), 1,
      anon_sym_LPAREN,
    ACTIONS(1094), 1,
      anon_sym_is,
    STATE(598), 1,
      sym_arguments,
    ACTIONS(1072), 2,
      anon_sym_and,
      anon_sym_AMP_AMP,
    ACTIONS(1074), 2,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
    ACTIONS(1076), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1078), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [35707] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym__identifier,
    ACTIONS(1245), 1,
      sym_float,
    ACTIONS(1247), 1,
      anon_sym_var,
    ACTIONS(1249), 1,
      anon_sym_LBRACE,
    ACTIONS(1251), 1,
      anon_sym_LBRACK,
    ACTIONS(1255), 1,
      sym__string_start,
    STATE(912), 1,
      sym__pattern,
    STATE(725), 2,
      sym_pattern_section,
      aux_sym_match_body_repeat1,
    ACTIONS(1243), 5,
      sym_true,
      sym_false,
      sym_null,
      sym_underscore,
      sym_integer,
    STATE(1251), 5,
      sym_identifier,
      sym_string,
      sym_pattern_binding,
      sym_pattern_array,
      sym_pattern_dictionary,
  [35750] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(1298), 1,
      sym_float,
    ACTIONS(1300), 1,
      anon_sym_var,
    ACTIONS(1302), 1,
      anon_sym_LBRACE,
    ACTIONS(1304), 1,
      sym_pattern_open_ending,
    ACTIONS(1306), 1,
      anon_sym_LBRACK,
    ACTIONS(1308), 1,
      anon_sym_RBRACK,
    STATE(962), 1,
      sym__pattern,
    ACTIONS(1296), 5,
      sym_true,
      sym_false,
      sym_null,
      sym_underscore,
      sym_integer,
    STATE(1167), 5,
      sym_identifier,
      sym_string,
      sym_pattern_binding,
      sym_pattern_array,
      sym_pattern_dictionary,
  [35795] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym__identifier,
    ACTIONS(1245), 1,
      sym_float,
    ACTIONS(1247), 1,
      anon_sym_var,
    ACTIONS(1249), 1,
      anon_sym_LBRACE,
    ACTIONS(1251), 1,
      anon_sym_LBRACK,
    ACTIONS(1255), 1,
      sym__string_start,
    STATE(912), 1,
      sym__pattern,
    STATE(732), 2,
      sym_pattern_section,
      aux_sym_match_body_repeat1,
    ACTIONS(1243), 5,
      sym_true,
      sym_false,
      sym_null,
      sym_underscore,
      sym_integer,
    STATE(1251), 5,
      sym_identifier,
      sym_string,
      sym_pattern_binding,
      sym_pattern_array,
      sym_pattern_dictionary,
  [35838] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(1298), 1,
      sym_float,
    ACTIONS(1300), 1,
      anon_sym_var,
    ACTIONS(1302), 1,
      anon_sym_LBRACE,
    ACTIONS(1306), 1,
      anon_sym_LBRACK,
    ACTIONS(1310), 1,
      sym_pattern_open_ending,
    ACTIONS(1312), 1,
      anon_sym_RBRACK,
    STATE(1067), 1,
      sym__pattern,
    ACTIONS(1296), 5,
      sym_true,
      sym_false,
      sym_null,
      sym_underscore,
      sym_integer,
    STATE(1167), 5,
      sym_identifier,
      sym_string,
      sym_pattern_binding,
      sym_pattern_array,
      sym_pattern_dictionary,
  [35883] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(1298), 1,
      sym_float,
    ACTIONS(1300), 1,
      anon_sym_var,
    ACTIONS(1302), 1,
      anon_sym_LBRACE,
    ACTIONS(1306), 1,
      anon_sym_LBRACK,
    ACTIONS(1314), 1,
      sym_pattern_open_ending,
    ACTIONS(1316), 1,
      anon_sym_RBRACK,
    STATE(1028), 1,
      sym__pattern,
    ACTIONS(1296), 5,
      sym_true,
      sym_false,
      sym_null,
      sym_underscore,
      sym_integer,
    STATE(1167), 5,
      sym_identifier,
      sym_string,
      sym_pattern_binding,
      sym_pattern_array,
      sym_pattern_dictionary,
  [35928] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      sym__identifier,
    ACTIONS(795), 1,
      sym__string_start,
    ACTIONS(1298), 1,
      sym_float,
    ACTIONS(1300), 1,
      anon_sym_var,
    ACTIONS(1302), 1,
      anon_sym_LBRACE,
    ACTIONS(1306), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      sym_pattern_open_ending,
    STATE(1200), 1,
      sym__pattern,
    ACTIONS(1296), 5,
      sym_true,
      sym_false,
      sym_null,
      sym_underscore,
      sym_integer,
    STATE(1167), 5,
      sym_identifier,
      sym_string,
      sym_pattern_binding,
      sym_pattern_array,
      sym_pattern_dictionary,
  [35970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1320), 17,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_setget,
      anon_sym_if,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(590), 17,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_setget,
      anon_sym_if,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [36016] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym__identifier,
    ACTIONS(1245), 1,
      sym_float,
    ACTIONS(1247), 1,
      anon_sym_var,
    ACTIONS(1249), 1,
      anon_sym_LBRACE,
    ACTIONS(1251), 1,
      anon_sym_LBRACK,
    ACTIONS(1255), 1,
      sym__string_start,
    STATE(1264), 1,
      sym__pattern,
    ACTIONS(1243), 5,
      sym_true,
      sym_false,
      sym_null,
      sym_underscore,
      sym_integer,
    STATE(1251), 5,
      sym_identifier,
      sym_string,
      sym_pattern_binding,
      sym_pattern_array,
      sym_pattern_dictionary,
  [36055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1324), 1,
      anon_sym_if,
    ACTIONS(1322), 16,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_setget,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [36080] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(943), 1,
      sym__identifier,
    ACTIONS(967), 1,
      sym__string_start,
    ACTIONS(1328), 1,
      sym_float,
    ACTIONS(1330), 1,
      anon_sym_var,
    ACTIONS(1332), 1,
      anon_sym_LBRACE,
    ACTIONS(1334), 1,
      anon_sym_LBRACK,
    STATE(1205), 1,
      sym__pattern,
    ACTIONS(1326), 5,
      sym_true,
      sym_false,
      sym_null,
      sym_underscore,
      sym_integer,
    STATE(1276), 5,
      sym_identifier,
      sym_string,
      sym_pattern_binding,
      sym_pattern_array,
      sym_pattern_dictionary,
  [36119] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1031), 1,
      anon_sym_LPAREN,
    ACTIONS(1338), 1,
      anon_sym_AT,
    ACTIONS(1340), 1,
      anon_sym_var,
    ACTIONS(1342), 1,
      anon_sym_onready,
    STATE(751), 1,
      sym_arguments,
    STATE(803), 1,
      sym_remote_keyword,
    STATE(994), 1,
      sym__variable_statement,
    STATE(1317), 1,
      sym_annotations,
    STATE(833), 2,
      sym_annotation,
      aux_sym__annotations,
    ACTIONS(13), 3,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
    ACTIONS(1336), 3,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
  [36161] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1324), 1,
      anon_sym_if,
    ACTIONS(1346), 1,
      anon_sym_EQ,
    ACTIONS(1344), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
    ACTIONS(1348), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [36188] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1352), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1354), 1,
      anon_sym_COLON,
    ACTIONS(1356), 1,
      anon_sym_EQ,
    ACTIONS(1358), 1,
      anon_sym_setget,
    STATE(324), 1,
      sym_inferred_type,
    STATE(795), 1,
      sym__variable_typed_definition,
    STATE(800), 1,
      sym__variable_inferred_type_assignment,
    STATE(802), 1,
      sym__variable_assignment,
    STATE(814), 1,
      sym__variable_typed_assignment,
    STATE(1063), 1,
      sym_setget,
    STATE(1096), 1,
      sym__setget_body,
    ACTIONS(1350), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [36230] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1338), 1,
      anon_sym_AT,
    ACTIONS(1340), 1,
      anon_sym_var,
    ACTIONS(1360), 1,
      anon_sym_onready,
    STATE(809), 1,
      sym_remote_keyword,
    STATE(1091), 1,
      sym__variable_statement,
    STATE(1317), 1,
      sym_annotations,
    STATE(833), 2,
      sym_annotation,
      aux_sym__annotations,
    ACTIONS(13), 3,
      anon_sym_remote,
      anon_sym_master,
      anon_sym_puppet,
    ACTIONS(1336), 3,
      anon_sym_remotesync,
      anon_sym_mastersync,
      anon_sym_puppetsync,
  [36266] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1352), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1354), 1,
      anon_sym_COLON,
    ACTIONS(1356), 1,
      anon_sym_EQ,
    ACTIONS(1358), 1,
      anon_sym_setget,
    STATE(324), 1,
      sym_inferred_type,
    STATE(788), 1,
      sym__variable_typed_definition,
    STATE(798), 1,
      sym__variable_assignment,
    STATE(799), 1,
      sym__variable_inferred_type_assignment,
    STATE(814), 1,
      sym__variable_typed_assignment,
    STATE(1095), 1,
      sym_setget,
    STATE(1096), 1,
      sym__setget_body,
    ACTIONS(1362), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [36308] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(766), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1090), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1221), 3,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_RBRACE,
    ACTIONS(1068), 6,
      anon_sym_in,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [36332] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(768), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1055), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1221), 3,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_else,
    ACTIONS(1035), 6,
      anon_sym_in,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [36356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(412), 5,
      sym__dedent,
      sym__string_start,
      sym_float,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(410), 7,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_underscore,
      sym_integer,
      anon_sym_var,
  [36376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(416), 5,
      sym__dedent,
      sym__string_start,
      sym_float,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(414), 7,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_underscore,
      sym_integer,
      anon_sym_var,
  [36396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(408), 5,
      sym__dedent,
      sym__string_start,
      sym_float,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(406), 7,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_underscore,
      sym_integer,
      anon_sym_var,
  [36416] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(758), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1367), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(665), 3,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_RBRACK,
    ACTIONS(1364), 6,
      anon_sym_in,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [36440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(400), 5,
      sym__dedent,
      sym__string_start,
      sym_float,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(398), 7,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_underscore,
      sym_integer,
      anon_sym_var,
  [36460] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(763), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1025), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1221), 3,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_RPAREN,
    ACTIONS(1013), 6,
      anon_sym_in,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [36484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1372), 5,
      sym__dedent,
      sym__string_start,
      sym_float,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(1370), 7,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_underscore,
      sym_integer,
      anon_sym_var,
  [36504] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(758), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1141), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1221), 3,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_RBRACK,
    ACTIONS(1133), 6,
      anon_sym_in,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [36528] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(763), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1377), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(665), 3,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_RPAREN,
    ACTIONS(1374), 6,
      anon_sym_in,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [36552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(404), 5,
      sym__dedent,
      sym__string_start,
      sym_float,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(402), 7,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_underscore,
      sym_integer,
      anon_sym_var,
  [36572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(420), 5,
      sym__dedent,
      sym__string_start,
      sym_float,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(418), 7,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_underscore,
      sym_integer,
      anon_sym_var,
  [36592] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(766), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1383), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(665), 3,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_RBRACE,
    ACTIONS(1380), 6,
      anon_sym_in,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [36616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1388), 5,
      sym__dedent,
      sym__string_start,
      sym_float,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(1386), 7,
      sym__identifier,
      sym_true,
      sym_false,
      sym_null,
      sym_underscore,
      sym_integer,
      anon_sym_var,
  [36636] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(768), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1393), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(665), 3,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_else,
    ACTIONS(1390), 6,
      anon_sym_in,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [36660] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(770), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1214), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1221), 2,
      anon_sym_if,
      anon_sym_RBRACK,
    ACTIONS(1206), 6,
      anon_sym_in,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [36683] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(770), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(665), 2,
      anon_sym_if,
      anon_sym_RBRACK,
    ACTIONS(1399), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1396), 6,
      anon_sym_in,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [36706] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(771), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(665), 2,
      anon_sym_if,
      anon_sym_RPAREN,
    ACTIONS(1405), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1402), 6,
      anon_sym_in,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [36729] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(771), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1204), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1221), 2,
      anon_sym_if,
      anon_sym_RPAREN,
    ACTIONS(1196), 6,
      anon_sym_in,
      anon_sym_is,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
  [36752] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1408), 1,
      anon_sym_SEMI,
    ACTIONS(1410), 1,
      anon_sym_AT,
    STATE(842), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(1412), 2,
      anon_sym_var,
      anon_sym_func,
    ACTIONS(1414), 2,
      sym__newline,
      sym__body_end,
    STATE(777), 2,
      sym_annotation,
      aux_sym__annotations,
  [36777] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1410), 1,
      anon_sym_AT,
    ACTIONS(1416), 1,
      anon_sym_SEMI,
    STATE(903), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(1412), 2,
      anon_sym_var,
      anon_sym_func,
    ACTIONS(1418), 2,
      sym__newline,
      sym__body_end,
    STATE(777), 2,
      sym_annotation,
      aux_sym__annotations,
  [36802] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1410), 1,
      anon_sym_AT,
    ACTIONS(1412), 1,
      anon_sym_var,
    ACTIONS(1420), 1,
      anon_sym_SEMI,
    STATE(887), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(1422), 2,
      sym__newline,
      sym__body_end,
    STATE(777), 2,
      sym_annotation,
      aux_sym__annotations,
  [36826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1426), 1,
      anon_sym_COLON,
    ACTIONS(1424), 7,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON_EQ,
      anon_sym_EQ,
      anon_sym_setget,
      anon_sym_LPAREN,
  [36842] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1430), 1,
      anon_sym_AT,
    STATE(777), 2,
      sym_annotation,
      aux_sym__annotations,
    ACTIONS(1428), 5,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_var,
      anon_sym_func,
  [36860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(572), 1,
      anon_sym_LPAREN,
    STATE(807), 1,
      sym_arguments,
    ACTIONS(1433), 6,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_func,
  [36878] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1410), 1,
      anon_sym_AT,
    ACTIONS(1412), 1,
      anon_sym_var,
    ACTIONS(1435), 1,
      anon_sym_SEMI,
    STATE(900), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(1437), 2,
      sym__newline,
      sym__body_end,
    STATE(777), 2,
      sym_annotation,
      aux_sym__annotations,
  [36902] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1410), 1,
      anon_sym_AT,
    ACTIONS(1412), 1,
      anon_sym_var,
    ACTIONS(1439), 1,
      anon_sym_SEMI,
    STATE(891), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(1441), 2,
      sym__newline,
      sym__body_end,
    STATE(777), 2,
      sym_annotation,
      aux_sym__annotations,
  [36926] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1410), 1,
      anon_sym_AT,
    ACTIONS(1412), 1,
      anon_sym_var,
    ACTIONS(1443), 1,
      anon_sym_SEMI,
    STATE(861), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(1445), 2,
      sym__newline,
      sym__body_end,
    STATE(777), 2,
      sym_annotation,
      aux_sym__annotations,
  [36950] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1410), 1,
      anon_sym_AT,
    ACTIONS(1412), 1,
      anon_sym_var,
    ACTIONS(1447), 1,
      anon_sym_SEMI,
    STATE(875), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(1449), 2,
      sym__newline,
      sym__body_end,
    STATE(777), 2,
      sym_annotation,
      aux_sym__annotations,
  [36974] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1410), 1,
      anon_sym_AT,
    ACTIONS(1412), 1,
      anon_sym_var,
    ACTIONS(1451), 1,
      anon_sym_SEMI,
    STATE(865), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(1453), 2,
      sym__newline,
      sym__body_end,
    STATE(777), 2,
      sym_annotation,
      aux_sym__annotations,
  [36998] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1410), 1,
      anon_sym_AT,
    ACTIONS(1412), 1,
      anon_sym_var,
    ACTIONS(1455), 1,
      anon_sym_SEMI,
    STATE(872), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(1457), 2,
      sym__newline,
      sym__body_end,
    STATE(777), 2,
      sym_annotation,
      aux_sym__annotations,
  [37022] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1410), 1,
      anon_sym_AT,
    ACTIONS(1412), 1,
      anon_sym_var,
    ACTIONS(1459), 1,
      anon_sym_SEMI,
    STATE(857), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(1461), 2,
      sym__newline,
      sym__body_end,
    STATE(777), 2,
      sym_annotation,
      aux_sym__annotations,
  [37046] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1352), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1356), 1,
      anon_sym_EQ,
    ACTIONS(1463), 1,
      anon_sym_COLON,
    STATE(324), 1,
      sym_inferred_type,
    STATE(1008), 1,
      sym__variable_inferred_type_assignment,
    STATE(1086), 1,
      sym__variable_typed_assignment,
    STATE(1089), 1,
      sym__variable_assignment,
  [37071] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1465), 1,
      sym__identifier,
    ACTIONS(1467), 1,
      anon_sym_RPAREN,
    STATE(854), 1,
      sym_identifier,
    STATE(1042), 1,
      sym__parameters,
    STATE(1100), 3,
      sym_typed_parameter,
      sym_default_parameter,
      sym_typed_default_parameter,
  [37092] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1358), 1,
      anon_sym_setget,
    ACTIONS(1471), 1,
      anon_sym_COLON,
    STATE(924), 1,
      sym_setget,
    STATE(1096), 1,
      sym__setget_body,
    ACTIONS(1469), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [37113] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1338), 1,
      anon_sym_AT,
    ACTIONS(1340), 1,
      anon_sym_var,
    ACTIONS(1473), 1,
      anon_sym_func,
    STATE(953), 1,
      sym__variable_statement,
    STATE(1128), 1,
      sym_annotations,
    STATE(833), 2,
      sym_annotation,
      aux_sym__annotations,
  [37136] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1465), 1,
      sym__identifier,
    ACTIONS(1475), 1,
      anon_sym_RPAREN,
    STATE(854), 1,
      sym_identifier,
    STATE(1193), 1,
      sym__parameters,
    STATE(1100), 3,
      sym_typed_parameter,
      sym_default_parameter,
      sym_typed_default_parameter,
  [37157] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1338), 1,
      anon_sym_AT,
    ACTIONS(1340), 1,
      anon_sym_var,
    ACTIONS(1477), 1,
      anon_sym_func,
    STATE(953), 1,
      sym__variable_statement,
    STATE(1201), 1,
      sym_annotations,
    STATE(833), 2,
      sym_annotation,
      aux_sym__annotations,
  [37180] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1465), 1,
      sym__identifier,
    ACTIONS(1479), 1,
      anon_sym_RPAREN,
    STATE(854), 1,
      sym_identifier,
    STATE(1193), 1,
      sym__parameters,
    STATE(1100), 3,
      sym_typed_parameter,
      sym_default_parameter,
      sym_typed_default_parameter,
  [37201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1481), 7,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_setget,
      anon_sym_DOT,
  [37214] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1410), 1,
      anon_sym_AT,
    ACTIONS(1412), 1,
      anon_sym_var,
    STATE(777), 2,
      sym_annotation,
      aux_sym__annotations,
    ACTIONS(1483), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [37233] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1358), 1,
      anon_sym_setget,
    ACTIONS(1471), 1,
      anon_sym_COLON,
    STATE(944), 1,
      sym_setget,
    STATE(1096), 1,
      sym__setget_body,
    ACTIONS(1485), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [37254] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1465), 1,
      sym__identifier,
    ACTIONS(1487), 1,
      anon_sym_RPAREN,
    STATE(854), 1,
      sym_identifier,
    STATE(1193), 1,
      sym__parameters,
    STATE(1100), 3,
      sym_typed_parameter,
      sym_default_parameter,
      sym_typed_default_parameter,
  [37275] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1465), 1,
      sym__identifier,
    ACTIONS(1489), 1,
      anon_sym_RPAREN,
    STATE(854), 1,
      sym_identifier,
    STATE(1040), 1,
      sym__parameters,
    STATE(1100), 3,
      sym_typed_parameter,
      sym_default_parameter,
      sym_typed_default_parameter,
  [37296] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1358), 1,
      anon_sym_setget,
    ACTIONS(1471), 1,
      anon_sym_COLON,
    STATE(971), 1,
      sym_setget,
    STATE(1096), 1,
      sym__setget_body,
    ACTIONS(1491), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [37317] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1358), 1,
      anon_sym_setget,
    ACTIONS(1471), 1,
      anon_sym_COLON,
    STATE(916), 1,
      sym_setget,
    STATE(1096), 1,
      sym__setget_body,
    ACTIONS(1469), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [37338] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1358), 1,
      anon_sym_setget,
    ACTIONS(1471), 1,
      anon_sym_COLON,
    STATE(997), 1,
      sym_setget,
    STATE(1096), 1,
      sym__setget_body,
    ACTIONS(1485), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [37359] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1465), 1,
      sym__identifier,
    ACTIONS(1493), 1,
      anon_sym_RPAREN,
    STATE(854), 1,
      sym_identifier,
    STATE(1193), 1,
      sym__parameters,
    STATE(1100), 3,
      sym_typed_parameter,
      sym_default_parameter,
      sym_typed_default_parameter,
  [37380] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1358), 1,
      anon_sym_setget,
    ACTIONS(1471), 1,
      anon_sym_COLON,
    STATE(1013), 1,
      sym_setget,
    STATE(1096), 1,
      sym__setget_body,
    ACTIONS(1495), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [37401] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1338), 1,
      anon_sym_AT,
    ACTIONS(1340), 1,
      anon_sym_var,
    STATE(1094), 1,
      sym__variable_statement,
    STATE(1317), 1,
      sym_annotations,
    STATE(833), 2,
      sym_annotation,
      aux_sym__annotations,
  [37421] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1465), 1,
      sym__identifier,
    STATE(854), 1,
      sym_identifier,
    STATE(1193), 1,
      sym__parameters,
    STATE(1100), 3,
      sym_typed_parameter,
      sym_default_parameter,
      sym_typed_default_parameter,
  [37439] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1338), 1,
      anon_sym_AT,
    ACTIONS(1340), 1,
      anon_sym_var,
    STATE(953), 1,
      sym__variable_statement,
    STATE(1317), 1,
      sym_annotations,
    STATE(833), 2,
      sym_annotation,
      aux_sym__annotations,
  [37459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1499), 1,
      anon_sym_EQ,
    ACTIONS(1497), 5,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
  [37473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1501), 6,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_func,
  [37485] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1338), 1,
      anon_sym_AT,
    ACTIONS(1340), 1,
      anon_sym_var,
    STATE(976), 1,
      sym__variable_statement,
    STATE(1317), 1,
      sym_annotations,
    STATE(833), 2,
      sym_annotation,
      aux_sym__annotations,
  [37505] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1338), 1,
      anon_sym_AT,
    ACTIONS(1340), 1,
      anon_sym_var,
    STATE(930), 1,
      sym__variable_statement,
    STATE(1317), 1,
      sym_annotations,
    STATE(833), 2,
      sym_annotation,
      aux_sym__annotations,
  [37525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1324), 1,
      anon_sym_if,
    ACTIONS(1503), 5,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
  [37539] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1505), 1,
      anon_sym_set,
    ACTIONS(1507), 1,
      anon_sym_get,
    STATE(977), 1,
      sym_get_body,
    STATE(978), 1,
      sym_set_body,
    STATE(1350), 1,
      sym__get_assign,
    STATE(1362), 1,
      sym__set_assign,
  [37561] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1509), 1,
      sym__identifier,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    ACTIONS(1513), 1,
      anon_sym__init,
    STATE(952), 1,
      sym_parameters,
    STATE(1203), 1,
      sym_name,
  [37580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1426), 1,
      anon_sym_COLON,
    ACTIONS(1424), 4,
      anon_sym_COLON_EQ,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
  [37593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1515), 5,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
  [37604] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1338), 1,
      anon_sym_AT,
    ACTIONS(1477), 1,
      anon_sym_func,
    STATE(1310), 1,
      sym_annotations,
    STATE(833), 2,
      sym_annotation,
      aux_sym__annotations,
  [37621] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1519), 1,
      anon_sym_DOT,
    STATE(816), 1,
      aux_sym_dotted_type_repeat1,
    ACTIONS(1517), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [37636] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1509), 1,
      sym__identifier,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    ACTIONS(1522), 1,
      anon_sym__init,
    STATE(1032), 1,
      sym_parameters,
    STATE(1275), 1,
      sym_name,
  [37655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1524), 5,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
  [37666] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1528), 1,
      anon_sym_DOT,
    STATE(830), 1,
      aux_sym_dotted_type_repeat1,
    ACTIONS(1526), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [37681] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1532), 1,
      anon_sym_LPAREN,
    STATE(1072), 1,
      sym_parameters,
    ACTIONS(1530), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [37696] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(653), 1,
      sym__string_start,
    ACTIONS(1534), 1,
      sym__identifier,
    STATE(1055), 1,
      sym_type,
    STATE(1112), 1,
      sym_string,
    STATE(1390), 1,
      sym_dotted_type,
  [37715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1536), 5,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
  [37726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(400), 5,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
  [37737] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1031), 1,
      anon_sym_LPAREN,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(1433), 3,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_func,
  [37752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1538), 5,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
  [37763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(420), 5,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
  [37774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(416), 5,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
  [37785] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1540), 1,
      anon_sym_AT,
    ACTIONS(1428), 2,
      anon_sym_var,
      anon_sym_func,
    STATE(828), 2,
      sym_annotation,
      aux_sym__annotations,
  [37800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(404), 5,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
  [37811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1528), 1,
      anon_sym_DOT,
    STATE(816), 1,
      aux_sym_dotted_type_repeat1,
    ACTIONS(1543), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [37826] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(73), 1,
      sym__string_start,
    ACTIONS(1545), 1,
      sym__identifier,
    STATE(819), 1,
      sym_type,
    STATE(894), 1,
      sym_string,
    STATE(927), 1,
      sym_dotted_type,
  [37845] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1338), 1,
      anon_sym_AT,
    ACTIONS(1473), 1,
      anon_sym_func,
    STATE(1379), 1,
      sym_annotations,
    STATE(833), 2,
      sym_annotation,
      aux_sym__annotations,
  [37862] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1338), 1,
      anon_sym_AT,
    ACTIONS(1412), 2,
      anon_sym_var,
      anon_sym_func,
    STATE(828), 2,
      sym_annotation,
      aux_sym__annotations,
  [37877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1547), 5,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
  [37888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(412), 5,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
  [37899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1549), 5,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
  [37910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1551), 5,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
  [37921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1553), 5,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
  [37932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(408), 5,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_setget,
  [37943] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1447), 1,
      anon_sym_SEMI,
    STATE(875), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(1449), 2,
      sym__newline,
      sym__body_end,
  [37957] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 1,
      sym__identifier,
    STATE(524), 1,
      sym_identifier,
    STATE(585), 2,
      sym_attribute_call,
      sym_attribute_subscript,
  [37971] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1557), 1,
      anon_sym_SEMI,
    STATE(845), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(352), 2,
      sym__newline,
      sym__body_end,
  [37985] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    ACTIONS(1559), 1,
      sym__identifier,
    STATE(998), 1,
      sym_parameters,
    STATE(1110), 1,
      sym_name,
  [38001] = 4,
    ACTIONS(1561), 1,
      sym_comment,
    ACTIONS(1565), 1,
      sym__string_end,
    STATE(882), 1,
      aux_sym_string_repeat1,
    ACTIONS(1563), 2,
      sym__string_content,
      sym_escape_sequence,
  [38015] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1567), 1,
      anon_sym_SEMI,
    STATE(845), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(1483), 2,
      sym__newline,
      sym__body_end,
  [38029] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1408), 1,
      anon_sym_SEMI,
    STATE(842), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(1414), 2,
      sym__newline,
      sym__body_end,
  [38043] = 4,
    ACTIONS(1561), 1,
      sym_comment,
    ACTIONS(1572), 1,
      sym__string_end,
    STATE(844), 1,
      aux_sym_string_repeat1,
    ACTIONS(1570), 2,
      sym__string_content,
      sym_escape_sequence,
  [38057] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    ACTIONS(1559), 1,
      sym__identifier,
    STATE(951), 1,
      sym_parameters,
    STATE(1111), 1,
      sym_name,
  [38073] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1559), 1,
      sym__identifier,
    ACTIONS(1574), 1,
      anon_sym_LBRACE,
    STATE(178), 1,
      sym_enumerator_list,
    STATE(1226), 1,
      sym_name,
  [38089] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    ACTIONS(1559), 1,
      sym__identifier,
    STATE(1077), 1,
      sym_parameters,
    STATE(1117), 1,
      sym_name,
  [38105] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 1,
      sym__identifier,
    ACTIONS(1576), 1,
      anon_sym_RBRACE,
    STATE(1059), 1,
      sym_identifier,
    STATE(1139), 1,
      sym_enumerator,
  [38121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 1,
      anon_sym_COMMA,
    ACTIONS(1578), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [38133] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 1,
      sym__identifier,
    ACTIONS(1582), 1,
      anon_sym_RBRACE,
    STATE(1059), 1,
      sym_identifier,
    STATE(1139), 1,
      sym_enumerator,
  [38149] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1584), 1,
      anon_sym_COLON,
    ACTIONS(1586), 1,
      anon_sym_EQ,
    ACTIONS(1588), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [38163] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    ACTIONS(1559), 1,
      sym__identifier,
    STATE(1047), 1,
      sym_parameters,
    STATE(1263), 1,
      sym_name,
  [38179] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    ACTIONS(1559), 1,
      sym__identifier,
    STATE(1070), 1,
      sym_parameters,
    STATE(1121), 1,
      sym_name,
  [38195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1590), 1,
      anon_sym_SEMI,
    STATE(845), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(344), 2,
      sym__newline,
      sym__body_end,
  [38209] = 4,
    ACTIONS(1561), 1,
      sym_comment,
    ACTIONS(1592), 1,
      sym__string_end,
    STATE(882), 1,
      aux_sym_string_repeat1,
    ACTIONS(1563), 2,
      sym__string_content,
      sym_escape_sequence,
  [38223] = 4,
    ACTIONS(1561), 1,
      sym_comment,
    ACTIONS(1596), 1,
      sym__string_end,
    STATE(874), 1,
      aux_sym_string_repeat1,
    ACTIONS(1594), 2,
      sym__string_content,
      sym_escape_sequence,
  [38237] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1559), 1,
      sym__identifier,
    ACTIONS(1598), 1,
      anon_sym_LBRACE,
    STATE(155), 1,
      sym_enumerator_list,
    STATE(1136), 1,
      sym_name,
  [38253] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1600), 1,
      anon_sym_SEMI,
    STATE(845), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(350), 2,
      sym__newline,
      sym__body_end,
  [38267] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1443), 1,
      anon_sym_SEMI,
    STATE(861), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(1445), 2,
      sym__newline,
      sym__body_end,
  [38281] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    ACTIONS(1559), 1,
      sym__identifier,
    STATE(1052), 1,
      sym_parameters,
    STATE(1126), 1,
      sym_name,
  [38297] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_SEMI,
    STATE(857), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(1461), 2,
      sym__newline,
      sym__body_end,
  [38311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1602), 1,
      anon_sym_SEMI,
    STATE(845), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(354), 2,
      sym__newline,
      sym__body_end,
  [38325] = 4,
    ACTIONS(1561), 1,
      sym_comment,
    ACTIONS(1604), 1,
      sym__string_end,
    STATE(882), 1,
      aux_sym_string_repeat1,
    ACTIONS(1563), 2,
      sym__string_content,
      sym_escape_sequence,
  [38339] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1451), 1,
      anon_sym_SEMI,
    STATE(865), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(1453), 2,
      sym__newline,
      sym__body_end,
  [38353] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    ACTIONS(1559), 1,
      sym__identifier,
    STATE(987), 1,
      sym_parameters,
    STATE(1165), 1,
      sym_name,
  [38369] = 4,
    ACTIONS(1561), 1,
      sym_comment,
    ACTIONS(1608), 1,
      sym__string_end,
    STATE(858), 1,
      aux_sym_string_repeat1,
    ACTIONS(1606), 2,
      sym__string_content,
      sym_escape_sequence,
  [38383] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    ACTIONS(1559), 1,
      sym__identifier,
    STATE(1046), 1,
      sym_parameters,
    STATE(1270), 1,
      sym_name,
  [38399] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1465), 1,
      sym__identifier,
    STATE(482), 1,
      sym_identifier,
    STATE(599), 2,
      sym_attribute_call,
      sym_attribute_subscript,
  [38413] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 1,
      anon_sym_SEMI,
    STATE(845), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(362), 2,
      sym__newline,
      sym__body_end,
  [38427] = 4,
    ACTIONS(1561), 1,
      sym_comment,
    ACTIONS(1612), 1,
      sym__string_end,
    STATE(882), 1,
      aux_sym_string_repeat1,
    ACTIONS(1563), 2,
      sym__string_content,
      sym_escape_sequence,
  [38441] = 4,
    ACTIONS(1561), 1,
      sym_comment,
    ACTIONS(1614), 1,
      sym__string_end,
    STATE(882), 1,
      aux_sym_string_repeat1,
    ACTIONS(1563), 2,
      sym__string_content,
      sym_escape_sequence,
  [38455] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1616), 1,
      anon_sym_SEMI,
    STATE(845), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(328), 2,
      sym__newline,
      sym__body_end,
  [38469] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1455), 1,
      anon_sym_SEMI,
    STATE(872), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(1457), 2,
      sym__newline,
      sym__body_end,
  [38483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1545), 1,
      sym__identifier,
    ACTIONS(1618), 1,
      anon_sym_EQ,
    ACTIONS(1620), 1,
      sym__indent,
    STATE(806), 1,
      sym_type,
  [38499] = 4,
    ACTIONS(1561), 1,
      sym_comment,
    ACTIONS(1624), 1,
      sym__string_end,
    STATE(873), 1,
      aux_sym_string_repeat1,
    ACTIONS(1622), 2,
      sym__string_content,
      sym_escape_sequence,
  [38513] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1626), 1,
      sym__identifier,
    STATE(634), 1,
      sym_identifier,
    STATE(681), 2,
      sym_attribute_call,
      sym_attribute_subscript,
  [38527] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1628), 1,
      sym__identifier,
    STATE(554), 1,
      sym_identifier,
    STATE(711), 2,
      sym_attribute_call,
      sym_attribute_subscript,
  [38541] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    ACTIONS(1559), 1,
      sym__identifier,
    STATE(929), 1,
      sym_parameters,
    STATE(1176), 1,
      sym_name,
  [38557] = 4,
    ACTIONS(1561), 1,
      sym_comment,
    ACTIONS(1633), 1,
      sym__string_end,
    STATE(882), 1,
      aux_sym_string_repeat1,
    ACTIONS(1630), 2,
      sym__string_content,
      sym_escape_sequence,
  [38571] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      sym__identifier,
    STATE(221), 1,
      sym_identifier,
    STATE(232), 2,
      sym_attribute_call,
      sym_attribute_subscript,
  [38585] = 4,
    ACTIONS(1561), 1,
      sym_comment,
    ACTIONS(1639), 1,
      sym__string_end,
    STATE(886), 1,
      aux_sym_string_repeat1,
    ACTIONS(1637), 2,
      sym__string_content,
      sym_escape_sequence,
  [38599] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1420), 1,
      anon_sym_SEMI,
    STATE(887), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(1422), 2,
      sym__newline,
      sym__body_end,
  [38613] = 4,
    ACTIONS(1561), 1,
      sym_comment,
    ACTIONS(1641), 1,
      sym__string_end,
    STATE(882), 1,
      aux_sym_string_repeat1,
    ACTIONS(1563), 2,
      sym__string_content,
      sym_escape_sequence,
  [38627] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1643), 1,
      anon_sym_SEMI,
    STATE(845), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(338), 2,
      sym__newline,
      sym__body_end,
  [38641] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      sym__identifier,
    STATE(514), 1,
      sym_identifier,
    STATE(649), 2,
      sym_attribute_call,
      sym_attribute_subscript,
  [38655] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    ACTIONS(1559), 1,
      sym__identifier,
    STATE(1083), 1,
      sym_parameters,
    STATE(1116), 1,
      sym_name,
  [38671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1649), 1,
      anon_sym_COMMA,
    ACTIONS(1647), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [38683] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1651), 1,
      anon_sym_SEMI,
    STATE(845), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(332), 2,
      sym__newline,
      sym__body_end,
  [38697] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1416), 1,
      anon_sym_SEMI,
    STATE(903), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(1418), 2,
      sym__newline,
      sym__body_end,
  [38711] = 4,
    ACTIONS(1561), 1,
      sym_comment,
    ACTIONS(1655), 1,
      sym__string_end,
    STATE(895), 1,
      aux_sym_string_repeat1,
    ACTIONS(1653), 2,
      sym__string_content,
      sym_escape_sequence,
  [38725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1659), 1,
      anon_sym_DOT,
    ACTIONS(1657), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [38737] = 4,
    ACTIONS(1561), 1,
      sym_comment,
    ACTIONS(1661), 1,
      sym__string_end,
    STATE(882), 1,
      aux_sym_string_repeat1,
    ACTIONS(1563), 2,
      sym__string_content,
      sym_escape_sequence,
  [38751] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1663), 1,
      sym__identifier,
    STATE(494), 1,
      sym_identifier,
    STATE(662), 2,
      sym_attribute_call,
      sym_attribute_subscript,
  [38765] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 1,
      sym__identifier,
    ACTIONS(1665), 1,
      anon_sym_RBRACE,
    STATE(1059), 1,
      sym_identifier,
    STATE(1139), 1,
      sym_enumerator,
  [38781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1424), 4,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [38791] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1439), 1,
      anon_sym_SEMI,
    STATE(891), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(1441), 2,
      sym__newline,
      sym__body_end,
  [38805] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1667), 1,
      anon_sym_SEMI,
    STATE(845), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(348), 2,
      sym__newline,
      sym__body_end,
  [38819] = 4,
    ACTIONS(1561), 1,
      sym_comment,
    ACTIONS(1671), 1,
      sym__string_end,
    STATE(866), 1,
      aux_sym_string_repeat1,
    ACTIONS(1669), 2,
      sym__string_content,
      sym_escape_sequence,
  [38833] = 4,
    ACTIONS(1561), 1,
      sym_comment,
    ACTIONS(1673), 1,
      sym__string_end,
    STATE(882), 1,
      aux_sym_string_repeat1,
    ACTIONS(1563), 2,
      sym__string_content,
      sym_escape_sequence,
  [38847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1675), 1,
      anon_sym_SEMI,
    STATE(845), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(340), 2,
      sym__newline,
      sym__body_end,
  [38861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1677), 4,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [38871] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 1,
      sym__identifier,
    ACTIONS(1679), 1,
      anon_sym_RBRACE,
    STATE(1059), 1,
      sym_identifier,
    STATE(1139), 1,
      sym_enumerator,
  [38887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1517), 4,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
      anon_sym_DOT,
  [38897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1435), 1,
      anon_sym_SEMI,
    STATE(900), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(1437), 2,
      sym__newline,
      sym__body_end,
  [38911] = 4,
    ACTIONS(1561), 1,
      sym_comment,
    ACTIONS(1683), 1,
      sym__string_end,
    STATE(902), 1,
      aux_sym_string_repeat1,
    ACTIONS(1681), 2,
      sym__string_content,
      sym_escape_sequence,
  [38925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1685), 1,
      anon_sym_EQ,
    ACTIONS(1687), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [38936] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1543), 1,
      anon_sym_COLON,
    ACTIONS(1689), 1,
      anon_sym_DOT,
    STATE(919), 1,
      aux_sym_dotted_type_repeat1,
  [38949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1534), 1,
      sym__identifier,
    STATE(1055), 1,
      sym_type,
    STATE(1328), 1,
      sym_dotted_type,
  [38962] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1691), 1,
      anon_sym_COLON,
    ACTIONS(1693), 1,
      anon_sym_COMMA,
    STATE(974), 1,
      aux_sym_pattern_section_repeat1,
  [38975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1695), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [38984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1320), 3,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_else,
  [38993] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1697), 1,
      anon_sym_COMMA,
    ACTIONS(1699), 1,
      anon_sym_RPAREN,
    STATE(990), 1,
      aux_sym_array_repeat1,
  [39006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1701), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [39015] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1703), 1,
      anon_sym_COMMA,
    ACTIONS(1705), 1,
      anon_sym_RBRACK,
    STATE(981), 1,
      aux_sym_array_repeat1,
  [39028] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1707), 1,
      anon_sym_COMMA,
    ACTIONS(1709), 1,
      anon_sym_RBRACE,
    STATE(975), 1,
      aux_sym_dictionary_repeat1,
  [39041] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1517), 1,
      anon_sym_COLON,
    ACTIONS(1711), 1,
      anon_sym_DOT,
    STATE(919), 1,
      aux_sym_dotted_type_repeat1,
  [39054] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1714), 1,
      anon_sym_COMMA,
    ACTIONS(1717), 1,
      anon_sym_RBRACE,
    STATE(920), 1,
      aux_sym_enumerator_list_repeat1,
  [39067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1719), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [39076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1320), 3,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_RBRACK,
  [39085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1481), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [39094] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1701), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [39103] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1721), 1,
      anon_sym_COMMA,
    ACTIONS(1724), 1,
      anon_sym_RBRACK,
    STATE(925), 1,
      aux_sym_array_repeat1,
  [39116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_if,
    ACTIONS(1503), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [39127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1657), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [39136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(590), 3,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_RBRACK,
  [39145] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_COLON,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    STATE(1376), 1,
      sym__return_type,
  [39158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1732), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [39167] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1734), 1,
      anon_sym_COMMA,
    ACTIONS(1736), 1,
      anon_sym_RBRACK,
    STATE(948), 1,
      aux_sym_pattern_array_repeat1,
  [39180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(590), 3,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_RBRACE,
  [39189] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(877), 1,
      anon_sym_RPAREN,
    ACTIONS(1738), 1,
      anon_sym_COMMA,
    STATE(1010), 1,
      aux_sym_array_repeat1,
  [39202] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1740), 1,
      anon_sym_COLON,
    ACTIONS(1742), 1,
      anon_sym_extends,
    STATE(1393), 1,
      sym_extends_statement,
  [39215] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(881), 1,
      anon_sym_RBRACK,
    ACTIONS(1744), 1,
      anon_sym_COMMA,
    STATE(925), 1,
      aux_sym_array_repeat1,
  [39228] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 1,
      sym__identifier,
    STATE(1058), 1,
      sym_enumerator,
    STATE(1059), 1,
      sym_identifier,
  [39241] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    ACTIONS(1746), 1,
      anon_sym_COLON,
    STATE(1314), 1,
      sym__return_type,
  [39254] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(695), 1,
      anon_sym_RBRACE,
    ACTIONS(1748), 1,
      anon_sym_COMMA,
    STATE(968), 1,
      aux_sym_dictionary_repeat1,
  [39267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1320), 3,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_RBRACE,
  [39276] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1750), 1,
      anon_sym_COMMA,
    ACTIONS(1752), 1,
      anon_sym_RPAREN,
    STATE(933), 1,
      aux_sym_array_repeat1,
  [39289] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [39298] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1756), 1,
      anon_sym_COMMA,
    ACTIONS(1758), 1,
      anon_sym_RBRACE,
    STATE(1071), 1,
      aux_sym_pattern_dictionary_repeat1,
  [39311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1760), 1,
      anon_sym_COMMA,
    ACTIONS(1762), 1,
      anon_sym_RBRACK,
    STATE(935), 1,
      aux_sym_array_repeat1,
  [39324] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1764), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [39333] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1766), 1,
      anon_sym_COMMA,
    ACTIONS(1768), 1,
      anon_sym_RBRACE,
    STATE(938), 1,
      aux_sym_dictionary_repeat1,
  [39346] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1770), 1,
      anon_sym_COMMA,
    ACTIONS(1772), 1,
      anon_sym_RBRACE,
    STATE(1054), 1,
      aux_sym_dictionary_repeat1,
  [39359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1774), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [39368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1776), 1,
      anon_sym_COMMA,
    ACTIONS(1779), 1,
      anon_sym_RBRACK,
    STATE(948), 1,
      aux_sym_pattern_array_repeat1,
  [39381] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1781), 1,
      anon_sym_COMMA,
    ACTIONS(1783), 1,
      anon_sym_RBRACK,
    STATE(1051), 1,
      aux_sym_array_repeat1,
  [39394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1785), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [39403] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    ACTIONS(1787), 1,
      anon_sym_COLON,
    STATE(1356), 1,
      sym__return_type,
  [39416] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    ACTIONS(1789), 1,
      anon_sym_COLON,
    STATE(1391), 1,
      sym__return_type,
  [39429] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1791), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [39438] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    ACTIONS(1793), 1,
      anon_sym_COLON,
    STATE(1358), 1,
      sym__return_type,
  [39451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1795), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [39460] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1665), 1,
      anon_sym_RBRACE,
    ACTIONS(1797), 1,
      anon_sym_COMMA,
    STATE(920), 1,
      aux_sym_enumerator_list_repeat1,
  [39473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1799), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [39482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(893), 1,
      anon_sym_RPAREN,
    ACTIONS(1801), 1,
      anon_sym_COMMA,
    STATE(1010), 1,
      aux_sym_array_repeat1,
  [39495] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(891), 1,
      anon_sym_RBRACK,
    ACTIONS(1803), 1,
      anon_sym_COMMA,
    STATE(925), 1,
      aux_sym_array_repeat1,
  [39508] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1756), 1,
      anon_sym_COMMA,
    ACTIONS(1805), 1,
      anon_sym_RBRACE,
    STATE(942), 1,
      aux_sym_pattern_dictionary_repeat1,
  [39521] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(699), 1,
      anon_sym_RBRACE,
    ACTIONS(1807), 1,
      anon_sym_COMMA,
    STATE(968), 1,
      aux_sym_dictionary_repeat1,
  [39534] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1734), 1,
      anon_sym_COMMA,
    ACTIONS(1809), 1,
      anon_sym_RBRACK,
    STATE(931), 1,
      aux_sym_pattern_array_repeat1,
  [39547] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1811), 1,
      anon_sym_COMMA,
    ACTIONS(1813), 1,
      anon_sym_RPAREN,
    STATE(958), 1,
      aux_sym_array_repeat1,
  [39560] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1815), 1,
      anon_sym_COMMA,
    ACTIONS(1817), 1,
      anon_sym_RBRACK,
    STATE(959), 1,
      aux_sym_array_repeat1,
  [39573] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1819), 1,
      anon_sym_COMMA,
    ACTIONS(1821), 1,
      anon_sym_RBRACE,
    STATE(961), 1,
      aux_sym_dictionary_repeat1,
  [39586] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [39595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1825), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [39604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1827), 1,
      anon_sym_COMMA,
    ACTIONS(1830), 1,
      anon_sym_RBRACE,
    STATE(968), 1,
      aux_sym_dictionary_repeat1,
  [39617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1501), 3,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_func,
  [39626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1832), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [39635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1834), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [39644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(408), 3,
      sym__dedent,
      anon_sym_set,
      anon_sym_get,
  [39653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1836), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [39662] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1693), 1,
      anon_sym_COMMA,
    ACTIONS(1838), 1,
      anon_sym_COLON,
    STATE(1005), 1,
      aux_sym_pattern_section_repeat1,
  [39675] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(753), 1,
      anon_sym_RBRACE,
    ACTIONS(1840), 1,
      anon_sym_COMMA,
    STATE(968), 1,
      aux_sym_dictionary_repeat1,
  [39688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1842), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [39697] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1844), 1,
      anon_sym_set,
    ACTIONS(1846), 1,
      sym__dedent,
    STATE(1368), 1,
      sym_set_body,
  [39710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1848), 1,
      anon_sym_get,
    ACTIONS(1850), 1,
      sym__dedent,
    STATE(1363), 1,
      sym_get_body,
  [39723] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_RPAREN,
    ACTIONS(1852), 1,
      anon_sym_COMMA,
    STATE(1010), 1,
      aux_sym_array_repeat1,
  [39736] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(404), 3,
      sym__dedent,
      anon_sym_set,
      anon_sym_get,
  [39745] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(853), 1,
      anon_sym_RBRACK,
    ACTIONS(1854), 1,
      anon_sym_COMMA,
    STATE(925), 1,
      aux_sym_array_repeat1,
  [39758] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1856), 3,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [39767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1858), 1,
      anon_sym_if,
    ACTIONS(1322), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [39778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1860), 3,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [39787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(412), 3,
      sym__dedent,
      anon_sym_set,
      anon_sym_get,
  [39796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1862), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [39805] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    ACTIONS(1864), 1,
      anon_sym_COLON,
    STATE(1331), 1,
      sym__return_type,
  [39818] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_RPAREN,
    ACTIONS(1866), 1,
      anon_sym_COMMA,
    STATE(1010), 1,
      aux_sym_array_repeat1,
  [39831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(416), 3,
      sym__dedent,
      anon_sym_set,
      anon_sym_get,
  [39840] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(869), 1,
      anon_sym_RPAREN,
    ACTIONS(1868), 1,
      anon_sym_COMMA,
    STATE(1010), 1,
      aux_sym_array_repeat1,
  [39853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(855), 1,
      anon_sym_RBRACK,
    ACTIONS(1870), 1,
      anon_sym_COMMA,
    STATE(925), 1,
      aux_sym_array_repeat1,
  [39866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(400), 3,
      sym__dedent,
      anon_sym_set,
      anon_sym_get,
  [39875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(420), 3,
      sym__dedent,
      anon_sym_set,
      anon_sym_get,
  [39884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1872), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [39893] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(743), 1,
      anon_sym_RBRACE,
    ACTIONS(1874), 1,
      anon_sym_COMMA,
    STATE(968), 1,
      aux_sym_dictionary_repeat1,
  [39906] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    ACTIONS(1876), 1,
      anon_sym_EQ,
    STATE(1359), 1,
      sym_parameters,
  [39919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1764), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [39928] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    ACTIONS(1878), 1,
      anon_sym_COLON,
    STATE(1365), 1,
      sym__return_type,
  [39941] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1880), 1,
      anon_sym_COMMA,
    ACTIONS(1882), 1,
      anon_sym_RPAREN,
    STATE(988), 1,
      aux_sym_array_repeat1,
  [39954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1884), 1,
      anon_sym_COMMA,
    ACTIONS(1886), 1,
      anon_sym_RBRACK,
    STATE(991), 1,
      aux_sym_array_repeat1,
  [39967] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1888), 1,
      anon_sym_COMMA,
    ACTIONS(1890), 1,
      anon_sym_RBRACE,
    STATE(995), 1,
      aux_sym_dictionary_repeat1,
  [39980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1493), 1,
      anon_sym_RPAREN,
    ACTIONS(1892), 1,
      anon_sym_COMMA,
    STATE(1017), 1,
      aux_sym_parameters_repeat1,
  [39993] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1894), 1,
      sym__identifier,
    ACTIONS(1896), 1,
      anon_sym_COMMA,
    STATE(852), 1,
      sym_setter,
  [40006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1898), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [40015] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1900), 1,
      anon_sym_COLON,
    ACTIONS(1902), 1,
      anon_sym_COMMA,
    STATE(1005), 1,
      aux_sym_pattern_section_repeat1,
  [40028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(590), 3,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_else,
  [40037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    ACTIONS(1905), 1,
      anon_sym_COLON,
    STATE(1367), 1,
      sym__return_type,
  [40050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [40059] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    ACTIONS(1909), 1,
      anon_sym_COLON,
    STATE(1388), 1,
      sym__return_type,
  [40072] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1724), 1,
      anon_sym_RPAREN,
    ACTIONS(1911), 1,
      anon_sym_COMMA,
    STATE(1010), 1,
      aux_sym_array_repeat1,
  [40085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1914), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [40094] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1916), 3,
      anon_sym_AT,
      anon_sym_var,
      anon_sym_func,
  [40103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1918), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [40112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1920), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [40121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1922), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [40130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1924), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [40139] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1926), 1,
      anon_sym_COMMA,
    ACTIONS(1929), 1,
      anon_sym_RPAREN,
    STATE(1017), 1,
      aux_sym_parameters_repeat1,
  [40152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1858), 1,
      anon_sym_if,
    ACTIONS(1503), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [40163] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1344), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [40172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1931), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [40181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1933), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [40190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_if,
    ACTIONS(1322), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [40201] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1734), 1,
      anon_sym_COMMA,
    ACTIONS(1935), 1,
      anon_sym_RBRACK,
    STATE(948), 1,
      aux_sym_pattern_array_repeat1,
  [40214] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1742), 1,
      anon_sym_extends,
    ACTIONS(1937), 1,
      anon_sym_COLON,
    STATE(1386), 1,
      sym_extends_statement,
  [40227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1756), 1,
      anon_sym_COMMA,
    ACTIONS(1939), 1,
      anon_sym_RBRACE,
    STATE(1071), 1,
      aux_sym_pattern_dictionary_repeat1,
  [40240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [40249] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 1,
      sym__identifier,
    STATE(1037), 1,
      sym_enumerator,
    STATE(1059), 1,
      sym_identifier,
  [40262] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1734), 1,
      anon_sym_COMMA,
    ACTIONS(1943), 1,
      anon_sym_RBRACK,
    STATE(1023), 1,
      aux_sym_pattern_array_repeat1,
  [40275] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1756), 1,
      anon_sym_COMMA,
    ACTIONS(1945), 1,
      anon_sym_RBRACE,
    STATE(1025), 1,
      aux_sym_pattern_dictionary_repeat1,
  [40288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1947), 1,
      anon_sym_COMMA,
    ACTIONS(1949), 1,
      anon_sym_RBRACE,
    STATE(1039), 1,
      aux_sym_dictionary_repeat1,
  [40301] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_COMMA,
    ACTIONS(1953), 1,
      anon_sym_RBRACK,
    STATE(1041), 1,
      aux_sym_array_repeat1,
  [40314] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    ACTIONS(1955), 1,
      anon_sym_COLON,
    STATE(1394), 1,
      sym__return_type,
  [40327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1481), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
  [40336] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1957), 1,
      anon_sym_COMMA,
    ACTIONS(1959), 1,
      anon_sym_RPAREN,
    STATE(1049), 1,
      aux_sym_array_repeat1,
  [40349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 1,
      anon_sym_if,
    ACTIONS(1322), 2,
      anon_sym_COLON,
      anon_sym_else,
  [40360] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    ACTIONS(1963), 1,
      anon_sym_COLON,
    STATE(1372), 1,
      sym__return_type,
  [40373] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1965), 1,
      anon_sym_COMMA,
    ACTIONS(1967), 1,
      anon_sym_RBRACE,
    STATE(1053), 1,
      aux_sym_enumerator_list_repeat1,
  [40386] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1969), 1,
      anon_sym_COLON,
    ACTIONS(1971), 1,
      anon_sym_DOT,
    ACTIONS(1973), 1,
      anon_sym_DASH_GT,
  [40399] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 1,
      anon_sym_RBRACE,
    ACTIONS(1975), 1,
      anon_sym_COMMA,
    STATE(968), 1,
      aux_sym_dictionary_repeat1,
  [40412] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1977), 1,
      anon_sym_COMMA,
    ACTIONS(1979), 1,
      anon_sym_RPAREN,
    STATE(1002), 1,
      aux_sym_parameters_repeat1,
  [40425] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(831), 1,
      anon_sym_RBRACK,
    ACTIONS(1981), 1,
      anon_sym_COMMA,
    STATE(925), 1,
      aux_sym_array_repeat1,
  [40438] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1983), 1,
      anon_sym_COMMA,
    ACTIONS(1985), 1,
      anon_sym_RPAREN,
    STATE(1056), 1,
      aux_sym_parameters_repeat1,
  [40451] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 1,
      anon_sym_COLON,
    ACTIONS(1989), 1,
      anon_sym_DOT,
    ACTIONS(1991), 1,
      anon_sym_DASH_GT,
  [40464] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    ACTIONS(1993), 1,
      anon_sym_COLON,
    STATE(1382), 1,
      sym__return_type,
  [40477] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    ACTIONS(1995), 1,
      anon_sym_COLON,
    STATE(1380), 1,
      sym__return_type,
  [40490] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    ACTIONS(1997), 1,
      anon_sym_COLON,
    STATE(1383), 1,
      sym__return_type,
  [40503] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    ACTIONS(1999), 1,
      anon_sym_COLON,
    STATE(1395), 1,
      sym__return_type,
  [40516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1695), 3,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [40525] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(865), 1,
      anon_sym_RPAREN,
    ACTIONS(2001), 1,
      anon_sym_COMMA,
    STATE(1010), 1,
      aux_sym_array_repeat1,
  [40538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1832), 3,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [40547] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 1,
      anon_sym_RBRACK,
    ACTIONS(2003), 1,
      anon_sym_COMMA,
    STATE(925), 1,
      aux_sym_array_repeat1,
  [40560] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    ACTIONS(2005), 1,
      anon_sym_COLON,
    STATE(1324), 1,
      sym__return_type,
  [40573] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1582), 1,
      anon_sym_RBRACE,
    ACTIONS(2007), 1,
      anon_sym_COMMA,
    STATE(920), 1,
      aux_sym_enumerator_list_repeat1,
  [40586] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(737), 1,
      anon_sym_RBRACE,
    ACTIONS(2009), 1,
      anon_sym_COMMA,
    STATE(968), 1,
      aux_sym_dictionary_repeat1,
  [40599] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1526), 1,
      anon_sym_COLON,
    ACTIONS(1689), 1,
      anon_sym_DOT,
    STATE(910), 1,
      aux_sym_dotted_type_repeat1,
  [40612] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_RPAREN,
    ACTIONS(2011), 1,
      anon_sym_COMMA,
    STATE(1017), 1,
      aux_sym_parameters_repeat1,
  [40625] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    ACTIONS(2013), 1,
      anon_sym_COLON,
    STATE(1385), 1,
      sym__return_type,
  [40638] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COMMA,
    ACTIONS(2017), 1,
      anon_sym_RBRACE,
    STATE(956), 1,
      aux_sym_enumerator_list_repeat1,
  [40651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2019), 1,
      anon_sym_EQ,
    ACTIONS(2021), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [40662] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1545), 1,
      sym__identifier,
    STATE(819), 1,
      sym_type,
    STATE(950), 1,
      sym_dotted_type,
  [40675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2023), 1,
      anon_sym_if,
    ACTIONS(1322), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [40686] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    ACTIONS(2025), 1,
      anon_sym_COLON,
    STATE(1329), 1,
      sym__return_type,
  [40699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [40708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1860), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [40717] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    ACTIONS(2029), 1,
      anon_sym_COLON,
    STATE(1355), 1,
      sym__return_type,
  [40730] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1756), 1,
      anon_sym_COMMA,
    ACTIONS(2031), 1,
      anon_sym_RBRACE,
    STATE(1068), 1,
      aux_sym_pattern_dictionary_repeat1,
  [40743] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1734), 1,
      anon_sym_COMMA,
    ACTIONS(2033), 1,
      anon_sym_RBRACK,
    STATE(1069), 1,
      aux_sym_pattern_array_repeat1,
  [40756] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1756), 1,
      anon_sym_COMMA,
    ACTIONS(2035), 1,
      anon_sym_RBRACE,
    STATE(1071), 1,
      aux_sym_pattern_dictionary_repeat1,
  [40769] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1734), 1,
      anon_sym_COMMA,
    ACTIONS(2037), 1,
      anon_sym_RBRACK,
    STATE(948), 1,
      aux_sym_pattern_array_repeat1,
  [40782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    ACTIONS(2039), 1,
      anon_sym_COLON,
    STATE(1338), 1,
      sym__return_type,
  [40795] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2041), 1,
      anon_sym_COMMA,
    ACTIONS(2044), 1,
      anon_sym_RBRACE,
    STATE(1071), 1,
      aux_sym_pattern_dictionary_repeat1,
  [40808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2046), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [40817] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    ACTIONS(2048), 1,
      anon_sym_COLON,
    STATE(1340), 1,
      sym__return_type,
  [40830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1856), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [40839] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 1,
      sym__identifier,
    STATE(1059), 1,
      sym_identifier,
    STATE(1139), 1,
      sym_enumerator,
  [40852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1320), 3,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_RPAREN,
  [40861] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    ACTIONS(2050), 1,
      anon_sym_COLON,
    STATE(1347), 1,
      sym__return_type,
  [40874] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    ACTIONS(2052), 1,
      anon_sym_COLON,
    STATE(1349), 1,
      sym__return_type,
  [40887] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2054), 1,
      anon_sym_COMMA,
    ACTIONS(2056), 1,
      anon_sym_RBRACE,
    STATE(1084), 1,
      aux_sym_dictionary_repeat1,
  [40900] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2058), 1,
      anon_sym_COMMA,
    ACTIONS(2060), 1,
      anon_sym_RBRACK,
    STATE(1085), 1,
      aux_sym_array_repeat1,
  [40913] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2062), 1,
      anon_sym_COMMA,
    ACTIONS(2064), 1,
      anon_sym_RPAREN,
    STATE(1087), 1,
      aux_sym_array_repeat1,
  [40926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1483), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [40935] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_DASH_GT,
    ACTIONS(2066), 1,
      anon_sym_COLON,
    STATE(1334), 1,
      sym__return_type,
  [40948] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 1,
      anon_sym_RBRACE,
    ACTIONS(2068), 1,
      anon_sym_COMMA,
    STATE(968), 1,
      aux_sym_dictionary_repeat1,
  [40961] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(859), 1,
      anon_sym_RBRACK,
    ACTIONS(2070), 1,
      anon_sym_COMMA,
    STATE(925), 1,
      aux_sym_array_repeat1,
  [40974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [40983] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(829), 1,
      anon_sym_RPAREN,
    ACTIONS(2072), 1,
      anon_sym_COMMA,
    STATE(1010), 1,
      aux_sym_array_repeat1,
  [40996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2023), 1,
      anon_sym_if,
    ACTIONS(1503), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [41007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2074), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [41016] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1534), 1,
      sym__identifier,
    ACTIONS(1618), 1,
      anon_sym_EQ,
    STATE(1332), 1,
      sym_type,
  [41029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [41038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(590), 3,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_RPAREN,
  [41047] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2078), 1,
      anon_sym_COMMA,
    ACTIONS(2080), 1,
      anon_sym_RPAREN,
    STATE(979), 1,
      aux_sym_array_repeat1,
  [41060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2082), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [41069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2084), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [41078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2086), 3,
      sym__newline,
      sym__body_end,
      anon_sym_SEMI,
  [41087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(572), 1,
      anon_sym_LPAREN,
    STATE(264), 1,
      sym_arguments,
  [41097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(404), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [41105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1473), 1,
      anon_sym_func,
    ACTIONS(2088), 1,
      anon_sym_var,
  [41115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [41123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(416), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [41131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      sym__identifier,
    STATE(1381), 1,
      sym_identifier,
  [41141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1126), 1,
      anon_sym_DOT,
    STATE(517), 1,
      aux_sym_attribute_repeat1,
  [41151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 1,
      anon_sym_if,
    ACTIONS(2090), 1,
      anon_sym_else,
  [41161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2092), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [41169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 1,
      anon_sym_if,
    ACTIONS(2094), 1,
      anon_sym_COLON,
  [41179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1663), 1,
      sym__identifier,
    STATE(1172), 1,
      sym_identifier,
  [41189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1098), 1,
      anon_sym_LPAREN,
    STATE(644), 1,
      sym_arguments,
  [41199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2096), 1,
      anon_sym_if,
    ACTIONS(2098), 1,
      anon_sym_RBRACK,
  [41209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    STATE(1007), 1,
      sym_parameters,
  [41219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    STATE(954), 1,
      sym_parameters,
  [41229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1657), 1,
      anon_sym_COLON,
    ACTIONS(2100), 1,
      anon_sym_DOT,
  [41239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1545), 1,
      sym__identifier,
    STATE(906), 1,
      sym_type,
  [41249] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2102), 1,
      sym__indent,
    STATE(197), 1,
      sym_match_body,
  [41259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2104), 1,
      anon_sym_COLON,
    ACTIONS(2106), 1,
      anon_sym_DASH_GT,
  [41269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    STATE(937), 1,
      sym_parameters,
  [41279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    STATE(1078), 1,
      sym_parameters,
  [41289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 1,
      anon_sym_if,
    ACTIONS(2108), 1,
      anon_sym_else,
  [41299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2096), 1,
      anon_sym_if,
    ACTIONS(2110), 1,
      anon_sym_RBRACK,
  [41309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1503), 1,
      anon_sym_COLON,
    ACTIONS(1961), 1,
      anon_sym_if,
  [41319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    STATE(1073), 1,
      sym_parameters,
  [41329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2112), 1,
      sym__identifier,
    STATE(1352), 1,
      sym_setter,
  [41339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2114), 1,
      sym__identifier,
    STATE(1345), 1,
      sym_getter,
  [41349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(941), 1,
      sym_string,
  [41359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 1,
      anon_sym_if,
    ACTIONS(2116), 1,
      anon_sym_COLON,
  [41369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    STATE(1062), 1,
      sym_parameters,
  [41379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2118), 1,
      sym__indent,
    STATE(167), 1,
      sym_match_body,
  [41389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2088), 1,
      anon_sym_var,
    ACTIONS(2120), 1,
      anon_sym_func,
  [41399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1465), 1,
      sym__identifier,
    STATE(587), 1,
      sym_identifier,
  [41409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 1,
      sym__identifier,
    STATE(1291), 1,
      sym_identifier,
  [41419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1322), 1,
      anon_sym_RPAREN,
    ACTIONS(2122), 1,
      anon_sym_if,
  [41429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1534), 1,
      sym__identifier,
    STATE(1373), 1,
      sym_type,
  [41439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(404), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [41447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1062), 1,
      anon_sym_DOT,
    STATE(486), 1,
      aux_sym_attribute_repeat1,
  [41457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2124), 1,
      sym__identifier,
    STATE(1024), 1,
      sym_name,
  [41467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1598), 1,
      anon_sym_LBRACE,
    STATE(157), 1,
      sym_enumerator_list,
  [41477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1031), 1,
      anon_sym_LPAREN,
    STATE(600), 1,
      sym_arguments,
  [41487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 1,
      anon_sym_if,
    ACTIONS(2126), 1,
      anon_sym_else,
  [41497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1717), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [41505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(937), 1,
      sym__string_start,
    STATE(703), 1,
      sym_string,
  [41515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2096), 1,
      anon_sym_if,
    ACTIONS(2128), 1,
      anon_sym_RBRACK,
  [41525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(653), 1,
      sym__string_start,
    STATE(543), 1,
      sym_string,
  [41535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    STATE(1359), 1,
      sym_parameters,
  [41545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1534), 1,
      sym__identifier,
    STATE(1312), 1,
      sym_type,
  [41555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(615), 1,
      anon_sym_DOT,
    STATE(216), 1,
      aux_sym_attribute_repeat1,
  [41565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(239), 1,
      sym_string,
  [41575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(400), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [41583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1534), 1,
      sym__identifier,
    STATE(1311), 1,
      sym_type,
  [41593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1031), 1,
      anon_sym_LPAREN,
    STATE(1283), 1,
      sym_arguments,
  [41603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1171), 1,
      anon_sym_LPAREN,
    STATE(717), 1,
      sym_arguments,
  [41613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      sym__identifier,
    STATE(778), 1,
      sym_identifier,
  [41623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2130), 1,
      sym__identifier,
    STATE(752), 1,
      sym_name,
  [41633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(408), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [41641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(420), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [41649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(400), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [41657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(416), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [41665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(412), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [41673] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(404), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [41681] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(408), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [41689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 1,
      anon_sym_if,
    ACTIONS(2132), 1,
      anon_sym_else,
  [41699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2096), 1,
      anon_sym_if,
    ACTIONS(2134), 1,
      anon_sym_RBRACK,
  [41709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(727), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [41717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      sym__identifier,
    STATE(1255), 1,
      sym_identifier,
  [41727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [41735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    STATE(1009), 1,
      sym_parameters,
  [41745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(556), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [41753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2136), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [41761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON,
    ACTIONS(2140), 1,
      anon_sym_EQ,
  [41771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      sym__identifier,
    STATE(231), 1,
      sym_identifier,
  [41781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2142), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [41789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2144), 1,
      sym__identifier,
    STATE(909), 1,
      sym_type,
  [41799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2146), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [41807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2148), 1,
      anon_sym_get,
    STATE(1343), 1,
      sym__get_assign,
  [41817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2142), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [41825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(823), 1,
      sym__string_start,
    STATE(540), 1,
      sym_string,
  [41835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    STATE(1065), 1,
      sym_parameters,
  [41845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2150), 1,
      sym__identifier,
    STATE(986), 1,
      sym_getter,
  [41855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      sym__identifier,
    STATE(824), 1,
      sym_identifier,
  [41865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2152), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [41873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 1,
      anon_sym_DOT,
    STATE(547), 1,
      aux_sym_attribute_repeat1,
  [41883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1724), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [41891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(420), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [41899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2152), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [41907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1559), 1,
      sym__identifier,
    STATE(786), 1,
      sym_name,
  [41917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1009), 1,
      anon_sym_LPAREN,
    STATE(552), 1,
      sym_arguments,
  [41927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [41935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2154), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [41943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1628), 1,
      sym__identifier,
    STATE(712), 1,
      sym_identifier,
  [41953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2156), 1,
      sym__identifier,
    STATE(1354), 1,
      sym_getter,
  [41963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      sym__identifier,
    STATE(1220), 1,
      sym_identifier,
  [41973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 1,
      anon_sym_if,
    ACTIONS(2158), 1,
      anon_sym_COLON,
  [41983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2160), 1,
      sym__identifier,
    STATE(1357), 1,
      sym_setter,
  [41993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1929), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [42001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      sym__identifier,
    STATE(611), 1,
      sym_identifier,
  [42011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 1,
      anon_sym_if,
    ACTIONS(2162), 1,
      anon_sym_else,
  [42021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2096), 1,
      anon_sym_if,
    ACTIONS(2164), 1,
      anon_sym_RBRACK,
  [42031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2130), 1,
      sym__identifier,
    STATE(750), 1,
      sym_name,
  [42041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2166), 2,
      sym__dedent,
      anon_sym_set,
  [42049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2168), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [42057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1779), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [42065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2088), 1,
      anon_sym_var,
    ACTIONS(2170), 1,
      anon_sym_func,
  [42075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 1,
      anon_sym_if,
    ACTIONS(2172), 1,
      anon_sym_COLON,
  [42085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    STATE(1036), 1,
      sym_parameters,
  [42095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    STATE(1038), 1,
      sym_parameters,
  [42105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2174), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [42113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(420), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [42121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      sym__identifier,
    STATE(1185), 1,
      sym_identifier,
  [42131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 1,
      anon_sym_if,
    ACTIONS(2176), 1,
      anon_sym_COLON,
  [42141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1320), 2,
      anon_sym_if,
      anon_sym_RPAREN,
  [42149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(993), 1,
      sym__string_start,
    STATE(685), 1,
      sym_string,
  [42159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(400), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [42167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2130), 1,
      sym__identifier,
    STATE(820), 1,
      sym_name,
  [42177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 1,
      anon_sym_if,
    ACTIONS(2178), 1,
      anon_sym_COLON,
  [42187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 1,
      sym__identifier,
    STATE(890), 1,
      sym_name,
  [42197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1064), 1,
      anon_sym_DOT,
    STATE(487), 1,
      aux_sym_attribute_repeat1,
  [42207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2182), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [42215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 1,
      sym__identifier,
    STATE(588), 1,
      sym_identifier,
  [42225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      sym__identifier,
    STATE(1097), 1,
      sym_identifier,
  [42235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      sym__identifier,
    STATE(1150), 1,
      sym_identifier,
  [42245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    STATE(671), 1,
      sym_arguments,
  [42255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1503), 1,
      anon_sym_RPAREN,
    ACTIONS(2122), 1,
      anon_sym_if,
  [42265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2184), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [42273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1424), 2,
      anon_sym_COLON,
      anon_sym_extends,
  [42281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2182), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [42289] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(590), 2,
      anon_sym_if,
      anon_sym_RPAREN,
  [42297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LBRACE,
    STATE(180), 1,
      sym_enumerator_list,
  [42307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      sym__identifier,
    STATE(1333), 1,
      sym_identifier,
  [42317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2184), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [42325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2186), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [42333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 1,
      anon_sym_if,
    ACTIONS(2188), 1,
      anon_sym_else,
  [42343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2096), 1,
      anon_sym_if,
    ACTIONS(2190), 1,
      anon_sym_RBRACK,
  [42353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(416), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [42361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2168), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [42369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 1,
      anon_sym_if,
    ACTIONS(2192), 1,
      anon_sym_COLON,
  [42379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2124), 1,
      sym__identifier,
    STATE(934), 1,
      sym_name,
  [42389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 1,
      anon_sym_if,
    ACTIONS(2194), 1,
      anon_sym_COLON,
  [42399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      sym__identifier,
    STATE(1108), 1,
      sym_identifier,
  [42409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1524), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [42417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(412), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [42425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1538), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [42433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(412), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [42441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1724), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [42449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1536), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [42457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1322), 1,
      anon_sym_RBRACK,
    ACTIONS(2096), 1,
      anon_sym_if,
  [42467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(967), 1,
      sym__string_start,
    STATE(605), 1,
      sym_string,
  [42477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(795), 1,
      sym__string_start,
    STATE(617), 1,
      sym_string,
  [42487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1547), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [42495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1534), 1,
      sym__identifier,
    STATE(1257), 1,
      sym_type,
  [42505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1534), 1,
      sym__identifier,
    STATE(1377), 1,
      sym_type,
  [42515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1062), 1,
      anon_sym_DOT,
    STATE(490), 1,
      aux_sym_attribute_repeat1,
  [42525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2136), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [42533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2196), 1,
      sym__identifier,
    STATE(1256), 1,
      sym_identifier,
  [42543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(408), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [42551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1547), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [42559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1092), 1,
      anon_sym_LPAREN,
    STATE(594), 1,
      sym_arguments,
  [42569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2146), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [42577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1517), 2,
      anon_sym_COLON,
      anon_sym_DOT,
  [42585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1534), 1,
      sym__identifier,
    STATE(1387), 1,
      sym_type,
  [42595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1663), 1,
      sym__identifier,
    STATE(659), 1,
      sym_identifier,
  [42605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1031), 1,
      anon_sym_LPAREN,
    STATE(1115), 1,
      sym_arguments,
  [42615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2198), 1,
      anon_sym_set,
    STATE(1337), 1,
      sym__set_assign,
  [42625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2168), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [42633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    STATE(1057), 1,
      sym_parameters,
  [42643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1900), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [42651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 1,
      anon_sym_if,
    ACTIONS(2200), 1,
      anon_sym_else,
  [42661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2096), 1,
      anon_sym_if,
    ACTIONS(2202), 1,
      anon_sym_RBRACK,
  [42671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1536), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [42679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1538), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [42687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2186), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [42695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    STATE(1045), 1,
      sym_parameters,
  [42705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1524), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [42713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2150), 1,
      sym__identifier,
    STATE(1011), 1,
      sym_getter,
  [42723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1547), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [42731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2186), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [42739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    STATE(1044), 1,
      sym_parameters,
  [42749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2136), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [42757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1626), 1,
      sym__identifier,
    STATE(678), 1,
      sym_identifier,
  [42767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1126), 1,
      anon_sym_DOT,
    STATE(527), 1,
      aux_sym_attribute_repeat1,
  [42777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2204), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [42785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_LPAREN,
    STATE(1043), 1,
      sym_parameters,
  [42795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 1,
      anon_sym_if,
    ACTIONS(2206), 1,
      anon_sym_COLON,
  [42805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2184), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [42813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2208), 1,
      anon_sym_COLON,
    ACTIONS(2210), 1,
      anon_sym_DASH_GT,
  [42823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2212), 2,
      sym__dedent,
      anon_sym_get,
  [42831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1320), 2,
      anon_sym_if,
      anon_sym_RBRACK,
  [42839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1536), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [42847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 1,
      anon_sym_DOT,
    STATE(574), 1,
      aux_sym_attribute_repeat1,
  [42857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1538), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [42865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2044), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [42873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 1,
      anon_sym_if,
    ACTIONS(2214), 1,
      anon_sym_COLON,
  [42883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2146), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [42891] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(615), 1,
      anon_sym_DOT,
    STATE(219), 1,
      aux_sym_attribute_repeat1,
  [42901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2142), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [42909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(590), 2,
      anon_sym_if,
      anon_sym_RBRACK,
  [42917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1194), 1,
      anon_sym_DOT,
    STATE(569), 1,
      aux_sym_attribute_repeat1,
  [42927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 1,
      anon_sym_if,
    ACTIONS(2216), 1,
      anon_sym_COLON,
  [42937] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2152), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [42945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1524), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [42953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_func,
    ACTIONS(2088), 1,
      anon_sym_var,
  [42963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [42971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1064), 1,
      anon_sym_DOT,
    STATE(530), 1,
      aux_sym_attribute_repeat1,
  [42981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    STATE(531), 1,
      aux_sym_attribute_repeat1,
  [42991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1194), 1,
      anon_sym_DOT,
    STATE(565), 1,
      aux_sym_attribute_repeat1,
  [43001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    STATE(471), 1,
      aux_sym_attribute_repeat1,
  [43011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      sym__identifier,
    STATE(1137), 1,
      sym_identifier,
  [43021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2182), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [43029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2220), 1,
      anon_sym_COLON,
  [43036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(416), 1,
      anon_sym_RPAREN,
  [43043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(412), 1,
      anon_sym_COLON,
  [43050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2170), 1,
      anon_sym_func,
  [43057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 1,
      anon_sym_COLON,
  [43064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2224), 1,
      anon_sym_COLON,
  [43071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(404), 1,
      anon_sym_COLON,
  [43078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 1,
      anon_sym_COLON,
  [43085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2228), 1,
      ts_builtin_sym_end,
  [43092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(400), 1,
      anon_sym_RPAREN,
  [43099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2088), 1,
      anon_sym_var,
  [43106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1924), 1,
      sym__dedent,
  [43113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(412), 1,
      anon_sym_RPAREN,
  [43120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1620), 1,
      sym__indent,
  [43127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1524), 1,
      anon_sym_RPAREN,
  [43134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(408), 1,
      anon_sym_COLON,
  [43141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1677), 1,
      sym__dedent,
  [43148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 1,
      anon_sym_COLON,
  [43155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(404), 1,
      anon_sym_RPAREN,
  [43162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1677), 1,
      anon_sym_COMMA,
  [43169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_RPAREN,
  [43176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1785), 1,
      anon_sym_COLON,
  [43183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 1,
      anon_sym_COLON,
  [43190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(420), 1,
      anon_sym_RPAREN,
  [43197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2236), 1,
      anon_sym_COLON,
  [43204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1499), 1,
      anon_sym_EQ,
  [43211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_in,
  [43218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2240), 1,
      anon_sym_COLON,
  [43225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1924), 1,
      anon_sym_COMMA,
  [43232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2242), 1,
      anon_sym_RPAREN,
  [43239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      sym__dedent,
  [43246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2246), 1,
      anon_sym_COLON,
  [43253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(416), 1,
      anon_sym_COLON,
  [43260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2248), 1,
      anon_sym_COLON,
  [43267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 1,
      anon_sym_EQ,
  [43274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2252), 1,
      anon_sym_COLON,
  [43281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2254), 1,
      sym__dedent,
  [43288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1524), 1,
      anon_sym_COLON,
  [43295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      sym__dedent,
  [43302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(408), 1,
      anon_sym_RPAREN,
  [43309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2258), 1,
      anon_sym_COLON,
  [43316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2260), 1,
      anon_sym_RPAREN,
  [43323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 1,
      anon_sym_COLON,
  [43330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2264), 1,
      anon_sym_COMMA,
  [43337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1547), 1,
      anon_sym_COLON,
  [43344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2266), 1,
      sym__dedent,
  [43351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2268), 1,
      anon_sym_EQ,
  [43358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_COMMA,
  [43365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2270), 1,
      anon_sym_COLON,
  [43372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2272), 1,
      anon_sym_COLON,
  [43379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2266), 1,
      anon_sym_COMMA,
  [43386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2274), 1,
      anon_sym_COLON,
  [43393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2276), 1,
      anon_sym_COLON,
  [43400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2278), 1,
      anon_sym_RPAREN,
  [43407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_COLON,
  [43414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2280), 1,
      anon_sym_COMMA,
  [43421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2282), 1,
      sym__dedent,
  [43428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(400), 1,
      anon_sym_COLON,
  [43435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2284), 1,
      anon_sym_COLON,
  [43442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(420), 1,
      anon_sym_COLON,
  [43449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2286), 1,
      anon_sym_COLON,
  [43456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2288), 1,
      sym__dedent,
  [43463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym_RPAREN,
  [43470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1538), 1,
      anon_sym_COLON,
  [43477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1536), 1,
      anon_sym_COLON,
  [43484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2292), 1,
      anon_sym_COLON,
  [43491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2294), 1,
      anon_sym_COLON,
  [43498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1547), 1,
      anon_sym_RPAREN,
  [43505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2296), 1,
      anon_sym_RPAREN,
  [43512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_COLON,
  [43519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2300), 1,
      anon_sym_COLON,
  [43526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1536), 1,
      anon_sym_RPAREN,
  [43533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2120), 1,
      anon_sym_func,
  [43540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2302), 1,
      anon_sym_COLON,
  [43547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2304), 1,
      anon_sym_in,
  [43554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_COLON,
  [43561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2308), 1,
      anon_sym_COLON,
  [43568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1538), 1,
      anon_sym_RPAREN,
  [43575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2310), 1,
      anon_sym_COLON,
  [43582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2312), 1,
      anon_sym_COLON,
  [43589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2314), 1,
      anon_sym_COLON,
  [43596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2316), 1,
      anon_sym_COLON,
  [43603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2318), 1,
      anon_sym_RPAREN,
  [43610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1657), 1,
      anon_sym_COLON,
  [43617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2320), 1,
      anon_sym_COLON,
  [43624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2322), 1,
      anon_sym_COLON,
  [43631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2324), 1,
      anon_sym_COLON,
  [43638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2326), 1,
      anon_sym_COLON,
  [43645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2328), 1,
      anon_sym_COLON,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(120)] = 0,
  [SMALL_STATE(121)] = 73,
  [SMALL_STATE(122)] = 146,
  [SMALL_STATE(123)] = 214,
  [SMALL_STATE(124)] = 286,
  [SMALL_STATE(125)] = 358,
  [SMALL_STATE(126)] = 425,
  [SMALL_STATE(127)] = 485,
  [SMALL_STATE(128)] = 545,
  [SMALL_STATE(129)] = 605,
  [SMALL_STATE(130)] = 665,
  [SMALL_STATE(131)] = 725,
  [SMALL_STATE(132)] = 785,
  [SMALL_STATE(133)] = 845,
  [SMALL_STATE(134)] = 905,
  [SMALL_STATE(135)] = 964,
  [SMALL_STATE(136)] = 1023,
  [SMALL_STATE(137)] = 1082,
  [SMALL_STATE(138)] = 1141,
  [SMALL_STATE(139)] = 1200,
  [SMALL_STATE(140)] = 1259,
  [SMALL_STATE(141)] = 1318,
  [SMALL_STATE(142)] = 1377,
  [SMALL_STATE(143)] = 1435,
  [SMALL_STATE(144)] = 1493,
  [SMALL_STATE(145)] = 1551,
  [SMALL_STATE(146)] = 1609,
  [SMALL_STATE(147)] = 1667,
  [SMALL_STATE(148)] = 1725,
  [SMALL_STATE(149)] = 1783,
  [SMALL_STATE(150)] = 1841,
  [SMALL_STATE(151)] = 1899,
  [SMALL_STATE(152)] = 1957,
  [SMALL_STATE(153)] = 2015,
  [SMALL_STATE(154)] = 2073,
  [SMALL_STATE(155)] = 2131,
  [SMALL_STATE(156)] = 2189,
  [SMALL_STATE(157)] = 2247,
  [SMALL_STATE(158)] = 2305,
  [SMALL_STATE(159)] = 2363,
  [SMALL_STATE(160)] = 2421,
  [SMALL_STATE(161)] = 2479,
  [SMALL_STATE(162)] = 2537,
  [SMALL_STATE(163)] = 2595,
  [SMALL_STATE(164)] = 2653,
  [SMALL_STATE(165)] = 2711,
  [SMALL_STATE(166)] = 2769,
  [SMALL_STATE(167)] = 2827,
  [SMALL_STATE(168)] = 2885,
  [SMALL_STATE(169)] = 2943,
  [SMALL_STATE(170)] = 3001,
  [SMALL_STATE(171)] = 3059,
  [SMALL_STATE(172)] = 3117,
  [SMALL_STATE(173)] = 3174,
  [SMALL_STATE(174)] = 3231,
  [SMALL_STATE(175)] = 3288,
  [SMALL_STATE(176)] = 3345,
  [SMALL_STATE(177)] = 3402,
  [SMALL_STATE(178)] = 3459,
  [SMALL_STATE(179)] = 3516,
  [SMALL_STATE(180)] = 3573,
  [SMALL_STATE(181)] = 3630,
  [SMALL_STATE(182)] = 3687,
  [SMALL_STATE(183)] = 3744,
  [SMALL_STATE(184)] = 3801,
  [SMALL_STATE(185)] = 3858,
  [SMALL_STATE(186)] = 3915,
  [SMALL_STATE(187)] = 3972,
  [SMALL_STATE(188)] = 4029,
  [SMALL_STATE(189)] = 4086,
  [SMALL_STATE(190)] = 4143,
  [SMALL_STATE(191)] = 4200,
  [SMALL_STATE(192)] = 4257,
  [SMALL_STATE(193)] = 4314,
  [SMALL_STATE(194)] = 4371,
  [SMALL_STATE(195)] = 4428,
  [SMALL_STATE(196)] = 4485,
  [SMALL_STATE(197)] = 4542,
  [SMALL_STATE(198)] = 4599,
  [SMALL_STATE(199)] = 4656,
  [SMALL_STATE(200)] = 4713,
  [SMALL_STATE(201)] = 4770,
  [SMALL_STATE(202)] = 4827,
  [SMALL_STATE(203)] = 4881,
  [SMALL_STATE(204)] = 4935,
  [SMALL_STATE(205)] = 4989,
  [SMALL_STATE(206)] = 5043,
  [SMALL_STATE(207)] = 5097,
  [SMALL_STATE(208)] = 5159,
  [SMALL_STATE(209)] = 5225,
  [SMALL_STATE(210)] = 5295,
  [SMALL_STATE(211)] = 5355,
  [SMALL_STATE(212)] = 5445,
  [SMALL_STATE(213)] = 5503,
  [SMALL_STATE(214)] = 5577,
  [SMALL_STATE(215)] = 5649,
  [SMALL_STATE(216)] = 5733,
  [SMALL_STATE(217)] = 5787,
  [SMALL_STATE(218)] = 5855,
  [SMALL_STATE(219)] = 5911,
  [SMALL_STATE(220)] = 5967,
  [SMALL_STATE(221)] = 6031,
  [SMALL_STATE(222)] = 6089,
  [SMALL_STATE(223)] = 6147,
  [SMALL_STATE(224)] = 6207,
  [SMALL_STATE(225)] = 6258,
  [SMALL_STATE(226)] = 6351,
  [SMALL_STATE(227)] = 6444,
  [SMALL_STATE(228)] = 6537,
  [SMALL_STATE(229)] = 6588,
  [SMALL_STATE(230)] = 6681,
  [SMALL_STATE(231)] = 6758,
  [SMALL_STATE(232)] = 6809,
  [SMALL_STATE(233)] = 6860,
  [SMALL_STATE(234)] = 6913,
  [SMALL_STATE(235)] = 6964,
  [SMALL_STATE(236)] = 7057,
  [SMALL_STATE(237)] = 7150,
  [SMALL_STATE(238)] = 7201,
  [SMALL_STATE(239)] = 7252,
  [SMALL_STATE(240)] = 7303,
  [SMALL_STATE(241)] = 7354,
  [SMALL_STATE(242)] = 7447,
  [SMALL_STATE(243)] = 7540,
  [SMALL_STATE(244)] = 7633,
  [SMALL_STATE(245)] = 7726,
  [SMALL_STATE(246)] = 7777,
  [SMALL_STATE(247)] = 7870,
  [SMALL_STATE(248)] = 7921,
  [SMALL_STATE(249)] = 7972,
  [SMALL_STATE(250)] = 8023,
  [SMALL_STATE(251)] = 8074,
  [SMALL_STATE(252)] = 8125,
  [SMALL_STATE(253)] = 8218,
  [SMALL_STATE(254)] = 8311,
  [SMALL_STATE(255)] = 8362,
  [SMALL_STATE(256)] = 8455,
  [SMALL_STATE(257)] = 8506,
  [SMALL_STATE(258)] = 8599,
  [SMALL_STATE(259)] = 8650,
  [SMALL_STATE(260)] = 8743,
  [SMALL_STATE(261)] = 8836,
  [SMALL_STATE(262)] = 8929,
  [SMALL_STATE(263)] = 8980,
  [SMALL_STATE(264)] = 9073,
  [SMALL_STATE(265)] = 9124,
  [SMALL_STATE(266)] = 9217,
  [SMALL_STATE(267)] = 9310,
  [SMALL_STATE(268)] = 9398,
  [SMALL_STATE(269)] = 9486,
  [SMALL_STATE(270)] = 9574,
  [SMALL_STATE(271)] = 9662,
  [SMALL_STATE(272)] = 9750,
  [SMALL_STATE(273)] = 9838,
  [SMALL_STATE(274)] = 9926,
  [SMALL_STATE(275)] = 10014,
  [SMALL_STATE(276)] = 10104,
  [SMALL_STATE(277)] = 10192,
  [SMALL_STATE(278)] = 10280,
  [SMALL_STATE(279)] = 10368,
  [SMALL_STATE(280)] = 10456,
  [SMALL_STATE(281)] = 10544,
  [SMALL_STATE(282)] = 10632,
  [SMALL_STATE(283)] = 10720,
  [SMALL_STATE(284)] = 10808,
  [SMALL_STATE(285)] = 10896,
  [SMALL_STATE(286)] = 10984,
  [SMALL_STATE(287)] = 11072,
  [SMALL_STATE(288)] = 11160,
  [SMALL_STATE(289)] = 11248,
  [SMALL_STATE(290)] = 11336,
  [SMALL_STATE(291)] = 11424,
  [SMALL_STATE(292)] = 11512,
  [SMALL_STATE(293)] = 11600,
  [SMALL_STATE(294)] = 11688,
  [SMALL_STATE(295)] = 11776,
  [SMALL_STATE(296)] = 11864,
  [SMALL_STATE(297)] = 11952,
  [SMALL_STATE(298)] = 12040,
  [SMALL_STATE(299)] = 12128,
  [SMALL_STATE(300)] = 12216,
  [SMALL_STATE(301)] = 12304,
  [SMALL_STATE(302)] = 12392,
  [SMALL_STATE(303)] = 12480,
  [SMALL_STATE(304)] = 12568,
  [SMALL_STATE(305)] = 12656,
  [SMALL_STATE(306)] = 12744,
  [SMALL_STATE(307)] = 12832,
  [SMALL_STATE(308)] = 12920,
  [SMALL_STATE(309)] = 13008,
  [SMALL_STATE(310)] = 13096,
  [SMALL_STATE(311)] = 13183,
  [SMALL_STATE(312)] = 13270,
  [SMALL_STATE(313)] = 13355,
  [SMALL_STATE(314)] = 13440,
  [SMALL_STATE(315)] = 13525,
  [SMALL_STATE(316)] = 13610,
  [SMALL_STATE(317)] = 13695,
  [SMALL_STATE(318)] = 13780,
  [SMALL_STATE(319)] = 13865,
  [SMALL_STATE(320)] = 13950,
  [SMALL_STATE(321)] = 14035,
  [SMALL_STATE(322)] = 14120,
  [SMALL_STATE(323)] = 14205,
  [SMALL_STATE(324)] = 14290,
  [SMALL_STATE(325)] = 14375,
  [SMALL_STATE(326)] = 14460,
  [SMALL_STATE(327)] = 14547,
  [SMALL_STATE(328)] = 14632,
  [SMALL_STATE(329)] = 14717,
  [SMALL_STATE(330)] = 14802,
  [SMALL_STATE(331)] = 14850,
  [SMALL_STATE(332)] = 14898,
  [SMALL_STATE(333)] = 14982,
  [SMALL_STATE(334)] = 15030,
  [SMALL_STATE(335)] = 15078,
  [SMALL_STATE(336)] = 15156,
  [SMALL_STATE(337)] = 15234,
  [SMALL_STATE(338)] = 15312,
  [SMALL_STATE(339)] = 15390,
  [SMALL_STATE(340)] = 15468,
  [SMALL_STATE(341)] = 15546,
  [SMALL_STATE(342)] = 15624,
  [SMALL_STATE(343)] = 15702,
  [SMALL_STATE(344)] = 15780,
  [SMALL_STATE(345)] = 15858,
  [SMALL_STATE(346)] = 15936,
  [SMALL_STATE(347)] = 16014,
  [SMALL_STATE(348)] = 16092,
  [SMALL_STATE(349)] = 16170,
  [SMALL_STATE(350)] = 16248,
  [SMALL_STATE(351)] = 16326,
  [SMALL_STATE(352)] = 16404,
  [SMALL_STATE(353)] = 16482,
  [SMALL_STATE(354)] = 16560,
  [SMALL_STATE(355)] = 16638,
  [SMALL_STATE(356)] = 16716,
  [SMALL_STATE(357)] = 16794,
  [SMALL_STATE(358)] = 16872,
  [SMALL_STATE(359)] = 16950,
  [SMALL_STATE(360)] = 17028,
  [SMALL_STATE(361)] = 17106,
  [SMALL_STATE(362)] = 17184,
  [SMALL_STATE(363)] = 17262,
  [SMALL_STATE(364)] = 17340,
  [SMALL_STATE(365)] = 17418,
  [SMALL_STATE(366)] = 17496,
  [SMALL_STATE(367)] = 17574,
  [SMALL_STATE(368)] = 17652,
  [SMALL_STATE(369)] = 17730,
  [SMALL_STATE(370)] = 17808,
  [SMALL_STATE(371)] = 17886,
  [SMALL_STATE(372)] = 17964,
  [SMALL_STATE(373)] = 18042,
  [SMALL_STATE(374)] = 18118,
  [SMALL_STATE(375)] = 18185,
  [SMALL_STATE(376)] = 18252,
  [SMALL_STATE(377)] = 18319,
  [SMALL_STATE(378)] = 18386,
  [SMALL_STATE(379)] = 18453,
  [SMALL_STATE(380)] = 18520,
  [SMALL_STATE(381)] = 18587,
  [SMALL_STATE(382)] = 18654,
  [SMALL_STATE(383)] = 18721,
  [SMALL_STATE(384)] = 18788,
  [SMALL_STATE(385)] = 18855,
  [SMALL_STATE(386)] = 18922,
  [SMALL_STATE(387)] = 18989,
  [SMALL_STATE(388)] = 19056,
  [SMALL_STATE(389)] = 19123,
  [SMALL_STATE(390)] = 19190,
  [SMALL_STATE(391)] = 19257,
  [SMALL_STATE(392)] = 19324,
  [SMALL_STATE(393)] = 19391,
  [SMALL_STATE(394)] = 19458,
  [SMALL_STATE(395)] = 19525,
  [SMALL_STATE(396)] = 19592,
  [SMALL_STATE(397)] = 19659,
  [SMALL_STATE(398)] = 19726,
  [SMALL_STATE(399)] = 19793,
  [SMALL_STATE(400)] = 19860,
  [SMALL_STATE(401)] = 19927,
  [SMALL_STATE(402)] = 19994,
  [SMALL_STATE(403)] = 20061,
  [SMALL_STATE(404)] = 20128,
  [SMALL_STATE(405)] = 20195,
  [SMALL_STATE(406)] = 20262,
  [SMALL_STATE(407)] = 20329,
  [SMALL_STATE(408)] = 20396,
  [SMALL_STATE(409)] = 20463,
  [SMALL_STATE(410)] = 20530,
  [SMALL_STATE(411)] = 20597,
  [SMALL_STATE(412)] = 20664,
  [SMALL_STATE(413)] = 20731,
  [SMALL_STATE(414)] = 20798,
  [SMALL_STATE(415)] = 20865,
  [SMALL_STATE(416)] = 20932,
  [SMALL_STATE(417)] = 20999,
  [SMALL_STATE(418)] = 21066,
  [SMALL_STATE(419)] = 21133,
  [SMALL_STATE(420)] = 21200,
  [SMALL_STATE(421)] = 21267,
  [SMALL_STATE(422)] = 21334,
  [SMALL_STATE(423)] = 21401,
  [SMALL_STATE(424)] = 21468,
  [SMALL_STATE(425)] = 21535,
  [SMALL_STATE(426)] = 21602,
  [SMALL_STATE(427)] = 21669,
  [SMALL_STATE(428)] = 21736,
  [SMALL_STATE(429)] = 21803,
  [SMALL_STATE(430)] = 21870,
  [SMALL_STATE(431)] = 21937,
  [SMALL_STATE(432)] = 22004,
  [SMALL_STATE(433)] = 22071,
  [SMALL_STATE(434)] = 22138,
  [SMALL_STATE(435)] = 22205,
  [SMALL_STATE(436)] = 22272,
  [SMALL_STATE(437)] = 22339,
  [SMALL_STATE(438)] = 22406,
  [SMALL_STATE(439)] = 22473,
  [SMALL_STATE(440)] = 22540,
  [SMALL_STATE(441)] = 22607,
  [SMALL_STATE(442)] = 22674,
  [SMALL_STATE(443)] = 22741,
  [SMALL_STATE(444)] = 22808,
  [SMALL_STATE(445)] = 22875,
  [SMALL_STATE(446)] = 22942,
  [SMALL_STATE(447)] = 23009,
  [SMALL_STATE(448)] = 23076,
  [SMALL_STATE(449)] = 23117,
  [SMALL_STATE(450)] = 23184,
  [SMALL_STATE(451)] = 23251,
  [SMALL_STATE(452)] = 23318,
  [SMALL_STATE(453)] = 23385,
  [SMALL_STATE(454)] = 23452,
  [SMALL_STATE(455)] = 23519,
  [SMALL_STATE(456)] = 23586,
  [SMALL_STATE(457)] = 23653,
  [SMALL_STATE(458)] = 23720,
  [SMALL_STATE(459)] = 23787,
  [SMALL_STATE(460)] = 23854,
  [SMALL_STATE(461)] = 23921,
  [SMALL_STATE(462)] = 23988,
  [SMALL_STATE(463)] = 24055,
  [SMALL_STATE(464)] = 24122,
  [SMALL_STATE(465)] = 24189,
  [SMALL_STATE(466)] = 24256,
  [SMALL_STATE(467)] = 24295,
  [SMALL_STATE(468)] = 24349,
  [SMALL_STATE(469)] = 24417,
  [SMALL_STATE(470)] = 24463,
  [SMALL_STATE(471)] = 24509,
  [SMALL_STATE(472)] = 24549,
  [SMALL_STATE(473)] = 24617,
  [SMALL_STATE(474)] = 24661,
  [SMALL_STATE(475)] = 24719,
  [SMALL_STATE(476)] = 24779,
  [SMALL_STATE(477)] = 24827,
  [SMALL_STATE(478)] = 24873,
  [SMALL_STATE(479)] = 24929,
  [SMALL_STATE(480)] = 24981,
  [SMALL_STATE(481)] = 25031,
  [SMALL_STATE(482)] = 25075,
  [SMALL_STATE(483)] = 25119,
  [SMALL_STATE(484)] = 25161,
  [SMALL_STATE(485)] = 25205,
  [SMALL_STATE(486)] = 25243,
  [SMALL_STATE(487)] = 25285,
  [SMALL_STATE(488)] = 25327,
  [SMALL_STATE(489)] = 25395,
  [SMALL_STATE(490)] = 25441,
  [SMALL_STATE(491)] = 25481,
  [SMALL_STATE(492)] = 25535,
  [SMALL_STATE(493)] = 25579,
  [SMALL_STATE(494)] = 25621,
  [SMALL_STATE(495)] = 25665,
  [SMALL_STATE(496)] = 25709,
  [SMALL_STATE(497)] = 25759,
  [SMALL_STATE(498)] = 25811,
  [SMALL_STATE(499)] = 25867,
  [SMALL_STATE(500)] = 25925,
  [SMALL_STATE(501)] = 25971,
  [SMALL_STATE(502)] = 26019,
  [SMALL_STATE(503)] = 26073,
  [SMALL_STATE(504)] = 26133,
  [SMALL_STATE(505)] = 26191,
  [SMALL_STATE(506)] = 26251,
  [SMALL_STATE(507)] = 26299,
  [SMALL_STATE(508)] = 26345,
  [SMALL_STATE(509)] = 26401,
  [SMALL_STATE(510)] = 26453,
  [SMALL_STATE(511)] = 26503,
  [SMALL_STATE(512)] = 26547,
  [SMALL_STATE(513)] = 26605,
  [SMALL_STATE(514)] = 26659,
  [SMALL_STATE(515)] = 26703,
  [SMALL_STATE(516)] = 26763,
  [SMALL_STATE(517)] = 26805,
  [SMALL_STATE(518)] = 26847,
  [SMALL_STATE(519)] = 26895,
  [SMALL_STATE(520)] = 26941,
  [SMALL_STATE(521)] = 26997,
  [SMALL_STATE(522)] = 27049,
  [SMALL_STATE(523)] = 27099,
  [SMALL_STATE(524)] = 27143,
  [SMALL_STATE(525)] = 27187,
  [SMALL_STATE(526)] = 27229,
  [SMALL_STATE(527)] = 27273,
  [SMALL_STATE(528)] = 27313,
  [SMALL_STATE(529)] = 27359,
  [SMALL_STATE(530)] = 27427,
  [SMALL_STATE(531)] = 27467,
  [SMALL_STATE(532)] = 27509,
  [SMALL_STATE(533)] = 27568,
  [SMALL_STATE(534)] = 27631,
  [SMALL_STATE(535)] = 27668,
  [SMALL_STATE(536)] = 27705,
  [SMALL_STATE(537)] = 27742,
  [SMALL_STATE(538)] = 27781,
  [SMALL_STATE(539)] = 27818,
  [SMALL_STATE(540)] = 27855,
  [SMALL_STATE(541)] = 27892,
  [SMALL_STATE(542)] = 27929,
  [SMALL_STATE(543)] = 27966,
  [SMALL_STATE(544)] = 28003,
  [SMALL_STATE(545)] = 28040,
  [SMALL_STATE(546)] = 28077,
  [SMALL_STATE(547)] = 28118,
  [SMALL_STATE(548)] = 28159,
  [SMALL_STATE(549)] = 28196,
  [SMALL_STATE(550)] = 28233,
  [SMALL_STATE(551)] = 28276,
  [SMALL_STATE(552)] = 28313,
  [SMALL_STATE(553)] = 28350,
  [SMALL_STATE(554)] = 28391,
  [SMALL_STATE(555)] = 28434,
  [SMALL_STATE(556)] = 28477,
  [SMALL_STATE(557)] = 28526,
  [SMALL_STATE(558)] = 28563,
  [SMALL_STATE(559)] = 28614,
  [SMALL_STATE(560)] = 28669,
  [SMALL_STATE(561)] = 28706,
  [SMALL_STATE(562)] = 28751,
  [SMALL_STATE(563)] = 28798,
  [SMALL_STATE(564)] = 28857,
  [SMALL_STATE(565)] = 28914,
  [SMALL_STATE(566)] = 28953,
  [SMALL_STATE(567)] = 29006,
  [SMALL_STATE(568)] = 29043,
  [SMALL_STATE(569)] = 29080,
  [SMALL_STATE(570)] = 29121,
  [SMALL_STATE(571)] = 29158,
  [SMALL_STATE(572)] = 29195,
  [SMALL_STATE(573)] = 29258,
  [SMALL_STATE(574)] = 29297,
  [SMALL_STATE(575)] = 29336,
  [SMALL_STATE(576)] = 29373,
  [SMALL_STATE(577)] = 29410,
  [SMALL_STATE(578)] = 29447,
  [SMALL_STATE(579)] = 29484,
  [SMALL_STATE(580)] = 29521,
  [SMALL_STATE(581)] = 29558,
  [SMALL_STATE(582)] = 29595,
  [SMALL_STATE(583)] = 29632,
  [SMALL_STATE(584)] = 29669,
  [SMALL_STATE(585)] = 29706,
  [SMALL_STATE(586)] = 29743,
  [SMALL_STATE(587)] = 29780,
  [SMALL_STATE(588)] = 29817,
  [SMALL_STATE(589)] = 29854,
  [SMALL_STATE(590)] = 29891,
  [SMALL_STATE(591)] = 29954,
  [SMALL_STATE(592)] = 29991,
  [SMALL_STATE(593)] = 30028,
  [SMALL_STATE(594)] = 30065,
  [SMALL_STATE(595)] = 30102,
  [SMALL_STATE(596)] = 30139,
  [SMALL_STATE(597)] = 30176,
  [SMALL_STATE(598)] = 30213,
  [SMALL_STATE(599)] = 30250,
  [SMALL_STATE(600)] = 30287,
  [SMALL_STATE(601)] = 30324,
  [SMALL_STATE(602)] = 30361,
  [SMALL_STATE(603)] = 30406,
  [SMALL_STATE(604)] = 30443,
  [SMALL_STATE(605)] = 30480,
  [SMALL_STATE(606)] = 30517,
  [SMALL_STATE(607)] = 30554,
  [SMALL_STATE(608)] = 30591,
  [SMALL_STATE(609)] = 30628,
  [SMALL_STATE(610)] = 30665,
  [SMALL_STATE(611)] = 30704,
  [SMALL_STATE(612)] = 30741,
  [SMALL_STATE(613)] = 30780,
  [SMALL_STATE(614)] = 30817,
  [SMALL_STATE(615)] = 30854,
  [SMALL_STATE(616)] = 30891,
  [SMALL_STATE(617)] = 30928,
  [SMALL_STATE(618)] = 30965,
  [SMALL_STATE(619)] = 31002,
  [SMALL_STATE(620)] = 31069,
  [SMALL_STATE(621)] = 31106,
  [SMALL_STATE(622)] = 31143,
  [SMALL_STATE(623)] = 31180,
  [SMALL_STATE(624)] = 31217,
  [SMALL_STATE(625)] = 31254,
  [SMALL_STATE(626)] = 31291,
  [SMALL_STATE(627)] = 31328,
  [SMALL_STATE(628)] = 31365,
  [SMALL_STATE(629)] = 31408,
  [SMALL_STATE(630)] = 31445,
  [SMALL_STATE(631)] = 31512,
  [SMALL_STATE(632)] = 31549,
  [SMALL_STATE(633)] = 31590,
  [SMALL_STATE(634)] = 31635,
  [SMALL_STATE(635)] = 31678,
  [SMALL_STATE(636)] = 31715,
  [SMALL_STATE(637)] = 31752,
  [SMALL_STATE(638)] = 31789,
  [SMALL_STATE(639)] = 31826,
  [SMALL_STATE(640)] = 31869,
  [SMALL_STATE(641)] = 31906,
  [SMALL_STATE(642)] = 31943,
  [SMALL_STATE(643)] = 31980,
  [SMALL_STATE(644)] = 32029,
  [SMALL_STATE(645)] = 32066,
  [SMALL_STATE(646)] = 32103,
  [SMALL_STATE(647)] = 32140,
  [SMALL_STATE(648)] = 32191,
  [SMALL_STATE(649)] = 32228,
  [SMALL_STATE(650)] = 32265,
  [SMALL_STATE(651)] = 32328,
  [SMALL_STATE(652)] = 32365,
  [SMALL_STATE(653)] = 32420,
  [SMALL_STATE(654)] = 32457,
  [SMALL_STATE(655)] = 32502,
  [SMALL_STATE(656)] = 32539,
  [SMALL_STATE(657)] = 32576,
  [SMALL_STATE(658)] = 32613,
  [SMALL_STATE(659)] = 32660,
  [SMALL_STATE(660)] = 32697,
  [SMALL_STATE(661)] = 32734,
  [SMALL_STATE(662)] = 32791,
  [SMALL_STATE(663)] = 32828,
  [SMALL_STATE(664)] = 32865,
  [SMALL_STATE(665)] = 32918,
  [SMALL_STATE(666)] = 32955,
  [SMALL_STATE(667)] = 32991,
  [SMALL_STATE(668)] = 33027,
  [SMALL_STATE(669)] = 33089,
  [SMALL_STATE(670)] = 33125,
  [SMALL_STATE(671)] = 33161,
  [SMALL_STATE(672)] = 33197,
  [SMALL_STATE(673)] = 33233,
  [SMALL_STATE(674)] = 33269,
  [SMALL_STATE(675)] = 33305,
  [SMALL_STATE(676)] = 33341,
  [SMALL_STATE(677)] = 33377,
  [SMALL_STATE(678)] = 33413,
  [SMALL_STATE(679)] = 33449,
  [SMALL_STATE(680)] = 33485,
  [SMALL_STATE(681)] = 33521,
  [SMALL_STATE(682)] = 33557,
  [SMALL_STATE(683)] = 33593,
  [SMALL_STATE(684)] = 33629,
  [SMALL_STATE(685)] = 33665,
  [SMALL_STATE(686)] = 33701,
  [SMALL_STATE(687)] = 33737,
  [SMALL_STATE(688)] = 33773,
  [SMALL_STATE(689)] = 33809,
  [SMALL_STATE(690)] = 33845,
  [SMALL_STATE(691)] = 33881,
  [SMALL_STATE(692)] = 33919,
  [SMALL_STATE(693)] = 33955,
  [SMALL_STATE(694)] = 33991,
  [SMALL_STATE(695)] = 34027,
  [SMALL_STATE(696)] = 34063,
  [SMALL_STATE(697)] = 34101,
  [SMALL_STATE(698)] = 34137,
  [SMALL_STATE(699)] = 34173,
  [SMALL_STATE(700)] = 34209,
  [SMALL_STATE(701)] = 34245,
  [SMALL_STATE(702)] = 34281,
  [SMALL_STATE(703)] = 34317,
  [SMALL_STATE(704)] = 34353,
  [SMALL_STATE(705)] = 34389,
  [SMALL_STATE(706)] = 34425,
  [SMALL_STATE(707)] = 34461,
  [SMALL_STATE(708)] = 34497,
  [SMALL_STATE(709)] = 34533,
  [SMALL_STATE(710)] = 34569,
  [SMALL_STATE(711)] = 34605,
  [SMALL_STATE(712)] = 34641,
  [SMALL_STATE(713)] = 34677,
  [SMALL_STATE(714)] = 34739,
  [SMALL_STATE(715)] = 34775,
  [SMALL_STATE(716)] = 34811,
  [SMALL_STATE(717)] = 34847,
  [SMALL_STATE(718)] = 34883,
  [SMALL_STATE(719)] = 34919,
  [SMALL_STATE(720)] = 34955,
  [SMALL_STATE(721)] = 34995,
  [SMALL_STATE(722)] = 35035,
  [SMALL_STATE(723)] = 35064,
  [SMALL_STATE(724)] = 35093,
  [SMALL_STATE(725)] = 35126,
  [SMALL_STATE(726)] = 35172,
  [SMALL_STATE(727)] = 35224,
  [SMALL_STATE(728)] = 35270,
  [SMALL_STATE(729)] = 35322,
  [SMALL_STATE(730)] = 35374,
  [SMALL_STATE(731)] = 35426,
  [SMALL_STATE(732)] = 35478,
  [SMALL_STATE(733)] = 35524,
  [SMALL_STATE(734)] = 35576,
  [SMALL_STATE(735)] = 35628,
  [SMALL_STATE(736)] = 35658,
  [SMALL_STATE(737)] = 35707,
  [SMALL_STATE(738)] = 35750,
  [SMALL_STATE(739)] = 35795,
  [SMALL_STATE(740)] = 35838,
  [SMALL_STATE(741)] = 35883,
  [SMALL_STATE(742)] = 35928,
  [SMALL_STATE(743)] = 35970,
  [SMALL_STATE(744)] = 35993,
  [SMALL_STATE(745)] = 36016,
  [SMALL_STATE(746)] = 36055,
  [SMALL_STATE(747)] = 36080,
  [SMALL_STATE(748)] = 36119,
  [SMALL_STATE(749)] = 36161,
  [SMALL_STATE(750)] = 36188,
  [SMALL_STATE(751)] = 36230,
  [SMALL_STATE(752)] = 36266,
  [SMALL_STATE(753)] = 36308,
  [SMALL_STATE(754)] = 36332,
  [SMALL_STATE(755)] = 36356,
  [SMALL_STATE(756)] = 36376,
  [SMALL_STATE(757)] = 36396,
  [SMALL_STATE(758)] = 36416,
  [SMALL_STATE(759)] = 36440,
  [SMALL_STATE(760)] = 36460,
  [SMALL_STATE(761)] = 36484,
  [SMALL_STATE(762)] = 36504,
  [SMALL_STATE(763)] = 36528,
  [SMALL_STATE(764)] = 36552,
  [SMALL_STATE(765)] = 36572,
  [SMALL_STATE(766)] = 36592,
  [SMALL_STATE(767)] = 36616,
  [SMALL_STATE(768)] = 36636,
  [SMALL_STATE(769)] = 36660,
  [SMALL_STATE(770)] = 36683,
  [SMALL_STATE(771)] = 36706,
  [SMALL_STATE(772)] = 36729,
  [SMALL_STATE(773)] = 36752,
  [SMALL_STATE(774)] = 36777,
  [SMALL_STATE(775)] = 36802,
  [SMALL_STATE(776)] = 36826,
  [SMALL_STATE(777)] = 36842,
  [SMALL_STATE(778)] = 36860,
  [SMALL_STATE(779)] = 36878,
  [SMALL_STATE(780)] = 36902,
  [SMALL_STATE(781)] = 36926,
  [SMALL_STATE(782)] = 36950,
  [SMALL_STATE(783)] = 36974,
  [SMALL_STATE(784)] = 36998,
  [SMALL_STATE(785)] = 37022,
  [SMALL_STATE(786)] = 37046,
  [SMALL_STATE(787)] = 37071,
  [SMALL_STATE(788)] = 37092,
  [SMALL_STATE(789)] = 37113,
  [SMALL_STATE(790)] = 37136,
  [SMALL_STATE(791)] = 37157,
  [SMALL_STATE(792)] = 37180,
  [SMALL_STATE(793)] = 37201,
  [SMALL_STATE(794)] = 37214,
  [SMALL_STATE(795)] = 37233,
  [SMALL_STATE(796)] = 37254,
  [SMALL_STATE(797)] = 37275,
  [SMALL_STATE(798)] = 37296,
  [SMALL_STATE(799)] = 37317,
  [SMALL_STATE(800)] = 37338,
  [SMALL_STATE(801)] = 37359,
  [SMALL_STATE(802)] = 37380,
  [SMALL_STATE(803)] = 37401,
  [SMALL_STATE(804)] = 37421,
  [SMALL_STATE(805)] = 37439,
  [SMALL_STATE(806)] = 37459,
  [SMALL_STATE(807)] = 37473,
  [SMALL_STATE(808)] = 37485,
  [SMALL_STATE(809)] = 37505,
  [SMALL_STATE(810)] = 37525,
  [SMALL_STATE(811)] = 37539,
  [SMALL_STATE(812)] = 37561,
  [SMALL_STATE(813)] = 37580,
  [SMALL_STATE(814)] = 37593,
  [SMALL_STATE(815)] = 37604,
  [SMALL_STATE(816)] = 37621,
  [SMALL_STATE(817)] = 37636,
  [SMALL_STATE(818)] = 37655,
  [SMALL_STATE(819)] = 37666,
  [SMALL_STATE(820)] = 37681,
  [SMALL_STATE(821)] = 37696,
  [SMALL_STATE(822)] = 37715,
  [SMALL_STATE(823)] = 37726,
  [SMALL_STATE(824)] = 37737,
  [SMALL_STATE(825)] = 37752,
  [SMALL_STATE(826)] = 37763,
  [SMALL_STATE(827)] = 37774,
  [SMALL_STATE(828)] = 37785,
  [SMALL_STATE(829)] = 37800,
  [SMALL_STATE(830)] = 37811,
  [SMALL_STATE(831)] = 37826,
  [SMALL_STATE(832)] = 37845,
  [SMALL_STATE(833)] = 37862,
  [SMALL_STATE(834)] = 37877,
  [SMALL_STATE(835)] = 37888,
  [SMALL_STATE(836)] = 37899,
  [SMALL_STATE(837)] = 37910,
  [SMALL_STATE(838)] = 37921,
  [SMALL_STATE(839)] = 37932,
  [SMALL_STATE(840)] = 37943,
  [SMALL_STATE(841)] = 37957,
  [SMALL_STATE(842)] = 37971,
  [SMALL_STATE(843)] = 37985,
  [SMALL_STATE(844)] = 38001,
  [SMALL_STATE(845)] = 38015,
  [SMALL_STATE(846)] = 38029,
  [SMALL_STATE(847)] = 38043,
  [SMALL_STATE(848)] = 38057,
  [SMALL_STATE(849)] = 38073,
  [SMALL_STATE(850)] = 38089,
  [SMALL_STATE(851)] = 38105,
  [SMALL_STATE(852)] = 38121,
  [SMALL_STATE(853)] = 38133,
  [SMALL_STATE(854)] = 38149,
  [SMALL_STATE(855)] = 38163,
  [SMALL_STATE(856)] = 38179,
  [SMALL_STATE(857)] = 38195,
  [SMALL_STATE(858)] = 38209,
  [SMALL_STATE(859)] = 38223,
  [SMALL_STATE(860)] = 38237,
  [SMALL_STATE(861)] = 38253,
  [SMALL_STATE(862)] = 38267,
  [SMALL_STATE(863)] = 38281,
  [SMALL_STATE(864)] = 38297,
  [SMALL_STATE(865)] = 38311,
  [SMALL_STATE(866)] = 38325,
  [SMALL_STATE(867)] = 38339,
  [SMALL_STATE(868)] = 38353,
  [SMALL_STATE(869)] = 38369,
  [SMALL_STATE(870)] = 38383,
  [SMALL_STATE(871)] = 38399,
  [SMALL_STATE(872)] = 38413,
  [SMALL_STATE(873)] = 38427,
  [SMALL_STATE(874)] = 38441,
  [SMALL_STATE(875)] = 38455,
  [SMALL_STATE(876)] = 38469,
  [SMALL_STATE(877)] = 38483,
  [SMALL_STATE(878)] = 38499,
  [SMALL_STATE(879)] = 38513,
  [SMALL_STATE(880)] = 38527,
  [SMALL_STATE(881)] = 38541,
  [SMALL_STATE(882)] = 38557,
  [SMALL_STATE(883)] = 38571,
  [SMALL_STATE(884)] = 38585,
  [SMALL_STATE(885)] = 38599,
  [SMALL_STATE(886)] = 38613,
  [SMALL_STATE(887)] = 38627,
  [SMALL_STATE(888)] = 38641,
  [SMALL_STATE(889)] = 38655,
  [SMALL_STATE(890)] = 38671,
  [SMALL_STATE(891)] = 38683,
  [SMALL_STATE(892)] = 38697,
  [SMALL_STATE(893)] = 38711,
  [SMALL_STATE(894)] = 38725,
  [SMALL_STATE(895)] = 38737,
  [SMALL_STATE(896)] = 38751,
  [SMALL_STATE(897)] = 38765,
  [SMALL_STATE(898)] = 38781,
  [SMALL_STATE(899)] = 38791,
  [SMALL_STATE(900)] = 38805,
  [SMALL_STATE(901)] = 38819,
  [SMALL_STATE(902)] = 38833,
  [SMALL_STATE(903)] = 38847,
  [SMALL_STATE(904)] = 38861,
  [SMALL_STATE(905)] = 38871,
  [SMALL_STATE(906)] = 38887,
  [SMALL_STATE(907)] = 38897,
  [SMALL_STATE(908)] = 38911,
  [SMALL_STATE(909)] = 38925,
  [SMALL_STATE(910)] = 38936,
  [SMALL_STATE(911)] = 38949,
  [SMALL_STATE(912)] = 38962,
  [SMALL_STATE(913)] = 38975,
  [SMALL_STATE(914)] = 38984,
  [SMALL_STATE(915)] = 38993,
  [SMALL_STATE(916)] = 39006,
  [SMALL_STATE(917)] = 39015,
  [SMALL_STATE(918)] = 39028,
  [SMALL_STATE(919)] = 39041,
  [SMALL_STATE(920)] = 39054,
  [SMALL_STATE(921)] = 39067,
  [SMALL_STATE(922)] = 39076,
  [SMALL_STATE(923)] = 39085,
  [SMALL_STATE(924)] = 39094,
  [SMALL_STATE(925)] = 39103,
  [SMALL_STATE(926)] = 39116,
  [SMALL_STATE(927)] = 39127,
  [SMALL_STATE(928)] = 39136,
  [SMALL_STATE(929)] = 39145,
  [SMALL_STATE(930)] = 39158,
  [SMALL_STATE(931)] = 39167,
  [SMALL_STATE(932)] = 39180,
  [SMALL_STATE(933)] = 39189,
  [SMALL_STATE(934)] = 39202,
  [SMALL_STATE(935)] = 39215,
  [SMALL_STATE(936)] = 39228,
  [SMALL_STATE(937)] = 39241,
  [SMALL_STATE(938)] = 39254,
  [SMALL_STATE(939)] = 39267,
  [SMALL_STATE(940)] = 39276,
  [SMALL_STATE(941)] = 39289,
  [SMALL_STATE(942)] = 39298,
  [SMALL_STATE(943)] = 39311,
  [SMALL_STATE(944)] = 39324,
  [SMALL_STATE(945)] = 39333,
  [SMALL_STATE(946)] = 39346,
  [SMALL_STATE(947)] = 39359,
  [SMALL_STATE(948)] = 39368,
  [SMALL_STATE(949)] = 39381,
  [SMALL_STATE(950)] = 39394,
  [SMALL_STATE(951)] = 39403,
  [SMALL_STATE(952)] = 39416,
  [SMALL_STATE(953)] = 39429,
  [SMALL_STATE(954)] = 39438,
  [SMALL_STATE(955)] = 39451,
  [SMALL_STATE(956)] = 39460,
  [SMALL_STATE(957)] = 39473,
  [SMALL_STATE(958)] = 39482,
  [SMALL_STATE(959)] = 39495,
  [SMALL_STATE(960)] = 39508,
  [SMALL_STATE(961)] = 39521,
  [SMALL_STATE(962)] = 39534,
  [SMALL_STATE(963)] = 39547,
  [SMALL_STATE(964)] = 39560,
  [SMALL_STATE(965)] = 39573,
  [SMALL_STATE(966)] = 39586,
  [SMALL_STATE(967)] = 39595,
  [SMALL_STATE(968)] = 39604,
  [SMALL_STATE(969)] = 39617,
  [SMALL_STATE(970)] = 39626,
  [SMALL_STATE(971)] = 39635,
  [SMALL_STATE(972)] = 39644,
  [SMALL_STATE(973)] = 39653,
  [SMALL_STATE(974)] = 39662,
  [SMALL_STATE(975)] = 39675,
  [SMALL_STATE(976)] = 39688,
  [SMALL_STATE(977)] = 39697,
  [SMALL_STATE(978)] = 39710,
  [SMALL_STATE(979)] = 39723,
  [SMALL_STATE(980)] = 39736,
  [SMALL_STATE(981)] = 39745,
  [SMALL_STATE(982)] = 39758,
  [SMALL_STATE(983)] = 39767,
  [SMALL_STATE(984)] = 39778,
  [SMALL_STATE(985)] = 39787,
  [SMALL_STATE(986)] = 39796,
  [SMALL_STATE(987)] = 39805,
  [SMALL_STATE(988)] = 39818,
  [SMALL_STATE(989)] = 39831,
  [SMALL_STATE(990)] = 39840,
  [SMALL_STATE(991)] = 39853,
  [SMALL_STATE(992)] = 39866,
  [SMALL_STATE(993)] = 39875,
  [SMALL_STATE(994)] = 39884,
  [SMALL_STATE(995)] = 39893,
  [SMALL_STATE(996)] = 39906,
  [SMALL_STATE(997)] = 39919,
  [SMALL_STATE(998)] = 39928,
  [SMALL_STATE(999)] = 39941,
  [SMALL_STATE(1000)] = 39954,
  [SMALL_STATE(1001)] = 39967,
  [SMALL_STATE(1002)] = 39980,
  [SMALL_STATE(1003)] = 39993,
  [SMALL_STATE(1004)] = 40006,
  [SMALL_STATE(1005)] = 40015,
  [SMALL_STATE(1006)] = 40028,
  [SMALL_STATE(1007)] = 40037,
  [SMALL_STATE(1008)] = 40050,
  [SMALL_STATE(1009)] = 40059,
  [SMALL_STATE(1010)] = 40072,
  [SMALL_STATE(1011)] = 40085,
  [SMALL_STATE(1012)] = 40094,
  [SMALL_STATE(1013)] = 40103,
  [SMALL_STATE(1014)] = 40112,
  [SMALL_STATE(1015)] = 40121,
  [SMALL_STATE(1016)] = 40130,
  [SMALL_STATE(1017)] = 40139,
  [SMALL_STATE(1018)] = 40152,
  [SMALL_STATE(1019)] = 40163,
  [SMALL_STATE(1020)] = 40172,
  [SMALL_STATE(1021)] = 40181,
  [SMALL_STATE(1022)] = 40190,
  [SMALL_STATE(1023)] = 40201,
  [SMALL_STATE(1024)] = 40214,
  [SMALL_STATE(1025)] = 40227,
  [SMALL_STATE(1026)] = 40240,
  [SMALL_STATE(1027)] = 40249,
  [SMALL_STATE(1028)] = 40262,
  [SMALL_STATE(1029)] = 40275,
  [SMALL_STATE(1030)] = 40288,
  [SMALL_STATE(1031)] = 40301,
  [SMALL_STATE(1032)] = 40314,
  [SMALL_STATE(1033)] = 40327,
  [SMALL_STATE(1034)] = 40336,
  [SMALL_STATE(1035)] = 40349,
  [SMALL_STATE(1036)] = 40360,
  [SMALL_STATE(1037)] = 40373,
  [SMALL_STATE(1038)] = 40386,
  [SMALL_STATE(1039)] = 40399,
  [SMALL_STATE(1040)] = 40412,
  [SMALL_STATE(1041)] = 40425,
  [SMALL_STATE(1042)] = 40438,
  [SMALL_STATE(1043)] = 40451,
  [SMALL_STATE(1044)] = 40464,
  [SMALL_STATE(1045)] = 40477,
  [SMALL_STATE(1046)] = 40490,
  [SMALL_STATE(1047)] = 40503,
  [SMALL_STATE(1048)] = 40516,
  [SMALL_STATE(1049)] = 40525,
  [SMALL_STATE(1050)] = 40538,
  [SMALL_STATE(1051)] = 40547,
  [SMALL_STATE(1052)] = 40560,
  [SMALL_STATE(1053)] = 40573,
  [SMALL_STATE(1054)] = 40586,
  [SMALL_STATE(1055)] = 40599,
  [SMALL_STATE(1056)] = 40612,
  [SMALL_STATE(1057)] = 40625,
  [SMALL_STATE(1058)] = 40638,
  [SMALL_STATE(1059)] = 40651,
  [SMALL_STATE(1060)] = 40662,
  [SMALL_STATE(1061)] = 40675,
  [SMALL_STATE(1062)] = 40686,
  [SMALL_STATE(1063)] = 40699,
  [SMALL_STATE(1064)] = 40708,
  [SMALL_STATE(1065)] = 40717,
  [SMALL_STATE(1066)] = 40730,
  [SMALL_STATE(1067)] = 40743,
  [SMALL_STATE(1068)] = 40756,
  [SMALL_STATE(1069)] = 40769,
  [SMALL_STATE(1070)] = 40782,
  [SMALL_STATE(1071)] = 40795,
  [SMALL_STATE(1072)] = 40808,
  [SMALL_STATE(1073)] = 40817,
  [SMALL_STATE(1074)] = 40830,
  [SMALL_STATE(1075)] = 40839,
  [SMALL_STATE(1076)] = 40852,
  [SMALL_STATE(1077)] = 40861,
  [SMALL_STATE(1078)] = 40874,
  [SMALL_STATE(1079)] = 40887,
  [SMALL_STATE(1080)] = 40900,
  [SMALL_STATE(1081)] = 40913,
  [SMALL_STATE(1082)] = 40926,
  [SMALL_STATE(1083)] = 40935,
  [SMALL_STATE(1084)] = 40948,
  [SMALL_STATE(1085)] = 40961,
  [SMALL_STATE(1086)] = 40974,
  [SMALL_STATE(1087)] = 40983,
  [SMALL_STATE(1088)] = 40996,
  [SMALL_STATE(1089)] = 41007,
  [SMALL_STATE(1090)] = 41016,
  [SMALL_STATE(1091)] = 41029,
  [SMALL_STATE(1092)] = 41038,
  [SMALL_STATE(1093)] = 41047,
  [SMALL_STATE(1094)] = 41060,
  [SMALL_STATE(1095)] = 41069,
  [SMALL_STATE(1096)] = 41078,
  [SMALL_STATE(1097)] = 41087,
  [SMALL_STATE(1098)] = 41097,
  [SMALL_STATE(1099)] = 41105,
  [SMALL_STATE(1100)] = 41115,
  [SMALL_STATE(1101)] = 41123,
  [SMALL_STATE(1102)] = 41131,
  [SMALL_STATE(1103)] = 41141,
  [SMALL_STATE(1104)] = 41151,
  [SMALL_STATE(1105)] = 41161,
  [SMALL_STATE(1106)] = 41169,
  [SMALL_STATE(1107)] = 41179,
  [SMALL_STATE(1108)] = 41189,
  [SMALL_STATE(1109)] = 41199,
  [SMALL_STATE(1110)] = 41209,
  [SMALL_STATE(1111)] = 41219,
  [SMALL_STATE(1112)] = 41229,
  [SMALL_STATE(1113)] = 41239,
  [SMALL_STATE(1114)] = 41249,
  [SMALL_STATE(1115)] = 41259,
  [SMALL_STATE(1116)] = 41269,
  [SMALL_STATE(1117)] = 41279,
  [SMALL_STATE(1118)] = 41289,
  [SMALL_STATE(1119)] = 41299,
  [SMALL_STATE(1120)] = 41309,
  [SMALL_STATE(1121)] = 41319,
  [SMALL_STATE(1122)] = 41329,
  [SMALL_STATE(1123)] = 41339,
  [SMALL_STATE(1124)] = 41349,
  [SMALL_STATE(1125)] = 41359,
  [SMALL_STATE(1126)] = 41369,
  [SMALL_STATE(1127)] = 41379,
  [SMALL_STATE(1128)] = 41389,
  [SMALL_STATE(1129)] = 41399,
  [SMALL_STATE(1130)] = 41409,
  [SMALL_STATE(1131)] = 41419,
  [SMALL_STATE(1132)] = 41429,
  [SMALL_STATE(1133)] = 41439,
  [SMALL_STATE(1134)] = 41447,
  [SMALL_STATE(1135)] = 41457,
  [SMALL_STATE(1136)] = 41467,
  [SMALL_STATE(1137)] = 41477,
  [SMALL_STATE(1138)] = 41487,
  [SMALL_STATE(1139)] = 41497,
  [SMALL_STATE(1140)] = 41505,
  [SMALL_STATE(1141)] = 41515,
  [SMALL_STATE(1142)] = 41525,
  [SMALL_STATE(1143)] = 41535,
  [SMALL_STATE(1144)] = 41545,
  [SMALL_STATE(1145)] = 41555,
  [SMALL_STATE(1146)] = 41565,
  [SMALL_STATE(1147)] = 41575,
  [SMALL_STATE(1148)] = 41583,
  [SMALL_STATE(1149)] = 41593,
  [SMALL_STATE(1150)] = 41603,
  [SMALL_STATE(1151)] = 41613,
  [SMALL_STATE(1152)] = 41623,
  [SMALL_STATE(1153)] = 41633,
  [SMALL_STATE(1154)] = 41641,
  [SMALL_STATE(1155)] = 41649,
  [SMALL_STATE(1156)] = 41657,
  [SMALL_STATE(1157)] = 41665,
  [SMALL_STATE(1158)] = 41673,
  [SMALL_STATE(1159)] = 41681,
  [SMALL_STATE(1160)] = 41689,
  [SMALL_STATE(1161)] = 41699,
  [SMALL_STATE(1162)] = 41709,
  [SMALL_STATE(1163)] = 41717,
  [SMALL_STATE(1164)] = 41727,
  [SMALL_STATE(1165)] = 41735,
  [SMALL_STATE(1166)] = 41745,
  [SMALL_STATE(1167)] = 41753,
  [SMALL_STATE(1168)] = 41761,
  [SMALL_STATE(1169)] = 41771,
  [SMALL_STATE(1170)] = 41781,
  [SMALL_STATE(1171)] = 41789,
  [SMALL_STATE(1172)] = 41799,
  [SMALL_STATE(1173)] = 41807,
  [SMALL_STATE(1174)] = 41817,
  [SMALL_STATE(1175)] = 41825,
  [SMALL_STATE(1176)] = 41835,
  [SMALL_STATE(1177)] = 41845,
  [SMALL_STATE(1178)] = 41855,
  [SMALL_STATE(1179)] = 41865,
  [SMALL_STATE(1180)] = 41873,
  [SMALL_STATE(1181)] = 41883,
  [SMALL_STATE(1182)] = 41891,
  [SMALL_STATE(1183)] = 41899,
  [SMALL_STATE(1184)] = 41907,
  [SMALL_STATE(1185)] = 41917,
  [SMALL_STATE(1186)] = 41927,
  [SMALL_STATE(1187)] = 41935,
  [SMALL_STATE(1188)] = 41943,
  [SMALL_STATE(1189)] = 41953,
  [SMALL_STATE(1190)] = 41963,
  [SMALL_STATE(1191)] = 41973,
  [SMALL_STATE(1192)] = 41983,
  [SMALL_STATE(1193)] = 41993,
  [SMALL_STATE(1194)] = 42001,
  [SMALL_STATE(1195)] = 42011,
  [SMALL_STATE(1196)] = 42021,
  [SMALL_STATE(1197)] = 42031,
  [SMALL_STATE(1198)] = 42041,
  [SMALL_STATE(1199)] = 42049,
  [SMALL_STATE(1200)] = 42057,
  [SMALL_STATE(1201)] = 42065,
  [SMALL_STATE(1202)] = 42075,
  [SMALL_STATE(1203)] = 42085,
  [SMALL_STATE(1204)] = 42095,
  [SMALL_STATE(1205)] = 42105,
  [SMALL_STATE(1206)] = 42113,
  [SMALL_STATE(1207)] = 42121,
  [SMALL_STATE(1208)] = 42131,
  [SMALL_STATE(1209)] = 42141,
  [SMALL_STATE(1210)] = 42149,
  [SMALL_STATE(1211)] = 42159,
  [SMALL_STATE(1212)] = 42167,
  [SMALL_STATE(1213)] = 42177,
  [SMALL_STATE(1214)] = 42187,
  [SMALL_STATE(1215)] = 42197,
  [SMALL_STATE(1216)] = 42207,
  [SMALL_STATE(1217)] = 42215,
  [SMALL_STATE(1218)] = 42225,
  [SMALL_STATE(1219)] = 42235,
  [SMALL_STATE(1220)] = 42245,
  [SMALL_STATE(1221)] = 42255,
  [SMALL_STATE(1222)] = 42265,
  [SMALL_STATE(1223)] = 42273,
  [SMALL_STATE(1224)] = 42281,
  [SMALL_STATE(1225)] = 42289,
  [SMALL_STATE(1226)] = 42297,
  [SMALL_STATE(1227)] = 42307,
  [SMALL_STATE(1228)] = 42317,
  [SMALL_STATE(1229)] = 42325,
  [SMALL_STATE(1230)] = 42333,
  [SMALL_STATE(1231)] = 42343,
  [SMALL_STATE(1232)] = 42353,
  [SMALL_STATE(1233)] = 42361,
  [SMALL_STATE(1234)] = 42369,
  [SMALL_STATE(1235)] = 42379,
  [SMALL_STATE(1236)] = 42389,
  [SMALL_STATE(1237)] = 42399,
  [SMALL_STATE(1238)] = 42409,
  [SMALL_STATE(1239)] = 42417,
  [SMALL_STATE(1240)] = 42425,
  [SMALL_STATE(1241)] = 42433,
  [SMALL_STATE(1242)] = 42441,
  [SMALL_STATE(1243)] = 42449,
  [SMALL_STATE(1244)] = 42457,
  [SMALL_STATE(1245)] = 42467,
  [SMALL_STATE(1246)] = 42477,
  [SMALL_STATE(1247)] = 42487,
  [SMALL_STATE(1248)] = 42495,
  [SMALL_STATE(1249)] = 42505,
  [SMALL_STATE(1250)] = 42515,
  [SMALL_STATE(1251)] = 42525,
  [SMALL_STATE(1252)] = 42533,
  [SMALL_STATE(1253)] = 42543,
  [SMALL_STATE(1254)] = 42551,
  [SMALL_STATE(1255)] = 42559,
  [SMALL_STATE(1256)] = 42569,
  [SMALL_STATE(1257)] = 42577,
  [SMALL_STATE(1258)] = 42585,
  [SMALL_STATE(1259)] = 42595,
  [SMALL_STATE(1260)] = 42605,
  [SMALL_STATE(1261)] = 42615,
  [SMALL_STATE(1262)] = 42625,
  [SMALL_STATE(1263)] = 42633,
  [SMALL_STATE(1264)] = 42643,
  [SMALL_STATE(1265)] = 42651,
  [SMALL_STATE(1266)] = 42661,
  [SMALL_STATE(1267)] = 42671,
  [SMALL_STATE(1268)] = 42679,
  [SMALL_STATE(1269)] = 42687,
  [SMALL_STATE(1270)] = 42695,
  [SMALL_STATE(1271)] = 42705,
  [SMALL_STATE(1272)] = 42713,
  [SMALL_STATE(1273)] = 42723,
  [SMALL_STATE(1274)] = 42731,
  [SMALL_STATE(1275)] = 42739,
  [SMALL_STATE(1276)] = 42749,
  [SMALL_STATE(1277)] = 42757,
  [SMALL_STATE(1278)] = 42767,
  [SMALL_STATE(1279)] = 42777,
  [SMALL_STATE(1280)] = 42785,
  [SMALL_STATE(1281)] = 42795,
  [SMALL_STATE(1282)] = 42805,
  [SMALL_STATE(1283)] = 42813,
  [SMALL_STATE(1284)] = 42823,
  [SMALL_STATE(1285)] = 42831,
  [SMALL_STATE(1286)] = 42839,
  [SMALL_STATE(1287)] = 42847,
  [SMALL_STATE(1288)] = 42857,
  [SMALL_STATE(1289)] = 42865,
  [SMALL_STATE(1290)] = 42873,
  [SMALL_STATE(1291)] = 42883,
  [SMALL_STATE(1292)] = 42891,
  [SMALL_STATE(1293)] = 42901,
  [SMALL_STATE(1294)] = 42909,
  [SMALL_STATE(1295)] = 42917,
  [SMALL_STATE(1296)] = 42927,
  [SMALL_STATE(1297)] = 42937,
  [SMALL_STATE(1298)] = 42945,
  [SMALL_STATE(1299)] = 42953,
  [SMALL_STATE(1300)] = 42963,
  [SMALL_STATE(1301)] = 42971,
  [SMALL_STATE(1302)] = 42981,
  [SMALL_STATE(1303)] = 42991,
  [SMALL_STATE(1304)] = 43001,
  [SMALL_STATE(1305)] = 43011,
  [SMALL_STATE(1306)] = 43021,
  [SMALL_STATE(1307)] = 43029,
  [SMALL_STATE(1308)] = 43036,
  [SMALL_STATE(1309)] = 43043,
  [SMALL_STATE(1310)] = 43050,
  [SMALL_STATE(1311)] = 43057,
  [SMALL_STATE(1312)] = 43064,
  [SMALL_STATE(1313)] = 43071,
  [SMALL_STATE(1314)] = 43078,
  [SMALL_STATE(1315)] = 43085,
  [SMALL_STATE(1316)] = 43092,
  [SMALL_STATE(1317)] = 43099,
  [SMALL_STATE(1318)] = 43106,
  [SMALL_STATE(1319)] = 43113,
  [SMALL_STATE(1320)] = 43120,
  [SMALL_STATE(1321)] = 43127,
  [SMALL_STATE(1322)] = 43134,
  [SMALL_STATE(1323)] = 43141,
  [SMALL_STATE(1324)] = 43148,
  [SMALL_STATE(1325)] = 43155,
  [SMALL_STATE(1326)] = 43162,
  [SMALL_STATE(1327)] = 43169,
  [SMALL_STATE(1328)] = 43176,
  [SMALL_STATE(1329)] = 43183,
  [SMALL_STATE(1330)] = 43190,
  [SMALL_STATE(1331)] = 43197,
  [SMALL_STATE(1332)] = 43204,
  [SMALL_STATE(1333)] = 43211,
  [SMALL_STATE(1334)] = 43218,
  [SMALL_STATE(1335)] = 43225,
  [SMALL_STATE(1336)] = 43232,
  [SMALL_STATE(1337)] = 43239,
  [SMALL_STATE(1338)] = 43246,
  [SMALL_STATE(1339)] = 43253,
  [SMALL_STATE(1340)] = 43260,
  [SMALL_STATE(1341)] = 43267,
  [SMALL_STATE(1342)] = 43274,
  [SMALL_STATE(1343)] = 43281,
  [SMALL_STATE(1344)] = 43288,
  [SMALL_STATE(1345)] = 43295,
  [SMALL_STATE(1346)] = 43302,
  [SMALL_STATE(1347)] = 43309,
  [SMALL_STATE(1348)] = 43316,
  [SMALL_STATE(1349)] = 43323,
  [SMALL_STATE(1350)] = 43330,
  [SMALL_STATE(1351)] = 43337,
  [SMALL_STATE(1352)] = 43344,
  [SMALL_STATE(1353)] = 43351,
  [SMALL_STATE(1354)] = 43358,
  [SMALL_STATE(1355)] = 43365,
  [SMALL_STATE(1356)] = 43372,
  [SMALL_STATE(1357)] = 43379,
  [SMALL_STATE(1358)] = 43386,
  [SMALL_STATE(1359)] = 43393,
  [SMALL_STATE(1360)] = 43400,
  [SMALL_STATE(1361)] = 43407,
  [SMALL_STATE(1362)] = 43414,
  [SMALL_STATE(1363)] = 43421,
  [SMALL_STATE(1364)] = 43428,
  [SMALL_STATE(1365)] = 43435,
  [SMALL_STATE(1366)] = 43442,
  [SMALL_STATE(1367)] = 43449,
  [SMALL_STATE(1368)] = 43456,
  [SMALL_STATE(1369)] = 43463,
  [SMALL_STATE(1370)] = 43470,
  [SMALL_STATE(1371)] = 43477,
  [SMALL_STATE(1372)] = 43484,
  [SMALL_STATE(1373)] = 43491,
  [SMALL_STATE(1374)] = 43498,
  [SMALL_STATE(1375)] = 43505,
  [SMALL_STATE(1376)] = 43512,
  [SMALL_STATE(1377)] = 43519,
  [SMALL_STATE(1378)] = 43526,
  [SMALL_STATE(1379)] = 43533,
  [SMALL_STATE(1380)] = 43540,
  [SMALL_STATE(1381)] = 43547,
  [SMALL_STATE(1382)] = 43554,
  [SMALL_STATE(1383)] = 43561,
  [SMALL_STATE(1384)] = 43568,
  [SMALL_STATE(1385)] = 43575,
  [SMALL_STATE(1386)] = 43582,
  [SMALL_STATE(1387)] = 43589,
  [SMALL_STATE(1388)] = 43596,
  [SMALL_STATE(1389)] = 43603,
  [SMALL_STATE(1390)] = 43610,
  [SMALL_STATE(1391)] = 43617,
  [SMALL_STATE(1392)] = 43624,
  [SMALL_STATE(1393)] = 43631,
  [SMALL_STATE(1394)] = 43638,
  [SMALL_STATE(1395)] = 43645,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1212),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1214),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1218),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1227),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(846),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1102),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(205),
  [124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(233),
  [127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(832),
  [130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(1012),
  [133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(233),
  [136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(1146),
  [139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(1151),
  [142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(1152),
  [145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(748),
  [148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(808),
  [151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(1184),
  [154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(211),
  [157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(921),
  [160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(947),
  [163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(846),
  [166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(966),
  [169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(1212),
  [172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(1214),
  [175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(1218),
  [178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(831),
  [181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(371),
  [184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(1102),
  [187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(372),
  [190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(1135),
  [193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(860),
  [196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(235),
  [199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(363),
  [202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(305),
  [205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(382),
  [208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(382),
  [211] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(313),
  [214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(342),
  [217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(817),
  [220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2),
  [222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(901),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source, 1),
  [239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(815),
  [242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(892),
  [245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(353),
  [248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(1227),
  [251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(351),
  [254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(1235),
  [257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(849),
  [260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(347),
  [263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_repeat1, 2), SHIFT_REPEAT(812),
  [266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(899),
  [268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1082),
  [324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 36),
  [366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 36),
  [368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 24),
  [374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 24),
  [376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 52),
  [378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 52),
  [380] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 52), SHIFT_REPEAT(350),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1307),
  [387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 52), SHIFT_REPEAT(341),
  [390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 34),
  [392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 34),
  [394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elif_clause, 4, .production_id = 24),
  [396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif_clause, 4, .production_id = 24),
  [398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 3),
  [400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 3),
  [402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_body, 2),
  [404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_body, 2),
  [406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_body, 1),
  [408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_body, 1),
  [410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_body, 3),
  [412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_body, 3),
  [414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 2),
  [416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 2),
  [418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 4),
  [420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 4),
  [422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, .production_id = 54),
  [424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, .production_id = 54),
  [426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, .production_id = 55),
  [428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, .production_id = 55),
  [430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, .production_id = 44),
  [432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, .production_id = 44),
  [434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, .production_id = 57),
  [436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, .production_id = 57),
  [438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, .production_id = 46),
  [440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, .production_id = 46),
  [442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, .production_id = 45),
  [444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, .production_id = 45),
  [446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 3, .production_id = 62),
  [448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 3, .production_id = 62),
  [450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, .production_id = 41),
  [452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, .production_id = 41),
  [454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_definition, 7, .production_id = 64),
  [456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_definition, 7, .production_id = 64),
  [458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_definition, 7, .production_id = 65),
  [460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_definition, 7, .production_id = 65),
  [462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_definition, 5, .production_id = 33),
  [464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_definition, 5, .production_id = 33),
  [466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, .production_id = 66),
  [468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, .production_id = 66),
  [470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 4),
  [472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 4),
  [474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_definition, 2, .production_id = 5),
  [476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_definition, 2, .production_id = 5),
  [478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 51),
  [480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 51),
  [482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_definition, 3, .production_id = 14),
  [484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_definition, 3, .production_id = 14),
  [486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 4, .production_id = 24),
  [488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 4, .production_id = 24),
  [490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, .production_id = 37),
  [492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, .production_id = 37),
  [494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 4, .production_id = 25),
  [496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 4, .production_id = 25),
  [498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_definition, 9, .production_id = 71),
  [500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_definition, 9, .production_id = 71),
  [502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, .production_id = 40),
  [504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, .production_id = 40),
  [506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 35),
  [508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 35),
  [510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 3),
  [512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 3),
  [514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 53),
  [516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 53),
  [518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 5),
  [520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 5),
  [522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_statement, 4, .production_id = 27),
  [524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_statement, 4, .production_id = 27),
  [526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, .production_id = 56),
  [528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, .production_id = 56),
  [530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_body, 3),
  [532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_body, 3),
  [534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, .production_id = 33),
  [536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, .production_id = 33),
  [538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, .production_id = 28),
  [540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, .production_id = 28),
  [542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 1),
  [556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 1),
  [558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 5),
  [560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 5),
  [562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_operator, 3),
  [564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_operator, 3),
  [566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1),
  [584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 2),
  [606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2),
  [608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attribute_repeat1, 2),
  [610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_repeat1, 2),
  [612] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_repeat1, 2), SHIFT_REPEAT(883),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_operator, 2),
  [621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_operator, 2),
  [623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 4),
  [625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 4),
  [627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2),
  [667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2),
  [669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_expression, 1),
  [671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_expression, 1),
  [673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute_expression, 1),
  [675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_subscript, 4),
  [677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_subscript, 4),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_name, 2, .production_id = 2),
  [689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_name, 2, .production_id = 2),
  [691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 2),
  [693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 2),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 5),
  [705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 5),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2),
  [715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2),
  [717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3),
  [719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3),
  [721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 4),
  [723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 4),
  [725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 3),
  [735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 3),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4),
  [741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4),
  [743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_call, 2),
  [747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_call, 2),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 5),
  [757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 5),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_base_call, 3),
  [763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_call, 3),
  [765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(610),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1219),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [1059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_repeat1, 2), SHIFT_REPEAT(871),
  [1062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [1064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [1066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(375),
  [1068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [1070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [1072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [1074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [1076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [1080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [1082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [1084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [1088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [1090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [1092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [1094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [1096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [1100] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_repeat1, 2), SHIFT_REPEAT(896),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [1117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [1123] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_repeat1, 2), SHIFT_REPEAT(888),
  [1126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [1128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [1130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_repeat1, 2), SHIFT_REPEAT(841),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [1135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [1139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [1173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_repeat1, 2), SHIFT_REPEAT(880),
  [1176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [1178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [1180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [1182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [1186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(408),
  [1188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [1190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [1192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [1194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [1196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [1198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [1200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [1204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [1206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [1208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [1212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [1214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [1216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_repeat1, 2), SHIFT_REPEAT(879),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [1221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comparison_operator, 2),
  [1223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comparison_operator, 2),
  [1225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(384),
  [1228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(384),
  [1231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inferred_type, 1),
  [1233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inferred_type, 1),
  [1235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inferred_type, 2),
  [1237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inferred_type, 2),
  [1239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enumerator_expression, 1),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [1243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [1247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [1259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_body_repeat1, 2), SHIFT_REPEAT(1166),
  [1262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_body_repeat1, 2), SHIFT_REPEAT(1251),
  [1265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_body_repeat1, 2), SHIFT_REPEAT(1251),
  [1268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_body_repeat1, 2), SHIFT_REPEAT(1252),
  [1271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_body_repeat1, 2), SHIFT_REPEAT(326),
  [1274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_body_repeat1, 2), SHIFT_REPEAT(738),
  [1277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_body_repeat1, 2),
  [1279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_body_repeat1, 2), SHIFT_REPEAT(878),
  [1282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [1284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [1286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [1290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [1294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [1296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1167),
  [1298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [1300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1107),
  [1302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [1304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [1306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [1308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [1310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [1312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [1314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [1316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [1318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [1320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2),
  [1322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5),
  [1324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [1326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [1328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [1330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [1332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [1334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [1338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [1340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [1342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [1344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1),
  [1346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [1348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [1350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_statement, 3, .production_id = 15),
  [1352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [1354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [1360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [1362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_statement, 2, .production_id = 3),
  [1364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(397),
  [1367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(397),
  [1370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern_section, 3, .production_id = 62),
  [1372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_section, 3, .production_id = 62),
  [1374] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(463),
  [1377] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(463),
  [1380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(420),
  [1383] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(420),
  [1386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern_section, 4, .production_id = 70),
  [1388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_section, 4, .production_id = 70),
  [1390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(450),
  [1393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(450),
  [1396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(435),
  [1399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(435),
  [1402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(409),
  [1405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(409),
  [1408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [1410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [1412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotations, 1),
  [1414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [1416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [1422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [1424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_name, 1),
  [1426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_name, 1),
  [1428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__annotations, 2),
  [1430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__annotations, 2), SHIFT_REPEAT(1151),
  [1433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 2),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [1463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1090),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [1469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_statement, 3, .production_id = 7),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [1481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1),
  [1483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__simple_statements_repeat1, 2),
  [1485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_statement, 4, .production_id = 31),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [1491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_statement, 3, .production_id = 6),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [1495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_statement, 4, .production_id = 30),
  [1497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_typed_definition, 2, .production_id = 17),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [1501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 3),
  [1503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rhs_expression, 1),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [1509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [1513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [1515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_typed_definition, 1, .production_id = 8),
  [1517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dotted_type_repeat1, 2),
  [1519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_type_repeat1, 2), SHIFT_REPEAT(1113),
  [1522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [1524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 6, .production_id = 61),
  [1526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_type, 1),
  [1528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [1530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signal_statement, 2),
  [1532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [1534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [1536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 5),
  [1538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 5, .production_id = 50),
  [1540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__annotations, 2), SHIFT_REPEAT(1178),
  [1543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_type, 2),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [1547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 4),
  [1549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_inferred_type_assignment, 2, .production_id = 19),
  [1551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_assignment, 2, .production_id = 18),
  [1553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_typed_assignment, 4, .production_id = 49),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [1557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [1559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [1561] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [1565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [1567] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__simple_statements_repeat1, 2), SHIFT_REPEAT(119),
  [1570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [1572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [1574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [1576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [1578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_setget, 2),
  [1580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [1582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [1584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [1586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [1588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 1),
  [1590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [1594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [1596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [1598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [1600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [1604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [1606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [1608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [1610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [1612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [1614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [1616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [1618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [1620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [1624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [1628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [1630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(882),
  [1633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2),
  [1635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [1637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [1639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [1641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [1643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [1645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [1647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_name_statement, 2),
  [1649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [1651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [1655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [1657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_statement, 2),
  [1659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [1661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [1663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [1665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [1667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [1669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [1671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [1673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [1675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [1677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_setter, 1),
  [1679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [1681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [1683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [1687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_parameter, 3, .production_id = 38),
  [1689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [1693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [1695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [1701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_statement, 4, .production_id = 21),
  [1703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [1705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [1711] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_type_repeat1, 2), SHIFT_REPEAT(1248),
  [1714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2), SHIFT_REPEAT(1075),
  [1717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2),
  [1719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pass_statement, 1),
  [1721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(316),
  [1724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2),
  [1726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [1728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [1730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [1732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_variable_statement, 4, .production_id = 22),
  [1734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [1736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [1740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [1744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [1746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [1748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [1750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [1752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [1754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_name_statement, 4, .production_id = 23),
  [1756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [1758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [1760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [1762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [1764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_statement, 5, .production_id = 43),
  [1766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [1768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [1770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [1774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 1),
  [1776] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pattern_array_repeat1, 2), SHIFT_REPEAT(742),
  [1779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pattern_array_repeat1, 2),
  [1781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [1783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [1785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_statement, 4),
  [1787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [1789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [1791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_statement, 2, .production_id = 4),
  [1793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [1795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__setget_body, 5, .production_id = 60),
  [1797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [1799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__setget_body, 5, .production_id = 59),
  [1801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [1803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [1805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [1807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [1809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [1811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [1813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [1815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [1817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [1819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [1821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [1823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 1),
  [1825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__setget_body, 4, .production_id = 47),
  [1827] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dictionary_repeat1, 2), SHIFT_REPEAT(275),
  [1830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dictionary_repeat1, 2),
  [1832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 5),
  [1834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_statement, 4, .production_id = 20),
  [1836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__setget_body, 6, .production_id = 68),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [1842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_onready_variable_statement, 2, .production_id = 4),
  [1844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [1846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [1848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [1850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [1852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [1854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [1856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 4),
  [1858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [1860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3),
  [1862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_setget, 3),
  [1864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [1866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [1868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [1870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [1872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_variable_statement, 2, .production_id = 4),
  [1874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [1878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [1880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [1882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [1884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [1888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [1890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [1892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [1894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [1896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [1898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [1900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pattern_section_repeat1, 2),
  [1902] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pattern_section_repeat1, 2), SHIFT_REPEAT(745),
  [1905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [1907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_statement, 3, .production_id = 7),
  [1909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [1911] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(325),
  [1914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_setget, 4),
  [1916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_remote_keyword, 1),
  [1918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_statement, 5, .production_id = 42),
  [1920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__setget_body, 4, .production_id = 48),
  [1922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__setget_body, 6, .production_id = 69),
  [1924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_getter, 1),
  [1926] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2), SHIFT_REPEAT(804),
  [1929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2),
  [1931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_statement, 1, .production_id = 1),
  [1933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment, 3, .production_id = 16),
  [1935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [1937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [1941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, .production_id = 16),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [1947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [1949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [1951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [1957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [1959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [1963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [1965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [1967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [1971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [1975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [1977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [1979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [1981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [1983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [1985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [1987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [1989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [2001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [2003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [2005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [2007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [2013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [2021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 1, .production_id = 13),
  [2023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [2025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [2027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_statement, 4, .production_id = 32),
  [2029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [2031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [2033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [2035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [2037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [2039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [2041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pattern_dictionary_repeat1, 2), SHIFT_REPEAT(332),
  [2044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pattern_dictionary_repeat1, 2),
  [2046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signal_statement, 3),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [2050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [2062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [2066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [2070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [2074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_statement, 3, .production_id = 6),
  [2076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_variable_statement, 3, .production_id = 12),
  [2078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [2080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [2082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_variable_statement, 3, .production_id = 11),
  [2084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_statement, 3, .production_id = 10),
  [2086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_setget, 1, .production_id = 9),
  [2088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [2090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [2092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_parameter, 3, .production_id = 39),
  [2094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [2096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [2098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [2100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [2102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [2104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [2106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [2110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [2112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [2114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [2118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [2122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [2124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [2126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [2128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [2130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [2132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [2134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [2136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 1),
  [2138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [2142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_dictionary, 2),
  [2144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [2146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_binding, 2),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [2150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [2152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_array, 2),
  [2154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 26),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [2160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [2162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [2164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [2166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_get_body, 3, .production_id = 58),
  [2168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_array, 4),
  [2170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [2172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [2174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_pair, 3, .production_id = 26),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [2182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_dictionary, 3),
  [2184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_array, 3),
  [2186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_dictionary, 4),
  [2188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [2190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [2192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [2194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [2196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [2198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [2202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [2204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_default_parameter, 5, .production_id = 63),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [2208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [2210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [2212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_body, 4, .production_id = 67),
  [2214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [2216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [2218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 3, .production_id = 16),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [2222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [2224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [2228] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [2230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [2256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__get_assign, 3, .production_id = 48),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [2260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [2266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__set_assign, 3, .production_id = 47),
  [2268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [2272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [2274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [2290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [2292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [2294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__return_type, 2, .production_id = 29),
  [2296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [2298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [2318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [2322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_gdscript_external_scanner_create(void);
void tree_sitter_gdscript_external_scanner_destroy(void *);
bool tree_sitter_gdscript_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_gdscript_external_scanner_serialize(void *, char *);
void tree_sitter_gdscript_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_gdscript(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym__identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_gdscript_external_scanner_create,
      tree_sitter_gdscript_external_scanner_destroy,
      tree_sitter_gdscript_external_scanner_scan,
      tree_sitter_gdscript_external_scanner_serialize,
      tree_sitter_gdscript_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
