#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 1282
#define LARGE_STATE_COUNT 354
#define SYMBOL_COUNT 292
#define ALIAS_COUNT 1
#define TOKEN_COUNT 130
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 37
#define MAX_ALIAS_SEQUENCE_LENGTH 11
#define PRODUCTION_ID_COUNT 238

enum {
  sym_identifier = 1,
  sym_decimal_integer_literal = 2,
  sym_hex_integer_literal = 3,
  sym_octal_integer_literal = 4,
  sym_binary_integer_literal = 5,
  sym_decimal_floating_point_literal = 6,
  sym_hex_floating_point_literal = 7,
  sym_true = 8,
  sym_false = 9,
  sym_character_literal = 10,
  sym_string_literal = 11,
  sym_text_block = 12,
  sym_null_literal = 13,
  anon_sym_LPAREN = 14,
  anon_sym_AMP = 15,
  anon_sym_RPAREN = 16,
  anon_sym_EQ = 17,
  anon_sym_PLUS_EQ = 18,
  anon_sym_DASH_EQ = 19,
  anon_sym_STAR_EQ = 20,
  anon_sym_SLASH_EQ = 21,
  anon_sym_AMP_EQ = 22,
  anon_sym_PIPE_EQ = 23,
  anon_sym_CARET_EQ = 24,
  anon_sym_PERCENT_EQ = 25,
  anon_sym_LT_LT_EQ = 26,
  anon_sym_GT_GT_EQ = 27,
  anon_sym_GT_GT_GT_EQ = 28,
  anon_sym_GT = 29,
  anon_sym_LT = 30,
  anon_sym_GT_EQ = 31,
  anon_sym_LT_EQ = 32,
  anon_sym_EQ_EQ = 33,
  anon_sym_BANG_EQ = 34,
  anon_sym_AMP_AMP = 35,
  anon_sym_PIPE_PIPE = 36,
  anon_sym_PLUS = 37,
  anon_sym_DASH = 38,
  anon_sym_STAR = 39,
  anon_sym_SLASH = 40,
  anon_sym_PIPE = 41,
  anon_sym_CARET = 42,
  anon_sym_PERCENT = 43,
  anon_sym_LT_LT = 44,
  anon_sym_GT_GT = 45,
  anon_sym_GT_GT_GT = 46,
  anon_sym_instanceof = 47,
  anon_sym_final = 48,
  anon_sym_DASH_GT = 49,
  anon_sym_COMMA = 50,
  anon_sym_QMARK = 51,
  anon_sym_COLON = 52,
  anon_sym_BANG = 53,
  anon_sym_TILDE = 54,
  anon_sym_PLUS_PLUS = 55,
  anon_sym_DASH_DASH = 56,
  anon_sym_new = 57,
  anon_sym_LBRACK = 58,
  anon_sym_RBRACK = 59,
  anon_sym_DOT = 60,
  anon_sym_class = 61,
  anon_sym_COLON_COLON = 62,
  anon_sym_extends = 63,
  anon_sym_switch = 64,
  anon_sym_LBRACE = 65,
  anon_sym_RBRACE = 66,
  anon_sym_case = 67,
  anon_sym_default = 68,
  anon_sym_SEMI = 69,
  anon_sym_assert = 70,
  anon_sym_do = 71,
  anon_sym_while = 72,
  anon_sym_break = 73,
  anon_sym_continue = 74,
  anon_sym_return = 75,
  anon_sym_yield = 76,
  anon_sym_synchronized = 77,
  anon_sym_throw = 78,
  anon_sym_try = 79,
  anon_sym_catch = 80,
  anon_sym_finally = 81,
  anon_sym_if = 82,
  anon_sym_else = 83,
  anon_sym_for = 84,
  anon_sym_AT = 85,
  anon_sym_open = 86,
  anon_sym_module = 87,
  anon_sym_requires = 88,
  anon_sym_transitive = 89,
  anon_sym_static = 90,
  anon_sym_exports = 91,
  anon_sym_to = 92,
  anon_sym_opens = 93,
  anon_sym_uses = 94,
  anon_sym_provides = 95,
  anon_sym_with = 96,
  anon_sym_package = 97,
  anon_sym_import = 98,
  anon_sym_enum = 99,
  anon_sym_public = 100,
  anon_sym_protected = 101,
  anon_sym_private = 102,
  anon_sym_abstract = 103,
  anon_sym_strictfp = 104,
  anon_sym_native = 105,
  anon_sym_transient = 106,
  anon_sym_volatile = 107,
  anon_sym_sealed = 108,
  anon_sym_non_DASHsealed = 109,
  anon_sym_implements = 110,
  anon_sym_permits = 111,
  anon_sym_record = 112,
  anon_sym_ATinterface = 113,
  anon_sym_interface = 114,
  anon_sym_byte = 115,
  anon_sym_short = 116,
  anon_sym_int = 117,
  anon_sym_long = 118,
  anon_sym_char = 119,
  anon_sym_float = 120,
  anon_sym_double = 121,
  sym_boolean_type = 122,
  sym_void_type = 123,
  anon_sym_DOT_DOT_DOT = 124,
  anon_sym_throws = 125,
  sym_this = 126,
  sym_super = 127,
  sym_line_comment = 128,
  sym_block_comment = 129,
  sym_program = 130,
  sym__literal = 131,
  sym_expression = 132,
  sym_cast_expression = 133,
  sym_assignment_expression = 134,
  sym_binary_expression = 135,
  sym_instanceof_expression = 136,
  sym_lambda_expression = 137,
  sym_inferred_parameters = 138,
  sym_ternary_expression = 139,
  sym_unary_expression = 140,
  sym_update_expression = 141,
  sym_primary_expression = 142,
  sym_array_creation_expression = 143,
  sym_dimensions_expr = 144,
  sym_parenthesized_expression = 145,
  sym_class_literal = 146,
  sym_object_creation_expression = 147,
  sym__unqualified_object_creation_expression = 148,
  sym_field_access = 149,
  sym_array_access = 150,
  sym_method_invocation = 151,
  sym_argument_list = 152,
  sym_method_reference = 153,
  sym_type_arguments = 154,
  sym_wildcard = 155,
  sym__wildcard_bounds = 156,
  sym_dimensions = 157,
  sym_switch_expression = 158,
  sym_switch_block = 159,
  sym_switch_block_statement_group = 160,
  sym_switch_rule = 161,
  sym_switch_label = 162,
  sym_statement = 163,
  sym_block = 164,
  sym_expression_statement = 165,
  sym_labeled_statement = 166,
  sym_assert_statement = 167,
  sym_do_statement = 168,
  sym_break_statement = 169,
  sym_continue_statement = 170,
  sym_return_statement = 171,
  sym_yield_statement = 172,
  sym_synchronized_statement = 173,
  sym_throw_statement = 174,
  sym_try_statement = 175,
  sym_catch_clause = 176,
  sym_catch_formal_parameter = 177,
  sym_catch_type = 178,
  sym_finally_clause = 179,
  sym_try_with_resources_statement = 180,
  sym_resource_specification = 181,
  sym_resource = 182,
  sym_if_statement = 183,
  sym_while_statement = 184,
  sym_for_statement = 185,
  sym_enhanced_for_statement = 186,
  sym__annotation = 187,
  sym_marker_annotation = 188,
  sym_annotation = 189,
  sym_annotation_argument_list = 190,
  sym_element_value_pair = 191,
  sym__element_value = 192,
  sym_element_value_array_initializer = 193,
  sym_declaration = 194,
  sym_module_declaration = 195,
  sym_module_body = 196,
  sym_module_directive = 197,
  sym_requires_module_directive = 198,
  sym_requires_modifier = 199,
  sym_exports_module_directive = 200,
  sym_opens_module_directive = 201,
  sym_uses_module_directive = 202,
  sym_provides_module_directive = 203,
  sym_package_declaration = 204,
  sym_import_declaration = 205,
  sym_asterisk = 206,
  sym_enum_declaration = 207,
  sym_enum_body = 208,
  sym_enum_body_declarations = 209,
  sym_enum_constant = 210,
  sym_class_declaration = 211,
  sym_modifiers = 212,
  sym_type_parameters = 213,
  sym_type_parameter = 214,
  sym_type_bound = 215,
  sym_superclass = 216,
  sym_super_interfaces = 217,
  sym_type_list = 218,
  sym_permits = 219,
  sym_class_body = 220,
  sym_static_initializer = 221,
  sym_constructor_declaration = 222,
  sym__constructor_declarator = 223,
  sym_constructor_body = 224,
  sym_explicit_constructor_invocation = 225,
  sym_scoped_identifier = 226,
  sym_field_declaration = 227,
  sym_record_declaration = 228,
  sym_annotation_type_declaration = 229,
  sym_annotation_type_body = 230,
  sym_annotation_type_element_declaration = 231,
  sym__default_value = 232,
  sym_interface_declaration = 233,
  sym_extends_interfaces = 234,
  sym_interface_body = 235,
  sym_constant_declaration = 236,
  sym__variable_declarator_list = 237,
  sym_variable_declarator = 238,
  sym__variable_declarator_id = 239,
  sym_array_initializer = 240,
  sym__type = 241,
  sym__unannotated_type = 242,
  sym_annotated_type = 243,
  sym_scoped_type_identifier = 244,
  sym_generic_type = 245,
  sym_array_type = 246,
  sym_integral_type = 247,
  sym_floating_point_type = 248,
  sym__method_header = 249,
  sym__method_declarator = 250,
  sym_formal_parameters = 251,
  sym_formal_parameter = 252,
  sym_receiver_parameter = 253,
  sym_spread_parameter = 254,
  sym_throws = 255,
  sym_local_variable_declaration = 256,
  sym_method_declaration = 257,
  sym_compact_constructor_declaration = 258,
  aux_sym_program_repeat1 = 259,
  aux_sym_cast_expression_repeat1 = 260,
  aux_sym_inferred_parameters_repeat1 = 261,
  aux_sym_array_creation_expression_repeat1 = 262,
  aux_sym_array_creation_expression_repeat2 = 263,
  aux_sym_argument_list_repeat1 = 264,
  aux_sym_type_arguments_repeat1 = 265,
  aux_sym_dimensions_repeat1 = 266,
  aux_sym_switch_block_repeat1 = 267,
  aux_sym_switch_block_repeat2 = 268,
  aux_sym_switch_block_statement_group_repeat1 = 269,
  aux_sym_try_statement_repeat1 = 270,
  aux_sym_catch_type_repeat1 = 271,
  aux_sym_resource_specification_repeat1 = 272,
  aux_sym_for_statement_repeat1 = 273,
  aux_sym_for_statement_repeat2 = 274,
  aux_sym_annotation_argument_list_repeat1 = 275,
  aux_sym_element_value_array_initializer_repeat1 = 276,
  aux_sym_module_body_repeat1 = 277,
  aux_sym_requires_module_directive_repeat1 = 278,
  aux_sym_exports_module_directive_repeat1 = 279,
  aux_sym_provides_module_directive_repeat1 = 280,
  aux_sym_enum_body_repeat1 = 281,
  aux_sym_enum_body_declarations_repeat1 = 282,
  aux_sym_modifiers_repeat1 = 283,
  aux_sym_type_parameters_repeat1 = 284,
  aux_sym_type_bound_repeat1 = 285,
  aux_sym_type_list_repeat1 = 286,
  aux_sym_annotation_type_body_repeat1 = 287,
  aux_sym_interface_body_repeat1 = 288,
  aux_sym__variable_declarator_list_repeat1 = 289,
  aux_sym_array_initializer_repeat1 = 290,
  aux_sym_formal_parameters_repeat1 = 291,
  alias_sym_type_identifier = 292,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_decimal_integer_literal] = "decimal_integer_literal",
  [sym_hex_integer_literal] = "hex_integer_literal",
  [sym_octal_integer_literal] = "octal_integer_literal",
  [sym_binary_integer_literal] = "binary_integer_literal",
  [sym_decimal_floating_point_literal] = "decimal_floating_point_literal",
  [sym_hex_floating_point_literal] = "hex_floating_point_literal",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_character_literal] = "character_literal",
  [sym_string_literal] = "string_literal",
  [sym_text_block] = "text_block",
  [sym_null_literal] = "null_literal",
  [anon_sym_LPAREN] = "(",
  [anon_sym_AMP] = "&",
  [anon_sym_RPAREN] = ")",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_GT] = ">",
  [anon_sym_LT] = "<",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_PERCENT] = "%",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_final] = "final",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_COMMA] = ",",
  [anon_sym_QMARK] = "\?",
  [anon_sym_COLON] = ":",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_new] = "new",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_extends] = "extends",
  [anon_sym_switch] = "switch",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_SEMI] = ";",
  [anon_sym_assert] = "assert",
  [anon_sym_do] = "do",
  [anon_sym_while] = "while",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_return] = "return",
  [anon_sym_yield] = "yield",
  [anon_sym_synchronized] = "synchronized",
  [anon_sym_throw] = "throw",
  [anon_sym_try] = "try",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_for] = "for",
  [anon_sym_AT] = "@",
  [anon_sym_open] = "open",
  [anon_sym_module] = "module",
  [anon_sym_requires] = "requires",
  [anon_sym_transitive] = "transitive",
  [anon_sym_static] = "static",
  [anon_sym_exports] = "exports",
  [anon_sym_to] = "to",
  [anon_sym_opens] = "opens",
  [anon_sym_uses] = "uses",
  [anon_sym_provides] = "provides",
  [anon_sym_with] = "with",
  [anon_sym_package] = "package",
  [anon_sym_import] = "import",
  [anon_sym_enum] = "enum",
  [anon_sym_public] = "public",
  [anon_sym_protected] = "protected",
  [anon_sym_private] = "private",
  [anon_sym_abstract] = "abstract",
  [anon_sym_strictfp] = "strictfp",
  [anon_sym_native] = "native",
  [anon_sym_transient] = "transient",
  [anon_sym_volatile] = "volatile",
  [anon_sym_sealed] = "sealed",
  [anon_sym_non_DASHsealed] = "non-sealed",
  [anon_sym_implements] = "implements",
  [anon_sym_permits] = "permits",
  [anon_sym_record] = "record",
  [anon_sym_ATinterface] = "@interface",
  [anon_sym_interface] = "interface",
  [anon_sym_byte] = "byte",
  [anon_sym_short] = "short",
  [anon_sym_int] = "int",
  [anon_sym_long] = "long",
  [anon_sym_char] = "char",
  [anon_sym_float] = "float",
  [anon_sym_double] = "double",
  [sym_boolean_type] = "boolean_type",
  [sym_void_type] = "void_type",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_throws] = "throws",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_line_comment] = "line_comment",
  [sym_block_comment] = "block_comment",
  [sym_program] = "program",
  [sym__literal] = "_literal",
  [sym_expression] = "expression",
  [sym_cast_expression] = "cast_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_instanceof_expression] = "instanceof_expression",
  [sym_lambda_expression] = "lambda_expression",
  [sym_inferred_parameters] = "inferred_parameters",
  [sym_ternary_expression] = "ternary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_primary_expression] = "primary_expression",
  [sym_array_creation_expression] = "array_creation_expression",
  [sym_dimensions_expr] = "dimensions_expr",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_class_literal] = "class_literal",
  [sym_object_creation_expression] = "object_creation_expression",
  [sym__unqualified_object_creation_expression] = "_unqualified_object_creation_expression",
  [sym_field_access] = "field_access",
  [sym_array_access] = "array_access",
  [sym_method_invocation] = "method_invocation",
  [sym_argument_list] = "argument_list",
  [sym_method_reference] = "method_reference",
  [sym_type_arguments] = "type_arguments",
  [sym_wildcard] = "wildcard",
  [sym__wildcard_bounds] = "_wildcard_bounds",
  [sym_dimensions] = "dimensions",
  [sym_switch_expression] = "switch_expression",
  [sym_switch_block] = "switch_block",
  [sym_switch_block_statement_group] = "switch_block_statement_group",
  [sym_switch_rule] = "switch_rule",
  [sym_switch_label] = "switch_label",
  [sym_statement] = "statement",
  [sym_block] = "block",
  [sym_expression_statement] = "expression_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_assert_statement] = "assert_statement",
  [sym_do_statement] = "do_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_return_statement] = "return_statement",
  [sym_yield_statement] = "yield_statement",
  [sym_synchronized_statement] = "synchronized_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_catch_formal_parameter] = "catch_formal_parameter",
  [sym_catch_type] = "catch_type",
  [sym_finally_clause] = "finally_clause",
  [sym_try_with_resources_statement] = "try_with_resources_statement",
  [sym_resource_specification] = "resource_specification",
  [sym_resource] = "resource",
  [sym_if_statement] = "if_statement",
  [sym_while_statement] = "while_statement",
  [sym_for_statement] = "for_statement",
  [sym_enhanced_for_statement] = "enhanced_for_statement",
  [sym__annotation] = "_annotation",
  [sym_marker_annotation] = "marker_annotation",
  [sym_annotation] = "annotation",
  [sym_annotation_argument_list] = "annotation_argument_list",
  [sym_element_value_pair] = "element_value_pair",
  [sym__element_value] = "_element_value",
  [sym_element_value_array_initializer] = "element_value_array_initializer",
  [sym_declaration] = "declaration",
  [sym_module_declaration] = "module_declaration",
  [sym_module_body] = "module_body",
  [sym_module_directive] = "module_directive",
  [sym_requires_module_directive] = "requires_module_directive",
  [sym_requires_modifier] = "requires_modifier",
  [sym_exports_module_directive] = "exports_module_directive",
  [sym_opens_module_directive] = "opens_module_directive",
  [sym_uses_module_directive] = "uses_module_directive",
  [sym_provides_module_directive] = "provides_module_directive",
  [sym_package_declaration] = "package_declaration",
  [sym_import_declaration] = "import_declaration",
  [sym_asterisk] = "asterisk",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_body_declarations] = "enum_body_declarations",
  [sym_enum_constant] = "enum_constant",
  [sym_class_declaration] = "class_declaration",
  [sym_modifiers] = "modifiers",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_type_bound] = "type_bound",
  [sym_superclass] = "superclass",
  [sym_super_interfaces] = "super_interfaces",
  [sym_type_list] = "type_list",
  [sym_permits] = "permits",
  [sym_class_body] = "class_body",
  [sym_static_initializer] = "static_initializer",
  [sym_constructor_declaration] = "constructor_declaration",
  [sym__constructor_declarator] = "_constructor_declarator",
  [sym_constructor_body] = "constructor_body",
  [sym_explicit_constructor_invocation] = "explicit_constructor_invocation",
  [sym_scoped_identifier] = "scoped_identifier",
  [sym_field_declaration] = "field_declaration",
  [sym_record_declaration] = "record_declaration",
  [sym_annotation_type_declaration] = "annotation_type_declaration",
  [sym_annotation_type_body] = "annotation_type_body",
  [sym_annotation_type_element_declaration] = "annotation_type_element_declaration",
  [sym__default_value] = "_default_value",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_interfaces] = "extends_interfaces",
  [sym_interface_body] = "interface_body",
  [sym_constant_declaration] = "constant_declaration",
  [sym__variable_declarator_list] = "_variable_declarator_list",
  [sym_variable_declarator] = "variable_declarator",
  [sym__variable_declarator_id] = "_variable_declarator_id",
  [sym_array_initializer] = "array_initializer",
  [sym__type] = "_type",
  [sym__unannotated_type] = "_unannotated_type",
  [sym_annotated_type] = "annotated_type",
  [sym_scoped_type_identifier] = "scoped_type_identifier",
  [sym_generic_type] = "generic_type",
  [sym_array_type] = "array_type",
  [sym_integral_type] = "integral_type",
  [sym_floating_point_type] = "floating_point_type",
  [sym__method_header] = "_method_header",
  [sym__method_declarator] = "_method_declarator",
  [sym_formal_parameters] = "formal_parameters",
  [sym_formal_parameter] = "formal_parameter",
  [sym_receiver_parameter] = "receiver_parameter",
  [sym_spread_parameter] = "spread_parameter",
  [sym_throws] = "throws",
  [sym_local_variable_declaration] = "local_variable_declaration",
  [sym_method_declaration] = "method_declaration",
  [sym_compact_constructor_declaration] = "compact_constructor_declaration",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_cast_expression_repeat1] = "cast_expression_repeat1",
  [aux_sym_inferred_parameters_repeat1] = "inferred_parameters_repeat1",
  [aux_sym_array_creation_expression_repeat1] = "array_creation_expression_repeat1",
  [aux_sym_array_creation_expression_repeat2] = "array_creation_expression_repeat2",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_dimensions_repeat1] = "dimensions_repeat1",
  [aux_sym_switch_block_repeat1] = "switch_block_repeat1",
  [aux_sym_switch_block_repeat2] = "switch_block_repeat2",
  [aux_sym_switch_block_statement_group_repeat1] = "switch_block_statement_group_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_catch_type_repeat1] = "catch_type_repeat1",
  [aux_sym_resource_specification_repeat1] = "resource_specification_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_for_statement_repeat2] = "for_statement_repeat2",
  [aux_sym_annotation_argument_list_repeat1] = "annotation_argument_list_repeat1",
  [aux_sym_element_value_array_initializer_repeat1] = "element_value_array_initializer_repeat1",
  [aux_sym_module_body_repeat1] = "module_body_repeat1",
  [aux_sym_requires_module_directive_repeat1] = "requires_module_directive_repeat1",
  [aux_sym_exports_module_directive_repeat1] = "exports_module_directive_repeat1",
  [aux_sym_provides_module_directive_repeat1] = "provides_module_directive_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_enum_body_declarations_repeat1] = "enum_body_declarations_repeat1",
  [aux_sym_modifiers_repeat1] = "modifiers_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_type_bound_repeat1] = "type_bound_repeat1",
  [aux_sym_type_list_repeat1] = "type_list_repeat1",
  [aux_sym_annotation_type_body_repeat1] = "annotation_type_body_repeat1",
  [aux_sym_interface_body_repeat1] = "interface_body_repeat1",
  [aux_sym__variable_declarator_list_repeat1] = "_variable_declarator_list_repeat1",
  [aux_sym_array_initializer_repeat1] = "array_initializer_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_decimal_integer_literal] = sym_decimal_integer_literal,
  [sym_hex_integer_literal] = sym_hex_integer_literal,
  [sym_octal_integer_literal] = sym_octal_integer_literal,
  [sym_binary_integer_literal] = sym_binary_integer_literal,
  [sym_decimal_floating_point_literal] = sym_decimal_floating_point_literal,
  [sym_hex_floating_point_literal] = sym_hex_floating_point_literal,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_character_literal] = sym_character_literal,
  [sym_string_literal] = sym_string_literal,
  [sym_text_block] = sym_text_block,
  [sym_null_literal] = sym_null_literal,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_final] = anon_sym_final,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_synchronized] = anon_sym_synchronized,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_open] = anon_sym_open,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_requires] = anon_sym_requires,
  [anon_sym_transitive] = anon_sym_transitive,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_exports] = anon_sym_exports,
  [anon_sym_to] = anon_sym_to,
  [anon_sym_opens] = anon_sym_opens,
  [anon_sym_uses] = anon_sym_uses,
  [anon_sym_provides] = anon_sym_provides,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_package] = anon_sym_package,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_strictfp] = anon_sym_strictfp,
  [anon_sym_native] = anon_sym_native,
  [anon_sym_transient] = anon_sym_transient,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_sealed] = anon_sym_sealed,
  [anon_sym_non_DASHsealed] = anon_sym_non_DASHsealed,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_permits] = anon_sym_permits,
  [anon_sym_record] = anon_sym_record,
  [anon_sym_ATinterface] = anon_sym_ATinterface,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_byte] = anon_sym_byte,
  [anon_sym_short] = anon_sym_short,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_long] = anon_sym_long,
  [anon_sym_char] = anon_sym_char,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_double] = anon_sym_double,
  [sym_boolean_type] = sym_boolean_type,
  [sym_void_type] = sym_void_type,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_throws] = anon_sym_throws,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_line_comment] = sym_line_comment,
  [sym_block_comment] = sym_block_comment,
  [sym_program] = sym_program,
  [sym__literal] = sym__literal,
  [sym_expression] = sym_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_instanceof_expression] = sym_instanceof_expression,
  [sym_lambda_expression] = sym_lambda_expression,
  [sym_inferred_parameters] = sym_inferred_parameters,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_array_creation_expression] = sym_array_creation_expression,
  [sym_dimensions_expr] = sym_dimensions_expr,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_class_literal] = sym_class_literal,
  [sym_object_creation_expression] = sym_object_creation_expression,
  [sym__unqualified_object_creation_expression] = sym__unqualified_object_creation_expression,
  [sym_field_access] = sym_field_access,
  [sym_array_access] = sym_array_access,
  [sym_method_invocation] = sym_method_invocation,
  [sym_argument_list] = sym_argument_list,
  [sym_method_reference] = sym_method_reference,
  [sym_type_arguments] = sym_type_arguments,
  [sym_wildcard] = sym_wildcard,
  [sym__wildcard_bounds] = sym__wildcard_bounds,
  [sym_dimensions] = sym_dimensions,
  [sym_switch_expression] = sym_switch_expression,
  [sym_switch_block] = sym_switch_block,
  [sym_switch_block_statement_group] = sym_switch_block_statement_group,
  [sym_switch_rule] = sym_switch_rule,
  [sym_switch_label] = sym_switch_label,
  [sym_statement] = sym_statement,
  [sym_block] = sym_block,
  [sym_expression_statement] = sym_expression_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_assert_statement] = sym_assert_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_yield_statement] = sym_yield_statement,
  [sym_synchronized_statement] = sym_synchronized_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_catch_formal_parameter] = sym_catch_formal_parameter,
  [sym_catch_type] = sym_catch_type,
  [sym_finally_clause] = sym_finally_clause,
  [sym_try_with_resources_statement] = sym_try_with_resources_statement,
  [sym_resource_specification] = sym_resource_specification,
  [sym_resource] = sym_resource,
  [sym_if_statement] = sym_if_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_enhanced_for_statement] = sym_enhanced_for_statement,
  [sym__annotation] = sym__annotation,
  [sym_marker_annotation] = sym_marker_annotation,
  [sym_annotation] = sym_annotation,
  [sym_annotation_argument_list] = sym_annotation_argument_list,
  [sym_element_value_pair] = sym_element_value_pair,
  [sym__element_value] = sym__element_value,
  [sym_element_value_array_initializer] = sym_element_value_array_initializer,
  [sym_declaration] = sym_declaration,
  [sym_module_declaration] = sym_module_declaration,
  [sym_module_body] = sym_module_body,
  [sym_module_directive] = sym_module_directive,
  [sym_requires_module_directive] = sym_requires_module_directive,
  [sym_requires_modifier] = sym_requires_modifier,
  [sym_exports_module_directive] = sym_exports_module_directive,
  [sym_opens_module_directive] = sym_opens_module_directive,
  [sym_uses_module_directive] = sym_uses_module_directive,
  [sym_provides_module_directive] = sym_provides_module_directive,
  [sym_package_declaration] = sym_package_declaration,
  [sym_import_declaration] = sym_import_declaration,
  [sym_asterisk] = sym_asterisk,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_body_declarations] = sym_enum_body_declarations,
  [sym_enum_constant] = sym_enum_constant,
  [sym_class_declaration] = sym_class_declaration,
  [sym_modifiers] = sym_modifiers,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_type_bound] = sym_type_bound,
  [sym_superclass] = sym_superclass,
  [sym_super_interfaces] = sym_super_interfaces,
  [sym_type_list] = sym_type_list,
  [sym_permits] = sym_permits,
  [sym_class_body] = sym_class_body,
  [sym_static_initializer] = sym_static_initializer,
  [sym_constructor_declaration] = sym_constructor_declaration,
  [sym__constructor_declarator] = sym__constructor_declarator,
  [sym_constructor_body] = sym_constructor_body,
  [sym_explicit_constructor_invocation] = sym_explicit_constructor_invocation,
  [sym_scoped_identifier] = sym_scoped_identifier,
  [sym_field_declaration] = sym_field_declaration,
  [sym_record_declaration] = sym_record_declaration,
  [sym_annotation_type_declaration] = sym_annotation_type_declaration,
  [sym_annotation_type_body] = sym_annotation_type_body,
  [sym_annotation_type_element_declaration] = sym_annotation_type_element_declaration,
  [sym__default_value] = sym__default_value,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_extends_interfaces] = sym_extends_interfaces,
  [sym_interface_body] = sym_interface_body,
  [sym_constant_declaration] = sym_constant_declaration,
  [sym__variable_declarator_list] = sym__variable_declarator_list,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym__variable_declarator_id] = sym__variable_declarator_id,
  [sym_array_initializer] = sym_array_initializer,
  [sym__type] = sym__type,
  [sym__unannotated_type] = sym__unannotated_type,
  [sym_annotated_type] = sym_annotated_type,
  [sym_scoped_type_identifier] = sym_scoped_type_identifier,
  [sym_generic_type] = sym_generic_type,
  [sym_array_type] = sym_array_type,
  [sym_integral_type] = sym_integral_type,
  [sym_floating_point_type] = sym_floating_point_type,
  [sym__method_header] = sym__method_header,
  [sym__method_declarator] = sym__method_declarator,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_formal_parameter] = sym_formal_parameter,
  [sym_receiver_parameter] = sym_receiver_parameter,
  [sym_spread_parameter] = sym_spread_parameter,
  [sym_throws] = sym_throws,
  [sym_local_variable_declaration] = sym_local_variable_declaration,
  [sym_method_declaration] = sym_method_declaration,
  [sym_compact_constructor_declaration] = sym_compact_constructor_declaration,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_cast_expression_repeat1] = aux_sym_cast_expression_repeat1,
  [aux_sym_inferred_parameters_repeat1] = aux_sym_inferred_parameters_repeat1,
  [aux_sym_array_creation_expression_repeat1] = aux_sym_array_creation_expression_repeat1,
  [aux_sym_array_creation_expression_repeat2] = aux_sym_array_creation_expression_repeat2,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_type_arguments_repeat1] = aux_sym_type_arguments_repeat1,
  [aux_sym_dimensions_repeat1] = aux_sym_dimensions_repeat1,
  [aux_sym_switch_block_repeat1] = aux_sym_switch_block_repeat1,
  [aux_sym_switch_block_repeat2] = aux_sym_switch_block_repeat2,
  [aux_sym_switch_block_statement_group_repeat1] = aux_sym_switch_block_statement_group_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_catch_type_repeat1] = aux_sym_catch_type_repeat1,
  [aux_sym_resource_specification_repeat1] = aux_sym_resource_specification_repeat1,
  [aux_sym_for_statement_repeat1] = aux_sym_for_statement_repeat1,
  [aux_sym_for_statement_repeat2] = aux_sym_for_statement_repeat2,
  [aux_sym_annotation_argument_list_repeat1] = aux_sym_annotation_argument_list_repeat1,
  [aux_sym_element_value_array_initializer_repeat1] = aux_sym_element_value_array_initializer_repeat1,
  [aux_sym_module_body_repeat1] = aux_sym_module_body_repeat1,
  [aux_sym_requires_module_directive_repeat1] = aux_sym_requires_module_directive_repeat1,
  [aux_sym_exports_module_directive_repeat1] = aux_sym_exports_module_directive_repeat1,
  [aux_sym_provides_module_directive_repeat1] = aux_sym_provides_module_directive_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_enum_body_declarations_repeat1] = aux_sym_enum_body_declarations_repeat1,
  [aux_sym_modifiers_repeat1] = aux_sym_modifiers_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_type_bound_repeat1] = aux_sym_type_bound_repeat1,
  [aux_sym_type_list_repeat1] = aux_sym_type_list_repeat1,
  [aux_sym_annotation_type_body_repeat1] = aux_sym_annotation_type_body_repeat1,
  [aux_sym_interface_body_repeat1] = aux_sym_interface_body_repeat1,
  [aux_sym__variable_declarator_list_repeat1] = aux_sym__variable_declarator_list_repeat1,
  [aux_sym_array_initializer_repeat1] = aux_sym_array_initializer_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_hex_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_octal_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal_floating_point_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_hex_floating_point_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_character_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_text_block] = {
    .visible = true,
    .named = true,
  },
  [sym_null_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_final] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_synchronized] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_open] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_requires] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_transitive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exports] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_to] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_opens] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uses] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_provides] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_package] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_strictfp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_native] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_transient] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sealed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_non_DASHsealed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_permits] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_record] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATinterface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_byte] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_char] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_double] = {
    .visible = true,
    .named = false,
  },
  [sym_boolean_type] = {
    .visible = true,
    .named = true,
  },
  [sym_void_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throws] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_instanceof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_inferred_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_array_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_dimensions_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_object_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__unqualified_object_creation_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_field_access] = {
    .visible = true,
    .named = true,
  },
  [sym_array_access] = {
    .visible = true,
    .named = true,
  },
  [sym_method_invocation] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_method_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_wildcard] = {
    .visible = true,
    .named = true,
  },
  [sym__wildcard_bounds] = {
    .visible = false,
    .named = true,
  },
  [sym_dimensions] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_block] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_block_statement_group] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_rule] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_label] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_synchronized_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_formal_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_type] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_try_with_resources_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_resource_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_resource] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_enhanced_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__annotation] = {
    .visible = false,
    .named = true,
  },
  [sym_marker_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_element_value_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__element_value] = {
    .visible = false,
    .named = true,
  },
  [sym_element_value_array_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_module_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module_body] = {
    .visible = true,
    .named = true,
  },
  [sym_module_directive] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_requires_module_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_requires_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_exports_module_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_opens_module_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_uses_module_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_provides_module_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_package_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_import_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_asterisk] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body_declarations] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_constant] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_modifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type_bound] = {
    .visible = true,
    .named = true,
  },
  [sym_superclass] = {
    .visible = true,
    .named = true,
  },
  [sym_super_interfaces] = {
    .visible = true,
    .named = true,
  },
  [sym_type_list] = {
    .visible = true,
    .named = true,
  },
  [sym_permits] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_static_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__constructor_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_body] = {
    .visible = true,
    .named = true,
  },
  [sym_explicit_constructor_invocation] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_record_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_type_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_type_body] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_type_element_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__default_value] = {
    .visible = false,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_interfaces] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_body] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_declarator_list] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_declarator_id] = {
    .visible = false,
    .named = true,
  },
  [sym_array_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__unannotated_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_annotated_type] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_integral_type] = {
    .visible = true,
    .named = true,
  },
  [sym_floating_point_type] = {
    .visible = true,
    .named = true,
  },
  [sym__method_header] = {
    .visible = false,
    .named = true,
  },
  [sym__method_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_receiver_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_spread_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_throws] = {
    .visible = true,
    .named = true,
  },
  [sym_local_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_compact_constructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_inferred_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_creation_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_creation_expression_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dimensions_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_block_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_block_statement_group_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_catch_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_resource_specification_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_annotation_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_element_value_array_initializer_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_requires_module_directive_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exports_module_directive_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_provides_module_directive_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_declarations_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_modifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_bound_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_annotation_type_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interface_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__variable_declarator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_initializer_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alternative = 1,
  field_arguments = 2,
  field_array = 3,
  field_body = 4,
  field_condition = 5,
  field_consequence = 6,
  field_constructor = 7,
  field_declarator = 8,
  field_dimensions = 9,
  field_element = 10,
  field_field = 11,
  field_index = 12,
  field_init = 13,
  field_interfaces = 14,
  field_key = 15,
  field_left = 16,
  field_modifiers = 17,
  field_module = 18,
  field_modules = 19,
  field_name = 20,
  field_object = 21,
  field_operand = 22,
  field_operator = 23,
  field_package = 24,
  field_parameters = 25,
  field_permits = 26,
  field_provided = 27,
  field_provider = 28,
  field_resources = 29,
  field_right = 30,
  field_scope = 31,
  field_superclass = 32,
  field_type = 33,
  field_type_arguments = 34,
  field_type_parameters = 35,
  field_update = 36,
  field_value = 37,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_arguments] = "arguments",
  [field_array] = "array",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constructor] = "constructor",
  [field_declarator] = "declarator",
  [field_dimensions] = "dimensions",
  [field_element] = "element",
  [field_field] = "field",
  [field_index] = "index",
  [field_init] = "init",
  [field_interfaces] = "interfaces",
  [field_key] = "key",
  [field_left] = "left",
  [field_modifiers] = "modifiers",
  [field_module] = "module",
  [field_modules] = "modules",
  [field_name] = "name",
  [field_object] = "object",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_package] = "package",
  [field_parameters] = "parameters",
  [field_permits] = "permits",
  [field_provided] = "provided",
  [field_provider] = "provider",
  [field_resources] = "resources",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_superclass] = "superclass",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [3] = {.index = 0, .length = 3},
  [4] = {.index = 3, .length = 2},
  [5] = {.index = 5, .length = 1},
  [6] = {.index = 5, .length = 1},
  [7] = {.index = 6, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 8, .length = 1},
  [10] = {.index = 8, .length = 1},
  [11] = {.index = 9, .length = 2},
  [12] = {.index = 11, .length = 1},
  [13] = {.index = 12, .length = 2},
  [15] = {.index = 14, .length = 3},
  [16] = {.index = 17, .length = 2},
  [17] = {.index = 19, .length = 2},
  [18] = {.index = 17, .length = 2},
  [19] = {.index = 19, .length = 2},
  [20] = {.index = 21, .length = 2},
  [21] = {.index = 23, .length = 2},
  [22] = {.index = 25, .length = 1},
  [23] = {.index = 26, .length = 1},
  [24] = {.index = 27, .length = 2},
  [25] = {.index = 29, .length = 2},
  [26] = {.index = 31, .length = 2},
  [27] = {.index = 31, .length = 2},
  [28] = {.index = 33, .length = 3},
  [29] = {.index = 36, .length = 2},
  [30] = {.index = 21, .length = 2},
  [31] = {.index = 38, .length = 2},
  [32] = {.index = 38, .length = 2},
  [33] = {.index = 33, .length = 3},
  [34] = {.index = 36, .length = 2},
  [36] = {.index = 40, .length = 2},
  [37] = {.index = 42, .length = 3},
  [38] = {.index = 45, .length = 2},
  [39] = {.index = 45, .length = 2},
  [40] = {.index = 47, .length = 2},
  [41] = {.index = 49, .length = 2},
  [43] = {.index = 51, .length = 3},
  [44] = {.index = 54, .length = 1},
  [45] = {.index = 55, .length = 2},
  [46] = {.index = 57, .length = 2},
  [47] = {.index = 59, .length = 3},
  [48] = {.index = 62, .length = 3},
  [49] = {.index = 59, .length = 3},
  [50] = {.index = 62, .length = 3},
  [51] = {.index = 65, .length = 3},
  [52] = {.index = 65, .length = 3},
  [53] = {.index = 68, .length = 2},
  [54] = {.index = 68, .length = 2},
  [55] = {.index = 70, .length = 3},
  [56] = {.index = 73, .length = 3},
  [57] = {.index = 76, .length = 3},
  [58] = {.index = 79, .length = 3},
  [59] = {.index = 82, .length = 2},
  [60] = {.index = 82, .length = 2},
  [61] = {.index = 84, .length = 2},
  [62] = {.index = 84, .length = 2},
  [64] = {.index = 86, .length = 3},
  [65] = {.index = 89, .length = 2},
  [66] = {.index = 91, .length = 3},
  [67] = {.index = 91, .length = 3},
  [69] = {.index = 94, .length = 2},
  [70] = {.index = 96, .length = 3},
  [71] = {.index = 96, .length = 3},
  [72] = {.index = 99, .length = 2},
  [73] = {.index = 101, .length = 2},
  [74] = {.index = 103, .length = 1},
  [75] = {.index = 104, .length = 2},
  [76] = {.index = 106, .length = 3},
  [78] = {.index = 109, .length = 3},
  [79] = {.index = 112, .length = 3},
  [80] = {.index = 115, .length = 3},
  [81] = {.index = 112, .length = 3},
  [82] = {.index = 115, .length = 3},
  [84] = {.index = 118, .length = 2},
  [85] = {.index = 120, .length = 2},
  [86] = {.index = 122, .length = 4},
  [87] = {.index = 126, .length = 4},
  [88] = {.index = 130, .length = 5},
  [89] = {.index = 135, .length = 6},
  [90] = {.index = 141, .length = 4},
  [91] = {.index = 145, .length = 4},
  [92] = {.index = 149, .length = 4},
  [93] = {.index = 153, .length = 4},
  [94] = {.index = 157, .length = 4},
  [95] = {.index = 161, .length = 4},
  [96] = {.index = 165, .length = 2},
  [97] = {.index = 167, .length = 3},
  [98] = {.index = 170, .length = 1},
  [99] = {.index = 171, .length = 2},
  [100] = {.index = 173, .length = 1},
  [101] = {.index = 174, .length = 4},
  [102] = {.index = 178, .length = 4},
  [103] = {.index = 182, .length = 3},
  [104] = {.index = 185, .length = 3},
  [105] = {.index = 188, .length = 2},
  [106] = {.index = 188, .length = 2},
  [107] = {.index = 190, .length = 4},
  [108] = {.index = 190, .length = 4},
  [109] = {.index = 194, .length = 3},
  [110] = {.index = 194, .length = 3},
  [111] = {.index = 197, .length = 3},
  [112] = {.index = 200, .length = 3},
  [113] = {.index = 203, .length = 3},
  [114] = {.index = 206, .length = 3},
  [115] = {.index = 209, .length = 3},
  [116] = {.index = 212, .length = 3},
  [117] = {.index = 215, .length = 2},
  [118] = {.index = 217, .length = 2},
  [119] = {.index = 217, .length = 2},
  [120] = {.index = 219, .length = 4},
  [121] = {.index = 223, .length = 5},
  [122] = {.index = 228, .length = 6},
  [123] = {.index = 234, .length = 3},
  [124] = {.index = 237, .length = 5},
  [125] = {.index = 242, .length = 4},
  [126] = {.index = 120, .length = 2},
  [127] = {.index = 246, .length = 5},
  [128] = {.index = 251, .length = 5},
  [129] = {.index = 256, .length = 5},
  [130] = {.index = 261, .length = 5},
  [131] = {.index = 266, .length = 4},
  [132] = {.index = 270, .length = 2},
  [133] = {.index = 272, .length = 1},
  [134] = {.index = 273, .length = 2},
  [135] = {.index = 275, .length = 2},
  [136] = {.index = 277, .length = 1},
  [137] = {.index = 277, .length = 1},
  [138] = {.index = 278, .length = 2},
  [139] = {.index = 280, .length = 1},
  [140] = {.index = 280, .length = 1},
  [141] = {.index = 54, .length = 1},
  [142] = {.index = 281, .length = 3},
  [143] = {.index = 284, .length = 5},
  [144] = {.index = 289, .length = 4},
  [145] = {.index = 293, .length = 3},
  [146] = {.index = 293, .length = 3},
  [147] = {.index = 296, .length = 4},
  [148] = {.index = 300, .length = 4},
  [149] = {.index = 304, .length = 4},
  [150] = {.index = 308, .length = 4},
  [151] = {.index = 312, .length = 4},
  [152] = {.index = 316, .length = 4},
  [153] = {.index = 320, .length = 4},
  [154] = {.index = 324, .length = 4},
  [155] = {.index = 328, .length = 3},
  [156] = {.index = 331, .length = 3},
  [157] = {.index = 334, .length = 4},
  [158] = {.index = 338, .length = 5},
  [159] = {.index = 343, .length = 3},
  [160] = {.index = 343, .length = 3},
  [161] = {.index = 346, .length = 6},
  [162] = {.index = 352, .length = 4},
  [163] = {.index = 356, .length = 1},
  [164] = {.index = 357, .length = 2},
  [165] = {.index = 359, .length = 2},
  [166] = {.index = 361, .length = 1},
  [167] = {.index = 362, .length = 2},
  [168] = {.index = 364, .length = 2},
  [169] = {.index = 366, .length = 2},
  [170] = {.index = 368, .length = 3},
  [171] = {.index = 371, .length = 3},
  [172] = {.index = 374, .length = 2},
  [173] = {.index = 374, .length = 2},
  [174] = {.index = 376, .length = 3},
  [175] = {.index = 379, .length = 4},
  [176] = {.index = 379, .length = 4},
  [177] = {.index = 383, .length = 5},
  [178] = {.index = 388, .length = 5},
  [179] = {.index = 393, .length = 5},
  [180] = {.index = 398, .length = 5},
  [181] = {.index = 403, .length = 5},
  [182] = {.index = 408, .length = 4},
  [183] = {.index = 412, .length = 2},
  [184] = {.index = 414, .length = 3},
  [185] = {.index = 417, .length = 3},
  [186] = {.index = 420, .length = 3},
  [187] = {.index = 423, .length = 3},
  [188] = {.index = 426, .length = 3},
  [189] = {.index = 429, .length = 5},
  [190] = {.index = 434, .length = 4},
  [191] = {.index = 438, .length = 4},
  [192] = {.index = 442, .length = 2},
  [193] = {.index = 442, .length = 2},
  [194] = {.index = 442, .length = 2},
  [195] = {.index = 442, .length = 2},
  [196] = {.index = 444, .length = 1},
  [197] = {.index = 444, .length = 1},
  [198] = {.index = 444, .length = 1},
  [199] = {.index = 444, .length = 1},
  [200] = {.index = 445, .length = 2},
  [201] = {.index = 447, .length = 6},
  [202] = {.index = 453, .length = 3},
  [203] = {.index = 456, .length = 4},
  [204] = {.index = 460, .length = 4},
  [205] = {.index = 464, .length = 4},
  [206] = {.index = 468, .length = 4},
  [207] = {.index = 472, .length = 4},
  [208] = {.index = 476, .length = 5},
  [209] = {.index = 481, .length = 5},
  [210] = {.index = 486, .length = 1},
  [211] = {.index = 486, .length = 1},
  [212] = {.index = 487, .length = 3},
  [213] = {.index = 490, .length = 2},
  [214] = {.index = 487, .length = 3},
  [215] = {.index = 487, .length = 3},
  [216] = {.index = 487, .length = 3},
  [217] = {.index = 492, .length = 1},
  [218] = {.index = 492, .length = 1},
  [219] = {.index = 493, .length = 2},
  [220] = {.index = 495, .length = 2},
  [221] = {.index = 493, .length = 2},
  [222] = {.index = 493, .length = 2},
  [223] = {.index = 493, .length = 2},
  [224] = {.index = 497, .length = 2},
  [225] = {.index = 499, .length = 1},
  [226] = {.index = 500, .length = 3},
  [227] = {.index = 503, .length = 3},
  [228] = {.index = 506, .length = 3},
  [229] = {.index = 509, .length = 5},
  [230] = {.index = 514, .length = 5},
  [231] = {.index = 519, .length = 5},
  [232] = {.index = 524, .length = 3},
  [233] = {.index = 527, .length = 3},
  [234] = {.index = 530, .length = 4},
  [235] = {.index = 534, .length = 4},
  [236] = {.index = 538, .length = 6},
  [237] = {.index = 544, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_arguments, 0, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_type_arguments, 0, .inherited = true},
  [3] =
    {field_operand, 1},
    {field_operator, 0},
  [5] =
    {field_name, 1},
  [6] =
    {field_arguments, 1},
    {field_name, 0},
  [8] =
    {field_name, 0},
  [9] =
    {field_dimensions, 1},
    {field_element, 0},
  [11] =
    {field_declarator, 0},
  [12] =
    {field_dimensions, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [14] =
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_type, 0},
  [17] =
    {field_arguments, 2},
    {field_type, 1},
  [19] =
    {field_dimensions, 2},
    {field_type, 1},
  [21] =
    {field_body, 2},
    {field_name, 1},
  [23] =
    {field_body, 2},
    {field_condition, 1},
  [25] =
    {field_body, 2},
  [26] =
    {field_body, 1},
  [27] =
    {field_body, 2},
    {field_resources, 1},
  [29] =
    {field_condition, 1},
    {field_consequence, 2},
  [31] =
    {field_arguments, 2},
    {field_name, 1},
  [33] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [36] =
    {field_body, 2},
    {field_parameters, 0},
  [38] =
    {field_field, 2},
    {field_object, 0},
  [40] =
    {field_left, 0},
    {field_right, 2},
  [42] =
    {field_arguments, 2, .inherited = true},
    {field_type, 2, .inherited = true},
    {field_type_arguments, 2, .inherited = true},
  [45] =
    {field_dimensions, 1},
    {field_name, 0},
  [47] =
    {field_declarator, 1, .inherited = true},
    {field_type, 0},
  [49] =
    {field_declarator, 0},
    {field_declarator, 1, .inherited = true},
  [51] =
    {field_dimensions, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_type, 1},
  [54] =
    {field_type, 1},
  [55] =
    {field_type, 1},
    {field_value, 3},
  [57] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [59] =
    {field_dimensions, 2},
    {field_type, 1},
    {field_value, 3},
  [62] =
    {field_dimensions, 2},
    {field_dimensions, 3},
    {field_type, 1},
  [65] =
    {field_arguments, 3},
    {field_type, 2},
    {field_type_arguments, 1},
  [68] =
    {field_dimensions, 3},
    {field_type, 2},
  [70] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [73] =
    {field_body, 3},
    {field_name, 1},
    {field_superclass, 2},
  [76] =
    {field_body, 3},
    {field_interfaces, 2},
    {field_name, 1},
  [79] =
    {field_body, 3},
    {field_name, 1},
    {field_permits, 2},
  [82] =
    {field_name, 2},
    {field_scope, 0},
  [84] =
    {field_body, 3},
    {field_name, 2},
  [86] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2},
  [89] =
    {field_body, 3},
    {field_name, 1},
  [91] =
    {field_arguments, 3},
    {field_name, 2},
    {field_object, 0},
  [94] =
    {field_left, 0},
    {field_right, 3},
  [96] =
    {field_left, 0},
    {field_name, 3},
    {field_right, 2},
  [99] =
    {field_array, 0},
    {field_index, 2},
  [101] =
    {field_declarator, 2, .inherited = true},
    {field_type, 1},
  [103] =
    {field_declarator, 1},
  [104] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
  [106] =
    {field_dimensions, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_value, 2},
  [109] =
    {field_type, 1},
    {field_type, 2, .inherited = true},
    {field_value, 4},
  [112] =
    {field_dimensions, 3},
    {field_type, 2},
    {field_value, 4},
  [115] =
    {field_dimensions, 3},
    {field_dimensions, 4},
    {field_type, 2},
  [118] =
    {field_body, 1},
    {field_name, 0},
  [120] =
    {field_name, 0},
    {field_parameters, 1},
  [122] =
    {field_body, 1},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [126] =
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type, 0},
  [130] =
    {field_dimensions, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [135] =
    {field_body, 1},
    {field_dimensions, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [141] =
    {field_body, 4},
    {field_name, 1},
    {field_superclass, 3},
    {field_type_parameters, 2},
  [145] =
    {field_body, 4},
    {field_interfaces, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [149] =
    {field_body, 4},
    {field_name, 1},
    {field_permits, 3},
    {field_type_parameters, 2},
  [153] =
    {field_body, 4},
    {field_interfaces, 3},
    {field_name, 1},
    {field_superclass, 2},
  [157] =
    {field_body, 4},
    {field_name, 1},
    {field_permits, 3},
    {field_superclass, 2},
  [161] =
    {field_body, 4},
    {field_interfaces, 2},
    {field_name, 1},
    {field_permits, 3},
  [165] =
    {field_body, 1},
    {field_condition, 3},
  [167] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [170] =
    {field_init, 1},
  [171] =
    {field_init, 0, .inherited = true},
    {field_init, 1, .inherited = true},
  [173] =
    {field_modifiers, 0},
  [174] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [178] =
    {field_body, 4},
    {field_interfaces, 3},
    {field_name, 1},
    {field_parameters, 2},
  [182] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [185] =
    {field_body, 4},
    {field_name, 1},
    {field_permits, 3},
  [188] =
    {field_field, 4},
    {field_object, 0},
  [190] =
    {field_arguments, 4},
    {field_name, 3},
    {field_object, 0},
    {field_type_arguments, 2},
  [194] =
    {field_left, 0},
    {field_name, 4},
    {field_right, 3},
  [197] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [200] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [203] =
    {field_body, 4},
    {field_name, 2},
    {field_superclass, 3},
  [206] =
    {field_body, 4},
    {field_interfaces, 3},
    {field_name, 2},
  [209] =
    {field_body, 4},
    {field_name, 2},
    {field_permits, 3},
  [212] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
  [215] =
    {field_body, 4},
    {field_name, 2},
  [217] =
    {field_body, 4},
    {field_name, 3},
  [219] =
    {field_body, 2},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [223] =
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [228] =
    {field_body, 2},
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [234] =
    {field_name, 1},
    {field_parameters, 2},
    {field_type_parameters, 0},
  [237] =
    {field_dimensions, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_parameters, 2, .inherited = true},
    {field_type, 1},
    {field_type_parameters, 0},
  [242] =
    {field_body, 2},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [246] =
    {field_body, 5},
    {field_interfaces, 4},
    {field_name, 1},
    {field_superclass, 3},
    {field_type_parameters, 2},
  [251] =
    {field_body, 5},
    {field_name, 1},
    {field_permits, 4},
    {field_superclass, 3},
    {field_type_parameters, 2},
  [256] =
    {field_body, 5},
    {field_interfaces, 3},
    {field_name, 1},
    {field_permits, 4},
    {field_type_parameters, 2},
  [261] =
    {field_body, 5},
    {field_interfaces, 3},
    {field_name, 1},
    {field_permits, 4},
    {field_superclass, 2},
  [266] =
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_type, 0},
    {field_value, 3},
  [270] =
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [272] =
    {field_body, 5},
  [273] =
    {field_body, 5},
    {field_init, 2},
  [275] =
    {field_key, 0},
    {field_value, 2},
  [277] =
    {field_module, 1},
  [278] =
    {field_modifiers, 0, .inherited = true},
    {field_modifiers, 1, .inherited = true},
  [280] =
    {field_package, 1},
  [281] =
    {field_arguments, 1},
    {field_body, 2},
    {field_name, 0},
  [284] =
    {field_body, 5},
    {field_interfaces, 4},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [289] =
    {field_body, 5},
    {field_name, 1},
    {field_permits, 4},
    {field_type_parameters, 2},
  [293] =
    {field_arguments, 5},
    {field_name, 4},
    {field_object, 0},
  [296] =
    {field_body, 5},
    {field_name, 2},
    {field_superclass, 4},
    {field_type_parameters, 3},
  [300] =
    {field_body, 5},
    {field_interfaces, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [304] =
    {field_body, 5},
    {field_name, 2},
    {field_permits, 4},
    {field_type_parameters, 3},
  [308] =
    {field_body, 5},
    {field_interfaces, 4},
    {field_name, 2},
    {field_superclass, 3},
  [312] =
    {field_body, 5},
    {field_name, 2},
    {field_permits, 4},
    {field_superclass, 3},
  [316] =
    {field_body, 5},
    {field_interfaces, 3},
    {field_name, 2},
    {field_permits, 4},
  [320] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [324] =
    {field_body, 5},
    {field_interfaces, 4},
    {field_name, 2},
    {field_parameters, 3},
  [328] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [331] =
    {field_body, 5},
    {field_name, 2},
    {field_permits, 4},
  [334] =
    {field_body, 3},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [338] =
    {field_dimensions, 3, .inherited = true},
    {field_name, 3, .inherited = true},
    {field_parameters, 3, .inherited = true},
    {field_type, 2},
    {field_type_parameters, 0},
  [343] =
    {field_dimensions, 2},
    {field_name, 0},
    {field_parameters, 1},
  [346] =
    {field_body, 6},
    {field_interfaces, 4},
    {field_name, 1},
    {field_permits, 5},
    {field_superclass, 3},
    {field_type_parameters, 2},
  [352] =
    {field_dimensions, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_type, 1},
    {field_value, 4},
  [356] =
    {field_body, 4},
  [357] =
    {field_dimensions, 2, .inherited = true},
    {field_name, 2, .inherited = true},
  [359] =
    {field_body, 6},
    {field_update, 4},
  [361] =
    {field_update, 1},
  [362] =
    {field_update, 0, .inherited = true},
    {field_update, 1, .inherited = true},
  [364] =
    {field_body, 6},
    {field_condition, 3},
  [366] =
    {field_body, 6},
    {field_init, 2},
  [368] =
    {field_body, 6},
    {field_init, 2},
    {field_update, 4},
  [371] =
    {field_body, 6},
    {field_condition, 3},
    {field_init, 2},
  [374] =
    {field_modifiers, 1, .inherited = true},
    {field_module, 2},
  [376] =
    {field_arguments, 2},
    {field_body, 3},
    {field_name, 1},
  [379] =
    {field_arguments, 6},
    {field_name, 5},
    {field_object, 0},
    {field_type_arguments, 4},
  [383] =
    {field_body, 6},
    {field_interfaces, 5},
    {field_name, 2},
    {field_superclass, 4},
    {field_type_parameters, 3},
  [388] =
    {field_body, 6},
    {field_name, 2},
    {field_permits, 5},
    {field_superclass, 4},
    {field_type_parameters, 3},
  [393] =
    {field_body, 6},
    {field_interfaces, 4},
    {field_name, 2},
    {field_permits, 5},
    {field_type_parameters, 3},
  [398] =
    {field_body, 6},
    {field_interfaces, 4},
    {field_name, 2},
    {field_permits, 5},
    {field_superclass, 3},
  [403] =
    {field_body, 6},
    {field_interfaces, 5},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [408] =
    {field_body, 6},
    {field_name, 2},
    {field_permits, 5},
    {field_type_parameters, 3},
  [412] =
    {field_arguments, 1},
    {field_constructor, 0},
  [414] =
    {field_body, 7},
    {field_update, 4},
    {field_update, 5, .inherited = true},
  [417] =
    {field_body, 7},
    {field_condition, 3},
    {field_update, 5},
  [420] =
    {field_body, 7},
    {field_init, 2},
    {field_update, 5},
  [423] =
    {field_body, 7},
    {field_condition, 4},
    {field_init, 2},
  [426] =
    {field_body, 7},
    {field_init, 2},
    {field_init, 3, .inherited = true},
  [429] =
    {field_body, 7},
    {field_dimensions, 3, .inherited = true},
    {field_name, 3, .inherited = true},
    {field_type, 2},
    {field_value, 5},
  [434] =
    {field_body, 7},
    {field_init, 2},
    {field_update, 4},
    {field_update, 5, .inherited = true},
  [438] =
    {field_body, 7},
    {field_condition, 3},
    {field_init, 2},
    {field_update, 5},
  [442] =
    {field_modules, 3},
    {field_package, 1},
  [444] =
    {field_provided, 1},
  [445] =
    {field_name, 1},
    {field_type, 0},
  [447] =
    {field_body, 7},
    {field_interfaces, 5},
    {field_name, 2},
    {field_permits, 6},
    {field_superclass, 4},
    {field_type_parameters, 3},
  [453] =
    {field_arguments, 2},
    {field_constructor, 1},
    {field_type_arguments, 0},
  [456] =
    {field_body, 8},
    {field_condition, 3},
    {field_update, 5},
    {field_update, 6, .inherited = true},
  [460] =
    {field_body, 8},
    {field_init, 2},
    {field_update, 5},
    {field_update, 6, .inherited = true},
  [464] =
    {field_body, 8},
    {field_condition, 4},
    {field_init, 2},
    {field_update, 6},
  [468] =
    {field_body, 8},
    {field_init, 2},
    {field_init, 3, .inherited = true},
    {field_update, 6},
  [472] =
    {field_body, 8},
    {field_condition, 5},
    {field_init, 2},
    {field_init, 3, .inherited = true},
  [476] =
    {field_body, 8},
    {field_dimensions, 4, .inherited = true},
    {field_name, 4, .inherited = true},
    {field_type, 3},
    {field_value, 6},
  [481] =
    {field_body, 8},
    {field_condition, 3},
    {field_init, 2},
    {field_update, 5},
    {field_update, 6, .inherited = true},
  [486] =
    {field_modules, 1},
  [487] =
    {field_modules, 3},
    {field_modules, 4, .inherited = true},
    {field_package, 1},
  [490] =
    {field_modules, 0, .inherited = true},
    {field_modules, 1, .inherited = true},
  [492] =
    {field_provider, 1},
  [493] =
    {field_provided, 1},
    {field_provider, 4, .inherited = true},
  [495] =
    {field_provider, 0, .inherited = true},
    {field_provider, 1, .inherited = true},
  [497] =
    {field_name, 2},
    {field_type, 1},
  [499] =
    {field_value, 1},
  [500] =
    {field_dimensions, 4},
    {field_name, 1},
    {field_type, 0},
  [503] =
    {field_name, 1},
    {field_type, 0},
    {field_value, 4, .inherited = true},
  [506] =
    {field_arguments, 3},
    {field_constructor, 2},
    {field_object, 0},
  [509] =
    {field_body, 9},
    {field_condition, 4},
    {field_init, 2},
    {field_update, 6},
    {field_update, 7, .inherited = true},
  [514] =
    {field_body, 9},
    {field_init, 2},
    {field_init, 3, .inherited = true},
    {field_update, 6},
    {field_update, 7, .inherited = true},
  [519] =
    {field_body, 9},
    {field_condition, 5},
    {field_init, 2},
    {field_init, 3, .inherited = true},
    {field_update, 7},
  [524] =
    {field_dimensions, 5},
    {field_name, 2},
    {field_type, 1},
  [527] =
    {field_name, 2},
    {field_type, 1},
    {field_value, 5, .inherited = true},
  [530] =
    {field_dimensions, 4},
    {field_name, 1},
    {field_type, 0},
    {field_value, 5, .inherited = true},
  [534] =
    {field_arguments, 4},
    {field_constructor, 3},
    {field_object, 0},
    {field_type_arguments, 2},
  [538] =
    {field_body, 10},
    {field_condition, 5},
    {field_init, 2},
    {field_init, 3, .inherited = true},
    {field_update, 7},
    {field_update, 8, .inherited = true},
  [544] =
    {field_dimensions, 5},
    {field_name, 2},
    {field_type, 1},
    {field_value, 6, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [2] = {
    [0] = alias_sym_type_identifier,
  },
  [5] = {
    [1] = sym_identifier,
  },
  [7] = {
    [0] = sym_identifier,
  },
  [9] = {
    [0] = sym_identifier,
  },
  [14] = {
    [1] = sym_identifier,
  },
  [18] = {
    [1] = alias_sym_type_identifier,
  },
  [19] = {
    [1] = alias_sym_type_identifier,
  },
  [26] = {
    [1] = sym_identifier,
  },
  [28] = {
    [0] = sym_identifier,
  },
  [29] = {
    [0] = sym_identifier,
  },
  [30] = {
    [1] = sym_identifier,
  },
  [31] = {
    [2] = sym_identifier,
  },
  [35] = {
    [0] = alias_sym_type_identifier,
    [2] = alias_sym_type_identifier,
  },
  [38] = {
    [0] = sym_identifier,
  },
  [42] = {
    [2] = alias_sym_type_identifier,
  },
  [49] = {
    [1] = alias_sym_type_identifier,
  },
  [50] = {
    [1] = alias_sym_type_identifier,
  },
  [52] = {
    [2] = alias_sym_type_identifier,
  },
  [54] = {
    [2] = alias_sym_type_identifier,
  },
  [59] = {
    [0] = sym_identifier,
  },
  [61] = {
    [2] = sym_identifier,
  },
  [63] = {
    [2] = sym_identifier,
  },
  [66] = {
    [2] = sym_identifier,
  },
  [68] = {
    [0] = alias_sym_type_identifier,
    [3] = alias_sym_type_identifier,
  },
  [70] = {
    [3] = sym_identifier,
  },
  [77] = {
    [3] = alias_sym_type_identifier,
  },
  [81] = {
    [2] = alias_sym_type_identifier,
  },
  [82] = {
    [2] = alias_sym_type_identifier,
  },
  [83] = {
    [1] = alias_sym_type_identifier,
  },
  [105] = {
    [4] = sym_identifier,
  },
  [107] = {
    [3] = sym_identifier,
  },
  [109] = {
    [4] = sym_identifier,
  },
  [118] = {
    [3] = sym_identifier,
  },
  [126] = {
    [0] = sym_identifier,
  },
  [136] = {
    [1] = sym_identifier,
  },
  [139] = {
    [1] = sym_identifier,
  },
  [141] = {
    [1] = sym_identifier,
  },
  [145] = {
    [4] = sym_identifier,
  },
  [159] = {
    [0] = sym_identifier,
  },
  [172] = {
    [2] = sym_identifier,
  },
  [175] = {
    [5] = sym_identifier,
  },
  [192] = {
    [1] = sym_identifier,
    [3] = sym_identifier,
  },
  [193] = {
    [1] = sym_identifier,
  },
  [194] = {
    [3] = sym_identifier,
  },
  [196] = {
    [1] = sym_identifier,
    [3] = sym_identifier,
  },
  [197] = {
    [1] = sym_identifier,
  },
  [198] = {
    [3] = sym_identifier,
  },
  [210] = {
    [1] = sym_identifier,
  },
  [212] = {
    [1] = sym_identifier,
    [3] = sym_identifier,
  },
  [214] = {
    [1] = sym_identifier,
  },
  [215] = {
    [3] = sym_identifier,
  },
  [217] = {
    [1] = sym_identifier,
  },
  [219] = {
    [1] = sym_identifier,
    [3] = sym_identifier,
  },
  [221] = {
    [1] = sym_identifier,
  },
  [222] = {
    [3] = sym_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 6656
    ? (c < 2979
      ? (c < 2308
        ? (c < 1376
          ? (c < 880
            ? (c < 192
              ? (c < 170
                ? (c < '_'
                  ? (c >= '$' && c <= 'Z')
                  : (c <= '_' || (c >= 'a' && c <= 'z')))
                : (c <= 170 || (c < 186
                  ? c == 181
                  : c <= 186)))
              : (c <= 214 || (c < 736
                ? (c < 248
                  ? (c >= 216 && c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))
                : (c <= 740 || (c < 750
                  ? c == 748
                  : c <= 750)))))
            : (c <= 884 || (c < 910
              ? (c < 902
                ? (c < 890
                  ? (c >= 886 && c <= 887)
                  : (c <= 893 || c == 895))
                : (c <= 902 || (c < 908
                  ? (c >= 904 && c <= 906)
                  : c <= 908)))
              : (c <= 929 || (c < 1162
                ? (c < 1015
                  ? (c >= 931 && c <= 1013)
                  : c <= 1153)
                : (c <= 1327 || (c < 1369
                  ? (c >= 1329 && c <= 1366)
                  : c <= 1369)))))))
          : (c <= 1416 || (c < 1969
            ? (c < 1765
              ? (c < 1646
                ? (c < 1519
                  ? (c >= 1488 && c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))
                : (c <= 1647 || (c < 1749
                  ? (c >= 1649 && c <= 1747)
                  : c <= 1749)))
              : (c <= 1766 || (c < 1808
                ? (c < 1786
                  ? (c >= 1774 && c <= 1775)
                  : (c <= 1788 || c == 1791))
                : (c <= 1808 || (c < 1869
                  ? (c >= 1810 && c <= 1839)
                  : c <= 1957)))))
            : (c <= 1969 || (c < 2088
              ? (c < 2048
                ? (c < 2036
                  ? (c >= 1994 && c <= 2026)
                  : (c <= 2037 || c == 2042))
                : (c <= 2069 || (c < 2084
                  ? c == 2074
                  : c <= 2084)))
              : (c <= 2088 || (c < 2160
                ? (c < 2144
                  ? (c >= 2112 && c <= 2136)
                  : c <= 2154)
                : (c <= 2183 || (c < 2208
                  ? (c >= 2185 && c <= 2190)
                  : c <= 2249)))))))))
        : (c <= 2361 || (c < 2693
          ? (c < 2527
            ? (c < 2451
              ? (c < 2417
                ? (c < 2384
                  ? c == 2365
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2447
                  ? (c >= 2437 && c <= 2444)
                  : c <= 2448)))
              : (c <= 2472 || (c < 2493
                ? (c < 2482
                  ? (c >= 2474 && c <= 2480)
                  : (c <= 2482 || (c >= 2486 && c <= 2489)))
                : (c <= 2493 || (c < 2524
                  ? c == 2510
                  : c <= 2525)))))
            : (c <= 2529 || (c < 2610
              ? (c < 2575
                ? (c < 2556
                  ? (c >= 2544 && c <= 2545)
                  : (c <= 2556 || (c >= 2565 && c <= 2570)))
                : (c <= 2576 || (c < 2602
                  ? (c >= 2579 && c <= 2600)
                  : c <= 2608)))
              : (c <= 2611 || (c < 2649
                ? (c < 2616
                  ? (c >= 2613 && c <= 2614)
                  : c <= 2617)
                : (c <= 2652 || (c < 2674
                  ? c == 2654
                  : c <= 2676)))))))
          : (c <= 2701 || (c < 2866
            ? (c < 2768
              ? (c < 2738
                ? (c < 2707
                  ? (c >= 2703 && c <= 2705)
                  : (c <= 2728 || (c >= 2730 && c <= 2736)))
                : (c <= 2739 || (c < 2749
                  ? (c >= 2741 && c <= 2745)
                  : c <= 2749)))
              : (c <= 2768 || (c < 2831
                ? (c < 2809
                  ? (c >= 2784 && c <= 2785)
                  : (c <= 2809 || (c >= 2821 && c <= 2828)))
                : (c <= 2832 || (c < 2858
                  ? (c >= 2835 && c <= 2856)
                  : c <= 2864)))))
            : (c <= 2867 || (c < 2949
              ? (c < 2911
                ? (c < 2877
                  ? (c >= 2869 && c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2947
                  ? c == 2929
                  : c <= 2947)))
              : (c <= 2954 || (c < 2969
                ? (c < 2962
                  ? (c >= 2958 && c <= 2960)
                  : c <= 2965)
                : (c <= 2970 || (c < 2974
                  ? c == 2972
                  : c <= 2975)))))))))))
      : (c <= 2980 || (c < 4159
        ? (c < 3412
          ? (c < 3214
            ? (c < 3114
              ? (c < 3077
                ? (c < 2990
                  ? (c >= 2984 && c <= 2986)
                  : (c <= 3001 || c == 3024))
                : (c <= 3084 || (c < 3090
                  ? (c >= 3086 && c <= 3088)
                  : c <= 3112)))
              : (c <= 3129 || (c < 3168
                ? (c < 3160
                  ? c == 3133
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3205
                  ? c == 3200
                  : c <= 3212)))))
            : (c <= 3216 || (c < 3313
              ? (c < 3261
                ? (c < 3242
                  ? (c >= 3218 && c <= 3240)
                  : (c <= 3251 || (c >= 3253 && c <= 3257)))
                : (c <= 3261 || (c < 3296
                  ? (c >= 3293 && c <= 3294)
                  : c <= 3297)))
              : (c <= 3314 || (c < 3346
                ? (c < 3342
                  ? (c >= 3332 && c <= 3340)
                  : c <= 3344)
                : (c <= 3386 || (c < 3406
                  ? c == 3389
                  : c <= 3406)))))))
          : (c <= 3414 || (c < 3724
            ? (c < 3520
              ? (c < 3482
                ? (c < 3450
                  ? (c >= 3423 && c <= 3425)
                  : (c <= 3455 || (c >= 3461 && c <= 3478)))
                : (c <= 3505 || (c < 3517
                  ? (c >= 3507 && c <= 3515)
                  : c <= 3517)))
              : (c <= 3526 || (c < 3713
                ? (c < 3634
                  ? (c >= 3585 && c <= 3632)
                  : (c <= 3635 || (c >= 3648 && c <= 3654)))
                : (c <= 3714 || (c < 3718
                  ? c == 3716
                  : c <= 3722)))))
            : (c <= 3747 || (c < 3804
              ? (c < 3773
                ? (c < 3751
                  ? c == 3749
                  : (c <= 3760 || (c >= 3762 && c <= 3763)))
                : (c <= 3773 || (c < 3782
                  ? (c >= 3776 && c <= 3780)
                  : c <= 3782)))
              : (c <= 3807 || (c < 3913
                ? (c < 3904
                  ? c == 3840
                  : c <= 3911)
                : (c <= 3948 || (c < 4096
                  ? (c >= 3976 && c <= 3980)
                  : c <= 4138)))))))))
        : (c <= 4159 || (c < 4888
          ? (c < 4688
            ? (c < 4238
              ? (c < 4197
                ? (c < 4186
                  ? (c >= 4176 && c <= 4181)
                  : (c <= 4189 || c == 4193))
                : (c <= 4198 || (c < 4213
                  ? (c >= 4206 && c <= 4208)
                  : c <= 4225)))
              : (c <= 4238 || (c < 4304
                ? (c < 4295
                  ? (c >= 4256 && c <= 4293)
                  : (c <= 4295 || c == 4301))
                : (c <= 4346 || (c < 4682
                  ? (c >= 4348 && c <= 4680)
                  : c <= 4685)))))
            : (c <= 4694 || (c < 4792
              ? (c < 4746
                ? (c < 4698
                  ? c == 4696
                  : (c <= 4701 || (c >= 4704 && c <= 4744)))
                : (c <= 4749 || (c < 4786
                  ? (c >= 4752 && c <= 4784)
                  : c <= 4789)))
              : (c <= 4798 || (c < 4808
                ? (c < 4802
                  ? c == 4800
                  : c <= 4805)
                : (c <= 4822 || (c < 4882
                  ? (c >= 4824 && c <= 4880)
                  : c <= 4885)))))))
          : (c <= 4954 || (c < 6016
            ? (c < 5792
              ? (c < 5121
                ? (c < 5024
                  ? (c >= 4992 && c <= 5007)
                  : (c <= 5109 || (c >= 5112 && c <= 5117)))
                : (c <= 5740 || (c < 5761
                  ? (c >= 5743 && c <= 5759)
                  : c <= 5786)))
              : (c <= 5866 || (c < 5952
                ? (c < 5888
                  ? (c >= 5873 && c <= 5880)
                  : (c <= 5905 || (c >= 5919 && c <= 5937)))
                : (c <= 5969 || (c < 5998
                  ? (c >= 5984 && c <= 5996)
                  : c <= 6000)))))
            : (c <= 6067 || (c < 6320
              ? (c < 6272
                ? (c < 6108
                  ? c == 6103
                  : (c <= 6108 || (c >= 6176 && c <= 6264)))
                : (c <= 6276 || (c < 6314
                  ? (c >= 6279 && c <= 6312)
                  : c <= 6314)))
              : (c <= 6389 || (c < 6512
                ? (c < 6480
                  ? (c >= 6400 && c <= 6430)
                  : c <= 6509)
                : (c <= 6516 || (c < 6576
                  ? (c >= 6528 && c <= 6571)
                  : c <= 6601)))))))))))))
    : (c <= 6678 || (c < 43259
      ? (c < 8579
        ? (c < 8031
          ? (c < 7401
            ? (c < 7098
              ? (c < 6981
                ? (c < 6823
                  ? (c >= 6688 && c <= 6740)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))
                : (c <= 6988 || (c < 7086
                  ? (c >= 7043 && c <= 7072)
                  : c <= 7087)))
              : (c <= 7141 || (c < 7296
                ? (c < 7245
                  ? (c >= 7168 && c <= 7203)
                  : (c <= 7247 || (c >= 7258 && c <= 7293)))
                : (c <= 7304 || (c < 7357
                  ? (c >= 7312 && c <= 7354)
                  : c <= 7359)))))
            : (c <= 7404 || (c < 7968
              ? (c < 7424
                ? (c < 7413
                  ? (c >= 7406 && c <= 7411)
                  : (c <= 7414 || c == 7418))
                : (c <= 7615 || (c < 7960
                  ? (c >= 7680 && c <= 7957)
                  : c <= 7965)))
              : (c <= 8005 || (c < 8025
                ? (c < 8016
                  ? (c >= 8008 && c <= 8013)
                  : c <= 8023)
                : (c <= 8025 || (c < 8029
                  ? c == 8027
                  : c <= 8029)))))))
          : (c <= 8061 || (c < 8450
            ? (c < 8150
              ? (c < 8130
                ? (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : (c <= 8124 || c == 8126))
                : (c <= 8132 || (c < 8144
                  ? (c >= 8134 && c <= 8140)
                  : c <= 8147)))
              : (c <= 8155 || (c < 8305
                ? (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : (c <= 8180 || (c >= 8182 && c <= 8188)))
                : (c <= 8305 || (c < 8336
                  ? c == 8319
                  : c <= 8348)))))
            : (c <= 8450 || (c < 8488
              ? (c < 8473
                ? (c < 8458
                  ? c == 8455
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8486
                  ? c == 8484
                  : c <= 8486)))
              : (c <= 8488 || (c < 8508
                ? (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : c <= 8505)
                : (c <= 8511 || (c < 8526
                  ? (c >= 8517 && c <= 8521)
                  : c <= 8526)))))))))
        : (c <= 8580 || (c < 12593
          ? (c < 11712
            ? (c < 11568
              ? (c < 11520
                ? (c < 11499
                  ? (c >= 11264 && c <= 11492)
                  : (c <= 11502 || (c >= 11506 && c <= 11507)))
                : (c <= 11557 || (c < 11565
                  ? c == 11559
                  : c <= 11565)))
              : (c <= 11623 || (c < 11688
                ? (c < 11648
                  ? c == 11631
                  : (c <= 11670 || (c >= 11680 && c <= 11686)))
                : (c <= 11694 || (c < 11704
                  ? (c >= 11696 && c <= 11702)
                  : c <= 11710)))))
            : (c <= 11718 || (c < 12347
              ? (c < 11823
                ? (c < 11728
                  ? (c >= 11720 && c <= 11726)
                  : (c <= 11734 || (c >= 11736 && c <= 11742)))
                : (c <= 11823 || (c < 12337
                  ? (c >= 12293 && c <= 12294)
                  : c <= 12341)))
              : (c <= 12348 || (c < 12449
                ? (c < 12445
                  ? (c >= 12353 && c <= 12438)
                  : c <= 12447)
                : (c <= 12538 || (c < 12549
                  ? (c >= 12540 && c <= 12543)
                  : c <= 12591)))))))
          : (c <= 12686 || (c < 42775
            ? (c < 42192
              ? (c < 19903
                ? (c < 12784
                  ? (c >= 12704 && c <= 12735)
                  : (c <= 12799 || c == 13312))
                : (c <= 19903 || (c < 40959
                  ? c == 19968
                  : c <= 42124)))
              : (c <= 42237 || (c < 42560
                ? (c < 42512
                  ? (c >= 42240 && c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42656
                  ? (c >= 42623 && c <= 42653)
                  : c <= 42725)))))
            : (c <= 42783 || (c < 43011
              ? (c < 42963
                ? (c < 42891
                  ? (c >= 42786 && c <= 42888)
                  : (c <= 42954 || (c >= 42960 && c <= 42961)))
                : (c <= 42963 || (c < 42994
                  ? (c >= 42965 && c <= 42969)
                  : c <= 43009)))
              : (c <= 43013 || (c < 43072
                ? (c < 43020
                  ? (c >= 43015 && c <= 43018)
                  : c <= 43042)
                : (c <= 43123 || (c < 43250
                  ? (c >= 43138 && c <= 43187)
                  : c <= 43255)))))))))))
      : (c <= 43259 || (c < 65313
        ? (c < 43808
          ? (c < 43642
            ? (c < 43488
              ? (c < 43360
                ? (c < 43274
                  ? (c >= 43261 && c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43471
                  ? (c >= 43396 && c <= 43442)
                  : c <= 43471)))
              : (c <= 43492 || (c < 43584
                ? (c < 43514
                  ? (c >= 43494 && c <= 43503)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43616
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43638)))))
            : (c <= 43642 || (c < 43739
              ? (c < 43705
                ? (c < 43697
                  ? (c >= 43646 && c <= 43695)
                  : (c <= 43697 || (c >= 43701 && c <= 43702)))
                : (c <= 43709 || (c < 43714
                  ? c == 43712
                  : c <= 43714)))
              : (c <= 43741 || (c < 43777
                ? (c < 43762
                  ? (c >= 43744 && c <= 43754)
                  : c <= 43764)
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64287
            ? (c < 55216
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 55203
                  ? c == 44032
                  : c <= 55203)))
              : (c <= 55238 || (c < 64256
                ? (c < 63744
                  ? (c >= 55243 && c <= 55291)
                  : (c <= 64109 || (c >= 64112 && c <= 64217)))
                : (c <= 64262 || (c < 64285
                  ? (c >= 64275 && c <= 64279)
                  : c <= 64285)))))
            : (c <= 64296 || (c < 64467
              ? (c < 64320
                ? (c < 64312
                  ? (c >= 64298 && c <= 64310)
                  : (c <= 64316 || c == 64318))
                : (c <= 64321 || (c < 64326
                  ? (c >= 64323 && c <= 64324)
                  : c <= 64433)))
              : (c <= 64829 || (c < 65008
                ? (c < 64914
                  ? (c >= 64848 && c <= 64911)
                  : c <= 64967)
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65338 || (c < 66864
          ? (c < 66176
            ? (c < 65536
              ? (c < 65482
                ? (c < 65382
                  ? (c >= 65345 && c <= 65370)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65498
                  ? (c >= 65490 && c <= 65495)
                  : c <= 65500)))
              : (c <= 65547 || (c < 65599
                ? (c < 65576
                  ? (c >= 65549 && c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))
                : (c <= 65613 || (c < 65664
                  ? (c >= 65616 && c <= 65629)
                  : c <= 65786)))))
            : (c <= 66204 || (c < 66464
              ? (c < 66370
                ? (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66368)))
                : (c <= 66377 || (c < 66432
                  ? (c >= 66384 && c <= 66421)
                  : c <= 66461)))
              : (c <= 66499 || (c < 66736
                ? (c < 66560
                  ? (c >= 66504 && c <= 66511)
                  : c <= 66717)
                : (c <= 66771 || (c < 66816
                  ? (c >= 66776 && c <= 66811)
                  : c <= 66855)))))))
          : (c <= 66915 || (c < 67506
            ? (c < 66995
              ? (c < 66964
                ? (c < 66940
                  ? (c >= 66928 && c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))
                : (c <= 66965 || (c < 66979
                  ? (c >= 66967 && c <= 66977)
                  : c <= 66993)))
              : (c <= 67001 || (c < 67424
                ? (c < 67072
                  ? (c >= 67003 && c <= 67004)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67463
                  ? (c >= 67456 && c <= 67461)
                  : c <= 67504)))))
            : (c <= 67514 || (c < 67680
              ? (c < 67639
                ? (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 6656
    ? (c < 2979
      ? (c < 2308
        ? (c < 1376
          ? (c < 750
            ? (c < 186
              ? (c < 'a'
                ? (c < 'A'
                  ? c == '$'
                  : (c <= 'Z' || c == '_'))
                : (c <= 'z' || (c < 181
                  ? c == 170
                  : c <= 181)))
              : (c <= 186 || (c < 710
                ? (c < 216
                  ? (c >= 192 && c <= 214)
                  : (c <= 246 || (c >= 248 && c <= 705)))
                : (c <= 721 || (c < 748
                  ? (c >= 736 && c <= 740)
                  : c <= 748)))))
            : (c <= 750 || (c < 908
              ? (c < 895
                ? (c < 886
                  ? (c >= 880 && c <= 884)
                  : (c <= 887 || (c >= 890 && c <= 893)))
                : (c <= 895 || (c < 904
                  ? c == 902
                  : c <= 906)))
              : (c <= 908 || (c < 1162
                ? (c < 931
                  ? (c >= 910 && c <= 929)
                  : (c <= 1013 || (c >= 1015 && c <= 1153)))
                : (c <= 1327 || (c < 1369
                  ? (c >= 1329 && c <= 1366)
                  : c <= 1369)))))))
          : (c <= 1416 || (c < 1969
            ? (c < 1765
              ? (c < 1646
                ? (c < 1519
                  ? (c >= 1488 && c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))
                : (c <= 1647 || (c < 1749
                  ? (c >= 1649 && c <= 1747)
                  : c <= 1749)))
              : (c <= 1766 || (c < 1808
                ? (c < 1786
                  ? (c >= 1774 && c <= 1775)
                  : (c <= 1788 || c == 1791))
                : (c <= 1808 || (c < 1869
                  ? (c >= 1810 && c <= 1839)
                  : c <= 1957)))))
            : (c <= 1969 || (c < 2088
              ? (c < 2048
                ? (c < 2036
                  ? (c >= 1994 && c <= 2026)
                  : (c <= 2037 || c == 2042))
                : (c <= 2069 || (c < 2084
                  ? c == 2074
                  : c <= 2084)))
              : (c <= 2088 || (c < 2160
                ? (c < 2144
                  ? (c >= 2112 && c <= 2136)
                  : c <= 2154)
                : (c <= 2183 || (c < 2208
                  ? (c >= 2185 && c <= 2190)
                  : c <= 2249)))))))))
        : (c <= 2361 || (c < 2693
          ? (c < 2527
            ? (c < 2451
              ? (c < 2417
                ? (c < 2384
                  ? c == 2365
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2447
                  ? (c >= 2437 && c <= 2444)
                  : c <= 2448)))
              : (c <= 2472 || (c < 2493
                ? (c < 2482
                  ? (c >= 2474 && c <= 2480)
                  : (c <= 2482 || (c >= 2486 && c <= 2489)))
                : (c <= 2493 || (c < 2524
                  ? c == 2510
                  : c <= 2525)))))
            : (c <= 2529 || (c < 2610
              ? (c < 2575
                ? (c < 2556
                  ? (c >= 2544 && c <= 2545)
                  : (c <= 2556 || (c >= 2565 && c <= 2570)))
                : (c <= 2576 || (c < 2602
                  ? (c >= 2579 && c <= 2600)
                  : c <= 2608)))
              : (c <= 2611 || (c < 2649
                ? (c < 2616
                  ? (c >= 2613 && c <= 2614)
                  : c <= 2617)
                : (c <= 2652 || (c < 2674
                  ? c == 2654
                  : c <= 2676)))))))
          : (c <= 2701 || (c < 2866
            ? (c < 2768
              ? (c < 2738
                ? (c < 2707
                  ? (c >= 2703 && c <= 2705)
                  : (c <= 2728 || (c >= 2730 && c <= 2736)))
                : (c <= 2739 || (c < 2749
                  ? (c >= 2741 && c <= 2745)
                  : c <= 2749)))
              : (c <= 2768 || (c < 2831
                ? (c < 2809
                  ? (c >= 2784 && c <= 2785)
                  : (c <= 2809 || (c >= 2821 && c <= 2828)))
                : (c <= 2832 || (c < 2858
                  ? (c >= 2835 && c <= 2856)
                  : c <= 2864)))))
            : (c <= 2867 || (c < 2949
              ? (c < 2911
                ? (c < 2877
                  ? (c >= 2869 && c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2947
                  ? c == 2929
                  : c <= 2947)))
              : (c <= 2954 || (c < 2969
                ? (c < 2962
                  ? (c >= 2958 && c <= 2960)
                  : c <= 2965)
                : (c <= 2970 || (c < 2974
                  ? c == 2972
                  : c <= 2975)))))))))))
      : (c <= 2980 || (c < 4159
        ? (c < 3412
          ? (c < 3214
            ? (c < 3114
              ? (c < 3077
                ? (c < 2990
                  ? (c >= 2984 && c <= 2986)
                  : (c <= 3001 || c == 3024))
                : (c <= 3084 || (c < 3090
                  ? (c >= 3086 && c <= 3088)
                  : c <= 3112)))
              : (c <= 3129 || (c < 3168
                ? (c < 3160
                  ? c == 3133
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3205
                  ? c == 3200
                  : c <= 3212)))))
            : (c <= 3216 || (c < 3313
              ? (c < 3261
                ? (c < 3242
                  ? (c >= 3218 && c <= 3240)
                  : (c <= 3251 || (c >= 3253 && c <= 3257)))
                : (c <= 3261 || (c < 3296
                  ? (c >= 3293 && c <= 3294)
                  : c <= 3297)))
              : (c <= 3314 || (c < 3346
                ? (c < 3342
                  ? (c >= 3332 && c <= 3340)
                  : c <= 3344)
                : (c <= 3386 || (c < 3406
                  ? c == 3389
                  : c <= 3406)))))))
          : (c <= 3414 || (c < 3724
            ? (c < 3520
              ? (c < 3482
                ? (c < 3450
                  ? (c >= 3423 && c <= 3425)
                  : (c <= 3455 || (c >= 3461 && c <= 3478)))
                : (c <= 3505 || (c < 3517
                  ? (c >= 3507 && c <= 3515)
                  : c <= 3517)))
              : (c <= 3526 || (c < 3713
                ? (c < 3634
                  ? (c >= 3585 && c <= 3632)
                  : (c <= 3635 || (c >= 3648 && c <= 3654)))
                : (c <= 3714 || (c < 3718
                  ? c == 3716
                  : c <= 3722)))))
            : (c <= 3747 || (c < 3804
              ? (c < 3773
                ? (c < 3751
                  ? c == 3749
                  : (c <= 3760 || (c >= 3762 && c <= 3763)))
                : (c <= 3773 || (c < 3782
                  ? (c >= 3776 && c <= 3780)
                  : c <= 3782)))
              : (c <= 3807 || (c < 3913
                ? (c < 3904
                  ? c == 3840
                  : c <= 3911)
                : (c <= 3948 || (c < 4096
                  ? (c >= 3976 && c <= 3980)
                  : c <= 4138)))))))))
        : (c <= 4159 || (c < 4888
          ? (c < 4688
            ? (c < 4238
              ? (c < 4197
                ? (c < 4186
                  ? (c >= 4176 && c <= 4181)
                  : (c <= 4189 || c == 4193))
                : (c <= 4198 || (c < 4213
                  ? (c >= 4206 && c <= 4208)
                  : c <= 4225)))
              : (c <= 4238 || (c < 4304
                ? (c < 4295
                  ? (c >= 4256 && c <= 4293)
                  : (c <= 4295 || c == 4301))
                : (c <= 4346 || (c < 4682
                  ? (c >= 4348 && c <= 4680)
                  : c <= 4685)))))
            : (c <= 4694 || (c < 4792
              ? (c < 4746
                ? (c < 4698
                  ? c == 4696
                  : (c <= 4701 || (c >= 4704 && c <= 4744)))
                : (c <= 4749 || (c < 4786
                  ? (c >= 4752 && c <= 4784)
                  : c <= 4789)))
              : (c <= 4798 || (c < 4808
                ? (c < 4802
                  ? c == 4800
                  : c <= 4805)
                : (c <= 4822 || (c < 4882
                  ? (c >= 4824 && c <= 4880)
                  : c <= 4885)))))))
          : (c <= 4954 || (c < 6016
            ? (c < 5792
              ? (c < 5121
                ? (c < 5024
                  ? (c >= 4992 && c <= 5007)
                  : (c <= 5109 || (c >= 5112 && c <= 5117)))
                : (c <= 5740 || (c < 5761
                  ? (c >= 5743 && c <= 5759)
                  : c <= 5786)))
              : (c <= 5866 || (c < 5952
                ? (c < 5888
                  ? (c >= 5873 && c <= 5880)
                  : (c <= 5905 || (c >= 5919 && c <= 5937)))
                : (c <= 5969 || (c < 5998
                  ? (c >= 5984 && c <= 5996)
                  : c <= 6000)))))
            : (c <= 6067 || (c < 6320
              ? (c < 6272
                ? (c < 6108
                  ? c == 6103
                  : (c <= 6108 || (c >= 6176 && c <= 6264)))
                : (c <= 6276 || (c < 6314
                  ? (c >= 6279 && c <= 6312)
                  : c <= 6314)))
              : (c <= 6389 || (c < 6512
                ? (c < 6480
                  ? (c >= 6400 && c <= 6430)
                  : c <= 6509)
                : (c <= 6516 || (c < 6576
                  ? (c >= 6528 && c <= 6571)
                  : c <= 6601)))))))))))))
    : (c <= 6678 || (c < 43259
      ? (c < 8579
        ? (c < 8031
          ? (c < 7401
            ? (c < 7098
              ? (c < 6981
                ? (c < 6823
                  ? (c >= 6688 && c <= 6740)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))
                : (c <= 6988 || (c < 7086
                  ? (c >= 7043 && c <= 7072)
                  : c <= 7087)))
              : (c <= 7141 || (c < 7296
                ? (c < 7245
                  ? (c >= 7168 && c <= 7203)
                  : (c <= 7247 || (c >= 7258 && c <= 7293)))
                : (c <= 7304 || (c < 7357
                  ? (c >= 7312 && c <= 7354)
                  : c <= 7359)))))
            : (c <= 7404 || (c < 7968
              ? (c < 7424
                ? (c < 7413
                  ? (c >= 7406 && c <= 7411)
                  : (c <= 7414 || c == 7418))
                : (c <= 7615 || (c < 7960
                  ? (c >= 7680 && c <= 7957)
                  : c <= 7965)))
              : (c <= 8005 || (c < 8025
                ? (c < 8016
                  ? (c >= 8008 && c <= 8013)
                  : c <= 8023)
                : (c <= 8025 || (c < 8029
                  ? c == 8027
                  : c <= 8029)))))))
          : (c <= 8061 || (c < 8450
            ? (c < 8150
              ? (c < 8130
                ? (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : (c <= 8124 || c == 8126))
                : (c <= 8132 || (c < 8144
                  ? (c >= 8134 && c <= 8140)
                  : c <= 8147)))
              : (c <= 8155 || (c < 8305
                ? (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : (c <= 8180 || (c >= 8182 && c <= 8188)))
                : (c <= 8305 || (c < 8336
                  ? c == 8319
                  : c <= 8348)))))
            : (c <= 8450 || (c < 8488
              ? (c < 8473
                ? (c < 8458
                  ? c == 8455
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8486
                  ? c == 8484
                  : c <= 8486)))
              : (c <= 8488 || (c < 8508
                ? (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : c <= 8505)
                : (c <= 8511 || (c < 8526
                  ? (c >= 8517 && c <= 8521)
                  : c <= 8526)))))))))
        : (c <= 8580 || (c < 12593
          ? (c < 11712
            ? (c < 11568
              ? (c < 11520
                ? (c < 11499
                  ? (c >= 11264 && c <= 11492)
                  : (c <= 11502 || (c >= 11506 && c <= 11507)))
                : (c <= 11557 || (c < 11565
                  ? c == 11559
                  : c <= 11565)))
              : (c <= 11623 || (c < 11688
                ? (c < 11648
                  ? c == 11631
                  : (c <= 11670 || (c >= 11680 && c <= 11686)))
                : (c <= 11694 || (c < 11704
                  ? (c >= 11696 && c <= 11702)
                  : c <= 11710)))))
            : (c <= 11718 || (c < 12347
              ? (c < 11823
                ? (c < 11728
                  ? (c >= 11720 && c <= 11726)
                  : (c <= 11734 || (c >= 11736 && c <= 11742)))
                : (c <= 11823 || (c < 12337
                  ? (c >= 12293 && c <= 12294)
                  : c <= 12341)))
              : (c <= 12348 || (c < 12449
                ? (c < 12445
                  ? (c >= 12353 && c <= 12438)
                  : c <= 12447)
                : (c <= 12538 || (c < 12549
                  ? (c >= 12540 && c <= 12543)
                  : c <= 12591)))))))
          : (c <= 12686 || (c < 42775
            ? (c < 42192
              ? (c < 19903
                ? (c < 12784
                  ? (c >= 12704 && c <= 12735)
                  : (c <= 12799 || c == 13312))
                : (c <= 19903 || (c < 40959
                  ? c == 19968
                  : c <= 42124)))
              : (c <= 42237 || (c < 42560
                ? (c < 42512
                  ? (c >= 42240 && c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42656
                  ? (c >= 42623 && c <= 42653)
                  : c <= 42725)))))
            : (c <= 42783 || (c < 43011
              ? (c < 42963
                ? (c < 42891
                  ? (c >= 42786 && c <= 42888)
                  : (c <= 42954 || (c >= 42960 && c <= 42961)))
                : (c <= 42963 || (c < 42994
                  ? (c >= 42965 && c <= 42969)
                  : c <= 43009)))
              : (c <= 43013 || (c < 43072
                ? (c < 43020
                  ? (c >= 43015 && c <= 43018)
                  : c <= 43042)
                : (c <= 43123 || (c < 43250
                  ? (c >= 43138 && c <= 43187)
                  : c <= 43255)))))))))))
      : (c <= 43259 || (c < 65313
        ? (c < 43808
          ? (c < 43642
            ? (c < 43488
              ? (c < 43360
                ? (c < 43274
                  ? (c >= 43261 && c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43471
                  ? (c >= 43396 && c <= 43442)
                  : c <= 43471)))
              : (c <= 43492 || (c < 43584
                ? (c < 43514
                  ? (c >= 43494 && c <= 43503)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43616
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43638)))))
            : (c <= 43642 || (c < 43739
              ? (c < 43705
                ? (c < 43697
                  ? (c >= 43646 && c <= 43695)
                  : (c <= 43697 || (c >= 43701 && c <= 43702)))
                : (c <= 43709 || (c < 43714
                  ? c == 43712
                  : c <= 43714)))
              : (c <= 43741 || (c < 43777
                ? (c < 43762
                  ? (c >= 43744 && c <= 43754)
                  : c <= 43764)
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64287
            ? (c < 55216
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 55203
                  ? c == 44032
                  : c <= 55203)))
              : (c <= 55238 || (c < 64256
                ? (c < 63744
                  ? (c >= 55243 && c <= 55291)
                  : (c <= 64109 || (c >= 64112 && c <= 64217)))
                : (c <= 64262 || (c < 64285
                  ? (c >= 64275 && c <= 64279)
                  : c <= 64285)))))
            : (c <= 64296 || (c < 64467
              ? (c < 64320
                ? (c < 64312
                  ? (c >= 64298 && c <= 64310)
                  : (c <= 64316 || c == 64318))
                : (c <= 64321 || (c < 64326
                  ? (c >= 64323 && c <= 64324)
                  : c <= 64433)))
              : (c <= 64829 || (c < 65008
                ? (c < 64914
                  ? (c >= 64848 && c <= 64911)
                  : c <= 64967)
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65338 || (c < 66864
          ? (c < 66176
            ? (c < 65536
              ? (c < 65482
                ? (c < 65382
                  ? (c >= 65345 && c <= 65370)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65498
                  ? (c >= 65490 && c <= 65495)
                  : c <= 65500)))
              : (c <= 65547 || (c < 65599
                ? (c < 65576
                  ? (c >= 65549 && c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))
                : (c <= 65613 || (c < 65664
                  ? (c >= 65616 && c <= 65629)
                  : c <= 65786)))))
            : (c <= 66204 || (c < 66464
              ? (c < 66370
                ? (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66368)))
                : (c <= 66377 || (c < 66432
                  ? (c >= 66384 && c <= 66421)
                  : c <= 66461)))
              : (c <= 66499 || (c < 66736
                ? (c < 66560
                  ? (c >= 66504 && c <= 66511)
                  : c <= 66717)
                : (c <= 66771 || (c < 66816
                  ? (c >= 66776 && c <= 66811)
                  : c <= 66855)))))))
          : (c <= 66915 || (c < 67506
            ? (c < 66995
              ? (c < 66964
                ? (c < 66940
                  ? (c >= 66928 && c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))
                : (c <= 66965 || (c < 66979
                  ? (c >= 66967 && c <= 66977)
                  : c <= 66993)))
              : (c <= 67001 || (c < 67424
                ? (c < 67072
                  ? (c >= 67003 && c <= 67004)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67463
                  ? (c >= 67456 && c <= 67461)
                  : c <= 67504)))))
            : (c <= 67514 || (c < 67680
              ? (c < 67639
                ? (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 6400
    ? (c < 2979
      ? (c < 2365
        ? (c < 1376
          ? (c < 750
            ? (c < 186
              ? (c < '_'
                ? (c < '0'
                  ? c == '$'
                  : (c <= '9' || (c >= 'A' && c <= 'Z')))
                : (c <= '_' || (c < 170
                  ? (c >= 'a' && c <= 'z')
                  : (c <= 170 || c == 181))))
              : (c <= 186 || (c < 710
                ? (c < 216
                  ? (c >= 192 && c <= 214)
                  : (c <= 246 || (c >= 248 && c <= 705)))
                : (c <= 721 || (c < 748
                  ? (c >= 736 && c <= 740)
                  : c <= 748)))))
            : (c <= 750 || (c < 908
              ? (c < 895
                ? (c < 886
                  ? (c >= 880 && c <= 884)
                  : (c <= 887 || (c >= 890 && c <= 893)))
                : (c <= 895 || (c < 904
                  ? c == 902
                  : c <= 906)))
              : (c <= 908 || (c < 1162
                ? (c < 931
                  ? (c >= 910 && c <= 929)
                  : (c <= 1013 || (c >= 1015 && c <= 1153)))
                : (c <= 1327 || (c < 1369
                  ? (c >= 1329 && c <= 1366)
                  : c <= 1369)))))))
          : (c <= 1416 || (c < 1969
            ? (c < 1749
              ? (c < 1632
                ? (c < 1519
                  ? (c >= 1488 && c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))
                : (c <= 1641 || (c < 1649
                  ? (c >= 1646 && c <= 1647)
                  : c <= 1747)))
              : (c <= 1749 || (c < 1808
                ? (c < 1774
                  ? (c >= 1765 && c <= 1766)
                  : (c <= 1788 || c == 1791))
                : (c <= 1808 || (c < 1869
                  ? (c >= 1810 && c <= 1839)
                  : c <= 1957)))))
            : (c <= 1969 || (c < 2088
              ? (c < 2048
                ? (c < 2036
                  ? (c >= 1984 && c <= 2026)
                  : (c <= 2037 || c == 2042))
                : (c <= 2069 || (c < 2084
                  ? c == 2074
                  : c <= 2084)))
              : (c <= 2088 || (c < 2185
                ? (c < 2144
                  ? (c >= 2112 && c <= 2136)
                  : (c <= 2154 || (c >= 2160 && c <= 2183)))
                : (c <= 2190 || (c < 2308
                  ? (c >= 2208 && c <= 2249)
                  : c <= 2361)))))))))
        : (c <= 2365 || (c < 2703
          ? (c < 2534
            ? (c < 2474
              ? (c < 2417
                ? (c < 2392
                  ? c == 2384
                  : (c <= 2401 || (c >= 2406 && c <= 2415)))
                : (c <= 2432 || (c < 2447
                  ? (c >= 2437 && c <= 2444)
                  : (c <= 2448 || (c >= 2451 && c <= 2472)))))
              : (c <= 2480 || (c < 2510
                ? (c < 2486
                  ? c == 2482
                  : (c <= 2489 || c == 2493))
                : (c <= 2510 || (c < 2527
                  ? (c >= 2524 && c <= 2525)
                  : c <= 2529)))))
            : (c <= 2545 || (c < 2613
              ? (c < 2579
                ? (c < 2565
                  ? c == 2556
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))
                : (c <= 2600 || (c < 2610
                  ? (c >= 2602 && c <= 2608)
                  : c <= 2611)))
              : (c <= 2614 || (c < 2662
                ? (c < 2649
                  ? (c >= 2616 && c <= 2617)
                  : (c <= 2652 || c == 2654))
                : (c <= 2671 || (c < 2693
                  ? (c >= 2674 && c <= 2676)
                  : c <= 2701)))))))
          : (c <= 2705 || (c < 2866
            ? (c < 2784
              ? (c < 2741
                ? (c < 2730
                  ? (c >= 2707 && c <= 2728)
                  : (c <= 2736 || (c >= 2738 && c <= 2739)))
                : (c <= 2745 || (c < 2768
                  ? c == 2749
                  : c <= 2768)))
              : (c <= 2785 || (c < 2831
                ? (c < 2809
                  ? (c >= 2790 && c <= 2799)
                  : (c <= 2809 || (c >= 2821 && c <= 2828)))
                : (c <= 2832 || (c < 2858
                  ? (c >= 2835 && c <= 2856)
                  : c <= 2864)))))
            : (c <= 2867 || (c < 2947
              ? (c < 2911
                ? (c < 2877
                  ? (c >= 2869 && c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2929
                  ? (c >= 2918 && c <= 2927)
                  : c <= 2929)))
              : (c <= 2947 || (c < 2969
                ? (c < 2958
                  ? (c >= 2949 && c <= 2954)
                  : (c <= 2960 || (c >= 2962 && c <= 2965)))
                : (c <= 2970 || (c < 2974
                  ? c == 2972
                  : c <= 2975)))))))))))
      : (c <= 2980 || (c < 3872
        ? (c < 3406
          ? (c < 3205
            ? (c < 3114
              ? (c < 3046
                ? (c < 2990
                  ? (c >= 2984 && c <= 2986)
                  : (c <= 3001 || c == 3024))
                : (c <= 3055 || (c < 3086
                  ? (c >= 3077 && c <= 3084)
                  : (c <= 3088 || (c >= 3090 && c <= 3112)))))
              : (c <= 3129 || (c < 3168
                ? (c < 3160
                  ? c == 3133
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3200
                  ? (c >= 3174 && c <= 3183)
                  : c <= 3200)))))
            : (c <= 3212 || (c < 3296
              ? (c < 3253
                ? (c < 3218
                  ? (c >= 3214 && c <= 3216)
                  : (c <= 3240 || (c >= 3242 && c <= 3251)))
                : (c <= 3257 || (c < 3293
                  ? c == 3261
                  : c <= 3294)))
              : (c <= 3297 || (c < 3342
                ? (c < 3313
                  ? (c >= 3302 && c <= 3311)
                  : (c <= 3314 || (c >= 3332 && c <= 3340)))
                : (c <= 3344 || (c < 3389
                  ? (c >= 3346 && c <= 3386)
                  : c <= 3389)))))))
          : (c <= 3406 || (c < 3664
            ? (c < 3507
              ? (c < 3450
                ? (c < 3423
                  ? (c >= 3412 && c <= 3414)
                  : (c <= 3425 || (c >= 3430 && c <= 3439)))
                : (c <= 3455 || (c < 3482
                  ? (c >= 3461 && c <= 3478)
                  : c <= 3505)))
              : (c <= 3515 || (c < 3585
                ? (c < 3520
                  ? c == 3517
                  : (c <= 3526 || (c >= 3558 && c <= 3567)))
                : (c <= 3632 || (c < 3648
                  ? (c >= 3634 && c <= 3635)
                  : c <= 3654)))))
            : (c <= 3673 || (c < 3762
              ? (c < 3724
                ? (c < 3716
                  ? (c >= 3713 && c <= 3714)
                  : (c <= 3716 || (c >= 3718 && c <= 3722)))
                : (c <= 3747 || (c < 3751
                  ? c == 3749
                  : c <= 3760)))
              : (c <= 3763 || (c < 3792
                ? (c < 3776
                  ? c == 3773
                  : (c <= 3780 || c == 3782))
                : (c <= 3801 || (c < 3840
                  ? (c >= 3804 && c <= 3807)
                  : c <= 3840)))))))))
        : (c <= 3881 || (c < 4802
          ? (c < 4295
            ? (c < 4193
              ? (c < 4096
                ? (c < 3913
                  ? (c >= 3904 && c <= 3911)
                  : (c <= 3948 || (c >= 3976 && c <= 3980)))
                : (c <= 4138 || (c < 4176
                  ? (c >= 4159 && c <= 4169)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))
              : (c <= 4193 || (c < 4238
                ? (c < 4206
                  ? (c >= 4197 && c <= 4198)
                  : (c <= 4208 || (c >= 4213 && c <= 4225)))
                : (c <= 4238 || (c < 4256
                  ? (c >= 4240 && c <= 4249)
                  : c <= 4293)))))
            : (c <= 4295 || (c < 4698
              ? (c < 4682
                ? (c < 4304
                  ? c == 4301
                  : (c <= 4346 || (c >= 4348 && c <= 4680)))
                : (c <= 4685 || (c < 4696
                  ? (c >= 4688 && c <= 4694)
                  : c <= 4696)))
              : (c <= 4701 || (c < 4786
                ? (c < 4746
                  ? (c >= 4704 && c <= 4744)
                  : (c <= 4749 || (c >= 4752 && c <= 4784)))
                : (c <= 4789 || (c < 4800
                  ? (c >= 4792 && c <= 4798)
                  : c <= 4800)))))))
          : (c <= 4805 || (c < 5919
            ? (c < 5112
              ? (c < 4888
                ? (c < 4824
                  ? (c >= 4808 && c <= 4822)
                  : (c <= 4880 || (c >= 4882 && c <= 4885)))
                : (c <= 4954 || (c < 5024
                  ? (c >= 4992 && c <= 5007)
                  : c <= 5109)))
              : (c <= 5117 || (c < 5792
                ? (c < 5743
                  ? (c >= 5121 && c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))
                : (c <= 5866 || (c < 5888
                  ? (c >= 5873 && c <= 5880)
                  : c <= 5905)))))
            : (c <= 5937 || (c < 6112
              ? (c < 6016
                ? (c < 5984
                  ? (c >= 5952 && c <= 5969)
                  : (c <= 5996 || (c >= 5998 && c <= 6000)))
                : (c <= 6067 || (c < 6108
                  ? c == 6103
                  : c <= 6108)))
              : (c <= 6121 || (c < 6279
                ? (c < 6176
                  ? (c >= 6160 && c <= 6169)
                  : (c <= 6264 || (c >= 6272 && c <= 6276)))
                : (c <= 6312 || (c < 6320
                  ? c == 6314
                  : c <= 6389)))))))))))))
    : (c <= 6430 || (c < 43216
      ? (c < 8490
        ? (c < 7968
          ? (c < 7086
            ? (c < 6784
              ? (c < 6576
                ? (c < 6512
                  ? (c >= 6470 && c <= 6509)
                  : (c <= 6516 || (c >= 6528 && c <= 6571)))
                : (c <= 6601 || (c < 6656
                  ? (c >= 6608 && c <= 6617)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6793 || (c < 6981
                ? (c < 6823
                  ? (c >= 6800 && c <= 6809)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))
                : (c <= 6988 || (c < 7043
                  ? (c >= 6992 && c <= 7001)
                  : c <= 7072)))))
            : (c <= 7141 || (c < 7401
              ? (c < 7296
                ? (c < 7232
                  ? (c >= 7168 && c <= 7203)
                  : (c <= 7241 || (c >= 7245 && c <= 7293)))
                : (c <= 7304 || (c < 7357
                  ? (c >= 7312 && c <= 7354)
                  : c <= 7359)))
              : (c <= 7404 || (c < 7424
                ? (c < 7413
                  ? (c >= 7406 && c <= 7411)
                  : (c <= 7414 || c == 7418))
                : (c <= 7615 || (c < 7960
                  ? (c >= 7680 && c <= 7957)
                  : c <= 7965)))))))
          : (c <= 8005 || (c < 8160
            ? (c < 8064
              ? (c < 8027
                ? (c < 8016
                  ? (c >= 8008 && c <= 8013)
                  : (c <= 8023 || c == 8025))
                : (c <= 8027 || (c < 8031
                  ? c == 8029
                  : c <= 8061)))
              : (c <= 8116 || (c < 8134
                ? (c < 8126
                  ? (c >= 8118 && c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))
                : (c <= 8140 || (c < 8150
                  ? (c >= 8144 && c <= 8147)
                  : c <= 8155)))))
            : (c <= 8172 || (c < 8455
              ? (c < 8319
                ? (c < 8182
                  ? (c >= 8178 && c <= 8180)
                  : (c <= 8188 || c == 8305))
                : (c <= 8319 || (c < 8450
                  ? (c >= 8336 && c <= 8348)
                  : c <= 8450)))
              : (c <= 8455 || (c < 8484
                ? (c < 8469
                  ? (c >= 8458 && c <= 8467)
                  : (c <= 8469 || (c >= 8473 && c <= 8477)))
                : (c <= 8484 || (c < 8488
                  ? c == 8486
                  : c <= 8488)))))))))
        : (c <= 8493 || (c < 12449
          ? (c < 11680
            ? (c < 11506
              ? (c < 8526
                ? (c < 8508
                  ? (c >= 8495 && c <= 8505)
                  : (c <= 8511 || (c >= 8517 && c <= 8521)))
                : (c <= 8526 || (c < 11264
                  ? (c >= 8579 && c <= 8580)
                  : (c <= 11492 || (c >= 11499 && c <= 11502)))))
              : (c <= 11507 || (c < 11568
                ? (c < 11559
                  ? (c >= 11520 && c <= 11557)
                  : (c <= 11559 || c == 11565))
                : (c <= 11623 || (c < 11648
                  ? c == 11631
                  : c <= 11670)))))
            : (c <= 11686 || (c < 11736
              ? (c < 11712
                ? (c < 11696
                  ? (c >= 11688 && c <= 11694)
                  : (c <= 11702 || (c >= 11704 && c <= 11710)))
                : (c <= 11718 || (c < 11728
                  ? (c >= 11720 && c <= 11726)
                  : c <= 11734)))
              : (c <= 11742 || (c < 12347
                ? (c < 12293
                  ? c == 11823
                  : (c <= 12294 || (c >= 12337 && c <= 12341)))
                : (c <= 12348 || (c < 12445
                  ? (c >= 12353 && c <= 12438)
                  : c <= 12447)))))))
          : (c <= 12538 || (c < 42623
            ? (c < 19903
              ? (c < 12704
                ? (c < 12549
                  ? (c >= 12540 && c <= 12543)
                  : (c <= 12591 || (c >= 12593 && c <= 12686)))
                : (c <= 12735 || (c < 13312
                  ? (c >= 12784 && c <= 12799)
                  : c <= 13312)))
              : (c <= 19903 || (c < 42240
                ? (c < 40959
                  ? c == 19968
                  : (c <= 42124 || (c >= 42192 && c <= 42237)))
                : (c <= 42508 || (c < 42560
                  ? (c >= 42512 && c <= 42539)
                  : c <= 42606)))))
            : (c <= 42653 || (c < 42965
              ? (c < 42891
                ? (c < 42775
                  ? (c >= 42656 && c <= 42725)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))
                : (c <= 42954 || (c < 42963
                  ? (c >= 42960 && c <= 42961)
                  : c <= 42963)))
              : (c <= 42969 || (c < 43020
                ? (c < 43011
                  ? (c >= 42994 && c <= 43009)
                  : (c <= 43013 || (c >= 43015 && c <= 43018)))
                : (c <= 43042 || (c < 43138
                  ? (c >= 43072 && c <= 43123)
                  : c <= 43187)))))))))))
      : (c <= 43225 || (c < 65296
        ? (c < 43808
          ? (c < 43616
            ? (c < 43471
              ? (c < 43264
                ? (c < 43259
                  ? (c >= 43250 && c <= 43255)
                  : (c <= 43259 || (c >= 43261 && c <= 43262)))
                : (c <= 43301 || (c < 43360
                  ? (c >= 43312 && c <= 43334)
                  : (c <= 43388 || (c >= 43396 && c <= 43442)))))
              : (c <= 43481 || (c < 43584
                ? (c < 43494
                  ? (c >= 43488 && c <= 43492)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43600
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43609)))))
            : (c <= 43638 || (c < 43714
              ? (c < 43701
                ? (c < 43646
                  ? c == 43642
                  : (c <= 43695 || c == 43697))
                : (c <= 43702 || (c < 43712
                  ? (c >= 43705 && c <= 43709)
                  : c <= 43712)))
              : (c <= 43714 || (c < 43777
                ? (c < 43744
                  ? (c >= 43739 && c <= 43741)
                  : (c <= 43754 || (c >= 43762 && c <= 43764)))
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64285
            ? (c < 55203
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 44032
                  ? (c >= 44016 && c <= 44025)
                  : c <= 44032)))
              : (c <= 55203 || (c < 64112
                ? (c < 55243
                  ? (c >= 55216 && c <= 55238)
                  : (c <= 55291 || (c >= 63744 && c <= 64109)))
                : (c <= 64217 || (c < 64275
                  ? (c >= 64256 && c <= 64262)
                  : c <= 64279)))))
            : (c <= 64285 || (c < 64326
              ? (c < 64318
                ? (c < 64298
                  ? (c >= 64287 && c <= 64296)
                  : (c <= 64310 || (c >= 64312 && c <= 64316)))
                : (c <= 64318 || (c < 64323
                  ? (c >= 64320 && c <= 64321)
                  : c <= 64324)))
              : (c <= 64433 || (c < 65008
                ? (c < 64848
                  ? (c >= 64467 && c <= 64829)
                  : (c <= 64911 || (c >= 64914 && c <= 64967)))
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65305 || (c < 66816
          ? (c < 65664
            ? (c < 65498
              ? (c < 65474
                ? (c < 65345
                  ? (c >= 65313 && c <= 65338)
                  : (c <= 65370 || (c >= 65382 && c <= 65470)))
                : (c <= 65479 || (c < 65490
                  ? (c >= 65482 && c <= 65487)
                  : c <= 65495)))
              : (c <= 65500 || (c < 65596
                ? (c < 65549
                  ? (c >= 65536 && c <= 65547)
                  : (c <= 65574 || (c >= 65576 && c <= 65594)))
                : (c <= 65597 || (c < 65616
                  ? (c >= 65599 && c <= 65613)
                  : c <= 65629)))))
            : (c <= 65786 || (c < 66432
              ? (c < 66349
                ? (c < 66208
                  ? (c >= 66176 && c <= 66204)
                  : (c <= 66256 || (c >= 66304 && c <= 66335)))
                : (c <= 66368 || (c < 66384
                  ? (c >= 66370 && c <= 66377)
                  : c <= 66421)))
              : (c <= 66461 || (c < 66720
                ? (c < 66504
                  ? (c >= 66464 && c <= 66499)
                  : (c <= 66511 || (c >= 66560 && c <= 66717)))
                : (c <= 66729 || (c < 66776
                  ? (c >= 66736 && c <= 66771)
                  : c <= 66811)))))))
          : (c <= 66855 || (c < 67463
            ? (c < 66979
              ? (c < 66956
                ? (c < 66928
                  ? (c >= 66864 && c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))
                : (c <= 66962 || (c < 66967
                  ? (c >= 66964 && c <= 66965)
                  : c <= 66977)))
              : (c <= 66993 || (c < 67392
                ? (c < 67003
                  ? (c >= 66995 && c <= 67001)
                  : (c <= 67004 || (c >= 67072 && c <= 67382)))
                : (c <= 67413 || (c < 67456
                  ? (c >= 67424 && c <= 67431)
                  : c <= 67461)))))
            : (c <= 67504 || (c < 67647
              ? (c < 67594
                ? (c < 67584
                  ? (c >= 67506 && c <= 67514)
                  : (c <= 67589 || c == 67592))
                : (c <= 67637 || (c < 67644
                  ? (c >= 67639 && c <= 67640)
                  : c <= 67644)))
              : (c <= 67669 || (c < 67828
                ? (c < 67712
                  ? (c >= 67680 && c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(61);
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '"') ADVANCE(7);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '&') ADVANCE(90);
      if (lookahead == '\'') ADVANCE(25);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '*') ADVANCE(123);
      if (lookahead == '+') ADVANCE(118);
      if (lookahead == ',') ADVANCE(140);
      if (lookahead == '-') ADVANCE(120);
      if (lookahead == '.') ADVANCE(153);
      if (lookahead == '/') ADVANCE(125);
      if (lookahead == '0') ADVANCE(63);
      if (lookahead == ':') ADVANCE(143);
      if (lookahead == ';') ADVANCE(158);
      if (lookahead == '<') ADVANCE(109);
      if (lookahead == '=') ADVANCE(93);
      if (lookahead == '>') ADVANCE(106);
      if (lookahead == '?') ADVANCE(141);
      if (lookahead == '@') ADVANCE(160);
      if (lookahead == '[') ADVANCE(149);
      if (lookahead == ']') ADVANCE(150);
      if (lookahead == '^') ADVANCE(130);
      if (lookahead == 'n') ADVANCE(166);
      if (lookahead == '{') ADVANCE(156);
      if (lookahead == '|') ADVANCE(127);
      if (lookahead == '}') ADVANCE(157);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(64);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(167);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(1);
      if (lookahead == '"') ADVANCE(11);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(1);
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(1);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(2);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '"') ADVANCE(7);
      if (lookahead == '%') ADVANCE(131);
      if (lookahead == '&') ADVANCE(89);
      if (lookahead == '\'') ADVANCE(25);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '*') ADVANCE(122);
      if (lookahead == '+') ADVANCE(117);
      if (lookahead == ',') ADVANCE(140);
      if (lookahead == '-') ADVANCE(121);
      if (lookahead == '.') ADVANCE(19);
      if (lookahead == '/') ADVANCE(124);
      if (lookahead == '0') ADVANCE(63);
      if (lookahead == ':') ADVANCE(143);
      if (lookahead == ';') ADVANCE(158);
      if (lookahead == '<') ADVANCE(110);
      if (lookahead == '=') ADVANCE(24);
      if (lookahead == '>') ADVANCE(107);
      if (lookahead == '?') ADVANCE(141);
      if (lookahead == '@') ADVANCE(159);
      if (lookahead == '[') ADVANCE(149);
      if (lookahead == ']') ADVANCE(150);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '{') ADVANCE(156);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '}') ADVANCE(157);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(64);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(167);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(144);
      if (lookahead == '"') ADVANCE(7);
      if (lookahead == '&') ADVANCE(88);
      if (lookahead == '\'') ADVANCE(25);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '+') ADVANCE(117);
      if (lookahead == ',') ADVANCE(140);
      if (lookahead == '-') ADVANCE(119);
      if (lookahead == '.') ADVANCE(51);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '0') ADVANCE(63);
      if (lookahead == ':') ADVANCE(142);
      if (lookahead == ';') ADVANCE(158);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(105);
      if (lookahead == '@') ADVANCE(159);
      if (lookahead == '[') ADVANCE(149);
      if (lookahead == 'n') ADVANCE(166);
      if (lookahead == '}') ADVANCE(157);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(4)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(64);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(167);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(23);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '&') ADVANCE(90);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '*') ADVANCE(123);
      if (lookahead == '+') ADVANCE(118);
      if (lookahead == ',') ADVANCE(140);
      if (lookahead == '-') ADVANCE(120);
      if (lookahead == '.') ADVANCE(152);
      if (lookahead == '/') ADVANCE(125);
      if (lookahead == ':') ADVANCE(143);
      if (lookahead == ';') ADVANCE(158);
      if (lookahead == '<') ADVANCE(109);
      if (lookahead == '=') ADVANCE(93);
      if (lookahead == '>') ADVANCE(106);
      if (lookahead == '?') ADVANCE(141);
      if (lookahead == '@') ADVANCE(159);
      if (lookahead == '[') ADVANCE(149);
      if (lookahead == ']') ADVANCE(150);
      if (lookahead == '^') ADVANCE(130);
      if (lookahead == '{') ADVANCE(156);
      if (lookahead == '|') ADVANCE(127);
      if (lookahead == '}') ADVANCE(157);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(5)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(167);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(23);
      if (lookahead == '%') ADVANCE(131);
      if (lookahead == '&') ADVANCE(89);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '*') ADVANCE(122);
      if (lookahead == '+') ADVANCE(117);
      if (lookahead == ',') ADVANCE(140);
      if (lookahead == '-') ADVANCE(121);
      if (lookahead == '.') ADVANCE(151);
      if (lookahead == '/') ADVANCE(124);
      if (lookahead == ':') ADVANCE(143);
      if (lookahead == ';') ADVANCE(158);
      if (lookahead == '<') ADVANCE(110);
      if (lookahead == '=') ADVANCE(24);
      if (lookahead == '>') ADVANCE(107);
      if (lookahead == '?') ADVANCE(141);
      if (lookahead == '@') ADVANCE(159);
      if (lookahead == '[') ADVANCE(149);
      if (lookahead == ']') ADVANCE(150);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '{') ADVANCE(156);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '}') ADVANCE(157);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(6)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(167);
      END_STATE();
    case 7:
      if (lookahead == '"') ADVANCE(85);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(8);
      END_STATE();
    case 8:
      if (lookahead == '"') ADVANCE(84);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(8);
      END_STATE();
    case 9:
      if (lookahead == '"') ADVANCE(11);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 10:
      if (lookahead == '"') ADVANCE(86);
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(10);
      END_STATE();
    case 12:
      if (lookahead == '&') ADVANCE(88);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == ',') ADVANCE(140);
      if (lookahead == '.') ADVANCE(152);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == ':') ADVANCE(143);
      if (lookahead == ';') ADVANCE(158);
      if (lookahead == '<') ADVANCE(108);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(105);
      if (lookahead == '?') ADVANCE(141);
      if (lookahead == '@') ADVANCE(159);
      if (lookahead == '[') ADVANCE(149);
      if (lookahead == '{') ADVANCE(156);
      if (lookahead == '|') ADVANCE(126);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(12)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(167);
      END_STATE();
    case 13:
      if (lookahead == '\'') ADVANCE(83);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(13);
      END_STATE();
    case 14:
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ',') ADVANCE(140);
      if (lookahead == '.') ADVANCE(151);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == ';') ADVANCE(158);
      if (lookahead == '<') ADVANCE(108);
      if (lookahead == '@') ADVANCE(160);
      if (lookahead == 'n') ADVANCE(166);
      if (lookahead == '{') ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(14)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(167);
      END_STATE();
    case 15:
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == '.') ADVANCE(151);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '@') ADVANCE(159);
      if (lookahead == '[') ADVANCE(149);
      if (lookahead == 'n') ADVANCE(166);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(15)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(167);
      END_STATE();
    case 16:
      if (lookahead == '*') ADVANCE(18);
      if (lookahead == '/') ADVANCE(168);
      END_STATE();
    case 17:
      if (lookahead == '*') ADVANCE(17);
      if (lookahead == '/') ADVANCE(169);
      if (lookahead != 0) ADVANCE(18);
      END_STATE();
    case 18:
      if (lookahead == '*') ADVANCE(17);
      if (lookahead != 0) ADVANCE(18);
      END_STATE();
    case 19:
      if (lookahead == '.') ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(74);
      END_STATE();
    case 20:
      if (lookahead == '.') ADVANCE(163);
      END_STATE();
    case 21:
      if (lookahead == '.') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      END_STATE();
    case 22:
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '<') ADVANCE(108);
      if (lookahead == '@') ADVANCE(41);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(22)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(167);
      END_STATE();
    case 23:
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 24:
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 25:
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'') ADVANCE(13);
      END_STATE();
    case 26:
      if (lookahead == '_') ADVANCE(26);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      END_STATE();
    case 27:
      if (lookahead == '_') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(74);
      END_STATE();
    case 28:
      if (lookahead == '_') ADVANCE(28);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(75);
      END_STATE();
    case 29:
      if (lookahead == '_') ADVANCE(30);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(66);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      END_STATE();
    case 30:
      if (lookahead == '_') ADVANCE(30);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(80);
      END_STATE();
    case 31:
      if (lookahead == '_') ADVANCE(30);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(78);
      END_STATE();
    case 32:
      if (lookahead == 'a') ADVANCE(42);
      END_STATE();
    case 33:
      if (lookahead == 'a') ADVANCE(34);
      END_STATE();
    case 34:
      if (lookahead == 'c') ADVANCE(39);
      END_STATE();
    case 35:
      if (lookahead == 'd') ADVANCE(161);
      END_STATE();
    case 36:
      if (lookahead == 'e') ADVANCE(44);
      END_STATE();
    case 37:
      if (lookahead == 'e') ADVANCE(32);
      END_STATE();
    case 38:
      if (lookahead == 'e') ADVANCE(35);
      END_STATE();
    case 39:
      if (lookahead == 'e') ADVANCE(162);
      END_STATE();
    case 40:
      if (lookahead == 'f') ADVANCE(33);
      END_STATE();
    case 41:
      if (lookahead == 'i') ADVANCE(43);
      END_STATE();
    case 42:
      if (lookahead == 'l') ADVANCE(38);
      END_STATE();
    case 43:
      if (lookahead == 'n') ADVANCE(46);
      END_STATE();
    case 44:
      if (lookahead == 'r') ADVANCE(40);
      END_STATE();
    case 45:
      if (lookahead == 's') ADVANCE(37);
      END_STATE();
    case 46:
      if (lookahead == 't') ADVANCE(36);
      END_STATE();
    case 47:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(75);
      END_STATE();
    case 48:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(53);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(80);
      END_STATE();
    case 49:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(72);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(70);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(74);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(75);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(80);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(78);
      END_STATE();
    case 56:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(9);
      END_STATE();
    case 57:
      if (lookahead != 0) ADVANCE(13);
      END_STATE();
    case 58:
      if (lookahead != 0) ADVANCE(8);
      END_STATE();
    case 59:
      if (eof) ADVANCE(61);
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '"') ADVANCE(7);
      if (lookahead == '%') ADVANCE(131);
      if (lookahead == '&') ADVANCE(89);
      if (lookahead == '\'') ADVANCE(25);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '*') ADVANCE(122);
      if (lookahead == '+') ADVANCE(117);
      if (lookahead == ',') ADVANCE(140);
      if (lookahead == '-') ADVANCE(121);
      if (lookahead == '.') ADVANCE(154);
      if (lookahead == '/') ADVANCE(124);
      if (lookahead == '0') ADVANCE(63);
      if (lookahead == ':') ADVANCE(143);
      if (lookahead == ';') ADVANCE(158);
      if (lookahead == '<') ADVANCE(110);
      if (lookahead == '=') ADVANCE(24);
      if (lookahead == '>') ADVANCE(107);
      if (lookahead == '?') ADVANCE(141);
      if (lookahead == '@') ADVANCE(160);
      if (lookahead == '[') ADVANCE(149);
      if (lookahead == ']') ADVANCE(150);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == 'n') ADVANCE(166);
      if (lookahead == '{') ADVANCE(156);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '}') ADVANCE(157);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(59)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(64);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(167);
      END_STATE();
    case 60:
      if (eof) ADVANCE(61);
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '"') ADVANCE(7);
      if (lookahead == '%') ADVANCE(131);
      if (lookahead == '&') ADVANCE(89);
      if (lookahead == '\'') ADVANCE(25);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '*') ADVANCE(122);
      if (lookahead == '+') ADVANCE(117);
      if (lookahead == ',') ADVANCE(140);
      if (lookahead == '-') ADVANCE(121);
      if (lookahead == '.') ADVANCE(51);
      if (lookahead == '/') ADVANCE(124);
      if (lookahead == '0') ADVANCE(63);
      if (lookahead == ':') ADVANCE(142);
      if (lookahead == ';') ADVANCE(158);
      if (lookahead == '<') ADVANCE(110);
      if (lookahead == '=') ADVANCE(24);
      if (lookahead == '>') ADVANCE(107);
      if (lookahead == '?') ADVANCE(141);
      if (lookahead == '@') ADVANCE(160);
      if (lookahead == ']') ADVANCE(150);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == 'n') ADVANCE(166);
      if (lookahead == '{') ADVANCE(156);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '}') ADVANCE(157);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(60)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(64);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(167);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if (lookahead == '.') ADVANCE(76);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(49);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(62);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(50);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(21);
      if (lookahead == '_') ADVANCE(26);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(47);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(47);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if (lookahead == '.') ADVANCE(76);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(62);
      if (lookahead == '_') ADVANCE(26);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(47);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(47);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_hex_integer_literal);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_hex_integer_literal);
      if (lookahead == '.') ADVANCE(82);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(65);
      if (lookahead == '_') ADVANCE(29);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(68);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      if (('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(66);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_hex_integer_literal);
      if (lookahead == '.') ADVANCE(82);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(65);
      if (lookahead == '_') ADVANCE(54);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(68);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_hex_integer_literal);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(53);
      if (lookahead == '.') ADVANCE(82);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(65);
      if (lookahead == '_') ADVANCE(54);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(68);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(66);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_octal_integer_literal);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_octal_integer_literal);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(69);
      if (lookahead == '_') ADVANCE(50);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(70);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_binary_integer_literal);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_binary_integer_literal);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(71);
      if (lookahead == '_') ADVANCE(49);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(72);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_decimal_floating_point_literal);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_decimal_floating_point_literal);
      if (lookahead == '_') ADVANCE(27);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(47);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(74);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_decimal_floating_point_literal);
      if (lookahead == '_') ADVANCE(28);
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(75);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_decimal_floating_point_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(47);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(74);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == '_') ADVANCE(55);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(81);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(78);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == '_') ADVANCE(31);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(81);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(78);
      if (('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(79);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == '_') ADVANCE(30);
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(80);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(53);
      if (lookahead == '_') ADVANCE(55);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(81);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(79);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(81);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(78);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_character_literal);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_string_literal);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_string_literal);
      if (lookahead == '"') ADVANCE(2);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_text_block);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(115);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(115);
      if (lookahead == '=') ADVANCE(98);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(111);
      if (lookahead == '>') ADVANCE(135);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(111);
      if (lookahead == '>') ADVANCE(136);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(134);
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(133);
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(147);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(147);
      if (lookahead == '=') ADVANCE(94);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(148);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(148);
      if (lookahead == '=') ADVANCE(95);
      if (lookahead == '>') ADVANCE(139);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(148);
      if (lookahead == '>') ADVANCE(139);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(96);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(18);
      if (lookahead == '/') ADVANCE(168);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(18);
      if (lookahead == '/') ADVANCE(168);
      if (lookahead == '=') ADVANCE(97);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == '|') ADVANCE(116);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(116);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(100);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(101);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(102);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(103);
      if (lookahead == '>') ADVANCE(138);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(137);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(104);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(155);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(20);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(74);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(74);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == 'i') ADVANCE(43);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_non_DASHsealed);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_ATinterface);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(45);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(167);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(164);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(167);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(165);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(167);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(167);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(168);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_block_comment);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'i') ADVANCE(7);
      if (lookahead == 'l') ADVANCE(8);
      if (lookahead == 'm') ADVANCE(9);
      if (lookahead == 'n') ADVANCE(10);
      if (lookahead == 'o') ADVANCE(11);
      if (lookahead == 'p') ADVANCE(12);
      if (lookahead == 'r') ADVANCE(13);
      if (lookahead == 's') ADVANCE(14);
      if (lookahead == 't') ADVANCE(15);
      if (lookahead == 'u') ADVANCE(16);
      if (lookahead == 'v') ADVANCE(17);
      if (lookahead == 'w') ADVANCE(18);
      if (lookahead == 'y') ADVANCE(19);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(20);
      if (lookahead == 's') ADVANCE(21);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(22);
      if (lookahead == 'r') ADVANCE(23);
      if (lookahead == 'y') ADVANCE(24);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(25);
      if (lookahead == 'h') ADVANCE(26);
      if (lookahead == 'l') ADVANCE(27);
      if (lookahead == 'o') ADVANCE(28);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(31);
      if (lookahead == 'n') ADVANCE(32);
      if (lookahead == 'x') ADVANCE(33);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(34);
      if (lookahead == 'i') ADVANCE(35);
      if (lookahead == 'l') ADVANCE(36);
      if (lookahead == 'o') ADVANCE(37);
      END_STATE();
    case 7:
      if (lookahead == 'f') ADVANCE(38);
      if (lookahead == 'm') ADVANCE(39);
      if (lookahead == 'n') ADVANCE(40);
      END_STATE();
    case 8:
      if (lookahead == 'o') ADVANCE(41);
      END_STATE();
    case 9:
      if (lookahead == 'o') ADVANCE(42);
      END_STATE();
    case 10:
      if (lookahead == 'a') ADVANCE(43);
      if (lookahead == 'e') ADVANCE(44);
      if (lookahead == 'u') ADVANCE(45);
      END_STATE();
    case 11:
      if (lookahead == 'p') ADVANCE(46);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(47);
      if (lookahead == 'e') ADVANCE(48);
      if (lookahead == 'r') ADVANCE(49);
      if (lookahead == 'u') ADVANCE(50);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(51);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(52);
      if (lookahead == 'h') ADVANCE(53);
      if (lookahead == 't') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(55);
      if (lookahead == 'w') ADVANCE(56);
      if (lookahead == 'y') ADVANCE(57);
      END_STATE();
    case 15:
      if (lookahead == 'h') ADVANCE(58);
      if (lookahead == 'o') ADVANCE(59);
      if (lookahead == 'r') ADVANCE(60);
      END_STATE();
    case 16:
      if (lookahead == 's') ADVANCE(61);
      END_STATE();
    case 17:
      if (lookahead == 'o') ADVANCE(62);
      END_STATE();
    case 18:
      if (lookahead == 'h') ADVANCE(63);
      if (lookahead == 'i') ADVANCE(64);
      END_STATE();
    case 19:
      if (lookahead == 'i') ADVANCE(65);
      END_STATE();
    case 20:
      if (lookahead == 's') ADVANCE(66);
      END_STATE();
    case 21:
      if (lookahead == 's') ADVANCE(67);
      END_STATE();
    case 22:
      if (lookahead == 'o') ADVANCE(68);
      END_STATE();
    case 23:
      if (lookahead == 'e') ADVANCE(69);
      END_STATE();
    case 24:
      if (lookahead == 't') ADVANCE(70);
      END_STATE();
    case 25:
      if (lookahead == 's') ADVANCE(71);
      if (lookahead == 't') ADVANCE(72);
      END_STATE();
    case 26:
      if (lookahead == 'a') ADVANCE(73);
      END_STATE();
    case 27:
      if (lookahead == 'a') ADVANCE(74);
      END_STATE();
    case 28:
      if (lookahead == 'n') ADVANCE(75);
      END_STATE();
    case 29:
      if (lookahead == 'f') ADVANCE(76);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u') ADVANCE(77);
      END_STATE();
    case 31:
      if (lookahead == 's') ADVANCE(78);
      END_STATE();
    case 32:
      if (lookahead == 'u') ADVANCE(79);
      END_STATE();
    case 33:
      if (lookahead == 'p') ADVANCE(80);
      if (lookahead == 't') ADVANCE(81);
      END_STATE();
    case 34:
      if (lookahead == 'l') ADVANCE(82);
      END_STATE();
    case 35:
      if (lookahead == 'n') ADVANCE(83);
      END_STATE();
    case 36:
      if (lookahead == 'o') ADVANCE(84);
      END_STATE();
    case 37:
      if (lookahead == 'r') ADVANCE(85);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 39:
      if (lookahead == 'p') ADVANCE(86);
      END_STATE();
    case 40:
      if (lookahead == 's') ADVANCE(87);
      if (lookahead == 't') ADVANCE(88);
      END_STATE();
    case 41:
      if (lookahead == 'n') ADVANCE(89);
      END_STATE();
    case 42:
      if (lookahead == 'd') ADVANCE(90);
      END_STATE();
    case 43:
      if (lookahead == 't') ADVANCE(91);
      END_STATE();
    case 44:
      if (lookahead == 'w') ADVANCE(92);
      END_STATE();
    case 45:
      if (lookahead == 'l') ADVANCE(93);
      END_STATE();
    case 46:
      if (lookahead == 'e') ADVANCE(94);
      END_STATE();
    case 47:
      if (lookahead == 'c') ADVANCE(95);
      END_STATE();
    case 48:
      if (lookahead == 'r') ADVANCE(96);
      END_STATE();
    case 49:
      if (lookahead == 'i') ADVANCE(97);
      if (lookahead == 'o') ADVANCE(98);
      END_STATE();
    case 50:
      if (lookahead == 'b') ADVANCE(99);
      END_STATE();
    case 51:
      if (lookahead == 'c') ADVANCE(100);
      if (lookahead == 'q') ADVANCE(101);
      if (lookahead == 't') ADVANCE(102);
      END_STATE();
    case 52:
      if (lookahead == 'a') ADVANCE(103);
      END_STATE();
    case 53:
      if (lookahead == 'o') ADVANCE(104);
      END_STATE();
    case 54:
      if (lookahead == 'a') ADVANCE(105);
      if (lookahead == 'r') ADVANCE(106);
      END_STATE();
    case 55:
      if (lookahead == 'p') ADVANCE(107);
      END_STATE();
    case 56:
      if (lookahead == 'i') ADVANCE(108);
      END_STATE();
    case 57:
      if (lookahead == 'n') ADVANCE(109);
      END_STATE();
    case 58:
      if (lookahead == 'i') ADVANCE(110);
      if (lookahead == 'r') ADVANCE(111);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_to);
      END_STATE();
    case 60:
      if (lookahead == 'a') ADVANCE(112);
      if (lookahead == 'u') ADVANCE(113);
      if (lookahead == 'y') ADVANCE(114);
      END_STATE();
    case 61:
      if (lookahead == 'e') ADVANCE(115);
      END_STATE();
    case 62:
      if (lookahead == 'i') ADVANCE(116);
      if (lookahead == 'l') ADVANCE(117);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(118);
      END_STATE();
    case 64:
      if (lookahead == 't') ADVANCE(119);
      END_STATE();
    case 65:
      if (lookahead == 'e') ADVANCE(120);
      END_STATE();
    case 66:
      if (lookahead == 't') ADVANCE(121);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(122);
      END_STATE();
    case 68:
      if (lookahead == 'l') ADVANCE(123);
      END_STATE();
    case 69:
      if (lookahead == 'a') ADVANCE(124);
      END_STATE();
    case 70:
      if (lookahead == 'e') ADVANCE(125);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(126);
      END_STATE();
    case 72:
      if (lookahead == 'c') ADVANCE(127);
      END_STATE();
    case 73:
      if (lookahead == 'r') ADVANCE(128);
      END_STATE();
    case 74:
      if (lookahead == 's') ADVANCE(129);
      END_STATE();
    case 75:
      if (lookahead == 't') ADVANCE(130);
      END_STATE();
    case 76:
      if (lookahead == 'a') ADVANCE(131);
      END_STATE();
    case 77:
      if (lookahead == 'b') ADVANCE(132);
      END_STATE();
    case 78:
      if (lookahead == 'e') ADVANCE(133);
      END_STATE();
    case 79:
      if (lookahead == 'm') ADVANCE(134);
      END_STATE();
    case 80:
      if (lookahead == 'o') ADVANCE(135);
      END_STATE();
    case 81:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 82:
      if (lookahead == 's') ADVANCE(137);
      END_STATE();
    case 83:
      if (lookahead == 'a') ADVANCE(138);
      END_STATE();
    case 84:
      if (lookahead == 'a') ADVANCE(139);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 86:
      if (lookahead == 'l') ADVANCE(140);
      if (lookahead == 'o') ADVANCE(141);
      END_STATE();
    case 87:
      if (lookahead == 't') ADVANCE(142);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_int);
      if (lookahead == 'e') ADVANCE(143);
      END_STATE();
    case 89:
      if (lookahead == 'g') ADVANCE(144);
      END_STATE();
    case 90:
      if (lookahead == 'u') ADVANCE(145);
      END_STATE();
    case 91:
      if (lookahead == 'i') ADVANCE(146);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 93:
      if (lookahead == 'l') ADVANCE(147);
      END_STATE();
    case 94:
      if (lookahead == 'n') ADVANCE(148);
      END_STATE();
    case 95:
      if (lookahead == 'k') ADVANCE(149);
      END_STATE();
    case 96:
      if (lookahead == 'm') ADVANCE(150);
      END_STATE();
    case 97:
      if (lookahead == 'v') ADVANCE(151);
      END_STATE();
    case 98:
      if (lookahead == 't') ADVANCE(152);
      if (lookahead == 'v') ADVANCE(153);
      END_STATE();
    case 99:
      if (lookahead == 'l') ADVANCE(154);
      END_STATE();
    case 100:
      if (lookahead == 'o') ADVANCE(155);
      END_STATE();
    case 101:
      if (lookahead == 'u') ADVANCE(156);
      END_STATE();
    case 102:
      if (lookahead == 'u') ADVANCE(157);
      END_STATE();
    case 103:
      if (lookahead == 'l') ADVANCE(158);
      END_STATE();
    case 104:
      if (lookahead == 'r') ADVANCE(159);
      END_STATE();
    case 105:
      if (lookahead == 't') ADVANCE(160);
      END_STATE();
    case 106:
      if (lookahead == 'i') ADVANCE(161);
      END_STATE();
    case 107:
      if (lookahead == 'e') ADVANCE(162);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(163);
      END_STATE();
    case 109:
      if (lookahead == 'c') ADVANCE(164);
      END_STATE();
    case 110:
      if (lookahead == 's') ADVANCE(165);
      END_STATE();
    case 111:
      if (lookahead == 'o') ADVANCE(166);
      END_STATE();
    case 112:
      if (lookahead == 'n') ADVANCE(167);
      END_STATE();
    case 113:
      if (lookahead == 'e') ADVANCE(168);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 115:
      if (lookahead == 's') ADVANCE(169);
      END_STATE();
    case 116:
      if (lookahead == 'd') ADVANCE(170);
      END_STATE();
    case 117:
      if (lookahead == 'a') ADVANCE(171);
      END_STATE();
    case 118:
      if (lookahead == 'l') ADVANCE(172);
      END_STATE();
    case 119:
      if (lookahead == 'h') ADVANCE(173);
      END_STATE();
    case 120:
      if (lookahead == 'l') ADVANCE(174);
      END_STATE();
    case 121:
      if (lookahead == 'r') ADVANCE(175);
      END_STATE();
    case 122:
      if (lookahead == 'r') ADVANCE(176);
      END_STATE();
    case 123:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 124:
      if (lookahead == 'k') ADVANCE(178);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_byte);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 127:
      if (lookahead == 'h') ADVANCE(179);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_char);
      END_STATE();
    case 129:
      if (lookahead == 's') ADVANCE(180);
      END_STATE();
    case 130:
      if (lookahead == 'i') ADVANCE(181);
      END_STATE();
    case 131:
      if (lookahead == 'u') ADVANCE(182);
      END_STATE();
    case 132:
      if (lookahead == 'l') ADVANCE(183);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 135:
      if (lookahead == 'r') ADVANCE(184);
      END_STATE();
    case 136:
      if (lookahead == 'n') ADVANCE(185);
      END_STATE();
    case 137:
      if (lookahead == 'e') ADVANCE(186);
      END_STATE();
    case 138:
      if (lookahead == 'l') ADVANCE(187);
      END_STATE();
    case 139:
      if (lookahead == 't') ADVANCE(188);
      END_STATE();
    case 140:
      if (lookahead == 'e') ADVANCE(189);
      END_STATE();
    case 141:
      if (lookahead == 'r') ADVANCE(190);
      END_STATE();
    case 142:
      if (lookahead == 'a') ADVANCE(191);
      END_STATE();
    case 143:
      if (lookahead == 'r') ADVANCE(192);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 145:
      if (lookahead == 'l') ADVANCE(193);
      END_STATE();
    case 146:
      if (lookahead == 'v') ADVANCE(194);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_null_literal);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_open);
      if (lookahead == 's') ADVANCE(195);
      END_STATE();
    case 149:
      if (lookahead == 'a') ADVANCE(196);
      END_STATE();
    case 150:
      if (lookahead == 'i') ADVANCE(197);
      END_STATE();
    case 151:
      if (lookahead == 'a') ADVANCE(198);
      END_STATE();
    case 152:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 153:
      if (lookahead == 'i') ADVANCE(200);
      END_STATE();
    case 154:
      if (lookahead == 'i') ADVANCE(201);
      END_STATE();
    case 155:
      if (lookahead == 'r') ADVANCE(202);
      END_STATE();
    case 156:
      if (lookahead == 'i') ADVANCE(203);
      END_STATE();
    case 157:
      if (lookahead == 'r') ADVANCE(204);
      END_STATE();
    case 158:
      if (lookahead == 'e') ADVANCE(205);
      END_STATE();
    case 159:
      if (lookahead == 't') ADVANCE(206);
      END_STATE();
    case 160:
      if (lookahead == 'i') ADVANCE(207);
      END_STATE();
    case 161:
      if (lookahead == 'c') ADVANCE(208);
      END_STATE();
    case 162:
      if (lookahead == 'r') ADVANCE(209);
      END_STATE();
    case 163:
      if (lookahead == 'c') ADVANCE(210);
      END_STATE();
    case 164:
      if (lookahead == 'h') ADVANCE(211);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 166:
      if (lookahead == 'w') ADVANCE(212);
      END_STATE();
    case 167:
      if (lookahead == 's') ADVANCE(213);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_uses);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_void_type);
      END_STATE();
    case 171:
      if (lookahead == 't') ADVANCE(214);
      END_STATE();
    case 172:
      if (lookahead == 'e') ADVANCE(215);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 174:
      if (lookahead == 'd') ADVANCE(216);
      END_STATE();
    case 175:
      if (lookahead == 'a') ADVANCE(217);
      END_STATE();
    case 176:
      if (lookahead == 't') ADVANCE(218);
      END_STATE();
    case 177:
      if (lookahead == 'a') ADVANCE(219);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 181:
      if (lookahead == 'n') ADVANCE(220);
      END_STATE();
    case 182:
      if (lookahead == 'l') ADVANCE(221);
      END_STATE();
    case 183:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 184:
      if (lookahead == 't') ADVANCE(223);
      END_STATE();
    case 185:
      if (lookahead == 'd') ADVANCE(224);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_final);
      if (lookahead == 'l') ADVANCE(225);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 189:
      if (lookahead == 'm') ADVANCE(226);
      END_STATE();
    case 190:
      if (lookahead == 't') ADVANCE(227);
      END_STATE();
    case 191:
      if (lookahead == 'n') ADVANCE(228);
      END_STATE();
    case 192:
      if (lookahead == 'f') ADVANCE(229);
      END_STATE();
    case 193:
      if (lookahead == 'e') ADVANCE(230);
      END_STATE();
    case 194:
      if (lookahead == 'e') ADVANCE(231);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_opens);
      END_STATE();
    case 196:
      if (lookahead == 'g') ADVANCE(232);
      END_STATE();
    case 197:
      if (lookahead == 't') ADVANCE(233);
      END_STATE();
    case 198:
      if (lookahead == 't') ADVANCE(234);
      END_STATE();
    case 199:
      if (lookahead == 'c') ADVANCE(235);
      END_STATE();
    case 200:
      if (lookahead == 'd') ADVANCE(236);
      END_STATE();
    case 201:
      if (lookahead == 'c') ADVANCE(237);
      END_STATE();
    case 202:
      if (lookahead == 'd') ADVANCE(238);
      END_STATE();
    case 203:
      if (lookahead == 'r') ADVANCE(239);
      END_STATE();
    case 204:
      if (lookahead == 'n') ADVANCE(240);
      END_STATE();
    case 205:
      if (lookahead == 'd') ADVANCE(241);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 207:
      if (lookahead == 'c') ADVANCE(242);
      END_STATE();
    case 208:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 210:
      if (lookahead == 'h') ADVANCE(244);
      END_STATE();
    case 211:
      if (lookahead == 'r') ADVANCE(245);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_throw);
      if (lookahead == 's') ADVANCE(246);
      END_STATE();
    case 213:
      if (lookahead == 'i') ADVANCE(247);
      END_STATE();
    case 214:
      if (lookahead == 'i') ADVANCE(248);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 217:
      if (lookahead == 'c') ADVANCE(249);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 219:
      if (lookahead == 'n') ADVANCE(250);
      END_STATE();
    case 220:
      if (lookahead == 'u') ADVANCE(251);
      END_STATE();
    case 221:
      if (lookahead == 't') ADVANCE(252);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_double);
      END_STATE();
    case 223:
      if (lookahead == 's') ADVANCE(253);
      END_STATE();
    case 224:
      if (lookahead == 's') ADVANCE(254);
      END_STATE();
    case 225:
      if (lookahead == 'y') ADVANCE(255);
      END_STATE();
    case 226:
      if (lookahead == 'e') ADVANCE(256);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 228:
      if (lookahead == 'c') ADVANCE(257);
      END_STATE();
    case 229:
      if (lookahead == 'a') ADVANCE(258);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_native);
      END_STATE();
    case 232:
      if (lookahead == 'e') ADVANCE(259);
      END_STATE();
    case 233:
      if (lookahead == 's') ADVANCE(260);
      END_STATE();
    case 234:
      if (lookahead == 'e') ADVANCE(261);
      END_STATE();
    case 235:
      if (lookahead == 't') ADVANCE(262);
      END_STATE();
    case 236:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_record);
      END_STATE();
    case 239:
      if (lookahead == 'e') ADVANCE(264);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_sealed);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 243:
      if (lookahead == 'f') ADVANCE(265);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 245:
      if (lookahead == 'o') ADVANCE(266);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_throws);
      END_STATE();
    case 247:
      if (lookahead == 'e') ADVANCE(267);
      if (lookahead == 't') ADVANCE(268);
      END_STATE();
    case 248:
      if (lookahead == 'l') ADVANCE(269);
      END_STATE();
    case 249:
      if (lookahead == 't') ADVANCE(270);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_boolean_type);
      END_STATE();
    case 251:
      if (lookahead == 'e') ADVANCE(271);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_exports);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 256:
      if (lookahead == 'n') ADVANCE(272);
      END_STATE();
    case 257:
      if (lookahead == 'e') ADVANCE(273);
      END_STATE();
    case 258:
      if (lookahead == 'c') ADVANCE(274);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_package);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_permits);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 262:
      if (lookahead == 'e') ADVANCE(275);
      END_STATE();
    case 263:
      if (lookahead == 's') ADVANCE(276);
      END_STATE();
    case 264:
      if (lookahead == 's') ADVANCE(277);
      END_STATE();
    case 265:
      if (lookahead == 'p') ADVANCE(278);
      END_STATE();
    case 266:
      if (lookahead == 'n') ADVANCE(279);
      END_STATE();
    case 267:
      if (lookahead == 'n') ADVANCE(280);
      END_STATE();
    case 268:
      if (lookahead == 'i') ADVANCE(281);
      END_STATE();
    case 269:
      if (lookahead == 'e') ADVANCE(282);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 272:
      if (lookahead == 't') ADVANCE(283);
      END_STATE();
    case 273:
      if (lookahead == 'o') ADVANCE(284);
      END_STATE();
    case 274:
      if (lookahead == 'e') ADVANCE(285);
      END_STATE();
    case 275:
      if (lookahead == 'd') ADVANCE(286);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_provides);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_requires);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_strictfp);
      END_STATE();
    case 279:
      if (lookahead == 'i') ADVANCE(287);
      END_STATE();
    case 280:
      if (lookahead == 't') ADVANCE(288);
      END_STATE();
    case 281:
      if (lookahead == 'v') ADVANCE(289);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 283:
      if (lookahead == 's') ADVANCE(290);
      END_STATE();
    case 284:
      if (lookahead == 'f') ADVANCE(291);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 287:
      if (lookahead == 'z') ADVANCE(292);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_transient);
      END_STATE();
    case 289:
      if (lookahead == 'e') ADVANCE(293);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    case 292:
      if (lookahead == 'e') ADVANCE(294);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_transitive);
      END_STATE();
    case 294:
      if (lookahead == 'd') ADVANCE(295);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_synchronized);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 60},
  [2] = {.lex_state = 60},
  [3] = {.lex_state = 60},
  [4] = {.lex_state = 60},
  [5] = {.lex_state = 60},
  [6] = {.lex_state = 60},
  [7] = {.lex_state = 60},
  [8] = {.lex_state = 60},
  [9] = {.lex_state = 60},
  [10] = {.lex_state = 60},
  [11] = {.lex_state = 60},
  [12] = {.lex_state = 60},
  [13] = {.lex_state = 60},
  [14] = {.lex_state = 60},
  [15] = {.lex_state = 60},
  [16] = {.lex_state = 60},
  [17] = {.lex_state = 60},
  [18] = {.lex_state = 60},
  [19] = {.lex_state = 60},
  [20] = {.lex_state = 60},
  [21] = {.lex_state = 60},
  [22] = {.lex_state = 60},
  [23] = {.lex_state = 60},
  [24] = {.lex_state = 60},
  [25] = {.lex_state = 60},
  [26] = {.lex_state = 60},
  [27] = {.lex_state = 60},
  [28] = {.lex_state = 60},
  [29] = {.lex_state = 60},
  [30] = {.lex_state = 60},
  [31] = {.lex_state = 60},
  [32] = {.lex_state = 60},
  [33] = {.lex_state = 60},
  [34] = {.lex_state = 60},
  [35] = {.lex_state = 60},
  [36] = {.lex_state = 60},
  [37] = {.lex_state = 60},
  [38] = {.lex_state = 60},
  [39] = {.lex_state = 60},
  [40] = {.lex_state = 60},
  [41] = {.lex_state = 60},
  [42] = {.lex_state = 60},
  [43] = {.lex_state = 60},
  [44] = {.lex_state = 60},
  [45] = {.lex_state = 60},
  [46] = {.lex_state = 60},
  [47] = {.lex_state = 60},
  [48] = {.lex_state = 60},
  [49] = {.lex_state = 60},
  [50] = {.lex_state = 60},
  [51] = {.lex_state = 60},
  [52] = {.lex_state = 60},
  [53] = {.lex_state = 60},
  [54] = {.lex_state = 60},
  [55] = {.lex_state = 60},
  [56] = {.lex_state = 60},
  [57] = {.lex_state = 60},
  [58] = {.lex_state = 60},
  [59] = {.lex_state = 60},
  [60] = {.lex_state = 60},
  [61] = {.lex_state = 60},
  [62] = {.lex_state = 60},
  [63] = {.lex_state = 60},
  [64] = {.lex_state = 60},
  [65] = {.lex_state = 60},
  [66] = {.lex_state = 60},
  [67] = {.lex_state = 60},
  [68] = {.lex_state = 60},
  [69] = {.lex_state = 60},
  [70] = {.lex_state = 60},
  [71] = {.lex_state = 60},
  [72] = {.lex_state = 60},
  [73] = {.lex_state = 60},
  [74] = {.lex_state = 60},
  [75] = {.lex_state = 59},
  [76] = {.lex_state = 59},
  [77] = {.lex_state = 59},
  [78] = {.lex_state = 60},
  [79] = {.lex_state = 60},
  [80] = {.lex_state = 60},
  [81] = {.lex_state = 60},
  [82] = {.lex_state = 60},
  [83] = {.lex_state = 60},
  [84] = {.lex_state = 4},
  [85] = {.lex_state = 4},
  [86] = {.lex_state = 4},
  [87] = {.lex_state = 4},
  [88] = {.lex_state = 60},
  [89] = {.lex_state = 60},
  [90] = {.lex_state = 60},
  [91] = {.lex_state = 60},
  [92] = {.lex_state = 3},
  [93] = {.lex_state = 3},
  [94] = {.lex_state = 3},
  [95] = {.lex_state = 3},
  [96] = {.lex_state = 3},
  [97] = {.lex_state = 3},
  [98] = {.lex_state = 60},
  [99] = {.lex_state = 60},
  [100] = {.lex_state = 60},
  [101] = {.lex_state = 3},
  [102] = {.lex_state = 3},
  [103] = {.lex_state = 60},
  [104] = {.lex_state = 60},
  [105] = {.lex_state = 60},
  [106] = {.lex_state = 60},
  [107] = {.lex_state = 60},
  [108] = {.lex_state = 60},
  [109] = {.lex_state = 60},
  [110] = {.lex_state = 60},
  [111] = {.lex_state = 60},
  [112] = {.lex_state = 60},
  [113] = {.lex_state = 60},
  [114] = {.lex_state = 60},
  [115] = {.lex_state = 60},
  [116] = {.lex_state = 60},
  [117] = {.lex_state = 60},
  [118] = {.lex_state = 60},
  [119] = {.lex_state = 60},
  [120] = {.lex_state = 60},
  [121] = {.lex_state = 60},
  [122] = {.lex_state = 60},
  [123] = {.lex_state = 60},
  [124] = {.lex_state = 60},
  [125] = {.lex_state = 60},
  [126] = {.lex_state = 60},
  [127] = {.lex_state = 3},
  [128] = {.lex_state = 60},
  [129] = {.lex_state = 60},
  [130] = {.lex_state = 60},
  [131] = {.lex_state = 60},
  [132] = {.lex_state = 60},
  [133] = {.lex_state = 60},
  [134] = {.lex_state = 60},
  [135] = {.lex_state = 60},
  [136] = {.lex_state = 60},
  [137] = {.lex_state = 60},
  [138] = {.lex_state = 60},
  [139] = {.lex_state = 60},
  [140] = {.lex_state = 60},
  [141] = {.lex_state = 60},
  [142] = {.lex_state = 60},
  [143] = {.lex_state = 60},
  [144] = {.lex_state = 3},
  [145] = {.lex_state = 60},
  [146] = {.lex_state = 60},
  [147] = {.lex_state = 60},
  [148] = {.lex_state = 60},
  [149] = {.lex_state = 60},
  [150] = {.lex_state = 60},
  [151] = {.lex_state = 60},
  [152] = {.lex_state = 60},
  [153] = {.lex_state = 60},
  [154] = {.lex_state = 60},
  [155] = {.lex_state = 60},
  [156] = {.lex_state = 60},
  [157] = {.lex_state = 60},
  [158] = {.lex_state = 60},
  [159] = {.lex_state = 60},
  [160] = {.lex_state = 60},
  [161] = {.lex_state = 60},
  [162] = {.lex_state = 60},
  [163] = {.lex_state = 60},
  [164] = {.lex_state = 60},
  [165] = {.lex_state = 60},
  [166] = {.lex_state = 3},
  [167] = {.lex_state = 60},
  [168] = {.lex_state = 60},
  [169] = {.lex_state = 60},
  [170] = {.lex_state = 60},
  [171] = {.lex_state = 60},
  [172] = {.lex_state = 3},
  [173] = {.lex_state = 60},
  [174] = {.lex_state = 3},
  [175] = {.lex_state = 60},
  [176] = {.lex_state = 60},
  [177] = {.lex_state = 60},
  [178] = {.lex_state = 3},
  [179] = {.lex_state = 60},
  [180] = {.lex_state = 60},
  [181] = {.lex_state = 60},
  [182] = {.lex_state = 60},
  [183] = {.lex_state = 60},
  [184] = {.lex_state = 60},
  [185] = {.lex_state = 60},
  [186] = {.lex_state = 60},
  [187] = {.lex_state = 60},
  [188] = {.lex_state = 60},
  [189] = {.lex_state = 60},
  [190] = {.lex_state = 60},
  [191] = {.lex_state = 60},
  [192] = {.lex_state = 60},
  [193] = {.lex_state = 60},
  [194] = {.lex_state = 60},
  [195] = {.lex_state = 60},
  [196] = {.lex_state = 60},
  [197] = {.lex_state = 60},
  [198] = {.lex_state = 60},
  [199] = {.lex_state = 60},
  [200] = {.lex_state = 60},
  [201] = {.lex_state = 60},
  [202] = {.lex_state = 3},
  [203] = {.lex_state = 3},
  [204] = {.lex_state = 60},
  [205] = {.lex_state = 60},
  [206] = {.lex_state = 60},
  [207] = {.lex_state = 60},
  [208] = {.lex_state = 60},
  [209] = {.lex_state = 60},
  [210] = {.lex_state = 60},
  [211] = {.lex_state = 60},
  [212] = {.lex_state = 60},
  [213] = {.lex_state = 60},
  [214] = {.lex_state = 60},
  [215] = {.lex_state = 60},
  [216] = {.lex_state = 60},
  [217] = {.lex_state = 60},
  [218] = {.lex_state = 3},
  [219] = {.lex_state = 60},
  [220] = {.lex_state = 60},
  [221] = {.lex_state = 3},
  [222] = {.lex_state = 60},
  [223] = {.lex_state = 60},
  [224] = {.lex_state = 60},
  [225] = {.lex_state = 3},
  [226] = {.lex_state = 60},
  [227] = {.lex_state = 60},
  [228] = {.lex_state = 60},
  [229] = {.lex_state = 60},
  [230] = {.lex_state = 60},
  [231] = {.lex_state = 60},
  [232] = {.lex_state = 60},
  [233] = {.lex_state = 60},
  [234] = {.lex_state = 60},
  [235] = {.lex_state = 60},
  [236] = {.lex_state = 60},
  [237] = {.lex_state = 60},
  [238] = {.lex_state = 60},
  [239] = {.lex_state = 60},
  [240] = {.lex_state = 60},
  [241] = {.lex_state = 60},
  [242] = {.lex_state = 60},
  [243] = {.lex_state = 60},
  [244] = {.lex_state = 60},
  [245] = {.lex_state = 60},
  [246] = {.lex_state = 60},
  [247] = {.lex_state = 60},
  [248] = {.lex_state = 60},
  [249] = {.lex_state = 60},
  [250] = {.lex_state = 60},
  [251] = {.lex_state = 60},
  [252] = {.lex_state = 60},
  [253] = {.lex_state = 60},
  [254] = {.lex_state = 60},
  [255] = {.lex_state = 60},
  [256] = {.lex_state = 60},
  [257] = {.lex_state = 3},
  [258] = {.lex_state = 60},
  [259] = {.lex_state = 3},
  [260] = {.lex_state = 3},
  [261] = {.lex_state = 3},
  [262] = {.lex_state = 3},
  [263] = {.lex_state = 3},
  [264] = {.lex_state = 3},
  [265] = {.lex_state = 3},
  [266] = {.lex_state = 3},
  [267] = {.lex_state = 3},
  [268] = {.lex_state = 3},
  [269] = {.lex_state = 3},
  [270] = {.lex_state = 3},
  [271] = {.lex_state = 3},
  [272] = {.lex_state = 3},
  [273] = {.lex_state = 3},
  [274] = {.lex_state = 3},
  [275] = {.lex_state = 3},
  [276] = {.lex_state = 3},
  [277] = {.lex_state = 3},
  [278] = {.lex_state = 3},
  [279] = {.lex_state = 3},
  [280] = {.lex_state = 3},
  [281] = {.lex_state = 3},
  [282] = {.lex_state = 3},
  [283] = {.lex_state = 3},
  [284] = {.lex_state = 3},
  [285] = {.lex_state = 3},
  [286] = {.lex_state = 3},
  [287] = {.lex_state = 3},
  [288] = {.lex_state = 3},
  [289] = {.lex_state = 3},
  [290] = {.lex_state = 3},
  [291] = {.lex_state = 3},
  [292] = {.lex_state = 3},
  [293] = {.lex_state = 3},
  [294] = {.lex_state = 3},
  [295] = {.lex_state = 3},
  [296] = {.lex_state = 3},
  [297] = {.lex_state = 3},
  [298] = {.lex_state = 3},
  [299] = {.lex_state = 3},
  [300] = {.lex_state = 3},
  [301] = {.lex_state = 3},
  [302] = {.lex_state = 3},
  [303] = {.lex_state = 3},
  [304] = {.lex_state = 3},
  [305] = {.lex_state = 3},
  [306] = {.lex_state = 3},
  [307] = {.lex_state = 3},
  [308] = {.lex_state = 3},
  [309] = {.lex_state = 3},
  [310] = {.lex_state = 3},
  [311] = {.lex_state = 3},
  [312] = {.lex_state = 3},
  [313] = {.lex_state = 3},
  [314] = {.lex_state = 3},
  [315] = {.lex_state = 3},
  [316] = {.lex_state = 3},
  [317] = {.lex_state = 3},
  [318] = {.lex_state = 3},
  [319] = {.lex_state = 3},
  [320] = {.lex_state = 3},
  [321] = {.lex_state = 3},
  [322] = {.lex_state = 60},
  [323] = {.lex_state = 3},
  [324] = {.lex_state = 3},
  [325] = {.lex_state = 3},
  [326] = {.lex_state = 3},
  [327] = {.lex_state = 3},
  [328] = {.lex_state = 3},
  [329] = {.lex_state = 3},
  [330] = {.lex_state = 3},
  [331] = {.lex_state = 3},
  [332] = {.lex_state = 3},
  [333] = {.lex_state = 3},
  [334] = {.lex_state = 3},
  [335] = {.lex_state = 3},
  [336] = {.lex_state = 3},
  [337] = {.lex_state = 3},
  [338] = {.lex_state = 3},
  [339] = {.lex_state = 3},
  [340] = {.lex_state = 3},
  [341] = {.lex_state = 3},
  [342] = {.lex_state = 3},
  [343] = {.lex_state = 3},
  [344] = {.lex_state = 3},
  [345] = {.lex_state = 3},
  [346] = {.lex_state = 4},
  [347] = {.lex_state = 60},
  [348] = {.lex_state = 4},
  [349] = {.lex_state = 60},
  [350] = {.lex_state = 60},
  [351] = {.lex_state = 60},
  [352] = {.lex_state = 4},
  [353] = {.lex_state = 4},
  [354] = {.lex_state = 0},
  [355] = {.lex_state = 0},
  [356] = {.lex_state = 0},
  [357] = {.lex_state = 0},
  [358] = {.lex_state = 0},
  [359] = {.lex_state = 0},
  [360] = {.lex_state = 0},
  [361] = {.lex_state = 0},
  [362] = {.lex_state = 5},
  [363] = {.lex_state = 5},
  [364] = {.lex_state = 5},
  [365] = {.lex_state = 5},
  [366] = {.lex_state = 0},
  [367] = {.lex_state = 0},
  [368] = {.lex_state = 0},
  [369] = {.lex_state = 5},
  [370] = {.lex_state = 5},
  [371] = {.lex_state = 5},
  [372] = {.lex_state = 5},
  [373] = {.lex_state = 5},
  [374] = {.lex_state = 5},
  [375] = {.lex_state = 5},
  [376] = {.lex_state = 5},
  [377] = {.lex_state = 5},
  [378] = {.lex_state = 5},
  [379] = {.lex_state = 5},
  [380] = {.lex_state = 5},
  [381] = {.lex_state = 5},
  [382] = {.lex_state = 6},
  [383] = {.lex_state = 5},
  [384] = {.lex_state = 5},
  [385] = {.lex_state = 5},
  [386] = {.lex_state = 6},
  [387] = {.lex_state = 3},
  [388] = {.lex_state = 3},
  [389] = {.lex_state = 6},
  [390] = {.lex_state = 6},
  [391] = {.lex_state = 6},
  [392] = {.lex_state = 6},
  [393] = {.lex_state = 5},
  [394] = {.lex_state = 4},
  [395] = {.lex_state = 14},
  [396] = {.lex_state = 14},
  [397] = {.lex_state = 6},
  [398] = {.lex_state = 4},
  [399] = {.lex_state = 3},
  [400] = {.lex_state = 6},
  [401] = {.lex_state = 3},
  [402] = {.lex_state = 6},
  [403] = {.lex_state = 6},
  [404] = {.lex_state = 4},
  [405] = {.lex_state = 4},
  [406] = {.lex_state = 6},
  [407] = {.lex_state = 6},
  [408] = {.lex_state = 6},
  [409] = {.lex_state = 6},
  [410] = {.lex_state = 14},
  [411] = {.lex_state = 6},
  [412] = {.lex_state = 6},
  [413] = {.lex_state = 6},
  [414] = {.lex_state = 6},
  [415] = {.lex_state = 6},
  [416] = {.lex_state = 6},
  [417] = {.lex_state = 6},
  [418] = {.lex_state = 14},
  [419] = {.lex_state = 3},
  [420] = {.lex_state = 3},
  [421] = {.lex_state = 3},
  [422] = {.lex_state = 3},
  [423] = {.lex_state = 0},
  [424] = {.lex_state = 6},
  [425] = {.lex_state = 6},
  [426] = {.lex_state = 6},
  [427] = {.lex_state = 0},
  [428] = {.lex_state = 6},
  [429] = {.lex_state = 0},
  [430] = {.lex_state = 6},
  [431] = {.lex_state = 0},
  [432] = {.lex_state = 0},
  [433] = {.lex_state = 3},
  [434] = {.lex_state = 0},
  [435] = {.lex_state = 0},
  [436] = {.lex_state = 0},
  [437] = {.lex_state = 6},
  [438] = {.lex_state = 0},
  [439] = {.lex_state = 6},
  [440] = {.lex_state = 3},
  [441] = {.lex_state = 0},
  [442] = {.lex_state = 0},
  [443] = {.lex_state = 0},
  [444] = {.lex_state = 0},
  [445] = {.lex_state = 0},
  [446] = {.lex_state = 6},
  [447] = {.lex_state = 0},
  [448] = {.lex_state = 0},
  [449] = {.lex_state = 3},
  [450] = {.lex_state = 0},
  [451] = {.lex_state = 0},
  [452] = {.lex_state = 0},
  [453] = {.lex_state = 0},
  [454] = {.lex_state = 0},
  [455] = {.lex_state = 6},
  [456] = {.lex_state = 0},
  [457] = {.lex_state = 0},
  [458] = {.lex_state = 6},
  [459] = {.lex_state = 6},
  [460] = {.lex_state = 6},
  [461] = {.lex_state = 6},
  [462] = {.lex_state = 6},
  [463] = {.lex_state = 6},
  [464] = {.lex_state = 6},
  [465] = {.lex_state = 6},
  [466] = {.lex_state = 6},
  [467] = {.lex_state = 0},
  [468] = {.lex_state = 0},
  [469] = {.lex_state = 6},
  [470] = {.lex_state = 6},
  [471] = {.lex_state = 6},
  [472] = {.lex_state = 6},
  [473] = {.lex_state = 6},
  [474] = {.lex_state = 6},
  [475] = {.lex_state = 6},
  [476] = {.lex_state = 0},
  [477] = {.lex_state = 6},
  [478] = {.lex_state = 6},
  [479] = {.lex_state = 6},
  [480] = {.lex_state = 6},
  [481] = {.lex_state = 6},
  [482] = {.lex_state = 6},
  [483] = {.lex_state = 6},
  [484] = {.lex_state = 6},
  [485] = {.lex_state = 6},
  [486] = {.lex_state = 6},
  [487] = {.lex_state = 6},
  [488] = {.lex_state = 6},
  [489] = {.lex_state = 6},
  [490] = {.lex_state = 6},
  [491] = {.lex_state = 0},
  [492] = {.lex_state = 6},
  [493] = {.lex_state = 6},
  [494] = {.lex_state = 6},
  [495] = {.lex_state = 6},
  [496] = {.lex_state = 0},
  [497] = {.lex_state = 12},
  [498] = {.lex_state = 12},
  [499] = {.lex_state = 12},
  [500] = {.lex_state = 0},
  [501] = {.lex_state = 3},
  [502] = {.lex_state = 3},
  [503] = {.lex_state = 3},
  [504] = {.lex_state = 3},
  [505] = {.lex_state = 3},
  [506] = {.lex_state = 3},
  [507] = {.lex_state = 3},
  [508] = {.lex_state = 3},
  [509] = {.lex_state = 0},
  [510] = {.lex_state = 3},
  [511] = {.lex_state = 0},
  [512] = {.lex_state = 0},
  [513] = {.lex_state = 0},
  [514] = {.lex_state = 0},
  [515] = {.lex_state = 3},
  [516] = {.lex_state = 3},
  [517] = {.lex_state = 0},
  [518] = {.lex_state = 0},
  [519] = {.lex_state = 3},
  [520] = {.lex_state = 3},
  [521] = {.lex_state = 3},
  [522] = {.lex_state = 15},
  [523] = {.lex_state = 3},
  [524] = {.lex_state = 3},
  [525] = {.lex_state = 3},
  [526] = {.lex_state = 6},
  [527] = {.lex_state = 3},
  [528] = {.lex_state = 4},
  [529] = {.lex_state = 3},
  [530] = {.lex_state = 3},
  [531] = {.lex_state = 3},
  [532] = {.lex_state = 3},
  [533] = {.lex_state = 3},
  [534] = {.lex_state = 3},
  [535] = {.lex_state = 3},
  [536] = {.lex_state = 3},
  [537] = {.lex_state = 3},
  [538] = {.lex_state = 4},
  [539] = {.lex_state = 15},
  [540] = {.lex_state = 12},
  [541] = {.lex_state = 12},
  [542] = {.lex_state = 15},
  [543] = {.lex_state = 15},
  [544] = {.lex_state = 3},
  [545] = {.lex_state = 3},
  [546] = {.lex_state = 6},
  [547] = {.lex_state = 3},
  [548] = {.lex_state = 3},
  [549] = {.lex_state = 4},
  [550] = {.lex_state = 3},
  [551] = {.lex_state = 3},
  [552] = {.lex_state = 3},
  [553] = {.lex_state = 3},
  [554] = {.lex_state = 3},
  [555] = {.lex_state = 3},
  [556] = {.lex_state = 3},
  [557] = {.lex_state = 12},
  [558] = {.lex_state = 4},
  [559] = {.lex_state = 3},
  [560] = {.lex_state = 4},
  [561] = {.lex_state = 3},
  [562] = {.lex_state = 3},
  [563] = {.lex_state = 3},
  [564] = {.lex_state = 3},
  [565] = {.lex_state = 3},
  [566] = {.lex_state = 3},
  [567] = {.lex_state = 3},
  [568] = {.lex_state = 3},
  [569] = {.lex_state = 3},
  [570] = {.lex_state = 3},
  [571] = {.lex_state = 3},
  [572] = {.lex_state = 3},
  [573] = {.lex_state = 3},
  [574] = {.lex_state = 3},
  [575] = {.lex_state = 3},
  [576] = {.lex_state = 3},
  [577] = {.lex_state = 4},
  [578] = {.lex_state = 3},
  [579] = {.lex_state = 4},
  [580] = {.lex_state = 4},
  [581] = {.lex_state = 3},
  [582] = {.lex_state = 3},
  [583] = {.lex_state = 3},
  [584] = {.lex_state = 3},
  [585] = {.lex_state = 3},
  [586] = {.lex_state = 4},
  [587] = {.lex_state = 3},
  [588] = {.lex_state = 4},
  [589] = {.lex_state = 3},
  [590] = {.lex_state = 3},
  [591] = {.lex_state = 4},
  [592] = {.lex_state = 4},
  [593] = {.lex_state = 3},
  [594] = {.lex_state = 3},
  [595] = {.lex_state = 12},
  [596] = {.lex_state = 3},
  [597] = {.lex_state = 3},
  [598] = {.lex_state = 4},
  [599] = {.lex_state = 4},
  [600] = {.lex_state = 3},
  [601] = {.lex_state = 3},
  [602] = {.lex_state = 3},
  [603] = {.lex_state = 3},
  [604] = {.lex_state = 22},
  [605] = {.lex_state = 3},
  [606] = {.lex_state = 4},
  [607] = {.lex_state = 3},
  [608] = {.lex_state = 3},
  [609] = {.lex_state = 3},
  [610] = {.lex_state = 3},
  [611] = {.lex_state = 3},
  [612] = {.lex_state = 3},
  [613] = {.lex_state = 3},
  [614] = {.lex_state = 3},
  [615] = {.lex_state = 3},
  [616] = {.lex_state = 3},
  [617] = {.lex_state = 3},
  [618] = {.lex_state = 3},
  [619] = {.lex_state = 3},
  [620] = {.lex_state = 3},
  [621] = {.lex_state = 3},
  [622] = {.lex_state = 3},
  [623] = {.lex_state = 3},
  [624] = {.lex_state = 3},
  [625] = {.lex_state = 3},
  [626] = {.lex_state = 22},
  [627] = {.lex_state = 3},
  [628] = {.lex_state = 3},
  [629] = {.lex_state = 3},
  [630] = {.lex_state = 3},
  [631] = {.lex_state = 3},
  [632] = {.lex_state = 3},
  [633] = {.lex_state = 3},
  [634] = {.lex_state = 3},
  [635] = {.lex_state = 3},
  [636] = {.lex_state = 3},
  [637] = {.lex_state = 3},
  [638] = {.lex_state = 3},
  [639] = {.lex_state = 3},
  [640] = {.lex_state = 3},
  [641] = {.lex_state = 12},
  [642] = {.lex_state = 3},
  [643] = {.lex_state = 3},
  [644] = {.lex_state = 3},
  [645] = {.lex_state = 3},
  [646] = {.lex_state = 12},
  [647] = {.lex_state = 3},
  [648] = {.lex_state = 3},
  [649] = {.lex_state = 4},
  [650] = {.lex_state = 3},
  [651] = {.lex_state = 5},
  [652] = {.lex_state = 5},
  [653] = {.lex_state = 3},
  [654] = {.lex_state = 12},
  [655] = {.lex_state = 22},
  [656] = {.lex_state = 12},
  [657] = {.lex_state = 12},
  [658] = {.lex_state = 12},
  [659] = {.lex_state = 3},
  [660] = {.lex_state = 12},
  [661] = {.lex_state = 3},
  [662] = {.lex_state = 3},
  [663] = {.lex_state = 3},
  [664] = {.lex_state = 3},
  [665] = {.lex_state = 3},
  [666] = {.lex_state = 12},
  [667] = {.lex_state = 3},
  [668] = {.lex_state = 5},
  [669] = {.lex_state = 5},
  [670] = {.lex_state = 3},
  [671] = {.lex_state = 12},
  [672] = {.lex_state = 12},
  [673] = {.lex_state = 22},
  [674] = {.lex_state = 12},
  [675] = {.lex_state = 12},
  [676] = {.lex_state = 3},
  [677] = {.lex_state = 12},
  [678] = {.lex_state = 3},
  [679] = {.lex_state = 3},
  [680] = {.lex_state = 3},
  [681] = {.lex_state = 3},
  [682] = {.lex_state = 3},
  [683] = {.lex_state = 5},
  [684] = {.lex_state = 12},
  [685] = {.lex_state = 12},
  [686] = {.lex_state = 3},
  [687] = {.lex_state = 3},
  [688] = {.lex_state = 5},
  [689] = {.lex_state = 3},
  [690] = {.lex_state = 5},
  [691] = {.lex_state = 12},
  [692] = {.lex_state = 5},
  [693] = {.lex_state = 12},
  [694] = {.lex_state = 3},
  [695] = {.lex_state = 3},
  [696] = {.lex_state = 3},
  [697] = {.lex_state = 3},
  [698] = {.lex_state = 3},
  [699] = {.lex_state = 3},
  [700] = {.lex_state = 3},
  [701] = {.lex_state = 3},
  [702] = {.lex_state = 3},
  [703] = {.lex_state = 3},
  [704] = {.lex_state = 3},
  [705] = {.lex_state = 3},
  [706] = {.lex_state = 5},
  [707] = {.lex_state = 5},
  [708] = {.lex_state = 5},
  [709] = {.lex_state = 3},
  [710] = {.lex_state = 3},
  [711] = {.lex_state = 3},
  [712] = {.lex_state = 3},
  [713] = {.lex_state = 3},
  [714] = {.lex_state = 5},
  [715] = {.lex_state = 3},
  [716] = {.lex_state = 5},
  [717] = {.lex_state = 3},
  [718] = {.lex_state = 5},
  [719] = {.lex_state = 3},
  [720] = {.lex_state = 3},
  [721] = {.lex_state = 3},
  [722] = {.lex_state = 5},
  [723] = {.lex_state = 3},
  [724] = {.lex_state = 5},
  [725] = {.lex_state = 4},
  [726] = {.lex_state = 5},
  [727] = {.lex_state = 3},
  [728] = {.lex_state = 5},
  [729] = {.lex_state = 3},
  [730] = {.lex_state = 4},
  [731] = {.lex_state = 3},
  [732] = {.lex_state = 5},
  [733] = {.lex_state = 3},
  [734] = {.lex_state = 5},
  [735] = {.lex_state = 5},
  [736] = {.lex_state = 3},
  [737] = {.lex_state = 5},
  [738] = {.lex_state = 3},
  [739] = {.lex_state = 4},
  [740] = {.lex_state = 4},
  [741] = {.lex_state = 3},
  [742] = {.lex_state = 5},
  [743] = {.lex_state = 3},
  [744] = {.lex_state = 5},
  [745] = {.lex_state = 5},
  [746] = {.lex_state = 4},
  [747] = {.lex_state = 5},
  [748] = {.lex_state = 4},
  [749] = {.lex_state = 5},
  [750] = {.lex_state = 4},
  [751] = {.lex_state = 5},
  [752] = {.lex_state = 4},
  [753] = {.lex_state = 5},
  [754] = {.lex_state = 3},
  [755] = {.lex_state = 5},
  [756] = {.lex_state = 5},
  [757] = {.lex_state = 3},
  [758] = {.lex_state = 3},
  [759] = {.lex_state = 3},
  [760] = {.lex_state = 5},
  [761] = {.lex_state = 5},
  [762] = {.lex_state = 4},
  [763] = {.lex_state = 3},
  [764] = {.lex_state = 3},
  [765] = {.lex_state = 4},
  [766] = {.lex_state = 3},
  [767] = {.lex_state = 3},
  [768] = {.lex_state = 3},
  [769] = {.lex_state = 3},
  [770] = {.lex_state = 12},
  [771] = {.lex_state = 3},
  [772] = {.lex_state = 3},
  [773] = {.lex_state = 3},
  [774] = {.lex_state = 3},
  [775] = {.lex_state = 3},
  [776] = {.lex_state = 3},
  [777] = {.lex_state = 3},
  [778] = {.lex_state = 3},
  [779] = {.lex_state = 3},
  [780] = {.lex_state = 3},
  [781] = {.lex_state = 3},
  [782] = {.lex_state = 0},
  [783] = {.lex_state = 3},
  [784] = {.lex_state = 0},
  [785] = {.lex_state = 3},
  [786] = {.lex_state = 3},
  [787] = {.lex_state = 3},
  [788] = {.lex_state = 3},
  [789] = {.lex_state = 3},
  [790] = {.lex_state = 4},
  [791] = {.lex_state = 4},
  [792] = {.lex_state = 3},
  [793] = {.lex_state = 3},
  [794] = {.lex_state = 3},
  [795] = {.lex_state = 4},
  [796] = {.lex_state = 3},
  [797] = {.lex_state = 3},
  [798] = {.lex_state = 3},
  [799] = {.lex_state = 3},
  [800] = {.lex_state = 3},
  [801] = {.lex_state = 3},
  [802] = {.lex_state = 3},
  [803] = {.lex_state = 3},
  [804] = {.lex_state = 3},
  [805] = {.lex_state = 3},
  [806] = {.lex_state = 3},
  [807] = {.lex_state = 3},
  [808] = {.lex_state = 3},
  [809] = {.lex_state = 3},
  [810] = {.lex_state = 3},
  [811] = {.lex_state = 3},
  [812] = {.lex_state = 3},
  [813] = {.lex_state = 3},
  [814] = {.lex_state = 3},
  [815] = {.lex_state = 3},
  [816] = {.lex_state = 3},
  [817] = {.lex_state = 3},
  [818] = {.lex_state = 4},
  [819] = {.lex_state = 3},
  [820] = {.lex_state = 3},
  [821] = {.lex_state = 3},
  [822] = {.lex_state = 3},
  [823] = {.lex_state = 3},
  [824] = {.lex_state = 4},
  [825] = {.lex_state = 3},
  [826] = {.lex_state = 3},
  [827] = {.lex_state = 3},
  [828] = {.lex_state = 3},
  [829] = {.lex_state = 3},
  [830] = {.lex_state = 3},
  [831] = {.lex_state = 3},
  [832] = {.lex_state = 3},
  [833] = {.lex_state = 3},
  [834] = {.lex_state = 3},
  [835] = {.lex_state = 3},
  [836] = {.lex_state = 3},
  [837] = {.lex_state = 3},
  [838] = {.lex_state = 3},
  [839] = {.lex_state = 3},
  [840] = {.lex_state = 3},
  [841] = {.lex_state = 3},
  [842] = {.lex_state = 3},
  [843] = {.lex_state = 3},
  [844] = {.lex_state = 3},
  [845] = {.lex_state = 3},
  [846] = {.lex_state = 3},
  [847] = {.lex_state = 3},
  [848] = {.lex_state = 3},
  [849] = {.lex_state = 3},
  [850] = {.lex_state = 4},
  [851] = {.lex_state = 3},
  [852] = {.lex_state = 3},
  [853] = {.lex_state = 3},
  [854] = {.lex_state = 3},
  [855] = {.lex_state = 3},
  [856] = {.lex_state = 3},
  [857] = {.lex_state = 3},
  [858] = {.lex_state = 3},
  [859] = {.lex_state = 3},
  [860] = {.lex_state = 12},
  [861] = {.lex_state = 3},
  [862] = {.lex_state = 3},
  [863] = {.lex_state = 3},
  [864] = {.lex_state = 3},
  [865] = {.lex_state = 5},
  [866] = {.lex_state = 3},
  [867] = {.lex_state = 3},
  [868] = {.lex_state = 5},
  [869] = {.lex_state = 3},
  [870] = {.lex_state = 3},
  [871] = {.lex_state = 5},
  [872] = {.lex_state = 5},
  [873] = {.lex_state = 3},
  [874] = {.lex_state = 3},
  [875] = {.lex_state = 5},
  [876] = {.lex_state = 3},
  [877] = {.lex_state = 0},
  [878] = {.lex_state = 12},
  [879] = {.lex_state = 3},
  [880] = {.lex_state = 3},
  [881] = {.lex_state = 0},
  [882] = {.lex_state = 3},
  [883] = {.lex_state = 0},
  [884] = {.lex_state = 3},
  [885] = {.lex_state = 0},
  [886] = {.lex_state = 0},
  [887] = {.lex_state = 3},
  [888] = {.lex_state = 3},
  [889] = {.lex_state = 3},
  [890] = {.lex_state = 3},
  [891] = {.lex_state = 5},
  [892] = {.lex_state = 3},
  [893] = {.lex_state = 3},
  [894] = {.lex_state = 3},
  [895] = {.lex_state = 3},
  [896] = {.lex_state = 3},
  [897] = {.lex_state = 0},
  [898] = {.lex_state = 5},
  [899] = {.lex_state = 0},
  [900] = {.lex_state = 4},
  [901] = {.lex_state = 5},
  [902] = {.lex_state = 0},
  [903] = {.lex_state = 0},
  [904] = {.lex_state = 0},
  [905] = {.lex_state = 0},
  [906] = {.lex_state = 3},
  [907] = {.lex_state = 3},
  [908] = {.lex_state = 0},
  [909] = {.lex_state = 0},
  [910] = {.lex_state = 3},
  [911] = {.lex_state = 3},
  [912] = {.lex_state = 0},
  [913] = {.lex_state = 12},
  [914] = {.lex_state = 3},
  [915] = {.lex_state = 5},
  [916] = {.lex_state = 5},
  [917] = {.lex_state = 5},
  [918] = {.lex_state = 5},
  [919] = {.lex_state = 5},
  [920] = {.lex_state = 5},
  [921] = {.lex_state = 5},
  [922] = {.lex_state = 5},
  [923] = {.lex_state = 5},
  [924] = {.lex_state = 5},
  [925] = {.lex_state = 5},
  [926] = {.lex_state = 12},
  [927] = {.lex_state = 3},
  [928] = {.lex_state = 0},
  [929] = {.lex_state = 3},
  [930] = {.lex_state = 3},
  [931] = {.lex_state = 0},
  [932] = {.lex_state = 3},
  [933] = {.lex_state = 0},
  [934] = {.lex_state = 3},
  [935] = {.lex_state = 3},
  [936] = {.lex_state = 3},
  [937] = {.lex_state = 3},
  [938] = {.lex_state = 3},
  [939] = {.lex_state = 3},
  [940] = {.lex_state = 0},
  [941] = {.lex_state = 3},
  [942] = {.lex_state = 3},
  [943] = {.lex_state = 4},
  [944] = {.lex_state = 3},
  [945] = {.lex_state = 4},
  [946] = {.lex_state = 3},
  [947] = {.lex_state = 0},
  [948] = {.lex_state = 0},
  [949] = {.lex_state = 3},
  [950] = {.lex_state = 3},
  [951] = {.lex_state = 3},
  [952] = {.lex_state = 0},
  [953] = {.lex_state = 0},
  [954] = {.lex_state = 3},
  [955] = {.lex_state = 3},
  [956] = {.lex_state = 3},
  [957] = {.lex_state = 3},
  [958] = {.lex_state = 3},
  [959] = {.lex_state = 0},
  [960] = {.lex_state = 0},
  [961] = {.lex_state = 0},
  [962] = {.lex_state = 0},
  [963] = {.lex_state = 3},
  [964] = {.lex_state = 3},
  [965] = {.lex_state = 3},
  [966] = {.lex_state = 0},
  [967] = {.lex_state = 0},
  [968] = {.lex_state = 5},
  [969] = {.lex_state = 4},
  [970] = {.lex_state = 3},
  [971] = {.lex_state = 4},
  [972] = {.lex_state = 0},
  [973] = {.lex_state = 0},
  [974] = {.lex_state = 0},
  [975] = {.lex_state = 0},
  [976] = {.lex_state = 3},
  [977] = {.lex_state = 0},
  [978] = {.lex_state = 0},
  [979] = {.lex_state = 0},
  [980] = {.lex_state = 0},
  [981] = {.lex_state = 0},
  [982] = {.lex_state = 0},
  [983] = {.lex_state = 0},
  [984] = {.lex_state = 0},
  [985] = {.lex_state = 0},
  [986] = {.lex_state = 0},
  [987] = {.lex_state = 0},
  [988] = {.lex_state = 0},
  [989] = {.lex_state = 0},
  [990] = {.lex_state = 0},
  [991] = {.lex_state = 0},
  [992] = {.lex_state = 5},
  [993] = {.lex_state = 0},
  [994] = {.lex_state = 0},
  [995] = {.lex_state = 0},
  [996] = {.lex_state = 0},
  [997] = {.lex_state = 0},
  [998] = {.lex_state = 0},
  [999] = {.lex_state = 5},
  [1000] = {.lex_state = 0},
  [1001] = {.lex_state = 3},
  [1002] = {.lex_state = 3},
  [1003] = {.lex_state = 0},
  [1004] = {.lex_state = 0},
  [1005] = {.lex_state = 5},
  [1006] = {.lex_state = 0},
  [1007] = {.lex_state = 0},
  [1008] = {.lex_state = 0},
  [1009] = {.lex_state = 0},
  [1010] = {.lex_state = 0},
  [1011] = {.lex_state = 0},
  [1012] = {.lex_state = 0},
  [1013] = {.lex_state = 5},
  [1014] = {.lex_state = 0},
  [1015] = {.lex_state = 0},
  [1016] = {.lex_state = 0},
  [1017] = {.lex_state = 5},
  [1018] = {.lex_state = 4},
  [1019] = {.lex_state = 5},
  [1020] = {.lex_state = 5},
  [1021] = {.lex_state = 0},
  [1022] = {.lex_state = 0},
  [1023] = {.lex_state = 3},
  [1024] = {.lex_state = 5},
  [1025] = {.lex_state = 5},
  [1026] = {.lex_state = 5},
  [1027] = {.lex_state = 5},
  [1028] = {.lex_state = 0},
  [1029] = {.lex_state = 3},
  [1030] = {.lex_state = 5},
  [1031] = {.lex_state = 5},
  [1032] = {.lex_state = 0},
  [1033] = {.lex_state = 0},
  [1034] = {.lex_state = 4},
  [1035] = {.lex_state = 4},
  [1036] = {.lex_state = 0},
  [1037] = {.lex_state = 0},
  [1038] = {.lex_state = 3},
  [1039] = {.lex_state = 0},
  [1040] = {.lex_state = 0},
  [1041] = {.lex_state = 5},
  [1042] = {.lex_state = 0},
  [1043] = {.lex_state = 0},
  [1044] = {.lex_state = 4},
  [1045] = {.lex_state = 0},
  [1046] = {.lex_state = 0},
  [1047] = {.lex_state = 0},
  [1048] = {.lex_state = 0},
  [1049] = {.lex_state = 0},
  [1050] = {.lex_state = 0},
  [1051] = {.lex_state = 0},
  [1052] = {.lex_state = 0},
  [1053] = {.lex_state = 0},
  [1054] = {.lex_state = 0},
  [1055] = {.lex_state = 3},
  [1056] = {.lex_state = 3},
  [1057] = {.lex_state = 3},
  [1058] = {.lex_state = 0},
  [1059] = {.lex_state = 0},
  [1060] = {.lex_state = 0},
  [1061] = {.lex_state = 0},
  [1062] = {.lex_state = 4},
  [1063] = {.lex_state = 0},
  [1064] = {.lex_state = 0},
  [1065] = {.lex_state = 0},
  [1066] = {.lex_state = 0},
  [1067] = {.lex_state = 0},
  [1068] = {.lex_state = 0},
  [1069] = {.lex_state = 0},
  [1070] = {.lex_state = 0},
  [1071] = {.lex_state = 5},
  [1072] = {.lex_state = 5},
  [1073] = {.lex_state = 4},
  [1074] = {.lex_state = 0},
  [1075] = {.lex_state = 5},
  [1076] = {.lex_state = 4},
  [1077] = {.lex_state = 0},
  [1078] = {.lex_state = 0},
  [1079] = {.lex_state = 5},
  [1080] = {.lex_state = 4},
  [1081] = {.lex_state = 3},
  [1082] = {.lex_state = 4},
  [1083] = {.lex_state = 0},
  [1084] = {.lex_state = 0},
  [1085] = {.lex_state = 0},
  [1086] = {.lex_state = 0},
  [1087] = {.lex_state = 0},
  [1088] = {.lex_state = 4},
  [1089] = {.lex_state = 0},
  [1090] = {.lex_state = 0},
  [1091] = {.lex_state = 3},
  [1092] = {.lex_state = 0},
  [1093] = {.lex_state = 3},
  [1094] = {.lex_state = 0},
  [1095] = {.lex_state = 3},
  [1096] = {.lex_state = 0},
  [1097] = {.lex_state = 0},
  [1098] = {.lex_state = 3},
  [1099] = {.lex_state = 0},
  [1100] = {.lex_state = 3},
  [1101] = {.lex_state = 0},
  [1102] = {.lex_state = 0},
  [1103] = {.lex_state = 0},
  [1104] = {.lex_state = 0},
  [1105] = {.lex_state = 0},
  [1106] = {.lex_state = 0},
  [1107] = {.lex_state = 0},
  [1108] = {.lex_state = 0},
  [1109] = {.lex_state = 0},
  [1110] = {.lex_state = 0},
  [1111] = {.lex_state = 3},
  [1112] = {.lex_state = 0},
  [1113] = {.lex_state = 0},
  [1114] = {.lex_state = 0},
  [1115] = {.lex_state = 0},
  [1116] = {.lex_state = 0},
  [1117] = {.lex_state = 4},
  [1118] = {.lex_state = 4},
  [1119] = {.lex_state = 5},
  [1120] = {.lex_state = 0},
  [1121] = {.lex_state = 0},
  [1122] = {.lex_state = 0},
  [1123] = {.lex_state = 0},
  [1124] = {.lex_state = 0},
  [1125] = {.lex_state = 5},
  [1126] = {.lex_state = 5},
  [1127] = {.lex_state = 5},
  [1128] = {.lex_state = 0},
  [1129] = {.lex_state = 0},
  [1130] = {.lex_state = 0},
  [1131] = {.lex_state = 0},
  [1132] = {.lex_state = 0},
  [1133] = {.lex_state = 0},
  [1134] = {.lex_state = 0},
  [1135] = {.lex_state = 0},
  [1136] = {.lex_state = 0},
  [1137] = {.lex_state = 0},
  [1138] = {.lex_state = 0},
  [1139] = {.lex_state = 0},
  [1140] = {.lex_state = 0},
  [1141] = {.lex_state = 0},
  [1142] = {.lex_state = 0},
  [1143] = {.lex_state = 0},
  [1144] = {.lex_state = 0},
  [1145] = {.lex_state = 0},
  [1146] = {.lex_state = 5},
  [1147] = {.lex_state = 0},
  [1148] = {.lex_state = 5},
  [1149] = {.lex_state = 0},
  [1150] = {.lex_state = 0},
  [1151] = {.lex_state = 0},
  [1152] = {.lex_state = 3},
  [1153] = {.lex_state = 0},
  [1154] = {.lex_state = 0},
  [1155] = {.lex_state = 4},
  [1156] = {.lex_state = 0},
  [1157] = {.lex_state = 0},
  [1158] = {.lex_state = 0},
  [1159] = {.lex_state = 5},
  [1160] = {.lex_state = 5},
  [1161] = {.lex_state = 5},
  [1162] = {.lex_state = 0},
  [1163] = {.lex_state = 5},
  [1164] = {.lex_state = 5},
  [1165] = {.lex_state = 0},
  [1166] = {.lex_state = 4},
  [1167] = {.lex_state = 5},
  [1168] = {.lex_state = 0},
  [1169] = {.lex_state = 0},
  [1170] = {.lex_state = 0},
  [1171] = {.lex_state = 0},
  [1172] = {.lex_state = 0},
  [1173] = {.lex_state = 5},
  [1174] = {.lex_state = 5},
  [1175] = {.lex_state = 5},
  [1176] = {.lex_state = 0},
  [1177] = {.lex_state = 0},
  [1178] = {.lex_state = 0},
  [1179] = {.lex_state = 0},
  [1180] = {.lex_state = 5},
  [1181] = {.lex_state = 3},
  [1182] = {.lex_state = 5},
  [1183] = {.lex_state = 5},
  [1184] = {.lex_state = 0},
  [1185] = {.lex_state = 3},
  [1186] = {.lex_state = 5},
  [1187] = {.lex_state = 0},
  [1188] = {.lex_state = 0},
  [1189] = {.lex_state = 0},
  [1190] = {.lex_state = 0},
  [1191] = {.lex_state = 0},
  [1192] = {.lex_state = 0},
  [1193] = {.lex_state = 0},
  [1194] = {.lex_state = 0},
  [1195] = {.lex_state = 0},
  [1196] = {.lex_state = 0},
  [1197] = {.lex_state = 0},
  [1198] = {.lex_state = 0},
  [1199] = {.lex_state = 3},
  [1200] = {.lex_state = 0},
  [1201] = {.lex_state = 0},
  [1202] = {.lex_state = 0},
  [1203] = {.lex_state = 0},
  [1204] = {.lex_state = 0},
  [1205] = {.lex_state = 0},
  [1206] = {.lex_state = 0},
  [1207] = {.lex_state = 0},
  [1208] = {.lex_state = 0},
  [1209] = {.lex_state = 0},
  [1210] = {.lex_state = 0},
  [1211] = {.lex_state = 0},
  [1212] = {.lex_state = 0},
  [1213] = {.lex_state = 0},
  [1214] = {.lex_state = 3},
  [1215] = {.lex_state = 3},
  [1216] = {.lex_state = 0},
  [1217] = {.lex_state = 0},
  [1218] = {.lex_state = 0},
  [1219] = {.lex_state = 3},
  [1220] = {.lex_state = 3},
  [1221] = {.lex_state = 0},
  [1222] = {.lex_state = 0},
  [1223] = {.lex_state = 5},
  [1224] = {.lex_state = 3},
  [1225] = {.lex_state = 0},
  [1226] = {.lex_state = 0},
  [1227] = {.lex_state = 3},
  [1228] = {.lex_state = 0},
  [1229] = {.lex_state = 0},
  [1230] = {.lex_state = 0},
  [1231] = {.lex_state = 0},
  [1232] = {.lex_state = 0},
  [1233] = {.lex_state = 5},
  [1234] = {.lex_state = 0},
  [1235] = {.lex_state = 3},
  [1236] = {.lex_state = 3},
  [1237] = {.lex_state = 0},
  [1238] = {.lex_state = 0},
  [1239] = {.lex_state = 0},
  [1240] = {.lex_state = 0},
  [1241] = {.lex_state = 0},
  [1242] = {.lex_state = 0},
  [1243] = {.lex_state = 3},
  [1244] = {.lex_state = 0},
  [1245] = {.lex_state = 0},
  [1246] = {.lex_state = 0},
  [1247] = {.lex_state = 0},
  [1248] = {.lex_state = 0},
  [1249] = {.lex_state = 0},
  [1250] = {.lex_state = 3},
  [1251] = {.lex_state = 3},
  [1252] = {.lex_state = 3},
  [1253] = {.lex_state = 3},
  [1254] = {.lex_state = 0},
  [1255] = {.lex_state = 0},
  [1256] = {.lex_state = 3},
  [1257] = {.lex_state = 0},
  [1258] = {.lex_state = 3},
  [1259] = {.lex_state = 0},
  [1260] = {.lex_state = 0},
  [1261] = {.lex_state = 3},
  [1262] = {.lex_state = 0},
  [1263] = {.lex_state = 3},
  [1264] = {.lex_state = 0},
  [1265] = {.lex_state = 0},
  [1266] = {.lex_state = 0},
  [1267] = {.lex_state = 0},
  [1268] = {.lex_state = 3},
  [1269] = {.lex_state = 0},
  [1270] = {.lex_state = 0},
  [1271] = {.lex_state = 3},
  [1272] = {.lex_state = 3},
  [1273] = {.lex_state = 0},
  [1274] = {.lex_state = 0},
  [1275] = {.lex_state = 3},
  [1276] = {.lex_state = 0},
  [1277] = {.lex_state = 0},
  [1278] = {.lex_state = 0},
  [1279] = {.lex_state = 0},
  [1280] = {.lex_state = 0},
  [1281] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_decimal_integer_literal] = ACTIONS(1),
    [sym_hex_integer_literal] = ACTIONS(1),
    [sym_octal_integer_literal] = ACTIONS(1),
    [sym_binary_integer_literal] = ACTIONS(1),
    [sym_decimal_floating_point_literal] = ACTIONS(1),
    [sym_hex_floating_point_literal] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_character_literal] = ACTIONS(1),
    [sym_string_literal] = ACTIONS(1),
    [sym_text_block] = ACTIONS(1),
    [sym_null_literal] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_final] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_synchronized] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_open] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_requires] = ACTIONS(1),
    [anon_sym_transitive] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_exports] = ACTIONS(1),
    [anon_sym_to] = ACTIONS(1),
    [anon_sym_opens] = ACTIONS(1),
    [anon_sym_uses] = ACTIONS(1),
    [anon_sym_provides] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_package] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_strictfp] = ACTIONS(1),
    [anon_sym_native] = ACTIONS(1),
    [anon_sym_transient] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_sealed] = ACTIONS(1),
    [anon_sym_non_DASHsealed] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_permits] = ACTIONS(1),
    [anon_sym_record] = ACTIONS(1),
    [anon_sym_ATinterface] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_byte] = ACTIONS(1),
    [anon_sym_short] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_long] = ACTIONS(1),
    [anon_sym_char] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_double] = ACTIONS(1),
    [sym_boolean_type] = ACTIONS(1),
    [sym_void_type] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_throws] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_program] = STATE(1209),
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(11),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_switch_label] = STATE(1228),
    [sym_statement] = STATE(5),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_program_repeat1] = STATE(5),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_switch_block_statement_group_repeat1] = STATE(235),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(87),
    [anon_sym_case] = ACTIONS(89),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [3] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(546),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_type_arguments] = STATE(1098),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(6),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_explicit_constructor_invocation] = STATE(13),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(93),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [4] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(4),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [ts_builtin_sym_end] = ACTIONS(99),
    [sym_identifier] = ACTIONS(101),
    [sym_decimal_integer_literal] = ACTIONS(104),
    [sym_hex_integer_literal] = ACTIONS(104),
    [sym_octal_integer_literal] = ACTIONS(107),
    [sym_binary_integer_literal] = ACTIONS(107),
    [sym_decimal_floating_point_literal] = ACTIONS(107),
    [sym_hex_floating_point_literal] = ACTIONS(104),
    [sym_true] = ACTIONS(104),
    [sym_false] = ACTIONS(104),
    [sym_character_literal] = ACTIONS(107),
    [sym_string_literal] = ACTIONS(104),
    [sym_text_block] = ACTIONS(107),
    [sym_null_literal] = ACTIONS(104),
    [anon_sym_LPAREN] = ACTIONS(110),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_final] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(119),
    [anon_sym_PLUS_PLUS] = ACTIONS(122),
    [anon_sym_DASH_DASH] = ACTIONS(122),
    [anon_sym_new] = ACTIONS(125),
    [anon_sym_class] = ACTIONS(128),
    [anon_sym_switch] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(134),
    [anon_sym_RBRACE] = ACTIONS(99),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(139),
    [anon_sym_assert] = ACTIONS(142),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_while] = ACTIONS(148),
    [anon_sym_break] = ACTIONS(151),
    [anon_sym_continue] = ACTIONS(154),
    [anon_sym_return] = ACTIONS(157),
    [anon_sym_yield] = ACTIONS(160),
    [anon_sym_synchronized] = ACTIONS(163),
    [anon_sym_throw] = ACTIONS(166),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_if] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(175),
    [anon_sym_AT] = ACTIONS(178),
    [anon_sym_open] = ACTIONS(181),
    [anon_sym_module] = ACTIONS(184),
    [anon_sym_static] = ACTIONS(116),
    [anon_sym_package] = ACTIONS(187),
    [anon_sym_import] = ACTIONS(190),
    [anon_sym_enum] = ACTIONS(193),
    [anon_sym_public] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(116),
    [anon_sym_strictfp] = ACTIONS(116),
    [anon_sym_native] = ACTIONS(116),
    [anon_sym_transient] = ACTIONS(116),
    [anon_sym_volatile] = ACTIONS(116),
    [anon_sym_sealed] = ACTIONS(116),
    [anon_sym_non_DASHsealed] = ACTIONS(196),
    [anon_sym_record] = ACTIONS(199),
    [anon_sym_ATinterface] = ACTIONS(202),
    [anon_sym_interface] = ACTIONS(205),
    [anon_sym_byte] = ACTIONS(208),
    [anon_sym_short] = ACTIONS(208),
    [anon_sym_int] = ACTIONS(208),
    [anon_sym_long] = ACTIONS(208),
    [anon_sym_char] = ACTIONS(208),
    [anon_sym_float] = ACTIONS(211),
    [anon_sym_double] = ACTIONS(211),
    [sym_boolean_type] = ACTIONS(214),
    [sym_void_type] = ACTIONS(214),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(220),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [5] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(4),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(223),
    [anon_sym_case] = ACTIONS(225),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [6] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(4),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(227),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [7] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(4),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(229),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [8] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(9),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(231),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [9] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(4),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(233),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [10] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(7),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(235),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [11] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(4),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [ts_builtin_sym_end] = ACTIONS(237),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [12] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(4),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(239),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [13] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(12),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(227),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [14] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(199),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [15] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(216),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [16] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(182),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [17] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(1250),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [18] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(240),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [19] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(249),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [20] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(248),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [21] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(247),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [22] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(246),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [23] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(185),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [24] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(209),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [25] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(245),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [26] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(242),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [27] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(236),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [28] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(234),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [29] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(233),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [30] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(183),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [31] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(184),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [32] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(186),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [33] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(189),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [34] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(249),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [35] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(248),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [36] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(247),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [37] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(192),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [38] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(246),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [39] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(183),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [40] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(184),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [41] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(186),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [42] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(189),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [43] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(192),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [44] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(216),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [45] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(226),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [46] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(193),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [47] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(215),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [48] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(194),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [49] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(198),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [50] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(244),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [51] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(200),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [52] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(206),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [53] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(211),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [54] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(193),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [55] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(213),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [56] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(194),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [57] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(215),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [58] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(226),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [59] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(213),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [60] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(1152),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [61] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(233),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [62] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(234),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [63] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(236),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [64] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(242),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [65] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(211),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [66] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(245),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [67] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(206),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [68] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(200),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [69] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(209),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [70] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(185),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [71] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(244),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [72] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(199),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [73] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(594),
    [sym_statement] = STATE(182),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(241),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(243),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(245),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [74] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(83),
    [sym_statement] = STATE(198),
    [sym_block] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_assert_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_yield_statement] = STATE(204),
    [sym_synchronized_statement] = STATE(204),
    [sym_throw_statement] = STATE(204),
    [sym_try_statement] = STATE(204),
    [sym_try_with_resources_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_enhanced_for_statement] = STATE(204),
    [sym__annotation] = STATE(491),
    [sym_marker_annotation] = STATE(491),
    [sym_annotation] = STATE(491),
    [sym_declaration] = STATE(204),
    [sym_module_declaration] = STATE(243),
    [sym_package_declaration] = STATE(243),
    [sym_import_declaration] = STATE(243),
    [sym_enum_declaration] = STATE(243),
    [sym_class_declaration] = STATE(243),
    [sym_modifiers] = STATE(655),
    [sym_record_declaration] = STATE(243),
    [sym_annotation_type_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(688),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(204),
    [aux_sym_array_creation_expression_repeat1] = STATE(629),
    [aux_sym_modifiers_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(17),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_class] = ACTIONS(25),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_default] = ACTIONS(17),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(17),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(17),
    [anon_sym_protected] = ACTIONS(17),
    [anon_sym_private] = ACTIONS(17),
    [anon_sym_abstract] = ACTIONS(17),
    [anon_sym_strictfp] = ACTIONS(17),
    [anon_sym_native] = ACTIONS(17),
    [anon_sym_transient] = ACTIONS(17),
    [anon_sym_volatile] = ACTIONS(17),
    [anon_sym_sealed] = ACTIONS(17),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_record] = ACTIONS(71),
    [anon_sym_ATinterface] = ACTIONS(73),
    [anon_sym_interface] = ACTIONS(75),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [75] = {
    [ts_builtin_sym_end] = ACTIONS(249),
    [sym_identifier] = ACTIONS(251),
    [sym_decimal_integer_literal] = ACTIONS(251),
    [sym_hex_integer_literal] = ACTIONS(251),
    [sym_octal_integer_literal] = ACTIONS(249),
    [sym_binary_integer_literal] = ACTIONS(249),
    [sym_decimal_floating_point_literal] = ACTIONS(249),
    [sym_hex_floating_point_literal] = ACTIONS(251),
    [sym_true] = ACTIONS(251),
    [sym_false] = ACTIONS(251),
    [sym_character_literal] = ACTIONS(249),
    [sym_string_literal] = ACTIONS(251),
    [sym_text_block] = ACTIONS(249),
    [sym_null_literal] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(249),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_RPAREN] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(251),
    [anon_sym_LT] = ACTIONS(251),
    [anon_sym_GT_EQ] = ACTIONS(249),
    [anon_sym_LT_EQ] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_BANG_EQ] = ACTIONS(249),
    [anon_sym_AMP_AMP] = ACTIONS(249),
    [anon_sym_PIPE_PIPE] = ACTIONS(249),
    [anon_sym_PLUS] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_SLASH] = ACTIONS(251),
    [anon_sym_PIPE] = ACTIONS(251),
    [anon_sym_CARET] = ACTIONS(249),
    [anon_sym_PERCENT] = ACTIONS(249),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(251),
    [anon_sym_GT_GT_GT] = ACTIONS(249),
    [anon_sym_instanceof] = ACTIONS(251),
    [anon_sym_final] = ACTIONS(251),
    [anon_sym_DASH_GT] = ACTIONS(249),
    [anon_sym_COMMA] = ACTIONS(249),
    [anon_sym_QMARK] = ACTIONS(249),
    [anon_sym_COLON] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(251),
    [anon_sym_TILDE] = ACTIONS(249),
    [anon_sym_PLUS_PLUS] = ACTIONS(249),
    [anon_sym_DASH_DASH] = ACTIONS(249),
    [anon_sym_new] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_RBRACK] = ACTIONS(249),
    [anon_sym_DOT] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(249),
    [anon_sym_switch] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_RBRACE] = ACTIONS(249),
    [anon_sym_case] = ACTIONS(251),
    [anon_sym_default] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_assert] = ACTIONS(251),
    [anon_sym_do] = ACTIONS(251),
    [anon_sym_while] = ACTIONS(251),
    [anon_sym_break] = ACTIONS(251),
    [anon_sym_continue] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(251),
    [anon_sym_synchronized] = ACTIONS(251),
    [anon_sym_throw] = ACTIONS(251),
    [anon_sym_try] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(251),
    [anon_sym_else] = ACTIONS(251),
    [anon_sym_for] = ACTIONS(251),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_open] = ACTIONS(251),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_static] = ACTIONS(251),
    [anon_sym_package] = ACTIONS(251),
    [anon_sym_import] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(251),
    [anon_sym_public] = ACTIONS(251),
    [anon_sym_protected] = ACTIONS(251),
    [anon_sym_private] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(251),
    [anon_sym_strictfp] = ACTIONS(251),
    [anon_sym_native] = ACTIONS(251),
    [anon_sym_transient] = ACTIONS(251),
    [anon_sym_volatile] = ACTIONS(251),
    [anon_sym_sealed] = ACTIONS(251),
    [anon_sym_non_DASHsealed] = ACTIONS(249),
    [anon_sym_record] = ACTIONS(251),
    [anon_sym_ATinterface] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_byte] = ACTIONS(251),
    [anon_sym_short] = ACTIONS(251),
    [anon_sym_int] = ACTIONS(251),
    [anon_sym_long] = ACTIONS(251),
    [anon_sym_char] = ACTIONS(251),
    [anon_sym_float] = ACTIONS(251),
    [anon_sym_double] = ACTIONS(251),
    [sym_boolean_type] = ACTIONS(251),
    [sym_void_type] = ACTIONS(251),
    [sym_this] = ACTIONS(251),
    [sym_super] = ACTIONS(251),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [76] = {
    [ts_builtin_sym_end] = ACTIONS(253),
    [sym_identifier] = ACTIONS(255),
    [sym_decimal_integer_literal] = ACTIONS(255),
    [sym_hex_integer_literal] = ACTIONS(255),
    [sym_octal_integer_literal] = ACTIONS(253),
    [sym_binary_integer_literal] = ACTIONS(253),
    [sym_decimal_floating_point_literal] = ACTIONS(253),
    [sym_hex_floating_point_literal] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_character_literal] = ACTIONS(253),
    [sym_string_literal] = ACTIONS(255),
    [sym_text_block] = ACTIONS(253),
    [sym_null_literal] = ACTIONS(255),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_AMP] = ACTIONS(255),
    [anon_sym_RPAREN] = ACTIONS(253),
    [anon_sym_GT] = ACTIONS(255),
    [anon_sym_LT] = ACTIONS(255),
    [anon_sym_GT_EQ] = ACTIONS(253),
    [anon_sym_LT_EQ] = ACTIONS(253),
    [anon_sym_EQ_EQ] = ACTIONS(253),
    [anon_sym_BANG_EQ] = ACTIONS(253),
    [anon_sym_AMP_AMP] = ACTIONS(253),
    [anon_sym_PIPE_PIPE] = ACTIONS(253),
    [anon_sym_PLUS] = ACTIONS(255),
    [anon_sym_DASH] = ACTIONS(255),
    [anon_sym_STAR] = ACTIONS(253),
    [anon_sym_SLASH] = ACTIONS(255),
    [anon_sym_PIPE] = ACTIONS(255),
    [anon_sym_CARET] = ACTIONS(253),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_LT_LT] = ACTIONS(253),
    [anon_sym_GT_GT] = ACTIONS(255),
    [anon_sym_GT_GT_GT] = ACTIONS(253),
    [anon_sym_instanceof] = ACTIONS(255),
    [anon_sym_final] = ACTIONS(255),
    [anon_sym_DASH_GT] = ACTIONS(253),
    [anon_sym_COMMA] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(253),
    [anon_sym_COLON] = ACTIONS(255),
    [anon_sym_BANG] = ACTIONS(255),
    [anon_sym_TILDE] = ACTIONS(253),
    [anon_sym_PLUS_PLUS] = ACTIONS(253),
    [anon_sym_DASH_DASH] = ACTIONS(253),
    [anon_sym_new] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_RBRACK] = ACTIONS(253),
    [anon_sym_DOT] = ACTIONS(255),
    [anon_sym_class] = ACTIONS(255),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_RBRACE] = ACTIONS(253),
    [anon_sym_case] = ACTIONS(255),
    [anon_sym_default] = ACTIONS(255),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_assert] = ACTIONS(255),
    [anon_sym_do] = ACTIONS(255),
    [anon_sym_while] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_continue] = ACTIONS(255),
    [anon_sym_return] = ACTIONS(255),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_synchronized] = ACTIONS(255),
    [anon_sym_throw] = ACTIONS(255),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_else] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(255),
    [anon_sym_AT] = ACTIONS(255),
    [anon_sym_open] = ACTIONS(255),
    [anon_sym_module] = ACTIONS(255),
    [anon_sym_static] = ACTIONS(255),
    [anon_sym_package] = ACTIONS(255),
    [anon_sym_import] = ACTIONS(255),
    [anon_sym_enum] = ACTIONS(255),
    [anon_sym_public] = ACTIONS(255),
    [anon_sym_protected] = ACTIONS(255),
    [anon_sym_private] = ACTIONS(255),
    [anon_sym_abstract] = ACTIONS(255),
    [anon_sym_strictfp] = ACTIONS(255),
    [anon_sym_native] = ACTIONS(255),
    [anon_sym_transient] = ACTIONS(255),
    [anon_sym_volatile] = ACTIONS(255),
    [anon_sym_sealed] = ACTIONS(255),
    [anon_sym_non_DASHsealed] = ACTIONS(253),
    [anon_sym_record] = ACTIONS(255),
    [anon_sym_ATinterface] = ACTIONS(253),
    [anon_sym_interface] = ACTIONS(255),
    [anon_sym_byte] = ACTIONS(255),
    [anon_sym_short] = ACTIONS(255),
    [anon_sym_int] = ACTIONS(255),
    [anon_sym_long] = ACTIONS(255),
    [anon_sym_char] = ACTIONS(255),
    [anon_sym_float] = ACTIONS(255),
    [anon_sym_double] = ACTIONS(255),
    [sym_boolean_type] = ACTIONS(255),
    [sym_void_type] = ACTIONS(255),
    [sym_this] = ACTIONS(255),
    [sym_super] = ACTIONS(255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [77] = {
    [sym_identifier] = ACTIONS(257),
    [sym_decimal_integer_literal] = ACTIONS(257),
    [sym_hex_integer_literal] = ACTIONS(257),
    [sym_octal_integer_literal] = ACTIONS(259),
    [sym_binary_integer_literal] = ACTIONS(259),
    [sym_decimal_floating_point_literal] = ACTIONS(259),
    [sym_hex_floating_point_literal] = ACTIONS(257),
    [sym_true] = ACTIONS(257),
    [sym_false] = ACTIONS(257),
    [sym_character_literal] = ACTIONS(259),
    [sym_string_literal] = ACTIONS(257),
    [sym_text_block] = ACTIONS(259),
    [sym_null_literal] = ACTIONS(257),
    [anon_sym_LPAREN] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(257),
    [anon_sym_RPAREN] = ACTIONS(259),
    [anon_sym_GT] = ACTIONS(257),
    [anon_sym_LT] = ACTIONS(257),
    [anon_sym_GT_EQ] = ACTIONS(259),
    [anon_sym_LT_EQ] = ACTIONS(259),
    [anon_sym_EQ_EQ] = ACTIONS(259),
    [anon_sym_BANG_EQ] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_PLUS] = ACTIONS(257),
    [anon_sym_DASH] = ACTIONS(257),
    [anon_sym_STAR] = ACTIONS(259),
    [anon_sym_SLASH] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(257),
    [anon_sym_CARET] = ACTIONS(259),
    [anon_sym_PERCENT] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(259),
    [anon_sym_GT_GT] = ACTIONS(257),
    [anon_sym_GT_GT_GT] = ACTIONS(259),
    [anon_sym_instanceof] = ACTIONS(257),
    [anon_sym_final] = ACTIONS(257),
    [anon_sym_DASH_GT] = ACTIONS(259),
    [anon_sym_COMMA] = ACTIONS(259),
    [anon_sym_QMARK] = ACTIONS(259),
    [anon_sym_COLON] = ACTIONS(257),
    [anon_sym_BANG] = ACTIONS(257),
    [anon_sym_TILDE] = ACTIONS(259),
    [anon_sym_PLUS_PLUS] = ACTIONS(259),
    [anon_sym_DASH_DASH] = ACTIONS(259),
    [anon_sym_new] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(259),
    [anon_sym_RBRACK] = ACTIONS(259),
    [anon_sym_DOT] = ACTIONS(257),
    [anon_sym_class] = ACTIONS(257),
    [anon_sym_COLON_COLON] = ACTIONS(259),
    [anon_sym_switch] = ACTIONS(257),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_RBRACE] = ACTIONS(259),
    [anon_sym_default] = ACTIONS(257),
    [anon_sym_SEMI] = ACTIONS(259),
    [anon_sym_assert] = ACTIONS(257),
    [anon_sym_do] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(257),
    [anon_sym_return] = ACTIONS(257),
    [anon_sym_yield] = ACTIONS(257),
    [anon_sym_synchronized] = ACTIONS(257),
    [anon_sym_throw] = ACTIONS(257),
    [anon_sym_try] = ACTIONS(257),
    [anon_sym_if] = ACTIONS(257),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(257),
    [anon_sym_open] = ACTIONS(257),
    [anon_sym_module] = ACTIONS(257),
    [anon_sym_static] = ACTIONS(257),
    [anon_sym_package] = ACTIONS(257),
    [anon_sym_import] = ACTIONS(257),
    [anon_sym_enum] = ACTIONS(257),
    [anon_sym_public] = ACTIONS(257),
    [anon_sym_protected] = ACTIONS(257),
    [anon_sym_private] = ACTIONS(257),
    [anon_sym_abstract] = ACTIONS(257),
    [anon_sym_strictfp] = ACTIONS(257),
    [anon_sym_native] = ACTIONS(257),
    [anon_sym_transient] = ACTIONS(257),
    [anon_sym_volatile] = ACTIONS(257),
    [anon_sym_sealed] = ACTIONS(257),
    [anon_sym_non_DASHsealed] = ACTIONS(259),
    [anon_sym_record] = ACTIONS(257),
    [anon_sym_ATinterface] = ACTIONS(259),
    [anon_sym_interface] = ACTIONS(257),
    [anon_sym_byte] = ACTIONS(257),
    [anon_sym_short] = ACTIONS(257),
    [anon_sym_int] = ACTIONS(257),
    [anon_sym_long] = ACTIONS(257),
    [anon_sym_char] = ACTIONS(257),
    [anon_sym_float] = ACTIONS(257),
    [anon_sym_double] = ACTIONS(257),
    [sym_boolean_type] = ACTIONS(257),
    [sym_void_type] = ACTIONS(257),
    [sym_this] = ACTIONS(257),
    [sym_super] = ACTIONS(257),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [78] = {
    [ts_builtin_sym_end] = ACTIONS(261),
    [sym_identifier] = ACTIONS(263),
    [sym_decimal_integer_literal] = ACTIONS(263),
    [sym_hex_integer_literal] = ACTIONS(263),
    [sym_octal_integer_literal] = ACTIONS(261),
    [sym_binary_integer_literal] = ACTIONS(261),
    [sym_decimal_floating_point_literal] = ACTIONS(261),
    [sym_hex_floating_point_literal] = ACTIONS(263),
    [sym_true] = ACTIONS(263),
    [sym_false] = ACTIONS(263),
    [sym_character_literal] = ACTIONS(261),
    [sym_string_literal] = ACTIONS(263),
    [sym_text_block] = ACTIONS(261),
    [sym_null_literal] = ACTIONS(263),
    [anon_sym_LPAREN] = ACTIONS(261),
    [anon_sym_AMP] = ACTIONS(263),
    [anon_sym_RPAREN] = ACTIONS(261),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT_EQ] = ACTIONS(261),
    [anon_sym_LT_EQ] = ACTIONS(261),
    [anon_sym_EQ_EQ] = ACTIONS(261),
    [anon_sym_BANG_EQ] = ACTIONS(261),
    [anon_sym_AMP_AMP] = ACTIONS(261),
    [anon_sym_PIPE_PIPE] = ACTIONS(261),
    [anon_sym_PLUS] = ACTIONS(263),
    [anon_sym_DASH] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(261),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_CARET] = ACTIONS(261),
    [anon_sym_PERCENT] = ACTIONS(261),
    [anon_sym_LT_LT] = ACTIONS(261),
    [anon_sym_GT_GT] = ACTIONS(263),
    [anon_sym_GT_GT_GT] = ACTIONS(261),
    [anon_sym_instanceof] = ACTIONS(263),
    [anon_sym_final] = ACTIONS(263),
    [anon_sym_DASH_GT] = ACTIONS(261),
    [anon_sym_COMMA] = ACTIONS(261),
    [anon_sym_QMARK] = ACTIONS(261),
    [anon_sym_COLON] = ACTIONS(261),
    [anon_sym_BANG] = ACTIONS(263),
    [anon_sym_TILDE] = ACTIONS(261),
    [anon_sym_PLUS_PLUS] = ACTIONS(261),
    [anon_sym_DASH_DASH] = ACTIONS(261),
    [anon_sym_new] = ACTIONS(263),
    [anon_sym_RBRACK] = ACTIONS(261),
    [anon_sym_class] = ACTIONS(263),
    [anon_sym_switch] = ACTIONS(263),
    [anon_sym_LBRACE] = ACTIONS(261),
    [anon_sym_RBRACE] = ACTIONS(261),
    [anon_sym_case] = ACTIONS(263),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_SEMI] = ACTIONS(261),
    [anon_sym_assert] = ACTIONS(263),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(263),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_continue] = ACTIONS(263),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_yield] = ACTIONS(263),
    [anon_sym_synchronized] = ACTIONS(263),
    [anon_sym_throw] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_else] = ACTIONS(263),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_AT] = ACTIONS(263),
    [anon_sym_open] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(263),
    [anon_sym_static] = ACTIONS(263),
    [anon_sym_package] = ACTIONS(263),
    [anon_sym_import] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(263),
    [anon_sym_public] = ACTIONS(263),
    [anon_sym_protected] = ACTIONS(263),
    [anon_sym_private] = ACTIONS(263),
    [anon_sym_abstract] = ACTIONS(263),
    [anon_sym_strictfp] = ACTIONS(263),
    [anon_sym_native] = ACTIONS(263),
    [anon_sym_transient] = ACTIONS(263),
    [anon_sym_volatile] = ACTIONS(263),
    [anon_sym_sealed] = ACTIONS(263),
    [anon_sym_non_DASHsealed] = ACTIONS(261),
    [anon_sym_record] = ACTIONS(263),
    [anon_sym_ATinterface] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_byte] = ACTIONS(263),
    [anon_sym_short] = ACTIONS(263),
    [anon_sym_int] = ACTIONS(263),
    [anon_sym_long] = ACTIONS(263),
    [anon_sym_char] = ACTIONS(263),
    [anon_sym_float] = ACTIONS(263),
    [anon_sym_double] = ACTIONS(263),
    [sym_boolean_type] = ACTIONS(263),
    [sym_void_type] = ACTIONS(263),
    [sym_this] = ACTIONS(263),
    [sym_super] = ACTIONS(263),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [79] = {
    [ts_builtin_sym_end] = ACTIONS(265),
    [sym_identifier] = ACTIONS(267),
    [sym_decimal_integer_literal] = ACTIONS(267),
    [sym_hex_integer_literal] = ACTIONS(267),
    [sym_octal_integer_literal] = ACTIONS(265),
    [sym_binary_integer_literal] = ACTIONS(265),
    [sym_decimal_floating_point_literal] = ACTIONS(265),
    [sym_hex_floating_point_literal] = ACTIONS(267),
    [sym_true] = ACTIONS(267),
    [sym_false] = ACTIONS(267),
    [sym_character_literal] = ACTIONS(265),
    [sym_string_literal] = ACTIONS(267),
    [sym_text_block] = ACTIONS(265),
    [sym_null_literal] = ACTIONS(267),
    [anon_sym_LPAREN] = ACTIONS(265),
    [anon_sym_AMP] = ACTIONS(267),
    [anon_sym_RPAREN] = ACTIONS(265),
    [anon_sym_GT] = ACTIONS(267),
    [anon_sym_LT] = ACTIONS(267),
    [anon_sym_GT_EQ] = ACTIONS(265),
    [anon_sym_LT_EQ] = ACTIONS(265),
    [anon_sym_EQ_EQ] = ACTIONS(265),
    [anon_sym_BANG_EQ] = ACTIONS(265),
    [anon_sym_AMP_AMP] = ACTIONS(265),
    [anon_sym_PIPE_PIPE] = ACTIONS(265),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(267),
    [anon_sym_STAR] = ACTIONS(265),
    [anon_sym_SLASH] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(267),
    [anon_sym_CARET] = ACTIONS(265),
    [anon_sym_PERCENT] = ACTIONS(265),
    [anon_sym_LT_LT] = ACTIONS(265),
    [anon_sym_GT_GT] = ACTIONS(267),
    [anon_sym_GT_GT_GT] = ACTIONS(265),
    [anon_sym_instanceof] = ACTIONS(267),
    [anon_sym_final] = ACTIONS(267),
    [anon_sym_DASH_GT] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(265),
    [anon_sym_QMARK] = ACTIONS(265),
    [anon_sym_COLON] = ACTIONS(265),
    [anon_sym_BANG] = ACTIONS(267),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_PLUS_PLUS] = ACTIONS(265),
    [anon_sym_DASH_DASH] = ACTIONS(265),
    [anon_sym_new] = ACTIONS(267),
    [anon_sym_RBRACK] = ACTIONS(265),
    [anon_sym_class] = ACTIONS(267),
    [anon_sym_switch] = ACTIONS(267),
    [anon_sym_LBRACE] = ACTIONS(265),
    [anon_sym_RBRACE] = ACTIONS(265),
    [anon_sym_case] = ACTIONS(267),
    [anon_sym_default] = ACTIONS(267),
    [anon_sym_SEMI] = ACTIONS(265),
    [anon_sym_assert] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_break] = ACTIONS(267),
    [anon_sym_continue] = ACTIONS(267),
    [anon_sym_return] = ACTIONS(267),
    [anon_sym_yield] = ACTIONS(267),
    [anon_sym_synchronized] = ACTIONS(267),
    [anon_sym_throw] = ACTIONS(267),
    [anon_sym_try] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_else] = ACTIONS(267),
    [anon_sym_for] = ACTIONS(267),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym_open] = ACTIONS(267),
    [anon_sym_module] = ACTIONS(267),
    [anon_sym_static] = ACTIONS(267),
    [anon_sym_package] = ACTIONS(267),
    [anon_sym_import] = ACTIONS(267),
    [anon_sym_enum] = ACTIONS(267),
    [anon_sym_public] = ACTIONS(267),
    [anon_sym_protected] = ACTIONS(267),
    [anon_sym_private] = ACTIONS(267),
    [anon_sym_abstract] = ACTIONS(267),
    [anon_sym_strictfp] = ACTIONS(267),
    [anon_sym_native] = ACTIONS(267),
    [anon_sym_transient] = ACTIONS(267),
    [anon_sym_volatile] = ACTIONS(267),
    [anon_sym_sealed] = ACTIONS(267),
    [anon_sym_non_DASHsealed] = ACTIONS(265),
    [anon_sym_record] = ACTIONS(267),
    [anon_sym_ATinterface] = ACTIONS(265),
    [anon_sym_interface] = ACTIONS(267),
    [anon_sym_byte] = ACTIONS(267),
    [anon_sym_short] = ACTIONS(267),
    [anon_sym_int] = ACTIONS(267),
    [anon_sym_long] = ACTIONS(267),
    [anon_sym_char] = ACTIONS(267),
    [anon_sym_float] = ACTIONS(267),
    [anon_sym_double] = ACTIONS(267),
    [sym_boolean_type] = ACTIONS(267),
    [sym_void_type] = ACTIONS(267),
    [sym_this] = ACTIONS(267),
    [sym_super] = ACTIONS(267),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [80] = {
    [ts_builtin_sym_end] = ACTIONS(269),
    [sym_identifier] = ACTIONS(271),
    [sym_decimal_integer_literal] = ACTIONS(271),
    [sym_hex_integer_literal] = ACTIONS(271),
    [sym_octal_integer_literal] = ACTIONS(269),
    [sym_binary_integer_literal] = ACTIONS(269),
    [sym_decimal_floating_point_literal] = ACTIONS(269),
    [sym_hex_floating_point_literal] = ACTIONS(271),
    [sym_true] = ACTIONS(271),
    [sym_false] = ACTIONS(271),
    [sym_character_literal] = ACTIONS(269),
    [sym_string_literal] = ACTIONS(271),
    [sym_text_block] = ACTIONS(269),
    [sym_null_literal] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_AMP] = ACTIONS(271),
    [anon_sym_RPAREN] = ACTIONS(269),
    [anon_sym_GT] = ACTIONS(271),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_GT_EQ] = ACTIONS(269),
    [anon_sym_LT_EQ] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(269),
    [anon_sym_AMP_AMP] = ACTIONS(269),
    [anon_sym_PIPE_PIPE] = ACTIONS(269),
    [anon_sym_PLUS] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(271),
    [anon_sym_STAR] = ACTIONS(269),
    [anon_sym_SLASH] = ACTIONS(271),
    [anon_sym_PIPE] = ACTIONS(271),
    [anon_sym_CARET] = ACTIONS(269),
    [anon_sym_PERCENT] = ACTIONS(269),
    [anon_sym_LT_LT] = ACTIONS(269),
    [anon_sym_GT_GT] = ACTIONS(271),
    [anon_sym_GT_GT_GT] = ACTIONS(269),
    [anon_sym_instanceof] = ACTIONS(271),
    [anon_sym_final] = ACTIONS(271),
    [anon_sym_DASH_GT] = ACTIONS(269),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_QMARK] = ACTIONS(269),
    [anon_sym_COLON] = ACTIONS(269),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_TILDE] = ACTIONS(269),
    [anon_sym_PLUS_PLUS] = ACTIONS(269),
    [anon_sym_DASH_DASH] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_RBRACK] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(271),
    [anon_sym_switch] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(269),
    [anon_sym_case] = ACTIONS(271),
    [anon_sym_default] = ACTIONS(271),
    [anon_sym_SEMI] = ACTIONS(269),
    [anon_sym_assert] = ACTIONS(271),
    [anon_sym_do] = ACTIONS(271),
    [anon_sym_while] = ACTIONS(271),
    [anon_sym_break] = ACTIONS(271),
    [anon_sym_continue] = ACTIONS(271),
    [anon_sym_return] = ACTIONS(271),
    [anon_sym_yield] = ACTIONS(271),
    [anon_sym_synchronized] = ACTIONS(271),
    [anon_sym_throw] = ACTIONS(271),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_if] = ACTIONS(271),
    [anon_sym_else] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(271),
    [anon_sym_open] = ACTIONS(271),
    [anon_sym_module] = ACTIONS(271),
    [anon_sym_static] = ACTIONS(271),
    [anon_sym_package] = ACTIONS(271),
    [anon_sym_import] = ACTIONS(271),
    [anon_sym_enum] = ACTIONS(271),
    [anon_sym_public] = ACTIONS(271),
    [anon_sym_protected] = ACTIONS(271),
    [anon_sym_private] = ACTIONS(271),
    [anon_sym_abstract] = ACTIONS(271),
    [anon_sym_strictfp] = ACTIONS(271),
    [anon_sym_native] = ACTIONS(271),
    [anon_sym_transient] = ACTIONS(271),
    [anon_sym_volatile] = ACTIONS(271),
    [anon_sym_sealed] = ACTIONS(271),
    [anon_sym_non_DASHsealed] = ACTIONS(269),
    [anon_sym_record] = ACTIONS(271),
    [anon_sym_ATinterface] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(271),
    [anon_sym_byte] = ACTIONS(271),
    [anon_sym_short] = ACTIONS(271),
    [anon_sym_int] = ACTIONS(271),
    [anon_sym_long] = ACTIONS(271),
    [anon_sym_char] = ACTIONS(271),
    [anon_sym_float] = ACTIONS(271),
    [anon_sym_double] = ACTIONS(271),
    [sym_boolean_type] = ACTIONS(271),
    [sym_void_type] = ACTIONS(271),
    [sym_this] = ACTIONS(271),
    [sym_super] = ACTIONS(271),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [81] = {
    [ts_builtin_sym_end] = ACTIONS(273),
    [sym_identifier] = ACTIONS(275),
    [sym_decimal_integer_literal] = ACTIONS(275),
    [sym_hex_integer_literal] = ACTIONS(275),
    [sym_octal_integer_literal] = ACTIONS(273),
    [sym_binary_integer_literal] = ACTIONS(273),
    [sym_decimal_floating_point_literal] = ACTIONS(273),
    [sym_hex_floating_point_literal] = ACTIONS(275),
    [sym_true] = ACTIONS(275),
    [sym_false] = ACTIONS(275),
    [sym_character_literal] = ACTIONS(273),
    [sym_string_literal] = ACTIONS(275),
    [sym_text_block] = ACTIONS(273),
    [sym_null_literal] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_AMP] = ACTIONS(275),
    [anon_sym_RPAREN] = ACTIONS(273),
    [anon_sym_GT] = ACTIONS(275),
    [anon_sym_LT] = ACTIONS(275),
    [anon_sym_GT_EQ] = ACTIONS(273),
    [anon_sym_LT_EQ] = ACTIONS(273),
    [anon_sym_EQ_EQ] = ACTIONS(273),
    [anon_sym_BANG_EQ] = ACTIONS(273),
    [anon_sym_AMP_AMP] = ACTIONS(273),
    [anon_sym_PIPE_PIPE] = ACTIONS(273),
    [anon_sym_PLUS] = ACTIONS(275),
    [anon_sym_DASH] = ACTIONS(275),
    [anon_sym_STAR] = ACTIONS(273),
    [anon_sym_SLASH] = ACTIONS(275),
    [anon_sym_PIPE] = ACTIONS(275),
    [anon_sym_CARET] = ACTIONS(273),
    [anon_sym_PERCENT] = ACTIONS(273),
    [anon_sym_LT_LT] = ACTIONS(273),
    [anon_sym_GT_GT] = ACTIONS(275),
    [anon_sym_GT_GT_GT] = ACTIONS(273),
    [anon_sym_instanceof] = ACTIONS(275),
    [anon_sym_final] = ACTIONS(275),
    [anon_sym_DASH_GT] = ACTIONS(273),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym_QMARK] = ACTIONS(273),
    [anon_sym_COLON] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_TILDE] = ACTIONS(273),
    [anon_sym_PLUS_PLUS] = ACTIONS(273),
    [anon_sym_DASH_DASH] = ACTIONS(273),
    [anon_sym_new] = ACTIONS(275),
    [anon_sym_RBRACK] = ACTIONS(273),
    [anon_sym_class] = ACTIONS(275),
    [anon_sym_switch] = ACTIONS(275),
    [anon_sym_LBRACE] = ACTIONS(273),
    [anon_sym_RBRACE] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_default] = ACTIONS(275),
    [anon_sym_SEMI] = ACTIONS(273),
    [anon_sym_assert] = ACTIONS(275),
    [anon_sym_do] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(275),
    [anon_sym_break] = ACTIONS(275),
    [anon_sym_continue] = ACTIONS(275),
    [anon_sym_return] = ACTIONS(275),
    [anon_sym_yield] = ACTIONS(275),
    [anon_sym_synchronized] = ACTIONS(275),
    [anon_sym_throw] = ACTIONS(275),
    [anon_sym_try] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_else] = ACTIONS(275),
    [anon_sym_for] = ACTIONS(275),
    [anon_sym_AT] = ACTIONS(275),
    [anon_sym_open] = ACTIONS(275),
    [anon_sym_module] = ACTIONS(275),
    [anon_sym_static] = ACTIONS(275),
    [anon_sym_package] = ACTIONS(275),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_enum] = ACTIONS(275),
    [anon_sym_public] = ACTIONS(275),
    [anon_sym_protected] = ACTIONS(275),
    [anon_sym_private] = ACTIONS(275),
    [anon_sym_abstract] = ACTIONS(275),
    [anon_sym_strictfp] = ACTIONS(275),
    [anon_sym_native] = ACTIONS(275),
    [anon_sym_transient] = ACTIONS(275),
    [anon_sym_volatile] = ACTIONS(275),
    [anon_sym_sealed] = ACTIONS(275),
    [anon_sym_non_DASHsealed] = ACTIONS(273),
    [anon_sym_record] = ACTIONS(275),
    [anon_sym_ATinterface] = ACTIONS(273),
    [anon_sym_interface] = ACTIONS(275),
    [anon_sym_byte] = ACTIONS(275),
    [anon_sym_short] = ACTIONS(275),
    [anon_sym_int] = ACTIONS(275),
    [anon_sym_long] = ACTIONS(275),
    [anon_sym_char] = ACTIONS(275),
    [anon_sym_float] = ACTIONS(275),
    [anon_sym_double] = ACTIONS(275),
    [sym_boolean_type] = ACTIONS(275),
    [sym_void_type] = ACTIONS(275),
    [sym_this] = ACTIONS(275),
    [sym_super] = ACTIONS(275),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [82] = {
    [ts_builtin_sym_end] = ACTIONS(277),
    [sym_identifier] = ACTIONS(279),
    [sym_decimal_integer_literal] = ACTIONS(279),
    [sym_hex_integer_literal] = ACTIONS(279),
    [sym_octal_integer_literal] = ACTIONS(277),
    [sym_binary_integer_literal] = ACTIONS(277),
    [sym_decimal_floating_point_literal] = ACTIONS(277),
    [sym_hex_floating_point_literal] = ACTIONS(279),
    [sym_true] = ACTIONS(279),
    [sym_false] = ACTIONS(279),
    [sym_character_literal] = ACTIONS(277),
    [sym_string_literal] = ACTIONS(279),
    [sym_text_block] = ACTIONS(277),
    [sym_null_literal] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(279),
    [anon_sym_RPAREN] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_AMP_AMP] = ACTIONS(277),
    [anon_sym_PIPE_PIPE] = ACTIONS(277),
    [anon_sym_PLUS] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(277),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(279),
    [anon_sym_GT_GT_GT] = ACTIONS(277),
    [anon_sym_instanceof] = ACTIONS(279),
    [anon_sym_final] = ACTIONS(279),
    [anon_sym_DASH_GT] = ACTIONS(277),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(277),
    [anon_sym_COLON] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(277),
    [anon_sym_PLUS_PLUS] = ACTIONS(277),
    [anon_sym_DASH_DASH] = ACTIONS(277),
    [anon_sym_new] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(277),
    [anon_sym_class] = ACTIONS(279),
    [anon_sym_switch] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(277),
    [anon_sym_RBRACE] = ACTIONS(277),
    [anon_sym_case] = ACTIONS(279),
    [anon_sym_default] = ACTIONS(279),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_assert] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_while] = ACTIONS(279),
    [anon_sym_break] = ACTIONS(279),
    [anon_sym_continue] = ACTIONS(279),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_yield] = ACTIONS(279),
    [anon_sym_synchronized] = ACTIONS(279),
    [anon_sym_throw] = ACTIONS(279),
    [anon_sym_try] = ACTIONS(279),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_else] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_open] = ACTIONS(279),
    [anon_sym_module] = ACTIONS(279),
    [anon_sym_static] = ACTIONS(279),
    [anon_sym_package] = ACTIONS(279),
    [anon_sym_import] = ACTIONS(279),
    [anon_sym_enum] = ACTIONS(279),
    [anon_sym_public] = ACTIONS(279),
    [anon_sym_protected] = ACTIONS(279),
    [anon_sym_private] = ACTIONS(279),
    [anon_sym_abstract] = ACTIONS(279),
    [anon_sym_strictfp] = ACTIONS(279),
    [anon_sym_native] = ACTIONS(279),
    [anon_sym_transient] = ACTIONS(279),
    [anon_sym_volatile] = ACTIONS(279),
    [anon_sym_sealed] = ACTIONS(279),
    [anon_sym_non_DASHsealed] = ACTIONS(277),
    [anon_sym_record] = ACTIONS(279),
    [anon_sym_ATinterface] = ACTIONS(277),
    [anon_sym_interface] = ACTIONS(279),
    [anon_sym_byte] = ACTIONS(279),
    [anon_sym_short] = ACTIONS(279),
    [anon_sym_int] = ACTIONS(279),
    [anon_sym_long] = ACTIONS(279),
    [anon_sym_char] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(279),
    [anon_sym_double] = ACTIONS(279),
    [sym_boolean_type] = ACTIONS(279),
    [sym_void_type] = ACTIONS(279),
    [sym_this] = ACTIONS(279),
    [sym_super] = ACTIONS(279),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [83] = {
    [ts_builtin_sym_end] = ACTIONS(281),
    [sym_identifier] = ACTIONS(283),
    [sym_decimal_integer_literal] = ACTIONS(283),
    [sym_hex_integer_literal] = ACTIONS(283),
    [sym_octal_integer_literal] = ACTIONS(281),
    [sym_binary_integer_literal] = ACTIONS(281),
    [sym_decimal_floating_point_literal] = ACTIONS(281),
    [sym_hex_floating_point_literal] = ACTIONS(283),
    [sym_true] = ACTIONS(283),
    [sym_false] = ACTIONS(283),
    [sym_character_literal] = ACTIONS(281),
    [sym_string_literal] = ACTIONS(283),
    [sym_text_block] = ACTIONS(281),
    [sym_null_literal] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(285),
    [anon_sym_GT] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(285),
    [anon_sym_GT_EQ] = ACTIONS(287),
    [anon_sym_LT_EQ] = ACTIONS(287),
    [anon_sym_EQ_EQ] = ACTIONS(287),
    [anon_sym_BANG_EQ] = ACTIONS(287),
    [anon_sym_AMP_AMP] = ACTIONS(287),
    [anon_sym_PIPE_PIPE] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(289),
    [anon_sym_STAR] = ACTIONS(287),
    [anon_sym_SLASH] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(285),
    [anon_sym_CARET] = ACTIONS(287),
    [anon_sym_PERCENT] = ACTIONS(287),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_GT_GT_GT] = ACTIONS(287),
    [anon_sym_instanceof] = ACTIONS(285),
    [anon_sym_final] = ACTIONS(283),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(283),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS_PLUS] = ACTIONS(292),
    [anon_sym_DASH_DASH] = ACTIONS(292),
    [anon_sym_new] = ACTIONS(283),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_switch] = ACTIONS(283),
    [anon_sym_LBRACE] = ACTIONS(281),
    [anon_sym_RBRACE] = ACTIONS(281),
    [anon_sym_case] = ACTIONS(283),
    [anon_sym_default] = ACTIONS(283),
    [anon_sym_SEMI] = ACTIONS(292),
    [anon_sym_assert] = ACTIONS(283),
    [anon_sym_do] = ACTIONS(283),
    [anon_sym_while] = ACTIONS(283),
    [anon_sym_break] = ACTIONS(283),
    [anon_sym_continue] = ACTIONS(283),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_yield] = ACTIONS(283),
    [anon_sym_synchronized] = ACTIONS(283),
    [anon_sym_throw] = ACTIONS(283),
    [anon_sym_try] = ACTIONS(283),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_else] = ACTIONS(283),
    [anon_sym_for] = ACTIONS(283),
    [anon_sym_AT] = ACTIONS(283),
    [anon_sym_open] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(283),
    [anon_sym_static] = ACTIONS(283),
    [anon_sym_package] = ACTIONS(283),
    [anon_sym_import] = ACTIONS(283),
    [anon_sym_enum] = ACTIONS(283),
    [anon_sym_public] = ACTIONS(283),
    [anon_sym_protected] = ACTIONS(283),
    [anon_sym_private] = ACTIONS(283),
    [anon_sym_abstract] = ACTIONS(283),
    [anon_sym_strictfp] = ACTIONS(283),
    [anon_sym_native] = ACTIONS(283),
    [anon_sym_transient] = ACTIONS(283),
    [anon_sym_volatile] = ACTIONS(283),
    [anon_sym_sealed] = ACTIONS(283),
    [anon_sym_non_DASHsealed] = ACTIONS(281),
    [anon_sym_record] = ACTIONS(283),
    [anon_sym_ATinterface] = ACTIONS(281),
    [anon_sym_interface] = ACTIONS(283),
    [anon_sym_byte] = ACTIONS(283),
    [anon_sym_short] = ACTIONS(283),
    [anon_sym_int] = ACTIONS(283),
    [anon_sym_long] = ACTIONS(283),
    [anon_sym_char] = ACTIONS(283),
    [anon_sym_float] = ACTIONS(283),
    [anon_sym_double] = ACTIONS(283),
    [sym_boolean_type] = ACTIONS(283),
    [sym_void_type] = ACTIONS(283),
    [sym_this] = ACTIONS(283),
    [sym_super] = ACTIONS(283),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [84] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(631),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(606),
    [sym_marker_annotation] = STATE(606),
    [sym_annotation] = STATE(606),
    [sym_modifiers] = STATE(703),
    [sym__type] = STATE(961),
    [sym__unannotated_type] = STATE(683),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_formal_parameter] = STATE(1003),
    [sym_receiver_parameter] = STATE(398),
    [sym_spread_parameter] = STATE(1003),
    [aux_sym_array_creation_expression_repeat1] = STATE(653),
    [aux_sym_modifiers_repeat1] = STATE(538),
    [sym_identifier] = ACTIONS(295),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(299),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_synchronized] = ACTIONS(299),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_open] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(303),
    [anon_sym_static] = ACTIONS(299),
    [anon_sym_public] = ACTIONS(299),
    [anon_sym_protected] = ACTIONS(299),
    [anon_sym_private] = ACTIONS(299),
    [anon_sym_abstract] = ACTIONS(299),
    [anon_sym_strictfp] = ACTIONS(299),
    [anon_sym_native] = ACTIONS(299),
    [anon_sym_transient] = ACTIONS(299),
    [anon_sym_volatile] = ACTIONS(299),
    [anon_sym_sealed] = ACTIONS(299),
    [anon_sym_non_DASHsealed] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(303),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [85] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(631),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(606),
    [sym_marker_annotation] = STATE(606),
    [sym_annotation] = STATE(606),
    [sym_modifiers] = STATE(703),
    [sym__type] = STATE(948),
    [sym__unannotated_type] = STATE(683),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_formal_parameter] = STATE(1003),
    [sym_receiver_parameter] = STATE(398),
    [sym_spread_parameter] = STATE(1003),
    [aux_sym_array_creation_expression_repeat1] = STATE(653),
    [aux_sym_modifiers_repeat1] = STATE(538),
    [sym_identifier] = ACTIONS(295),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(299),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_synchronized] = ACTIONS(299),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_open] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(303),
    [anon_sym_static] = ACTIONS(299),
    [anon_sym_public] = ACTIONS(299),
    [anon_sym_protected] = ACTIONS(299),
    [anon_sym_private] = ACTIONS(299),
    [anon_sym_abstract] = ACTIONS(299),
    [anon_sym_strictfp] = ACTIONS(299),
    [anon_sym_native] = ACTIONS(299),
    [anon_sym_transient] = ACTIONS(299),
    [anon_sym_volatile] = ACTIONS(299),
    [anon_sym_sealed] = ACTIONS(299),
    [anon_sym_non_DASHsealed] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(303),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [86] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(552),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(606),
    [sym_marker_annotation] = STATE(606),
    [sym_annotation] = STATE(606),
    [sym_modifiers] = STATE(696),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(690),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(277),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [aux_sym_modifiers_repeat1] = STATE(538),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(299),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_SEMI] = ACTIONS(309),
    [anon_sym_synchronized] = ACTIONS(299),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_static] = ACTIONS(299),
    [anon_sym_public] = ACTIONS(299),
    [anon_sym_protected] = ACTIONS(299),
    [anon_sym_private] = ACTIONS(299),
    [anon_sym_abstract] = ACTIONS(299),
    [anon_sym_strictfp] = ACTIONS(299),
    [anon_sym_native] = ACTIONS(299),
    [anon_sym_transient] = ACTIONS(299),
    [anon_sym_volatile] = ACTIONS(299),
    [anon_sym_sealed] = ACTIONS(299),
    [anon_sym_non_DASHsealed] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [87] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(553),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(606),
    [sym_marker_annotation] = STATE(606),
    [sym_annotation] = STATE(606),
    [sym_modifiers] = STATE(697),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(692),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [sym_local_variable_declaration] = STATE(264),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [aux_sym_modifiers_repeat1] = STATE(538),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_final] = ACTIONS(299),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_SEMI] = ACTIONS(313),
    [anon_sym_synchronized] = ACTIONS(299),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_static] = ACTIONS(299),
    [anon_sym_public] = ACTIONS(299),
    [anon_sym_protected] = ACTIONS(299),
    [anon_sym_private] = ACTIONS(299),
    [anon_sym_abstract] = ACTIONS(299),
    [anon_sym_strictfp] = ACTIONS(299),
    [anon_sym_native] = ACTIONS(299),
    [anon_sym_transient] = ACTIONS(299),
    [anon_sym_volatile] = ACTIONS(299),
    [anon_sym_sealed] = ACTIONS(299),
    [anon_sym_non_DASHsealed] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [88] = {
    [sym_catch_clause] = STATE(89),
    [sym_finally_clause] = STATE(187),
    [aux_sym_try_statement_repeat1] = STATE(89),
    [ts_builtin_sym_end] = ACTIONS(315),
    [sym_identifier] = ACTIONS(317),
    [sym_decimal_integer_literal] = ACTIONS(317),
    [sym_hex_integer_literal] = ACTIONS(317),
    [sym_octal_integer_literal] = ACTIONS(315),
    [sym_binary_integer_literal] = ACTIONS(315),
    [sym_decimal_floating_point_literal] = ACTIONS(315),
    [sym_hex_floating_point_literal] = ACTIONS(317),
    [sym_true] = ACTIONS(317),
    [sym_false] = ACTIONS(317),
    [sym_character_literal] = ACTIONS(315),
    [sym_string_literal] = ACTIONS(317),
    [sym_text_block] = ACTIONS(315),
    [sym_null_literal] = ACTIONS(317),
    [anon_sym_LPAREN] = ACTIONS(315),
    [anon_sym_PLUS] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(317),
    [anon_sym_final] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(315),
    [anon_sym_TILDE] = ACTIONS(315),
    [anon_sym_PLUS_PLUS] = ACTIONS(315),
    [anon_sym_DASH_DASH] = ACTIONS(315),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_class] = ACTIONS(317),
    [anon_sym_switch] = ACTIONS(317),
    [anon_sym_LBRACE] = ACTIONS(315),
    [anon_sym_RBRACE] = ACTIONS(315),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_default] = ACTIONS(317),
    [anon_sym_SEMI] = ACTIONS(315),
    [anon_sym_assert] = ACTIONS(317),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_while] = ACTIONS(317),
    [anon_sym_break] = ACTIONS(317),
    [anon_sym_continue] = ACTIONS(317),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_yield] = ACTIONS(317),
    [anon_sym_synchronized] = ACTIONS(317),
    [anon_sym_throw] = ACTIONS(317),
    [anon_sym_try] = ACTIONS(317),
    [anon_sym_catch] = ACTIONS(319),
    [anon_sym_finally] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_else] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(317),
    [anon_sym_AT] = ACTIONS(317),
    [anon_sym_open] = ACTIONS(317),
    [anon_sym_module] = ACTIONS(317),
    [anon_sym_static] = ACTIONS(317),
    [anon_sym_package] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(317),
    [anon_sym_enum] = ACTIONS(317),
    [anon_sym_public] = ACTIONS(317),
    [anon_sym_protected] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(317),
    [anon_sym_abstract] = ACTIONS(317),
    [anon_sym_strictfp] = ACTIONS(317),
    [anon_sym_native] = ACTIONS(317),
    [anon_sym_transient] = ACTIONS(317),
    [anon_sym_volatile] = ACTIONS(317),
    [anon_sym_sealed] = ACTIONS(317),
    [anon_sym_non_DASHsealed] = ACTIONS(315),
    [anon_sym_record] = ACTIONS(317),
    [anon_sym_ATinterface] = ACTIONS(315),
    [anon_sym_interface] = ACTIONS(317),
    [anon_sym_byte] = ACTIONS(317),
    [anon_sym_short] = ACTIONS(317),
    [anon_sym_int] = ACTIONS(317),
    [anon_sym_long] = ACTIONS(317),
    [anon_sym_char] = ACTIONS(317),
    [anon_sym_float] = ACTIONS(317),
    [anon_sym_double] = ACTIONS(317),
    [sym_boolean_type] = ACTIONS(317),
    [sym_void_type] = ACTIONS(317),
    [sym_this] = ACTIONS(317),
    [sym_super] = ACTIONS(317),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [89] = {
    [sym_catch_clause] = STATE(91),
    [sym_finally_clause] = STATE(241),
    [aux_sym_try_statement_repeat1] = STATE(91),
    [ts_builtin_sym_end] = ACTIONS(323),
    [sym_identifier] = ACTIONS(325),
    [sym_decimal_integer_literal] = ACTIONS(325),
    [sym_hex_integer_literal] = ACTIONS(325),
    [sym_octal_integer_literal] = ACTIONS(323),
    [sym_binary_integer_literal] = ACTIONS(323),
    [sym_decimal_floating_point_literal] = ACTIONS(323),
    [sym_hex_floating_point_literal] = ACTIONS(325),
    [sym_true] = ACTIONS(325),
    [sym_false] = ACTIONS(325),
    [sym_character_literal] = ACTIONS(323),
    [sym_string_literal] = ACTIONS(325),
    [sym_text_block] = ACTIONS(323),
    [sym_null_literal] = ACTIONS(325),
    [anon_sym_LPAREN] = ACTIONS(323),
    [anon_sym_PLUS] = ACTIONS(325),
    [anon_sym_DASH] = ACTIONS(325),
    [anon_sym_final] = ACTIONS(325),
    [anon_sym_BANG] = ACTIONS(323),
    [anon_sym_TILDE] = ACTIONS(323),
    [anon_sym_PLUS_PLUS] = ACTIONS(323),
    [anon_sym_DASH_DASH] = ACTIONS(323),
    [anon_sym_new] = ACTIONS(325),
    [anon_sym_class] = ACTIONS(325),
    [anon_sym_switch] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(323),
    [anon_sym_RBRACE] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(323),
    [anon_sym_assert] = ACTIONS(325),
    [anon_sym_do] = ACTIONS(325),
    [anon_sym_while] = ACTIONS(325),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(325),
    [anon_sym_yield] = ACTIONS(325),
    [anon_sym_synchronized] = ACTIONS(325),
    [anon_sym_throw] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_catch] = ACTIONS(319),
    [anon_sym_finally] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(325),
    [anon_sym_else] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_AT] = ACTIONS(325),
    [anon_sym_open] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(325),
    [anon_sym_static] = ACTIONS(325),
    [anon_sym_package] = ACTIONS(325),
    [anon_sym_import] = ACTIONS(325),
    [anon_sym_enum] = ACTIONS(325),
    [anon_sym_public] = ACTIONS(325),
    [anon_sym_protected] = ACTIONS(325),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_abstract] = ACTIONS(325),
    [anon_sym_strictfp] = ACTIONS(325),
    [anon_sym_native] = ACTIONS(325),
    [anon_sym_transient] = ACTIONS(325),
    [anon_sym_volatile] = ACTIONS(325),
    [anon_sym_sealed] = ACTIONS(325),
    [anon_sym_non_DASHsealed] = ACTIONS(323),
    [anon_sym_record] = ACTIONS(325),
    [anon_sym_ATinterface] = ACTIONS(323),
    [anon_sym_interface] = ACTIONS(325),
    [anon_sym_byte] = ACTIONS(325),
    [anon_sym_short] = ACTIONS(325),
    [anon_sym_int] = ACTIONS(325),
    [anon_sym_long] = ACTIONS(325),
    [anon_sym_char] = ACTIONS(325),
    [anon_sym_float] = ACTIONS(325),
    [anon_sym_double] = ACTIONS(325),
    [sym_boolean_type] = ACTIONS(325),
    [sym_void_type] = ACTIONS(325),
    [sym_this] = ACTIONS(325),
    [sym_super] = ACTIONS(325),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [90] = {
    [sym_catch_clause] = STATE(91),
    [sym_finally_clause] = STATE(188),
    [aux_sym_try_statement_repeat1] = STATE(91),
    [ts_builtin_sym_end] = ACTIONS(327),
    [sym_identifier] = ACTIONS(329),
    [sym_decimal_integer_literal] = ACTIONS(329),
    [sym_hex_integer_literal] = ACTIONS(329),
    [sym_octal_integer_literal] = ACTIONS(327),
    [sym_binary_integer_literal] = ACTIONS(327),
    [sym_decimal_floating_point_literal] = ACTIONS(327),
    [sym_hex_floating_point_literal] = ACTIONS(329),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_character_literal] = ACTIONS(327),
    [sym_string_literal] = ACTIONS(329),
    [sym_text_block] = ACTIONS(327),
    [sym_null_literal] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_PLUS] = ACTIONS(329),
    [anon_sym_DASH] = ACTIONS(329),
    [anon_sym_final] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(327),
    [anon_sym_TILDE] = ACTIONS(327),
    [anon_sym_PLUS_PLUS] = ACTIONS(327),
    [anon_sym_DASH_DASH] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_class] = ACTIONS(329),
    [anon_sym_switch] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_RBRACE] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(327),
    [anon_sym_assert] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(329),
    [anon_sym_return] = ACTIONS(329),
    [anon_sym_yield] = ACTIONS(329),
    [anon_sym_synchronized] = ACTIONS(329),
    [anon_sym_throw] = ACTIONS(329),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_catch] = ACTIONS(319),
    [anon_sym_finally] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(329),
    [anon_sym_else] = ACTIONS(329),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(329),
    [anon_sym_module] = ACTIONS(329),
    [anon_sym_static] = ACTIONS(329),
    [anon_sym_package] = ACTIONS(329),
    [anon_sym_import] = ACTIONS(329),
    [anon_sym_enum] = ACTIONS(329),
    [anon_sym_public] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_private] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_strictfp] = ACTIONS(329),
    [anon_sym_native] = ACTIONS(329),
    [anon_sym_transient] = ACTIONS(329),
    [anon_sym_volatile] = ACTIONS(329),
    [anon_sym_sealed] = ACTIONS(329),
    [anon_sym_non_DASHsealed] = ACTIONS(327),
    [anon_sym_record] = ACTIONS(329),
    [anon_sym_ATinterface] = ACTIONS(327),
    [anon_sym_interface] = ACTIONS(329),
    [anon_sym_byte] = ACTIONS(329),
    [anon_sym_short] = ACTIONS(329),
    [anon_sym_int] = ACTIONS(329),
    [anon_sym_long] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_float] = ACTIONS(329),
    [anon_sym_double] = ACTIONS(329),
    [sym_boolean_type] = ACTIONS(329),
    [sym_void_type] = ACTIONS(329),
    [sym_this] = ACTIONS(329),
    [sym_super] = ACTIONS(329),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [91] = {
    [sym_catch_clause] = STATE(91),
    [aux_sym_try_statement_repeat1] = STATE(91),
    [ts_builtin_sym_end] = ACTIONS(331),
    [sym_identifier] = ACTIONS(333),
    [sym_decimal_integer_literal] = ACTIONS(333),
    [sym_hex_integer_literal] = ACTIONS(333),
    [sym_octal_integer_literal] = ACTIONS(331),
    [sym_binary_integer_literal] = ACTIONS(331),
    [sym_decimal_floating_point_literal] = ACTIONS(331),
    [sym_hex_floating_point_literal] = ACTIONS(333),
    [sym_true] = ACTIONS(333),
    [sym_false] = ACTIONS(333),
    [sym_character_literal] = ACTIONS(331),
    [sym_string_literal] = ACTIONS(333),
    [sym_text_block] = ACTIONS(331),
    [sym_null_literal] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_final] = ACTIONS(333),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(331),
    [anon_sym_PLUS_PLUS] = ACTIONS(331),
    [anon_sym_DASH_DASH] = ACTIONS(331),
    [anon_sym_new] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(333),
    [anon_sym_switch] = ACTIONS(333),
    [anon_sym_LBRACE] = ACTIONS(331),
    [anon_sym_RBRACE] = ACTIONS(331),
    [anon_sym_case] = ACTIONS(333),
    [anon_sym_default] = ACTIONS(333),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_assert] = ACTIONS(333),
    [anon_sym_do] = ACTIONS(333),
    [anon_sym_while] = ACTIONS(333),
    [anon_sym_break] = ACTIONS(333),
    [anon_sym_continue] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(333),
    [anon_sym_yield] = ACTIONS(333),
    [anon_sym_synchronized] = ACTIONS(333),
    [anon_sym_throw] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(333),
    [anon_sym_catch] = ACTIONS(335),
    [anon_sym_finally] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_open] = ACTIONS(333),
    [anon_sym_module] = ACTIONS(333),
    [anon_sym_static] = ACTIONS(333),
    [anon_sym_package] = ACTIONS(333),
    [anon_sym_import] = ACTIONS(333),
    [anon_sym_enum] = ACTIONS(333),
    [anon_sym_public] = ACTIONS(333),
    [anon_sym_protected] = ACTIONS(333),
    [anon_sym_private] = ACTIONS(333),
    [anon_sym_abstract] = ACTIONS(333),
    [anon_sym_strictfp] = ACTIONS(333),
    [anon_sym_native] = ACTIONS(333),
    [anon_sym_transient] = ACTIONS(333),
    [anon_sym_volatile] = ACTIONS(333),
    [anon_sym_sealed] = ACTIONS(333),
    [anon_sym_non_DASHsealed] = ACTIONS(331),
    [anon_sym_record] = ACTIONS(333),
    [anon_sym_ATinterface] = ACTIONS(331),
    [anon_sym_interface] = ACTIONS(333),
    [anon_sym_byte] = ACTIONS(333),
    [anon_sym_short] = ACTIONS(333),
    [anon_sym_int] = ACTIONS(333),
    [anon_sym_long] = ACTIONS(333),
    [anon_sym_char] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(333),
    [anon_sym_double] = ACTIONS(333),
    [sym_boolean_type] = ACTIONS(333),
    [sym_void_type] = ACTIONS(333),
    [sym_this] = ACTIONS(333),
    [sym_super] = ACTIONS(333),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [92] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(544),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(710),
    [sym_marker_annotation] = STATE(710),
    [sym_annotation] = STATE(710),
    [sym_element_value_pair] = STATE(973),
    [sym__element_value] = STATE(1247),
    [sym_element_value_array_initializer] = STATE(1247),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(338),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(340),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [93] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(544),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(710),
    [sym_marker_annotation] = STATE(710),
    [sym_annotation] = STATE(710),
    [sym_element_value_pair] = STATE(975),
    [sym__element_value] = STATE(1217),
    [sym_element_value_array_initializer] = STATE(1217),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(338),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(346),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [94] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(544),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(710),
    [sym_marker_annotation] = STATE(710),
    [sym_annotation] = STATE(710),
    [sym__element_value] = STATE(1008),
    [sym_element_value_array_initializer] = STATE(1008),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(348),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(342),
    [anon_sym_RBRACE] = ACTIONS(350),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [95] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(544),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(710),
    [sym_marker_annotation] = STATE(710),
    [sym_annotation] = STATE(710),
    [sym_element_value_pair] = STATE(1010),
    [sym__element_value] = STATE(1207),
    [sym_element_value_array_initializer] = STATE(1207),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(338),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(352),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [96] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(616),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym_block] = STATE(1057),
    [sym_expression_statement] = STATE(1057),
    [sym_throw_statement] = STATE(1057),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [97] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(544),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(710),
    [sym_marker_annotation] = STATE(710),
    [sym_annotation] = STATE(710),
    [sym__element_value] = STATE(1083),
    [sym_element_value_array_initializer] = STATE(1083),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(342),
    [anon_sym_RBRACE] = ACTIONS(354),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [98] = {
    [ts_builtin_sym_end] = ACTIONS(265),
    [sym_identifier] = ACTIONS(267),
    [sym_decimal_integer_literal] = ACTIONS(267),
    [sym_hex_integer_literal] = ACTIONS(267),
    [sym_octal_integer_literal] = ACTIONS(265),
    [sym_binary_integer_literal] = ACTIONS(265),
    [sym_decimal_floating_point_literal] = ACTIONS(265),
    [sym_hex_floating_point_literal] = ACTIONS(267),
    [sym_true] = ACTIONS(267),
    [sym_false] = ACTIONS(267),
    [sym_character_literal] = ACTIONS(265),
    [sym_string_literal] = ACTIONS(267),
    [sym_text_block] = ACTIONS(265),
    [sym_null_literal] = ACTIONS(267),
    [anon_sym_LPAREN] = ACTIONS(265),
    [anon_sym_PLUS] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(267),
    [anon_sym_final] = ACTIONS(267),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_PLUS_PLUS] = ACTIONS(265),
    [anon_sym_DASH_DASH] = ACTIONS(265),
    [anon_sym_new] = ACTIONS(267),
    [anon_sym_class] = ACTIONS(267),
    [anon_sym_switch] = ACTIONS(267),
    [anon_sym_LBRACE] = ACTIONS(265),
    [anon_sym_RBRACE] = ACTIONS(265),
    [anon_sym_case] = ACTIONS(267),
    [anon_sym_default] = ACTIONS(267),
    [anon_sym_SEMI] = ACTIONS(265),
    [anon_sym_assert] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_break] = ACTIONS(267),
    [anon_sym_continue] = ACTIONS(267),
    [anon_sym_return] = ACTIONS(267),
    [anon_sym_yield] = ACTIONS(267),
    [anon_sym_synchronized] = ACTIONS(267),
    [anon_sym_throw] = ACTIONS(267),
    [anon_sym_try] = ACTIONS(267),
    [anon_sym_catch] = ACTIONS(267),
    [anon_sym_finally] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_else] = ACTIONS(267),
    [anon_sym_for] = ACTIONS(267),
    [anon_sym_AT] = ACTIONS(267),
    [anon_sym_open] = ACTIONS(267),
    [anon_sym_module] = ACTIONS(267),
    [anon_sym_static] = ACTIONS(267),
    [anon_sym_package] = ACTIONS(267),
    [anon_sym_import] = ACTIONS(267),
    [anon_sym_enum] = ACTIONS(267),
    [anon_sym_public] = ACTIONS(267),
    [anon_sym_protected] = ACTIONS(267),
    [anon_sym_private] = ACTIONS(267),
    [anon_sym_abstract] = ACTIONS(267),
    [anon_sym_strictfp] = ACTIONS(267),
    [anon_sym_native] = ACTIONS(267),
    [anon_sym_transient] = ACTIONS(267),
    [anon_sym_volatile] = ACTIONS(267),
    [anon_sym_sealed] = ACTIONS(267),
    [anon_sym_non_DASHsealed] = ACTIONS(265),
    [anon_sym_record] = ACTIONS(267),
    [anon_sym_ATinterface] = ACTIONS(265),
    [anon_sym_interface] = ACTIONS(267),
    [anon_sym_byte] = ACTIONS(267),
    [anon_sym_short] = ACTIONS(267),
    [anon_sym_int] = ACTIONS(267),
    [anon_sym_long] = ACTIONS(267),
    [anon_sym_char] = ACTIONS(267),
    [anon_sym_float] = ACTIONS(267),
    [anon_sym_double] = ACTIONS(267),
    [sym_boolean_type] = ACTIONS(267),
    [sym_void_type] = ACTIONS(267),
    [sym_this] = ACTIONS(267),
    [sym_super] = ACTIONS(267),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [99] = {
    [ts_builtin_sym_end] = ACTIONS(277),
    [sym_identifier] = ACTIONS(279),
    [sym_decimal_integer_literal] = ACTIONS(279),
    [sym_hex_integer_literal] = ACTIONS(279),
    [sym_octal_integer_literal] = ACTIONS(277),
    [sym_binary_integer_literal] = ACTIONS(277),
    [sym_decimal_floating_point_literal] = ACTIONS(277),
    [sym_hex_floating_point_literal] = ACTIONS(279),
    [sym_true] = ACTIONS(279),
    [sym_false] = ACTIONS(279),
    [sym_character_literal] = ACTIONS(277),
    [sym_string_literal] = ACTIONS(279),
    [sym_text_block] = ACTIONS(277),
    [sym_null_literal] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_PLUS] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_final] = ACTIONS(279),
    [anon_sym_BANG] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(277),
    [anon_sym_PLUS_PLUS] = ACTIONS(277),
    [anon_sym_DASH_DASH] = ACTIONS(277),
    [anon_sym_new] = ACTIONS(279),
    [anon_sym_class] = ACTIONS(279),
    [anon_sym_switch] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(277),
    [anon_sym_RBRACE] = ACTIONS(277),
    [anon_sym_case] = ACTIONS(279),
    [anon_sym_default] = ACTIONS(279),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_assert] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(279),
    [anon_sym_while] = ACTIONS(279),
    [anon_sym_break] = ACTIONS(279),
    [anon_sym_continue] = ACTIONS(279),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_yield] = ACTIONS(279),
    [anon_sym_synchronized] = ACTIONS(279),
    [anon_sym_throw] = ACTIONS(279),
    [anon_sym_try] = ACTIONS(279),
    [anon_sym_catch] = ACTIONS(279),
    [anon_sym_finally] = ACTIONS(279),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_else] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_open] = ACTIONS(279),
    [anon_sym_module] = ACTIONS(279),
    [anon_sym_static] = ACTIONS(279),
    [anon_sym_package] = ACTIONS(279),
    [anon_sym_import] = ACTIONS(279),
    [anon_sym_enum] = ACTIONS(279),
    [anon_sym_public] = ACTIONS(279),
    [anon_sym_protected] = ACTIONS(279),
    [anon_sym_private] = ACTIONS(279),
    [anon_sym_abstract] = ACTIONS(279),
    [anon_sym_strictfp] = ACTIONS(279),
    [anon_sym_native] = ACTIONS(279),
    [anon_sym_transient] = ACTIONS(279),
    [anon_sym_volatile] = ACTIONS(279),
    [anon_sym_sealed] = ACTIONS(279),
    [anon_sym_non_DASHsealed] = ACTIONS(277),
    [anon_sym_record] = ACTIONS(279),
    [anon_sym_ATinterface] = ACTIONS(277),
    [anon_sym_interface] = ACTIONS(279),
    [anon_sym_byte] = ACTIONS(279),
    [anon_sym_short] = ACTIONS(279),
    [anon_sym_int] = ACTIONS(279),
    [anon_sym_long] = ACTIONS(279),
    [anon_sym_char] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(279),
    [anon_sym_double] = ACTIONS(279),
    [sym_boolean_type] = ACTIONS(279),
    [sym_void_type] = ACTIONS(279),
    [sym_this] = ACTIONS(279),
    [sym_super] = ACTIONS(279),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [100] = {
    [ts_builtin_sym_end] = ACTIONS(356),
    [sym_identifier] = ACTIONS(358),
    [sym_decimal_integer_literal] = ACTIONS(358),
    [sym_hex_integer_literal] = ACTIONS(358),
    [sym_octal_integer_literal] = ACTIONS(356),
    [sym_binary_integer_literal] = ACTIONS(356),
    [sym_decimal_floating_point_literal] = ACTIONS(356),
    [sym_hex_floating_point_literal] = ACTIONS(358),
    [sym_true] = ACTIONS(358),
    [sym_false] = ACTIONS(358),
    [sym_character_literal] = ACTIONS(356),
    [sym_string_literal] = ACTIONS(358),
    [sym_text_block] = ACTIONS(356),
    [sym_null_literal] = ACTIONS(358),
    [anon_sym_LPAREN] = ACTIONS(356),
    [anon_sym_PLUS] = ACTIONS(358),
    [anon_sym_DASH] = ACTIONS(358),
    [anon_sym_final] = ACTIONS(358),
    [anon_sym_BANG] = ACTIONS(356),
    [anon_sym_TILDE] = ACTIONS(356),
    [anon_sym_PLUS_PLUS] = ACTIONS(356),
    [anon_sym_DASH_DASH] = ACTIONS(356),
    [anon_sym_new] = ACTIONS(358),
    [anon_sym_class] = ACTIONS(358),
    [anon_sym_switch] = ACTIONS(358),
    [anon_sym_LBRACE] = ACTIONS(356),
    [anon_sym_RBRACE] = ACTIONS(356),
    [anon_sym_case] = ACTIONS(358),
    [anon_sym_default] = ACTIONS(358),
    [anon_sym_SEMI] = ACTIONS(356),
    [anon_sym_assert] = ACTIONS(358),
    [anon_sym_do] = ACTIONS(358),
    [anon_sym_while] = ACTIONS(358),
    [anon_sym_break] = ACTIONS(358),
    [anon_sym_continue] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(358),
    [anon_sym_yield] = ACTIONS(358),
    [anon_sym_synchronized] = ACTIONS(358),
    [anon_sym_throw] = ACTIONS(358),
    [anon_sym_try] = ACTIONS(358),
    [anon_sym_catch] = ACTIONS(358),
    [anon_sym_finally] = ACTIONS(358),
    [anon_sym_if] = ACTIONS(358),
    [anon_sym_else] = ACTIONS(358),
    [anon_sym_for] = ACTIONS(358),
    [anon_sym_AT] = ACTIONS(358),
    [anon_sym_open] = ACTIONS(358),
    [anon_sym_module] = ACTIONS(358),
    [anon_sym_static] = ACTIONS(358),
    [anon_sym_package] = ACTIONS(358),
    [anon_sym_import] = ACTIONS(358),
    [anon_sym_enum] = ACTIONS(358),
    [anon_sym_public] = ACTIONS(358),
    [anon_sym_protected] = ACTIONS(358),
    [anon_sym_private] = ACTIONS(358),
    [anon_sym_abstract] = ACTIONS(358),
    [anon_sym_strictfp] = ACTIONS(358),
    [anon_sym_native] = ACTIONS(358),
    [anon_sym_transient] = ACTIONS(358),
    [anon_sym_volatile] = ACTIONS(358),
    [anon_sym_sealed] = ACTIONS(358),
    [anon_sym_non_DASHsealed] = ACTIONS(356),
    [anon_sym_record] = ACTIONS(358),
    [anon_sym_ATinterface] = ACTIONS(356),
    [anon_sym_interface] = ACTIONS(358),
    [anon_sym_byte] = ACTIONS(358),
    [anon_sym_short] = ACTIONS(358),
    [anon_sym_int] = ACTIONS(358),
    [anon_sym_long] = ACTIONS(358),
    [anon_sym_char] = ACTIONS(358),
    [anon_sym_float] = ACTIONS(358),
    [anon_sym_double] = ACTIONS(358),
    [sym_boolean_type] = ACTIONS(358),
    [sym_void_type] = ACTIONS(358),
    [sym_this] = ACTIONS(358),
    [sym_super] = ACTIONS(358),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [101] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(554),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym_array_initializer] = STATE(1063),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(360),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(362),
    [anon_sym_RBRACE] = ACTIONS(364),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [102] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(544),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(710),
    [sym_marker_annotation] = STATE(710),
    [sym_annotation] = STATE(710),
    [sym__element_value] = STATE(1083),
    [sym_element_value_array_initializer] = STATE(1083),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(342),
    [anon_sym_RBRACE] = ACTIONS(366),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [103] = {
    [ts_builtin_sym_end] = ACTIONS(368),
    [sym_identifier] = ACTIONS(370),
    [sym_decimal_integer_literal] = ACTIONS(370),
    [sym_hex_integer_literal] = ACTIONS(370),
    [sym_octal_integer_literal] = ACTIONS(368),
    [sym_binary_integer_literal] = ACTIONS(368),
    [sym_decimal_floating_point_literal] = ACTIONS(368),
    [sym_hex_floating_point_literal] = ACTIONS(370),
    [sym_true] = ACTIONS(370),
    [sym_false] = ACTIONS(370),
    [sym_character_literal] = ACTIONS(368),
    [sym_string_literal] = ACTIONS(370),
    [sym_text_block] = ACTIONS(368),
    [sym_null_literal] = ACTIONS(370),
    [anon_sym_LPAREN] = ACTIONS(368),
    [anon_sym_LT] = ACTIONS(368),
    [anon_sym_PLUS] = ACTIONS(370),
    [anon_sym_DASH] = ACTIONS(370),
    [anon_sym_final] = ACTIONS(370),
    [anon_sym_BANG] = ACTIONS(368),
    [anon_sym_TILDE] = ACTIONS(368),
    [anon_sym_PLUS_PLUS] = ACTIONS(368),
    [anon_sym_DASH_DASH] = ACTIONS(368),
    [anon_sym_new] = ACTIONS(370),
    [anon_sym_class] = ACTIONS(370),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_LBRACE] = ACTIONS(368),
    [anon_sym_RBRACE] = ACTIONS(368),
    [anon_sym_case] = ACTIONS(370),
    [anon_sym_default] = ACTIONS(370),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym_assert] = ACTIONS(370),
    [anon_sym_do] = ACTIONS(370),
    [anon_sym_while] = ACTIONS(370),
    [anon_sym_break] = ACTIONS(370),
    [anon_sym_continue] = ACTIONS(370),
    [anon_sym_return] = ACTIONS(370),
    [anon_sym_yield] = ACTIONS(370),
    [anon_sym_synchronized] = ACTIONS(370),
    [anon_sym_throw] = ACTIONS(370),
    [anon_sym_try] = ACTIONS(370),
    [anon_sym_if] = ACTIONS(370),
    [anon_sym_else] = ACTIONS(370),
    [anon_sym_for] = ACTIONS(370),
    [anon_sym_AT] = ACTIONS(370),
    [anon_sym_open] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(370),
    [anon_sym_static] = ACTIONS(370),
    [anon_sym_package] = ACTIONS(370),
    [anon_sym_import] = ACTIONS(370),
    [anon_sym_enum] = ACTIONS(370),
    [anon_sym_public] = ACTIONS(370),
    [anon_sym_protected] = ACTIONS(370),
    [anon_sym_private] = ACTIONS(370),
    [anon_sym_abstract] = ACTIONS(370),
    [anon_sym_strictfp] = ACTIONS(370),
    [anon_sym_native] = ACTIONS(370),
    [anon_sym_transient] = ACTIONS(370),
    [anon_sym_volatile] = ACTIONS(370),
    [anon_sym_sealed] = ACTIONS(370),
    [anon_sym_non_DASHsealed] = ACTIONS(368),
    [anon_sym_record] = ACTIONS(370),
    [anon_sym_ATinterface] = ACTIONS(368),
    [anon_sym_interface] = ACTIONS(370),
    [anon_sym_byte] = ACTIONS(370),
    [anon_sym_short] = ACTIONS(370),
    [anon_sym_int] = ACTIONS(370),
    [anon_sym_long] = ACTIONS(370),
    [anon_sym_char] = ACTIONS(370),
    [anon_sym_float] = ACTIONS(370),
    [anon_sym_double] = ACTIONS(370),
    [sym_boolean_type] = ACTIONS(370),
    [sym_void_type] = ACTIONS(370),
    [sym_this] = ACTIONS(370),
    [sym_super] = ACTIONS(370),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [104] = {
    [ts_builtin_sym_end] = ACTIONS(372),
    [sym_identifier] = ACTIONS(374),
    [sym_decimal_integer_literal] = ACTIONS(374),
    [sym_hex_integer_literal] = ACTIONS(374),
    [sym_octal_integer_literal] = ACTIONS(372),
    [sym_binary_integer_literal] = ACTIONS(372),
    [sym_decimal_floating_point_literal] = ACTIONS(372),
    [sym_hex_floating_point_literal] = ACTIONS(374),
    [sym_true] = ACTIONS(374),
    [sym_false] = ACTIONS(374),
    [sym_character_literal] = ACTIONS(372),
    [sym_string_literal] = ACTIONS(374),
    [sym_text_block] = ACTIONS(372),
    [sym_null_literal] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(372),
    [anon_sym_LT] = ACTIONS(372),
    [anon_sym_PLUS] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(374),
    [anon_sym_final] = ACTIONS(374),
    [anon_sym_BANG] = ACTIONS(372),
    [anon_sym_TILDE] = ACTIONS(372),
    [anon_sym_PLUS_PLUS] = ACTIONS(372),
    [anon_sym_DASH_DASH] = ACTIONS(372),
    [anon_sym_new] = ACTIONS(374),
    [anon_sym_class] = ACTIONS(374),
    [anon_sym_switch] = ACTIONS(374),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_RBRACE] = ACTIONS(372),
    [anon_sym_case] = ACTIONS(374),
    [anon_sym_default] = ACTIONS(374),
    [anon_sym_SEMI] = ACTIONS(372),
    [anon_sym_assert] = ACTIONS(374),
    [anon_sym_do] = ACTIONS(374),
    [anon_sym_while] = ACTIONS(374),
    [anon_sym_break] = ACTIONS(374),
    [anon_sym_continue] = ACTIONS(374),
    [anon_sym_return] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(374),
    [anon_sym_synchronized] = ACTIONS(374),
    [anon_sym_throw] = ACTIONS(374),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_else] = ACTIONS(374),
    [anon_sym_for] = ACTIONS(374),
    [anon_sym_AT] = ACTIONS(374),
    [anon_sym_open] = ACTIONS(374),
    [anon_sym_module] = ACTIONS(374),
    [anon_sym_static] = ACTIONS(374),
    [anon_sym_package] = ACTIONS(374),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_enum] = ACTIONS(374),
    [anon_sym_public] = ACTIONS(374),
    [anon_sym_protected] = ACTIONS(374),
    [anon_sym_private] = ACTIONS(374),
    [anon_sym_abstract] = ACTIONS(374),
    [anon_sym_strictfp] = ACTIONS(374),
    [anon_sym_native] = ACTIONS(374),
    [anon_sym_transient] = ACTIONS(374),
    [anon_sym_volatile] = ACTIONS(374),
    [anon_sym_sealed] = ACTIONS(374),
    [anon_sym_non_DASHsealed] = ACTIONS(372),
    [anon_sym_record] = ACTIONS(374),
    [anon_sym_ATinterface] = ACTIONS(372),
    [anon_sym_interface] = ACTIONS(374),
    [anon_sym_byte] = ACTIONS(374),
    [anon_sym_short] = ACTIONS(374),
    [anon_sym_int] = ACTIONS(374),
    [anon_sym_long] = ACTIONS(374),
    [anon_sym_char] = ACTIONS(374),
    [anon_sym_float] = ACTIONS(374),
    [anon_sym_double] = ACTIONS(374),
    [sym_boolean_type] = ACTIONS(374),
    [sym_void_type] = ACTIONS(374),
    [sym_this] = ACTIONS(374),
    [sym_super] = ACTIONS(374),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [105] = {
    [ts_builtin_sym_end] = ACTIONS(376),
    [sym_identifier] = ACTIONS(378),
    [sym_decimal_integer_literal] = ACTIONS(378),
    [sym_hex_integer_literal] = ACTIONS(378),
    [sym_octal_integer_literal] = ACTIONS(376),
    [sym_binary_integer_literal] = ACTIONS(376),
    [sym_decimal_floating_point_literal] = ACTIONS(376),
    [sym_hex_floating_point_literal] = ACTIONS(378),
    [sym_true] = ACTIONS(378),
    [sym_false] = ACTIONS(378),
    [sym_character_literal] = ACTIONS(376),
    [sym_string_literal] = ACTIONS(378),
    [sym_text_block] = ACTIONS(376),
    [sym_null_literal] = ACTIONS(378),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_PLUS] = ACTIONS(378),
    [anon_sym_DASH] = ACTIONS(378),
    [anon_sym_final] = ACTIONS(378),
    [anon_sym_BANG] = ACTIONS(376),
    [anon_sym_TILDE] = ACTIONS(376),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_new] = ACTIONS(378),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_switch] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(376),
    [anon_sym_case] = ACTIONS(378),
    [anon_sym_default] = ACTIONS(378),
    [anon_sym_SEMI] = ACTIONS(376),
    [anon_sym_assert] = ACTIONS(378),
    [anon_sym_do] = ACTIONS(378),
    [anon_sym_while] = ACTIONS(378),
    [anon_sym_break] = ACTIONS(378),
    [anon_sym_continue] = ACTIONS(378),
    [anon_sym_return] = ACTIONS(378),
    [anon_sym_yield] = ACTIONS(378),
    [anon_sym_synchronized] = ACTIONS(378),
    [anon_sym_throw] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(378),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_else] = ACTIONS(378),
    [anon_sym_for] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(378),
    [anon_sym_open] = ACTIONS(378),
    [anon_sym_module] = ACTIONS(378),
    [anon_sym_static] = ACTIONS(378),
    [anon_sym_package] = ACTIONS(378),
    [anon_sym_import] = ACTIONS(378),
    [anon_sym_enum] = ACTIONS(378),
    [anon_sym_public] = ACTIONS(378),
    [anon_sym_protected] = ACTIONS(378),
    [anon_sym_private] = ACTIONS(378),
    [anon_sym_abstract] = ACTIONS(378),
    [anon_sym_strictfp] = ACTIONS(378),
    [anon_sym_native] = ACTIONS(378),
    [anon_sym_transient] = ACTIONS(378),
    [anon_sym_volatile] = ACTIONS(378),
    [anon_sym_sealed] = ACTIONS(378),
    [anon_sym_non_DASHsealed] = ACTIONS(376),
    [anon_sym_record] = ACTIONS(378),
    [anon_sym_ATinterface] = ACTIONS(376),
    [anon_sym_interface] = ACTIONS(378),
    [anon_sym_byte] = ACTIONS(378),
    [anon_sym_short] = ACTIONS(378),
    [anon_sym_int] = ACTIONS(378),
    [anon_sym_long] = ACTIONS(378),
    [anon_sym_char] = ACTIONS(378),
    [anon_sym_float] = ACTIONS(378),
    [anon_sym_double] = ACTIONS(378),
    [sym_boolean_type] = ACTIONS(378),
    [sym_void_type] = ACTIONS(378),
    [sym_this] = ACTIONS(378),
    [sym_super] = ACTIONS(378),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [106] = {
    [ts_builtin_sym_end] = ACTIONS(380),
    [sym_identifier] = ACTIONS(382),
    [sym_decimal_integer_literal] = ACTIONS(382),
    [sym_hex_integer_literal] = ACTIONS(382),
    [sym_octal_integer_literal] = ACTIONS(380),
    [sym_binary_integer_literal] = ACTIONS(380),
    [sym_decimal_floating_point_literal] = ACTIONS(380),
    [sym_hex_floating_point_literal] = ACTIONS(382),
    [sym_true] = ACTIONS(382),
    [sym_false] = ACTIONS(382),
    [sym_character_literal] = ACTIONS(380),
    [sym_string_literal] = ACTIONS(382),
    [sym_text_block] = ACTIONS(380),
    [sym_null_literal] = ACTIONS(382),
    [anon_sym_LPAREN] = ACTIONS(380),
    [anon_sym_LT] = ACTIONS(380),
    [anon_sym_PLUS] = ACTIONS(382),
    [anon_sym_DASH] = ACTIONS(382),
    [anon_sym_final] = ACTIONS(382),
    [anon_sym_BANG] = ACTIONS(380),
    [anon_sym_TILDE] = ACTIONS(380),
    [anon_sym_PLUS_PLUS] = ACTIONS(380),
    [anon_sym_DASH_DASH] = ACTIONS(380),
    [anon_sym_new] = ACTIONS(382),
    [anon_sym_class] = ACTIONS(382),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_RBRACE] = ACTIONS(380),
    [anon_sym_case] = ACTIONS(382),
    [anon_sym_default] = ACTIONS(382),
    [anon_sym_SEMI] = ACTIONS(380),
    [anon_sym_assert] = ACTIONS(382),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(382),
    [anon_sym_break] = ACTIONS(382),
    [anon_sym_continue] = ACTIONS(382),
    [anon_sym_return] = ACTIONS(382),
    [anon_sym_yield] = ACTIONS(382),
    [anon_sym_synchronized] = ACTIONS(382),
    [anon_sym_throw] = ACTIONS(382),
    [anon_sym_try] = ACTIONS(382),
    [anon_sym_if] = ACTIONS(382),
    [anon_sym_else] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_AT] = ACTIONS(382),
    [anon_sym_open] = ACTIONS(382),
    [anon_sym_module] = ACTIONS(382),
    [anon_sym_static] = ACTIONS(382),
    [anon_sym_package] = ACTIONS(382),
    [anon_sym_import] = ACTIONS(382),
    [anon_sym_enum] = ACTIONS(382),
    [anon_sym_public] = ACTIONS(382),
    [anon_sym_protected] = ACTIONS(382),
    [anon_sym_private] = ACTIONS(382),
    [anon_sym_abstract] = ACTIONS(382),
    [anon_sym_strictfp] = ACTIONS(382),
    [anon_sym_native] = ACTIONS(382),
    [anon_sym_transient] = ACTIONS(382),
    [anon_sym_volatile] = ACTIONS(382),
    [anon_sym_sealed] = ACTIONS(382),
    [anon_sym_non_DASHsealed] = ACTIONS(380),
    [anon_sym_record] = ACTIONS(382),
    [anon_sym_ATinterface] = ACTIONS(380),
    [anon_sym_interface] = ACTIONS(382),
    [anon_sym_byte] = ACTIONS(382),
    [anon_sym_short] = ACTIONS(382),
    [anon_sym_int] = ACTIONS(382),
    [anon_sym_long] = ACTIONS(382),
    [anon_sym_char] = ACTIONS(382),
    [anon_sym_float] = ACTIONS(382),
    [anon_sym_double] = ACTIONS(382),
    [sym_boolean_type] = ACTIONS(382),
    [sym_void_type] = ACTIONS(382),
    [sym_this] = ACTIONS(382),
    [sym_super] = ACTIONS(382),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [107] = {
    [ts_builtin_sym_end] = ACTIONS(384),
    [sym_identifier] = ACTIONS(386),
    [sym_decimal_integer_literal] = ACTIONS(386),
    [sym_hex_integer_literal] = ACTIONS(386),
    [sym_octal_integer_literal] = ACTIONS(384),
    [sym_binary_integer_literal] = ACTIONS(384),
    [sym_decimal_floating_point_literal] = ACTIONS(384),
    [sym_hex_floating_point_literal] = ACTIONS(386),
    [sym_true] = ACTIONS(386),
    [sym_false] = ACTIONS(386),
    [sym_character_literal] = ACTIONS(384),
    [sym_string_literal] = ACTIONS(386),
    [sym_text_block] = ACTIONS(384),
    [sym_null_literal] = ACTIONS(386),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_LT] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_final] = ACTIONS(386),
    [anon_sym_BANG] = ACTIONS(384),
    [anon_sym_TILDE] = ACTIONS(384),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_new] = ACTIONS(386),
    [anon_sym_class] = ACTIONS(386),
    [anon_sym_switch] = ACTIONS(386),
    [anon_sym_LBRACE] = ACTIONS(384),
    [anon_sym_RBRACE] = ACTIONS(384),
    [anon_sym_case] = ACTIONS(386),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_SEMI] = ACTIONS(384),
    [anon_sym_assert] = ACTIONS(386),
    [anon_sym_do] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(386),
    [anon_sym_continue] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_yield] = ACTIONS(386),
    [anon_sym_synchronized] = ACTIONS(386),
    [anon_sym_throw] = ACTIONS(386),
    [anon_sym_try] = ACTIONS(386),
    [anon_sym_if] = ACTIONS(386),
    [anon_sym_else] = ACTIONS(386),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_AT] = ACTIONS(386),
    [anon_sym_open] = ACTIONS(386),
    [anon_sym_module] = ACTIONS(386),
    [anon_sym_static] = ACTIONS(386),
    [anon_sym_package] = ACTIONS(386),
    [anon_sym_import] = ACTIONS(386),
    [anon_sym_enum] = ACTIONS(386),
    [anon_sym_public] = ACTIONS(386),
    [anon_sym_protected] = ACTIONS(386),
    [anon_sym_private] = ACTIONS(386),
    [anon_sym_abstract] = ACTIONS(386),
    [anon_sym_strictfp] = ACTIONS(386),
    [anon_sym_native] = ACTIONS(386),
    [anon_sym_transient] = ACTIONS(386),
    [anon_sym_volatile] = ACTIONS(386),
    [anon_sym_sealed] = ACTIONS(386),
    [anon_sym_non_DASHsealed] = ACTIONS(384),
    [anon_sym_record] = ACTIONS(386),
    [anon_sym_ATinterface] = ACTIONS(384),
    [anon_sym_interface] = ACTIONS(386),
    [anon_sym_byte] = ACTIONS(386),
    [anon_sym_short] = ACTIONS(386),
    [anon_sym_int] = ACTIONS(386),
    [anon_sym_long] = ACTIONS(386),
    [anon_sym_char] = ACTIONS(386),
    [anon_sym_float] = ACTIONS(386),
    [anon_sym_double] = ACTIONS(386),
    [sym_boolean_type] = ACTIONS(386),
    [sym_void_type] = ACTIONS(386),
    [sym_this] = ACTIONS(386),
    [sym_super] = ACTIONS(386),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [108] = {
    [ts_builtin_sym_end] = ACTIONS(388),
    [sym_identifier] = ACTIONS(390),
    [sym_decimal_integer_literal] = ACTIONS(390),
    [sym_hex_integer_literal] = ACTIONS(390),
    [sym_octal_integer_literal] = ACTIONS(388),
    [sym_binary_integer_literal] = ACTIONS(388),
    [sym_decimal_floating_point_literal] = ACTIONS(388),
    [sym_hex_floating_point_literal] = ACTIONS(390),
    [sym_true] = ACTIONS(390),
    [sym_false] = ACTIONS(390),
    [sym_character_literal] = ACTIONS(388),
    [sym_string_literal] = ACTIONS(390),
    [sym_text_block] = ACTIONS(388),
    [sym_null_literal] = ACTIONS(390),
    [anon_sym_LPAREN] = ACTIONS(388),
    [anon_sym_LT] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(390),
    [anon_sym_DASH] = ACTIONS(390),
    [anon_sym_final] = ACTIONS(390),
    [anon_sym_BANG] = ACTIONS(388),
    [anon_sym_TILDE] = ACTIONS(388),
    [anon_sym_PLUS_PLUS] = ACTIONS(388),
    [anon_sym_DASH_DASH] = ACTIONS(388),
    [anon_sym_new] = ACTIONS(390),
    [anon_sym_class] = ACTIONS(390),
    [anon_sym_switch] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(388),
    [anon_sym_RBRACE] = ACTIONS(388),
    [anon_sym_case] = ACTIONS(390),
    [anon_sym_default] = ACTIONS(390),
    [anon_sym_SEMI] = ACTIONS(388),
    [anon_sym_assert] = ACTIONS(390),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_while] = ACTIONS(390),
    [anon_sym_break] = ACTIONS(390),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_return] = ACTIONS(390),
    [anon_sym_yield] = ACTIONS(390),
    [anon_sym_synchronized] = ACTIONS(390),
    [anon_sym_throw] = ACTIONS(390),
    [anon_sym_try] = ACTIONS(390),
    [anon_sym_if] = ACTIONS(390),
    [anon_sym_else] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(390),
    [anon_sym_AT] = ACTIONS(390),
    [anon_sym_open] = ACTIONS(390),
    [anon_sym_module] = ACTIONS(390),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_package] = ACTIONS(390),
    [anon_sym_import] = ACTIONS(390),
    [anon_sym_enum] = ACTIONS(390),
    [anon_sym_public] = ACTIONS(390),
    [anon_sym_protected] = ACTIONS(390),
    [anon_sym_private] = ACTIONS(390),
    [anon_sym_abstract] = ACTIONS(390),
    [anon_sym_strictfp] = ACTIONS(390),
    [anon_sym_native] = ACTIONS(390),
    [anon_sym_transient] = ACTIONS(390),
    [anon_sym_volatile] = ACTIONS(390),
    [anon_sym_sealed] = ACTIONS(390),
    [anon_sym_non_DASHsealed] = ACTIONS(388),
    [anon_sym_record] = ACTIONS(390),
    [anon_sym_ATinterface] = ACTIONS(388),
    [anon_sym_interface] = ACTIONS(390),
    [anon_sym_byte] = ACTIONS(390),
    [anon_sym_short] = ACTIONS(390),
    [anon_sym_int] = ACTIONS(390),
    [anon_sym_long] = ACTIONS(390),
    [anon_sym_char] = ACTIONS(390),
    [anon_sym_float] = ACTIONS(390),
    [anon_sym_double] = ACTIONS(390),
    [sym_boolean_type] = ACTIONS(390),
    [sym_void_type] = ACTIONS(390),
    [sym_this] = ACTIONS(390),
    [sym_super] = ACTIONS(390),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [109] = {
    [ts_builtin_sym_end] = ACTIONS(392),
    [sym_identifier] = ACTIONS(394),
    [sym_decimal_integer_literal] = ACTIONS(394),
    [sym_hex_integer_literal] = ACTIONS(394),
    [sym_octal_integer_literal] = ACTIONS(392),
    [sym_binary_integer_literal] = ACTIONS(392),
    [sym_decimal_floating_point_literal] = ACTIONS(392),
    [sym_hex_floating_point_literal] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_character_literal] = ACTIONS(392),
    [sym_string_literal] = ACTIONS(394),
    [sym_text_block] = ACTIONS(392),
    [sym_null_literal] = ACTIONS(394),
    [anon_sym_LPAREN] = ACTIONS(392),
    [anon_sym_LT] = ACTIONS(392),
    [anon_sym_PLUS] = ACTIONS(394),
    [anon_sym_DASH] = ACTIONS(394),
    [anon_sym_final] = ACTIONS(394),
    [anon_sym_BANG] = ACTIONS(392),
    [anon_sym_TILDE] = ACTIONS(392),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_new] = ACTIONS(394),
    [anon_sym_class] = ACTIONS(394),
    [anon_sym_switch] = ACTIONS(394),
    [anon_sym_LBRACE] = ACTIONS(392),
    [anon_sym_RBRACE] = ACTIONS(392),
    [anon_sym_case] = ACTIONS(394),
    [anon_sym_default] = ACTIONS(394),
    [anon_sym_SEMI] = ACTIONS(392),
    [anon_sym_assert] = ACTIONS(394),
    [anon_sym_do] = ACTIONS(394),
    [anon_sym_while] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(394),
    [anon_sym_continue] = ACTIONS(394),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_yield] = ACTIONS(394),
    [anon_sym_synchronized] = ACTIONS(394),
    [anon_sym_throw] = ACTIONS(394),
    [anon_sym_try] = ACTIONS(394),
    [anon_sym_if] = ACTIONS(394),
    [anon_sym_else] = ACTIONS(394),
    [anon_sym_for] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(394),
    [anon_sym_open] = ACTIONS(394),
    [anon_sym_module] = ACTIONS(394),
    [anon_sym_static] = ACTIONS(394),
    [anon_sym_package] = ACTIONS(394),
    [anon_sym_import] = ACTIONS(394),
    [anon_sym_enum] = ACTIONS(394),
    [anon_sym_public] = ACTIONS(394),
    [anon_sym_protected] = ACTIONS(394),
    [anon_sym_private] = ACTIONS(394),
    [anon_sym_abstract] = ACTIONS(394),
    [anon_sym_strictfp] = ACTIONS(394),
    [anon_sym_native] = ACTIONS(394),
    [anon_sym_transient] = ACTIONS(394),
    [anon_sym_volatile] = ACTIONS(394),
    [anon_sym_sealed] = ACTIONS(394),
    [anon_sym_non_DASHsealed] = ACTIONS(392),
    [anon_sym_record] = ACTIONS(394),
    [anon_sym_ATinterface] = ACTIONS(392),
    [anon_sym_interface] = ACTIONS(394),
    [anon_sym_byte] = ACTIONS(394),
    [anon_sym_short] = ACTIONS(394),
    [anon_sym_int] = ACTIONS(394),
    [anon_sym_long] = ACTIONS(394),
    [anon_sym_char] = ACTIONS(394),
    [anon_sym_float] = ACTIONS(394),
    [anon_sym_double] = ACTIONS(394),
    [sym_boolean_type] = ACTIONS(394),
    [sym_void_type] = ACTIONS(394),
    [sym_this] = ACTIONS(394),
    [sym_super] = ACTIONS(394),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [110] = {
    [ts_builtin_sym_end] = ACTIONS(396),
    [sym_identifier] = ACTIONS(398),
    [sym_decimal_integer_literal] = ACTIONS(398),
    [sym_hex_integer_literal] = ACTIONS(398),
    [sym_octal_integer_literal] = ACTIONS(396),
    [sym_binary_integer_literal] = ACTIONS(396),
    [sym_decimal_floating_point_literal] = ACTIONS(396),
    [sym_hex_floating_point_literal] = ACTIONS(398),
    [sym_true] = ACTIONS(398),
    [sym_false] = ACTIONS(398),
    [sym_character_literal] = ACTIONS(396),
    [sym_string_literal] = ACTIONS(398),
    [sym_text_block] = ACTIONS(396),
    [sym_null_literal] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(396),
    [anon_sym_PLUS] = ACTIONS(398),
    [anon_sym_DASH] = ACTIONS(398),
    [anon_sym_final] = ACTIONS(398),
    [anon_sym_BANG] = ACTIONS(396),
    [anon_sym_TILDE] = ACTIONS(396),
    [anon_sym_PLUS_PLUS] = ACTIONS(396),
    [anon_sym_DASH_DASH] = ACTIONS(396),
    [anon_sym_new] = ACTIONS(398),
    [anon_sym_class] = ACTIONS(398),
    [anon_sym_switch] = ACTIONS(398),
    [anon_sym_LBRACE] = ACTIONS(396),
    [anon_sym_RBRACE] = ACTIONS(396),
    [anon_sym_case] = ACTIONS(398),
    [anon_sym_default] = ACTIONS(398),
    [anon_sym_SEMI] = ACTIONS(396),
    [anon_sym_assert] = ACTIONS(398),
    [anon_sym_do] = ACTIONS(398),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_break] = ACTIONS(398),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_return] = ACTIONS(398),
    [anon_sym_yield] = ACTIONS(398),
    [anon_sym_synchronized] = ACTIONS(398),
    [anon_sym_throw] = ACTIONS(398),
    [anon_sym_try] = ACTIONS(398),
    [anon_sym_if] = ACTIONS(398),
    [anon_sym_else] = ACTIONS(398),
    [anon_sym_for] = ACTIONS(398),
    [anon_sym_AT] = ACTIONS(398),
    [anon_sym_open] = ACTIONS(398),
    [anon_sym_module] = ACTIONS(398),
    [anon_sym_static] = ACTIONS(398),
    [anon_sym_package] = ACTIONS(398),
    [anon_sym_import] = ACTIONS(398),
    [anon_sym_enum] = ACTIONS(398),
    [anon_sym_public] = ACTIONS(398),
    [anon_sym_protected] = ACTIONS(398),
    [anon_sym_private] = ACTIONS(398),
    [anon_sym_abstract] = ACTIONS(398),
    [anon_sym_strictfp] = ACTIONS(398),
    [anon_sym_native] = ACTIONS(398),
    [anon_sym_transient] = ACTIONS(398),
    [anon_sym_volatile] = ACTIONS(398),
    [anon_sym_sealed] = ACTIONS(398),
    [anon_sym_non_DASHsealed] = ACTIONS(396),
    [anon_sym_record] = ACTIONS(398),
    [anon_sym_ATinterface] = ACTIONS(396),
    [anon_sym_interface] = ACTIONS(398),
    [anon_sym_byte] = ACTIONS(398),
    [anon_sym_short] = ACTIONS(398),
    [anon_sym_int] = ACTIONS(398),
    [anon_sym_long] = ACTIONS(398),
    [anon_sym_char] = ACTIONS(398),
    [anon_sym_float] = ACTIONS(398),
    [anon_sym_double] = ACTIONS(398),
    [sym_boolean_type] = ACTIONS(398),
    [sym_void_type] = ACTIONS(398),
    [sym_this] = ACTIONS(398),
    [sym_super] = ACTIONS(398),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [111] = {
    [ts_builtin_sym_end] = ACTIONS(400),
    [sym_identifier] = ACTIONS(402),
    [sym_decimal_integer_literal] = ACTIONS(402),
    [sym_hex_integer_literal] = ACTIONS(402),
    [sym_octal_integer_literal] = ACTIONS(400),
    [sym_binary_integer_literal] = ACTIONS(400),
    [sym_decimal_floating_point_literal] = ACTIONS(400),
    [sym_hex_floating_point_literal] = ACTIONS(402),
    [sym_true] = ACTIONS(402),
    [sym_false] = ACTIONS(402),
    [sym_character_literal] = ACTIONS(400),
    [sym_string_literal] = ACTIONS(402),
    [sym_text_block] = ACTIONS(400),
    [sym_null_literal] = ACTIONS(402),
    [anon_sym_LPAREN] = ACTIONS(400),
    [anon_sym_LT] = ACTIONS(400),
    [anon_sym_PLUS] = ACTIONS(402),
    [anon_sym_DASH] = ACTIONS(402),
    [anon_sym_final] = ACTIONS(402),
    [anon_sym_BANG] = ACTIONS(400),
    [anon_sym_TILDE] = ACTIONS(400),
    [anon_sym_PLUS_PLUS] = ACTIONS(400),
    [anon_sym_DASH_DASH] = ACTIONS(400),
    [anon_sym_new] = ACTIONS(402),
    [anon_sym_class] = ACTIONS(402),
    [anon_sym_switch] = ACTIONS(402),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_RBRACE] = ACTIONS(400),
    [anon_sym_case] = ACTIONS(402),
    [anon_sym_default] = ACTIONS(402),
    [anon_sym_SEMI] = ACTIONS(400),
    [anon_sym_assert] = ACTIONS(402),
    [anon_sym_do] = ACTIONS(402),
    [anon_sym_while] = ACTIONS(402),
    [anon_sym_break] = ACTIONS(402),
    [anon_sym_continue] = ACTIONS(402),
    [anon_sym_return] = ACTIONS(402),
    [anon_sym_yield] = ACTIONS(402),
    [anon_sym_synchronized] = ACTIONS(402),
    [anon_sym_throw] = ACTIONS(402),
    [anon_sym_try] = ACTIONS(402),
    [anon_sym_if] = ACTIONS(402),
    [anon_sym_else] = ACTIONS(402),
    [anon_sym_for] = ACTIONS(402),
    [anon_sym_AT] = ACTIONS(402),
    [anon_sym_open] = ACTIONS(402),
    [anon_sym_module] = ACTIONS(402),
    [anon_sym_static] = ACTIONS(402),
    [anon_sym_package] = ACTIONS(402),
    [anon_sym_import] = ACTIONS(402),
    [anon_sym_enum] = ACTIONS(402),
    [anon_sym_public] = ACTIONS(402),
    [anon_sym_protected] = ACTIONS(402),
    [anon_sym_private] = ACTIONS(402),
    [anon_sym_abstract] = ACTIONS(402),
    [anon_sym_strictfp] = ACTIONS(402),
    [anon_sym_native] = ACTIONS(402),
    [anon_sym_transient] = ACTIONS(402),
    [anon_sym_volatile] = ACTIONS(402),
    [anon_sym_sealed] = ACTIONS(402),
    [anon_sym_non_DASHsealed] = ACTIONS(400),
    [anon_sym_record] = ACTIONS(402),
    [anon_sym_ATinterface] = ACTIONS(400),
    [anon_sym_interface] = ACTIONS(402),
    [anon_sym_byte] = ACTIONS(402),
    [anon_sym_short] = ACTIONS(402),
    [anon_sym_int] = ACTIONS(402),
    [anon_sym_long] = ACTIONS(402),
    [anon_sym_char] = ACTIONS(402),
    [anon_sym_float] = ACTIONS(402),
    [anon_sym_double] = ACTIONS(402),
    [sym_boolean_type] = ACTIONS(402),
    [sym_void_type] = ACTIONS(402),
    [sym_this] = ACTIONS(402),
    [sym_super] = ACTIONS(402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [112] = {
    [ts_builtin_sym_end] = ACTIONS(404),
    [sym_identifier] = ACTIONS(406),
    [sym_decimal_integer_literal] = ACTIONS(406),
    [sym_hex_integer_literal] = ACTIONS(406),
    [sym_octal_integer_literal] = ACTIONS(404),
    [sym_binary_integer_literal] = ACTIONS(404),
    [sym_decimal_floating_point_literal] = ACTIONS(404),
    [sym_hex_floating_point_literal] = ACTIONS(406),
    [sym_true] = ACTIONS(406),
    [sym_false] = ACTIONS(406),
    [sym_character_literal] = ACTIONS(404),
    [sym_string_literal] = ACTIONS(406),
    [sym_text_block] = ACTIONS(404),
    [sym_null_literal] = ACTIONS(406),
    [anon_sym_LPAREN] = ACTIONS(404),
    [anon_sym_LT] = ACTIONS(404),
    [anon_sym_PLUS] = ACTIONS(406),
    [anon_sym_DASH] = ACTIONS(406),
    [anon_sym_final] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(404),
    [anon_sym_TILDE] = ACTIONS(404),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_new] = ACTIONS(406),
    [anon_sym_class] = ACTIONS(406),
    [anon_sym_switch] = ACTIONS(406),
    [anon_sym_LBRACE] = ACTIONS(404),
    [anon_sym_RBRACE] = ACTIONS(404),
    [anon_sym_case] = ACTIONS(406),
    [anon_sym_default] = ACTIONS(406),
    [anon_sym_SEMI] = ACTIONS(404),
    [anon_sym_assert] = ACTIONS(406),
    [anon_sym_do] = ACTIONS(406),
    [anon_sym_while] = ACTIONS(406),
    [anon_sym_break] = ACTIONS(406),
    [anon_sym_continue] = ACTIONS(406),
    [anon_sym_return] = ACTIONS(406),
    [anon_sym_yield] = ACTIONS(406),
    [anon_sym_synchronized] = ACTIONS(406),
    [anon_sym_throw] = ACTIONS(406),
    [anon_sym_try] = ACTIONS(406),
    [anon_sym_if] = ACTIONS(406),
    [anon_sym_else] = ACTIONS(406),
    [anon_sym_for] = ACTIONS(406),
    [anon_sym_AT] = ACTIONS(406),
    [anon_sym_open] = ACTIONS(406),
    [anon_sym_module] = ACTIONS(406),
    [anon_sym_static] = ACTIONS(406),
    [anon_sym_package] = ACTIONS(406),
    [anon_sym_import] = ACTIONS(406),
    [anon_sym_enum] = ACTIONS(406),
    [anon_sym_public] = ACTIONS(406),
    [anon_sym_protected] = ACTIONS(406),
    [anon_sym_private] = ACTIONS(406),
    [anon_sym_abstract] = ACTIONS(406),
    [anon_sym_strictfp] = ACTIONS(406),
    [anon_sym_native] = ACTIONS(406),
    [anon_sym_transient] = ACTIONS(406),
    [anon_sym_volatile] = ACTIONS(406),
    [anon_sym_sealed] = ACTIONS(406),
    [anon_sym_non_DASHsealed] = ACTIONS(404),
    [anon_sym_record] = ACTIONS(406),
    [anon_sym_ATinterface] = ACTIONS(404),
    [anon_sym_interface] = ACTIONS(406),
    [anon_sym_byte] = ACTIONS(406),
    [anon_sym_short] = ACTIONS(406),
    [anon_sym_int] = ACTIONS(406),
    [anon_sym_long] = ACTIONS(406),
    [anon_sym_char] = ACTIONS(406),
    [anon_sym_float] = ACTIONS(406),
    [anon_sym_double] = ACTIONS(406),
    [sym_boolean_type] = ACTIONS(406),
    [sym_void_type] = ACTIONS(406),
    [sym_this] = ACTIONS(406),
    [sym_super] = ACTIONS(406),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [113] = {
    [ts_builtin_sym_end] = ACTIONS(408),
    [sym_identifier] = ACTIONS(410),
    [sym_decimal_integer_literal] = ACTIONS(410),
    [sym_hex_integer_literal] = ACTIONS(410),
    [sym_octal_integer_literal] = ACTIONS(408),
    [sym_binary_integer_literal] = ACTIONS(408),
    [sym_decimal_floating_point_literal] = ACTIONS(408),
    [sym_hex_floating_point_literal] = ACTIONS(410),
    [sym_true] = ACTIONS(410),
    [sym_false] = ACTIONS(410),
    [sym_character_literal] = ACTIONS(408),
    [sym_string_literal] = ACTIONS(410),
    [sym_text_block] = ACTIONS(408),
    [sym_null_literal] = ACTIONS(410),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_LT] = ACTIONS(408),
    [anon_sym_PLUS] = ACTIONS(410),
    [anon_sym_DASH] = ACTIONS(410),
    [anon_sym_final] = ACTIONS(410),
    [anon_sym_BANG] = ACTIONS(408),
    [anon_sym_TILDE] = ACTIONS(408),
    [anon_sym_PLUS_PLUS] = ACTIONS(408),
    [anon_sym_DASH_DASH] = ACTIONS(408),
    [anon_sym_new] = ACTIONS(410),
    [anon_sym_class] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(410),
    [anon_sym_LBRACE] = ACTIONS(408),
    [anon_sym_RBRACE] = ACTIONS(408),
    [anon_sym_case] = ACTIONS(410),
    [anon_sym_default] = ACTIONS(410),
    [anon_sym_SEMI] = ACTIONS(408),
    [anon_sym_assert] = ACTIONS(410),
    [anon_sym_do] = ACTIONS(410),
    [anon_sym_while] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(410),
    [anon_sym_continue] = ACTIONS(410),
    [anon_sym_return] = ACTIONS(410),
    [anon_sym_yield] = ACTIONS(410),
    [anon_sym_synchronized] = ACTIONS(410),
    [anon_sym_throw] = ACTIONS(410),
    [anon_sym_try] = ACTIONS(410),
    [anon_sym_if] = ACTIONS(410),
    [anon_sym_else] = ACTIONS(410),
    [anon_sym_for] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(410),
    [anon_sym_open] = ACTIONS(410),
    [anon_sym_module] = ACTIONS(410),
    [anon_sym_static] = ACTIONS(410),
    [anon_sym_package] = ACTIONS(410),
    [anon_sym_import] = ACTIONS(410),
    [anon_sym_enum] = ACTIONS(410),
    [anon_sym_public] = ACTIONS(410),
    [anon_sym_protected] = ACTIONS(410),
    [anon_sym_private] = ACTIONS(410),
    [anon_sym_abstract] = ACTIONS(410),
    [anon_sym_strictfp] = ACTIONS(410),
    [anon_sym_native] = ACTIONS(410),
    [anon_sym_transient] = ACTIONS(410),
    [anon_sym_volatile] = ACTIONS(410),
    [anon_sym_sealed] = ACTIONS(410),
    [anon_sym_non_DASHsealed] = ACTIONS(408),
    [anon_sym_record] = ACTIONS(410),
    [anon_sym_ATinterface] = ACTIONS(408),
    [anon_sym_interface] = ACTIONS(410),
    [anon_sym_byte] = ACTIONS(410),
    [anon_sym_short] = ACTIONS(410),
    [anon_sym_int] = ACTIONS(410),
    [anon_sym_long] = ACTIONS(410),
    [anon_sym_char] = ACTIONS(410),
    [anon_sym_float] = ACTIONS(410),
    [anon_sym_double] = ACTIONS(410),
    [sym_boolean_type] = ACTIONS(410),
    [sym_void_type] = ACTIONS(410),
    [sym_this] = ACTIONS(410),
    [sym_super] = ACTIONS(410),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [114] = {
    [ts_builtin_sym_end] = ACTIONS(412),
    [sym_identifier] = ACTIONS(414),
    [sym_decimal_integer_literal] = ACTIONS(414),
    [sym_hex_integer_literal] = ACTIONS(414),
    [sym_octal_integer_literal] = ACTIONS(412),
    [sym_binary_integer_literal] = ACTIONS(412),
    [sym_decimal_floating_point_literal] = ACTIONS(412),
    [sym_hex_floating_point_literal] = ACTIONS(414),
    [sym_true] = ACTIONS(414),
    [sym_false] = ACTIONS(414),
    [sym_character_literal] = ACTIONS(412),
    [sym_string_literal] = ACTIONS(414),
    [sym_text_block] = ACTIONS(412),
    [sym_null_literal] = ACTIONS(414),
    [anon_sym_LPAREN] = ACTIONS(412),
    [anon_sym_LT] = ACTIONS(412),
    [anon_sym_PLUS] = ACTIONS(414),
    [anon_sym_DASH] = ACTIONS(414),
    [anon_sym_final] = ACTIONS(414),
    [anon_sym_BANG] = ACTIONS(412),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(412),
    [anon_sym_DASH_DASH] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(414),
    [anon_sym_class] = ACTIONS(414),
    [anon_sym_switch] = ACTIONS(414),
    [anon_sym_LBRACE] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_case] = ACTIONS(414),
    [anon_sym_default] = ACTIONS(414),
    [anon_sym_SEMI] = ACTIONS(412),
    [anon_sym_assert] = ACTIONS(414),
    [anon_sym_do] = ACTIONS(414),
    [anon_sym_while] = ACTIONS(414),
    [anon_sym_break] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(414),
    [anon_sym_return] = ACTIONS(414),
    [anon_sym_yield] = ACTIONS(414),
    [anon_sym_synchronized] = ACTIONS(414),
    [anon_sym_throw] = ACTIONS(414),
    [anon_sym_try] = ACTIONS(414),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_else] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(414),
    [anon_sym_open] = ACTIONS(414),
    [anon_sym_module] = ACTIONS(414),
    [anon_sym_static] = ACTIONS(414),
    [anon_sym_package] = ACTIONS(414),
    [anon_sym_import] = ACTIONS(414),
    [anon_sym_enum] = ACTIONS(414),
    [anon_sym_public] = ACTIONS(414),
    [anon_sym_protected] = ACTIONS(414),
    [anon_sym_private] = ACTIONS(414),
    [anon_sym_abstract] = ACTIONS(414),
    [anon_sym_strictfp] = ACTIONS(414),
    [anon_sym_native] = ACTIONS(414),
    [anon_sym_transient] = ACTIONS(414),
    [anon_sym_volatile] = ACTIONS(414),
    [anon_sym_sealed] = ACTIONS(414),
    [anon_sym_non_DASHsealed] = ACTIONS(412),
    [anon_sym_record] = ACTIONS(414),
    [anon_sym_ATinterface] = ACTIONS(412),
    [anon_sym_interface] = ACTIONS(414),
    [anon_sym_byte] = ACTIONS(414),
    [anon_sym_short] = ACTIONS(414),
    [anon_sym_int] = ACTIONS(414),
    [anon_sym_long] = ACTIONS(414),
    [anon_sym_char] = ACTIONS(414),
    [anon_sym_float] = ACTIONS(414),
    [anon_sym_double] = ACTIONS(414),
    [sym_boolean_type] = ACTIONS(414),
    [sym_void_type] = ACTIONS(414),
    [sym_this] = ACTIONS(414),
    [sym_super] = ACTIONS(414),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [115] = {
    [ts_builtin_sym_end] = ACTIONS(416),
    [sym_identifier] = ACTIONS(418),
    [sym_decimal_integer_literal] = ACTIONS(418),
    [sym_hex_integer_literal] = ACTIONS(418),
    [sym_octal_integer_literal] = ACTIONS(416),
    [sym_binary_integer_literal] = ACTIONS(416),
    [sym_decimal_floating_point_literal] = ACTIONS(416),
    [sym_hex_floating_point_literal] = ACTIONS(418),
    [sym_true] = ACTIONS(418),
    [sym_false] = ACTIONS(418),
    [sym_character_literal] = ACTIONS(416),
    [sym_string_literal] = ACTIONS(418),
    [sym_text_block] = ACTIONS(416),
    [sym_null_literal] = ACTIONS(418),
    [anon_sym_LPAREN] = ACTIONS(416),
    [anon_sym_LT] = ACTIONS(416),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_final] = ACTIONS(418),
    [anon_sym_BANG] = ACTIONS(416),
    [anon_sym_TILDE] = ACTIONS(416),
    [anon_sym_PLUS_PLUS] = ACTIONS(416),
    [anon_sym_DASH_DASH] = ACTIONS(416),
    [anon_sym_new] = ACTIONS(418),
    [anon_sym_class] = ACTIONS(418),
    [anon_sym_switch] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(416),
    [anon_sym_RBRACE] = ACTIONS(416),
    [anon_sym_case] = ACTIONS(418),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_SEMI] = ACTIONS(416),
    [anon_sym_assert] = ACTIONS(418),
    [anon_sym_do] = ACTIONS(418),
    [anon_sym_while] = ACTIONS(418),
    [anon_sym_break] = ACTIONS(418),
    [anon_sym_continue] = ACTIONS(418),
    [anon_sym_return] = ACTIONS(418),
    [anon_sym_yield] = ACTIONS(418),
    [anon_sym_synchronized] = ACTIONS(418),
    [anon_sym_throw] = ACTIONS(418),
    [anon_sym_try] = ACTIONS(418),
    [anon_sym_if] = ACTIONS(418),
    [anon_sym_else] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(418),
    [anon_sym_AT] = ACTIONS(418),
    [anon_sym_open] = ACTIONS(418),
    [anon_sym_module] = ACTIONS(418),
    [anon_sym_static] = ACTIONS(418),
    [anon_sym_package] = ACTIONS(418),
    [anon_sym_import] = ACTIONS(418),
    [anon_sym_enum] = ACTIONS(418),
    [anon_sym_public] = ACTIONS(418),
    [anon_sym_protected] = ACTIONS(418),
    [anon_sym_private] = ACTIONS(418),
    [anon_sym_abstract] = ACTIONS(418),
    [anon_sym_strictfp] = ACTIONS(418),
    [anon_sym_native] = ACTIONS(418),
    [anon_sym_transient] = ACTIONS(418),
    [anon_sym_volatile] = ACTIONS(418),
    [anon_sym_sealed] = ACTIONS(418),
    [anon_sym_non_DASHsealed] = ACTIONS(416),
    [anon_sym_record] = ACTIONS(418),
    [anon_sym_ATinterface] = ACTIONS(416),
    [anon_sym_interface] = ACTIONS(418),
    [anon_sym_byte] = ACTIONS(418),
    [anon_sym_short] = ACTIONS(418),
    [anon_sym_int] = ACTIONS(418),
    [anon_sym_long] = ACTIONS(418),
    [anon_sym_char] = ACTIONS(418),
    [anon_sym_float] = ACTIONS(418),
    [anon_sym_double] = ACTIONS(418),
    [sym_boolean_type] = ACTIONS(418),
    [sym_void_type] = ACTIONS(418),
    [sym_this] = ACTIONS(418),
    [sym_super] = ACTIONS(418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [116] = {
    [ts_builtin_sym_end] = ACTIONS(420),
    [sym_identifier] = ACTIONS(422),
    [sym_decimal_integer_literal] = ACTIONS(422),
    [sym_hex_integer_literal] = ACTIONS(422),
    [sym_octal_integer_literal] = ACTIONS(420),
    [sym_binary_integer_literal] = ACTIONS(420),
    [sym_decimal_floating_point_literal] = ACTIONS(420),
    [sym_hex_floating_point_literal] = ACTIONS(422),
    [sym_true] = ACTIONS(422),
    [sym_false] = ACTIONS(422),
    [sym_character_literal] = ACTIONS(420),
    [sym_string_literal] = ACTIONS(422),
    [sym_text_block] = ACTIONS(420),
    [sym_null_literal] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(420),
    [anon_sym_LT] = ACTIONS(420),
    [anon_sym_PLUS] = ACTIONS(422),
    [anon_sym_DASH] = ACTIONS(422),
    [anon_sym_final] = ACTIONS(422),
    [anon_sym_BANG] = ACTIONS(420),
    [anon_sym_TILDE] = ACTIONS(420),
    [anon_sym_PLUS_PLUS] = ACTIONS(420),
    [anon_sym_DASH_DASH] = ACTIONS(420),
    [anon_sym_new] = ACTIONS(422),
    [anon_sym_class] = ACTIONS(422),
    [anon_sym_switch] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(420),
    [anon_sym_RBRACE] = ACTIONS(420),
    [anon_sym_case] = ACTIONS(422),
    [anon_sym_default] = ACTIONS(422),
    [anon_sym_SEMI] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_do] = ACTIONS(422),
    [anon_sym_while] = ACTIONS(422),
    [anon_sym_break] = ACTIONS(422),
    [anon_sym_continue] = ACTIONS(422),
    [anon_sym_return] = ACTIONS(422),
    [anon_sym_yield] = ACTIONS(422),
    [anon_sym_synchronized] = ACTIONS(422),
    [anon_sym_throw] = ACTIONS(422),
    [anon_sym_try] = ACTIONS(422),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_else] = ACTIONS(422),
    [anon_sym_for] = ACTIONS(422),
    [anon_sym_AT] = ACTIONS(422),
    [anon_sym_open] = ACTIONS(422),
    [anon_sym_module] = ACTIONS(422),
    [anon_sym_static] = ACTIONS(422),
    [anon_sym_package] = ACTIONS(422),
    [anon_sym_import] = ACTIONS(422),
    [anon_sym_enum] = ACTIONS(422),
    [anon_sym_public] = ACTIONS(422),
    [anon_sym_protected] = ACTIONS(422),
    [anon_sym_private] = ACTIONS(422),
    [anon_sym_abstract] = ACTIONS(422),
    [anon_sym_strictfp] = ACTIONS(422),
    [anon_sym_native] = ACTIONS(422),
    [anon_sym_transient] = ACTIONS(422),
    [anon_sym_volatile] = ACTIONS(422),
    [anon_sym_sealed] = ACTIONS(422),
    [anon_sym_non_DASHsealed] = ACTIONS(420),
    [anon_sym_record] = ACTIONS(422),
    [anon_sym_ATinterface] = ACTIONS(420),
    [anon_sym_interface] = ACTIONS(422),
    [anon_sym_byte] = ACTIONS(422),
    [anon_sym_short] = ACTIONS(422),
    [anon_sym_int] = ACTIONS(422),
    [anon_sym_long] = ACTIONS(422),
    [anon_sym_char] = ACTIONS(422),
    [anon_sym_float] = ACTIONS(422),
    [anon_sym_double] = ACTIONS(422),
    [sym_boolean_type] = ACTIONS(422),
    [sym_void_type] = ACTIONS(422),
    [sym_this] = ACTIONS(422),
    [sym_super] = ACTIONS(422),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [117] = {
    [ts_builtin_sym_end] = ACTIONS(424),
    [sym_identifier] = ACTIONS(426),
    [sym_decimal_integer_literal] = ACTIONS(426),
    [sym_hex_integer_literal] = ACTIONS(426),
    [sym_octal_integer_literal] = ACTIONS(424),
    [sym_binary_integer_literal] = ACTIONS(424),
    [sym_decimal_floating_point_literal] = ACTIONS(424),
    [sym_hex_floating_point_literal] = ACTIONS(426),
    [sym_true] = ACTIONS(426),
    [sym_false] = ACTIONS(426),
    [sym_character_literal] = ACTIONS(424),
    [sym_string_literal] = ACTIONS(426),
    [sym_text_block] = ACTIONS(424),
    [sym_null_literal] = ACTIONS(426),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_LT] = ACTIONS(424),
    [anon_sym_PLUS] = ACTIONS(426),
    [anon_sym_DASH] = ACTIONS(426),
    [anon_sym_final] = ACTIONS(426),
    [anon_sym_BANG] = ACTIONS(424),
    [anon_sym_TILDE] = ACTIONS(424),
    [anon_sym_PLUS_PLUS] = ACTIONS(424),
    [anon_sym_DASH_DASH] = ACTIONS(424),
    [anon_sym_new] = ACTIONS(426),
    [anon_sym_class] = ACTIONS(426),
    [anon_sym_switch] = ACTIONS(426),
    [anon_sym_LBRACE] = ACTIONS(424),
    [anon_sym_RBRACE] = ACTIONS(424),
    [anon_sym_case] = ACTIONS(426),
    [anon_sym_default] = ACTIONS(426),
    [anon_sym_SEMI] = ACTIONS(424),
    [anon_sym_assert] = ACTIONS(426),
    [anon_sym_do] = ACTIONS(426),
    [anon_sym_while] = ACTIONS(426),
    [anon_sym_break] = ACTIONS(426),
    [anon_sym_continue] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(426),
    [anon_sym_yield] = ACTIONS(426),
    [anon_sym_synchronized] = ACTIONS(426),
    [anon_sym_throw] = ACTIONS(426),
    [anon_sym_try] = ACTIONS(426),
    [anon_sym_if] = ACTIONS(426),
    [anon_sym_else] = ACTIONS(426),
    [anon_sym_for] = ACTIONS(426),
    [anon_sym_AT] = ACTIONS(426),
    [anon_sym_open] = ACTIONS(426),
    [anon_sym_module] = ACTIONS(426),
    [anon_sym_static] = ACTIONS(426),
    [anon_sym_package] = ACTIONS(426),
    [anon_sym_import] = ACTIONS(426),
    [anon_sym_enum] = ACTIONS(426),
    [anon_sym_public] = ACTIONS(426),
    [anon_sym_protected] = ACTIONS(426),
    [anon_sym_private] = ACTIONS(426),
    [anon_sym_abstract] = ACTIONS(426),
    [anon_sym_strictfp] = ACTIONS(426),
    [anon_sym_native] = ACTIONS(426),
    [anon_sym_transient] = ACTIONS(426),
    [anon_sym_volatile] = ACTIONS(426),
    [anon_sym_sealed] = ACTIONS(426),
    [anon_sym_non_DASHsealed] = ACTIONS(424),
    [anon_sym_record] = ACTIONS(426),
    [anon_sym_ATinterface] = ACTIONS(424),
    [anon_sym_interface] = ACTIONS(426),
    [anon_sym_byte] = ACTIONS(426),
    [anon_sym_short] = ACTIONS(426),
    [anon_sym_int] = ACTIONS(426),
    [anon_sym_long] = ACTIONS(426),
    [anon_sym_char] = ACTIONS(426),
    [anon_sym_float] = ACTIONS(426),
    [anon_sym_double] = ACTIONS(426),
    [sym_boolean_type] = ACTIONS(426),
    [sym_void_type] = ACTIONS(426),
    [sym_this] = ACTIONS(426),
    [sym_super] = ACTIONS(426),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [118] = {
    [ts_builtin_sym_end] = ACTIONS(428),
    [sym_identifier] = ACTIONS(430),
    [sym_decimal_integer_literal] = ACTIONS(430),
    [sym_hex_integer_literal] = ACTIONS(430),
    [sym_octal_integer_literal] = ACTIONS(428),
    [sym_binary_integer_literal] = ACTIONS(428),
    [sym_decimal_floating_point_literal] = ACTIONS(428),
    [sym_hex_floating_point_literal] = ACTIONS(430),
    [sym_true] = ACTIONS(430),
    [sym_false] = ACTIONS(430),
    [sym_character_literal] = ACTIONS(428),
    [sym_string_literal] = ACTIONS(430),
    [sym_text_block] = ACTIONS(428),
    [sym_null_literal] = ACTIONS(430),
    [anon_sym_LPAREN] = ACTIONS(428),
    [anon_sym_LT] = ACTIONS(428),
    [anon_sym_PLUS] = ACTIONS(430),
    [anon_sym_DASH] = ACTIONS(430),
    [anon_sym_final] = ACTIONS(430),
    [anon_sym_BANG] = ACTIONS(428),
    [anon_sym_TILDE] = ACTIONS(428),
    [anon_sym_PLUS_PLUS] = ACTIONS(428),
    [anon_sym_DASH_DASH] = ACTIONS(428),
    [anon_sym_new] = ACTIONS(430),
    [anon_sym_class] = ACTIONS(430),
    [anon_sym_switch] = ACTIONS(430),
    [anon_sym_LBRACE] = ACTIONS(428),
    [anon_sym_RBRACE] = ACTIONS(428),
    [anon_sym_case] = ACTIONS(430),
    [anon_sym_default] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(428),
    [anon_sym_assert] = ACTIONS(430),
    [anon_sym_do] = ACTIONS(430),
    [anon_sym_while] = ACTIONS(430),
    [anon_sym_break] = ACTIONS(430),
    [anon_sym_continue] = ACTIONS(430),
    [anon_sym_return] = ACTIONS(430),
    [anon_sym_yield] = ACTIONS(430),
    [anon_sym_synchronized] = ACTIONS(430),
    [anon_sym_throw] = ACTIONS(430),
    [anon_sym_try] = ACTIONS(430),
    [anon_sym_if] = ACTIONS(430),
    [anon_sym_else] = ACTIONS(430),
    [anon_sym_for] = ACTIONS(430),
    [anon_sym_AT] = ACTIONS(430),
    [anon_sym_open] = ACTIONS(430),
    [anon_sym_module] = ACTIONS(430),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_package] = ACTIONS(430),
    [anon_sym_import] = ACTIONS(430),
    [anon_sym_enum] = ACTIONS(430),
    [anon_sym_public] = ACTIONS(430),
    [anon_sym_protected] = ACTIONS(430),
    [anon_sym_private] = ACTIONS(430),
    [anon_sym_abstract] = ACTIONS(430),
    [anon_sym_strictfp] = ACTIONS(430),
    [anon_sym_native] = ACTIONS(430),
    [anon_sym_transient] = ACTIONS(430),
    [anon_sym_volatile] = ACTIONS(430),
    [anon_sym_sealed] = ACTIONS(430),
    [anon_sym_non_DASHsealed] = ACTIONS(428),
    [anon_sym_record] = ACTIONS(430),
    [anon_sym_ATinterface] = ACTIONS(428),
    [anon_sym_interface] = ACTIONS(430),
    [anon_sym_byte] = ACTIONS(430),
    [anon_sym_short] = ACTIONS(430),
    [anon_sym_int] = ACTIONS(430),
    [anon_sym_long] = ACTIONS(430),
    [anon_sym_char] = ACTIONS(430),
    [anon_sym_float] = ACTIONS(430),
    [anon_sym_double] = ACTIONS(430),
    [sym_boolean_type] = ACTIONS(430),
    [sym_void_type] = ACTIONS(430),
    [sym_this] = ACTIONS(430),
    [sym_super] = ACTIONS(430),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [119] = {
    [ts_builtin_sym_end] = ACTIONS(432),
    [sym_identifier] = ACTIONS(434),
    [sym_decimal_integer_literal] = ACTIONS(434),
    [sym_hex_integer_literal] = ACTIONS(434),
    [sym_octal_integer_literal] = ACTIONS(432),
    [sym_binary_integer_literal] = ACTIONS(432),
    [sym_decimal_floating_point_literal] = ACTIONS(432),
    [sym_hex_floating_point_literal] = ACTIONS(434),
    [sym_true] = ACTIONS(434),
    [sym_false] = ACTIONS(434),
    [sym_character_literal] = ACTIONS(432),
    [sym_string_literal] = ACTIONS(434),
    [sym_text_block] = ACTIONS(432),
    [sym_null_literal] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(432),
    [anon_sym_LT] = ACTIONS(432),
    [anon_sym_PLUS] = ACTIONS(434),
    [anon_sym_DASH] = ACTIONS(434),
    [anon_sym_final] = ACTIONS(434),
    [anon_sym_BANG] = ACTIONS(432),
    [anon_sym_TILDE] = ACTIONS(432),
    [anon_sym_PLUS_PLUS] = ACTIONS(432),
    [anon_sym_DASH_DASH] = ACTIONS(432),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_class] = ACTIONS(434),
    [anon_sym_switch] = ACTIONS(434),
    [anon_sym_LBRACE] = ACTIONS(432),
    [anon_sym_RBRACE] = ACTIONS(432),
    [anon_sym_case] = ACTIONS(434),
    [anon_sym_default] = ACTIONS(434),
    [anon_sym_SEMI] = ACTIONS(432),
    [anon_sym_assert] = ACTIONS(434),
    [anon_sym_do] = ACTIONS(434),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_break] = ACTIONS(434),
    [anon_sym_continue] = ACTIONS(434),
    [anon_sym_return] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(434),
    [anon_sym_synchronized] = ACTIONS(434),
    [anon_sym_throw] = ACTIONS(434),
    [anon_sym_try] = ACTIONS(434),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_else] = ACTIONS(434),
    [anon_sym_for] = ACTIONS(434),
    [anon_sym_AT] = ACTIONS(434),
    [anon_sym_open] = ACTIONS(434),
    [anon_sym_module] = ACTIONS(434),
    [anon_sym_static] = ACTIONS(434),
    [anon_sym_package] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(434),
    [anon_sym_enum] = ACTIONS(434),
    [anon_sym_public] = ACTIONS(434),
    [anon_sym_protected] = ACTIONS(434),
    [anon_sym_private] = ACTIONS(434),
    [anon_sym_abstract] = ACTIONS(434),
    [anon_sym_strictfp] = ACTIONS(434),
    [anon_sym_native] = ACTIONS(434),
    [anon_sym_transient] = ACTIONS(434),
    [anon_sym_volatile] = ACTIONS(434),
    [anon_sym_sealed] = ACTIONS(434),
    [anon_sym_non_DASHsealed] = ACTIONS(432),
    [anon_sym_record] = ACTIONS(434),
    [anon_sym_ATinterface] = ACTIONS(432),
    [anon_sym_interface] = ACTIONS(434),
    [anon_sym_byte] = ACTIONS(434),
    [anon_sym_short] = ACTIONS(434),
    [anon_sym_int] = ACTIONS(434),
    [anon_sym_long] = ACTIONS(434),
    [anon_sym_char] = ACTIONS(434),
    [anon_sym_float] = ACTIONS(434),
    [anon_sym_double] = ACTIONS(434),
    [sym_boolean_type] = ACTIONS(434),
    [sym_void_type] = ACTIONS(434),
    [sym_this] = ACTIONS(434),
    [sym_super] = ACTIONS(434),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [120] = {
    [ts_builtin_sym_end] = ACTIONS(436),
    [sym_identifier] = ACTIONS(438),
    [sym_decimal_integer_literal] = ACTIONS(438),
    [sym_hex_integer_literal] = ACTIONS(438),
    [sym_octal_integer_literal] = ACTIONS(436),
    [sym_binary_integer_literal] = ACTIONS(436),
    [sym_decimal_floating_point_literal] = ACTIONS(436),
    [sym_hex_floating_point_literal] = ACTIONS(438),
    [sym_true] = ACTIONS(438),
    [sym_false] = ACTIONS(438),
    [sym_character_literal] = ACTIONS(436),
    [sym_string_literal] = ACTIONS(438),
    [sym_text_block] = ACTIONS(436),
    [sym_null_literal] = ACTIONS(438),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_LT] = ACTIONS(436),
    [anon_sym_PLUS] = ACTIONS(438),
    [anon_sym_DASH] = ACTIONS(438),
    [anon_sym_final] = ACTIONS(438),
    [anon_sym_BANG] = ACTIONS(436),
    [anon_sym_TILDE] = ACTIONS(436),
    [anon_sym_PLUS_PLUS] = ACTIONS(436),
    [anon_sym_DASH_DASH] = ACTIONS(436),
    [anon_sym_new] = ACTIONS(438),
    [anon_sym_class] = ACTIONS(438),
    [anon_sym_switch] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(436),
    [anon_sym_RBRACE] = ACTIONS(436),
    [anon_sym_case] = ACTIONS(438),
    [anon_sym_default] = ACTIONS(438),
    [anon_sym_SEMI] = ACTIONS(436),
    [anon_sym_assert] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(438),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_break] = ACTIONS(438),
    [anon_sym_continue] = ACTIONS(438),
    [anon_sym_return] = ACTIONS(438),
    [anon_sym_yield] = ACTIONS(438),
    [anon_sym_synchronized] = ACTIONS(438),
    [anon_sym_throw] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(438),
    [anon_sym_if] = ACTIONS(438),
    [anon_sym_else] = ACTIONS(438),
    [anon_sym_for] = ACTIONS(438),
    [anon_sym_AT] = ACTIONS(438),
    [anon_sym_open] = ACTIONS(438),
    [anon_sym_module] = ACTIONS(438),
    [anon_sym_static] = ACTIONS(438),
    [anon_sym_package] = ACTIONS(438),
    [anon_sym_import] = ACTIONS(438),
    [anon_sym_enum] = ACTIONS(438),
    [anon_sym_public] = ACTIONS(438),
    [anon_sym_protected] = ACTIONS(438),
    [anon_sym_private] = ACTIONS(438),
    [anon_sym_abstract] = ACTIONS(438),
    [anon_sym_strictfp] = ACTIONS(438),
    [anon_sym_native] = ACTIONS(438),
    [anon_sym_transient] = ACTIONS(438),
    [anon_sym_volatile] = ACTIONS(438),
    [anon_sym_sealed] = ACTIONS(438),
    [anon_sym_non_DASHsealed] = ACTIONS(436),
    [anon_sym_record] = ACTIONS(438),
    [anon_sym_ATinterface] = ACTIONS(436),
    [anon_sym_interface] = ACTIONS(438),
    [anon_sym_byte] = ACTIONS(438),
    [anon_sym_short] = ACTIONS(438),
    [anon_sym_int] = ACTIONS(438),
    [anon_sym_long] = ACTIONS(438),
    [anon_sym_char] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [sym_boolean_type] = ACTIONS(438),
    [sym_void_type] = ACTIONS(438),
    [sym_this] = ACTIONS(438),
    [sym_super] = ACTIONS(438),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [121] = {
    [ts_builtin_sym_end] = ACTIONS(440),
    [sym_identifier] = ACTIONS(442),
    [sym_decimal_integer_literal] = ACTIONS(442),
    [sym_hex_integer_literal] = ACTIONS(442),
    [sym_octal_integer_literal] = ACTIONS(440),
    [sym_binary_integer_literal] = ACTIONS(440),
    [sym_decimal_floating_point_literal] = ACTIONS(440),
    [sym_hex_floating_point_literal] = ACTIONS(442),
    [sym_true] = ACTIONS(442),
    [sym_false] = ACTIONS(442),
    [sym_character_literal] = ACTIONS(440),
    [sym_string_literal] = ACTIONS(442),
    [sym_text_block] = ACTIONS(440),
    [sym_null_literal] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(440),
    [anon_sym_LT] = ACTIONS(440),
    [anon_sym_PLUS] = ACTIONS(442),
    [anon_sym_DASH] = ACTIONS(442),
    [anon_sym_final] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(440),
    [anon_sym_TILDE] = ACTIONS(440),
    [anon_sym_PLUS_PLUS] = ACTIONS(440),
    [anon_sym_DASH_DASH] = ACTIONS(440),
    [anon_sym_new] = ACTIONS(442),
    [anon_sym_class] = ACTIONS(442),
    [anon_sym_switch] = ACTIONS(442),
    [anon_sym_LBRACE] = ACTIONS(440),
    [anon_sym_RBRACE] = ACTIONS(440),
    [anon_sym_case] = ACTIONS(442),
    [anon_sym_default] = ACTIONS(442),
    [anon_sym_SEMI] = ACTIONS(440),
    [anon_sym_assert] = ACTIONS(442),
    [anon_sym_do] = ACTIONS(442),
    [anon_sym_while] = ACTIONS(442),
    [anon_sym_break] = ACTIONS(442),
    [anon_sym_continue] = ACTIONS(442),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_yield] = ACTIONS(442),
    [anon_sym_synchronized] = ACTIONS(442),
    [anon_sym_throw] = ACTIONS(442),
    [anon_sym_try] = ACTIONS(442),
    [anon_sym_if] = ACTIONS(442),
    [anon_sym_else] = ACTIONS(442),
    [anon_sym_for] = ACTIONS(442),
    [anon_sym_AT] = ACTIONS(442),
    [anon_sym_open] = ACTIONS(442),
    [anon_sym_module] = ACTIONS(442),
    [anon_sym_static] = ACTIONS(442),
    [anon_sym_package] = ACTIONS(442),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_enum] = ACTIONS(442),
    [anon_sym_public] = ACTIONS(442),
    [anon_sym_protected] = ACTIONS(442),
    [anon_sym_private] = ACTIONS(442),
    [anon_sym_abstract] = ACTIONS(442),
    [anon_sym_strictfp] = ACTIONS(442),
    [anon_sym_native] = ACTIONS(442),
    [anon_sym_transient] = ACTIONS(442),
    [anon_sym_volatile] = ACTIONS(442),
    [anon_sym_sealed] = ACTIONS(442),
    [anon_sym_non_DASHsealed] = ACTIONS(440),
    [anon_sym_record] = ACTIONS(442),
    [anon_sym_ATinterface] = ACTIONS(440),
    [anon_sym_interface] = ACTIONS(442),
    [anon_sym_byte] = ACTIONS(442),
    [anon_sym_short] = ACTIONS(442),
    [anon_sym_int] = ACTIONS(442),
    [anon_sym_long] = ACTIONS(442),
    [anon_sym_char] = ACTIONS(442),
    [anon_sym_float] = ACTIONS(442),
    [anon_sym_double] = ACTIONS(442),
    [sym_boolean_type] = ACTIONS(442),
    [sym_void_type] = ACTIONS(442),
    [sym_this] = ACTIONS(442),
    [sym_super] = ACTIONS(442),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [122] = {
    [ts_builtin_sym_end] = ACTIONS(444),
    [sym_identifier] = ACTIONS(446),
    [sym_decimal_integer_literal] = ACTIONS(446),
    [sym_hex_integer_literal] = ACTIONS(446),
    [sym_octal_integer_literal] = ACTIONS(444),
    [sym_binary_integer_literal] = ACTIONS(444),
    [sym_decimal_floating_point_literal] = ACTIONS(444),
    [sym_hex_floating_point_literal] = ACTIONS(446),
    [sym_true] = ACTIONS(446),
    [sym_false] = ACTIONS(446),
    [sym_character_literal] = ACTIONS(444),
    [sym_string_literal] = ACTIONS(446),
    [sym_text_block] = ACTIONS(444),
    [sym_null_literal] = ACTIONS(446),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_LT] = ACTIONS(444),
    [anon_sym_PLUS] = ACTIONS(446),
    [anon_sym_DASH] = ACTIONS(446),
    [anon_sym_final] = ACTIONS(446),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_PLUS_PLUS] = ACTIONS(444),
    [anon_sym_DASH_DASH] = ACTIONS(444),
    [anon_sym_new] = ACTIONS(446),
    [anon_sym_class] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(446),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_case] = ACTIONS(446),
    [anon_sym_default] = ACTIONS(446),
    [anon_sym_SEMI] = ACTIONS(444),
    [anon_sym_assert] = ACTIONS(446),
    [anon_sym_do] = ACTIONS(446),
    [anon_sym_while] = ACTIONS(446),
    [anon_sym_break] = ACTIONS(446),
    [anon_sym_continue] = ACTIONS(446),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_yield] = ACTIONS(446),
    [anon_sym_synchronized] = ACTIONS(446),
    [anon_sym_throw] = ACTIONS(446),
    [anon_sym_try] = ACTIONS(446),
    [anon_sym_if] = ACTIONS(446),
    [anon_sym_else] = ACTIONS(446),
    [anon_sym_for] = ACTIONS(446),
    [anon_sym_AT] = ACTIONS(446),
    [anon_sym_open] = ACTIONS(446),
    [anon_sym_module] = ACTIONS(446),
    [anon_sym_static] = ACTIONS(446),
    [anon_sym_package] = ACTIONS(446),
    [anon_sym_import] = ACTIONS(446),
    [anon_sym_enum] = ACTIONS(446),
    [anon_sym_public] = ACTIONS(446),
    [anon_sym_protected] = ACTIONS(446),
    [anon_sym_private] = ACTIONS(446),
    [anon_sym_abstract] = ACTIONS(446),
    [anon_sym_strictfp] = ACTIONS(446),
    [anon_sym_native] = ACTIONS(446),
    [anon_sym_transient] = ACTIONS(446),
    [anon_sym_volatile] = ACTIONS(446),
    [anon_sym_sealed] = ACTIONS(446),
    [anon_sym_non_DASHsealed] = ACTIONS(444),
    [anon_sym_record] = ACTIONS(446),
    [anon_sym_ATinterface] = ACTIONS(444),
    [anon_sym_interface] = ACTIONS(446),
    [anon_sym_byte] = ACTIONS(446),
    [anon_sym_short] = ACTIONS(446),
    [anon_sym_int] = ACTIONS(446),
    [anon_sym_long] = ACTIONS(446),
    [anon_sym_char] = ACTIONS(446),
    [anon_sym_float] = ACTIONS(446),
    [anon_sym_double] = ACTIONS(446),
    [sym_boolean_type] = ACTIONS(446),
    [sym_void_type] = ACTIONS(446),
    [sym_this] = ACTIONS(446),
    [sym_super] = ACTIONS(446),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [123] = {
    [ts_builtin_sym_end] = ACTIONS(448),
    [sym_identifier] = ACTIONS(450),
    [sym_decimal_integer_literal] = ACTIONS(450),
    [sym_hex_integer_literal] = ACTIONS(450),
    [sym_octal_integer_literal] = ACTIONS(448),
    [sym_binary_integer_literal] = ACTIONS(448),
    [sym_decimal_floating_point_literal] = ACTIONS(448),
    [sym_hex_floating_point_literal] = ACTIONS(450),
    [sym_true] = ACTIONS(450),
    [sym_false] = ACTIONS(450),
    [sym_character_literal] = ACTIONS(448),
    [sym_string_literal] = ACTIONS(450),
    [sym_text_block] = ACTIONS(448),
    [sym_null_literal] = ACTIONS(450),
    [anon_sym_LPAREN] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(448),
    [anon_sym_PLUS] = ACTIONS(450),
    [anon_sym_DASH] = ACTIONS(450),
    [anon_sym_final] = ACTIONS(450),
    [anon_sym_BANG] = ACTIONS(448),
    [anon_sym_TILDE] = ACTIONS(448),
    [anon_sym_PLUS_PLUS] = ACTIONS(448),
    [anon_sym_DASH_DASH] = ACTIONS(448),
    [anon_sym_new] = ACTIONS(450),
    [anon_sym_class] = ACTIONS(450),
    [anon_sym_switch] = ACTIONS(450),
    [anon_sym_LBRACE] = ACTIONS(448),
    [anon_sym_RBRACE] = ACTIONS(448),
    [anon_sym_case] = ACTIONS(450),
    [anon_sym_default] = ACTIONS(450),
    [anon_sym_SEMI] = ACTIONS(448),
    [anon_sym_assert] = ACTIONS(450),
    [anon_sym_do] = ACTIONS(450),
    [anon_sym_while] = ACTIONS(450),
    [anon_sym_break] = ACTIONS(450),
    [anon_sym_continue] = ACTIONS(450),
    [anon_sym_return] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_synchronized] = ACTIONS(450),
    [anon_sym_throw] = ACTIONS(450),
    [anon_sym_try] = ACTIONS(450),
    [anon_sym_if] = ACTIONS(450),
    [anon_sym_else] = ACTIONS(450),
    [anon_sym_for] = ACTIONS(450),
    [anon_sym_AT] = ACTIONS(450),
    [anon_sym_open] = ACTIONS(450),
    [anon_sym_module] = ACTIONS(450),
    [anon_sym_static] = ACTIONS(450),
    [anon_sym_package] = ACTIONS(450),
    [anon_sym_import] = ACTIONS(450),
    [anon_sym_enum] = ACTIONS(450),
    [anon_sym_public] = ACTIONS(450),
    [anon_sym_protected] = ACTIONS(450),
    [anon_sym_private] = ACTIONS(450),
    [anon_sym_abstract] = ACTIONS(450),
    [anon_sym_strictfp] = ACTIONS(450),
    [anon_sym_native] = ACTIONS(450),
    [anon_sym_transient] = ACTIONS(450),
    [anon_sym_volatile] = ACTIONS(450),
    [anon_sym_sealed] = ACTIONS(450),
    [anon_sym_non_DASHsealed] = ACTIONS(448),
    [anon_sym_record] = ACTIONS(450),
    [anon_sym_ATinterface] = ACTIONS(448),
    [anon_sym_interface] = ACTIONS(450),
    [anon_sym_byte] = ACTIONS(450),
    [anon_sym_short] = ACTIONS(450),
    [anon_sym_int] = ACTIONS(450),
    [anon_sym_long] = ACTIONS(450),
    [anon_sym_char] = ACTIONS(450),
    [anon_sym_float] = ACTIONS(450),
    [anon_sym_double] = ACTIONS(450),
    [sym_boolean_type] = ACTIONS(450),
    [sym_void_type] = ACTIONS(450),
    [sym_this] = ACTIONS(450),
    [sym_super] = ACTIONS(450),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [124] = {
    [ts_builtin_sym_end] = ACTIONS(452),
    [sym_identifier] = ACTIONS(454),
    [sym_decimal_integer_literal] = ACTIONS(454),
    [sym_hex_integer_literal] = ACTIONS(454),
    [sym_octal_integer_literal] = ACTIONS(452),
    [sym_binary_integer_literal] = ACTIONS(452),
    [sym_decimal_floating_point_literal] = ACTIONS(452),
    [sym_hex_floating_point_literal] = ACTIONS(454),
    [sym_true] = ACTIONS(454),
    [sym_false] = ACTIONS(454),
    [sym_character_literal] = ACTIONS(452),
    [sym_string_literal] = ACTIONS(454),
    [sym_text_block] = ACTIONS(452),
    [sym_null_literal] = ACTIONS(454),
    [anon_sym_LPAREN] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(452),
    [anon_sym_PLUS] = ACTIONS(454),
    [anon_sym_DASH] = ACTIONS(454),
    [anon_sym_final] = ACTIONS(454),
    [anon_sym_BANG] = ACTIONS(452),
    [anon_sym_TILDE] = ACTIONS(452),
    [anon_sym_PLUS_PLUS] = ACTIONS(452),
    [anon_sym_DASH_DASH] = ACTIONS(452),
    [anon_sym_new] = ACTIONS(454),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_switch] = ACTIONS(454),
    [anon_sym_LBRACE] = ACTIONS(452),
    [anon_sym_RBRACE] = ACTIONS(452),
    [anon_sym_case] = ACTIONS(454),
    [anon_sym_default] = ACTIONS(454),
    [anon_sym_SEMI] = ACTIONS(452),
    [anon_sym_assert] = ACTIONS(454),
    [anon_sym_do] = ACTIONS(454),
    [anon_sym_while] = ACTIONS(454),
    [anon_sym_break] = ACTIONS(454),
    [anon_sym_continue] = ACTIONS(454),
    [anon_sym_return] = ACTIONS(454),
    [anon_sym_yield] = ACTIONS(454),
    [anon_sym_synchronized] = ACTIONS(454),
    [anon_sym_throw] = ACTIONS(454),
    [anon_sym_try] = ACTIONS(454),
    [anon_sym_if] = ACTIONS(454),
    [anon_sym_else] = ACTIONS(454),
    [anon_sym_for] = ACTIONS(454),
    [anon_sym_AT] = ACTIONS(454),
    [anon_sym_open] = ACTIONS(454),
    [anon_sym_module] = ACTIONS(454),
    [anon_sym_static] = ACTIONS(454),
    [anon_sym_package] = ACTIONS(454),
    [anon_sym_import] = ACTIONS(454),
    [anon_sym_enum] = ACTIONS(454),
    [anon_sym_public] = ACTIONS(454),
    [anon_sym_protected] = ACTIONS(454),
    [anon_sym_private] = ACTIONS(454),
    [anon_sym_abstract] = ACTIONS(454),
    [anon_sym_strictfp] = ACTIONS(454),
    [anon_sym_native] = ACTIONS(454),
    [anon_sym_transient] = ACTIONS(454),
    [anon_sym_volatile] = ACTIONS(454),
    [anon_sym_sealed] = ACTIONS(454),
    [anon_sym_non_DASHsealed] = ACTIONS(452),
    [anon_sym_record] = ACTIONS(454),
    [anon_sym_ATinterface] = ACTIONS(452),
    [anon_sym_interface] = ACTIONS(454),
    [anon_sym_byte] = ACTIONS(454),
    [anon_sym_short] = ACTIONS(454),
    [anon_sym_int] = ACTIONS(454),
    [anon_sym_long] = ACTIONS(454),
    [anon_sym_char] = ACTIONS(454),
    [anon_sym_float] = ACTIONS(454),
    [anon_sym_double] = ACTIONS(454),
    [sym_boolean_type] = ACTIONS(454),
    [sym_void_type] = ACTIONS(454),
    [sym_this] = ACTIONS(454),
    [sym_super] = ACTIONS(454),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [125] = {
    [ts_builtin_sym_end] = ACTIONS(456),
    [sym_identifier] = ACTIONS(458),
    [sym_decimal_integer_literal] = ACTIONS(458),
    [sym_hex_integer_literal] = ACTIONS(458),
    [sym_octal_integer_literal] = ACTIONS(456),
    [sym_binary_integer_literal] = ACTIONS(456),
    [sym_decimal_floating_point_literal] = ACTIONS(456),
    [sym_hex_floating_point_literal] = ACTIONS(458),
    [sym_true] = ACTIONS(458),
    [sym_false] = ACTIONS(458),
    [sym_character_literal] = ACTIONS(456),
    [sym_string_literal] = ACTIONS(458),
    [sym_text_block] = ACTIONS(456),
    [sym_null_literal] = ACTIONS(458),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_LT] = ACTIONS(456),
    [anon_sym_PLUS] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(458),
    [anon_sym_final] = ACTIONS(458),
    [anon_sym_BANG] = ACTIONS(456),
    [anon_sym_TILDE] = ACTIONS(456),
    [anon_sym_PLUS_PLUS] = ACTIONS(456),
    [anon_sym_DASH_DASH] = ACTIONS(456),
    [anon_sym_new] = ACTIONS(458),
    [anon_sym_class] = ACTIONS(458),
    [anon_sym_switch] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(456),
    [anon_sym_RBRACE] = ACTIONS(456),
    [anon_sym_case] = ACTIONS(458),
    [anon_sym_default] = ACTIONS(458),
    [anon_sym_SEMI] = ACTIONS(456),
    [anon_sym_assert] = ACTIONS(458),
    [anon_sym_do] = ACTIONS(458),
    [anon_sym_while] = ACTIONS(458),
    [anon_sym_break] = ACTIONS(458),
    [anon_sym_continue] = ACTIONS(458),
    [anon_sym_return] = ACTIONS(458),
    [anon_sym_yield] = ACTIONS(458),
    [anon_sym_synchronized] = ACTIONS(458),
    [anon_sym_throw] = ACTIONS(458),
    [anon_sym_try] = ACTIONS(458),
    [anon_sym_if] = ACTIONS(458),
    [anon_sym_else] = ACTIONS(458),
    [anon_sym_for] = ACTIONS(458),
    [anon_sym_AT] = ACTIONS(458),
    [anon_sym_open] = ACTIONS(458),
    [anon_sym_module] = ACTIONS(458),
    [anon_sym_static] = ACTIONS(458),
    [anon_sym_package] = ACTIONS(458),
    [anon_sym_import] = ACTIONS(458),
    [anon_sym_enum] = ACTIONS(458),
    [anon_sym_public] = ACTIONS(458),
    [anon_sym_protected] = ACTIONS(458),
    [anon_sym_private] = ACTIONS(458),
    [anon_sym_abstract] = ACTIONS(458),
    [anon_sym_strictfp] = ACTIONS(458),
    [anon_sym_native] = ACTIONS(458),
    [anon_sym_transient] = ACTIONS(458),
    [anon_sym_volatile] = ACTIONS(458),
    [anon_sym_sealed] = ACTIONS(458),
    [anon_sym_non_DASHsealed] = ACTIONS(456),
    [anon_sym_record] = ACTIONS(458),
    [anon_sym_ATinterface] = ACTIONS(456),
    [anon_sym_interface] = ACTIONS(458),
    [anon_sym_byte] = ACTIONS(458),
    [anon_sym_short] = ACTIONS(458),
    [anon_sym_int] = ACTIONS(458),
    [anon_sym_long] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_float] = ACTIONS(458),
    [anon_sym_double] = ACTIONS(458),
    [sym_boolean_type] = ACTIONS(458),
    [sym_void_type] = ACTIONS(458),
    [sym_this] = ACTIONS(458),
    [sym_super] = ACTIONS(458),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [126] = {
    [ts_builtin_sym_end] = ACTIONS(460),
    [sym_identifier] = ACTIONS(462),
    [sym_decimal_integer_literal] = ACTIONS(462),
    [sym_hex_integer_literal] = ACTIONS(462),
    [sym_octal_integer_literal] = ACTIONS(460),
    [sym_binary_integer_literal] = ACTIONS(460),
    [sym_decimal_floating_point_literal] = ACTIONS(460),
    [sym_hex_floating_point_literal] = ACTIONS(462),
    [sym_true] = ACTIONS(462),
    [sym_false] = ACTIONS(462),
    [sym_character_literal] = ACTIONS(460),
    [sym_string_literal] = ACTIONS(462),
    [sym_text_block] = ACTIONS(460),
    [sym_null_literal] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(460),
    [anon_sym_LT] = ACTIONS(460),
    [anon_sym_PLUS] = ACTIONS(462),
    [anon_sym_DASH] = ACTIONS(462),
    [anon_sym_final] = ACTIONS(462),
    [anon_sym_BANG] = ACTIONS(460),
    [anon_sym_TILDE] = ACTIONS(460),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_new] = ACTIONS(462),
    [anon_sym_class] = ACTIONS(462),
    [anon_sym_switch] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(460),
    [anon_sym_RBRACE] = ACTIONS(460),
    [anon_sym_case] = ACTIONS(462),
    [anon_sym_default] = ACTIONS(462),
    [anon_sym_SEMI] = ACTIONS(460),
    [anon_sym_assert] = ACTIONS(462),
    [anon_sym_do] = ACTIONS(462),
    [anon_sym_while] = ACTIONS(462),
    [anon_sym_break] = ACTIONS(462),
    [anon_sym_continue] = ACTIONS(462),
    [anon_sym_return] = ACTIONS(462),
    [anon_sym_yield] = ACTIONS(462),
    [anon_sym_synchronized] = ACTIONS(462),
    [anon_sym_throw] = ACTIONS(462),
    [anon_sym_try] = ACTIONS(462),
    [anon_sym_if] = ACTIONS(462),
    [anon_sym_else] = ACTIONS(462),
    [anon_sym_for] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(462),
    [anon_sym_open] = ACTIONS(462),
    [anon_sym_module] = ACTIONS(462),
    [anon_sym_static] = ACTIONS(462),
    [anon_sym_package] = ACTIONS(462),
    [anon_sym_import] = ACTIONS(462),
    [anon_sym_enum] = ACTIONS(462),
    [anon_sym_public] = ACTIONS(462),
    [anon_sym_protected] = ACTIONS(462),
    [anon_sym_private] = ACTIONS(462),
    [anon_sym_abstract] = ACTIONS(462),
    [anon_sym_strictfp] = ACTIONS(462),
    [anon_sym_native] = ACTIONS(462),
    [anon_sym_transient] = ACTIONS(462),
    [anon_sym_volatile] = ACTIONS(462),
    [anon_sym_sealed] = ACTIONS(462),
    [anon_sym_non_DASHsealed] = ACTIONS(460),
    [anon_sym_record] = ACTIONS(462),
    [anon_sym_ATinterface] = ACTIONS(460),
    [anon_sym_interface] = ACTIONS(462),
    [anon_sym_byte] = ACTIONS(462),
    [anon_sym_short] = ACTIONS(462),
    [anon_sym_int] = ACTIONS(462),
    [anon_sym_long] = ACTIONS(462),
    [anon_sym_char] = ACTIONS(462),
    [anon_sym_float] = ACTIONS(462),
    [anon_sym_double] = ACTIONS(462),
    [sym_boolean_type] = ACTIONS(462),
    [sym_void_type] = ACTIONS(462),
    [sym_this] = ACTIONS(462),
    [sym_super] = ACTIONS(462),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [127] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(608),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(710),
    [sym_marker_annotation] = STATE(710),
    [sym_annotation] = STATE(710),
    [sym__element_value] = STATE(1170),
    [sym_element_value_array_initializer] = STATE(1170),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [128] = {
    [ts_builtin_sym_end] = ACTIONS(464),
    [sym_identifier] = ACTIONS(466),
    [sym_decimal_integer_literal] = ACTIONS(466),
    [sym_hex_integer_literal] = ACTIONS(466),
    [sym_octal_integer_literal] = ACTIONS(464),
    [sym_binary_integer_literal] = ACTIONS(464),
    [sym_decimal_floating_point_literal] = ACTIONS(464),
    [sym_hex_floating_point_literal] = ACTIONS(466),
    [sym_true] = ACTIONS(466),
    [sym_false] = ACTIONS(466),
    [sym_character_literal] = ACTIONS(464),
    [sym_string_literal] = ACTIONS(466),
    [sym_text_block] = ACTIONS(464),
    [sym_null_literal] = ACTIONS(466),
    [anon_sym_LPAREN] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(464),
    [anon_sym_PLUS] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(466),
    [anon_sym_final] = ACTIONS(466),
    [anon_sym_BANG] = ACTIONS(464),
    [anon_sym_TILDE] = ACTIONS(464),
    [anon_sym_PLUS_PLUS] = ACTIONS(464),
    [anon_sym_DASH_DASH] = ACTIONS(464),
    [anon_sym_new] = ACTIONS(466),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_switch] = ACTIONS(466),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_RBRACE] = ACTIONS(464),
    [anon_sym_case] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(466),
    [anon_sym_SEMI] = ACTIONS(464),
    [anon_sym_assert] = ACTIONS(466),
    [anon_sym_do] = ACTIONS(466),
    [anon_sym_while] = ACTIONS(466),
    [anon_sym_break] = ACTIONS(466),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_return] = ACTIONS(466),
    [anon_sym_yield] = ACTIONS(466),
    [anon_sym_synchronized] = ACTIONS(466),
    [anon_sym_throw] = ACTIONS(466),
    [anon_sym_try] = ACTIONS(466),
    [anon_sym_if] = ACTIONS(466),
    [anon_sym_else] = ACTIONS(466),
    [anon_sym_for] = ACTIONS(466),
    [anon_sym_AT] = ACTIONS(466),
    [anon_sym_open] = ACTIONS(466),
    [anon_sym_module] = ACTIONS(466),
    [anon_sym_static] = ACTIONS(466),
    [anon_sym_package] = ACTIONS(466),
    [anon_sym_import] = ACTIONS(466),
    [anon_sym_enum] = ACTIONS(466),
    [anon_sym_public] = ACTIONS(466),
    [anon_sym_protected] = ACTIONS(466),
    [anon_sym_private] = ACTIONS(466),
    [anon_sym_abstract] = ACTIONS(466),
    [anon_sym_strictfp] = ACTIONS(466),
    [anon_sym_native] = ACTIONS(466),
    [anon_sym_transient] = ACTIONS(466),
    [anon_sym_volatile] = ACTIONS(466),
    [anon_sym_sealed] = ACTIONS(466),
    [anon_sym_non_DASHsealed] = ACTIONS(464),
    [anon_sym_record] = ACTIONS(466),
    [anon_sym_ATinterface] = ACTIONS(464),
    [anon_sym_interface] = ACTIONS(466),
    [anon_sym_byte] = ACTIONS(466),
    [anon_sym_short] = ACTIONS(466),
    [anon_sym_int] = ACTIONS(466),
    [anon_sym_long] = ACTIONS(466),
    [anon_sym_char] = ACTIONS(466),
    [anon_sym_float] = ACTIONS(466),
    [anon_sym_double] = ACTIONS(466),
    [sym_boolean_type] = ACTIONS(466),
    [sym_void_type] = ACTIONS(466),
    [sym_this] = ACTIONS(466),
    [sym_super] = ACTIONS(466),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [129] = {
    [ts_builtin_sym_end] = ACTIONS(468),
    [sym_identifier] = ACTIONS(470),
    [sym_decimal_integer_literal] = ACTIONS(470),
    [sym_hex_integer_literal] = ACTIONS(470),
    [sym_octal_integer_literal] = ACTIONS(468),
    [sym_binary_integer_literal] = ACTIONS(468),
    [sym_decimal_floating_point_literal] = ACTIONS(468),
    [sym_hex_floating_point_literal] = ACTIONS(470),
    [sym_true] = ACTIONS(470),
    [sym_false] = ACTIONS(470),
    [sym_character_literal] = ACTIONS(468),
    [sym_string_literal] = ACTIONS(470),
    [sym_text_block] = ACTIONS(468),
    [sym_null_literal] = ACTIONS(470),
    [anon_sym_LPAREN] = ACTIONS(468),
    [anon_sym_LT] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(470),
    [anon_sym_DASH] = ACTIONS(470),
    [anon_sym_final] = ACTIONS(470),
    [anon_sym_BANG] = ACTIONS(468),
    [anon_sym_TILDE] = ACTIONS(468),
    [anon_sym_PLUS_PLUS] = ACTIONS(468),
    [anon_sym_DASH_DASH] = ACTIONS(468),
    [anon_sym_new] = ACTIONS(470),
    [anon_sym_class] = ACTIONS(470),
    [anon_sym_switch] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(468),
    [anon_sym_RBRACE] = ACTIONS(468),
    [anon_sym_case] = ACTIONS(470),
    [anon_sym_default] = ACTIONS(470),
    [anon_sym_SEMI] = ACTIONS(468),
    [anon_sym_assert] = ACTIONS(470),
    [anon_sym_do] = ACTIONS(470),
    [anon_sym_while] = ACTIONS(470),
    [anon_sym_break] = ACTIONS(470),
    [anon_sym_continue] = ACTIONS(470),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_yield] = ACTIONS(470),
    [anon_sym_synchronized] = ACTIONS(470),
    [anon_sym_throw] = ACTIONS(470),
    [anon_sym_try] = ACTIONS(470),
    [anon_sym_if] = ACTIONS(470),
    [anon_sym_else] = ACTIONS(470),
    [anon_sym_for] = ACTIONS(470),
    [anon_sym_AT] = ACTIONS(470),
    [anon_sym_open] = ACTIONS(470),
    [anon_sym_module] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(470),
    [anon_sym_package] = ACTIONS(470),
    [anon_sym_import] = ACTIONS(470),
    [anon_sym_enum] = ACTIONS(470),
    [anon_sym_public] = ACTIONS(470),
    [anon_sym_protected] = ACTIONS(470),
    [anon_sym_private] = ACTIONS(470),
    [anon_sym_abstract] = ACTIONS(470),
    [anon_sym_strictfp] = ACTIONS(470),
    [anon_sym_native] = ACTIONS(470),
    [anon_sym_transient] = ACTIONS(470),
    [anon_sym_volatile] = ACTIONS(470),
    [anon_sym_sealed] = ACTIONS(470),
    [anon_sym_non_DASHsealed] = ACTIONS(468),
    [anon_sym_record] = ACTIONS(470),
    [anon_sym_ATinterface] = ACTIONS(468),
    [anon_sym_interface] = ACTIONS(470),
    [anon_sym_byte] = ACTIONS(470),
    [anon_sym_short] = ACTIONS(470),
    [anon_sym_int] = ACTIONS(470),
    [anon_sym_long] = ACTIONS(470),
    [anon_sym_char] = ACTIONS(470),
    [anon_sym_float] = ACTIONS(470),
    [anon_sym_double] = ACTIONS(470),
    [sym_boolean_type] = ACTIONS(470),
    [sym_void_type] = ACTIONS(470),
    [sym_this] = ACTIONS(470),
    [sym_super] = ACTIONS(470),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [130] = {
    [ts_builtin_sym_end] = ACTIONS(472),
    [sym_identifier] = ACTIONS(474),
    [sym_decimal_integer_literal] = ACTIONS(474),
    [sym_hex_integer_literal] = ACTIONS(474),
    [sym_octal_integer_literal] = ACTIONS(472),
    [sym_binary_integer_literal] = ACTIONS(472),
    [sym_decimal_floating_point_literal] = ACTIONS(472),
    [sym_hex_floating_point_literal] = ACTIONS(474),
    [sym_true] = ACTIONS(474),
    [sym_false] = ACTIONS(474),
    [sym_character_literal] = ACTIONS(472),
    [sym_string_literal] = ACTIONS(474),
    [sym_text_block] = ACTIONS(472),
    [sym_null_literal] = ACTIONS(474),
    [anon_sym_LPAREN] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(474),
    [anon_sym_DASH] = ACTIONS(474),
    [anon_sym_final] = ACTIONS(474),
    [anon_sym_BANG] = ACTIONS(472),
    [anon_sym_TILDE] = ACTIONS(472),
    [anon_sym_PLUS_PLUS] = ACTIONS(472),
    [anon_sym_DASH_DASH] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(474),
    [anon_sym_class] = ACTIONS(474),
    [anon_sym_switch] = ACTIONS(474),
    [anon_sym_LBRACE] = ACTIONS(472),
    [anon_sym_RBRACE] = ACTIONS(472),
    [anon_sym_case] = ACTIONS(474),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_SEMI] = ACTIONS(472),
    [anon_sym_assert] = ACTIONS(474),
    [anon_sym_do] = ACTIONS(474),
    [anon_sym_while] = ACTIONS(474),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_continue] = ACTIONS(474),
    [anon_sym_return] = ACTIONS(474),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_synchronized] = ACTIONS(474),
    [anon_sym_throw] = ACTIONS(474),
    [anon_sym_try] = ACTIONS(474),
    [anon_sym_if] = ACTIONS(474),
    [anon_sym_else] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(474),
    [anon_sym_AT] = ACTIONS(474),
    [anon_sym_open] = ACTIONS(474),
    [anon_sym_module] = ACTIONS(474),
    [anon_sym_static] = ACTIONS(474),
    [anon_sym_package] = ACTIONS(474),
    [anon_sym_import] = ACTIONS(474),
    [anon_sym_enum] = ACTIONS(474),
    [anon_sym_public] = ACTIONS(474),
    [anon_sym_protected] = ACTIONS(474),
    [anon_sym_private] = ACTIONS(474),
    [anon_sym_abstract] = ACTIONS(474),
    [anon_sym_strictfp] = ACTIONS(474),
    [anon_sym_native] = ACTIONS(474),
    [anon_sym_transient] = ACTIONS(474),
    [anon_sym_volatile] = ACTIONS(474),
    [anon_sym_sealed] = ACTIONS(474),
    [anon_sym_non_DASHsealed] = ACTIONS(472),
    [anon_sym_record] = ACTIONS(474),
    [anon_sym_ATinterface] = ACTIONS(472),
    [anon_sym_interface] = ACTIONS(474),
    [anon_sym_byte] = ACTIONS(474),
    [anon_sym_short] = ACTIONS(474),
    [anon_sym_int] = ACTIONS(474),
    [anon_sym_long] = ACTIONS(474),
    [anon_sym_char] = ACTIONS(474),
    [anon_sym_float] = ACTIONS(474),
    [anon_sym_double] = ACTIONS(474),
    [sym_boolean_type] = ACTIONS(474),
    [sym_void_type] = ACTIONS(474),
    [sym_this] = ACTIONS(474),
    [sym_super] = ACTIONS(474),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [131] = {
    [ts_builtin_sym_end] = ACTIONS(476),
    [sym_identifier] = ACTIONS(478),
    [sym_decimal_integer_literal] = ACTIONS(478),
    [sym_hex_integer_literal] = ACTIONS(478),
    [sym_octal_integer_literal] = ACTIONS(476),
    [sym_binary_integer_literal] = ACTIONS(476),
    [sym_decimal_floating_point_literal] = ACTIONS(476),
    [sym_hex_floating_point_literal] = ACTIONS(478),
    [sym_true] = ACTIONS(478),
    [sym_false] = ACTIONS(478),
    [sym_character_literal] = ACTIONS(476),
    [sym_string_literal] = ACTIONS(478),
    [sym_text_block] = ACTIONS(476),
    [sym_null_literal] = ACTIONS(478),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_final] = ACTIONS(478),
    [anon_sym_BANG] = ACTIONS(476),
    [anon_sym_TILDE] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(476),
    [anon_sym_DASH_DASH] = ACTIONS(476),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_class] = ACTIONS(478),
    [anon_sym_switch] = ACTIONS(478),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_RBRACE] = ACTIONS(476),
    [anon_sym_case] = ACTIONS(478),
    [anon_sym_default] = ACTIONS(478),
    [anon_sym_SEMI] = ACTIONS(476),
    [anon_sym_assert] = ACTIONS(478),
    [anon_sym_do] = ACTIONS(478),
    [anon_sym_while] = ACTIONS(478),
    [anon_sym_break] = ACTIONS(478),
    [anon_sym_continue] = ACTIONS(478),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_yield] = ACTIONS(478),
    [anon_sym_synchronized] = ACTIONS(478),
    [anon_sym_throw] = ACTIONS(478),
    [anon_sym_try] = ACTIONS(478),
    [anon_sym_if] = ACTIONS(478),
    [anon_sym_else] = ACTIONS(478),
    [anon_sym_for] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(478),
    [anon_sym_open] = ACTIONS(478),
    [anon_sym_module] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_package] = ACTIONS(478),
    [anon_sym_import] = ACTIONS(478),
    [anon_sym_enum] = ACTIONS(478),
    [anon_sym_public] = ACTIONS(478),
    [anon_sym_protected] = ACTIONS(478),
    [anon_sym_private] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(478),
    [anon_sym_strictfp] = ACTIONS(478),
    [anon_sym_native] = ACTIONS(478),
    [anon_sym_transient] = ACTIONS(478),
    [anon_sym_volatile] = ACTIONS(478),
    [anon_sym_sealed] = ACTIONS(478),
    [anon_sym_non_DASHsealed] = ACTIONS(476),
    [anon_sym_record] = ACTIONS(478),
    [anon_sym_ATinterface] = ACTIONS(476),
    [anon_sym_interface] = ACTIONS(478),
    [anon_sym_byte] = ACTIONS(478),
    [anon_sym_short] = ACTIONS(478),
    [anon_sym_int] = ACTIONS(478),
    [anon_sym_long] = ACTIONS(478),
    [anon_sym_char] = ACTIONS(478),
    [anon_sym_float] = ACTIONS(478),
    [anon_sym_double] = ACTIONS(478),
    [sym_boolean_type] = ACTIONS(478),
    [sym_void_type] = ACTIONS(478),
    [sym_this] = ACTIONS(478),
    [sym_super] = ACTIONS(478),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [132] = {
    [ts_builtin_sym_end] = ACTIONS(480),
    [sym_identifier] = ACTIONS(482),
    [sym_decimal_integer_literal] = ACTIONS(482),
    [sym_hex_integer_literal] = ACTIONS(482),
    [sym_octal_integer_literal] = ACTIONS(480),
    [sym_binary_integer_literal] = ACTIONS(480),
    [sym_decimal_floating_point_literal] = ACTIONS(480),
    [sym_hex_floating_point_literal] = ACTIONS(482),
    [sym_true] = ACTIONS(482),
    [sym_false] = ACTIONS(482),
    [sym_character_literal] = ACTIONS(480),
    [sym_string_literal] = ACTIONS(482),
    [sym_text_block] = ACTIONS(480),
    [sym_null_literal] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(480),
    [anon_sym_PLUS] = ACTIONS(482),
    [anon_sym_DASH] = ACTIONS(482),
    [anon_sym_final] = ACTIONS(482),
    [anon_sym_BANG] = ACTIONS(480),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_new] = ACTIONS(482),
    [anon_sym_class] = ACTIONS(482),
    [anon_sym_switch] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(480),
    [anon_sym_RBRACE] = ACTIONS(480),
    [anon_sym_case] = ACTIONS(482),
    [anon_sym_default] = ACTIONS(482),
    [anon_sym_SEMI] = ACTIONS(480),
    [anon_sym_assert] = ACTIONS(482),
    [anon_sym_do] = ACTIONS(482),
    [anon_sym_while] = ACTIONS(482),
    [anon_sym_break] = ACTIONS(482),
    [anon_sym_continue] = ACTIONS(482),
    [anon_sym_return] = ACTIONS(482),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_synchronized] = ACTIONS(482),
    [anon_sym_throw] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(482),
    [anon_sym_if] = ACTIONS(482),
    [anon_sym_else] = ACTIONS(482),
    [anon_sym_for] = ACTIONS(482),
    [anon_sym_AT] = ACTIONS(482),
    [anon_sym_open] = ACTIONS(482),
    [anon_sym_module] = ACTIONS(482),
    [anon_sym_static] = ACTIONS(482),
    [anon_sym_package] = ACTIONS(482),
    [anon_sym_import] = ACTIONS(482),
    [anon_sym_enum] = ACTIONS(482),
    [anon_sym_public] = ACTIONS(482),
    [anon_sym_protected] = ACTIONS(482),
    [anon_sym_private] = ACTIONS(482),
    [anon_sym_abstract] = ACTIONS(482),
    [anon_sym_strictfp] = ACTIONS(482),
    [anon_sym_native] = ACTIONS(482),
    [anon_sym_transient] = ACTIONS(482),
    [anon_sym_volatile] = ACTIONS(482),
    [anon_sym_sealed] = ACTIONS(482),
    [anon_sym_non_DASHsealed] = ACTIONS(480),
    [anon_sym_record] = ACTIONS(482),
    [anon_sym_ATinterface] = ACTIONS(480),
    [anon_sym_interface] = ACTIONS(482),
    [anon_sym_byte] = ACTIONS(482),
    [anon_sym_short] = ACTIONS(482),
    [anon_sym_int] = ACTIONS(482),
    [anon_sym_long] = ACTIONS(482),
    [anon_sym_char] = ACTIONS(482),
    [anon_sym_float] = ACTIONS(482),
    [anon_sym_double] = ACTIONS(482),
    [sym_boolean_type] = ACTIONS(482),
    [sym_void_type] = ACTIONS(482),
    [sym_this] = ACTIONS(482),
    [sym_super] = ACTIONS(482),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [133] = {
    [ts_builtin_sym_end] = ACTIONS(484),
    [sym_identifier] = ACTIONS(486),
    [sym_decimal_integer_literal] = ACTIONS(486),
    [sym_hex_integer_literal] = ACTIONS(486),
    [sym_octal_integer_literal] = ACTIONS(484),
    [sym_binary_integer_literal] = ACTIONS(484),
    [sym_decimal_floating_point_literal] = ACTIONS(484),
    [sym_hex_floating_point_literal] = ACTIONS(486),
    [sym_true] = ACTIONS(486),
    [sym_false] = ACTIONS(486),
    [sym_character_literal] = ACTIONS(484),
    [sym_string_literal] = ACTIONS(486),
    [sym_text_block] = ACTIONS(484),
    [sym_null_literal] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_LT] = ACTIONS(484),
    [anon_sym_PLUS] = ACTIONS(486),
    [anon_sym_DASH] = ACTIONS(486),
    [anon_sym_final] = ACTIONS(486),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(484),
    [anon_sym_DASH_DASH] = ACTIONS(484),
    [anon_sym_new] = ACTIONS(486),
    [anon_sym_class] = ACTIONS(486),
    [anon_sym_switch] = ACTIONS(486),
    [anon_sym_LBRACE] = ACTIONS(484),
    [anon_sym_RBRACE] = ACTIONS(484),
    [anon_sym_case] = ACTIONS(486),
    [anon_sym_default] = ACTIONS(486),
    [anon_sym_SEMI] = ACTIONS(484),
    [anon_sym_assert] = ACTIONS(486),
    [anon_sym_do] = ACTIONS(486),
    [anon_sym_while] = ACTIONS(486),
    [anon_sym_break] = ACTIONS(486),
    [anon_sym_continue] = ACTIONS(486),
    [anon_sym_return] = ACTIONS(486),
    [anon_sym_yield] = ACTIONS(486),
    [anon_sym_synchronized] = ACTIONS(486),
    [anon_sym_throw] = ACTIONS(486),
    [anon_sym_try] = ACTIONS(486),
    [anon_sym_if] = ACTIONS(486),
    [anon_sym_else] = ACTIONS(486),
    [anon_sym_for] = ACTIONS(486),
    [anon_sym_AT] = ACTIONS(486),
    [anon_sym_open] = ACTIONS(486),
    [anon_sym_module] = ACTIONS(486),
    [anon_sym_static] = ACTIONS(486),
    [anon_sym_package] = ACTIONS(486),
    [anon_sym_import] = ACTIONS(486),
    [anon_sym_enum] = ACTIONS(486),
    [anon_sym_public] = ACTIONS(486),
    [anon_sym_protected] = ACTIONS(486),
    [anon_sym_private] = ACTIONS(486),
    [anon_sym_abstract] = ACTIONS(486),
    [anon_sym_strictfp] = ACTIONS(486),
    [anon_sym_native] = ACTIONS(486),
    [anon_sym_transient] = ACTIONS(486),
    [anon_sym_volatile] = ACTIONS(486),
    [anon_sym_sealed] = ACTIONS(486),
    [anon_sym_non_DASHsealed] = ACTIONS(484),
    [anon_sym_record] = ACTIONS(486),
    [anon_sym_ATinterface] = ACTIONS(484),
    [anon_sym_interface] = ACTIONS(486),
    [anon_sym_byte] = ACTIONS(486),
    [anon_sym_short] = ACTIONS(486),
    [anon_sym_int] = ACTIONS(486),
    [anon_sym_long] = ACTIONS(486),
    [anon_sym_char] = ACTIONS(486),
    [anon_sym_float] = ACTIONS(486),
    [anon_sym_double] = ACTIONS(486),
    [sym_boolean_type] = ACTIONS(486),
    [sym_void_type] = ACTIONS(486),
    [sym_this] = ACTIONS(486),
    [sym_super] = ACTIONS(486),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [134] = {
    [ts_builtin_sym_end] = ACTIONS(488),
    [sym_identifier] = ACTIONS(490),
    [sym_decimal_integer_literal] = ACTIONS(490),
    [sym_hex_integer_literal] = ACTIONS(490),
    [sym_octal_integer_literal] = ACTIONS(488),
    [sym_binary_integer_literal] = ACTIONS(488),
    [sym_decimal_floating_point_literal] = ACTIONS(488),
    [sym_hex_floating_point_literal] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_character_literal] = ACTIONS(488),
    [sym_string_literal] = ACTIONS(490),
    [sym_text_block] = ACTIONS(488),
    [sym_null_literal] = ACTIONS(490),
    [anon_sym_LPAREN] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_final] = ACTIONS(490),
    [anon_sym_BANG] = ACTIONS(488),
    [anon_sym_TILDE] = ACTIONS(488),
    [anon_sym_PLUS_PLUS] = ACTIONS(488),
    [anon_sym_DASH_DASH] = ACTIONS(488),
    [anon_sym_new] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(490),
    [anon_sym_switch] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(488),
    [anon_sym_RBRACE] = ACTIONS(488),
    [anon_sym_case] = ACTIONS(490),
    [anon_sym_default] = ACTIONS(490),
    [anon_sym_SEMI] = ACTIONS(488),
    [anon_sym_assert] = ACTIONS(490),
    [anon_sym_do] = ACTIONS(490),
    [anon_sym_while] = ACTIONS(490),
    [anon_sym_break] = ACTIONS(490),
    [anon_sym_continue] = ACTIONS(490),
    [anon_sym_return] = ACTIONS(490),
    [anon_sym_yield] = ACTIONS(490),
    [anon_sym_synchronized] = ACTIONS(490),
    [anon_sym_throw] = ACTIONS(490),
    [anon_sym_try] = ACTIONS(490),
    [anon_sym_if] = ACTIONS(490),
    [anon_sym_else] = ACTIONS(490),
    [anon_sym_for] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(490),
    [anon_sym_open] = ACTIONS(490),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_static] = ACTIONS(490),
    [anon_sym_package] = ACTIONS(490),
    [anon_sym_import] = ACTIONS(490),
    [anon_sym_enum] = ACTIONS(490),
    [anon_sym_public] = ACTIONS(490),
    [anon_sym_protected] = ACTIONS(490),
    [anon_sym_private] = ACTIONS(490),
    [anon_sym_abstract] = ACTIONS(490),
    [anon_sym_strictfp] = ACTIONS(490),
    [anon_sym_native] = ACTIONS(490),
    [anon_sym_transient] = ACTIONS(490),
    [anon_sym_volatile] = ACTIONS(490),
    [anon_sym_sealed] = ACTIONS(490),
    [anon_sym_non_DASHsealed] = ACTIONS(488),
    [anon_sym_record] = ACTIONS(490),
    [anon_sym_ATinterface] = ACTIONS(488),
    [anon_sym_interface] = ACTIONS(490),
    [anon_sym_byte] = ACTIONS(490),
    [anon_sym_short] = ACTIONS(490),
    [anon_sym_int] = ACTIONS(490),
    [anon_sym_long] = ACTIONS(490),
    [anon_sym_char] = ACTIONS(490),
    [anon_sym_float] = ACTIONS(490),
    [anon_sym_double] = ACTIONS(490),
    [sym_boolean_type] = ACTIONS(490),
    [sym_void_type] = ACTIONS(490),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [135] = {
    [ts_builtin_sym_end] = ACTIONS(492),
    [sym_identifier] = ACTIONS(494),
    [sym_decimal_integer_literal] = ACTIONS(494),
    [sym_hex_integer_literal] = ACTIONS(494),
    [sym_octal_integer_literal] = ACTIONS(492),
    [sym_binary_integer_literal] = ACTIONS(492),
    [sym_decimal_floating_point_literal] = ACTIONS(492),
    [sym_hex_floating_point_literal] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_character_literal] = ACTIONS(492),
    [sym_string_literal] = ACTIONS(494),
    [sym_text_block] = ACTIONS(492),
    [sym_null_literal] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_final] = ACTIONS(494),
    [anon_sym_BANG] = ACTIONS(492),
    [anon_sym_TILDE] = ACTIONS(492),
    [anon_sym_PLUS_PLUS] = ACTIONS(492),
    [anon_sym_DASH_DASH] = ACTIONS(492),
    [anon_sym_new] = ACTIONS(494),
    [anon_sym_class] = ACTIONS(494),
    [anon_sym_switch] = ACTIONS(494),
    [anon_sym_LBRACE] = ACTIONS(492),
    [anon_sym_RBRACE] = ACTIONS(492),
    [anon_sym_case] = ACTIONS(494),
    [anon_sym_default] = ACTIONS(494),
    [anon_sym_SEMI] = ACTIONS(492),
    [anon_sym_assert] = ACTIONS(494),
    [anon_sym_do] = ACTIONS(494),
    [anon_sym_while] = ACTIONS(494),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_continue] = ACTIONS(494),
    [anon_sym_return] = ACTIONS(494),
    [anon_sym_yield] = ACTIONS(494),
    [anon_sym_synchronized] = ACTIONS(494),
    [anon_sym_throw] = ACTIONS(494),
    [anon_sym_try] = ACTIONS(494),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_else] = ACTIONS(494),
    [anon_sym_for] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(494),
    [anon_sym_open] = ACTIONS(494),
    [anon_sym_module] = ACTIONS(494),
    [anon_sym_static] = ACTIONS(494),
    [anon_sym_package] = ACTIONS(494),
    [anon_sym_import] = ACTIONS(494),
    [anon_sym_enum] = ACTIONS(494),
    [anon_sym_public] = ACTIONS(494),
    [anon_sym_protected] = ACTIONS(494),
    [anon_sym_private] = ACTIONS(494),
    [anon_sym_abstract] = ACTIONS(494),
    [anon_sym_strictfp] = ACTIONS(494),
    [anon_sym_native] = ACTIONS(494),
    [anon_sym_transient] = ACTIONS(494),
    [anon_sym_volatile] = ACTIONS(494),
    [anon_sym_sealed] = ACTIONS(494),
    [anon_sym_non_DASHsealed] = ACTIONS(492),
    [anon_sym_record] = ACTIONS(494),
    [anon_sym_ATinterface] = ACTIONS(492),
    [anon_sym_interface] = ACTIONS(494),
    [anon_sym_byte] = ACTIONS(494),
    [anon_sym_short] = ACTIONS(494),
    [anon_sym_int] = ACTIONS(494),
    [anon_sym_long] = ACTIONS(494),
    [anon_sym_char] = ACTIONS(494),
    [anon_sym_float] = ACTIONS(494),
    [anon_sym_double] = ACTIONS(494),
    [sym_boolean_type] = ACTIONS(494),
    [sym_void_type] = ACTIONS(494),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [136] = {
    [ts_builtin_sym_end] = ACTIONS(496),
    [sym_identifier] = ACTIONS(498),
    [sym_decimal_integer_literal] = ACTIONS(498),
    [sym_hex_integer_literal] = ACTIONS(498),
    [sym_octal_integer_literal] = ACTIONS(496),
    [sym_binary_integer_literal] = ACTIONS(496),
    [sym_decimal_floating_point_literal] = ACTIONS(496),
    [sym_hex_floating_point_literal] = ACTIONS(498),
    [sym_true] = ACTIONS(498),
    [sym_false] = ACTIONS(498),
    [sym_character_literal] = ACTIONS(496),
    [sym_string_literal] = ACTIONS(498),
    [sym_text_block] = ACTIONS(496),
    [sym_null_literal] = ACTIONS(498),
    [anon_sym_LPAREN] = ACTIONS(496),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_final] = ACTIONS(498),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_PLUS_PLUS] = ACTIONS(496),
    [anon_sym_DASH_DASH] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(498),
    [anon_sym_class] = ACTIONS(498),
    [anon_sym_switch] = ACTIONS(498),
    [anon_sym_LBRACE] = ACTIONS(496),
    [anon_sym_RBRACE] = ACTIONS(496),
    [anon_sym_case] = ACTIONS(498),
    [anon_sym_default] = ACTIONS(498),
    [anon_sym_SEMI] = ACTIONS(496),
    [anon_sym_assert] = ACTIONS(498),
    [anon_sym_do] = ACTIONS(498),
    [anon_sym_while] = ACTIONS(498),
    [anon_sym_break] = ACTIONS(498),
    [anon_sym_continue] = ACTIONS(498),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_yield] = ACTIONS(498),
    [anon_sym_synchronized] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(498),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_if] = ACTIONS(498),
    [anon_sym_else] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(498),
    [anon_sym_AT] = ACTIONS(498),
    [anon_sym_open] = ACTIONS(498),
    [anon_sym_module] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(498),
    [anon_sym_package] = ACTIONS(498),
    [anon_sym_import] = ACTIONS(498),
    [anon_sym_enum] = ACTIONS(498),
    [anon_sym_public] = ACTIONS(498),
    [anon_sym_protected] = ACTIONS(498),
    [anon_sym_private] = ACTIONS(498),
    [anon_sym_abstract] = ACTIONS(498),
    [anon_sym_strictfp] = ACTIONS(498),
    [anon_sym_native] = ACTIONS(498),
    [anon_sym_transient] = ACTIONS(498),
    [anon_sym_volatile] = ACTIONS(498),
    [anon_sym_sealed] = ACTIONS(498),
    [anon_sym_non_DASHsealed] = ACTIONS(496),
    [anon_sym_record] = ACTIONS(498),
    [anon_sym_ATinterface] = ACTIONS(496),
    [anon_sym_interface] = ACTIONS(498),
    [anon_sym_byte] = ACTIONS(498),
    [anon_sym_short] = ACTIONS(498),
    [anon_sym_int] = ACTIONS(498),
    [anon_sym_long] = ACTIONS(498),
    [anon_sym_char] = ACTIONS(498),
    [anon_sym_float] = ACTIONS(498),
    [anon_sym_double] = ACTIONS(498),
    [sym_boolean_type] = ACTIONS(498),
    [sym_void_type] = ACTIONS(498),
    [sym_this] = ACTIONS(498),
    [sym_super] = ACTIONS(498),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [137] = {
    [ts_builtin_sym_end] = ACTIONS(500),
    [sym_identifier] = ACTIONS(502),
    [sym_decimal_integer_literal] = ACTIONS(502),
    [sym_hex_integer_literal] = ACTIONS(502),
    [sym_octal_integer_literal] = ACTIONS(500),
    [sym_binary_integer_literal] = ACTIONS(500),
    [sym_decimal_floating_point_literal] = ACTIONS(500),
    [sym_hex_floating_point_literal] = ACTIONS(502),
    [sym_true] = ACTIONS(502),
    [sym_false] = ACTIONS(502),
    [sym_character_literal] = ACTIONS(500),
    [sym_string_literal] = ACTIONS(502),
    [sym_text_block] = ACTIONS(500),
    [sym_null_literal] = ACTIONS(502),
    [anon_sym_LPAREN] = ACTIONS(500),
    [anon_sym_LT] = ACTIONS(500),
    [anon_sym_PLUS] = ACTIONS(502),
    [anon_sym_DASH] = ACTIONS(502),
    [anon_sym_final] = ACTIONS(502),
    [anon_sym_BANG] = ACTIONS(500),
    [anon_sym_TILDE] = ACTIONS(500),
    [anon_sym_PLUS_PLUS] = ACTIONS(500),
    [anon_sym_DASH_DASH] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_class] = ACTIONS(502),
    [anon_sym_switch] = ACTIONS(502),
    [anon_sym_LBRACE] = ACTIONS(500),
    [anon_sym_RBRACE] = ACTIONS(500),
    [anon_sym_case] = ACTIONS(502),
    [anon_sym_default] = ACTIONS(502),
    [anon_sym_SEMI] = ACTIONS(500),
    [anon_sym_assert] = ACTIONS(502),
    [anon_sym_do] = ACTIONS(502),
    [anon_sym_while] = ACTIONS(502),
    [anon_sym_break] = ACTIONS(502),
    [anon_sym_continue] = ACTIONS(502),
    [anon_sym_return] = ACTIONS(502),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_synchronized] = ACTIONS(502),
    [anon_sym_throw] = ACTIONS(502),
    [anon_sym_try] = ACTIONS(502),
    [anon_sym_if] = ACTIONS(502),
    [anon_sym_else] = ACTIONS(502),
    [anon_sym_for] = ACTIONS(502),
    [anon_sym_AT] = ACTIONS(502),
    [anon_sym_open] = ACTIONS(502),
    [anon_sym_module] = ACTIONS(502),
    [anon_sym_static] = ACTIONS(502),
    [anon_sym_package] = ACTIONS(502),
    [anon_sym_import] = ACTIONS(502),
    [anon_sym_enum] = ACTIONS(502),
    [anon_sym_public] = ACTIONS(502),
    [anon_sym_protected] = ACTIONS(502),
    [anon_sym_private] = ACTIONS(502),
    [anon_sym_abstract] = ACTIONS(502),
    [anon_sym_strictfp] = ACTIONS(502),
    [anon_sym_native] = ACTIONS(502),
    [anon_sym_transient] = ACTIONS(502),
    [anon_sym_volatile] = ACTIONS(502),
    [anon_sym_sealed] = ACTIONS(502),
    [anon_sym_non_DASHsealed] = ACTIONS(500),
    [anon_sym_record] = ACTIONS(502),
    [anon_sym_ATinterface] = ACTIONS(500),
    [anon_sym_interface] = ACTIONS(502),
    [anon_sym_byte] = ACTIONS(502),
    [anon_sym_short] = ACTIONS(502),
    [anon_sym_int] = ACTIONS(502),
    [anon_sym_long] = ACTIONS(502),
    [anon_sym_char] = ACTIONS(502),
    [anon_sym_float] = ACTIONS(502),
    [anon_sym_double] = ACTIONS(502),
    [sym_boolean_type] = ACTIONS(502),
    [sym_void_type] = ACTIONS(502),
    [sym_this] = ACTIONS(502),
    [sym_super] = ACTIONS(502),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [138] = {
    [ts_builtin_sym_end] = ACTIONS(504),
    [sym_identifier] = ACTIONS(506),
    [sym_decimal_integer_literal] = ACTIONS(506),
    [sym_hex_integer_literal] = ACTIONS(506),
    [sym_octal_integer_literal] = ACTIONS(504),
    [sym_binary_integer_literal] = ACTIONS(504),
    [sym_decimal_floating_point_literal] = ACTIONS(504),
    [sym_hex_floating_point_literal] = ACTIONS(506),
    [sym_true] = ACTIONS(506),
    [sym_false] = ACTIONS(506),
    [sym_character_literal] = ACTIONS(504),
    [sym_string_literal] = ACTIONS(506),
    [sym_text_block] = ACTIONS(504),
    [sym_null_literal] = ACTIONS(506),
    [anon_sym_LPAREN] = ACTIONS(504),
    [anon_sym_LT] = ACTIONS(504),
    [anon_sym_PLUS] = ACTIONS(506),
    [anon_sym_DASH] = ACTIONS(506),
    [anon_sym_final] = ACTIONS(506),
    [anon_sym_BANG] = ACTIONS(504),
    [anon_sym_TILDE] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_new] = ACTIONS(506),
    [anon_sym_class] = ACTIONS(506),
    [anon_sym_switch] = ACTIONS(506),
    [anon_sym_LBRACE] = ACTIONS(504),
    [anon_sym_RBRACE] = ACTIONS(504),
    [anon_sym_case] = ACTIONS(506),
    [anon_sym_default] = ACTIONS(506),
    [anon_sym_SEMI] = ACTIONS(504),
    [anon_sym_assert] = ACTIONS(506),
    [anon_sym_do] = ACTIONS(506),
    [anon_sym_while] = ACTIONS(506),
    [anon_sym_break] = ACTIONS(506),
    [anon_sym_continue] = ACTIONS(506),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_yield] = ACTIONS(506),
    [anon_sym_synchronized] = ACTIONS(506),
    [anon_sym_throw] = ACTIONS(506),
    [anon_sym_try] = ACTIONS(506),
    [anon_sym_if] = ACTIONS(506),
    [anon_sym_else] = ACTIONS(506),
    [anon_sym_for] = ACTIONS(506),
    [anon_sym_AT] = ACTIONS(506),
    [anon_sym_open] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_package] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(506),
    [anon_sym_enum] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_abstract] = ACTIONS(506),
    [anon_sym_strictfp] = ACTIONS(506),
    [anon_sym_native] = ACTIONS(506),
    [anon_sym_transient] = ACTIONS(506),
    [anon_sym_volatile] = ACTIONS(506),
    [anon_sym_sealed] = ACTIONS(506),
    [anon_sym_non_DASHsealed] = ACTIONS(504),
    [anon_sym_record] = ACTIONS(506),
    [anon_sym_ATinterface] = ACTIONS(504),
    [anon_sym_interface] = ACTIONS(506),
    [anon_sym_byte] = ACTIONS(506),
    [anon_sym_short] = ACTIONS(506),
    [anon_sym_int] = ACTIONS(506),
    [anon_sym_long] = ACTIONS(506),
    [anon_sym_char] = ACTIONS(506),
    [anon_sym_float] = ACTIONS(506),
    [anon_sym_double] = ACTIONS(506),
    [sym_boolean_type] = ACTIONS(506),
    [sym_void_type] = ACTIONS(506),
    [sym_this] = ACTIONS(506),
    [sym_super] = ACTIONS(506),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [139] = {
    [ts_builtin_sym_end] = ACTIONS(508),
    [sym_identifier] = ACTIONS(510),
    [sym_decimal_integer_literal] = ACTIONS(510),
    [sym_hex_integer_literal] = ACTIONS(510),
    [sym_octal_integer_literal] = ACTIONS(508),
    [sym_binary_integer_literal] = ACTIONS(508),
    [sym_decimal_floating_point_literal] = ACTIONS(508),
    [sym_hex_floating_point_literal] = ACTIONS(510),
    [sym_true] = ACTIONS(510),
    [sym_false] = ACTIONS(510),
    [sym_character_literal] = ACTIONS(508),
    [sym_string_literal] = ACTIONS(510),
    [sym_text_block] = ACTIONS(508),
    [sym_null_literal] = ACTIONS(510),
    [anon_sym_LPAREN] = ACTIONS(508),
    [anon_sym_LT] = ACTIONS(508),
    [anon_sym_PLUS] = ACTIONS(510),
    [anon_sym_DASH] = ACTIONS(510),
    [anon_sym_final] = ACTIONS(510),
    [anon_sym_BANG] = ACTIONS(508),
    [anon_sym_TILDE] = ACTIONS(508),
    [anon_sym_PLUS_PLUS] = ACTIONS(508),
    [anon_sym_DASH_DASH] = ACTIONS(508),
    [anon_sym_new] = ACTIONS(510),
    [anon_sym_class] = ACTIONS(510),
    [anon_sym_switch] = ACTIONS(510),
    [anon_sym_LBRACE] = ACTIONS(508),
    [anon_sym_RBRACE] = ACTIONS(508),
    [anon_sym_case] = ACTIONS(510),
    [anon_sym_default] = ACTIONS(510),
    [anon_sym_SEMI] = ACTIONS(508),
    [anon_sym_assert] = ACTIONS(510),
    [anon_sym_do] = ACTIONS(510),
    [anon_sym_while] = ACTIONS(510),
    [anon_sym_break] = ACTIONS(510),
    [anon_sym_continue] = ACTIONS(510),
    [anon_sym_return] = ACTIONS(510),
    [anon_sym_yield] = ACTIONS(510),
    [anon_sym_synchronized] = ACTIONS(510),
    [anon_sym_throw] = ACTIONS(510),
    [anon_sym_try] = ACTIONS(510),
    [anon_sym_if] = ACTIONS(510),
    [anon_sym_else] = ACTIONS(510),
    [anon_sym_for] = ACTIONS(510),
    [anon_sym_AT] = ACTIONS(510),
    [anon_sym_open] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_package] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(510),
    [anon_sym_enum] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_abstract] = ACTIONS(510),
    [anon_sym_strictfp] = ACTIONS(510),
    [anon_sym_native] = ACTIONS(510),
    [anon_sym_transient] = ACTIONS(510),
    [anon_sym_volatile] = ACTIONS(510),
    [anon_sym_sealed] = ACTIONS(510),
    [anon_sym_non_DASHsealed] = ACTIONS(508),
    [anon_sym_record] = ACTIONS(510),
    [anon_sym_ATinterface] = ACTIONS(508),
    [anon_sym_interface] = ACTIONS(510),
    [anon_sym_byte] = ACTIONS(510),
    [anon_sym_short] = ACTIONS(510),
    [anon_sym_int] = ACTIONS(510),
    [anon_sym_long] = ACTIONS(510),
    [anon_sym_char] = ACTIONS(510),
    [anon_sym_float] = ACTIONS(510),
    [anon_sym_double] = ACTIONS(510),
    [sym_boolean_type] = ACTIONS(510),
    [sym_void_type] = ACTIONS(510),
    [sym_this] = ACTIONS(510),
    [sym_super] = ACTIONS(510),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [140] = {
    [ts_builtin_sym_end] = ACTIONS(512),
    [sym_identifier] = ACTIONS(514),
    [sym_decimal_integer_literal] = ACTIONS(514),
    [sym_hex_integer_literal] = ACTIONS(514),
    [sym_octal_integer_literal] = ACTIONS(512),
    [sym_binary_integer_literal] = ACTIONS(512),
    [sym_decimal_floating_point_literal] = ACTIONS(512),
    [sym_hex_floating_point_literal] = ACTIONS(514),
    [sym_true] = ACTIONS(514),
    [sym_false] = ACTIONS(514),
    [sym_character_literal] = ACTIONS(512),
    [sym_string_literal] = ACTIONS(514),
    [sym_text_block] = ACTIONS(512),
    [sym_null_literal] = ACTIONS(514),
    [anon_sym_LPAREN] = ACTIONS(512),
    [anon_sym_LT] = ACTIONS(512),
    [anon_sym_PLUS] = ACTIONS(514),
    [anon_sym_DASH] = ACTIONS(514),
    [anon_sym_final] = ACTIONS(514),
    [anon_sym_BANG] = ACTIONS(512),
    [anon_sym_TILDE] = ACTIONS(512),
    [anon_sym_PLUS_PLUS] = ACTIONS(512),
    [anon_sym_DASH_DASH] = ACTIONS(512),
    [anon_sym_new] = ACTIONS(514),
    [anon_sym_class] = ACTIONS(514),
    [anon_sym_switch] = ACTIONS(514),
    [anon_sym_LBRACE] = ACTIONS(512),
    [anon_sym_RBRACE] = ACTIONS(512),
    [anon_sym_case] = ACTIONS(514),
    [anon_sym_default] = ACTIONS(514),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_assert] = ACTIONS(514),
    [anon_sym_do] = ACTIONS(514),
    [anon_sym_while] = ACTIONS(514),
    [anon_sym_break] = ACTIONS(514),
    [anon_sym_continue] = ACTIONS(514),
    [anon_sym_return] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(514),
    [anon_sym_synchronized] = ACTIONS(514),
    [anon_sym_throw] = ACTIONS(514),
    [anon_sym_try] = ACTIONS(514),
    [anon_sym_if] = ACTIONS(514),
    [anon_sym_else] = ACTIONS(514),
    [anon_sym_for] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(514),
    [anon_sym_open] = ACTIONS(514),
    [anon_sym_module] = ACTIONS(514),
    [anon_sym_static] = ACTIONS(514),
    [anon_sym_package] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_enum] = ACTIONS(514),
    [anon_sym_public] = ACTIONS(514),
    [anon_sym_protected] = ACTIONS(514),
    [anon_sym_private] = ACTIONS(514),
    [anon_sym_abstract] = ACTIONS(514),
    [anon_sym_strictfp] = ACTIONS(514),
    [anon_sym_native] = ACTIONS(514),
    [anon_sym_transient] = ACTIONS(514),
    [anon_sym_volatile] = ACTIONS(514),
    [anon_sym_sealed] = ACTIONS(514),
    [anon_sym_non_DASHsealed] = ACTIONS(512),
    [anon_sym_record] = ACTIONS(514),
    [anon_sym_ATinterface] = ACTIONS(512),
    [anon_sym_interface] = ACTIONS(514),
    [anon_sym_byte] = ACTIONS(514),
    [anon_sym_short] = ACTIONS(514),
    [anon_sym_int] = ACTIONS(514),
    [anon_sym_long] = ACTIONS(514),
    [anon_sym_char] = ACTIONS(514),
    [anon_sym_float] = ACTIONS(514),
    [anon_sym_double] = ACTIONS(514),
    [sym_boolean_type] = ACTIONS(514),
    [sym_void_type] = ACTIONS(514),
    [sym_this] = ACTIONS(514),
    [sym_super] = ACTIONS(514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [141] = {
    [ts_builtin_sym_end] = ACTIONS(516),
    [sym_identifier] = ACTIONS(518),
    [sym_decimal_integer_literal] = ACTIONS(518),
    [sym_hex_integer_literal] = ACTIONS(518),
    [sym_octal_integer_literal] = ACTIONS(516),
    [sym_binary_integer_literal] = ACTIONS(516),
    [sym_decimal_floating_point_literal] = ACTIONS(516),
    [sym_hex_floating_point_literal] = ACTIONS(518),
    [sym_true] = ACTIONS(518),
    [sym_false] = ACTIONS(518),
    [sym_character_literal] = ACTIONS(516),
    [sym_string_literal] = ACTIONS(518),
    [sym_text_block] = ACTIONS(516),
    [sym_null_literal] = ACTIONS(518),
    [anon_sym_LPAREN] = ACTIONS(516),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_PLUS] = ACTIONS(518),
    [anon_sym_DASH] = ACTIONS(518),
    [anon_sym_final] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(516),
    [anon_sym_TILDE] = ACTIONS(516),
    [anon_sym_PLUS_PLUS] = ACTIONS(516),
    [anon_sym_DASH_DASH] = ACTIONS(516),
    [anon_sym_new] = ACTIONS(518),
    [anon_sym_class] = ACTIONS(518),
    [anon_sym_switch] = ACTIONS(518),
    [anon_sym_LBRACE] = ACTIONS(516),
    [anon_sym_RBRACE] = ACTIONS(516),
    [anon_sym_case] = ACTIONS(518),
    [anon_sym_default] = ACTIONS(518),
    [anon_sym_SEMI] = ACTIONS(516),
    [anon_sym_assert] = ACTIONS(518),
    [anon_sym_do] = ACTIONS(518),
    [anon_sym_while] = ACTIONS(518),
    [anon_sym_break] = ACTIONS(518),
    [anon_sym_continue] = ACTIONS(518),
    [anon_sym_return] = ACTIONS(518),
    [anon_sym_yield] = ACTIONS(518),
    [anon_sym_synchronized] = ACTIONS(518),
    [anon_sym_throw] = ACTIONS(518),
    [anon_sym_try] = ACTIONS(518),
    [anon_sym_if] = ACTIONS(518),
    [anon_sym_else] = ACTIONS(518),
    [anon_sym_for] = ACTIONS(518),
    [anon_sym_AT] = ACTIONS(518),
    [anon_sym_open] = ACTIONS(518),
    [anon_sym_module] = ACTIONS(518),
    [anon_sym_static] = ACTIONS(518),
    [anon_sym_package] = ACTIONS(518),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_enum] = ACTIONS(518),
    [anon_sym_public] = ACTIONS(518),
    [anon_sym_protected] = ACTIONS(518),
    [anon_sym_private] = ACTIONS(518),
    [anon_sym_abstract] = ACTIONS(518),
    [anon_sym_strictfp] = ACTIONS(518),
    [anon_sym_native] = ACTIONS(518),
    [anon_sym_transient] = ACTIONS(518),
    [anon_sym_volatile] = ACTIONS(518),
    [anon_sym_sealed] = ACTIONS(518),
    [anon_sym_non_DASHsealed] = ACTIONS(516),
    [anon_sym_record] = ACTIONS(518),
    [anon_sym_ATinterface] = ACTIONS(516),
    [anon_sym_interface] = ACTIONS(518),
    [anon_sym_byte] = ACTIONS(518),
    [anon_sym_short] = ACTIONS(518),
    [anon_sym_int] = ACTIONS(518),
    [anon_sym_long] = ACTIONS(518),
    [anon_sym_char] = ACTIONS(518),
    [anon_sym_float] = ACTIONS(518),
    [anon_sym_double] = ACTIONS(518),
    [sym_boolean_type] = ACTIONS(518),
    [sym_void_type] = ACTIONS(518),
    [sym_this] = ACTIONS(518),
    [sym_super] = ACTIONS(518),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [142] = {
    [ts_builtin_sym_end] = ACTIONS(520),
    [sym_identifier] = ACTIONS(522),
    [sym_decimal_integer_literal] = ACTIONS(522),
    [sym_hex_integer_literal] = ACTIONS(522),
    [sym_octal_integer_literal] = ACTIONS(520),
    [sym_binary_integer_literal] = ACTIONS(520),
    [sym_decimal_floating_point_literal] = ACTIONS(520),
    [sym_hex_floating_point_literal] = ACTIONS(522),
    [sym_true] = ACTIONS(522),
    [sym_false] = ACTIONS(522),
    [sym_character_literal] = ACTIONS(520),
    [sym_string_literal] = ACTIONS(522),
    [sym_text_block] = ACTIONS(520),
    [sym_null_literal] = ACTIONS(522),
    [anon_sym_LPAREN] = ACTIONS(520),
    [anon_sym_LT] = ACTIONS(520),
    [anon_sym_PLUS] = ACTIONS(522),
    [anon_sym_DASH] = ACTIONS(522),
    [anon_sym_final] = ACTIONS(522),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_PLUS_PLUS] = ACTIONS(520),
    [anon_sym_DASH_DASH] = ACTIONS(520),
    [anon_sym_new] = ACTIONS(522),
    [anon_sym_class] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(522),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_RBRACE] = ACTIONS(520),
    [anon_sym_case] = ACTIONS(522),
    [anon_sym_default] = ACTIONS(522),
    [anon_sym_SEMI] = ACTIONS(520),
    [anon_sym_assert] = ACTIONS(522),
    [anon_sym_do] = ACTIONS(522),
    [anon_sym_while] = ACTIONS(522),
    [anon_sym_break] = ACTIONS(522),
    [anon_sym_continue] = ACTIONS(522),
    [anon_sym_return] = ACTIONS(522),
    [anon_sym_yield] = ACTIONS(522),
    [anon_sym_synchronized] = ACTIONS(522),
    [anon_sym_throw] = ACTIONS(522),
    [anon_sym_try] = ACTIONS(522),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_else] = ACTIONS(522),
    [anon_sym_for] = ACTIONS(522),
    [anon_sym_AT] = ACTIONS(522),
    [anon_sym_open] = ACTIONS(522),
    [anon_sym_module] = ACTIONS(522),
    [anon_sym_static] = ACTIONS(522),
    [anon_sym_package] = ACTIONS(522),
    [anon_sym_import] = ACTIONS(522),
    [anon_sym_enum] = ACTIONS(522),
    [anon_sym_public] = ACTIONS(522),
    [anon_sym_protected] = ACTIONS(522),
    [anon_sym_private] = ACTIONS(522),
    [anon_sym_abstract] = ACTIONS(522),
    [anon_sym_strictfp] = ACTIONS(522),
    [anon_sym_native] = ACTIONS(522),
    [anon_sym_transient] = ACTIONS(522),
    [anon_sym_volatile] = ACTIONS(522),
    [anon_sym_sealed] = ACTIONS(522),
    [anon_sym_non_DASHsealed] = ACTIONS(520),
    [anon_sym_record] = ACTIONS(522),
    [anon_sym_ATinterface] = ACTIONS(520),
    [anon_sym_interface] = ACTIONS(522),
    [anon_sym_byte] = ACTIONS(522),
    [anon_sym_short] = ACTIONS(522),
    [anon_sym_int] = ACTIONS(522),
    [anon_sym_long] = ACTIONS(522),
    [anon_sym_char] = ACTIONS(522),
    [anon_sym_float] = ACTIONS(522),
    [anon_sym_double] = ACTIONS(522),
    [sym_boolean_type] = ACTIONS(522),
    [sym_void_type] = ACTIONS(522),
    [sym_this] = ACTIONS(522),
    [sym_super] = ACTIONS(522),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [143] = {
    [ts_builtin_sym_end] = ACTIONS(524),
    [sym_identifier] = ACTIONS(526),
    [sym_decimal_integer_literal] = ACTIONS(526),
    [sym_hex_integer_literal] = ACTIONS(526),
    [sym_octal_integer_literal] = ACTIONS(524),
    [sym_binary_integer_literal] = ACTIONS(524),
    [sym_decimal_floating_point_literal] = ACTIONS(524),
    [sym_hex_floating_point_literal] = ACTIONS(526),
    [sym_true] = ACTIONS(526),
    [sym_false] = ACTIONS(526),
    [sym_character_literal] = ACTIONS(524),
    [sym_string_literal] = ACTIONS(526),
    [sym_text_block] = ACTIONS(524),
    [sym_null_literal] = ACTIONS(526),
    [anon_sym_LPAREN] = ACTIONS(524),
    [anon_sym_LT] = ACTIONS(524),
    [anon_sym_PLUS] = ACTIONS(526),
    [anon_sym_DASH] = ACTIONS(526),
    [anon_sym_final] = ACTIONS(526),
    [anon_sym_BANG] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_PLUS_PLUS] = ACTIONS(524),
    [anon_sym_DASH_DASH] = ACTIONS(524),
    [anon_sym_new] = ACTIONS(526),
    [anon_sym_class] = ACTIONS(526),
    [anon_sym_switch] = ACTIONS(526),
    [anon_sym_LBRACE] = ACTIONS(524),
    [anon_sym_RBRACE] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(526),
    [anon_sym_SEMI] = ACTIONS(524),
    [anon_sym_assert] = ACTIONS(526),
    [anon_sym_do] = ACTIONS(526),
    [anon_sym_while] = ACTIONS(526),
    [anon_sym_break] = ACTIONS(526),
    [anon_sym_continue] = ACTIONS(526),
    [anon_sym_return] = ACTIONS(526),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_synchronized] = ACTIONS(526),
    [anon_sym_throw] = ACTIONS(526),
    [anon_sym_try] = ACTIONS(526),
    [anon_sym_if] = ACTIONS(526),
    [anon_sym_else] = ACTIONS(526),
    [anon_sym_for] = ACTIONS(526),
    [anon_sym_AT] = ACTIONS(526),
    [anon_sym_open] = ACTIONS(526),
    [anon_sym_module] = ACTIONS(526),
    [anon_sym_static] = ACTIONS(526),
    [anon_sym_package] = ACTIONS(526),
    [anon_sym_import] = ACTIONS(526),
    [anon_sym_enum] = ACTIONS(526),
    [anon_sym_public] = ACTIONS(526),
    [anon_sym_protected] = ACTIONS(526),
    [anon_sym_private] = ACTIONS(526),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_strictfp] = ACTIONS(526),
    [anon_sym_native] = ACTIONS(526),
    [anon_sym_transient] = ACTIONS(526),
    [anon_sym_volatile] = ACTIONS(526),
    [anon_sym_sealed] = ACTIONS(526),
    [anon_sym_non_DASHsealed] = ACTIONS(524),
    [anon_sym_record] = ACTIONS(526),
    [anon_sym_ATinterface] = ACTIONS(524),
    [anon_sym_interface] = ACTIONS(526),
    [anon_sym_byte] = ACTIONS(526),
    [anon_sym_short] = ACTIONS(526),
    [anon_sym_int] = ACTIONS(526),
    [anon_sym_long] = ACTIONS(526),
    [anon_sym_char] = ACTIONS(526),
    [anon_sym_float] = ACTIONS(526),
    [anon_sym_double] = ACTIONS(526),
    [sym_boolean_type] = ACTIONS(526),
    [sym_void_type] = ACTIONS(526),
    [sym_this] = ACTIONS(526),
    [sym_super] = ACTIONS(526),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [144] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(605),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym_array_initializer] = STATE(1110),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(362),
    [anon_sym_RBRACE] = ACTIONS(528),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [145] = {
    [ts_builtin_sym_end] = ACTIONS(530),
    [sym_identifier] = ACTIONS(532),
    [sym_decimal_integer_literal] = ACTIONS(532),
    [sym_hex_integer_literal] = ACTIONS(532),
    [sym_octal_integer_literal] = ACTIONS(530),
    [sym_binary_integer_literal] = ACTIONS(530),
    [sym_decimal_floating_point_literal] = ACTIONS(530),
    [sym_hex_floating_point_literal] = ACTIONS(532),
    [sym_true] = ACTIONS(532),
    [sym_false] = ACTIONS(532),
    [sym_character_literal] = ACTIONS(530),
    [sym_string_literal] = ACTIONS(532),
    [sym_text_block] = ACTIONS(530),
    [sym_null_literal] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(530),
    [anon_sym_LT] = ACTIONS(530),
    [anon_sym_PLUS] = ACTIONS(532),
    [anon_sym_DASH] = ACTIONS(532),
    [anon_sym_final] = ACTIONS(532),
    [anon_sym_BANG] = ACTIONS(530),
    [anon_sym_TILDE] = ACTIONS(530),
    [anon_sym_PLUS_PLUS] = ACTIONS(530),
    [anon_sym_DASH_DASH] = ACTIONS(530),
    [anon_sym_new] = ACTIONS(532),
    [anon_sym_class] = ACTIONS(532),
    [anon_sym_switch] = ACTIONS(532),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(530),
    [anon_sym_case] = ACTIONS(532),
    [anon_sym_default] = ACTIONS(532),
    [anon_sym_SEMI] = ACTIONS(530),
    [anon_sym_assert] = ACTIONS(532),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_while] = ACTIONS(532),
    [anon_sym_break] = ACTIONS(532),
    [anon_sym_continue] = ACTIONS(532),
    [anon_sym_return] = ACTIONS(532),
    [anon_sym_yield] = ACTIONS(532),
    [anon_sym_synchronized] = ACTIONS(532),
    [anon_sym_throw] = ACTIONS(532),
    [anon_sym_try] = ACTIONS(532),
    [anon_sym_if] = ACTIONS(532),
    [anon_sym_else] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(532),
    [anon_sym_AT] = ACTIONS(532),
    [anon_sym_open] = ACTIONS(532),
    [anon_sym_module] = ACTIONS(532),
    [anon_sym_static] = ACTIONS(532),
    [anon_sym_package] = ACTIONS(532),
    [anon_sym_import] = ACTIONS(532),
    [anon_sym_enum] = ACTIONS(532),
    [anon_sym_public] = ACTIONS(532),
    [anon_sym_protected] = ACTIONS(532),
    [anon_sym_private] = ACTIONS(532),
    [anon_sym_abstract] = ACTIONS(532),
    [anon_sym_strictfp] = ACTIONS(532),
    [anon_sym_native] = ACTIONS(532),
    [anon_sym_transient] = ACTIONS(532),
    [anon_sym_volatile] = ACTIONS(532),
    [anon_sym_sealed] = ACTIONS(532),
    [anon_sym_non_DASHsealed] = ACTIONS(530),
    [anon_sym_record] = ACTIONS(532),
    [anon_sym_ATinterface] = ACTIONS(530),
    [anon_sym_interface] = ACTIONS(532),
    [anon_sym_byte] = ACTIONS(532),
    [anon_sym_short] = ACTIONS(532),
    [anon_sym_int] = ACTIONS(532),
    [anon_sym_long] = ACTIONS(532),
    [anon_sym_char] = ACTIONS(532),
    [anon_sym_float] = ACTIONS(532),
    [anon_sym_double] = ACTIONS(532),
    [sym_boolean_type] = ACTIONS(532),
    [sym_void_type] = ACTIONS(532),
    [sym_this] = ACTIONS(532),
    [sym_super] = ACTIONS(532),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [146] = {
    [ts_builtin_sym_end] = ACTIONS(534),
    [sym_identifier] = ACTIONS(536),
    [sym_decimal_integer_literal] = ACTIONS(536),
    [sym_hex_integer_literal] = ACTIONS(536),
    [sym_octal_integer_literal] = ACTIONS(534),
    [sym_binary_integer_literal] = ACTIONS(534),
    [sym_decimal_floating_point_literal] = ACTIONS(534),
    [sym_hex_floating_point_literal] = ACTIONS(536),
    [sym_true] = ACTIONS(536),
    [sym_false] = ACTIONS(536),
    [sym_character_literal] = ACTIONS(534),
    [sym_string_literal] = ACTIONS(536),
    [sym_text_block] = ACTIONS(534),
    [sym_null_literal] = ACTIONS(536),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_LT] = ACTIONS(534),
    [anon_sym_PLUS] = ACTIONS(536),
    [anon_sym_DASH] = ACTIONS(536),
    [anon_sym_final] = ACTIONS(536),
    [anon_sym_BANG] = ACTIONS(534),
    [anon_sym_TILDE] = ACTIONS(534),
    [anon_sym_PLUS_PLUS] = ACTIONS(534),
    [anon_sym_DASH_DASH] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(536),
    [anon_sym_class] = ACTIONS(536),
    [anon_sym_switch] = ACTIONS(536),
    [anon_sym_LBRACE] = ACTIONS(534),
    [anon_sym_RBRACE] = ACTIONS(534),
    [anon_sym_case] = ACTIONS(536),
    [anon_sym_default] = ACTIONS(536),
    [anon_sym_SEMI] = ACTIONS(534),
    [anon_sym_assert] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(536),
    [anon_sym_while] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(536),
    [anon_sym_continue] = ACTIONS(536),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_yield] = ACTIONS(536),
    [anon_sym_synchronized] = ACTIONS(536),
    [anon_sym_throw] = ACTIONS(536),
    [anon_sym_try] = ACTIONS(536),
    [anon_sym_if] = ACTIONS(536),
    [anon_sym_else] = ACTIONS(536),
    [anon_sym_for] = ACTIONS(536),
    [anon_sym_AT] = ACTIONS(536),
    [anon_sym_open] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_package] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(536),
    [anon_sym_enum] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_abstract] = ACTIONS(536),
    [anon_sym_strictfp] = ACTIONS(536),
    [anon_sym_native] = ACTIONS(536),
    [anon_sym_transient] = ACTIONS(536),
    [anon_sym_volatile] = ACTIONS(536),
    [anon_sym_sealed] = ACTIONS(536),
    [anon_sym_non_DASHsealed] = ACTIONS(534),
    [anon_sym_record] = ACTIONS(536),
    [anon_sym_ATinterface] = ACTIONS(534),
    [anon_sym_interface] = ACTIONS(536),
    [anon_sym_byte] = ACTIONS(536),
    [anon_sym_short] = ACTIONS(536),
    [anon_sym_int] = ACTIONS(536),
    [anon_sym_long] = ACTIONS(536),
    [anon_sym_char] = ACTIONS(536),
    [anon_sym_float] = ACTIONS(536),
    [anon_sym_double] = ACTIONS(536),
    [sym_boolean_type] = ACTIONS(536),
    [sym_void_type] = ACTIONS(536),
    [sym_this] = ACTIONS(536),
    [sym_super] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [147] = {
    [ts_builtin_sym_end] = ACTIONS(538),
    [sym_identifier] = ACTIONS(540),
    [sym_decimal_integer_literal] = ACTIONS(540),
    [sym_hex_integer_literal] = ACTIONS(540),
    [sym_octal_integer_literal] = ACTIONS(538),
    [sym_binary_integer_literal] = ACTIONS(538),
    [sym_decimal_floating_point_literal] = ACTIONS(538),
    [sym_hex_floating_point_literal] = ACTIONS(540),
    [sym_true] = ACTIONS(540),
    [sym_false] = ACTIONS(540),
    [sym_character_literal] = ACTIONS(538),
    [sym_string_literal] = ACTIONS(540),
    [sym_text_block] = ACTIONS(538),
    [sym_null_literal] = ACTIONS(540),
    [anon_sym_LPAREN] = ACTIONS(538),
    [anon_sym_LT] = ACTIONS(538),
    [anon_sym_PLUS] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(540),
    [anon_sym_final] = ACTIONS(540),
    [anon_sym_BANG] = ACTIONS(538),
    [anon_sym_TILDE] = ACTIONS(538),
    [anon_sym_PLUS_PLUS] = ACTIONS(538),
    [anon_sym_DASH_DASH] = ACTIONS(538),
    [anon_sym_new] = ACTIONS(540),
    [anon_sym_class] = ACTIONS(540),
    [anon_sym_switch] = ACTIONS(540),
    [anon_sym_LBRACE] = ACTIONS(538),
    [anon_sym_RBRACE] = ACTIONS(538),
    [anon_sym_case] = ACTIONS(540),
    [anon_sym_default] = ACTIONS(540),
    [anon_sym_SEMI] = ACTIONS(538),
    [anon_sym_assert] = ACTIONS(540),
    [anon_sym_do] = ACTIONS(540),
    [anon_sym_while] = ACTIONS(540),
    [anon_sym_break] = ACTIONS(540),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_return] = ACTIONS(540),
    [anon_sym_yield] = ACTIONS(540),
    [anon_sym_synchronized] = ACTIONS(540),
    [anon_sym_throw] = ACTIONS(540),
    [anon_sym_try] = ACTIONS(540),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_else] = ACTIONS(540),
    [anon_sym_for] = ACTIONS(540),
    [anon_sym_AT] = ACTIONS(540),
    [anon_sym_open] = ACTIONS(540),
    [anon_sym_module] = ACTIONS(540),
    [anon_sym_static] = ACTIONS(540),
    [anon_sym_package] = ACTIONS(540),
    [anon_sym_import] = ACTIONS(540),
    [anon_sym_enum] = ACTIONS(540),
    [anon_sym_public] = ACTIONS(540),
    [anon_sym_protected] = ACTIONS(540),
    [anon_sym_private] = ACTIONS(540),
    [anon_sym_abstract] = ACTIONS(540),
    [anon_sym_strictfp] = ACTIONS(540),
    [anon_sym_native] = ACTIONS(540),
    [anon_sym_transient] = ACTIONS(540),
    [anon_sym_volatile] = ACTIONS(540),
    [anon_sym_sealed] = ACTIONS(540),
    [anon_sym_non_DASHsealed] = ACTIONS(538),
    [anon_sym_record] = ACTIONS(540),
    [anon_sym_ATinterface] = ACTIONS(538),
    [anon_sym_interface] = ACTIONS(540),
    [anon_sym_byte] = ACTIONS(540),
    [anon_sym_short] = ACTIONS(540),
    [anon_sym_int] = ACTIONS(540),
    [anon_sym_long] = ACTIONS(540),
    [anon_sym_char] = ACTIONS(540),
    [anon_sym_float] = ACTIONS(540),
    [anon_sym_double] = ACTIONS(540),
    [sym_boolean_type] = ACTIONS(540),
    [sym_void_type] = ACTIONS(540),
    [sym_this] = ACTIONS(540),
    [sym_super] = ACTIONS(540),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [148] = {
    [ts_builtin_sym_end] = ACTIONS(542),
    [sym_identifier] = ACTIONS(544),
    [sym_decimal_integer_literal] = ACTIONS(544),
    [sym_hex_integer_literal] = ACTIONS(544),
    [sym_octal_integer_literal] = ACTIONS(542),
    [sym_binary_integer_literal] = ACTIONS(542),
    [sym_decimal_floating_point_literal] = ACTIONS(542),
    [sym_hex_floating_point_literal] = ACTIONS(544),
    [sym_true] = ACTIONS(544),
    [sym_false] = ACTIONS(544),
    [sym_character_literal] = ACTIONS(542),
    [sym_string_literal] = ACTIONS(544),
    [sym_text_block] = ACTIONS(542),
    [sym_null_literal] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(542),
    [anon_sym_PLUS] = ACTIONS(544),
    [anon_sym_DASH] = ACTIONS(544),
    [anon_sym_final] = ACTIONS(544),
    [anon_sym_BANG] = ACTIONS(542),
    [anon_sym_TILDE] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(542),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_class] = ACTIONS(544),
    [anon_sym_switch] = ACTIONS(544),
    [anon_sym_LBRACE] = ACTIONS(542),
    [anon_sym_RBRACE] = ACTIONS(542),
    [anon_sym_case] = ACTIONS(544),
    [anon_sym_default] = ACTIONS(544),
    [anon_sym_SEMI] = ACTIONS(542),
    [anon_sym_assert] = ACTIONS(544),
    [anon_sym_do] = ACTIONS(544),
    [anon_sym_while] = ACTIONS(544),
    [anon_sym_break] = ACTIONS(544),
    [anon_sym_continue] = ACTIONS(544),
    [anon_sym_return] = ACTIONS(544),
    [anon_sym_yield] = ACTIONS(544),
    [anon_sym_synchronized] = ACTIONS(544),
    [anon_sym_throw] = ACTIONS(544),
    [anon_sym_try] = ACTIONS(544),
    [anon_sym_if] = ACTIONS(544),
    [anon_sym_else] = ACTIONS(544),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_AT] = ACTIONS(544),
    [anon_sym_open] = ACTIONS(544),
    [anon_sym_module] = ACTIONS(544),
    [anon_sym_static] = ACTIONS(544),
    [anon_sym_package] = ACTIONS(544),
    [anon_sym_import] = ACTIONS(544),
    [anon_sym_enum] = ACTIONS(544),
    [anon_sym_public] = ACTIONS(544),
    [anon_sym_protected] = ACTIONS(544),
    [anon_sym_private] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(544),
    [anon_sym_strictfp] = ACTIONS(544),
    [anon_sym_native] = ACTIONS(544),
    [anon_sym_transient] = ACTIONS(544),
    [anon_sym_volatile] = ACTIONS(544),
    [anon_sym_sealed] = ACTIONS(544),
    [anon_sym_non_DASHsealed] = ACTIONS(542),
    [anon_sym_record] = ACTIONS(544),
    [anon_sym_ATinterface] = ACTIONS(542),
    [anon_sym_interface] = ACTIONS(544),
    [anon_sym_byte] = ACTIONS(544),
    [anon_sym_short] = ACTIONS(544),
    [anon_sym_int] = ACTIONS(544),
    [anon_sym_long] = ACTIONS(544),
    [anon_sym_char] = ACTIONS(544),
    [anon_sym_float] = ACTIONS(544),
    [anon_sym_double] = ACTIONS(544),
    [sym_boolean_type] = ACTIONS(544),
    [sym_void_type] = ACTIONS(544),
    [sym_this] = ACTIONS(544),
    [sym_super] = ACTIONS(544),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [149] = {
    [ts_builtin_sym_end] = ACTIONS(546),
    [sym_identifier] = ACTIONS(548),
    [sym_decimal_integer_literal] = ACTIONS(548),
    [sym_hex_integer_literal] = ACTIONS(548),
    [sym_octal_integer_literal] = ACTIONS(546),
    [sym_binary_integer_literal] = ACTIONS(546),
    [sym_decimal_floating_point_literal] = ACTIONS(546),
    [sym_hex_floating_point_literal] = ACTIONS(548),
    [sym_true] = ACTIONS(548),
    [sym_false] = ACTIONS(548),
    [sym_character_literal] = ACTIONS(546),
    [sym_string_literal] = ACTIONS(548),
    [sym_text_block] = ACTIONS(546),
    [sym_null_literal] = ACTIONS(548),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_LT] = ACTIONS(546),
    [anon_sym_PLUS] = ACTIONS(548),
    [anon_sym_DASH] = ACTIONS(548),
    [anon_sym_final] = ACTIONS(548),
    [anon_sym_BANG] = ACTIONS(546),
    [anon_sym_TILDE] = ACTIONS(546),
    [anon_sym_PLUS_PLUS] = ACTIONS(546),
    [anon_sym_DASH_DASH] = ACTIONS(546),
    [anon_sym_new] = ACTIONS(548),
    [anon_sym_class] = ACTIONS(548),
    [anon_sym_switch] = ACTIONS(548),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_RBRACE] = ACTIONS(546),
    [anon_sym_case] = ACTIONS(548),
    [anon_sym_default] = ACTIONS(548),
    [anon_sym_SEMI] = ACTIONS(546),
    [anon_sym_assert] = ACTIONS(548),
    [anon_sym_do] = ACTIONS(548),
    [anon_sym_while] = ACTIONS(548),
    [anon_sym_break] = ACTIONS(548),
    [anon_sym_continue] = ACTIONS(548),
    [anon_sym_return] = ACTIONS(548),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_synchronized] = ACTIONS(548),
    [anon_sym_throw] = ACTIONS(548),
    [anon_sym_try] = ACTIONS(548),
    [anon_sym_if] = ACTIONS(548),
    [anon_sym_else] = ACTIONS(548),
    [anon_sym_for] = ACTIONS(548),
    [anon_sym_AT] = ACTIONS(548),
    [anon_sym_open] = ACTIONS(548),
    [anon_sym_module] = ACTIONS(548),
    [anon_sym_static] = ACTIONS(548),
    [anon_sym_package] = ACTIONS(548),
    [anon_sym_import] = ACTIONS(548),
    [anon_sym_enum] = ACTIONS(548),
    [anon_sym_public] = ACTIONS(548),
    [anon_sym_protected] = ACTIONS(548),
    [anon_sym_private] = ACTIONS(548),
    [anon_sym_abstract] = ACTIONS(548),
    [anon_sym_strictfp] = ACTIONS(548),
    [anon_sym_native] = ACTIONS(548),
    [anon_sym_transient] = ACTIONS(548),
    [anon_sym_volatile] = ACTIONS(548),
    [anon_sym_sealed] = ACTIONS(548),
    [anon_sym_non_DASHsealed] = ACTIONS(546),
    [anon_sym_record] = ACTIONS(548),
    [anon_sym_ATinterface] = ACTIONS(546),
    [anon_sym_interface] = ACTIONS(548),
    [anon_sym_byte] = ACTIONS(548),
    [anon_sym_short] = ACTIONS(548),
    [anon_sym_int] = ACTIONS(548),
    [anon_sym_long] = ACTIONS(548),
    [anon_sym_char] = ACTIONS(548),
    [anon_sym_float] = ACTIONS(548),
    [anon_sym_double] = ACTIONS(548),
    [sym_boolean_type] = ACTIONS(548),
    [sym_void_type] = ACTIONS(548),
    [sym_this] = ACTIONS(548),
    [sym_super] = ACTIONS(548),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [150] = {
    [ts_builtin_sym_end] = ACTIONS(550),
    [sym_identifier] = ACTIONS(552),
    [sym_decimal_integer_literal] = ACTIONS(552),
    [sym_hex_integer_literal] = ACTIONS(552),
    [sym_octal_integer_literal] = ACTIONS(550),
    [sym_binary_integer_literal] = ACTIONS(550),
    [sym_decimal_floating_point_literal] = ACTIONS(550),
    [sym_hex_floating_point_literal] = ACTIONS(552),
    [sym_true] = ACTIONS(552),
    [sym_false] = ACTIONS(552),
    [sym_character_literal] = ACTIONS(550),
    [sym_string_literal] = ACTIONS(552),
    [sym_text_block] = ACTIONS(550),
    [sym_null_literal] = ACTIONS(552),
    [anon_sym_LPAREN] = ACTIONS(550),
    [anon_sym_LT] = ACTIONS(550),
    [anon_sym_PLUS] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(552),
    [anon_sym_final] = ACTIONS(552),
    [anon_sym_BANG] = ACTIONS(550),
    [anon_sym_TILDE] = ACTIONS(550),
    [anon_sym_PLUS_PLUS] = ACTIONS(550),
    [anon_sym_DASH_DASH] = ACTIONS(550),
    [anon_sym_new] = ACTIONS(552),
    [anon_sym_class] = ACTIONS(552),
    [anon_sym_switch] = ACTIONS(552),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_RBRACE] = ACTIONS(550),
    [anon_sym_case] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(550),
    [anon_sym_assert] = ACTIONS(552),
    [anon_sym_do] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_yield] = ACTIONS(552),
    [anon_sym_synchronized] = ACTIONS(552),
    [anon_sym_throw] = ACTIONS(552),
    [anon_sym_try] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_else] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_AT] = ACTIONS(552),
    [anon_sym_open] = ACTIONS(552),
    [anon_sym_module] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_package] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(552),
    [anon_sym_protected] = ACTIONS(552),
    [anon_sym_private] = ACTIONS(552),
    [anon_sym_abstract] = ACTIONS(552),
    [anon_sym_strictfp] = ACTIONS(552),
    [anon_sym_native] = ACTIONS(552),
    [anon_sym_transient] = ACTIONS(552),
    [anon_sym_volatile] = ACTIONS(552),
    [anon_sym_sealed] = ACTIONS(552),
    [anon_sym_non_DASHsealed] = ACTIONS(550),
    [anon_sym_record] = ACTIONS(552),
    [anon_sym_ATinterface] = ACTIONS(550),
    [anon_sym_interface] = ACTIONS(552),
    [anon_sym_byte] = ACTIONS(552),
    [anon_sym_short] = ACTIONS(552),
    [anon_sym_int] = ACTIONS(552),
    [anon_sym_long] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_float] = ACTIONS(552),
    [anon_sym_double] = ACTIONS(552),
    [sym_boolean_type] = ACTIONS(552),
    [sym_void_type] = ACTIONS(552),
    [sym_this] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [151] = {
    [ts_builtin_sym_end] = ACTIONS(554),
    [sym_identifier] = ACTIONS(556),
    [sym_decimal_integer_literal] = ACTIONS(556),
    [sym_hex_integer_literal] = ACTIONS(556),
    [sym_octal_integer_literal] = ACTIONS(554),
    [sym_binary_integer_literal] = ACTIONS(554),
    [sym_decimal_floating_point_literal] = ACTIONS(554),
    [sym_hex_floating_point_literal] = ACTIONS(556),
    [sym_true] = ACTIONS(556),
    [sym_false] = ACTIONS(556),
    [sym_character_literal] = ACTIONS(554),
    [sym_string_literal] = ACTIONS(556),
    [sym_text_block] = ACTIONS(554),
    [sym_null_literal] = ACTIONS(556),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(554),
    [anon_sym_PLUS] = ACTIONS(556),
    [anon_sym_DASH] = ACTIONS(556),
    [anon_sym_final] = ACTIONS(556),
    [anon_sym_BANG] = ACTIONS(554),
    [anon_sym_TILDE] = ACTIONS(554),
    [anon_sym_PLUS_PLUS] = ACTIONS(554),
    [anon_sym_DASH_DASH] = ACTIONS(554),
    [anon_sym_new] = ACTIONS(556),
    [anon_sym_class] = ACTIONS(556),
    [anon_sym_switch] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(554),
    [anon_sym_RBRACE] = ACTIONS(554),
    [anon_sym_case] = ACTIONS(556),
    [anon_sym_default] = ACTIONS(556),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_assert] = ACTIONS(556),
    [anon_sym_do] = ACTIONS(556),
    [anon_sym_while] = ACTIONS(556),
    [anon_sym_break] = ACTIONS(556),
    [anon_sym_continue] = ACTIONS(556),
    [anon_sym_return] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(556),
    [anon_sym_synchronized] = ACTIONS(556),
    [anon_sym_throw] = ACTIONS(556),
    [anon_sym_try] = ACTIONS(556),
    [anon_sym_if] = ACTIONS(556),
    [anon_sym_else] = ACTIONS(556),
    [anon_sym_for] = ACTIONS(556),
    [anon_sym_AT] = ACTIONS(556),
    [anon_sym_open] = ACTIONS(556),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_static] = ACTIONS(556),
    [anon_sym_package] = ACTIONS(556),
    [anon_sym_import] = ACTIONS(556),
    [anon_sym_enum] = ACTIONS(556),
    [anon_sym_public] = ACTIONS(556),
    [anon_sym_protected] = ACTIONS(556),
    [anon_sym_private] = ACTIONS(556),
    [anon_sym_abstract] = ACTIONS(556),
    [anon_sym_strictfp] = ACTIONS(556),
    [anon_sym_native] = ACTIONS(556),
    [anon_sym_transient] = ACTIONS(556),
    [anon_sym_volatile] = ACTIONS(556),
    [anon_sym_sealed] = ACTIONS(556),
    [anon_sym_non_DASHsealed] = ACTIONS(554),
    [anon_sym_record] = ACTIONS(556),
    [anon_sym_ATinterface] = ACTIONS(554),
    [anon_sym_interface] = ACTIONS(556),
    [anon_sym_byte] = ACTIONS(556),
    [anon_sym_short] = ACTIONS(556),
    [anon_sym_int] = ACTIONS(556),
    [anon_sym_long] = ACTIONS(556),
    [anon_sym_char] = ACTIONS(556),
    [anon_sym_float] = ACTIONS(556),
    [anon_sym_double] = ACTIONS(556),
    [sym_boolean_type] = ACTIONS(556),
    [sym_void_type] = ACTIONS(556),
    [sym_this] = ACTIONS(556),
    [sym_super] = ACTIONS(556),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [152] = {
    [ts_builtin_sym_end] = ACTIONS(558),
    [sym_identifier] = ACTIONS(560),
    [sym_decimal_integer_literal] = ACTIONS(560),
    [sym_hex_integer_literal] = ACTIONS(560),
    [sym_octal_integer_literal] = ACTIONS(558),
    [sym_binary_integer_literal] = ACTIONS(558),
    [sym_decimal_floating_point_literal] = ACTIONS(558),
    [sym_hex_floating_point_literal] = ACTIONS(560),
    [sym_true] = ACTIONS(560),
    [sym_false] = ACTIONS(560),
    [sym_character_literal] = ACTIONS(558),
    [sym_string_literal] = ACTIONS(560),
    [sym_text_block] = ACTIONS(558),
    [sym_null_literal] = ACTIONS(560),
    [anon_sym_LPAREN] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(558),
    [anon_sym_PLUS] = ACTIONS(560),
    [anon_sym_DASH] = ACTIONS(560),
    [anon_sym_final] = ACTIONS(560),
    [anon_sym_BANG] = ACTIONS(558),
    [anon_sym_TILDE] = ACTIONS(558),
    [anon_sym_PLUS_PLUS] = ACTIONS(558),
    [anon_sym_DASH_DASH] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(560),
    [anon_sym_class] = ACTIONS(560),
    [anon_sym_switch] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(558),
    [anon_sym_RBRACE] = ACTIONS(558),
    [anon_sym_case] = ACTIONS(560),
    [anon_sym_default] = ACTIONS(560),
    [anon_sym_SEMI] = ACTIONS(558),
    [anon_sym_assert] = ACTIONS(560),
    [anon_sym_do] = ACTIONS(560),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_break] = ACTIONS(560),
    [anon_sym_continue] = ACTIONS(560),
    [anon_sym_return] = ACTIONS(560),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_synchronized] = ACTIONS(560),
    [anon_sym_throw] = ACTIONS(560),
    [anon_sym_try] = ACTIONS(560),
    [anon_sym_if] = ACTIONS(560),
    [anon_sym_else] = ACTIONS(560),
    [anon_sym_for] = ACTIONS(560),
    [anon_sym_AT] = ACTIONS(560),
    [anon_sym_open] = ACTIONS(560),
    [anon_sym_module] = ACTIONS(560),
    [anon_sym_static] = ACTIONS(560),
    [anon_sym_package] = ACTIONS(560),
    [anon_sym_import] = ACTIONS(560),
    [anon_sym_enum] = ACTIONS(560),
    [anon_sym_public] = ACTIONS(560),
    [anon_sym_protected] = ACTIONS(560),
    [anon_sym_private] = ACTIONS(560),
    [anon_sym_abstract] = ACTIONS(560),
    [anon_sym_strictfp] = ACTIONS(560),
    [anon_sym_native] = ACTIONS(560),
    [anon_sym_transient] = ACTIONS(560),
    [anon_sym_volatile] = ACTIONS(560),
    [anon_sym_sealed] = ACTIONS(560),
    [anon_sym_non_DASHsealed] = ACTIONS(558),
    [anon_sym_record] = ACTIONS(560),
    [anon_sym_ATinterface] = ACTIONS(558),
    [anon_sym_interface] = ACTIONS(560),
    [anon_sym_byte] = ACTIONS(560),
    [anon_sym_short] = ACTIONS(560),
    [anon_sym_int] = ACTIONS(560),
    [anon_sym_long] = ACTIONS(560),
    [anon_sym_char] = ACTIONS(560),
    [anon_sym_float] = ACTIONS(560),
    [anon_sym_double] = ACTIONS(560),
    [sym_boolean_type] = ACTIONS(560),
    [sym_void_type] = ACTIONS(560),
    [sym_this] = ACTIONS(560),
    [sym_super] = ACTIONS(560),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [153] = {
    [ts_builtin_sym_end] = ACTIONS(562),
    [sym_identifier] = ACTIONS(564),
    [sym_decimal_integer_literal] = ACTIONS(564),
    [sym_hex_integer_literal] = ACTIONS(564),
    [sym_octal_integer_literal] = ACTIONS(562),
    [sym_binary_integer_literal] = ACTIONS(562),
    [sym_decimal_floating_point_literal] = ACTIONS(562),
    [sym_hex_floating_point_literal] = ACTIONS(564),
    [sym_true] = ACTIONS(564),
    [sym_false] = ACTIONS(564),
    [sym_character_literal] = ACTIONS(562),
    [sym_string_literal] = ACTIONS(564),
    [sym_text_block] = ACTIONS(562),
    [sym_null_literal] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_final] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(562),
    [anon_sym_TILDE] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(562),
    [anon_sym_DASH_DASH] = ACTIONS(562),
    [anon_sym_new] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(564),
    [anon_sym_switch] = ACTIONS(564),
    [anon_sym_LBRACE] = ACTIONS(562),
    [anon_sym_RBRACE] = ACTIONS(562),
    [anon_sym_case] = ACTIONS(564),
    [anon_sym_default] = ACTIONS(564),
    [anon_sym_SEMI] = ACTIONS(562),
    [anon_sym_assert] = ACTIONS(564),
    [anon_sym_do] = ACTIONS(564),
    [anon_sym_while] = ACTIONS(564),
    [anon_sym_break] = ACTIONS(564),
    [anon_sym_continue] = ACTIONS(564),
    [anon_sym_return] = ACTIONS(564),
    [anon_sym_yield] = ACTIONS(564),
    [anon_sym_synchronized] = ACTIONS(564),
    [anon_sym_throw] = ACTIONS(564),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_if] = ACTIONS(564),
    [anon_sym_else] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_AT] = ACTIONS(564),
    [anon_sym_open] = ACTIONS(564),
    [anon_sym_module] = ACTIONS(564),
    [anon_sym_static] = ACTIONS(564),
    [anon_sym_package] = ACTIONS(564),
    [anon_sym_import] = ACTIONS(564),
    [anon_sym_enum] = ACTIONS(564),
    [anon_sym_public] = ACTIONS(564),
    [anon_sym_protected] = ACTIONS(564),
    [anon_sym_private] = ACTIONS(564),
    [anon_sym_abstract] = ACTIONS(564),
    [anon_sym_strictfp] = ACTIONS(564),
    [anon_sym_native] = ACTIONS(564),
    [anon_sym_transient] = ACTIONS(564),
    [anon_sym_volatile] = ACTIONS(564),
    [anon_sym_sealed] = ACTIONS(564),
    [anon_sym_non_DASHsealed] = ACTIONS(562),
    [anon_sym_record] = ACTIONS(564),
    [anon_sym_ATinterface] = ACTIONS(562),
    [anon_sym_interface] = ACTIONS(564),
    [anon_sym_byte] = ACTIONS(564),
    [anon_sym_short] = ACTIONS(564),
    [anon_sym_int] = ACTIONS(564),
    [anon_sym_long] = ACTIONS(564),
    [anon_sym_char] = ACTIONS(564),
    [anon_sym_float] = ACTIONS(564),
    [anon_sym_double] = ACTIONS(564),
    [sym_boolean_type] = ACTIONS(564),
    [sym_void_type] = ACTIONS(564),
    [sym_this] = ACTIONS(564),
    [sym_super] = ACTIONS(564),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [154] = {
    [ts_builtin_sym_end] = ACTIONS(566),
    [sym_identifier] = ACTIONS(568),
    [sym_decimal_integer_literal] = ACTIONS(568),
    [sym_hex_integer_literal] = ACTIONS(568),
    [sym_octal_integer_literal] = ACTIONS(566),
    [sym_binary_integer_literal] = ACTIONS(566),
    [sym_decimal_floating_point_literal] = ACTIONS(566),
    [sym_hex_floating_point_literal] = ACTIONS(568),
    [sym_true] = ACTIONS(568),
    [sym_false] = ACTIONS(568),
    [sym_character_literal] = ACTIONS(566),
    [sym_string_literal] = ACTIONS(568),
    [sym_text_block] = ACTIONS(566),
    [sym_null_literal] = ACTIONS(568),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_LT] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(568),
    [anon_sym_DASH] = ACTIONS(568),
    [anon_sym_final] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(566),
    [anon_sym_TILDE] = ACTIONS(566),
    [anon_sym_PLUS_PLUS] = ACTIONS(566),
    [anon_sym_DASH_DASH] = ACTIONS(566),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_class] = ACTIONS(568),
    [anon_sym_switch] = ACTIONS(568),
    [anon_sym_LBRACE] = ACTIONS(566),
    [anon_sym_RBRACE] = ACTIONS(566),
    [anon_sym_case] = ACTIONS(568),
    [anon_sym_default] = ACTIONS(568),
    [anon_sym_SEMI] = ACTIONS(566),
    [anon_sym_assert] = ACTIONS(568),
    [anon_sym_do] = ACTIONS(568),
    [anon_sym_while] = ACTIONS(568),
    [anon_sym_break] = ACTIONS(568),
    [anon_sym_continue] = ACTIONS(568),
    [anon_sym_return] = ACTIONS(568),
    [anon_sym_yield] = ACTIONS(568),
    [anon_sym_synchronized] = ACTIONS(568),
    [anon_sym_throw] = ACTIONS(568),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_if] = ACTIONS(568),
    [anon_sym_else] = ACTIONS(568),
    [anon_sym_for] = ACTIONS(568),
    [anon_sym_AT] = ACTIONS(568),
    [anon_sym_open] = ACTIONS(568),
    [anon_sym_module] = ACTIONS(568),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_package] = ACTIONS(568),
    [anon_sym_import] = ACTIONS(568),
    [anon_sym_enum] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_abstract] = ACTIONS(568),
    [anon_sym_strictfp] = ACTIONS(568),
    [anon_sym_native] = ACTIONS(568),
    [anon_sym_transient] = ACTIONS(568),
    [anon_sym_volatile] = ACTIONS(568),
    [anon_sym_sealed] = ACTIONS(568),
    [anon_sym_non_DASHsealed] = ACTIONS(566),
    [anon_sym_record] = ACTIONS(568),
    [anon_sym_ATinterface] = ACTIONS(566),
    [anon_sym_interface] = ACTIONS(568),
    [anon_sym_byte] = ACTIONS(568),
    [anon_sym_short] = ACTIONS(568),
    [anon_sym_int] = ACTIONS(568),
    [anon_sym_long] = ACTIONS(568),
    [anon_sym_char] = ACTIONS(568),
    [anon_sym_float] = ACTIONS(568),
    [anon_sym_double] = ACTIONS(568),
    [sym_boolean_type] = ACTIONS(568),
    [sym_void_type] = ACTIONS(568),
    [sym_this] = ACTIONS(568),
    [sym_super] = ACTIONS(568),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [155] = {
    [ts_builtin_sym_end] = ACTIONS(570),
    [sym_identifier] = ACTIONS(572),
    [sym_decimal_integer_literal] = ACTIONS(572),
    [sym_hex_integer_literal] = ACTIONS(572),
    [sym_octal_integer_literal] = ACTIONS(570),
    [sym_binary_integer_literal] = ACTIONS(570),
    [sym_decimal_floating_point_literal] = ACTIONS(570),
    [sym_hex_floating_point_literal] = ACTIONS(572),
    [sym_true] = ACTIONS(572),
    [sym_false] = ACTIONS(572),
    [sym_character_literal] = ACTIONS(570),
    [sym_string_literal] = ACTIONS(572),
    [sym_text_block] = ACTIONS(570),
    [sym_null_literal] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_LT] = ACTIONS(570),
    [anon_sym_PLUS] = ACTIONS(572),
    [anon_sym_DASH] = ACTIONS(572),
    [anon_sym_final] = ACTIONS(572),
    [anon_sym_BANG] = ACTIONS(570),
    [anon_sym_TILDE] = ACTIONS(570),
    [anon_sym_PLUS_PLUS] = ACTIONS(570),
    [anon_sym_DASH_DASH] = ACTIONS(570),
    [anon_sym_new] = ACTIONS(572),
    [anon_sym_class] = ACTIONS(572),
    [anon_sym_switch] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(570),
    [anon_sym_RBRACE] = ACTIONS(570),
    [anon_sym_case] = ACTIONS(572),
    [anon_sym_default] = ACTIONS(572),
    [anon_sym_SEMI] = ACTIONS(570),
    [anon_sym_assert] = ACTIONS(572),
    [anon_sym_do] = ACTIONS(572),
    [anon_sym_while] = ACTIONS(572),
    [anon_sym_break] = ACTIONS(572),
    [anon_sym_continue] = ACTIONS(572),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(572),
    [anon_sym_synchronized] = ACTIONS(572),
    [anon_sym_throw] = ACTIONS(572),
    [anon_sym_try] = ACTIONS(572),
    [anon_sym_if] = ACTIONS(572),
    [anon_sym_else] = ACTIONS(572),
    [anon_sym_for] = ACTIONS(572),
    [anon_sym_AT] = ACTIONS(572),
    [anon_sym_open] = ACTIONS(572),
    [anon_sym_module] = ACTIONS(572),
    [anon_sym_static] = ACTIONS(572),
    [anon_sym_package] = ACTIONS(572),
    [anon_sym_import] = ACTIONS(572),
    [anon_sym_enum] = ACTIONS(572),
    [anon_sym_public] = ACTIONS(572),
    [anon_sym_protected] = ACTIONS(572),
    [anon_sym_private] = ACTIONS(572),
    [anon_sym_abstract] = ACTIONS(572),
    [anon_sym_strictfp] = ACTIONS(572),
    [anon_sym_native] = ACTIONS(572),
    [anon_sym_transient] = ACTIONS(572),
    [anon_sym_volatile] = ACTIONS(572),
    [anon_sym_sealed] = ACTIONS(572),
    [anon_sym_non_DASHsealed] = ACTIONS(570),
    [anon_sym_record] = ACTIONS(572),
    [anon_sym_ATinterface] = ACTIONS(570),
    [anon_sym_interface] = ACTIONS(572),
    [anon_sym_byte] = ACTIONS(572),
    [anon_sym_short] = ACTIONS(572),
    [anon_sym_int] = ACTIONS(572),
    [anon_sym_long] = ACTIONS(572),
    [anon_sym_char] = ACTIONS(572),
    [anon_sym_float] = ACTIONS(572),
    [anon_sym_double] = ACTIONS(572),
    [sym_boolean_type] = ACTIONS(572),
    [sym_void_type] = ACTIONS(572),
    [sym_this] = ACTIONS(572),
    [sym_super] = ACTIONS(572),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [156] = {
    [ts_builtin_sym_end] = ACTIONS(574),
    [sym_identifier] = ACTIONS(576),
    [sym_decimal_integer_literal] = ACTIONS(576),
    [sym_hex_integer_literal] = ACTIONS(576),
    [sym_octal_integer_literal] = ACTIONS(574),
    [sym_binary_integer_literal] = ACTIONS(574),
    [sym_decimal_floating_point_literal] = ACTIONS(574),
    [sym_hex_floating_point_literal] = ACTIONS(576),
    [sym_true] = ACTIONS(576),
    [sym_false] = ACTIONS(576),
    [sym_character_literal] = ACTIONS(574),
    [sym_string_literal] = ACTIONS(576),
    [sym_text_block] = ACTIONS(574),
    [sym_null_literal] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(574),
    [anon_sym_LT] = ACTIONS(574),
    [anon_sym_PLUS] = ACTIONS(576),
    [anon_sym_DASH] = ACTIONS(576),
    [anon_sym_final] = ACTIONS(576),
    [anon_sym_BANG] = ACTIONS(574),
    [anon_sym_TILDE] = ACTIONS(574),
    [anon_sym_PLUS_PLUS] = ACTIONS(574),
    [anon_sym_DASH_DASH] = ACTIONS(574),
    [anon_sym_new] = ACTIONS(576),
    [anon_sym_class] = ACTIONS(576),
    [anon_sym_switch] = ACTIONS(576),
    [anon_sym_LBRACE] = ACTIONS(574),
    [anon_sym_RBRACE] = ACTIONS(574),
    [anon_sym_case] = ACTIONS(576),
    [anon_sym_default] = ACTIONS(576),
    [anon_sym_SEMI] = ACTIONS(574),
    [anon_sym_assert] = ACTIONS(576),
    [anon_sym_do] = ACTIONS(576),
    [anon_sym_while] = ACTIONS(576),
    [anon_sym_break] = ACTIONS(576),
    [anon_sym_continue] = ACTIONS(576),
    [anon_sym_return] = ACTIONS(576),
    [anon_sym_yield] = ACTIONS(576),
    [anon_sym_synchronized] = ACTIONS(576),
    [anon_sym_throw] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(576),
    [anon_sym_if] = ACTIONS(576),
    [anon_sym_else] = ACTIONS(576),
    [anon_sym_for] = ACTIONS(576),
    [anon_sym_AT] = ACTIONS(576),
    [anon_sym_open] = ACTIONS(576),
    [anon_sym_module] = ACTIONS(576),
    [anon_sym_static] = ACTIONS(576),
    [anon_sym_package] = ACTIONS(576),
    [anon_sym_import] = ACTIONS(576),
    [anon_sym_enum] = ACTIONS(576),
    [anon_sym_public] = ACTIONS(576),
    [anon_sym_protected] = ACTIONS(576),
    [anon_sym_private] = ACTIONS(576),
    [anon_sym_abstract] = ACTIONS(576),
    [anon_sym_strictfp] = ACTIONS(576),
    [anon_sym_native] = ACTIONS(576),
    [anon_sym_transient] = ACTIONS(576),
    [anon_sym_volatile] = ACTIONS(576),
    [anon_sym_sealed] = ACTIONS(576),
    [anon_sym_non_DASHsealed] = ACTIONS(574),
    [anon_sym_record] = ACTIONS(576),
    [anon_sym_ATinterface] = ACTIONS(574),
    [anon_sym_interface] = ACTIONS(576),
    [anon_sym_byte] = ACTIONS(576),
    [anon_sym_short] = ACTIONS(576),
    [anon_sym_int] = ACTIONS(576),
    [anon_sym_long] = ACTIONS(576),
    [anon_sym_char] = ACTIONS(576),
    [anon_sym_float] = ACTIONS(576),
    [anon_sym_double] = ACTIONS(576),
    [sym_boolean_type] = ACTIONS(576),
    [sym_void_type] = ACTIONS(576),
    [sym_this] = ACTIONS(576),
    [sym_super] = ACTIONS(576),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [157] = {
    [ts_builtin_sym_end] = ACTIONS(578),
    [sym_identifier] = ACTIONS(580),
    [sym_decimal_integer_literal] = ACTIONS(580),
    [sym_hex_integer_literal] = ACTIONS(580),
    [sym_octal_integer_literal] = ACTIONS(578),
    [sym_binary_integer_literal] = ACTIONS(578),
    [sym_decimal_floating_point_literal] = ACTIONS(578),
    [sym_hex_floating_point_literal] = ACTIONS(580),
    [sym_true] = ACTIONS(580),
    [sym_false] = ACTIONS(580),
    [sym_character_literal] = ACTIONS(578),
    [sym_string_literal] = ACTIONS(580),
    [sym_text_block] = ACTIONS(578),
    [sym_null_literal] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_final] = ACTIONS(580),
    [anon_sym_BANG] = ACTIONS(578),
    [anon_sym_TILDE] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(578),
    [anon_sym_DASH_DASH] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(580),
    [anon_sym_class] = ACTIONS(580),
    [anon_sym_switch] = ACTIONS(580),
    [anon_sym_LBRACE] = ACTIONS(578),
    [anon_sym_RBRACE] = ACTIONS(578),
    [anon_sym_case] = ACTIONS(580),
    [anon_sym_default] = ACTIONS(580),
    [anon_sym_SEMI] = ACTIONS(578),
    [anon_sym_assert] = ACTIONS(580),
    [anon_sym_do] = ACTIONS(580),
    [anon_sym_while] = ACTIONS(580),
    [anon_sym_break] = ACTIONS(580),
    [anon_sym_continue] = ACTIONS(580),
    [anon_sym_return] = ACTIONS(580),
    [anon_sym_yield] = ACTIONS(580),
    [anon_sym_synchronized] = ACTIONS(580),
    [anon_sym_throw] = ACTIONS(580),
    [anon_sym_try] = ACTIONS(580),
    [anon_sym_if] = ACTIONS(580),
    [anon_sym_else] = ACTIONS(580),
    [anon_sym_for] = ACTIONS(580),
    [anon_sym_AT] = ACTIONS(580),
    [anon_sym_open] = ACTIONS(580),
    [anon_sym_module] = ACTIONS(580),
    [anon_sym_static] = ACTIONS(580),
    [anon_sym_package] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_enum] = ACTIONS(580),
    [anon_sym_public] = ACTIONS(580),
    [anon_sym_protected] = ACTIONS(580),
    [anon_sym_private] = ACTIONS(580),
    [anon_sym_abstract] = ACTIONS(580),
    [anon_sym_strictfp] = ACTIONS(580),
    [anon_sym_native] = ACTIONS(580),
    [anon_sym_transient] = ACTIONS(580),
    [anon_sym_volatile] = ACTIONS(580),
    [anon_sym_sealed] = ACTIONS(580),
    [anon_sym_non_DASHsealed] = ACTIONS(578),
    [anon_sym_record] = ACTIONS(580),
    [anon_sym_ATinterface] = ACTIONS(578),
    [anon_sym_interface] = ACTIONS(580),
    [anon_sym_byte] = ACTIONS(580),
    [anon_sym_short] = ACTIONS(580),
    [anon_sym_int] = ACTIONS(580),
    [anon_sym_long] = ACTIONS(580),
    [anon_sym_char] = ACTIONS(580),
    [anon_sym_float] = ACTIONS(580),
    [anon_sym_double] = ACTIONS(580),
    [sym_boolean_type] = ACTIONS(580),
    [sym_void_type] = ACTIONS(580),
    [sym_this] = ACTIONS(580),
    [sym_super] = ACTIONS(580),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [158] = {
    [ts_builtin_sym_end] = ACTIONS(582),
    [sym_identifier] = ACTIONS(584),
    [sym_decimal_integer_literal] = ACTIONS(584),
    [sym_hex_integer_literal] = ACTIONS(584),
    [sym_octal_integer_literal] = ACTIONS(582),
    [sym_binary_integer_literal] = ACTIONS(582),
    [sym_decimal_floating_point_literal] = ACTIONS(582),
    [sym_hex_floating_point_literal] = ACTIONS(584),
    [sym_true] = ACTIONS(584),
    [sym_false] = ACTIONS(584),
    [sym_character_literal] = ACTIONS(582),
    [sym_string_literal] = ACTIONS(584),
    [sym_text_block] = ACTIONS(582),
    [sym_null_literal] = ACTIONS(584),
    [anon_sym_LPAREN] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_final] = ACTIONS(584),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_TILDE] = ACTIONS(582),
    [anon_sym_PLUS_PLUS] = ACTIONS(582),
    [anon_sym_DASH_DASH] = ACTIONS(582),
    [anon_sym_new] = ACTIONS(584),
    [anon_sym_class] = ACTIONS(584),
    [anon_sym_switch] = ACTIONS(584),
    [anon_sym_LBRACE] = ACTIONS(582),
    [anon_sym_RBRACE] = ACTIONS(582),
    [anon_sym_case] = ACTIONS(584),
    [anon_sym_default] = ACTIONS(584),
    [anon_sym_SEMI] = ACTIONS(582),
    [anon_sym_assert] = ACTIONS(584),
    [anon_sym_do] = ACTIONS(584),
    [anon_sym_while] = ACTIONS(584),
    [anon_sym_break] = ACTIONS(584),
    [anon_sym_continue] = ACTIONS(584),
    [anon_sym_return] = ACTIONS(584),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_synchronized] = ACTIONS(584),
    [anon_sym_throw] = ACTIONS(584),
    [anon_sym_try] = ACTIONS(584),
    [anon_sym_if] = ACTIONS(584),
    [anon_sym_else] = ACTIONS(584),
    [anon_sym_for] = ACTIONS(584),
    [anon_sym_AT] = ACTIONS(584),
    [anon_sym_open] = ACTIONS(584),
    [anon_sym_module] = ACTIONS(584),
    [anon_sym_static] = ACTIONS(584),
    [anon_sym_package] = ACTIONS(584),
    [anon_sym_import] = ACTIONS(584),
    [anon_sym_enum] = ACTIONS(584),
    [anon_sym_public] = ACTIONS(584),
    [anon_sym_protected] = ACTIONS(584),
    [anon_sym_private] = ACTIONS(584),
    [anon_sym_abstract] = ACTIONS(584),
    [anon_sym_strictfp] = ACTIONS(584),
    [anon_sym_native] = ACTIONS(584),
    [anon_sym_transient] = ACTIONS(584),
    [anon_sym_volatile] = ACTIONS(584),
    [anon_sym_sealed] = ACTIONS(584),
    [anon_sym_non_DASHsealed] = ACTIONS(582),
    [anon_sym_record] = ACTIONS(584),
    [anon_sym_ATinterface] = ACTIONS(582),
    [anon_sym_interface] = ACTIONS(584),
    [anon_sym_byte] = ACTIONS(584),
    [anon_sym_short] = ACTIONS(584),
    [anon_sym_int] = ACTIONS(584),
    [anon_sym_long] = ACTIONS(584),
    [anon_sym_char] = ACTIONS(584),
    [anon_sym_float] = ACTIONS(584),
    [anon_sym_double] = ACTIONS(584),
    [sym_boolean_type] = ACTIONS(584),
    [sym_void_type] = ACTIONS(584),
    [sym_this] = ACTIONS(584),
    [sym_super] = ACTIONS(584),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [159] = {
    [ts_builtin_sym_end] = ACTIONS(586),
    [sym_identifier] = ACTIONS(588),
    [sym_decimal_integer_literal] = ACTIONS(588),
    [sym_hex_integer_literal] = ACTIONS(588),
    [sym_octal_integer_literal] = ACTIONS(586),
    [sym_binary_integer_literal] = ACTIONS(586),
    [sym_decimal_floating_point_literal] = ACTIONS(586),
    [sym_hex_floating_point_literal] = ACTIONS(588),
    [sym_true] = ACTIONS(588),
    [sym_false] = ACTIONS(588),
    [sym_character_literal] = ACTIONS(586),
    [sym_string_literal] = ACTIONS(588),
    [sym_text_block] = ACTIONS(586),
    [sym_null_literal] = ACTIONS(588),
    [anon_sym_LPAREN] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(586),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_final] = ACTIONS(588),
    [anon_sym_BANG] = ACTIONS(586),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_PLUS_PLUS] = ACTIONS(586),
    [anon_sym_DASH_DASH] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(588),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_switch] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(586),
    [anon_sym_RBRACE] = ACTIONS(586),
    [anon_sym_case] = ACTIONS(588),
    [anon_sym_default] = ACTIONS(588),
    [anon_sym_SEMI] = ACTIONS(586),
    [anon_sym_assert] = ACTIONS(588),
    [anon_sym_do] = ACTIONS(588),
    [anon_sym_while] = ACTIONS(588),
    [anon_sym_break] = ACTIONS(588),
    [anon_sym_continue] = ACTIONS(588),
    [anon_sym_return] = ACTIONS(588),
    [anon_sym_yield] = ACTIONS(588),
    [anon_sym_synchronized] = ACTIONS(588),
    [anon_sym_throw] = ACTIONS(588),
    [anon_sym_try] = ACTIONS(588),
    [anon_sym_if] = ACTIONS(588),
    [anon_sym_else] = ACTIONS(588),
    [anon_sym_for] = ACTIONS(588),
    [anon_sym_AT] = ACTIONS(588),
    [anon_sym_open] = ACTIONS(588),
    [anon_sym_module] = ACTIONS(588),
    [anon_sym_static] = ACTIONS(588),
    [anon_sym_package] = ACTIONS(588),
    [anon_sym_import] = ACTIONS(588),
    [anon_sym_enum] = ACTIONS(588),
    [anon_sym_public] = ACTIONS(588),
    [anon_sym_protected] = ACTIONS(588),
    [anon_sym_private] = ACTIONS(588),
    [anon_sym_abstract] = ACTIONS(588),
    [anon_sym_strictfp] = ACTIONS(588),
    [anon_sym_native] = ACTIONS(588),
    [anon_sym_transient] = ACTIONS(588),
    [anon_sym_volatile] = ACTIONS(588),
    [anon_sym_sealed] = ACTIONS(588),
    [anon_sym_non_DASHsealed] = ACTIONS(586),
    [anon_sym_record] = ACTIONS(588),
    [anon_sym_ATinterface] = ACTIONS(586),
    [anon_sym_interface] = ACTIONS(588),
    [anon_sym_byte] = ACTIONS(588),
    [anon_sym_short] = ACTIONS(588),
    [anon_sym_int] = ACTIONS(588),
    [anon_sym_long] = ACTIONS(588),
    [anon_sym_char] = ACTIONS(588),
    [anon_sym_float] = ACTIONS(588),
    [anon_sym_double] = ACTIONS(588),
    [sym_boolean_type] = ACTIONS(588),
    [sym_void_type] = ACTIONS(588),
    [sym_this] = ACTIONS(588),
    [sym_super] = ACTIONS(588),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [160] = {
    [ts_builtin_sym_end] = ACTIONS(590),
    [sym_identifier] = ACTIONS(592),
    [sym_decimal_integer_literal] = ACTIONS(592),
    [sym_hex_integer_literal] = ACTIONS(592),
    [sym_octal_integer_literal] = ACTIONS(590),
    [sym_binary_integer_literal] = ACTIONS(590),
    [sym_decimal_floating_point_literal] = ACTIONS(590),
    [sym_hex_floating_point_literal] = ACTIONS(592),
    [sym_true] = ACTIONS(592),
    [sym_false] = ACTIONS(592),
    [sym_character_literal] = ACTIONS(590),
    [sym_string_literal] = ACTIONS(592),
    [sym_text_block] = ACTIONS(590),
    [sym_null_literal] = ACTIONS(592),
    [anon_sym_LPAREN] = ACTIONS(590),
    [anon_sym_LT] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(592),
    [anon_sym_DASH] = ACTIONS(592),
    [anon_sym_final] = ACTIONS(592),
    [anon_sym_BANG] = ACTIONS(590),
    [anon_sym_TILDE] = ACTIONS(590),
    [anon_sym_PLUS_PLUS] = ACTIONS(590),
    [anon_sym_DASH_DASH] = ACTIONS(590),
    [anon_sym_new] = ACTIONS(592),
    [anon_sym_class] = ACTIONS(592),
    [anon_sym_switch] = ACTIONS(592),
    [anon_sym_LBRACE] = ACTIONS(590),
    [anon_sym_RBRACE] = ACTIONS(590),
    [anon_sym_case] = ACTIONS(592),
    [anon_sym_default] = ACTIONS(592),
    [anon_sym_SEMI] = ACTIONS(590),
    [anon_sym_assert] = ACTIONS(592),
    [anon_sym_do] = ACTIONS(592),
    [anon_sym_while] = ACTIONS(592),
    [anon_sym_break] = ACTIONS(592),
    [anon_sym_continue] = ACTIONS(592),
    [anon_sym_return] = ACTIONS(592),
    [anon_sym_yield] = ACTIONS(592),
    [anon_sym_synchronized] = ACTIONS(592),
    [anon_sym_throw] = ACTIONS(592),
    [anon_sym_try] = ACTIONS(592),
    [anon_sym_if] = ACTIONS(592),
    [anon_sym_else] = ACTIONS(592),
    [anon_sym_for] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(592),
    [anon_sym_open] = ACTIONS(592),
    [anon_sym_module] = ACTIONS(592),
    [anon_sym_static] = ACTIONS(592),
    [anon_sym_package] = ACTIONS(592),
    [anon_sym_import] = ACTIONS(592),
    [anon_sym_enum] = ACTIONS(592),
    [anon_sym_public] = ACTIONS(592),
    [anon_sym_protected] = ACTIONS(592),
    [anon_sym_private] = ACTIONS(592),
    [anon_sym_abstract] = ACTIONS(592),
    [anon_sym_strictfp] = ACTIONS(592),
    [anon_sym_native] = ACTIONS(592),
    [anon_sym_transient] = ACTIONS(592),
    [anon_sym_volatile] = ACTIONS(592),
    [anon_sym_sealed] = ACTIONS(592),
    [anon_sym_non_DASHsealed] = ACTIONS(590),
    [anon_sym_record] = ACTIONS(592),
    [anon_sym_ATinterface] = ACTIONS(590),
    [anon_sym_interface] = ACTIONS(592),
    [anon_sym_byte] = ACTIONS(592),
    [anon_sym_short] = ACTIONS(592),
    [anon_sym_int] = ACTIONS(592),
    [anon_sym_long] = ACTIONS(592),
    [anon_sym_char] = ACTIONS(592),
    [anon_sym_float] = ACTIONS(592),
    [anon_sym_double] = ACTIONS(592),
    [sym_boolean_type] = ACTIONS(592),
    [sym_void_type] = ACTIONS(592),
    [sym_this] = ACTIONS(592),
    [sym_super] = ACTIONS(592),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [161] = {
    [ts_builtin_sym_end] = ACTIONS(594),
    [sym_identifier] = ACTIONS(596),
    [sym_decimal_integer_literal] = ACTIONS(596),
    [sym_hex_integer_literal] = ACTIONS(596),
    [sym_octal_integer_literal] = ACTIONS(594),
    [sym_binary_integer_literal] = ACTIONS(594),
    [sym_decimal_floating_point_literal] = ACTIONS(594),
    [sym_hex_floating_point_literal] = ACTIONS(596),
    [sym_true] = ACTIONS(596),
    [sym_false] = ACTIONS(596),
    [sym_character_literal] = ACTIONS(594),
    [sym_string_literal] = ACTIONS(596),
    [sym_text_block] = ACTIONS(594),
    [sym_null_literal] = ACTIONS(596),
    [anon_sym_LPAREN] = ACTIONS(594),
    [anon_sym_LT] = ACTIONS(594),
    [anon_sym_PLUS] = ACTIONS(596),
    [anon_sym_DASH] = ACTIONS(596),
    [anon_sym_final] = ACTIONS(596),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_new] = ACTIONS(596),
    [anon_sym_class] = ACTIONS(596),
    [anon_sym_switch] = ACTIONS(596),
    [anon_sym_LBRACE] = ACTIONS(594),
    [anon_sym_RBRACE] = ACTIONS(594),
    [anon_sym_case] = ACTIONS(596),
    [anon_sym_default] = ACTIONS(596),
    [anon_sym_SEMI] = ACTIONS(594),
    [anon_sym_assert] = ACTIONS(596),
    [anon_sym_do] = ACTIONS(596),
    [anon_sym_while] = ACTIONS(596),
    [anon_sym_break] = ACTIONS(596),
    [anon_sym_continue] = ACTIONS(596),
    [anon_sym_return] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(596),
    [anon_sym_synchronized] = ACTIONS(596),
    [anon_sym_throw] = ACTIONS(596),
    [anon_sym_try] = ACTIONS(596),
    [anon_sym_if] = ACTIONS(596),
    [anon_sym_else] = ACTIONS(596),
    [anon_sym_for] = ACTIONS(596),
    [anon_sym_AT] = ACTIONS(596),
    [anon_sym_open] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_package] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(596),
    [anon_sym_enum] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_abstract] = ACTIONS(596),
    [anon_sym_strictfp] = ACTIONS(596),
    [anon_sym_native] = ACTIONS(596),
    [anon_sym_transient] = ACTIONS(596),
    [anon_sym_volatile] = ACTIONS(596),
    [anon_sym_sealed] = ACTIONS(596),
    [anon_sym_non_DASHsealed] = ACTIONS(594),
    [anon_sym_record] = ACTIONS(596),
    [anon_sym_ATinterface] = ACTIONS(594),
    [anon_sym_interface] = ACTIONS(596),
    [anon_sym_byte] = ACTIONS(596),
    [anon_sym_short] = ACTIONS(596),
    [anon_sym_int] = ACTIONS(596),
    [anon_sym_long] = ACTIONS(596),
    [anon_sym_char] = ACTIONS(596),
    [anon_sym_float] = ACTIONS(596),
    [anon_sym_double] = ACTIONS(596),
    [sym_boolean_type] = ACTIONS(596),
    [sym_void_type] = ACTIONS(596),
    [sym_this] = ACTIONS(596),
    [sym_super] = ACTIONS(596),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [162] = {
    [ts_builtin_sym_end] = ACTIONS(598),
    [sym_identifier] = ACTIONS(600),
    [sym_decimal_integer_literal] = ACTIONS(600),
    [sym_hex_integer_literal] = ACTIONS(600),
    [sym_octal_integer_literal] = ACTIONS(598),
    [sym_binary_integer_literal] = ACTIONS(598),
    [sym_decimal_floating_point_literal] = ACTIONS(598),
    [sym_hex_floating_point_literal] = ACTIONS(600),
    [sym_true] = ACTIONS(600),
    [sym_false] = ACTIONS(600),
    [sym_character_literal] = ACTIONS(598),
    [sym_string_literal] = ACTIONS(600),
    [sym_text_block] = ACTIONS(598),
    [sym_null_literal] = ACTIONS(600),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_LT] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(600),
    [anon_sym_DASH] = ACTIONS(600),
    [anon_sym_final] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(598),
    [anon_sym_TILDE] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(598),
    [anon_sym_DASH_DASH] = ACTIONS(598),
    [anon_sym_new] = ACTIONS(600),
    [anon_sym_class] = ACTIONS(600),
    [anon_sym_switch] = ACTIONS(600),
    [anon_sym_LBRACE] = ACTIONS(598),
    [anon_sym_RBRACE] = ACTIONS(598),
    [anon_sym_case] = ACTIONS(600),
    [anon_sym_default] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(598),
    [anon_sym_assert] = ACTIONS(600),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_while] = ACTIONS(600),
    [anon_sym_break] = ACTIONS(600),
    [anon_sym_continue] = ACTIONS(600),
    [anon_sym_return] = ACTIONS(600),
    [anon_sym_yield] = ACTIONS(600),
    [anon_sym_synchronized] = ACTIONS(600),
    [anon_sym_throw] = ACTIONS(600),
    [anon_sym_try] = ACTIONS(600),
    [anon_sym_if] = ACTIONS(600),
    [anon_sym_else] = ACTIONS(600),
    [anon_sym_for] = ACTIONS(600),
    [anon_sym_AT] = ACTIONS(600),
    [anon_sym_open] = ACTIONS(600),
    [anon_sym_module] = ACTIONS(600),
    [anon_sym_static] = ACTIONS(600),
    [anon_sym_package] = ACTIONS(600),
    [anon_sym_import] = ACTIONS(600),
    [anon_sym_enum] = ACTIONS(600),
    [anon_sym_public] = ACTIONS(600),
    [anon_sym_protected] = ACTIONS(600),
    [anon_sym_private] = ACTIONS(600),
    [anon_sym_abstract] = ACTIONS(600),
    [anon_sym_strictfp] = ACTIONS(600),
    [anon_sym_native] = ACTIONS(600),
    [anon_sym_transient] = ACTIONS(600),
    [anon_sym_volatile] = ACTIONS(600),
    [anon_sym_sealed] = ACTIONS(600),
    [anon_sym_non_DASHsealed] = ACTIONS(598),
    [anon_sym_record] = ACTIONS(600),
    [anon_sym_ATinterface] = ACTIONS(598),
    [anon_sym_interface] = ACTIONS(600),
    [anon_sym_byte] = ACTIONS(600),
    [anon_sym_short] = ACTIONS(600),
    [anon_sym_int] = ACTIONS(600),
    [anon_sym_long] = ACTIONS(600),
    [anon_sym_char] = ACTIONS(600),
    [anon_sym_float] = ACTIONS(600),
    [anon_sym_double] = ACTIONS(600),
    [sym_boolean_type] = ACTIONS(600),
    [sym_void_type] = ACTIONS(600),
    [sym_this] = ACTIONS(600),
    [sym_super] = ACTIONS(600),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [163] = {
    [ts_builtin_sym_end] = ACTIONS(602),
    [sym_identifier] = ACTIONS(604),
    [sym_decimal_integer_literal] = ACTIONS(604),
    [sym_hex_integer_literal] = ACTIONS(604),
    [sym_octal_integer_literal] = ACTIONS(602),
    [sym_binary_integer_literal] = ACTIONS(602),
    [sym_decimal_floating_point_literal] = ACTIONS(602),
    [sym_hex_floating_point_literal] = ACTIONS(604),
    [sym_true] = ACTIONS(604),
    [sym_false] = ACTIONS(604),
    [sym_character_literal] = ACTIONS(602),
    [sym_string_literal] = ACTIONS(604),
    [sym_text_block] = ACTIONS(602),
    [sym_null_literal] = ACTIONS(604),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(604),
    [anon_sym_DASH] = ACTIONS(604),
    [anon_sym_final] = ACTIONS(604),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_PLUS_PLUS] = ACTIONS(602),
    [anon_sym_DASH_DASH] = ACTIONS(602),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_class] = ACTIONS(604),
    [anon_sym_switch] = ACTIONS(604),
    [anon_sym_LBRACE] = ACTIONS(602),
    [anon_sym_RBRACE] = ACTIONS(602),
    [anon_sym_case] = ACTIONS(604),
    [anon_sym_default] = ACTIONS(604),
    [anon_sym_SEMI] = ACTIONS(602),
    [anon_sym_assert] = ACTIONS(604),
    [anon_sym_do] = ACTIONS(604),
    [anon_sym_while] = ACTIONS(604),
    [anon_sym_break] = ACTIONS(604),
    [anon_sym_continue] = ACTIONS(604),
    [anon_sym_return] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(604),
    [anon_sym_synchronized] = ACTIONS(604),
    [anon_sym_throw] = ACTIONS(604),
    [anon_sym_try] = ACTIONS(604),
    [anon_sym_if] = ACTIONS(604),
    [anon_sym_else] = ACTIONS(604),
    [anon_sym_for] = ACTIONS(604),
    [anon_sym_AT] = ACTIONS(604),
    [anon_sym_open] = ACTIONS(604),
    [anon_sym_module] = ACTIONS(604),
    [anon_sym_static] = ACTIONS(604),
    [anon_sym_package] = ACTIONS(604),
    [anon_sym_import] = ACTIONS(604),
    [anon_sym_enum] = ACTIONS(604),
    [anon_sym_public] = ACTIONS(604),
    [anon_sym_protected] = ACTIONS(604),
    [anon_sym_private] = ACTIONS(604),
    [anon_sym_abstract] = ACTIONS(604),
    [anon_sym_strictfp] = ACTIONS(604),
    [anon_sym_native] = ACTIONS(604),
    [anon_sym_transient] = ACTIONS(604),
    [anon_sym_volatile] = ACTIONS(604),
    [anon_sym_sealed] = ACTIONS(604),
    [anon_sym_non_DASHsealed] = ACTIONS(602),
    [anon_sym_record] = ACTIONS(604),
    [anon_sym_ATinterface] = ACTIONS(602),
    [anon_sym_interface] = ACTIONS(604),
    [anon_sym_byte] = ACTIONS(604),
    [anon_sym_short] = ACTIONS(604),
    [anon_sym_int] = ACTIONS(604),
    [anon_sym_long] = ACTIONS(604),
    [anon_sym_char] = ACTIONS(604),
    [anon_sym_float] = ACTIONS(604),
    [anon_sym_double] = ACTIONS(604),
    [sym_boolean_type] = ACTIONS(604),
    [sym_void_type] = ACTIONS(604),
    [sym_this] = ACTIONS(604),
    [sym_super] = ACTIONS(604),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [164] = {
    [ts_builtin_sym_end] = ACTIONS(606),
    [sym_identifier] = ACTIONS(608),
    [sym_decimal_integer_literal] = ACTIONS(608),
    [sym_hex_integer_literal] = ACTIONS(608),
    [sym_octal_integer_literal] = ACTIONS(606),
    [sym_binary_integer_literal] = ACTIONS(606),
    [sym_decimal_floating_point_literal] = ACTIONS(606),
    [sym_hex_floating_point_literal] = ACTIONS(608),
    [sym_true] = ACTIONS(608),
    [sym_false] = ACTIONS(608),
    [sym_character_literal] = ACTIONS(606),
    [sym_string_literal] = ACTIONS(608),
    [sym_text_block] = ACTIONS(606),
    [sym_null_literal] = ACTIONS(608),
    [anon_sym_LPAREN] = ACTIONS(606),
    [anon_sym_LT] = ACTIONS(606),
    [anon_sym_PLUS] = ACTIONS(608),
    [anon_sym_DASH] = ACTIONS(608),
    [anon_sym_final] = ACTIONS(608),
    [anon_sym_BANG] = ACTIONS(606),
    [anon_sym_TILDE] = ACTIONS(606),
    [anon_sym_PLUS_PLUS] = ACTIONS(606),
    [anon_sym_DASH_DASH] = ACTIONS(606),
    [anon_sym_new] = ACTIONS(608),
    [anon_sym_class] = ACTIONS(608),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_LBRACE] = ACTIONS(606),
    [anon_sym_RBRACE] = ACTIONS(606),
    [anon_sym_case] = ACTIONS(608),
    [anon_sym_default] = ACTIONS(608),
    [anon_sym_SEMI] = ACTIONS(606),
    [anon_sym_assert] = ACTIONS(608),
    [anon_sym_do] = ACTIONS(608),
    [anon_sym_while] = ACTIONS(608),
    [anon_sym_break] = ACTIONS(608),
    [anon_sym_continue] = ACTIONS(608),
    [anon_sym_return] = ACTIONS(608),
    [anon_sym_yield] = ACTIONS(608),
    [anon_sym_synchronized] = ACTIONS(608),
    [anon_sym_throw] = ACTIONS(608),
    [anon_sym_try] = ACTIONS(608),
    [anon_sym_if] = ACTIONS(608),
    [anon_sym_else] = ACTIONS(608),
    [anon_sym_for] = ACTIONS(608),
    [anon_sym_AT] = ACTIONS(608),
    [anon_sym_open] = ACTIONS(608),
    [anon_sym_module] = ACTIONS(608),
    [anon_sym_static] = ACTIONS(608),
    [anon_sym_package] = ACTIONS(608),
    [anon_sym_import] = ACTIONS(608),
    [anon_sym_enum] = ACTIONS(608),
    [anon_sym_public] = ACTIONS(608),
    [anon_sym_protected] = ACTIONS(608),
    [anon_sym_private] = ACTIONS(608),
    [anon_sym_abstract] = ACTIONS(608),
    [anon_sym_strictfp] = ACTIONS(608),
    [anon_sym_native] = ACTIONS(608),
    [anon_sym_transient] = ACTIONS(608),
    [anon_sym_volatile] = ACTIONS(608),
    [anon_sym_sealed] = ACTIONS(608),
    [anon_sym_non_DASHsealed] = ACTIONS(606),
    [anon_sym_record] = ACTIONS(608),
    [anon_sym_ATinterface] = ACTIONS(606),
    [anon_sym_interface] = ACTIONS(608),
    [anon_sym_byte] = ACTIONS(608),
    [anon_sym_short] = ACTIONS(608),
    [anon_sym_int] = ACTIONS(608),
    [anon_sym_long] = ACTIONS(608),
    [anon_sym_char] = ACTIONS(608),
    [anon_sym_float] = ACTIONS(608),
    [anon_sym_double] = ACTIONS(608),
    [sym_boolean_type] = ACTIONS(608),
    [sym_void_type] = ACTIONS(608),
    [sym_this] = ACTIONS(608),
    [sym_super] = ACTIONS(608),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [165] = {
    [ts_builtin_sym_end] = ACTIONS(610),
    [sym_identifier] = ACTIONS(612),
    [sym_decimal_integer_literal] = ACTIONS(612),
    [sym_hex_integer_literal] = ACTIONS(612),
    [sym_octal_integer_literal] = ACTIONS(610),
    [sym_binary_integer_literal] = ACTIONS(610),
    [sym_decimal_floating_point_literal] = ACTIONS(610),
    [sym_hex_floating_point_literal] = ACTIONS(612),
    [sym_true] = ACTIONS(612),
    [sym_false] = ACTIONS(612),
    [sym_character_literal] = ACTIONS(610),
    [sym_string_literal] = ACTIONS(612),
    [sym_text_block] = ACTIONS(610),
    [sym_null_literal] = ACTIONS(612),
    [anon_sym_LPAREN] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(610),
    [anon_sym_PLUS] = ACTIONS(612),
    [anon_sym_DASH] = ACTIONS(612),
    [anon_sym_final] = ACTIONS(612),
    [anon_sym_BANG] = ACTIONS(610),
    [anon_sym_TILDE] = ACTIONS(610),
    [anon_sym_PLUS_PLUS] = ACTIONS(610),
    [anon_sym_DASH_DASH] = ACTIONS(610),
    [anon_sym_new] = ACTIONS(612),
    [anon_sym_class] = ACTIONS(612),
    [anon_sym_switch] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(610),
    [anon_sym_RBRACE] = ACTIONS(610),
    [anon_sym_case] = ACTIONS(612),
    [anon_sym_default] = ACTIONS(612),
    [anon_sym_SEMI] = ACTIONS(610),
    [anon_sym_assert] = ACTIONS(612),
    [anon_sym_do] = ACTIONS(612),
    [anon_sym_while] = ACTIONS(612),
    [anon_sym_break] = ACTIONS(612),
    [anon_sym_continue] = ACTIONS(612),
    [anon_sym_return] = ACTIONS(612),
    [anon_sym_yield] = ACTIONS(612),
    [anon_sym_synchronized] = ACTIONS(612),
    [anon_sym_throw] = ACTIONS(612),
    [anon_sym_try] = ACTIONS(612),
    [anon_sym_if] = ACTIONS(612),
    [anon_sym_else] = ACTIONS(612),
    [anon_sym_for] = ACTIONS(612),
    [anon_sym_AT] = ACTIONS(612),
    [anon_sym_open] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(612),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_package] = ACTIONS(612),
    [anon_sym_import] = ACTIONS(612),
    [anon_sym_enum] = ACTIONS(612),
    [anon_sym_public] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(612),
    [anon_sym_private] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(612),
    [anon_sym_strictfp] = ACTIONS(612),
    [anon_sym_native] = ACTIONS(612),
    [anon_sym_transient] = ACTIONS(612),
    [anon_sym_volatile] = ACTIONS(612),
    [anon_sym_sealed] = ACTIONS(612),
    [anon_sym_non_DASHsealed] = ACTIONS(610),
    [anon_sym_record] = ACTIONS(612),
    [anon_sym_ATinterface] = ACTIONS(610),
    [anon_sym_interface] = ACTIONS(612),
    [anon_sym_byte] = ACTIONS(612),
    [anon_sym_short] = ACTIONS(612),
    [anon_sym_int] = ACTIONS(612),
    [anon_sym_long] = ACTIONS(612),
    [anon_sym_char] = ACTIONS(612),
    [anon_sym_float] = ACTIONS(612),
    [anon_sym_double] = ACTIONS(612),
    [sym_boolean_type] = ACTIONS(612),
    [sym_void_type] = ACTIONS(612),
    [sym_this] = ACTIONS(612),
    [sym_super] = ACTIONS(612),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [166] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(605),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym_array_initializer] = STATE(1110),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(362),
    [anon_sym_RBRACE] = ACTIONS(614),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [167] = {
    [ts_builtin_sym_end] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_decimal_integer_literal] = ACTIONS(618),
    [sym_hex_integer_literal] = ACTIONS(618),
    [sym_octal_integer_literal] = ACTIONS(616),
    [sym_binary_integer_literal] = ACTIONS(616),
    [sym_decimal_floating_point_literal] = ACTIONS(616),
    [sym_hex_floating_point_literal] = ACTIONS(618),
    [sym_true] = ACTIONS(618),
    [sym_false] = ACTIONS(618),
    [sym_character_literal] = ACTIONS(616),
    [sym_string_literal] = ACTIONS(618),
    [sym_text_block] = ACTIONS(616),
    [sym_null_literal] = ACTIONS(618),
    [anon_sym_LPAREN] = ACTIONS(616),
    [anon_sym_LT] = ACTIONS(616),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_final] = ACTIONS(618),
    [anon_sym_BANG] = ACTIONS(616),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(616),
    [anon_sym_DASH_DASH] = ACTIONS(616),
    [anon_sym_new] = ACTIONS(618),
    [anon_sym_class] = ACTIONS(618),
    [anon_sym_switch] = ACTIONS(618),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(616),
    [anon_sym_case] = ACTIONS(618),
    [anon_sym_default] = ACTIONS(618),
    [anon_sym_SEMI] = ACTIONS(616),
    [anon_sym_assert] = ACTIONS(618),
    [anon_sym_do] = ACTIONS(618),
    [anon_sym_while] = ACTIONS(618),
    [anon_sym_break] = ACTIONS(618),
    [anon_sym_continue] = ACTIONS(618),
    [anon_sym_return] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(618),
    [anon_sym_synchronized] = ACTIONS(618),
    [anon_sym_throw] = ACTIONS(618),
    [anon_sym_try] = ACTIONS(618),
    [anon_sym_if] = ACTIONS(618),
    [anon_sym_else] = ACTIONS(618),
    [anon_sym_for] = ACTIONS(618),
    [anon_sym_AT] = ACTIONS(618),
    [anon_sym_open] = ACTIONS(618),
    [anon_sym_module] = ACTIONS(618),
    [anon_sym_static] = ACTIONS(618),
    [anon_sym_package] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(618),
    [anon_sym_enum] = ACTIONS(618),
    [anon_sym_public] = ACTIONS(618),
    [anon_sym_protected] = ACTIONS(618),
    [anon_sym_private] = ACTIONS(618),
    [anon_sym_abstract] = ACTIONS(618),
    [anon_sym_strictfp] = ACTIONS(618),
    [anon_sym_native] = ACTIONS(618),
    [anon_sym_transient] = ACTIONS(618),
    [anon_sym_volatile] = ACTIONS(618),
    [anon_sym_sealed] = ACTIONS(618),
    [anon_sym_non_DASHsealed] = ACTIONS(616),
    [anon_sym_record] = ACTIONS(618),
    [anon_sym_ATinterface] = ACTIONS(616),
    [anon_sym_interface] = ACTIONS(618),
    [anon_sym_byte] = ACTIONS(618),
    [anon_sym_short] = ACTIONS(618),
    [anon_sym_int] = ACTIONS(618),
    [anon_sym_long] = ACTIONS(618),
    [anon_sym_char] = ACTIONS(618),
    [anon_sym_float] = ACTIONS(618),
    [anon_sym_double] = ACTIONS(618),
    [sym_boolean_type] = ACTIONS(618),
    [sym_void_type] = ACTIONS(618),
    [sym_this] = ACTIONS(618),
    [sym_super] = ACTIONS(618),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [168] = {
    [ts_builtin_sym_end] = ACTIONS(620),
    [sym_identifier] = ACTIONS(622),
    [sym_decimal_integer_literal] = ACTIONS(622),
    [sym_hex_integer_literal] = ACTIONS(622),
    [sym_octal_integer_literal] = ACTIONS(620),
    [sym_binary_integer_literal] = ACTIONS(620),
    [sym_decimal_floating_point_literal] = ACTIONS(620),
    [sym_hex_floating_point_literal] = ACTIONS(622),
    [sym_true] = ACTIONS(622),
    [sym_false] = ACTIONS(622),
    [sym_character_literal] = ACTIONS(620),
    [sym_string_literal] = ACTIONS(622),
    [sym_text_block] = ACTIONS(620),
    [sym_null_literal] = ACTIONS(622),
    [anon_sym_LPAREN] = ACTIONS(620),
    [anon_sym_LT] = ACTIONS(620),
    [anon_sym_PLUS] = ACTIONS(622),
    [anon_sym_DASH] = ACTIONS(622),
    [anon_sym_final] = ACTIONS(622),
    [anon_sym_BANG] = ACTIONS(620),
    [anon_sym_TILDE] = ACTIONS(620),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_new] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(622),
    [anon_sym_switch] = ACTIONS(622),
    [anon_sym_LBRACE] = ACTIONS(620),
    [anon_sym_RBRACE] = ACTIONS(620),
    [anon_sym_case] = ACTIONS(622),
    [anon_sym_default] = ACTIONS(622),
    [anon_sym_SEMI] = ACTIONS(620),
    [anon_sym_assert] = ACTIONS(622),
    [anon_sym_do] = ACTIONS(622),
    [anon_sym_while] = ACTIONS(622),
    [anon_sym_break] = ACTIONS(622),
    [anon_sym_continue] = ACTIONS(622),
    [anon_sym_return] = ACTIONS(622),
    [anon_sym_yield] = ACTIONS(622),
    [anon_sym_synchronized] = ACTIONS(622),
    [anon_sym_throw] = ACTIONS(622),
    [anon_sym_try] = ACTIONS(622),
    [anon_sym_if] = ACTIONS(622),
    [anon_sym_else] = ACTIONS(622),
    [anon_sym_for] = ACTIONS(622),
    [anon_sym_AT] = ACTIONS(622),
    [anon_sym_open] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_static] = ACTIONS(622),
    [anon_sym_package] = ACTIONS(622),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_enum] = ACTIONS(622),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_abstract] = ACTIONS(622),
    [anon_sym_strictfp] = ACTIONS(622),
    [anon_sym_native] = ACTIONS(622),
    [anon_sym_transient] = ACTIONS(622),
    [anon_sym_volatile] = ACTIONS(622),
    [anon_sym_sealed] = ACTIONS(622),
    [anon_sym_non_DASHsealed] = ACTIONS(620),
    [anon_sym_record] = ACTIONS(622),
    [anon_sym_ATinterface] = ACTIONS(620),
    [anon_sym_interface] = ACTIONS(622),
    [anon_sym_byte] = ACTIONS(622),
    [anon_sym_short] = ACTIONS(622),
    [anon_sym_int] = ACTIONS(622),
    [anon_sym_long] = ACTIONS(622),
    [anon_sym_char] = ACTIONS(622),
    [anon_sym_float] = ACTIONS(622),
    [anon_sym_double] = ACTIONS(622),
    [sym_boolean_type] = ACTIONS(622),
    [sym_void_type] = ACTIONS(622),
    [sym_this] = ACTIONS(622),
    [sym_super] = ACTIONS(622),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [169] = {
    [ts_builtin_sym_end] = ACTIONS(624),
    [sym_identifier] = ACTIONS(626),
    [sym_decimal_integer_literal] = ACTIONS(626),
    [sym_hex_integer_literal] = ACTIONS(626),
    [sym_octal_integer_literal] = ACTIONS(624),
    [sym_binary_integer_literal] = ACTIONS(624),
    [sym_decimal_floating_point_literal] = ACTIONS(624),
    [sym_hex_floating_point_literal] = ACTIONS(626),
    [sym_true] = ACTIONS(626),
    [sym_false] = ACTIONS(626),
    [sym_character_literal] = ACTIONS(624),
    [sym_string_literal] = ACTIONS(626),
    [sym_text_block] = ACTIONS(624),
    [sym_null_literal] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(624),
    [anon_sym_LT] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_final] = ACTIONS(626),
    [anon_sym_BANG] = ACTIONS(624),
    [anon_sym_TILDE] = ACTIONS(624),
    [anon_sym_PLUS_PLUS] = ACTIONS(624),
    [anon_sym_DASH_DASH] = ACTIONS(624),
    [anon_sym_new] = ACTIONS(626),
    [anon_sym_class] = ACTIONS(626),
    [anon_sym_switch] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(624),
    [anon_sym_RBRACE] = ACTIONS(624),
    [anon_sym_case] = ACTIONS(626),
    [anon_sym_default] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(624),
    [anon_sym_assert] = ACTIONS(626),
    [anon_sym_do] = ACTIONS(626),
    [anon_sym_while] = ACTIONS(626),
    [anon_sym_break] = ACTIONS(626),
    [anon_sym_continue] = ACTIONS(626),
    [anon_sym_return] = ACTIONS(626),
    [anon_sym_yield] = ACTIONS(626),
    [anon_sym_synchronized] = ACTIONS(626),
    [anon_sym_throw] = ACTIONS(626),
    [anon_sym_try] = ACTIONS(626),
    [anon_sym_if] = ACTIONS(626),
    [anon_sym_else] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(626),
    [anon_sym_open] = ACTIONS(626),
    [anon_sym_module] = ACTIONS(626),
    [anon_sym_static] = ACTIONS(626),
    [anon_sym_package] = ACTIONS(626),
    [anon_sym_import] = ACTIONS(626),
    [anon_sym_enum] = ACTIONS(626),
    [anon_sym_public] = ACTIONS(626),
    [anon_sym_protected] = ACTIONS(626),
    [anon_sym_private] = ACTIONS(626),
    [anon_sym_abstract] = ACTIONS(626),
    [anon_sym_strictfp] = ACTIONS(626),
    [anon_sym_native] = ACTIONS(626),
    [anon_sym_transient] = ACTIONS(626),
    [anon_sym_volatile] = ACTIONS(626),
    [anon_sym_sealed] = ACTIONS(626),
    [anon_sym_non_DASHsealed] = ACTIONS(624),
    [anon_sym_record] = ACTIONS(626),
    [anon_sym_ATinterface] = ACTIONS(624),
    [anon_sym_interface] = ACTIONS(626),
    [anon_sym_byte] = ACTIONS(626),
    [anon_sym_short] = ACTIONS(626),
    [anon_sym_int] = ACTIONS(626),
    [anon_sym_long] = ACTIONS(626),
    [anon_sym_char] = ACTIONS(626),
    [anon_sym_float] = ACTIONS(626),
    [anon_sym_double] = ACTIONS(626),
    [sym_boolean_type] = ACTIONS(626),
    [sym_void_type] = ACTIONS(626),
    [sym_this] = ACTIONS(626),
    [sym_super] = ACTIONS(626),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [170] = {
    [ts_builtin_sym_end] = ACTIONS(628),
    [sym_identifier] = ACTIONS(630),
    [sym_decimal_integer_literal] = ACTIONS(630),
    [sym_hex_integer_literal] = ACTIONS(630),
    [sym_octal_integer_literal] = ACTIONS(628),
    [sym_binary_integer_literal] = ACTIONS(628),
    [sym_decimal_floating_point_literal] = ACTIONS(628),
    [sym_hex_floating_point_literal] = ACTIONS(630),
    [sym_true] = ACTIONS(630),
    [sym_false] = ACTIONS(630),
    [sym_character_literal] = ACTIONS(628),
    [sym_string_literal] = ACTIONS(630),
    [sym_text_block] = ACTIONS(628),
    [sym_null_literal] = ACTIONS(630),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_LT] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(630),
    [anon_sym_DASH] = ACTIONS(630),
    [anon_sym_final] = ACTIONS(630),
    [anon_sym_BANG] = ACTIONS(628),
    [anon_sym_TILDE] = ACTIONS(628),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(630),
    [anon_sym_class] = ACTIONS(630),
    [anon_sym_switch] = ACTIONS(630),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_RBRACE] = ACTIONS(628),
    [anon_sym_case] = ACTIONS(630),
    [anon_sym_default] = ACTIONS(630),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_assert] = ACTIONS(630),
    [anon_sym_do] = ACTIONS(630),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_break] = ACTIONS(630),
    [anon_sym_continue] = ACTIONS(630),
    [anon_sym_return] = ACTIONS(630),
    [anon_sym_yield] = ACTIONS(630),
    [anon_sym_synchronized] = ACTIONS(630),
    [anon_sym_throw] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_else] = ACTIONS(630),
    [anon_sym_for] = ACTIONS(630),
    [anon_sym_AT] = ACTIONS(630),
    [anon_sym_open] = ACTIONS(630),
    [anon_sym_module] = ACTIONS(630),
    [anon_sym_static] = ACTIONS(630),
    [anon_sym_package] = ACTIONS(630),
    [anon_sym_import] = ACTIONS(630),
    [anon_sym_enum] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(630),
    [anon_sym_protected] = ACTIONS(630),
    [anon_sym_private] = ACTIONS(630),
    [anon_sym_abstract] = ACTIONS(630),
    [anon_sym_strictfp] = ACTIONS(630),
    [anon_sym_native] = ACTIONS(630),
    [anon_sym_transient] = ACTIONS(630),
    [anon_sym_volatile] = ACTIONS(630),
    [anon_sym_sealed] = ACTIONS(630),
    [anon_sym_non_DASHsealed] = ACTIONS(628),
    [anon_sym_record] = ACTIONS(630),
    [anon_sym_ATinterface] = ACTIONS(628),
    [anon_sym_interface] = ACTIONS(630),
    [anon_sym_byte] = ACTIONS(630),
    [anon_sym_short] = ACTIONS(630),
    [anon_sym_int] = ACTIONS(630),
    [anon_sym_long] = ACTIONS(630),
    [anon_sym_char] = ACTIONS(630),
    [anon_sym_float] = ACTIONS(630),
    [anon_sym_double] = ACTIONS(630),
    [sym_boolean_type] = ACTIONS(630),
    [sym_void_type] = ACTIONS(630),
    [sym_this] = ACTIONS(630),
    [sym_super] = ACTIONS(630),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [171] = {
    [ts_builtin_sym_end] = ACTIONS(632),
    [sym_identifier] = ACTIONS(634),
    [sym_decimal_integer_literal] = ACTIONS(634),
    [sym_hex_integer_literal] = ACTIONS(634),
    [sym_octal_integer_literal] = ACTIONS(632),
    [sym_binary_integer_literal] = ACTIONS(632),
    [sym_decimal_floating_point_literal] = ACTIONS(632),
    [sym_hex_floating_point_literal] = ACTIONS(634),
    [sym_true] = ACTIONS(634),
    [sym_false] = ACTIONS(634),
    [sym_character_literal] = ACTIONS(632),
    [sym_string_literal] = ACTIONS(634),
    [sym_text_block] = ACTIONS(632),
    [sym_null_literal] = ACTIONS(634),
    [anon_sym_LPAREN] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(632),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_final] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_new] = ACTIONS(634),
    [anon_sym_class] = ACTIONS(634),
    [anon_sym_switch] = ACTIONS(634),
    [anon_sym_LBRACE] = ACTIONS(632),
    [anon_sym_RBRACE] = ACTIONS(632),
    [anon_sym_case] = ACTIONS(634),
    [anon_sym_default] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(632),
    [anon_sym_assert] = ACTIONS(634),
    [anon_sym_do] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(634),
    [anon_sym_break] = ACTIONS(634),
    [anon_sym_continue] = ACTIONS(634),
    [anon_sym_return] = ACTIONS(634),
    [anon_sym_yield] = ACTIONS(634),
    [anon_sym_synchronized] = ACTIONS(634),
    [anon_sym_throw] = ACTIONS(634),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_if] = ACTIONS(634),
    [anon_sym_else] = ACTIONS(634),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_AT] = ACTIONS(634),
    [anon_sym_open] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_package] = ACTIONS(634),
    [anon_sym_import] = ACTIONS(634),
    [anon_sym_enum] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_abstract] = ACTIONS(634),
    [anon_sym_strictfp] = ACTIONS(634),
    [anon_sym_native] = ACTIONS(634),
    [anon_sym_transient] = ACTIONS(634),
    [anon_sym_volatile] = ACTIONS(634),
    [anon_sym_sealed] = ACTIONS(634),
    [anon_sym_non_DASHsealed] = ACTIONS(632),
    [anon_sym_record] = ACTIONS(634),
    [anon_sym_ATinterface] = ACTIONS(632),
    [anon_sym_interface] = ACTIONS(634),
    [anon_sym_byte] = ACTIONS(634),
    [anon_sym_short] = ACTIONS(634),
    [anon_sym_int] = ACTIONS(634),
    [anon_sym_long] = ACTIONS(634),
    [anon_sym_char] = ACTIONS(634),
    [anon_sym_float] = ACTIONS(634),
    [anon_sym_double] = ACTIONS(634),
    [sym_boolean_type] = ACTIONS(634),
    [sym_void_type] = ACTIONS(634),
    [sym_this] = ACTIONS(634),
    [sym_super] = ACTIONS(634),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [172] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(544),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(710),
    [sym_marker_annotation] = STATE(710),
    [sym_annotation] = STATE(710),
    [sym__element_value] = STATE(1211),
    [sym_element_value_array_initializer] = STATE(1211),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [173] = {
    [ts_builtin_sym_end] = ACTIONS(636),
    [sym_identifier] = ACTIONS(638),
    [sym_decimal_integer_literal] = ACTIONS(638),
    [sym_hex_integer_literal] = ACTIONS(638),
    [sym_octal_integer_literal] = ACTIONS(636),
    [sym_binary_integer_literal] = ACTIONS(636),
    [sym_decimal_floating_point_literal] = ACTIONS(636),
    [sym_hex_floating_point_literal] = ACTIONS(638),
    [sym_true] = ACTIONS(638),
    [sym_false] = ACTIONS(638),
    [sym_character_literal] = ACTIONS(636),
    [sym_string_literal] = ACTIONS(638),
    [sym_text_block] = ACTIONS(636),
    [sym_null_literal] = ACTIONS(638),
    [anon_sym_LPAREN] = ACTIONS(636),
    [anon_sym_LT] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(638),
    [anon_sym_DASH] = ACTIONS(638),
    [anon_sym_final] = ACTIONS(638),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_class] = ACTIONS(638),
    [anon_sym_switch] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(636),
    [anon_sym_RBRACE] = ACTIONS(636),
    [anon_sym_case] = ACTIONS(638),
    [anon_sym_default] = ACTIONS(638),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_assert] = ACTIONS(638),
    [anon_sym_do] = ACTIONS(638),
    [anon_sym_while] = ACTIONS(638),
    [anon_sym_break] = ACTIONS(638),
    [anon_sym_continue] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(638),
    [anon_sym_yield] = ACTIONS(638),
    [anon_sym_synchronized] = ACTIONS(638),
    [anon_sym_throw] = ACTIONS(638),
    [anon_sym_try] = ACTIONS(638),
    [anon_sym_if] = ACTIONS(638),
    [anon_sym_else] = ACTIONS(638),
    [anon_sym_for] = ACTIONS(638),
    [anon_sym_AT] = ACTIONS(638),
    [anon_sym_open] = ACTIONS(638),
    [anon_sym_module] = ACTIONS(638),
    [anon_sym_static] = ACTIONS(638),
    [anon_sym_package] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(638),
    [anon_sym_enum] = ACTIONS(638),
    [anon_sym_public] = ACTIONS(638),
    [anon_sym_protected] = ACTIONS(638),
    [anon_sym_private] = ACTIONS(638),
    [anon_sym_abstract] = ACTIONS(638),
    [anon_sym_strictfp] = ACTIONS(638),
    [anon_sym_native] = ACTIONS(638),
    [anon_sym_transient] = ACTIONS(638),
    [anon_sym_volatile] = ACTIONS(638),
    [anon_sym_sealed] = ACTIONS(638),
    [anon_sym_non_DASHsealed] = ACTIONS(636),
    [anon_sym_record] = ACTIONS(638),
    [anon_sym_ATinterface] = ACTIONS(636),
    [anon_sym_interface] = ACTIONS(638),
    [anon_sym_byte] = ACTIONS(638),
    [anon_sym_short] = ACTIONS(638),
    [anon_sym_int] = ACTIONS(638),
    [anon_sym_long] = ACTIONS(638),
    [anon_sym_char] = ACTIONS(638),
    [anon_sym_float] = ACTIONS(638),
    [anon_sym_double] = ACTIONS(638),
    [sym_boolean_type] = ACTIONS(638),
    [sym_void_type] = ACTIONS(638),
    [sym_this] = ACTIONS(638),
    [sym_super] = ACTIONS(638),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [174] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(544),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(710),
    [sym_marker_annotation] = STATE(710),
    [sym_annotation] = STATE(710),
    [sym__element_value] = STATE(1083),
    [sym_element_value_array_initializer] = STATE(1083),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [175] = {
    [ts_builtin_sym_end] = ACTIONS(640),
    [sym_identifier] = ACTIONS(642),
    [sym_decimal_integer_literal] = ACTIONS(642),
    [sym_hex_integer_literal] = ACTIONS(642),
    [sym_octal_integer_literal] = ACTIONS(640),
    [sym_binary_integer_literal] = ACTIONS(640),
    [sym_decimal_floating_point_literal] = ACTIONS(640),
    [sym_hex_floating_point_literal] = ACTIONS(642),
    [sym_true] = ACTIONS(642),
    [sym_false] = ACTIONS(642),
    [sym_character_literal] = ACTIONS(640),
    [sym_string_literal] = ACTIONS(642),
    [sym_text_block] = ACTIONS(640),
    [sym_null_literal] = ACTIONS(642),
    [anon_sym_LPAREN] = ACTIONS(640),
    [anon_sym_LT] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(642),
    [anon_sym_DASH] = ACTIONS(642),
    [anon_sym_final] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(640),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_new] = ACTIONS(642),
    [anon_sym_class] = ACTIONS(642),
    [anon_sym_switch] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(640),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_default] = ACTIONS(642),
    [anon_sym_SEMI] = ACTIONS(640),
    [anon_sym_assert] = ACTIONS(642),
    [anon_sym_do] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_break] = ACTIONS(642),
    [anon_sym_continue] = ACTIONS(642),
    [anon_sym_return] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(642),
    [anon_sym_synchronized] = ACTIONS(642),
    [anon_sym_throw] = ACTIONS(642),
    [anon_sym_try] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_else] = ACTIONS(642),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(642),
    [anon_sym_open] = ACTIONS(642),
    [anon_sym_module] = ACTIONS(642),
    [anon_sym_static] = ACTIONS(642),
    [anon_sym_package] = ACTIONS(642),
    [anon_sym_import] = ACTIONS(642),
    [anon_sym_enum] = ACTIONS(642),
    [anon_sym_public] = ACTIONS(642),
    [anon_sym_protected] = ACTIONS(642),
    [anon_sym_private] = ACTIONS(642),
    [anon_sym_abstract] = ACTIONS(642),
    [anon_sym_strictfp] = ACTIONS(642),
    [anon_sym_native] = ACTIONS(642),
    [anon_sym_transient] = ACTIONS(642),
    [anon_sym_volatile] = ACTIONS(642),
    [anon_sym_sealed] = ACTIONS(642),
    [anon_sym_non_DASHsealed] = ACTIONS(640),
    [anon_sym_record] = ACTIONS(642),
    [anon_sym_ATinterface] = ACTIONS(640),
    [anon_sym_interface] = ACTIONS(642),
    [anon_sym_byte] = ACTIONS(642),
    [anon_sym_short] = ACTIONS(642),
    [anon_sym_int] = ACTIONS(642),
    [anon_sym_long] = ACTIONS(642),
    [anon_sym_char] = ACTIONS(642),
    [anon_sym_float] = ACTIONS(642),
    [anon_sym_double] = ACTIONS(642),
    [sym_boolean_type] = ACTIONS(642),
    [sym_void_type] = ACTIONS(642),
    [sym_this] = ACTIONS(642),
    [sym_super] = ACTIONS(642),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [176] = {
    [ts_builtin_sym_end] = ACTIONS(644),
    [sym_identifier] = ACTIONS(646),
    [sym_decimal_integer_literal] = ACTIONS(646),
    [sym_hex_integer_literal] = ACTIONS(646),
    [sym_octal_integer_literal] = ACTIONS(644),
    [sym_binary_integer_literal] = ACTIONS(644),
    [sym_decimal_floating_point_literal] = ACTIONS(644),
    [sym_hex_floating_point_literal] = ACTIONS(646),
    [sym_true] = ACTIONS(646),
    [sym_false] = ACTIONS(646),
    [sym_character_literal] = ACTIONS(644),
    [sym_string_literal] = ACTIONS(646),
    [sym_text_block] = ACTIONS(644),
    [sym_null_literal] = ACTIONS(646),
    [anon_sym_LPAREN] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(646),
    [anon_sym_final] = ACTIONS(646),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_TILDE] = ACTIONS(644),
    [anon_sym_PLUS_PLUS] = ACTIONS(644),
    [anon_sym_DASH_DASH] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_RBRACE] = ACTIONS(644),
    [anon_sym_case] = ACTIONS(646),
    [anon_sym_default] = ACTIONS(646),
    [anon_sym_SEMI] = ACTIONS(644),
    [anon_sym_assert] = ACTIONS(646),
    [anon_sym_do] = ACTIONS(646),
    [anon_sym_while] = ACTIONS(646),
    [anon_sym_break] = ACTIONS(646),
    [anon_sym_continue] = ACTIONS(646),
    [anon_sym_return] = ACTIONS(646),
    [anon_sym_yield] = ACTIONS(646),
    [anon_sym_synchronized] = ACTIONS(646),
    [anon_sym_throw] = ACTIONS(646),
    [anon_sym_try] = ACTIONS(646),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_else] = ACTIONS(646),
    [anon_sym_for] = ACTIONS(646),
    [anon_sym_AT] = ACTIONS(646),
    [anon_sym_open] = ACTIONS(646),
    [anon_sym_module] = ACTIONS(646),
    [anon_sym_static] = ACTIONS(646),
    [anon_sym_package] = ACTIONS(646),
    [anon_sym_import] = ACTIONS(646),
    [anon_sym_enum] = ACTIONS(646),
    [anon_sym_public] = ACTIONS(646),
    [anon_sym_protected] = ACTIONS(646),
    [anon_sym_private] = ACTIONS(646),
    [anon_sym_abstract] = ACTIONS(646),
    [anon_sym_strictfp] = ACTIONS(646),
    [anon_sym_native] = ACTIONS(646),
    [anon_sym_transient] = ACTIONS(646),
    [anon_sym_volatile] = ACTIONS(646),
    [anon_sym_sealed] = ACTIONS(646),
    [anon_sym_non_DASHsealed] = ACTIONS(644),
    [anon_sym_record] = ACTIONS(646),
    [anon_sym_ATinterface] = ACTIONS(644),
    [anon_sym_interface] = ACTIONS(646),
    [anon_sym_byte] = ACTIONS(646),
    [anon_sym_short] = ACTIONS(646),
    [anon_sym_int] = ACTIONS(646),
    [anon_sym_long] = ACTIONS(646),
    [anon_sym_char] = ACTIONS(646),
    [anon_sym_float] = ACTIONS(646),
    [anon_sym_double] = ACTIONS(646),
    [sym_boolean_type] = ACTIONS(646),
    [sym_void_type] = ACTIONS(646),
    [sym_this] = ACTIONS(646),
    [sym_super] = ACTIONS(646),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [177] = {
    [ts_builtin_sym_end] = ACTIONS(648),
    [sym_identifier] = ACTIONS(650),
    [sym_decimal_integer_literal] = ACTIONS(650),
    [sym_hex_integer_literal] = ACTIONS(650),
    [sym_octal_integer_literal] = ACTIONS(648),
    [sym_binary_integer_literal] = ACTIONS(648),
    [sym_decimal_floating_point_literal] = ACTIONS(648),
    [sym_hex_floating_point_literal] = ACTIONS(650),
    [sym_true] = ACTIONS(650),
    [sym_false] = ACTIONS(650),
    [sym_character_literal] = ACTIONS(648),
    [sym_string_literal] = ACTIONS(650),
    [sym_text_block] = ACTIONS(648),
    [sym_null_literal] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(648),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_final] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(648),
    [anon_sym_TILDE] = ACTIONS(648),
    [anon_sym_PLUS_PLUS] = ACTIONS(648),
    [anon_sym_DASH_DASH] = ACTIONS(648),
    [anon_sym_new] = ACTIONS(650),
    [anon_sym_class] = ACTIONS(650),
    [anon_sym_switch] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(648),
    [anon_sym_RBRACE] = ACTIONS(648),
    [anon_sym_case] = ACTIONS(650),
    [anon_sym_default] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(648),
    [anon_sym_assert] = ACTIONS(650),
    [anon_sym_do] = ACTIONS(650),
    [anon_sym_while] = ACTIONS(650),
    [anon_sym_break] = ACTIONS(650),
    [anon_sym_continue] = ACTIONS(650),
    [anon_sym_return] = ACTIONS(650),
    [anon_sym_yield] = ACTIONS(650),
    [anon_sym_synchronized] = ACTIONS(650),
    [anon_sym_throw] = ACTIONS(650),
    [anon_sym_try] = ACTIONS(650),
    [anon_sym_if] = ACTIONS(650),
    [anon_sym_else] = ACTIONS(650),
    [anon_sym_for] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_open] = ACTIONS(650),
    [anon_sym_module] = ACTIONS(650),
    [anon_sym_static] = ACTIONS(650),
    [anon_sym_package] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(650),
    [anon_sym_enum] = ACTIONS(650),
    [anon_sym_public] = ACTIONS(650),
    [anon_sym_protected] = ACTIONS(650),
    [anon_sym_private] = ACTIONS(650),
    [anon_sym_abstract] = ACTIONS(650),
    [anon_sym_strictfp] = ACTIONS(650),
    [anon_sym_native] = ACTIONS(650),
    [anon_sym_transient] = ACTIONS(650),
    [anon_sym_volatile] = ACTIONS(650),
    [anon_sym_sealed] = ACTIONS(650),
    [anon_sym_non_DASHsealed] = ACTIONS(648),
    [anon_sym_record] = ACTIONS(650),
    [anon_sym_ATinterface] = ACTIONS(648),
    [anon_sym_interface] = ACTIONS(650),
    [anon_sym_byte] = ACTIONS(650),
    [anon_sym_short] = ACTIONS(650),
    [anon_sym_int] = ACTIONS(650),
    [anon_sym_long] = ACTIONS(650),
    [anon_sym_char] = ACTIONS(650),
    [anon_sym_float] = ACTIONS(650),
    [anon_sym_double] = ACTIONS(650),
    [sym_boolean_type] = ACTIONS(650),
    [sym_void_type] = ACTIONS(650),
    [sym_this] = ACTIONS(650),
    [sym_super] = ACTIONS(650),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [178] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(544),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(710),
    [sym_marker_annotation] = STATE(710),
    [sym_annotation] = STATE(710),
    [sym__element_value] = STATE(1170),
    [sym_element_value_array_initializer] = STATE(1170),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [179] = {
    [ts_builtin_sym_end] = ACTIONS(652),
    [sym_identifier] = ACTIONS(654),
    [sym_decimal_integer_literal] = ACTIONS(654),
    [sym_hex_integer_literal] = ACTIONS(654),
    [sym_octal_integer_literal] = ACTIONS(652),
    [sym_binary_integer_literal] = ACTIONS(652),
    [sym_decimal_floating_point_literal] = ACTIONS(652),
    [sym_hex_floating_point_literal] = ACTIONS(654),
    [sym_true] = ACTIONS(654),
    [sym_false] = ACTIONS(654),
    [sym_character_literal] = ACTIONS(652),
    [sym_string_literal] = ACTIONS(654),
    [sym_text_block] = ACTIONS(652),
    [sym_null_literal] = ACTIONS(654),
    [anon_sym_LPAREN] = ACTIONS(652),
    [anon_sym_LT] = ACTIONS(652),
    [anon_sym_PLUS] = ACTIONS(654),
    [anon_sym_DASH] = ACTIONS(654),
    [anon_sym_final] = ACTIONS(654),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_PLUS_PLUS] = ACTIONS(652),
    [anon_sym_DASH_DASH] = ACTIONS(652),
    [anon_sym_new] = ACTIONS(654),
    [anon_sym_class] = ACTIONS(654),
    [anon_sym_switch] = ACTIONS(654),
    [anon_sym_LBRACE] = ACTIONS(652),
    [anon_sym_RBRACE] = ACTIONS(652),
    [anon_sym_case] = ACTIONS(654),
    [anon_sym_default] = ACTIONS(654),
    [anon_sym_SEMI] = ACTIONS(652),
    [anon_sym_assert] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(654),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_break] = ACTIONS(654),
    [anon_sym_continue] = ACTIONS(654),
    [anon_sym_return] = ACTIONS(654),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_synchronized] = ACTIONS(654),
    [anon_sym_throw] = ACTIONS(654),
    [anon_sym_try] = ACTIONS(654),
    [anon_sym_if] = ACTIONS(654),
    [anon_sym_else] = ACTIONS(654),
    [anon_sym_for] = ACTIONS(654),
    [anon_sym_AT] = ACTIONS(654),
    [anon_sym_open] = ACTIONS(654),
    [anon_sym_module] = ACTIONS(654),
    [anon_sym_static] = ACTIONS(654),
    [anon_sym_package] = ACTIONS(654),
    [anon_sym_import] = ACTIONS(654),
    [anon_sym_enum] = ACTIONS(654),
    [anon_sym_public] = ACTIONS(654),
    [anon_sym_protected] = ACTIONS(654),
    [anon_sym_private] = ACTIONS(654),
    [anon_sym_abstract] = ACTIONS(654),
    [anon_sym_strictfp] = ACTIONS(654),
    [anon_sym_native] = ACTIONS(654),
    [anon_sym_transient] = ACTIONS(654),
    [anon_sym_volatile] = ACTIONS(654),
    [anon_sym_sealed] = ACTIONS(654),
    [anon_sym_non_DASHsealed] = ACTIONS(652),
    [anon_sym_record] = ACTIONS(654),
    [anon_sym_ATinterface] = ACTIONS(652),
    [anon_sym_interface] = ACTIONS(654),
    [anon_sym_byte] = ACTIONS(654),
    [anon_sym_short] = ACTIONS(654),
    [anon_sym_int] = ACTIONS(654),
    [anon_sym_long] = ACTIONS(654),
    [anon_sym_char] = ACTIONS(654),
    [anon_sym_float] = ACTIONS(654),
    [anon_sym_double] = ACTIONS(654),
    [sym_boolean_type] = ACTIONS(654),
    [sym_void_type] = ACTIONS(654),
    [sym_this] = ACTIONS(654),
    [sym_super] = ACTIONS(654),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [180] = {
    [ts_builtin_sym_end] = ACTIONS(656),
    [sym_identifier] = ACTIONS(658),
    [sym_decimal_integer_literal] = ACTIONS(658),
    [sym_hex_integer_literal] = ACTIONS(658),
    [sym_octal_integer_literal] = ACTIONS(656),
    [sym_binary_integer_literal] = ACTIONS(656),
    [sym_decimal_floating_point_literal] = ACTIONS(656),
    [sym_hex_floating_point_literal] = ACTIONS(658),
    [sym_true] = ACTIONS(658),
    [sym_false] = ACTIONS(658),
    [sym_character_literal] = ACTIONS(656),
    [sym_string_literal] = ACTIONS(658),
    [sym_text_block] = ACTIONS(656),
    [sym_null_literal] = ACTIONS(658),
    [anon_sym_LPAREN] = ACTIONS(656),
    [anon_sym_PLUS] = ACTIONS(658),
    [anon_sym_DASH] = ACTIONS(658),
    [anon_sym_final] = ACTIONS(658),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_new] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(658),
    [anon_sym_switch] = ACTIONS(658),
    [anon_sym_LBRACE] = ACTIONS(656),
    [anon_sym_RBRACE] = ACTIONS(656),
    [anon_sym_case] = ACTIONS(658),
    [anon_sym_default] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(656),
    [anon_sym_assert] = ACTIONS(658),
    [anon_sym_do] = ACTIONS(658),
    [anon_sym_while] = ACTIONS(658),
    [anon_sym_break] = ACTIONS(658),
    [anon_sym_continue] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(658),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_synchronized] = ACTIONS(658),
    [anon_sym_throw] = ACTIONS(658),
    [anon_sym_try] = ACTIONS(658),
    [anon_sym_if] = ACTIONS(658),
    [anon_sym_else] = ACTIONS(658),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_AT] = ACTIONS(658),
    [anon_sym_open] = ACTIONS(658),
    [anon_sym_module] = ACTIONS(658),
    [anon_sym_static] = ACTIONS(658),
    [anon_sym_package] = ACTIONS(658),
    [anon_sym_import] = ACTIONS(658),
    [anon_sym_enum] = ACTIONS(658),
    [anon_sym_public] = ACTIONS(658),
    [anon_sym_protected] = ACTIONS(658),
    [anon_sym_private] = ACTIONS(658),
    [anon_sym_abstract] = ACTIONS(658),
    [anon_sym_strictfp] = ACTIONS(658),
    [anon_sym_native] = ACTIONS(658),
    [anon_sym_transient] = ACTIONS(658),
    [anon_sym_volatile] = ACTIONS(658),
    [anon_sym_sealed] = ACTIONS(658),
    [anon_sym_non_DASHsealed] = ACTIONS(656),
    [anon_sym_record] = ACTIONS(658),
    [anon_sym_ATinterface] = ACTIONS(656),
    [anon_sym_interface] = ACTIONS(658),
    [anon_sym_byte] = ACTIONS(658),
    [anon_sym_short] = ACTIONS(658),
    [anon_sym_int] = ACTIONS(658),
    [anon_sym_long] = ACTIONS(658),
    [anon_sym_char] = ACTIONS(658),
    [anon_sym_float] = ACTIONS(658),
    [anon_sym_double] = ACTIONS(658),
    [sym_boolean_type] = ACTIONS(658),
    [sym_void_type] = ACTIONS(658),
    [sym_this] = ACTIONS(658),
    [sym_super] = ACTIONS(658),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [181] = {
    [ts_builtin_sym_end] = ACTIONS(660),
    [sym_identifier] = ACTIONS(662),
    [sym_decimal_integer_literal] = ACTIONS(662),
    [sym_hex_integer_literal] = ACTIONS(662),
    [sym_octal_integer_literal] = ACTIONS(660),
    [sym_binary_integer_literal] = ACTIONS(660),
    [sym_decimal_floating_point_literal] = ACTIONS(660),
    [sym_hex_floating_point_literal] = ACTIONS(662),
    [sym_true] = ACTIONS(662),
    [sym_false] = ACTIONS(662),
    [sym_character_literal] = ACTIONS(660),
    [sym_string_literal] = ACTIONS(662),
    [sym_text_block] = ACTIONS(660),
    [sym_null_literal] = ACTIONS(662),
    [anon_sym_LPAREN] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(662),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_final] = ACTIONS(662),
    [anon_sym_BANG] = ACTIONS(660),
    [anon_sym_TILDE] = ACTIONS(660),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(662),
    [anon_sym_switch] = ACTIONS(662),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_RBRACE] = ACTIONS(660),
    [anon_sym_case] = ACTIONS(662),
    [anon_sym_default] = ACTIONS(662),
    [anon_sym_SEMI] = ACTIONS(660),
    [anon_sym_assert] = ACTIONS(662),
    [anon_sym_do] = ACTIONS(662),
    [anon_sym_while] = ACTIONS(662),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(662),
    [anon_sym_return] = ACTIONS(662),
    [anon_sym_yield] = ACTIONS(662),
    [anon_sym_synchronized] = ACTIONS(662),
    [anon_sym_throw] = ACTIONS(662),
    [anon_sym_try] = ACTIONS(662),
    [anon_sym_if] = ACTIONS(662),
    [anon_sym_else] = ACTIONS(662),
    [anon_sym_for] = ACTIONS(662),
    [anon_sym_AT] = ACTIONS(662),
    [anon_sym_open] = ACTIONS(662),
    [anon_sym_module] = ACTIONS(662),
    [anon_sym_static] = ACTIONS(662),
    [anon_sym_package] = ACTIONS(662),
    [anon_sym_import] = ACTIONS(662),
    [anon_sym_enum] = ACTIONS(662),
    [anon_sym_public] = ACTIONS(662),
    [anon_sym_protected] = ACTIONS(662),
    [anon_sym_private] = ACTIONS(662),
    [anon_sym_abstract] = ACTIONS(662),
    [anon_sym_strictfp] = ACTIONS(662),
    [anon_sym_native] = ACTIONS(662),
    [anon_sym_transient] = ACTIONS(662),
    [anon_sym_volatile] = ACTIONS(662),
    [anon_sym_sealed] = ACTIONS(662),
    [anon_sym_non_DASHsealed] = ACTIONS(660),
    [anon_sym_record] = ACTIONS(662),
    [anon_sym_ATinterface] = ACTIONS(660),
    [anon_sym_interface] = ACTIONS(662),
    [anon_sym_byte] = ACTIONS(662),
    [anon_sym_short] = ACTIONS(662),
    [anon_sym_int] = ACTIONS(662),
    [anon_sym_long] = ACTIONS(662),
    [anon_sym_char] = ACTIONS(662),
    [anon_sym_float] = ACTIONS(662),
    [anon_sym_double] = ACTIONS(662),
    [sym_boolean_type] = ACTIONS(662),
    [sym_void_type] = ACTIONS(662),
    [sym_this] = ACTIONS(662),
    [sym_super] = ACTIONS(662),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [182] = {
    [ts_builtin_sym_end] = ACTIONS(664),
    [sym_identifier] = ACTIONS(666),
    [sym_decimal_integer_literal] = ACTIONS(666),
    [sym_hex_integer_literal] = ACTIONS(666),
    [sym_octal_integer_literal] = ACTIONS(664),
    [sym_binary_integer_literal] = ACTIONS(664),
    [sym_decimal_floating_point_literal] = ACTIONS(664),
    [sym_hex_floating_point_literal] = ACTIONS(666),
    [sym_true] = ACTIONS(666),
    [sym_false] = ACTIONS(666),
    [sym_character_literal] = ACTIONS(664),
    [sym_string_literal] = ACTIONS(666),
    [sym_text_block] = ACTIONS(664),
    [sym_null_literal] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(664),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_final] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(664),
    [anon_sym_TILDE] = ACTIONS(664),
    [anon_sym_PLUS_PLUS] = ACTIONS(664),
    [anon_sym_DASH_DASH] = ACTIONS(664),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_class] = ACTIONS(666),
    [anon_sym_switch] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(664),
    [anon_sym_RBRACE] = ACTIONS(664),
    [anon_sym_case] = ACTIONS(666),
    [anon_sym_default] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(664),
    [anon_sym_assert] = ACTIONS(666),
    [anon_sym_do] = ACTIONS(666),
    [anon_sym_while] = ACTIONS(666),
    [anon_sym_break] = ACTIONS(666),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_return] = ACTIONS(666),
    [anon_sym_yield] = ACTIONS(666),
    [anon_sym_synchronized] = ACTIONS(666),
    [anon_sym_throw] = ACTIONS(666),
    [anon_sym_try] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_else] = ACTIONS(666),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_AT] = ACTIONS(666),
    [anon_sym_open] = ACTIONS(666),
    [anon_sym_module] = ACTIONS(666),
    [anon_sym_static] = ACTIONS(666),
    [anon_sym_package] = ACTIONS(666),
    [anon_sym_import] = ACTIONS(666),
    [anon_sym_enum] = ACTIONS(666),
    [anon_sym_public] = ACTIONS(666),
    [anon_sym_protected] = ACTIONS(666),
    [anon_sym_private] = ACTIONS(666),
    [anon_sym_abstract] = ACTIONS(666),
    [anon_sym_strictfp] = ACTIONS(666),
    [anon_sym_native] = ACTIONS(666),
    [anon_sym_transient] = ACTIONS(666),
    [anon_sym_volatile] = ACTIONS(666),
    [anon_sym_sealed] = ACTIONS(666),
    [anon_sym_non_DASHsealed] = ACTIONS(664),
    [anon_sym_record] = ACTIONS(666),
    [anon_sym_ATinterface] = ACTIONS(664),
    [anon_sym_interface] = ACTIONS(666),
    [anon_sym_byte] = ACTIONS(666),
    [anon_sym_short] = ACTIONS(666),
    [anon_sym_int] = ACTIONS(666),
    [anon_sym_long] = ACTIONS(666),
    [anon_sym_char] = ACTIONS(666),
    [anon_sym_float] = ACTIONS(666),
    [anon_sym_double] = ACTIONS(666),
    [sym_boolean_type] = ACTIONS(666),
    [sym_void_type] = ACTIONS(666),
    [sym_this] = ACTIONS(666),
    [sym_super] = ACTIONS(666),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [183] = {
    [ts_builtin_sym_end] = ACTIONS(668),
    [sym_identifier] = ACTIONS(670),
    [sym_decimal_integer_literal] = ACTIONS(670),
    [sym_hex_integer_literal] = ACTIONS(670),
    [sym_octal_integer_literal] = ACTIONS(668),
    [sym_binary_integer_literal] = ACTIONS(668),
    [sym_decimal_floating_point_literal] = ACTIONS(668),
    [sym_hex_floating_point_literal] = ACTIONS(670),
    [sym_true] = ACTIONS(670),
    [sym_false] = ACTIONS(670),
    [sym_character_literal] = ACTIONS(668),
    [sym_string_literal] = ACTIONS(670),
    [sym_text_block] = ACTIONS(668),
    [sym_null_literal] = ACTIONS(670),
    [anon_sym_LPAREN] = ACTIONS(668),
    [anon_sym_PLUS] = ACTIONS(670),
    [anon_sym_DASH] = ACTIONS(670),
    [anon_sym_final] = ACTIONS(670),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_PLUS_PLUS] = ACTIONS(668),
    [anon_sym_DASH_DASH] = ACTIONS(668),
    [anon_sym_new] = ACTIONS(670),
    [anon_sym_class] = ACTIONS(670),
    [anon_sym_switch] = ACTIONS(670),
    [anon_sym_LBRACE] = ACTIONS(668),
    [anon_sym_RBRACE] = ACTIONS(668),
    [anon_sym_case] = ACTIONS(670),
    [anon_sym_default] = ACTIONS(670),
    [anon_sym_SEMI] = ACTIONS(668),
    [anon_sym_assert] = ACTIONS(670),
    [anon_sym_do] = ACTIONS(670),
    [anon_sym_while] = ACTIONS(670),
    [anon_sym_break] = ACTIONS(670),
    [anon_sym_continue] = ACTIONS(670),
    [anon_sym_return] = ACTIONS(670),
    [anon_sym_yield] = ACTIONS(670),
    [anon_sym_synchronized] = ACTIONS(670),
    [anon_sym_throw] = ACTIONS(670),
    [anon_sym_try] = ACTIONS(670),
    [anon_sym_if] = ACTIONS(670),
    [anon_sym_else] = ACTIONS(670),
    [anon_sym_for] = ACTIONS(670),
    [anon_sym_AT] = ACTIONS(670),
    [anon_sym_open] = ACTIONS(670),
    [anon_sym_module] = ACTIONS(670),
    [anon_sym_static] = ACTIONS(670),
    [anon_sym_package] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(670),
    [anon_sym_enum] = ACTIONS(670),
    [anon_sym_public] = ACTIONS(670),
    [anon_sym_protected] = ACTIONS(670),
    [anon_sym_private] = ACTIONS(670),
    [anon_sym_abstract] = ACTIONS(670),
    [anon_sym_strictfp] = ACTIONS(670),
    [anon_sym_native] = ACTIONS(670),
    [anon_sym_transient] = ACTIONS(670),
    [anon_sym_volatile] = ACTIONS(670),
    [anon_sym_sealed] = ACTIONS(670),
    [anon_sym_non_DASHsealed] = ACTIONS(668),
    [anon_sym_record] = ACTIONS(670),
    [anon_sym_ATinterface] = ACTIONS(668),
    [anon_sym_interface] = ACTIONS(670),
    [anon_sym_byte] = ACTIONS(670),
    [anon_sym_short] = ACTIONS(670),
    [anon_sym_int] = ACTIONS(670),
    [anon_sym_long] = ACTIONS(670),
    [anon_sym_char] = ACTIONS(670),
    [anon_sym_float] = ACTIONS(670),
    [anon_sym_double] = ACTIONS(670),
    [sym_boolean_type] = ACTIONS(670),
    [sym_void_type] = ACTIONS(670),
    [sym_this] = ACTIONS(670),
    [sym_super] = ACTIONS(670),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [184] = {
    [ts_builtin_sym_end] = ACTIONS(672),
    [sym_identifier] = ACTIONS(674),
    [sym_decimal_integer_literal] = ACTIONS(674),
    [sym_hex_integer_literal] = ACTIONS(674),
    [sym_octal_integer_literal] = ACTIONS(672),
    [sym_binary_integer_literal] = ACTIONS(672),
    [sym_decimal_floating_point_literal] = ACTIONS(672),
    [sym_hex_floating_point_literal] = ACTIONS(674),
    [sym_true] = ACTIONS(674),
    [sym_false] = ACTIONS(674),
    [sym_character_literal] = ACTIONS(672),
    [sym_string_literal] = ACTIONS(674),
    [sym_text_block] = ACTIONS(672),
    [sym_null_literal] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(674),
    [anon_sym_DASH] = ACTIONS(674),
    [anon_sym_final] = ACTIONS(674),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_TILDE] = ACTIONS(672),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_new] = ACTIONS(674),
    [anon_sym_class] = ACTIONS(674),
    [anon_sym_switch] = ACTIONS(674),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(672),
    [anon_sym_case] = ACTIONS(674),
    [anon_sym_default] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(672),
    [anon_sym_assert] = ACTIONS(674),
    [anon_sym_do] = ACTIONS(674),
    [anon_sym_while] = ACTIONS(674),
    [anon_sym_break] = ACTIONS(674),
    [anon_sym_continue] = ACTIONS(674),
    [anon_sym_return] = ACTIONS(674),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_synchronized] = ACTIONS(674),
    [anon_sym_throw] = ACTIONS(674),
    [anon_sym_try] = ACTIONS(674),
    [anon_sym_if] = ACTIONS(674),
    [anon_sym_else] = ACTIONS(674),
    [anon_sym_for] = ACTIONS(674),
    [anon_sym_AT] = ACTIONS(674),
    [anon_sym_open] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_package] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(674),
    [anon_sym_enum] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_abstract] = ACTIONS(674),
    [anon_sym_strictfp] = ACTIONS(674),
    [anon_sym_native] = ACTIONS(674),
    [anon_sym_transient] = ACTIONS(674),
    [anon_sym_volatile] = ACTIONS(674),
    [anon_sym_sealed] = ACTIONS(674),
    [anon_sym_non_DASHsealed] = ACTIONS(672),
    [anon_sym_record] = ACTIONS(674),
    [anon_sym_ATinterface] = ACTIONS(672),
    [anon_sym_interface] = ACTIONS(674),
    [anon_sym_byte] = ACTIONS(674),
    [anon_sym_short] = ACTIONS(674),
    [anon_sym_int] = ACTIONS(674),
    [anon_sym_long] = ACTIONS(674),
    [anon_sym_char] = ACTIONS(674),
    [anon_sym_float] = ACTIONS(674),
    [anon_sym_double] = ACTIONS(674),
    [sym_boolean_type] = ACTIONS(674),
    [sym_void_type] = ACTIONS(674),
    [sym_this] = ACTIONS(674),
    [sym_super] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [185] = {
    [ts_builtin_sym_end] = ACTIONS(676),
    [sym_identifier] = ACTIONS(678),
    [sym_decimal_integer_literal] = ACTIONS(678),
    [sym_hex_integer_literal] = ACTIONS(678),
    [sym_octal_integer_literal] = ACTIONS(676),
    [sym_binary_integer_literal] = ACTIONS(676),
    [sym_decimal_floating_point_literal] = ACTIONS(676),
    [sym_hex_floating_point_literal] = ACTIONS(678),
    [sym_true] = ACTIONS(678),
    [sym_false] = ACTIONS(678),
    [sym_character_literal] = ACTIONS(676),
    [sym_string_literal] = ACTIONS(678),
    [sym_text_block] = ACTIONS(676),
    [sym_null_literal] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_final] = ACTIONS(678),
    [anon_sym_BANG] = ACTIONS(676),
    [anon_sym_TILDE] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(676),
    [anon_sym_DASH_DASH] = ACTIONS(676),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_class] = ACTIONS(678),
    [anon_sym_switch] = ACTIONS(678),
    [anon_sym_LBRACE] = ACTIONS(676),
    [anon_sym_RBRACE] = ACTIONS(676),
    [anon_sym_case] = ACTIONS(678),
    [anon_sym_default] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(676),
    [anon_sym_assert] = ACTIONS(678),
    [anon_sym_do] = ACTIONS(678),
    [anon_sym_while] = ACTIONS(678),
    [anon_sym_break] = ACTIONS(678),
    [anon_sym_continue] = ACTIONS(678),
    [anon_sym_return] = ACTIONS(678),
    [anon_sym_yield] = ACTIONS(678),
    [anon_sym_synchronized] = ACTIONS(678),
    [anon_sym_throw] = ACTIONS(678),
    [anon_sym_try] = ACTIONS(678),
    [anon_sym_if] = ACTIONS(678),
    [anon_sym_else] = ACTIONS(678),
    [anon_sym_for] = ACTIONS(678),
    [anon_sym_AT] = ACTIONS(678),
    [anon_sym_open] = ACTIONS(678),
    [anon_sym_module] = ACTIONS(678),
    [anon_sym_static] = ACTIONS(678),
    [anon_sym_package] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_enum] = ACTIONS(678),
    [anon_sym_public] = ACTIONS(678),
    [anon_sym_protected] = ACTIONS(678),
    [anon_sym_private] = ACTIONS(678),
    [anon_sym_abstract] = ACTIONS(678),
    [anon_sym_strictfp] = ACTIONS(678),
    [anon_sym_native] = ACTIONS(678),
    [anon_sym_transient] = ACTIONS(678),
    [anon_sym_volatile] = ACTIONS(678),
    [anon_sym_sealed] = ACTIONS(678),
    [anon_sym_non_DASHsealed] = ACTIONS(676),
    [anon_sym_record] = ACTIONS(678),
    [anon_sym_ATinterface] = ACTIONS(676),
    [anon_sym_interface] = ACTIONS(678),
    [anon_sym_byte] = ACTIONS(678),
    [anon_sym_short] = ACTIONS(678),
    [anon_sym_int] = ACTIONS(678),
    [anon_sym_long] = ACTIONS(678),
    [anon_sym_char] = ACTIONS(678),
    [anon_sym_float] = ACTIONS(678),
    [anon_sym_double] = ACTIONS(678),
    [sym_boolean_type] = ACTIONS(678),
    [sym_void_type] = ACTIONS(678),
    [sym_this] = ACTIONS(678),
    [sym_super] = ACTIONS(678),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [186] = {
    [ts_builtin_sym_end] = ACTIONS(680),
    [sym_identifier] = ACTIONS(682),
    [sym_decimal_integer_literal] = ACTIONS(682),
    [sym_hex_integer_literal] = ACTIONS(682),
    [sym_octal_integer_literal] = ACTIONS(680),
    [sym_binary_integer_literal] = ACTIONS(680),
    [sym_decimal_floating_point_literal] = ACTIONS(680),
    [sym_hex_floating_point_literal] = ACTIONS(682),
    [sym_true] = ACTIONS(682),
    [sym_false] = ACTIONS(682),
    [sym_character_literal] = ACTIONS(680),
    [sym_string_literal] = ACTIONS(682),
    [sym_text_block] = ACTIONS(680),
    [sym_null_literal] = ACTIONS(682),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_final] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_new] = ACTIONS(682),
    [anon_sym_class] = ACTIONS(682),
    [anon_sym_switch] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(680),
    [anon_sym_RBRACE] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(682),
    [anon_sym_default] = ACTIONS(682),
    [anon_sym_SEMI] = ACTIONS(680),
    [anon_sym_assert] = ACTIONS(682),
    [anon_sym_do] = ACTIONS(682),
    [anon_sym_while] = ACTIONS(682),
    [anon_sym_break] = ACTIONS(682),
    [anon_sym_continue] = ACTIONS(682),
    [anon_sym_return] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(682),
    [anon_sym_synchronized] = ACTIONS(682),
    [anon_sym_throw] = ACTIONS(682),
    [anon_sym_try] = ACTIONS(682),
    [anon_sym_if] = ACTIONS(682),
    [anon_sym_else] = ACTIONS(682),
    [anon_sym_for] = ACTIONS(682),
    [anon_sym_AT] = ACTIONS(682),
    [anon_sym_open] = ACTIONS(682),
    [anon_sym_module] = ACTIONS(682),
    [anon_sym_static] = ACTIONS(682),
    [anon_sym_package] = ACTIONS(682),
    [anon_sym_import] = ACTIONS(682),
    [anon_sym_enum] = ACTIONS(682),
    [anon_sym_public] = ACTIONS(682),
    [anon_sym_protected] = ACTIONS(682),
    [anon_sym_private] = ACTIONS(682),
    [anon_sym_abstract] = ACTIONS(682),
    [anon_sym_strictfp] = ACTIONS(682),
    [anon_sym_native] = ACTIONS(682),
    [anon_sym_transient] = ACTIONS(682),
    [anon_sym_volatile] = ACTIONS(682),
    [anon_sym_sealed] = ACTIONS(682),
    [anon_sym_non_DASHsealed] = ACTIONS(680),
    [anon_sym_record] = ACTIONS(682),
    [anon_sym_ATinterface] = ACTIONS(680),
    [anon_sym_interface] = ACTIONS(682),
    [anon_sym_byte] = ACTIONS(682),
    [anon_sym_short] = ACTIONS(682),
    [anon_sym_int] = ACTIONS(682),
    [anon_sym_long] = ACTIONS(682),
    [anon_sym_char] = ACTIONS(682),
    [anon_sym_float] = ACTIONS(682),
    [anon_sym_double] = ACTIONS(682),
    [sym_boolean_type] = ACTIONS(682),
    [sym_void_type] = ACTIONS(682),
    [sym_this] = ACTIONS(682),
    [sym_super] = ACTIONS(682),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [187] = {
    [ts_builtin_sym_end] = ACTIONS(323),
    [sym_identifier] = ACTIONS(325),
    [sym_decimal_integer_literal] = ACTIONS(325),
    [sym_hex_integer_literal] = ACTIONS(325),
    [sym_octal_integer_literal] = ACTIONS(323),
    [sym_binary_integer_literal] = ACTIONS(323),
    [sym_decimal_floating_point_literal] = ACTIONS(323),
    [sym_hex_floating_point_literal] = ACTIONS(325),
    [sym_true] = ACTIONS(325),
    [sym_false] = ACTIONS(325),
    [sym_character_literal] = ACTIONS(323),
    [sym_string_literal] = ACTIONS(325),
    [sym_text_block] = ACTIONS(323),
    [sym_null_literal] = ACTIONS(325),
    [anon_sym_LPAREN] = ACTIONS(323),
    [anon_sym_PLUS] = ACTIONS(325),
    [anon_sym_DASH] = ACTIONS(325),
    [anon_sym_final] = ACTIONS(325),
    [anon_sym_BANG] = ACTIONS(323),
    [anon_sym_TILDE] = ACTIONS(323),
    [anon_sym_PLUS_PLUS] = ACTIONS(323),
    [anon_sym_DASH_DASH] = ACTIONS(323),
    [anon_sym_new] = ACTIONS(325),
    [anon_sym_class] = ACTIONS(325),
    [anon_sym_switch] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(323),
    [anon_sym_RBRACE] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(323),
    [anon_sym_assert] = ACTIONS(325),
    [anon_sym_do] = ACTIONS(325),
    [anon_sym_while] = ACTIONS(325),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_return] = ACTIONS(325),
    [anon_sym_yield] = ACTIONS(325),
    [anon_sym_synchronized] = ACTIONS(325),
    [anon_sym_throw] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_if] = ACTIONS(325),
    [anon_sym_else] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_AT] = ACTIONS(325),
    [anon_sym_open] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(325),
    [anon_sym_static] = ACTIONS(325),
    [anon_sym_package] = ACTIONS(325),
    [anon_sym_import] = ACTIONS(325),
    [anon_sym_enum] = ACTIONS(325),
    [anon_sym_public] = ACTIONS(325),
    [anon_sym_protected] = ACTIONS(325),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_abstract] = ACTIONS(325),
    [anon_sym_strictfp] = ACTIONS(325),
    [anon_sym_native] = ACTIONS(325),
    [anon_sym_transient] = ACTIONS(325),
    [anon_sym_volatile] = ACTIONS(325),
    [anon_sym_sealed] = ACTIONS(325),
    [anon_sym_non_DASHsealed] = ACTIONS(323),
    [anon_sym_record] = ACTIONS(325),
    [anon_sym_ATinterface] = ACTIONS(323),
    [anon_sym_interface] = ACTIONS(325),
    [anon_sym_byte] = ACTIONS(325),
    [anon_sym_short] = ACTIONS(325),
    [anon_sym_int] = ACTIONS(325),
    [anon_sym_long] = ACTIONS(325),
    [anon_sym_char] = ACTIONS(325),
    [anon_sym_float] = ACTIONS(325),
    [anon_sym_double] = ACTIONS(325),
    [sym_boolean_type] = ACTIONS(325),
    [sym_void_type] = ACTIONS(325),
    [sym_this] = ACTIONS(325),
    [sym_super] = ACTIONS(325),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [188] = {
    [ts_builtin_sym_end] = ACTIONS(684),
    [sym_identifier] = ACTIONS(686),
    [sym_decimal_integer_literal] = ACTIONS(686),
    [sym_hex_integer_literal] = ACTIONS(686),
    [sym_octal_integer_literal] = ACTIONS(684),
    [sym_binary_integer_literal] = ACTIONS(684),
    [sym_decimal_floating_point_literal] = ACTIONS(684),
    [sym_hex_floating_point_literal] = ACTIONS(686),
    [sym_true] = ACTIONS(686),
    [sym_false] = ACTIONS(686),
    [sym_character_literal] = ACTIONS(684),
    [sym_string_literal] = ACTIONS(686),
    [sym_text_block] = ACTIONS(684),
    [sym_null_literal] = ACTIONS(686),
    [anon_sym_LPAREN] = ACTIONS(684),
    [anon_sym_PLUS] = ACTIONS(686),
    [anon_sym_DASH] = ACTIONS(686),
    [anon_sym_final] = ACTIONS(686),
    [anon_sym_BANG] = ACTIONS(684),
    [anon_sym_TILDE] = ACTIONS(684),
    [anon_sym_PLUS_PLUS] = ACTIONS(684),
    [anon_sym_DASH_DASH] = ACTIONS(684),
    [anon_sym_new] = ACTIONS(686),
    [anon_sym_class] = ACTIONS(686),
    [anon_sym_switch] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(684),
    [anon_sym_RBRACE] = ACTIONS(684),
    [anon_sym_case] = ACTIONS(686),
    [anon_sym_default] = ACTIONS(686),
    [anon_sym_SEMI] = ACTIONS(684),
    [anon_sym_assert] = ACTIONS(686),
    [anon_sym_do] = ACTIONS(686),
    [anon_sym_while] = ACTIONS(686),
    [anon_sym_break] = ACTIONS(686),
    [anon_sym_continue] = ACTIONS(686),
    [anon_sym_return] = ACTIONS(686),
    [anon_sym_yield] = ACTIONS(686),
    [anon_sym_synchronized] = ACTIONS(686),
    [anon_sym_throw] = ACTIONS(686),
    [anon_sym_try] = ACTIONS(686),
    [anon_sym_if] = ACTIONS(686),
    [anon_sym_else] = ACTIONS(686),
    [anon_sym_for] = ACTIONS(686),
    [anon_sym_AT] = ACTIONS(686),
    [anon_sym_open] = ACTIONS(686),
    [anon_sym_module] = ACTIONS(686),
    [anon_sym_static] = ACTIONS(686),
    [anon_sym_package] = ACTIONS(686),
    [anon_sym_import] = ACTIONS(686),
    [anon_sym_enum] = ACTIONS(686),
    [anon_sym_public] = ACTIONS(686),
    [anon_sym_protected] = ACTIONS(686),
    [anon_sym_private] = ACTIONS(686),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_strictfp] = ACTIONS(686),
    [anon_sym_native] = ACTIONS(686),
    [anon_sym_transient] = ACTIONS(686),
    [anon_sym_volatile] = ACTIONS(686),
    [anon_sym_sealed] = ACTIONS(686),
    [anon_sym_non_DASHsealed] = ACTIONS(684),
    [anon_sym_record] = ACTIONS(686),
    [anon_sym_ATinterface] = ACTIONS(684),
    [anon_sym_interface] = ACTIONS(686),
    [anon_sym_byte] = ACTIONS(686),
    [anon_sym_short] = ACTIONS(686),
    [anon_sym_int] = ACTIONS(686),
    [anon_sym_long] = ACTIONS(686),
    [anon_sym_char] = ACTIONS(686),
    [anon_sym_float] = ACTIONS(686),
    [anon_sym_double] = ACTIONS(686),
    [sym_boolean_type] = ACTIONS(686),
    [sym_void_type] = ACTIONS(686),
    [sym_this] = ACTIONS(686),
    [sym_super] = ACTIONS(686),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [189] = {
    [ts_builtin_sym_end] = ACTIONS(688),
    [sym_identifier] = ACTIONS(690),
    [sym_decimal_integer_literal] = ACTIONS(690),
    [sym_hex_integer_literal] = ACTIONS(690),
    [sym_octal_integer_literal] = ACTIONS(688),
    [sym_binary_integer_literal] = ACTIONS(688),
    [sym_decimal_floating_point_literal] = ACTIONS(688),
    [sym_hex_floating_point_literal] = ACTIONS(690),
    [sym_true] = ACTIONS(690),
    [sym_false] = ACTIONS(690),
    [sym_character_literal] = ACTIONS(688),
    [sym_string_literal] = ACTIONS(690),
    [sym_text_block] = ACTIONS(688),
    [sym_null_literal] = ACTIONS(690),
    [anon_sym_LPAREN] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_final] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(688),
    [anon_sym_TILDE] = ACTIONS(688),
    [anon_sym_PLUS_PLUS] = ACTIONS(688),
    [anon_sym_DASH_DASH] = ACTIONS(688),
    [anon_sym_new] = ACTIONS(690),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_switch] = ACTIONS(690),
    [anon_sym_LBRACE] = ACTIONS(688),
    [anon_sym_RBRACE] = ACTIONS(688),
    [anon_sym_case] = ACTIONS(690),
    [anon_sym_default] = ACTIONS(690),
    [anon_sym_SEMI] = ACTIONS(688),
    [anon_sym_assert] = ACTIONS(690),
    [anon_sym_do] = ACTIONS(690),
    [anon_sym_while] = ACTIONS(690),
    [anon_sym_break] = ACTIONS(690),
    [anon_sym_continue] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(690),
    [anon_sym_yield] = ACTIONS(690),
    [anon_sym_synchronized] = ACTIONS(690),
    [anon_sym_throw] = ACTIONS(690),
    [anon_sym_try] = ACTIONS(690),
    [anon_sym_if] = ACTIONS(690),
    [anon_sym_else] = ACTIONS(690),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_AT] = ACTIONS(690),
    [anon_sym_open] = ACTIONS(690),
    [anon_sym_module] = ACTIONS(690),
    [anon_sym_static] = ACTIONS(690),
    [anon_sym_package] = ACTIONS(690),
    [anon_sym_import] = ACTIONS(690),
    [anon_sym_enum] = ACTIONS(690),
    [anon_sym_public] = ACTIONS(690),
    [anon_sym_protected] = ACTIONS(690),
    [anon_sym_private] = ACTIONS(690),
    [anon_sym_abstract] = ACTIONS(690),
    [anon_sym_strictfp] = ACTIONS(690),
    [anon_sym_native] = ACTIONS(690),
    [anon_sym_transient] = ACTIONS(690),
    [anon_sym_volatile] = ACTIONS(690),
    [anon_sym_sealed] = ACTIONS(690),
    [anon_sym_non_DASHsealed] = ACTIONS(688),
    [anon_sym_record] = ACTIONS(690),
    [anon_sym_ATinterface] = ACTIONS(688),
    [anon_sym_interface] = ACTIONS(690),
    [anon_sym_byte] = ACTIONS(690),
    [anon_sym_short] = ACTIONS(690),
    [anon_sym_int] = ACTIONS(690),
    [anon_sym_long] = ACTIONS(690),
    [anon_sym_char] = ACTIONS(690),
    [anon_sym_float] = ACTIONS(690),
    [anon_sym_double] = ACTIONS(690),
    [sym_boolean_type] = ACTIONS(690),
    [sym_void_type] = ACTIONS(690),
    [sym_this] = ACTIONS(690),
    [sym_super] = ACTIONS(690),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [190] = {
    [ts_builtin_sym_end] = ACTIONS(692),
    [sym_identifier] = ACTIONS(694),
    [sym_decimal_integer_literal] = ACTIONS(694),
    [sym_hex_integer_literal] = ACTIONS(694),
    [sym_octal_integer_literal] = ACTIONS(692),
    [sym_binary_integer_literal] = ACTIONS(692),
    [sym_decimal_floating_point_literal] = ACTIONS(692),
    [sym_hex_floating_point_literal] = ACTIONS(694),
    [sym_true] = ACTIONS(694),
    [sym_false] = ACTIONS(694),
    [sym_character_literal] = ACTIONS(692),
    [sym_string_literal] = ACTIONS(694),
    [sym_text_block] = ACTIONS(692),
    [sym_null_literal] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(692),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_final] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_TILDE] = ACTIONS(692),
    [anon_sym_PLUS_PLUS] = ACTIONS(692),
    [anon_sym_DASH_DASH] = ACTIONS(692),
    [anon_sym_new] = ACTIONS(694),
    [anon_sym_class] = ACTIONS(694),
    [anon_sym_switch] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(692),
    [anon_sym_RBRACE] = ACTIONS(692),
    [anon_sym_case] = ACTIONS(694),
    [anon_sym_default] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(692),
    [anon_sym_assert] = ACTIONS(694),
    [anon_sym_do] = ACTIONS(694),
    [anon_sym_while] = ACTIONS(694),
    [anon_sym_break] = ACTIONS(694),
    [anon_sym_continue] = ACTIONS(694),
    [anon_sym_return] = ACTIONS(694),
    [anon_sym_yield] = ACTIONS(694),
    [anon_sym_synchronized] = ACTIONS(694),
    [anon_sym_throw] = ACTIONS(694),
    [anon_sym_try] = ACTIONS(694),
    [anon_sym_if] = ACTIONS(694),
    [anon_sym_else] = ACTIONS(694),
    [anon_sym_for] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_open] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(694),
    [anon_sym_static] = ACTIONS(694),
    [anon_sym_package] = ACTIONS(694),
    [anon_sym_import] = ACTIONS(694),
    [anon_sym_enum] = ACTIONS(694),
    [anon_sym_public] = ACTIONS(694),
    [anon_sym_protected] = ACTIONS(694),
    [anon_sym_private] = ACTIONS(694),
    [anon_sym_abstract] = ACTIONS(694),
    [anon_sym_strictfp] = ACTIONS(694),
    [anon_sym_native] = ACTIONS(694),
    [anon_sym_transient] = ACTIONS(694),
    [anon_sym_volatile] = ACTIONS(694),
    [anon_sym_sealed] = ACTIONS(694),
    [anon_sym_non_DASHsealed] = ACTIONS(692),
    [anon_sym_record] = ACTIONS(694),
    [anon_sym_ATinterface] = ACTIONS(692),
    [anon_sym_interface] = ACTIONS(694),
    [anon_sym_byte] = ACTIONS(694),
    [anon_sym_short] = ACTIONS(694),
    [anon_sym_int] = ACTIONS(694),
    [anon_sym_long] = ACTIONS(694),
    [anon_sym_char] = ACTIONS(694),
    [anon_sym_float] = ACTIONS(694),
    [anon_sym_double] = ACTIONS(694),
    [sym_boolean_type] = ACTIONS(694),
    [sym_void_type] = ACTIONS(694),
    [sym_this] = ACTIONS(694),
    [sym_super] = ACTIONS(694),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [191] = {
    [ts_builtin_sym_end] = ACTIONS(696),
    [sym_identifier] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(698),
    [sym_hex_integer_literal] = ACTIONS(698),
    [sym_octal_integer_literal] = ACTIONS(696),
    [sym_binary_integer_literal] = ACTIONS(696),
    [sym_decimal_floating_point_literal] = ACTIONS(696),
    [sym_hex_floating_point_literal] = ACTIONS(698),
    [sym_true] = ACTIONS(698),
    [sym_false] = ACTIONS(698),
    [sym_character_literal] = ACTIONS(696),
    [sym_string_literal] = ACTIONS(698),
    [sym_text_block] = ACTIONS(696),
    [sym_null_literal] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_final] = ACTIONS(698),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(696),
    [anon_sym_DASH_DASH] = ACTIONS(696),
    [anon_sym_new] = ACTIONS(698),
    [anon_sym_class] = ACTIONS(698),
    [anon_sym_switch] = ACTIONS(698),
    [anon_sym_LBRACE] = ACTIONS(696),
    [anon_sym_RBRACE] = ACTIONS(696),
    [anon_sym_case] = ACTIONS(698),
    [anon_sym_default] = ACTIONS(698),
    [anon_sym_SEMI] = ACTIONS(696),
    [anon_sym_assert] = ACTIONS(698),
    [anon_sym_do] = ACTIONS(698),
    [anon_sym_while] = ACTIONS(698),
    [anon_sym_break] = ACTIONS(698),
    [anon_sym_continue] = ACTIONS(698),
    [anon_sym_return] = ACTIONS(698),
    [anon_sym_yield] = ACTIONS(698),
    [anon_sym_synchronized] = ACTIONS(698),
    [anon_sym_throw] = ACTIONS(698),
    [anon_sym_try] = ACTIONS(698),
    [anon_sym_if] = ACTIONS(698),
    [anon_sym_else] = ACTIONS(698),
    [anon_sym_for] = ACTIONS(698),
    [anon_sym_AT] = ACTIONS(698),
    [anon_sym_open] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_package] = ACTIONS(698),
    [anon_sym_import] = ACTIONS(698),
    [anon_sym_enum] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_abstract] = ACTIONS(698),
    [anon_sym_strictfp] = ACTIONS(698),
    [anon_sym_native] = ACTIONS(698),
    [anon_sym_transient] = ACTIONS(698),
    [anon_sym_volatile] = ACTIONS(698),
    [anon_sym_sealed] = ACTIONS(698),
    [anon_sym_non_DASHsealed] = ACTIONS(696),
    [anon_sym_record] = ACTIONS(698),
    [anon_sym_ATinterface] = ACTIONS(696),
    [anon_sym_interface] = ACTIONS(698),
    [anon_sym_byte] = ACTIONS(698),
    [anon_sym_short] = ACTIONS(698),
    [anon_sym_int] = ACTIONS(698),
    [anon_sym_long] = ACTIONS(698),
    [anon_sym_char] = ACTIONS(698),
    [anon_sym_float] = ACTIONS(698),
    [anon_sym_double] = ACTIONS(698),
    [sym_boolean_type] = ACTIONS(698),
    [sym_void_type] = ACTIONS(698),
    [sym_this] = ACTIONS(698),
    [sym_super] = ACTIONS(698),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [192] = {
    [ts_builtin_sym_end] = ACTIONS(700),
    [sym_identifier] = ACTIONS(702),
    [sym_decimal_integer_literal] = ACTIONS(702),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_octal_integer_literal] = ACTIONS(700),
    [sym_binary_integer_literal] = ACTIONS(700),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [sym_hex_floating_point_literal] = ACTIONS(702),
    [sym_true] = ACTIONS(702),
    [sym_false] = ACTIONS(702),
    [sym_character_literal] = ACTIONS(700),
    [sym_string_literal] = ACTIONS(702),
    [sym_text_block] = ACTIONS(700),
    [sym_null_literal] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_PLUS] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(702),
    [anon_sym_final] = ACTIONS(702),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(700),
    [anon_sym_PLUS_PLUS] = ACTIONS(700),
    [anon_sym_DASH_DASH] = ACTIONS(700),
    [anon_sym_new] = ACTIONS(702),
    [anon_sym_class] = ACTIONS(702),
    [anon_sym_switch] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(700),
    [anon_sym_RBRACE] = ACTIONS(700),
    [anon_sym_case] = ACTIONS(702),
    [anon_sym_default] = ACTIONS(702),
    [anon_sym_SEMI] = ACTIONS(700),
    [anon_sym_assert] = ACTIONS(702),
    [anon_sym_do] = ACTIONS(702),
    [anon_sym_while] = ACTIONS(702),
    [anon_sym_break] = ACTIONS(702),
    [anon_sym_continue] = ACTIONS(702),
    [anon_sym_return] = ACTIONS(702),
    [anon_sym_yield] = ACTIONS(702),
    [anon_sym_synchronized] = ACTIONS(702),
    [anon_sym_throw] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(702),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_else] = ACTIONS(702),
    [anon_sym_for] = ACTIONS(702),
    [anon_sym_AT] = ACTIONS(702),
    [anon_sym_open] = ACTIONS(702),
    [anon_sym_module] = ACTIONS(702),
    [anon_sym_static] = ACTIONS(702),
    [anon_sym_package] = ACTIONS(702),
    [anon_sym_import] = ACTIONS(702),
    [anon_sym_enum] = ACTIONS(702),
    [anon_sym_public] = ACTIONS(702),
    [anon_sym_protected] = ACTIONS(702),
    [anon_sym_private] = ACTIONS(702),
    [anon_sym_abstract] = ACTIONS(702),
    [anon_sym_strictfp] = ACTIONS(702),
    [anon_sym_native] = ACTIONS(702),
    [anon_sym_transient] = ACTIONS(702),
    [anon_sym_volatile] = ACTIONS(702),
    [anon_sym_sealed] = ACTIONS(702),
    [anon_sym_non_DASHsealed] = ACTIONS(700),
    [anon_sym_record] = ACTIONS(702),
    [anon_sym_ATinterface] = ACTIONS(700),
    [anon_sym_interface] = ACTIONS(702),
    [anon_sym_byte] = ACTIONS(702),
    [anon_sym_short] = ACTIONS(702),
    [anon_sym_int] = ACTIONS(702),
    [anon_sym_long] = ACTIONS(702),
    [anon_sym_char] = ACTIONS(702),
    [anon_sym_float] = ACTIONS(702),
    [anon_sym_double] = ACTIONS(702),
    [sym_boolean_type] = ACTIONS(702),
    [sym_void_type] = ACTIONS(702),
    [sym_this] = ACTIONS(702),
    [sym_super] = ACTIONS(702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [193] = {
    [ts_builtin_sym_end] = ACTIONS(704),
    [sym_identifier] = ACTIONS(706),
    [sym_decimal_integer_literal] = ACTIONS(706),
    [sym_hex_integer_literal] = ACTIONS(706),
    [sym_octal_integer_literal] = ACTIONS(704),
    [sym_binary_integer_literal] = ACTIONS(704),
    [sym_decimal_floating_point_literal] = ACTIONS(704),
    [sym_hex_floating_point_literal] = ACTIONS(706),
    [sym_true] = ACTIONS(706),
    [sym_false] = ACTIONS(706),
    [sym_character_literal] = ACTIONS(704),
    [sym_string_literal] = ACTIONS(706),
    [sym_text_block] = ACTIONS(704),
    [sym_null_literal] = ACTIONS(706),
    [anon_sym_LPAREN] = ACTIONS(704),
    [anon_sym_PLUS] = ACTIONS(706),
    [anon_sym_DASH] = ACTIONS(706),
    [anon_sym_final] = ACTIONS(706),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(704),
    [anon_sym_DASH_DASH] = ACTIONS(704),
    [anon_sym_new] = ACTIONS(706),
    [anon_sym_class] = ACTIONS(706),
    [anon_sym_switch] = ACTIONS(706),
    [anon_sym_LBRACE] = ACTIONS(704),
    [anon_sym_RBRACE] = ACTIONS(704),
    [anon_sym_case] = ACTIONS(706),
    [anon_sym_default] = ACTIONS(706),
    [anon_sym_SEMI] = ACTIONS(704),
    [anon_sym_assert] = ACTIONS(706),
    [anon_sym_do] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(706),
    [anon_sym_break] = ACTIONS(706),
    [anon_sym_continue] = ACTIONS(706),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_yield] = ACTIONS(706),
    [anon_sym_synchronized] = ACTIONS(706),
    [anon_sym_throw] = ACTIONS(706),
    [anon_sym_try] = ACTIONS(706),
    [anon_sym_if] = ACTIONS(706),
    [anon_sym_else] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_AT] = ACTIONS(706),
    [anon_sym_open] = ACTIONS(706),
    [anon_sym_module] = ACTIONS(706),
    [anon_sym_static] = ACTIONS(706),
    [anon_sym_package] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(706),
    [anon_sym_enum] = ACTIONS(706),
    [anon_sym_public] = ACTIONS(706),
    [anon_sym_protected] = ACTIONS(706),
    [anon_sym_private] = ACTIONS(706),
    [anon_sym_abstract] = ACTIONS(706),
    [anon_sym_strictfp] = ACTIONS(706),
    [anon_sym_native] = ACTIONS(706),
    [anon_sym_transient] = ACTIONS(706),
    [anon_sym_volatile] = ACTIONS(706),
    [anon_sym_sealed] = ACTIONS(706),
    [anon_sym_non_DASHsealed] = ACTIONS(704),
    [anon_sym_record] = ACTIONS(706),
    [anon_sym_ATinterface] = ACTIONS(704),
    [anon_sym_interface] = ACTIONS(706),
    [anon_sym_byte] = ACTIONS(706),
    [anon_sym_short] = ACTIONS(706),
    [anon_sym_int] = ACTIONS(706),
    [anon_sym_long] = ACTIONS(706),
    [anon_sym_char] = ACTIONS(706),
    [anon_sym_float] = ACTIONS(706),
    [anon_sym_double] = ACTIONS(706),
    [sym_boolean_type] = ACTIONS(706),
    [sym_void_type] = ACTIONS(706),
    [sym_this] = ACTIONS(706),
    [sym_super] = ACTIONS(706),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [194] = {
    [ts_builtin_sym_end] = ACTIONS(708),
    [sym_identifier] = ACTIONS(710),
    [sym_decimal_integer_literal] = ACTIONS(710),
    [sym_hex_integer_literal] = ACTIONS(710),
    [sym_octal_integer_literal] = ACTIONS(708),
    [sym_binary_integer_literal] = ACTIONS(708),
    [sym_decimal_floating_point_literal] = ACTIONS(708),
    [sym_hex_floating_point_literal] = ACTIONS(710),
    [sym_true] = ACTIONS(710),
    [sym_false] = ACTIONS(710),
    [sym_character_literal] = ACTIONS(708),
    [sym_string_literal] = ACTIONS(710),
    [sym_text_block] = ACTIONS(708),
    [sym_null_literal] = ACTIONS(710),
    [anon_sym_LPAREN] = ACTIONS(708),
    [anon_sym_PLUS] = ACTIONS(710),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_final] = ACTIONS(710),
    [anon_sym_BANG] = ACTIONS(708),
    [anon_sym_TILDE] = ACTIONS(708),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_new] = ACTIONS(710),
    [anon_sym_class] = ACTIONS(710),
    [anon_sym_switch] = ACTIONS(710),
    [anon_sym_LBRACE] = ACTIONS(708),
    [anon_sym_RBRACE] = ACTIONS(708),
    [anon_sym_case] = ACTIONS(710),
    [anon_sym_default] = ACTIONS(710),
    [anon_sym_SEMI] = ACTIONS(708),
    [anon_sym_assert] = ACTIONS(710),
    [anon_sym_do] = ACTIONS(710),
    [anon_sym_while] = ACTIONS(710),
    [anon_sym_break] = ACTIONS(710),
    [anon_sym_continue] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(710),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_synchronized] = ACTIONS(710),
    [anon_sym_throw] = ACTIONS(710),
    [anon_sym_try] = ACTIONS(710),
    [anon_sym_if] = ACTIONS(710),
    [anon_sym_else] = ACTIONS(710),
    [anon_sym_for] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(710),
    [anon_sym_open] = ACTIONS(710),
    [anon_sym_module] = ACTIONS(710),
    [anon_sym_static] = ACTIONS(710),
    [anon_sym_package] = ACTIONS(710),
    [anon_sym_import] = ACTIONS(710),
    [anon_sym_enum] = ACTIONS(710),
    [anon_sym_public] = ACTIONS(710),
    [anon_sym_protected] = ACTIONS(710),
    [anon_sym_private] = ACTIONS(710),
    [anon_sym_abstract] = ACTIONS(710),
    [anon_sym_strictfp] = ACTIONS(710),
    [anon_sym_native] = ACTIONS(710),
    [anon_sym_transient] = ACTIONS(710),
    [anon_sym_volatile] = ACTIONS(710),
    [anon_sym_sealed] = ACTIONS(710),
    [anon_sym_non_DASHsealed] = ACTIONS(708),
    [anon_sym_record] = ACTIONS(710),
    [anon_sym_ATinterface] = ACTIONS(708),
    [anon_sym_interface] = ACTIONS(710),
    [anon_sym_byte] = ACTIONS(710),
    [anon_sym_short] = ACTIONS(710),
    [anon_sym_int] = ACTIONS(710),
    [anon_sym_long] = ACTIONS(710),
    [anon_sym_char] = ACTIONS(710),
    [anon_sym_float] = ACTIONS(710),
    [anon_sym_double] = ACTIONS(710),
    [sym_boolean_type] = ACTIONS(710),
    [sym_void_type] = ACTIONS(710),
    [sym_this] = ACTIONS(710),
    [sym_super] = ACTIONS(710),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [195] = {
    [ts_builtin_sym_end] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [sym_decimal_integer_literal] = ACTIONS(714),
    [sym_hex_integer_literal] = ACTIONS(714),
    [sym_octal_integer_literal] = ACTIONS(712),
    [sym_binary_integer_literal] = ACTIONS(712),
    [sym_decimal_floating_point_literal] = ACTIONS(712),
    [sym_hex_floating_point_literal] = ACTIONS(714),
    [sym_true] = ACTIONS(714),
    [sym_false] = ACTIONS(714),
    [sym_character_literal] = ACTIONS(712),
    [sym_string_literal] = ACTIONS(714),
    [sym_text_block] = ACTIONS(712),
    [sym_null_literal] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(712),
    [anon_sym_PLUS] = ACTIONS(714),
    [anon_sym_DASH] = ACTIONS(714),
    [anon_sym_final] = ACTIONS(714),
    [anon_sym_BANG] = ACTIONS(712),
    [anon_sym_TILDE] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(712),
    [anon_sym_DASH_DASH] = ACTIONS(712),
    [anon_sym_new] = ACTIONS(714),
    [anon_sym_class] = ACTIONS(714),
    [anon_sym_switch] = ACTIONS(714),
    [anon_sym_LBRACE] = ACTIONS(712),
    [anon_sym_RBRACE] = ACTIONS(712),
    [anon_sym_case] = ACTIONS(714),
    [anon_sym_default] = ACTIONS(714),
    [anon_sym_SEMI] = ACTIONS(712),
    [anon_sym_assert] = ACTIONS(714),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_while] = ACTIONS(714),
    [anon_sym_break] = ACTIONS(714),
    [anon_sym_continue] = ACTIONS(714),
    [anon_sym_return] = ACTIONS(714),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_synchronized] = ACTIONS(714),
    [anon_sym_throw] = ACTIONS(714),
    [anon_sym_try] = ACTIONS(714),
    [anon_sym_if] = ACTIONS(714),
    [anon_sym_else] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(714),
    [anon_sym_AT] = ACTIONS(714),
    [anon_sym_open] = ACTIONS(714),
    [anon_sym_module] = ACTIONS(714),
    [anon_sym_static] = ACTIONS(714),
    [anon_sym_package] = ACTIONS(714),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_enum] = ACTIONS(714),
    [anon_sym_public] = ACTIONS(714),
    [anon_sym_protected] = ACTIONS(714),
    [anon_sym_private] = ACTIONS(714),
    [anon_sym_abstract] = ACTIONS(714),
    [anon_sym_strictfp] = ACTIONS(714),
    [anon_sym_native] = ACTIONS(714),
    [anon_sym_transient] = ACTIONS(714),
    [anon_sym_volatile] = ACTIONS(714),
    [anon_sym_sealed] = ACTIONS(714),
    [anon_sym_non_DASHsealed] = ACTIONS(712),
    [anon_sym_record] = ACTIONS(714),
    [anon_sym_ATinterface] = ACTIONS(712),
    [anon_sym_interface] = ACTIONS(714),
    [anon_sym_byte] = ACTIONS(714),
    [anon_sym_short] = ACTIONS(714),
    [anon_sym_int] = ACTIONS(714),
    [anon_sym_long] = ACTIONS(714),
    [anon_sym_char] = ACTIONS(714),
    [anon_sym_float] = ACTIONS(714),
    [anon_sym_double] = ACTIONS(714),
    [sym_boolean_type] = ACTIONS(714),
    [sym_void_type] = ACTIONS(714),
    [sym_this] = ACTIONS(714),
    [sym_super] = ACTIONS(714),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [196] = {
    [ts_builtin_sym_end] = ACTIONS(716),
    [sym_identifier] = ACTIONS(718),
    [sym_decimal_integer_literal] = ACTIONS(718),
    [sym_hex_integer_literal] = ACTIONS(718),
    [sym_octal_integer_literal] = ACTIONS(716),
    [sym_binary_integer_literal] = ACTIONS(716),
    [sym_decimal_floating_point_literal] = ACTIONS(716),
    [sym_hex_floating_point_literal] = ACTIONS(718),
    [sym_true] = ACTIONS(718),
    [sym_false] = ACTIONS(718),
    [sym_character_literal] = ACTIONS(716),
    [sym_string_literal] = ACTIONS(718),
    [sym_text_block] = ACTIONS(716),
    [sym_null_literal] = ACTIONS(718),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_final] = ACTIONS(718),
    [anon_sym_BANG] = ACTIONS(716),
    [anon_sym_TILDE] = ACTIONS(716),
    [anon_sym_PLUS_PLUS] = ACTIONS(716),
    [anon_sym_DASH_DASH] = ACTIONS(716),
    [anon_sym_new] = ACTIONS(718),
    [anon_sym_class] = ACTIONS(718),
    [anon_sym_switch] = ACTIONS(718),
    [anon_sym_LBRACE] = ACTIONS(716),
    [anon_sym_RBRACE] = ACTIONS(716),
    [anon_sym_case] = ACTIONS(718),
    [anon_sym_default] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(716),
    [anon_sym_assert] = ACTIONS(718),
    [anon_sym_do] = ACTIONS(718),
    [anon_sym_while] = ACTIONS(718),
    [anon_sym_break] = ACTIONS(718),
    [anon_sym_continue] = ACTIONS(718),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(718),
    [anon_sym_synchronized] = ACTIONS(718),
    [anon_sym_throw] = ACTIONS(718),
    [anon_sym_try] = ACTIONS(718),
    [anon_sym_if] = ACTIONS(718),
    [anon_sym_else] = ACTIONS(718),
    [anon_sym_for] = ACTIONS(718),
    [anon_sym_AT] = ACTIONS(718),
    [anon_sym_open] = ACTIONS(718),
    [anon_sym_module] = ACTIONS(718),
    [anon_sym_static] = ACTIONS(718),
    [anon_sym_package] = ACTIONS(718),
    [anon_sym_import] = ACTIONS(718),
    [anon_sym_enum] = ACTIONS(718),
    [anon_sym_public] = ACTIONS(718),
    [anon_sym_protected] = ACTIONS(718),
    [anon_sym_private] = ACTIONS(718),
    [anon_sym_abstract] = ACTIONS(718),
    [anon_sym_strictfp] = ACTIONS(718),
    [anon_sym_native] = ACTIONS(718),
    [anon_sym_transient] = ACTIONS(718),
    [anon_sym_volatile] = ACTIONS(718),
    [anon_sym_sealed] = ACTIONS(718),
    [anon_sym_non_DASHsealed] = ACTIONS(716),
    [anon_sym_record] = ACTIONS(718),
    [anon_sym_ATinterface] = ACTIONS(716),
    [anon_sym_interface] = ACTIONS(718),
    [anon_sym_byte] = ACTIONS(718),
    [anon_sym_short] = ACTIONS(718),
    [anon_sym_int] = ACTIONS(718),
    [anon_sym_long] = ACTIONS(718),
    [anon_sym_char] = ACTIONS(718),
    [anon_sym_float] = ACTIONS(718),
    [anon_sym_double] = ACTIONS(718),
    [sym_boolean_type] = ACTIONS(718),
    [sym_void_type] = ACTIONS(718),
    [sym_this] = ACTIONS(718),
    [sym_super] = ACTIONS(718),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [197] = {
    [ts_builtin_sym_end] = ACTIONS(720),
    [sym_identifier] = ACTIONS(722),
    [sym_decimal_integer_literal] = ACTIONS(722),
    [sym_hex_integer_literal] = ACTIONS(722),
    [sym_octal_integer_literal] = ACTIONS(720),
    [sym_binary_integer_literal] = ACTIONS(720),
    [sym_decimal_floating_point_literal] = ACTIONS(720),
    [sym_hex_floating_point_literal] = ACTIONS(722),
    [sym_true] = ACTIONS(722),
    [sym_false] = ACTIONS(722),
    [sym_character_literal] = ACTIONS(720),
    [sym_string_literal] = ACTIONS(722),
    [sym_text_block] = ACTIONS(720),
    [sym_null_literal] = ACTIONS(722),
    [anon_sym_LPAREN] = ACTIONS(720),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_final] = ACTIONS(722),
    [anon_sym_BANG] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(720),
    [anon_sym_PLUS_PLUS] = ACTIONS(720),
    [anon_sym_DASH_DASH] = ACTIONS(720),
    [anon_sym_new] = ACTIONS(722),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_switch] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(720),
    [anon_sym_RBRACE] = ACTIONS(720),
    [anon_sym_case] = ACTIONS(722),
    [anon_sym_default] = ACTIONS(722),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_assert] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(722),
    [anon_sym_while] = ACTIONS(722),
    [anon_sym_break] = ACTIONS(722),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_return] = ACTIONS(722),
    [anon_sym_yield] = ACTIONS(722),
    [anon_sym_synchronized] = ACTIONS(722),
    [anon_sym_throw] = ACTIONS(722),
    [anon_sym_try] = ACTIONS(722),
    [anon_sym_if] = ACTIONS(722),
    [anon_sym_else] = ACTIONS(722),
    [anon_sym_for] = ACTIONS(722),
    [anon_sym_AT] = ACTIONS(722),
    [anon_sym_open] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_package] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(722),
    [anon_sym_enum] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_abstract] = ACTIONS(722),
    [anon_sym_strictfp] = ACTIONS(722),
    [anon_sym_native] = ACTIONS(722),
    [anon_sym_transient] = ACTIONS(722),
    [anon_sym_volatile] = ACTIONS(722),
    [anon_sym_sealed] = ACTIONS(722),
    [anon_sym_non_DASHsealed] = ACTIONS(720),
    [anon_sym_record] = ACTIONS(722),
    [anon_sym_ATinterface] = ACTIONS(720),
    [anon_sym_interface] = ACTIONS(722),
    [anon_sym_byte] = ACTIONS(722),
    [anon_sym_short] = ACTIONS(722),
    [anon_sym_int] = ACTIONS(722),
    [anon_sym_long] = ACTIONS(722),
    [anon_sym_char] = ACTIONS(722),
    [anon_sym_float] = ACTIONS(722),
    [anon_sym_double] = ACTIONS(722),
    [sym_boolean_type] = ACTIONS(722),
    [sym_void_type] = ACTIONS(722),
    [sym_this] = ACTIONS(722),
    [sym_super] = ACTIONS(722),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [198] = {
    [ts_builtin_sym_end] = ACTIONS(724),
    [sym_identifier] = ACTIONS(726),
    [sym_decimal_integer_literal] = ACTIONS(726),
    [sym_hex_integer_literal] = ACTIONS(726),
    [sym_octal_integer_literal] = ACTIONS(724),
    [sym_binary_integer_literal] = ACTIONS(724),
    [sym_decimal_floating_point_literal] = ACTIONS(724),
    [sym_hex_floating_point_literal] = ACTIONS(726),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_character_literal] = ACTIONS(724),
    [sym_string_literal] = ACTIONS(726),
    [sym_text_block] = ACTIONS(724),
    [sym_null_literal] = ACTIONS(726),
    [anon_sym_LPAREN] = ACTIONS(724),
    [anon_sym_PLUS] = ACTIONS(726),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_final] = ACTIONS(726),
    [anon_sym_BANG] = ACTIONS(724),
    [anon_sym_TILDE] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_new] = ACTIONS(726),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_switch] = ACTIONS(726),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_RBRACE] = ACTIONS(724),
    [anon_sym_case] = ACTIONS(726),
    [anon_sym_default] = ACTIONS(726),
    [anon_sym_SEMI] = ACTIONS(724),
    [anon_sym_assert] = ACTIONS(726),
    [anon_sym_do] = ACTIONS(726),
    [anon_sym_while] = ACTIONS(726),
    [anon_sym_break] = ACTIONS(726),
    [anon_sym_continue] = ACTIONS(726),
    [anon_sym_return] = ACTIONS(726),
    [anon_sym_yield] = ACTIONS(726),
    [anon_sym_synchronized] = ACTIONS(726),
    [anon_sym_throw] = ACTIONS(726),
    [anon_sym_try] = ACTIONS(726),
    [anon_sym_if] = ACTIONS(726),
    [anon_sym_else] = ACTIONS(726),
    [anon_sym_for] = ACTIONS(726),
    [anon_sym_AT] = ACTIONS(726),
    [anon_sym_open] = ACTIONS(726),
    [anon_sym_module] = ACTIONS(726),
    [anon_sym_static] = ACTIONS(726),
    [anon_sym_package] = ACTIONS(726),
    [anon_sym_import] = ACTIONS(726),
    [anon_sym_enum] = ACTIONS(726),
    [anon_sym_public] = ACTIONS(726),
    [anon_sym_protected] = ACTIONS(726),
    [anon_sym_private] = ACTIONS(726),
    [anon_sym_abstract] = ACTIONS(726),
    [anon_sym_strictfp] = ACTIONS(726),
    [anon_sym_native] = ACTIONS(726),
    [anon_sym_transient] = ACTIONS(726),
    [anon_sym_volatile] = ACTIONS(726),
    [anon_sym_sealed] = ACTIONS(726),
    [anon_sym_non_DASHsealed] = ACTIONS(724),
    [anon_sym_record] = ACTIONS(726),
    [anon_sym_ATinterface] = ACTIONS(724),
    [anon_sym_interface] = ACTIONS(726),
    [anon_sym_byte] = ACTIONS(726),
    [anon_sym_short] = ACTIONS(726),
    [anon_sym_int] = ACTIONS(726),
    [anon_sym_long] = ACTIONS(726),
    [anon_sym_char] = ACTIONS(726),
    [anon_sym_float] = ACTIONS(726),
    [anon_sym_double] = ACTIONS(726),
    [sym_boolean_type] = ACTIONS(726),
    [sym_void_type] = ACTIONS(726),
    [sym_this] = ACTIONS(726),
    [sym_super] = ACTIONS(726),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [199] = {
    [ts_builtin_sym_end] = ACTIONS(728),
    [sym_identifier] = ACTIONS(730),
    [sym_decimal_integer_literal] = ACTIONS(730),
    [sym_hex_integer_literal] = ACTIONS(730),
    [sym_octal_integer_literal] = ACTIONS(728),
    [sym_binary_integer_literal] = ACTIONS(728),
    [sym_decimal_floating_point_literal] = ACTIONS(728),
    [sym_hex_floating_point_literal] = ACTIONS(730),
    [sym_true] = ACTIONS(730),
    [sym_false] = ACTIONS(730),
    [sym_character_literal] = ACTIONS(728),
    [sym_string_literal] = ACTIONS(730),
    [sym_text_block] = ACTIONS(728),
    [sym_null_literal] = ACTIONS(730),
    [anon_sym_LPAREN] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(730),
    [anon_sym_DASH] = ACTIONS(730),
    [anon_sym_final] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_PLUS_PLUS] = ACTIONS(728),
    [anon_sym_DASH_DASH] = ACTIONS(728),
    [anon_sym_new] = ACTIONS(730),
    [anon_sym_class] = ACTIONS(730),
    [anon_sym_switch] = ACTIONS(730),
    [anon_sym_LBRACE] = ACTIONS(728),
    [anon_sym_RBRACE] = ACTIONS(728),
    [anon_sym_case] = ACTIONS(730),
    [anon_sym_default] = ACTIONS(730),
    [anon_sym_SEMI] = ACTIONS(728),
    [anon_sym_assert] = ACTIONS(730),
    [anon_sym_do] = ACTIONS(730),
    [anon_sym_while] = ACTIONS(730),
    [anon_sym_break] = ACTIONS(730),
    [anon_sym_continue] = ACTIONS(730),
    [anon_sym_return] = ACTIONS(730),
    [anon_sym_yield] = ACTIONS(730),
    [anon_sym_synchronized] = ACTIONS(730),
    [anon_sym_throw] = ACTIONS(730),
    [anon_sym_try] = ACTIONS(730),
    [anon_sym_if] = ACTIONS(730),
    [anon_sym_else] = ACTIONS(730),
    [anon_sym_for] = ACTIONS(730),
    [anon_sym_AT] = ACTIONS(730),
    [anon_sym_open] = ACTIONS(730),
    [anon_sym_module] = ACTIONS(730),
    [anon_sym_static] = ACTIONS(730),
    [anon_sym_package] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_enum] = ACTIONS(730),
    [anon_sym_public] = ACTIONS(730),
    [anon_sym_protected] = ACTIONS(730),
    [anon_sym_private] = ACTIONS(730),
    [anon_sym_abstract] = ACTIONS(730),
    [anon_sym_strictfp] = ACTIONS(730),
    [anon_sym_native] = ACTIONS(730),
    [anon_sym_transient] = ACTIONS(730),
    [anon_sym_volatile] = ACTIONS(730),
    [anon_sym_sealed] = ACTIONS(730),
    [anon_sym_non_DASHsealed] = ACTIONS(728),
    [anon_sym_record] = ACTIONS(730),
    [anon_sym_ATinterface] = ACTIONS(728),
    [anon_sym_interface] = ACTIONS(730),
    [anon_sym_byte] = ACTIONS(730),
    [anon_sym_short] = ACTIONS(730),
    [anon_sym_int] = ACTIONS(730),
    [anon_sym_long] = ACTIONS(730),
    [anon_sym_char] = ACTIONS(730),
    [anon_sym_float] = ACTIONS(730),
    [anon_sym_double] = ACTIONS(730),
    [sym_boolean_type] = ACTIONS(730),
    [sym_void_type] = ACTIONS(730),
    [sym_this] = ACTIONS(730),
    [sym_super] = ACTIONS(730),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [200] = {
    [ts_builtin_sym_end] = ACTIONS(732),
    [sym_identifier] = ACTIONS(734),
    [sym_decimal_integer_literal] = ACTIONS(734),
    [sym_hex_integer_literal] = ACTIONS(734),
    [sym_octal_integer_literal] = ACTIONS(732),
    [sym_binary_integer_literal] = ACTIONS(732),
    [sym_decimal_floating_point_literal] = ACTIONS(732),
    [sym_hex_floating_point_literal] = ACTIONS(734),
    [sym_true] = ACTIONS(734),
    [sym_false] = ACTIONS(734),
    [sym_character_literal] = ACTIONS(732),
    [sym_string_literal] = ACTIONS(734),
    [sym_text_block] = ACTIONS(732),
    [sym_null_literal] = ACTIONS(734),
    [anon_sym_LPAREN] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(734),
    [anon_sym_DASH] = ACTIONS(734),
    [anon_sym_final] = ACTIONS(734),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_PLUS_PLUS] = ACTIONS(732),
    [anon_sym_DASH_DASH] = ACTIONS(732),
    [anon_sym_new] = ACTIONS(734),
    [anon_sym_class] = ACTIONS(734),
    [anon_sym_switch] = ACTIONS(734),
    [anon_sym_LBRACE] = ACTIONS(732),
    [anon_sym_RBRACE] = ACTIONS(732),
    [anon_sym_case] = ACTIONS(734),
    [anon_sym_default] = ACTIONS(734),
    [anon_sym_SEMI] = ACTIONS(732),
    [anon_sym_assert] = ACTIONS(734),
    [anon_sym_do] = ACTIONS(734),
    [anon_sym_while] = ACTIONS(734),
    [anon_sym_break] = ACTIONS(734),
    [anon_sym_continue] = ACTIONS(734),
    [anon_sym_return] = ACTIONS(734),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_synchronized] = ACTIONS(734),
    [anon_sym_throw] = ACTIONS(734),
    [anon_sym_try] = ACTIONS(734),
    [anon_sym_if] = ACTIONS(734),
    [anon_sym_else] = ACTIONS(734),
    [anon_sym_for] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(734),
    [anon_sym_open] = ACTIONS(734),
    [anon_sym_module] = ACTIONS(734),
    [anon_sym_static] = ACTIONS(734),
    [anon_sym_package] = ACTIONS(734),
    [anon_sym_import] = ACTIONS(734),
    [anon_sym_enum] = ACTIONS(734),
    [anon_sym_public] = ACTIONS(734),
    [anon_sym_protected] = ACTIONS(734),
    [anon_sym_private] = ACTIONS(734),
    [anon_sym_abstract] = ACTIONS(734),
    [anon_sym_strictfp] = ACTIONS(734),
    [anon_sym_native] = ACTIONS(734),
    [anon_sym_transient] = ACTIONS(734),
    [anon_sym_volatile] = ACTIONS(734),
    [anon_sym_sealed] = ACTIONS(734),
    [anon_sym_non_DASHsealed] = ACTIONS(732),
    [anon_sym_record] = ACTIONS(734),
    [anon_sym_ATinterface] = ACTIONS(732),
    [anon_sym_interface] = ACTIONS(734),
    [anon_sym_byte] = ACTIONS(734),
    [anon_sym_short] = ACTIONS(734),
    [anon_sym_int] = ACTIONS(734),
    [anon_sym_long] = ACTIONS(734),
    [anon_sym_char] = ACTIONS(734),
    [anon_sym_float] = ACTIONS(734),
    [anon_sym_double] = ACTIONS(734),
    [sym_boolean_type] = ACTIONS(734),
    [sym_void_type] = ACTIONS(734),
    [sym_this] = ACTIONS(734),
    [sym_super] = ACTIONS(734),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [201] = {
    [ts_builtin_sym_end] = ACTIONS(736),
    [sym_identifier] = ACTIONS(738),
    [sym_decimal_integer_literal] = ACTIONS(738),
    [sym_hex_integer_literal] = ACTIONS(738),
    [sym_octal_integer_literal] = ACTIONS(736),
    [sym_binary_integer_literal] = ACTIONS(736),
    [sym_decimal_floating_point_literal] = ACTIONS(736),
    [sym_hex_floating_point_literal] = ACTIONS(738),
    [sym_true] = ACTIONS(738),
    [sym_false] = ACTIONS(738),
    [sym_character_literal] = ACTIONS(736),
    [sym_string_literal] = ACTIONS(738),
    [sym_text_block] = ACTIONS(736),
    [sym_null_literal] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(736),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_final] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_PLUS_PLUS] = ACTIONS(736),
    [anon_sym_DASH_DASH] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(738),
    [anon_sym_class] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(736),
    [anon_sym_RBRACE] = ACTIONS(736),
    [anon_sym_case] = ACTIONS(738),
    [anon_sym_default] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(736),
    [anon_sym_assert] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(738),
    [anon_sym_while] = ACTIONS(738),
    [anon_sym_break] = ACTIONS(738),
    [anon_sym_continue] = ACTIONS(738),
    [anon_sym_return] = ACTIONS(738),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_synchronized] = ACTIONS(738),
    [anon_sym_throw] = ACTIONS(738),
    [anon_sym_try] = ACTIONS(738),
    [anon_sym_if] = ACTIONS(738),
    [anon_sym_else] = ACTIONS(738),
    [anon_sym_for] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_open] = ACTIONS(738),
    [anon_sym_module] = ACTIONS(738),
    [anon_sym_static] = ACTIONS(738),
    [anon_sym_package] = ACTIONS(738),
    [anon_sym_import] = ACTIONS(738),
    [anon_sym_enum] = ACTIONS(738),
    [anon_sym_public] = ACTIONS(738),
    [anon_sym_protected] = ACTIONS(738),
    [anon_sym_private] = ACTIONS(738),
    [anon_sym_abstract] = ACTIONS(738),
    [anon_sym_strictfp] = ACTIONS(738),
    [anon_sym_native] = ACTIONS(738),
    [anon_sym_transient] = ACTIONS(738),
    [anon_sym_volatile] = ACTIONS(738),
    [anon_sym_sealed] = ACTIONS(738),
    [anon_sym_non_DASHsealed] = ACTIONS(736),
    [anon_sym_record] = ACTIONS(738),
    [anon_sym_ATinterface] = ACTIONS(736),
    [anon_sym_interface] = ACTIONS(738),
    [anon_sym_byte] = ACTIONS(738),
    [anon_sym_short] = ACTIONS(738),
    [anon_sym_int] = ACTIONS(738),
    [anon_sym_long] = ACTIONS(738),
    [anon_sym_char] = ACTIONS(738),
    [anon_sym_float] = ACTIONS(738),
    [anon_sym_double] = ACTIONS(738),
    [sym_boolean_type] = ACTIONS(738),
    [sym_void_type] = ACTIONS(738),
    [sym_this] = ACTIONS(738),
    [sym_super] = ACTIONS(738),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [202] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(527),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym_block] = STATE(520),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [203] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(581),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1234),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(393),
    [sym_array_access] = STATE(393),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym_block] = STATE(519),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1234),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(740),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(750),
    [anon_sym_module] = ACTIONS(750),
    [anon_sym_record] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [204] = {
    [ts_builtin_sym_end] = ACTIONS(281),
    [sym_identifier] = ACTIONS(283),
    [sym_decimal_integer_literal] = ACTIONS(283),
    [sym_hex_integer_literal] = ACTIONS(283),
    [sym_octal_integer_literal] = ACTIONS(281),
    [sym_binary_integer_literal] = ACTIONS(281),
    [sym_decimal_floating_point_literal] = ACTIONS(281),
    [sym_hex_floating_point_literal] = ACTIONS(283),
    [sym_true] = ACTIONS(283),
    [sym_false] = ACTIONS(283),
    [sym_character_literal] = ACTIONS(281),
    [sym_string_literal] = ACTIONS(283),
    [sym_text_block] = ACTIONS(281),
    [sym_null_literal] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(283),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_final] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [anon_sym_new] = ACTIONS(283),
    [anon_sym_class] = ACTIONS(283),
    [anon_sym_switch] = ACTIONS(283),
    [anon_sym_LBRACE] = ACTIONS(281),
    [anon_sym_RBRACE] = ACTIONS(281),
    [anon_sym_case] = ACTIONS(283),
    [anon_sym_default] = ACTIONS(283),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym_assert] = ACTIONS(283),
    [anon_sym_do] = ACTIONS(283),
    [anon_sym_while] = ACTIONS(283),
    [anon_sym_break] = ACTIONS(283),
    [anon_sym_continue] = ACTIONS(283),
    [anon_sym_return] = ACTIONS(283),
    [anon_sym_yield] = ACTIONS(283),
    [anon_sym_synchronized] = ACTIONS(283),
    [anon_sym_throw] = ACTIONS(283),
    [anon_sym_try] = ACTIONS(283),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_else] = ACTIONS(283),
    [anon_sym_for] = ACTIONS(283),
    [anon_sym_AT] = ACTIONS(283),
    [anon_sym_open] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(283),
    [anon_sym_static] = ACTIONS(283),
    [anon_sym_package] = ACTIONS(283),
    [anon_sym_import] = ACTIONS(283),
    [anon_sym_enum] = ACTIONS(283),
    [anon_sym_public] = ACTIONS(283),
    [anon_sym_protected] = ACTIONS(283),
    [anon_sym_private] = ACTIONS(283),
    [anon_sym_abstract] = ACTIONS(283),
    [anon_sym_strictfp] = ACTIONS(283),
    [anon_sym_native] = ACTIONS(283),
    [anon_sym_transient] = ACTIONS(283),
    [anon_sym_volatile] = ACTIONS(283),
    [anon_sym_sealed] = ACTIONS(283),
    [anon_sym_non_DASHsealed] = ACTIONS(281),
    [anon_sym_record] = ACTIONS(283),
    [anon_sym_ATinterface] = ACTIONS(281),
    [anon_sym_interface] = ACTIONS(283),
    [anon_sym_byte] = ACTIONS(283),
    [anon_sym_short] = ACTIONS(283),
    [anon_sym_int] = ACTIONS(283),
    [anon_sym_long] = ACTIONS(283),
    [anon_sym_char] = ACTIONS(283),
    [anon_sym_float] = ACTIONS(283),
    [anon_sym_double] = ACTIONS(283),
    [sym_boolean_type] = ACTIONS(283),
    [sym_void_type] = ACTIONS(283),
    [sym_this] = ACTIONS(283),
    [sym_super] = ACTIONS(283),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [205] = {
    [ts_builtin_sym_end] = ACTIONS(752),
    [sym_identifier] = ACTIONS(754),
    [sym_decimal_integer_literal] = ACTIONS(754),
    [sym_hex_integer_literal] = ACTIONS(754),
    [sym_octal_integer_literal] = ACTIONS(752),
    [sym_binary_integer_literal] = ACTIONS(752),
    [sym_decimal_floating_point_literal] = ACTIONS(752),
    [sym_hex_floating_point_literal] = ACTIONS(754),
    [sym_true] = ACTIONS(754),
    [sym_false] = ACTIONS(754),
    [sym_character_literal] = ACTIONS(752),
    [sym_string_literal] = ACTIONS(754),
    [sym_text_block] = ACTIONS(752),
    [sym_null_literal] = ACTIONS(754),
    [anon_sym_LPAREN] = ACTIONS(752),
    [anon_sym_PLUS] = ACTIONS(754),
    [anon_sym_DASH] = ACTIONS(754),
    [anon_sym_final] = ACTIONS(754),
    [anon_sym_BANG] = ACTIONS(752),
    [anon_sym_TILDE] = ACTIONS(752),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_new] = ACTIONS(754),
    [anon_sym_class] = ACTIONS(754),
    [anon_sym_switch] = ACTIONS(754),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_RBRACE] = ACTIONS(752),
    [anon_sym_case] = ACTIONS(754),
    [anon_sym_default] = ACTIONS(754),
    [anon_sym_SEMI] = ACTIONS(752),
    [anon_sym_assert] = ACTIONS(754),
    [anon_sym_do] = ACTIONS(754),
    [anon_sym_while] = ACTIONS(754),
    [anon_sym_break] = ACTIONS(754),
    [anon_sym_continue] = ACTIONS(754),
    [anon_sym_return] = ACTIONS(754),
    [anon_sym_yield] = ACTIONS(754),
    [anon_sym_synchronized] = ACTIONS(754),
    [anon_sym_throw] = ACTIONS(754),
    [anon_sym_try] = ACTIONS(754),
    [anon_sym_if] = ACTIONS(754),
    [anon_sym_else] = ACTIONS(754),
    [anon_sym_for] = ACTIONS(754),
    [anon_sym_AT] = ACTIONS(754),
    [anon_sym_open] = ACTIONS(754),
    [anon_sym_module] = ACTIONS(754),
    [anon_sym_static] = ACTIONS(754),
    [anon_sym_package] = ACTIONS(754),
    [anon_sym_import] = ACTIONS(754),
    [anon_sym_enum] = ACTIONS(754),
    [anon_sym_public] = ACTIONS(754),
    [anon_sym_protected] = ACTIONS(754),
    [anon_sym_private] = ACTIONS(754),
    [anon_sym_abstract] = ACTIONS(754),
    [anon_sym_strictfp] = ACTIONS(754),
    [anon_sym_native] = ACTIONS(754),
    [anon_sym_transient] = ACTIONS(754),
    [anon_sym_volatile] = ACTIONS(754),
    [anon_sym_sealed] = ACTIONS(754),
    [anon_sym_non_DASHsealed] = ACTIONS(752),
    [anon_sym_record] = ACTIONS(754),
    [anon_sym_ATinterface] = ACTIONS(752),
    [anon_sym_interface] = ACTIONS(754),
    [anon_sym_byte] = ACTIONS(754),
    [anon_sym_short] = ACTIONS(754),
    [anon_sym_int] = ACTIONS(754),
    [anon_sym_long] = ACTIONS(754),
    [anon_sym_char] = ACTIONS(754),
    [anon_sym_float] = ACTIONS(754),
    [anon_sym_double] = ACTIONS(754),
    [sym_boolean_type] = ACTIONS(754),
    [sym_void_type] = ACTIONS(754),
    [sym_this] = ACTIONS(754),
    [sym_super] = ACTIONS(754),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [206] = {
    [ts_builtin_sym_end] = ACTIONS(756),
    [sym_identifier] = ACTIONS(758),
    [sym_decimal_integer_literal] = ACTIONS(758),
    [sym_hex_integer_literal] = ACTIONS(758),
    [sym_octal_integer_literal] = ACTIONS(756),
    [sym_binary_integer_literal] = ACTIONS(756),
    [sym_decimal_floating_point_literal] = ACTIONS(756),
    [sym_hex_floating_point_literal] = ACTIONS(758),
    [sym_true] = ACTIONS(758),
    [sym_false] = ACTIONS(758),
    [sym_character_literal] = ACTIONS(756),
    [sym_string_literal] = ACTIONS(758),
    [sym_text_block] = ACTIONS(756),
    [sym_null_literal] = ACTIONS(758),
    [anon_sym_LPAREN] = ACTIONS(756),
    [anon_sym_PLUS] = ACTIONS(758),
    [anon_sym_DASH] = ACTIONS(758),
    [anon_sym_final] = ACTIONS(758),
    [anon_sym_BANG] = ACTIONS(756),
    [anon_sym_TILDE] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(756),
    [anon_sym_DASH_DASH] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(758),
    [anon_sym_class] = ACTIONS(758),
    [anon_sym_switch] = ACTIONS(758),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_RBRACE] = ACTIONS(756),
    [anon_sym_case] = ACTIONS(758),
    [anon_sym_default] = ACTIONS(758),
    [anon_sym_SEMI] = ACTIONS(756),
    [anon_sym_assert] = ACTIONS(758),
    [anon_sym_do] = ACTIONS(758),
    [anon_sym_while] = ACTIONS(758),
    [anon_sym_break] = ACTIONS(758),
    [anon_sym_continue] = ACTIONS(758),
    [anon_sym_return] = ACTIONS(758),
    [anon_sym_yield] = ACTIONS(758),
    [anon_sym_synchronized] = ACTIONS(758),
    [anon_sym_throw] = ACTIONS(758),
    [anon_sym_try] = ACTIONS(758),
    [anon_sym_if] = ACTIONS(758),
    [anon_sym_else] = ACTIONS(758),
    [anon_sym_for] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(758),
    [anon_sym_open] = ACTIONS(758),
    [anon_sym_module] = ACTIONS(758),
    [anon_sym_static] = ACTIONS(758),
    [anon_sym_package] = ACTIONS(758),
    [anon_sym_import] = ACTIONS(758),
    [anon_sym_enum] = ACTIONS(758),
    [anon_sym_public] = ACTIONS(758),
    [anon_sym_protected] = ACTIONS(758),
    [anon_sym_private] = ACTIONS(758),
    [anon_sym_abstract] = ACTIONS(758),
    [anon_sym_strictfp] = ACTIONS(758),
    [anon_sym_native] = ACTIONS(758),
    [anon_sym_transient] = ACTIONS(758),
    [anon_sym_volatile] = ACTIONS(758),
    [anon_sym_sealed] = ACTIONS(758),
    [anon_sym_non_DASHsealed] = ACTIONS(756),
    [anon_sym_record] = ACTIONS(758),
    [anon_sym_ATinterface] = ACTIONS(756),
    [anon_sym_interface] = ACTIONS(758),
    [anon_sym_byte] = ACTIONS(758),
    [anon_sym_short] = ACTIONS(758),
    [anon_sym_int] = ACTIONS(758),
    [anon_sym_long] = ACTIONS(758),
    [anon_sym_char] = ACTIONS(758),
    [anon_sym_float] = ACTIONS(758),
    [anon_sym_double] = ACTIONS(758),
    [sym_boolean_type] = ACTIONS(758),
    [sym_void_type] = ACTIONS(758),
    [sym_this] = ACTIONS(758),
    [sym_super] = ACTIONS(758),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [207] = {
    [ts_builtin_sym_end] = ACTIONS(760),
    [sym_identifier] = ACTIONS(762),
    [sym_decimal_integer_literal] = ACTIONS(762),
    [sym_hex_integer_literal] = ACTIONS(762),
    [sym_octal_integer_literal] = ACTIONS(760),
    [sym_binary_integer_literal] = ACTIONS(760),
    [sym_decimal_floating_point_literal] = ACTIONS(760),
    [sym_hex_floating_point_literal] = ACTIONS(762),
    [sym_true] = ACTIONS(762),
    [sym_false] = ACTIONS(762),
    [sym_character_literal] = ACTIONS(760),
    [sym_string_literal] = ACTIONS(762),
    [sym_text_block] = ACTIONS(760),
    [sym_null_literal] = ACTIONS(762),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_final] = ACTIONS(762),
    [anon_sym_BANG] = ACTIONS(760),
    [anon_sym_TILDE] = ACTIONS(760),
    [anon_sym_PLUS_PLUS] = ACTIONS(760),
    [anon_sym_DASH_DASH] = ACTIONS(760),
    [anon_sym_new] = ACTIONS(762),
    [anon_sym_class] = ACTIONS(762),
    [anon_sym_switch] = ACTIONS(762),
    [anon_sym_LBRACE] = ACTIONS(760),
    [anon_sym_RBRACE] = ACTIONS(760),
    [anon_sym_case] = ACTIONS(762),
    [anon_sym_default] = ACTIONS(762),
    [anon_sym_SEMI] = ACTIONS(760),
    [anon_sym_assert] = ACTIONS(762),
    [anon_sym_do] = ACTIONS(762),
    [anon_sym_while] = ACTIONS(762),
    [anon_sym_break] = ACTIONS(762),
    [anon_sym_continue] = ACTIONS(762),
    [anon_sym_return] = ACTIONS(762),
    [anon_sym_yield] = ACTIONS(762),
    [anon_sym_synchronized] = ACTIONS(762),
    [anon_sym_throw] = ACTIONS(762),
    [anon_sym_try] = ACTIONS(762),
    [anon_sym_if] = ACTIONS(762),
    [anon_sym_else] = ACTIONS(762),
    [anon_sym_for] = ACTIONS(762),
    [anon_sym_AT] = ACTIONS(762),
    [anon_sym_open] = ACTIONS(762),
    [anon_sym_module] = ACTIONS(762),
    [anon_sym_static] = ACTIONS(762),
    [anon_sym_package] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(762),
    [anon_sym_enum] = ACTIONS(762),
    [anon_sym_public] = ACTIONS(762),
    [anon_sym_protected] = ACTIONS(762),
    [anon_sym_private] = ACTIONS(762),
    [anon_sym_abstract] = ACTIONS(762),
    [anon_sym_strictfp] = ACTIONS(762),
    [anon_sym_native] = ACTIONS(762),
    [anon_sym_transient] = ACTIONS(762),
    [anon_sym_volatile] = ACTIONS(762),
    [anon_sym_sealed] = ACTIONS(762),
    [anon_sym_non_DASHsealed] = ACTIONS(760),
    [anon_sym_record] = ACTIONS(762),
    [anon_sym_ATinterface] = ACTIONS(760),
    [anon_sym_interface] = ACTIONS(762),
    [anon_sym_byte] = ACTIONS(762),
    [anon_sym_short] = ACTIONS(762),
    [anon_sym_int] = ACTIONS(762),
    [anon_sym_long] = ACTIONS(762),
    [anon_sym_char] = ACTIONS(762),
    [anon_sym_float] = ACTIONS(762),
    [anon_sym_double] = ACTIONS(762),
    [sym_boolean_type] = ACTIONS(762),
    [sym_void_type] = ACTIONS(762),
    [sym_this] = ACTIONS(762),
    [sym_super] = ACTIONS(762),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [208] = {
    [ts_builtin_sym_end] = ACTIONS(764),
    [sym_identifier] = ACTIONS(766),
    [sym_decimal_integer_literal] = ACTIONS(766),
    [sym_hex_integer_literal] = ACTIONS(766),
    [sym_octal_integer_literal] = ACTIONS(764),
    [sym_binary_integer_literal] = ACTIONS(764),
    [sym_decimal_floating_point_literal] = ACTIONS(764),
    [sym_hex_floating_point_literal] = ACTIONS(766),
    [sym_true] = ACTIONS(766),
    [sym_false] = ACTIONS(766),
    [sym_character_literal] = ACTIONS(764),
    [sym_string_literal] = ACTIONS(766),
    [sym_text_block] = ACTIONS(764),
    [sym_null_literal] = ACTIONS(766),
    [anon_sym_LPAREN] = ACTIONS(764),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_final] = ACTIONS(766),
    [anon_sym_BANG] = ACTIONS(764),
    [anon_sym_TILDE] = ACTIONS(764),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_class] = ACTIONS(766),
    [anon_sym_switch] = ACTIONS(766),
    [anon_sym_LBRACE] = ACTIONS(764),
    [anon_sym_RBRACE] = ACTIONS(764),
    [anon_sym_case] = ACTIONS(766),
    [anon_sym_default] = ACTIONS(766),
    [anon_sym_SEMI] = ACTIONS(764),
    [anon_sym_assert] = ACTIONS(766),
    [anon_sym_do] = ACTIONS(766),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_break] = ACTIONS(766),
    [anon_sym_continue] = ACTIONS(766),
    [anon_sym_return] = ACTIONS(766),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_synchronized] = ACTIONS(766),
    [anon_sym_throw] = ACTIONS(766),
    [anon_sym_try] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(766),
    [anon_sym_else] = ACTIONS(766),
    [anon_sym_for] = ACTIONS(766),
    [anon_sym_AT] = ACTIONS(766),
    [anon_sym_open] = ACTIONS(766),
    [anon_sym_module] = ACTIONS(766),
    [anon_sym_static] = ACTIONS(766),
    [anon_sym_package] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(766),
    [anon_sym_enum] = ACTIONS(766),
    [anon_sym_public] = ACTIONS(766),
    [anon_sym_protected] = ACTIONS(766),
    [anon_sym_private] = ACTIONS(766),
    [anon_sym_abstract] = ACTIONS(766),
    [anon_sym_strictfp] = ACTIONS(766),
    [anon_sym_native] = ACTIONS(766),
    [anon_sym_transient] = ACTIONS(766),
    [anon_sym_volatile] = ACTIONS(766),
    [anon_sym_sealed] = ACTIONS(766),
    [anon_sym_non_DASHsealed] = ACTIONS(764),
    [anon_sym_record] = ACTIONS(766),
    [anon_sym_ATinterface] = ACTIONS(764),
    [anon_sym_interface] = ACTIONS(766),
    [anon_sym_byte] = ACTIONS(766),
    [anon_sym_short] = ACTIONS(766),
    [anon_sym_int] = ACTIONS(766),
    [anon_sym_long] = ACTIONS(766),
    [anon_sym_char] = ACTIONS(766),
    [anon_sym_float] = ACTIONS(766),
    [anon_sym_double] = ACTIONS(766),
    [sym_boolean_type] = ACTIONS(766),
    [sym_void_type] = ACTIONS(766),
    [sym_this] = ACTIONS(766),
    [sym_super] = ACTIONS(766),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [209] = {
    [ts_builtin_sym_end] = ACTIONS(768),
    [sym_identifier] = ACTIONS(770),
    [sym_decimal_integer_literal] = ACTIONS(770),
    [sym_hex_integer_literal] = ACTIONS(770),
    [sym_octal_integer_literal] = ACTIONS(768),
    [sym_binary_integer_literal] = ACTIONS(768),
    [sym_decimal_floating_point_literal] = ACTIONS(768),
    [sym_hex_floating_point_literal] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_character_literal] = ACTIONS(768),
    [sym_string_literal] = ACTIONS(770),
    [sym_text_block] = ACTIONS(768),
    [sym_null_literal] = ACTIONS(770),
    [anon_sym_LPAREN] = ACTIONS(768),
    [anon_sym_PLUS] = ACTIONS(770),
    [anon_sym_DASH] = ACTIONS(770),
    [anon_sym_final] = ACTIONS(770),
    [anon_sym_BANG] = ACTIONS(768),
    [anon_sym_TILDE] = ACTIONS(768),
    [anon_sym_PLUS_PLUS] = ACTIONS(768),
    [anon_sym_DASH_DASH] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(770),
    [anon_sym_class] = ACTIONS(770),
    [anon_sym_switch] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(768),
    [anon_sym_RBRACE] = ACTIONS(768),
    [anon_sym_case] = ACTIONS(770),
    [anon_sym_default] = ACTIONS(770),
    [anon_sym_SEMI] = ACTIONS(768),
    [anon_sym_assert] = ACTIONS(770),
    [anon_sym_do] = ACTIONS(770),
    [anon_sym_while] = ACTIONS(770),
    [anon_sym_break] = ACTIONS(770),
    [anon_sym_continue] = ACTIONS(770),
    [anon_sym_return] = ACTIONS(770),
    [anon_sym_yield] = ACTIONS(770),
    [anon_sym_synchronized] = ACTIONS(770),
    [anon_sym_throw] = ACTIONS(770),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_if] = ACTIONS(770),
    [anon_sym_else] = ACTIONS(770),
    [anon_sym_for] = ACTIONS(770),
    [anon_sym_AT] = ACTIONS(770),
    [anon_sym_open] = ACTIONS(770),
    [anon_sym_module] = ACTIONS(770),
    [anon_sym_static] = ACTIONS(770),
    [anon_sym_package] = ACTIONS(770),
    [anon_sym_import] = ACTIONS(770),
    [anon_sym_enum] = ACTIONS(770),
    [anon_sym_public] = ACTIONS(770),
    [anon_sym_protected] = ACTIONS(770),
    [anon_sym_private] = ACTIONS(770),
    [anon_sym_abstract] = ACTIONS(770),
    [anon_sym_strictfp] = ACTIONS(770),
    [anon_sym_native] = ACTIONS(770),
    [anon_sym_transient] = ACTIONS(770),
    [anon_sym_volatile] = ACTIONS(770),
    [anon_sym_sealed] = ACTIONS(770),
    [anon_sym_non_DASHsealed] = ACTIONS(768),
    [anon_sym_record] = ACTIONS(770),
    [anon_sym_ATinterface] = ACTIONS(768),
    [anon_sym_interface] = ACTIONS(770),
    [anon_sym_byte] = ACTIONS(770),
    [anon_sym_short] = ACTIONS(770),
    [anon_sym_int] = ACTIONS(770),
    [anon_sym_long] = ACTIONS(770),
    [anon_sym_char] = ACTIONS(770),
    [anon_sym_float] = ACTIONS(770),
    [anon_sym_double] = ACTIONS(770),
    [sym_boolean_type] = ACTIONS(770),
    [sym_void_type] = ACTIONS(770),
    [sym_this] = ACTIONS(770),
    [sym_super] = ACTIONS(770),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [210] = {
    [ts_builtin_sym_end] = ACTIONS(772),
    [sym_identifier] = ACTIONS(774),
    [sym_decimal_integer_literal] = ACTIONS(774),
    [sym_hex_integer_literal] = ACTIONS(774),
    [sym_octal_integer_literal] = ACTIONS(772),
    [sym_binary_integer_literal] = ACTIONS(772),
    [sym_decimal_floating_point_literal] = ACTIONS(772),
    [sym_hex_floating_point_literal] = ACTIONS(774),
    [sym_true] = ACTIONS(774),
    [sym_false] = ACTIONS(774),
    [sym_character_literal] = ACTIONS(772),
    [sym_string_literal] = ACTIONS(774),
    [sym_text_block] = ACTIONS(772),
    [sym_null_literal] = ACTIONS(774),
    [anon_sym_LPAREN] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(774),
    [anon_sym_DASH] = ACTIONS(774),
    [anon_sym_final] = ACTIONS(774),
    [anon_sym_BANG] = ACTIONS(772),
    [anon_sym_TILDE] = ACTIONS(772),
    [anon_sym_PLUS_PLUS] = ACTIONS(772),
    [anon_sym_DASH_DASH] = ACTIONS(772),
    [anon_sym_new] = ACTIONS(774),
    [anon_sym_class] = ACTIONS(774),
    [anon_sym_switch] = ACTIONS(774),
    [anon_sym_LBRACE] = ACTIONS(772),
    [anon_sym_RBRACE] = ACTIONS(772),
    [anon_sym_case] = ACTIONS(774),
    [anon_sym_default] = ACTIONS(774),
    [anon_sym_SEMI] = ACTIONS(772),
    [anon_sym_assert] = ACTIONS(774),
    [anon_sym_do] = ACTIONS(774),
    [anon_sym_while] = ACTIONS(774),
    [anon_sym_break] = ACTIONS(774),
    [anon_sym_continue] = ACTIONS(774),
    [anon_sym_return] = ACTIONS(774),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_synchronized] = ACTIONS(774),
    [anon_sym_throw] = ACTIONS(774),
    [anon_sym_try] = ACTIONS(774),
    [anon_sym_if] = ACTIONS(774),
    [anon_sym_else] = ACTIONS(774),
    [anon_sym_for] = ACTIONS(774),
    [anon_sym_AT] = ACTIONS(774),
    [anon_sym_open] = ACTIONS(774),
    [anon_sym_module] = ACTIONS(774),
    [anon_sym_static] = ACTIONS(774),
    [anon_sym_package] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(774),
    [anon_sym_enum] = ACTIONS(774),
    [anon_sym_public] = ACTIONS(774),
    [anon_sym_protected] = ACTIONS(774),
    [anon_sym_private] = ACTIONS(774),
    [anon_sym_abstract] = ACTIONS(774),
    [anon_sym_strictfp] = ACTIONS(774),
    [anon_sym_native] = ACTIONS(774),
    [anon_sym_transient] = ACTIONS(774),
    [anon_sym_volatile] = ACTIONS(774),
    [anon_sym_sealed] = ACTIONS(774),
    [anon_sym_non_DASHsealed] = ACTIONS(772),
    [anon_sym_record] = ACTIONS(774),
    [anon_sym_ATinterface] = ACTIONS(772),
    [anon_sym_interface] = ACTIONS(774),
    [anon_sym_byte] = ACTIONS(774),
    [anon_sym_short] = ACTIONS(774),
    [anon_sym_int] = ACTIONS(774),
    [anon_sym_long] = ACTIONS(774),
    [anon_sym_char] = ACTIONS(774),
    [anon_sym_float] = ACTIONS(774),
    [anon_sym_double] = ACTIONS(774),
    [sym_boolean_type] = ACTIONS(774),
    [sym_void_type] = ACTIONS(774),
    [sym_this] = ACTIONS(774),
    [sym_super] = ACTIONS(774),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [211] = {
    [ts_builtin_sym_end] = ACTIONS(776),
    [sym_identifier] = ACTIONS(778),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(778),
    [sym_octal_integer_literal] = ACTIONS(776),
    [sym_binary_integer_literal] = ACTIONS(776),
    [sym_decimal_floating_point_literal] = ACTIONS(776),
    [sym_hex_floating_point_literal] = ACTIONS(778),
    [sym_true] = ACTIONS(778),
    [sym_false] = ACTIONS(778),
    [sym_character_literal] = ACTIONS(776),
    [sym_string_literal] = ACTIONS(778),
    [sym_text_block] = ACTIONS(776),
    [sym_null_literal] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(776),
    [anon_sym_PLUS] = ACTIONS(778),
    [anon_sym_DASH] = ACTIONS(778),
    [anon_sym_final] = ACTIONS(778),
    [anon_sym_BANG] = ACTIONS(776),
    [anon_sym_TILDE] = ACTIONS(776),
    [anon_sym_PLUS_PLUS] = ACTIONS(776),
    [anon_sym_DASH_DASH] = ACTIONS(776),
    [anon_sym_new] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(778),
    [anon_sym_switch] = ACTIONS(778),
    [anon_sym_LBRACE] = ACTIONS(776),
    [anon_sym_RBRACE] = ACTIONS(776),
    [anon_sym_case] = ACTIONS(778),
    [anon_sym_default] = ACTIONS(778),
    [anon_sym_SEMI] = ACTIONS(776),
    [anon_sym_assert] = ACTIONS(778),
    [anon_sym_do] = ACTIONS(778),
    [anon_sym_while] = ACTIONS(778),
    [anon_sym_break] = ACTIONS(778),
    [anon_sym_continue] = ACTIONS(778),
    [anon_sym_return] = ACTIONS(778),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_synchronized] = ACTIONS(778),
    [anon_sym_throw] = ACTIONS(778),
    [anon_sym_try] = ACTIONS(778),
    [anon_sym_if] = ACTIONS(778),
    [anon_sym_else] = ACTIONS(778),
    [anon_sym_for] = ACTIONS(778),
    [anon_sym_AT] = ACTIONS(778),
    [anon_sym_open] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_package] = ACTIONS(778),
    [anon_sym_import] = ACTIONS(778),
    [anon_sym_enum] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_abstract] = ACTIONS(778),
    [anon_sym_strictfp] = ACTIONS(778),
    [anon_sym_native] = ACTIONS(778),
    [anon_sym_transient] = ACTIONS(778),
    [anon_sym_volatile] = ACTIONS(778),
    [anon_sym_sealed] = ACTIONS(778),
    [anon_sym_non_DASHsealed] = ACTIONS(776),
    [anon_sym_record] = ACTIONS(778),
    [anon_sym_ATinterface] = ACTIONS(776),
    [anon_sym_interface] = ACTIONS(778),
    [anon_sym_byte] = ACTIONS(778),
    [anon_sym_short] = ACTIONS(778),
    [anon_sym_int] = ACTIONS(778),
    [anon_sym_long] = ACTIONS(778),
    [anon_sym_char] = ACTIONS(778),
    [anon_sym_float] = ACTIONS(778),
    [anon_sym_double] = ACTIONS(778),
    [sym_boolean_type] = ACTIONS(778),
    [sym_void_type] = ACTIONS(778),
    [sym_this] = ACTIONS(778),
    [sym_super] = ACTIONS(778),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [212] = {
    [ts_builtin_sym_end] = ACTIONS(780),
    [sym_identifier] = ACTIONS(782),
    [sym_decimal_integer_literal] = ACTIONS(782),
    [sym_hex_integer_literal] = ACTIONS(782),
    [sym_octal_integer_literal] = ACTIONS(780),
    [sym_binary_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(780),
    [sym_hex_floating_point_literal] = ACTIONS(782),
    [sym_true] = ACTIONS(782),
    [sym_false] = ACTIONS(782),
    [sym_character_literal] = ACTIONS(780),
    [sym_string_literal] = ACTIONS(782),
    [sym_text_block] = ACTIONS(780),
    [sym_null_literal] = ACTIONS(782),
    [anon_sym_LPAREN] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(782),
    [anon_sym_DASH] = ACTIONS(782),
    [anon_sym_final] = ACTIONS(782),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(780),
    [anon_sym_DASH_DASH] = ACTIONS(780),
    [anon_sym_new] = ACTIONS(782),
    [anon_sym_class] = ACTIONS(782),
    [anon_sym_switch] = ACTIONS(782),
    [anon_sym_LBRACE] = ACTIONS(780),
    [anon_sym_RBRACE] = ACTIONS(780),
    [anon_sym_case] = ACTIONS(782),
    [anon_sym_default] = ACTIONS(782),
    [anon_sym_SEMI] = ACTIONS(780),
    [anon_sym_assert] = ACTIONS(782),
    [anon_sym_do] = ACTIONS(782),
    [anon_sym_while] = ACTIONS(782),
    [anon_sym_break] = ACTIONS(782),
    [anon_sym_continue] = ACTIONS(782),
    [anon_sym_return] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(782),
    [anon_sym_synchronized] = ACTIONS(782),
    [anon_sym_throw] = ACTIONS(782),
    [anon_sym_try] = ACTIONS(782),
    [anon_sym_if] = ACTIONS(782),
    [anon_sym_else] = ACTIONS(782),
    [anon_sym_for] = ACTIONS(782),
    [anon_sym_AT] = ACTIONS(782),
    [anon_sym_open] = ACTIONS(782),
    [anon_sym_module] = ACTIONS(782),
    [anon_sym_static] = ACTIONS(782),
    [anon_sym_package] = ACTIONS(782),
    [anon_sym_import] = ACTIONS(782),
    [anon_sym_enum] = ACTIONS(782),
    [anon_sym_public] = ACTIONS(782),
    [anon_sym_protected] = ACTIONS(782),
    [anon_sym_private] = ACTIONS(782),
    [anon_sym_abstract] = ACTIONS(782),
    [anon_sym_strictfp] = ACTIONS(782),
    [anon_sym_native] = ACTIONS(782),
    [anon_sym_transient] = ACTIONS(782),
    [anon_sym_volatile] = ACTIONS(782),
    [anon_sym_sealed] = ACTIONS(782),
    [anon_sym_non_DASHsealed] = ACTIONS(780),
    [anon_sym_record] = ACTIONS(782),
    [anon_sym_ATinterface] = ACTIONS(780),
    [anon_sym_interface] = ACTIONS(782),
    [anon_sym_byte] = ACTIONS(782),
    [anon_sym_short] = ACTIONS(782),
    [anon_sym_int] = ACTIONS(782),
    [anon_sym_long] = ACTIONS(782),
    [anon_sym_char] = ACTIONS(782),
    [anon_sym_float] = ACTIONS(782),
    [anon_sym_double] = ACTIONS(782),
    [sym_boolean_type] = ACTIONS(782),
    [sym_void_type] = ACTIONS(782),
    [sym_this] = ACTIONS(782),
    [sym_super] = ACTIONS(782),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [213] = {
    [ts_builtin_sym_end] = ACTIONS(784),
    [sym_identifier] = ACTIONS(786),
    [sym_decimal_integer_literal] = ACTIONS(786),
    [sym_hex_integer_literal] = ACTIONS(786),
    [sym_octal_integer_literal] = ACTIONS(784),
    [sym_binary_integer_literal] = ACTIONS(784),
    [sym_decimal_floating_point_literal] = ACTIONS(784),
    [sym_hex_floating_point_literal] = ACTIONS(786),
    [sym_true] = ACTIONS(786),
    [sym_false] = ACTIONS(786),
    [sym_character_literal] = ACTIONS(784),
    [sym_string_literal] = ACTIONS(786),
    [sym_text_block] = ACTIONS(784),
    [sym_null_literal] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(786),
    [anon_sym_DASH] = ACTIONS(786),
    [anon_sym_final] = ACTIONS(786),
    [anon_sym_BANG] = ACTIONS(784),
    [anon_sym_TILDE] = ACTIONS(784),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_class] = ACTIONS(786),
    [anon_sym_switch] = ACTIONS(786),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_RBRACE] = ACTIONS(784),
    [anon_sym_case] = ACTIONS(786),
    [anon_sym_default] = ACTIONS(786),
    [anon_sym_SEMI] = ACTIONS(784),
    [anon_sym_assert] = ACTIONS(786),
    [anon_sym_do] = ACTIONS(786),
    [anon_sym_while] = ACTIONS(786),
    [anon_sym_break] = ACTIONS(786),
    [anon_sym_continue] = ACTIONS(786),
    [anon_sym_return] = ACTIONS(786),
    [anon_sym_yield] = ACTIONS(786),
    [anon_sym_synchronized] = ACTIONS(786),
    [anon_sym_throw] = ACTIONS(786),
    [anon_sym_try] = ACTIONS(786),
    [anon_sym_if] = ACTIONS(786),
    [anon_sym_else] = ACTIONS(786),
    [anon_sym_for] = ACTIONS(786),
    [anon_sym_AT] = ACTIONS(786),
    [anon_sym_open] = ACTIONS(786),
    [anon_sym_module] = ACTIONS(786),
    [anon_sym_static] = ACTIONS(786),
    [anon_sym_package] = ACTIONS(786),
    [anon_sym_import] = ACTIONS(786),
    [anon_sym_enum] = ACTIONS(786),
    [anon_sym_public] = ACTIONS(786),
    [anon_sym_protected] = ACTIONS(786),
    [anon_sym_private] = ACTIONS(786),
    [anon_sym_abstract] = ACTIONS(786),
    [anon_sym_strictfp] = ACTIONS(786),
    [anon_sym_native] = ACTIONS(786),
    [anon_sym_transient] = ACTIONS(786),
    [anon_sym_volatile] = ACTIONS(786),
    [anon_sym_sealed] = ACTIONS(786),
    [anon_sym_non_DASHsealed] = ACTIONS(784),
    [anon_sym_record] = ACTIONS(786),
    [anon_sym_ATinterface] = ACTIONS(784),
    [anon_sym_interface] = ACTIONS(786),
    [anon_sym_byte] = ACTIONS(786),
    [anon_sym_short] = ACTIONS(786),
    [anon_sym_int] = ACTIONS(786),
    [anon_sym_long] = ACTIONS(786),
    [anon_sym_char] = ACTIONS(786),
    [anon_sym_float] = ACTIONS(786),
    [anon_sym_double] = ACTIONS(786),
    [sym_boolean_type] = ACTIONS(786),
    [sym_void_type] = ACTIONS(786),
    [sym_this] = ACTIONS(786),
    [sym_super] = ACTIONS(786),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [214] = {
    [ts_builtin_sym_end] = ACTIONS(788),
    [sym_identifier] = ACTIONS(790),
    [sym_decimal_integer_literal] = ACTIONS(790),
    [sym_hex_integer_literal] = ACTIONS(790),
    [sym_octal_integer_literal] = ACTIONS(788),
    [sym_binary_integer_literal] = ACTIONS(788),
    [sym_decimal_floating_point_literal] = ACTIONS(788),
    [sym_hex_floating_point_literal] = ACTIONS(790),
    [sym_true] = ACTIONS(790),
    [sym_false] = ACTIONS(790),
    [sym_character_literal] = ACTIONS(788),
    [sym_string_literal] = ACTIONS(790),
    [sym_text_block] = ACTIONS(788),
    [sym_null_literal] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(788),
    [anon_sym_PLUS] = ACTIONS(790),
    [anon_sym_DASH] = ACTIONS(790),
    [anon_sym_final] = ACTIONS(790),
    [anon_sym_BANG] = ACTIONS(788),
    [anon_sym_TILDE] = ACTIONS(788),
    [anon_sym_PLUS_PLUS] = ACTIONS(788),
    [anon_sym_DASH_DASH] = ACTIONS(788),
    [anon_sym_new] = ACTIONS(790),
    [anon_sym_class] = ACTIONS(790),
    [anon_sym_switch] = ACTIONS(790),
    [anon_sym_LBRACE] = ACTIONS(788),
    [anon_sym_RBRACE] = ACTIONS(788),
    [anon_sym_case] = ACTIONS(790),
    [anon_sym_default] = ACTIONS(790),
    [anon_sym_SEMI] = ACTIONS(788),
    [anon_sym_assert] = ACTIONS(790),
    [anon_sym_do] = ACTIONS(790),
    [anon_sym_while] = ACTIONS(790),
    [anon_sym_break] = ACTIONS(790),
    [anon_sym_continue] = ACTIONS(790),
    [anon_sym_return] = ACTIONS(790),
    [anon_sym_yield] = ACTIONS(790),
    [anon_sym_synchronized] = ACTIONS(790),
    [anon_sym_throw] = ACTIONS(790),
    [anon_sym_try] = ACTIONS(790),
    [anon_sym_if] = ACTIONS(790),
    [anon_sym_else] = ACTIONS(790),
    [anon_sym_for] = ACTIONS(790),
    [anon_sym_AT] = ACTIONS(790),
    [anon_sym_open] = ACTIONS(790),
    [anon_sym_module] = ACTIONS(790),
    [anon_sym_static] = ACTIONS(790),
    [anon_sym_package] = ACTIONS(790),
    [anon_sym_import] = ACTIONS(790),
    [anon_sym_enum] = ACTIONS(790),
    [anon_sym_public] = ACTIONS(790),
    [anon_sym_protected] = ACTIONS(790),
    [anon_sym_private] = ACTIONS(790),
    [anon_sym_abstract] = ACTIONS(790),
    [anon_sym_strictfp] = ACTIONS(790),
    [anon_sym_native] = ACTIONS(790),
    [anon_sym_transient] = ACTIONS(790),
    [anon_sym_volatile] = ACTIONS(790),
    [anon_sym_sealed] = ACTIONS(790),
    [anon_sym_non_DASHsealed] = ACTIONS(788),
    [anon_sym_record] = ACTIONS(790),
    [anon_sym_ATinterface] = ACTIONS(788),
    [anon_sym_interface] = ACTIONS(790),
    [anon_sym_byte] = ACTIONS(790),
    [anon_sym_short] = ACTIONS(790),
    [anon_sym_int] = ACTIONS(790),
    [anon_sym_long] = ACTIONS(790),
    [anon_sym_char] = ACTIONS(790),
    [anon_sym_float] = ACTIONS(790),
    [anon_sym_double] = ACTIONS(790),
    [sym_boolean_type] = ACTIONS(790),
    [sym_void_type] = ACTIONS(790),
    [sym_this] = ACTIONS(790),
    [sym_super] = ACTIONS(790),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [215] = {
    [ts_builtin_sym_end] = ACTIONS(792),
    [sym_identifier] = ACTIONS(794),
    [sym_decimal_integer_literal] = ACTIONS(794),
    [sym_hex_integer_literal] = ACTIONS(794),
    [sym_octal_integer_literal] = ACTIONS(792),
    [sym_binary_integer_literal] = ACTIONS(792),
    [sym_decimal_floating_point_literal] = ACTIONS(792),
    [sym_hex_floating_point_literal] = ACTIONS(794),
    [sym_true] = ACTIONS(794),
    [sym_false] = ACTIONS(794),
    [sym_character_literal] = ACTIONS(792),
    [sym_string_literal] = ACTIONS(794),
    [sym_text_block] = ACTIONS(792),
    [sym_null_literal] = ACTIONS(794),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_PLUS] = ACTIONS(794),
    [anon_sym_DASH] = ACTIONS(794),
    [anon_sym_final] = ACTIONS(794),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_new] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(794),
    [anon_sym_switch] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(792),
    [anon_sym_RBRACE] = ACTIONS(792),
    [anon_sym_case] = ACTIONS(794),
    [anon_sym_default] = ACTIONS(794),
    [anon_sym_SEMI] = ACTIONS(792),
    [anon_sym_assert] = ACTIONS(794),
    [anon_sym_do] = ACTIONS(794),
    [anon_sym_while] = ACTIONS(794),
    [anon_sym_break] = ACTIONS(794),
    [anon_sym_continue] = ACTIONS(794),
    [anon_sym_return] = ACTIONS(794),
    [anon_sym_yield] = ACTIONS(794),
    [anon_sym_synchronized] = ACTIONS(794),
    [anon_sym_throw] = ACTIONS(794),
    [anon_sym_try] = ACTIONS(794),
    [anon_sym_if] = ACTIONS(794),
    [anon_sym_else] = ACTIONS(794),
    [anon_sym_for] = ACTIONS(794),
    [anon_sym_AT] = ACTIONS(794),
    [anon_sym_open] = ACTIONS(794),
    [anon_sym_module] = ACTIONS(794),
    [anon_sym_static] = ACTIONS(794),
    [anon_sym_package] = ACTIONS(794),
    [anon_sym_import] = ACTIONS(794),
    [anon_sym_enum] = ACTIONS(794),
    [anon_sym_public] = ACTIONS(794),
    [anon_sym_protected] = ACTIONS(794),
    [anon_sym_private] = ACTIONS(794),
    [anon_sym_abstract] = ACTIONS(794),
    [anon_sym_strictfp] = ACTIONS(794),
    [anon_sym_native] = ACTIONS(794),
    [anon_sym_transient] = ACTIONS(794),
    [anon_sym_volatile] = ACTIONS(794),
    [anon_sym_sealed] = ACTIONS(794),
    [anon_sym_non_DASHsealed] = ACTIONS(792),
    [anon_sym_record] = ACTIONS(794),
    [anon_sym_ATinterface] = ACTIONS(792),
    [anon_sym_interface] = ACTIONS(794),
    [anon_sym_byte] = ACTIONS(794),
    [anon_sym_short] = ACTIONS(794),
    [anon_sym_int] = ACTIONS(794),
    [anon_sym_long] = ACTIONS(794),
    [anon_sym_char] = ACTIONS(794),
    [anon_sym_float] = ACTIONS(794),
    [anon_sym_double] = ACTIONS(794),
    [sym_boolean_type] = ACTIONS(794),
    [sym_void_type] = ACTIONS(794),
    [sym_this] = ACTIONS(794),
    [sym_super] = ACTIONS(794),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [216] = {
    [ts_builtin_sym_end] = ACTIONS(796),
    [sym_identifier] = ACTIONS(798),
    [sym_decimal_integer_literal] = ACTIONS(798),
    [sym_hex_integer_literal] = ACTIONS(798),
    [sym_octal_integer_literal] = ACTIONS(796),
    [sym_binary_integer_literal] = ACTIONS(796),
    [sym_decimal_floating_point_literal] = ACTIONS(796),
    [sym_hex_floating_point_literal] = ACTIONS(798),
    [sym_true] = ACTIONS(798),
    [sym_false] = ACTIONS(798),
    [sym_character_literal] = ACTIONS(796),
    [sym_string_literal] = ACTIONS(798),
    [sym_text_block] = ACTIONS(796),
    [sym_null_literal] = ACTIONS(798),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_final] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(796),
    [anon_sym_TILDE] = ACTIONS(796),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_new] = ACTIONS(798),
    [anon_sym_class] = ACTIONS(798),
    [anon_sym_switch] = ACTIONS(798),
    [anon_sym_LBRACE] = ACTIONS(796),
    [anon_sym_RBRACE] = ACTIONS(796),
    [anon_sym_case] = ACTIONS(798),
    [anon_sym_default] = ACTIONS(798),
    [anon_sym_SEMI] = ACTIONS(796),
    [anon_sym_assert] = ACTIONS(798),
    [anon_sym_do] = ACTIONS(798),
    [anon_sym_while] = ACTIONS(798),
    [anon_sym_break] = ACTIONS(798),
    [anon_sym_continue] = ACTIONS(798),
    [anon_sym_return] = ACTIONS(798),
    [anon_sym_yield] = ACTIONS(798),
    [anon_sym_synchronized] = ACTIONS(798),
    [anon_sym_throw] = ACTIONS(798),
    [anon_sym_try] = ACTIONS(798),
    [anon_sym_if] = ACTIONS(798),
    [anon_sym_else] = ACTIONS(798),
    [anon_sym_for] = ACTIONS(798),
    [anon_sym_AT] = ACTIONS(798),
    [anon_sym_open] = ACTIONS(798),
    [anon_sym_module] = ACTIONS(798),
    [anon_sym_static] = ACTIONS(798),
    [anon_sym_package] = ACTIONS(798),
    [anon_sym_import] = ACTIONS(798),
    [anon_sym_enum] = ACTIONS(798),
    [anon_sym_public] = ACTIONS(798),
    [anon_sym_protected] = ACTIONS(798),
    [anon_sym_private] = ACTIONS(798),
    [anon_sym_abstract] = ACTIONS(798),
    [anon_sym_strictfp] = ACTIONS(798),
    [anon_sym_native] = ACTIONS(798),
    [anon_sym_transient] = ACTIONS(798),
    [anon_sym_volatile] = ACTIONS(798),
    [anon_sym_sealed] = ACTIONS(798),
    [anon_sym_non_DASHsealed] = ACTIONS(796),
    [anon_sym_record] = ACTIONS(798),
    [anon_sym_ATinterface] = ACTIONS(796),
    [anon_sym_interface] = ACTIONS(798),
    [anon_sym_byte] = ACTIONS(798),
    [anon_sym_short] = ACTIONS(798),
    [anon_sym_int] = ACTIONS(798),
    [anon_sym_long] = ACTIONS(798),
    [anon_sym_char] = ACTIONS(798),
    [anon_sym_float] = ACTIONS(798),
    [anon_sym_double] = ACTIONS(798),
    [sym_boolean_type] = ACTIONS(798),
    [sym_void_type] = ACTIONS(798),
    [sym_this] = ACTIONS(798),
    [sym_super] = ACTIONS(798),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [217] = {
    [ts_builtin_sym_end] = ACTIONS(800),
    [sym_identifier] = ACTIONS(802),
    [sym_decimal_integer_literal] = ACTIONS(802),
    [sym_hex_integer_literal] = ACTIONS(802),
    [sym_octal_integer_literal] = ACTIONS(800),
    [sym_binary_integer_literal] = ACTIONS(800),
    [sym_decimal_floating_point_literal] = ACTIONS(800),
    [sym_hex_floating_point_literal] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_character_literal] = ACTIONS(800),
    [sym_string_literal] = ACTIONS(802),
    [sym_text_block] = ACTIONS(800),
    [sym_null_literal] = ACTIONS(802),
    [anon_sym_LPAREN] = ACTIONS(800),
    [anon_sym_PLUS] = ACTIONS(802),
    [anon_sym_DASH] = ACTIONS(802),
    [anon_sym_final] = ACTIONS(802),
    [anon_sym_BANG] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(800),
    [anon_sym_PLUS_PLUS] = ACTIONS(800),
    [anon_sym_DASH_DASH] = ACTIONS(800),
    [anon_sym_new] = ACTIONS(802),
    [anon_sym_class] = ACTIONS(802),
    [anon_sym_switch] = ACTIONS(802),
    [anon_sym_LBRACE] = ACTIONS(800),
    [anon_sym_RBRACE] = ACTIONS(800),
    [anon_sym_case] = ACTIONS(802),
    [anon_sym_default] = ACTIONS(802),
    [anon_sym_SEMI] = ACTIONS(800),
    [anon_sym_assert] = ACTIONS(802),
    [anon_sym_do] = ACTIONS(802),
    [anon_sym_while] = ACTIONS(802),
    [anon_sym_break] = ACTIONS(802),
    [anon_sym_continue] = ACTIONS(802),
    [anon_sym_return] = ACTIONS(802),
    [anon_sym_yield] = ACTIONS(802),
    [anon_sym_synchronized] = ACTIONS(802),
    [anon_sym_throw] = ACTIONS(802),
    [anon_sym_try] = ACTIONS(802),
    [anon_sym_if] = ACTIONS(802),
    [anon_sym_else] = ACTIONS(802),
    [anon_sym_for] = ACTIONS(802),
    [anon_sym_AT] = ACTIONS(802),
    [anon_sym_open] = ACTIONS(802),
    [anon_sym_module] = ACTIONS(802),
    [anon_sym_static] = ACTIONS(802),
    [anon_sym_package] = ACTIONS(802),
    [anon_sym_import] = ACTIONS(802),
    [anon_sym_enum] = ACTIONS(802),
    [anon_sym_public] = ACTIONS(802),
    [anon_sym_protected] = ACTIONS(802),
    [anon_sym_private] = ACTIONS(802),
    [anon_sym_abstract] = ACTIONS(802),
    [anon_sym_strictfp] = ACTIONS(802),
    [anon_sym_native] = ACTIONS(802),
    [anon_sym_transient] = ACTIONS(802),
    [anon_sym_volatile] = ACTIONS(802),
    [anon_sym_sealed] = ACTIONS(802),
    [anon_sym_non_DASHsealed] = ACTIONS(800),
    [anon_sym_record] = ACTIONS(802),
    [anon_sym_ATinterface] = ACTIONS(800),
    [anon_sym_interface] = ACTIONS(802),
    [anon_sym_byte] = ACTIONS(802),
    [anon_sym_short] = ACTIONS(802),
    [anon_sym_int] = ACTIONS(802),
    [anon_sym_long] = ACTIONS(802),
    [anon_sym_char] = ACTIONS(802),
    [anon_sym_float] = ACTIONS(802),
    [anon_sym_double] = ACTIONS(802),
    [sym_boolean_type] = ACTIONS(802),
    [sym_void_type] = ACTIONS(802),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [218] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(605),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym_array_initializer] = STATE(1110),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(362),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [219] = {
    [ts_builtin_sym_end] = ACTIONS(804),
    [sym_identifier] = ACTIONS(806),
    [sym_decimal_integer_literal] = ACTIONS(806),
    [sym_hex_integer_literal] = ACTIONS(806),
    [sym_octal_integer_literal] = ACTIONS(804),
    [sym_binary_integer_literal] = ACTIONS(804),
    [sym_decimal_floating_point_literal] = ACTIONS(804),
    [sym_hex_floating_point_literal] = ACTIONS(806),
    [sym_true] = ACTIONS(806),
    [sym_false] = ACTIONS(806),
    [sym_character_literal] = ACTIONS(804),
    [sym_string_literal] = ACTIONS(806),
    [sym_text_block] = ACTIONS(804),
    [sym_null_literal] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(804),
    [anon_sym_PLUS] = ACTIONS(806),
    [anon_sym_DASH] = ACTIONS(806),
    [anon_sym_final] = ACTIONS(806),
    [anon_sym_BANG] = ACTIONS(804),
    [anon_sym_TILDE] = ACTIONS(804),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_new] = ACTIONS(806),
    [anon_sym_class] = ACTIONS(806),
    [anon_sym_switch] = ACTIONS(806),
    [anon_sym_LBRACE] = ACTIONS(804),
    [anon_sym_RBRACE] = ACTIONS(804),
    [anon_sym_case] = ACTIONS(806),
    [anon_sym_default] = ACTIONS(806),
    [anon_sym_SEMI] = ACTIONS(804),
    [anon_sym_assert] = ACTIONS(806),
    [anon_sym_do] = ACTIONS(806),
    [anon_sym_while] = ACTIONS(806),
    [anon_sym_break] = ACTIONS(806),
    [anon_sym_continue] = ACTIONS(806),
    [anon_sym_return] = ACTIONS(806),
    [anon_sym_yield] = ACTIONS(806),
    [anon_sym_synchronized] = ACTIONS(806),
    [anon_sym_throw] = ACTIONS(806),
    [anon_sym_try] = ACTIONS(806),
    [anon_sym_if] = ACTIONS(806),
    [anon_sym_else] = ACTIONS(806),
    [anon_sym_for] = ACTIONS(806),
    [anon_sym_AT] = ACTIONS(806),
    [anon_sym_open] = ACTIONS(806),
    [anon_sym_module] = ACTIONS(806),
    [anon_sym_static] = ACTIONS(806),
    [anon_sym_package] = ACTIONS(806),
    [anon_sym_import] = ACTIONS(806),
    [anon_sym_enum] = ACTIONS(806),
    [anon_sym_public] = ACTIONS(806),
    [anon_sym_protected] = ACTIONS(806),
    [anon_sym_private] = ACTIONS(806),
    [anon_sym_abstract] = ACTIONS(806),
    [anon_sym_strictfp] = ACTIONS(806),
    [anon_sym_native] = ACTIONS(806),
    [anon_sym_transient] = ACTIONS(806),
    [anon_sym_volatile] = ACTIONS(806),
    [anon_sym_sealed] = ACTIONS(806),
    [anon_sym_non_DASHsealed] = ACTIONS(804),
    [anon_sym_record] = ACTIONS(806),
    [anon_sym_ATinterface] = ACTIONS(804),
    [anon_sym_interface] = ACTIONS(806),
    [anon_sym_byte] = ACTIONS(806),
    [anon_sym_short] = ACTIONS(806),
    [anon_sym_int] = ACTIONS(806),
    [anon_sym_long] = ACTIONS(806),
    [anon_sym_char] = ACTIONS(806),
    [anon_sym_float] = ACTIONS(806),
    [anon_sym_double] = ACTIONS(806),
    [sym_boolean_type] = ACTIONS(806),
    [sym_void_type] = ACTIONS(806),
    [sym_this] = ACTIONS(806),
    [sym_super] = ACTIONS(806),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [220] = {
    [ts_builtin_sym_end] = ACTIONS(808),
    [sym_identifier] = ACTIONS(810),
    [sym_decimal_integer_literal] = ACTIONS(810),
    [sym_hex_integer_literal] = ACTIONS(810),
    [sym_octal_integer_literal] = ACTIONS(808),
    [sym_binary_integer_literal] = ACTIONS(808),
    [sym_decimal_floating_point_literal] = ACTIONS(808),
    [sym_hex_floating_point_literal] = ACTIONS(810),
    [sym_true] = ACTIONS(810),
    [sym_false] = ACTIONS(810),
    [sym_character_literal] = ACTIONS(808),
    [sym_string_literal] = ACTIONS(810),
    [sym_text_block] = ACTIONS(808),
    [sym_null_literal] = ACTIONS(810),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(810),
    [anon_sym_DASH] = ACTIONS(810),
    [anon_sym_final] = ACTIONS(810),
    [anon_sym_BANG] = ACTIONS(808),
    [anon_sym_TILDE] = ACTIONS(808),
    [anon_sym_PLUS_PLUS] = ACTIONS(808),
    [anon_sym_DASH_DASH] = ACTIONS(808),
    [anon_sym_new] = ACTIONS(810),
    [anon_sym_class] = ACTIONS(810),
    [anon_sym_switch] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(808),
    [anon_sym_RBRACE] = ACTIONS(808),
    [anon_sym_case] = ACTIONS(810),
    [anon_sym_default] = ACTIONS(810),
    [anon_sym_SEMI] = ACTIONS(808),
    [anon_sym_assert] = ACTIONS(810),
    [anon_sym_do] = ACTIONS(810),
    [anon_sym_while] = ACTIONS(810),
    [anon_sym_break] = ACTIONS(810),
    [anon_sym_continue] = ACTIONS(810),
    [anon_sym_return] = ACTIONS(810),
    [anon_sym_yield] = ACTIONS(810),
    [anon_sym_synchronized] = ACTIONS(810),
    [anon_sym_throw] = ACTIONS(810),
    [anon_sym_try] = ACTIONS(810),
    [anon_sym_if] = ACTIONS(810),
    [anon_sym_else] = ACTIONS(810),
    [anon_sym_for] = ACTIONS(810),
    [anon_sym_AT] = ACTIONS(810),
    [anon_sym_open] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_package] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(810),
    [anon_sym_enum] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_abstract] = ACTIONS(810),
    [anon_sym_strictfp] = ACTIONS(810),
    [anon_sym_native] = ACTIONS(810),
    [anon_sym_transient] = ACTIONS(810),
    [anon_sym_volatile] = ACTIONS(810),
    [anon_sym_sealed] = ACTIONS(810),
    [anon_sym_non_DASHsealed] = ACTIONS(808),
    [anon_sym_record] = ACTIONS(810),
    [anon_sym_ATinterface] = ACTIONS(808),
    [anon_sym_interface] = ACTIONS(810),
    [anon_sym_byte] = ACTIONS(810),
    [anon_sym_short] = ACTIONS(810),
    [anon_sym_int] = ACTIONS(810),
    [anon_sym_long] = ACTIONS(810),
    [anon_sym_char] = ACTIONS(810),
    [anon_sym_float] = ACTIONS(810),
    [anon_sym_double] = ACTIONS(810),
    [sym_boolean_type] = ACTIONS(810),
    [sym_void_type] = ACTIONS(810),
    [sym_this] = ACTIONS(810),
    [sym_super] = ACTIONS(810),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [221] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(587),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1234),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(393),
    [sym_array_access] = STATE(393),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym_block] = STATE(520),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1234),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(740),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(750),
    [anon_sym_module] = ACTIONS(750),
    [anon_sym_record] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [222] = {
    [ts_builtin_sym_end] = ACTIONS(812),
    [sym_identifier] = ACTIONS(814),
    [sym_decimal_integer_literal] = ACTIONS(814),
    [sym_hex_integer_literal] = ACTIONS(814),
    [sym_octal_integer_literal] = ACTIONS(812),
    [sym_binary_integer_literal] = ACTIONS(812),
    [sym_decimal_floating_point_literal] = ACTIONS(812),
    [sym_hex_floating_point_literal] = ACTIONS(814),
    [sym_true] = ACTIONS(814),
    [sym_false] = ACTIONS(814),
    [sym_character_literal] = ACTIONS(812),
    [sym_string_literal] = ACTIONS(814),
    [sym_text_block] = ACTIONS(812),
    [sym_null_literal] = ACTIONS(814),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_final] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(812),
    [anon_sym_TILDE] = ACTIONS(812),
    [anon_sym_PLUS_PLUS] = ACTIONS(812),
    [anon_sym_DASH_DASH] = ACTIONS(812),
    [anon_sym_new] = ACTIONS(814),
    [anon_sym_class] = ACTIONS(814),
    [anon_sym_switch] = ACTIONS(814),
    [anon_sym_LBRACE] = ACTIONS(812),
    [anon_sym_RBRACE] = ACTIONS(812),
    [anon_sym_case] = ACTIONS(814),
    [anon_sym_default] = ACTIONS(814),
    [anon_sym_SEMI] = ACTIONS(812),
    [anon_sym_assert] = ACTIONS(814),
    [anon_sym_do] = ACTIONS(814),
    [anon_sym_while] = ACTIONS(814),
    [anon_sym_break] = ACTIONS(814),
    [anon_sym_continue] = ACTIONS(814),
    [anon_sym_return] = ACTIONS(814),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_synchronized] = ACTIONS(814),
    [anon_sym_throw] = ACTIONS(814),
    [anon_sym_try] = ACTIONS(814),
    [anon_sym_if] = ACTIONS(814),
    [anon_sym_else] = ACTIONS(814),
    [anon_sym_for] = ACTIONS(814),
    [anon_sym_AT] = ACTIONS(814),
    [anon_sym_open] = ACTIONS(814),
    [anon_sym_module] = ACTIONS(814),
    [anon_sym_static] = ACTIONS(814),
    [anon_sym_package] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(814),
    [anon_sym_enum] = ACTIONS(814),
    [anon_sym_public] = ACTIONS(814),
    [anon_sym_protected] = ACTIONS(814),
    [anon_sym_private] = ACTIONS(814),
    [anon_sym_abstract] = ACTIONS(814),
    [anon_sym_strictfp] = ACTIONS(814),
    [anon_sym_native] = ACTIONS(814),
    [anon_sym_transient] = ACTIONS(814),
    [anon_sym_volatile] = ACTIONS(814),
    [anon_sym_sealed] = ACTIONS(814),
    [anon_sym_non_DASHsealed] = ACTIONS(812),
    [anon_sym_record] = ACTIONS(814),
    [anon_sym_ATinterface] = ACTIONS(812),
    [anon_sym_interface] = ACTIONS(814),
    [anon_sym_byte] = ACTIONS(814),
    [anon_sym_short] = ACTIONS(814),
    [anon_sym_int] = ACTIONS(814),
    [anon_sym_long] = ACTIONS(814),
    [anon_sym_char] = ACTIONS(814),
    [anon_sym_float] = ACTIONS(814),
    [anon_sym_double] = ACTIONS(814),
    [sym_boolean_type] = ACTIONS(814),
    [sym_void_type] = ACTIONS(814),
    [sym_this] = ACTIONS(814),
    [sym_super] = ACTIONS(814),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [223] = {
    [ts_builtin_sym_end] = ACTIONS(816),
    [sym_identifier] = ACTIONS(818),
    [sym_decimal_integer_literal] = ACTIONS(818),
    [sym_hex_integer_literal] = ACTIONS(818),
    [sym_octal_integer_literal] = ACTIONS(816),
    [sym_binary_integer_literal] = ACTIONS(816),
    [sym_decimal_floating_point_literal] = ACTIONS(816),
    [sym_hex_floating_point_literal] = ACTIONS(818),
    [sym_true] = ACTIONS(818),
    [sym_false] = ACTIONS(818),
    [sym_character_literal] = ACTIONS(816),
    [sym_string_literal] = ACTIONS(818),
    [sym_text_block] = ACTIONS(816),
    [sym_null_literal] = ACTIONS(818),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_PLUS] = ACTIONS(818),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_final] = ACTIONS(818),
    [anon_sym_BANG] = ACTIONS(816),
    [anon_sym_TILDE] = ACTIONS(816),
    [anon_sym_PLUS_PLUS] = ACTIONS(816),
    [anon_sym_DASH_DASH] = ACTIONS(816),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_class] = ACTIONS(818),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_LBRACE] = ACTIONS(816),
    [anon_sym_RBRACE] = ACTIONS(816),
    [anon_sym_case] = ACTIONS(818),
    [anon_sym_default] = ACTIONS(818),
    [anon_sym_SEMI] = ACTIONS(816),
    [anon_sym_assert] = ACTIONS(818),
    [anon_sym_do] = ACTIONS(818),
    [anon_sym_while] = ACTIONS(818),
    [anon_sym_break] = ACTIONS(818),
    [anon_sym_continue] = ACTIONS(818),
    [anon_sym_return] = ACTIONS(818),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_synchronized] = ACTIONS(818),
    [anon_sym_throw] = ACTIONS(818),
    [anon_sym_try] = ACTIONS(818),
    [anon_sym_if] = ACTIONS(818),
    [anon_sym_else] = ACTIONS(818),
    [anon_sym_for] = ACTIONS(818),
    [anon_sym_AT] = ACTIONS(818),
    [anon_sym_open] = ACTIONS(818),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_static] = ACTIONS(818),
    [anon_sym_package] = ACTIONS(818),
    [anon_sym_import] = ACTIONS(818),
    [anon_sym_enum] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(818),
    [anon_sym_protected] = ACTIONS(818),
    [anon_sym_private] = ACTIONS(818),
    [anon_sym_abstract] = ACTIONS(818),
    [anon_sym_strictfp] = ACTIONS(818),
    [anon_sym_native] = ACTIONS(818),
    [anon_sym_transient] = ACTIONS(818),
    [anon_sym_volatile] = ACTIONS(818),
    [anon_sym_sealed] = ACTIONS(818),
    [anon_sym_non_DASHsealed] = ACTIONS(816),
    [anon_sym_record] = ACTIONS(818),
    [anon_sym_ATinterface] = ACTIONS(816),
    [anon_sym_interface] = ACTIONS(818),
    [anon_sym_byte] = ACTIONS(818),
    [anon_sym_short] = ACTIONS(818),
    [anon_sym_int] = ACTIONS(818),
    [anon_sym_long] = ACTIONS(818),
    [anon_sym_char] = ACTIONS(818),
    [anon_sym_float] = ACTIONS(818),
    [anon_sym_double] = ACTIONS(818),
    [sym_boolean_type] = ACTIONS(818),
    [sym_void_type] = ACTIONS(818),
    [sym_this] = ACTIONS(818),
    [sym_super] = ACTIONS(818),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [224] = {
    [ts_builtin_sym_end] = ACTIONS(820),
    [sym_identifier] = ACTIONS(822),
    [sym_decimal_integer_literal] = ACTIONS(822),
    [sym_hex_integer_literal] = ACTIONS(822),
    [sym_octal_integer_literal] = ACTIONS(820),
    [sym_binary_integer_literal] = ACTIONS(820),
    [sym_decimal_floating_point_literal] = ACTIONS(820),
    [sym_hex_floating_point_literal] = ACTIONS(822),
    [sym_true] = ACTIONS(822),
    [sym_false] = ACTIONS(822),
    [sym_character_literal] = ACTIONS(820),
    [sym_string_literal] = ACTIONS(822),
    [sym_text_block] = ACTIONS(820),
    [sym_null_literal] = ACTIONS(822),
    [anon_sym_LPAREN] = ACTIONS(820),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_final] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_PLUS_PLUS] = ACTIONS(820),
    [anon_sym_DASH_DASH] = ACTIONS(820),
    [anon_sym_new] = ACTIONS(822),
    [anon_sym_class] = ACTIONS(822),
    [anon_sym_switch] = ACTIONS(822),
    [anon_sym_LBRACE] = ACTIONS(820),
    [anon_sym_RBRACE] = ACTIONS(820),
    [anon_sym_case] = ACTIONS(822),
    [anon_sym_default] = ACTIONS(822),
    [anon_sym_SEMI] = ACTIONS(820),
    [anon_sym_assert] = ACTIONS(822),
    [anon_sym_do] = ACTIONS(822),
    [anon_sym_while] = ACTIONS(822),
    [anon_sym_break] = ACTIONS(822),
    [anon_sym_continue] = ACTIONS(822),
    [anon_sym_return] = ACTIONS(822),
    [anon_sym_yield] = ACTIONS(822),
    [anon_sym_synchronized] = ACTIONS(822),
    [anon_sym_throw] = ACTIONS(822),
    [anon_sym_try] = ACTIONS(822),
    [anon_sym_if] = ACTIONS(822),
    [anon_sym_else] = ACTIONS(822),
    [anon_sym_for] = ACTIONS(822),
    [anon_sym_AT] = ACTIONS(822),
    [anon_sym_open] = ACTIONS(822),
    [anon_sym_module] = ACTIONS(822),
    [anon_sym_static] = ACTIONS(822),
    [anon_sym_package] = ACTIONS(822),
    [anon_sym_import] = ACTIONS(822),
    [anon_sym_enum] = ACTIONS(822),
    [anon_sym_public] = ACTIONS(822),
    [anon_sym_protected] = ACTIONS(822),
    [anon_sym_private] = ACTIONS(822),
    [anon_sym_abstract] = ACTIONS(822),
    [anon_sym_strictfp] = ACTIONS(822),
    [anon_sym_native] = ACTIONS(822),
    [anon_sym_transient] = ACTIONS(822),
    [anon_sym_volatile] = ACTIONS(822),
    [anon_sym_sealed] = ACTIONS(822),
    [anon_sym_non_DASHsealed] = ACTIONS(820),
    [anon_sym_record] = ACTIONS(822),
    [anon_sym_ATinterface] = ACTIONS(820),
    [anon_sym_interface] = ACTIONS(822),
    [anon_sym_byte] = ACTIONS(822),
    [anon_sym_short] = ACTIONS(822),
    [anon_sym_int] = ACTIONS(822),
    [anon_sym_long] = ACTIONS(822),
    [anon_sym_char] = ACTIONS(822),
    [anon_sym_float] = ACTIONS(822),
    [anon_sym_double] = ACTIONS(822),
    [sym_boolean_type] = ACTIONS(822),
    [sym_void_type] = ACTIONS(822),
    [sym_this] = ACTIONS(822),
    [sym_super] = ACTIONS(822),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [225] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(525),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym_block] = STATE(519),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [226] = {
    [ts_builtin_sym_end] = ACTIONS(824),
    [sym_identifier] = ACTIONS(826),
    [sym_decimal_integer_literal] = ACTIONS(826),
    [sym_hex_integer_literal] = ACTIONS(826),
    [sym_octal_integer_literal] = ACTIONS(824),
    [sym_binary_integer_literal] = ACTIONS(824),
    [sym_decimal_floating_point_literal] = ACTIONS(824),
    [sym_hex_floating_point_literal] = ACTIONS(826),
    [sym_true] = ACTIONS(826),
    [sym_false] = ACTIONS(826),
    [sym_character_literal] = ACTIONS(824),
    [sym_string_literal] = ACTIONS(826),
    [sym_text_block] = ACTIONS(824),
    [sym_null_literal] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(824),
    [anon_sym_PLUS] = ACTIONS(826),
    [anon_sym_DASH] = ACTIONS(826),
    [anon_sym_final] = ACTIONS(826),
    [anon_sym_BANG] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_PLUS_PLUS] = ACTIONS(824),
    [anon_sym_DASH_DASH] = ACTIONS(824),
    [anon_sym_new] = ACTIONS(826),
    [anon_sym_class] = ACTIONS(826),
    [anon_sym_switch] = ACTIONS(826),
    [anon_sym_LBRACE] = ACTIONS(824),
    [anon_sym_RBRACE] = ACTIONS(824),
    [anon_sym_case] = ACTIONS(826),
    [anon_sym_default] = ACTIONS(826),
    [anon_sym_SEMI] = ACTIONS(824),
    [anon_sym_assert] = ACTIONS(826),
    [anon_sym_do] = ACTIONS(826),
    [anon_sym_while] = ACTIONS(826),
    [anon_sym_break] = ACTIONS(826),
    [anon_sym_continue] = ACTIONS(826),
    [anon_sym_return] = ACTIONS(826),
    [anon_sym_yield] = ACTIONS(826),
    [anon_sym_synchronized] = ACTIONS(826),
    [anon_sym_throw] = ACTIONS(826),
    [anon_sym_try] = ACTIONS(826),
    [anon_sym_if] = ACTIONS(826),
    [anon_sym_else] = ACTIONS(826),
    [anon_sym_for] = ACTIONS(826),
    [anon_sym_AT] = ACTIONS(826),
    [anon_sym_open] = ACTIONS(826),
    [anon_sym_module] = ACTIONS(826),
    [anon_sym_static] = ACTIONS(826),
    [anon_sym_package] = ACTIONS(826),
    [anon_sym_import] = ACTIONS(826),
    [anon_sym_enum] = ACTIONS(826),
    [anon_sym_public] = ACTIONS(826),
    [anon_sym_protected] = ACTIONS(826),
    [anon_sym_private] = ACTIONS(826),
    [anon_sym_abstract] = ACTIONS(826),
    [anon_sym_strictfp] = ACTIONS(826),
    [anon_sym_native] = ACTIONS(826),
    [anon_sym_transient] = ACTIONS(826),
    [anon_sym_volatile] = ACTIONS(826),
    [anon_sym_sealed] = ACTIONS(826),
    [anon_sym_non_DASHsealed] = ACTIONS(824),
    [anon_sym_record] = ACTIONS(826),
    [anon_sym_ATinterface] = ACTIONS(824),
    [anon_sym_interface] = ACTIONS(826),
    [anon_sym_byte] = ACTIONS(826),
    [anon_sym_short] = ACTIONS(826),
    [anon_sym_int] = ACTIONS(826),
    [anon_sym_long] = ACTIONS(826),
    [anon_sym_char] = ACTIONS(826),
    [anon_sym_float] = ACTIONS(826),
    [anon_sym_double] = ACTIONS(826),
    [sym_boolean_type] = ACTIONS(826),
    [sym_void_type] = ACTIONS(826),
    [sym_this] = ACTIONS(826),
    [sym_super] = ACTIONS(826),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [227] = {
    [ts_builtin_sym_end] = ACTIONS(828),
    [sym_identifier] = ACTIONS(830),
    [sym_decimal_integer_literal] = ACTIONS(830),
    [sym_hex_integer_literal] = ACTIONS(830),
    [sym_octal_integer_literal] = ACTIONS(828),
    [sym_binary_integer_literal] = ACTIONS(828),
    [sym_decimal_floating_point_literal] = ACTIONS(828),
    [sym_hex_floating_point_literal] = ACTIONS(830),
    [sym_true] = ACTIONS(830),
    [sym_false] = ACTIONS(830),
    [sym_character_literal] = ACTIONS(828),
    [sym_string_literal] = ACTIONS(830),
    [sym_text_block] = ACTIONS(828),
    [sym_null_literal] = ACTIONS(830),
    [anon_sym_LPAREN] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(830),
    [anon_sym_DASH] = ACTIONS(830),
    [anon_sym_final] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(828),
    [anon_sym_TILDE] = ACTIONS(828),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_new] = ACTIONS(830),
    [anon_sym_class] = ACTIONS(830),
    [anon_sym_switch] = ACTIONS(830),
    [anon_sym_LBRACE] = ACTIONS(828),
    [anon_sym_RBRACE] = ACTIONS(828),
    [anon_sym_case] = ACTIONS(830),
    [anon_sym_default] = ACTIONS(830),
    [anon_sym_SEMI] = ACTIONS(828),
    [anon_sym_assert] = ACTIONS(830),
    [anon_sym_do] = ACTIONS(830),
    [anon_sym_while] = ACTIONS(830),
    [anon_sym_break] = ACTIONS(830),
    [anon_sym_continue] = ACTIONS(830),
    [anon_sym_return] = ACTIONS(830),
    [anon_sym_yield] = ACTIONS(830),
    [anon_sym_synchronized] = ACTIONS(830),
    [anon_sym_throw] = ACTIONS(830),
    [anon_sym_try] = ACTIONS(830),
    [anon_sym_if] = ACTIONS(830),
    [anon_sym_else] = ACTIONS(830),
    [anon_sym_for] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(830),
    [anon_sym_open] = ACTIONS(830),
    [anon_sym_module] = ACTIONS(830),
    [anon_sym_static] = ACTIONS(830),
    [anon_sym_package] = ACTIONS(830),
    [anon_sym_import] = ACTIONS(830),
    [anon_sym_enum] = ACTIONS(830),
    [anon_sym_public] = ACTIONS(830),
    [anon_sym_protected] = ACTIONS(830),
    [anon_sym_private] = ACTIONS(830),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_strictfp] = ACTIONS(830),
    [anon_sym_native] = ACTIONS(830),
    [anon_sym_transient] = ACTIONS(830),
    [anon_sym_volatile] = ACTIONS(830),
    [anon_sym_sealed] = ACTIONS(830),
    [anon_sym_non_DASHsealed] = ACTIONS(828),
    [anon_sym_record] = ACTIONS(830),
    [anon_sym_ATinterface] = ACTIONS(828),
    [anon_sym_interface] = ACTIONS(830),
    [anon_sym_byte] = ACTIONS(830),
    [anon_sym_short] = ACTIONS(830),
    [anon_sym_int] = ACTIONS(830),
    [anon_sym_long] = ACTIONS(830),
    [anon_sym_char] = ACTIONS(830),
    [anon_sym_float] = ACTIONS(830),
    [anon_sym_double] = ACTIONS(830),
    [sym_boolean_type] = ACTIONS(830),
    [sym_void_type] = ACTIONS(830),
    [sym_this] = ACTIONS(830),
    [sym_super] = ACTIONS(830),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [228] = {
    [ts_builtin_sym_end] = ACTIONS(832),
    [sym_identifier] = ACTIONS(834),
    [sym_decimal_integer_literal] = ACTIONS(834),
    [sym_hex_integer_literal] = ACTIONS(834),
    [sym_octal_integer_literal] = ACTIONS(832),
    [sym_binary_integer_literal] = ACTIONS(832),
    [sym_decimal_floating_point_literal] = ACTIONS(832),
    [sym_hex_floating_point_literal] = ACTIONS(834),
    [sym_true] = ACTIONS(834),
    [sym_false] = ACTIONS(834),
    [sym_character_literal] = ACTIONS(832),
    [sym_string_literal] = ACTIONS(834),
    [sym_text_block] = ACTIONS(832),
    [sym_null_literal] = ACTIONS(834),
    [anon_sym_LPAREN] = ACTIONS(832),
    [anon_sym_PLUS] = ACTIONS(834),
    [anon_sym_DASH] = ACTIONS(834),
    [anon_sym_final] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(832),
    [anon_sym_TILDE] = ACTIONS(832),
    [anon_sym_PLUS_PLUS] = ACTIONS(832),
    [anon_sym_DASH_DASH] = ACTIONS(832),
    [anon_sym_new] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(834),
    [anon_sym_switch] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(832),
    [anon_sym_RBRACE] = ACTIONS(832),
    [anon_sym_case] = ACTIONS(834),
    [anon_sym_default] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(832),
    [anon_sym_assert] = ACTIONS(834),
    [anon_sym_do] = ACTIONS(834),
    [anon_sym_while] = ACTIONS(834),
    [anon_sym_break] = ACTIONS(834),
    [anon_sym_continue] = ACTIONS(834),
    [anon_sym_return] = ACTIONS(834),
    [anon_sym_yield] = ACTIONS(834),
    [anon_sym_synchronized] = ACTIONS(834),
    [anon_sym_throw] = ACTIONS(834),
    [anon_sym_try] = ACTIONS(834),
    [anon_sym_if] = ACTIONS(834),
    [anon_sym_else] = ACTIONS(834),
    [anon_sym_for] = ACTIONS(834),
    [anon_sym_AT] = ACTIONS(834),
    [anon_sym_open] = ACTIONS(834),
    [anon_sym_module] = ACTIONS(834),
    [anon_sym_static] = ACTIONS(834),
    [anon_sym_package] = ACTIONS(834),
    [anon_sym_import] = ACTIONS(834),
    [anon_sym_enum] = ACTIONS(834),
    [anon_sym_public] = ACTIONS(834),
    [anon_sym_protected] = ACTIONS(834),
    [anon_sym_private] = ACTIONS(834),
    [anon_sym_abstract] = ACTIONS(834),
    [anon_sym_strictfp] = ACTIONS(834),
    [anon_sym_native] = ACTIONS(834),
    [anon_sym_transient] = ACTIONS(834),
    [anon_sym_volatile] = ACTIONS(834),
    [anon_sym_sealed] = ACTIONS(834),
    [anon_sym_non_DASHsealed] = ACTIONS(832),
    [anon_sym_record] = ACTIONS(834),
    [anon_sym_ATinterface] = ACTIONS(832),
    [anon_sym_interface] = ACTIONS(834),
    [anon_sym_byte] = ACTIONS(834),
    [anon_sym_short] = ACTIONS(834),
    [anon_sym_int] = ACTIONS(834),
    [anon_sym_long] = ACTIONS(834),
    [anon_sym_char] = ACTIONS(834),
    [anon_sym_float] = ACTIONS(834),
    [anon_sym_double] = ACTIONS(834),
    [sym_boolean_type] = ACTIONS(834),
    [sym_void_type] = ACTIONS(834),
    [sym_this] = ACTIONS(834),
    [sym_super] = ACTIONS(834),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [229] = {
    [ts_builtin_sym_end] = ACTIONS(836),
    [sym_identifier] = ACTIONS(838),
    [sym_decimal_integer_literal] = ACTIONS(838),
    [sym_hex_integer_literal] = ACTIONS(838),
    [sym_octal_integer_literal] = ACTIONS(836),
    [sym_binary_integer_literal] = ACTIONS(836),
    [sym_decimal_floating_point_literal] = ACTIONS(836),
    [sym_hex_floating_point_literal] = ACTIONS(838),
    [sym_true] = ACTIONS(838),
    [sym_false] = ACTIONS(838),
    [sym_character_literal] = ACTIONS(836),
    [sym_string_literal] = ACTIONS(838),
    [sym_text_block] = ACTIONS(836),
    [sym_null_literal] = ACTIONS(838),
    [anon_sym_LPAREN] = ACTIONS(836),
    [anon_sym_PLUS] = ACTIONS(838),
    [anon_sym_DASH] = ACTIONS(838),
    [anon_sym_final] = ACTIONS(838),
    [anon_sym_BANG] = ACTIONS(836),
    [anon_sym_TILDE] = ACTIONS(836),
    [anon_sym_PLUS_PLUS] = ACTIONS(836),
    [anon_sym_DASH_DASH] = ACTIONS(836),
    [anon_sym_new] = ACTIONS(838),
    [anon_sym_class] = ACTIONS(838),
    [anon_sym_switch] = ACTIONS(838),
    [anon_sym_LBRACE] = ACTIONS(836),
    [anon_sym_RBRACE] = ACTIONS(836),
    [anon_sym_case] = ACTIONS(838),
    [anon_sym_default] = ACTIONS(838),
    [anon_sym_SEMI] = ACTIONS(836),
    [anon_sym_assert] = ACTIONS(838),
    [anon_sym_do] = ACTIONS(838),
    [anon_sym_while] = ACTIONS(838),
    [anon_sym_break] = ACTIONS(838),
    [anon_sym_continue] = ACTIONS(838),
    [anon_sym_return] = ACTIONS(838),
    [anon_sym_yield] = ACTIONS(838),
    [anon_sym_synchronized] = ACTIONS(838),
    [anon_sym_throw] = ACTIONS(838),
    [anon_sym_try] = ACTIONS(838),
    [anon_sym_if] = ACTIONS(838),
    [anon_sym_else] = ACTIONS(838),
    [anon_sym_for] = ACTIONS(838),
    [anon_sym_AT] = ACTIONS(838),
    [anon_sym_open] = ACTIONS(838),
    [anon_sym_module] = ACTIONS(838),
    [anon_sym_static] = ACTIONS(838),
    [anon_sym_package] = ACTIONS(838),
    [anon_sym_import] = ACTIONS(838),
    [anon_sym_enum] = ACTIONS(838),
    [anon_sym_public] = ACTIONS(838),
    [anon_sym_protected] = ACTIONS(838),
    [anon_sym_private] = ACTIONS(838),
    [anon_sym_abstract] = ACTIONS(838),
    [anon_sym_strictfp] = ACTIONS(838),
    [anon_sym_native] = ACTIONS(838),
    [anon_sym_transient] = ACTIONS(838),
    [anon_sym_volatile] = ACTIONS(838),
    [anon_sym_sealed] = ACTIONS(838),
    [anon_sym_non_DASHsealed] = ACTIONS(836),
    [anon_sym_record] = ACTIONS(838),
    [anon_sym_ATinterface] = ACTIONS(836),
    [anon_sym_interface] = ACTIONS(838),
    [anon_sym_byte] = ACTIONS(838),
    [anon_sym_short] = ACTIONS(838),
    [anon_sym_int] = ACTIONS(838),
    [anon_sym_long] = ACTIONS(838),
    [anon_sym_char] = ACTIONS(838),
    [anon_sym_float] = ACTIONS(838),
    [anon_sym_double] = ACTIONS(838),
    [sym_boolean_type] = ACTIONS(838),
    [sym_void_type] = ACTIONS(838),
    [sym_this] = ACTIONS(838),
    [sym_super] = ACTIONS(838),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [230] = {
    [ts_builtin_sym_end] = ACTIONS(840),
    [sym_identifier] = ACTIONS(842),
    [sym_decimal_integer_literal] = ACTIONS(842),
    [sym_hex_integer_literal] = ACTIONS(842),
    [sym_octal_integer_literal] = ACTIONS(840),
    [sym_binary_integer_literal] = ACTIONS(840),
    [sym_decimal_floating_point_literal] = ACTIONS(840),
    [sym_hex_floating_point_literal] = ACTIONS(842),
    [sym_true] = ACTIONS(842),
    [sym_false] = ACTIONS(842),
    [sym_character_literal] = ACTIONS(840),
    [sym_string_literal] = ACTIONS(842),
    [sym_text_block] = ACTIONS(840),
    [sym_null_literal] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_final] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_PLUS_PLUS] = ACTIONS(840),
    [anon_sym_DASH_DASH] = ACTIONS(840),
    [anon_sym_new] = ACTIONS(842),
    [anon_sym_class] = ACTIONS(842),
    [anon_sym_switch] = ACTIONS(842),
    [anon_sym_LBRACE] = ACTIONS(840),
    [anon_sym_RBRACE] = ACTIONS(840),
    [anon_sym_case] = ACTIONS(842),
    [anon_sym_default] = ACTIONS(842),
    [anon_sym_SEMI] = ACTIONS(840),
    [anon_sym_assert] = ACTIONS(842),
    [anon_sym_do] = ACTIONS(842),
    [anon_sym_while] = ACTIONS(842),
    [anon_sym_break] = ACTIONS(842),
    [anon_sym_continue] = ACTIONS(842),
    [anon_sym_return] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(842),
    [anon_sym_synchronized] = ACTIONS(842),
    [anon_sym_throw] = ACTIONS(842),
    [anon_sym_try] = ACTIONS(842),
    [anon_sym_if] = ACTIONS(842),
    [anon_sym_else] = ACTIONS(842),
    [anon_sym_for] = ACTIONS(842),
    [anon_sym_AT] = ACTIONS(842),
    [anon_sym_open] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_package] = ACTIONS(842),
    [anon_sym_import] = ACTIONS(842),
    [anon_sym_enum] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_abstract] = ACTIONS(842),
    [anon_sym_strictfp] = ACTIONS(842),
    [anon_sym_native] = ACTIONS(842),
    [anon_sym_transient] = ACTIONS(842),
    [anon_sym_volatile] = ACTIONS(842),
    [anon_sym_sealed] = ACTIONS(842),
    [anon_sym_non_DASHsealed] = ACTIONS(840),
    [anon_sym_record] = ACTIONS(842),
    [anon_sym_ATinterface] = ACTIONS(840),
    [anon_sym_interface] = ACTIONS(842),
    [anon_sym_byte] = ACTIONS(842),
    [anon_sym_short] = ACTIONS(842),
    [anon_sym_int] = ACTIONS(842),
    [anon_sym_long] = ACTIONS(842),
    [anon_sym_char] = ACTIONS(842),
    [anon_sym_float] = ACTIONS(842),
    [anon_sym_double] = ACTIONS(842),
    [sym_boolean_type] = ACTIONS(842),
    [sym_void_type] = ACTIONS(842),
    [sym_this] = ACTIONS(842),
    [sym_super] = ACTIONS(842),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [231] = {
    [ts_builtin_sym_end] = ACTIONS(844),
    [sym_identifier] = ACTIONS(846),
    [sym_decimal_integer_literal] = ACTIONS(846),
    [sym_hex_integer_literal] = ACTIONS(846),
    [sym_octal_integer_literal] = ACTIONS(844),
    [sym_binary_integer_literal] = ACTIONS(844),
    [sym_decimal_floating_point_literal] = ACTIONS(844),
    [sym_hex_floating_point_literal] = ACTIONS(846),
    [sym_true] = ACTIONS(846),
    [sym_false] = ACTIONS(846),
    [sym_character_literal] = ACTIONS(844),
    [sym_string_literal] = ACTIONS(846),
    [sym_text_block] = ACTIONS(844),
    [sym_null_literal] = ACTIONS(846),
    [anon_sym_LPAREN] = ACTIONS(844),
    [anon_sym_PLUS] = ACTIONS(846),
    [anon_sym_DASH] = ACTIONS(846),
    [anon_sym_final] = ACTIONS(846),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(846),
    [anon_sym_class] = ACTIONS(846),
    [anon_sym_switch] = ACTIONS(846),
    [anon_sym_LBRACE] = ACTIONS(844),
    [anon_sym_RBRACE] = ACTIONS(844),
    [anon_sym_case] = ACTIONS(846),
    [anon_sym_default] = ACTIONS(846),
    [anon_sym_SEMI] = ACTIONS(844),
    [anon_sym_assert] = ACTIONS(846),
    [anon_sym_do] = ACTIONS(846),
    [anon_sym_while] = ACTIONS(846),
    [anon_sym_break] = ACTIONS(846),
    [anon_sym_continue] = ACTIONS(846),
    [anon_sym_return] = ACTIONS(846),
    [anon_sym_yield] = ACTIONS(846),
    [anon_sym_synchronized] = ACTIONS(846),
    [anon_sym_throw] = ACTIONS(846),
    [anon_sym_try] = ACTIONS(846),
    [anon_sym_if] = ACTIONS(846),
    [anon_sym_else] = ACTIONS(846),
    [anon_sym_for] = ACTIONS(846),
    [anon_sym_AT] = ACTIONS(846),
    [anon_sym_open] = ACTIONS(846),
    [anon_sym_module] = ACTIONS(846),
    [anon_sym_static] = ACTIONS(846),
    [anon_sym_package] = ACTIONS(846),
    [anon_sym_import] = ACTIONS(846),
    [anon_sym_enum] = ACTIONS(846),
    [anon_sym_public] = ACTIONS(846),
    [anon_sym_protected] = ACTIONS(846),
    [anon_sym_private] = ACTIONS(846),
    [anon_sym_abstract] = ACTIONS(846),
    [anon_sym_strictfp] = ACTIONS(846),
    [anon_sym_native] = ACTIONS(846),
    [anon_sym_transient] = ACTIONS(846),
    [anon_sym_volatile] = ACTIONS(846),
    [anon_sym_sealed] = ACTIONS(846),
    [anon_sym_non_DASHsealed] = ACTIONS(844),
    [anon_sym_record] = ACTIONS(846),
    [anon_sym_ATinterface] = ACTIONS(844),
    [anon_sym_interface] = ACTIONS(846),
    [anon_sym_byte] = ACTIONS(846),
    [anon_sym_short] = ACTIONS(846),
    [anon_sym_int] = ACTIONS(846),
    [anon_sym_long] = ACTIONS(846),
    [anon_sym_char] = ACTIONS(846),
    [anon_sym_float] = ACTIONS(846),
    [anon_sym_double] = ACTIONS(846),
    [sym_boolean_type] = ACTIONS(846),
    [sym_void_type] = ACTIONS(846),
    [sym_this] = ACTIONS(846),
    [sym_super] = ACTIONS(846),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [232] = {
    [ts_builtin_sym_end] = ACTIONS(848),
    [sym_identifier] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(850),
    [sym_hex_integer_literal] = ACTIONS(850),
    [sym_octal_integer_literal] = ACTIONS(848),
    [sym_binary_integer_literal] = ACTIONS(848),
    [sym_decimal_floating_point_literal] = ACTIONS(848),
    [sym_hex_floating_point_literal] = ACTIONS(850),
    [sym_true] = ACTIONS(850),
    [sym_false] = ACTIONS(850),
    [sym_character_literal] = ACTIONS(848),
    [sym_string_literal] = ACTIONS(850),
    [sym_text_block] = ACTIONS(848),
    [sym_null_literal] = ACTIONS(850),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(850),
    [anon_sym_DASH] = ACTIONS(850),
    [anon_sym_final] = ACTIONS(850),
    [anon_sym_BANG] = ACTIONS(848),
    [anon_sym_TILDE] = ACTIONS(848),
    [anon_sym_PLUS_PLUS] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(848),
    [anon_sym_new] = ACTIONS(850),
    [anon_sym_class] = ACTIONS(850),
    [anon_sym_switch] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(848),
    [anon_sym_RBRACE] = ACTIONS(848),
    [anon_sym_case] = ACTIONS(850),
    [anon_sym_default] = ACTIONS(850),
    [anon_sym_SEMI] = ACTIONS(848),
    [anon_sym_assert] = ACTIONS(850),
    [anon_sym_do] = ACTIONS(850),
    [anon_sym_while] = ACTIONS(850),
    [anon_sym_break] = ACTIONS(850),
    [anon_sym_continue] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_yield] = ACTIONS(850),
    [anon_sym_synchronized] = ACTIONS(850),
    [anon_sym_throw] = ACTIONS(850),
    [anon_sym_try] = ACTIONS(850),
    [anon_sym_if] = ACTIONS(850),
    [anon_sym_else] = ACTIONS(850),
    [anon_sym_for] = ACTIONS(850),
    [anon_sym_AT] = ACTIONS(850),
    [anon_sym_open] = ACTIONS(850),
    [anon_sym_module] = ACTIONS(850),
    [anon_sym_static] = ACTIONS(850),
    [anon_sym_package] = ACTIONS(850),
    [anon_sym_import] = ACTIONS(850),
    [anon_sym_enum] = ACTIONS(850),
    [anon_sym_public] = ACTIONS(850),
    [anon_sym_protected] = ACTIONS(850),
    [anon_sym_private] = ACTIONS(850),
    [anon_sym_abstract] = ACTIONS(850),
    [anon_sym_strictfp] = ACTIONS(850),
    [anon_sym_native] = ACTIONS(850),
    [anon_sym_transient] = ACTIONS(850),
    [anon_sym_volatile] = ACTIONS(850),
    [anon_sym_sealed] = ACTIONS(850),
    [anon_sym_non_DASHsealed] = ACTIONS(848),
    [anon_sym_record] = ACTIONS(850),
    [anon_sym_ATinterface] = ACTIONS(848),
    [anon_sym_interface] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_short] = ACTIONS(850),
    [anon_sym_int] = ACTIONS(850),
    [anon_sym_long] = ACTIONS(850),
    [anon_sym_char] = ACTIONS(850),
    [anon_sym_float] = ACTIONS(850),
    [anon_sym_double] = ACTIONS(850),
    [sym_boolean_type] = ACTIONS(850),
    [sym_void_type] = ACTIONS(850),
    [sym_this] = ACTIONS(850),
    [sym_super] = ACTIONS(850),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [233] = {
    [ts_builtin_sym_end] = ACTIONS(852),
    [sym_identifier] = ACTIONS(854),
    [sym_decimal_integer_literal] = ACTIONS(854),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_octal_integer_literal] = ACTIONS(852),
    [sym_binary_integer_literal] = ACTIONS(852),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [sym_hex_floating_point_literal] = ACTIONS(854),
    [sym_true] = ACTIONS(854),
    [sym_false] = ACTIONS(854),
    [sym_character_literal] = ACTIONS(852),
    [sym_string_literal] = ACTIONS(854),
    [sym_text_block] = ACTIONS(852),
    [sym_null_literal] = ACTIONS(854),
    [anon_sym_LPAREN] = ACTIONS(852),
    [anon_sym_PLUS] = ACTIONS(854),
    [anon_sym_DASH] = ACTIONS(854),
    [anon_sym_final] = ACTIONS(854),
    [anon_sym_BANG] = ACTIONS(852),
    [anon_sym_TILDE] = ACTIONS(852),
    [anon_sym_PLUS_PLUS] = ACTIONS(852),
    [anon_sym_DASH_DASH] = ACTIONS(852),
    [anon_sym_new] = ACTIONS(854),
    [anon_sym_class] = ACTIONS(854),
    [anon_sym_switch] = ACTIONS(854),
    [anon_sym_LBRACE] = ACTIONS(852),
    [anon_sym_RBRACE] = ACTIONS(852),
    [anon_sym_case] = ACTIONS(854),
    [anon_sym_default] = ACTIONS(854),
    [anon_sym_SEMI] = ACTIONS(852),
    [anon_sym_assert] = ACTIONS(854),
    [anon_sym_do] = ACTIONS(854),
    [anon_sym_while] = ACTIONS(854),
    [anon_sym_break] = ACTIONS(854),
    [anon_sym_continue] = ACTIONS(854),
    [anon_sym_return] = ACTIONS(854),
    [anon_sym_yield] = ACTIONS(854),
    [anon_sym_synchronized] = ACTIONS(854),
    [anon_sym_throw] = ACTIONS(854),
    [anon_sym_try] = ACTIONS(854),
    [anon_sym_if] = ACTIONS(854),
    [anon_sym_else] = ACTIONS(854),
    [anon_sym_for] = ACTIONS(854),
    [anon_sym_AT] = ACTIONS(854),
    [anon_sym_open] = ACTIONS(854),
    [anon_sym_module] = ACTIONS(854),
    [anon_sym_static] = ACTIONS(854),
    [anon_sym_package] = ACTIONS(854),
    [anon_sym_import] = ACTIONS(854),
    [anon_sym_enum] = ACTIONS(854),
    [anon_sym_public] = ACTIONS(854),
    [anon_sym_protected] = ACTIONS(854),
    [anon_sym_private] = ACTIONS(854),
    [anon_sym_abstract] = ACTIONS(854),
    [anon_sym_strictfp] = ACTIONS(854),
    [anon_sym_native] = ACTIONS(854),
    [anon_sym_transient] = ACTIONS(854),
    [anon_sym_volatile] = ACTIONS(854),
    [anon_sym_sealed] = ACTIONS(854),
    [anon_sym_non_DASHsealed] = ACTIONS(852),
    [anon_sym_record] = ACTIONS(854),
    [anon_sym_ATinterface] = ACTIONS(852),
    [anon_sym_interface] = ACTIONS(854),
    [anon_sym_byte] = ACTIONS(854),
    [anon_sym_short] = ACTIONS(854),
    [anon_sym_int] = ACTIONS(854),
    [anon_sym_long] = ACTIONS(854),
    [anon_sym_char] = ACTIONS(854),
    [anon_sym_float] = ACTIONS(854),
    [anon_sym_double] = ACTIONS(854),
    [sym_boolean_type] = ACTIONS(854),
    [sym_void_type] = ACTIONS(854),
    [sym_this] = ACTIONS(854),
    [sym_super] = ACTIONS(854),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [234] = {
    [ts_builtin_sym_end] = ACTIONS(856),
    [sym_identifier] = ACTIONS(858),
    [sym_decimal_integer_literal] = ACTIONS(858),
    [sym_hex_integer_literal] = ACTIONS(858),
    [sym_octal_integer_literal] = ACTIONS(856),
    [sym_binary_integer_literal] = ACTIONS(856),
    [sym_decimal_floating_point_literal] = ACTIONS(856),
    [sym_hex_floating_point_literal] = ACTIONS(858),
    [sym_true] = ACTIONS(858),
    [sym_false] = ACTIONS(858),
    [sym_character_literal] = ACTIONS(856),
    [sym_string_literal] = ACTIONS(858),
    [sym_text_block] = ACTIONS(856),
    [sym_null_literal] = ACTIONS(858),
    [anon_sym_LPAREN] = ACTIONS(856),
    [anon_sym_PLUS] = ACTIONS(858),
    [anon_sym_DASH] = ACTIONS(858),
    [anon_sym_final] = ACTIONS(858),
    [anon_sym_BANG] = ACTIONS(856),
    [anon_sym_TILDE] = ACTIONS(856),
    [anon_sym_PLUS_PLUS] = ACTIONS(856),
    [anon_sym_DASH_DASH] = ACTIONS(856),
    [anon_sym_new] = ACTIONS(858),
    [anon_sym_class] = ACTIONS(858),
    [anon_sym_switch] = ACTIONS(858),
    [anon_sym_LBRACE] = ACTIONS(856),
    [anon_sym_RBRACE] = ACTIONS(856),
    [anon_sym_case] = ACTIONS(858),
    [anon_sym_default] = ACTIONS(858),
    [anon_sym_SEMI] = ACTIONS(856),
    [anon_sym_assert] = ACTIONS(858),
    [anon_sym_do] = ACTIONS(858),
    [anon_sym_while] = ACTIONS(858),
    [anon_sym_break] = ACTIONS(858),
    [anon_sym_continue] = ACTIONS(858),
    [anon_sym_return] = ACTIONS(858),
    [anon_sym_yield] = ACTIONS(858),
    [anon_sym_synchronized] = ACTIONS(858),
    [anon_sym_throw] = ACTIONS(858),
    [anon_sym_try] = ACTIONS(858),
    [anon_sym_if] = ACTIONS(858),
    [anon_sym_else] = ACTIONS(858),
    [anon_sym_for] = ACTIONS(858),
    [anon_sym_AT] = ACTIONS(858),
    [anon_sym_open] = ACTIONS(858),
    [anon_sym_module] = ACTIONS(858),
    [anon_sym_static] = ACTIONS(858),
    [anon_sym_package] = ACTIONS(858),
    [anon_sym_import] = ACTIONS(858),
    [anon_sym_enum] = ACTIONS(858),
    [anon_sym_public] = ACTIONS(858),
    [anon_sym_protected] = ACTIONS(858),
    [anon_sym_private] = ACTIONS(858),
    [anon_sym_abstract] = ACTIONS(858),
    [anon_sym_strictfp] = ACTIONS(858),
    [anon_sym_native] = ACTIONS(858),
    [anon_sym_transient] = ACTIONS(858),
    [anon_sym_volatile] = ACTIONS(858),
    [anon_sym_sealed] = ACTIONS(858),
    [anon_sym_non_DASHsealed] = ACTIONS(856),
    [anon_sym_record] = ACTIONS(858),
    [anon_sym_ATinterface] = ACTIONS(856),
    [anon_sym_interface] = ACTIONS(858),
    [anon_sym_byte] = ACTIONS(858),
    [anon_sym_short] = ACTIONS(858),
    [anon_sym_int] = ACTIONS(858),
    [anon_sym_long] = ACTIONS(858),
    [anon_sym_char] = ACTIONS(858),
    [anon_sym_float] = ACTIONS(858),
    [anon_sym_double] = ACTIONS(858),
    [sym_boolean_type] = ACTIONS(858),
    [sym_void_type] = ACTIONS(858),
    [sym_this] = ACTIONS(858),
    [sym_super] = ACTIONS(858),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [235] = {
    [sym_switch_label] = STATE(1228),
    [aux_sym_switch_block_statement_group_repeat1] = STATE(235),
    [sym_identifier] = ACTIONS(860),
    [sym_decimal_integer_literal] = ACTIONS(860),
    [sym_hex_integer_literal] = ACTIONS(860),
    [sym_octal_integer_literal] = ACTIONS(862),
    [sym_binary_integer_literal] = ACTIONS(862),
    [sym_decimal_floating_point_literal] = ACTIONS(862),
    [sym_hex_floating_point_literal] = ACTIONS(860),
    [sym_true] = ACTIONS(860),
    [sym_false] = ACTIONS(860),
    [sym_character_literal] = ACTIONS(862),
    [sym_string_literal] = ACTIONS(860),
    [sym_text_block] = ACTIONS(862),
    [sym_null_literal] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_final] = ACTIONS(860),
    [anon_sym_BANG] = ACTIONS(862),
    [anon_sym_TILDE] = ACTIONS(862),
    [anon_sym_PLUS_PLUS] = ACTIONS(862),
    [anon_sym_DASH_DASH] = ACTIONS(862),
    [anon_sym_new] = ACTIONS(860),
    [anon_sym_class] = ACTIONS(860),
    [anon_sym_switch] = ACTIONS(860),
    [anon_sym_LBRACE] = ACTIONS(862),
    [anon_sym_RBRACE] = ACTIONS(862),
    [anon_sym_case] = ACTIONS(864),
    [anon_sym_default] = ACTIONS(867),
    [anon_sym_SEMI] = ACTIONS(862),
    [anon_sym_assert] = ACTIONS(860),
    [anon_sym_do] = ACTIONS(860),
    [anon_sym_while] = ACTIONS(860),
    [anon_sym_break] = ACTIONS(860),
    [anon_sym_continue] = ACTIONS(860),
    [anon_sym_return] = ACTIONS(860),
    [anon_sym_yield] = ACTIONS(860),
    [anon_sym_synchronized] = ACTIONS(860),
    [anon_sym_throw] = ACTIONS(860),
    [anon_sym_try] = ACTIONS(860),
    [anon_sym_if] = ACTIONS(860),
    [anon_sym_for] = ACTIONS(860),
    [anon_sym_AT] = ACTIONS(860),
    [anon_sym_open] = ACTIONS(860),
    [anon_sym_module] = ACTIONS(860),
    [anon_sym_static] = ACTIONS(860),
    [anon_sym_package] = ACTIONS(860),
    [anon_sym_import] = ACTIONS(860),
    [anon_sym_enum] = ACTIONS(860),
    [anon_sym_public] = ACTIONS(860),
    [anon_sym_protected] = ACTIONS(860),
    [anon_sym_private] = ACTIONS(860),
    [anon_sym_abstract] = ACTIONS(860),
    [anon_sym_strictfp] = ACTIONS(860),
    [anon_sym_native] = ACTIONS(860),
    [anon_sym_transient] = ACTIONS(860),
    [anon_sym_volatile] = ACTIONS(860),
    [anon_sym_sealed] = ACTIONS(860),
    [anon_sym_non_DASHsealed] = ACTIONS(862),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_ATinterface] = ACTIONS(862),
    [anon_sym_interface] = ACTIONS(860),
    [anon_sym_byte] = ACTIONS(860),
    [anon_sym_short] = ACTIONS(860),
    [anon_sym_int] = ACTIONS(860),
    [anon_sym_long] = ACTIONS(860),
    [anon_sym_char] = ACTIONS(860),
    [anon_sym_float] = ACTIONS(860),
    [anon_sym_double] = ACTIONS(860),
    [sym_boolean_type] = ACTIONS(860),
    [sym_void_type] = ACTIONS(860),
    [sym_this] = ACTIONS(860),
    [sym_super] = ACTIONS(860),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [236] = {
    [ts_builtin_sym_end] = ACTIONS(870),
    [sym_identifier] = ACTIONS(872),
    [sym_decimal_integer_literal] = ACTIONS(872),
    [sym_hex_integer_literal] = ACTIONS(872),
    [sym_octal_integer_literal] = ACTIONS(870),
    [sym_binary_integer_literal] = ACTIONS(870),
    [sym_decimal_floating_point_literal] = ACTIONS(870),
    [sym_hex_floating_point_literal] = ACTIONS(872),
    [sym_true] = ACTIONS(872),
    [sym_false] = ACTIONS(872),
    [sym_character_literal] = ACTIONS(870),
    [sym_string_literal] = ACTIONS(872),
    [sym_text_block] = ACTIONS(870),
    [sym_null_literal] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(872),
    [anon_sym_DASH] = ACTIONS(872),
    [anon_sym_final] = ACTIONS(872),
    [anon_sym_BANG] = ACTIONS(870),
    [anon_sym_TILDE] = ACTIONS(870),
    [anon_sym_PLUS_PLUS] = ACTIONS(870),
    [anon_sym_DASH_DASH] = ACTIONS(870),
    [anon_sym_new] = ACTIONS(872),
    [anon_sym_class] = ACTIONS(872),
    [anon_sym_switch] = ACTIONS(872),
    [anon_sym_LBRACE] = ACTIONS(870),
    [anon_sym_RBRACE] = ACTIONS(870),
    [anon_sym_case] = ACTIONS(872),
    [anon_sym_default] = ACTIONS(872),
    [anon_sym_SEMI] = ACTIONS(870),
    [anon_sym_assert] = ACTIONS(872),
    [anon_sym_do] = ACTIONS(872),
    [anon_sym_while] = ACTIONS(872),
    [anon_sym_break] = ACTIONS(872),
    [anon_sym_continue] = ACTIONS(872),
    [anon_sym_return] = ACTIONS(872),
    [anon_sym_yield] = ACTIONS(872),
    [anon_sym_synchronized] = ACTIONS(872),
    [anon_sym_throw] = ACTIONS(872),
    [anon_sym_try] = ACTIONS(872),
    [anon_sym_if] = ACTIONS(872),
    [anon_sym_else] = ACTIONS(872),
    [anon_sym_for] = ACTIONS(872),
    [anon_sym_AT] = ACTIONS(872),
    [anon_sym_open] = ACTIONS(872),
    [anon_sym_module] = ACTIONS(872),
    [anon_sym_static] = ACTIONS(872),
    [anon_sym_package] = ACTIONS(872),
    [anon_sym_import] = ACTIONS(872),
    [anon_sym_enum] = ACTIONS(872),
    [anon_sym_public] = ACTIONS(872),
    [anon_sym_protected] = ACTIONS(872),
    [anon_sym_private] = ACTIONS(872),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_strictfp] = ACTIONS(872),
    [anon_sym_native] = ACTIONS(872),
    [anon_sym_transient] = ACTIONS(872),
    [anon_sym_volatile] = ACTIONS(872),
    [anon_sym_sealed] = ACTIONS(872),
    [anon_sym_non_DASHsealed] = ACTIONS(870),
    [anon_sym_record] = ACTIONS(872),
    [anon_sym_ATinterface] = ACTIONS(870),
    [anon_sym_interface] = ACTIONS(872),
    [anon_sym_byte] = ACTIONS(872),
    [anon_sym_short] = ACTIONS(872),
    [anon_sym_int] = ACTIONS(872),
    [anon_sym_long] = ACTIONS(872),
    [anon_sym_char] = ACTIONS(872),
    [anon_sym_float] = ACTIONS(872),
    [anon_sym_double] = ACTIONS(872),
    [sym_boolean_type] = ACTIONS(872),
    [sym_void_type] = ACTIONS(872),
    [sym_this] = ACTIONS(872),
    [sym_super] = ACTIONS(872),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [237] = {
    [ts_builtin_sym_end] = ACTIONS(327),
    [sym_identifier] = ACTIONS(329),
    [sym_decimal_integer_literal] = ACTIONS(329),
    [sym_hex_integer_literal] = ACTIONS(329),
    [sym_octal_integer_literal] = ACTIONS(327),
    [sym_binary_integer_literal] = ACTIONS(327),
    [sym_decimal_floating_point_literal] = ACTIONS(327),
    [sym_hex_floating_point_literal] = ACTIONS(329),
    [sym_true] = ACTIONS(329),
    [sym_false] = ACTIONS(329),
    [sym_character_literal] = ACTIONS(327),
    [sym_string_literal] = ACTIONS(329),
    [sym_text_block] = ACTIONS(327),
    [sym_null_literal] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_PLUS] = ACTIONS(329),
    [anon_sym_DASH] = ACTIONS(329),
    [anon_sym_final] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(327),
    [anon_sym_TILDE] = ACTIONS(327),
    [anon_sym_PLUS_PLUS] = ACTIONS(327),
    [anon_sym_DASH_DASH] = ACTIONS(327),
    [anon_sym_new] = ACTIONS(329),
    [anon_sym_class] = ACTIONS(329),
    [anon_sym_switch] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_RBRACE] = ACTIONS(327),
    [anon_sym_case] = ACTIONS(329),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(327),
    [anon_sym_assert] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(329),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_break] = ACTIONS(329),
    [anon_sym_continue] = ACTIONS(329),
    [anon_sym_return] = ACTIONS(329),
    [anon_sym_yield] = ACTIONS(329),
    [anon_sym_synchronized] = ACTIONS(329),
    [anon_sym_throw] = ACTIONS(329),
    [anon_sym_try] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(329),
    [anon_sym_else] = ACTIONS(329),
    [anon_sym_for] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(329),
    [anon_sym_open] = ACTIONS(329),
    [anon_sym_module] = ACTIONS(329),
    [anon_sym_static] = ACTIONS(329),
    [anon_sym_package] = ACTIONS(329),
    [anon_sym_import] = ACTIONS(329),
    [anon_sym_enum] = ACTIONS(329),
    [anon_sym_public] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_private] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_strictfp] = ACTIONS(329),
    [anon_sym_native] = ACTIONS(329),
    [anon_sym_transient] = ACTIONS(329),
    [anon_sym_volatile] = ACTIONS(329),
    [anon_sym_sealed] = ACTIONS(329),
    [anon_sym_non_DASHsealed] = ACTIONS(327),
    [anon_sym_record] = ACTIONS(329),
    [anon_sym_ATinterface] = ACTIONS(327),
    [anon_sym_interface] = ACTIONS(329),
    [anon_sym_byte] = ACTIONS(329),
    [anon_sym_short] = ACTIONS(329),
    [anon_sym_int] = ACTIONS(329),
    [anon_sym_long] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_float] = ACTIONS(329),
    [anon_sym_double] = ACTIONS(329),
    [sym_boolean_type] = ACTIONS(329),
    [sym_void_type] = ACTIONS(329),
    [sym_this] = ACTIONS(329),
    [sym_super] = ACTIONS(329),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [238] = {
    [ts_builtin_sym_end] = ACTIONS(874),
    [sym_identifier] = ACTIONS(876),
    [sym_decimal_integer_literal] = ACTIONS(876),
    [sym_hex_integer_literal] = ACTIONS(876),
    [sym_octal_integer_literal] = ACTIONS(874),
    [sym_binary_integer_literal] = ACTIONS(874),
    [sym_decimal_floating_point_literal] = ACTIONS(874),
    [sym_hex_floating_point_literal] = ACTIONS(876),
    [sym_true] = ACTIONS(876),
    [sym_false] = ACTIONS(876),
    [sym_character_literal] = ACTIONS(874),
    [sym_string_literal] = ACTIONS(876),
    [sym_text_block] = ACTIONS(874),
    [sym_null_literal] = ACTIONS(876),
    [anon_sym_LPAREN] = ACTIONS(874),
    [anon_sym_PLUS] = ACTIONS(876),
    [anon_sym_DASH] = ACTIONS(876),
    [anon_sym_final] = ACTIONS(876),
    [anon_sym_BANG] = ACTIONS(874),
    [anon_sym_TILDE] = ACTIONS(874),
    [anon_sym_PLUS_PLUS] = ACTIONS(874),
    [anon_sym_DASH_DASH] = ACTIONS(874),
    [anon_sym_new] = ACTIONS(876),
    [anon_sym_class] = ACTIONS(876),
    [anon_sym_switch] = ACTIONS(876),
    [anon_sym_LBRACE] = ACTIONS(874),
    [anon_sym_RBRACE] = ACTIONS(874),
    [anon_sym_case] = ACTIONS(876),
    [anon_sym_default] = ACTIONS(876),
    [anon_sym_SEMI] = ACTIONS(874),
    [anon_sym_assert] = ACTIONS(876),
    [anon_sym_do] = ACTIONS(876),
    [anon_sym_while] = ACTIONS(876),
    [anon_sym_break] = ACTIONS(876),
    [anon_sym_continue] = ACTIONS(876),
    [anon_sym_return] = ACTIONS(876),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_synchronized] = ACTIONS(876),
    [anon_sym_throw] = ACTIONS(876),
    [anon_sym_try] = ACTIONS(876),
    [anon_sym_if] = ACTIONS(876),
    [anon_sym_else] = ACTIONS(876),
    [anon_sym_for] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(876),
    [anon_sym_open] = ACTIONS(876),
    [anon_sym_module] = ACTIONS(876),
    [anon_sym_static] = ACTIONS(876),
    [anon_sym_package] = ACTIONS(876),
    [anon_sym_import] = ACTIONS(876),
    [anon_sym_enum] = ACTIONS(876),
    [anon_sym_public] = ACTIONS(876),
    [anon_sym_protected] = ACTIONS(876),
    [anon_sym_private] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(876),
    [anon_sym_strictfp] = ACTIONS(876),
    [anon_sym_native] = ACTIONS(876),
    [anon_sym_transient] = ACTIONS(876),
    [anon_sym_volatile] = ACTIONS(876),
    [anon_sym_sealed] = ACTIONS(876),
    [anon_sym_non_DASHsealed] = ACTIONS(874),
    [anon_sym_record] = ACTIONS(876),
    [anon_sym_ATinterface] = ACTIONS(874),
    [anon_sym_interface] = ACTIONS(876),
    [anon_sym_byte] = ACTIONS(876),
    [anon_sym_short] = ACTIONS(876),
    [anon_sym_int] = ACTIONS(876),
    [anon_sym_long] = ACTIONS(876),
    [anon_sym_char] = ACTIONS(876),
    [anon_sym_float] = ACTIONS(876),
    [anon_sym_double] = ACTIONS(876),
    [sym_boolean_type] = ACTIONS(876),
    [sym_void_type] = ACTIONS(876),
    [sym_this] = ACTIONS(876),
    [sym_super] = ACTIONS(876),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [239] = {
    [ts_builtin_sym_end] = ACTIONS(878),
    [sym_identifier] = ACTIONS(880),
    [sym_decimal_integer_literal] = ACTIONS(880),
    [sym_hex_integer_literal] = ACTIONS(880),
    [sym_octal_integer_literal] = ACTIONS(878),
    [sym_binary_integer_literal] = ACTIONS(878),
    [sym_decimal_floating_point_literal] = ACTIONS(878),
    [sym_hex_floating_point_literal] = ACTIONS(880),
    [sym_true] = ACTIONS(880),
    [sym_false] = ACTIONS(880),
    [sym_character_literal] = ACTIONS(878),
    [sym_string_literal] = ACTIONS(880),
    [sym_text_block] = ACTIONS(878),
    [sym_null_literal] = ACTIONS(880),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_PLUS] = ACTIONS(880),
    [anon_sym_DASH] = ACTIONS(880),
    [anon_sym_final] = ACTIONS(880),
    [anon_sym_BANG] = ACTIONS(878),
    [anon_sym_TILDE] = ACTIONS(878),
    [anon_sym_PLUS_PLUS] = ACTIONS(878),
    [anon_sym_DASH_DASH] = ACTIONS(878),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(880),
    [anon_sym_switch] = ACTIONS(880),
    [anon_sym_LBRACE] = ACTIONS(878),
    [anon_sym_RBRACE] = ACTIONS(878),
    [anon_sym_case] = ACTIONS(880),
    [anon_sym_default] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(878),
    [anon_sym_assert] = ACTIONS(880),
    [anon_sym_do] = ACTIONS(880),
    [anon_sym_while] = ACTIONS(880),
    [anon_sym_break] = ACTIONS(880),
    [anon_sym_continue] = ACTIONS(880),
    [anon_sym_return] = ACTIONS(880),
    [anon_sym_yield] = ACTIONS(880),
    [anon_sym_synchronized] = ACTIONS(880),
    [anon_sym_throw] = ACTIONS(880),
    [anon_sym_try] = ACTIONS(880),
    [anon_sym_if] = ACTIONS(880),
    [anon_sym_else] = ACTIONS(880),
    [anon_sym_for] = ACTIONS(880),
    [anon_sym_AT] = ACTIONS(880),
    [anon_sym_open] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(880),
    [anon_sym_static] = ACTIONS(880),
    [anon_sym_package] = ACTIONS(880),
    [anon_sym_import] = ACTIONS(880),
    [anon_sym_enum] = ACTIONS(880),
    [anon_sym_public] = ACTIONS(880),
    [anon_sym_protected] = ACTIONS(880),
    [anon_sym_private] = ACTIONS(880),
    [anon_sym_abstract] = ACTIONS(880),
    [anon_sym_strictfp] = ACTIONS(880),
    [anon_sym_native] = ACTIONS(880),
    [anon_sym_transient] = ACTIONS(880),
    [anon_sym_volatile] = ACTIONS(880),
    [anon_sym_sealed] = ACTIONS(880),
    [anon_sym_non_DASHsealed] = ACTIONS(878),
    [anon_sym_record] = ACTIONS(880),
    [anon_sym_ATinterface] = ACTIONS(878),
    [anon_sym_interface] = ACTIONS(880),
    [anon_sym_byte] = ACTIONS(880),
    [anon_sym_short] = ACTIONS(880),
    [anon_sym_int] = ACTIONS(880),
    [anon_sym_long] = ACTIONS(880),
    [anon_sym_char] = ACTIONS(880),
    [anon_sym_float] = ACTIONS(880),
    [anon_sym_double] = ACTIONS(880),
    [sym_boolean_type] = ACTIONS(880),
    [sym_void_type] = ACTIONS(880),
    [sym_this] = ACTIONS(880),
    [sym_super] = ACTIONS(880),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [240] = {
    [ts_builtin_sym_end] = ACTIONS(882),
    [sym_identifier] = ACTIONS(884),
    [sym_decimal_integer_literal] = ACTIONS(884),
    [sym_hex_integer_literal] = ACTIONS(884),
    [sym_octal_integer_literal] = ACTIONS(882),
    [sym_binary_integer_literal] = ACTIONS(882),
    [sym_decimal_floating_point_literal] = ACTIONS(882),
    [sym_hex_floating_point_literal] = ACTIONS(884),
    [sym_true] = ACTIONS(884),
    [sym_false] = ACTIONS(884),
    [sym_character_literal] = ACTIONS(882),
    [sym_string_literal] = ACTIONS(884),
    [sym_text_block] = ACTIONS(882),
    [sym_null_literal] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_final] = ACTIONS(884),
    [anon_sym_BANG] = ACTIONS(882),
    [anon_sym_TILDE] = ACTIONS(882),
    [anon_sym_PLUS_PLUS] = ACTIONS(882),
    [anon_sym_DASH_DASH] = ACTIONS(882),
    [anon_sym_new] = ACTIONS(884),
    [anon_sym_class] = ACTIONS(884),
    [anon_sym_switch] = ACTIONS(884),
    [anon_sym_LBRACE] = ACTIONS(882),
    [anon_sym_RBRACE] = ACTIONS(882),
    [anon_sym_case] = ACTIONS(884),
    [anon_sym_default] = ACTIONS(884),
    [anon_sym_SEMI] = ACTIONS(882),
    [anon_sym_assert] = ACTIONS(884),
    [anon_sym_do] = ACTIONS(884),
    [anon_sym_while] = ACTIONS(884),
    [anon_sym_break] = ACTIONS(884),
    [anon_sym_continue] = ACTIONS(884),
    [anon_sym_return] = ACTIONS(884),
    [anon_sym_yield] = ACTIONS(884),
    [anon_sym_synchronized] = ACTIONS(884),
    [anon_sym_throw] = ACTIONS(884),
    [anon_sym_try] = ACTIONS(884),
    [anon_sym_if] = ACTIONS(884),
    [anon_sym_else] = ACTIONS(886),
    [anon_sym_for] = ACTIONS(884),
    [anon_sym_AT] = ACTIONS(884),
    [anon_sym_open] = ACTIONS(884),
    [anon_sym_module] = ACTIONS(884),
    [anon_sym_static] = ACTIONS(884),
    [anon_sym_package] = ACTIONS(884),
    [anon_sym_import] = ACTIONS(884),
    [anon_sym_enum] = ACTIONS(884),
    [anon_sym_public] = ACTIONS(884),
    [anon_sym_protected] = ACTIONS(884),
    [anon_sym_private] = ACTIONS(884),
    [anon_sym_abstract] = ACTIONS(884),
    [anon_sym_strictfp] = ACTIONS(884),
    [anon_sym_native] = ACTIONS(884),
    [anon_sym_transient] = ACTIONS(884),
    [anon_sym_volatile] = ACTIONS(884),
    [anon_sym_sealed] = ACTIONS(884),
    [anon_sym_non_DASHsealed] = ACTIONS(882),
    [anon_sym_record] = ACTIONS(884),
    [anon_sym_ATinterface] = ACTIONS(882),
    [anon_sym_interface] = ACTIONS(884),
    [anon_sym_byte] = ACTIONS(884),
    [anon_sym_short] = ACTIONS(884),
    [anon_sym_int] = ACTIONS(884),
    [anon_sym_long] = ACTIONS(884),
    [anon_sym_char] = ACTIONS(884),
    [anon_sym_float] = ACTIONS(884),
    [anon_sym_double] = ACTIONS(884),
    [sym_boolean_type] = ACTIONS(884),
    [sym_void_type] = ACTIONS(884),
    [sym_this] = ACTIONS(884),
    [sym_super] = ACTIONS(884),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [241] = {
    [ts_builtin_sym_end] = ACTIONS(888),
    [sym_identifier] = ACTIONS(890),
    [sym_decimal_integer_literal] = ACTIONS(890),
    [sym_hex_integer_literal] = ACTIONS(890),
    [sym_octal_integer_literal] = ACTIONS(888),
    [sym_binary_integer_literal] = ACTIONS(888),
    [sym_decimal_floating_point_literal] = ACTIONS(888),
    [sym_hex_floating_point_literal] = ACTIONS(890),
    [sym_true] = ACTIONS(890),
    [sym_false] = ACTIONS(890),
    [sym_character_literal] = ACTIONS(888),
    [sym_string_literal] = ACTIONS(890),
    [sym_text_block] = ACTIONS(888),
    [sym_null_literal] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(888),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_final] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(888),
    [anon_sym_TILDE] = ACTIONS(888),
    [anon_sym_PLUS_PLUS] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(888),
    [anon_sym_new] = ACTIONS(890),
    [anon_sym_class] = ACTIONS(890),
    [anon_sym_switch] = ACTIONS(890),
    [anon_sym_LBRACE] = ACTIONS(888),
    [anon_sym_RBRACE] = ACTIONS(888),
    [anon_sym_case] = ACTIONS(890),
    [anon_sym_default] = ACTIONS(890),
    [anon_sym_SEMI] = ACTIONS(888),
    [anon_sym_assert] = ACTIONS(890),
    [anon_sym_do] = ACTIONS(890),
    [anon_sym_while] = ACTIONS(890),
    [anon_sym_break] = ACTIONS(890),
    [anon_sym_continue] = ACTIONS(890),
    [anon_sym_return] = ACTIONS(890),
    [anon_sym_yield] = ACTIONS(890),
    [anon_sym_synchronized] = ACTIONS(890),
    [anon_sym_throw] = ACTIONS(890),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_if] = ACTIONS(890),
    [anon_sym_else] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(890),
    [anon_sym_AT] = ACTIONS(890),
    [anon_sym_open] = ACTIONS(890),
    [anon_sym_module] = ACTIONS(890),
    [anon_sym_static] = ACTIONS(890),
    [anon_sym_package] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(890),
    [anon_sym_enum] = ACTIONS(890),
    [anon_sym_public] = ACTIONS(890),
    [anon_sym_protected] = ACTIONS(890),
    [anon_sym_private] = ACTIONS(890),
    [anon_sym_abstract] = ACTIONS(890),
    [anon_sym_strictfp] = ACTIONS(890),
    [anon_sym_native] = ACTIONS(890),
    [anon_sym_transient] = ACTIONS(890),
    [anon_sym_volatile] = ACTIONS(890),
    [anon_sym_sealed] = ACTIONS(890),
    [anon_sym_non_DASHsealed] = ACTIONS(888),
    [anon_sym_record] = ACTIONS(890),
    [anon_sym_ATinterface] = ACTIONS(888),
    [anon_sym_interface] = ACTIONS(890),
    [anon_sym_byte] = ACTIONS(890),
    [anon_sym_short] = ACTIONS(890),
    [anon_sym_int] = ACTIONS(890),
    [anon_sym_long] = ACTIONS(890),
    [anon_sym_char] = ACTIONS(890),
    [anon_sym_float] = ACTIONS(890),
    [anon_sym_double] = ACTIONS(890),
    [sym_boolean_type] = ACTIONS(890),
    [sym_void_type] = ACTIONS(890),
    [sym_this] = ACTIONS(890),
    [sym_super] = ACTIONS(890),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [242] = {
    [ts_builtin_sym_end] = ACTIONS(892),
    [sym_identifier] = ACTIONS(894),
    [sym_decimal_integer_literal] = ACTIONS(894),
    [sym_hex_integer_literal] = ACTIONS(894),
    [sym_octal_integer_literal] = ACTIONS(892),
    [sym_binary_integer_literal] = ACTIONS(892),
    [sym_decimal_floating_point_literal] = ACTIONS(892),
    [sym_hex_floating_point_literal] = ACTIONS(894),
    [sym_true] = ACTIONS(894),
    [sym_false] = ACTIONS(894),
    [sym_character_literal] = ACTIONS(892),
    [sym_string_literal] = ACTIONS(894),
    [sym_text_block] = ACTIONS(892),
    [sym_null_literal] = ACTIONS(894),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_PLUS] = ACTIONS(894),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_final] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(892),
    [anon_sym_TILDE] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_new] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(894),
    [anon_sym_switch] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(892),
    [anon_sym_RBRACE] = ACTIONS(892),
    [anon_sym_case] = ACTIONS(894),
    [anon_sym_default] = ACTIONS(894),
    [anon_sym_SEMI] = ACTIONS(892),
    [anon_sym_assert] = ACTIONS(894),
    [anon_sym_do] = ACTIONS(894),
    [anon_sym_while] = ACTIONS(894),
    [anon_sym_break] = ACTIONS(894),
    [anon_sym_continue] = ACTIONS(894),
    [anon_sym_return] = ACTIONS(894),
    [anon_sym_yield] = ACTIONS(894),
    [anon_sym_synchronized] = ACTIONS(894),
    [anon_sym_throw] = ACTIONS(894),
    [anon_sym_try] = ACTIONS(894),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_else] = ACTIONS(894),
    [anon_sym_for] = ACTIONS(894),
    [anon_sym_AT] = ACTIONS(894),
    [anon_sym_open] = ACTIONS(894),
    [anon_sym_module] = ACTIONS(894),
    [anon_sym_static] = ACTIONS(894),
    [anon_sym_package] = ACTIONS(894),
    [anon_sym_import] = ACTIONS(894),
    [anon_sym_enum] = ACTIONS(894),
    [anon_sym_public] = ACTIONS(894),
    [anon_sym_protected] = ACTIONS(894),
    [anon_sym_private] = ACTIONS(894),
    [anon_sym_abstract] = ACTIONS(894),
    [anon_sym_strictfp] = ACTIONS(894),
    [anon_sym_native] = ACTIONS(894),
    [anon_sym_transient] = ACTIONS(894),
    [anon_sym_volatile] = ACTIONS(894),
    [anon_sym_sealed] = ACTIONS(894),
    [anon_sym_non_DASHsealed] = ACTIONS(892),
    [anon_sym_record] = ACTIONS(894),
    [anon_sym_ATinterface] = ACTIONS(892),
    [anon_sym_interface] = ACTIONS(894),
    [anon_sym_byte] = ACTIONS(894),
    [anon_sym_short] = ACTIONS(894),
    [anon_sym_int] = ACTIONS(894),
    [anon_sym_long] = ACTIONS(894),
    [anon_sym_char] = ACTIONS(894),
    [anon_sym_float] = ACTIONS(894),
    [anon_sym_double] = ACTIONS(894),
    [sym_boolean_type] = ACTIONS(894),
    [sym_void_type] = ACTIONS(894),
    [sym_this] = ACTIONS(894),
    [sym_super] = ACTIONS(894),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [243] = {
    [ts_builtin_sym_end] = ACTIONS(896),
    [sym_identifier] = ACTIONS(898),
    [sym_decimal_integer_literal] = ACTIONS(898),
    [sym_hex_integer_literal] = ACTIONS(898),
    [sym_octal_integer_literal] = ACTIONS(896),
    [sym_binary_integer_literal] = ACTIONS(896),
    [sym_decimal_floating_point_literal] = ACTIONS(896),
    [sym_hex_floating_point_literal] = ACTIONS(898),
    [sym_true] = ACTIONS(898),
    [sym_false] = ACTIONS(898),
    [sym_character_literal] = ACTIONS(896),
    [sym_string_literal] = ACTIONS(898),
    [sym_text_block] = ACTIONS(896),
    [sym_null_literal] = ACTIONS(898),
    [anon_sym_LPAREN] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_final] = ACTIONS(898),
    [anon_sym_BANG] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_PLUS_PLUS] = ACTIONS(896),
    [anon_sym_DASH_DASH] = ACTIONS(896),
    [anon_sym_new] = ACTIONS(898),
    [anon_sym_class] = ACTIONS(898),
    [anon_sym_switch] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(896),
    [anon_sym_RBRACE] = ACTIONS(896),
    [anon_sym_case] = ACTIONS(898),
    [anon_sym_default] = ACTIONS(898),
    [anon_sym_SEMI] = ACTIONS(896),
    [anon_sym_assert] = ACTIONS(898),
    [anon_sym_do] = ACTIONS(898),
    [anon_sym_while] = ACTIONS(898),
    [anon_sym_break] = ACTIONS(898),
    [anon_sym_continue] = ACTIONS(898),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_yield] = ACTIONS(898),
    [anon_sym_synchronized] = ACTIONS(898),
    [anon_sym_throw] = ACTIONS(898),
    [anon_sym_try] = ACTIONS(898),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_else] = ACTIONS(898),
    [anon_sym_for] = ACTIONS(898),
    [anon_sym_AT] = ACTIONS(898),
    [anon_sym_open] = ACTIONS(898),
    [anon_sym_module] = ACTIONS(898),
    [anon_sym_static] = ACTIONS(898),
    [anon_sym_package] = ACTIONS(898),
    [anon_sym_import] = ACTIONS(898),
    [anon_sym_enum] = ACTIONS(898),
    [anon_sym_public] = ACTIONS(898),
    [anon_sym_protected] = ACTIONS(898),
    [anon_sym_private] = ACTIONS(898),
    [anon_sym_abstract] = ACTIONS(898),
    [anon_sym_strictfp] = ACTIONS(898),
    [anon_sym_native] = ACTIONS(898),
    [anon_sym_transient] = ACTIONS(898),
    [anon_sym_volatile] = ACTIONS(898),
    [anon_sym_sealed] = ACTIONS(898),
    [anon_sym_non_DASHsealed] = ACTIONS(896),
    [anon_sym_record] = ACTIONS(898),
    [anon_sym_ATinterface] = ACTIONS(896),
    [anon_sym_interface] = ACTIONS(898),
    [anon_sym_byte] = ACTIONS(898),
    [anon_sym_short] = ACTIONS(898),
    [anon_sym_int] = ACTIONS(898),
    [anon_sym_long] = ACTIONS(898),
    [anon_sym_char] = ACTIONS(898),
    [anon_sym_float] = ACTIONS(898),
    [anon_sym_double] = ACTIONS(898),
    [sym_boolean_type] = ACTIONS(898),
    [sym_void_type] = ACTIONS(898),
    [sym_this] = ACTIONS(898),
    [sym_super] = ACTIONS(898),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [244] = {
    [ts_builtin_sym_end] = ACTIONS(900),
    [sym_identifier] = ACTIONS(902),
    [sym_decimal_integer_literal] = ACTIONS(902),
    [sym_hex_integer_literal] = ACTIONS(902),
    [sym_octal_integer_literal] = ACTIONS(900),
    [sym_binary_integer_literal] = ACTIONS(900),
    [sym_decimal_floating_point_literal] = ACTIONS(900),
    [sym_hex_floating_point_literal] = ACTIONS(902),
    [sym_true] = ACTIONS(902),
    [sym_false] = ACTIONS(902),
    [sym_character_literal] = ACTIONS(900),
    [sym_string_literal] = ACTIONS(902),
    [sym_text_block] = ACTIONS(900),
    [sym_null_literal] = ACTIONS(902),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_PLUS] = ACTIONS(902),
    [anon_sym_DASH] = ACTIONS(902),
    [anon_sym_final] = ACTIONS(902),
    [anon_sym_BANG] = ACTIONS(900),
    [anon_sym_TILDE] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(900),
    [anon_sym_DASH_DASH] = ACTIONS(900),
    [anon_sym_new] = ACTIONS(902),
    [anon_sym_class] = ACTIONS(902),
    [anon_sym_switch] = ACTIONS(902),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_RBRACE] = ACTIONS(900),
    [anon_sym_case] = ACTIONS(902),
    [anon_sym_default] = ACTIONS(902),
    [anon_sym_SEMI] = ACTIONS(900),
    [anon_sym_assert] = ACTIONS(902),
    [anon_sym_do] = ACTIONS(902),
    [anon_sym_while] = ACTIONS(902),
    [anon_sym_break] = ACTIONS(902),
    [anon_sym_continue] = ACTIONS(902),
    [anon_sym_return] = ACTIONS(902),
    [anon_sym_yield] = ACTIONS(902),
    [anon_sym_synchronized] = ACTIONS(902),
    [anon_sym_throw] = ACTIONS(902),
    [anon_sym_try] = ACTIONS(902),
    [anon_sym_if] = ACTIONS(902),
    [anon_sym_else] = ACTIONS(902),
    [anon_sym_for] = ACTIONS(902),
    [anon_sym_AT] = ACTIONS(902),
    [anon_sym_open] = ACTIONS(902),
    [anon_sym_module] = ACTIONS(902),
    [anon_sym_static] = ACTIONS(902),
    [anon_sym_package] = ACTIONS(902),
    [anon_sym_import] = ACTIONS(902),
    [anon_sym_enum] = ACTIONS(902),
    [anon_sym_public] = ACTIONS(902),
    [anon_sym_protected] = ACTIONS(902),
    [anon_sym_private] = ACTIONS(902),
    [anon_sym_abstract] = ACTIONS(902),
    [anon_sym_strictfp] = ACTIONS(902),
    [anon_sym_native] = ACTIONS(902),
    [anon_sym_transient] = ACTIONS(902),
    [anon_sym_volatile] = ACTIONS(902),
    [anon_sym_sealed] = ACTIONS(902),
    [anon_sym_non_DASHsealed] = ACTIONS(900),
    [anon_sym_record] = ACTIONS(902),
    [anon_sym_ATinterface] = ACTIONS(900),
    [anon_sym_interface] = ACTIONS(902),
    [anon_sym_byte] = ACTIONS(902),
    [anon_sym_short] = ACTIONS(902),
    [anon_sym_int] = ACTIONS(902),
    [anon_sym_long] = ACTIONS(902),
    [anon_sym_char] = ACTIONS(902),
    [anon_sym_float] = ACTIONS(902),
    [anon_sym_double] = ACTIONS(902),
    [sym_boolean_type] = ACTIONS(902),
    [sym_void_type] = ACTIONS(902),
    [sym_this] = ACTIONS(902),
    [sym_super] = ACTIONS(902),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [245] = {
    [ts_builtin_sym_end] = ACTIONS(904),
    [sym_identifier] = ACTIONS(906),
    [sym_decimal_integer_literal] = ACTIONS(906),
    [sym_hex_integer_literal] = ACTIONS(906),
    [sym_octal_integer_literal] = ACTIONS(904),
    [sym_binary_integer_literal] = ACTIONS(904),
    [sym_decimal_floating_point_literal] = ACTIONS(904),
    [sym_hex_floating_point_literal] = ACTIONS(906),
    [sym_true] = ACTIONS(906),
    [sym_false] = ACTIONS(906),
    [sym_character_literal] = ACTIONS(904),
    [sym_string_literal] = ACTIONS(906),
    [sym_text_block] = ACTIONS(904),
    [sym_null_literal] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_final] = ACTIONS(906),
    [anon_sym_BANG] = ACTIONS(904),
    [anon_sym_TILDE] = ACTIONS(904),
    [anon_sym_PLUS_PLUS] = ACTIONS(904),
    [anon_sym_DASH_DASH] = ACTIONS(904),
    [anon_sym_new] = ACTIONS(906),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_switch] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(904),
    [anon_sym_RBRACE] = ACTIONS(904),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_default] = ACTIONS(906),
    [anon_sym_SEMI] = ACTIONS(904),
    [anon_sym_assert] = ACTIONS(906),
    [anon_sym_do] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_break] = ACTIONS(906),
    [anon_sym_continue] = ACTIONS(906),
    [anon_sym_return] = ACTIONS(906),
    [anon_sym_yield] = ACTIONS(906),
    [anon_sym_synchronized] = ACTIONS(906),
    [anon_sym_throw] = ACTIONS(906),
    [anon_sym_try] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_else] = ACTIONS(906),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_AT] = ACTIONS(906),
    [anon_sym_open] = ACTIONS(906),
    [anon_sym_module] = ACTIONS(906),
    [anon_sym_static] = ACTIONS(906),
    [anon_sym_package] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_enum] = ACTIONS(906),
    [anon_sym_public] = ACTIONS(906),
    [anon_sym_protected] = ACTIONS(906),
    [anon_sym_private] = ACTIONS(906),
    [anon_sym_abstract] = ACTIONS(906),
    [anon_sym_strictfp] = ACTIONS(906),
    [anon_sym_native] = ACTIONS(906),
    [anon_sym_transient] = ACTIONS(906),
    [anon_sym_volatile] = ACTIONS(906),
    [anon_sym_sealed] = ACTIONS(906),
    [anon_sym_non_DASHsealed] = ACTIONS(904),
    [anon_sym_record] = ACTIONS(906),
    [anon_sym_ATinterface] = ACTIONS(904),
    [anon_sym_interface] = ACTIONS(906),
    [anon_sym_byte] = ACTIONS(906),
    [anon_sym_short] = ACTIONS(906),
    [anon_sym_int] = ACTIONS(906),
    [anon_sym_long] = ACTIONS(906),
    [anon_sym_char] = ACTIONS(906),
    [anon_sym_float] = ACTIONS(906),
    [anon_sym_double] = ACTIONS(906),
    [sym_boolean_type] = ACTIONS(906),
    [sym_void_type] = ACTIONS(906),
    [sym_this] = ACTIONS(906),
    [sym_super] = ACTIONS(906),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [246] = {
    [ts_builtin_sym_end] = ACTIONS(908),
    [sym_identifier] = ACTIONS(910),
    [sym_decimal_integer_literal] = ACTIONS(910),
    [sym_hex_integer_literal] = ACTIONS(910),
    [sym_octal_integer_literal] = ACTIONS(908),
    [sym_binary_integer_literal] = ACTIONS(908),
    [sym_decimal_floating_point_literal] = ACTIONS(908),
    [sym_hex_floating_point_literal] = ACTIONS(910),
    [sym_true] = ACTIONS(910),
    [sym_false] = ACTIONS(910),
    [sym_character_literal] = ACTIONS(908),
    [sym_string_literal] = ACTIONS(910),
    [sym_text_block] = ACTIONS(908),
    [sym_null_literal] = ACTIONS(910),
    [anon_sym_LPAREN] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_final] = ACTIONS(910),
    [anon_sym_BANG] = ACTIONS(908),
    [anon_sym_TILDE] = ACTIONS(908),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_new] = ACTIONS(910),
    [anon_sym_class] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_RBRACE] = ACTIONS(908),
    [anon_sym_case] = ACTIONS(910),
    [anon_sym_default] = ACTIONS(910),
    [anon_sym_SEMI] = ACTIONS(908),
    [anon_sym_assert] = ACTIONS(910),
    [anon_sym_do] = ACTIONS(910),
    [anon_sym_while] = ACTIONS(910),
    [anon_sym_break] = ACTIONS(910),
    [anon_sym_continue] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(910),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_synchronized] = ACTIONS(910),
    [anon_sym_throw] = ACTIONS(910),
    [anon_sym_try] = ACTIONS(910),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_else] = ACTIONS(910),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_AT] = ACTIONS(910),
    [anon_sym_open] = ACTIONS(910),
    [anon_sym_module] = ACTIONS(910),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_package] = ACTIONS(910),
    [anon_sym_import] = ACTIONS(910),
    [anon_sym_enum] = ACTIONS(910),
    [anon_sym_public] = ACTIONS(910),
    [anon_sym_protected] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym_abstract] = ACTIONS(910),
    [anon_sym_strictfp] = ACTIONS(910),
    [anon_sym_native] = ACTIONS(910),
    [anon_sym_transient] = ACTIONS(910),
    [anon_sym_volatile] = ACTIONS(910),
    [anon_sym_sealed] = ACTIONS(910),
    [anon_sym_non_DASHsealed] = ACTIONS(908),
    [anon_sym_record] = ACTIONS(910),
    [anon_sym_ATinterface] = ACTIONS(908),
    [anon_sym_interface] = ACTIONS(910),
    [anon_sym_byte] = ACTIONS(910),
    [anon_sym_short] = ACTIONS(910),
    [anon_sym_int] = ACTIONS(910),
    [anon_sym_long] = ACTIONS(910),
    [anon_sym_char] = ACTIONS(910),
    [anon_sym_float] = ACTIONS(910),
    [anon_sym_double] = ACTIONS(910),
    [sym_boolean_type] = ACTIONS(910),
    [sym_void_type] = ACTIONS(910),
    [sym_this] = ACTIONS(910),
    [sym_super] = ACTIONS(910),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [247] = {
    [ts_builtin_sym_end] = ACTIONS(912),
    [sym_identifier] = ACTIONS(914),
    [sym_decimal_integer_literal] = ACTIONS(914),
    [sym_hex_integer_literal] = ACTIONS(914),
    [sym_octal_integer_literal] = ACTIONS(912),
    [sym_binary_integer_literal] = ACTIONS(912),
    [sym_decimal_floating_point_literal] = ACTIONS(912),
    [sym_hex_floating_point_literal] = ACTIONS(914),
    [sym_true] = ACTIONS(914),
    [sym_false] = ACTIONS(914),
    [sym_character_literal] = ACTIONS(912),
    [sym_string_literal] = ACTIONS(914),
    [sym_text_block] = ACTIONS(912),
    [sym_null_literal] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(914),
    [anon_sym_DASH] = ACTIONS(914),
    [anon_sym_final] = ACTIONS(914),
    [anon_sym_BANG] = ACTIONS(912),
    [anon_sym_TILDE] = ACTIONS(912),
    [anon_sym_PLUS_PLUS] = ACTIONS(912),
    [anon_sym_DASH_DASH] = ACTIONS(912),
    [anon_sym_new] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(914),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(912),
    [anon_sym_case] = ACTIONS(914),
    [anon_sym_default] = ACTIONS(914),
    [anon_sym_SEMI] = ACTIONS(912),
    [anon_sym_assert] = ACTIONS(914),
    [anon_sym_do] = ACTIONS(914),
    [anon_sym_while] = ACTIONS(914),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(914),
    [anon_sym_return] = ACTIONS(914),
    [anon_sym_yield] = ACTIONS(914),
    [anon_sym_synchronized] = ACTIONS(914),
    [anon_sym_throw] = ACTIONS(914),
    [anon_sym_try] = ACTIONS(914),
    [anon_sym_if] = ACTIONS(914),
    [anon_sym_else] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_AT] = ACTIONS(914),
    [anon_sym_open] = ACTIONS(914),
    [anon_sym_module] = ACTIONS(914),
    [anon_sym_static] = ACTIONS(914),
    [anon_sym_package] = ACTIONS(914),
    [anon_sym_import] = ACTIONS(914),
    [anon_sym_enum] = ACTIONS(914),
    [anon_sym_public] = ACTIONS(914),
    [anon_sym_protected] = ACTIONS(914),
    [anon_sym_private] = ACTIONS(914),
    [anon_sym_abstract] = ACTIONS(914),
    [anon_sym_strictfp] = ACTIONS(914),
    [anon_sym_native] = ACTIONS(914),
    [anon_sym_transient] = ACTIONS(914),
    [anon_sym_volatile] = ACTIONS(914),
    [anon_sym_sealed] = ACTIONS(914),
    [anon_sym_non_DASHsealed] = ACTIONS(912),
    [anon_sym_record] = ACTIONS(914),
    [anon_sym_ATinterface] = ACTIONS(912),
    [anon_sym_interface] = ACTIONS(914),
    [anon_sym_byte] = ACTIONS(914),
    [anon_sym_short] = ACTIONS(914),
    [anon_sym_int] = ACTIONS(914),
    [anon_sym_long] = ACTIONS(914),
    [anon_sym_char] = ACTIONS(914),
    [anon_sym_float] = ACTIONS(914),
    [anon_sym_double] = ACTIONS(914),
    [sym_boolean_type] = ACTIONS(914),
    [sym_void_type] = ACTIONS(914),
    [sym_this] = ACTIONS(914),
    [sym_super] = ACTIONS(914),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [248] = {
    [ts_builtin_sym_end] = ACTIONS(916),
    [sym_identifier] = ACTIONS(918),
    [sym_decimal_integer_literal] = ACTIONS(918),
    [sym_hex_integer_literal] = ACTIONS(918),
    [sym_octal_integer_literal] = ACTIONS(916),
    [sym_binary_integer_literal] = ACTIONS(916),
    [sym_decimal_floating_point_literal] = ACTIONS(916),
    [sym_hex_floating_point_literal] = ACTIONS(918),
    [sym_true] = ACTIONS(918),
    [sym_false] = ACTIONS(918),
    [sym_character_literal] = ACTIONS(916),
    [sym_string_literal] = ACTIONS(918),
    [sym_text_block] = ACTIONS(916),
    [sym_null_literal] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(916),
    [anon_sym_PLUS] = ACTIONS(918),
    [anon_sym_DASH] = ACTIONS(918),
    [anon_sym_final] = ACTIONS(918),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_new] = ACTIONS(918),
    [anon_sym_class] = ACTIONS(918),
    [anon_sym_switch] = ACTIONS(918),
    [anon_sym_LBRACE] = ACTIONS(916),
    [anon_sym_RBRACE] = ACTIONS(916),
    [anon_sym_case] = ACTIONS(918),
    [anon_sym_default] = ACTIONS(918),
    [anon_sym_SEMI] = ACTIONS(916),
    [anon_sym_assert] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(918),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_break] = ACTIONS(918),
    [anon_sym_continue] = ACTIONS(918),
    [anon_sym_return] = ACTIONS(918),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_synchronized] = ACTIONS(918),
    [anon_sym_throw] = ACTIONS(918),
    [anon_sym_try] = ACTIONS(918),
    [anon_sym_if] = ACTIONS(918),
    [anon_sym_else] = ACTIONS(918),
    [anon_sym_for] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(918),
    [anon_sym_open] = ACTIONS(918),
    [anon_sym_module] = ACTIONS(918),
    [anon_sym_static] = ACTIONS(918),
    [anon_sym_package] = ACTIONS(918),
    [anon_sym_import] = ACTIONS(918),
    [anon_sym_enum] = ACTIONS(918),
    [anon_sym_public] = ACTIONS(918),
    [anon_sym_protected] = ACTIONS(918),
    [anon_sym_private] = ACTIONS(918),
    [anon_sym_abstract] = ACTIONS(918),
    [anon_sym_strictfp] = ACTIONS(918),
    [anon_sym_native] = ACTIONS(918),
    [anon_sym_transient] = ACTIONS(918),
    [anon_sym_volatile] = ACTIONS(918),
    [anon_sym_sealed] = ACTIONS(918),
    [anon_sym_non_DASHsealed] = ACTIONS(916),
    [anon_sym_record] = ACTIONS(918),
    [anon_sym_ATinterface] = ACTIONS(916),
    [anon_sym_interface] = ACTIONS(918),
    [anon_sym_byte] = ACTIONS(918),
    [anon_sym_short] = ACTIONS(918),
    [anon_sym_int] = ACTIONS(918),
    [anon_sym_long] = ACTIONS(918),
    [anon_sym_char] = ACTIONS(918),
    [anon_sym_float] = ACTIONS(918),
    [anon_sym_double] = ACTIONS(918),
    [sym_boolean_type] = ACTIONS(918),
    [sym_void_type] = ACTIONS(918),
    [sym_this] = ACTIONS(918),
    [sym_super] = ACTIONS(918),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [249] = {
    [ts_builtin_sym_end] = ACTIONS(920),
    [sym_identifier] = ACTIONS(922),
    [sym_decimal_integer_literal] = ACTIONS(922),
    [sym_hex_integer_literal] = ACTIONS(922),
    [sym_octal_integer_literal] = ACTIONS(920),
    [sym_binary_integer_literal] = ACTIONS(920),
    [sym_decimal_floating_point_literal] = ACTIONS(920),
    [sym_hex_floating_point_literal] = ACTIONS(922),
    [sym_true] = ACTIONS(922),
    [sym_false] = ACTIONS(922),
    [sym_character_literal] = ACTIONS(920),
    [sym_string_literal] = ACTIONS(922),
    [sym_text_block] = ACTIONS(920),
    [sym_null_literal] = ACTIONS(922),
    [anon_sym_LPAREN] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_final] = ACTIONS(922),
    [anon_sym_BANG] = ACTIONS(920),
    [anon_sym_TILDE] = ACTIONS(920),
    [anon_sym_PLUS_PLUS] = ACTIONS(920),
    [anon_sym_DASH_DASH] = ACTIONS(920),
    [anon_sym_new] = ACTIONS(922),
    [anon_sym_class] = ACTIONS(922),
    [anon_sym_switch] = ACTIONS(922),
    [anon_sym_LBRACE] = ACTIONS(920),
    [anon_sym_RBRACE] = ACTIONS(920),
    [anon_sym_case] = ACTIONS(922),
    [anon_sym_default] = ACTIONS(922),
    [anon_sym_SEMI] = ACTIONS(920),
    [anon_sym_assert] = ACTIONS(922),
    [anon_sym_do] = ACTIONS(922),
    [anon_sym_while] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(922),
    [anon_sym_continue] = ACTIONS(922),
    [anon_sym_return] = ACTIONS(922),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_synchronized] = ACTIONS(922),
    [anon_sym_throw] = ACTIONS(922),
    [anon_sym_try] = ACTIONS(922),
    [anon_sym_if] = ACTIONS(922),
    [anon_sym_else] = ACTIONS(922),
    [anon_sym_for] = ACTIONS(922),
    [anon_sym_AT] = ACTIONS(922),
    [anon_sym_open] = ACTIONS(922),
    [anon_sym_module] = ACTIONS(922),
    [anon_sym_static] = ACTIONS(922),
    [anon_sym_package] = ACTIONS(922),
    [anon_sym_import] = ACTIONS(922),
    [anon_sym_enum] = ACTIONS(922),
    [anon_sym_public] = ACTIONS(922),
    [anon_sym_protected] = ACTIONS(922),
    [anon_sym_private] = ACTIONS(922),
    [anon_sym_abstract] = ACTIONS(922),
    [anon_sym_strictfp] = ACTIONS(922),
    [anon_sym_native] = ACTIONS(922),
    [anon_sym_transient] = ACTIONS(922),
    [anon_sym_volatile] = ACTIONS(922),
    [anon_sym_sealed] = ACTIONS(922),
    [anon_sym_non_DASHsealed] = ACTIONS(920),
    [anon_sym_record] = ACTIONS(922),
    [anon_sym_ATinterface] = ACTIONS(920),
    [anon_sym_interface] = ACTIONS(922),
    [anon_sym_byte] = ACTIONS(922),
    [anon_sym_short] = ACTIONS(922),
    [anon_sym_int] = ACTIONS(922),
    [anon_sym_long] = ACTIONS(922),
    [anon_sym_char] = ACTIONS(922),
    [anon_sym_float] = ACTIONS(922),
    [anon_sym_double] = ACTIONS(922),
    [sym_boolean_type] = ACTIONS(922),
    [sym_void_type] = ACTIONS(922),
    [sym_this] = ACTIONS(922),
    [sym_super] = ACTIONS(922),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [250] = {
    [ts_builtin_sym_end] = ACTIONS(924),
    [sym_identifier] = ACTIONS(926),
    [sym_decimal_integer_literal] = ACTIONS(926),
    [sym_hex_integer_literal] = ACTIONS(926),
    [sym_octal_integer_literal] = ACTIONS(924),
    [sym_binary_integer_literal] = ACTIONS(924),
    [sym_decimal_floating_point_literal] = ACTIONS(924),
    [sym_hex_floating_point_literal] = ACTIONS(926),
    [sym_true] = ACTIONS(926),
    [sym_false] = ACTIONS(926),
    [sym_character_literal] = ACTIONS(924),
    [sym_string_literal] = ACTIONS(926),
    [sym_text_block] = ACTIONS(924),
    [sym_null_literal] = ACTIONS(926),
    [anon_sym_LPAREN] = ACTIONS(924),
    [anon_sym_PLUS] = ACTIONS(926),
    [anon_sym_DASH] = ACTIONS(926),
    [anon_sym_final] = ACTIONS(926),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(924),
    [anon_sym_DASH_DASH] = ACTIONS(924),
    [anon_sym_new] = ACTIONS(926),
    [anon_sym_class] = ACTIONS(926),
    [anon_sym_switch] = ACTIONS(926),
    [anon_sym_LBRACE] = ACTIONS(924),
    [anon_sym_RBRACE] = ACTIONS(924),
    [anon_sym_case] = ACTIONS(926),
    [anon_sym_default] = ACTIONS(926),
    [anon_sym_SEMI] = ACTIONS(924),
    [anon_sym_assert] = ACTIONS(926),
    [anon_sym_do] = ACTIONS(926),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_break] = ACTIONS(926),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_return] = ACTIONS(926),
    [anon_sym_yield] = ACTIONS(926),
    [anon_sym_synchronized] = ACTIONS(926),
    [anon_sym_throw] = ACTIONS(926),
    [anon_sym_try] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(926),
    [anon_sym_else] = ACTIONS(926),
    [anon_sym_for] = ACTIONS(926),
    [anon_sym_AT] = ACTIONS(926),
    [anon_sym_open] = ACTIONS(926),
    [anon_sym_module] = ACTIONS(926),
    [anon_sym_static] = ACTIONS(926),
    [anon_sym_package] = ACTIONS(926),
    [anon_sym_import] = ACTIONS(926),
    [anon_sym_enum] = ACTIONS(926),
    [anon_sym_public] = ACTIONS(926),
    [anon_sym_protected] = ACTIONS(926),
    [anon_sym_private] = ACTIONS(926),
    [anon_sym_abstract] = ACTIONS(926),
    [anon_sym_strictfp] = ACTIONS(926),
    [anon_sym_native] = ACTIONS(926),
    [anon_sym_transient] = ACTIONS(926),
    [anon_sym_volatile] = ACTIONS(926),
    [anon_sym_sealed] = ACTIONS(926),
    [anon_sym_non_DASHsealed] = ACTIONS(924),
    [anon_sym_record] = ACTIONS(926),
    [anon_sym_ATinterface] = ACTIONS(924),
    [anon_sym_interface] = ACTIONS(926),
    [anon_sym_byte] = ACTIONS(926),
    [anon_sym_short] = ACTIONS(926),
    [anon_sym_int] = ACTIONS(926),
    [anon_sym_long] = ACTIONS(926),
    [anon_sym_char] = ACTIONS(926),
    [anon_sym_float] = ACTIONS(926),
    [anon_sym_double] = ACTIONS(926),
    [sym_boolean_type] = ACTIONS(926),
    [sym_void_type] = ACTIONS(926),
    [sym_this] = ACTIONS(926),
    [sym_super] = ACTIONS(926),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [251] = {
    [ts_builtin_sym_end] = ACTIONS(928),
    [sym_identifier] = ACTIONS(930),
    [sym_decimal_integer_literal] = ACTIONS(930),
    [sym_hex_integer_literal] = ACTIONS(930),
    [sym_octal_integer_literal] = ACTIONS(928),
    [sym_binary_integer_literal] = ACTIONS(928),
    [sym_decimal_floating_point_literal] = ACTIONS(928),
    [sym_hex_floating_point_literal] = ACTIONS(930),
    [sym_true] = ACTIONS(930),
    [sym_false] = ACTIONS(930),
    [sym_character_literal] = ACTIONS(928),
    [sym_string_literal] = ACTIONS(930),
    [sym_text_block] = ACTIONS(928),
    [sym_null_literal] = ACTIONS(930),
    [anon_sym_LPAREN] = ACTIONS(928),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_final] = ACTIONS(930),
    [anon_sym_BANG] = ACTIONS(928),
    [anon_sym_TILDE] = ACTIONS(928),
    [anon_sym_PLUS_PLUS] = ACTIONS(928),
    [anon_sym_DASH_DASH] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(930),
    [anon_sym_class] = ACTIONS(930),
    [anon_sym_switch] = ACTIONS(930),
    [anon_sym_LBRACE] = ACTIONS(928),
    [anon_sym_RBRACE] = ACTIONS(928),
    [anon_sym_case] = ACTIONS(930),
    [anon_sym_default] = ACTIONS(930),
    [anon_sym_SEMI] = ACTIONS(928),
    [anon_sym_assert] = ACTIONS(930),
    [anon_sym_do] = ACTIONS(930),
    [anon_sym_while] = ACTIONS(930),
    [anon_sym_break] = ACTIONS(930),
    [anon_sym_continue] = ACTIONS(930),
    [anon_sym_return] = ACTIONS(930),
    [anon_sym_yield] = ACTIONS(930),
    [anon_sym_synchronized] = ACTIONS(930),
    [anon_sym_throw] = ACTIONS(930),
    [anon_sym_try] = ACTIONS(930),
    [anon_sym_if] = ACTIONS(930),
    [anon_sym_else] = ACTIONS(930),
    [anon_sym_for] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(930),
    [anon_sym_open] = ACTIONS(930),
    [anon_sym_module] = ACTIONS(930),
    [anon_sym_static] = ACTIONS(930),
    [anon_sym_package] = ACTIONS(930),
    [anon_sym_import] = ACTIONS(930),
    [anon_sym_enum] = ACTIONS(930),
    [anon_sym_public] = ACTIONS(930),
    [anon_sym_protected] = ACTIONS(930),
    [anon_sym_private] = ACTIONS(930),
    [anon_sym_abstract] = ACTIONS(930),
    [anon_sym_strictfp] = ACTIONS(930),
    [anon_sym_native] = ACTIONS(930),
    [anon_sym_transient] = ACTIONS(930),
    [anon_sym_volatile] = ACTIONS(930),
    [anon_sym_sealed] = ACTIONS(930),
    [anon_sym_non_DASHsealed] = ACTIONS(928),
    [anon_sym_record] = ACTIONS(930),
    [anon_sym_ATinterface] = ACTIONS(928),
    [anon_sym_interface] = ACTIONS(930),
    [anon_sym_byte] = ACTIONS(930),
    [anon_sym_short] = ACTIONS(930),
    [anon_sym_int] = ACTIONS(930),
    [anon_sym_long] = ACTIONS(930),
    [anon_sym_char] = ACTIONS(930),
    [anon_sym_float] = ACTIONS(930),
    [anon_sym_double] = ACTIONS(930),
    [sym_boolean_type] = ACTIONS(930),
    [sym_void_type] = ACTIONS(930),
    [sym_this] = ACTIONS(930),
    [sym_super] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [252] = {
    [ts_builtin_sym_end] = ACTIONS(932),
    [sym_identifier] = ACTIONS(934),
    [sym_decimal_integer_literal] = ACTIONS(934),
    [sym_hex_integer_literal] = ACTIONS(934),
    [sym_octal_integer_literal] = ACTIONS(932),
    [sym_binary_integer_literal] = ACTIONS(932),
    [sym_decimal_floating_point_literal] = ACTIONS(932),
    [sym_hex_floating_point_literal] = ACTIONS(934),
    [sym_true] = ACTIONS(934),
    [sym_false] = ACTIONS(934),
    [sym_character_literal] = ACTIONS(932),
    [sym_string_literal] = ACTIONS(934),
    [sym_text_block] = ACTIONS(932),
    [sym_null_literal] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(932),
    [anon_sym_PLUS] = ACTIONS(934),
    [anon_sym_DASH] = ACTIONS(934),
    [anon_sym_final] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(932),
    [anon_sym_new] = ACTIONS(934),
    [anon_sym_class] = ACTIONS(934),
    [anon_sym_switch] = ACTIONS(934),
    [anon_sym_LBRACE] = ACTIONS(932),
    [anon_sym_RBRACE] = ACTIONS(932),
    [anon_sym_case] = ACTIONS(934),
    [anon_sym_default] = ACTIONS(934),
    [anon_sym_SEMI] = ACTIONS(932),
    [anon_sym_assert] = ACTIONS(934),
    [anon_sym_do] = ACTIONS(934),
    [anon_sym_while] = ACTIONS(934),
    [anon_sym_break] = ACTIONS(934),
    [anon_sym_continue] = ACTIONS(934),
    [anon_sym_return] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(934),
    [anon_sym_synchronized] = ACTIONS(934),
    [anon_sym_throw] = ACTIONS(934),
    [anon_sym_try] = ACTIONS(934),
    [anon_sym_if] = ACTIONS(934),
    [anon_sym_else] = ACTIONS(934),
    [anon_sym_for] = ACTIONS(934),
    [anon_sym_AT] = ACTIONS(934),
    [anon_sym_open] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_package] = ACTIONS(934),
    [anon_sym_import] = ACTIONS(934),
    [anon_sym_enum] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_abstract] = ACTIONS(934),
    [anon_sym_strictfp] = ACTIONS(934),
    [anon_sym_native] = ACTIONS(934),
    [anon_sym_transient] = ACTIONS(934),
    [anon_sym_volatile] = ACTIONS(934),
    [anon_sym_sealed] = ACTIONS(934),
    [anon_sym_non_DASHsealed] = ACTIONS(932),
    [anon_sym_record] = ACTIONS(934),
    [anon_sym_ATinterface] = ACTIONS(932),
    [anon_sym_interface] = ACTIONS(934),
    [anon_sym_byte] = ACTIONS(934),
    [anon_sym_short] = ACTIONS(934),
    [anon_sym_int] = ACTIONS(934),
    [anon_sym_long] = ACTIONS(934),
    [anon_sym_char] = ACTIONS(934),
    [anon_sym_float] = ACTIONS(934),
    [anon_sym_double] = ACTIONS(934),
    [sym_boolean_type] = ACTIONS(934),
    [sym_void_type] = ACTIONS(934),
    [sym_this] = ACTIONS(934),
    [sym_super] = ACTIONS(934),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [253] = {
    [ts_builtin_sym_end] = ACTIONS(936),
    [sym_identifier] = ACTIONS(938),
    [sym_decimal_integer_literal] = ACTIONS(938),
    [sym_hex_integer_literal] = ACTIONS(938),
    [sym_octal_integer_literal] = ACTIONS(936),
    [sym_binary_integer_literal] = ACTIONS(936),
    [sym_decimal_floating_point_literal] = ACTIONS(936),
    [sym_hex_floating_point_literal] = ACTIONS(938),
    [sym_true] = ACTIONS(938),
    [sym_false] = ACTIONS(938),
    [sym_character_literal] = ACTIONS(936),
    [sym_string_literal] = ACTIONS(938),
    [sym_text_block] = ACTIONS(936),
    [sym_null_literal] = ACTIONS(938),
    [anon_sym_LPAREN] = ACTIONS(936),
    [anon_sym_PLUS] = ACTIONS(938),
    [anon_sym_DASH] = ACTIONS(938),
    [anon_sym_final] = ACTIONS(938),
    [anon_sym_BANG] = ACTIONS(936),
    [anon_sym_TILDE] = ACTIONS(936),
    [anon_sym_PLUS_PLUS] = ACTIONS(936),
    [anon_sym_DASH_DASH] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(938),
    [anon_sym_class] = ACTIONS(938),
    [anon_sym_switch] = ACTIONS(938),
    [anon_sym_LBRACE] = ACTIONS(936),
    [anon_sym_RBRACE] = ACTIONS(936),
    [anon_sym_case] = ACTIONS(938),
    [anon_sym_default] = ACTIONS(938),
    [anon_sym_SEMI] = ACTIONS(936),
    [anon_sym_assert] = ACTIONS(938),
    [anon_sym_do] = ACTIONS(938),
    [anon_sym_while] = ACTIONS(938),
    [anon_sym_break] = ACTIONS(938),
    [anon_sym_continue] = ACTIONS(938),
    [anon_sym_return] = ACTIONS(938),
    [anon_sym_yield] = ACTIONS(938),
    [anon_sym_synchronized] = ACTIONS(938),
    [anon_sym_throw] = ACTIONS(938),
    [anon_sym_try] = ACTIONS(938),
    [anon_sym_if] = ACTIONS(938),
    [anon_sym_else] = ACTIONS(938),
    [anon_sym_for] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(938),
    [anon_sym_open] = ACTIONS(938),
    [anon_sym_module] = ACTIONS(938),
    [anon_sym_static] = ACTIONS(938),
    [anon_sym_package] = ACTIONS(938),
    [anon_sym_import] = ACTIONS(938),
    [anon_sym_enum] = ACTIONS(938),
    [anon_sym_public] = ACTIONS(938),
    [anon_sym_protected] = ACTIONS(938),
    [anon_sym_private] = ACTIONS(938),
    [anon_sym_abstract] = ACTIONS(938),
    [anon_sym_strictfp] = ACTIONS(938),
    [anon_sym_native] = ACTIONS(938),
    [anon_sym_transient] = ACTIONS(938),
    [anon_sym_volatile] = ACTIONS(938),
    [anon_sym_sealed] = ACTIONS(938),
    [anon_sym_non_DASHsealed] = ACTIONS(936),
    [anon_sym_record] = ACTIONS(938),
    [anon_sym_ATinterface] = ACTIONS(936),
    [anon_sym_interface] = ACTIONS(938),
    [anon_sym_byte] = ACTIONS(938),
    [anon_sym_short] = ACTIONS(938),
    [anon_sym_int] = ACTIONS(938),
    [anon_sym_long] = ACTIONS(938),
    [anon_sym_char] = ACTIONS(938),
    [anon_sym_float] = ACTIONS(938),
    [anon_sym_double] = ACTIONS(938),
    [sym_boolean_type] = ACTIONS(938),
    [sym_void_type] = ACTIONS(938),
    [sym_this] = ACTIONS(938),
    [sym_super] = ACTIONS(938),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [254] = {
    [ts_builtin_sym_end] = ACTIONS(940),
    [sym_identifier] = ACTIONS(942),
    [sym_decimal_integer_literal] = ACTIONS(942),
    [sym_hex_integer_literal] = ACTIONS(942),
    [sym_octal_integer_literal] = ACTIONS(940),
    [sym_binary_integer_literal] = ACTIONS(940),
    [sym_decimal_floating_point_literal] = ACTIONS(940),
    [sym_hex_floating_point_literal] = ACTIONS(942),
    [sym_true] = ACTIONS(942),
    [sym_false] = ACTIONS(942),
    [sym_character_literal] = ACTIONS(940),
    [sym_string_literal] = ACTIONS(942),
    [sym_text_block] = ACTIONS(940),
    [sym_null_literal] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(940),
    [anon_sym_PLUS] = ACTIONS(942),
    [anon_sym_DASH] = ACTIONS(942),
    [anon_sym_final] = ACTIONS(942),
    [anon_sym_BANG] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(940),
    [anon_sym_PLUS_PLUS] = ACTIONS(940),
    [anon_sym_DASH_DASH] = ACTIONS(940),
    [anon_sym_new] = ACTIONS(942),
    [anon_sym_class] = ACTIONS(942),
    [anon_sym_switch] = ACTIONS(942),
    [anon_sym_LBRACE] = ACTIONS(940),
    [anon_sym_RBRACE] = ACTIONS(940),
    [anon_sym_case] = ACTIONS(942),
    [anon_sym_default] = ACTIONS(942),
    [anon_sym_SEMI] = ACTIONS(940),
    [anon_sym_assert] = ACTIONS(942),
    [anon_sym_do] = ACTIONS(942),
    [anon_sym_while] = ACTIONS(942),
    [anon_sym_break] = ACTIONS(942),
    [anon_sym_continue] = ACTIONS(942),
    [anon_sym_return] = ACTIONS(942),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_synchronized] = ACTIONS(942),
    [anon_sym_throw] = ACTIONS(942),
    [anon_sym_try] = ACTIONS(942),
    [anon_sym_if] = ACTIONS(942),
    [anon_sym_else] = ACTIONS(942),
    [anon_sym_for] = ACTIONS(942),
    [anon_sym_AT] = ACTIONS(942),
    [anon_sym_open] = ACTIONS(942),
    [anon_sym_module] = ACTIONS(942),
    [anon_sym_static] = ACTIONS(942),
    [anon_sym_package] = ACTIONS(942),
    [anon_sym_import] = ACTIONS(942),
    [anon_sym_enum] = ACTIONS(942),
    [anon_sym_public] = ACTIONS(942),
    [anon_sym_protected] = ACTIONS(942),
    [anon_sym_private] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(942),
    [anon_sym_strictfp] = ACTIONS(942),
    [anon_sym_native] = ACTIONS(942),
    [anon_sym_transient] = ACTIONS(942),
    [anon_sym_volatile] = ACTIONS(942),
    [anon_sym_sealed] = ACTIONS(942),
    [anon_sym_non_DASHsealed] = ACTIONS(940),
    [anon_sym_record] = ACTIONS(942),
    [anon_sym_ATinterface] = ACTIONS(940),
    [anon_sym_interface] = ACTIONS(942),
    [anon_sym_byte] = ACTIONS(942),
    [anon_sym_short] = ACTIONS(942),
    [anon_sym_int] = ACTIONS(942),
    [anon_sym_long] = ACTIONS(942),
    [anon_sym_char] = ACTIONS(942),
    [anon_sym_float] = ACTIONS(942),
    [anon_sym_double] = ACTIONS(942),
    [sym_boolean_type] = ACTIONS(942),
    [sym_void_type] = ACTIONS(942),
    [sym_this] = ACTIONS(942),
    [sym_super] = ACTIONS(942),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [255] = {
    [ts_builtin_sym_end] = ACTIONS(944),
    [sym_identifier] = ACTIONS(946),
    [sym_decimal_integer_literal] = ACTIONS(946),
    [sym_hex_integer_literal] = ACTIONS(946),
    [sym_octal_integer_literal] = ACTIONS(944),
    [sym_binary_integer_literal] = ACTIONS(944),
    [sym_decimal_floating_point_literal] = ACTIONS(944),
    [sym_hex_floating_point_literal] = ACTIONS(946),
    [sym_true] = ACTIONS(946),
    [sym_false] = ACTIONS(946),
    [sym_character_literal] = ACTIONS(944),
    [sym_string_literal] = ACTIONS(946),
    [sym_text_block] = ACTIONS(944),
    [sym_null_literal] = ACTIONS(946),
    [anon_sym_LPAREN] = ACTIONS(944),
    [anon_sym_PLUS] = ACTIONS(946),
    [anon_sym_DASH] = ACTIONS(946),
    [anon_sym_final] = ACTIONS(946),
    [anon_sym_BANG] = ACTIONS(944),
    [anon_sym_TILDE] = ACTIONS(944),
    [anon_sym_PLUS_PLUS] = ACTIONS(944),
    [anon_sym_DASH_DASH] = ACTIONS(944),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_class] = ACTIONS(946),
    [anon_sym_switch] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(944),
    [anon_sym_RBRACE] = ACTIONS(944),
    [anon_sym_case] = ACTIONS(946),
    [anon_sym_default] = ACTIONS(946),
    [anon_sym_SEMI] = ACTIONS(944),
    [anon_sym_assert] = ACTIONS(946),
    [anon_sym_do] = ACTIONS(946),
    [anon_sym_while] = ACTIONS(946),
    [anon_sym_break] = ACTIONS(946),
    [anon_sym_continue] = ACTIONS(946),
    [anon_sym_return] = ACTIONS(946),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_synchronized] = ACTIONS(946),
    [anon_sym_throw] = ACTIONS(946),
    [anon_sym_try] = ACTIONS(946),
    [anon_sym_if] = ACTIONS(946),
    [anon_sym_else] = ACTIONS(946),
    [anon_sym_for] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(946),
    [anon_sym_open] = ACTIONS(946),
    [anon_sym_module] = ACTIONS(946),
    [anon_sym_static] = ACTIONS(946),
    [anon_sym_package] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(946),
    [anon_sym_enum] = ACTIONS(946),
    [anon_sym_public] = ACTIONS(946),
    [anon_sym_protected] = ACTIONS(946),
    [anon_sym_private] = ACTIONS(946),
    [anon_sym_abstract] = ACTIONS(946),
    [anon_sym_strictfp] = ACTIONS(946),
    [anon_sym_native] = ACTIONS(946),
    [anon_sym_transient] = ACTIONS(946),
    [anon_sym_volatile] = ACTIONS(946),
    [anon_sym_sealed] = ACTIONS(946),
    [anon_sym_non_DASHsealed] = ACTIONS(944),
    [anon_sym_record] = ACTIONS(946),
    [anon_sym_ATinterface] = ACTIONS(944),
    [anon_sym_interface] = ACTIONS(946),
    [anon_sym_byte] = ACTIONS(946),
    [anon_sym_short] = ACTIONS(946),
    [anon_sym_int] = ACTIONS(946),
    [anon_sym_long] = ACTIONS(946),
    [anon_sym_char] = ACTIONS(946),
    [anon_sym_float] = ACTIONS(946),
    [anon_sym_double] = ACTIONS(946),
    [sym_boolean_type] = ACTIONS(946),
    [sym_void_type] = ACTIONS(946),
    [sym_this] = ACTIONS(946),
    [sym_super] = ACTIONS(946),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [256] = {
    [ts_builtin_sym_end] = ACTIONS(948),
    [sym_identifier] = ACTIONS(950),
    [sym_decimal_integer_literal] = ACTIONS(950),
    [sym_hex_integer_literal] = ACTIONS(950),
    [sym_octal_integer_literal] = ACTIONS(948),
    [sym_binary_integer_literal] = ACTIONS(948),
    [sym_decimal_floating_point_literal] = ACTIONS(948),
    [sym_hex_floating_point_literal] = ACTIONS(950),
    [sym_true] = ACTIONS(950),
    [sym_false] = ACTIONS(950),
    [sym_character_literal] = ACTIONS(948),
    [sym_string_literal] = ACTIONS(950),
    [sym_text_block] = ACTIONS(948),
    [sym_null_literal] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(950),
    [anon_sym_DASH] = ACTIONS(950),
    [anon_sym_final] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(948),
    [anon_sym_TILDE] = ACTIONS(948),
    [anon_sym_PLUS_PLUS] = ACTIONS(948),
    [anon_sym_DASH_DASH] = ACTIONS(948),
    [anon_sym_new] = ACTIONS(950),
    [anon_sym_class] = ACTIONS(950),
    [anon_sym_switch] = ACTIONS(950),
    [anon_sym_LBRACE] = ACTIONS(948),
    [anon_sym_RBRACE] = ACTIONS(948),
    [anon_sym_case] = ACTIONS(950),
    [anon_sym_default] = ACTIONS(950),
    [anon_sym_SEMI] = ACTIONS(948),
    [anon_sym_assert] = ACTIONS(950),
    [anon_sym_do] = ACTIONS(950),
    [anon_sym_while] = ACTIONS(950),
    [anon_sym_break] = ACTIONS(950),
    [anon_sym_continue] = ACTIONS(950),
    [anon_sym_return] = ACTIONS(950),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_synchronized] = ACTIONS(950),
    [anon_sym_throw] = ACTIONS(950),
    [anon_sym_try] = ACTIONS(950),
    [anon_sym_if] = ACTIONS(950),
    [anon_sym_else] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(950),
    [anon_sym_AT] = ACTIONS(950),
    [anon_sym_open] = ACTIONS(950),
    [anon_sym_module] = ACTIONS(950),
    [anon_sym_static] = ACTIONS(950),
    [anon_sym_package] = ACTIONS(950),
    [anon_sym_import] = ACTIONS(950),
    [anon_sym_enum] = ACTIONS(950),
    [anon_sym_public] = ACTIONS(950),
    [anon_sym_protected] = ACTIONS(950),
    [anon_sym_private] = ACTIONS(950),
    [anon_sym_abstract] = ACTIONS(950),
    [anon_sym_strictfp] = ACTIONS(950),
    [anon_sym_native] = ACTIONS(950),
    [anon_sym_transient] = ACTIONS(950),
    [anon_sym_volatile] = ACTIONS(950),
    [anon_sym_sealed] = ACTIONS(950),
    [anon_sym_non_DASHsealed] = ACTIONS(948),
    [anon_sym_record] = ACTIONS(950),
    [anon_sym_ATinterface] = ACTIONS(948),
    [anon_sym_interface] = ACTIONS(950),
    [anon_sym_byte] = ACTIONS(950),
    [anon_sym_short] = ACTIONS(950),
    [anon_sym_int] = ACTIONS(950),
    [anon_sym_long] = ACTIONS(950),
    [anon_sym_char] = ACTIONS(950),
    [anon_sym_float] = ACTIONS(950),
    [anon_sym_double] = ACTIONS(950),
    [sym_boolean_type] = ACTIONS(950),
    [sym_void_type] = ACTIONS(950),
    [sym_this] = ACTIONS(950),
    [sym_super] = ACTIONS(950),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [257] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(596),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym_array_initializer] = STATE(1021),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(362),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [258] = {
    [ts_builtin_sym_end] = ACTIONS(952),
    [sym_identifier] = ACTIONS(954),
    [sym_decimal_integer_literal] = ACTIONS(954),
    [sym_hex_integer_literal] = ACTIONS(954),
    [sym_octal_integer_literal] = ACTIONS(952),
    [sym_binary_integer_literal] = ACTIONS(952),
    [sym_decimal_floating_point_literal] = ACTIONS(952),
    [sym_hex_floating_point_literal] = ACTIONS(954),
    [sym_true] = ACTIONS(954),
    [sym_false] = ACTIONS(954),
    [sym_character_literal] = ACTIONS(952),
    [sym_string_literal] = ACTIONS(954),
    [sym_text_block] = ACTIONS(952),
    [sym_null_literal] = ACTIONS(954),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_PLUS] = ACTIONS(954),
    [anon_sym_DASH] = ACTIONS(954),
    [anon_sym_final] = ACTIONS(954),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(952),
    [anon_sym_PLUS_PLUS] = ACTIONS(952),
    [anon_sym_DASH_DASH] = ACTIONS(952),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_class] = ACTIONS(954),
    [anon_sym_switch] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(952),
    [anon_sym_RBRACE] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(954),
    [anon_sym_default] = ACTIONS(954),
    [anon_sym_SEMI] = ACTIONS(952),
    [anon_sym_assert] = ACTIONS(954),
    [anon_sym_do] = ACTIONS(954),
    [anon_sym_while] = ACTIONS(954),
    [anon_sym_break] = ACTIONS(954),
    [anon_sym_continue] = ACTIONS(954),
    [anon_sym_return] = ACTIONS(954),
    [anon_sym_yield] = ACTIONS(954),
    [anon_sym_synchronized] = ACTIONS(954),
    [anon_sym_throw] = ACTIONS(954),
    [anon_sym_try] = ACTIONS(954),
    [anon_sym_if] = ACTIONS(954),
    [anon_sym_else] = ACTIONS(954),
    [anon_sym_for] = ACTIONS(954),
    [anon_sym_AT] = ACTIONS(954),
    [anon_sym_open] = ACTIONS(954),
    [anon_sym_module] = ACTIONS(954),
    [anon_sym_static] = ACTIONS(954),
    [anon_sym_package] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(954),
    [anon_sym_enum] = ACTIONS(954),
    [anon_sym_public] = ACTIONS(954),
    [anon_sym_protected] = ACTIONS(954),
    [anon_sym_private] = ACTIONS(954),
    [anon_sym_abstract] = ACTIONS(954),
    [anon_sym_strictfp] = ACTIONS(954),
    [anon_sym_native] = ACTIONS(954),
    [anon_sym_transient] = ACTIONS(954),
    [anon_sym_volatile] = ACTIONS(954),
    [anon_sym_sealed] = ACTIONS(954),
    [anon_sym_non_DASHsealed] = ACTIONS(952),
    [anon_sym_record] = ACTIONS(954),
    [anon_sym_ATinterface] = ACTIONS(952),
    [anon_sym_interface] = ACTIONS(954),
    [anon_sym_byte] = ACTIONS(954),
    [anon_sym_short] = ACTIONS(954),
    [anon_sym_int] = ACTIONS(954),
    [anon_sym_long] = ACTIONS(954),
    [anon_sym_char] = ACTIONS(954),
    [anon_sym_float] = ACTIONS(954),
    [anon_sym_double] = ACTIONS(954),
    [sym_boolean_type] = ACTIONS(954),
    [sym_void_type] = ACTIONS(954),
    [sym_this] = ACTIONS(954),
    [sym_super] = ACTIONS(954),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [259] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(612),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_RBRACK] = ACTIONS(956),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [260] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(575),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(958),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [261] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(593),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(960),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [262] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(638),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(962),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [263] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(578),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(964),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [264] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(634),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(966),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [265] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(567),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(968),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [266] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(583),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(970),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [267] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(571),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(972),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [268] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(548),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(974),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [269] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(597),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(976),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [270] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(633),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(978),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [271] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(619),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_RBRACK] = ACTIONS(980),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [272] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(574),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(982),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [273] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(618),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(984),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [274] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(572),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(986),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [275] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(619),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_RBRACK] = ACTIONS(988),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [276] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(632),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(990),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [277] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(635),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(992),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [278] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(582),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [279] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(611),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(996),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [280] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(628),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(998),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [281] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(562),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(1000),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [282] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(612),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_RBRACK] = ACTIONS(1002),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [283] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(615),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1004),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [284] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(569),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(1006),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [285] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(550),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(1008),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [286] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(590),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(1010),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [287] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(551),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(1012),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [288] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(585),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(1014),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [289] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(570),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1234),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(393),
    [sym_array_access] = STATE(393),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1234),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(740),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(750),
    [anon_sym_module] = ACTIONS(750),
    [anon_sym_record] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [290] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(508),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [291] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(612),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [292] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(610),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [293] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(555),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1234),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(393),
    [sym_array_access] = STATE(393),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1234),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(740),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(750),
    [anon_sym_module] = ACTIONS(750),
    [anon_sym_record] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [294] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(503),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [295] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(624),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [296] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(617),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [297] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(501),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [298] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(613),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [299] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(607),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [300] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(502),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [301] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(600),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [302] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(631),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [303] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(622),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [304] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(573),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1234),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(393),
    [sym_array_access] = STATE(393),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1234),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(740),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(750),
    [anon_sym_module] = ACTIONS(750),
    [anon_sym_record] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [305] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(523),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [306] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(568),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1234),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(393),
    [sym_array_access] = STATE(393),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1234),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(740),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(750),
    [anon_sym_module] = ACTIONS(750),
    [anon_sym_record] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [307] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(533),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [308] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(561),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1234),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(393),
    [sym_array_access] = STATE(393),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1234),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(740),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(750),
    [anon_sym_module] = ACTIONS(750),
    [anon_sym_record] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [309] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(619),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [310] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(566),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1234),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(393),
    [sym_array_access] = STATE(393),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1234),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(740),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(750),
    [anon_sym_module] = ACTIONS(750),
    [anon_sym_record] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [311] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(584),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1234),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(393),
    [sym_array_access] = STATE(393),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1234),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(740),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(750),
    [anon_sym_module] = ACTIONS(750),
    [anon_sym_record] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [312] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(637),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [313] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(565),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1234),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(393),
    [sym_array_access] = STATE(393),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1234),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(740),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(750),
    [anon_sym_module] = ACTIONS(750),
    [anon_sym_record] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [314] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(506),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1234),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(393),
    [sym_array_access] = STATE(393),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1234),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(740),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(750),
    [anon_sym_module] = ACTIONS(750),
    [anon_sym_record] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [315] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(621),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [316] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(589),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1234),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(393),
    [sym_array_access] = STATE(393),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1234),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(740),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(750),
    [anon_sym_module] = ACTIONS(750),
    [anon_sym_record] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [317] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(564),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1234),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(393),
    [sym_array_access] = STATE(393),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1234),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(740),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(750),
    [anon_sym_module] = ACTIONS(750),
    [anon_sym_record] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [318] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(620),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [319] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(563),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1234),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(393),
    [sym_array_access] = STATE(393),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1234),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(740),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(750),
    [anon_sym_module] = ACTIONS(750),
    [anon_sym_record] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [320] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(536),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [321] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(601),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [322] = {
    [sym_identifier] = ACTIONS(860),
    [sym_decimal_integer_literal] = ACTIONS(860),
    [sym_hex_integer_literal] = ACTIONS(860),
    [sym_octal_integer_literal] = ACTIONS(862),
    [sym_binary_integer_literal] = ACTIONS(862),
    [sym_decimal_floating_point_literal] = ACTIONS(862),
    [sym_hex_floating_point_literal] = ACTIONS(860),
    [sym_true] = ACTIONS(860),
    [sym_false] = ACTIONS(860),
    [sym_character_literal] = ACTIONS(862),
    [sym_string_literal] = ACTIONS(860),
    [sym_text_block] = ACTIONS(862),
    [sym_null_literal] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(862),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_final] = ACTIONS(860),
    [anon_sym_BANG] = ACTIONS(862),
    [anon_sym_TILDE] = ACTIONS(862),
    [anon_sym_PLUS_PLUS] = ACTIONS(862),
    [anon_sym_DASH_DASH] = ACTIONS(862),
    [anon_sym_new] = ACTIONS(860),
    [anon_sym_class] = ACTIONS(860),
    [anon_sym_switch] = ACTIONS(860),
    [anon_sym_LBRACE] = ACTIONS(862),
    [anon_sym_RBRACE] = ACTIONS(862),
    [anon_sym_case] = ACTIONS(860),
    [anon_sym_default] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(862),
    [anon_sym_assert] = ACTIONS(860),
    [anon_sym_do] = ACTIONS(860),
    [anon_sym_while] = ACTIONS(860),
    [anon_sym_break] = ACTIONS(860),
    [anon_sym_continue] = ACTIONS(860),
    [anon_sym_return] = ACTIONS(860),
    [anon_sym_yield] = ACTIONS(860),
    [anon_sym_synchronized] = ACTIONS(860),
    [anon_sym_throw] = ACTIONS(860),
    [anon_sym_try] = ACTIONS(860),
    [anon_sym_if] = ACTIONS(860),
    [anon_sym_for] = ACTIONS(860),
    [anon_sym_AT] = ACTIONS(860),
    [anon_sym_open] = ACTIONS(860),
    [anon_sym_module] = ACTIONS(860),
    [anon_sym_static] = ACTIONS(860),
    [anon_sym_package] = ACTIONS(860),
    [anon_sym_import] = ACTIONS(860),
    [anon_sym_enum] = ACTIONS(860),
    [anon_sym_public] = ACTIONS(860),
    [anon_sym_protected] = ACTIONS(860),
    [anon_sym_private] = ACTIONS(860),
    [anon_sym_abstract] = ACTIONS(860),
    [anon_sym_strictfp] = ACTIONS(860),
    [anon_sym_native] = ACTIONS(860),
    [anon_sym_transient] = ACTIONS(860),
    [anon_sym_volatile] = ACTIONS(860),
    [anon_sym_sealed] = ACTIONS(860),
    [anon_sym_non_DASHsealed] = ACTIONS(862),
    [anon_sym_record] = ACTIONS(860),
    [anon_sym_ATinterface] = ACTIONS(862),
    [anon_sym_interface] = ACTIONS(860),
    [anon_sym_byte] = ACTIONS(860),
    [anon_sym_short] = ACTIONS(860),
    [anon_sym_int] = ACTIONS(860),
    [anon_sym_long] = ACTIONS(860),
    [anon_sym_char] = ACTIONS(860),
    [anon_sym_float] = ACTIONS(860),
    [anon_sym_double] = ACTIONS(860),
    [sym_boolean_type] = ACTIONS(860),
    [sym_void_type] = ACTIONS(860),
    [sym_this] = ACTIONS(860),
    [sym_super] = ACTIONS(860),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [323] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(547),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [324] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(502),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1234),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(393),
    [sym_array_access] = STATE(393),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1234),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(740),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(750),
    [anon_sym_module] = ACTIONS(750),
    [anon_sym_record] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [325] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(534),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [326] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(529),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [327] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(636),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [328] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(506),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [329] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(603),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [330] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(559),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [331] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(524),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [332] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(501),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1234),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(393),
    [sym_array_access] = STATE(393),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1234),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(740),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(750),
    [anon_sym_module] = ACTIONS(750),
    [anon_sym_record] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [333] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(535),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [334] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(521),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [335] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(537),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [336] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(576),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1234),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(393),
    [sym_array_access] = STATE(393),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1234),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(740),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(750),
    [anon_sym_module] = ACTIONS(750),
    [anon_sym_record] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [337] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(531),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [338] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(545),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1234),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(393),
    [sym_array_access] = STATE(393),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1234),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(740),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(750),
    [anon_sym_module] = ACTIONS(750),
    [anon_sym_record] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [339] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(508),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1234),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(393),
    [sym_array_access] = STATE(393),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1234),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(740),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(750),
    [anon_sym_module] = ACTIONS(750),
    [anon_sym_record] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [340] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(609),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [341] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(503),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1234),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(393),
    [sym_array_access] = STATE(393),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1234),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(740),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(750),
    [anon_sym_module] = ACTIONS(750),
    [anon_sym_record] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [342] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [343] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(532),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [344] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(556),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1234),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(393),
    [sym_array_access] = STATE(393),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1234),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(740),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(750),
    [anon_sym_module] = ACTIONS(750),
    [anon_sym_record] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [345] = {
    [sym__literal] = STATE(461),
    [sym_expression] = STATE(623),
    [sym_cast_expression] = STATE(510),
    [sym_assignment_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_instanceof_expression] = STATE(510),
    [sym_lambda_expression] = STATE(510),
    [sym_inferred_parameters] = STATE(1206),
    [sym_ternary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_primary_expression] = STATE(482),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(381),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_switch_expression] = STATE(510),
    [sym__annotation] = STATE(661),
    [sym_marker_annotation] = STATE(661),
    [sym_annotation] = STATE(661),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(761),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [sym_formal_parameters] = STATE(1206),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [sym_identifier] = ACTIONS(307),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(21),
    [anon_sym_DASH_DASH] = ACTIONS(21),
    [anon_sym_new] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(344),
    [anon_sym_open] = ACTIONS(311),
    [anon_sym_module] = ACTIONS(311),
    [anon_sym_record] = ACTIONS(311),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [346] = {
    [sym__literal] = STATE(461),
    [sym_primary_expression] = STATE(992),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(875),
    [sym_array_access] = STATE(461),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_resource] = STATE(1172),
    [sym__annotation] = STATE(606),
    [sym_marker_annotation] = STATE(606),
    [sym_annotation] = STATE(606),
    [sym_modifiers] = STATE(701),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(706),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [aux_sym_modifiers_repeat1] = STATE(538),
    [sym_identifier] = ACTIONS(1016),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1020),
    [anon_sym_final] = ACTIONS(299),
    [anon_sym_new] = ACTIONS(1022),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_synchronized] = ACTIONS(299),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_open] = ACTIONS(1024),
    [anon_sym_module] = ACTIONS(1024),
    [anon_sym_static] = ACTIONS(299),
    [anon_sym_public] = ACTIONS(299),
    [anon_sym_protected] = ACTIONS(299),
    [anon_sym_private] = ACTIONS(299),
    [anon_sym_abstract] = ACTIONS(299),
    [anon_sym_strictfp] = ACTIONS(299),
    [anon_sym_native] = ACTIONS(299),
    [anon_sym_transient] = ACTIONS(299),
    [anon_sym_volatile] = ACTIONS(299),
    [anon_sym_sealed] = ACTIONS(299),
    [anon_sym_non_DASHsealed] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(1024),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [347] = {
    [sym_identifier] = ACTIONS(1026),
    [sym_decimal_integer_literal] = ACTIONS(1026),
    [sym_hex_integer_literal] = ACTIONS(1026),
    [sym_octal_integer_literal] = ACTIONS(1028),
    [sym_binary_integer_literal] = ACTIONS(1028),
    [sym_decimal_floating_point_literal] = ACTIONS(1028),
    [sym_hex_floating_point_literal] = ACTIONS(1026),
    [sym_true] = ACTIONS(1026),
    [sym_false] = ACTIONS(1026),
    [sym_character_literal] = ACTIONS(1028),
    [sym_string_literal] = ACTIONS(1026),
    [sym_text_block] = ACTIONS(1028),
    [sym_null_literal] = ACTIONS(1026),
    [anon_sym_LPAREN] = ACTIONS(1028),
    [anon_sym_PLUS] = ACTIONS(1026),
    [anon_sym_DASH] = ACTIONS(1026),
    [anon_sym_final] = ACTIONS(1026),
    [anon_sym_BANG] = ACTIONS(1028),
    [anon_sym_TILDE] = ACTIONS(1028),
    [anon_sym_PLUS_PLUS] = ACTIONS(1028),
    [anon_sym_DASH_DASH] = ACTIONS(1028),
    [anon_sym_new] = ACTIONS(1026),
    [anon_sym_class] = ACTIONS(1026),
    [anon_sym_switch] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_RBRACE] = ACTIONS(1028),
    [anon_sym_default] = ACTIONS(1026),
    [anon_sym_SEMI] = ACTIONS(1028),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1026),
    [anon_sym_while] = ACTIONS(1026),
    [anon_sym_break] = ACTIONS(1026),
    [anon_sym_continue] = ACTIONS(1026),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_synchronized] = ACTIONS(1026),
    [anon_sym_throw] = ACTIONS(1026),
    [anon_sym_try] = ACTIONS(1026),
    [anon_sym_if] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1026),
    [anon_sym_AT] = ACTIONS(1026),
    [anon_sym_open] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_package] = ACTIONS(1026),
    [anon_sym_import] = ACTIONS(1026),
    [anon_sym_enum] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_abstract] = ACTIONS(1026),
    [anon_sym_strictfp] = ACTIONS(1026),
    [anon_sym_native] = ACTIONS(1026),
    [anon_sym_transient] = ACTIONS(1026),
    [anon_sym_volatile] = ACTIONS(1026),
    [anon_sym_sealed] = ACTIONS(1026),
    [anon_sym_non_DASHsealed] = ACTIONS(1028),
    [anon_sym_record] = ACTIONS(1026),
    [anon_sym_ATinterface] = ACTIONS(1028),
    [anon_sym_interface] = ACTIONS(1026),
    [anon_sym_byte] = ACTIONS(1026),
    [anon_sym_short] = ACTIONS(1026),
    [anon_sym_int] = ACTIONS(1026),
    [anon_sym_long] = ACTIONS(1026),
    [anon_sym_char] = ACTIONS(1026),
    [anon_sym_float] = ACTIONS(1026),
    [anon_sym_double] = ACTIONS(1026),
    [sym_boolean_type] = ACTIONS(1026),
    [sym_void_type] = ACTIONS(1026),
    [sym_this] = ACTIONS(1026),
    [sym_super] = ACTIONS(1026),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [348] = {
    [sym__literal] = STATE(461),
    [sym_primary_expression] = STATE(992),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(875),
    [sym_array_access] = STATE(461),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_resource] = STATE(1172),
    [sym__annotation] = STATE(606),
    [sym_marker_annotation] = STATE(606),
    [sym_annotation] = STATE(606),
    [sym_modifiers] = STATE(701),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(706),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [aux_sym_modifiers_repeat1] = STATE(538),
    [sym_identifier] = ACTIONS(1016),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1030),
    [anon_sym_final] = ACTIONS(299),
    [anon_sym_new] = ACTIONS(1022),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_synchronized] = ACTIONS(299),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_open] = ACTIONS(1024),
    [anon_sym_module] = ACTIONS(1024),
    [anon_sym_static] = ACTIONS(299),
    [anon_sym_public] = ACTIONS(299),
    [anon_sym_protected] = ACTIONS(299),
    [anon_sym_private] = ACTIONS(299),
    [anon_sym_abstract] = ACTIONS(299),
    [anon_sym_strictfp] = ACTIONS(299),
    [anon_sym_native] = ACTIONS(299),
    [anon_sym_transient] = ACTIONS(299),
    [anon_sym_volatile] = ACTIONS(299),
    [anon_sym_sealed] = ACTIONS(299),
    [anon_sym_non_DASHsealed] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(1024),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [349] = {
    [sym_identifier] = ACTIONS(1032),
    [sym_decimal_integer_literal] = ACTIONS(1032),
    [sym_hex_integer_literal] = ACTIONS(1032),
    [sym_octal_integer_literal] = ACTIONS(1034),
    [sym_binary_integer_literal] = ACTIONS(1034),
    [sym_decimal_floating_point_literal] = ACTIONS(1034),
    [sym_hex_floating_point_literal] = ACTIONS(1032),
    [sym_true] = ACTIONS(1032),
    [sym_false] = ACTIONS(1032),
    [sym_character_literal] = ACTIONS(1034),
    [sym_string_literal] = ACTIONS(1032),
    [sym_text_block] = ACTIONS(1034),
    [sym_null_literal] = ACTIONS(1032),
    [anon_sym_LPAREN] = ACTIONS(1034),
    [anon_sym_PLUS] = ACTIONS(1032),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_final] = ACTIONS(1032),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_PLUS_PLUS] = ACTIONS(1034),
    [anon_sym_DASH_DASH] = ACTIONS(1034),
    [anon_sym_new] = ACTIONS(1032),
    [anon_sym_class] = ACTIONS(1032),
    [anon_sym_switch] = ACTIONS(1032),
    [anon_sym_LBRACE] = ACTIONS(1034),
    [anon_sym_RBRACE] = ACTIONS(1034),
    [anon_sym_default] = ACTIONS(1032),
    [anon_sym_SEMI] = ACTIONS(1034),
    [anon_sym_assert] = ACTIONS(1032),
    [anon_sym_do] = ACTIONS(1032),
    [anon_sym_while] = ACTIONS(1032),
    [anon_sym_break] = ACTIONS(1032),
    [anon_sym_continue] = ACTIONS(1032),
    [anon_sym_return] = ACTIONS(1032),
    [anon_sym_yield] = ACTIONS(1032),
    [anon_sym_synchronized] = ACTIONS(1032),
    [anon_sym_throw] = ACTIONS(1032),
    [anon_sym_try] = ACTIONS(1032),
    [anon_sym_if] = ACTIONS(1032),
    [anon_sym_for] = ACTIONS(1032),
    [anon_sym_AT] = ACTIONS(1032),
    [anon_sym_open] = ACTIONS(1032),
    [anon_sym_module] = ACTIONS(1032),
    [anon_sym_static] = ACTIONS(1032),
    [anon_sym_package] = ACTIONS(1032),
    [anon_sym_import] = ACTIONS(1032),
    [anon_sym_enum] = ACTIONS(1032),
    [anon_sym_public] = ACTIONS(1032),
    [anon_sym_protected] = ACTIONS(1032),
    [anon_sym_private] = ACTIONS(1032),
    [anon_sym_abstract] = ACTIONS(1032),
    [anon_sym_strictfp] = ACTIONS(1032),
    [anon_sym_native] = ACTIONS(1032),
    [anon_sym_transient] = ACTIONS(1032),
    [anon_sym_volatile] = ACTIONS(1032),
    [anon_sym_sealed] = ACTIONS(1032),
    [anon_sym_non_DASHsealed] = ACTIONS(1034),
    [anon_sym_record] = ACTIONS(1032),
    [anon_sym_ATinterface] = ACTIONS(1034),
    [anon_sym_interface] = ACTIONS(1032),
    [anon_sym_byte] = ACTIONS(1032),
    [anon_sym_short] = ACTIONS(1032),
    [anon_sym_int] = ACTIONS(1032),
    [anon_sym_long] = ACTIONS(1032),
    [anon_sym_char] = ACTIONS(1032),
    [anon_sym_float] = ACTIONS(1032),
    [anon_sym_double] = ACTIONS(1032),
    [sym_boolean_type] = ACTIONS(1032),
    [sym_void_type] = ACTIONS(1032),
    [sym_this] = ACTIONS(1032),
    [sym_super] = ACTIONS(1032),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [350] = {
    [sym_identifier] = ACTIONS(1036),
    [sym_decimal_integer_literal] = ACTIONS(1036),
    [sym_hex_integer_literal] = ACTIONS(1036),
    [sym_octal_integer_literal] = ACTIONS(1038),
    [sym_binary_integer_literal] = ACTIONS(1038),
    [sym_decimal_floating_point_literal] = ACTIONS(1038),
    [sym_hex_floating_point_literal] = ACTIONS(1036),
    [sym_true] = ACTIONS(1036),
    [sym_false] = ACTIONS(1036),
    [sym_character_literal] = ACTIONS(1038),
    [sym_string_literal] = ACTIONS(1036),
    [sym_text_block] = ACTIONS(1038),
    [sym_null_literal] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [anon_sym_PLUS] = ACTIONS(1036),
    [anon_sym_DASH] = ACTIONS(1036),
    [anon_sym_final] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_TILDE] = ACTIONS(1038),
    [anon_sym_PLUS_PLUS] = ACTIONS(1038),
    [anon_sym_DASH_DASH] = ACTIONS(1038),
    [anon_sym_new] = ACTIONS(1036),
    [anon_sym_class] = ACTIONS(1036),
    [anon_sym_switch] = ACTIONS(1036),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_RBRACE] = ACTIONS(1038),
    [anon_sym_default] = ACTIONS(1036),
    [anon_sym_SEMI] = ACTIONS(1038),
    [anon_sym_assert] = ACTIONS(1036),
    [anon_sym_do] = ACTIONS(1036),
    [anon_sym_while] = ACTIONS(1036),
    [anon_sym_break] = ACTIONS(1036),
    [anon_sym_continue] = ACTIONS(1036),
    [anon_sym_return] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1036),
    [anon_sym_synchronized] = ACTIONS(1036),
    [anon_sym_throw] = ACTIONS(1036),
    [anon_sym_try] = ACTIONS(1036),
    [anon_sym_if] = ACTIONS(1036),
    [anon_sym_for] = ACTIONS(1036),
    [anon_sym_AT] = ACTIONS(1036),
    [anon_sym_open] = ACTIONS(1036),
    [anon_sym_module] = ACTIONS(1036),
    [anon_sym_static] = ACTIONS(1036),
    [anon_sym_package] = ACTIONS(1036),
    [anon_sym_import] = ACTIONS(1036),
    [anon_sym_enum] = ACTIONS(1036),
    [anon_sym_public] = ACTIONS(1036),
    [anon_sym_protected] = ACTIONS(1036),
    [anon_sym_private] = ACTIONS(1036),
    [anon_sym_abstract] = ACTIONS(1036),
    [anon_sym_strictfp] = ACTIONS(1036),
    [anon_sym_native] = ACTIONS(1036),
    [anon_sym_transient] = ACTIONS(1036),
    [anon_sym_volatile] = ACTIONS(1036),
    [anon_sym_sealed] = ACTIONS(1036),
    [anon_sym_non_DASHsealed] = ACTIONS(1038),
    [anon_sym_record] = ACTIONS(1036),
    [anon_sym_ATinterface] = ACTIONS(1038),
    [anon_sym_interface] = ACTIONS(1036),
    [anon_sym_byte] = ACTIONS(1036),
    [anon_sym_short] = ACTIONS(1036),
    [anon_sym_int] = ACTIONS(1036),
    [anon_sym_long] = ACTIONS(1036),
    [anon_sym_char] = ACTIONS(1036),
    [anon_sym_float] = ACTIONS(1036),
    [anon_sym_double] = ACTIONS(1036),
    [sym_boolean_type] = ACTIONS(1036),
    [sym_void_type] = ACTIONS(1036),
    [sym_this] = ACTIONS(1036),
    [sym_super] = ACTIONS(1036),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [351] = {
    [sym_identifier] = ACTIONS(1040),
    [sym_decimal_integer_literal] = ACTIONS(1040),
    [sym_hex_integer_literal] = ACTIONS(1040),
    [sym_octal_integer_literal] = ACTIONS(1042),
    [sym_binary_integer_literal] = ACTIONS(1042),
    [sym_decimal_floating_point_literal] = ACTIONS(1042),
    [sym_hex_floating_point_literal] = ACTIONS(1040),
    [sym_true] = ACTIONS(1040),
    [sym_false] = ACTIONS(1040),
    [sym_character_literal] = ACTIONS(1042),
    [sym_string_literal] = ACTIONS(1040),
    [sym_text_block] = ACTIONS(1042),
    [sym_null_literal] = ACTIONS(1040),
    [anon_sym_LPAREN] = ACTIONS(1042),
    [anon_sym_PLUS] = ACTIONS(1040),
    [anon_sym_DASH] = ACTIONS(1040),
    [anon_sym_final] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_PLUS_PLUS] = ACTIONS(1042),
    [anon_sym_DASH_DASH] = ACTIONS(1042),
    [anon_sym_new] = ACTIONS(1040),
    [anon_sym_class] = ACTIONS(1040),
    [anon_sym_switch] = ACTIONS(1040),
    [anon_sym_LBRACE] = ACTIONS(1042),
    [anon_sym_RBRACE] = ACTIONS(1042),
    [anon_sym_default] = ACTIONS(1040),
    [anon_sym_SEMI] = ACTIONS(1042),
    [anon_sym_assert] = ACTIONS(1040),
    [anon_sym_do] = ACTIONS(1040),
    [anon_sym_while] = ACTIONS(1040),
    [anon_sym_break] = ACTIONS(1040),
    [anon_sym_continue] = ACTIONS(1040),
    [anon_sym_return] = ACTIONS(1040),
    [anon_sym_yield] = ACTIONS(1040),
    [anon_sym_synchronized] = ACTIONS(1040),
    [anon_sym_throw] = ACTIONS(1040),
    [anon_sym_try] = ACTIONS(1040),
    [anon_sym_if] = ACTIONS(1040),
    [anon_sym_for] = ACTIONS(1040),
    [anon_sym_AT] = ACTIONS(1040),
    [anon_sym_open] = ACTIONS(1040),
    [anon_sym_module] = ACTIONS(1040),
    [anon_sym_static] = ACTIONS(1040),
    [anon_sym_package] = ACTIONS(1040),
    [anon_sym_import] = ACTIONS(1040),
    [anon_sym_enum] = ACTIONS(1040),
    [anon_sym_public] = ACTIONS(1040),
    [anon_sym_protected] = ACTIONS(1040),
    [anon_sym_private] = ACTIONS(1040),
    [anon_sym_abstract] = ACTIONS(1040),
    [anon_sym_strictfp] = ACTIONS(1040),
    [anon_sym_native] = ACTIONS(1040),
    [anon_sym_transient] = ACTIONS(1040),
    [anon_sym_volatile] = ACTIONS(1040),
    [anon_sym_sealed] = ACTIONS(1040),
    [anon_sym_non_DASHsealed] = ACTIONS(1042),
    [anon_sym_record] = ACTIONS(1040),
    [anon_sym_ATinterface] = ACTIONS(1042),
    [anon_sym_interface] = ACTIONS(1040),
    [anon_sym_byte] = ACTIONS(1040),
    [anon_sym_short] = ACTIONS(1040),
    [anon_sym_int] = ACTIONS(1040),
    [anon_sym_long] = ACTIONS(1040),
    [anon_sym_char] = ACTIONS(1040),
    [anon_sym_float] = ACTIONS(1040),
    [anon_sym_double] = ACTIONS(1040),
    [sym_boolean_type] = ACTIONS(1040),
    [sym_void_type] = ACTIONS(1040),
    [sym_this] = ACTIONS(1040),
    [sym_super] = ACTIONS(1040),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [352] = {
    [sym__literal] = STATE(461),
    [sym_primary_expression] = STATE(992),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(875),
    [sym_array_access] = STATE(461),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_resource] = STATE(1172),
    [sym__annotation] = STATE(606),
    [sym_marker_annotation] = STATE(606),
    [sym_annotation] = STATE(606),
    [sym_modifiers] = STATE(701),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(706),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [aux_sym_modifiers_repeat1] = STATE(538),
    [sym_identifier] = ACTIONS(1016),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_final] = ACTIONS(299),
    [anon_sym_new] = ACTIONS(1022),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_synchronized] = ACTIONS(299),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_open] = ACTIONS(1024),
    [anon_sym_module] = ACTIONS(1024),
    [anon_sym_static] = ACTIONS(299),
    [anon_sym_public] = ACTIONS(299),
    [anon_sym_protected] = ACTIONS(299),
    [anon_sym_private] = ACTIONS(299),
    [anon_sym_abstract] = ACTIONS(299),
    [anon_sym_strictfp] = ACTIONS(299),
    [anon_sym_native] = ACTIONS(299),
    [anon_sym_transient] = ACTIONS(299),
    [anon_sym_volatile] = ACTIONS(299),
    [anon_sym_sealed] = ACTIONS(299),
    [anon_sym_non_DASHsealed] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(1024),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [353] = {
    [sym__literal] = STATE(461),
    [sym_primary_expression] = STATE(992),
    [sym_array_creation_expression] = STATE(461),
    [sym_parenthesized_expression] = STATE(461),
    [sym_class_literal] = STATE(461),
    [sym_object_creation_expression] = STATE(461),
    [sym__unqualified_object_creation_expression] = STATE(494),
    [sym_field_access] = STATE(875),
    [sym_array_access] = STATE(461),
    [sym_method_invocation] = STATE(461),
    [sym_method_reference] = STATE(461),
    [sym_resource] = STATE(1054),
    [sym__annotation] = STATE(606),
    [sym_marker_annotation] = STATE(606),
    [sym_annotation] = STATE(606),
    [sym_modifiers] = STATE(701),
    [sym__type] = STATE(1201),
    [sym__unannotated_type] = STATE(706),
    [sym_annotated_type] = STATE(770),
    [sym_scoped_type_identifier] = STATE(722),
    [sym_generic_type] = STATE(751),
    [sym_array_type] = STATE(685),
    [sym_integral_type] = STATE(685),
    [sym_floating_point_type] = STATE(685),
    [aux_sym_array_creation_expression_repeat1] = STATE(661),
    [aux_sym_modifiers_repeat1] = STATE(538),
    [sym_identifier] = ACTIONS(1016),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_final] = ACTIONS(299),
    [anon_sym_new] = ACTIONS(1022),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_synchronized] = ACTIONS(299),
    [anon_sym_AT] = ACTIONS(301),
    [anon_sym_open] = ACTIONS(1024),
    [anon_sym_module] = ACTIONS(1024),
    [anon_sym_static] = ACTIONS(299),
    [anon_sym_public] = ACTIONS(299),
    [anon_sym_protected] = ACTIONS(299),
    [anon_sym_private] = ACTIONS(299),
    [anon_sym_abstract] = ACTIONS(299),
    [anon_sym_strictfp] = ACTIONS(299),
    [anon_sym_native] = ACTIONS(299),
    [anon_sym_transient] = ACTIONS(299),
    [anon_sym_volatile] = ACTIONS(299),
    [anon_sym_sealed] = ACTIONS(299),
    [anon_sym_non_DASHsealed] = ACTIONS(305),
    [anon_sym_record] = ACTIONS(1024),
    [anon_sym_byte] = ACTIONS(77),
    [anon_sym_short] = ACTIONS(77),
    [anon_sym_int] = ACTIONS(77),
    [anon_sym_long] = ACTIONS(77),
    [anon_sym_char] = ACTIONS(77),
    [anon_sym_float] = ACTIONS(79),
    [anon_sym_double] = ACTIONS(79),
    [sym_boolean_type] = ACTIONS(81),
    [sym_void_type] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 28,
    ACTIONS(25), 1,
      anon_sym_class,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_AT,
    ACTIONS(67), 1,
      anon_sym_enum,
    ACTIONS(69), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(73), 1,
      anon_sym_ATinterface,
    ACTIONS(75), 1,
      anon_sym_interface,
    ACTIONS(1044), 1,
      sym_identifier,
    ACTIONS(1046), 1,
      anon_sym_LT,
    ACTIONS(1048), 1,
      anon_sym_RBRACE,
    ACTIONS(1050), 1,
      anon_sym_SEMI,
    ACTIONS(1052), 1,
      anon_sym_static,
    ACTIONS(1054), 1,
      anon_sym_record,
    STATE(604), 1,
      sym_modifiers,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(667), 1,
      sym_type_parameters,
    STATE(684), 1,
      sym_generic_type,
    STATE(704), 1,
      sym__unannotated_type,
    STATE(927), 1,
      sym__constructor_declarator,
    STATE(983), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(423), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(17), 12,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
    STATE(355), 12,
      sym_block,
      sym_enum_declaration,
      sym_class_declaration,
      sym_static_initializer,
      sym_constructor_declaration,
      sym_field_declaration,
      sym_record_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_method_declaration,
      sym_compact_constructor_declaration,
      aux_sym_enum_body_declarations_repeat1,
  [119] = 28,
    ACTIONS(25), 1,
      anon_sym_class,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_AT,
    ACTIONS(67), 1,
      anon_sym_enum,
    ACTIONS(69), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(73), 1,
      anon_sym_ATinterface,
    ACTIONS(75), 1,
      anon_sym_interface,
    ACTIONS(1044), 1,
      sym_identifier,
    ACTIONS(1046), 1,
      anon_sym_LT,
    ACTIONS(1052), 1,
      anon_sym_static,
    ACTIONS(1054), 1,
      anon_sym_record,
    ACTIONS(1056), 1,
      anon_sym_RBRACE,
    ACTIONS(1058), 1,
      anon_sym_SEMI,
    STATE(604), 1,
      sym_modifiers,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(667), 1,
      sym_type_parameters,
    STATE(684), 1,
      sym_generic_type,
    STATE(704), 1,
      sym__unannotated_type,
    STATE(927), 1,
      sym__constructor_declarator,
    STATE(983), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(423), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(17), 12,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
    STATE(358), 12,
      sym_block,
      sym_enum_declaration,
      sym_class_declaration,
      sym_static_initializer,
      sym_constructor_declaration,
      sym_field_declaration,
      sym_record_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_method_declaration,
      sym_compact_constructor_declaration,
      aux_sym_enum_body_declarations_repeat1,
  [238] = 28,
    ACTIONS(25), 1,
      anon_sym_class,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_AT,
    ACTIONS(67), 1,
      anon_sym_enum,
    ACTIONS(69), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(73), 1,
      anon_sym_ATinterface,
    ACTIONS(75), 1,
      anon_sym_interface,
    ACTIONS(1044), 1,
      sym_identifier,
    ACTIONS(1046), 1,
      anon_sym_LT,
    ACTIONS(1052), 1,
      anon_sym_static,
    ACTIONS(1054), 1,
      anon_sym_record,
    ACTIONS(1058), 1,
      anon_sym_SEMI,
    ACTIONS(1060), 1,
      anon_sym_RBRACE,
    STATE(604), 1,
      sym_modifiers,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(667), 1,
      sym_type_parameters,
    STATE(684), 1,
      sym_generic_type,
    STATE(704), 1,
      sym__unannotated_type,
    STATE(927), 1,
      sym__constructor_declarator,
    STATE(983), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(423), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(17), 12,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
    STATE(358), 12,
      sym_block,
      sym_enum_declaration,
      sym_class_declaration,
      sym_static_initializer,
      sym_constructor_declaration,
      sym_field_declaration,
      sym_record_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_method_declaration,
      sym_compact_constructor_declaration,
      aux_sym_enum_body_declarations_repeat1,
  [357] = 28,
    ACTIONS(25), 1,
      anon_sym_class,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_AT,
    ACTIONS(67), 1,
      anon_sym_enum,
    ACTIONS(69), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(73), 1,
      anon_sym_ATinterface,
    ACTIONS(75), 1,
      anon_sym_interface,
    ACTIONS(1044), 1,
      sym_identifier,
    ACTIONS(1046), 1,
      anon_sym_LT,
    ACTIONS(1052), 1,
      anon_sym_static,
    ACTIONS(1054), 1,
      anon_sym_record,
    ACTIONS(1062), 1,
      anon_sym_RBRACE,
    ACTIONS(1064), 1,
      anon_sym_SEMI,
    STATE(604), 1,
      sym_modifiers,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(667), 1,
      sym_type_parameters,
    STATE(684), 1,
      sym_generic_type,
    STATE(704), 1,
      sym__unannotated_type,
    STATE(927), 1,
      sym__constructor_declarator,
    STATE(983), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(423), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(17), 12,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
    STATE(356), 12,
      sym_block,
      sym_enum_declaration,
      sym_class_declaration,
      sym_static_initializer,
      sym_constructor_declaration,
      sym_field_declaration,
      sym_record_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_method_declaration,
      sym_compact_constructor_declaration,
      aux_sym_enum_body_declarations_repeat1,
  [476] = 28,
    ACTIONS(1066), 1,
      sym_identifier,
    ACTIONS(1069), 1,
      anon_sym_LT,
    ACTIONS(1075), 1,
      anon_sym_class,
    ACTIONS(1078), 1,
      anon_sym_LBRACE,
    ACTIONS(1081), 1,
      anon_sym_RBRACE,
    ACTIONS(1083), 1,
      anon_sym_SEMI,
    ACTIONS(1086), 1,
      anon_sym_AT,
    ACTIONS(1089), 1,
      anon_sym_static,
    ACTIONS(1092), 1,
      anon_sym_enum,
    ACTIONS(1095), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1098), 1,
      anon_sym_record,
    ACTIONS(1101), 1,
      anon_sym_ATinterface,
    ACTIONS(1104), 1,
      anon_sym_interface,
    STATE(604), 1,
      sym_modifiers,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(667), 1,
      sym_type_parameters,
    STATE(684), 1,
      sym_generic_type,
    STATE(704), 1,
      sym__unannotated_type,
    STATE(927), 1,
      sym__constructor_declarator,
    STATE(983), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1110), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1113), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(423), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1107), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(1072), 12,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
    STATE(358), 12,
      sym_block,
      sym_enum_declaration,
      sym_class_declaration,
      sym_static_initializer,
      sym_constructor_declaration,
      sym_field_declaration,
      sym_record_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_method_declaration,
      sym_compact_constructor_declaration,
      aux_sym_enum_body_declarations_repeat1,
  [595] = 25,
    ACTIONS(1116), 1,
      sym_identifier,
    ACTIONS(1119), 1,
      anon_sym_LT,
    ACTIONS(1125), 1,
      anon_sym_class,
    ACTIONS(1128), 1,
      anon_sym_RBRACE,
    ACTIONS(1130), 1,
      anon_sym_SEMI,
    ACTIONS(1133), 1,
      anon_sym_AT,
    ACTIONS(1136), 1,
      anon_sym_enum,
    ACTIONS(1139), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1142), 1,
      anon_sym_record,
    ACTIONS(1145), 1,
      anon_sym_ATinterface,
    ACTIONS(1148), 1,
      anon_sym_interface,
    STATE(626), 1,
      sym_modifiers,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(659), 1,
      sym_type_parameters,
    STATE(684), 1,
      sym_generic_type,
    STATE(695), 1,
      sym__unannotated_type,
    STATE(983), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1154), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1157), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(423), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1151), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(359), 8,
      sym_enum_declaration,
      sym_class_declaration,
      sym_record_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      sym_method_declaration,
      aux_sym_interface_body_repeat1,
    ACTIONS(1122), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [702] = 25,
    ACTIONS(25), 1,
      anon_sym_class,
    ACTIONS(57), 1,
      anon_sym_AT,
    ACTIONS(67), 1,
      anon_sym_enum,
    ACTIONS(69), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(73), 1,
      anon_sym_ATinterface,
    ACTIONS(75), 1,
      anon_sym_interface,
    ACTIONS(1046), 1,
      anon_sym_LT,
    ACTIONS(1054), 1,
      anon_sym_record,
    ACTIONS(1160), 1,
      sym_identifier,
    ACTIONS(1162), 1,
      anon_sym_RBRACE,
    ACTIONS(1164), 1,
      anon_sym_SEMI,
    STATE(626), 1,
      sym_modifiers,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(659), 1,
      sym_type_parameters,
    STATE(684), 1,
      sym_generic_type,
    STATE(695), 1,
      sym__unannotated_type,
    STATE(983), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(423), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(359), 8,
      sym_enum_declaration,
      sym_class_declaration,
      sym_record_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      sym_method_declaration,
      aux_sym_interface_body_repeat1,
    ACTIONS(17), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [809] = 25,
    ACTIONS(25), 1,
      anon_sym_class,
    ACTIONS(57), 1,
      anon_sym_AT,
    ACTIONS(67), 1,
      anon_sym_enum,
    ACTIONS(69), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(73), 1,
      anon_sym_ATinterface,
    ACTIONS(75), 1,
      anon_sym_interface,
    ACTIONS(1046), 1,
      anon_sym_LT,
    ACTIONS(1054), 1,
      anon_sym_record,
    ACTIONS(1160), 1,
      sym_identifier,
    ACTIONS(1166), 1,
      anon_sym_RBRACE,
    ACTIONS(1168), 1,
      anon_sym_SEMI,
    STATE(626), 1,
      sym_modifiers,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(659), 1,
      sym_type_parameters,
    STATE(684), 1,
      sym_generic_type,
    STATE(695), 1,
      sym__unannotated_type,
    STATE(983), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(423), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(360), 8,
      sym_enum_declaration,
      sym_class_declaration,
      sym_record_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      sym_method_declaration,
      aux_sym_interface_body_repeat1,
    ACTIONS(17), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [916] = 14,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(1178), 1,
      anon_sym_EQ,
    ACTIONS(1182), 1,
      anon_sym_LT,
    ACTIONS(1185), 1,
      anon_sym_DASH_GT,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1194), 1,
      anon_sym_AT,
    STATE(472), 1,
      sym_argument_list,
    STATE(674), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1187), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1170), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1180), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1174), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COLON,
    ACTIONS(1176), 14,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [1000] = 18,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(1178), 1,
      anon_sym_EQ,
    ACTIONS(1182), 1,
      anon_sym_LT,
    ACTIONS(1185), 1,
      anon_sym_DASH_GT,
    ACTIONS(1196), 1,
      anon_sym_AMP,
    ACTIONS(1199), 1,
      anon_sym_RPAREN,
    ACTIONS(1203), 1,
      anon_sym_COMMA,
    ACTIONS(1205), 1,
      anon_sym_DOT,
    STATE(472), 1,
      sym_argument_list,
    STATE(674), 1,
      sym_type_arguments,
    STATE(1015), 1,
      aux_sym_inferred_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1187), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1194), 2,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1170), 5,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1176), 9,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1180), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1174), 12,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
  [1091] = 15,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(1178), 1,
      anon_sym_EQ,
    ACTIONS(1182), 1,
      anon_sym_LT,
    ACTIONS(1185), 1,
      anon_sym_DASH_GT,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1194), 1,
      anon_sym_AT,
    ACTIONS(1209), 1,
      anon_sym_COLON,
    STATE(472), 1,
      sym_argument_list,
    STATE(674), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1187), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1170), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1176), 10,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_SEMI,
    ACTIONS(1180), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1174), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
  [1173] = 15,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(1178), 1,
      anon_sym_EQ,
    ACTIONS(1182), 1,
      anon_sym_LT,
    ACTIONS(1185), 1,
      anon_sym_DASH_GT,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1194), 1,
      anon_sym_AT,
    ACTIONS(1211), 1,
      anon_sym_COLON,
    STATE(472), 1,
      sym_argument_list,
    STATE(674), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1187), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1170), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1176), 10,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_SEMI,
    ACTIONS(1180), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1174), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
  [1255] = 20,
    ACTIONS(1213), 1,
      sym_identifier,
    ACTIONS(1219), 1,
      anon_sym_class,
    ACTIONS(1222), 1,
      anon_sym_RBRACE,
    ACTIONS(1224), 1,
      anon_sym_AT,
    ACTIONS(1227), 1,
      anon_sym_enum,
    ACTIONS(1230), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1233), 1,
      anon_sym_ATinterface,
    ACTIONS(1236), 1,
      anon_sym_interface,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(673), 1,
      sym_modifiers,
    STATE(684), 1,
      sym_generic_type,
    STATE(712), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1242), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1245), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(423), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1239), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(366), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_annotation_type_declaration,
      sym_annotation_type_element_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      aux_sym_annotation_type_body_repeat1,
    ACTIONS(1216), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [1346] = 20,
    ACTIONS(25), 1,
      anon_sym_class,
    ACTIONS(57), 1,
      anon_sym_AT,
    ACTIONS(67), 1,
      anon_sym_enum,
    ACTIONS(69), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(73), 1,
      anon_sym_ATinterface,
    ACTIONS(75), 1,
      anon_sym_interface,
    ACTIONS(1160), 1,
      sym_identifier,
    ACTIONS(1248), 1,
      anon_sym_RBRACE,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(673), 1,
      sym_modifiers,
    STATE(684), 1,
      sym_generic_type,
    STATE(712), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(423), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(368), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_annotation_type_declaration,
      sym_annotation_type_element_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      aux_sym_annotation_type_body_repeat1,
    ACTIONS(17), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [1437] = 20,
    ACTIONS(25), 1,
      anon_sym_class,
    ACTIONS(57), 1,
      anon_sym_AT,
    ACTIONS(67), 1,
      anon_sym_enum,
    ACTIONS(69), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(73), 1,
      anon_sym_ATinterface,
    ACTIONS(75), 1,
      anon_sym_interface,
    ACTIONS(1160), 1,
      sym_identifier,
    ACTIONS(1250), 1,
      anon_sym_RBRACE,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(673), 1,
      sym_modifiers,
    STATE(684), 1,
      sym_generic_type,
    STATE(712), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(423), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(366), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_annotation_type_declaration,
      sym_annotation_type_element_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      aux_sym_annotation_type_body_repeat1,
    ACTIONS(17), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [1528] = 5,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    STATE(458), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1252), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1254), 30,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [1588] = 8,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(1260), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_DASH_GT,
    STATE(464), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1262), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1256), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1258), 18,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [1654] = 11,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(1260), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_DASH_GT,
    ACTIONS(1266), 1,
      sym_identifier,
    STATE(464), 1,
      sym_argument_list,
    STATE(1072), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1268), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    ACTIONS(1262), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1258), 13,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
    ACTIONS(1256), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
  [1726] = 5,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    STATE(492), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1270), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1272), 30,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [1786] = 5,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    STATE(493), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1274), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1276), 30,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [1846] = 5,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    STATE(477), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1278), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1280), 30,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [1906] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1278), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1280), 30,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [1960] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1274), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1276), 30,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2014] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1282), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1284), 30,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2068] = 13,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LT,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1194), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_EQ,
    ACTIONS(1290), 1,
      anon_sym_DASH_GT,
    STATE(472), 1,
      sym_argument_list,
    STATE(674), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1187), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1176), 11,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1288), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1174), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
  [2142] = 13,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(1182), 1,
      anon_sym_LT,
    ACTIONS(1185), 1,
      anon_sym_DASH_GT,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1194), 1,
      anon_sym_AT,
    ACTIONS(1293), 1,
      anon_sym_EQ,
    STATE(472), 1,
      sym_argument_list,
    STATE(674), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1187), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1176), 11,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1180), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1174), 12,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
  [2215] = 11,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(1203), 1,
      anon_sym_COMMA,
    ACTIONS(1260), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_DASH_GT,
    ACTIONS(1295), 1,
      anon_sym_RPAREN,
    STATE(464), 1,
      sym_argument_list,
    STATE(1066), 1,
      aux_sym_inferred_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1262), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1256), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(1258), 13,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [2284] = 5,
    ACTIONS(1178), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1180), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1174), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1176), 18,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2341] = 7,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1302), 1,
      anon_sym_LBRACK,
    STATE(386), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(824), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1298), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_COLON,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1300), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2401] = 8,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(1304), 1,
      anon_sym_EQ,
    ACTIONS(1308), 1,
      anon_sym_DASH_GT,
    STATE(464), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1306), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1256), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1258), 14,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [2463] = 9,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(1260), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_DASH_GT,
    ACTIONS(1311), 1,
      sym_identifier,
    STATE(464), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1262), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1258), 13,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
    ACTIONS(1256), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
  [2527] = 9,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(1260), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_DASH_GT,
    ACTIONS(1313), 1,
      anon_sym_module,
    STATE(464), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1262), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1256), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(1258), 14,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
  [2591] = 7,
    ACTIONS(1319), 1,
      anon_sym_LBRACK,
    ACTIONS(1322), 1,
      anon_sym_AT,
    STATE(386), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(824), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1315), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_COLON,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1317), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2651] = 8,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1302), 1,
      anon_sym_LBRACK,
    STATE(382), 1,
      aux_sym_dimensions_repeat1,
    STATE(422), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(824), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1325), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1327), 21,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2712] = 8,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1302), 1,
      anon_sym_LBRACK,
    STATE(382), 1,
      aux_sym_dimensions_repeat1,
    STATE(422), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(824), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1329), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1331), 21,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2773] = 9,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1337), 1,
      anon_sym_LBRACK,
    STATE(382), 1,
      aux_sym_dimensions_repeat1,
    STATE(469), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(397), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(791), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1333), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1335), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2836] = 9,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1337), 1,
      anon_sym_LBRACK,
    STATE(382), 1,
      aux_sym_dimensions_repeat1,
    STATE(462), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(397), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(791), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1339), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1341), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2899] = 9,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1337), 1,
      anon_sym_LBRACK,
    STATE(382), 1,
      aux_sym_dimensions_repeat1,
    STATE(490), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(397), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(791), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1343), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1345), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2962] = 9,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1337), 1,
      anon_sym_LBRACK,
    STATE(382), 1,
      aux_sym_dimensions_repeat1,
    STATE(473), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(397), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(791), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1347), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1349), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [3025] = 5,
    ACTIONS(1286), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1288), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1174), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1176), 15,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [3079] = 19,
    ACTIONS(297), 1,
      anon_sym_RPAREN,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(305), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(398), 1,
      sym_receiver_parameter,
    STATE(538), 1,
      aux_sym_modifiers_repeat1,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(664), 1,
      aux_sym_array_creation_expression_repeat1,
    STATE(684), 1,
      sym_generic_type,
    STATE(703), 1,
      sym_modifiers,
    STATE(715), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(1003), 2,
      sym_formal_parameter,
      sym_spread_parameter,
    STATE(606), 3,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(299), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [3161] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1353), 8,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1351), 33,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_to,
      anon_sym_with,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [3211] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1357), 8,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1355), 33,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_to,
      anon_sym_with,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [3261] = 7,
    ACTIONS(1363), 1,
      anon_sym_LBRACK,
    ACTIONS(1366), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(397), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(818), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1359), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1361), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [3318] = 16,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(305), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1160), 1,
      sym_identifier,
    ACTIONS(1369), 1,
      anon_sym_RPAREN,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(703), 1,
      sym_modifiers,
    STATE(720), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(998), 2,
      sym_formal_parameter,
      sym_spread_parameter,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(538), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(299), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [3392] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(952), 12,
      sym_octal_integer_literal,
      sym_binary_integer_literal,
      sym_decimal_floating_point_literal,
      sym_character_literal,
      sym_text_block,
      anon_sym_LPAREN,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(954), 26,
      sym_decimal_integer_literal,
      sym_hex_integer_literal,
      sym_hex_floating_point_literal,
      sym_true,
      sym_false,
      sym_string_literal,
      sym_null_literal,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_switch,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_this,
      sym_super,
      sym_identifier,
  [3439] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1371), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_COLON,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1373), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [3486] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(800), 12,
      sym_octal_integer_literal,
      sym_binary_integer_literal,
      sym_decimal_floating_point_literal,
      sym_character_literal,
      sym_text_block,
      anon_sym_LPAREN,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(802), 26,
      sym_decimal_integer_literal,
      sym_hex_integer_literal,
      sym_hex_floating_point_literal,
      sym_true,
      sym_false,
      sym_string_literal,
      sym_null_literal,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_switch,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_this,
      sym_super,
      sym_identifier,
  [3533] = 6,
    ACTIONS(1375), 1,
      anon_sym_LT,
    ACTIONS(1378), 1,
      anon_sym_DOT,
    STATE(412), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1170), 12,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1194), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [3586] = 6,
    ACTIONS(1384), 1,
      anon_sym_LT,
    ACTIONS(1387), 1,
      anon_sym_DOT,
    STATE(409), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1380), 12,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1382), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [3639] = 16,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(305), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(689), 1,
      sym_modifiers,
    STATE(719), 1,
      sym__unannotated_type,
    STATE(873), 1,
      sym_catch_type,
    STATE(1208), 1,
      sym_catch_formal_parameter,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(538), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(299), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [3712] = 15,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(305), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(703), 1,
      sym_modifiers,
    STATE(720), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(1190), 2,
      sym_formal_parameter,
      sym_spread_parameter,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(538), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(299), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [3783] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1315), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_COLON,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1317), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [3830] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1389), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1391), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [3876] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1393), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1395), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [3922] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1397), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1399), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [3968] = 6,
    ACTIONS(1403), 1,
      anon_sym_LPAREN,
    ACTIONS(1407), 1,
      anon_sym_DOT,
    STATE(453), 1,
      sym_annotation_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1405), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1401), 31,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [4020] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1409), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1411), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4066] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1413), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1415), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4112] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1417), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1419), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4158] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1421), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1423), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4204] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1425), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1427), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4250] = 4,
    ACTIONS(1387), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1380), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1382), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4298] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1429), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1431), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4344] = 6,
    ACTIONS(1403), 1,
      anon_sym_LPAREN,
    ACTIONS(1437), 1,
      anon_sym_DOT,
    STATE(454), 1,
      sym_annotation_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1433), 31,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [4396] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1439), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1441), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4441] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1443), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1445), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4486] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1380), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1382), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4531] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1447), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1449), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4576] = 7,
    ACTIONS(57), 1,
      anon_sym_AT,
    ACTIONS(1457), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1453), 2,
      anon_sym_LT,
      anon_sym_ATinterface,
    STATE(427), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1455), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
    ACTIONS(1451), 14,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [4628] = 5,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(460), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1459), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1461), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [4676] = 5,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(480), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1465), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1467), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [4724] = 5,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(470), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1469), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1471), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [4772] = 7,
    ACTIONS(1480), 1,
      anon_sym_AT,
    ACTIONS(1483), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1475), 2,
      anon_sym_LT,
      anon_sym_ATinterface,
    STATE(427), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1477), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
    ACTIONS(1473), 14,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [4824] = 5,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(475), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1486), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1488), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [4872] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1492), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1490), 31,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [4915] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1494), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1496), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [4958] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1500), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1498), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5001] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1504), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1502), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5044] = 5,
    ACTIONS(1506), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1512), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    ACTIONS(1508), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
    ACTIONS(1510), 21,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5091] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1516), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1514), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5134] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1520), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1518), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5177] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1524), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1522), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5220] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1526), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1528), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [5263] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1532), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1530), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5306] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1534), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1536), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [5349] = 5,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1544), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    ACTIONS(1540), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
    ACTIONS(1542), 21,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5396] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1548), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1546), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5439] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1552), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1550), 31,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5482] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1556), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1554), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5525] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1560), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1558), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5568] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1564), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1562), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5611] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1566), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1568), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5654] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1572), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1570), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5697] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1576), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1574), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5740] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1329), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_instanceof,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    ACTIONS(1331), 21,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5783] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1580), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1578), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5826] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1584), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1582), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5869] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1588), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1586), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5912] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1592), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1590), 31,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5955] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1596), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1594), 31,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [5998] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1598), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1600), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6041] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1604), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1602), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6084] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1608), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1606), 31,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6127] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1610), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1612), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6169] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1614), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1616), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6211] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1618), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1620), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6253] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1174), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1176), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6295] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1622), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1624), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6337] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1626), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1628), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6379] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1630), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1632), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6421] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1634), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1636), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6463] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1638), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1640), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6505] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1644), 5,
      anon_sym_LT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1642), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6547] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1648), 5,
      anon_sym_LT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1646), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6589] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1650), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1652), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6631] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1654), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1656), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6673] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1658), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1660), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6715] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1662), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1664), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6757] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1666), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1668), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6799] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1670), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1672), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6841] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1674), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1676), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6883] = 5,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    STATE(447), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1680), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1678), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6929] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1682), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1684), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6971] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1686), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1688), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7013] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1690), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1692), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7055] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1694), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1696), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7097] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1698), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1700), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7139] = 6,
    ACTIONS(1702), 1,
      anon_sym_LBRACK,
    ACTIONS(1704), 1,
      anon_sym_DOT,
    ACTIONS(1706), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(285), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(287), 21,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7187] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1708), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1710), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7229] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1712), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1714), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7271] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1716), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1718), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7313] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1720), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1722), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7355] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1724), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1726), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7397] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1728), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1730), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7439] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1732), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1734), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7481] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1736), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1738), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7523] = 5,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1680), 2,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1743), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
    ACTIONS(1740), 11,
      anon_sym_AT,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
    ACTIONS(1678), 17,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
  [7569] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1745), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1747), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7611] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1749), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1751), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7653] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1753), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1755), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7695] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1757), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1759), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7737] = 5,
    ACTIONS(1018), 1,
      anon_sym_LPAREN,
    STATE(1134), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1680), 2,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1678), 28,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [7782] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1395), 12,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1393), 19,
      anon_sym_new,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_this,
      sym_super,
      sym_identifier,
  [7822] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1423), 12,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1421), 19,
      anon_sym_new,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_this,
      sym_super,
      sym_identifier,
  [7862] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1391), 12,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1389), 19,
      anon_sym_new,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_this,
      sym_super,
      sym_identifier,
  [7902] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1763), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1761), 27,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [7941] = 4,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1765), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1767), 20,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7982] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1771), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1773), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8021] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1775), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1777), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8060] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1779), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1781), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8099] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1783), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1785), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8138] = 4,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1787), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1789), 20,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8179] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1775), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1777), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8218] = 4,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1791), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1793), 20,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8259] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1797), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1795), 27,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8298] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(285), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(287), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8337] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1801), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1799), 27,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8376] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1805), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1803), 27,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8415] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1809), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1807), 27,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8454] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1813), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1811), 27,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8493] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1815), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1817), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8532] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1819), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1821), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8571] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1825), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1823), 27,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8610] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1829), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1827), 27,
      anon_sym_final,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8649] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1831), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1833), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8688] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1835), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1837), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8727] = 15,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1789), 9,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8789] = 6,
    ACTIONS(1863), 1,
      anon_sym_LPAREN,
    ACTIONS(1865), 1,
      anon_sym_DOT,
    STATE(591), 1,
      sym_annotation_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1405), 3,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1401), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8833] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1867), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8901] = 6,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1787), 7,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1789), 17,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8945] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1833), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9013] = 5,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    STATE(1257), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1174), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1176), 19,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
  [9055] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1837), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9123] = 6,
    ACTIONS(1878), 1,
      anon_sym_AT,
    ACTIONS(1881), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(528), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1473), 10,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
    ACTIONS(1875), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [9167] = 15,
    ACTIONS(1787), 1,
      anon_sym_PIPE,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1789), 9,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9229] = 13,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1787), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1789), 10,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9287] = 9,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1787), 4,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
    ACTIONS(1789), 15,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9337] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1884), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9405] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1886), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9473] = 14,
    ACTIONS(1787), 1,
      anon_sym_PIPE,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1789), 10,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9533] = 16,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1789), 8,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9597] = 7,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1787), 5,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1789), 17,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9643] = 12,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1787), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1789), 12,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9699] = 6,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1890), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(528), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1451), 10,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
    ACTIONS(1888), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [9743] = 6,
    ACTIONS(1863), 1,
      anon_sym_LPAREN,
    ACTIONS(1892), 1,
      anon_sym_DOT,
    STATE(592), 1,
      sym_annotation_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1435), 3,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1433), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [9787] = 7,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    STATE(541), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1300), 10,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1298), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_default,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      anon_sym_throws,
      sym_this,
      sym_identifier,
  [9832] = 7,
    ACTIONS(1322), 1,
      anon_sym_AT,
    ACTIONS(1896), 1,
      anon_sym_LBRACK,
    STATE(541), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1317), 10,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1315), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_default,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      anon_sym_throws,
      sym_this,
      sym_identifier,
  [9877] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1357), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1355), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [9914] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1353), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1351), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [9951] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1899), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [10017] = 20,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1901), 1,
      anon_sym_AMP,
    ACTIONS(1909), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1911), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1917), 1,
      anon_sym_SLASH,
    ACTIONS(1919), 1,
      anon_sym_PIPE,
    ACTIONS(1921), 1,
      anon_sym_CARET,
    ACTIONS(1925), 1,
      anon_sym_GT_GT,
    ACTIONS(1929), 1,
      anon_sym_COMMA,
    ACTIONS(1931), 1,
      anon_sym_QMARK,
    STATE(928), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1903), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1907), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1913), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1923), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1927), 2,
      anon_sym_DASH_GT,
      anon_sym_COLON,
  [10087] = 6,
    ACTIONS(1702), 1,
      anon_sym_LBRACK,
    ACTIONS(1706), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1933), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(285), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(287), 16,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_SEMI,
  [10129] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1935), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
  [10194] = 20,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(1937), 1,
      anon_sym_RPAREN,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    STATE(1065), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [10263] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1552), 3,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1550), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [10298] = 20,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(1941), 1,
      anon_sym_RPAREN,
    STATE(994), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [10367] = 20,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(1943), 1,
      anon_sym_RPAREN,
    STATE(1009), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [10436] = 20,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(1945), 1,
      anon_sym_COMMA,
    ACTIONS(1947), 1,
      anon_sym_SEMI,
    STATE(1070), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [10505] = 20,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(1945), 1,
      anon_sym_COMMA,
    ACTIONS(1949), 1,
      anon_sym_SEMI,
    STATE(1050), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [10574] = 20,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(1951), 1,
      anon_sym_COMMA,
    ACTIONS(1953), 1,
      anon_sym_RBRACE,
    STATE(1077), 1,
      aux_sym_array_initializer_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [10643] = 18,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1901), 1,
      anon_sym_AMP,
    ACTIONS(1909), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1911), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1917), 1,
      anon_sym_SLASH,
    ACTIONS(1919), 1,
      anon_sym_PIPE,
    ACTIONS(1921), 1,
      anon_sym_CARET,
    ACTIONS(1925), 1,
      anon_sym_GT_GT,
    ACTIONS(1931), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1903), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1907), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1913), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1923), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1884), 3,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_COLON,
  [10708] = 18,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1901), 1,
      anon_sym_AMP,
    ACTIONS(1909), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1911), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1917), 1,
      anon_sym_SLASH,
    ACTIONS(1919), 1,
      anon_sym_PIPE,
    ACTIONS(1921), 1,
      anon_sym_CARET,
    ACTIONS(1925), 1,
      anon_sym_GT_GT,
    ACTIONS(1931), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1903), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1907), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1913), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1923), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1935), 3,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_COLON,
  [10773] = 15,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(1160), 1,
      sym_identifier,
    ACTIONS(1955), 1,
      anon_sym_GT,
    ACTIONS(1957), 1,
      anon_sym_QMARK,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(693), 1,
      sym__unannotated_type,
    STATE(770), 1,
      sym_annotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(971), 2,
      sym_wildcard,
      sym__type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(650), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [10832] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1492), 3,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1490), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [10867] = 20,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(1927), 1,
      anon_sym_COLON,
    ACTIONS(1959), 1,
      anon_sym_COMMA,
    STATE(1040), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [10936] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1608), 3,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1606), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [10971] = 7,
    ACTIONS(1917), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1913), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1787), 5,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1789), 14,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [11014] = 20,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(1961), 1,
      anon_sym_RPAREN,
    STATE(1032), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [11083] = 14,
    ACTIONS(1787), 1,
      anon_sym_PIPE,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1901), 1,
      anon_sym_AMP,
    ACTIONS(1917), 1,
      anon_sym_SLASH,
    ACTIONS(1925), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1903), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1907), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1913), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1923), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1789), 7,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [11140] = 15,
    ACTIONS(1787), 1,
      anon_sym_PIPE,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1901), 1,
      anon_sym_AMP,
    ACTIONS(1917), 1,
      anon_sym_SLASH,
    ACTIONS(1921), 1,
      anon_sym_CARET,
    ACTIONS(1925), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1903), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1907), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1913), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1923), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1789), 6,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [11199] = 6,
    ACTIONS(1917), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1915), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1787), 7,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1789), 14,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [11240] = 16,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1901), 1,
      anon_sym_AMP,
    ACTIONS(1909), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1917), 1,
      anon_sym_SLASH,
    ACTIONS(1919), 1,
      anon_sym_PIPE,
    ACTIONS(1921), 1,
      anon_sym_CARET,
    ACTIONS(1925), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1903), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1907), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1913), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1923), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1789), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [11301] = 20,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(1963), 1,
      anon_sym_RPAREN,
    STATE(1061), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [11370] = 15,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1901), 1,
      anon_sym_AMP,
    ACTIONS(1917), 1,
      anon_sym_SLASH,
    ACTIONS(1919), 1,
      anon_sym_PIPE,
    ACTIONS(1921), 1,
      anon_sym_CARET,
    ACTIONS(1925), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1903), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1907), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1913), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1923), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1789), 6,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [11429] = 20,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(1965), 1,
      anon_sym_RPAREN,
    STATE(1048), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [11498] = 12,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1917), 1,
      anon_sym_SLASH,
    ACTIONS(1925), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1787), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1903), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1913), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1923), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1789), 9,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [11551] = 20,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(1967), 1,
      anon_sym_RPAREN,
    STATE(1053), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [11620] = 20,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(1959), 1,
      anon_sym_COMMA,
    ACTIONS(1969), 1,
      anon_sym_RPAREN,
    STATE(1045), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [11689] = 9,
    ACTIONS(1917), 1,
      anon_sym_SLASH,
    ACTIONS(1925), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1913), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1923), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1787), 4,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
    ACTIONS(1789), 12,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [11736] = 20,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(1971), 1,
      anon_sym_RPAREN,
    STATE(1016), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [11805] = 20,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(1973), 1,
      anon_sym_RPAREN,
    STATE(1052), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [11874] = 13,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1917), 1,
      anon_sym_SLASH,
    ACTIONS(1925), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1787), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1903), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1907), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1913), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1923), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1789), 7,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [11929] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1977), 3,
      anon_sym_RPAREN,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1975), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [11964] = 20,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(1979), 1,
      anon_sym_RPAREN,
    STATE(1049), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [12033] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1983), 3,
      anon_sym_RPAREN,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1981), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [12068] = 12,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(305), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1985), 1,
      sym_identifier,
    ACTIONS(1987), 1,
      anon_sym_COMMA,
    ACTIONS(1989), 1,
      anon_sym_RBRACE,
    ACTIONS(1991), 1,
      anon_sym_SEMI,
    STATE(897), 1,
      sym_enum_constant,
    STATE(1202), 1,
      sym_enum_body_declarations,
    STATE(1224), 1,
      sym_modifiers,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(538), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(299), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [12121] = 18,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1901), 1,
      anon_sym_AMP,
    ACTIONS(1909), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1911), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1917), 1,
      anon_sym_SLASH,
    ACTIONS(1919), 1,
      anon_sym_PIPE,
    ACTIONS(1921), 1,
      anon_sym_CARET,
    ACTIONS(1925), 1,
      anon_sym_GT_GT,
    ACTIONS(1931), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1903), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1907), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1913), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1923), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1833), 3,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_COLON,
  [12186] = 20,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(1993), 1,
      anon_sym_RPAREN,
    STATE(1046), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [12255] = 20,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(1995), 1,
      anon_sym_RPAREN,
    STATE(1043), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [12324] = 18,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1901), 1,
      anon_sym_AMP,
    ACTIONS(1909), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1911), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1917), 1,
      anon_sym_SLASH,
    ACTIONS(1919), 1,
      anon_sym_PIPE,
    ACTIONS(1921), 1,
      anon_sym_CARET,
    ACTIONS(1925), 1,
      anon_sym_GT_GT,
    ACTIONS(1931), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1903), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1907), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1913), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1923), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1867), 3,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_COLON,
  [12389] = 20,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(1997), 1,
      anon_sym_RPAREN,
    STATE(1039), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [12458] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2001), 3,
      anon_sym_RPAREN,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1999), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [12493] = 18,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1901), 1,
      anon_sym_AMP,
    ACTIONS(1909), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1911), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1917), 1,
      anon_sym_SLASH,
    ACTIONS(1919), 1,
      anon_sym_PIPE,
    ACTIONS(1921), 1,
      anon_sym_CARET,
    ACTIONS(1925), 1,
      anon_sym_GT_GT,
    ACTIONS(1931), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1903), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1907), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1913), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1923), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1837), 3,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_COLON,
  [12558] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2005), 3,
      anon_sym_RPAREN,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(2003), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [12593] = 18,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1901), 1,
      anon_sym_AMP,
    ACTIONS(1909), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1911), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1917), 1,
      anon_sym_SLASH,
    ACTIONS(1919), 1,
      anon_sym_PIPE,
    ACTIONS(1921), 1,
      anon_sym_CARET,
    ACTIONS(1925), 1,
      anon_sym_GT_GT,
    ACTIONS(1931), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1903), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1907), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1913), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1923), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1886), 3,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_COLON,
  [12658] = 20,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(2007), 1,
      anon_sym_RPAREN,
    STATE(1028), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [12727] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1592), 3,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1590), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [12762] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1596), 3,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1594), 23,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [12797] = 20,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(2009), 1,
      anon_sym_RPAREN,
    STATE(1074), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [12866] = 4,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(281), 2,
      anon_sym_while,
      anon_sym_else,
    ACTIONS(285), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(287), 16,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_SEMI,
  [12903] = 15,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(1160), 1,
      sym_identifier,
    ACTIONS(1957), 1,
      anon_sym_QMARK,
    ACTIONS(2011), 1,
      anon_sym_GT,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(693), 1,
      sym__unannotated_type,
    STATE(770), 1,
      sym_annotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(1034), 2,
      sym_wildcard,
      sym__type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(650), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [12962] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2013), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [13027] = 20,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(2015), 1,
      anon_sym_RPAREN,
    STATE(1068), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [13096] = 11,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(305), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1985), 1,
      sym_identifier,
    ACTIONS(1991), 1,
      anon_sym_SEMI,
    ACTIONS(2017), 1,
      anon_sym_RBRACE,
    STATE(1000), 1,
      sym_enum_constant,
    STATE(1224), 1,
      sym_modifiers,
    STATE(1265), 1,
      sym_enum_body_declarations,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(538), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(299), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [13146] = 11,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(305), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1985), 1,
      sym_identifier,
    ACTIONS(1991), 1,
      anon_sym_SEMI,
    ACTIONS(2019), 1,
      anon_sym_RBRACE,
    STATE(1000), 1,
      sym_enum_constant,
    STATE(1196), 1,
      sym_enum_body_declarations,
    STATE(1224), 1,
      sym_modifiers,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(538), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(299), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [13196] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2021), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [13260] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2023), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [13324] = 14,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(1160), 1,
      sym_identifier,
    ACTIONS(1957), 1,
      anon_sym_QMARK,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(693), 1,
      sym__unannotated_type,
    STATE(770), 1,
      sym_annotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(1080), 2,
      sym_wildcard,
      sym__type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(650), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [13380] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2025), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [13444] = 18,
    ACTIONS(1046), 1,
      anon_sym_LT,
    ACTIONS(2027), 1,
      sym_identifier,
    ACTIONS(2029), 1,
      anon_sym_class,
    ACTIONS(2031), 1,
      anon_sym_enum,
    ACTIONS(2033), 1,
      anon_sym_record,
    ACTIONS(2035), 1,
      anon_sym_ATinterface,
    ACTIONS(2037), 1,
      anon_sym_interface,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(667), 1,
      sym_type_parameters,
    STATE(684), 1,
      sym_generic_type,
    STATE(700), 1,
      sym__unannotated_type,
    STATE(930), 1,
      sym__constructor_declarator,
    STATE(1047), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [13508] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2039), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [13572] = 5,
    ACTIONS(1680), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(2041), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1740), 10,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
    ACTIONS(1678), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [13610] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2044), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [13674] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1899), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [13738] = 19,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2046), 1,
      anon_sym_COLON,
    ACTIONS(2048), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [13804] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2050), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [13867] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2052), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [13930] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2054), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [13993] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2056), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [14056] = 14,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(693), 1,
      sym__unannotated_type,
    STATE(770), 1,
      sym_annotated_type,
    STATE(964), 1,
      sym__type,
    STATE(1091), 1,
      sym_type_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(661), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [14111] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2058), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [14174] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2060), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [14237] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2062), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [14300] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2064), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [14363] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2066), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [14426] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2068), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [14489] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2070), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [14552] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2072), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [14615] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2074), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [14678] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2076), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [14741] = 14,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(2078), 1,
      sym_identifier,
    ACTIONS(2080), 1,
      anon_sym_final,
    STATE(388), 1,
      sym__unannotated_type,
    STATE(403), 1,
      sym_scoped_type_identifier,
    STATE(416), 1,
      sym_generic_type,
    STATE(440), 1,
      sym__type,
    STATE(449), 1,
      sym_annotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2084), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(2086), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(421), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(663), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(2082), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [14796] = 17,
    ACTIONS(1046), 1,
      anon_sym_LT,
    ACTIONS(1160), 1,
      sym_identifier,
    ACTIONS(2029), 1,
      anon_sym_class,
    ACTIONS(2031), 1,
      anon_sym_enum,
    ACTIONS(2033), 1,
      anon_sym_record,
    ACTIONS(2035), 1,
      anon_sym_ATinterface,
    ACTIONS(2037), 1,
      anon_sym_interface,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(659), 1,
      sym_type_parameters,
    STATE(684), 1,
      sym_generic_type,
    STATE(694), 1,
      sym__unannotated_type,
    STATE(1047), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [14857] = 14,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(693), 1,
      sym__unannotated_type,
    STATE(770), 1,
      sym_annotated_type,
    STATE(964), 1,
      sym__type,
    STATE(1185), 1,
      sym_type_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(661), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [14912] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2088), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [14975] = 14,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(1160), 1,
      sym_identifier,
    ACTIONS(2090), 1,
      anon_sym_open,
    ACTIONS(2092), 1,
      anon_sym_module,
    ACTIONS(2094), 1,
      anon_sym_package,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(691), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(687), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [15030] = 14,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(693), 1,
      sym__unannotated_type,
    STATE(770), 1,
      sym_annotated_type,
    STATE(964), 1,
      sym__type,
    STATE(1203), 1,
      sym_type_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(661), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [15085] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2096), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [15148] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2098), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [15211] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2100), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [15274] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2102), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [15337] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2104), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [15400] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2106), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [15463] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2108), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [15526] = 18,
    ACTIONS(1839), 1,
      anon_sym_AMP,
    ACTIONS(1851), 1,
      anon_sym_SLASH,
    ACTIONS(1853), 1,
      anon_sym_PIPE,
    ACTIONS(1855), 1,
      anon_sym_CARET,
    ACTIONS(1859), 1,
      anon_sym_GT_GT,
    ACTIONS(1861), 1,
      anon_sym_instanceof,
    ACTIONS(1869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1873), 1,
      anon_sym_QMARK,
    ACTIONS(2110), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1769), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1841), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1845), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1847), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1849), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1857), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
  [15589] = 13,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(693), 1,
      sym__unannotated_type,
    STATE(770), 1,
      sym_annotated_type,
    STATE(1193), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(661), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [15641] = 13,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(693), 1,
      sym__unannotated_type,
    STATE(770), 1,
      sym_annotated_type,
    STATE(900), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(661), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [15693] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1371), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_default,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      anon_sym_throws,
      sym_this,
      sym_identifier,
    ACTIONS(1373), 12,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [15725] = 13,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(693), 1,
      sym__unannotated_type,
    STATE(770), 1,
      sym_annotated_type,
    STATE(1001), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(661), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [15777] = 13,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(693), 1,
      sym__unannotated_type,
    STATE(770), 1,
      sym_annotated_type,
    STATE(1044), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(661), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [15829] = 13,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(693), 1,
      sym__unannotated_type,
    STATE(770), 1,
      sym_annotated_type,
    STATE(903), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(661), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [15881] = 13,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(2078), 1,
      sym_identifier,
    STATE(388), 1,
      sym__unannotated_type,
    STATE(403), 1,
      sym_scoped_type_identifier,
    STATE(416), 1,
      sym_generic_type,
    STATE(433), 1,
      sym__type,
    STATE(449), 1,
      sym_annotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2084), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(2086), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(421), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(663), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(2082), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [15933] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1315), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_default,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      anon_sym_throws,
      sym_this,
      sym_identifier,
    ACTIONS(1317), 12,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [15965] = 13,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(693), 1,
      sym__unannotated_type,
    STATE(770), 1,
      sym_annotated_type,
    STATE(911), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(661), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [16017] = 13,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(693), 1,
      sym__unannotated_type,
    STATE(770), 1,
      sym_annotated_type,
    STATE(1155), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(661), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [16069] = 8,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(305), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1985), 1,
      sym_identifier,
    STATE(1000), 1,
      sym_enum_constant,
    STATE(1224), 1,
      sym_modifiers,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(538), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(299), 13,
      anon_sym_final,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [16110] = 12,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(1160), 1,
      sym_identifier,
    ACTIONS(2112), 1,
      anon_sym_QMARK,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(691), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(687), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [16159] = 6,
    ACTIONS(2114), 1,
      anon_sym_LPAREN,
    ACTIONS(2116), 1,
      anon_sym_DOT,
    STATE(676), 1,
      sym_annotation_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1435), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1433), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [16196] = 6,
    ACTIONS(2114), 1,
      anon_sym_LPAREN,
    ACTIONS(2118), 1,
      anon_sym_DOT,
    STATE(682), 1,
      sym_annotation_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1405), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1401), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [16233] = 11,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(729), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(687), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [16279] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1409), 8,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1411), 13,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [16309] = 14,
    ACTIONS(1160), 1,
      sym_identifier,
    ACTIONS(2029), 1,
      anon_sym_class,
    ACTIONS(2031), 1,
      anon_sym_enum,
    ACTIONS(2033), 1,
      anon_sym_record,
    ACTIONS(2035), 1,
      anon_sym_ATinterface,
    ACTIONS(2037), 1,
      anon_sym_interface,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(711), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [16361] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1425), 8,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1427), 13,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [16391] = 6,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(2120), 1,
      anon_sym_DOT,
    STATE(674), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1170), 7,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1194), 11,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [16427] = 6,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(2122), 1,
      anon_sym_DOT,
    STATE(671), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1380), 7,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1382), 11,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [16463] = 11,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(738), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(670), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [16509] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1429), 8,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1431), 13,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [16539] = 11,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(691), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(687), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [16585] = 12,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(2124), 1,
      sym_identifier,
    STATE(714), 1,
      sym_scoped_type_identifier,
    STATE(721), 1,
      sym_type_arguments,
    STATE(726), 1,
      sym_generic_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(2126), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(748), 2,
      sym_integral_type,
      sym_floating_point_type,
    STATE(678), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [16633] = 11,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(2078), 1,
      sym_identifier,
    STATE(387), 1,
      sym__unannotated_type,
    STATE(403), 1,
      sym_scoped_type_identifier,
    STATE(416), 1,
      sym_generic_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2084), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(2086), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(421), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(687), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(2082), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [16679] = 11,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(766), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(687), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [16725] = 12,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(2128), 1,
      sym_identifier,
    STATE(716), 1,
      sym_scoped_type_identifier,
    STATE(721), 1,
      sym_type_arguments,
    STATE(735), 1,
      sym_generic_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(2130), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(752), 2,
      sym_integral_type,
      sym_floating_point_type,
    STATE(686), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [16773] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1417), 8,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1419), 13,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [16803] = 11,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(2132), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(738), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(670), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [16849] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1353), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1351), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [16879] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1357), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1355), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [16909] = 11,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(741), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(687), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [16955] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1397), 8,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1399), 12,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [16984] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1439), 8,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1441), 12,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [17013] = 13,
    ACTIONS(1160), 1,
      sym_identifier,
    ACTIONS(2029), 1,
      anon_sym_class,
    ACTIONS(2031), 1,
      anon_sym_enum,
    ACTIONS(2035), 1,
      anon_sym_ATinterface,
    ACTIONS(2037), 1,
      anon_sym_interface,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(713), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [17062] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1413), 8,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1415), 12,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [17091] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1443), 8,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1445), 12,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [17120] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1596), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1594), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [17148] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1447), 8,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1449), 11,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [17176] = 10,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(2134), 1,
      sym_identifier,
    STATE(737), 1,
      sym_scoped_type_identifier,
    STATE(753), 1,
      sym_generic_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(2136), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(762), 2,
      sym_integral_type,
      sym_floating_point_type,
    STATE(687), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [17218] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1608), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1606), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [17246] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1492), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1490), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [17274] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1552), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1550), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [17302] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1592), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1590), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [17330] = 13,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2138), 1,
      sym_identifier,
    ACTIONS(2140), 1,
      anon_sym_DOT,
    ACTIONS(2144), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2146), 1,
      sym_this,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    STATE(1187), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1331), 3,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
    ACTIONS(2142), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [17378] = 4,
    ACTIONS(2122), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1380), 7,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1382), 11,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [17408] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1380), 8,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1382), 11,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [17436] = 10,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(2148), 1,
      sym_identifier,
    STATE(732), 1,
      sym_scoped_type_identifier,
    STATE(756), 1,
      sym_generic_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(2150), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(765), 2,
      sym_integral_type,
      sym_floating_point_type,
    STATE(687), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [17478] = 5,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(2156), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(687), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(2152), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [17510] = 13,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1331), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2159), 1,
      sym_identifier,
    ACTIONS(2161), 1,
      anon_sym_DOT,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    STATE(908), 1,
      sym__variable_declarator_id,
    STATE(1067), 1,
      sym_variable_declarator,
    STATE(1262), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2142), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [17556] = 10,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(719), 1,
      sym__unannotated_type,
    STATE(864), 1,
      sym_catch_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [17596] = 13,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1331), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2159), 1,
      sym_identifier,
    ACTIONS(2161), 1,
      anon_sym_DOT,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    STATE(905), 1,
      sym__variable_declarator_id,
    STATE(1067), 1,
      sym_variable_declarator,
    STATE(1225), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2142), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [17642] = 7,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1327), 9,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_implements,
      anon_sym_permits,
  [17676] = 13,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1331), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2159), 1,
      sym_identifier,
    ACTIONS(2161), 1,
      anon_sym_DOT,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    STATE(947), 1,
      sym__variable_declarator_id,
    STATE(1067), 1,
      sym_variable_declarator,
    STATE(1225), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2142), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [17722] = 7,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(1331), 8,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_implements,
      anon_sym_permits,
  [17755] = 12,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2163), 1,
      sym_identifier,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    STATE(908), 1,
      sym__variable_declarator_id,
    STATE(950), 1,
      sym__method_declarator,
    STATE(1067), 1,
      sym_variable_declarator,
    STATE(1238), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2165), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [17798] = 12,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2163), 1,
      sym_identifier,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    STATE(908), 1,
      sym__variable_declarator_id,
    STATE(950), 1,
      sym__method_declarator,
    STATE(1067), 1,
      sym_variable_declarator,
    STATE(1237), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2165), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [17841] = 9,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(709), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [17878] = 9,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(717), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [17915] = 10,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(2167), 1,
      sym_identifier,
    STATE(721), 1,
      sym_type_arguments,
    STATE(868), 1,
      sym_scoped_type_identifier,
    STATE(1071), 1,
      sym_generic_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(2169), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(1112), 2,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [17954] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2173), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
    ACTIONS(2171), 13,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [17979] = 12,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2163), 1,
      sym_identifier,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    STATE(908), 1,
      sym__variable_declarator_id,
    STATE(950), 1,
      sym__method_declarator,
    STATE(1067), 1,
      sym_variable_declarator,
    STATE(1246), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2165), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [18022] = 9,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(736), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [18059] = 9,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(733), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [18096] = 9,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(658), 1,
      sym_scoped_type_identifier,
    STATE(684), 1,
      sym_generic_type,
    STATE(723), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(81), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(685), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [18133] = 12,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2163), 1,
      sym_identifier,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    STATE(908), 1,
      sym__variable_declarator_id,
    STATE(950), 1,
      sym__method_declarator,
    STATE(1067), 1,
      sym_variable_declarator,
    STATE(1249), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2165), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [18176] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2177), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
    ACTIONS(2175), 13,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [18201] = 11,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1331), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2159), 1,
      sym_identifier,
    ACTIONS(2161), 1,
      anon_sym_DOT,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    STATE(1269), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2142), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [18241] = 12,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(2179), 1,
      anon_sym_LBRACK,
    ACTIONS(2181), 1,
      anon_sym_DOT,
    STATE(425), 1,
      sym_argument_list,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(674), 1,
      sym_type_arguments,
    STATE(1149), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(744), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(850), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [18283] = 12,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(2179), 1,
      anon_sym_LBRACK,
    ACTIONS(2181), 1,
      anon_sym_DOT,
    STATE(425), 1,
      sym_argument_list,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(674), 1,
      sym_type_arguments,
    STATE(1149), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(389), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(850), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [18325] = 11,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2159), 1,
      sym_identifier,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    STATE(902), 1,
      sym__variable_declarator_id,
    STATE(1067), 1,
      sym_variable_declarator,
    STATE(1218), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2142), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [18365] = 4,
    ACTIONS(2183), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1899), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1743), 10,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [18391] = 11,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2159), 1,
      sym_identifier,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    STATE(908), 1,
      sym__variable_declarator_id,
    STATE(1067), 1,
      sym_variable_declarator,
    STATE(1244), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2142), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [18431] = 11,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2185), 1,
      sym_identifier,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    STATE(908), 1,
      sym__variable_declarator_id,
    STATE(1067), 1,
      sym_variable_declarator,
    STATE(1237), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2142), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [18471] = 11,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2187), 1,
      sym_identifier,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    STATE(908), 1,
      sym__variable_declarator_id,
    STATE(1067), 1,
      sym_variable_declarator,
    STATE(1238), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2142), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [18511] = 12,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(2179), 1,
      anon_sym_LBRACK,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    STATE(424), 1,
      sym_argument_list,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(671), 1,
      sym_type_arguments,
    STATE(1156), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(390), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(850), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [18553] = 11,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2138), 1,
      sym_identifier,
    ACTIONS(2144), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2146), 1,
      sym_this,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    STATE(1187), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2142), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [18593] = 12,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(2179), 1,
      anon_sym_LBRACK,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    STATE(424), 1,
      sym_argument_list,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(671), 1,
      sym_type_arguments,
    STATE(1156), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(749), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(850), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [18635] = 11,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2159), 1,
      sym_identifier,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    STATE(962), 1,
      sym__variable_declarator_id,
    STATE(1067), 1,
      sym_variable_declarator,
    STATE(1218), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2142), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [18675] = 10,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(1190), 1,
      anon_sym_DOT,
    ACTIONS(1194), 1,
      anon_sym_AT,
    STATE(472), 1,
      sym_argument_list,
    STATE(674), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1187), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(2191), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(1170), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
  [18712] = 9,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2195), 1,
      anon_sym_PIPE,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    STATE(851), 1,
      aux_sym_catch_type_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2193), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [18747] = 10,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2144), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2159), 1,
      sym_identifier,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    STATE(1187), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2142), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [18784] = 8,
    ACTIONS(2197), 1,
      sym_identifier,
    STATE(872), 1,
      sym_scoped_type_identifier,
    STATE(1017), 1,
      sym_generic_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(79), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(2199), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(1143), 2,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(77), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [18817] = 6,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(2201), 1,
      anon_sym_DOT,
    STATE(671), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1380), 5,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1382), 6,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [18846] = 10,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2159), 1,
      sym_identifier,
    ACTIONS(2204), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    STATE(1136), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2142), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [18883] = 10,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(2181), 1,
      anon_sym_DOT,
    ACTIONS(2206), 1,
      anon_sym_LPAREN,
    STATE(448), 1,
      sym_block,
    STATE(674), 1,
      sym_type_arguments,
    STATE(1100), 1,
      sym_formal_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1194), 2,
      anon_sym_LBRACK,
      anon_sym_AT,
    ACTIONS(1170), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
  [18919] = 9,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2206), 1,
      anon_sym_LPAREN,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(758), 1,
      sym_formal_parameters,
    STATE(881), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2208), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [18953] = 10,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(2179), 1,
      anon_sym_LBRACK,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    STATE(424), 1,
      sym_argument_list,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(1156), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(390), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(850), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [18989] = 9,
    ACTIONS(2210), 1,
      anon_sym_RBRACE,
    ACTIONS(2212), 1,
      anon_sym_requires,
    ACTIONS(2215), 1,
      anon_sym_exports,
    ACTIONS(2218), 1,
      anon_sym_opens,
    ACTIONS(2221), 1,
      anon_sym_uses,
    ACTIONS(2224), 1,
      anon_sym_provides,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(727), 2,
      sym_module_directive,
      aux_sym_module_body_repeat1,
    STATE(825), 5,
      sym_requires_module_directive,
      sym_exports_module_directive,
      sym_opens_module_directive,
      sym_uses_module_directive,
      sym_provides_module_directive,
  [19023] = 10,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(2179), 1,
      anon_sym_LBRACK,
    ACTIONS(2181), 1,
      anon_sym_DOT,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(674), 1,
      sym_type_arguments,
    STATE(1105), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(747), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(850), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19059] = 9,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2227), 1,
      sym_identifier,
    ACTIONS(2229), 1,
      sym_this,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1327), 3,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19093] = 9,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2206), 1,
      anon_sym_LPAREN,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(759), 1,
      sym_formal_parameters,
    STATE(877), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2231), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19127] = 9,
    ACTIONS(2233), 1,
      anon_sym_RBRACE,
    ACTIONS(2235), 1,
      anon_sym_requires,
    ACTIONS(2237), 1,
      anon_sym_exports,
    ACTIONS(2239), 1,
      anon_sym_opens,
    ACTIONS(2241), 1,
      anon_sym_uses,
    ACTIONS(2243), 1,
      anon_sym_provides,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(743), 2,
      sym_module_directive,
      aux_sym_module_body_repeat1,
    STATE(825), 5,
      sym_requires_module_directive,
      sym_exports_module_directive,
      sym_opens_module_directive,
      sym_uses_module_directive,
      sym_provides_module_directive,
  [19161] = 10,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(2179), 1,
      anon_sym_LBRACK,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(671), 1,
      sym_type_arguments,
    STATE(1141), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(745), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(850), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19197] = 8,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2247), 1,
      anon_sym_PIPE,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2245), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19229] = 10,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(2179), 1,
      anon_sym_LBRACK,
    ACTIONS(2181), 1,
      anon_sym_DOT,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(674), 1,
      sym_type_arguments,
    STATE(1105), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(391), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(850), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19265] = 10,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(2179), 1,
      anon_sym_LBRACK,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    STATE(424), 1,
      sym_argument_list,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(1156), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(749), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(850), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19301] = 9,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2159), 1,
      sym_identifier,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    STATE(1212), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2142), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19335] = 10,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(2179), 1,
      anon_sym_LBRACK,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(671), 1,
      sym_type_arguments,
    STATE(1141), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(392), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(850), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19371] = 9,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2249), 1,
      sym_identifier,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    STATE(963), 1,
      sym__method_declarator,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2251), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19405] = 7,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(877), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(2231), 5,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [19435] = 7,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(881), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
    ACTIONS(2208), 5,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [19465] = 9,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2249), 1,
      sym_identifier,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    STATE(938), 1,
      sym__method_declarator,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2251), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19499] = 10,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(2181), 1,
      anon_sym_DOT,
    ACTIONS(2206), 1,
      anon_sym_LPAREN,
    STATE(441), 1,
      sym_block,
    STATE(674), 1,
      sym_type_arguments,
    STATE(1100), 1,
      sym_formal_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1194), 2,
      anon_sym_LBRACK,
      anon_sym_AT,
    ACTIONS(1170), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
  [19535] = 9,
    ACTIONS(2235), 1,
      anon_sym_requires,
    ACTIONS(2237), 1,
      anon_sym_exports,
    ACTIONS(2239), 1,
      anon_sym_opens,
    ACTIONS(2241), 1,
      anon_sym_uses,
    ACTIONS(2243), 1,
      anon_sym_provides,
    ACTIONS(2253), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(727), 2,
      sym_module_directive,
      aux_sym_module_body_repeat1,
    STATE(825), 5,
      sym_requires_module_directive,
      sym_exports_module_directive,
      sym_opens_module_directive,
      sym_uses_module_directive,
      sym_provides_module_directive,
  [19569] = 8,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(2179), 1,
      anon_sym_LBRACK,
    STATE(469), 1,
      sym_dimensions,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1335), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(397), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(850), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19600] = 8,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(2179), 1,
      anon_sym_LBRACK,
    STATE(473), 1,
      sym_dimensions,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1349), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(397), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(850), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19631] = 8,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2255), 1,
      anon_sym_LPAREN,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(877), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2231), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19662] = 8,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(2179), 1,
      anon_sym_LBRACK,
    STATE(490), 1,
      sym_dimensions,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1345), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(397), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(850), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19693] = 9,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(2179), 1,
      anon_sym_LBRACK,
    STATE(424), 1,
      sym_argument_list,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(1156), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(390), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(850), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19726] = 8,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(2179), 1,
      anon_sym_LBRACK,
    STATE(462), 1,
      sym_dimensions,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1341), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(397), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(850), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19757] = 8,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2257), 1,
      anon_sym_LPAREN,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(877), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2231), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19788] = 4,
    ACTIONS(2201), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1380), 5,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_this,
      sym_identifier,
    ACTIONS(1382), 6,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [19811] = 9,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(2179), 1,
      anon_sym_LBRACK,
    STATE(424), 1,
      sym_argument_list,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(1156), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(749), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(850), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19844] = 8,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(2179), 1,
      anon_sym_LBRACK,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(1141), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(392), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(850), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19874] = 9,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2259), 1,
      anon_sym_default,
    ACTIONS(2261), 1,
      anon_sym_SEMI,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(1002), 1,
      sym_dimensions,
    STATE(1198), 1,
      sym__default_value,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19906] = 8,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2263), 1,
      anon_sym_DOT,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(877), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2231), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19936] = 8,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(2179), 1,
      anon_sym_LBRACK,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(1141), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(745), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(850), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19966] = 9,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2259), 1,
      anon_sym_default,
    ACTIONS(2265), 1,
      anon_sym_SEMI,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(1038), 1,
      sym_dimensions,
    STATE(1230), 1,
      sym__default_value,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [19998] = 7,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(1055), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2267), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_throws,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20026] = 7,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(1056), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2269), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_throws,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20054] = 8,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(2181), 1,
      anon_sym_DOT,
    ACTIONS(2206), 1,
      anon_sym_LPAREN,
    STATE(674), 1,
      sym_type_arguments,
    STATE(1111), 1,
      sym_formal_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1194), 2,
      anon_sym_LBRACK,
      anon_sym_AT,
    ACTIONS(1170), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
  [20084] = 8,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1331), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2161), 1,
      anon_sym_DOT,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20113] = 7,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(2179), 1,
      anon_sym_LBRACK,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(1141), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(392), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(850), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20140] = 9,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      sym_identifier,
    ACTIONS(2273), 1,
      anon_sym_new,
    ACTIONS(2277), 1,
      sym_this,
    ACTIONS(2279), 1,
      sym_super,
    STATE(486), 1,
      sym__unqualified_object_creation_expression,
    STATE(867), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2275), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [20171] = 9,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      sym_identifier,
    ACTIONS(2273), 1,
      anon_sym_new,
    ACTIONS(2277), 1,
      sym_this,
    ACTIONS(2281), 1,
      sym_super,
    STATE(486), 1,
      sym__unqualified_object_creation_expression,
    STATE(949), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2275), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [20202] = 7,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(2179), 1,
      anon_sym_LBRACK,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(1141), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(745), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat2,
    STATE(850), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20229] = 8,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(1894), 1,
      anon_sym_LBRACK,
    ACTIONS(2227), 1,
      sym_identifier,
    ACTIONS(2229), 1,
      sym_this,
    STATE(540), 1,
      aux_sym_dimensions_repeat1,
    STATE(677), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(790), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20258] = 11,
    ACTIONS(1046), 1,
      anon_sym_LT,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    ACTIONS(2283), 1,
      anon_sym_extends,
    ACTIONS(2285), 1,
      anon_sym_implements,
    ACTIONS(2287), 1,
      anon_sym_permits,
    STATE(168), 1,
      sym_class_body,
    STATE(773), 1,
      sym_type_parameters,
    STATE(857), 1,
      sym_superclass,
    STATE(936), 1,
      sym_super_interfaces,
    STATE(1090), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20293] = 11,
    ACTIONS(1046), 1,
      anon_sym_LT,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    ACTIONS(2283), 1,
      anon_sym_extends,
    ACTIONS(2285), 1,
      anon_sym_implements,
    ACTIONS(2287), 1,
      anon_sym_permits,
    STATE(117), 1,
      sym_class_body,
    STATE(777), 1,
      sym_type_parameters,
    STATE(858), 1,
      sym_superclass,
    STATE(946), 1,
      sym_super_interfaces,
    STATE(1120), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20328] = 9,
    ACTIONS(2289), 1,
      sym_identifier,
    ACTIONS(2291), 1,
      anon_sym_open,
    ACTIONS(2293), 1,
      anon_sym_module,
    ACTIONS(2297), 1,
      anon_sym_record,
    STATE(778), 1,
      aux_sym_requires_module_directive_repeat1,
    STATE(848), 1,
      sym_requires_modifier,
    STATE(1186), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2295), 2,
      anon_sym_transitive,
      anon_sym_static,
  [20358] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1331), 9,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_implements,
      anon_sym_permits,
  [20374] = 7,
    ACTIONS(2299), 1,
      sym_identifier,
    STATE(769), 1,
      aux_sym_requires_module_directive_repeat1,
    STATE(848), 1,
      sym_requires_modifier,
    STATE(1173), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2295), 2,
      anon_sym_transitive,
      anon_sym_static,
    ACTIONS(2301), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [20400] = 8,
    ACTIONS(2303), 1,
      anon_sym_RBRACE,
    ACTIONS(2305), 1,
      anon_sym_case,
    ACTIONS(2307), 1,
      anon_sym_default,
    STATE(2), 1,
      aux_sym_switch_block_statement_group_repeat1,
    STATE(1078), 1,
      sym_switch_label,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(788), 2,
      sym_switch_block_statement_group,
      aux_sym_switch_block_repeat1,
    STATE(855), 2,
      sym_switch_rule,
      aux_sym_switch_block_repeat2,
  [20428] = 9,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    ACTIONS(2283), 1,
      anon_sym_extends,
    ACTIONS(2285), 1,
      anon_sym_implements,
    ACTIONS(2287), 1,
      anon_sym_permits,
    STATE(112), 1,
      sym_class_body,
    STATE(845), 1,
      sym_superclass,
    STATE(955), 1,
      sym_super_interfaces,
    STATE(1165), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20457] = 7,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      sym_identifier,
    ACTIONS(2277), 1,
      sym_this,
    ACTIONS(2281), 1,
      sym_super,
    STATE(949), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2275), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [20482] = 9,
    ACTIONS(1046), 1,
      anon_sym_LT,
    ACTIONS(2287), 1,
      anon_sym_permits,
    ACTIONS(2309), 1,
      anon_sym_extends,
    ACTIONS(2311), 1,
      anon_sym_LBRACE,
    STATE(149), 1,
      sym_interface_body,
    STATE(820), 1,
      sym_type_parameters,
    STATE(951), 1,
      sym_extends_interfaces,
    STATE(1168), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20511] = 9,
    ACTIONS(1046), 1,
      anon_sym_LT,
    ACTIONS(2287), 1,
      anon_sym_permits,
    ACTIONS(2309), 1,
      anon_sym_extends,
    ACTIONS(2311), 1,
      anon_sym_LBRACE,
    STATE(120), 1,
      sym_interface_body,
    STATE(847), 1,
      sym_type_parameters,
    STATE(954), 1,
      sym_extends_interfaces,
    STATE(1144), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20540] = 9,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    ACTIONS(2283), 1,
      anon_sym_extends,
    ACTIONS(2285), 1,
      anon_sym_implements,
    ACTIONS(2287), 1,
      anon_sym_permits,
    STATE(103), 1,
      sym_class_body,
    STATE(813), 1,
      sym_superclass,
    STATE(944), 1,
      sym_super_interfaces,
    STATE(1135), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20569] = 5,
    STATE(778), 1,
      aux_sym_requires_module_directive_repeat1,
    STATE(848), 1,
      sym_requires_modifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2315), 2,
      anon_sym_transitive,
      anon_sym_static,
    ACTIONS(2313), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
  [20590] = 5,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(2318), 1,
      sym_identifier,
    STATE(1118), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(826), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20610] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2320), 7,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_implements,
      anon_sym_throws,
  [20624] = 7,
    ACTIONS(2322), 1,
      anon_sym_RBRACE,
    ACTIONS(2324), 1,
      anon_sym_case,
    ACTIONS(2327), 1,
      anon_sym_default,
    STATE(2), 1,
      aux_sym_switch_block_statement_group_repeat1,
    STATE(1228), 1,
      sym_switch_label,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(781), 2,
      sym_switch_block_statement_group,
      aux_sym_switch_block_repeat1,
  [20648] = 6,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(886), 1,
      sym_argument_list,
    STATE(1051), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2330), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [20670] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2332), 7,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_implements,
      anon_sym_throws,
  [20684] = 6,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(885), 1,
      sym_argument_list,
    STATE(996), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2334), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [20706] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2336), 7,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_implements,
      anon_sym_throws,
  [20720] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2338), 7,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_implements,
      anon_sym_throws,
  [20734] = 5,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(2318), 1,
      sym_identifier,
    STATE(1035), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(826), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20754] = 7,
    ACTIONS(2307), 1,
      anon_sym_default,
    ACTIONS(2340), 1,
      anon_sym_RBRACE,
    ACTIONS(2342), 1,
      anon_sym_case,
    STATE(2), 1,
      aux_sym_switch_block_statement_group_repeat1,
    STATE(1228), 1,
      sym_switch_label,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(781), 2,
      sym_switch_block_statement_group,
      aux_sym_switch_block_repeat1,
  [20778] = 6,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(2344), 1,
      sym_identifier,
    ACTIONS(2348), 1,
      sym_this,
    STATE(941), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2346), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [20800] = 4,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(2350), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(795), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20817] = 4,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(2352), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(795), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20834] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2354), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [20847] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2356), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [20860] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2358), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [20873] = 4,
    ACTIONS(2154), 1,
      anon_sym_LBRACK,
    ACTIONS(2360), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(795), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20890] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2363), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [20903] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2365), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [20916] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2367), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [20929] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2369), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [20942] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2371), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [20955] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2373), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [20968] = 4,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(2375), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(811), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [20985] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2377), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [20998] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2379), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21011] = 5,
    ACTIONS(2159), 1,
      sym_identifier,
    STATE(908), 1,
      sym__variable_declarator_id,
    STATE(1096), 1,
      sym_variable_declarator,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2142), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [21030] = 5,
    ACTIONS(2159), 1,
      sym_identifier,
    STATE(908), 1,
      sym__variable_declarator_id,
    STATE(1191), 1,
      sym_variable_declarator,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2142), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [21049] = 5,
    ACTIONS(2381), 1,
      sym_identifier,
    ACTIONS(2385), 1,
      anon_sym_static,
    STATE(1119), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2383), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [21068] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2387), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21081] = 4,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(2389), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(822), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21098] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2391), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21111] = 4,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(2393), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(687), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21128] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2395), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21141] = 7,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    ACTIONS(2285), 1,
      anon_sym_implements,
    ACTIONS(2287), 1,
      anon_sym_permits,
    STATE(155), 1,
      sym_class_body,
    STATE(965), 1,
      sym_super_interfaces,
    STATE(1177), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21164] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2397), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21177] = 5,
    ACTIONS(2159), 1,
      sym_identifier,
    STATE(908), 1,
      sym__variable_declarator_id,
    STATE(1133), 1,
      sym_variable_declarator,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2142), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [21196] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2399), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21209] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2401), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21222] = 4,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(2403), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(795), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21239] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2405), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21252] = 7,
    ACTIONS(2287), 1,
      anon_sym_permits,
    ACTIONS(2309), 1,
      anon_sym_extends,
    ACTIONS(2311), 1,
      anon_sym_LBRACE,
    STATE(114), 1,
      sym_interface_body,
    STATE(907), 1,
      sym_extends_interfaces,
    STATE(1194), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21275] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2405), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21288] = 4,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(2407), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(687), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21305] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2409), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21318] = 4,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(2411), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(795), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21335] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2413), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21348] = 4,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(2415), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(687), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21365] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2417), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21378] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2405), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21391] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2419), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21404] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2421), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21417] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2423), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21430] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2425), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21443] = 4,
    ACTIONS(2427), 1,
      anon_sym_PIPE,
    STATE(833), 1,
      aux_sym_catch_type_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2245), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
  [21460] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2430), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21473] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2432), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21486] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2434), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21499] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2436), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21512] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2438), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21525] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2440), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21538] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2442), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21551] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2444), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21564] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2446), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21577] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2448), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21590] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2434), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [21603] = 7,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    ACTIONS(2285), 1,
      anon_sym_implements,
    ACTIONS(2287), 1,
      anon_sym_permits,
    STATE(121), 1,
      sym_class_body,
    STATE(957), 1,
      sym_super_interfaces,
    STATE(1145), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21626] = 4,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(2450), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(687), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21643] = 7,
    ACTIONS(2287), 1,
      anon_sym_permits,
    ACTIONS(2309), 1,
      anon_sym_extends,
    ACTIONS(2311), 1,
      anon_sym_LBRACE,
    STATE(141), 1,
      sym_interface_body,
    STATE(939), 1,
      sym_extends_interfaces,
    STATE(1122), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21666] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2452), 6,
      anon_sym_open,
      anon_sym_module,
      anon_sym_transitive,
      anon_sym_static,
      anon_sym_record,
      sym_identifier,
  [21679] = 4,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(2454), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(687), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21696] = 4,
    ACTIONS(301), 1,
      anon_sym_AT,
    ACTIONS(2456), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(795), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21713] = 4,
    ACTIONS(2195), 1,
      anon_sym_PIPE,
    STATE(833), 1,
      aux_sym_catch_type_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2458), 4,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
      sym_identifier,
  [21730] = 4,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(2460), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(846), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21747] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2462), 6,
      anon_sym_open,
      anon_sym_module,
      anon_sym_transitive,
      anon_sym_static,
      anon_sym_record,
      sym_identifier,
  [21760] = 6,
    ACTIONS(2464), 1,
      anon_sym_RBRACE,
    ACTIONS(2466), 1,
      anon_sym_case,
    ACTIONS(2469), 1,
      anon_sym_default,
    STATE(1226), 1,
      sym_switch_label,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(854), 2,
      sym_switch_rule,
      aux_sym_switch_block_repeat2,
  [21781] = 6,
    ACTIONS(2305), 1,
      anon_sym_case,
    ACTIONS(2307), 1,
      anon_sym_default,
    ACTIONS(2340), 1,
      anon_sym_RBRACE,
    STATE(1226), 1,
      sym_switch_label,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(854), 2,
      sym_switch_rule,
      aux_sym_switch_block_repeat2,
  [21802] = 4,
    ACTIONS(344), 1,
      anon_sym_AT,
    ACTIONS(2472), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(849), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_array_creation_expression_repeat1,
  [21819] = 7,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    ACTIONS(2285), 1,
      anon_sym_implements,
    ACTIONS(2287), 1,
      anon_sym_permits,
    STATE(111), 1,
      sym_class_body,
    STATE(935), 1,
      sym_super_interfaces,
    STATE(1130), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21842] = 7,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    ACTIONS(2285), 1,
      anon_sym_implements,
    ACTIONS(2287), 1,
      anon_sym_permits,
    STATE(136), 1,
      sym_class_body,
    STATE(914), 1,
      sym_super_interfaces,
    STATE(1131), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21865] = 4,
    ACTIONS(2474), 1,
      sym_identifier,
    STATE(410), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2476), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [21881] = 4,
    STATE(1166), 1,
      sym__wildcard_bounds,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2478), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    ACTIONS(2480), 2,
      anon_sym_extends,
      sym_super,
  [21897] = 4,
    ACTIONS(2482), 1,
      anon_sym_COMMA,
    STATE(861), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2485), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_permits,
  [21913] = 4,
    ACTIONS(2487), 1,
      sym_identifier,
    STATE(1163), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2489), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [21929] = 4,
    ACTIONS(2491), 1,
      sym_identifier,
    STATE(1013), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2493), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [21945] = 4,
    ACTIONS(2159), 1,
      sym_identifier,
    STATE(1273), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2142), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [21961] = 6,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(2181), 1,
      anon_sym_DOT,
    STATE(425), 1,
      sym_argument_list,
    STATE(674), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21981] = 4,
    ACTIONS(2495), 1,
      sym_identifier,
    STATE(1148), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2497), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [21997] = 4,
    ACTIONS(2499), 1,
      sym_identifier,
    ACTIONS(2503), 1,
      sym_super,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2501), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [22013] = 6,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    STATE(424), 1,
      sym_argument_list,
    STATE(671), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22033] = 4,
    ACTIONS(2505), 1,
      sym_identifier,
    STATE(652), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2507), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [22049] = 4,
    ACTIONS(2509), 1,
      sym_identifier,
    STATE(1025), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2511), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [22065] = 6,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(2181), 1,
      anon_sym_DOT,
    STATE(426), 1,
      sym_argument_list,
    STATE(674), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22085] = 6,
    ACTIONS(91), 1,
      anon_sym_LT,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    STATE(428), 1,
      sym_argument_list,
    STATE(671), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22105] = 4,
    ACTIONS(2159), 1,
      sym_identifier,
    STATE(1270), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2142), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [22121] = 4,
    ACTIONS(2513), 1,
      sym_identifier,
    STATE(1027), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2515), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [22137] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2191), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(1176), 3,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [22151] = 4,
    ACTIONS(2517), 1,
      sym_identifier,
    STATE(1159), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2519), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [22167] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2521), 5,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [22179] = 4,
    STATE(1082), 1,
      sym__wildcard_bounds,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2480), 2,
      anon_sym_extends,
      sym_super,
    ACTIONS(2523), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [22195] = 4,
    ACTIONS(2525), 1,
      sym_identifier,
    STATE(1020), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2527), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [22211] = 4,
    ACTIONS(2529), 1,
      sym_identifier,
    STATE(1175), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2531), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [22227] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2533), 5,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [22239] = 4,
    ACTIONS(2535), 1,
      sym_identifier,
    STATE(968), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2537), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [22255] = 6,
    ACTIONS(1991), 1,
      anon_sym_SEMI,
    ACTIONS(2019), 1,
      anon_sym_RBRACE,
    ACTIONS(2539), 1,
      anon_sym_COMMA,
    STATE(960), 1,
      aux_sym_enum_body_repeat1,
    STATE(1196), 1,
      sym_enum_body_declarations,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22275] = 4,
    ACTIONS(2541), 1,
      sym_identifier,
    STATE(1031), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2543), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [22291] = 4,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(1059), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2545), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [22307] = 4,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(1007), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2547), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [22323] = 4,
    ACTIONS(2549), 1,
      sym_identifier,
    STATE(522), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2551), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [22339] = 4,
    ACTIONS(2553), 1,
      sym_identifier,
    STATE(1126), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2555), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [22355] = 4,
    ACTIONS(2557), 1,
      sym_identifier,
    STATE(925), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2559), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [22371] = 5,
    ACTIONS(2561), 1,
      anon_sym_catch,
    ACTIONS(2563), 1,
      anon_sym_finally,
    STATE(237), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(90), 2,
      sym_catch_clause,
      aux_sym_try_statement_repeat1,
  [22389] = 4,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    STATE(464), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1258), 3,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [22405] = 4,
    ACTIONS(2565), 1,
      sym_identifier,
    STATE(923), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2567), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [22421] = 4,
    ACTIONS(2569), 1,
      sym_identifier,
    STATE(921), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2571), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [22437] = 4,
    ACTIONS(2573), 1,
      sym_identifier,
    STATE(919), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2575), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [22453] = 4,
    ACTIONS(2577), 1,
      sym_identifier,
    STATE(917), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2579), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [22469] = 4,
    ACTIONS(2581), 1,
      sym_identifier,
    STATE(915), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2583), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [22485] = 6,
    ACTIONS(1991), 1,
      anon_sym_SEMI,
    ACTIONS(2585), 1,
      anon_sym_COMMA,
    ACTIONS(2587), 1,
      anon_sym_RBRACE,
    STATE(883), 1,
      aux_sym_enum_body_repeat1,
    STATE(1195), 1,
      sym_enum_body_declarations,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22505] = 5,
    ACTIONS(1437), 1,
      anon_sym_DOT,
    ACTIONS(2589), 1,
      anon_sym_COMMA,
    ACTIONS(2591), 1,
      anon_sym_SEMI,
    STATE(977), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22522] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2593), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [22533] = 4,
    ACTIONS(2595), 1,
      anon_sym_AMP,
    STATE(943), 1,
      aux_sym_type_bound_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2597), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [22548] = 5,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(1706), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2599), 1,
      anon_sym_DOT,
    STATE(1257), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22565] = 4,
    ACTIONS(2601), 1,
      anon_sym_EQ,
    ACTIONS(2605), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2603), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [22580] = 4,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    STATE(933), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2609), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [22595] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2611), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [22606] = 4,
    ACTIONS(2601), 1,
      anon_sym_EQ,
    ACTIONS(2613), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2603), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [22621] = 5,
    ACTIONS(2285), 1,
      anon_sym_implements,
    ACTIONS(2615), 1,
      anon_sym_LBRACE,
    STATE(153), 1,
      sym_enum_body,
    STATE(1189), 1,
      sym_super_interfaces,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22638] = 5,
    ACTIONS(2287), 1,
      anon_sym_permits,
    ACTIONS(2311), 1,
      anon_sym_LBRACE,
    STATE(134), 1,
      sym_interface_body,
    STATE(1142), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22655] = 3,
    ACTIONS(2601), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2603), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [22668] = 5,
    ACTIONS(1046), 1,
      anon_sym_LT,
    ACTIONS(2206), 1,
      anon_sym_LPAREN,
    STATE(958), 1,
      sym_formal_parameters,
    STATE(1192), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22685] = 5,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    ACTIONS(2285), 1,
      anon_sym_implements,
    STATE(140), 1,
      sym_class_body,
    STATE(1123), 1,
      sym_super_interfaces,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22702] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2485), 4,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_permits,
  [22713] = 4,
    ACTIONS(2617), 1,
      anon_sym_COMMA,
    STATE(912), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1935), 2,
      anon_sym_DASH_GT,
      anon_sym_COLON,
  [22728] = 4,
    ACTIONS(2622), 1,
      anon_sym_extends,
    STATE(1088), 1,
      sym_type_bound,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2620), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [22743] = 5,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    ACTIONS(2287), 1,
      anon_sym_permits,
    STATE(158), 1,
      sym_class_body,
    STATE(1162), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22760] = 5,
    ACTIONS(1407), 1,
      anon_sym_DOT,
    ACTIONS(2589), 1,
      anon_sym_COMMA,
    ACTIONS(2624), 1,
      anon_sym_SEMI,
    STATE(979), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22777] = 5,
    ACTIONS(1437), 1,
      anon_sym_DOT,
    ACTIONS(2589), 1,
      anon_sym_COMMA,
    ACTIONS(2626), 1,
      anon_sym_SEMI,
    STATE(981), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22794] = 5,
    ACTIONS(1407), 1,
      anon_sym_DOT,
    ACTIONS(2589), 1,
      anon_sym_COMMA,
    ACTIONS(2628), 1,
      anon_sym_SEMI,
    STATE(982), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22811] = 5,
    ACTIONS(1437), 1,
      anon_sym_DOT,
    ACTIONS(2589), 1,
      anon_sym_COMMA,
    ACTIONS(2630), 1,
      anon_sym_SEMI,
    STATE(984), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22828] = 5,
    ACTIONS(1407), 1,
      anon_sym_DOT,
    ACTIONS(2589), 1,
      anon_sym_COMMA,
    ACTIONS(2632), 1,
      anon_sym_SEMI,
    STATE(985), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22845] = 5,
    ACTIONS(1437), 1,
      anon_sym_DOT,
    ACTIONS(2589), 1,
      anon_sym_COMMA,
    ACTIONS(2634), 1,
      anon_sym_SEMI,
    STATE(987), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22862] = 5,
    ACTIONS(1407), 1,
      anon_sym_DOT,
    ACTIONS(2589), 1,
      anon_sym_COMMA,
    ACTIONS(2636), 1,
      anon_sym_SEMI,
    STATE(988), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22879] = 5,
    ACTIONS(1437), 1,
      anon_sym_DOT,
    ACTIONS(2638), 1,
      anon_sym_COMMA,
    ACTIONS(2640), 1,
      anon_sym_SEMI,
    STATE(991), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22896] = 5,
    ACTIONS(1407), 1,
      anon_sym_DOT,
    ACTIONS(2638), 1,
      anon_sym_COMMA,
    ACTIONS(2642), 1,
      anon_sym_SEMI,
    STATE(993), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22913] = 5,
    ACTIONS(1437), 1,
      anon_sym_DOT,
    ACTIONS(2638), 1,
      anon_sym_COMMA,
    ACTIONS(2644), 1,
      anon_sym_SEMI,
    STATE(995), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22930] = 5,
    ACTIONS(1407), 1,
      anon_sym_DOT,
    ACTIONS(2638), 1,
      anon_sym_COMMA,
    ACTIONS(2646), 1,
      anon_sym_SEMI,
    STATE(997), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22947] = 4,
    ACTIONS(2622), 1,
      anon_sym_extends,
    STATE(1117), 1,
      sym_type_bound,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2648), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [22962] = 5,
    ACTIONS(2650), 1,
      anon_sym_LBRACE,
    ACTIONS(2652), 1,
      anon_sym_throws,
    STATE(450), 1,
      sym_constructor_body,
    STATE(1106), 1,
      sym_throws,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22979] = 4,
    ACTIONS(1929), 1,
      anon_sym_COMMA,
    STATE(912), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2654), 2,
      anon_sym_DASH_GT,
      anon_sym_COLON,
  [22994] = 4,
    ACTIONS(91), 1,
      anon_sym_LT,
    STATE(1081), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2656), 2,
      anon_sym_new,
      sym_identifier,
  [23009] = 5,
    ACTIONS(2650), 1,
      anon_sym_LBRACE,
    ACTIONS(2652), 1,
      anon_sym_throws,
    STATE(431), 1,
      sym_constructor_body,
    STATE(1115), 1,
      sym_throws,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23026] = 5,
    ACTIONS(1046), 1,
      anon_sym_LT,
    ACTIONS(2206), 1,
      anon_sym_LPAREN,
    STATE(910), 1,
      sym_formal_parameters,
    STATE(1138), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23043] = 5,
    ACTIONS(2285), 1,
      anon_sym_implements,
    ACTIONS(2615), 1,
      anon_sym_LBRACE,
    STATE(118), 1,
      sym_enum_body,
    STATE(1137), 1,
      sym_super_interfaces,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23060] = 4,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    STATE(861), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2658), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [23075] = 5,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    ACTIONS(2285), 1,
      anon_sym_implements,
    STATE(161), 1,
      sym_class_body,
    STATE(1158), 1,
      sym_super_interfaces,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23092] = 5,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    ACTIONS(2287), 1,
      anon_sym_permits,
    STATE(124), 1,
      sym_class_body,
    STATE(1157), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23109] = 5,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    ACTIONS(2287), 1,
      anon_sym_permits,
    STATE(110), 1,
      sym_class_body,
    STATE(1128), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23126] = 5,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    ACTIONS(2285), 1,
      anon_sym_implements,
    STATE(129), 1,
      sym_class_body,
    STATE(1147), 1,
      sym_super_interfaces,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23143] = 4,
    ACTIONS(2652), 1,
      anon_sym_throws,
    STATE(1107), 1,
      sym_throws,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2660), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [23158] = 5,
    ACTIONS(2287), 1,
      anon_sym_permits,
    ACTIONS(2311), 1,
      anon_sym_LBRACE,
    STATE(164), 1,
      sym_interface_body,
    STATE(1140), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23175] = 5,
    ACTIONS(2662), 1,
      anon_sym_LPAREN,
    ACTIONS(2664), 1,
      anon_sym_LBRACE,
    STATE(890), 1,
      sym_block,
    STATE(1132), 1,
      sym_resource_specification,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23192] = 3,
    ACTIONS(2666), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2668), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [23205] = 3,
    ACTIONS(2670), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2672), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [23218] = 4,
    ACTIONS(2595), 1,
      anon_sym_AMP,
    STATE(945), 1,
      aux_sym_type_bound_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2674), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [23233] = 5,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    ACTIONS(2287), 1,
      anon_sym_permits,
    STATE(156), 1,
      sym_class_body,
    STATE(1176), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23250] = 4,
    ACTIONS(2676), 1,
      anon_sym_AMP,
    STATE(945), 1,
      aux_sym_type_bound_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2679), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [23265] = 5,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    ACTIONS(2287), 1,
      anon_sym_permits,
    STATE(137), 1,
      sym_class_body,
    STATE(1129), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23282] = 4,
    ACTIONS(2601), 1,
      anon_sym_EQ,
    ACTIONS(2681), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2603), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [23297] = 5,
    ACTIONS(1706), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2683), 1,
      anon_sym_AMP,
    ACTIONS(2685), 1,
      anon_sym_RPAREN,
    STATE(1036), 1,
      aux_sym_cast_expression_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23314] = 3,
    ACTIONS(2499), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2501), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_record,
  [23327] = 4,
    ACTIONS(2652), 1,
      anon_sym_throws,
    STATE(1094), 1,
      sym_throws,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2687), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [23342] = 5,
    ACTIONS(2287), 1,
      anon_sym_permits,
    ACTIONS(2311), 1,
      anon_sym_LBRACE,
    STATE(105), 1,
      sym_interface_body,
    STATE(1097), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23359] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2689), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [23370] = 4,
    ACTIONS(2691), 1,
      anon_sym_COMMA,
    STATE(953), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1935), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [23385] = 5,
    ACTIONS(2287), 1,
      anon_sym_permits,
    ACTIONS(2311), 1,
      anon_sym_LBRACE,
    STATE(143), 1,
      sym_interface_body,
    STATE(1121), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23402] = 5,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    ACTIONS(2287), 1,
      anon_sym_permits,
    STATE(122), 1,
      sym_class_body,
    STATE(1154), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23419] = 4,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    STATE(861), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2694), 2,
      anon_sym_LBRACE,
      anon_sym_permits,
  [23434] = 5,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    ACTIONS(2287), 1,
      anon_sym_permits,
    STATE(145), 1,
      sym_class_body,
    STATE(1092), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23451] = 5,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    ACTIONS(2285), 1,
      anon_sym_implements,
    STATE(108), 1,
      sym_class_body,
    STATE(1084), 1,
      sym_super_interfaces,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23468] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2696), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [23479] = 4,
    ACTIONS(2698), 1,
      anon_sym_COMMA,
    STATE(960), 1,
      aux_sym_enum_body_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2701), 2,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [23494] = 5,
    ACTIONS(1706), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2683), 1,
      anon_sym_AMP,
    ACTIONS(2703), 1,
      anon_sym_RPAREN,
    STATE(1012), 1,
      aux_sym_cast_expression_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23511] = 4,
    ACTIONS(2601), 1,
      anon_sym_EQ,
    ACTIONS(2705), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2603), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [23526] = 4,
    ACTIONS(2652), 1,
      anon_sym_throws,
    STATE(1104), 1,
      sym_throws,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2707), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [23541] = 4,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    STATE(956), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2709), 2,
      anon_sym_LBRACE,
      anon_sym_permits,
  [23556] = 5,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    ACTIONS(2287), 1,
      anon_sym_permits,
    STATE(176), 1,
      sym_class_body,
    STATE(1103), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23573] = 4,
    ACTIONS(2711), 1,
      anon_sym_RPAREN,
    ACTIONS(2713), 1,
      anon_sym_COMMA,
    STATE(966), 1,
      aux_sym_formal_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23587] = 4,
    ACTIONS(2716), 1,
      anon_sym_RPAREN,
    ACTIONS(2718), 1,
      anon_sym_COMMA,
    STATE(967), 1,
      aux_sym_annotation_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23601] = 4,
    ACTIONS(1407), 1,
      anon_sym_DOT,
    ACTIONS(2721), 1,
      anon_sym_LBRACE,
    STATE(195), 1,
      sym_module_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23615] = 4,
    ACTIONS(2723), 1,
      anon_sym_GT,
    ACTIONS(2725), 1,
      anon_sym_COMMA,
    STATE(1076), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23629] = 4,
    ACTIONS(2727), 1,
      sym_identifier,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    STATE(1254), 1,
      sym_asterisk,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23643] = 4,
    ACTIONS(2725), 1,
      anon_sym_COMMA,
    ACTIONS(2731), 1,
      anon_sym_GT,
    STATE(969), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23657] = 4,
    ACTIONS(2733), 1,
      anon_sym_COMMA,
    ACTIONS(2736), 1,
      anon_sym_SEMI,
    STATE(972), 1,
      aux_sym__variable_declarator_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23671] = 4,
    ACTIONS(2738), 1,
      anon_sym_RPAREN,
    ACTIONS(2740), 1,
      anon_sym_COMMA,
    STATE(1014), 1,
      aux_sym_annotation_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23685] = 4,
    ACTIONS(2740), 1,
      anon_sym_COMMA,
    ACTIONS(2742), 1,
      anon_sym_RPAREN,
    STATE(967), 1,
      aux_sym_annotation_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23699] = 4,
    ACTIONS(2740), 1,
      anon_sym_COMMA,
    ACTIONS(2744), 1,
      anon_sym_RPAREN,
    STATE(974), 1,
      aux_sym_annotation_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23713] = 4,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2746), 1,
      sym_identifier,
    STATE(1240), 1,
      sym_asterisk,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23727] = 4,
    ACTIONS(2589), 1,
      anon_sym_COMMA,
    ACTIONS(2748), 1,
      anon_sym_SEMI,
    STATE(1022), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23741] = 4,
    ACTIONS(2750), 1,
      anon_sym_RPAREN,
    ACTIONS(2752), 1,
      anon_sym_SEMI,
    STATE(978), 1,
      aux_sym_resource_specification_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23755] = 4,
    ACTIONS(2589), 1,
      anon_sym_COMMA,
    ACTIONS(2755), 1,
      anon_sym_SEMI,
    STATE(1022), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23769] = 4,
    ACTIONS(2757), 1,
      anon_sym_RPAREN,
    ACTIONS(2759), 1,
      anon_sym_COMMA,
    STATE(966), 1,
      aux_sym_formal_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23783] = 4,
    ACTIONS(2589), 1,
      anon_sym_COMMA,
    ACTIONS(2761), 1,
      anon_sym_SEMI,
    STATE(1022), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23797] = 4,
    ACTIONS(2589), 1,
      anon_sym_COMMA,
    ACTIONS(2763), 1,
      anon_sym_SEMI,
    STATE(1022), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23811] = 4,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(2765), 1,
      anon_sym_SEMI,
    STATE(452), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23825] = 4,
    ACTIONS(2589), 1,
      anon_sym_COMMA,
    ACTIONS(2767), 1,
      anon_sym_SEMI,
    STATE(1022), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23839] = 4,
    ACTIONS(2589), 1,
      anon_sym_COMMA,
    ACTIONS(2769), 1,
      anon_sym_SEMI,
    STATE(1022), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23853] = 4,
    ACTIONS(1991), 1,
      anon_sym_SEMI,
    ACTIONS(2587), 1,
      anon_sym_RBRACE,
    STATE(1195), 1,
      sym_enum_body_declarations,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23867] = 4,
    ACTIONS(2589), 1,
      anon_sym_COMMA,
    ACTIONS(2771), 1,
      anon_sym_SEMI,
    STATE(1022), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23881] = 4,
    ACTIONS(2589), 1,
      anon_sym_COMMA,
    ACTIONS(2773), 1,
      anon_sym_SEMI,
    STATE(1022), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23895] = 4,
    ACTIONS(2775), 1,
      anon_sym_AMP,
    ACTIONS(2778), 1,
      anon_sym_RPAREN,
    STATE(989), 1,
      aux_sym_cast_expression_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23909] = 4,
    ACTIONS(2780), 1,
      anon_sym_COMMA,
    ACTIONS(2783), 1,
      anon_sym_SEMI,
    STATE(990), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23923] = 4,
    ACTIONS(2638), 1,
      anon_sym_COMMA,
    ACTIONS(2785), 1,
      anon_sym_SEMI,
    STATE(1033), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23937] = 4,
    ACTIONS(1702), 1,
      anon_sym_LBRACK,
    ACTIONS(1704), 1,
      anon_sym_DOT,
    ACTIONS(1706), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23951] = 4,
    ACTIONS(2638), 1,
      anon_sym_COMMA,
    ACTIONS(2787), 1,
      anon_sym_SEMI,
    STATE(1033), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23965] = 4,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(2789), 1,
      anon_sym_RPAREN,
    STATE(1064), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23979] = 4,
    ACTIONS(2638), 1,
      anon_sym_COMMA,
    ACTIONS(2791), 1,
      anon_sym_SEMI,
    STATE(1033), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23993] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2793), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [24003] = 4,
    ACTIONS(2638), 1,
      anon_sym_COMMA,
    ACTIONS(2795), 1,
      anon_sym_SEMI,
    STATE(1033), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24017] = 4,
    ACTIONS(2759), 1,
      anon_sym_COMMA,
    ACTIONS(2797), 1,
      anon_sym_RPAREN,
    STATE(980), 1,
      aux_sym_formal_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24031] = 4,
    ACTIONS(1437), 1,
      anon_sym_DOT,
    ACTIONS(2721), 1,
      anon_sym_LBRACE,
    STATE(196), 1,
      sym_module_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24045] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2701), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [24055] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2799), 3,
      anon_sym_LBRACE,
      anon_sym_implements,
      anon_sym_permits,
  [24065] = 4,
    ACTIONS(2259), 1,
      anon_sym_default,
    ACTIONS(2801), 1,
      anon_sym_SEMI,
    STATE(1281), 1,
      sym__default_value,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24079] = 4,
    ACTIONS(1369), 1,
      anon_sym_RPAREN,
    ACTIONS(2759), 1,
      anon_sym_COMMA,
    STATE(1004), 1,
      aux_sym_formal_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24093] = 4,
    ACTIONS(2759), 1,
      anon_sym_COMMA,
    ACTIONS(2797), 1,
      anon_sym_RPAREN,
    STATE(966), 1,
      aux_sym_formal_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24107] = 4,
    ACTIONS(1437), 1,
      anon_sym_DOT,
    ACTIONS(2721), 1,
      anon_sym_LBRACE,
    STATE(222), 1,
      sym_module_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24121] = 4,
    ACTIONS(2740), 1,
      anon_sym_COMMA,
    ACTIONS(2803), 1,
      anon_sym_RPAREN,
    STATE(967), 1,
      aux_sym_annotation_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24135] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2805), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [24145] = 4,
    ACTIONS(2807), 1,
      anon_sym_COMMA,
    ACTIONS(2809), 1,
      anon_sym_RBRACE,
    STATE(1011), 1,
      aux_sym_element_value_array_initializer_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24159] = 4,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(2811), 1,
      anon_sym_RPAREN,
    STATE(1064), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24173] = 4,
    ACTIONS(2740), 1,
      anon_sym_COMMA,
    ACTIONS(2813), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      aux_sym_annotation_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24187] = 4,
    ACTIONS(366), 1,
      anon_sym_RBRACE,
    ACTIONS(2815), 1,
      anon_sym_COMMA,
    STATE(1069), 1,
      aux_sym_element_value_array_initializer_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24201] = 4,
    ACTIONS(2683), 1,
      anon_sym_AMP,
    ACTIONS(2817), 1,
      anon_sym_RPAREN,
    STATE(989), 1,
      aux_sym_cast_expression_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24215] = 4,
    ACTIONS(1407), 1,
      anon_sym_DOT,
    ACTIONS(2721), 1,
      anon_sym_LBRACE,
    STATE(214), 1,
      sym_module_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24229] = 4,
    ACTIONS(2740), 1,
      anon_sym_COMMA,
    ACTIONS(2819), 1,
      anon_sym_RPAREN,
    STATE(967), 1,
      aux_sym_annotation_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24243] = 4,
    ACTIONS(1203), 1,
      anon_sym_COMMA,
    ACTIONS(2821), 1,
      anon_sym_RPAREN,
    STATE(1037), 1,
      aux_sym_inferred_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24257] = 4,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(2823), 1,
      anon_sym_RPAREN,
    STATE(1064), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24271] = 4,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    STATE(428), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24285] = 4,
    ACTIONS(2725), 1,
      anon_sym_COMMA,
    ACTIONS(2825), 1,
      anon_sym_GT,
    STATE(1076), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24299] = 3,
    ACTIONS(1437), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2827), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [24311] = 3,
    ACTIONS(1407), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2829), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [24323] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2013), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [24333] = 4,
    ACTIONS(2831), 1,
      anon_sym_COMMA,
    ACTIONS(2834), 1,
      anon_sym_SEMI,
    STATE(1022), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24347] = 4,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2746), 1,
      sym_identifier,
    STATE(1221), 1,
      sym_asterisk,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24361] = 4,
    ACTIONS(1437), 1,
      anon_sym_DOT,
    ACTIONS(2836), 1,
      anon_sym_SEMI,
    ACTIONS(2838), 1,
      anon_sym_to,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24375] = 4,
    ACTIONS(1407), 1,
      anon_sym_DOT,
    ACTIONS(2840), 1,
      anon_sym_SEMI,
    ACTIONS(2842), 1,
      anon_sym_to,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24389] = 4,
    ACTIONS(1437), 1,
      anon_sym_DOT,
    ACTIONS(2844), 1,
      anon_sym_SEMI,
    ACTIONS(2846), 1,
      anon_sym_to,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24403] = 4,
    ACTIONS(1407), 1,
      anon_sym_DOT,
    ACTIONS(2848), 1,
      anon_sym_SEMI,
    ACTIONS(2850), 1,
      anon_sym_to,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24417] = 4,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(2852), 1,
      anon_sym_RPAREN,
    STATE(1064), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24431] = 4,
    ACTIONS(2727), 1,
      sym_identifier,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    STATE(1232), 1,
      sym_asterisk,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24445] = 3,
    ACTIONS(1437), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2854), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [24457] = 3,
    ACTIONS(1407), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2856), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [24469] = 4,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(2858), 1,
      anon_sym_RPAREN,
    STATE(1064), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24483] = 4,
    ACTIONS(2860), 1,
      anon_sym_COMMA,
    ACTIONS(2863), 1,
      anon_sym_SEMI,
    STATE(1033), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24497] = 4,
    ACTIONS(2725), 1,
      anon_sym_COMMA,
    ACTIONS(2865), 1,
      anon_sym_GT,
    STATE(1018), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24511] = 4,
    ACTIONS(2867), 1,
      anon_sym_GT,
    ACTIONS(2869), 1,
      anon_sym_COMMA,
    STATE(1062), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24525] = 4,
    ACTIONS(2683), 1,
      anon_sym_AMP,
    ACTIONS(2871), 1,
      anon_sym_RPAREN,
    STATE(989), 1,
      aux_sym_cast_expression_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24539] = 4,
    ACTIONS(2873), 1,
      anon_sym_RPAREN,
    ACTIONS(2875), 1,
      anon_sym_COMMA,
    STATE(1037), 1,
      aux_sym_inferred_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24553] = 4,
    ACTIONS(2259), 1,
      anon_sym_default,
    ACTIONS(2878), 1,
      anon_sym_SEMI,
    STATE(1276), 1,
      sym__default_value,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24567] = 4,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(2880), 1,
      anon_sym_RPAREN,
    STATE(1064), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24581] = 4,
    ACTIONS(1959), 1,
      anon_sym_COMMA,
    ACTIONS(2654), 1,
      anon_sym_COLON,
    STATE(953), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24595] = 4,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(2882), 1,
      anon_sym_DOT,
    STATE(1239), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24609] = 4,
    ACTIONS(2039), 1,
      anon_sym_RBRACE,
    ACTIONS(2884), 1,
      anon_sym_COMMA,
    STATE(1042), 1,
      aux_sym_array_initializer_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24623] = 4,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(2887), 1,
      anon_sym_RPAREN,
    STATE(1064), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24637] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2679), 3,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_COMMA,
  [24647] = 4,
    ACTIONS(1959), 1,
      anon_sym_COMMA,
    ACTIONS(2889), 1,
      anon_sym_RPAREN,
    STATE(953), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24661] = 4,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(2891), 1,
      anon_sym_RPAREN,
    STATE(1064), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24675] = 4,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(2893), 1,
      anon_sym_SEMI,
    STATE(434), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24689] = 4,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(2895), 1,
      anon_sym_RPAREN,
    STATE(1064), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24703] = 4,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(2897), 1,
      anon_sym_RPAREN,
    STATE(1064), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24717] = 4,
    ACTIONS(1945), 1,
      anon_sym_COMMA,
    ACTIONS(2899), 1,
      anon_sym_SEMI,
    STATE(990), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24731] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2901), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [24741] = 4,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(2903), 1,
      anon_sym_RPAREN,
    STATE(1064), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24755] = 4,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(2905), 1,
      anon_sym_RPAREN,
    STATE(1064), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24769] = 4,
    ACTIONS(2907), 1,
      anon_sym_RPAREN,
    ACTIONS(2909), 1,
      anon_sym_SEMI,
    STATE(1058), 1,
      aux_sym_resource_specification_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24783] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2911), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_throws,
  [24793] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2913), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_throws,
  [24803] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2915), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [24813] = 4,
    ACTIONS(1030), 1,
      anon_sym_RPAREN,
    ACTIONS(2917), 1,
      anon_sym_SEMI,
    STATE(978), 1,
      aux_sym_resource_specification_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24827] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2919), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [24837] = 4,
    ACTIONS(2921), 1,
      anon_sym_COMMA,
    ACTIONS(2923), 1,
      anon_sym_SEMI,
    STATE(972), 1,
      aux_sym__variable_declarator_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24851] = 4,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(2925), 1,
      anon_sym_RPAREN,
    STATE(1064), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24865] = 4,
    ACTIONS(2869), 1,
      anon_sym_COMMA,
    ACTIONS(2927), 1,
      anon_sym_GT,
    STATE(1073), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24879] = 4,
    ACTIONS(1951), 1,
      anon_sym_COMMA,
    ACTIONS(1953), 1,
      anon_sym_RBRACE,
    STATE(1077), 1,
      aux_sym_array_initializer_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24893] = 4,
    ACTIONS(2929), 1,
      anon_sym_RPAREN,
    ACTIONS(2931), 1,
      anon_sym_COMMA,
    STATE(1064), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24907] = 4,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(2934), 1,
      anon_sym_RPAREN,
    STATE(1064), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24921] = 4,
    ACTIONS(1203), 1,
      anon_sym_COMMA,
    ACTIONS(2936), 1,
      anon_sym_RPAREN,
    STATE(1037), 1,
      aux_sym_inferred_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24935] = 4,
    ACTIONS(2921), 1,
      anon_sym_COMMA,
    ACTIONS(2938), 1,
      anon_sym_SEMI,
    STATE(1060), 1,
      aux_sym__variable_declarator_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24949] = 4,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(2940), 1,
      anon_sym_RPAREN,
    STATE(1064), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24963] = 4,
    ACTIONS(2942), 1,
      anon_sym_COMMA,
    ACTIONS(2945), 1,
      anon_sym_RBRACE,
    STATE(1069), 1,
      aux_sym_element_value_array_initializer_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24977] = 4,
    ACTIONS(1945), 1,
      anon_sym_COMMA,
    ACTIONS(2947), 1,
      anon_sym_SEMI,
    STATE(990), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [24991] = 4,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    STATE(424), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25005] = 4,
    ACTIONS(1407), 1,
      anon_sym_DOT,
    ACTIONS(2721), 1,
      anon_sym_LBRACE,
    STATE(251), 1,
      sym_module_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25019] = 4,
    ACTIONS(2949), 1,
      anon_sym_GT,
    ACTIONS(2951), 1,
      anon_sym_COMMA,
    STATE(1073), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25033] = 4,
    ACTIONS(1939), 1,
      anon_sym_COMMA,
    ACTIONS(2954), 1,
      anon_sym_RPAREN,
    STATE(1064), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25047] = 4,
    ACTIONS(1437), 1,
      anon_sym_DOT,
    ACTIONS(2721), 1,
      anon_sym_LBRACE,
    STATE(250), 1,
      sym_module_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25061] = 4,
    ACTIONS(2956), 1,
      anon_sym_GT,
    ACTIONS(2958), 1,
      anon_sym_COMMA,
    STATE(1076), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25075] = 4,
    ACTIONS(528), 1,
      anon_sym_RBRACE,
    ACTIONS(2961), 1,
      anon_sym_COMMA,
    STATE(1042), 1,
      aux_sym_array_initializer_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25089] = 3,
    ACTIONS(2963), 1,
      anon_sym_DASH_GT,
    ACTIONS(2965), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25100] = 3,
    ACTIONS(1437), 1,
      anon_sym_DOT,
    ACTIONS(2967), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25111] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2956), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [25120] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2969), 2,
      anon_sym_new,
      sym_identifier,
  [25129] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2971), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [25138] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2945), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [25147] = 3,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(130), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25158] = 3,
    ACTIONS(1018), 1,
      anon_sym_LPAREN,
    STATE(1264), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25169] = 3,
    ACTIONS(1018), 1,
      anon_sym_LPAREN,
    STATE(1150), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25180] = 3,
    ACTIONS(1018), 1,
      anon_sym_LPAREN,
    STATE(45), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25191] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2973), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [25200] = 3,
    ACTIONS(2664), 1,
      anon_sym_LBRACE,
    STATE(100), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25211] = 3,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(109), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25222] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2975), 2,
      anon_sym_LBRACE,
      anon_sym_permits,
  [25231] = 3,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(167), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25242] = 3,
    ACTIONS(2977), 1,
      sym_identifier,
    ACTIONS(2979), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25253] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2981), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [25262] = 3,
    ACTIONS(2983), 1,
      sym_identifier,
    ACTIONS(2985), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25273] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2987), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [25282] = 3,
    ACTIONS(2311), 1,
      anon_sym_LBRACE,
    STATE(135), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25293] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2989), 2,
      sym_this,
      sym_super,
  [25302] = 3,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    STATE(484), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25313] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2991), 2,
      anon_sym_LBRACE,
      anon_sym_throws,
  [25322] = 3,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    STATE(1248), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25333] = 3,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    STATE(485), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25344] = 3,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(170), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25355] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2993), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [25364] = 3,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    STATE(487), 1,
      sym_array_initializer,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25375] = 3,
    ACTIONS(2650), 1,
      anon_sym_LBRACE,
    STATE(436), 1,
      sym_constructor_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25386] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2995), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [25395] = 3,
    ACTIONS(2206), 1,
      anon_sym_LPAREN,
    STATE(759), 1,
      sym_formal_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25406] = 3,
    ACTIONS(2206), 1,
      anon_sym_LPAREN,
    STATE(758), 1,
      sym_formal_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25417] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2039), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [25426] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2997), 2,
      anon_sym_LBRACE,
      anon_sym_throws,
  [25435] = 3,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    STATE(424), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25446] = 3,
    ACTIONS(1018), 1,
      anon_sym_LPAREN,
    STATE(18), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25457] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2999), 2,
      anon_sym_DASH_GT,
      anon_sym_COLON,
  [25466] = 3,
    ACTIONS(2650), 1,
      anon_sym_LBRACE,
    STATE(443), 1,
      sym_constructor_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25477] = 3,
    ACTIONS(3001), 1,
      anon_sym_LBRACE,
    STATE(150), 1,
      sym_annotation_type_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25488] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3003), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [25497] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2949), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [25506] = 3,
    ACTIONS(3005), 1,
      anon_sym_DOT,
    ACTIONS(3007), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25517] = 3,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(138), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25528] = 3,
    ACTIONS(2311), 1,
      anon_sym_LBRACE,
    STATE(165), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25539] = 3,
    ACTIONS(2311), 1,
      anon_sym_LBRACE,
    STATE(163), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25550] = 3,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(162), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25561] = 3,
    ACTIONS(3001), 1,
      anon_sym_LBRACE,
    STATE(119), 1,
      sym_annotation_type_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25572] = 3,
    ACTIONS(3009), 1,
      anon_sym_DOT,
    ACTIONS(3011), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25583] = 3,
    ACTIONS(1407), 1,
      anon_sym_DOT,
    ACTIONS(3013), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25594] = 3,
    ACTIONS(1437), 1,
      anon_sym_DOT,
    ACTIONS(3015), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25605] = 3,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(126), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25616] = 3,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(160), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25627] = 3,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(125), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25638] = 3,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(159), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25649] = 3,
    ACTIONS(2664), 1,
      anon_sym_LBRACE,
    STATE(88), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25660] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3017), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [25669] = 3,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    STATE(231), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25680] = 3,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(157), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25691] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3019), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [25700] = 3,
    ACTIONS(2615), 1,
      anon_sym_LBRACE,
    STATE(139), 1,
      sym_enum_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25711] = 3,
    ACTIONS(2206), 1,
      anon_sym_LPAREN,
    STATE(934), 1,
      sym_formal_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25722] = 3,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    STATE(190), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25733] = 3,
    ACTIONS(2311), 1,
      anon_sym_LBRACE,
    STATE(179), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25744] = 3,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    STATE(471), 1,
      sym_array_initializer,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25755] = 3,
    ACTIONS(2311), 1,
      anon_sym_LBRACE,
    STATE(154), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25766] = 3,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    STATE(428), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25777] = 3,
    ACTIONS(2311), 1,
      anon_sym_LBRACE,
    STATE(142), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25788] = 3,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(146), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25799] = 3,
    ACTIONS(1437), 1,
      anon_sym_DOT,
    ACTIONS(3021), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25810] = 3,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(152), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25821] = 3,
    ACTIONS(1407), 1,
      anon_sym_DOT,
    ACTIONS(3023), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25832] = 3,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    STATE(459), 1,
      sym_array_initializer,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25843] = 3,
    ACTIONS(3025), 1,
      anon_sym_LBRACE,
    STATE(81), 1,
      sym_switch_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25854] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3027), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [25863] = 3,
    ACTIONS(882), 1,
      anon_sym_while,
    ACTIONS(3029), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25874] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2873), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [25883] = 3,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(147), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25894] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3031), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [25903] = 3,
    ACTIONS(362), 1,
      anon_sym_LBRACE,
    STATE(479), 1,
      sym_array_initializer,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25914] = 3,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(148), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25925] = 3,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(104), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25936] = 3,
    ACTIONS(1407), 1,
      anon_sym_DOT,
    ACTIONS(3033), 1,
      anon_sym_with,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25947] = 3,
    ACTIONS(1437), 1,
      anon_sym_DOT,
    ACTIONS(3035), 1,
      anon_sym_with,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25958] = 3,
    ACTIONS(3037), 1,
      anon_sym_DOT,
    ACTIONS(3039), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25969] = 3,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(169), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25980] = 3,
    ACTIONS(1407), 1,
      anon_sym_DOT,
    ACTIONS(3041), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [25991] = 3,
    ACTIONS(1437), 1,
      anon_sym_DOT,
    ACTIONS(3043), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26002] = 3,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(123), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26013] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2523), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [26022] = 3,
    ACTIONS(1407), 1,
      anon_sym_DOT,
    ACTIONS(3045), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26033] = 3,
    ACTIONS(2311), 1,
      anon_sym_LBRACE,
    STATE(113), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26044] = 3,
    ACTIONS(1018), 1,
      anon_sym_LPAREN,
    STATE(60), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26055] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3047), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [26064] = 3,
    ACTIONS(1018), 1,
      anon_sym_LPAREN,
    STATE(58), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26075] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2750), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [26084] = 3,
    ACTIONS(1407), 1,
      anon_sym_DOT,
    ACTIONS(3049), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26095] = 3,
    ACTIONS(1437), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26106] = 3,
    ACTIONS(3053), 1,
      anon_sym_DOT,
    ACTIONS(3055), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26117] = 3,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(171), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26128] = 3,
    ACTIONS(1463), 1,
      anon_sym_LBRACE,
    STATE(175), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26139] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2716), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [26148] = 3,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    STATE(478), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26159] = 3,
    ACTIONS(1706), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2599), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26170] = 3,
    ACTIONS(3057), 1,
      sym_identifier,
    STATE(1178), 1,
      sym_element_value_pair,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26181] = 3,
    ACTIONS(1437), 1,
      anon_sym_DOT,
    ACTIONS(3059), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26192] = 3,
    ACTIONS(1437), 1,
      anon_sym_DOT,
    ACTIONS(3061), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26203] = 3,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    STATE(466), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26214] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3063), 2,
      anon_sym_LBRACE,
      anon_sym_permits,
  [26223] = 3,
    ACTIONS(1407), 1,
      anon_sym_DOT,
    ACTIONS(3065), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26234] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3067), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [26243] = 3,
    ACTIONS(1172), 1,
      anon_sym_LPAREN,
    STATE(1279), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26254] = 3,
    ACTIONS(2615), 1,
      anon_sym_LBRACE,
    STATE(116), 1,
      sym_enum_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26265] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2711), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [26274] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3069), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [26283] = 3,
    ACTIONS(2206), 1,
      anon_sym_LPAREN,
    STATE(937), 1,
      sym_formal_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26294] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3071), 2,
      anon_sym_AMP,
      anon_sym_RPAREN,
  [26303] = 3,
    ACTIONS(2311), 1,
      anon_sym_LBRACE,
    STATE(133), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26314] = 2,
    ACTIONS(2019), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26322] = 2,
    ACTIONS(2017), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26330] = 2,
    ACTIONS(3073), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26338] = 2,
    ACTIONS(3075), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26346] = 2,
    ACTIONS(3077), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26354] = 2,
    ACTIONS(988), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26362] = 2,
    ACTIONS(1706), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26370] = 2,
    ACTIONS(2587), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26378] = 2,
    ACTIONS(3079), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26386] = 2,
    ACTIONS(2809), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26394] = 2,
    ACTIONS(3081), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26402] = 2,
    ACTIONS(1185), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26410] = 2,
    ACTIONS(2813), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26418] = 2,
    ACTIONS(3083), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26426] = 2,
    ACTIONS(3085), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26434] = 2,
    ACTIONS(3087), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26442] = 2,
    ACTIONS(3089), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26450] = 2,
    ACTIONS(3091), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26458] = 2,
    ACTIONS(3093), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26466] = 2,
    ACTIONS(3095), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26474] = 2,
    ACTIONS(3097), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26482] = 2,
    ACTIONS(980), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26490] = 2,
    ACTIONS(2744), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26498] = 2,
    ACTIONS(3099), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26506] = 2,
    ACTIONS(3101), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26514] = 2,
    ACTIONS(3103), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26522] = 2,
    ACTIONS(3105), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26530] = 2,
    ACTIONS(3107), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26538] = 2,
    ACTIONS(3109), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26546] = 2,
    ACTIONS(3111), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26554] = 2,
    ACTIONS(3113), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26562] = 2,
    ACTIONS(2963), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26570] = 2,
    ACTIONS(3115), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26578] = 2,
    ACTIONS(2965), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26586] = 2,
    ACTIONS(956), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26594] = 2,
    ACTIONS(3117), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26602] = 2,
    ACTIONS(3119), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26610] = 2,
    ACTIONS(3121), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26618] = 2,
    ACTIONS(2882), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26626] = 2,
    ACTIONS(3123), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26634] = 2,
    ACTIONS(3125), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26642] = 2,
    ACTIONS(3127), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26650] = 2,
    ACTIONS(3129), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26658] = 2,
    ACTIONS(3131), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26666] = 2,
    ACTIONS(3133), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26674] = 2,
    ACTIONS(3135), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26682] = 2,
    ACTIONS(3137), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26690] = 2,
    ACTIONS(3139), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26698] = 2,
    ACTIONS(3141), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26706] = 2,
    ACTIONS(3143), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26714] = 2,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26722] = 2,
    ACTIONS(3147), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26730] = 2,
    ACTIONS(2738), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26738] = 2,
    ACTIONS(3149), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26746] = 2,
    ACTIONS(3151), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26754] = 2,
    ACTIONS(3153), 1,
      anon_sym_while,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26762] = 2,
    ACTIONS(3155), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26770] = 2,
    ACTIONS(3157), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26778] = 2,
    ACTIONS(3159), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26786] = 2,
    ACTIONS(3161), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26794] = 2,
    ACTIONS(3163), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26802] = 2,
    ACTIONS(3165), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26810] = 2,
    ACTIONS(3167), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26818] = 2,
    ACTIONS(3169), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26826] = 2,
    ACTIONS(1002), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26834] = 2,
    ACTIONS(3171), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26842] = 2,
    ACTIONS(3173), 1,
      anon_sym_class,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26850] = 2,
    ACTIONS(3175), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26858] = 2,
    ACTIONS(2746), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26866] = 2,
    ACTIONS(3177), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26874] = 2,
    ACTIONS(3179), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26882] = 2,
    ACTIONS(3181), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26890] = 2,
    ACTIONS(3183), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26898] = 2,
    ACTIONS(3185), 1,
      anon_sym_module,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26906] = 2,
    ACTIONS(3187), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26914] = 2,
    ACTIONS(3189), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26922] = 2,
    ACTIONS(3191), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26930] = 2,
    ACTIONS(3193), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26938] = 2,
    ACTIONS(3195), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26946] = 2,
    ACTIONS(1953), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26954] = 2,
    ACTIONS(2727), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26962] = 2,
    ACTIONS(3197), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26970] = 2,
    ACTIONS(3199), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26978] = 2,
    ACTIONS(3201), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26986] = 2,
    ACTIONS(3203), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [26994] = 2,
    ACTIONS(3205), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [27002] = 2,
    ACTIONS(3207), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(354)] = 0,
  [SMALL_STATE(355)] = 119,
  [SMALL_STATE(356)] = 238,
  [SMALL_STATE(357)] = 357,
  [SMALL_STATE(358)] = 476,
  [SMALL_STATE(359)] = 595,
  [SMALL_STATE(360)] = 702,
  [SMALL_STATE(361)] = 809,
  [SMALL_STATE(362)] = 916,
  [SMALL_STATE(363)] = 1000,
  [SMALL_STATE(364)] = 1091,
  [SMALL_STATE(365)] = 1173,
  [SMALL_STATE(366)] = 1255,
  [SMALL_STATE(367)] = 1346,
  [SMALL_STATE(368)] = 1437,
  [SMALL_STATE(369)] = 1528,
  [SMALL_STATE(370)] = 1588,
  [SMALL_STATE(371)] = 1654,
  [SMALL_STATE(372)] = 1726,
  [SMALL_STATE(373)] = 1786,
  [SMALL_STATE(374)] = 1846,
  [SMALL_STATE(375)] = 1906,
  [SMALL_STATE(376)] = 1960,
  [SMALL_STATE(377)] = 2014,
  [SMALL_STATE(378)] = 2068,
  [SMALL_STATE(379)] = 2142,
  [SMALL_STATE(380)] = 2215,
  [SMALL_STATE(381)] = 2284,
  [SMALL_STATE(382)] = 2341,
  [SMALL_STATE(383)] = 2401,
  [SMALL_STATE(384)] = 2463,
  [SMALL_STATE(385)] = 2527,
  [SMALL_STATE(386)] = 2591,
  [SMALL_STATE(387)] = 2651,
  [SMALL_STATE(388)] = 2712,
  [SMALL_STATE(389)] = 2773,
  [SMALL_STATE(390)] = 2836,
  [SMALL_STATE(391)] = 2899,
  [SMALL_STATE(392)] = 2962,
  [SMALL_STATE(393)] = 3025,
  [SMALL_STATE(394)] = 3079,
  [SMALL_STATE(395)] = 3161,
  [SMALL_STATE(396)] = 3211,
  [SMALL_STATE(397)] = 3261,
  [SMALL_STATE(398)] = 3318,
  [SMALL_STATE(399)] = 3392,
  [SMALL_STATE(400)] = 3439,
  [SMALL_STATE(401)] = 3486,
  [SMALL_STATE(402)] = 3533,
  [SMALL_STATE(403)] = 3586,
  [SMALL_STATE(404)] = 3639,
  [SMALL_STATE(405)] = 3712,
  [SMALL_STATE(406)] = 3783,
  [SMALL_STATE(407)] = 3830,
  [SMALL_STATE(408)] = 3876,
  [SMALL_STATE(409)] = 3922,
  [SMALL_STATE(410)] = 3968,
  [SMALL_STATE(411)] = 4020,
  [SMALL_STATE(412)] = 4066,
  [SMALL_STATE(413)] = 4112,
  [SMALL_STATE(414)] = 4158,
  [SMALL_STATE(415)] = 4204,
  [SMALL_STATE(416)] = 4250,
  [SMALL_STATE(417)] = 4298,
  [SMALL_STATE(418)] = 4344,
  [SMALL_STATE(419)] = 4396,
  [SMALL_STATE(420)] = 4441,
  [SMALL_STATE(421)] = 4486,
  [SMALL_STATE(422)] = 4531,
  [SMALL_STATE(423)] = 4576,
  [SMALL_STATE(424)] = 4628,
  [SMALL_STATE(425)] = 4676,
  [SMALL_STATE(426)] = 4724,
  [SMALL_STATE(427)] = 4772,
  [SMALL_STATE(428)] = 4824,
  [SMALL_STATE(429)] = 4872,
  [SMALL_STATE(430)] = 4915,
  [SMALL_STATE(431)] = 4958,
  [SMALL_STATE(432)] = 5001,
  [SMALL_STATE(433)] = 5044,
  [SMALL_STATE(434)] = 5091,
  [SMALL_STATE(435)] = 5134,
  [SMALL_STATE(436)] = 5177,
  [SMALL_STATE(437)] = 5220,
  [SMALL_STATE(438)] = 5263,
  [SMALL_STATE(439)] = 5306,
  [SMALL_STATE(440)] = 5349,
  [SMALL_STATE(441)] = 5396,
  [SMALL_STATE(442)] = 5439,
  [SMALL_STATE(443)] = 5482,
  [SMALL_STATE(444)] = 5525,
  [SMALL_STATE(445)] = 5568,
  [SMALL_STATE(446)] = 5611,
  [SMALL_STATE(447)] = 5654,
  [SMALL_STATE(448)] = 5697,
  [SMALL_STATE(449)] = 5740,
  [SMALL_STATE(450)] = 5783,
  [SMALL_STATE(451)] = 5826,
  [SMALL_STATE(452)] = 5869,
  [SMALL_STATE(453)] = 5912,
  [SMALL_STATE(454)] = 5955,
  [SMALL_STATE(455)] = 5998,
  [SMALL_STATE(456)] = 6041,
  [SMALL_STATE(457)] = 6084,
  [SMALL_STATE(458)] = 6127,
  [SMALL_STATE(459)] = 6169,
  [SMALL_STATE(460)] = 6211,
  [SMALL_STATE(461)] = 6253,
  [SMALL_STATE(462)] = 6295,
  [SMALL_STATE(463)] = 6337,
  [SMALL_STATE(464)] = 6379,
  [SMALL_STATE(465)] = 6421,
  [SMALL_STATE(466)] = 6463,
  [SMALL_STATE(467)] = 6505,
  [SMALL_STATE(468)] = 6547,
  [SMALL_STATE(469)] = 6589,
  [SMALL_STATE(470)] = 6631,
  [SMALL_STATE(471)] = 6673,
  [SMALL_STATE(472)] = 6715,
  [SMALL_STATE(473)] = 6757,
  [SMALL_STATE(474)] = 6799,
  [SMALL_STATE(475)] = 6841,
  [SMALL_STATE(476)] = 6883,
  [SMALL_STATE(477)] = 6929,
  [SMALL_STATE(478)] = 6971,
  [SMALL_STATE(479)] = 7013,
  [SMALL_STATE(480)] = 7055,
  [SMALL_STATE(481)] = 7097,
  [SMALL_STATE(482)] = 7139,
  [SMALL_STATE(483)] = 7187,
  [SMALL_STATE(484)] = 7229,
  [SMALL_STATE(485)] = 7271,
  [SMALL_STATE(486)] = 7313,
  [SMALL_STATE(487)] = 7355,
  [SMALL_STATE(488)] = 7397,
  [SMALL_STATE(489)] = 7439,
  [SMALL_STATE(490)] = 7481,
  [SMALL_STATE(491)] = 7523,
  [SMALL_STATE(492)] = 7569,
  [SMALL_STATE(493)] = 7611,
  [SMALL_STATE(494)] = 7653,
  [SMALL_STATE(495)] = 7695,
  [SMALL_STATE(496)] = 7737,
  [SMALL_STATE(497)] = 7782,
  [SMALL_STATE(498)] = 7822,
  [SMALL_STATE(499)] = 7862,
  [SMALL_STATE(500)] = 7902,
  [SMALL_STATE(501)] = 7941,
  [SMALL_STATE(502)] = 7982,
  [SMALL_STATE(503)] = 8021,
  [SMALL_STATE(504)] = 8060,
  [SMALL_STATE(505)] = 8099,
  [SMALL_STATE(506)] = 8138,
  [SMALL_STATE(507)] = 8179,
  [SMALL_STATE(508)] = 8218,
  [SMALL_STATE(509)] = 8259,
  [SMALL_STATE(510)] = 8298,
  [SMALL_STATE(511)] = 8337,
  [SMALL_STATE(512)] = 8376,
  [SMALL_STATE(513)] = 8415,
  [SMALL_STATE(514)] = 8454,
  [SMALL_STATE(515)] = 8493,
  [SMALL_STATE(516)] = 8532,
  [SMALL_STATE(517)] = 8571,
  [SMALL_STATE(518)] = 8610,
  [SMALL_STATE(519)] = 8649,
  [SMALL_STATE(520)] = 8688,
  [SMALL_STATE(521)] = 8727,
  [SMALL_STATE(522)] = 8789,
  [SMALL_STATE(523)] = 8833,
  [SMALL_STATE(524)] = 8901,
  [SMALL_STATE(525)] = 8945,
  [SMALL_STATE(526)] = 9013,
  [SMALL_STATE(527)] = 9055,
  [SMALL_STATE(528)] = 9123,
  [SMALL_STATE(529)] = 9167,
  [SMALL_STATE(530)] = 9229,
  [SMALL_STATE(531)] = 9287,
  [SMALL_STATE(532)] = 9337,
  [SMALL_STATE(533)] = 9405,
  [SMALL_STATE(534)] = 9473,
  [SMALL_STATE(535)] = 9533,
  [SMALL_STATE(536)] = 9597,
  [SMALL_STATE(537)] = 9643,
  [SMALL_STATE(538)] = 9699,
  [SMALL_STATE(539)] = 9743,
  [SMALL_STATE(540)] = 9787,
  [SMALL_STATE(541)] = 9832,
  [SMALL_STATE(542)] = 9877,
  [SMALL_STATE(543)] = 9914,
  [SMALL_STATE(544)] = 9951,
  [SMALL_STATE(545)] = 10017,
  [SMALL_STATE(546)] = 10087,
  [SMALL_STATE(547)] = 10129,
  [SMALL_STATE(548)] = 10194,
  [SMALL_STATE(549)] = 10263,
  [SMALL_STATE(550)] = 10298,
  [SMALL_STATE(551)] = 10367,
  [SMALL_STATE(552)] = 10436,
  [SMALL_STATE(553)] = 10505,
  [SMALL_STATE(554)] = 10574,
  [SMALL_STATE(555)] = 10643,
  [SMALL_STATE(556)] = 10708,
  [SMALL_STATE(557)] = 10773,
  [SMALL_STATE(558)] = 10832,
  [SMALL_STATE(559)] = 10867,
  [SMALL_STATE(560)] = 10936,
  [SMALL_STATE(561)] = 10971,
  [SMALL_STATE(562)] = 11014,
  [SMALL_STATE(563)] = 11083,
  [SMALL_STATE(564)] = 11140,
  [SMALL_STATE(565)] = 11199,
  [SMALL_STATE(566)] = 11240,
  [SMALL_STATE(567)] = 11301,
  [SMALL_STATE(568)] = 11370,
  [SMALL_STATE(569)] = 11429,
  [SMALL_STATE(570)] = 11498,
  [SMALL_STATE(571)] = 11551,
  [SMALL_STATE(572)] = 11620,
  [SMALL_STATE(573)] = 11689,
  [SMALL_STATE(574)] = 11736,
  [SMALL_STATE(575)] = 11805,
  [SMALL_STATE(576)] = 11874,
  [SMALL_STATE(577)] = 11929,
  [SMALL_STATE(578)] = 11964,
  [SMALL_STATE(579)] = 12033,
  [SMALL_STATE(580)] = 12068,
  [SMALL_STATE(581)] = 12121,
  [SMALL_STATE(582)] = 12186,
  [SMALL_STATE(583)] = 12255,
  [SMALL_STATE(584)] = 12324,
  [SMALL_STATE(585)] = 12389,
  [SMALL_STATE(586)] = 12458,
  [SMALL_STATE(587)] = 12493,
  [SMALL_STATE(588)] = 12558,
  [SMALL_STATE(589)] = 12593,
  [SMALL_STATE(590)] = 12658,
  [SMALL_STATE(591)] = 12727,
  [SMALL_STATE(592)] = 12762,
  [SMALL_STATE(593)] = 12797,
  [SMALL_STATE(594)] = 12866,
  [SMALL_STATE(595)] = 12903,
  [SMALL_STATE(596)] = 12962,
  [SMALL_STATE(597)] = 13027,
  [SMALL_STATE(598)] = 13096,
  [SMALL_STATE(599)] = 13146,
  [SMALL_STATE(600)] = 13196,
  [SMALL_STATE(601)] = 13260,
  [SMALL_STATE(602)] = 13324,
  [SMALL_STATE(603)] = 13380,
  [SMALL_STATE(604)] = 13444,
  [SMALL_STATE(605)] = 13508,
  [SMALL_STATE(606)] = 13572,
  [SMALL_STATE(607)] = 13610,
  [SMALL_STATE(608)] = 13674,
  [SMALL_STATE(609)] = 13738,
  [SMALL_STATE(610)] = 13804,
  [SMALL_STATE(611)] = 13867,
  [SMALL_STATE(612)] = 13930,
  [SMALL_STATE(613)] = 13993,
  [SMALL_STATE(614)] = 14056,
  [SMALL_STATE(615)] = 14111,
  [SMALL_STATE(616)] = 14174,
  [SMALL_STATE(617)] = 14237,
  [SMALL_STATE(618)] = 14300,
  [SMALL_STATE(619)] = 14363,
  [SMALL_STATE(620)] = 14426,
  [SMALL_STATE(621)] = 14489,
  [SMALL_STATE(622)] = 14552,
  [SMALL_STATE(623)] = 14615,
  [SMALL_STATE(624)] = 14678,
  [SMALL_STATE(625)] = 14741,
  [SMALL_STATE(626)] = 14796,
  [SMALL_STATE(627)] = 14857,
  [SMALL_STATE(628)] = 14912,
  [SMALL_STATE(629)] = 14975,
  [SMALL_STATE(630)] = 15030,
  [SMALL_STATE(631)] = 15085,
  [SMALL_STATE(632)] = 15148,
  [SMALL_STATE(633)] = 15211,
  [SMALL_STATE(634)] = 15274,
  [SMALL_STATE(635)] = 15337,
  [SMALL_STATE(636)] = 15400,
  [SMALL_STATE(637)] = 15463,
  [SMALL_STATE(638)] = 15526,
  [SMALL_STATE(639)] = 15589,
  [SMALL_STATE(640)] = 15641,
  [SMALL_STATE(641)] = 15693,
  [SMALL_STATE(642)] = 15725,
  [SMALL_STATE(643)] = 15777,
  [SMALL_STATE(644)] = 15829,
  [SMALL_STATE(645)] = 15881,
  [SMALL_STATE(646)] = 15933,
  [SMALL_STATE(647)] = 15965,
  [SMALL_STATE(648)] = 16017,
  [SMALL_STATE(649)] = 16069,
  [SMALL_STATE(650)] = 16110,
  [SMALL_STATE(651)] = 16159,
  [SMALL_STATE(652)] = 16196,
  [SMALL_STATE(653)] = 16233,
  [SMALL_STATE(654)] = 16279,
  [SMALL_STATE(655)] = 16309,
  [SMALL_STATE(656)] = 16361,
  [SMALL_STATE(657)] = 16391,
  [SMALL_STATE(658)] = 16427,
  [SMALL_STATE(659)] = 16463,
  [SMALL_STATE(660)] = 16509,
  [SMALL_STATE(661)] = 16539,
  [SMALL_STATE(662)] = 16585,
  [SMALL_STATE(663)] = 16633,
  [SMALL_STATE(664)] = 16679,
  [SMALL_STATE(665)] = 16725,
  [SMALL_STATE(666)] = 16773,
  [SMALL_STATE(667)] = 16803,
  [SMALL_STATE(668)] = 16849,
  [SMALL_STATE(669)] = 16879,
  [SMALL_STATE(670)] = 16909,
  [SMALL_STATE(671)] = 16955,
  [SMALL_STATE(672)] = 16984,
  [SMALL_STATE(673)] = 17013,
  [SMALL_STATE(674)] = 17062,
  [SMALL_STATE(675)] = 17091,
  [SMALL_STATE(676)] = 17120,
  [SMALL_STATE(677)] = 17148,
  [SMALL_STATE(678)] = 17176,
  [SMALL_STATE(679)] = 17218,
  [SMALL_STATE(680)] = 17246,
  [SMALL_STATE(681)] = 17274,
  [SMALL_STATE(682)] = 17302,
  [SMALL_STATE(683)] = 17330,
  [SMALL_STATE(684)] = 17378,
  [SMALL_STATE(685)] = 17408,
  [SMALL_STATE(686)] = 17436,
  [SMALL_STATE(687)] = 17478,
  [SMALL_STATE(688)] = 17510,
  [SMALL_STATE(689)] = 17556,
  [SMALL_STATE(690)] = 17596,
  [SMALL_STATE(691)] = 17642,
  [SMALL_STATE(692)] = 17676,
  [SMALL_STATE(693)] = 17722,
  [SMALL_STATE(694)] = 17755,
  [SMALL_STATE(695)] = 17798,
  [SMALL_STATE(696)] = 17841,
  [SMALL_STATE(697)] = 17878,
  [SMALL_STATE(698)] = 17915,
  [SMALL_STATE(699)] = 17954,
  [SMALL_STATE(700)] = 17979,
  [SMALL_STATE(701)] = 18022,
  [SMALL_STATE(702)] = 18059,
  [SMALL_STATE(703)] = 18096,
  [SMALL_STATE(704)] = 18133,
  [SMALL_STATE(705)] = 18176,
  [SMALL_STATE(706)] = 18201,
  [SMALL_STATE(707)] = 18241,
  [SMALL_STATE(708)] = 18283,
  [SMALL_STATE(709)] = 18325,
  [SMALL_STATE(710)] = 18365,
  [SMALL_STATE(711)] = 18391,
  [SMALL_STATE(712)] = 18431,
  [SMALL_STATE(713)] = 18471,
  [SMALL_STATE(714)] = 18511,
  [SMALL_STATE(715)] = 18553,
  [SMALL_STATE(716)] = 18593,
  [SMALL_STATE(717)] = 18635,
  [SMALL_STATE(718)] = 18675,
  [SMALL_STATE(719)] = 18712,
  [SMALL_STATE(720)] = 18747,
  [SMALL_STATE(721)] = 18784,
  [SMALL_STATE(722)] = 18817,
  [SMALL_STATE(723)] = 18846,
  [SMALL_STATE(724)] = 18883,
  [SMALL_STATE(725)] = 18919,
  [SMALL_STATE(726)] = 18953,
  [SMALL_STATE(727)] = 18989,
  [SMALL_STATE(728)] = 19023,
  [SMALL_STATE(729)] = 19059,
  [SMALL_STATE(730)] = 19093,
  [SMALL_STATE(731)] = 19127,
  [SMALL_STATE(732)] = 19161,
  [SMALL_STATE(733)] = 19197,
  [SMALL_STATE(734)] = 19229,
  [SMALL_STATE(735)] = 19265,
  [SMALL_STATE(736)] = 19301,
  [SMALL_STATE(737)] = 19335,
  [SMALL_STATE(738)] = 19371,
  [SMALL_STATE(739)] = 19405,
  [SMALL_STATE(740)] = 19435,
  [SMALL_STATE(741)] = 19465,
  [SMALL_STATE(742)] = 19499,
  [SMALL_STATE(743)] = 19535,
  [SMALL_STATE(744)] = 19569,
  [SMALL_STATE(745)] = 19600,
  [SMALL_STATE(746)] = 19631,
  [SMALL_STATE(747)] = 19662,
  [SMALL_STATE(748)] = 19693,
  [SMALL_STATE(749)] = 19726,
  [SMALL_STATE(750)] = 19757,
  [SMALL_STATE(751)] = 19788,
  [SMALL_STATE(752)] = 19811,
  [SMALL_STATE(753)] = 19844,
  [SMALL_STATE(754)] = 19874,
  [SMALL_STATE(755)] = 19906,
  [SMALL_STATE(756)] = 19936,
  [SMALL_STATE(757)] = 19966,
  [SMALL_STATE(758)] = 19998,
  [SMALL_STATE(759)] = 20026,
  [SMALL_STATE(760)] = 20054,
  [SMALL_STATE(761)] = 20084,
  [SMALL_STATE(762)] = 20113,
  [SMALL_STATE(763)] = 20140,
  [SMALL_STATE(764)] = 20171,
  [SMALL_STATE(765)] = 20202,
  [SMALL_STATE(766)] = 20229,
  [SMALL_STATE(767)] = 20258,
  [SMALL_STATE(768)] = 20293,
  [SMALL_STATE(769)] = 20328,
  [SMALL_STATE(770)] = 20358,
  [SMALL_STATE(771)] = 20374,
  [SMALL_STATE(772)] = 20400,
  [SMALL_STATE(773)] = 20428,
  [SMALL_STATE(774)] = 20457,
  [SMALL_STATE(775)] = 20482,
  [SMALL_STATE(776)] = 20511,
  [SMALL_STATE(777)] = 20540,
  [SMALL_STATE(778)] = 20569,
  [SMALL_STATE(779)] = 20590,
  [SMALL_STATE(780)] = 20610,
  [SMALL_STATE(781)] = 20624,
  [SMALL_STATE(782)] = 20648,
  [SMALL_STATE(783)] = 20670,
  [SMALL_STATE(784)] = 20684,
  [SMALL_STATE(785)] = 20706,
  [SMALL_STATE(786)] = 20720,
  [SMALL_STATE(787)] = 20734,
  [SMALL_STATE(788)] = 20754,
  [SMALL_STATE(789)] = 20778,
  [SMALL_STATE(790)] = 20800,
  [SMALL_STATE(791)] = 20817,
  [SMALL_STATE(792)] = 20834,
  [SMALL_STATE(793)] = 20847,
  [SMALL_STATE(794)] = 20860,
  [SMALL_STATE(795)] = 20873,
  [SMALL_STATE(796)] = 20890,
  [SMALL_STATE(797)] = 20903,
  [SMALL_STATE(798)] = 20916,
  [SMALL_STATE(799)] = 20929,
  [SMALL_STATE(800)] = 20942,
  [SMALL_STATE(801)] = 20955,
  [SMALL_STATE(802)] = 20968,
  [SMALL_STATE(803)] = 20985,
  [SMALL_STATE(804)] = 20998,
  [SMALL_STATE(805)] = 21011,
  [SMALL_STATE(806)] = 21030,
  [SMALL_STATE(807)] = 21049,
  [SMALL_STATE(808)] = 21068,
  [SMALL_STATE(809)] = 21081,
  [SMALL_STATE(810)] = 21098,
  [SMALL_STATE(811)] = 21111,
  [SMALL_STATE(812)] = 21128,
  [SMALL_STATE(813)] = 21141,
  [SMALL_STATE(814)] = 21164,
  [SMALL_STATE(815)] = 21177,
  [SMALL_STATE(816)] = 21196,
  [SMALL_STATE(817)] = 21209,
  [SMALL_STATE(818)] = 21222,
  [SMALL_STATE(819)] = 21239,
  [SMALL_STATE(820)] = 21252,
  [SMALL_STATE(821)] = 21275,
  [SMALL_STATE(822)] = 21288,
  [SMALL_STATE(823)] = 21305,
  [SMALL_STATE(824)] = 21318,
  [SMALL_STATE(825)] = 21335,
  [SMALL_STATE(826)] = 21348,
  [SMALL_STATE(827)] = 21365,
  [SMALL_STATE(828)] = 21378,
  [SMALL_STATE(829)] = 21391,
  [SMALL_STATE(830)] = 21404,
  [SMALL_STATE(831)] = 21417,
  [SMALL_STATE(832)] = 21430,
  [SMALL_STATE(833)] = 21443,
  [SMALL_STATE(834)] = 21460,
  [SMALL_STATE(835)] = 21473,
  [SMALL_STATE(836)] = 21486,
  [SMALL_STATE(837)] = 21499,
  [SMALL_STATE(838)] = 21512,
  [SMALL_STATE(839)] = 21525,
  [SMALL_STATE(840)] = 21538,
  [SMALL_STATE(841)] = 21551,
  [SMALL_STATE(842)] = 21564,
  [SMALL_STATE(843)] = 21577,
  [SMALL_STATE(844)] = 21590,
  [SMALL_STATE(845)] = 21603,
  [SMALL_STATE(846)] = 21626,
  [SMALL_STATE(847)] = 21643,
  [SMALL_STATE(848)] = 21666,
  [SMALL_STATE(849)] = 21679,
  [SMALL_STATE(850)] = 21696,
  [SMALL_STATE(851)] = 21713,
  [SMALL_STATE(852)] = 21730,
  [SMALL_STATE(853)] = 21747,
  [SMALL_STATE(854)] = 21760,
  [SMALL_STATE(855)] = 21781,
  [SMALL_STATE(856)] = 21802,
  [SMALL_STATE(857)] = 21819,
  [SMALL_STATE(858)] = 21842,
  [SMALL_STATE(859)] = 21865,
  [SMALL_STATE(860)] = 21881,
  [SMALL_STATE(861)] = 21897,
  [SMALL_STATE(862)] = 21913,
  [SMALL_STATE(863)] = 21929,
  [SMALL_STATE(864)] = 21945,
  [SMALL_STATE(865)] = 21961,
  [SMALL_STATE(866)] = 21981,
  [SMALL_STATE(867)] = 21997,
  [SMALL_STATE(868)] = 22013,
  [SMALL_STATE(869)] = 22033,
  [SMALL_STATE(870)] = 22049,
  [SMALL_STATE(871)] = 22065,
  [SMALL_STATE(872)] = 22085,
  [SMALL_STATE(873)] = 22105,
  [SMALL_STATE(874)] = 22121,
  [SMALL_STATE(875)] = 22137,
  [SMALL_STATE(876)] = 22151,
  [SMALL_STATE(877)] = 22167,
  [SMALL_STATE(878)] = 22179,
  [SMALL_STATE(879)] = 22195,
  [SMALL_STATE(880)] = 22211,
  [SMALL_STATE(881)] = 22227,
  [SMALL_STATE(882)] = 22239,
  [SMALL_STATE(883)] = 22255,
  [SMALL_STATE(884)] = 22275,
  [SMALL_STATE(885)] = 22291,
  [SMALL_STATE(886)] = 22307,
  [SMALL_STATE(887)] = 22323,
  [SMALL_STATE(888)] = 22339,
  [SMALL_STATE(889)] = 22355,
  [SMALL_STATE(890)] = 22371,
  [SMALL_STATE(891)] = 22389,
  [SMALL_STATE(892)] = 22405,
  [SMALL_STATE(893)] = 22421,
  [SMALL_STATE(894)] = 22437,
  [SMALL_STATE(895)] = 22453,
  [SMALL_STATE(896)] = 22469,
  [SMALL_STATE(897)] = 22485,
  [SMALL_STATE(898)] = 22505,
  [SMALL_STATE(899)] = 22522,
  [SMALL_STATE(900)] = 22533,
  [SMALL_STATE(901)] = 22548,
  [SMALL_STATE(902)] = 22565,
  [SMALL_STATE(903)] = 22580,
  [SMALL_STATE(904)] = 22595,
  [SMALL_STATE(905)] = 22606,
  [SMALL_STATE(906)] = 22621,
  [SMALL_STATE(907)] = 22638,
  [SMALL_STATE(908)] = 22655,
  [SMALL_STATE(909)] = 22668,
  [SMALL_STATE(910)] = 22685,
  [SMALL_STATE(911)] = 22702,
  [SMALL_STATE(912)] = 22713,
  [SMALL_STATE(913)] = 22728,
  [SMALL_STATE(914)] = 22743,
  [SMALL_STATE(915)] = 22760,
  [SMALL_STATE(916)] = 22777,
  [SMALL_STATE(917)] = 22794,
  [SMALL_STATE(918)] = 22811,
  [SMALL_STATE(919)] = 22828,
  [SMALL_STATE(920)] = 22845,
  [SMALL_STATE(921)] = 22862,
  [SMALL_STATE(922)] = 22879,
  [SMALL_STATE(923)] = 22896,
  [SMALL_STATE(924)] = 22913,
  [SMALL_STATE(925)] = 22930,
  [SMALL_STATE(926)] = 22947,
  [SMALL_STATE(927)] = 22962,
  [SMALL_STATE(928)] = 22979,
  [SMALL_STATE(929)] = 22994,
  [SMALL_STATE(930)] = 23009,
  [SMALL_STATE(931)] = 23026,
  [SMALL_STATE(932)] = 23043,
  [SMALL_STATE(933)] = 23060,
  [SMALL_STATE(934)] = 23075,
  [SMALL_STATE(935)] = 23092,
  [SMALL_STATE(936)] = 23109,
  [SMALL_STATE(937)] = 23126,
  [SMALL_STATE(938)] = 23143,
  [SMALL_STATE(939)] = 23158,
  [SMALL_STATE(940)] = 23175,
  [SMALL_STATE(941)] = 23192,
  [SMALL_STATE(942)] = 23205,
  [SMALL_STATE(943)] = 23218,
  [SMALL_STATE(944)] = 23233,
  [SMALL_STATE(945)] = 23250,
  [SMALL_STATE(946)] = 23265,
  [SMALL_STATE(947)] = 23282,
  [SMALL_STATE(948)] = 23297,
  [SMALL_STATE(949)] = 23314,
  [SMALL_STATE(950)] = 23327,
  [SMALL_STATE(951)] = 23342,
  [SMALL_STATE(952)] = 23359,
  [SMALL_STATE(953)] = 23370,
  [SMALL_STATE(954)] = 23385,
  [SMALL_STATE(955)] = 23402,
  [SMALL_STATE(956)] = 23419,
  [SMALL_STATE(957)] = 23434,
  [SMALL_STATE(958)] = 23451,
  [SMALL_STATE(959)] = 23468,
  [SMALL_STATE(960)] = 23479,
  [SMALL_STATE(961)] = 23494,
  [SMALL_STATE(962)] = 23511,
  [SMALL_STATE(963)] = 23526,
  [SMALL_STATE(964)] = 23541,
  [SMALL_STATE(965)] = 23556,
  [SMALL_STATE(966)] = 23573,
  [SMALL_STATE(967)] = 23587,
  [SMALL_STATE(968)] = 23601,
  [SMALL_STATE(969)] = 23615,
  [SMALL_STATE(970)] = 23629,
  [SMALL_STATE(971)] = 23643,
  [SMALL_STATE(972)] = 23657,
  [SMALL_STATE(973)] = 23671,
  [SMALL_STATE(974)] = 23685,
  [SMALL_STATE(975)] = 23699,
  [SMALL_STATE(976)] = 23713,
  [SMALL_STATE(977)] = 23727,
  [SMALL_STATE(978)] = 23741,
  [SMALL_STATE(979)] = 23755,
  [SMALL_STATE(980)] = 23769,
  [SMALL_STATE(981)] = 23783,
  [SMALL_STATE(982)] = 23797,
  [SMALL_STATE(983)] = 23811,
  [SMALL_STATE(984)] = 23825,
  [SMALL_STATE(985)] = 23839,
  [SMALL_STATE(986)] = 23853,
  [SMALL_STATE(987)] = 23867,
  [SMALL_STATE(988)] = 23881,
  [SMALL_STATE(989)] = 23895,
  [SMALL_STATE(990)] = 23909,
  [SMALL_STATE(991)] = 23923,
  [SMALL_STATE(992)] = 23937,
  [SMALL_STATE(993)] = 23951,
  [SMALL_STATE(994)] = 23965,
  [SMALL_STATE(995)] = 23979,
  [SMALL_STATE(996)] = 23993,
  [SMALL_STATE(997)] = 24003,
  [SMALL_STATE(998)] = 24017,
  [SMALL_STATE(999)] = 24031,
  [SMALL_STATE(1000)] = 24045,
  [SMALL_STATE(1001)] = 24055,
  [SMALL_STATE(1002)] = 24065,
  [SMALL_STATE(1003)] = 24079,
  [SMALL_STATE(1004)] = 24093,
  [SMALL_STATE(1005)] = 24107,
  [SMALL_STATE(1006)] = 24121,
  [SMALL_STATE(1007)] = 24135,
  [SMALL_STATE(1008)] = 24145,
  [SMALL_STATE(1009)] = 24159,
  [SMALL_STATE(1010)] = 24173,
  [SMALL_STATE(1011)] = 24187,
  [SMALL_STATE(1012)] = 24201,
  [SMALL_STATE(1013)] = 24215,
  [SMALL_STATE(1014)] = 24229,
  [SMALL_STATE(1015)] = 24243,
  [SMALL_STATE(1016)] = 24257,
  [SMALL_STATE(1017)] = 24271,
  [SMALL_STATE(1018)] = 24285,
  [SMALL_STATE(1019)] = 24299,
  [SMALL_STATE(1020)] = 24311,
  [SMALL_STATE(1021)] = 24323,
  [SMALL_STATE(1022)] = 24333,
  [SMALL_STATE(1023)] = 24347,
  [SMALL_STATE(1024)] = 24361,
  [SMALL_STATE(1025)] = 24375,
  [SMALL_STATE(1026)] = 24389,
  [SMALL_STATE(1027)] = 24403,
  [SMALL_STATE(1028)] = 24417,
  [SMALL_STATE(1029)] = 24431,
  [SMALL_STATE(1030)] = 24445,
  [SMALL_STATE(1031)] = 24457,
  [SMALL_STATE(1032)] = 24469,
  [SMALL_STATE(1033)] = 24483,
  [SMALL_STATE(1034)] = 24497,
  [SMALL_STATE(1035)] = 24511,
  [SMALL_STATE(1036)] = 24525,
  [SMALL_STATE(1037)] = 24539,
  [SMALL_STATE(1038)] = 24553,
  [SMALL_STATE(1039)] = 24567,
  [SMALL_STATE(1040)] = 24581,
  [SMALL_STATE(1041)] = 24595,
  [SMALL_STATE(1042)] = 24609,
  [SMALL_STATE(1043)] = 24623,
  [SMALL_STATE(1044)] = 24637,
  [SMALL_STATE(1045)] = 24647,
  [SMALL_STATE(1046)] = 24661,
  [SMALL_STATE(1047)] = 24675,
  [SMALL_STATE(1048)] = 24689,
  [SMALL_STATE(1049)] = 24703,
  [SMALL_STATE(1050)] = 24717,
  [SMALL_STATE(1051)] = 24731,
  [SMALL_STATE(1052)] = 24741,
  [SMALL_STATE(1053)] = 24755,
  [SMALL_STATE(1054)] = 24769,
  [SMALL_STATE(1055)] = 24783,
  [SMALL_STATE(1056)] = 24793,
  [SMALL_STATE(1057)] = 24803,
  [SMALL_STATE(1058)] = 24813,
  [SMALL_STATE(1059)] = 24827,
  [SMALL_STATE(1060)] = 24837,
  [SMALL_STATE(1061)] = 24851,
  [SMALL_STATE(1062)] = 24865,
  [SMALL_STATE(1063)] = 24879,
  [SMALL_STATE(1064)] = 24893,
  [SMALL_STATE(1065)] = 24907,
  [SMALL_STATE(1066)] = 24921,
  [SMALL_STATE(1067)] = 24935,
  [SMALL_STATE(1068)] = 24949,
  [SMALL_STATE(1069)] = 24963,
  [SMALL_STATE(1070)] = 24977,
  [SMALL_STATE(1071)] = 24991,
  [SMALL_STATE(1072)] = 25005,
  [SMALL_STATE(1073)] = 25019,
  [SMALL_STATE(1074)] = 25033,
  [SMALL_STATE(1075)] = 25047,
  [SMALL_STATE(1076)] = 25061,
  [SMALL_STATE(1077)] = 25075,
  [SMALL_STATE(1078)] = 25089,
  [SMALL_STATE(1079)] = 25100,
  [SMALL_STATE(1080)] = 25111,
  [SMALL_STATE(1081)] = 25120,
  [SMALL_STATE(1082)] = 25129,
  [SMALL_STATE(1083)] = 25138,
  [SMALL_STATE(1084)] = 25147,
  [SMALL_STATE(1085)] = 25158,
  [SMALL_STATE(1086)] = 25169,
  [SMALL_STATE(1087)] = 25180,
  [SMALL_STATE(1088)] = 25191,
  [SMALL_STATE(1089)] = 25200,
  [SMALL_STATE(1090)] = 25211,
  [SMALL_STATE(1091)] = 25222,
  [SMALL_STATE(1092)] = 25231,
  [SMALL_STATE(1093)] = 25242,
  [SMALL_STATE(1094)] = 25253,
  [SMALL_STATE(1095)] = 25262,
  [SMALL_STATE(1096)] = 25273,
  [SMALL_STATE(1097)] = 25282,
  [SMALL_STATE(1098)] = 25293,
  [SMALL_STATE(1099)] = 25302,
  [SMALL_STATE(1100)] = 25313,
  [SMALL_STATE(1101)] = 25322,
  [SMALL_STATE(1102)] = 25333,
  [SMALL_STATE(1103)] = 25344,
  [SMALL_STATE(1104)] = 25355,
  [SMALL_STATE(1105)] = 25364,
  [SMALL_STATE(1106)] = 25375,
  [SMALL_STATE(1107)] = 25386,
  [SMALL_STATE(1108)] = 25395,
  [SMALL_STATE(1109)] = 25406,
  [SMALL_STATE(1110)] = 25417,
  [SMALL_STATE(1111)] = 25426,
  [SMALL_STATE(1112)] = 25435,
  [SMALL_STATE(1113)] = 25446,
  [SMALL_STATE(1114)] = 25457,
  [SMALL_STATE(1115)] = 25466,
  [SMALL_STATE(1116)] = 25477,
  [SMALL_STATE(1117)] = 25488,
  [SMALL_STATE(1118)] = 25497,
  [SMALL_STATE(1119)] = 25506,
  [SMALL_STATE(1120)] = 25517,
  [SMALL_STATE(1121)] = 25528,
  [SMALL_STATE(1122)] = 25539,
  [SMALL_STATE(1123)] = 25550,
  [SMALL_STATE(1124)] = 25561,
  [SMALL_STATE(1125)] = 25572,
  [SMALL_STATE(1126)] = 25583,
  [SMALL_STATE(1127)] = 25594,
  [SMALL_STATE(1128)] = 25605,
  [SMALL_STATE(1129)] = 25616,
  [SMALL_STATE(1130)] = 25627,
  [SMALL_STATE(1131)] = 25638,
  [SMALL_STATE(1132)] = 25649,
  [SMALL_STATE(1133)] = 25660,
  [SMALL_STATE(1134)] = 25669,
  [SMALL_STATE(1135)] = 25680,
  [SMALL_STATE(1136)] = 25691,
  [SMALL_STATE(1137)] = 25700,
  [SMALL_STATE(1138)] = 25711,
  [SMALL_STATE(1139)] = 25722,
  [SMALL_STATE(1140)] = 25733,
  [SMALL_STATE(1141)] = 25744,
  [SMALL_STATE(1142)] = 25755,
  [SMALL_STATE(1143)] = 25766,
  [SMALL_STATE(1144)] = 25777,
  [SMALL_STATE(1145)] = 25788,
  [SMALL_STATE(1146)] = 25799,
  [SMALL_STATE(1147)] = 25810,
  [SMALL_STATE(1148)] = 25821,
  [SMALL_STATE(1149)] = 25832,
  [SMALL_STATE(1150)] = 25843,
  [SMALL_STATE(1151)] = 25854,
  [SMALL_STATE(1152)] = 25863,
  [SMALL_STATE(1153)] = 25874,
  [SMALL_STATE(1154)] = 25883,
  [SMALL_STATE(1155)] = 25894,
  [SMALL_STATE(1156)] = 25903,
  [SMALL_STATE(1157)] = 25914,
  [SMALL_STATE(1158)] = 25925,
  [SMALL_STATE(1159)] = 25936,
  [SMALL_STATE(1160)] = 25947,
  [SMALL_STATE(1161)] = 25958,
  [SMALL_STATE(1162)] = 25969,
  [SMALL_STATE(1163)] = 25980,
  [SMALL_STATE(1164)] = 25991,
  [SMALL_STATE(1165)] = 26002,
  [SMALL_STATE(1166)] = 26013,
  [SMALL_STATE(1167)] = 26022,
  [SMALL_STATE(1168)] = 26033,
  [SMALL_STATE(1169)] = 26044,
  [SMALL_STATE(1170)] = 26055,
  [SMALL_STATE(1171)] = 26064,
  [SMALL_STATE(1172)] = 26075,
  [SMALL_STATE(1173)] = 26084,
  [SMALL_STATE(1174)] = 26095,
  [SMALL_STATE(1175)] = 26106,
  [SMALL_STATE(1176)] = 26117,
  [SMALL_STATE(1177)] = 26128,
  [SMALL_STATE(1178)] = 26139,
  [SMALL_STATE(1179)] = 26148,
  [SMALL_STATE(1180)] = 26159,
  [SMALL_STATE(1181)] = 26170,
  [SMALL_STATE(1182)] = 26181,
  [SMALL_STATE(1183)] = 26192,
  [SMALL_STATE(1184)] = 26203,
  [SMALL_STATE(1185)] = 26214,
  [SMALL_STATE(1186)] = 26223,
  [SMALL_STATE(1187)] = 26234,
  [SMALL_STATE(1188)] = 26243,
  [SMALL_STATE(1189)] = 26254,
  [SMALL_STATE(1190)] = 26265,
  [SMALL_STATE(1191)] = 26274,
  [SMALL_STATE(1192)] = 26283,
  [SMALL_STATE(1193)] = 26294,
  [SMALL_STATE(1194)] = 26303,
  [SMALL_STATE(1195)] = 26314,
  [SMALL_STATE(1196)] = 26322,
  [SMALL_STATE(1197)] = 26330,
  [SMALL_STATE(1198)] = 26338,
  [SMALL_STATE(1199)] = 26346,
  [SMALL_STATE(1200)] = 26354,
  [SMALL_STATE(1201)] = 26362,
  [SMALL_STATE(1202)] = 26370,
  [SMALL_STATE(1203)] = 26378,
  [SMALL_STATE(1204)] = 26386,
  [SMALL_STATE(1205)] = 26394,
  [SMALL_STATE(1206)] = 26402,
  [SMALL_STATE(1207)] = 26410,
  [SMALL_STATE(1208)] = 26418,
  [SMALL_STATE(1209)] = 26426,
  [SMALL_STATE(1210)] = 26434,
  [SMALL_STATE(1211)] = 26442,
  [SMALL_STATE(1212)] = 26450,
  [SMALL_STATE(1213)] = 26458,
  [SMALL_STATE(1214)] = 26466,
  [SMALL_STATE(1215)] = 26474,
  [SMALL_STATE(1216)] = 26482,
  [SMALL_STATE(1217)] = 26490,
  [SMALL_STATE(1218)] = 26498,
  [SMALL_STATE(1219)] = 26506,
  [SMALL_STATE(1220)] = 26514,
  [SMALL_STATE(1221)] = 26522,
  [SMALL_STATE(1222)] = 26530,
  [SMALL_STATE(1223)] = 26538,
  [SMALL_STATE(1224)] = 26546,
  [SMALL_STATE(1225)] = 26554,
  [SMALL_STATE(1226)] = 26562,
  [SMALL_STATE(1227)] = 26570,
  [SMALL_STATE(1228)] = 26578,
  [SMALL_STATE(1229)] = 26586,
  [SMALL_STATE(1230)] = 26594,
  [SMALL_STATE(1231)] = 26602,
  [SMALL_STATE(1232)] = 26610,
  [SMALL_STATE(1233)] = 26618,
  [SMALL_STATE(1234)] = 26626,
  [SMALL_STATE(1235)] = 26634,
  [SMALL_STATE(1236)] = 26642,
  [SMALL_STATE(1237)] = 26650,
  [SMALL_STATE(1238)] = 26658,
  [SMALL_STATE(1239)] = 26666,
  [SMALL_STATE(1240)] = 26674,
  [SMALL_STATE(1241)] = 26682,
  [SMALL_STATE(1242)] = 26690,
  [SMALL_STATE(1243)] = 26698,
  [SMALL_STATE(1244)] = 26706,
  [SMALL_STATE(1245)] = 26714,
  [SMALL_STATE(1246)] = 26722,
  [SMALL_STATE(1247)] = 26730,
  [SMALL_STATE(1248)] = 26738,
  [SMALL_STATE(1249)] = 26746,
  [SMALL_STATE(1250)] = 26754,
  [SMALL_STATE(1251)] = 26762,
  [SMALL_STATE(1252)] = 26770,
  [SMALL_STATE(1253)] = 26778,
  [SMALL_STATE(1254)] = 26786,
  [SMALL_STATE(1255)] = 26794,
  [SMALL_STATE(1256)] = 26802,
  [SMALL_STATE(1257)] = 26810,
  [SMALL_STATE(1258)] = 26818,
  [SMALL_STATE(1259)] = 26826,
  [SMALL_STATE(1260)] = 26834,
  [SMALL_STATE(1261)] = 26842,
  [SMALL_STATE(1262)] = 26850,
  [SMALL_STATE(1263)] = 26858,
  [SMALL_STATE(1264)] = 26866,
  [SMALL_STATE(1265)] = 26874,
  [SMALL_STATE(1266)] = 26882,
  [SMALL_STATE(1267)] = 26890,
  [SMALL_STATE(1268)] = 26898,
  [SMALL_STATE(1269)] = 26906,
  [SMALL_STATE(1270)] = 26914,
  [SMALL_STATE(1271)] = 26922,
  [SMALL_STATE(1272)] = 26930,
  [SMALL_STATE(1273)] = 26938,
  [SMALL_STATE(1274)] = 26946,
  [SMALL_STATE(1275)] = 26954,
  [SMALL_STATE(1276)] = 26962,
  [SMALL_STATE(1277)] = 26970,
  [SMALL_STATE(1278)] = 26978,
  [SMALL_STATE(1279)] = 26986,
  [SMALL_STATE(1280)] = 26994,
  [SMALL_STATE(1281)] = 27002,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(662),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1087),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1095),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1245),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1227),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [87] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block_statement_group, 1),
  [89] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block_statement_group, 1),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [99] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(364),
  [104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(489),
  [107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(489),
  [110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(84),
  [113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(300),
  [116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(423),
  [119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(300),
  [122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(294),
  [125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(662),
  [128] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1272),
  [131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1086),
  [134] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(10),
  [137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [139] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(204),
  [142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(340),
  [145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(17),
  [148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1087),
  [151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1093),
  [154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1095),
  [157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(262),
  [160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(312),
  [163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(496),
  [166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(327),
  [169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(940),
  [172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1113),
  [175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1245),
  [178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(859),
  [181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(385),
  [184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(371),
  [187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(888),
  [190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(807),
  [193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1236),
  [196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(423),
  [199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(384),
  [202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1235),
  [205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1227),
  [208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(675),
  [211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(672),
  [214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(685),
  [217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(461),
  [220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1180),
  [223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block_statement_group, 2),
  [225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block_statement_group, 2),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1278),
  [249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3),
  [251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3),
  [253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2),
  [255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2),
  [257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 3),
  [263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 3),
  [265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3),
  [267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3),
  [269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 2),
  [271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 2),
  [273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 3, .production_id = 21),
  [275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 3, .production_id = 21),
  [277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2),
  [279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2),
  [281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1),
  [283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1),
  [285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1), REDUCE(sym_statement, 1),
  [292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1), REDUCE(sym_statement, 1),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_with_resources_statement, 3, .production_id = 24),
  [317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_with_resources_statement, 3, .production_id = 24),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_with_resources_statement, 4, .production_id = 24),
  [325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_with_resources_statement, 4, .production_id = 24),
  [327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 23),
  [329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 23),
  [331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(1280),
  [338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 163),
  [358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 163),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 112),
  [370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 112),
  [372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, .production_id = 181),
  [374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, .production_id = 181),
  [376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 65),
  [378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 65),
  [380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2),
  [382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2),
  [384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_body, 2),
  [386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_body, 2),
  [388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 4, .production_id = 64),
  [390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 4, .production_id = 64),
  [392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 58),
  [394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 58),
  [396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 57),
  [398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 57),
  [400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 56),
  [402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 56),
  [404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 55),
  [406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 55),
  [408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 58),
  [410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 58),
  [412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 55),
  [414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 55),
  [416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_body, 2),
  [418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_body, 2),
  [420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 57),
  [422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 57),
  [424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 62),
  [426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 62),
  [428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 62),
  [430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 62),
  [432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_declaration, 4, .production_id = 62),
  [434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_declaration, 4, .production_id = 62),
  [436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 62),
  [438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 62),
  [440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 90),
  [442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 90),
  [444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 91),
  [446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 91),
  [448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 92),
  [450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 92),
  [452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 93),
  [454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 93),
  [456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 94),
  [458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 94),
  [460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 95),
  [462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 95),
  [464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3),
  [466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3),
  [468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, .production_id = 101),
  [470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, .production_id = 101),
  [472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, .production_id = 102),
  [474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, .production_id = 102),
  [476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_body, 3),
  [478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_body, 3),
  [480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_body, 3),
  [482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_body, 3),
  [484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 92),
  [486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 92),
  [488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 103),
  [490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 103),
  [492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 104),
  [494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 104),
  [496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 113),
  [498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 113),
  [500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 114),
  [502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 114),
  [504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 115),
  [506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 115),
  [508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, .production_id = 114),
  [510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, .production_id = 114),
  [512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, .production_id = 116),
  [514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, .production_id = 116),
  [516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 112),
  [518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 112),
  [520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 115),
  [522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 115),
  [524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 117),
  [526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 117),
  [528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 127),
  [532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 127),
  [534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 128),
  [536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 128),
  [538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 129),
  [540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 129),
  [542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 130),
  [544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 130),
  [546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 20),
  [548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 20),
  [550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_declaration, 3, .production_id = 20),
  [552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_declaration, 3, .production_id = 20),
  [554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4),
  [556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4),
  [558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, .production_id = 143),
  [560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, .production_id = 143),
  [562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 20),
  [564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 20),
  [566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 144),
  [568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 144),
  [570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 147),
  [572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 147),
  [574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 148),
  [576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 148),
  [578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 149),
  [580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 149),
  [582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 150),
  [584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 150),
  [586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 151),
  [588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 151),
  [590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 152),
  [592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 152),
  [594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, .production_id = 153),
  [596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, .production_id = 153),
  [598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, .production_id = 154),
  [600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, .production_id = 154),
  [602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 149),
  [604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 149),
  [606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 155),
  [608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 155),
  [610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 156),
  [612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 156),
  [614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 161),
  [618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 161),
  [620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 20),
  [622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 20),
  [624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 180),
  [626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 180),
  [628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, .production_id = 201),
  [630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, .production_id = 201),
  [632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 179),
  [634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 179),
  [636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 6),
  [638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 6),
  [640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 178),
  [642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 178),
  [644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 177),
  [646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 177),
  [648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5),
  [650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5),
  [652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, .production_id = 182),
  [654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, .production_id = 182),
  [656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_declaration, 3, .production_id = 14),
  [658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_declaration, 3, .production_id = 14),
  [660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_declaration, 4, .production_id = 63),
  [662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_declaration, 4, .production_id = 63),
  [664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3),
  [666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3),
  [668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 209),
  [670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 209),
  [672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enhanced_for_statement, 9, .production_id = 208),
  [674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enhanced_for_statement, 9, .production_id = 208),
  [676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 133),
  [678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 133),
  [680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 207),
  [682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 207),
  [684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 23),
  [686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 23),
  [688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 206),
  [690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 206),
  [692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2),
  [694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2),
  [696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_body, 2),
  [698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_body, 2),
  [700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 205),
  [702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 205),
  [704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 204),
  [706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 204),
  [708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 203),
  [710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 203),
  [712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 4, .production_id = 62),
  [714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 4, .production_id = 62),
  [716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 4, .production_id = 61),
  [718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 4, .production_id = 61),
  [720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 6, .production_id = 63),
  [722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 6, .production_id = 63),
  [724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 191),
  [726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 191),
  [728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 190),
  [730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 190),
  [732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enhanced_for_statement, 8, .production_id = 189),
  [734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enhanced_for_statement, 8, .production_id = 189),
  [736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 188),
  [758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 188),
  [760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4),
  [762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4),
  [764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, .production_id = 63),
  [766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4, .production_id = 63),
  [768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 134),
  [770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 134),
  [772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 6),
  [774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 6),
  [776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 187),
  [778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 187),
  [780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 186),
  [786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 186),
  [788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 5, .production_id = 119),
  [790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 5, .production_id = 119),
  [792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 185),
  [794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 185),
  [796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 184),
  [798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 184),
  [800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_variable_declaration, 4, .production_id = 73),
  [802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_variable_declaration, 4, .production_id = 73),
  [804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 3),
  [806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 3),
  [808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_declaration, 4),
  [810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_declaration, 4),
  [812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 5, .production_id = 118),
  [814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 5, .production_id = 118),
  [816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 3),
  [822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_statement, 3),
  [824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 21),
  [826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 21),
  [828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3),
  [830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3),
  [832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3),
  [834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3),
  [836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_statement, 3),
  [842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_statement, 3),
  [844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_synchronized_statement, 3, .production_id = 22),
  [846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_synchronized_statement, 3, .production_id = 22),
  [848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 171),
  [854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 171),
  [856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 170),
  [858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 170),
  [860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_switch_block_statement_group_repeat1, 2),
  [862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_block_statement_group_repeat1, 2),
  [864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_statement_group_repeat1, 2), SHIFT_REPEAT(330),
  [867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_statement_group_repeat1, 2), SHIFT_REPEAT(1114),
  [870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 169),
  [872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 169),
  [874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 5),
  [876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_statement, 5),
  [878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 96),
  [880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 96),
  [882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 25),
  [884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 25),
  [886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_with_resources_statement, 5, .production_id = 24),
  [890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_with_resources_statement, 5, .production_id = 24),
  [892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 168),
  [894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 168),
  [896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1),
  [898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1),
  [900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 97),
  [902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 97),
  [904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 165),
  [906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 165),
  [908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, .production_id = 229),
  [910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, .production_id = 229),
  [912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, .production_id = 230),
  [914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, .production_id = 230),
  [916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, .production_id = 231),
  [918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, .production_id = 231),
  [920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 11, .production_id = 236),
  [922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 11, .production_id = 236),
  [924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 3, .production_id = 30),
  [926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 3, .production_id = 30),
  [928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 3, .production_id = 20),
  [930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 3, .production_id = 20),
  [932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_body, 3),
  [934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_body, 3),
  [936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_declaration, 3),
  [938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_declaration, 3),
  [940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 5, .production_id = 14),
  [942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 5, .production_id = 14),
  [944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 3, .production_id = 14),
  [946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 3, .production_id = 14),
  [948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 5),
  [950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 5),
  [952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_variable_declaration, 3, .production_id = 40),
  [954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_variable_declaration, 3, .production_id = 40),
  [956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [1000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [1002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [1004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [1006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [1008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [1010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [1012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [1014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [1016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [1018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [1020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [1022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [1024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [1026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_constructor_invocation, 5, .production_id = 228),
  [1028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_constructor_invocation, 5, .production_id = 228),
  [1030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [1032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_constructor_invocation, 4, .production_id = 202),
  [1034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_constructor_invocation, 4, .production_id = 202),
  [1036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_constructor_invocation, 3, .production_id = 183),
  [1038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_constructor_invocation, 3, .production_id = 183),
  [1040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_constructor_invocation, 6, .production_id = 235),
  [1042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_constructor_invocation, 6, .production_id = 235),
  [1044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [1046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [1050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [1052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [1054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1243),
  [1056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [1058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [1060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body_declarations, 2),
  [1062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body_declarations, 1),
  [1064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [1066] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(724),
  [1069] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(787),
  [1072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(423),
  [1075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(1272),
  [1078] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(10),
  [1081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2),
  [1083] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(358),
  [1086] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(859),
  [1089] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(476),
  [1092] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(1236),
  [1095] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(423),
  [1098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(1243),
  [1101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(1235),
  [1104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(1227),
  [1107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(675),
  [1110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(672),
  [1113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(685),
  [1116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(657),
  [1119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(787),
  [1122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(423),
  [1125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(1272),
  [1128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interface_body_repeat1, 2),
  [1130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(359),
  [1133] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(859),
  [1136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(1236),
  [1139] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(423),
  [1142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(1243),
  [1145] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(1235),
  [1148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(1227),
  [1151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(675),
  [1154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(672),
  [1157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(685),
  [1160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [1162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [1164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [1166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [1168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [1170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unannotated_type, 1, .production_id = 2),
  [1172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [1174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1),
  [1176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1),
  [1178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [1180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [1182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(557),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__unannotated_type, 1, .production_id = 2),
  [1190] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__unannotated_type, 1, .production_id = 2), SHIFT(856),
  [1194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unannotated_type, 1, .production_id = 2),
  [1196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__unannotated_type, 1, .production_id = 2),
  [1199] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__unannotated_type, 1, .production_id = 2), SHIFT(1210),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [1205] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__unannotated_type, 1, .production_id = 2), SHIFT(856),
  [1209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [1213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(657),
  [1216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(423),
  [1219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(1272),
  [1222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2),
  [1224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(859),
  [1227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(1236),
  [1230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(423),
  [1233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(1235),
  [1236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(1227),
  [1239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(675),
  [1242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(672),
  [1245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(685),
  [1248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [1250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_access, 5, .dynamic_precedence = 16, .production_id = 105),
  [1254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_access, 5, .dynamic_precedence = 16, .production_id = 105),
  [1256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [1258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [1260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [1262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [1264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [1266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [1268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [1270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_access, 3, .dynamic_precedence = 16, .production_id = 31),
  [1272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_access, 3, .dynamic_precedence = 16, .production_id = 31),
  [1274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_access, 3, .dynamic_precedence = 16, .production_id = 32),
  [1276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_access, 3, .dynamic_precedence = 16, .production_id = 32),
  [1278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_access, 5, .dynamic_precedence = 16, .production_id = 106),
  [1280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_access, 5, .dynamic_precedence = 16, .production_id = 106),
  [1282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_access, 4, .production_id = 72),
  [1284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_access, 4, .production_id = 72),
  [1286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [1290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(203),
  [1293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [1295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(1277),
  [1298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dimensions, 1),
  [1300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimensions, 1),
  [1302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [1304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [1306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [1308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(221),
  [1311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [1315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_dimensions_repeat1, 2),
  [1317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dimensions_repeat1, 2),
  [1319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimensions_repeat1, 2), SHIFT_REPEAT(1229),
  [1322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimensions_repeat1, 2), SHIFT_REPEAT(887),
  [1325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotated_type, 2),
  [1327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotated_type, 2),
  [1329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [1331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [1333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 3, .production_id = 19),
  [1335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 3, .production_id = 19),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [1339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 3, .production_id = 17),
  [1341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 3, .production_id = 17),
  [1343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4, .production_id = 54),
  [1345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4, .production_id = 54),
  [1347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4, .production_id = 53),
  [1349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4, .production_id = 53),
  [1351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, .production_id = 60),
  [1353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, .production_id = 60),
  [1355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, .production_id = 59),
  [1357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, .production_id = 59),
  [1359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_creation_expression_repeat2, 2),
  [1361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat2, 2),
  [1363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat2, 2), SHIFT_REPEAT(291),
  [1366] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat2, 2), SHIFT_REPEAT(887),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [1371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_dimensions_repeat1, 3),
  [1373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dimensions_repeat1, 3),
  [1375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__unannotated_type, 1, .production_id = 2), SHIFT(595),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [1380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unannotated_type, 1),
  [1382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unannotated_type, 1),
  [1384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__unannotated_type, 1), SHIFT(595),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [1389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 2),
  [1391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 2),
  [1393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [1395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [1397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .dynamic_precedence = 10),
  [1399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .dynamic_precedence = 10),
  [1401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_marker_annotation, 2, .production_id = 6),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [1405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_marker_annotation, 2, .production_id = 6),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [1409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 42),
  [1411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 42),
  [1413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .dynamic_precedence = 10, .production_id = 2),
  [1415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .dynamic_precedence = 10, .production_id = 2),
  [1417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 4, .production_id = 77),
  [1419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 4, .production_id = 77),
  [1421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [1423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [1425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 4, .production_id = 68),
  [1427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 4, .production_id = 68),
  [1429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 35),
  [1431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 35),
  [1433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_marker_annotation, 2, .production_id = 5),
  [1435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_marker_annotation, 2, .production_id = 5),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [1439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_floating_point_type, 1),
  [1441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_floating_point_type, 1),
  [1443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integral_type, 1),
  [1445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integral_type, 1),
  [1447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 2, .production_id = 11),
  [1449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 2, .production_id = 11),
  [1451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifiers, 1),
  [1453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifiers, 1),
  [1455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [1459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 3, .production_id = 16),
  [1461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 3, .production_id = 16),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [1465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 3, .production_id = 18),
  [1467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 3, .production_id = 18),
  [1469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 52),
  [1471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 52),
  [1473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_modifiers_repeat1, 2),
  [1475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_modifiers_repeat1, 2),
  [1477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(427),
  [1480] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(859),
  [1483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(427),
  [1486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 51),
  [1488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 51),
  [1490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_argument_list, 3),
  [1492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_argument_list, 3),
  [1494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4),
  [1496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4),
  [1498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 3, .production_id = 120),
  [1500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 3, .production_id = 120),
  [1502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 3, .production_id = 121),
  [1504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 3, .production_id = 121),
  [1506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [1508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instanceof_expression, 4, .production_id = 69),
  [1510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instanceof_expression, 4, .production_id = 69),
  [1512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [1514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 3, .production_id = 122),
  [1516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 3, .production_id = 122),
  [1518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_body, 2),
  [1520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_body, 2),
  [1522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 3, .production_id = 125),
  [1524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 3, .production_id = 125),
  [1526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dimensions_expr, 3),
  [1528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimensions_expr, 3),
  [1530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 40),
  [1532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 40),
  [1534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dimensions_expr, 4),
  [1536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimensions_expr, 4),
  [1538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [1540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instanceof_expression, 3, .production_id = 36),
  [1542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instanceof_expression, 3, .production_id = 36),
  [1544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [1546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compact_constructor_declaration, 3, .production_id = 20),
  [1548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compact_constructor_declaration, 3, .production_id = 20),
  [1550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_argument_list, 4),
  [1552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_argument_list, 4),
  [1554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 4, .production_id = 157),
  [1556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 4, .production_id = 157),
  [1558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, .production_id = 73),
  [1560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, .production_id = 73),
  [1562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_body, 3),
  [1564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_body, 3),
  [1566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2),
  [1568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2),
  [1570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_initializer, 2),
  [1572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_initializer, 2),
  [1574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compact_constructor_declaration, 2, .production_id = 84),
  [1576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compact_constructor_declaration, 2, .production_id = 84),
  [1578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 2, .production_id = 86),
  [1580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 2, .production_id = 86),
  [1582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 2, .production_id = 88),
  [1584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 2, .production_id = 88),
  [1586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 2, .production_id = 89),
  [1588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 2, .production_id = 89),
  [1590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 3, .production_id = 27),
  [1592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 3, .production_id = 27),
  [1594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 3, .production_id = 26),
  [1596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 3, .production_id = 26),
  [1598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3),
  [1600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3),
  [1602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_body, 4),
  [1604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_body, 4),
  [1606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_argument_list, 2),
  [1608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_argument_list, 2),
  [1610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 6, .production_id = 145),
  [1612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 6, .production_id = 145),
  [1614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4, .production_id = 49),
  [1616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4, .production_id = 49),
  [1618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 16),
  [1620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 16),
  [1622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4, .production_id = 48),
  [1624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4, .production_id = 48),
  [1626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_initializer, 5),
  [1628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_initializer, 5),
  [1630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 2, .production_id = 7),
  [1632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 2, .production_id = 7),
  [1634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_initializer, 2),
  [1636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_initializer, 2),
  [1638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 7, .production_id = 175),
  [1640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 7, .production_id = 175),
  [1642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_declaration, 4, .production_id = 73),
  [1644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_declaration, 4, .production_id = 73),
  [1646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_declaration, 3, .production_id = 40),
  [1648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_declaration, 3, .production_id = 40),
  [1650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4, .production_id = 50),
  [1652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4, .production_id = 50),
  [1654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 5, .production_id = 52),
  [1656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 5, .production_id = 52),
  [1658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 5, .production_id = 79),
  [1660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 5, .production_id = 79),
  [1662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 2, .production_id = 8),
  [1664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 2, .production_id = 8),
  [1666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 5, .production_id = 80),
  [1668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 5, .production_id = 80),
  [1670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_initializer, 4),
  [1672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_initializer, 4),
  [1674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 5, .production_id = 51),
  [1676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 5, .production_id = 51),
  [1678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_modifiers_repeat1, 1),
  [1680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_modifiers_repeat1, 1),
  [1682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 6, .production_id = 146),
  [1684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 6, .production_id = 146),
  [1686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 7, .production_id = 176),
  [1688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 7, .production_id = 176),
  [1690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4, .production_id = 47),
  [1692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4, .production_id = 47),
  [1694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 18),
  [1696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 18),
  [1698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_reference, 3),
  [1700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_reference, 3),
  [1702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [1704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [1706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [1708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_literal, 3, .dynamic_precedence = 17),
  [1710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_literal, 3, .dynamic_precedence = 17),
  [1712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 5, .production_id = 107),
  [1714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 5, .production_id = 107),
  [1716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 5, .production_id = 108),
  [1718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 5, .production_id = 108),
  [1720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 3, .production_id = 37),
  [1722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 3, .production_id = 37),
  [1724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 5, .production_id = 81),
  [1726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 5, .production_id = 81),
  [1728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_initializer, 3),
  [1730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_initializer, 3),
  [1732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literal, 1),
  [1734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literal, 1),
  [1736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 5, .production_id = 82),
  [1738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 5, .production_id = 82),
  [1740] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_creation_expression_repeat1, 1), REDUCE(aux_sym_modifiers_repeat1, 1),
  [1743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_creation_expression_repeat1, 1),
  [1745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 4, .production_id = 66),
  [1747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 4, .production_id = 66),
  [1749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 4, .production_id = 67),
  [1751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 4, .production_id = 67),
  [1753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 1, .production_id = 3),
  [1755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 1, .production_id = 3),
  [1757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_reference, 4),
  [1759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_reference, 4),
  [1761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 5, .production_id = 200),
  [1763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 5, .production_id = 200),
  [1765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, .production_id = 45),
  [1767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, .production_id = 45),
  [1769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [1771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 4),
  [1773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 4),
  [1775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2),
  [1777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2),
  [1779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instanceof_expression, 4, .production_id = 70),
  [1781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instanceof_expression, 4, .production_id = 70),
  [1783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instanceof_expression, 4, .production_id = 71),
  [1785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instanceof_expression, 4, .production_id = 71),
  [1787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 33),
  [1789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 33),
  [1791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 5, .production_id = 78),
  [1793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 5, .production_id = 78),
  [1795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 8, .production_id = 237),
  [1797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 8, .production_id = 237),
  [1799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 234),
  [1801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 234),
  [1803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 233),
  [1805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 233),
  [1807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 232),
  [1809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 232),
  [1811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 227),
  [1813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 227),
  [1815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instanceof_expression, 5, .production_id = 110),
  [1817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instanceof_expression, 5, .production_id = 110),
  [1819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instanceof_expression, 5, .production_id = 109),
  [1821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instanceof_expression, 5, .production_id = 109),
  [1823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 226),
  [1825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 226),
  [1827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 224),
  [1829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 224),
  [1831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, .production_id = 34),
  [1833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, .production_id = 34),
  [1835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, .production_id = 29),
  [1837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, .production_id = 29),
  [1839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [1841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [1843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [1845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [1847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [1849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [1851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [1853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [1855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [1857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [1859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [1861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [1863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [1865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [1867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 33),
  [1869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [1873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [1875] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(528),
  [1878] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(887),
  [1881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(528),
  [1884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 111),
  [1886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 28),
  [1888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [1890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [1892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [1894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [1896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimensions_repeat1, 2), SHIFT_REPEAT(1259),
  [1899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__element_value, 1),
  [1901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [1903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [1905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [1907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [1909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [1911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [1913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [1915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [1917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [1919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [1921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [1923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [1925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [1927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_label, 2),
  [1929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [1933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [1935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [1937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [1941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [1947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [1949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [1951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [1957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [1959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [1963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [1965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [1967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [1969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [1971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [1975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receiver_parameter, 4),
  [1977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receiver_parameter, 4),
  [1979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [1981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receiver_parameter, 5),
  [1983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receiver_parameter, 5),
  [1985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [1987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [1989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [1999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receiver_parameter, 3),
  [2001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receiver_parameter, 3),
  [2003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receiver_parameter, 2),
  [2005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receiver_parameter, 2),
  [2007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [2013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 76),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [2021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource, 5, .production_id = 162),
  [2023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, .production_id = 98),
  [2025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource, 4, .production_id = 131),
  [2027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [2029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [2031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [2033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [2035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [2037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [2039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_initializer_repeat1, 2),
  [2041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 1), REDUCE(aux_sym_modifiers_repeat1, 1),
  [2044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat2, 2, .production_id = 166),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [2050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [2062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [2066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [2070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [2074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [2078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [2080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [2082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [2084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [2086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [2088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [2090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [2092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [2094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [2096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [2098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [2100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [2102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [2104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [2106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [2110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [2112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [2114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [2118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [2120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [2122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [2124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [2126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [2128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [2130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [2132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [2134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [2136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [2138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [2140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1261),
  [2142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [2144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [2146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [2148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [2150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [2152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2),
  [2154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2),
  [2156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2), SHIFT_REPEAT(869),
  [2159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [2161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [2163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [2165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [2167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [2169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [2171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4),
  [2173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4),
  [2175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3),
  [2177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3),
  [2179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [2181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [2183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 1),
  [2185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [2187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [2189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [2191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource, 1),
  [2193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_type, 1),
  [2195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [2197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [2199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [2201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__unannotated_type, 1), SHIFT(852),
  [2204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [2208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_id, 1, .production_id = 9),
  [2210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2),
  [2212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2), SHIFT_REPEAT(771),
  [2215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2), SHIFT_REPEAT(870),
  [2218] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2), SHIFT_REPEAT(874),
  [2221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2), SHIFT_REPEAT(862),
  [2224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2), SHIFT_REPEAT(876),
  [2227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [2229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(586),
  [2231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_id, 1, .production_id = 10),
  [2233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [2235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [2237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [2239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [2243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [2245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_catch_type_repeat1, 2),
  [2247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_catch_type_repeat1, 2),
  [2249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1108),
  [2251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [2253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [2255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [2257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [2259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [2261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [2263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [2267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_declarator, 2, .production_id = 126),
  [2269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_declarator, 2, .production_id = 85),
  [2271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [2273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [2275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [2277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [2279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [2281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [2283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [2287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [2289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1167),
  [2291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [2293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [2295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [2297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1183),
  [2299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [2301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [2303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [2305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [2313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_requires_module_directive_repeat1, 2, .production_id = 138),
  [2315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requires_module_directive_repeat1, 2, .production_id = 138), SHIFT_REPEAT(853),
  [2318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [2320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [2322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2),
  [2324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(330),
  [2327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1114),
  [2330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 1, .production_id = 10),
  [2332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5),
  [2334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 2, .production_id = 6),
  [2336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [2338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [2344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [2346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [2348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(375),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [2352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [2354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 6, .production_id = 219),
  [2356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 6, .production_id = 216),
  [2358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 6, .production_id = 215),
  [2360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2), SHIFT_REPEAT(887),
  [2363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 6, .production_id = 214),
  [2365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 6, .production_id = 212),
  [2367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 6, .production_id = 216),
  [2369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 6, .production_id = 215),
  [2371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 6, .production_id = 214),
  [2373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 6, .production_id = 212),
  [2375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [2377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_module_directive, 3, .production_id = 136),
  [2379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_module_directive, 3, .production_id = 137),
  [2381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [2383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [2385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [2387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 3, .production_id = 139),
  [2389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [2391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 3, .production_id = 140),
  [2393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [2395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 3, .production_id = 139),
  [2397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 3, .production_id = 140),
  [2399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uses_module_directive, 3, .production_id = 141),
  [2401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uses_module_directive, 3, .production_id = 44),
  [2403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [2405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_module_directive, 4, .production_id = 172),
  [2407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [2409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 6, .production_id = 222),
  [2411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [2413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_directive, 1),
  [2415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [2417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 5, .production_id = 199),
  [2419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 5, .production_id = 198),
  [2421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 5, .production_id = 197),
  [2423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 6, .production_id = 223),
  [2425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 5, .production_id = 196),
  [2427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_catch_type_repeat1, 2), SHIFT_REPEAT(702),
  [2430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 5, .production_id = 195),
  [2432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 5, .production_id = 194),
  [2434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_module_directive, 4, .production_id = 173),
  [2436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 5, .production_id = 193),
  [2438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 5, .production_id = 192),
  [2440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 5, .production_id = 195),
  [2442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 5, .production_id = 194),
  [2444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 5, .production_id = 193),
  [2446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 6, .production_id = 221),
  [2448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 5, .production_id = 192),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [2452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_requires_module_directive_repeat1, 1, .production_id = 100),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [2458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_type, 2),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [2462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_modifier, 1),
  [2464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat2, 2),
  [2466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat2, 2), SHIFT_REPEAT(338),
  [2469] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat2, 2), SHIFT_REPEAT(1114),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [2474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [2476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [2478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wildcard, 1),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [2482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_list_repeat1, 2), SHIFT_REPEAT(647),
  [2485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_list_repeat1, 2),
  [2487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [2489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [2491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [2493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [2495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [2497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [2499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1102),
  [2501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1099),
  [2503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [2505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [2507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [2509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1025),
  [2511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [2513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [2515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1026),
  [2517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1159),
  [2519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [2521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_id, 2, .production_id = 39),
  [2523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wildcard, 2),
  [2525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1020),
  [2527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1019),
  [2529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [2531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1161),
  [2533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_id, 2, .production_id = 38),
  [2535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [2537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [2539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [2541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1031),
  [2543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [2545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 3, .production_id = 27),
  [2547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 2, .production_id = 8),
  [2549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [2551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [2553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [2555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1127),
  [2557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [2559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [2561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [2563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [2565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [2567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [2569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [2571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [2573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [2575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [2577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [2579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [2581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [2583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [2589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [2591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [2593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_value_array_initializer, 5),
  [2595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [2597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_bound, 2),
  [2599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [2603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 13),
  [2605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [2607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [2609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throws, 2),
  [2611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_value_array_initializer, 4),
  [2613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [2615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [2617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(344),
  [2620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, .production_id = 2),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [2624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [2628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [2632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [2634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [2636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [2638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [2648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 83),
  [2650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [2652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [2654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_label, 3),
  [2656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [2658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throws, 3),
  [2660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 4, .production_id = 158),
  [2662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [2664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [2666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [2668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [2670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [2672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [2674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_bound, 3),
  [2676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_bound_repeat1, 2), SHIFT_REPEAT(643),
  [2679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_bound_repeat1, 2),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [2683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [2685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [2687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 2, .production_id = 87),
  [2689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_value_array_initializer, 3),
  [2691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(323),
  [2694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_list, 2),
  [2696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_value_array_initializer, 2),
  [2698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2), SHIFT_REPEAT(649),
  [2701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [2705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [2707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 3, .production_id = 124),
  [2709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_list, 1),
  [2711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [2713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(405),
  [2716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_argument_list_repeat1, 2),
  [2718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_annotation_argument_list_repeat1, 2), SHIFT_REPEAT(1181),
  [2721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [2723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [2725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [2727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [2729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [2731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [2733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__variable_declarator_list_repeat1, 2, .production_id = 75), SHIFT_REPEAT(805),
  [2736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_declarator_list_repeat1, 2, .production_id = 75),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [2750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_resource_specification_repeat1, 2),
  [2752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_resource_specification_repeat1, 2), SHIFT_REPEAT(352),
  [2755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [2757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [2759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [2761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [2763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [2765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [2767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [2769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [2771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [2773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [2775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cast_expression_repeat1, 2, .production_id = 46), SHIFT_REPEAT(639),
  [2778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_cast_expression_repeat1, 2, .production_id = 46),
  [2780] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, .production_id = 99), SHIFT_REPEAT(321),
  [2783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, .production_id = 99),
  [2785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [2789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [2791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [2793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 3, .production_id = 20),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [2799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_superclass, 2),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [2805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 3, .production_id = 142),
  [2807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [2809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [2811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [2813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [2815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [2817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [2821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [2823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [2825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [2827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exports_module_directive_repeat1, 2, .production_id = 210),
  [2829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exports_module_directive_repeat1, 2, .production_id = 211),
  [2831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exports_module_directive_repeat1, 2, .production_id = 213), SHIFT_REPEAT(879),
  [2834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exports_module_directive_repeat1, 2, .production_id = 213),
  [2836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [2838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [2840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [2844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [2848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [2850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [2852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [2854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_provides_module_directive_repeat1, 2, .production_id = 217),
  [2856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_provides_module_directive_repeat1, 2, .production_id = 218),
  [2858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [2860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_provides_module_directive_repeat1, 2, .production_id = 220), SHIFT_REPEAT(884),
  [2863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_provides_module_directive_repeat1, 2, .production_id = 220),
  [2865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [2867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [2871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [2873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_inferred_parameters_repeat1, 2),
  [2875] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inferred_parameters_repeat1, 2), SHIFT_REPEAT(942),
  [2878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [2880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [2882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [2884] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_initializer_repeat1, 2), SHIFT_REPEAT(218),
  [2887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [2889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [2891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [2893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [2895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [2897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [2899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [2901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 2, .production_id = 84),
  [2903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [2907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [2909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [2911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_declarator, 3, .production_id = 159),
  [2913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_declarator, 3, .production_id = 160),
  [2915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_rule, 3),
  [2917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [2919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 4, .production_id = 174),
  [2921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [2923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_list, 2, .production_id = 41),
  [2925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [2927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [2929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat2, 2, .production_id = 167),
  [2931] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat2, 2, .production_id = 167), SHIFT_REPEAT(299),
  [2934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [2936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [2938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_list, 1, .production_id = 12),
  [2940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [2942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_element_value_array_initializer_repeat1, 2), SHIFT_REPEAT(174),
  [2945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_element_value_array_initializer_repeat1, 2),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [2949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [2951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(779),
  [2954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [2956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2),
  [2958] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2), SHIFT_REPEAT(602),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [2969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [2971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wildcard, 3),
  [2973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 2),
  [2975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_interfaces, 2),
  [2977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [2981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 3, .production_id = 87),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [2987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_declarator_list_repeat1, 2, .production_id = 74),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [2991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_declarator, 2, .production_id = 85),
  [2993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 4, .production_id = 124),
  [2995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 5, .production_id = 158),
  [2997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_declarator, 3, .production_id = 123),
  [2999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_label, 1),
  [3001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [3003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, .production_id = 83),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [3009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [3015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [3017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_parameter, 4),
  [3019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameter, 3, .production_id = 43),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [3027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_inferred_parameters_repeat1, 2, .production_id = 14),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [3031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__wildcard_bounds, 2),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [3047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_value_pair, 3, .production_id = 135),
  [3049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [3051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [3053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [3055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [3057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [3059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [3063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_super_interfaces, 2),
  [3065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [3067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameter, 2, .production_id = 15),
  [3069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_parameter, 3),
  [3071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_cast_expression_repeat1, 2, .production_id = 44),
  [3073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [3075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [3077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [3079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_permits, 2),
  [3081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inferred_parameters, 4),
  [3083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [3085] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [3087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inferred_parameters, 3),
  [3089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__default_value, 2, .production_id = 225),
  [3091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [3093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [3095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [3097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [3101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [3103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [3105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [3107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_specification, 4),
  [3109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [3111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [3113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [3115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [3117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [3119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inferred_parameters, 4, .production_id = 14),
  [3121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [3131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [3133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [3137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [3143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [3145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [3147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [3163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asterisk, 1),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [3167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [3173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [3181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_specification, 3),
  [3183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_specification, 5),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [3187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [3189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_formal_parameter, 2, .production_id = 132),
  [3191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [3193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [3195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_formal_parameter, 3, .production_id = 164),
  [3197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [3199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inferred_parameters, 3, .production_id = 14),
  [3201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [3203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [3205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [3207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_java(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
